/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/nls","vs/base/common/path","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/common/process","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/window/common/window","vs/base/common/hash","vs/base/common/labels","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/stopwatch","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/severity","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/cssDev/node/cssDevService","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","net","vs/base/node/id","vs/base/node/processes","path","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/nls.messages","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/native/electron-main/auth","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],ue=function(G){for(var e=[],i=0,r=G.length;i<r;i++)e[i]=le[G[i]];return e};define(le[66],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=e.LoaderEventType=e.$W=e.$V=void 0,e.$V=!1,e.$W=!0;var i;(function(v){v[v.LoaderAvailable=1]="LoaderAvailable",v[v.BeginLoadingScript=10]="BeginLoadingScript",v[v.EndLoadingScriptOK=11]="EndLoadingScriptOK",v[v.EndLoadingScriptError=12]="EndLoadingScriptError",v[v.BeginInvokeFactory=21]="BeginInvokeFactory",v[v.EndInvokeFactory=22]="EndInvokeFactory",v[v.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",v[v.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",v[v.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",v[v.NodeEndNativeRequire=34]="NodeEndNativeRequire",v[v.CachedDataFound=60]="CachedDataFound",v[v.CachedDataMissed=61]="CachedDataMissed",v[v.CachedDataRejected=62]="CachedDataRejected",v[v.CachedDataCreated=63]="CachedDataCreated"})(i||(e.LoaderEventType=i={}));class r{static get(){const D=new Map,O=new Map,I=new Map,b=new Map;function l(d,f){d.has(f.detail)||d.set(f.detail,-f.timestamp)}function m(d,f){const y=d.get(f.detail);y&&(y>=0||d.set(f.detail,y+f.timestamp))}let u=[];typeof G=="function"&&typeof G.getStats=="function"&&(u=G.getStats().slice(0).sort((d,f)=>d.timestamp-f.timestamp));for(const d of u)switch(d.type){case i.BeginLoadingScript:l(D,d);break;case i.EndLoadingScriptOK:case i.EndLoadingScriptError:m(D,d);break;case i.BeginInvokeFactory:l(O,d);break;case i.EndInvokeFactory:m(O,d);break;case i.NodeBeginNativeRequire:l(I,d);break;case i.NodeEndNativeRequire:m(I,d);break;case i.NodeBeginEvaluatingScript:l(b,d);break;case i.NodeEndEvaluatingScript:m(b,d);break}let $=0;I.forEach(d=>$+=d);function p(d){const f=[];return d.forEach((y,E)=>f.push([E,y])),f}return{amdLoad:p(D),amdInvoke:p(O),nodeRequire:p(I),nodeEval:p(b),nodeRequireTotal:$}}static toMarkdownTable(D,O){let I="";const b=[];return D.forEach((l,m)=>{b[m]=l.length}),O.forEach(l=>{l.forEach((m,u)=>{typeof m>"u"&&(m=l[u]="-");const $=m.toString().length;b[u]=Math.max($,b[u])})}),D.forEach((l,m)=>{I+=`| ${l+" ".repeat(b[m]-l.toString().length)} `}),I+=`|
`,D.forEach((l,m)=>{I+=`| ${"-".repeat(b[m])} `}),I+=`|
`,O.forEach(l=>{l.forEach((m,u)=>{typeof m<"u"&&(I+=`| ${m+" ".repeat(b[u]-m.toString().length)} `)}),I+=`|
`}),I}}e.$X=r}),define(le[141],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=void 0,e.$jb=i,e.$kb=r,e.$lb=v,e.$mb=D,e.$nb=O,e.$ob=I,e.$pb=b,e.$rb=m,e.$sb=u,e.$tb=$,e.$ub=p,e.$vb=d;function i(f,y){const E=r(f,y);if(E!==-1)return f[E]}function r(f,y,E=f.length-1){for(let g=E;g>=0;g--){const S=f[g];if(y(S))return g}return-1}function v(f,y){const E=D(f,y);return E===-1?void 0:f[E]}function D(f,y,E=0,g=f.length){let S=E,k=g;for(;S<k;){const s=Math.floor((S+k)/2);y(f[s])?S=s+1:k=s}return S-1}function O(f,y){const E=I(f,y);return E===f.length?void 0:f[E]}function I(f,y,E=0,g=f.length){let S=E,k=g;for(;S<k;){const s=Math.floor((S+k)/2);y(f[s])?k=s:S=s+1}return S}function b(f,y,E=0,g=f.length){const S=I(f,y,E,g);return S===f.length?-1:S}class l{static{this.assertInvariants=!1}constructor(y){this.e=y,this.c=0}findLastMonotonous(y){if(l.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!y(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=y}const E=D(this.e,y,this.c);return this.c=E+1,E===-1?void 0:this.e[E]}}e.$qb=l;function m(f,y){if(f.length===0)return;let E=f[0];for(let g=1;g<f.length;g++){const S=f[g];y(S,E)>0&&(E=S)}return E}function u(f,y){if(f.length===0)return;let E=f[0];for(let g=1;g<f.length;g++){const S=f[g];y(S,E)>=0&&(E=S)}return E}function $(f,y){return m(f,(E,g)=>-y(E,g))}function p(f,y){if(f.length===0)return-1;let E=0;for(let g=1;g<f.length;g++){const S=f[g];y(S,f[E])>0&&(E=g)}return E}function d(f,y){for(const E of f){const g=y(E);if(g!==void 0)return g}}}),define(le[39],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var i;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(e.CharCode=i={}))}),define(le[142],ue([0,1]),function(G,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$i=void 0,e.$e=r,e.$f=v,e.$g=D,e.$h=O;function r(b,l){const m=Object.create(null);for(const u of b){const $=l(u);let p=m[$];p||(p=m[$]=[]),p.push(u)}return m}function v(b,l){const m=[],u=[];for(const $ of b)l.has($)||m.push($);for(const $ of l)b.has($)||u.push($);return{removed:m,added:u}}function D(b,l){const m=[],u=[];for(const[$,p]of b)l.has($)||m.push(p);for(const[$,p]of l)b.has($)||u.push(p);return{removed:m,added:u}}function O(b,l){const m=new Set;for(const u of l)b.has(u)&&m.add(u);return m}class I{static{i=Symbol.toStringTag}constructor(l,m){this.b=m,this.a=new Map,this[i]="SetWithKey";for(const u of l)this.add(u)}get size(){return this.a.size}add(l){const m=this.b(l);return this.a.set(m,l),this}delete(l){return this.a.delete(this.b(l))}has(l){return this.a.has(this.b(l))}*entries(){for(const l of this.a.values())yield[l,l]}keys(){return this.values()}*values(){for(const l of this.a.values())yield l}clear(){this.a.clear()}forEach(l,m){this.a.forEach(u=>l.call(m,u,u,this))}[Symbol.iterator](){return this.values()}}e.$i=I}),define(le[143],ue([0,1,39]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=e.$vu=e.$uu=e.$tu=void 0;function r(b,l){const m=Math.pow(10,l);return Math.round(b*m)/m}class v{constructor(l,m,u,$=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,u))|0,this.a=r(Math.max(Math.min(1,$),0),3)}static equals(l,m){return l.r===m.r&&l.g===m.g&&l.b===m.b&&l.a===m.a}}e.$tu=v;class D{constructor(l,m,u,$){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.l=r(Math.max(Math.min(1,u),0),3),this.a=r(Math.max(Math.min(1,$),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.l===m.l&&l.a===m.a}static fromRGBA(l){const m=l.r/255,u=l.g/255,$=l.b/255,p=l.a,d=Math.max(m,u,$),f=Math.min(m,u,$);let y=0,E=0;const g=(f+d)/2,S=d-f;if(S>0){switch(E=Math.min(g<=.5?S/(2*g):S/(2-2*g),1),d){case m:y=(u-$)/S+(u<$?6:0);break;case u:y=($-m)/S+2;break;case $:y=(m-u)/S+4;break}y*=60,y=Math.round(y)}return new D(y,E,g,p)}static i(l,m,u){return u<0&&(u+=1),u>1&&(u-=1),u<1/6?l+(m-l)*6*u:u<1/2?m:u<2/3?l+(m-l)*(2/3-u)*6:l}static toRGBA(l){const m=l.h/360,{s:u,l:$,a:p}=l;let d,f,y;if(u===0)d=f=y=$;else{const E=$<.5?$*(1+u):$+u-$*u,g=2*$-E;d=D.i(g,E,m+1/3),f=D.i(g,E,m),y=D.i(g,E,m-1/3)}return new v(Math.round(d*255),Math.round(f*255),Math.round(y*255),p)}}e.$uu=D;class O{constructor(l,m,u,$){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=r(Math.max(Math.min(1,m),0),3),this.v=r(Math.max(Math.min(1,u),0),3),this.a=r(Math.max(Math.min(1,$),0),3)}static equals(l,m){return l.h===m.h&&l.s===m.s&&l.v===m.v&&l.a===m.a}static fromRGBA(l){const m=l.r/255,u=l.g/255,$=l.b/255,p=Math.max(m,u,$),d=Math.min(m,u,$),f=p-d,y=p===0?0:f/p;let E;return f===0?E=0:p===m?E=((u-$)/f%6+6)%6:p===u?E=($-m)/f+2:E=(m-u)/f+4,new O(Math.round(E*60),y,p,l.a)}static toRGBA(l){const{h:m,s:u,v:$,a:p}=l,d=$*u,f=d*(1-Math.abs(m/60%2-1)),y=$-d;let[E,g,S]=[0,0,0];return m<60?(E=d,g=f):m<120?(E=f,g=d):m<180?(g=d,S=f):m<240?(g=f,S=d):m<300?(E=f,S=d):m<=360&&(E=d,S=f),E=Math.round((E+y)*255),g=Math.round((g+y)*255),S=Math.round((S+y)*255),new v(E,g,S,p)}}e.$vu=O;class I{static fromHex(l){return I.Format.CSS.parseHex(l)||I.red}static equals(l,m){return!l&&!m?!0:!l||!m?!1:l.equals(m)}get hsla(){return this.i?this.i:D.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof v)this.rgba=l;else if(l instanceof D)this.i=l,this.rgba=D.toRGBA(l);else if(l instanceof O)this.j=l,this.rgba=O.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&v.equals(this.rgba,l.rgba)&&D.equals(this.hsla,l.hsla)&&O.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=I.k(this.rgba.r),m=I.k(this.rgba.g),u=I.k(this.rgba.b),$=.2126*l+.7152*m+.0722*u;return r($,4)}static k(l){const m=l/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(l){const m=this.getRelativeLuminance(),u=l.getRelativeLuminance();return m>u?(m+.05)/(u+.05):(u+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const m=this.getRelativeLuminance(),u=l.getRelativeLuminance();return m>u}isDarkerThan(l){const m=this.getRelativeLuminance(),u=l.getRelativeLuminance();return m<u}lighten(l){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new I(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:m,g:u,b:$,a:p}=this.rgba;return new I(new v(m,u,$,p*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new v(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const m=l.rgba,u=this.rgba.a,$=m.a,p=u+$*(1-u);if(p<1e-6)return I.transparent;const d=this.rgba.r*u/p+m.r*$*(1-u)/p,f=this.rgba.g*u/p+m.g*$*(1-u)/p,y=this.rgba.b*u/p+m.b*$*(1-u)/p;return new I(new v(d,f,y,p))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:m,g:u,b:$,a:p}=this.rgba;return new I(new v(l.rgba.r-p*(l.rgba.r-m),l.rgba.g-p*(l.rgba.g-u),l.rgba.b-p*(l.rgba.b-$),1))}flatten(...l){const m=l.reduceRight((u,$)=>I.o($,u));return I.o(this,m)}static o(l,m){const u=1-l.rgba.a;return new I(new v(u*m.rgba.r+l.rgba.a*l.rgba.r,u*m.rgba.g+l.rgba.a*l.rgba.g,u*m.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(l,m,u){if(l.isLighterThan(m))return l;u=u||.5;const $=l.getRelativeLuminance(),p=m.getRelativeLuminance();return u=u*(p-$)/p,l.lighten(u)}static getDarkerColor(l,m,u){if(l.isDarkerThan(m))return l;u=u||.5;const $=l.getRelativeLuminance(),p=m.getRelativeLuminance();return u=u*($-p)/$,l.darken(u)}static{this.white=new I(new v(255,255,255,1))}static{this.black=new I(new v(0,0,0,1))}static{this.red=new I(new v(255,0,0,1))}static{this.blue=new I(new v(0,0,255,1))}static{this.green=new I(new v(0,255,0,1))}static{this.cyan=new I(new v(0,255,255,1))}static{this.lightgrey=new I(new v(211,211,211,1))}static{this.transparent=new I(new v(0,0,0,0))}}e.$wu=I,function(b){let l;(function(m){let u;(function($){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:b.Format.CSS.formatRGBA(t)}$.formatRGB=p;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}$.formatRGBA=d;function f(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(t)}$.formatHSL=f;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}$.formatHSLA=y;function E(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function g(t){return`#${E(t.rgba.r)}${E(t.rgba.g)}${E(t.rgba.b)}`}$.formatHex=g;function S(t,o=!1){return o&&t.rgba.a===1?b.Format.CSS.formatHex(t):`#${E(t.rgba.r)}${E(t.rgba.g)}${E(t.rgba.b)}${E(Math.round(t.rgba.a*255))}`}$.formatHexA=S;function k(t){return t.isOpaque()?b.Format.CSS.formatHex(t):b.Format.CSS.formatRGBA(t)}$.format=k;function s(t){const o=t.length;if(o===0||t.charCodeAt(0)!==i.CharCode.Hash)return null;if(o===7){const n=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),c=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),h=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new b(new v(n,c,h,1))}if(o===9){const n=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),c=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),h=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),P=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new b(new v(n,c,h,P/255))}if(o===4){const n=a(t.charCodeAt(1)),c=a(t.charCodeAt(2)),h=a(t.charCodeAt(3));return new b(new v(16*n+n,16*c+c,16*h+h))}if(o===5){const n=a(t.charCodeAt(1)),c=a(t.charCodeAt(2)),h=a(t.charCodeAt(3)),P=a(t.charCodeAt(4));return new b(new v(16*n+n,16*c+c,16*h+h,(16*P+P)/255))}return null}$.parseHex=s;function a(t){switch(t){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(u=m.CSS||(m.CSS={}))})(l=b.Format||(b.Format={}))}(I||(e.$wu=I={}))}),define(le[54],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=r,e.$di=v,e.$ei=D;function i(O){return(I,b,l)=>{let m=null,u=null;if(typeof l.value=="function"?(m="value",u=l.value):typeof l.get=="function"&&(m="get",u=l.get),!u)throw new Error("not supported");l[m]=O(u,b)}}function r(O,I,b){let l=null,m=null;if(typeof b.value=="function"?(l="value",m=b.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(l="get",m=b.get),!m)throw new Error("not supported");const u=`$memoize$${I}`;b[l]=function(...$){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,$)}),this[u]}}function v(O,I,b){return i((l,m)=>{const u=`$debounce$${m}`,$=`$debounce$result$${m}`;return function(...p){this[$]||(this[$]=b?b():void 0),clearTimeout(this[u]),I&&(this[$]=I(this[$],...p),p=[this[$]]),this[u]=setTimeout(()=>{l.apply(this,p),this[$]=b?b():void 0},O)}})}function D(O,I,b){return i((l,m)=>{const u=`$throttle$timer$${m}`,$=`$throttle$result$${m}`,p=`$throttle$lastRun$${m}`,d=`$throttle$pending$${m}`;return function(...f){if(this[$]||(this[$]=b?b():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),I&&(this[$]=I(this[$],...f)),this[d])return;const y=this[p]+O;y<=Date.now()?(this[p]=Date.now(),l.apply(this,[this[$]]),this[$]=b?b():void 0):(this[d]=!0,this[u]=setTimeout(()=>{this[d]=!1,this[p]=Date.now(),l.apply(this,[this[$]]),this[$]=b?b():void 0},y-Date.now()))}})}}),define(le[15],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=e.$fb=e.$eb=e.$db=e.$cb=e.$ab=e.$9=e.$1=e.$Z=void 0,e.setUnexpectedErrorHandler=r,e.$3=v,e.$4=D,e.$5=O,e.$6=I,e.$7=b,e.$8=m,e.$0=$,e.$$=p,e.$_=d,e.$bb=y;class i{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?k.isErrorNoTelemetry(t)?new k(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$Z=i,e.$1=new i;function r(a){e.$1.setUnexpectedErrorHandler(a)}function v(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function D(a){m(a)||e.$1.onUnexpectedError(a)}function O(a){m(a)||e.$1.onUnexpectedExternalError(a)}function I(a){if(a instanceof Error){const{name:t,message:o}=a,n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:n,noTelemetry:k.isErrorNoTelemetry(a)}}return a}function b(a){let t;return a.noTelemetry?t=new k:(t=new Error,t.name=a.name),t.message=a.message,t.stack=a.stack,t}const l="Canceled";function m(a){return a instanceof u?!0:a instanceof Error&&a.name===l&&a.message===l}class u extends Error{constructor(){super(l),this.name=this.message}}e.$9=u;function $(){const a=new Error(l);return a.name=a.message,a}function p(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function d(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class f extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$ab=f;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class E extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$cb=E;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$db=g;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$eb=S;class k extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof k)return t;const o=new k;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$fb=k;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$gb=s}),define(le[21],ue([0,1,15,141]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.$cc=e.$ac=e.$_b=e.CompareResult=void 0,e.$wb=v,e.$xb=D,e.$yb=O,e.$zb=I,e.$Ab=b,e.$Bb=l,e.$Cb=m,e.$Db=u,e.$Eb=$,e.$Fb=p,e.$Gb=d,e.$Hb=f,e.$Ib=y,e.top=E,e.$Kb=g,e.$Lb=k,e.$Mb=s,e.$Nb=a,e.$Ob=t,e.$Pb=o,e.$Qb=n,e.$Rb=c,e.$Sb=h,e.$Tb=P,e.$Ub=w,e.$Vb=R,e.$Wb=T,e.$Xb=A,e.$Yb=L,e.$Zb=M,e.$1b=V,e.$2b=q,e.$3b=Y,e.$4b=de,e.$5b=re,e.$6b=ee,e.$7b=W,e.$8b=Z,e.$9b=C,e.$0b=z,e.$$b=ie,e.$bc=oe,e.$fc=U;function v(N,Q=0){return N[N.length-(1+Q)]}function D(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function O(N,Q,K=(H,_)=>H===_){if(N===Q)return!0;if(!N||!Q||N.length!==Q.length)return!1;for(let H=0,_=N.length;H<_;H++)if(!K(N[H],Q[H]))return!1;return!0}function I(N,Q){const K=N.length-1;Q<K&&(N[Q]=N[K]),N.pop()}function b(N,Q,K){return l(N.length,H=>K(N[H],Q))}function l(N,Q){let K=0,H=N-1;for(;K<=H;){const _=(K+H)/2|0,ae=Q(_);if(ae<0)K=_+1;else if(ae>0)H=_-1;else return _}return-(K+1)}function m(N,Q,K){if(N=N|0,N>=Q.length)throw new TypeError("invalid index");const H=Q[Math.floor(Q.length*Math.random())],_=[],ae=[],$e=[];for(const be of Q){const ye=K(be,H);ye<0?_.push(be):ye>0?ae.push(be):$e.push(be)}return N<_.length?m(N,_,K):N<_.length+$e.length?$e[0]:m(N-(_.length+$e.length),ae,K)}function u(N,Q){const K=[];let H;for(const _ of N.slice(0).sort(Q))!H||Q(H[0],_)!==0?(H=[_],K.push(H)):H.push(_);return K}function*$(N,Q){let K,H;for(const _ of N)H!==void 0&&Q(H,_)?K.push(_):(K&&(yield K),K=[_]),H=_;K&&(yield K)}function p(N,Q){for(let K=0;K<=N.length;K++)Q(K===0?void 0:N[K-1],K===N.length?void 0:N[K])}function d(N,Q){for(let K=0;K<N.length;K++)Q(K===0?void 0:N[K-1],N[K],K+1===N.length?void 0:N[K+1])}function f(N,Q,K){const H=[];function _(be,ye,Fe){if(ye===0&&Fe.length===0)return;const xe=H[H.length-1];xe&&xe.start+xe.deleteCount===be?(xe.deleteCount+=ye,xe.toInsert.push(...Fe)):H.push({start:be,deleteCount:ye,toInsert:Fe})}let ae=0,$e=0;for(;;){if(ae===N.length){_(ae,0,Q.slice($e));break}if($e===Q.length){_(ae,N.length-ae,[]);break}const be=N[ae],ye=Q[$e],Fe=K(be,ye);Fe===0?(ae+=1,$e+=1):Fe<0?(_(ae,1,[]),ae+=1):Fe>0&&(_(ae,0,[ye]),$e+=1)}return H}function y(N,Q,K){const H=f(N,Q,K),_=[],ae=[];for(const $e of H)_.push(...N.slice($e.start,$e.start+$e.deleteCount)),ae.push(...$e.toInsert);return{removed:_,added:ae}}function E(N,Q,K){if(K===0)return[];const H=N.slice(0,K).sort(Q);return S(N,Q,H,K,N.length),H}function g(N,Q,K,H,_){return K===0?Promise.resolve([]):new Promise((ae,$e)=>{(async()=>{const be=N.length,ye=N.slice(0,K).sort(Q);for(let Fe=K,xe=Math.min(K+H,be);Fe<be;Fe=xe,xe=Math.min(xe+H,be)){if(Fe>K&&await new Promise(Ae=>setTimeout(Ae)),_&&_.isCancellationRequested)throw new i.$9;S(N,Q,ye,Fe,xe)}return ye})().then(ae,$e)})}function S(N,Q,K,H,_){for(const ae=K.length;H<_;H++){const $e=N[H];if(Q($e,K[ae-1])<0){K.pop();const be=(0,r.$ob)(K,ye=>Q($e,ye)<0);K.splice(be,0,$e)}}}function k(N){return N.filter(Q=>!!Q)}function s(N){let Q=0;for(let K=0;K<N.length;K++)N[K]&&(N[Q]=N[K],Q+=1);N.length=Q}function a(N,Q,K){N.splice(K,0,N.splice(Q,1)[0])}function t(N){return!Array.isArray(N)||N.length===0}function o(N){return Array.isArray(N)&&N.length>0}function n(N,Q=K=>K){const K=new Set;return N.filter(H=>{const _=Q(H);return K.has(_)?!1:(K.add(_),!0)})}function c(N){const Q=new Set;return K=>{const H=N(K);return Q.has(H)?!1:(Q.add(H),!0)}}function h(N,Q){return N.length>0?N[0]:Q}function P(N,Q){return N.length>0?N[N.length-1]:Q}function w(N,Q,K=(H,_)=>H===_){let H=0;for(let _=0,ae=Math.min(N.length,Q.length);_<ae&&K(N[_],Q[_]);_++)H++;return H}function R(N,Q){let K=typeof Q=="number"?N:0;typeof Q=="number"?K=N:(K=0,Q=N);const H=[];if(K<=Q)for(let _=K;_<Q;_++)H.push(_);else for(let _=K;_>Q;_--)H.push(_);return H}function T(N,Q,K){return N.reduce((H,_)=>(H[Q(_)]=K?K(_):_,H),Object.create(null))}function A(N,Q){return N.push(Q),()=>L(N,Q)}function L(N,Q){const K=N.indexOf(Q);if(K>-1)return N.splice(K,1),Q}function M(N,Q,K){const H=N.slice(0,Q),_=N.slice(Q);return H.concat(K,_)}function V(N,Q){let K;if(typeof Q=="number"){let H=Q;K=()=>{const _=Math.sin(H++)*179426549;return _-Math.floor(_)}}else K=Math.random;for(let H=N.length-1;H>0;H-=1){const _=Math.floor(K()*(H+1)),ae=N[H];N[H]=N[_],N[_]=ae}}function q(N,Q){const K=N.indexOf(Q);K>-1&&(N.splice(K,1),N.unshift(Q))}function Y(N,Q){const K=N.indexOf(Q);K>-1&&(N.splice(K,1),N.push(Q))}function de(N,Q){for(const K of Q)N.push(K)}function re(N,Q){return Array.isArray(N)?N.map(Q):Q(N)}function ee(N){return Array.isArray(N)?N:[N]}function W(N){return N[Math.floor(Math.random()*N.length)]}function Z(N,Q,K){const H=B(N,Q),_=N.length,ae=K.length;N.length=_+ae;for(let $e=_-1;$e>=H;$e--)N[$e+ae]=N[$e];for(let $e=0;$e<ae;$e++)N[$e+H]=K[$e]}function C(N,Q,K,H){const _=B(N,Q);let ae=N.splice(_,K);return ae===void 0&&(ae=[]),Z(N,_,H),ae}function B(N,Q){return Q<0?Math.max(Q+N.length,0):Math.min(Q,N.length)}var F;(function(N){function Q(ae){return ae<0}N.isLessThan=Q;function K(ae){return ae<=0}N.isLessThanOrEqual=K;function H(ae){return ae>0}N.isGreaterThan=H;function _(ae){return ae===0}N.isNeitherLessOrGreaterThan=_,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(F||(e.CompareResult=F={}));function z(N,Q){return(K,H)=>Q(N(K),N(H))}function ie(...N){return(Q,K)=>{for(const H of N){const _=H(Q,K);if(!F.isNeitherLessOrGreaterThan(_))return _}return F.neitherLessOrGreaterThan}}const x=(N,Q)=>N-Q;e.$_b=x;const ce=(N,Q)=>(0,e.$_b)(N?1:0,Q?1:0);e.$ac=ce;function oe(N){return(Q,K)=>-N(Q,K)}class te{constructor(Q){this.g=Q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let K=this.c;for(;K<this.g.length&&Q(this.g[K]);)K++;const H=K===this.c?null:this.g.slice(this.c,K);return this.c=K,H}takeFromEndWhile(Q){let K=this.d;for(;K>=0&&Q(this.g[K]);)K--;const H=K===this.d?null:this.g.slice(K+1,this.d+1);return this.d=K,H}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Q=this.g[this.c];return this.c++,Q}removeLast(){const Q=this.g[this.d];return this.d--,Q}takeCount(Q){const K=this.g.slice(this.c,this.c+Q);return this.c+=Q,K}}e.$cc=te;class j{static{this.empty=new j(Q=>{})}constructor(Q){this.iterate=Q}forEach(Q){this.iterate(K=>(Q(K),!0))}toArray(){const Q=[];return this.iterate(K=>(Q.push(K),!0)),Q}filter(Q){return new j(K=>this.iterate(H=>Q(H)?K(H):!0))}map(Q){return new j(K=>this.iterate(H=>K(Q(H))))}some(Q){let K=!1;return this.iterate(H=>(K=Q(H),!K)),K}findFirst(Q){let K;return this.iterate(H=>Q(H)?(K=H,!1):!0),K}findLast(Q){let K;return this.iterate(H=>(Q(H)&&(K=H),!0)),K}findLastMaxBy(Q){let K,H=!0;return this.iterate(_=>((H||F.isGreaterThan(Q(_,K)))&&(H=!1,K=_),!0)),K}}e.$dc=j;class X{constructor(Q){this.c=Q}static createSortPermutation(Q,K){const H=Array.from(Q.keys()).sort((_,ae)=>K(Q[_],Q[ae]));return new X(H)}apply(Q){return Q.map((K,H)=>Q[this.c[H]])}inverse(){const Q=this.c.slice();for(let K=0;K<this.c.length;K++)Q[this.c[K]]=K;return new X(Q)}}e.$ec=X;async function U(N,Q){return(await Promise.all(N.map(async(H,_)=>({element:H,ok:await Q(H,_)})))).find(H=>H.ok)?.element}}),define(le[144],ue([0,1,15]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$jd=v,e.$kd=D,e.$ld=O,e.$md=I,e.$nd=b;function r(l,m){if(!l)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}function v(l,m="Unreachable"){throw new Error(m)}function D(l,m="unexpected state"){if(!l)throw new i.$gb(`Assertion Failed: ${m}`)}function O(l){l||(0,i.$4)(new i.$gb("Soft Assertion Failed"))}function I(l){if(!l()){debugger;l(),(0,i.$4)(new i.$gb("Assertion Failed"))}}function b(l,m){let u=0;for(;u<l.length-1;){const $=l[u],p=l[u+1];if(!m($,p))return!1;u++}return!0}}),define(le[91],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hb=i;function i(r,v){const D=this;let O=!1,I;return function(){if(O)return I;if(O=!0,v)try{I=r.apply(D,arguments)}finally{v()}else I=r.apply(D,arguments);return I}}}),define(le[78],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(r){function v(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}r.is=v;const D=Object.freeze([]);function O(){return D}r.empty=O;function*I(t){yield t}r.single=I;function b(t){return v(t)?t:I(t)}r.wrap=b;function l(t){return t||D}r.from=l;function*m(t){for(let o=t.length-1;o>=0;o--)yield t[o]}r.reverse=m;function u(t){return!t||t[Symbol.iterator]().next().done===!0}r.isEmpty=u;function $(t){return t[Symbol.iterator]().next().value}r.first=$;function p(t,o){let n=0;for(const c of t)if(o(c,n++))return!0;return!1}r.some=p;function d(t,o){for(const n of t)if(o(n))return n}r.find=d;function*f(t,o){for(const n of t)o(n)&&(yield n)}r.filter=f;function*y(t,o){let n=0;for(const c of t)yield o(c,n++)}r.map=y;function*E(t,o){let n=0;for(const c of t)yield*o(c,n++)}r.flatMap=E;function*g(...t){for(const o of t)yield*o}r.concat=g;function S(t,o,n){let c=n;for(const h of t)c=o(c,h);return c}r.reduce=S;function*k(t,o,n=t.length){for(o<0&&(o+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);o<n;o++)yield t[o]}r.slice=k;function s(t,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,t];const c=t[Symbol.iterator]();for(let h=0;h<o;h++){const P=c.next();if(P.done)return[n,r.empty()];n.push(P.value)}return[n,{[Symbol.iterator](){return c}}]}r.consume=s;async function a(t){const o=[];for await(const n of t)o.push(n);return Promise.resolve(o)}r.asyncToArray=a})(i||(e.Iterable=i={}))}),define(le[43],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$3n=O,e.$4n=u,e.$5n=$,e.$6n=p,e.$7n=d,e.$8n=f,e.$9n=y,e.$0n=E,e.$$n=g,e.$_n=S,e.$ao=k;var i;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var r;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var v;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(v||(e.ParseErrorCode=v={}));var D;(function(s){s.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function O(s,a=!1){let t=0;const o=s.length;let n="",c=0,h=r.Unknown,P=i.None;function w(q){let Y=0,de=0;for(;Y<q;){const re=s.charCodeAt(t);if(re>=m._0&&re<=m._9)de=de*16+re-m._0;else if(re>=m.A&&re<=m.F)de=de*16+re-m.A+10;else if(re>=m.a&&re<=m.f)de=de*16+re-m.a+10;else break;t++,Y++}return Y<q&&(de=-1),de}function R(q){t=q,n="",c=0,h=r.Unknown,P=i.None}function T(){const q=t;if(s.charCodeAt(t)===m._0)t++;else for(t++;t<s.length&&l(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===m.dot)if(t++,t<s.length&&l(s.charCodeAt(t)))for(t++;t<s.length&&l(s.charCodeAt(t));)t++;else return P=i.UnexpectedEndOfNumber,s.substring(q,t);let Y=t;if(t<s.length&&(s.charCodeAt(t)===m.E||s.charCodeAt(t)===m.e))if(t++,(t<s.length&&s.charCodeAt(t)===m.plus||s.charCodeAt(t)===m.minus)&&t++,t<s.length&&l(s.charCodeAt(t))){for(t++;t<s.length&&l(s.charCodeAt(t));)t++;Y=t}else P=i.UnexpectedEndOfNumber;return s.substring(q,Y)}function A(){let q="",Y=t;for(;;){if(t>=o){q+=s.substring(Y,t),P=i.UnexpectedEndOfString;break}const de=s.charCodeAt(t);if(de===m.doubleQuote){q+=s.substring(Y,t),t++;break}if(de===m.backslash){if(q+=s.substring(Y,t),t++,t>=o){P=i.UnexpectedEndOfString;break}switch(s.charCodeAt(t++)){case m.doubleQuote:q+='"';break;case m.backslash:q+="\\";break;case m.slash:q+="/";break;case m.b:q+="\b";break;case m.f:q+="\f";break;case m.n:q+=`
`;break;case m.r:q+="\r";break;case m.t:q+="	";break;case m.u:{const ee=w(4);ee>=0?q+=String.fromCharCode(ee):P=i.InvalidUnicode;break}default:P=i.InvalidEscapeCharacter}Y=t;continue}if(de>=0&&de<=31)if(b(de)){q+=s.substring(Y,t),P=i.UnexpectedEndOfString;break}else P=i.InvalidCharacter;t++}return q}function L(){if(n="",P=i.None,c=t,t>=o)return c=o,h=r.EOF;let q=s.charCodeAt(t);if(I(q)){do t++,n+=String.fromCharCode(q),q=s.charCodeAt(t);while(I(q));return h=r.Trivia}if(b(q))return t++,n+=String.fromCharCode(q),q===m.carriageReturn&&s.charCodeAt(t)===m.lineFeed&&(t++,n+=`
`),h=r.LineBreakTrivia;switch(q){case m.openBrace:return t++,h=r.OpenBraceToken;case m.closeBrace:return t++,h=r.CloseBraceToken;case m.openBracket:return t++,h=r.OpenBracketToken;case m.closeBracket:return t++,h=r.CloseBracketToken;case m.colon:return t++,h=r.ColonToken;case m.comma:return t++,h=r.CommaToken;case m.doubleQuote:return t++,n=A(),h=r.StringLiteral;case m.slash:{const Y=t-1;if(s.charCodeAt(t+1)===m.slash){for(t+=2;t<o&&!b(s.charCodeAt(t));)t++;return n=s.substring(Y,t),h=r.LineCommentTrivia}if(s.charCodeAt(t+1)===m.asterisk){t+=2;const de=o-1;let re=!1;for(;t<de;){if(s.charCodeAt(t)===m.asterisk&&s.charCodeAt(t+1)===m.slash){t+=2,re=!0;break}t++}return re||(t++,P=i.UnexpectedEndOfComment),n=s.substring(Y,t),h=r.BlockCommentTrivia}return n+=String.fromCharCode(q),t++,h=r.Unknown}case m.minus:if(n+=String.fromCharCode(q),t++,t===o||!l(s.charCodeAt(t)))return h=r.Unknown;case m._0:case m._1:case m._2:case m._3:case m._4:case m._5:case m._6:case m._7:case m._8:case m._9:return n+=T(),h=r.NumericLiteral;default:for(;t<o&&M(q);)t++,q=s.charCodeAt(t);if(c!==t){switch(n=s.substring(c,t),n){case"true":return h=r.TrueKeyword;case"false":return h=r.FalseKeyword;case"null":return h=r.NullKeyword}return h=r.Unknown}return n+=String.fromCharCode(q),t++,h=r.Unknown}}function M(q){if(I(q)||b(q))return!1;switch(q){case m.closeBrace:case m.closeBracket:case m.openBrace:case m.openBracket:case m.doubleQuote:case m.colon:case m.comma:case m.slash:return!1}return!0}function V(){let q;do q=L();while(q>=r.LineCommentTrivia&&q<=r.Trivia);return q}return{setPosition:R,getPosition:()=>t,scan:a?V:L,getToken:()=>h,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>P}}function I(s){return s===m.space||s===m.tab||s===m.verticalTab||s===m.formFeed||s===m.nonBreakingSpace||s===m.ogham||s>=m.enQuad&&s<=m.zeroWidthSpace||s===m.narrowNoBreakSpace||s===m.mathematicalSpace||s===m.ideographicSpace||s===m.byteOrderMark}function b(s){return s===m.lineFeed||s===m.carriageReturn||s===m.lineSeparator||s===m.paragraphSeparator}function l(s){return s>=m._0&&s<=m._9}var m;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(m||(m={}));function u(s,a){const t=[],o=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function P(w,R,T,A){c.value=w,c.offset=R,c.length=T,c.type=A,c.colonOffset=void 0,n=c}try{S(s,{onObjectBegin:(w,R)=>{if(a<=w)throw o;n=void 0,h=a>w,t.push("")},onObjectProperty:(w,R,T)=>{if(a<R||(P(w,R,T,"property"),t[t.length-1]=w,a<=R+T))throw o},onObjectEnd:(w,R)=>{if(a<=w)throw o;n=void 0,t.pop()},onArrayBegin:(w,R)=>{if(a<=w)throw o;n=void 0,t.push(0)},onArrayEnd:(w,R)=>{if(a<=w)throw o;n=void 0,t.pop()},onLiteralValue:(w,R,T)=>{if(a<R||(P(w,R,T,k(w)),a<=R+T))throw o},onSeparator:(w,R,T)=>{if(a<=R)throw o;if(w===":"&&n&&n.type==="property")n.colonOffset=R,h=!1,n=void 0;else if(w===","){const A=t[t.length-1];typeof A=="number"?t[t.length-1]=A+1:(h=!0,t[t.length-1]=""),n=void 0}}})}catch(w){if(w!==o)throw w}return{path:t,previousNode:n,isAtPropertyKey:h,matches:w=>{let R=0;for(let T=0;R<w.length&&T<t.length;T++)if(w[R]===t[T]||w[R]==="*")R++;else if(w[R]!=="**")return!1;return R===w.length}}}function $(s,a=[],t=D.DEFAULT){let o=null,n=[];const c=[];function h(w){Array.isArray(n)?n.push(w):o!==null&&(n[o]=w)}return S(s,{onObjectBegin:()=>{const w={};h(w),c.push(n),n=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const w=[];h(w),c.push(n),n=w,o=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:h,onError:(w,R,T)=>{a.push({error:w,offset:R,length:T})}},t),n[0]}function p(s,a=[],t=D.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(w){o.type==="property"&&(o.length=w-o.offset,o=o.parent)}function c(w){return o.children.push(w),w}S(s,{onObjectBegin:w=>{o=c({type:"object",offset:w,length:-1,parent:o,children:[]})},onObjectProperty:(w,R,T)=>{o=c({type:"property",offset:R,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:w,offset:R,length:T,parent:o})},onObjectEnd:(w,R)=>{o.length=w+R-o.offset,o=o.parent,n(w+R)},onArrayBegin:(w,R)=>{o=c({type:"array",offset:w,length:-1,parent:o,children:[]})},onArrayEnd:(w,R)=>{o.length=w+R-o.offset,o=o.parent,n(w+R)},onLiteralValue:(w,R,T)=>{c({type:k(w),offset:R,length:T,parent:o,value:w}),n(R+T)},onSeparator:(w,R,T)=>{o.type==="property"&&(w===":"?o.colonOffset=R:w===","&&n(R))},onError:(w,R,T)=>{a.push({error:w,offset:R,length:T})}},t);const P=o.children[0];return P&&delete P.parent,P}function d(s,a){if(!s)return;let t=s;for(const o of a)if(typeof o=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===o){t=c.children[1],n=!0;break}if(!n)return}else{const n=o;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}function f(s){if(!s.parent||!s.parent.children)return[];const a=f(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;a.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&a.push(t)}return a}function y(s){switch(s.type){case"array":return s.children.map(y);case"object":{const a=Object.create(null);for(const t of s.children){const o=t.children[1];o&&(a[t.children[0].value]=y(o))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}function E(s,a,t=!1){return a>=s.offset&&a<s.offset+s.length||t&&a===s.offset+s.length}function g(s,a,t=!1){if(E(s,a,t)){const o=s.children;if(Array.isArray(o))for(let n=0;n<o.length&&o[n].offset<=a;n++){const c=g(o[n],a,t);if(c)return c}return s}}function S(s,a,t=D.DEFAULT){const o=O(s,!1);function n(z){return z?()=>z(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(z){return z?ie=>z(ie,o.getTokenOffset(),o.getTokenLength()):()=>!0}const h=n(a.onObjectBegin),P=c(a.onObjectProperty),w=n(a.onObjectEnd),R=n(a.onArrayBegin),T=n(a.onArrayEnd),A=c(a.onLiteralValue),L=c(a.onSeparator),M=n(a.onComment),V=c(a.onError),q=t&&t.disallowComments,Y=t&&t.allowTrailingComma;function de(){for(;;){const z=o.scan();switch(o.getTokenError()){case i.InvalidUnicode:re(v.InvalidUnicode);break;case i.InvalidEscapeCharacter:re(v.InvalidEscapeCharacter);break;case i.UnexpectedEndOfNumber:re(v.UnexpectedEndOfNumber);break;case i.UnexpectedEndOfComment:q||re(v.UnexpectedEndOfComment);break;case i.UnexpectedEndOfString:re(v.UnexpectedEndOfString);break;case i.InvalidCharacter:re(v.InvalidCharacter);break}switch(z){case r.LineCommentTrivia:case r.BlockCommentTrivia:q?re(v.InvalidCommentToken):M();break;case r.Unknown:re(v.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return z}}}function re(z,ie=[],x=[]){if(V(z),ie.length+x.length>0){let ce=o.getToken();for(;ce!==r.EOF;){if(ie.indexOf(ce)!==-1){de();break}else if(x.indexOf(ce)!==-1)break;ce=de()}}}function ee(z){const ie=o.getTokenValue();return z?A(ie):P(ie),de(),!0}function W(){switch(o.getToken()){case r.NumericLiteral:{let z=0;try{z=JSON.parse(o.getTokenValue()),typeof z!="number"&&(re(v.InvalidNumberFormat),z=0)}catch{re(v.InvalidNumberFormat)}A(z);break}case r.NullKeyword:A(null);break;case r.TrueKeyword:A(!0);break;case r.FalseKeyword:A(!1);break;default:return!1}return de(),!0}function Z(){return o.getToken()!==r.StringLiteral?(re(v.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(ee(!1),o.getToken()===r.ColonToken?(L(":"),de(),F()||re(v.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):re(v.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function C(){h(),de();let z=!1;for(;o.getToken()!==r.CloseBraceToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(z||re(v.ValueExpected,[],[]),L(","),de(),o.getToken()===r.CloseBraceToken&&Y)break}else z&&re(v.CommaExpected,[],[]);Z()||re(v.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),z=!0}return w(),o.getToken()!==r.CloseBraceToken?re(v.CloseBraceExpected,[r.CloseBraceToken],[]):de(),!0}function B(){R(),de();let z=!1;for(;o.getToken()!==r.CloseBracketToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(z||re(v.ValueExpected,[],[]),L(","),de(),o.getToken()===r.CloseBracketToken&&Y)break}else z&&re(v.CommaExpected,[],[]);F()||re(v.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),z=!0}return T(),o.getToken()!==r.CloseBracketToken?re(v.CloseBracketExpected,[r.CloseBracketToken],[]):de(),!0}function F(){switch(o.getToken()){case r.OpenBracketToken:return B();case r.OpenBraceToken:return C();case r.StringLiteral:return ee(!0);default:return W()}}return de(),o.getToken()===r.EOF?t.allowEmptyContent?!0:(re(v.ValueExpected,[],[]),!1):F()?(o.getToken()!==r.EOF&&re(v.EndOfFileExpected,[],[]),!0):(re(v.ValueExpected,[],[]),!1)}function k(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[145],ue([0,1,43]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=r,e.$co=v,e.$do=I,e.$eo=b;function r(l,m,u){let $,p,d,f,y;if(m){for(f=m.offset,y=f+m.length,d=f;d>0&&!b(l,d-1);)d--;let P=y;for(;P<l.length&&!b(l,P);)P++;p=l.substring(d,P),$=O(p,u)}else p=l,$=0,d=0,f=0,y=l.length;const E=I(u,l);let g=!1,S=0,k;u.insertSpaces?k=D(" ",u.tabSize||4):k="	";const s=(0,i.$3n)(p,!1);let a=!1;function t(){return E+D(k,$+S)}function o(){let P=s.scan();for(g=!1;P===i.SyntaxKind.Trivia||P===i.SyntaxKind.LineBreakTrivia;)g=g||P===i.SyntaxKind.LineBreakTrivia,P=s.scan();return a=P===i.SyntaxKind.Unknown||s.getTokenError()!==i.ScanError.None,P}const n=[];function c(P,w,R){!a&&w<y&&R>f&&l.substring(w,R)!==P&&n.push({offset:w,length:R-w,content:P})}let h=o();if(h!==i.SyntaxKind.EOF){const P=s.getTokenOffset()+d,w=D(k,$);c(w,d,P)}for(;h!==i.SyntaxKind.EOF;){let P=s.getTokenOffset()+s.getTokenLength()+d,w=o(),R="";for(;!g&&(w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia);){const A=s.getTokenOffset()+d;c(" ",P,A),P=s.getTokenOffset()+s.getTokenLength()+d,R=w===i.SyntaxKind.LineCommentTrivia?t():"",w=o()}if(w===i.SyntaxKind.CloseBraceToken)h!==i.SyntaxKind.OpenBraceToken&&(S--,R=t());else if(w===i.SyntaxKind.CloseBracketToken)h!==i.SyntaxKind.OpenBracketToken&&(S--,R=t());else{switch(h){case i.SyntaxKind.OpenBracketToken:case i.SyntaxKind.OpenBraceToken:S++,R=t();break;case i.SyntaxKind.CommaToken:case i.SyntaxKind.LineCommentTrivia:R=t();break;case i.SyntaxKind.BlockCommentTrivia:g?R=t():R=" ";break;case i.SyntaxKind.ColonToken:R=" ";break;case i.SyntaxKind.StringLiteral:if(w===i.SyntaxKind.ColonToken){R="";break}case i.SyntaxKind.NullKeyword:case i.SyntaxKind.TrueKeyword:case i.SyntaxKind.FalseKeyword:case i.SyntaxKind.NumericLiteral:case i.SyntaxKind.CloseBraceToken:case i.SyntaxKind.CloseBracketToken:w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia?R=" ":w!==i.SyntaxKind.CommaToken&&w!==i.SyntaxKind.EOF&&(a=!0);break;case i.SyntaxKind.Unknown:a=!0;break}g&&(w===i.SyntaxKind.LineCommentTrivia||w===i.SyntaxKind.BlockCommentTrivia)&&(R=t())}const T=s.getTokenOffset()+d;c(R,P,T),h=w}return n}function v(l,m){const u=JSON.stringify(l,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?u.replace(/\r\n|\r|\n/g,m.eol):u}function D(l,m){let u="";for(let $=0;$<m;$++)u+=l;return u}function O(l,m){let u=0,$=0;const p=m.tabSize||4;for(;u<l.length;){const d=l.charAt(u);if(d===" ")$++;else if(d==="	")$+=p;else break;u++}return Math.floor($/p)}function I(l,m){for(let u=0;u<m.length;u++){const $=m.charAt(u);if($==="\r")return u+1<m.length&&m.charAt(u+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return l&&l.eol||`
`}function b(l,m){return`\r
`.indexOf(l.charAt(m))!==-1}}),define(le[110],ue([0,1,43,145]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=v,e.$go=D,e.$ho=O,e.$io=I,e.$jo=b;function v(l,m,u){return D(l,m,void 0,u)}function D(l,m,u,$,p){const d=m.slice(),f=[],y=(0,i.$6n)(l,f);let E,g;for(;d.length>0&&(g=d.pop(),E=(0,i.$7n)(y,d),E===void 0&&u!==void 0);)typeof g=="string"?u={[g]:u}:u=[u];if(E)if(E.type==="object"&&typeof g=="string"&&Array.isArray(E.children)){const S=(0,i.$7n)(E,[g]);if(S!==void 0)if(u===void 0){if(!S.parent)throw new Error("Malformed AST");const k=E.children.indexOf(S.parent);let s,a=S.parent.offset+S.parent.length;if(k>0){const t=E.children[k-1];s=t.offset+t.length}else s=E.offset+1,E.children.length>1&&(a=E.children[1].offset);return O(l,{offset:s,length:a-s,content:""},$)}else return O(l,{offset:S.offset,length:S.length,content:JSON.stringify(u)},$);else{if(u===void 0)return[];const k=`${JSON.stringify(g)}: ${JSON.stringify(u)}`,s=p?p(E.children.map(t=>t.children[0].value)):E.children.length;let a;if(s>0){const t=E.children[s-1];a={offset:t.offset+t.length,length:0,content:","+k}}else E.children.length===0?a={offset:E.offset+1,length:0,content:k}:a={offset:E.offset+1,length:0,content:k+","};return O(l,a,$)}}else if(E.type==="array"&&typeof g=="number"&&Array.isArray(E.children))if(u!==void 0){const S=`${JSON.stringify(u)}`;let k;if(E.children.length===0||g===0)k={offset:E.offset+1,length:0,content:E.children.length===0?S:S+","};else{const s=g===-1||g>E.children.length?E.children.length:g,a=E.children[s-1];k={offset:a.offset+a.length,length:0,content:","+S}}return O(l,k,$)}else{const S=g,k=E.children[S];let s;if(E.children.length===1)s={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===S){const a=E.children[S-1],t=a.offset+a.length,o=E.offset+E.length;s={offset:t,length:o-2-t,content:""}}else s={offset:k.offset,length:E.children[S+1].offset-k.offset,content:""};return O(l,s,$)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${E.type}`);else return u===void 0?[]:O(l,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(u)},$)}function O(l,m,u){let $=I(l,m),p=m.offset,d=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;p>0&&!(0,r.$eo)($,p-1);)p--;for(;d<$.length&&!(0,r.$eo)($,d);)d++}const f=(0,r.$bo)($,{offset:p,length:d-p},u);for(let E=f.length-1;E>=0;E--){const g=f[E];$=I($,g),p=Math.min(p,g.offset),d=Math.max(d,g.offset+g.length),d+=g.content.length-g.length}const y=l.length-($.length-d)-p;return[{offset:p,length:y,content:$.substring(p,d)}]}function I(l,m){return l.substring(0,m.offset)+m.content+l.substring(m.offset+m.length)}function b(l,m){const u=m.slice(0).sort((p,d)=>{const f=p.offset-d.offset;return f===0?p.length-d.length:f});let $=l.length;for(let p=u.length-1;p>=0;p--){const d=u[p];if(d.offset+d.length<=$)l=I(l,d);else throw new Error("Overlapping edit");$=d.offset}return l}}),define(le[146],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=i;function i(D){let O=!1;const I=new Map,b=new Map;if(v(D,f=>{if(D===f)return!0;const y=JSON.stringify(f);if(y.length<30)return!0;const E=I.get(y);if(!E){const g={schemas:[f]};return I.set(y,g),b.set(f,g),!0}return E.schemas.push(f),b.set(f,E),O=!0,!1}),I.clear(),!O)return JSON.stringify(D);let m="$defs";for(;D.hasOwnProperty(m);)m+="_";const u=[];function $(f){return JSON.stringify(f,(y,E)=>{if(E!==f){const g=b.get(E);if(g&&g.schemas.length>1)return g.id||(g.id=`_${u.length}`,u.push(g.schemas[0])),{$ref:`#/${m}/${g.id}`}}return E})}const p=$(D),d=[];for(let f=0;f<u.length;f++)d.push(`"_${f}":${$(u[f])}`);return d.length?`${p.substring(0,p.length-1)},"${m}":{${d.join(",")}}}`:p}function r(D){return typeof D=="object"&&D!==null}function v(D,O){if(!D||typeof D!="object")return;const I=(...p)=>{for(const d of p)r(d)&&u.push(d)},b=(...p)=>{for(const d of p)if(r(d))for(const f in d){const y=d[f];r(y)&&u.push(y)}},l=(...p)=>{for(const d of p)if(Array.isArray(d))for(const f of d)r(f)&&u.push(f)},m=p=>{if(Array.isArray(p))for(const d of p)r(d)&&u.push(d);else r(p)&&u.push(p)},u=[D];let $=u.pop();for(;$;)O($)&&(I($.additionalItems,$.additionalProperties,$.not,$.contains,$.propertyNames,$.if,$.then,$.else,$.unevaluatedItems,$.unevaluatedProperties),b($.definitions,$.$defs,$.properties,$.patternProperties,$.dependencies,$.dependentSchemas),l($.anyOf,$.allOf,$.oneOf,$.prefixItems),m($.items)),$=u.pop()}}),function(){function G(){const e=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function i(v){return v.replace(e,function(D,O,I,b,l,m){if(b)return"";if(l){const u=l.length;return l[u-1]===`
`?l[u-2]==="\r"?`\r
`:`
`:""}else return m?D.substring(1):D})}function r(v){const D=i(v);try{return JSON.parse(D)}catch{const I=D.replace(/,\s*([}\]])/g,"$1");return JSON.parse(I)}}return{stripComments:i,parse:r}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return G()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=G():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[67],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y=void 0;class i{constructor(v){this.d=v,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(v){this.c=v}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$Y=i}),define(le[111],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(D){this.element=D,this.next=i.Undefined,this.prev=i.Undefined}}class r{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let D=this.a;for(;D!==i.Undefined;){const O=D.next;D.prev=i.Undefined,D.next=i.Undefined,D=O}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,O){const I=new i(D);if(this.a===i.Undefined)this.a=I,this.b=I;else if(O){const l=this.b;this.b=I,I.prev=l,l.next=I}else{const l=this.a;this.a=I,I.next=l,l.prev=I}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(I))}}shift(){if(this.a!==i.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==i.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==i.Undefined&&D.next!==i.Undefined){const O=D.prev;O.next=D.next,D.next.prev=O}else D.prev===i.Undefined&&D.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):D.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):D.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==i.Undefined;)yield D.element,D=D.next}}e.$0c=r}),define(le[31],ue([0,1]),function(G,e){"use strict";var i,r,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.Touch=e.$Gc=e.$Fc=void 0,e.$Cc=D,e.$Dc=O,e.$Ec=I,e.$Nc=k;function D(s,a,t){let o=s.get(a);return o===void 0&&(o=t,s.set(a,o)),o}function O(s){const a=[];return s.forEach((t,o)=>{a.push(`${o} => ${t}`)}),`Map(${s.size}) {${a.join(", ")}}`}function I(s){const a=[];return s.forEach(t=>{a.push(t)}),`Set(${s.size}) {${a.join(", ")}}`}class b{constructor(a,t){this.uri=a,this.value=t}}function l(s){return Array.isArray(s)}class m{static{this.c=a=>a.toString()}constructor(a,t){if(this[i]="ResourceMap",a instanceof m)this.d=new Map(a.d),this.e=t??m.c;else if(l(a)){this.d=new Map,this.e=t??m.c;for(const[o,n]of a)this.set(o,n)}else this.d=new Map,this.e=a??m.c}set(a,t){return this.d.set(this.e(a),new b(a,t)),this}get(a){return this.d.get(this.e(a))?.value}has(a){return this.d.has(this.e(a))}get size(){return this.d.size}clear(){this.d.clear()}delete(a){return this.d.delete(this.e(a))}forEach(a,t){typeof t<"u"&&(a=a.bind(t));for(const[o,n]of this.d)a(n.value,n.uri,this)}*values(){for(const a of this.d.values())yield a.value}*keys(){for(const a of this.d.values())yield a.uri}*entries(){for(const a of this.d.values())yield[a.uri,a.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.d)yield[a.uri,a.value]}}e.$Fc=m;class u{constructor(a,t){this[r]="ResourceSet",!a||typeof a=="function"?this.c=new m(a):(this.c=new m(t),a.forEach(this.add,this))}get size(){return this.c.size}add(a){return this.c.set(a,a),this}clear(){this.c.clear()}delete(a){return this.c.delete(a)}forEach(a,t){this.c.forEach((o,n)=>a.call(t,n,n,this))}has(a){return this.c.has(a)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Gc=u;var $;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})($||(e.Touch=$={}));class p{constructor(){this[v]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(a){return this.c.has(a)}get(a,t=$.None){const o=this.c.get(a);if(o)return t!==$.None&&this.m(o,t),o.value}set(a,t,o=$.None){let n=this.c.get(a);if(n)n.value=t,o!==$.None&&this.m(n,o);else{switch(n={key:a,value:t,next:void 0,previous:void 0},o){case $.None:this.k(n);break;case $.AsOld:this.j(n);break;case $.AsNew:this.k(n);break;default:this.k(n);break}this.c.set(a,n),this.f++}return this}delete(a){return!!this.remove(a)}remove(a){const t=this.c.get(a);if(t)return this.c.delete(a),this.l(t),this.f--,t.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const a=this.d;return this.c.delete(a.key),this.l(a),this.f--,a.value}forEach(a,t){const o=this.g;let n=this.d;for(;n;){if(t?a.bind(t)(n.value,n.key,this):a(n.value,n.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const a=this,t=this.g;let o=this.d;const n={[Symbol.iterator](){return n},next(){if(a.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.key,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return n}values(){const a=this,t=this.g;let o=this.d;const n={[Symbol.iterator](){return n},next(){if(a.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.value,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return n}entries(){const a=this,t=this.g;let o=this.d;const n={[Symbol.iterator](){return n},next(){if(a.g!==t)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:[o.key,o.value],done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return n}[(v=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(a){if(a>=this.size)return;if(a===0){this.clear();return}let t=this.d,o=this.size;for(;t&&o>a;)this.c.delete(t.key),t=t.next,o--;this.d=t,this.f=o,t&&(t.previous=void 0),this.g++}i(a){if(a>=this.size)return;if(a===0){this.clear();return}let t=this.e,o=this.size;for(;t&&o>a;)this.c.delete(t.key),t=t.previous,o--;this.e=t,this.f=o,t&&(t.next=void 0),this.g++}j(a){if(!this.d&&!this.e)this.e=a;else if(this.d)a.next=this.d,this.d.previous=a;else throw new Error("Invalid list");this.d=a,this.g++}k(a){if(!this.d&&!this.e)this.d=a;else if(this.e)a.previous=this.e,this.e.next=a;else throw new Error("Invalid list");this.e=a,this.g++}l(a){if(a===this.d&&a===this.e)this.d=void 0,this.e=void 0;else if(a===this.d){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.d=a.next}else if(a===this.e){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.e=a.previous}else{const t=a.next,o=a.previous;if(!t||!o)throw new Error("Invalid list");t.previous=o,o.next=t}a.next=void 0,a.previous=void 0,this.g++}m(a,t){if(!this.d||!this.e)throw new Error("Invalid list");if(!(t!==$.AsOld&&t!==$.AsNew)){if(t===$.AsOld){if(a===this.d)return;const o=a.next,n=a.previous;a===this.e?(n.next=void 0,this.e=n):(o.previous=n,n.next=o),a.previous=void 0,a.next=this.d,this.d.previous=a,this.d=a,this.g++}else if(t===$.AsNew){if(a===this.e)return;const o=a.next,n=a.previous;a===this.d?(o.previous=void 0,this.d=o):(o.previous=n,n.next=o),a.next=void 0,a.previous=this.e,this.e.next=a,this.e=a,this.g++}}}toJSON(){const a=[];return this.forEach((t,o)=>{a.push([o,t])}),a}fromJSON(a){this.clear();for(const[t,o]of a)this.set(t,o)}}e.$Hc=p;class d extends p{constructor(a,t=1){super(),this.n=a,this.o=Math.min(Math.max(0,t),1)}get limit(){return this.n}set limit(a){this.n=a,this.p()}get ratio(){return this.o}set ratio(a){this.o=Math.min(Math.max(0,a),1),this.p()}get(a,t=$.AsNew){return super.get(a,t)}peek(a){return super.get(a,$.None)}set(a,t){return super.set(a,t,$.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class f extends d{constructor(a,t=1){super(a,t)}q(a){this.h(a)}set(a,t){return super.set(a,t),this.p(),this}}e.$Ic=f;class y extends d{constructor(a,t=1){super(a,t)}q(a){this.i(a)}set(a,t){return this.n<=this.size&&!this.has(a)&&this.q(Math.round(this.n*this.o)-1),super.set(a,t),this}}e.$Jc=y;class E{constructor(){this.c=new Map}add(a){return this.c.set(a,(this.c.get(a)||0)+1),this}delete(a){let t=this.c.get(a)||0;return t===0?!1:(t--,t===0?this.c.delete(a):this.c.set(a,t),!0)}has(a){return this.c.has(a)}}e.$Kc=E;class g{constructor(a){if(this.c=new Map,this.d=new Map,a)for(const[t,o]of a)this.set(t,o)}clear(){this.c.clear(),this.d.clear()}set(a,t){this.c.set(a,t),this.d.set(t,a)}get(a){return this.c.get(a)}getKey(a){return this.d.get(a)}delete(a){const t=this.c.get(a);return t===void 0?!1:(this.c.delete(a),this.d.delete(t),!0)}forEach(a,t){this.c.forEach((o,n)=>{a.call(t,o,n,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Lc=g;class S{constructor(){this.c=new Map}add(a,t){let o=this.c.get(a);o||(o=new Set,this.c.set(a,o)),o.add(t)}delete(a,t){const o=this.c.get(a);o&&(o.delete(t),o.size===0&&this.c.delete(a))}forEach(a,t){const o=this.c.get(a);o&&o.forEach(t)}get(a){const t=this.c.get(a);return t||new Set}}e.$Mc=S;function k(s,a){if(s===a)return!0;if(s.size!==a.size)return!1;for(const[t,o]of s)if(!a.has(t)||a.get(t)!==o)return!1;for(const[t]of a)if(!s.has(t))return!1;return!0}}),define(le[2],ue([0,1,21,142,31,91,78]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$7c=e.$6c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Oc=void 0,e.$Pc=m,e.$Qc=u,e.$Rc=$,e.$Sc=f,e.$Tc=y,e.$Uc=E,e.$Vc=g,e.$Wc=S,e.$Xc=k,e.$8c=R;const I=!1;let b=null;class l{constructor(){this.b=new Map}static{this.a=0}c(L){let M=this.b.get(L);return M||(M={parent:null,source:null,isSingleton:!1,value:L,idx:l.a++},this.b.set(L,M)),M}trackDisposable(L){const M=this.c(L);M.source||(M.source=new Error().stack)}setParent(L,M){const V=this.c(L);V.parent=M}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,M){const V=M.get(L);if(V)return V;const q=L.parent?this.f(this.c(L.parent),M):L;return M.set(L,q),q}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,V])=>V.source!==null&&!this.f(V,L).isSingleton).flatMap(([V])=>V)}computeLeakingDisposables(L=10,M){let V;if(M)V=M;else{const ee=new Map,W=[...this.b.values()].filter(C=>C.source!==null&&!this.f(C,ee).isSingleton);if(W.length===0)return;const Z=new Set(W.map(C=>C.value));if(V=W.filter(C=>!(C.parent&&Z.has(C.parent))),V.length===0)throw new Error("There are cyclic diposable chains!")}if(!V)return;function q(ee){function W(C,B){for(;C.length>0&&B.some(F=>typeof F=="string"?F===C[0]:C[0].match(F));)C.shift()}const Z=ee.source.split(`
`).map(C=>C.trim().replace("at ","")).filter(C=>C!=="");return W(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const Y=new v.$Mc;for(const ee of V){const W=q(ee);for(let Z=0;Z<=W.length;Z++)Y.add(W.slice(0,Z).join(`
`),ee)}V.sort((0,i.$0b)(ee=>ee.idx,i.$_b));let de="",re=0;for(const ee of V.slice(0,L)){re++;const W=q(ee),Z=[];for(let C=0;C<W.length;C++){let B=W[C];B=`(shared with ${Y.get(W.slice(0,C+1).join(`
`)).size}/${V.length} leaks) at ${B}`;const z=Y.get(W.slice(0,C).join(`
`)),ie=(0,r.$e)([...z].map(x=>q(x)[C]),x=>x);delete ie[W[C]];for(const[x,ce]of Object.entries(ie))Z.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${x}`);Z.unshift(B)}de+=`


==================== Leaking disposable ${re}/${V.length}: ${ee.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return V.length>L&&(de+=`


... and ${V.length-L} more leaking disposables

`),{leaks:V,details:de}}}e.$Oc=l;function m(A){b=A}if(I){const A="__is_disposable_tracked__";m(new class{trackDisposable(L){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[A]||console.log(M)},3e3)}setParent(L,M){if(L&&L!==a.None)try{L[A]=!0}catch{}}markAsDisposed(L){if(L&&L!==a.None)try{L[A]=!0}catch{}}markAsSingleton(L){}})}function u(A){return b?.trackDisposable(A),A}function $(A){b?.markAsDisposed(A)}function p(A,L){b?.setParent(A,L)}function d(A,L){if(b)for(const M of A)b.setParent(M,L)}function f(A){return b?.markAsSingleton(A),A}function y(A){return typeof A=="object"&&A!==null&&typeof A.dispose=="function"&&A.dispose.length===0}function E(A){if(O.Iterable.is(A)){const L=[];for(const M of A)if(M)try{M.dispose()}catch(V){L.push(V)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}function g(A){for(const L of A)y(L)&&L.dispose();return[]}function S(...A){const L=k(()=>E(A));return d(A,L),L}function k(A){const L=u({dispose:(0,D.$hb)(()=>{$(L),A()})});return L}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,u(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{E(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return p(L,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),p(L,null))}}e.$Yc=s;class a{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,u(this),p(this.q,this)}dispose(){$(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Zc=a;class t{constructor(){this.b=!1,u(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&p(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&p(L,null),L}}e.$1c=t;class o{constructor(L){this.a=new t,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}e.$2c=o;class n{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$3c=n;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set(L){let M=L;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,$(this))},this}}e.$4c=c;class h{constructor(){this.a=new Map}acquire(L,...M){let V=this.a.get(L);V||(V={counter:0,object:this.b(L,...M)},this.a.set(L,V));const{object:q}=V,Y=(0,D.$hb)(()=>{--V.counter===0&&(this.c(L,V.object),this.a.delete(L))});return V.counter++,{object:q,dispose:Y}}}e.$5c=h;class P{constructor(L){this.a=L}async acquire(L,...M){const V=this.a.acquire(L,...M);try{return{object:await V.object,dispose:()=>V.dispose()}}catch(q){throw V.dispose(),q}}}e.$6c=P;class w{constructor(L){this.object=L}dispose(){}}e.$7c=w;function R(A){const L=new s;try{A(L)}finally{L.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,u(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{E(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,M,V=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),V||this.a.get(L)?.dispose(),this.a.set(L,M)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}deleteAndLeak(L){const M=this.a.get(L);return this.a.delete(L),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$9c=T}),define(le[92],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var i;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(e.MarshalledId=i={}))}),define(le[79],ue([0,1,31]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=void 0,e.$sm=v,e.$tm=O;const r=new i.$Ic(1e4);function v(l){return b(l,"NFC",r)}const D=new i.$Ic(1e4);function O(l){return b(l,"NFD",D)}const I=/[^\u0000-\u0080]/;function b(l,m,u){if(!l)return l;const $=u.get(l);if($)return $;let p;return I.test(l)?p=l.normalize(m):p=l,u.set(l,p),p}e.$um=function(){const l=/[\u0300-\u036f]/g;return function(m){return O(m).replace(l,"")}}()}),define(le[147],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Qm=i,e.rot=r,e.$Vm=I;function i(b,l,m){return Math.min(Math.max(b,l),m)}function r(b,l){return(l+b%l)%l}class v{constructor(){this.a=0}getNext(){return this.a++}}e.$Sm=v;class D{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Tm=D;class O{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const m=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Um=O;function I(b,l,m,u,$,p,d,f){const y=d-m,E=f-u,g=$-m,S=p-u,k=b-m,s=l-u,a=y*y+E*E,t=y*g+E*S,o=y*k+E*s,n=g*g+S*S,c=g*k+S*s,h=1/(a*n-t*t),P=(n*o-t*c)*h,w=(a*c-t*o)*h;return P>=0&&w>=0&&P+w<1}}),function(){function G(v){const D=[];typeof v=="number"&&D.push("code/timeOrigin",v);function O(b){D.push(b,Date.now())}function I(){const b=[];for(let l=0;l<D.length;l+=2)b.push({name:D[l],startTime:D[l+1]});return b}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const O of performance.getEntriesByType("mark"))D.push({name:O.name,startTime:Math.round(v+O.startTime)});return D}};if(typeof process=="object"){const v=performance?.timeOrigin;return G(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function i(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=e()),v.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=i(r))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var r in i)(typeof exports=="object"?exports:G)[r]=i[r]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function i(r){if(e[r])return e[r].exports;var v=e[r]={i:r,l:!1,exports:{}};return G[r].call(v.exports,v,v.exports,i),v.l=!0,v.exports}return i.m=G,i.c=e,i.d=function(r,v,D){i.o(r,v)||Object.defineProperty(r,v,{enumerable:!0,get:D})},i.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},i.t=function(r,v){if(1&v&&(r=i(r)),8&v||4&v&&typeof r=="object"&&r&&r.__esModule)return r;var D=Object.create(null);if(i.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:r}),2&v&&typeof r!="string")for(var O in r)i.d(D,O,function(I){return r[I]}.bind(null,O));return D},i.n=function(r){var v=r&&r.__esModule?function(){return r.default}:function(){return r};return i.d(v,"a",v),v},i.o=function(r,v){return Object.prototype.hasOwnProperty.call(r,v)},i.p="",i(i.s=0)}([function(G,e,i){(function(r){var v;e=G.exports=ce,v=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],b=e.src=[],l=0,m=l++;b[m]="0|[1-9]\\d*";var u=l++;b[u]="[0-9]+";var $=l++;b[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=l++;b[p]="("+b[m]+")\\.("+b[m]+")\\.("+b[m]+")";var d=l++;b[d]="("+b[u]+")\\.("+b[u]+")\\.("+b[u]+")";var f=l++;b[f]="(?:"+b[m]+"|"+b[$]+")";var y=l++;b[y]="(?:"+b[u]+"|"+b[$]+")";var E=l++;b[E]="(?:-("+b[f]+"(?:\\."+b[f]+")*))";var g=l++;b[g]="(?:-?("+b[y]+"(?:\\."+b[y]+")*))";var S=l++;b[S]="[0-9A-Za-z-]+";var k=l++;b[k]="(?:\\+("+b[S]+"(?:\\."+b[S]+")*))";var s=l++,a="v?"+b[p]+b[E]+"?"+b[k]+"?";b[s]="^"+a+"$";var t="[v=\\s]*"+b[d]+b[g]+"?"+b[k]+"?",o=l++;b[o]="^"+t+"$";var n=l++;b[n]="((?:<|>)?=?)";var c=l++;b[c]=b[u]+"|x|X|\\*";var h=l++;b[h]=b[m]+"|x|X|\\*";var P=l++;b[P]="[v=\\s]*("+b[h]+")(?:\\.("+b[h]+")(?:\\.("+b[h]+")(?:"+b[E]+")?"+b[k]+"?)?)?";var w=l++;b[w]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[g]+")?"+b[k]+"?)?)?";var R=l++;b[R]="^"+b[n]+"\\s*"+b[P]+"$";var T=l++;b[T]="^"+b[n]+"\\s*"+b[w]+"$";var A=l++;b[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=l++;b[L]="(?:~>?)";var M=l++;b[M]="(\\s*)"+b[L]+"\\s+",I[M]=new RegExp(b[M],"g");var V=l++;b[V]="^"+b[L]+b[P]+"$";var q=l++;b[q]="^"+b[L]+b[w]+"$";var Y=l++;b[Y]="(?:\\^)";var de=l++;b[de]="(\\s*)"+b[Y]+"\\s+",I[de]=new RegExp(b[de],"g");var re=l++;b[re]="^"+b[Y]+b[P]+"$";var ee=l++;b[ee]="^"+b[Y]+b[w]+"$";var W=l++;b[W]="^"+b[n]+"\\s*("+t+")$|^$";var Z=l++;b[Z]="^"+b[n]+"\\s*("+a+")$|^$";var C=l++;b[C]="(\\s*)"+b[n]+"\\s*("+t+"|"+b[P]+")",I[C]=new RegExp(b[C],"g");var B=l++;b[B]="^\\s*("+b[P]+")\\s+-\\s+("+b[P]+")\\s*$";var F=l++;b[F]="^\\s*("+b[w]+")\\s+-\\s+("+b[w]+")\\s*$";var z=l++;b[z]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)v(ie,b[ie]),I[ie]||(I[ie]=new RegExp(b[ie]));function x(J,he){if(J instanceof ce)return J;if(typeof J!="string"||J.length>D||!(he?I[o]:I[s]).test(J))return null;try{return new ce(J,he)}catch{return null}}function ce(J,he){if(J instanceof ce){if(J.loose===he)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof ce))return new ce(J,he);v("SemVer",J,he),this.loose=he;var fe=J.trim().match(he?I[o]:I[s]);if(!fe)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var ve=+pe;if(ve>=0&&ve<O)return ve}return pe}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=x,e.valid=function(J,he){var fe=x(J,he);return fe?fe.version:null},e.clean=function(J,he){var fe=x(J.trim().replace(/^[=v]+/,""),he);return fe?fe.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(J){return v("SemVer.compare",this.version,this.loose,J),J instanceof ce||(J=new ce(J,this.loose)),this.compareMain(J)||this.comparePre(J)},ce.prototype.compareMain=function(J){return J instanceof ce||(J=new ce(J,this.loose)),te(this.major,J.major)||te(this.minor,J.minor)||te(this.patch,J.patch)},ce.prototype.comparePre=function(J){if(J instanceof ce||(J=new ce(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var he=0;do{var fe=this.prerelease[he],pe=J.prerelease[he];if(v("prerelease compare",he,fe,pe),fe===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(fe===void 0)return-1;if(fe!==pe)return te(fe,pe)}while(++he)},ce.prototype.inc=function(J,he){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,he,fe,pe){typeof fe=="string"&&(pe=fe,fe=void 0);try{return new ce(J,fe).inc(he,pe).version}catch{return null}},e.diff=function(J,he){if(N(J,he))return null;var fe=x(J),pe=x(he);if(fe.prerelease.length||pe.prerelease.length){for(var ve in fe)if((ve==="major"||ve==="minor"||ve==="patch")&&fe[ve]!==pe[ve])return"pre"+ve;return"prerelease"}for(var ve in fe)if((ve==="major"||ve==="minor"||ve==="patch")&&fe[ve]!==pe[ve])return ve},e.compareIdentifiers=te;var oe=/^[0-9]+$/;function te(J,he){var fe=oe.test(J),pe=oe.test(he);return fe&&pe&&(J=+J,he=+he),fe&&!pe?-1:pe&&!fe?1:J<he?-1:J>he?1:0}function j(J,he,fe){return new ce(J,fe).compare(new ce(he,fe))}function X(J,he,fe){return j(J,he,fe)>0}function U(J,he,fe){return j(J,he,fe)<0}function N(J,he,fe){return j(J,he,fe)===0}function Q(J,he,fe){return j(J,he,fe)!==0}function K(J,he,fe){return j(J,he,fe)>=0}function H(J,he,fe){return j(J,he,fe)<=0}function _(J,he,fe,pe){var ve;switch(he){case"===":typeof J=="object"&&(J=J.version),typeof fe=="object"&&(fe=fe.version),ve=J===fe;break;case"!==":typeof J=="object"&&(J=J.version),typeof fe=="object"&&(fe=fe.version),ve=J!==fe;break;case"":case"=":case"==":ve=N(J,fe,pe);break;case"!=":ve=Q(J,fe,pe);break;case">":ve=X(J,fe,pe);break;case">=":ve=K(J,fe,pe);break;case"<":ve=U(J,fe,pe);break;case"<=":ve=H(J,fe,pe);break;default:throw new TypeError("Invalid operator: "+he)}return ve}function ae(J,he){if(J instanceof ae){if(J.loose===he)return J;J=J.value}if(!(this instanceof ae))return new ae(J,he);v("comparator",J,he),this.loose=he,this.parse(J),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}e.rcompareIdentifiers=function(J,he){return te(he,J)},e.major=function(J,he){return new ce(J,he).major},e.minor=function(J,he){return new ce(J,he).minor},e.patch=function(J,he){return new ce(J,he).patch},e.compare=j,e.compareLoose=function(J,he){return j(J,he,!0)},e.rcompare=function(J,he,fe){return j(he,J,fe)},e.sort=function(J,he){return J.sort(function(fe,pe){return e.compare(fe,pe,he)})},e.rsort=function(J,he){return J.sort(function(fe,pe){return e.rcompare(fe,pe,he)})},e.gt=X,e.lt=U,e.eq=N,e.neq=Q,e.gte=K,e.lte=H,e.cmp=_,e.Comparator=ae;var $e={};function be(J,he){if(J instanceof be)return J.loose===he?J:new be(J.raw,he);if(J instanceof ae)return new be(J.value,he);if(!(this instanceof be))return new be(J,he);if(this.loose=he,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function ye(J){return!J||J.toLowerCase()==="x"||J==="*"}function Fe(J,he,fe,pe,ve,je,Oe,Re,We,Ke,Qe,qe,Xe){return((he=ye(fe)?"":ye(pe)?">="+fe+".0.0":ye(ve)?">="+fe+"."+pe+".0":">="+he)+" "+(Re=ye(We)?"":ye(Ke)?"<"+(+We+1)+".0.0":ye(Qe)?"<"+We+"."+(+Ke+1)+".0":qe?"<="+We+"."+Ke+"."+Qe+"-"+qe:"<="+Re)).trim()}function xe(J,he){for(var fe=0;fe<J.length;fe++)if(!J[fe].test(he))return!1;if(he.prerelease.length){for(fe=0;fe<J.length;fe++)if(v(J[fe].semver),J[fe].semver!==$e&&J[fe].semver.prerelease.length>0){var pe=J[fe].semver;if(pe.major===he.major&&pe.minor===he.minor&&pe.patch===he.patch)return!0}return!1}return!0}function Ae(J,he,fe){try{he=new be(he,fe)}catch{return!1}return he.test(J)}function me(J,he,fe,pe){var ve,je,Oe,Re,We;switch(J=new ce(J,pe),he=new be(he,pe),fe){case">":ve=X,je=H,Oe=U,Re=">",We=">=";break;case"<":ve=U,je=K,Oe=X,Re="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(J,he,pe))return!1;for(var Ke=0;Ke<he.set.length;++Ke){var Qe=he.set[Ke],qe=null,Xe=null;if(Qe.forEach(function(Ye){Ye.semver===$e&&(Ye=new ae(">=0.0.0")),qe=qe||Ye,Xe=Xe||Ye,ve(Ye.semver,qe.semver,pe)?qe=Ye:Oe(Ye.semver,Xe.semver,pe)&&(Xe=Ye)}),qe.operator===Re||qe.operator===We||(!Xe.operator||Xe.operator===Re)&&je(J,Xe.semver)||Xe.operator===We&&Oe(J,Xe.semver))return!1}return!0}ae.prototype.parse=function(J){var he=this.loose?I[W]:I[Z],fe=J.match(he);if(!fe)throw new TypeError("Invalid comparator: "+J);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new ce(fe[2],this.loose):this.semver=$e},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(J){return v("Comparator.test",J,this.loose),this.semver===$e||(typeof J=="string"&&(J=new ce(J,this.loose)),_(J,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(J,he){if(!(J instanceof ae))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new be(J.value,he),Ae(this.value,fe,he);if(J.operator==="")return fe=new be(this.value,he),Ae(J.semver,fe,he);var pe=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),je=this.semver.version===J.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Re=_(this.semver,"<",J.semver,he)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),We=_(this.semver,">",J.semver,he)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return pe||ve||je&&Oe||Re||We},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(J){var he=this.loose;J=J.trim(),v("range",J,he);var fe=he?I[F]:I[B];J=J.replace(fe,Fe),v("hyphen replace",J),J=J.replace(I[C],"$1$2$3"),v("comparator trim",J,I[C]),J=(J=(J=J.replace(I[M],"$1~")).replace(I[de],"$1^")).split(/\s+/).join(" ");var pe=he?I[W]:I[Z],ve=J.split(" ").map(function(je){return function(Oe,Re){return v("comp",Oe),Oe=function(We,Ke){return We.trim().split(/\s+/).map(function(Qe){return function(qe,Xe){v("caret",qe,Xe);var Ye=Xe?I[ee]:I[re];return qe.replace(Ye,function(Je,Ce,ne,ge,we){var Ee;return v("caret",qe,Je,Ce,ne,ge,we),ye(Ce)?Ee="":ye(ne)?Ee=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":ye(ge)?Ee=Ce==="0"?">="+Ce+"."+ne+".0 <"+Ce+"."+(+ne+1)+".0":">="+Ce+"."+ne+".0 <"+(+Ce+1)+".0.0":we?(v("replaceCaret pr",we),we.charAt(0)!=="-"&&(we="-"+we),Ee=Ce==="0"?ne==="0"?">="+Ce+"."+ne+"."+ge+we+" <"+Ce+"."+ne+"."+(+ge+1):">="+Ce+"."+ne+"."+ge+we+" <"+Ce+"."+(+ne+1)+".0":">="+Ce+"."+ne+"."+ge+we+" <"+(+Ce+1)+".0.0"):(v("no pr"),Ee=Ce==="0"?ne==="0"?">="+Ce+"."+ne+"."+ge+" <"+Ce+"."+ne+"."+(+ge+1):">="+Ce+"."+ne+"."+ge+" <"+Ce+"."+(+ne+1)+".0":">="+Ce+"."+ne+"."+ge+" <"+(+Ce+1)+".0.0"),v("caret return",Ee),Ee})}(Qe,Ke)}).join(" ")}(Oe,Re),v("caret",Oe),Oe=function(We,Ke){return We.trim().split(/\s+/).map(function(Qe){return function(qe,Xe){var Ye=Xe?I[q]:I[V];return qe.replace(Ye,function(Je,Ce,ne,ge,we){var Ee;return v("tilde",qe,Je,Ce,ne,ge,we),ye(Ce)?Ee="":ye(ne)?Ee=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":ye(ge)?Ee=">="+Ce+"."+ne+".0 <"+Ce+"."+(+ne+1)+".0":we?(v("replaceTilde pr",we),we.charAt(0)!=="-"&&(we="-"+we),Ee=">="+Ce+"."+ne+"."+ge+we+" <"+Ce+"."+(+ne+1)+".0"):Ee=">="+Ce+"."+ne+"."+ge+" <"+Ce+"."+(+ne+1)+".0",v("tilde return",Ee),Ee})}(Qe,Ke)}).join(" ")}(Oe,Re),v("tildes",Oe),Oe=function(We,Ke){return v("replaceXRanges",We,Ke),We.split(/\s+/).map(function(Qe){return function(qe,Xe){qe=qe.trim();var Ye=Xe?I[T]:I[R];return qe.replace(Ye,function(Je,Ce,ne,ge,we,Ee){v("xRange",qe,Je,Ce,ne,ge,we,Ee);var Me=ye(ne),Be=Me||ye(ge),_e=Be||ye(we);return Ce==="="&&_e&&(Ce=""),Me?Je=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&_e?(Be&&(ge=0),_e&&(we=0),Ce===">"?(Ce=">=",Be?(ne=+ne+1,ge=0,we=0):_e&&(ge=+ge+1,we=0)):Ce==="<="&&(Ce="<",Be?ne=+ne+1:ge=+ge+1),Je=Ce+ne+"."+ge+"."+we):Be?Je=">="+ne+".0.0 <"+(+ne+1)+".0.0":_e&&(Je=">="+ne+"."+ge+".0 <"+ne+"."+(+ge+1)+".0"),v("xRange return",Je),Je})}(Qe,Ke)}).join(" ")}(Oe,Re),v("xrange",Oe),Oe=function(We,Ke){return v("replaceStars",We,Ke),We.trim().replace(I[z],"")}(Oe,Re),v("stars",Oe),Oe}(je,he)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(je){return!!je.match(pe)})),ve=ve.map(function(je){return new ae(je,he)})},be.prototype.intersects=function(J,he){if(!(J instanceof be))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(pe){return J.set.some(function(ve){return ve.every(function(je){return pe.intersects(je,he)})})})})},e.toComparators=function(J,he){return new be(J,he).set.map(function(fe){return fe.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},be.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new ce(J,this.loose));for(var he=0;he<this.set.length;he++)if(xe(this.set[he],J))return!0;return!1},e.satisfies=Ae,e.maxSatisfying=function(J,he,fe){var pe=null,ve=null;try{var je=new be(he,fe)}catch{return null}return J.forEach(function(Oe){je.test(Oe)&&(pe&&ve.compare(Oe)!==-1||(ve=new ce(pe=Oe,fe)))}),pe},e.minSatisfying=function(J,he,fe){var pe=null,ve=null;try{var je=new be(he,fe)}catch{return null}return J.forEach(function(Oe){je.test(Oe)&&(pe&&ve.compare(Oe)!==1||(ve=new ce(pe=Oe,fe)))}),pe},e.validRange=function(J,he){try{return new be(J,he).range||"*"}catch{return null}},e.ltr=function(J,he,fe){return me(J,he,"<",fe)},e.gtr=function(J,he,fe){return me(J,he,">",fe)},e.outside=me,e.prerelease=function(J,he){var fe=x(J,he);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(J,he,fe){return J=new be(J,fe),he=new be(he,fe),J.intersects(he)},e.coerce=function(J){if(J instanceof ce)return J;if(typeof J!="string")return null;var he=J.match(I[A]);return he==null?null:x((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,i(1))},function(G,e){var i,r,v=G.exports={};function D(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(y){if(i===setTimeout)return setTimeout(y,0);if((i===D||!i)&&setTimeout)return i=setTimeout,setTimeout(y,0);try{return i(y,0)}catch{try{return i.call(null,y,0)}catch{return i.call(this,y,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:D}catch{i=D}try{r=typeof clearTimeout=="function"?clearTimeout:O}catch{r=O}})();var b,l=[],m=!1,u=-1;function $(){m&&b&&(m=!1,b.length?l=b.concat(l):u=-1,l.length&&p())}function p(){if(!m){var y=I($);m=!0;for(var E=l.length;E;){for(b=l,l=[];++u<E;)b&&b[u].run();u=-1,E=l.length}b=null,m=!1,function(g){if(r===clearTimeout)return clearTimeout(g);if((r===O||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(g);try{r(g)}catch{try{return r.call(null,g)}catch{return r.call(this,g)}}}(y)}}function d(y,E){this.fun=y,this.array=E}function f(){}v.nextTick=function(y){var E=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)E[g-1]=arguments[g];l.push(new d(y,E)),l.length!==1||m||I(p)},d.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=f,v.addListener=f,v.once=f,v.off=f,v.removeListener=f,v.removeAllListeners=f,v.emit=f,v.prependListener=f,v.prependOnceListener=f,v.listeners=function(y){return[]},v.binding=function(y){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(y){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(le[148],ue([0,1]),function(G,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0;class r{constructor(I,b,l){this.level=I,this.key=b,this.value=l,this.forward=[]}}const v=void 0;class D{constructor(I,b=2**16){this.comparator=I,this[i]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(b)|0),this.e=new r(this.c,v,v)}get size(){return this.f}clear(){this.e=new r(this.c,v,v),this.f=0}has(I){return!!D.g(this,I,this.comparator)}get(I){return D.g(this,I,this.comparator)?.value}set(I,b){return D.h(this,I,b,this.comparator)&&(this.f+=1),this}delete(I){const b=D.k(this,I,this.comparator);return b&&(this.f-=1),b}forEach(I,b){let l=this.e.forward[0];for(;l;)I.call(b,l.value,l.key,this),l=l.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",b=this.e.forward[0];for(;b;)I+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return I}static g(I,b,l){let m=I.e;for(let u=I.d-1;u>=0;u--)for(;m.forward[u]&&l(m.forward[u].key,b)<0;)m=m.forward[u];if(m=m.forward[0],m&&l(m.key,b)===0)return m}static h(I,b,l,m){const u=[];let $=I.e;for(let p=I.d-1;p>=0;p--){for(;$.forward[p]&&m($.forward[p].key,b)<0;)$=$.forward[p];u[p]=$}if($=$.forward[0],$&&m($.key,b)===0)return $.value=l,!1;{const p=D.j(I);if(p>I.d){for(let d=I.d;d<p;d++)u[d]=I.e;I.d=p}$=new r(p,b,l);for(let d=0;d<p;d++)$.forward[d]=u[d].forward[d],u[d].forward[d]=$;return!0}}static j(I,b=.5){let l=1;for(;Math.random()<b&&l<I.c;)l+=1;return l}static k(I,b,l){const m=[];let u=I.e;for(let $=I.d-1;$>=0;$--){for(;u.forward[$]&&l(u.forward[$].key,b)<0;)u=u.forward[$];m[$]=u}if(u=u.forward[0],!u||l(u.key,b)!==0)return!1;for(let $=0;$<I.d&&m[$].forward[$]===u;$++)m[$].forward[$]=u.forward[$];for(;I.d>0&&I.e.forward[I.d-1]===v;)I.d-=1;return!0}}e.$2s=D}),define(le[60],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(D){return new r(D)}constructor(D){this.c=i&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ke=r}),define(le[4],ue([0,1,15,91,2,111,60]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$me=e.Event=void 0,e.$ne=p;const I=!1,b=!1,l=!1;var m;(function(q){q.None=()=>v.$Zc.None;function Y(Ae){if(l){const{onDidAddListener:me}=Ae,J=f.create();let he=0;Ae.onDidAddListener=()=>{++he===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),J.print()),me?.()}}}function de(Ae,me){return ce(Ae,()=>{},0,void 0,!0,void 0,me)}q.defer=de;function re(Ae){return(me,J=null,he)=>{let fe=!1,pe;return pe=Ae(ve=>{if(!fe)return pe?pe.dispose():fe=!0,me.call(J,ve)},null,he),fe&&pe.dispose(),pe}}q.once=re;function ee(Ae,me){return q.once(q.filter(Ae,me))}q.onceIf=ee;function W(Ae,me,J){return ie((he,fe=null,pe)=>Ae(ve=>he.call(fe,me(ve)),null,pe),J)}q.map=W;function Z(Ae,me,J){return ie((he,fe=null,pe)=>Ae(ve=>{me(ve),he.call(fe,ve)},null,pe),J)}q.forEach=Z;function C(Ae,me,J){return ie((he,fe=null,pe)=>Ae(ve=>me(ve)&&he.call(fe,ve),null,pe),J)}q.filter=C;function B(Ae){return Ae}q.signal=B;function F(...Ae){return(me,J=null,he)=>{const fe=(0,v.$Wc)(...Ae.map(pe=>pe(ve=>me.call(J,ve))));return x(fe,he)}}q.any=F;function z(Ae,me,J,he){let fe=J;return W(Ae,pe=>(fe=me(fe,pe),fe),he)}q.reduce=z;function ie(Ae,me){let J;const he={onWillAddFirstListener(){J=Ae(fe.fire,fe)},onDidRemoveLastListener(){J?.dispose()}};me||Y(he);const fe=new t(he);return me?.add(fe),fe.event}function x(Ae,me){return me instanceof Array?me.push(Ae):me&&me.add(Ae),Ae}function ce(Ae,me,J=100,he=!1,fe=!1,pe,ve){let je,Oe,Re,We=0,Ke;const Qe={leakWarningThreshold:pe,onWillAddFirstListener(){je=Ae(Xe=>{We++,Oe=me(Oe,Xe),he&&!Re&&(qe.fire(Oe),Oe=void 0),Ke=()=>{const Ye=Oe;Oe=void 0,Re=void 0,(!he||We>1)&&qe.fire(Ye),We=0},typeof J=="number"?(clearTimeout(Re),Re=setTimeout(Ke,J)):Re===void 0&&(Re=0,queueMicrotask(Ke))})},onWillRemoveListener(){fe&&We>0&&Ke?.()},onDidRemoveLastListener(){Ke=void 0,je.dispose()}};ve||Y(Qe);const qe=new t(Qe);return ve?.add(qe),qe.event}q.debounce=ce;function oe(Ae,me=0,J){return q.debounce(Ae,(he,fe)=>he?(he.push(fe),he):[fe],me,void 0,!0,void 0,J)}q.accumulate=oe;function te(Ae,me=(he,fe)=>he===fe,J){let he=!0,fe;return C(Ae,pe=>{const ve=he||!me(pe,fe);return he=!1,fe=pe,ve},J)}q.latch=te;function j(Ae,me,J){return[q.filter(Ae,me,J),q.filter(Ae,he=>!me(he),J)]}q.split=j;function X(Ae,me=!1,J=[],he){let fe=J.slice(),pe=Ae(Oe=>{fe?fe.push(Oe):je.fire(Oe)});he&&he.add(pe);const ve=()=>{fe?.forEach(Oe=>je.fire(Oe)),fe=null},je=new t({onWillAddFirstListener(){pe||(pe=Ae(Oe=>je.fire(Oe)),he&&he.add(pe))},onDidAddFirstListener(){fe&&(me?setTimeout(ve):ve())},onDidRemoveLastListener(){pe&&pe.dispose(),pe=null}});return he&&he.add(je),je.event}q.buffer=X;function U(Ae,me){return(he,fe,pe)=>{const ve=me(new Q);return Ae(function(je){const Oe=ve.evaluate(je);Oe!==N&&he.call(fe,Oe)},void 0,pe)}}q.chain=U;const N=Symbol("HaltChainable");class Q{constructor(){this.f=[]}map(me){return this.f.push(me),this}forEach(me){return this.f.push(J=>(me(J),J)),this}filter(me){return this.f.push(J=>me(J)?J:N),this}reduce(me,J){let he=J;return this.f.push(fe=>(he=me(he,fe),he)),this}latch(me=(J,he)=>J===he){let J=!0,he;return this.f.push(fe=>{const pe=J||!me(fe,he);return J=!1,he=fe,pe?fe:N}),this}evaluate(me){for(const J of this.f)if(me=J(me),me===N)break;return me}}function K(Ae,me,J=he=>he){const he=(...je)=>ve.fire(J(...je)),fe=()=>Ae.on(me,he),pe=()=>Ae.removeListener(me,he),ve=new t({onWillAddFirstListener:fe,onDidRemoveLastListener:pe});return ve.event}q.fromNodeEventEmitter=K;function H(Ae,me,J=he=>he){const he=(...je)=>ve.fire(J(...je)),fe=()=>Ae.addEventListener(me,he),pe=()=>Ae.removeEventListener(me,he),ve=new t({onWillAddFirstListener:fe,onDidRemoveLastListener:pe});return ve.event}q.fromDOMEventEmitter=H;function _(Ae){return new Promise(me=>re(Ae)(me))}q.toPromise=_;function ae(Ae){const me=new t;return Ae.then(J=>{me.fire(J)},()=>{me.fire(void 0)}).finally(()=>{me.dispose()}),me.event}q.fromPromise=ae;function $e(Ae,me){return Ae(J=>me.fire(J))}q.forward=$e;function be(Ae,me,J){return me(J),Ae(he=>me(he))}q.runAndSubscribe=be;class ye{constructor(me,J){this._observable=me,this.f=0,this.g=!1;const he={onWillAddFirstListener:()=>{me.addObserver(this),this._observable.reportChanges()},onDidRemoveLastListener:()=>{me.removeObserver(this)}};J||Y(he),this.emitter=new t(he),J&&J.add(this.emitter)}beginUpdate(me){this.f++}handlePossibleChange(me){}handleChange(me,J){this.g=!0}endUpdate(me){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Fe(Ae,me){return new ye(Ae,me).emitter.event}q.fromObservable=Fe;function xe(Ae){return(me,J,he)=>{let fe=0,pe=!1;const ve={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(Ae.reportChanges(),pe&&(pe=!1,me.call(J)))},handlePossibleChange(){},handleChange(){pe=!0}};Ae.addObserver(ve),Ae.reportChanges();const je={dispose(){Ae.removeObserver(ve)}};return he instanceof v.$Yc?he.add(je):Array.isArray(he)&&he.push(je),je}}q.fromObservableLight=xe})(m||(e.Event=m={}));class u{static{this.all=new Set}static{this.f=0}constructor(Y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${Y}_${u.f++}`,u.all.add(this)}start(Y){this.g=new O.$ke,this.listenerCount=Y}stop(){if(this.g){const Y=this.g.elapsed();this.durations.push(Y),this.elapsedOverall+=Y,this.invocationCount+=1,this.g=void 0}}}e.$me=u;let $=-1;function p(q){const Y=$;return $=q,{dispose(){$=Y}}}class d{static{this.f=1}constructor(Y,de,re=(d.f++).toString(16).padStart(3,"0")){this.j=Y,this.threshold=de,this.name=re,this.h=0}dispose(){this.g?.clear()}check(Y,de){const re=this.threshold;if(re<=0||de<re)return;this.g||(this.g=new Map);const ee=this.g.get(Y.value)||0;if(this.g.set(Y.value,ee+1),this.h-=1,this.h<=0){this.h=re*.5;const[W,Z]=this.getMostFrequentStack(),C=`[${this.name}] potential listener LEAK detected, having ${de} listeners already. MOST frequent listener (${Z}):`;console.warn(C),console.warn(W);const B=new y(C,W);this.j(B)}return()=>{const W=this.g.get(Y.value)||0;this.g.set(Y.value,W-1)}}getMostFrequentStack(){if(!this.g)return;let Y,de=0;for(const[re,ee]of this.g)(!Y||de<ee)&&(Y=[re,ee],de=ee);return Y}}class f{static create(){const Y=new Error;return new f(Y.stack??"")}constructor(Y){this.value=Y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y extends Error{constructor(Y,de){super(Y),this.name="ListenerLeakError",this.stack=de}}e.$oe=y;class E extends Error{constructor(Y,de){super(Y),this.name="ListenerRefusalError",this.stack=de}}e.$pe=E;let g=0;class S{constructor(Y){this.value=Y,this.id=g++}}const k=2,s=(q,Y)=>{if(q instanceof S)Y(q);else for(let de=0;de<q.length;de++){const re=q[de];re&&Y(re)}};let a;if(I){const q=[];setInterval(()=>{q.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(q.join(`
`)),q.length=0)},3e3),a=new FinalizationRegistry(Y=>{typeof Y=="string"&&q.push(Y)})}class t{constructor(Y){this.z=0,this.f=Y,this.g=$>0||this.f?.leakWarningThreshold?new d(Y?.onListenerError??i.$4,this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new u(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(b){const Y=this.u;queueMicrotask(()=>{s(Y,de=>de.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(Y,de,re)=>{if(this.g&&this.z>this.g.threshold**2){const B=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(B);const F=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],z=new E(`${B}. HINT: Stack shows most frequent listener (${F[1]}-times)`,F[0]);return(this.f?.onListenerError||i.$4)(z),v.$Zc.None}if(this.m)return v.$Zc.None;de&&(Y=Y.bind(de));const ee=new S(Y);let W,Z;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(ee.stack=f.create(),W=this.g.check(ee.stack,this.z+1)),b&&(ee.stack=Z??f.create()),this.u?this.u instanceof S?(this.w??=new n,this.u=[this.u,ee]):this.u.push(ee):(this.f?.onWillAddFirstListener?.(this),this.u=ee,this.f?.onDidAddFirstListener?.(this)),this.z++;const C=(0,v.$Xc)(()=>{a?.unregister(C),W?.(),this.A(ee)});if(re instanceof v.$Yc?re.add(C):Array.isArray(re)&&re.push(C),a){const B=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),F=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(B);a.register(C,F?.[2]??B,C)}return C},this.q}A(Y){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const de=this.u,re=de.indexOf(Y);if(re===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,de[re]=void 0;const ee=this.w.current===this;if(this.z*k<=de.length){let W=0;for(let Z=0;Z<de.length;Z++)de[Z]?de[W++]=de[Z]:ee&&(this.w.end--,W<this.w.i&&this.w.i--);de.length=W}}B(Y,de){if(!Y)return;const re=this.f?.onListenerError||i.$4;if(!re){Y.value(de);return}try{Y.value(de)}catch(ee){re(ee)}}C(Y){const de=Y.current.u;for(;Y.i<Y.end;)this.B(de[Y.i++],Y.value);Y.reset()}fire(Y){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof S)this.B(this.u,Y);else{const de=this.w;de.enqueue(this,Y,this.u.length),this.C(de)}this.j?.stop()}hasListeners(){return this.z>0}}e.$qe=t;const o=()=>new n;e.$re=o;class n{constructor(){this.i=-1,this.end=0}enqueue(Y,de,re){this.i=0,this.end=re,this.current=Y,this.value=de}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends t{async fireAsync(Y,de,re){if(this.u)for(this.h||(this.h=new D.$0c),s(this.u,ee=>this.h.push([ee.value,Y]));this.h.size>0&&!de.isCancellationRequested;){const[ee,W]=this.h.shift(),Z=[],C={...W,token:de,waitUntil:B=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");re&&(B=re(B,ee)),Z.push(B)}};try{ee(C)}catch(B){(0,i.$4)(B);continue}Object.freeze(Z),await Promise.allSettled(Z).then(B=>{for(const F of B)F.status==="rejected"&&(0,i.$4)(F.reason)})}}}e.$se=c;class h extends t{get isPaused(){return this.h!==0}constructor(Y){super(Y),this.h=0,this.s=new D.$0c,this.t=Y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const Y=Array.from(this.s);this.s.clear(),super.fire(this.t(Y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(Y){this.z&&(this.h!==0?this.s.push(Y):super.fire(Y))}}e.$te=h;class P extends h{constructor(Y){super(Y),this.k=Y.delay??100}fire(Y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(Y)}}e.$ue=P;class w extends t{constructor(Y){super(Y),this.h=[],this.k=Y?.merge}fire(Y){this.hasListeners()&&(this.h.push(Y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(de=>super.fire(de)),this.h=[]}))}}e.$ve=w;class R{constructor(){this.g=!1,this.h=[],this.f=new t({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(Y){const de={event:Y,listener:null};this.h.push(de),this.g&&this.m(de);const re=()=>{this.g&&this.o(de);const ee=this.h.indexOf(de);this.h.splice(ee,1)};return(0,v.$Xc)((0,r.$hb)(re))}j(){this.g=!0,this.h.forEach(Y=>this.m(Y))}k(){this.g=!1,this.h.forEach(Y=>this.o(Y))}m(Y){Y.listener=Y.event(de=>this.f.fire(de))}o(Y){Y.listener?.dispose(),Y.listener=null}dispose(){this.f.dispose();for(const Y of this.h)Y.listener?.dispose();this.h=[]}}e.$we=R;class T{constructor(Y,de,re,ee){this.f=new v.$Yc;const W=this.f.add(new R),Z=this.f.add(new v.$9c);function C(B){Z.set(B,W.add(ee(B)))}for(const B of Y)C(B);this.f.add(de(B=>{C(B)})),this.f.add(re(B=>{Z.deleteAndDispose(B)})),this.event=W.event}dispose(){this.f.dispose()}}e.$xe=T;class A{constructor(){this.f=[]}wrapEvent(Y,de,re){return(ee,W,Z)=>Y(C=>{const B=this.f[this.f.length-1];if(!de){B?B.buffers.push(()=>ee.call(W,C)):ee.call(W,C);return}const F=B;if(!F){ee.call(W,de(re,C));return}F.items??=[],F.items.push(C),F.buffers.length===0&&B.buffers.push(()=>{F.reducedResult??=re?F.items.reduce(de,re):F.items.reduce(de),ee.call(W,F.reducedResult)})},void 0,Z)}bufferEvents(Y){const de={buffers:new Array};this.f.push(de);const re=Y();return this.f.pop(),de.buffers.forEach(ee=>ee()),re}}e.$ye=A;class L{constructor(){this.f=!1,this.g=m.None,this.h=v.$Zc.None,this.j=new t({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(Y){this.g=Y,this.f&&(this.h.dispose(),this.h=Y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ze=L;class M{static const(Y){return new V(Y)}constructor(Y){this.g=Y,this.f=new t,this.onDidChange=this.f.event}get value(){return this.g}set value(Y){Y!==this.g&&(this.g=Y,this.f.fire(void 0))}}e.$Ae=M;class V{constructor(Y){this.value=Y,this.onDidChange=m.None}}}),define(le[22],ue([0,1,4]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.CancellationToken=void 0,e.$Ce=I;const r=Object.freeze(function(b,l){const m=setTimeout(b.bind(l),0);return{dispose(){clearTimeout(m)}}});var v;(function(b){function l(m){return m===b.None||m===b.Cancelled||m instanceof D?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}b.isCancellationToken=l,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(v||(e.CancellationToken=v={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new i.$qe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=v.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=v.None}}e.$Be=O;function I(b){const l=new O;return b.add({dispose(){l.cancel()}}),l.token}}),define(le[149],ue([0,1,22]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ef=e.$df=e.$bf=void 0,e.$cf=v;class r{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new i.$Be,l=this.b(b.token);return this.a={promise:l,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$bf=r;function v(I){return I}class D{constructor(b,l){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=v):(this.c=l,this.d=b.getCacheKey)}get(b){const l=this.d(b);return this.b!==l&&(this.b=l,this.a=this.c(b)),this.a}}e.$df=D;class O{get cachedValues(){return this.a}constructor(b,l){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=v):(this.c=l,this.d=b.getCacheKey)}get(b){const l=this.d(b);if(this.b.has(l))return this.b.get(l);const m=this.c(b);return this.a.set(b,m),this.b.set(l,m),m}}e.$ef=O}),define(le[68],ue([0,1,15,2]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=v,e.$Ee=D,e.$Fe=O,e.$Ge=I,e.$He=l,e.$Ie=m,e.$Je=u,e.$Ke=$,e.$Le=p,e.$Me=d,e.$Ne=f,e.$Oe=y,e.$Pe=E,e.$Qe=g,e.$Re=S;function v(k){const s=k;return s?typeof s.read=="function":!1}function D(k){const s=k;return s?[s.on,s.pause,s.resume,s.destroy].every(a=>typeof a=="function"):!1}function O(k){const s=k;return s?D(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function I(k,s){return new b(k,s)}class b{constructor(s,a){this.e=s,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(a=>a(s))}h(s){this.c.error.length===0?(0,i.$4)(s):this.c.error.slice(0).forEach(a=>a(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,a){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(s,a){if(this.a.destroyed)return;let t;switch(s){case"data":t=this.c.data;break;case"end":t=this.c.end;break;case"error":t=this.c.error;break}if(t){const o=t.indexOf(a);o>=0&&t.splice(o,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(t=>t())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(k,s){const a=[];let t;for(;(t=k.read())!==null;)a.push(t);return s(a)}function m(k,s,a){const t=[];let o;for(;(o=k.read())!==null&&t.length<a;)t.push(o);return o===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof o<"u"){const n=o;return o=void 0,n}return k.read()}}}function u(k,s){return new Promise((a,t)=>{const o=[];$(k,{onData:n=>{s&&o.push(n)},onError:n=>{s?t(n):a(void 0)},onEnd:()=>{a(s?s(o):void 0)}})})}function $(k,s,a){k.on("error",t=>{a?.isCancellationRequested||s.onError(t)}),k.on("end",()=>{a?.isCancellationRequested||s.onEnd()}),k.on("data",t=>{a?.isCancellationRequested||s.onData(t)})}function p(k,s){return new Promise((a,t)=>{const o=new r.$Yc,n=[],c=w=>{if(n.push(w),n.length>s)return o.dispose(),k.pause(),a({stream:k,buffer:n,ended:!1})},h=w=>(o.dispose(),t(w)),P=()=>(o.dispose(),a({stream:k,buffer:n,ended:!0}));o.add((0,r.$Xc)(()=>k.removeListener("error",h))),k.on("error",h),o.add((0,r.$Xc)(()=>k.removeListener("end",P))),k.on("end",P),o.add((0,r.$Xc)(()=>k.removeListener("data",c))),k.on("data",c)})}function d(k,s){const a=I(s);return a.end(k),a}function f(){const k=I(()=>{throw new Error("not supported")});return k.end(),k}function y(k){let s=!1;return{read:()=>s?null:(s=!0,k)}}function E(k,s,a){const t=I(a);return $(k,{onData:o=>t.write(s.data(o)),onError:o=>t.error(s.error?s.error(o):o),onEnd:()=>t.end()}),t}function g(k,s,a){let t=!1;return{read:()=>{const o=s.read();return t?o:(t=!0,o!==null?a([k,o]):k)}}}function S(k,s,a){let t=!1;const o=I(a);return $(s,{onData:n=>t?o.write(n):(t=!0,o.write(a([k,n]))),onError:n=>o.error(n),onEnd:()=>{t||(t=!0,o.write(k)),o.end()}}),o}});var At=this&&this.__createBinding||(Object.create?function(G,e,i,r){r===void 0&&(r=i);var v=Object.getOwnPropertyDescriptor(e,i);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[i]}}),Object.defineProperty(G,r,v)}:function(G,e,i,r){r===void 0&&(r=i),G[r]=e[i]}),Ot=this&&this.__setModuleDefault||(Object.create?function(G,e){Object.defineProperty(G,"default",{enumerable:!0,value:e})}:function(G,e){G.default=e}),Ie=this&&this.__importStar||function(G){if(G&&G.__esModule)return G;var e={};if(G!=null)for(var i in G)i!=="default"&&Object.prototype.hasOwnProperty.call(G,i)&&At(e,G,i);return Ot(e,G),e};define(le[17],ue([0,1,67,68]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=l,e.$Ue=m,e.$Ve=u,e.$We=$,e.$Xe=p,e.$Ye=d,e.$Ze=f,e.$1e=y,e.$2e=E,e.$3e=g,e.$4e=S,e.$5e=k,e.$6e=s,e.$7e=a,e.$8e=t,e.$9e=o,e.$0e=n,e.$$e=c,e.$_e=h,e.$af=R,r=Ie(r);const v=typeof Buffer<"u",D=new i.$Y(()=>new Uint8Array(256));let O,I;class b{static alloc(A){return v?new b(Buffer.allocUnsafe(A)):new b(new Uint8Array(A))}static wrap(A){return v&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new b(A)}static fromString(A,L){return!(L?.dontUseNodeBuffer||!1)&&v?new b(Buffer.from(A)):(O||(O=new TextEncoder),new b(O.encode(A)))}static fromByteArray(A){const L=b.alloc(A.length);for(let M=0,V=A.length;M<V;M++)L.buffer[M]=A[M];return L}static concat(A,L){if(typeof L>"u"){L=0;for(let q=0,Y=A.length;q<Y;q++)L+=A[q].byteLength}const M=b.alloc(L);let V=0;for(let q=0,Y=A.length;q<Y;q++){const de=A[q];M.set(de,V),V+=de.byteLength}return M}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=b.alloc(this.byteLength);return A.set(this),A}toString(){return v?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(A,L){return new b(this.buffer.subarray(A,L))}set(A,L){if(A instanceof b)this.buffer.set(A.buffer,L);else if(A instanceof Uint8Array)this.buffer.set(A,L);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),L);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return $(this.buffer,A)}writeUInt32BE(A,L){p(this.buffer,A,L)}readUInt32LE(A){return d(this.buffer,A)}writeUInt32LE(A,L){f(this.buffer,A,L)}readUInt8(A){return y(this.buffer,A)}writeUInt8(A,L){E(this.buffer,A,L)}indexOf(A,L=0){return l(this.buffer,A instanceof b?A.buffer:A,L)}}e.$Se=b;function l(T,A,L=0){const M=A.byteLength,V=T.byteLength;if(M===0)return 0;if(M===1)return T.indexOf(A[0]);if(M>V-L)return-1;const q=D.value;q.fill(A.length);for(let ee=0;ee<A.length;ee++)q[A[ee]]=A.length-ee-1;let Y=L+A.length-1,de=Y,re=-1;for(;Y<V;)if(T[Y]===A[de]){if(de===0){re=Y;break}Y--,de--}else Y+=Math.max(A.length-de,q[T[Y]]),de=A.length-1;return re}function m(T,A){return T[A+0]<<0>>>0|T[A+1]<<8>>>0}function u(T,A,L){T[L+0]=A&255,A=A>>>8,T[L+1]=A&255}function $(T,A){return T[A]*2**24+T[A+1]*2**16+T[A+2]*2**8+T[A+3]}function p(T,A,L){T[L+3]=A,A=A>>>8,T[L+2]=A,A=A>>>8,T[L+1]=A,A=A>>>8,T[L]=A}function d(T,A){return T[A+0]<<0>>>0|T[A+1]<<8>>>0|T[A+2]<<16>>>0|T[A+3]<<24>>>0}function f(T,A,L){T[L+0]=A&255,A=A>>>8,T[L+1]=A&255,A=A>>>8,T[L+2]=A&255,A=A>>>8,T[L+3]=A&255}function y(T,A){return T[A]}function E(T,A,L){T[L]=A}function g(T){return r.$He(T,A=>b.concat(A))}function S(T){return r.$Oe(T)}function k(T){return r.$Je(T,A=>b.concat(A))}async function s(T){return T.ended?b.concat(T.buffer):b.concat([...T.buffer,await k(T.stream)])}function a(T){return r.$Me(T,A=>b.concat(A))}function t(T){return r.$Pe(T,{data:A=>typeof A=="string"?b.fromString(A):b.wrap(A)},A=>b.concat(A))}function o(T){return r.$Ge(A=>b.concat(A),T)}function n(T,A){return r.$Qe(T,A,L=>b.concat(L))}function c(T,A){return r.$Re(T,A,L=>b.concat(L))}function h(T){let A=0,L=0,M=0;const V=new Uint8Array(Math.floor(T.length/4*3)),q=de=>{switch(L){case 3:V[M++]=A|de,L=0;break;case 2:V[M++]=A|de>>>2,A=de<<6,L=3;break;case 1:V[M++]=A|de>>>4,A=de<<4,L=2;break;default:A=de<<2,L=1}};for(let de=0;de<T.length;de++){const re=T.charCodeAt(de);if(re>=65&&re<=90)q(re-65);else if(re>=97&&re<=122)q(re-97+26);else if(re>=48&&re<=57)q(re-48+52);else if(re===43||re===45)q(62);else if(re===47||re===95)q(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${T[de]}`)}}const Y=M;for(;L>0;)q(0);return b.wrap(V).slice(0,Y)}const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:T},A=!0,L=!1){const M=L?w:P;let V="";const q=T.byteLength%3;let Y=0;for(;Y<T.byteLength-q;Y+=3){const de=T[Y+0],re=T[Y+1],ee=T[Y+2];V+=M[de>>>2],V+=M[(de<<4|re>>>4)&63],V+=M[(re<<2|ee>>>6)&63],V+=M[ee&63]}if(q===1){const de=T[Y+0];V+=M[de>>>2],V+=M[de<<4&63],A&&(V+="==")}else if(q===2){const de=T[Y+0],re=T[Y+1];V+=M[de>>>2],V+=M[(de<<4|re>>>4)&63],V+=M[re<<2&63],A&&(V+="=")}return V}}),define(le[150],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=void 0,e.$le=Symbol("MicrotaskDelay")}),define(le[12],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=i,e.$kg=r,e.$lg=v,e.$mg=D,e.$ng=O,e.$og=I,e.$pg=b,e.$qg=l,e.$rg=m,e.$sg=u,e.$tg=$,e.$ug=p,e.$vg=d,e.$wg=y,e.$xg=E,e.$yg=g,e.$zg=S,e.$Ag=k,e.$Bg=s;function i(a){return typeof a=="string"}function r(a){return Array.isArray(a)&&a.every(t=>i(t))}function v(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function D(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function O(a){return typeof a=="number"&&!isNaN(a)}function I(a){return!!a&&typeof a[Symbol.iterator]=="function"}function b(a){return a===!0||a===!1}function l(a){return typeof a>"u"}function m(a){return!u(a)}function u(a){return l(a)||a===null}function $(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function p(a){if(u(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function d(...a){const t=[];for(let o=0;o<a.length;o++){const n=a[o];if(u(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(n)}return t}const f=Object.prototype.hasOwnProperty;function y(a){if(!v(a))return!1;for(const t in a)if(f.call(a,t))return!1;return!0}function E(a){return typeof a=="function"}function g(...a){return a.length>0&&a.every(E)}function S(a,t){const o=Math.min(a.length,t.length);for(let n=0;n<o;n++)k(a[n],t[n])}function k(a,t){if(i(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(E(t)){try{if(a instanceof t)return}catch{}if(!u(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function s(a){return a}}),define(le[112],ue([0,1,12]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=v,e.$6j=D;const r=Object.create(null);function v(O,I){if((0,i.$jg)(I)){const b=r[I];if(b===void 0)throw new Error(`${O} references an unknown codicon: ${I}`);I=b}return r[O]=I,{id:O}}function D(){return r}}),define(le[151],ue([0,1,112]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=void 0,e.$7j={add:(0,i.$5j)("add",6e4),plus:(0,i.$5j)("plus",6e4),gistNew:(0,i.$5j)("gist-new",6e4),repoCreate:(0,i.$5j)("repo-create",6e4),lightbulb:(0,i.$5j)("lightbulb",60001),lightBulb:(0,i.$5j)("light-bulb",60001),repo:(0,i.$5j)("repo",60002),repoDelete:(0,i.$5j)("repo-delete",60002),gistFork:(0,i.$5j)("gist-fork",60003),repoForked:(0,i.$5j)("repo-forked",60003),gitPullRequest:(0,i.$5j)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$5j)("git-pull-request-abandoned",60004),recordKeys:(0,i.$5j)("record-keys",60005),keyboard:(0,i.$5j)("keyboard",60005),tag:(0,i.$5j)("tag",60006),gitPullRequestLabel:(0,i.$5j)("git-pull-request-label",60006),tagAdd:(0,i.$5j)("tag-add",60006),tagRemove:(0,i.$5j)("tag-remove",60006),person:(0,i.$5j)("person",60007),personFollow:(0,i.$5j)("person-follow",60007),personOutline:(0,i.$5j)("person-outline",60007),personFilled:(0,i.$5j)("person-filled",60007),gitBranch:(0,i.$5j)("git-branch",60008),gitBranchCreate:(0,i.$5j)("git-branch-create",60008),gitBranchDelete:(0,i.$5j)("git-branch-delete",60008),sourceControl:(0,i.$5j)("source-control",60008),mirror:(0,i.$5j)("mirror",60009),mirrorPublic:(0,i.$5j)("mirror-public",60009),star:(0,i.$5j)("star",60010),starAdd:(0,i.$5j)("star-add",60010),starDelete:(0,i.$5j)("star-delete",60010),starEmpty:(0,i.$5j)("star-empty",60010),comment:(0,i.$5j)("comment",60011),commentAdd:(0,i.$5j)("comment-add",60011),alert:(0,i.$5j)("alert",60012),warning:(0,i.$5j)("warning",60012),search:(0,i.$5j)("search",60013),searchSave:(0,i.$5j)("search-save",60013),logOut:(0,i.$5j)("log-out",60014),signOut:(0,i.$5j)("sign-out",60014),logIn:(0,i.$5j)("log-in",60015),signIn:(0,i.$5j)("sign-in",60015),eye:(0,i.$5j)("eye",60016),eyeUnwatch:(0,i.$5j)("eye-unwatch",60016),eyeWatch:(0,i.$5j)("eye-watch",60016),circleFilled:(0,i.$5j)("circle-filled",60017),primitiveDot:(0,i.$5j)("primitive-dot",60017),closeDirty:(0,i.$5j)("close-dirty",60017),debugBreakpoint:(0,i.$5j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$5j)("debug-breakpoint-disabled",60017),debugHint:(0,i.$5j)("debug-hint",60017),terminalDecorationSuccess:(0,i.$5j)("terminal-decoration-success",60017),primitiveSquare:(0,i.$5j)("primitive-square",60018),edit:(0,i.$5j)("edit",60019),pencil:(0,i.$5j)("pencil",60019),info:(0,i.$5j)("info",60020),issueOpened:(0,i.$5j)("issue-opened",60020),gistPrivate:(0,i.$5j)("gist-private",60021),gitForkPrivate:(0,i.$5j)("git-fork-private",60021),lock:(0,i.$5j)("lock",60021),mirrorPrivate:(0,i.$5j)("mirror-private",60021),close:(0,i.$5j)("close",60022),removeClose:(0,i.$5j)("remove-close",60022),x:(0,i.$5j)("x",60022),repoSync:(0,i.$5j)("repo-sync",60023),sync:(0,i.$5j)("sync",60023),clone:(0,i.$5j)("clone",60024),desktopDownload:(0,i.$5j)("desktop-download",60024),beaker:(0,i.$5j)("beaker",60025),microscope:(0,i.$5j)("microscope",60025),vm:(0,i.$5j)("vm",60026),deviceDesktop:(0,i.$5j)("device-desktop",60026),file:(0,i.$5j)("file",60027),fileText:(0,i.$5j)("file-text",60027),more:(0,i.$5j)("more",60028),ellipsis:(0,i.$5j)("ellipsis",60028),kebabHorizontal:(0,i.$5j)("kebab-horizontal",60028),mailReply:(0,i.$5j)("mail-reply",60029),reply:(0,i.$5j)("reply",60029),organization:(0,i.$5j)("organization",60030),organizationFilled:(0,i.$5j)("organization-filled",60030),organizationOutline:(0,i.$5j)("organization-outline",60030),newFile:(0,i.$5j)("new-file",60031),fileAdd:(0,i.$5j)("file-add",60031),newFolder:(0,i.$5j)("new-folder",60032),fileDirectoryCreate:(0,i.$5j)("file-directory-create",60032),trash:(0,i.$5j)("trash",60033),trashcan:(0,i.$5j)("trashcan",60033),history:(0,i.$5j)("history",60034),clock:(0,i.$5j)("clock",60034),folder:(0,i.$5j)("folder",60035),fileDirectory:(0,i.$5j)("file-directory",60035),symbolFolder:(0,i.$5j)("symbol-folder",60035),logoGithub:(0,i.$5j)("logo-github",60036),markGithub:(0,i.$5j)("mark-github",60036),github:(0,i.$5j)("github",60036),terminal:(0,i.$5j)("terminal",60037),console:(0,i.$5j)("console",60037),repl:(0,i.$5j)("repl",60037),zap:(0,i.$5j)("zap",60038),symbolEvent:(0,i.$5j)("symbol-event",60038),error:(0,i.$5j)("error",60039),stop:(0,i.$5j)("stop",60039),variable:(0,i.$5j)("variable",60040),symbolVariable:(0,i.$5j)("symbol-variable",60040),array:(0,i.$5j)("array",60042),symbolArray:(0,i.$5j)("symbol-array",60042),symbolModule:(0,i.$5j)("symbol-module",60043),symbolPackage:(0,i.$5j)("symbol-package",60043),symbolNamespace:(0,i.$5j)("symbol-namespace",60043),symbolObject:(0,i.$5j)("symbol-object",60043),symbolMethod:(0,i.$5j)("symbol-method",60044),symbolFunction:(0,i.$5j)("symbol-function",60044),symbolConstructor:(0,i.$5j)("symbol-constructor",60044),symbolBoolean:(0,i.$5j)("symbol-boolean",60047),symbolNull:(0,i.$5j)("symbol-null",60047),symbolNumeric:(0,i.$5j)("symbol-numeric",60048),symbolNumber:(0,i.$5j)("symbol-number",60048),symbolStructure:(0,i.$5j)("symbol-structure",60049),symbolStruct:(0,i.$5j)("symbol-struct",60049),symbolParameter:(0,i.$5j)("symbol-parameter",60050),symbolTypeParameter:(0,i.$5j)("symbol-type-parameter",60050),symbolKey:(0,i.$5j)("symbol-key",60051),symbolText:(0,i.$5j)("symbol-text",60051),symbolReference:(0,i.$5j)("symbol-reference",60052),goToFile:(0,i.$5j)("go-to-file",60052),symbolEnum:(0,i.$5j)("symbol-enum",60053),symbolValue:(0,i.$5j)("symbol-value",60053),symbolRuler:(0,i.$5j)("symbol-ruler",60054),symbolUnit:(0,i.$5j)("symbol-unit",60054),activateBreakpoints:(0,i.$5j)("activate-breakpoints",60055),archive:(0,i.$5j)("archive",60056),arrowBoth:(0,i.$5j)("arrow-both",60057),arrowDown:(0,i.$5j)("arrow-down",60058),arrowLeft:(0,i.$5j)("arrow-left",60059),arrowRight:(0,i.$5j)("arrow-right",60060),arrowSmallDown:(0,i.$5j)("arrow-small-down",60061),arrowSmallLeft:(0,i.$5j)("arrow-small-left",60062),arrowSmallRight:(0,i.$5j)("arrow-small-right",60063),arrowSmallUp:(0,i.$5j)("arrow-small-up",60064),arrowUp:(0,i.$5j)("arrow-up",60065),bell:(0,i.$5j)("bell",60066),bold:(0,i.$5j)("bold",60067),book:(0,i.$5j)("book",60068),bookmark:(0,i.$5j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$5j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$5j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$5j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$5j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$5j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$5j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$5j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$5j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$5j)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$5j)("briefcase",60076),broadcast:(0,i.$5j)("broadcast",60077),browser:(0,i.$5j)("browser",60078),bug:(0,i.$5j)("bug",60079),calendar:(0,i.$5j)("calendar",60080),caseSensitive:(0,i.$5j)("case-sensitive",60081),check:(0,i.$5j)("check",60082),checklist:(0,i.$5j)("checklist",60083),chevronDown:(0,i.$5j)("chevron-down",60084),chevronLeft:(0,i.$5j)("chevron-left",60085),chevronRight:(0,i.$5j)("chevron-right",60086),chevronUp:(0,i.$5j)("chevron-up",60087),chromeClose:(0,i.$5j)("chrome-close",60088),chromeMaximize:(0,i.$5j)("chrome-maximize",60089),chromeMinimize:(0,i.$5j)("chrome-minimize",60090),chromeRestore:(0,i.$5j)("chrome-restore",60091),circleOutline:(0,i.$5j)("circle-outline",60092),circle:(0,i.$5j)("circle",60092),debugBreakpointUnverified:(0,i.$5j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$5j)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$5j)("circle-slash",60093),circuitBoard:(0,i.$5j)("circuit-board",60094),clearAll:(0,i.$5j)("clear-all",60095),clippy:(0,i.$5j)("clippy",60096),closeAll:(0,i.$5j)("close-all",60097),cloudDownload:(0,i.$5j)("cloud-download",60098),cloudUpload:(0,i.$5j)("cloud-upload",60099),code:(0,i.$5j)("code",60100),collapseAll:(0,i.$5j)("collapse-all",60101),colorMode:(0,i.$5j)("color-mode",60102),commentDiscussion:(0,i.$5j)("comment-discussion",60103),creditCard:(0,i.$5j)("credit-card",60105),dash:(0,i.$5j)("dash",60108),dashboard:(0,i.$5j)("dashboard",60109),database:(0,i.$5j)("database",60110),debugContinue:(0,i.$5j)("debug-continue",60111),debugDisconnect:(0,i.$5j)("debug-disconnect",60112),debugPause:(0,i.$5j)("debug-pause",60113),debugRestart:(0,i.$5j)("debug-restart",60114),debugStart:(0,i.$5j)("debug-start",60115),debugStepInto:(0,i.$5j)("debug-step-into",60116),debugStepOut:(0,i.$5j)("debug-step-out",60117),debugStepOver:(0,i.$5j)("debug-step-over",60118),debugStop:(0,i.$5j)("debug-stop",60119),debug:(0,i.$5j)("debug",60120),deviceCameraVideo:(0,i.$5j)("device-camera-video",60121),deviceCamera:(0,i.$5j)("device-camera",60122),deviceMobile:(0,i.$5j)("device-mobile",60123),diffAdded:(0,i.$5j)("diff-added",60124),diffIgnored:(0,i.$5j)("diff-ignored",60125),diffModified:(0,i.$5j)("diff-modified",60126),diffRemoved:(0,i.$5j)("diff-removed",60127),diffRenamed:(0,i.$5j)("diff-renamed",60128),diff:(0,i.$5j)("diff",60129),diffSidebyside:(0,i.$5j)("diff-sidebyside",60129),discard:(0,i.$5j)("discard",60130),editorLayout:(0,i.$5j)("editor-layout",60131),emptyWindow:(0,i.$5j)("empty-window",60132),exclude:(0,i.$5j)("exclude",60133),extensions:(0,i.$5j)("extensions",60134),eyeClosed:(0,i.$5j)("eye-closed",60135),fileBinary:(0,i.$5j)("file-binary",60136),fileCode:(0,i.$5j)("file-code",60137),fileMedia:(0,i.$5j)("file-media",60138),filePdf:(0,i.$5j)("file-pdf",60139),fileSubmodule:(0,i.$5j)("file-submodule",60140),fileSymlinkDirectory:(0,i.$5j)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$5j)("file-symlink-file",60142),fileZip:(0,i.$5j)("file-zip",60143),files:(0,i.$5j)("files",60144),filter:(0,i.$5j)("filter",60145),flame:(0,i.$5j)("flame",60146),foldDown:(0,i.$5j)("fold-down",60147),foldUp:(0,i.$5j)("fold-up",60148),fold:(0,i.$5j)("fold",60149),folderActive:(0,i.$5j)("folder-active",60150),folderOpened:(0,i.$5j)("folder-opened",60151),gear:(0,i.$5j)("gear",60152),gift:(0,i.$5j)("gift",60153),gistSecret:(0,i.$5j)("gist-secret",60154),gist:(0,i.$5j)("gist",60155),gitCommit:(0,i.$5j)("git-commit",60156),gitCompare:(0,i.$5j)("git-compare",60157),compareChanges:(0,i.$5j)("compare-changes",60157),gitMerge:(0,i.$5j)("git-merge",60158),githubAction:(0,i.$5j)("github-action",60159),githubAlt:(0,i.$5j)("github-alt",60160),globe:(0,i.$5j)("globe",60161),grabber:(0,i.$5j)("grabber",60162),graph:(0,i.$5j)("graph",60163),gripper:(0,i.$5j)("gripper",60164),heart:(0,i.$5j)("heart",60165),home:(0,i.$5j)("home",60166),horizontalRule:(0,i.$5j)("horizontal-rule",60167),hubot:(0,i.$5j)("hubot",60168),inbox:(0,i.$5j)("inbox",60169),issueReopened:(0,i.$5j)("issue-reopened",60171),issues:(0,i.$5j)("issues",60172),italic:(0,i.$5j)("italic",60173),jersey:(0,i.$5j)("jersey",60174),json:(0,i.$5j)("json",60175),kebabVertical:(0,i.$5j)("kebab-vertical",60176),key:(0,i.$5j)("key",60177),law:(0,i.$5j)("law",60178),lightbulbAutofix:(0,i.$5j)("lightbulb-autofix",60179),linkExternal:(0,i.$5j)("link-external",60180),link:(0,i.$5j)("link",60181),listOrdered:(0,i.$5j)("list-ordered",60182),listUnordered:(0,i.$5j)("list-unordered",60183),liveShare:(0,i.$5j)("live-share",60184),loading:(0,i.$5j)("loading",60185),location:(0,i.$5j)("location",60186),mailRead:(0,i.$5j)("mail-read",60187),mail:(0,i.$5j)("mail",60188),markdown:(0,i.$5j)("markdown",60189),megaphone:(0,i.$5j)("megaphone",60190),mention:(0,i.$5j)("mention",60191),milestone:(0,i.$5j)("milestone",60192),gitPullRequestMilestone:(0,i.$5j)("git-pull-request-milestone",60192),mortarBoard:(0,i.$5j)("mortar-board",60193),move:(0,i.$5j)("move",60194),multipleWindows:(0,i.$5j)("multiple-windows",60195),mute:(0,i.$5j)("mute",60196),noNewline:(0,i.$5j)("no-newline",60197),note:(0,i.$5j)("note",60198),octoface:(0,i.$5j)("octoface",60199),openPreview:(0,i.$5j)("open-preview",60200),package:(0,i.$5j)("package",60201),paintcan:(0,i.$5j)("paintcan",60202),pin:(0,i.$5j)("pin",60203),play:(0,i.$5j)("play",60204),run:(0,i.$5j)("run",60204),plug:(0,i.$5j)("plug",60205),preserveCase:(0,i.$5j)("preserve-case",60206),preview:(0,i.$5j)("preview",60207),project:(0,i.$5j)("project",60208),pulse:(0,i.$5j)("pulse",60209),question:(0,i.$5j)("question",60210),quote:(0,i.$5j)("quote",60211),radioTower:(0,i.$5j)("radio-tower",60212),reactions:(0,i.$5j)("reactions",60213),references:(0,i.$5j)("references",60214),refresh:(0,i.$5j)("refresh",60215),regex:(0,i.$5j)("regex",60216),remoteExplorer:(0,i.$5j)("remote-explorer",60217),remote:(0,i.$5j)("remote",60218),remove:(0,i.$5j)("remove",60219),replaceAll:(0,i.$5j)("replace-all",60220),replace:(0,i.$5j)("replace",60221),repoClone:(0,i.$5j)("repo-clone",60222),repoForcePush:(0,i.$5j)("repo-force-push",60223),repoPull:(0,i.$5j)("repo-pull",60224),repoPush:(0,i.$5j)("repo-push",60225),report:(0,i.$5j)("report",60226),requestChanges:(0,i.$5j)("request-changes",60227),rocket:(0,i.$5j)("rocket",60228),rootFolderOpened:(0,i.$5j)("root-folder-opened",60229),rootFolder:(0,i.$5j)("root-folder",60230),rss:(0,i.$5j)("rss",60231),ruby:(0,i.$5j)("ruby",60232),saveAll:(0,i.$5j)("save-all",60233),saveAs:(0,i.$5j)("save-as",60234),save:(0,i.$5j)("save",60235),screenFull:(0,i.$5j)("screen-full",60236),screenNormal:(0,i.$5j)("screen-normal",60237),searchStop:(0,i.$5j)("search-stop",60238),server:(0,i.$5j)("server",60240),settingsGear:(0,i.$5j)("settings-gear",60241),settings:(0,i.$5j)("settings",60242),shield:(0,i.$5j)("shield",60243),smiley:(0,i.$5j)("smiley",60244),sortPrecedence:(0,i.$5j)("sort-precedence",60245),splitHorizontal:(0,i.$5j)("split-horizontal",60246),splitVertical:(0,i.$5j)("split-vertical",60247),squirrel:(0,i.$5j)("squirrel",60248),starFull:(0,i.$5j)("star-full",60249),starHalf:(0,i.$5j)("star-half",60250),symbolClass:(0,i.$5j)("symbol-class",60251),symbolColor:(0,i.$5j)("symbol-color",60252),symbolConstant:(0,i.$5j)("symbol-constant",60253),symbolEnumMember:(0,i.$5j)("symbol-enum-member",60254),symbolField:(0,i.$5j)("symbol-field",60255),symbolFile:(0,i.$5j)("symbol-file",60256),symbolInterface:(0,i.$5j)("symbol-interface",60257),symbolKeyword:(0,i.$5j)("symbol-keyword",60258),symbolMisc:(0,i.$5j)("symbol-misc",60259),symbolOperator:(0,i.$5j)("symbol-operator",60260),symbolProperty:(0,i.$5j)("symbol-property",60261),wrench:(0,i.$5j)("wrench",60261),wrenchSubaction:(0,i.$5j)("wrench-subaction",60261),symbolSnippet:(0,i.$5j)("symbol-snippet",60262),tasklist:(0,i.$5j)("tasklist",60263),telescope:(0,i.$5j)("telescope",60264),textSize:(0,i.$5j)("text-size",60265),threeBars:(0,i.$5j)("three-bars",60266),thumbsdown:(0,i.$5j)("thumbsdown",60267),thumbsup:(0,i.$5j)("thumbsup",60268),tools:(0,i.$5j)("tools",60269),triangleDown:(0,i.$5j)("triangle-down",60270),triangleLeft:(0,i.$5j)("triangle-left",60271),triangleRight:(0,i.$5j)("triangle-right",60272),triangleUp:(0,i.$5j)("triangle-up",60273),twitter:(0,i.$5j)("twitter",60274),unfold:(0,i.$5j)("unfold",60275),unlock:(0,i.$5j)("unlock",60276),unmute:(0,i.$5j)("unmute",60277),unverified:(0,i.$5j)("unverified",60278),verified:(0,i.$5j)("verified",60279),versions:(0,i.$5j)("versions",60280),vmActive:(0,i.$5j)("vm-active",60281),vmOutline:(0,i.$5j)("vm-outline",60282),vmRunning:(0,i.$5j)("vm-running",60283),watch:(0,i.$5j)("watch",60284),whitespace:(0,i.$5j)("whitespace",60285),wholeWord:(0,i.$5j)("whole-word",60286),window:(0,i.$5j)("window",60287),wordWrap:(0,i.$5j)("word-wrap",60288),zoomIn:(0,i.$5j)("zoom-in",60289),zoomOut:(0,i.$5j)("zoom-out",60290),listFilter:(0,i.$5j)("list-filter",60291),listFlat:(0,i.$5j)("list-flat",60292),listSelection:(0,i.$5j)("list-selection",60293),selection:(0,i.$5j)("selection",60293),listTree:(0,i.$5j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$5j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$5j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$5j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$5j)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$5j)("circle-small-filled",60298),debugStackframeDot:(0,i.$5j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$5j)("terminal-decoration-mark",60298),debugStackframe:(0,i.$5j)("debug-stackframe",60299),debugStackframeFocused:(0,i.$5j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$5j)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$5j)("symbol-string",60301),debugReverseContinue:(0,i.$5j)("debug-reverse-continue",60302),debugStepBack:(0,i.$5j)("debug-step-back",60303),debugRestartFrame:(0,i.$5j)("debug-restart-frame",60304),debugAlt:(0,i.$5j)("debug-alt",60305),callIncoming:(0,i.$5j)("call-incoming",60306),callOutgoing:(0,i.$5j)("call-outgoing",60307),menu:(0,i.$5j)("menu",60308),expandAll:(0,i.$5j)("expand-all",60309),feedback:(0,i.$5j)("feedback",60310),gitPullRequestReviewer:(0,i.$5j)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$5j)("group-by-ref-type",60311),ungroupByRefType:(0,i.$5j)("ungroup-by-ref-type",60312),account:(0,i.$5j)("account",60313),gitPullRequestAssignee:(0,i.$5j)("git-pull-request-assignee",60313),bellDot:(0,i.$5j)("bell-dot",60314),debugConsole:(0,i.$5j)("debug-console",60315),library:(0,i.$5j)("library",60316),output:(0,i.$5j)("output",60317),runAll:(0,i.$5j)("run-all",60318),syncIgnored:(0,i.$5j)("sync-ignored",60319),pinned:(0,i.$5j)("pinned",60320),githubInverted:(0,i.$5j)("github-inverted",60321),serverProcess:(0,i.$5j)("server-process",60322),serverEnvironment:(0,i.$5j)("server-environment",60323),pass:(0,i.$5j)("pass",60324),issueClosed:(0,i.$5j)("issue-closed",60324),stopCircle:(0,i.$5j)("stop-circle",60325),playCircle:(0,i.$5j)("play-circle",60326),record:(0,i.$5j)("record",60327),debugAltSmall:(0,i.$5j)("debug-alt-small",60328),vmConnect:(0,i.$5j)("vm-connect",60329),cloud:(0,i.$5j)("cloud",60330),merge:(0,i.$5j)("merge",60331),export:(0,i.$5j)("export",60332),graphLeft:(0,i.$5j)("graph-left",60333),magnet:(0,i.$5j)("magnet",60334),notebook:(0,i.$5j)("notebook",60335),redo:(0,i.$5j)("redo",60336),checkAll:(0,i.$5j)("check-all",60337),pinnedDirty:(0,i.$5j)("pinned-dirty",60338),passFilled:(0,i.$5j)("pass-filled",60339),circleLargeFilled:(0,i.$5j)("circle-large-filled",60340),circleLarge:(0,i.$5j)("circle-large",60341),circleLargeOutline:(0,i.$5j)("circle-large-outline",60341),combine:(0,i.$5j)("combine",60342),gather:(0,i.$5j)("gather",60342),table:(0,i.$5j)("table",60343),variableGroup:(0,i.$5j)("variable-group",60344),typeHierarchy:(0,i.$5j)("type-hierarchy",60345),typeHierarchySub:(0,i.$5j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$5j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$5j)("git-pull-request-create",60348),runAbove:(0,i.$5j)("run-above",60349),runBelow:(0,i.$5j)("run-below",60350),notebookTemplate:(0,i.$5j)("notebook-template",60351),debugRerun:(0,i.$5j)("debug-rerun",60352),workspaceTrusted:(0,i.$5j)("workspace-trusted",60353),workspaceUntrusted:(0,i.$5j)("workspace-untrusted",60354),workspaceUnknown:(0,i.$5j)("workspace-unknown",60355),terminalCmd:(0,i.$5j)("terminal-cmd",60356),terminalDebian:(0,i.$5j)("terminal-debian",60357),terminalLinux:(0,i.$5j)("terminal-linux",60358),terminalPowershell:(0,i.$5j)("terminal-powershell",60359),terminalTmux:(0,i.$5j)("terminal-tmux",60360),terminalUbuntu:(0,i.$5j)("terminal-ubuntu",60361),terminalBash:(0,i.$5j)("terminal-bash",60362),arrowSwap:(0,i.$5j)("arrow-swap",60363),copy:(0,i.$5j)("copy",60364),personAdd:(0,i.$5j)("person-add",60365),filterFilled:(0,i.$5j)("filter-filled",60366),wand:(0,i.$5j)("wand",60367),debugLineByLine:(0,i.$5j)("debug-line-by-line",60368),inspect:(0,i.$5j)("inspect",60369),layers:(0,i.$5j)("layers",60370),layersDot:(0,i.$5j)("layers-dot",60371),layersActive:(0,i.$5j)("layers-active",60372),compass:(0,i.$5j)("compass",60373),compassDot:(0,i.$5j)("compass-dot",60374),compassActive:(0,i.$5j)("compass-active",60375),azure:(0,i.$5j)("azure",60376),issueDraft:(0,i.$5j)("issue-draft",60377),gitPullRequestClosed:(0,i.$5j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$5j)("git-pull-request-draft",60379),debugAll:(0,i.$5j)("debug-all",60380),debugCoverage:(0,i.$5j)("debug-coverage",60381),runErrors:(0,i.$5j)("run-errors",60382),folderLibrary:(0,i.$5j)("folder-library",60383),debugContinueSmall:(0,i.$5j)("debug-continue-small",60384),beakerStop:(0,i.$5j)("beaker-stop",60385),graphLine:(0,i.$5j)("graph-line",60386),graphScatter:(0,i.$5j)("graph-scatter",60387),pieChart:(0,i.$5j)("pie-chart",60388),bracket:(0,i.$5j)("bracket",60175),bracketDot:(0,i.$5j)("bracket-dot",60389),bracketError:(0,i.$5j)("bracket-error",60390),lockSmall:(0,i.$5j)("lock-small",60391),azureDevops:(0,i.$5j)("azure-devops",60392),verifiedFilled:(0,i.$5j)("verified-filled",60393),newline:(0,i.$5j)("newline",60394),layout:(0,i.$5j)("layout",60395),layoutActivitybarLeft:(0,i.$5j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$5j)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$5j)("layout-panel-left",60398),layoutPanelCenter:(0,i.$5j)("layout-panel-center",60399),layoutPanelJustify:(0,i.$5j)("layout-panel-justify",60400),layoutPanelRight:(0,i.$5j)("layout-panel-right",60401),layoutPanel:(0,i.$5j)("layout-panel",60402),layoutSidebarLeft:(0,i.$5j)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$5j)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$5j)("layout-statusbar",60405),layoutMenubar:(0,i.$5j)("layout-menubar",60406),layoutCentered:(0,i.$5j)("layout-centered",60407),target:(0,i.$5j)("target",60408),indent:(0,i.$5j)("indent",60409),recordSmall:(0,i.$5j)("record-small",60410),errorSmall:(0,i.$5j)("error-small",60411),terminalDecorationError:(0,i.$5j)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$5j)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$5j)("arrow-circle-left",60413),arrowCircleRight:(0,i.$5j)("arrow-circle-right",60414),arrowCircleUp:(0,i.$5j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$5j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$5j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$5j)("layout-sidebar-left-off",60418),blank:(0,i.$5j)("blank",60419),heartFilled:(0,i.$5j)("heart-filled",60420),map:(0,i.$5j)("map",60421),mapHorizontal:(0,i.$5j)("map-horizontal",60421),foldHorizontal:(0,i.$5j)("fold-horizontal",60421),mapFilled:(0,i.$5j)("map-filled",60422),mapHorizontalFilled:(0,i.$5j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$5j)("fold-horizontal-filled",60422),circleSmall:(0,i.$5j)("circle-small",60423),bellSlash:(0,i.$5j)("bell-slash",60424),bellSlashDot:(0,i.$5j)("bell-slash-dot",60425),commentUnresolved:(0,i.$5j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$5j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$5j)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$5j)("search-fuzzy",60429),commentDraft:(0,i.$5j)("comment-draft",60430),send:(0,i.$5j)("send",60431),sparkle:(0,i.$5j)("sparkle",60432),insert:(0,i.$5j)("insert",60433),mic:(0,i.$5j)("mic",60434),thumbsdownFilled:(0,i.$5j)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$5j)("thumbsup-filled",60436),coffee:(0,i.$5j)("coffee",60437),snake:(0,i.$5j)("snake",60438),game:(0,i.$5j)("game",60439),vr:(0,i.$5j)("vr",60440),chip:(0,i.$5j)("chip",60441),piano:(0,i.$5j)("piano",60442),music:(0,i.$5j)("music",60443),micFilled:(0,i.$5j)("mic-filled",60444),repoFetch:(0,i.$5j)("repo-fetch",60445),copilot:(0,i.$5j)("copilot",60446),lightbulbSparkle:(0,i.$5j)("lightbulb-sparkle",60447),robot:(0,i.$5j)("robot",60448),sparkleFilled:(0,i.$5j)("sparkle-filled",60449),diffSingle:(0,i.$5j)("diff-single",60450),diffMultiple:(0,i.$5j)("diff-multiple",60451),surroundWith:(0,i.$5j)("surround-with",60452),share:(0,i.$5j)("share",60453),gitStash:(0,i.$5j)("git-stash",60454),gitStashApply:(0,i.$5j)("git-stash-apply",60455),gitStashPop:(0,i.$5j)("git-stash-pop",60456),vscode:(0,i.$5j)("vscode",60457),vscodeInsiders:(0,i.$5j)("vscode-insiders",60458),codeOss:(0,i.$5j)("code-oss",60459),runCoverage:(0,i.$5j)("run-coverage",60460),runAllCoverage:(0,i.$5j)("run-all-coverage",60461),coverage:(0,i.$5j)("coverage",60462),githubProject:(0,i.$5j)("github-project",60463),mapVertical:(0,i.$5j)("map-vertical",60464),foldVertical:(0,i.$5j)("fold-vertical",60464),mapVerticalFilled:(0,i.$5j)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$5j)("fold-vertical-filled",60465),goToSearch:(0,i.$5j)("go-to-search",60466),percentage:(0,i.$5j)("percentage",60467),sortPercentage:(0,i.$5j)("sort-percentage",60467),attach:(0,i.$5j)("attach",60468)}}),define(le[80],ue([0,1,112,151]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=void 0,e.$8j=v;function v(){return Object.values(e.$0j)}e.$9j={dialogError:(0,i.$5j)("dialog-error","error"),dialogWarning:(0,i.$5j)("dialog-warning","warning"),dialogInfo:(0,i.$5j)("dialog-info","info"),dialogClose:(0,i.$5j)("dialog-close","close"),treeItemExpanded:(0,i.$5j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$5j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$5j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$5j)("tree-filter-clear","close"),treeItemLoading:(0,i.$5j)("tree-item-loading","loading"),menuSelection:(0,i.$5j)("menu-selection","check"),menuSubmenu:(0,i.$5j)("menu-submenu","chevron-right"),menuBarMore:(0,i.$5j)("menubar-more","more"),scrollbarButtonLeft:(0,i.$5j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$5j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$5j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$5j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$5j)("toolbar-more","more"),quickInputBack:(0,i.$5j)("quick-input-back","arrow-left"),dropDownButton:(0,i.$5j)("drop-down-button",60084),symbolCustomColor:(0,i.$5j)("symbol-customcolor",60252),exportIcon:(0,i.$5j)("export",60332),workspaceUnspecified:(0,i.$5j)("workspace-unspecified",60355),newLine:(0,i.$5j)("newline",60394),thumbsDownFilled:(0,i.$5j)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$5j)("thumbsup-filled",60436),gitFetch:(0,i.$5j)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$5j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$5j)("debug-breakpoint-pending",60377)},e.$0j={...r.$7j,...e.$9j}}),define(le[37],ue([0,1,12]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=r,e.$lo=v,e.$mo=O,e.$no=b,e.$oo=l,e.$po=m,e.$qo=u,e.$ro=$,e.$so=p,e.$to=d,e.$uo=f,e.$vo=y,e.$wo=E;function r(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const S=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([k,s])=>{S[k]=s&&typeof s=="object"?r(s):s}),S}function v(g){if(!g||typeof g!="object")return g;const S=[g];for(;S.length>0;){const k=S.shift();Object.freeze(k);for(const s in k)if(D.call(k,s)){const a=k[s];typeof a=="object"&&!Object.isFrozen(a)&&!(0,i.$mg)(a)&&S.push(a)}}return g}const D=Object.prototype.hasOwnProperty;function O(g,S){return I(g,S,new Set)}function I(g,S,k){if((0,i.$sg)(g))return g;const s=S(g);if(typeof s<"u")return s;if(Array.isArray(g)){const a=[];for(const t of g)a.push(I(t,S,k));return a}if((0,i.$lg)(g)){if(k.has(g))throw new Error("Cannot clone recursive data-structure");k.add(g);const a={};for(const t in g)D.call(g,t)&&(a[t]=I(g[t],S,k));return k.delete(g),a}return g}function b(g,S,k=!0){return(0,i.$lg)(g)?((0,i.$lg)(S)&&Object.keys(S).forEach(s=>{s in g?k&&((0,i.$lg)(g[s])&&(0,i.$lg)(S[s])?b(g[s],S[s],k):g[s]=S[s]):g[s]=S[s]}),g):S}function l(g,S){if(g===S)return!0;if(g==null||S===null||S===void 0||typeof g!=typeof S||typeof g!="object"||Array.isArray(g)!==Array.isArray(S))return!1;let k,s;if(Array.isArray(g)){if(g.length!==S.length)return!1;for(k=0;k<g.length;k++)if(!l(g[k],S[k]))return!1}else{const a=[];for(s in g)a.push(s);a.sort();const t=[];for(s in S)t.push(s);if(t.sort(),!l(a,t))return!1;for(k=0;k<a.length;k++)if(!l(g[a[k]],S[a[k]]))return!1}return!0}function m(g){const S=new Set;return JSON.stringify(g,(k,s)=>{if((0,i.$lg)(s)||Array.isArray(s)){if(S.has(s))return"[Circular]";S.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function u(g,S){const k=Object.create(null);return!g||!S||Object.keys(S).forEach(a=>{const t=g[a],o=S[a];l(t,o)||(k[a]=o)}),k}function $(g,S){const k=S.toLowerCase(),s=Object.keys(g).find(a=>a.toLowerCase()===k);return s?g[s]:g[S]}function p(g,S){const k=Object.create(null);for(const[s,a]of Object.entries(g))S(s,a)&&(k[s]=a);return k}function d(g){let S=[];for(;Object.prototype!==g;)S=S.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return S}function f(g){const S=[];for(const k of d(g))typeof g[k]=="function"&&S.push(k);return S}function y(g,S){const k=a=>function(){const t=Array.prototype.slice.call(arguments,0);return S(a,t)},s={};for(const a of g)s[a]=k(a);return s}function E(g,S){const k={};for(const[s,a]of Object.entries(g))k[s]=S(a,s);return k}}),define(le[113],ue([0,1,80]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$$j=v;var r;(function(O){function I(b){return b&&typeof b=="object"&&typeof b.id=="string"}O.isThemeColor=I})(r||(e.ThemeColor=r={}));function v(O){return{id:O}}var D;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function b(g){const S=I.exec(g.id);if(!S)return b(i.$0j.error);const[,k,s]=S,a=["codicon","codicon-"+k];return s&&a.push("codicon-modifier-"+s.substring(1)),a}O.asClassNameArray=b;function l(g){return b(g).join(" ")}O.asClassName=l;function m(g){return"."+b(g).join(".")}O.asCSSSelector=m;function u(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||r.isThemeColor(g.color))}O.isThemeIcon=u;const $=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function p(g){const S=$.exec(g);if(!S)return;const[,k]=S;return{id:k}}O.fromString=p;function d(g){return{id:g}}O.fromId=d;function f(g,S){let k=g.id;const s=k.lastIndexOf("~");return s!==-1&&(k=k.substring(0,s)),S&&(k=`${k}~${S}`),{id:k}}O.modify=f;function y(g){const S=g.id.lastIndexOf("~");if(S!==-1)return g.id.substring(S+1)}O.getModifier=y;function E(g,S){return g.id===S.id&&g.color?.id===S.color?.id}O.isEqual=E})(D||(e.ThemeIcon=D={}))}),define(le[152],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$ff=r,e.$gf=v;var i;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(e.Constants=i={}));function r(D){return D<0?0:D>i.MAX_UINT_8?i.MAX_UINT_8:D|0}function v(D){return D<0?0:D>i.MAX_UINT_32?i.MAX_UINT_32:D|0}}),define(le[25],ue([0,1,149,39,67,152]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=e.GraphemeBreakType=e.$9f=e.$1f=e.$Tf=e.$Sf=void 0,e.$hf=O,e.$if=b,e.$jf=m,e.$kf=u,e.$lf=$,e.$mf=p,e.$nf=d,e.$of=f,e.$pf=y,e.$qf=E,e.$rf=g,e.$sf=S,e.$tf=k,e.$uf=s,e.$vf=a,e.$wf=t,e.$xf=o,e.$yf=n,e.$zf=c,e.$Af=h,e.$Bf=P,e.$Cf=w,e.$Df=R,e.$Ef=T,e.$Ff=A,e.$Gf=L,e.$Hf=M,e.$If=V,e.$Jf=q,e.$Kf=Y,e.$Lf=de,e.$Mf=re,e.$Nf=ee,e.$Of=W,e.$Pf=Z,e.$Qf=C,e.$Rf=B,e.$Uf=x,e.$Vf=ce,e.$Wf=oe,e.$Xf=te,e.$Yf=U,e.$Zf=Q,e.$2f=K,e.$3f=H,e.$4f=_,e.$5f=ae,e.$6f=be,e.$7f=ye,e.$8f=xe,e.$0f=Ae,e.$$f=me,e.$_f=J,e.$ag=he,e.$bg=fe,e.$cg=pe,e.$dg=ve,e.$eg=je,e.$fg=Qe;function O(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}const I=/{(\d+)}/g;function b(ne,...ge){return ge.length===0?ne:ne.replace(I,function(we,Ee){const Me=parseInt(Ee,10);return isNaN(Me)||Me<0||Me>=ge.length?we:ge[Me]})}const l=/{([^}]+)}/g;function m(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(l,(we,Ee)=>ge[Ee]??we)}function u(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function $(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function p(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function d(ne,ge){let we=0,Ee=ne.indexOf(ge);for(;Ee!==-1;)we++,Ee=ne.indexOf(ge,Ee+ge.length);return we}function f(ne,ge,we="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${we}`}function y(ne,ge,we="\u2026"){if(ne.length<=ge)return ne;const Ee=Math.ceil(ge/2)-we.length/2,Me=Math.floor(ge/2)-we.length/2;return`${ne.substr(0,Ee)}${we}${ne.substr(ne.length-Me)}`}function E(ne,ge=" "){const we=g(ne,ge);return S(we,ge)}function g(ne,ge){if(!ne||!ge)return ne;const we=ge.length;if(we===0||ne.length===0)return ne;let Ee=0;for(;ne.indexOf(ge,Ee)===Ee;)Ee=Ee+we;return ne.substring(Ee)}function S(ne,ge){if(!ne||!ge)return ne;const we=ge.length,Ee=ne.length;if(we===0||Ee===0)return ne;let Me=Ee,Be=-1;for(;Be=ne.lastIndexOf(ge,Me-1),!(Be===-1||Be+we!==Me);){if(Be===0)return"";Me=Be}return ne.substring(0,Me)}function k(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function s(ne){return ne.replace(/\*/g,"")}function a(ne,ge,we={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=p(ne)),we.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let Ee="";return we.global&&(Ee+="g"),we.matchCase||(Ee+="i"),we.multiline&&(Ee+="m"),we.unicode&&(Ee+="u"),new RegExp(ne,Ee)}function t(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}function o(ne){return ne.split(/\r\n|\r|\n/)}function n(ne){const ge=[],we=ne.split(/(\r\n|\r|\n)/);for(let Ee=0;Ee<Math.ceil(we.length/2);Ee++)ge.push(we[2*Ee]+(we[2*Ee+1]??""));return ge}function c(ne){for(let ge=0,we=ne.length;ge<we;ge++){const Ee=ne.charCodeAt(ge);if(Ee!==r.CharCode.Space&&Ee!==r.CharCode.Tab)return ge}return-1}function h(ne,ge=0,we=ne.length){for(let Ee=ge;Ee<we;Ee++){const Me=ne.charCodeAt(Ee);if(Me!==r.CharCode.Space&&Me!==r.CharCode.Tab)return ne.substring(ge,Ee)}return ne.substring(ge,we)}function P(ne,ge=ne.length-1){for(let we=ge;we>=0;we--){const Ee=ne.charCodeAt(we);if(Ee!==r.CharCode.Space&&Ee!==r.CharCode.Tab)return we}return-1}function w(ne,ge,we){const Ee=[];let Me=0;for(const Be of ne.matchAll(ge)){if(Ee.push(ne.slice(Me,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Me=Be.index+Be[0].length,Ee.push(we(Be[0],...Be.slice(1),Be.index,ne,Be.groups))}return Ee.push(ne.slice(Me)),Promise.all(Ee).then(Be=>Be.join(""))}function R(ne,ge){return ne<ge?-1:ne>ge?1:0}function T(ne,ge,we=0,Ee=ne.length,Me=0,Be=ge.length){for(;we<Ee&&Me<Be;we++,Me++){const rt=ne.charCodeAt(we),at=ge.charCodeAt(Me);if(rt<at)return-1;if(rt>at)return 1}const _e=Ee-we,lt=Be-Me;return _e<lt?-1:_e>lt?1:0}function A(ne,ge){return L(ne,ge,0,ne.length,0,ge.length)}function L(ne,ge,we=0,Ee=ne.length,Me=0,Be=ge.length){for(;we<Ee&&Me<Be;we++,Me++){let rt=ne.charCodeAt(we),at=ge.charCodeAt(Me);if(rt===at)continue;if(rt>=128||at>=128)return T(ne.toLowerCase(),ge.toLowerCase(),we,Ee,Me,Be);V(rt)&&(rt-=32),V(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const _e=Ee-we,lt=Be-Me;return _e<lt?-1:_e>lt?1:0}function M(ne){return ne>=r.CharCode.Digit0&&ne<=r.CharCode.Digit9}function V(ne){return ne>=r.CharCode.a&&ne<=r.CharCode.z}function q(ne){return ne>=r.CharCode.A&&ne<=r.CharCode.Z}function Y(ne,ge){return ne.length===ge.length&&L(ne,ge)===0}function de(ne,ge){const we=ge.length;return ge.length>ne.length?!1:L(ne,ge,0,we)===0}function re(ne,ge){const we=Math.min(ne.length,ge.length);let Ee;for(Ee=0;Ee<we;Ee++)if(ne.charCodeAt(Ee)!==ge.charCodeAt(Ee))return Ee;return we}function ee(ne,ge){const we=Math.min(ne.length,ge.length);let Ee;const Me=ne.length-1,Be=ge.length-1;for(Ee=0;Ee<we;Ee++)if(ne.charCodeAt(Me-Ee)!==ge.charCodeAt(Be-Ee))return Ee;return we}function W(ne){return 55296<=ne&&ne<=56319}function Z(ne){return 56320<=ne&&ne<=57343}function C(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}function B(ne,ge,we){const Ee=ne.charCodeAt(we);if(W(Ee)&&we+1<ge){const Me=ne.charCodeAt(we+1);if(Z(Me))return C(Ee,Me)}return Ee}function F(ne,ge){const we=ne.charCodeAt(ge-1);if(Z(we)&&ge>1){const Ee=ne.charCodeAt(ge-2);if(W(Ee))return C(Ee,we)}return we}class z{get offset(){return this.e}constructor(ge,we=0){this.c=ge,this.d=ge.length,this.e=we}setOffset(ge){this.e=ge}prevCodePoint(){const ge=F(this.c,this.e);return this.e-=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=B(this.c,this.d,this.e);return this.e+=ge>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Sf=z;class ie{get offset(){return this.c.offset}constructor(ge,we=0){this.c=new z(ge,we)}nextGraphemeLength(){const ge=We.getInstance(),we=this.c,Ee=we.offset;let Me=ge.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Be=we.offset,_e=ge.getGraphemeBreakType(we.nextCodePoint());if(Oe(Me,_e)){we.setOffset(Be);break}Me=_e}return we.offset-Ee}prevGraphemeLength(){const ge=We.getInstance(),we=this.c,Ee=we.offset;let Me=ge.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Be=we.offset,_e=ge.getGraphemeBreakType(we.prevCodePoint());if(Oe(_e,Me)){we.setOffset(Be);break}Me=_e}return Ee-we.offset}eol(){return this.c.eol()}}e.$Tf=ie;function x(ne,ge){return new ie(ne,ge).nextGraphemeLength()}function ce(ne,ge){return new ie(ne,ge).prevGraphemeLength()}function oe(ne,ge){ge>0&&Z(ne.charCodeAt(ge))&&ge--;const we=ge+x(ne,ge);return[we-ce(ne,we),we]}function te(ne){const ge=new ie(ne);let we=0;for(;!ge.eol();)we++,ge.nextGraphemeLength();return we}let j;function X(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(ne){return j||(j=X()),j.test(ne)}const N=/^[\t\n\r\x20-\x7E]*$/;function Q(ne){return N.test(ne)}e.$1f=/[\u2028\u2029]/;function K(ne){return e.$1f.test(ne)}function H(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}function _(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}function ae(ne,ge,we=""){const Ee=ne.trimStart();if(Ee.length<ge)return Ee;const Me=/\b/g;let Be=0;for(;Me.test(Ee)&&!(Ee.length-Me.lastIndex<ge);)Be=Me.lastIndex,Me.lastIndex+=1;return Be===0?Ee:we+Ee.substring(Be).trimStart()}const $e=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*be(ne){let ge=0;for(const we of ne.matchAll($e))ge!==we.index&&(yield{isCode:!1,str:ne.substring(ge,we.index)}),yield{isCode:!0,str:we[0]},ge=we.index+we[0].length;ge!==ne.length&&(yield{isCode:!1,str:ne.substring(ge)})}function ye(ne){return ne&&(ne=ne.replace($e,"")),ne}const Fe=/\\\[.*?\\\]/g;function xe(ne){return ye(ne).replace(Fe,"")}e.$9f=String.fromCharCode(r.CharCode.UTF8_BOM);function Ae(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===r.CharCode.UTF8_BOM)}function me(ne){return Ae(ne)?ne.substr(1):ne}function J(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const we=ge.length,Ee=ne.toLowerCase();let Me=0,Be=-1;for(;Me<we;){const _e=Ee.indexOf(ge[Me],Be+1);if(_e<0)return!1;Be=_e,Me++}return!0}function he(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}function fe(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}function pe(ne,ge=1){if(ge===0)return"";let we=-1;do we=ne.indexOf(`
`,we+1),ge--;while(ge>0&&we>=0);return we===-1?ne:(ne[we-1]==="\r"&&we--,ne.substr(0,we))}function ve(ne){const ge=r.CharCode.Z-r.CharCode.A+1;return ne=ne%(2*ge),ne<ge?String.fromCharCode(r.CharCode.a+ne):String.fromCharCode(r.CharCode.A+ne-ge)}function je(ne){return We.getInstance().getGraphemeBreakType(ne)}function Oe(ne,ge){return ne===Re.Other?ge!==Re.Extend&&ge!==Re.SpacingMark:ne===Re.CR&&ge===Re.LF?!1:ne===Re.Control||ne===Re.CR||ne===Re.LF||ge===Re.Control||ge===Re.CR||ge===Re.LF?!0:!(ne===Re.L&&(ge===Re.L||ge===Re.V||ge===Re.LV||ge===Re.LVT)||(ne===Re.LV||ne===Re.V)&&(ge===Re.V||ge===Re.T)||(ne===Re.LVT||ne===Re.T)&&ge===Re.T||ge===Re.Extend||ge===Re.ZWJ||ge===Re.SpacingMark||ne===Re.Prepend||ne===Re.ZWJ&&ge===Re.Extended_Pictographic||ne===Re.Regional_Indicator&&ge===Re.Regional_Indicator)}var Re;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Re||(e.GraphemeBreakType=Re={}));class We{static{this.c=null}static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Ke()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?Re.LF:ge===r.CharCode.CarriageReturn?Re.CR:Re.Control;if(ge<127)return Re.Other;const we=this.d,Ee=we.length/3;let Me=1;for(;Me<=Ee;)if(ge<we[3*Me])Me=2*Me;else if(ge>we[3*Me+1])Me=2*Me+1;else return we[3*Me+2];return Re.Other}}function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(ne,ge){if(ne===0)return 0;const we=qe(ne,ge);if(we!==void 0)return we;const Ee=new z(ge,ne);return Ee.prevCodePoint(),Ee.offset}function qe(ne,ge){const we=new z(ge,ne);let Ee=we.prevCodePoint();for(;Xe(Ee)||Ee===Ye.emojiVariantSelector||Ee===Ye.enclosingKeyCap;){if(we.offset===0)return;Ee=we.prevCodePoint()}if(!_(Ee))return;let Me=we.offset;return Me>0&&we.prevCodePoint()===Ye.zwj&&(Me=we.offset),Me}function Xe(ne){return 127995<=ne&&ne<=127999}var Ye;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$gg="\xA0";class Je{static{this.c=new v.$Y(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$df({getCacheKey:JSON.stringify},ge=>{function we(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function Ee(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function Me(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Be=this.c.value;let _e=ge.filter(tt=>!tt.startsWith("_")&&tt in Be);_e.length===0&&(_e=["_default"]);let lt;for(const tt of _e){const ut=we(Be[tt]);lt=Me(lt,ut)}const rt=we(Be._common),at=Ee(rt,lt);return new Je(at)})}static getInstance(ge){return Je.d.get(Array.from(ge))}static{this.e=new v.$Y(()=>Object.keys(Je.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Je.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let we=0;we<ge.length;we++){const Ee=ge.codePointAt(we);if(typeof Ee=="number"&&this.isAmbiguous(Ee))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hg=Je;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(ge){return Ce.e().has(ge)}static containsInvisibleCharacter(ge){for(let we=0;we<ge.length;we++){const Ee=ge.codePointAt(we);if(typeof Ee=="number"&&Ce.isInvisibleCharacter(Ee))return!0}return!1}static get codePoints(){return Ce.e()}}e.$ig=Ce}),define(le[48],ue([0,1,25]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Cj=void 0,e.$yj=r,e.$zj=v,e.$Aj=D,e.$Bj=I,e.$Dj=f,i=Ie(i);function r(E){return v(E,0)}function v(E,g){switch(typeof E){case"object":return E===null?D(349,g):Array.isArray(E)?b(E,g):l(E,g);case"string":return I(E,g);case"boolean":return O(E,g);case"number":return D(E,g);case"undefined":return D(937,g);default:return D(617,g)}}function D(E,g){return(g<<5)-g+E|0}function O(E,g){return D(E?433:863,g)}function I(E,g){g=D(149417,g);for(let S=0,k=E.length;S<k;S++)g=D(E.charCodeAt(S),g);return g}function b(E,g){return g=D(104579,g),E.reduce((S,k)=>v(k,S),g)}function l(E,g){return g=D(181387,g),Object.keys(E).sort().reduce((S,k)=>(S=I(k,S),v(E[k],S)),g)}class m{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=v(g,this.g),this.g}}e.$Cj=m;var u;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function $(E,g,S=32){const k=S-g,s=~((1<<k)-1);return(E<<g|(s&E)>>>k)>>>0}function p(E,g=0,S=E.byteLength,k=0){for(let s=0;s<S;s++)E[g+s]=k}function d(E,g,S="0"){for(;E.length<g;)E=S+E;return E}function f(E,g=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(S=>S.toString(16).padStart(2,"0")).join(""):d((E>>>0).toString(16),g/4)}class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(u.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const S=g.length;if(S===0)return;const k=this.p;let s=this.r,a=this.u,t,o;for(a!==0?(t=a,o=-1,a=0):(t=g.charCodeAt(0),o=0);;){let n=t;if(i.$Of(t))if(o+1<S){const c=g.charCodeAt(o+1);i.$Pf(c)?(o++,n=i.$Qf(t,c)):n=u.UNICODE_REPLACEMENT}else{a=t;break}else i.$Pf(t)&&(n=u.UNICODE_REPLACEMENT);if(s=this.w(k,s,n),o++,o<S)t=g.charCodeAt(o);else break}this.r=s,this.u=a}w(g,S,k){return k<128?g[S++]=k:k<2048?(g[S++]=192|(k&1984)>>>6,g[S++]=128|(k&63)>>>0):k<65536?(g[S++]=224|(k&61440)>>>12,g[S++]=128|(k&4032)>>>6,g[S++]=128|(k&63)>>>0):(g[S++]=240|(k&1835008)>>>18,g[S++]=128|(k&258048)>>>12,g[S++]=128|(k&4032)>>>6,g[S++]=128|(k&63)>>>0),S>=u.BLOCK_SIZE&&(this.y(),S-=u.BLOCK_SIZE,this.t+=u.BLOCK_SIZE,g[0]=g[u.BLOCK_SIZE+0],g[1]=g[u.BLOCK_SIZE+1],g[2]=g[u.BLOCK_SIZE+2]),S}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,u.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=y.g,S=this.q;for(let P=0;P<64;P+=4)g.setUint32(P,S.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)g.setUint32(P,$(g.getUint32(P-12,!1)^g.getUint32(P-32,!1)^g.getUint32(P-56,!1)^g.getUint32(P-64,!1),1),!1);let k=this.h,s=this.l,a=this.m,t=this.n,o=this.o,n,c,h;for(let P=0;P<80;P++)P<20?(n=s&a|~s&t,c=1518500249):P<40?(n=s^a^t,c=1859775393):P<60?(n=s&a|s&t|a&t,c=2400959708):(n=s^a^t,c=3395469782),h=$(k,5)+n+o+c+g.getUint32(P*4,!1)&4294967295,o=t,t=a,a=$(s,30),s=k,k=h;this.h=this.h+k&4294967295,this.l=this.l+s&4294967295,this.m=this.m+a&4294967295,this.n=this.n+t&4294967295,this.o=this.o+o&4294967295}}e.$Ej=y}),define(le[81],ue([0,1,25]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i=Ie(i);var r;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(r||(r={})),function(v){const D="error",O="warning",I="warn",b="info",l="ignore";function m($){return $?i.$Kf(D,$)?v.Error:i.$Kf(O,$)||i.$Kf(I,$)?v.Warning:i.$Kf(b,$)?v.Info:v.Ignore:v.Ignore}v.fromValue=m;function u($){switch($){case v.Error:return D;case v.Warning:return O;case v.Info:return b;default:return l}}v.toString=u}(r||(r={})),e.default=r}),define(le[61],ue([0,1,21,39,25]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class D{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const f=d.charCodeAt(0),y=this.b.charCodeAt(this.c);return f-y}value(){return this.b[this.c]}}e.$Mi=D;class O{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,v.$Ef)(d,this.b,0,d.length,this.c,this.d):(0,v.$Gf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ni=O;class I{constructor(d=!0,f=!0){this.f=d,this.g=f}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let f=d.length-1;f>=0;f--,this.c--){const y=this.b.charCodeAt(f);if(!(y===r.CharCode.Slash||this.f&&y===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===r.CharCode.Slash||this.f&&f===r.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,v.$Ef)(d,this.b,0,d.length,this.d,this.e):(0,v.$Gf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Oi=I;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class l{constructor(d,f){this.f=d,this.g=f,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(b.Scheme),this.c.authority&&this.d.push(b.Authority),this.c.path&&(this.b=new I(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(b.Path)),this.g(d)||(this.c.query&&this.d.push(b.Query),this.c.fragment&&this.d.push(b.Fragment)),this.e=0,this}next(){return this.d[this.e]===b.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===b.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===b.Scheme)return(0,v.$Ff)(d,this.c.scheme);if(this.d[this.e]===b.Authority)return(0,v.$Ff)(d,this.c.authority);if(this.d[this.e]===b.Path)return this.b.cmp(d);if(this.d[this.e]===b.Query)return(0,v.$Df)(d,this.c.query);if(this.d[this.e]===b.Fragment)return(0,v.$Df)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===b.Scheme)return this.c.scheme;if(this.d[this.e]===b.Authority)return this.c.authority;if(this.d[this.e]===b.Path)return this.b.value();if(this.d[this.e]===b.Query)return this.c.query;if(this.d[this.e]===b.Fragment)return this.c.fragment;throw new Error}}e.$Pi=l;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(u||(u={}));class ${static forUris(d=()=>!1,f=()=>!1){return new $(new l(d,f))}static forPaths(d=!1){return new $(new I(void 0,!d))}static forStrings(){return new $(new D)}static forConfigKeys(){return new $(new O)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,f){if(f){const y=f.slice(0);(0,i.$1b)(y);for(const E of y)this.set(E,d)}else{const y=d.slice(0);(0,i.$1b)(y);for(const E of y)this.set(E[0],E[1])}}set(d,f){const y=this.b.reset(d);let E;this.c||(this.c=new m,this.c.segment=y.value());const g=[];for(E=this.c;;){const k=y.cmp(E.segment);if(k>0)E.left||(E.left=new m,E.left.segment=y.value()),g.push([u.Left,E]),E=E.left;else if(k<0)E.right||(E.right=new m,E.right.segment=y.value()),g.push([u.Right,E]),E=E.right;else if(y.hasNext())y.next(),E.mid||(E.mid=new m,E.mid.segment=y.value()),g.push([u.Mid,E]),E=E.mid;else break}const S=E.value;E.value=f,E.key=d;for(let k=g.length-1;k>=0;k--){const s=g[k][1];s.updateHeight();const a=s.balanceFactor();if(a<-1||a>1){const t=g[k][0],o=g[k+1][0];if(t===u.Right&&o===u.Right)g[k][1]=s.rotateLeft();else if(t===u.Left&&o===u.Left)g[k][1]=s.rotateRight();else if(t===u.Right&&o===u.Left)s.right=g[k+1][1]=g[k+1][1].rotateRight(),g[k][1]=s.rotateLeft();else if(t===u.Left&&o===u.Right)s.left=g[k+1][1]=g[k+1][1].rotateLeft(),g[k][1]=s.rotateRight();else throw new Error;if(k>0)switch(g[k-1][0]){case u.Left:g[k-1][1].left=g[k][1];break;case u.Right:g[k-1][1].right=g[k][1];break;case u.Mid:g[k-1][1].mid=g[k][1];break}else this.c=g[0][1]}}return S}get(d){return this.d(d)?.value}d(d){const f=this.b.reset(d);let y=this.c;for(;y;){const E=f.cmp(y.segment);if(E>0)y=y.left;else if(E<0)y=y.right;else if(f.hasNext())f.next(),y=y.mid;else break}return y}has(d){const f=this.d(d);return!(f?.value===void 0&&f?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,f){const y=this.b.reset(d),E=[];let g=this.c;for(;g;){const S=y.cmp(g.segment);if(S>0)E.push([u.Left,g]),g=g.left;else if(S<0)E.push([u.Right,g]),g=g.right;else if(y.hasNext())y.next(),E.push([u.Mid,g]),g=g.mid;else break}if(g){if(f?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const S=this.f(g.right);if(S.key){const{key:k,value:s,segment:a}=S;this.e(S.key,!1),g.key=k,g.value=s,g.segment=a}}else{const S=g.left??g.right;if(E.length>0){const[k,s]=E[E.length-1];switch(k){case u.Left:s.left=S;break;case u.Mid:s.mid=S;break;case u.Right:s.right=S;break}}else this.c=S}for(let S=E.length-1;S>=0;S--){const k=E[S][1];k.updateHeight();const s=k.balanceFactor();if(s>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),E[S][1]=k.rotateLeft()):s<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),E[S][1]=k.rotateRight()),S>0)switch(E[S-1][0]){case u.Left:E[S-1][1].left=E[S][1];break;case u.Right:E[S-1][1].right=E[S][1];break;case u.Mid:E[S-1][1].mid=E[S][1];break}else this.c=E[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const f=this.b.reset(d);let y=this.c,E;for(;y;){const g=f.cmp(y.segment);if(g>0)y=y.left;else if(g<0)y=y.right;else if(f.hasNext())f.next(),E=y.value||E,y=y.mid;else break}return y&&y.value||E}findSuperstr(d){return this.g(d,!1)}g(d,f){const y=this.b.reset(d);let E=this.c;for(;E;){const g=y.cmp(E.segment);if(g>0)E=E.left;else if(g<0)E=E.right;else if(y.hasNext())y.next(),E=E.mid;else return E.mid?this.h(E.mid):f?E.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[f,y]of this)d(y,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const f=[];return this.j(d,f),f[Symbol.iterator]()}j(d,f){d&&(d.left&&this.j(d.left,f),d.value&&f.push([d.key,d.value]),d.mid&&this.j(d.mid,f),d.right&&this.j(d.right,f))}_isBalanced(){const d=f=>{if(!f)return!0;const y=f.balanceFactor();return y<-1||y>1?!1:d(f.left)&&d(f.right)};return d(this.c)}}e.$Qi=$}),define(le[33],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=void 0,e.$6g=r;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(v){return i.test(v)}e.$7g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(I){for(let b=0;b<I.length;b++)I[b]=Math.floor(Math.random()*256);return I};const D=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){v(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let b=0,l="";return l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l+="-",l+=O[D[b++]],l+=O[D[b++]],l+="-",l+=O[D[b++]],l+=O[D[b++]],l+="-",l+=O[D[b++]],l+=O[D[b++]],l+="-",l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l+=O[D[b++]],l}}()}),define(le[153],ue([0,1,93,26,91]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iY=D,i=Ie(i),r=Ie(r);async function D(O,I){if(await new Promise((m,u)=>{const $=r.createReadStream(O),p=i.createHash("sha256");$.pipe(p);const d=(0,v.$hb)((f,y)=>{$.removeAllListeners(),p.removeAllListeners(),f?u(f):m(y)});$.once("error",d),$.once("end",d),p.once("error",d),p.once("data",f=>d(void 0,f.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(le[154],ue([0,1,27]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=D;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(O){const I=O.replace(/\-/g,":").toLowerCase();return!r.has(I)}function D(){const O=(0,i.networkInterfaces)();for(const I in O){const b=O[I];if(b){for(const{mac:l}of b)if(v(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[114],ue([0,1,94]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=void 0,e.$9g=r,e.$$g=D,i=Ie(i);function r(I,b,l,m=1){let u=!1;return new Promise($=>{const p=setTimeout(()=>{if(!u)return u=!0,$(0)},l);v(I,b,m,d=>{if(!u)return u=!0,clearTimeout(p),$(d)})})}function v(I,b,l,m){if(b===0)return m(0);const u=new i.Socket;u.once("connect",()=>(O(u),v(I+l,b-1,l,m))),u.once("data",()=>{}),u.once("error",$=>(O(u),$.code!=="ECONNREFUSED"?v(I+l,b-1,l,m):m(I))),u.connect(I,"127.0.0.1")}e.$0g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(I,b,l,m="127.0.0.1"){let u=!1,$,p=1;const d=i.createServer({pauseOnConnect:!0});function f(y,E){u||(u=!0,d.removeAllListeners(),d.close(),$&&clearTimeout($),E(y))}return new Promise(y=>{$=setTimeout(()=>{f(0,y)},l),d.on("listening",()=>{f(I,y)}),d.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&p<b?(I++,p++,d.listen(I,m)):f(0,y)}),d.on("close",()=>{f(0,y)}),d.listen(I,m)})}function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(b){console.error(b)}}}),function(){function G(){function e(){return process.uncHostAllowlist}function i(b){const l=new Set;if(Array.isArray(b))for(const m of b)typeof m=="string"&&l.add(m);return Array.from(l)}function r(){const b=e();return b?Array.from(b):[]}function v(b){if(process.platform!=="win32")return;const l=e();if(l)if(typeof b=="string")l.add(b.toLowerCase());else for(const m of i(b))v(m)}function D(b){if(typeof b!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const u of l){if(b.indexOf(u)!==0)continue;const p=b.indexOf("\\",u.length);if(p===-1)continue;const d=b.substring(u.length,p);if(d){m=d;break}}return m}function O(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:v,getUNCHost:D,disableUNCAccessRestrictions:O,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return G()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=G():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[155],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oY=e.$nY=void 0,e.$nY="vscode:contextmenu",e.$oY="vscode:onCloseContextMenu"}),define(le[156],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vY=void 0;class i{constructor(v,D){this.a=v,this.onMessage=D}send(v){try{this.a.send("vscode:message",v.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$vY=i}),define(le[115],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a=i,e.$b=r;function i(){return globalThis._VSCODE_NLS_MESSAGES}function r(){return globalThis._VSCODE_NLS_LANGUAGE}}),define(le[9],ue([0,1,115,115]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNLSMessages=e.getNLSLanguage=void 0,e.localize=O,e.localize2=b,Object.defineProperty(e,"getNLSLanguage",{enumerable:!0,get:function(){return r.$b}}),Object.defineProperty(e,"getNLSMessages",{enumerable:!0,get:function(){return r.$a}});const v=(0,i.$b)()==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function D(l,m){let u;return m.length===0?u=l:u=l.replace(/\{(\d+)\}/g,($,p)=>{const d=p[0],f=m[d];let y=$;return typeof f=="string"?y=f:(typeof f=="number"||typeof f=="boolean"||f===void 0||f===null)&&(y=String(f)),y}),v&&(u="\uFF3B"+u.replace(/[aouei]/g,"$&$&")+"\uFF3D"),u}function O(l,m,...u){return D(typeof l=="number"?I(l,m):m,u)}function I(l,m){const u=(0,i.$a)()?.[l];if(typeof u!="string"){if(typeof m=="string")return m;throw new Error(`!!! NLS MISSING: ${l} !!!`)}return u}function b(l,m,...u){let $;typeof l=="number"?$=I(l,m):$=m;const p=D($,u);return{value:p,original:m===$?p:D(m,u)}}}),define(le[157],ue([0,1,9]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=l,e.$8m=m,e.$9m=u,e.$0m=$;const r=60,v=r*60,D=v*24,O=D*7,I=D*30,b=D*365;function l(p,d,f,y){typeof p!="number"&&(p=p.getTime());const E=Math.round((new Date().getTime()-p)/1e3);if(E<-30)return(0,i.localize)(42,null,l(new Date().getTime()+E*1e3,!1));if(!y&&E<30)return(0,i.localize)(43,null);let g;return E<r?(g=E,d?g===1?f?(0,i.localize)(44,null,g):(0,i.localize)(45,null,g):f?(0,i.localize)(46,null,g):(0,i.localize)(47,null,g):g===1?f?(0,i.localize)(48,null,g):(0,i.localize)(49,null,g):f?(0,i.localize)(50,null,g):(0,i.localize)(51,null,g)):E<v?(g=Math.floor(E/r),d?g===1?f?(0,i.localize)(52,null,g):(0,i.localize)(53,null,g):f?(0,i.localize)(54,null,g):(0,i.localize)(55,null,g):g===1?f?(0,i.localize)(56,null,g):(0,i.localize)(57,null,g):f?(0,i.localize)(58,null,g):(0,i.localize)(59,null,g)):E<D?(g=Math.floor(E/v),d?g===1?f?(0,i.localize)(60,null,g):(0,i.localize)(61,null,g):f?(0,i.localize)(62,null,g):(0,i.localize)(63,null,g):g===1?f?(0,i.localize)(64,null,g):(0,i.localize)(65,null,g):f?(0,i.localize)(66,null,g):(0,i.localize)(67,null,g)):E<O?(g=Math.floor(E/D),d?g===1?(0,i.localize)(68,null,g):(0,i.localize)(69,null,g):g===1?(0,i.localize)(70,null,g):(0,i.localize)(71,null,g)):E<I?(g=Math.floor(E/O),d?g===1?f?(0,i.localize)(72,null,g):(0,i.localize)(73,null,g):f?(0,i.localize)(74,null,g):(0,i.localize)(75,null,g):g===1?f?(0,i.localize)(76,null,g):(0,i.localize)(77,null,g):f?(0,i.localize)(78,null,g):(0,i.localize)(79,null,g)):E<b?(g=Math.floor(E/I),d?g===1?f?(0,i.localize)(80,null,g):(0,i.localize)(81,null,g):f?(0,i.localize)(82,null,g):(0,i.localize)(83,null,g):g===1?f?(0,i.localize)(84,null,g):(0,i.localize)(85,null,g):f?(0,i.localize)(86,null,g):(0,i.localize)(87,null,g)):(g=Math.floor(E/b),d?g===1?f?(0,i.localize)(88,null,g):(0,i.localize)(89,null,g):f?(0,i.localize)(90,null,g):(0,i.localize)(91,null,g):g===1?f?(0,i.localize)(92,null,g):(0,i.localize)(93,null,g):f?(0,i.localize)(94,null,g):(0,i.localize)(95,null,g))}function m(p,d,f){typeof p!="number"&&(p=p.getTime());const y=new Date;y.setHours(0,0,0,0);const E=new Date(y.getTime());return E.setDate(E.getDate()-1),p>y.getTime()?(0,i.localize)(96,null):p>E.getTime()?(0,i.localize)(97,null):l(p,d,f)}function u(p,d){const f=Math.abs(p/1e3);return f<1?d?(0,i.localize)(98,null,p):(0,i.localize)(99,null,p):f<r?d?(0,i.localize)(100,null,Math.round(p)/1e3):(0,i.localize)(101,null,Math.round(p)/1e3):f<v?d?(0,i.localize)(102,null,Math.round(p/(1e3*r))):(0,i.localize)(103,null,Math.round(p/(1e3*r))):f<D?d?(0,i.localize)(104,null,Math.round(p/(1e3*v))):(0,i.localize)(105,null,Math.round(p/(1e3*v))):(0,i.localize)(106,null,Math.round(p/(1e3*D)))}function $(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[55],ue([0,1,21,12,9]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=b,e.$wj=l,e.$xj=m,i=Ie(i),r=Ie(r),v=Ie(v);function D(u,$){return $&&(u.stack||u.stacktrace)?v.localize(107,null,I(u),O(u.stack)||O(u.stacktrace)):I(u)}function O(u){return Array.isArray(u)?u.join(`
`):u}function I(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?v.localize(108,null,u.message):u.message||v.localize(109,null)}function b(u=null,$=!1){if(!u)return v.localize(110,null);if(Array.isArray(u)){const p=i.$Lb(u),d=b(p[0],$);return p.length>1?v.localize(111,null,d,p.length):d}if(r.$jg(u))return u;if(u.detail){const p=u.detail;if(p.error)return D(p.error,$);if(p.exception)return D(p.exception,$)}return u.stack?D(u,$):u.message?u.message:v.localize(112,null)}function l(u){const $=u;return $ instanceof Error&&Array.isArray($.actions)}function m(u,$){let p;return typeof u=="string"?p=new Error(u):p=u,p.actions=$,p}}),define(le[158],ue([0,1,9,43]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=v;function v(D){switch(D){case r.ParseErrorCode.InvalidSymbol:return(0,i.localize)(113,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,i.localize)(114,null);case r.ParseErrorCode.PropertyNameExpected:return(0,i.localize)(115,null);case r.ParseErrorCode.ValueExpected:return(0,i.localize)(116,null);case r.ParseErrorCode.ColonExpected:return(0,i.localize)(117,null);case r.ParseErrorCode.CommaExpected:return(0,i.localize)(118,null);case r.ParseErrorCode.CloseBraceExpected:return(0,i.localize)(119,null);case r.ParseErrorCode.CloseBracketExpected:return(0,i.localize)(120,null);case r.ParseErrorCode.EndOfFileExpected:return(0,i.localize)(121,null);default:return""}}}),define(le[3],ue([0,1,9]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=e.$H=e.OS=e.OperatingSystem=e.$E=e.$D=e.$C=e.$B=e.$A=e.Language=e.$z=e.$y=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.Platform=e.$j=void 0,e.$k=t,e.$G=w,e.$M=R,i=Ie(i),e.$j="en";let r=!1,v=!1,D=!1,O=!1,I=!1,b=!1,l=!1,m=!1,u=!1,$=!1,p,d=e.$j,f=e.$j,y,E;const g=globalThis;let S;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?S=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(S=process);const k=typeof S?.versions?.electron=="string",s=k&&S?.type==="renderer";if(typeof S=="object"){r=S.platform==="win32",v=S.platform==="darwin",D=S.platform==="linux",O=D&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,l=k,u=!!S.env.CI||!!S.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.$j,d=e.$j;const T=S.env.VSCODE_NLS_CONFIG;if(T)try{const A=JSON.parse(T);p=A.userLocale,f=A.osLocale,d=A.resolvedLanguage||e.$j,y=A.languagePack?.translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!s?(E=navigator.userAgent,r=E.indexOf("Windows")>=0,v=E.indexOf("Macintosh")>=0,m=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=E.indexOf("Linux")>=0,$=E?.indexOf("Mobi")>=0,b=!0,d=i.getNLSLanguage()||e.$j,p=navigator.language.toLowerCase(),f=p):console.error("Unable to resolve platform.");var a;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(a||(e.Platform=a={}));function t(T){switch(T){case a.Web:return"Web";case a.Mac:return"Mac";case a.Linux:return"Linux";case a.Windows:return"Windows"}}let o=a.Web;v?o=a.Mac:r?o=a.Windows:D&&(o=a.Linux),e.$l=r,e.$m=v,e.$n=D,e.$o=O,e.$p=I,e.$q=l,e.$r=b,e.$s=b&&typeof g.importScripts=="function",e.$t=e.$s?g.origin:void 0,e.$u=m,e.$v=$,e.$w=u,e.$x=o,e.$y=E,e.$z=d;var n;(function(T){function A(){return e.$z}T.value=A;function L(){return e.$z.length===2?e.$z==="en":e.$z.length>=3?e.$z[0]==="e"&&e.$z[1]==="n"&&e.$z[2]==="-":!1}T.isDefaultVariant=L;function M(){return e.$z==="en"}T.isDefault=M})(n||(e.Language=n={})),e.$A=p,e.$B=f,e.$C=y,e.$D=typeof g.postMessage=="function"&&!g.importScripts,e.$E=(()=>{if(e.$D){const T=[];g.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let M=0,V=T.length;M<V;M++){const q=T[M];if(q.id===L.data.vscodeScheduleAsyncWork){T.splice(M,1),q.callback();return}}});let A=0;return L=>{const M=++A;T.push({id:M,callback:L}),g.postMessage({vscodeScheduleAsyncWork:M},"*")}}return T=>setTimeout(T)})();var c;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=v||m?c.Macintosh:r?c.Windows:c.Linux;let h=!0,P=!1;function w(){if(!P){P=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,h=new Uint16Array(T.buffer)[0]===513}return h}e.$H=!!(e.$y&&e.$y.indexOf("Chrome")>=0),e.$I=!!(e.$y&&e.$y.indexOf("Firefox")>=0),e.$J=!!(!e.$H&&e.$y&&e.$y.indexOf("Safari")>=0),e.$K=!!(e.$y&&e.$y.indexOf("Edg/")>=0),e.$L=!!(e.$y&&e.$y.indexOf("Android")>=0);function R(T){return parseFloat(T)>=20}}),define(le[38],ue([0,1,3]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jc=e.$ic=e.env=e.cwd=void 0;let r;const v=globalThis.vscode;if(typeof v<"u"&&typeof v.process<"u"){const D=v.process;r={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"&&typeof process?.versions?.node=="string"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return i.$l?"win32":i.$m?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$ic=r.platform,e.$jc=r.arch}),define(le[10],ue([0,1,38]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.sep=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=void 0,i=Ie(i);const r=65,v=97,D=90,O=122,I=46,b=47,l=92,m=58,u=63;class $ extends Error{constructor(o,n,c){let h;typeof n=="string"&&n.indexOf("not ")===0?(h="must not be",n=n.replace(/^not /,"")):h="must be";const P=o.indexOf(".")!==-1?"property":"argument";let w=`The "${o}" ${P} ${h} of type ${n}`;w+=`. Received type ${typeof c}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function p(t,o){if(t===null||typeof t!="object")throw new $(o,"Object",t)}function d(t,o){if(typeof t!="string")throw new $(o,"string",t)}const f=i.$ic==="win32";function y(t){return t===b||t===l}function E(t){return t===b}function g(t){return t>=r&&t<=D||t>=v&&t<=O}function S(t,o,n,c){let h="",P=0,w=-1,R=0,T=0;for(let A=0;A<=t.length;++A){if(A<t.length)T=t.charCodeAt(A);else{if(c(T))break;T=b}if(c(T)){if(!(w===A-1||R===1))if(R===2){if(h.length<2||P!==2||h.charCodeAt(h.length-1)!==I||h.charCodeAt(h.length-2)!==I){if(h.length>2){const L=h.lastIndexOf(n);L===-1?(h="",P=0):(h=h.slice(0,L),P=h.length-1-h.lastIndexOf(n)),w=A,R=0;continue}else if(h.length!==0){h="",P=0,w=A,R=0;continue}}o&&(h+=h.length>0?`${n}..`:"..",P=2)}else h.length>0?h+=`${n}${t.slice(w+1,A)}`:h=t.slice(w+1,A),P=A-w-1;w=A,R=0}else T===I&&R!==-1?++R:R=-1}return h}function k(t){return t?`${t[0]==="."?"":"."}${t}`:""}function s(t,o){p(o,"pathObject");const n=o.dir||o.root,c=o.base||`${o.name||""}${k(o.ext)}`;return n?n===o.root?`${n}${c}`:`${n}${t}${c}`:c}e.$kc={resolve(...t){let o="",n="",c=!1;for(let h=t.length-1;h>=-1;h--){let P;if(h>=0){if(P=t[h],d(P,`paths[${h}]`),P.length===0)continue}else o.length===0?P=i.cwd():(P=i.env[`=${o}`]||i.cwd(),(P===void 0||P.slice(0,2).toLowerCase()!==o.toLowerCase()&&P.charCodeAt(2)===l)&&(P=`${o}\\`));const w=P.length;let R=0,T="",A=!1;const L=P.charCodeAt(0);if(w===1)y(L)&&(R=1,A=!0);else if(y(L))if(A=!0,y(P.charCodeAt(1))){let M=2,V=M;for(;M<w&&!y(P.charCodeAt(M));)M++;if(M<w&&M!==V){const q=P.slice(V,M);for(V=M;M<w&&y(P.charCodeAt(M));)M++;if(M<w&&M!==V){for(V=M;M<w&&!y(P.charCodeAt(M));)M++;(M===w||M!==V)&&(T=`\\\\${q}\\${P.slice(V,M)}`,R=M)}}}else R=1;else g(L)&&P.charCodeAt(1)===m&&(T=P.slice(0,2),R=2,w>2&&y(P.charCodeAt(2))&&(A=!0,R=3));if(T.length>0)if(o.length>0){if(T.toLowerCase()!==o.toLowerCase())continue}else o=T;if(c){if(o.length>0)break}else if(n=`${P.slice(R)}\\${n}`,c=A,A&&o.length>0)break}return n=S(n,!c,"\\",y),c?`${o}\\${n}`:`${o}${n}`||"."},normalize(t){d(t,"path");const o=t.length;if(o===0)return".";let n=0,c,h=!1;const P=t.charCodeAt(0);if(o===1)return E(P)?"\\":t;if(y(P))if(h=!0,y(t.charCodeAt(1))){let R=2,T=R;for(;R<o&&!y(t.charCodeAt(R));)R++;if(R<o&&R!==T){const A=t.slice(T,R);for(T=R;R<o&&y(t.charCodeAt(R));)R++;if(R<o&&R!==T){for(T=R;R<o&&!y(t.charCodeAt(R));)R++;if(R===o)return`\\\\${A}\\${t.slice(T)}\\`;R!==T&&(c=`\\\\${A}\\${t.slice(T,R)}`,n=R)}}}else n=1;else g(P)&&t.charCodeAt(1)===m&&(c=t.slice(0,2),n=2,o>2&&y(t.charCodeAt(2))&&(h=!0,n=3));let w=n<o?S(t.slice(n),!h,"\\",y):"";return w.length===0&&!h&&(w="."),w.length>0&&y(t.charCodeAt(o-1))&&(w+="\\"),c===void 0?h?`\\${w}`:w:h?`${c}\\${w}`:`${c}${w}`},isAbsolute(t){d(t,"path");const o=t.length;if(o===0)return!1;const n=t.charCodeAt(0);return y(n)||o>2&&g(n)&&t.charCodeAt(1)===m&&y(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,n;for(let P=0;P<t.length;++P){const w=t[P];d(w,"path"),w.length>0&&(o===void 0?o=n=w:o+=`\\${w}`)}if(o===void 0)return".";let c=!0,h=0;if(typeof n=="string"&&y(n.charCodeAt(0))){++h;const P=n.length;P>1&&y(n.charCodeAt(1))&&(++h,P>2&&(y(n.charCodeAt(2))?++h:c=!1))}if(c){for(;h<o.length&&y(o.charCodeAt(h));)h++;h>=2&&(o=`\\${o.slice(h)}`)}return e.$kc.normalize(o)},relative(t,o){if(d(t,"from"),d(o,"to"),t===o)return"";const n=e.$kc.resolve(t),c=e.$kc.resolve(o);if(n===c||(t=n.toLowerCase(),o=c.toLowerCase(),t===o))return"";let h=0;for(;h<t.length&&t.charCodeAt(h)===l;)h++;let P=t.length;for(;P-1>h&&t.charCodeAt(P-1)===l;)P--;const w=P-h;let R=0;for(;R<o.length&&o.charCodeAt(R)===l;)R++;let T=o.length;for(;T-1>R&&o.charCodeAt(T-1)===l;)T--;const A=T-R,L=w<A?w:A;let M=-1,V=0;for(;V<L;V++){const Y=t.charCodeAt(h+V);if(Y!==o.charCodeAt(R+V))break;Y===l&&(M=V)}if(V!==L){if(M===-1)return c}else{if(A>L){if(o.charCodeAt(R+V)===l)return c.slice(R+V+1);if(V===2)return c.slice(R+V)}w>L&&(t.charCodeAt(h+V)===l?M=V:V===2&&(M=3)),M===-1&&(M=0)}let q="";for(V=h+M+1;V<=P;++V)(V===P||t.charCodeAt(V)===l)&&(q+=q.length===0?"..":"\\..");return R+=M,q.length>0?`${q}${c.slice(R,T)}`:(c.charCodeAt(R)===l&&++R,c.slice(R,T))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$kc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===l){if(o.charCodeAt(1)===l){const n=o.charCodeAt(2);if(n!==u&&n!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===m&&o.charCodeAt(2)===l)return`\\\\?\\${o}`;return t},dirname(t){d(t,"path");const o=t.length;if(o===0)return".";let n=-1,c=0;const h=t.charCodeAt(0);if(o===1)return y(h)?t:".";if(y(h)){if(n=c=1,y(t.charCodeAt(1))){let R=2,T=R;for(;R<o&&!y(t.charCodeAt(R));)R++;if(R<o&&R!==T){for(T=R;R<o&&y(t.charCodeAt(R));)R++;if(R<o&&R!==T){for(T=R;R<o&&!y(t.charCodeAt(R));)R++;if(R===o)return t;R!==T&&(n=c=R+1)}}}}else g(h)&&t.charCodeAt(1)===m&&(n=o>2&&y(t.charCodeAt(2))?3:2,c=n);let P=-1,w=!0;for(let R=o-1;R>=c;--R)if(y(t.charCodeAt(R))){if(!w){P=R;break}}else w=!1;if(P===-1){if(n===-1)return".";P=n}return t.slice(0,P)},basename(t,o){o!==void 0&&d(o,"suffix"),d(t,"path");let n=0,c=-1,h=!0,P;if(t.length>=2&&g(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(n=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,R=-1;for(P=t.length-1;P>=n;--P){const T=t.charCodeAt(P);if(y(T)){if(!h){n=P+1;break}}else R===-1&&(h=!1,R=P+1),w>=0&&(T===o.charCodeAt(w)?--w===-1&&(c=P):(w=-1,c=R))}return n===c?c=R:c===-1&&(c=t.length),t.slice(n,c)}for(P=t.length-1;P>=n;--P)if(y(t.charCodeAt(P))){if(!h){n=P+1;break}}else c===-1&&(h=!1,c=P+1);return c===-1?"":t.slice(n,c)},extname(t){d(t,"path");let o=0,n=-1,c=0,h=-1,P=!0,w=0;t.length>=2&&t.charCodeAt(1)===m&&g(t.charCodeAt(0))&&(o=c=2);for(let R=t.length-1;R>=o;--R){const T=t.charCodeAt(R);if(y(T)){if(!P){c=R+1;break}continue}h===-1&&(P=!1,h=R+1),T===I?n===-1?n=R:w!==1&&(w=1):n!==-1&&(w=-1)}return n===-1||h===-1||w===0||w===1&&n===h-1&&n===c+1?"":t.slice(n,h)},format:s.bind(null,"\\"),parse(t){d(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.length;let c=0,h=t.charCodeAt(0);if(n===1)return y(h)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(y(h)){if(c=1,y(t.charCodeAt(1))){let M=2,V=M;for(;M<n&&!y(t.charCodeAt(M));)M++;if(M<n&&M!==V){for(V=M;M<n&&y(t.charCodeAt(M));)M++;if(M<n&&M!==V){for(V=M;M<n&&!y(t.charCodeAt(M));)M++;M===n?c=M:M!==V&&(c=M+1)}}}}else if(g(h)&&t.charCodeAt(1)===m){if(n<=2)return o.root=o.dir=t,o;if(c=2,y(t.charCodeAt(2))){if(n===3)return o.root=o.dir=t,o;c=3}}c>0&&(o.root=t.slice(0,c));let P=-1,w=c,R=-1,T=!0,A=t.length-1,L=0;for(;A>=c;--A){if(h=t.charCodeAt(A),y(h)){if(!T){w=A+1;break}continue}R===-1&&(T=!1,R=A+1),h===I?P===-1?P=A:L!==1&&(L=1):P!==-1&&(L=-1)}return R!==-1&&(P===-1||L===0||L===1&&P===R-1&&P===w+1?o.base=o.name=t.slice(w,R):(o.name=t.slice(w,P),o.base=t.slice(w,R),o.ext=t.slice(P,R))),w>0&&w!==c?o.dir=t.slice(0,w-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(f){const t=/\\/g;return()=>{const o=i.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>i.cwd()})();e.$lc={resolve(...t){let o="",n=!1;for(let c=t.length-1;c>=-1&&!n;c--){const h=c>=0?t[c]:a();d(h,`paths[${c}]`),h.length!==0&&(o=`${h}/${o}`,n=h.charCodeAt(0)===b)}return o=S(o,!n,"/",E),n?`/${o}`:o.length>0?o:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===b,n=t.charCodeAt(t.length-1)===b;return t=S(t,!o,"/",E),t.length===0?o?"/":n?"./":".":(n&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let o;for(let n=0;n<t.length;++n){const c=t[n];d(c,"path"),c.length>0&&(o===void 0?o=c:o+=`/${c}`)}return o===void 0?".":e.$lc.normalize(o)},relative(t,o){if(d(t,"from"),d(o,"to"),t===o||(t=e.$lc.resolve(t),o=e.$lc.resolve(o),t===o))return"";const n=1,c=t.length,h=c-n,P=1,w=o.length-P,R=h<w?h:w;let T=-1,A=0;for(;A<R;A++){const M=t.charCodeAt(n+A);if(M!==o.charCodeAt(P+A))break;M===b&&(T=A)}if(A===R)if(w>R){if(o.charCodeAt(P+A)===b)return o.slice(P+A+1);if(A===0)return o.slice(P+A)}else h>R&&(t.charCodeAt(n+A)===b?T=A:A===0&&(T=0));let L="";for(A=n+T+1;A<=c;++A)(A===c||t.charCodeAt(A)===b)&&(L+=L.length===0?"..":"/..");return`${L}${o.slice(P+T)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===b;let n=-1,c=!0;for(let h=t.length-1;h>=1;--h)if(t.charCodeAt(h)===b){if(!c){n=h;break}}else c=!1;return n===-1?o?"/":".":o&&n===1?"//":t.slice(0,n)},basename(t,o){o!==void 0&&d(o,"ext"),d(t,"path");let n=0,c=-1,h=!0,P;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,R=-1;for(P=t.length-1;P>=0;--P){const T=t.charCodeAt(P);if(T===b){if(!h){n=P+1;break}}else R===-1&&(h=!1,R=P+1),w>=0&&(T===o.charCodeAt(w)?--w===-1&&(c=P):(w=-1,c=R))}return n===c?c=R:c===-1&&(c=t.length),t.slice(n,c)}for(P=t.length-1;P>=0;--P)if(t.charCodeAt(P)===b){if(!h){n=P+1;break}}else c===-1&&(h=!1,c=P+1);return c===-1?"":t.slice(n,c)},extname(t){d(t,"path");let o=-1,n=0,c=-1,h=!0,P=0;for(let w=t.length-1;w>=0;--w){const R=t.charCodeAt(w);if(R===b){if(!h){n=w+1;break}continue}c===-1&&(h=!1,c=w+1),R===I?o===-1?o=w:P!==1&&(P=1):o!==-1&&(P=-1)}return o===-1||c===-1||P===0||P===1&&o===c-1&&o===n+1?"":t.slice(o,c)},format:s.bind(null,"/"),parse(t){d(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.charCodeAt(0)===b;let c;n?(o.root="/",c=1):c=0;let h=-1,P=0,w=-1,R=!0,T=t.length-1,A=0;for(;T>=c;--T){const L=t.charCodeAt(T);if(L===b){if(!R){P=T+1;break}continue}w===-1&&(R=!1,w=T+1),L===I?h===-1?h=T:A!==1&&(A=1):h!==-1&&(A=-1)}if(w!==-1){const L=P===0&&n?1:P;h===-1||A===0||A===1&&h===w-1&&h===P+1?o.base=o.name=t.slice(L,w):(o.name=t.slice(L,h),o.base=t.slice(L,w),o.ext=t.slice(h,w))}return P>0?o.dir=t.slice(0,P-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$lc.win32=e.$kc.win32=e.$kc,e.$lc.posix=e.$kc.posix=e.$lc,e.$mc=f?e.$kc.normalize:e.$lc.normalize,e.$nc=f?e.$kc.isAbsolute:e.$lc.isAbsolute,e.$oc=f?e.$kc.join:e.$lc.join,e.$pc=f?e.$kc.resolve:e.$lc.resolve,e.$qc=f?e.$kc.relative:e.$lc.relative,e.$rc=f?e.$kc.dirname:e.$lc.dirname,e.$sc=f?e.$kc.basename:e.$lc.basename,e.$tc=f?e.$kc.extname:e.$lc.extname,e.$uc=f?e.$kc.format:e.$lc.format,e.$vc=f?e.$kc.parse:e.$lc.parse,e.$wc=f?e.$kc.toNamespacedPath:e.$lc.toNamespacedPath,e.sep=f?e.$kc.sep:e.$lc.sep,e.$yc=f?e.$kc.delimiter:e.$lc.delimiter}),define(le[32],ue([0,1,39,10,3,25,12]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=I,e.$Dg=b,e.$Eg=l,e.$Fg=m,e.$Gg=u,e.$Hg=f,e.$Ig=y,e.$Jg=E,e.$Kg=g,e.$Lg=S,e.$Mg=k,e.$Ng=s,e.$Og=a,e.$Pg=t,e.$Qg=o,e.$Rg=n,e.$Sg=P;function I(w){return w===i.CharCode.Slash||w===i.CharCode.Backslash}function b(w){return w.replace(/[\\/]/g,r.$lc.sep)}function l(w){return w.indexOf("/")===-1&&(w=b(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function m(w,R=r.$lc.sep){if(!w)return"";const T=w.length,A=w.charCodeAt(0);if(I(A)){if(I(w.charCodeAt(1))&&!I(w.charCodeAt(2))){let M=3;const V=M;for(;M<T&&!I(w.charCodeAt(M));M++);if(V!==M&&!I(w.charCodeAt(M+1))){for(M+=1;M<T;M++)if(I(w.charCodeAt(M)))return w.slice(0,M+1).replace(/[\\/]/g,R)}}return R}else if(g(A)&&w.charCodeAt(1)===i.CharCode.Colon)return I(w.charCodeAt(2))?w.slice(0,2)+R:w.slice(0,2);let L=w.indexOf("://");if(L!==-1){for(L+=3;L<T;L++)if(I(w.charCodeAt(L)))return w.slice(0,L+1)}return""}function u(w){if(!v.$l||!w||w.length<5)return!1;let R=w.charCodeAt(0);if(R!==i.CharCode.Backslash||(R=w.charCodeAt(1),R!==i.CharCode.Backslash))return!1;let T=2;const A=T;for(;T<w.length&&(R=w.charCodeAt(T),R!==i.CharCode.Backslash);T++);return!(A===T||(R=w.charCodeAt(T+1),isNaN(R)||R===i.CharCode.Backslash))}const $=/[\\/:\*\?"<>\|]/g,p=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(w,R=v.$l){const T=R?$:p;return!(!w||w.length===0||/^\s+$/.test(w)||(T.lastIndex=0,T.test(w))||R&&d.test(w)||w==="."||w===".."||R&&w[w.length-1]==="."||R&&w.length!==w.trim().length||w.length>255)}function y(w,R,T){const A=w===R;return!T||A?A:!w||!R?!1:(0,D.$Kf)(w,R)}function E(w,R,T,A=r.sep){if(w===R)return!0;if(!w||!R||R.length>w.length)return!1;if(T){if(!(0,D.$Lf)(w,R))return!1;if(R.length===w.length)return!0;let M=R.length;return R.charAt(R.length-1)===A&&M--,w.charAt(M)===A}return R.charAt(R.length-1)!==A&&(R+=A),w.indexOf(R)===0}function g(w){return w>=i.CharCode.A&&w<=i.CharCode.Z||w>=i.CharCode.a&&w<=i.CharCode.z}function S(w,R){return v.$l&&w.endsWith(":")&&(w+=r.sep),(0,r.$nc)(w)||(w=(0,r.$oc)(R,w)),w=(0,r.$mc)(w),k(w)}function k(w){return v.$l?(w=(0,D.$sf)(w,r.sep),w.endsWith(":")&&(w+=r.sep)):(w=(0,D.$sf)(w,r.sep),w||(w=r.sep)),w}function s(w){const R=(0,r.$mc)(w);return v.$l?w.length>3?!1:a(R)&&(w.length===2||R.charCodeAt(2)===i.CharCode.Backslash):R===r.$lc.sep}function a(w,R=v.$l){return R?g(w.charCodeAt(0))&&w.charCodeAt(1)===i.CharCode.Colon:!1}function t(w,R=v.$l){return a(w,R)?w[0]:void 0}function o(w,R,T){return R.length>w.length?-1:w===R?0:(T&&(w=w.toLowerCase(),R=R.toLowerCase()),w.indexOf(R))}function n(w){const R=w.split(":");let T,A,L;for(const M of R){const V=Number(M);(0,O.$ng)(V)?A===void 0?A=V:L===void 0&&(L=V):T=T?[T,M].join(":"):M}if(!T)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:T,line:A!==void 0?A:void 0,column:L!==void 0?L:A!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function P(w,R,T=8){let A="";for(let M=0;M<T;M++){let V;M===0&&v.$l&&!R&&(T===3||T===4)?V=h:V=c,A+=V.charAt(Math.floor(Math.random()*V.length))}let L;return R?L=`${R}-${A}`:L=A,w?(0,r.$oc)(w,L):L}}),define(le[82],ue([0,1,3]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=D,e.$rm=O;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var v;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(v||(e.TerminateResponseCode=v={}));function D(I,...b){const l=b.reduce(($,p)=>($[p]=!0,$),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter($=>!l[$]).forEach($=>{for(let p=0;p<m.length;p++)if($.search(m[p])!==-1){delete I[$];break}})}function O(I){I&&(delete I.DEBUG,i.$n&&delete I.LD_PRELOAD)}}),define(le[7],ue([0,1,39,92,10,3]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$Ac=y,e.$Bc=a,v=Ie(v);const O=/^\w[\w\d+.-]*$/,I=/^\//,b=/^\/\//;function l(h,P){if(!h.scheme&&P)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!O.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!I.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(h,P){return!h&&!P?"file":h}function u(h,P){switch(h){case"https":case"http":case"file":P?P[0]!==p&&(P=p+P):P=p;break}return P}const $="",p="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(P){return P instanceof f?!0:P?typeof P.authority=="string"&&typeof P.fragment=="string"&&typeof P.path=="string"&&typeof P.query=="string"&&typeof P.scheme=="string"&&typeof P.fsPath=="string"&&typeof P.with=="function"&&typeof P.toString=="function":!1}constructor(P,w,R,T,A,L=!1){typeof P=="object"?(this.scheme=P.scheme||$,this.authority=P.authority||$,this.path=P.path||$,this.query=P.query||$,this.fragment=P.fragment||$):(this.scheme=m(P,L),this.authority=w||$,this.path=u(this.scheme,R||$),this.query=T||$,this.fragment=A||$,l(this,L))}get fsPath(){return a(this,!1)}with(P){if(!P)return this;let{scheme:w,authority:R,path:T,query:A,fragment:L}=P;return w===void 0?w=this.scheme:w===null&&(w=$),R===void 0?R=this.authority:R===null&&(R=$),T===void 0?T=this.path:T===null&&(T=$),A===void 0?A=this.query:A===null&&(A=$),L===void 0?L=this.fragment:L===null&&(L=$),w===this.scheme&&R===this.authority&&T===this.path&&A===this.query&&L===this.fragment?this:new g(w,R,T,A,L)}static parse(P,w=!1){const R=d.exec(P);return R?new g(R[2]||$,c(R[4]||$),c(R[5]||$),c(R[7]||$),c(R[9]||$),w):new g($,$,$,$,$)}static file(P){let w=$;if(D.$l&&(P=P.replace(/\\/g,p)),P[0]===p&&P[1]===p){const R=P.indexOf(p,2);R===-1?(w=P.substring(2),P=p):(w=P.substring(2,R),P=P.substring(R)||p)}return new g("file",w,P,$,$)}static from(P,w){return new g(P.scheme,P.authority,P.path,P.query,P.fragment,w)}static joinPath(P,...w){if(!P.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return D.$l&&P.scheme==="file"?R=f.file(v.$kc.join(a(P,!0),...w)).path:R=v.$lc.join(P.path,...w),P.with({path:R})}toString(P=!1){return t(this,P)}toJSON(){return this}static revive(P){if(P){if(P instanceof f)return P;{const w=new g(P);return w._formatted=P.external??null,w._fsPath=P._sep===E?P.fsPath??null:null,w}}else return P}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=f;function y(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const E=D.$l?1:void 0;class g extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(P=!1){return P?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const P={$mid:r.MarshalledId.Uri};return this._fsPath&&(P.fsPath=this._fsPath,P._sep=E),this._formatted&&(P.external=this._formatted),this.path&&(P.path=this.path),this.scheme&&(P.scheme=this.scheme),this.authority&&(P.authority=this.authority),this.query&&(P.query=this.query),this.fragment&&(P.fragment=this.fragment),P}}const S={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function k(h,P,w){let R,T=-1;for(let A=0;A<h.length;A++){const L=h.charCodeAt(A);if(L>=i.CharCode.a&&L<=i.CharCode.z||L>=i.CharCode.A&&L<=i.CharCode.Z||L>=i.CharCode.Digit0&&L<=i.CharCode.Digit9||L===i.CharCode.Dash||L===i.CharCode.Period||L===i.CharCode.Underline||L===i.CharCode.Tilde||P&&L===i.CharCode.Slash||w&&L===i.CharCode.OpenSquareBracket||w&&L===i.CharCode.CloseSquareBracket||w&&L===i.CharCode.Colon)T!==-1&&(R+=encodeURIComponent(h.substring(T,A)),T=-1),R!==void 0&&(R+=h.charAt(A));else{R===void 0&&(R=h.substr(0,A));const M=S[L];M!==void 0?(T!==-1&&(R+=encodeURIComponent(h.substring(T,A)),T=-1),R+=M):T===-1&&(T=A)}}return T!==-1&&(R+=encodeURIComponent(h.substring(T))),R!==void 0?R:h}function s(h){let P;for(let w=0;w<h.length;w++){const R=h.charCodeAt(w);R===i.CharCode.Hash||R===i.CharCode.QuestionMark?(P===void 0&&(P=h.substr(0,w)),P+=S[R]):P!==void 0&&(P+=h[w])}return P!==void 0?P:h}function a(h,P){let w;return h.authority&&h.path.length>1&&h.scheme==="file"?w=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===i.CharCode.Slash&&(h.path.charCodeAt(1)>=i.CharCode.A&&h.path.charCodeAt(1)<=i.CharCode.Z||h.path.charCodeAt(1)>=i.CharCode.a&&h.path.charCodeAt(1)<=i.CharCode.z)&&h.path.charCodeAt(2)===i.CharCode.Colon?P?w=h.path.substr(1):w=h.path[1].toLowerCase()+h.path.substr(2):w=h.path,D.$l&&(w=w.replace(/\//g,"\\")),w}function t(h,P){const w=P?s:k;let R="",{scheme:T,authority:A,path:L,query:M,fragment:V}=h;if(T&&(R+=T,R+=":"),(A||T==="file")&&(R+=p,R+=p),A){let q=A.indexOf("@");if(q!==-1){const Y=A.substr(0,q);A=A.substr(q+1),q=Y.lastIndexOf(":"),q===-1?R+=w(Y,!1,!1):(R+=w(Y.substr(0,q),!1,!1),R+=":",R+=w(Y.substr(q+1),!1,!0)),R+="@"}A=A.toLowerCase(),q=A.lastIndexOf(":"),q===-1?R+=w(A,!1,!0):(R+=w(A.substr(0,q),!1,!0),R+=A.substr(q))}if(L){if(L.length>=3&&L.charCodeAt(0)===i.CharCode.Slash&&L.charCodeAt(2)===i.CharCode.Colon){const q=L.charCodeAt(1);q>=i.CharCode.A&&q<=i.CharCode.Z&&(L=`/${String.fromCharCode(q+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===i.CharCode.Colon){const q=L.charCodeAt(0);q>=i.CharCode.A&&q<=i.CharCode.Z&&(L=`${String.fromCharCode(q+32)}:${L.substr(2)}`)}R+=w(L,!0,!1)}return M&&(R+="?",R+=w(M,!1,!1)),V&&(R+="#",R+=P?V:k(V,!1,!1)),R}function o(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+o(h.substr(3)):h}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(h){return h.match(n)?h.replace(n,P=>o(P)):h}}),define(le[159],ue([0,1,7]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=r,e.$mr=v,e.$nr=D,e.log=I;function r(l){const m=l;return m&&typeof m.type=="string"&&typeof m.severity=="string"}function v(l){const m=[];let u;try{const $=JSON.parse(l.arguments),p=$[$.length-1];p&&p.__$stack&&($.pop(),u=p.__$stack),m.push(...$)}catch{m.push("Unable to log remote console arguments",l.arguments)}return{args:m,stack:u}}function D(l){if(typeof l!="string")return D(v(l).stack);const m=l;if(m){const u=O(m),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if($&&$.length===4)return{uri:i.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function O(l){if(!l)return l;const m=l.indexOf(`
`);return m===-1?l:l.substring(0,m)}function I(l,m){const{args:u,stack:$}=v(l),p=typeof u[0]=="string"&&u.length===1;let d=O($);d&&(d=`(${d.trim()})`);let f=[];if(typeof u[0]=="string"?d&&p?f=[`%c[${m}] %c${u[0]} %c${d}`,b("blue"),b(""),b("grey")]:f=[`%c[${m}] %c${u[0]}`,b("blue"),b(""),...u.slice(1)]:f=[`%c[${m}]%`,b("blue"),...u],d&&!p&&f.push(d),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,f)}function b(l){return`color: ${l}`}}),define(le[83],ue([0,1,17,7,92]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=D,e.$gi=O,e.$hi=b;function D(l){return JSON.stringify(l,I)}function O(l){let m=JSON.parse(l);return m=b(m),m}function I(l,m){return m instanceof RegExp?{$mid:v.MarshalledId.Regexp,source:m.source,flags:m.flags}:m}function b(l,m=0){if(!l||m>200)return l;if(typeof l=="object"){switch(l.$mid){case v.MarshalledId.Uri:return r.URI.revive(l);case v.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case v.MarshalledId.Date:return new Date(l.source)}if(l instanceof i.$Se||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let u=0;u<l.length;++u)l[u]=b(l[u],m+1);else for(const u in l)Object.hasOwnProperty.call(l,u)&&(l[u]=b(l[u],m+1))}return l}}),define(le[11],ue([0,1,15,3,25,7,10]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Xg=e.$Wg=e.$Vg=e.Schemas=void 0,e.$Tg=b,e.$Ug=l,e.$Yg=u,i=Ie(i),r=Ie(r),O=Ie(O);var I;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellMetadataDiff="vscode-notebook-cell-metadata-diff",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeNotebookCellOutputDiff="vscode-notebook-cell-output-diff",d.vscodeNotebookMetadata="vscode-notebook-metadata",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting",d.outputChannel="output"})(I||(e.Schemas=I={}));function b(d,f){return D.URI.isUri(d)?(0,v.$Kf)(d.scheme,f):(0,v.$Lf)(d,f+":")}function l(d,...f){return f.some(y=>b(d,y))}e.$Vg="vscode-tkn",e.$Wg="tkn";class m{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f,y){this.f=u(f,y)}getServerRootPath(){return this.f}get g(){return O.$lc.join(this.f,I.vscodeRemoteResource)}set(f,y,E){this.a[f]=y,this.b[f]=E}setConnectionToken(f,y){this.c[f]=y}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(s){return i.$4(s),f}const y=f.authority;let E=this.a[y];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const g=this.b[y],S=this.c[y];let k=`path=${encodeURIComponent(f.path)}`;return typeof S=="string"&&(k+=`&${e.$Wg}=${encodeURIComponent(S)}`),D.URI.from({scheme:r.$r?this.d:I.vscodeRemoteResource,authority:`${E}:${g}`,path:this.g,query:k})}}e.$Xg=new m;function u(d,f){return O.$lc.join(f??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Zg="vs/../../extensions",e.$1g="vs/../../node_modules",e.$2g="vs/../../node_modules.asar",e.$3g="vs/../../node_modules.asar.unpacked",e.$4g="vscode-app";class ${static{this.a=e.$4g}asBrowserUri(f){const y=this.b(f,G);return this.uriToBrowserUri(y)}uriToBrowserUri(f){return f.scheme===I.vscodeRemote?e.$Xg.rewrite(f):f.scheme===I.file&&(r.$p||r.$t===`${I.vscodeFileResource}://${$.a}`)?f.with({scheme:I.vscodeFileResource,authority:f.authority||$.a,query:null,fragment:null}):f}asFileUri(f){const y=this.b(f,G);return this.uriToFileUri(y)}uriToFileUri(f){return f.scheme===I.vscodeFileResource?f.with({scheme:I.file,authority:f.authority!==$.a?f.authority:null,query:null,fragment:null}):f}b(f,y){if(D.URI.isUri(f))return f;if(globalThis._VSCODE_FILE_ROOT){const E=globalThis._VSCODE_FILE_ROOT;if(/^\w[\w\d+.-]*:\/\//.test(E))return D.URI.joinPath(D.URI.parse(E,!0),f);const g=O.$oc(E,f);return D.URI.file(g)}return D.URI.parse(y.toUrl(f))}}e.$5g=new $;var p;(function(d){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(f.get("3"));const y="vscode-coi";function E(S){let k;typeof S=="string"?k=new URL(S).searchParams:S instanceof URL?k=S.searchParams:D.URI.isUri(S)&&(k=new URL(S.toString(!0)).searchParams);const s=k?.get(y);if(s)return f.get(s)}d.getHeadersFromQuery=E;function g(S,k,s){if(!globalThis.crossOriginIsolated)return;const a=k&&s?"3":s?"2":"1";S instanceof URLSearchParams?S.set(y,a):S[y]=a}d.addSearchParam=g})(p||(e.COI=p={}))}),define(le[160],ue([0,1,66,11,3,12,7]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=m,e.$Aq=u,v=Ie(v);class I{constructor(p,d,f){this.id=p,this.dependencies=d,this.callback=f}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,d,f)=>{typeof p!="string"&&(f=d,d=p,p=null),(typeof d!="object"||!Array.isArray(d))&&(f=d,d=null),this.c.push(new I(p,d,f))},globalThis.define.amd=!0,this.b?this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith(`${r.Schemas.vscodeFileResource}://${r.$4g}`))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis._VSCODE_WEB_PACKAGE_TTP??globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const d=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!d){console.warn(`Did not receive a define call from script ${p}`);return}const f={},y=[],E=[];if(Array.isArray(d.dependencies))for(const g of d.dependencies)g==="exports"?y.push(f):E.push(g);if(E.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${E.join(", ")}`);return typeof d.callback=="function"?d.callback(...y)??f:d.callback}h(p){return new Promise((d,f)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const E=()=>{y.removeEventListener("load",g),y.removeEventListener("error",S)},g=k=>{E(),d(this.c.pop())},S=k=>{E(),f(k)};y.addEventListener("load",g),y.addEventListener("error",S),this.f&&(p=this.f.createScriptURL(p)),y.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(y)})}async i(p){return this.f&&(p=this.f.createScriptURL(p)),i.$V?await new Promise((d,f)=>{G([p],d,f)}).then(Ie):importScripts(p),this.c.pop()}async j(p){try{const d=globalThis._VSCODE_NODE_MODULES.fs,f=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,E=O.URI.parse(p).fsPath,g=d.readFileSync(E).toString(),S=y.wrap(g.replace(/^#!.*/,""));return new f.Script(S).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const l=new Map;async function m($,p,d){if(i.$V){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit);const f=p?`${$}/${p}`:$;if(l.has(f))return l.get(f);let y;if(/^\w[\w\d+.-]*:\/\//.test(f))y=f;else{const k=`${i.$W&&d&&!v.$r?r.$2g:r.$1g}/${f}`;y=r.$5g.asBrowserUri(k).toString(!0)}const E=b.INSTANCE.load(y);return l.set(f,E),E}else return await new Promise((f,y)=>{G([$],f,y)}).then(Ie)}function u($,p){(0,D.$tg)(i.$V);const f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit,y=i.$W&&f&&!v.$r,E=`${$}/${p}`,S=`${y?r.$2g:r.$1g}/${E}`;return r.$5g.asBrowserUri(S).toString(!0)}}),define(le[18],ue([0,1,39,32,11,10,3,25,7]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=void 0,e.$_g=l,e.$uh=u,e.$vh=p,r=Ie(r),D=Ie(D);function l(d){return(0,b.$Bc)(d,!0)}class m{constructor(f){this.a=f}compare(f,y,E=!1){return f===y?0:(0,I.$Df)(this.getComparisonKey(f,E),this.getComparisonKey(y,E))}isEqual(f,y,E=!1){return f===y?!0:!f||!y?!1:this.getComparisonKey(f,E)===this.getComparisonKey(y,E)}getComparisonKey(f,y=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,y,E=!1){if(f.scheme===y.scheme){if(f.scheme===v.Schemas.file)return r.$Jg(l(f),l(y),this.a(f))&&f.query===y.query&&(E||f.fragment===y.fragment);if((0,e.$qh)(f.authority,y.authority))return r.$Jg(f.path,y.path,this.a(f),"/")&&f.query===y.query&&(E||f.fragment===y.fragment)}return!1}joinPath(f,...y){return b.URI.joinPath(f,...y)}basenameOrAuthority(f){return(0,e.$ih)(f)||f.authority}basename(f){return D.$lc.basename(f.path)}extname(f){return D.$lc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let y;return f.scheme===v.Schemas.file?y=b.URI.file(D.$rc(l(f))).path:(y=D.$lc.dirname(f.path),f.authority&&y.length&&y.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${f.toString})) resulted in a relative path`),y="/")),f.with({path:y})}normalizePath(f){if(!f.path.length)return f;let y;return f.scheme===v.Schemas.file?y=b.URI.file(D.$mc(l(f))).path:y=D.$lc.normalize(f.path),f.with({path:y})}relativePath(f,y){if(f.scheme!==y.scheme||!(0,e.$qh)(f.authority,y.authority))return;if(f.scheme===v.Schemas.file){const S=D.$qc(l(f),l(y));return O.$l?r.$Dg(S):S}let E=f.path||"/";const g=y.path||"/";if(this.a(f)){let S=0;for(const k=Math.min(E.length,g.length);S<k&&!(E.charCodeAt(S)!==g.charCodeAt(S)&&E.charAt(S).toLowerCase()!==g.charAt(S).toLowerCase());S++);E=g.substr(0,S)+E.substr(S)}return D.$lc.relative(E,g)}resolvePath(f,y){if(f.scheme===v.Schemas.file){const E=b.URI.file(D.$pc(l(f),y));return f.with({authority:E.authority,path:E.path})}return y=r.$Eg(y),f.with({path:D.$lc.resolve(f.path,y)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,y){return f===y||f!==void 0&&y!==void 0&&(0,I.$Kf)(f,y)}hasTrailingPathSeparator(f,y=D.sep){if(f.scheme===v.Schemas.file){const E=l(f);return E.length>r.$Fg(E).length&&E[E.length-1]===y}else{const E=f.path;return E.length>1&&E.charCodeAt(E.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,y=D.sep){return(0,e.$rh)(f,y)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,y=D.sep){let E=!1;if(f.scheme===v.Schemas.file){const g=l(f);E=g!==void 0&&g.length===r.$Fg(g).length&&g[g.length-1]===y}else{y="/";const g=f.path;E=g.length===1&&g.charCodeAt(g.length-1)===i.CharCode.Slash}return!E&&!(0,e.$rh)(f,y)?f.with({path:f.path+"/"}):f}}e.$ah=m,e.$bh=new m(()=>!1),e.$ch=new m(d=>d.scheme===v.Schemas.file?!O.$n:!0),e.$dh=new m(d=>!0),e.$eh=e.$bh.isEqual.bind(e.$bh),e.$fh=e.$bh.isEqualOrParent.bind(e.$bh),e.$gh=e.$bh.getComparisonKey.bind(e.$bh),e.$hh=e.$bh.basenameOrAuthority.bind(e.$bh),e.$ih=e.$bh.basename.bind(e.$bh),e.$jh=e.$bh.extname.bind(e.$bh),e.$kh=e.$bh.dirname.bind(e.$bh),e.$lh=e.$bh.joinPath.bind(e.$bh),e.$mh=e.$bh.normalizePath.bind(e.$bh),e.$nh=e.$bh.relativePath.bind(e.$bh),e.$oh=e.$bh.resolvePath.bind(e.$bh),e.$ph=e.$bh.isAbsolutePath.bind(e.$bh),e.$qh=e.$bh.isEqualAuthority.bind(e.$bh),e.$rh=e.$bh.hasTrailingPathSeparator.bind(e.$bh),e.$sh=e.$bh.removeTrailingPathSeparator.bind(e.$bh),e.$th=e.$bh.addTrailingPathSeparator.bind(e.$bh);function u(d,f){const y=[];for(let E=0;E<d.length;E++){const g=f(d[E]);d.some((S,k)=>k===E?!1:(0,e.$fh)(g,f(S)))||y.push(d[E])}return y}var $;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function f(y){const E=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(k=>{const[s,a]=k.split(":");s&&a&&E.set(s,a)});const S=y.path.substring(0,y.path.indexOf(";"));return S&&E.set(d.META_DATA_MIME,S),E}d.parseMetaData=f})($||(e.DataUri=$={}));function p(d,f,y){if(f){let E=d.path;return E&&E[0]!==D.$lc.sep&&(E=D.$lc.sep+E),d.with({scheme:y,authority:f,path:E})}return d.with({scheme:y})}}),define(le[8],ue([0,1,22,15,4,2,18,3,150,67]),function(G,e,i,r,v,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$_h=e.$$h=e.$0h=e.$9h=e.Promises=e.$8h=e.$7h=e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0,e.$wh=m,e.$xh=u,e.$yh=$,e.$zh=p,e.$Ah=d,e.$Bh=f,e.$Ch=y,e.$Dh=E,e.$Lh=h,e.$Mh=P,e.$Nh=w,e.$Oh=R,e.$Ph=T,e.$5h=B,e.$ai=N;function m(K){return!!K&&typeof K.then=="function"}function u(K){const H=new i.$Be,_=K(H.token),ae=new Promise(($e,be)=>{const ye=H.token.onCancellationRequested(()=>{ye.dispose(),be(new r.$9)});Promise.resolve(_).then(Fe=>{ye.dispose(),H.dispose(),$e(Fe)},Fe=>{ye.dispose(),H.dispose(),be(Fe)})});return new class{cancel(){H.cancel(),H.dispose()}then($e,be){return ae.then($e,be)}catch($e){return this.then(void 0,$e)}finally($e){return ae.finally($e)}}}function $(K,H,_){return new Promise((ae,$e)=>{const be=H.onCancellationRequested(()=>{be.dispose(),ae(_)});K.then(ae,$e).finally(()=>be.dispose())})}function p(K,H){return new Promise((_,ae)=>{const $e=H.onCancellationRequested(()=>{$e.dispose(),ae(new r.$9)});K.then(_,ae).finally(()=>$e.dispose())})}async function d(K){let H=-1;const _=K.map((ae,$e)=>ae.then(be=>(H=$e,be)));try{return await Promise.race(_)}finally{K.forEach((ae,$e)=>{$e!==H&&ae.cancel()})}}function f(K,H,_){let ae;const $e=setTimeout(()=>{ae?.(void 0),_?.()},H);return Promise.race([K.finally(()=>clearTimeout($e)),new Promise(be=>ae=be)])}function y(K){return new Promise((H,_)=>{const ae=K();m(ae)?ae.then(H,_):H(ae)})}function E(){let K,H;return{promise:new Promise((ae,$e)=>{K=ae,H=$e}),resolve:K,reject:H}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const _=()=>{if(this.b=null,this.f)return;const ae=this.queue(this.d);return this.d=null,ae};this.b=new Promise(ae=>{this.a.then(_,_).then(ae)})}return new Promise((_,ae)=>{this.b.then(_,ae)})}return this.a=H(),new Promise((_,ae)=>{this.a.then($e=>{this.a=null,_($e)},$e=>{this.a=null,ae($e)})})}dispose(){this.f=!0}}e.$Eh=g;class S{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$Fh=S;class k{constructor(){this.a=new Map}queue(H,_){const $e=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(H)===$e&&this.a.delete(H)});return this.a.set(H,$e),$e}}e.$Gh=k;const s=(K,H)=>{let _=!0;const ae=setTimeout(()=>{_=!1,H()},K);return{isTriggered:()=>_,dispose:()=>{clearTimeout(ae),_=!1}}},a=K=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,K())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class t{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,_=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise(($e,be)=>{this.d=$e,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const ae=()=>{this.a=null,this.d?.(null)};return this.a=_===b.$le?a(ae):s(_,ae),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$9),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Hh=t;class o{constructor(H){this.a=new t(H),this.b=new g}trigger(H,_){return this.a.trigger(()=>this.b.queue(H),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ih=o;class n{constructor(){this.a=!1,this.b=new Promise((H,_)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Jh=n;class c extends n{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$Kh=c;function h(K,H){return H?new Promise((_,ae)=>{const $e=setTimeout(()=>{be.dispose(),_()},K),be=H.onCancellationRequested(()=>{clearTimeout($e),be.dispose(),ae(new r.$9)})}):u(_=>h(K,_))}function P(K,H=0,_){const ae=setTimeout(()=>{K(),_&&$e.dispose()},H),$e=(0,D.$Xc)(()=>{clearTimeout(ae),_?.deleteAndLeak($e)});return _?.add($e),$e}function w(K){const H=[];let _=0;const ae=K.length;function $e(){return _<ae?K[_++]():null}function be(ye){ye!=null&&H.push(ye);const Fe=$e();return Fe?Fe.then(be):Promise.resolve(H)}return Promise.resolve(null).then(be)}function R(K,H=ae=>!!ae,_=null){let ae=0;const $e=K.length,be=()=>{if(ae>=$e)return Promise.resolve(_);const ye=K[ae++];return Promise.resolve(ye()).then(xe=>H(xe)?Promise.resolve(xe):be())};return be()}function T(K,H=ae=>!!ae,_=null){if(K.length===0)return Promise.resolve(_);let ae=K.length;const $e=()=>{ae=-1;for(const be of K)be.cancel?.()};return new Promise((be,ye)=>{for(const Fe of K)Fe.then(xe=>{--ae>=0&&H(xe)?($e(),be(xe)):ae===0&&be(_)}).catch(xe=>{--ae>=0&&($e(),ye(xe))})})}class A{constructor(H){this.a=0,this.b=!1,this.f=H,this.g=[],this.d=0,this.h=new v.$qe}whenIdle(){return this.size>0?v.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(H){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((_,ae)=>{this.g.push({factory:H,c:_,e:ae}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const H=this.g.shift();this.d++;const _=H.factory();_.then(H.c,H.e),_.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Qh=A;class L extends A{constructor(){super(1)}}e.$Rh=L;class M{constructor(){this.a=new F,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$Sh=M;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new x;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueSize(H,_=O.$bh){const ae=_.getComparisonKey(H);return this.a.get(ae)?.size??0}queueFor(H,_,ae=O.$bh){const $e=ae.getComparisonKey(H);let be=this.a.get($e);if(!be){be=new L;const ye=this.f++,Fe=v.Event.once(be.onDrained)(()=>{be?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(ye),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$9c),this.d.set(ye,Fe),this.a.set($e,be)}return be.queue(_)}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Th=V;class q{constructor(H,_){this.b=!1,this.a=-1,typeof H=="function"&&typeof _=="number"&&this.setIfNotSet(H,_)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,_){if(this.b)throw new r.$gb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},_)}setIfNotSet(H,_){if(this.b)throw new r.$gb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},_))}}e.$Uh=q;class Y{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,_,ae=globalThis){if(this.f)throw new r.$gb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const $e=ae.setInterval(()=>{H()},_);this.d=(0,D.$Xc)(()=>{ae.clearInterval($e),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Vh=Y;class de{constructor(H,_){this.b=-1,this.a=H,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Wh=de;class re{constructor(H,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=H,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Xh=re;class ee extends de{constructor(H,_){super(H,_),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$Yh=ee;class W extends D.$Zc{constructor(H,_){super(),this.g=H,this.h=_,this.a=[],this.b=this.B(new D.$1c),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of H)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new de(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Zh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$2h=(K,H)=>{(0,I.$E)(()=>{if(_)return;const ae=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.$2h=(K,H,_)=>{const ae=K.requestIdleCallback(H,typeof _=="number"?{timeout:_}:void 0);let $e=!1;return{dispose(){$e||($e=!0,K.cancelIdleCallback(ae))}}},e.$1h=K=>(0,e.$2h)(globalThis,K)}();class Z{constructor(H,_){this.g=!1,this.d=()=>{try{this.j=_()}catch(ae){this.l=ae}finally{this.g=!0}},this.f=(0,e.$2h)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$3h=Z;class C extends Z{constructor(H){super(globalThis,H)}}e.$4h=C;async function B(K,H,_){let ae;for(let $e=0;$e<_;$e++)try{return await K()}catch(be){ae=be,await h(H)}throw ae}class F{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,_,ae){return this.a={taskId:H,cancel:()=>ae?.(),promise:_},_.then(()=>this.d(H),()=>this.d(H)),_}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{const{promise:_,resolve:ae,reject:$e}=E();this.b={run:H,promise:_,promiseResolve:ae,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$6h=F;class z{constructor(H,_=()=>Date.now()){this.d=H,this.f=_,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$7h=z;var ie;(function(K){K[K.Resolved=0]="Resolved",K[K.Rejected=1]="Rejected"})(ie||(ie={}));class x{get isRejected(){return this.d?.outcome===ie.Rejected}get isResolved(){return this.d?.outcome===ie.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ie.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((H,_)=>{this.a=H,this.b=_})}complete(H){return new Promise(_=>{this.a(H),this.d={outcome:ie.Resolved,value:H},_()})}error(H){return new Promise(_=>{this.b(H),this.d={outcome:ie.Rejected,value:H},_()})}cancel(){return this.error(new r.$9)}}e.$8h=x;var ce;(function(K){async function H(ae){let $e;const be=await Promise.all(ae.map(ye=>ye.then(Fe=>Fe,Fe=>{$e||($e=Fe)})));if(typeof $e<"u")throw $e;return be}K.settled=H;function _(ae){return new Promise(async($e,be)=>{try{await ae($e,be)}catch(ye){be(ye)}})}K.withAsyncBody=_})(ce||(e.Promises=ce={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(H){this.a=void 0,this.b=void 0,this.d=!1,this.promise=H.then(_=>(this.a=_,this.d=!0,_),_=>{throw this.b=_,this.d=!0,_})}requireValue(){if(!this.d)throw new r.$gb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$9h=oe;class te{constructor(H){this.b=H,this.a=new l.$Y(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$0h=te;var j;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(j||(j={}));class X{static fromArray(H){return new X(_=>{_.emitMany(H)})}static fromPromise(H){return new X(async _=>{_.emitMany(await H)})}static fromPromises(H){return new X(async _=>{await Promise.all(H.map(async ae=>_.emitOne(await ae)))})}static merge(H){return new X(async _=>{await Promise.all(H.map(async ae=>{for await(const $e of ae)_.emitOne($e)}))})}static{this.EMPTY=X.fromArray([])}constructor(H,_){this.a=j.Initial,this.b=[],this.d=null,this.f=_,this.g=new v.$qe,queueMicrotask(async()=>{const ae={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(H(ae)),this.k()}catch($e){this.l($e)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===j.DoneError)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===j.DoneOK)return{done:!0,value:void 0};await v.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(H,_){return new X(async ae=>{for await(const $e of H)ae.emitOne(_($e))})}map(H){return X.map(this,H)}static filter(H,_){return new X(async ae=>{for await(const $e of H)_($e)&&ae.emitOne($e)})}filter(H){return X.filter(this,H)}static coalesce(H){return X.filter(H,_=>!!_)}coalesce(){return X.coalesce(this)}static async toPromise(H){const _=[];for await(const ae of H)_.push(ae);return _}toPromise(){return X.toPromise(this)}h(H){this.a===j.Initial&&(this.b.push(H),this.g.fire())}j(H){this.a===j.Initial&&(this.b=this.b.concat(H),this.g.fire())}k(){this.a===j.Initial&&(this.a=j.DoneOK,this.g.fire())}l(H){this.a===j.Initial&&(this.a=j.DoneError,this.d=H,this.g.fire())}}e.$$h=X;class U extends X{constructor(H,_){super(_),this.m=H}cancel(){this.m.cancel()}}e.$_h=U;function N(K){const H=new i.$Be,_=K(H.token);return new U(H,async ae=>{const $e=H.token.onCancellationRequested(()=>{$e.dispose(),H.dispose(),ae.reject(new r.$9)});try{for await(const be of _){if(H.token.isCancellationRequested)return;ae.emitOne(be)}$e.dispose(),H.dispose()}catch(be){$e.dispose(),H.dispose(),ae.reject(be)}})}class Q{constructor(H){this.a=new x,this.b=new X($e=>{if(_){$e.reject(_);return}return ae&&$e.emitMany(ae),this.d=be=>$e.reject(be),this.f=be=>$e.emitOne(be),this.a.p},H);let _,ae;this.f=$e=>{ae||(ae=[]),ae.push($e)},this.d=$e=>{_||(_=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$bi=Q}),define(le[116],ue([0,1,21,8,39,32,31,10,3,25]),function(G,e,i,r,v,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=void 0,e.$Ak=m,e.$Dk=f,e.$Ek=M,e.$Fk=V,e.$Gk=q,e.$Hk=Y,e.$Ik=de,e.$Jk=Z;function m(){return Object.create(null)}e.$Bk="**",e.$Ck="/";const u="[/\\\\]",$="[^/\\\\]",p=/\//g;function d(C,B){switch(C){case 0:return"";case 1:return`${$}*?`;default:return`(?:${u}|${$}+${u}${B?`|${u}${$}+`:""})*?`}}function f(C,B){if(!C)return[];const F=[];let z=!1,ie=!1,x="";for(const ce of C){switch(ce){case B:if(!z&&!ie){F.push(x),x="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}x+=ce}return x&&F.push(x),F}function y(C){if(!C)return"";let B="";const F=f(C,e.$Ck);if(F.every(z=>z===e.$Bk))B=".*";else{let z=!1;F.forEach((ie,x)=>{if(ie===e.$Bk){if(z)return;B+=d(2,x===F.length-1)}else{let ce=!1,oe="",te=!1,j="";for(const X of ie){if(X!=="}"&&ce){oe+=X;continue}if(te&&(X!=="]"||!j)){let U;X==="-"?U=X:(X==="^"||X==="!")&&!j?U="^":X===e.$Ck?U="":U=(0,l.$mf)(X),j+=U;continue}switch(X){case"{":ce=!0;continue;case"[":te=!0;continue;case"}":{const N=`(?:${f(oe,",").map(Q=>y(Q)).join("|")})`;B+=N,ce=!1,oe="";break}case"]":{B+="["+j+"]",te=!1,j="";break}case"?":B+=$;continue;case"*":B+=d(1);continue;default:B+=(0,l.$mf)(X)}}x<F.length-1&&(F[x+1]!==e.$Bk||x+2<F.length)&&(B+=u)}z=ie===e.$Bk})}return B}const E=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Ic(1e4),o=function(){return!1},n=function(){return null};function c(C,B){if(!C)return n;let F;typeof C!="string"?F=C.pattern:F=C,F=F.trim();const z=`${F}_${!!B.trimForExclusions}`;let ie=t.get(z);if(ie)return h(ie,C);let x;return E.test(F)?ie=w(F.substr(4),F):(x=g.exec(P(F,B)))?ie=R(x[1],F):(B.trimForExclusions?k:S).test(F)?ie=T(F,B):(x=s.exec(P(F,B)))?ie=A(x[1].substr(1),F,!0):(x=a.exec(P(F,B)))?ie=A(x[1],F,!1):ie=L(F),t.set(z,ie),h(ie,C)}function h(C,B){if(typeof B=="string")return C;const F=function(z,ie){return(0,D.$Jg)(z,B.base,!b.$n)?C((0,l.$rf)(z.substr(B.base.length),I.sep),ie):null};return F.allBasenames=C.allBasenames,F.allPaths=C.allPaths,F.basenames=C.basenames,F.patterns=C.patterns,F}function P(C,B){return B.trimForExclusions&&C.endsWith("/**")?C.substr(0,C.length-2):C}function w(C,B){return function(F,z){return typeof F=="string"&&F.endsWith(C)?B:null}}function R(C,B){const F=`/${C}`,z=`\\${C}`,ie=function(ce,oe){return typeof ce!="string"?null:oe?oe===C?B:null:ce===C||ce.endsWith(F)||ce.endsWith(z)?B:null},x=[C];return ie.basenames=x,ie.patterns=[B],ie.allBasenames=x,ie}function T(C,B){const F=W(C.slice(1,-1).split(",").map(oe=>c(oe,B)).filter(oe=>oe!==n),C),z=F.length;if(!z)return n;if(z===1)return F[0];const ie=function(oe,te){for(let j=0,X=F.length;j<X;j++)if(F[j](oe,te))return C;return null},x=F.find(oe=>!!oe.allBasenames);x&&(ie.allBasenames=x.allBasenames);const ce=F.reduce((oe,te)=>te.allPaths?oe.concat(te.allPaths):oe,[]);return ce.length&&(ie.allPaths=ce),ie}function A(C,B,F){const z=I.sep===I.$lc.sep,ie=z?C:C.replace(p,I.sep),x=I.sep+ie,ce=I.$lc.sep+C;let oe;return F?oe=function(te,j){return typeof te=="string"&&(te===ie||te.endsWith(x)||!z&&(te===C||te.endsWith(ce)))?B:null}:oe=function(te,j){return typeof te=="string"&&(te===ie||!z&&te===C)?B:null},oe.allPaths=[(F?"*/":"./")+C],oe}function L(C){try{const B=new RegExp(`^${y(C)}$`);return function(F){return B.lastIndex=0,typeof F=="string"&&B.test(F)?C:null}}catch{return n}}function M(C,B,F){return!C||typeof B!="string"?!1:V(C)(B,void 0,F)}function V(C,B={}){if(!C)return o;if(typeof C=="string"||q(C)){const F=c(C,B);if(F===n)return o;const z=function(ie,x){return!!F(ie,x)};return F.allBasenames&&(z.allBasenames=F.allBasenames),F.allPaths&&(z.allPaths=F.allPaths),z}return re(C,B)}function q(C){const B=C;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function Y(C){return C.allBasenames||[]}function de(C){return C.allPaths||[]}function re(C,B){const F=W(Object.getOwnPropertyNames(C).map(oe=>ee(oe,C[oe],B)).filter(oe=>oe!==n)),z=F.length;if(!z)return n;if(!F.some(oe=>!!oe.requiresSiblings)){if(z===1)return F[0];const oe=function(X,U){let N;for(let Q=0,K=F.length;Q<K;Q++){const H=F[Q](X,U);if(typeof H=="string")return H;(0,r.$wh)(H)&&(N||(N=[]),N.push(H))}return N?(async()=>{for(const Q of N){const K=await Q;if(typeof K=="string")return K}return null})():null},te=F.find(X=>!!X.allBasenames);te&&(oe.allBasenames=te.allBasenames);const j=F.reduce((X,U)=>U.allPaths?X.concat(U.allPaths):X,[]);return j.length&&(oe.allPaths=j),oe}const ie=function(oe,te,j){let X,U;for(let N=0,Q=F.length;N<Q;N++){const K=F[N];K.requiresSiblings&&j&&(te||(te=(0,I.$sc)(oe)),X||(X=te.substr(0,te.length-(0,I.$tc)(oe).length)));const H=K(oe,te,X,j);if(typeof H=="string")return H;(0,r.$wh)(H)&&(U||(U=[]),U.push(H))}return U?(async()=>{for(const N of U){const Q=await N;if(typeof Q=="string")return Q}return null})():null},x=F.find(oe=>!!oe.allBasenames);x&&(ie.allBasenames=x.allBasenames);const ce=F.reduce((oe,te)=>te.allPaths?oe.concat(te.allPaths):oe,[]);return ce.length&&(ie.allPaths=ce),ie}function ee(C,B,F){if(B===!1)return n;const z=c(C,F);if(z===n)return n;if(typeof B=="boolean")return z;if(B){const ie=B.when;if(typeof ie=="string"){const x=(ce,oe,te,j)=>{if(!j||!z(ce,oe))return null;const X=ie.replace("$(basename)",()=>te),U=j(X);return(0,r.$wh)(U)?U.then(N=>N?C:null):U?C:null};return x.requiresSiblings=!0,x}}return z}function W(C,B){const F=C.filter(oe=>!!oe.basenames);if(F.length<2)return C;const z=F.reduce((oe,te)=>{const j=te.basenames;return j?oe.concat(j):oe},[]);let ie;if(B){ie=[];for(let oe=0,te=z.length;oe<te;oe++)ie.push(B)}else ie=F.reduce((oe,te)=>{const j=te.patterns;return j?oe.concat(j):oe},[]);const x=function(oe,te){if(typeof oe!="string")return null;if(!te){let X;for(X=oe.length;X>0;X--){const U=oe.charCodeAt(X-1);if(U===v.CharCode.Slash||U===v.CharCode.Backslash)break}te=oe.substr(X)}const j=z.indexOf(te);return j!==-1?ie[j]:null};x.basenames=z,x.patterns=ie,x.allBasenames=z;const ce=C.filter(oe=>!oe.basenames);return ce.push(x),ce}function Z(C,B){return(0,i.$yb)(C,B,(F,z)=>typeof F=="string"&&typeof z=="string"?F===z:typeof F!="string"&&typeof z!="string"?F.base===z.base&&F.pattern===z.pattern:!1)}}),define(le[49],ue([0,1,21,32,10,3,18,25]),function(G,e,i,r,v,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9w=b,e.$0w=m,e.$$w=$,e.$_w=p,e.$ax=E,e.$bx=S,e.$cx=k,e.$dx=s,e.$ex=a,e.$fx=t;function b(n,c){const{os:h,tildify:P,relative:w}=c;if(w){const A=l(n,w,h);if(typeof A=="string")return A}let R=n.fsPath;if(h===D.OperatingSystem.Windows&&!D.$l?R=R.replace(/\//g,"\\"):h!==D.OperatingSystem.Windows&&D.$l&&(R=R.replace(/\\/g,"/")),h!==D.OperatingSystem.Windows&&P?.userHome){const A=P.userHome.fsPath;let L;n.scheme!==P.userHome.scheme&&n.path[0]===v.$lc.sep&&n.path[1]!==v.$lc.sep?L=P.userHome.with({path:n.path}).fsPath:L=R,R=$(L,A,h)}return(h===D.OperatingSystem.Windows?v.$kc:v.$lc).normalize(m(R,h===D.OperatingSystem.Windows))}function l(n,c,h){const P=h===D.OperatingSystem.Windows?v.$kc:v.$lc,w=h===D.OperatingSystem.Linux?O.$bh:O.$dh,R=c.getWorkspace(),T=(0,i.$Sb)(R.folders);if(!T)return;n.scheme!==T.uri.scheme&&n.path[0]===v.$lc.sep&&n.path[1]!==v.$lc.sep&&(n=T.uri.with({path:n.path}));const A=c.getWorkspaceFolder(n);if(!A)return;let L;if(w.isEqual(A.uri,n)?L="":L=w.relativePath(A.uri,n)??"",L&&(L=P.normalize(L)),R.folders.length>1&&!c.noPrefix){const M=A.name?A.name:w.basenameOrAuthority(A.uri);L=L?`${M} \u2022 ${L}`:M}return L}function m(n,c=D.$l){return(0,r.$Og)(n,c)?n.charAt(0).toUpperCase()+n.slice(1):n}let u=Object.create(null);function $(n,c,h=D.OS){if(h===D.OperatingSystem.Windows||!n||!c)return n;let P=u.original===c?u.normalized:void 0;P||(P=c,D.$l&&(P=(0,r.$Dg)(P)),P=`${(0,I.$sf)(P,v.$lc.sep)}${v.$lc.sep}`,u={original:c,normalized:P});let w=n;return D.$l&&(w=(0,r.$Dg)(w)),(h===D.OperatingSystem.Linux?w.startsWith(P):(0,I.$Lf)(w,P))?`~/${w.substr(P.length)}`:n}function p(n,c){return n.replace(/^~($|\/|\\)/,`${c}$1`)}const d="\u2026",f="\\\\",y="~";function E(n,c=v.sep){const h=new Array(n.length);let P=!1;for(let w=0;w<n.length;w++){const R=n[w];if(R===""){h[w]=`.${c}`;continue}if(!R){h[w]=R;continue}P=!0;let T="",A=R;A.indexOf(f)===0?(T=A.substr(0,A.indexOf(f)+f.length),A=A.substr(A.indexOf(f)+f.length)):A.indexOf(c)===0?(T=A.substr(0,A.indexOf(c)+c.length),A=A.substr(A.indexOf(c)+c.length)):A.indexOf(y)===0&&(T=A.substr(0,A.indexOf(y)+y.length),A=A.substr(A.indexOf(y)+y.length));const L=A.split(c);for(let M=1;P&&M<=L.length;M++)for(let V=L.length-M;P&&V>=0;V--){P=!1;let q=L.slice(V,V+M).join(c);for(let Y=0;!P&&Y<n.length;Y++)if(Y!==w&&n[Y]&&n[Y].indexOf(q)>-1){const de=V+M===L.length,re=V>0&&n[Y].indexOf(c)>-1?c+q:q,ee=n[Y].endsWith(re);P=!de||ee}if(!P){let Y="";(L[0].endsWith(":")||T!=="")&&(V===1&&(V=0,M++,q=L[0]+c+q),V>0&&(Y=L[0]+c),Y=T+Y),V>0&&(Y=Y+d+c),Y=Y+q,V+M<L.length&&(Y=Y+c+d),h[w]=Y}}P&&(h[w]=R)}return h}var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function S(n,c=Object.create(null)){const h=[];let P=!1,w="";for(const R of n)if(R==="$"||P&&R==="{")w&&h.push({value:w,type:g.TEXT}),w="",P=!0;else if(R==="}"&&P){const T=c[w];if(typeof T=="string")T.length&&h.push({value:T,type:g.VARIABLE});else if(T){const A=h[h.length-1];(!A||A.type!==g.SEPARATOR)&&h.push({value:T.label,type:g.SEPARATOR})}w="",P=!1}else w+=R;return w&&!P&&h.push({value:w,type:g.TEXT}),h.filter((R,T)=>{if(R.type===g.SEPARATOR){const A=h[T-1],L=h[T+1];return[A,L].every(M=>M&&(M.type===g.VARIABLE||M.type===g.TEXT)&&M.value.length>0)}return!0}).map(R=>R.value).join("")}function k(n,c){return D.$m||c?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$m?"&":"&&"):n.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function s(n,c){return D.$m||c?n.replace(/\(&&\w\)|&&/g,""):D.$l?n.replace(/&&|&/g,h=>h==="&"?"&&":"&"):n.replace(/&&/g,"_")}function a(n){return n.replace(/&/g,"&&")}function t(n){if(n.endsWith("]")){const c=n.lastIndexOf(" [",n.length-2);if(c!==-1){const h=o(n.substring(0,c)),P=n.substring(c);return{name:h.name+P,parentPath:h.parentPath}}}return o(n)}function o(n){const c=n.indexOf("/")!==-1?v.$lc:v.$kc,h=c.basename(n),P=c.dirname(n);return h.length?{name:h,parentPath:P}:{name:P,parentPath:""}}}),define(le[161],ue([0,1,17,92,7]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=void 0,e.$Un=b,e.$Vn=m,e.$Wn=u;function D($){return $.toJSON()}class O{constructor(p){this.a=p}transformIncoming(p){const d=this.a.transformIncoming(p);return d===p?p:D(v.URI.from(d))}transformOutgoing(p){const d=this.a.transformOutgoing(p);return d===p?p:D(v.URI.from(d))}transformOutgoingURI(p){const d=this.a.transformOutgoing(p);return d===p?p:v.URI.from(d)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Sn=O,e.$Tn=new class{transformIncoming($){return $}transformOutgoing($){return $}transformOutgoingURI($){return $}transformOutgoingScheme($){return $}};function I($,p,d){if(!$||d>200)return null;if(typeof $=="object"){if($ instanceof v.URI)return p.transformOutgoing($);for(const f in $)if(Object.hasOwnProperty.call($,f)){const y=I($[f],p,d+1);y!==null&&($[f]=y)}}return null}function b($,p){const d=I($,p,0);return d===null?$:d}function l($,p,d,f){if(!$||f>200)return null;if(typeof $=="object"){if($.$mid===r.MarshalledId.Uri)return d?v.URI.revive(p.transformIncoming($)):p.transformIncoming($);if($ instanceof i.$Se)return null;for(const y in $)if(Object.hasOwnProperty.call($,y)){const E=l($[y],p,d,f+1);E!==null&&($[y]=E)}}return null}function m($,p){const d=l($,p,!1,0);return d===null?$:d}function u($,p){const d=l($,p,!0,0);return d===null?$:d}}),define(le[95],ue([0,1,27,61,33,154,3]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Zn=b,e.$1n=u,e.$2n=$,v=Ie(v),e.$Yn=new class{c(p){return this.a||(this.a=r.$Qi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,d=0;const f=(0,i.networkInterfaces)();for(const y in f){const E=f[y];if(E)for(const{mac:g,internal:S}of E)S||(d+=1,this.c(g.toUpperCase())&&(p+=1))}this.b=d>0?p/d:0}return this.b}};let I;async function b(p){return I||(I=(async()=>await l(p)||v.$7g())()),I}async function l(p){try{const d=await new Promise((y,E)=>{G(["crypto"],y,E)}).then(Ie),f=(0,D.$Xn)();return d.createHash("sha256").update(f,"utf8").digest("hex")}catch(d){p(d);return}}const m="Software\\Microsoft\\SQMClient";async function u(p){if(O.$l){const d=await new Promise((f,y)=>{G(["@vscode/windows-registry"],f,y)}).then(Ie);try{return d.GetStringRegKey("HKEY_LOCAL_MACHINE",m,"MachineId")||""}catch(f){return p(f),""}}return""}async function $(p){try{return await(await new Promise((y,E)=>{G(["@vscode/deviceid"],y,E)}).then(Ie)).getDeviceId()}catch(d){return p(d),""}}}),define(le[23],ue([0,1,26,27,162,8,32,79,10,3,18,7]),function(G,e,i,r,v,D,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=y,e.readdirSync=S,e.whenDeleted=a,e.configureFlushOnWrite=h,e.writeFileSync=w,i=Ie(i);var $;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function p(re,ee=$.UNLINK,W){if((0,O.$Ng)(re))throw new Error("rimraf - will refuse to recursively delete root");return ee===$.UNLINK?f(re):d(re,W)}async function d(re,ee=(0,O.$Sg)((0,r.tmpdir)())){try{try{await i.promises.rename(re,ee)}catch(W){return W.code==="ENOENT"?void 0:f(re)}f(ee).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function f(re){return i.promises.rm(re,{recursive:!0,force:!0,maxRetries:3})}function y(re){if((0,O.$Ng)(re))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}async function E(re,ee){return k(await(ee?g(re):i.promises.readdir(re)))}async function g(re){try{return await i.promises.readdir(re,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const ee=[],W=await E(re);for(const Z of W){let C=!1,B=!1,F=!1;try{const z=await i.promises.lstat((0,b.$oc)(re,Z));C=z.isFile(),B=z.isDirectory(),F=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}ee.push({name:Z,isFile:()=>C,isDirectory:()=>B,isSymbolicLink:()=>F})}return ee}function S(re){return k(i.readdirSync(re))}function k(re){return re.map(ee=>typeof ee=="string"?l.$m?(0,I.$sm)(ee):ee:(ee.name=l.$m?(0,I.$sm)(ee.name):ee.name,ee))}async function s(re){const ee=await E(re),W=[];for(const Z of ee)await t.existsDirectory((0,b.$oc)(re,Z))&&W.push(Z);return W}function a(re,ee=1e3){return new Promise(W=>{let Z=!1;const C=setInterval(()=>{Z||(Z=!0,i.access(re,B=>{Z=!1,B&&(clearInterval(C),W(void 0))}))},ee)})}var t;(function(re){async function ee(C){let B;try{if(B=await i.promises.lstat(C),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await i.promises.stat(C),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(l.$l&&F.code==="EACCES")try{return{stat:await i.promises.stat(await i.promises.readlink(C)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw z}throw F}}re.stat=ee;async function W(C){try{const{stat:B,symbolicLink:F}=await re.stat(C);return B.isFile()&&F?.dangling!==!0}catch{}return!1}re.existsFile=W;async function Z(C){try{const{stat:B,symbolicLink:F}=await re.stat(C);return B.isDirectory()&&F?.dangling!==!0}catch{}return!1}re.existsDirectory=Z})(t||(e.SymlinkSupport=t={}));const o=new D.$Th;function n(re,ee,W){return o.queueFor(u.URI.file(re),()=>{const Z=R(W);return new Promise((C,B)=>P(re,ee,Z,F=>F?B(F):C()))},m.$ch)}let c=!0;function h(re){c=re}function P(re,ee,W,Z){if(!c)return i.writeFile(re,ee,{mode:W.mode,flag:W.flag},Z);i.open(re,W.flag,W.mode,(C,B)=>{if(C)return Z(C);i.writeFile(B,ee,F=>{if(F)return i.close(B,()=>Z(F));i.fdatasync(B,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),h(!1)),i.close(B,ie=>Z(ie))))})})}function w(re,ee,W){const Z=R(W);if(!c)return i.writeFileSync(re,ee,{mode:Z.mode,flag:Z.flag});const C=i.openSync(re,Z.flag,Z.mode);try{i.writeFileSync(C,ee);try{i.fdatasyncSync(C)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),h(!1)}}finally{i.closeSync(C)}}function R(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function T(re,ee,W=6e4){if(re!==ee)try{l.$l&&typeof W=="number"?await A(re,ee,Date.now(),W):await i.promises.rename(re,ee)}catch(Z){if(re.toLowerCase()!==ee.toLowerCase()&&Z.code==="EXDEV"||re.endsWith("."))await L(re,ee,{preserveSymlinks:!1}),await p(re,$.MOVE);else throw Z}}async function A(re,ee,W,Z,C=0){try{return await i.promises.rename(re,ee)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-W>=Z)throw console.error(`[node.js fs] rename failed after ${C} retries with error: ${B}`),B;if(C===0){let F=!1;try{const{stat:z}=await t.stat(ee);z.isFile()||(F=!0)}catch{}if(F)throw B}return await(0,D.$Lh)(Math.min(100,C*10)),A(re,ee,W,Z,C+1)}}async function L(re,ee,W){return V(re,ee,{root:{source:re,target:ee},options:W,handledSourcePaths:new Set})}const M=511;async function V(re,ee,W){if(W.handledSourcePaths.has(re))return;W.handledSourcePaths.add(re);const{stat:Z,symbolicLink:C}=await t.stat(re);if(C){if(W.options.preserveSymlinks)try{return await de(re,ee,W)}catch{}if(C.dangling)return}return Z.isDirectory()?q(re,ee,Z.mode&M,W):Y(re,ee,Z.mode&M)}async function q(re,ee,W,Z){await i.promises.mkdir(ee,{recursive:!0,mode:W});const C=await E(re);for(const B of C)await V((0,b.$oc)(re,B),(0,b.$oc)(ee,B),Z)}async function Y(re,ee,W){await i.promises.copyFile(re,ee),await i.promises.chmod(ee,W)}async function de(re,ee,W){let Z=await i.promises.readlink(re);(0,O.$Jg)(Z,W.root.source,!l.$n)&&(Z=(0,b.$oc)(W.root.target,Z.substr(W.root.source.length+1))),await i.promises.symlink(Z,ee)}e.Promises=new class{get read(){return(re,ee,W,Z,C)=>new Promise((B,F)=>{i.read(re,ee,W,Z,C,(z,ie,x)=>z?F(z):B({bytesRead:ie,buffer:x}))})}get write(){return(re,ee,W,Z,C)=>new Promise((B,F)=>{i.write(re,ee,W,Z,C,(z,ie,x)=>z?F(z):B({bytesWritten:ie,buffer:x}))})}get fdatasync(){return(0,v.promisify)(i.fdatasync)}get open(){return(0,v.promisify)(i.open)}get close(){return(0,v.promisify)(i.close)}get realpath(){return(0,v.promisify)(i.realpath)}async exists(re){try{return await i.promises.access(re),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return s}get writeFile(){return n}get rm(){return p}get rename(){return T}get copy(){return L}}}),define(le[117],ue([0,1,26,10,3,25,23]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=I,e.$ur=b,e.$vr=l,e.$wr=m,i=Ie(i);function I($){if(v.$n)return $;const p=(0,r.$rc)($);if($===p)return $;const d=((0,r.$sc)($)||$).toLowerCase();try{const y=(0,O.readdirSync)(p).filter(E=>E.toLowerCase()===d);if(y.length===1){const E=I(p);if(E)return(0,r.$oc)(E,y[0])}else if(y.length>1){const E=y.indexOf(d);if(E>=0){const g=I(p);if(g)return(0,r.$oc)(g,y[E])}}}catch{}return null}async function b($,p){if(v.$n)return $;const d=(0,r.$rc)($);if($===d)return $;const f=((0,r.$sc)($)||$).toLowerCase();try{if(p?.isCancellationRequested)return null;const E=(await O.Promises.readdir(d)).filter(g=>g.toLowerCase()===f);if(E.length===1){const g=await b(d,p);if(g)return(0,r.$oc)(g,E[0])}else if(E.length>1){const g=E.indexOf(f);if(g>=0){const S=await b(d,p);if(S)return(0,r.$oc)(S,E[g])}}}catch{}return null}async function l($){try{return await O.Promises.realpath($)}catch{const d=u($);return await i.promises.access(d,i.constants.R_OK),d}}function m($){try{return i.realpathSync($)}catch{const d=u($);return i.accessSync(d,i.constants.R_OK),d}}function u($){return(0,D.$sf)((0,r.$mc)($),r.sep)}}),define(le[118],ue([0,1,27,10,23]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=g,e.$Cm=S,i=Ie(i),r=Ie(r),v=Ie(v);const D=/^\d+$/,O=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var b;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(b||(b={}));let l;switch(process.arch){case"ia32":l=b.x86;break;case"arm":case"arm64":l=b.ARM;break;default:l=b.x64;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?b.ARM:b.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=b.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=b.x86:m=b.x64;class u{constructor(s,a,t){this.exePath=s,this.displayName=a,this.a=t}async exists(){return this.a===void 0&&(this.a=await v.SymlinkSupport.existsFile(this.exePath)),this.a}}function $({useAlternateBitness:k=!1}={}){return k?l===b.x64?process.env["ProgramFiles(x86)"]||null:m===b.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:k=!1,findPreview:s=!1}={}){const a=$({useAlternateBitness:k});if(!a)return null;const t=r.$oc(a,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(t))return null;let o=-1,n=null;for(const P of await v.Promises.readdir(t)){let w=-1;if(s){const T=P.indexOf("-");if(T<0)continue;const A=P.substring(0,T);if(!D.test(A)||P.substring(T+1)!=="preview")continue;w=parseInt(A,10)}else{if(!D.test(P))continue;w=parseInt(P,10)}if(w<=o)continue;const R=r.$oc(t,P,"pwsh.exe");await v.SymlinkSupport.existsFile(R)&&(n=R,o=w)}if(!n)return null;const c=a.includes("x86")?" (x86)":"",h=s?" Preview":"";return new u(n,`PowerShell${h}${c}`,!0)}async function d({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const s=r.$oc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:a,pwshMsixName:t}=k?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const o of await v.Promises.readdir(s))if(a.test(o)){const n=r.$oc(s,o,"pwsh.exe");return new u(n,t)}return null}function f(){const k=r.$oc(i.homedir(),".dotnet","tools","pwsh.exe");return new u(k,".NET Core PowerShell Global Tool")}function y(){const k=r.$oc(process.env.windir,l===b.x86&&m!==b.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(k,"Windows PowerShell",!0)}async function*E(){let k=await p();k&&(yield k),k=await p({useAlternateBitness:!0}),k&&(yield k),k=await d(),k&&(yield k),k=f(),k&&(yield k),k=await p({findPreview:!0}),k&&(yield k),k=await d({findPreview:!0}),k&&(yield k),k=await p({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=y(),k&&(yield k)}async function*g(){for await(const k of E())await k.exists()&&(yield k)}async function S(){for await(const k of g())return k;return null}}),define(le[96],ue([0,1,26,10,3,38,82,12,23]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$Dm=l,e.$Em=m,r=Ie(r),v=Ie(v),D=Ie(D),I=Ie(I),b=Ie(b),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function l($=D.env){return $.comspec||"cmd.exe"}function m($){let p=[],d=!1;const f=function(y){if(d){p.push(y);return}(!$.send(y,g=>{if(g&&console.error(g),d=!1,p.length>0){const S=p.slice(0);p=[],S.forEach(k=>f(k))}})||v.$l)&&(d=!0)};return{send:f}}var u;(function($){async function p(d,f,y){if(r.$nc(d))return d;if(f===void 0&&(f=D.cwd()),r.$rc(d)!=="."||(y===void 0&&I.$jg(D.env.PATH)&&(y=D.env.PATH.split(r.$yc)),y===void 0||y.length===0))return r.$oc(f,d);async function g(S){if(await b.Promises.exists(S)){let k;try{k=await i.promises.stat(S)}catch(s){s.message.startsWith("EACCES")&&(k=await i.promises.lstat(S))}return k?!k.isDirectory():!1}return!1}for(const S of y){let k;if(r.$nc(S)?k=r.$oc(S,d):k=r.$oc(f,S,d),await g(k))return k;let s=k+".com";if(await g(s)||(s=k+".exe",await g(s)))return s}return r.$oc(f,d)}$.findExecutable=p})(u||(e.win32=u={}))}),define(le[119],ue([0,1,44,11]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=v;function v(O){return new Promise((I,b)=>{let l;const m=new Map;function u(p,d,f,y,E){const g=m.get(d);if(p===O||g){const S={name:$(f),cmd:f,pid:p,ppid:d,load:y,mem:E};m.set(p,S),p===O&&(l=S),g&&(g.children||(g.children=[]),g.children.push(S),g.children.length>1&&(g.children=g.children.sort((k,s)=>k.pid-s.pid)))}}function $(p){const d=/--utility-sub-type=network/i,f=/--crashes-directory/i,y=/\\pipe\\winpty-control/i,E=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(f.exec(p))return"electron-crash-reporter";if(y.exec(p))return"winpty-agent";if(E.exec(p))return"conpty-agent";let S=g.exec(p);if(S&&S.length===2)return S[1]==="renderer"?"window":S[1]==="utility"?d.exec(p)?"utility-network-service":"utility-process":S[1]==="extensionHost"?"extension-host":S[1];const k=/[a-zA-Z-]+\.js/g;let s="";do S=k.exec(p),S&&(s+=S+" ");while(S);return s&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron-nodejs (${s})`:p}if(process.platform==="win32"){const p=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,f)=>{G(["@vscode/windows-process-tree"],d,f)}).then(Ie).then(d=>{d.getProcessList(O,f=>{if(!f){b(new Error(`Root process ${O} not found`));return}d.getProcessCpuUsage(f,y=>{const E=new Map;y.forEach(g=>{const S=p(g.commandLine||"");E.set(g.pid,{name:$(S),cmd:S,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),l=E.get(O),l?(E.forEach(g=>{const S=E.get(g.ppid);S&&(S.children||(S.children=[]),S.children.push(g))}),E.forEach(g=>{g.children&&(g.children=g.children.sort((S,k)=>S.pid-k.pid))}),I(l)):b(new Error(`Root process ${O} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let p=function(){let d=[l];const f=[];for(;d.length;){const E=d.shift();E&&(f.push(E.pid),E.children&&(d=d.concat(E.children)))}let y=JSON.stringify(r.$5g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+f.join(" "),(0,i.exec)(y,{},(E,g,S)=>{if(E||S)b(E||new Error(S.toString()));else{const k=g.toString().split(`
`);for(let s=0;s<f.length;s++){const a=m.get(f[s]);a.load=parseFloat(k[s])}if(!l){b(new Error(`Root process ${O} not found`));return}I(l)}})};(0,i.exec)("which ps",{},(d,f,y)=>{if(d||y)if(process.platform!=="linux")b(d||new Error(y.toString()));else{const E=JSON.stringify(r.$5g.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)(E,{},(g,S,k)=>{g||k?b(g||new Error(k.toString())):(D(S,u),p())})}else{const E=f.toString().trim();(0,i.exec)(`${E} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(S,k,s)=>{S||s&&!s.includes("screen size is bogus")?b(S||new Error(s.toString())):(D(k,u),process.platform==="linux"?p():l?I(l):b(new Error(`Root process ${O} not found`)))})}})}})}function D(O,I){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=O.toString().split(`
`);for(const m of l){const u=b.exec(m.trim());u&&u.length===6&&I(parseInt(u[1]),parseInt(u[2]),u[5],parseFloat(u[3]),parseFloat(u[4]))}}}),define(le[120],ue([0,1,27,3,118,96]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=O,r=Ie(r),D=Ie(D);async function O(u,$){return u===r.OperatingSystem.Windows?r.$l?m():D.$Dm($):b(u,$)}let I=null;function b(u,$){if(r.$n&&u===r.OperatingSystem.Macintosh||r.$m&&u===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let p;if(r.$l)p="/bin/bash";else{if(p=$.SHELL,!p)try{p=(0,i.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}I=p}return I}let l=null;async function m(){return l||(l=(await(0,v.$Cm)()).exePath),l}});var ke=this&&this.__decorate||function(G,e,i,r){var v=arguments.length,D=v<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,i):r,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(G,e,i,r);else for(var I=G.length-1;I>=0;I--)(O=G[I])&&(D=(v<3?O(D):v>3?O(e,i,D):O(e,i))||D);return v>3&&D&&Object.defineProperty(e,i,D),D};define(le[45],ue([0,1,21,8,17,22,54,15,4,2,83,25,12]),function(G,e,i,r,v,D,O,I,b,l,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.ProxyChannel=e.$si=e.$pi=e.$oi=e.$ni=e.RequestInitiator=e.$mi=e.$ji=e.$ii=void 0,e.$ki=h,e.$li=P,e.$qi=M,e.$ri=V,u=Ie(u);var p;(function(C){C[C.Promise=100]="Promise",C[C.PromiseCancel=101]="PromiseCancel",C[C.EventListen=102]="EventListen",C[C.EventDispose=103]="EventDispose"})(p||(p={}));function d(C){switch(C){case p.Promise:return"req";case p.PromiseCancel:return"cancel";case p.EventListen:return"subscribe";case p.EventDispose:return"unsubscribe"}}var f;(function(C){C[C.Initialize=200]="Initialize",C[C.PromiseSuccess=201]="PromiseSuccess",C[C.PromiseError=202]="PromiseError",C[C.PromiseErrorObj=203]="PromiseErrorObj",C[C.EventFire=204]="EventFire"})(f||(f={}));function y(C){switch(C){case f.Initialize:return"init";case f.PromiseSuccess:return"reply:";case f.PromiseError:case f.PromiseErrorObj:return"replyErr:";case f.EventFire:return"event:"}}var E;(function(C){C[C.Uninitialized=0]="Uninitialized",C[C.Idle=1]="Idle"})(E||(E={}));function g(C){let B=0;for(let F=0;;F+=7){const z=C.read(1);if(B|=(z.buffer[0]&127)<<F,!(z.buffer[0]&128))return B}}const S=o(0);function k(C,B){if(B===0){C.write(S);return}let F=0;for(let ie=B;ie!==0;ie=ie>>>7)F++;const z=v.$Se.alloc(F);for(let ie=0;B!==0;ie++)z.buffer[ie]=B&127,B=B>>>7,B>0&&(z.buffer[ie]|=128);C.write(z)}class s{constructor(B){this.b=B,this.a=0}read(B){const F=this.b.slice(this.a,this.a+B);return this.a+=F.byteLength,F}}e.$ii=s;class a{constructor(){this.a=[]}get buffer(){return v.$Se.concat(this.a)}write(B){this.a.push(B)}}e.$ji=a;var t;(function(C){C[C.Undefined=0]="Undefined",C[C.String=1]="String",C[C.Buffer=2]="Buffer",C[C.VSBuffer=3]="VSBuffer",C[C.Array=4]="Array",C[C.Object=5]="Object",C[C.Int=6]="Int"})(t||(t={}));function o(C){const B=v.$Se.alloc(1);return B.writeUInt8(C,0),B}const n={Undefined:o(t.Undefined),String:o(t.String),Buffer:o(t.Buffer),VSBuffer:o(t.VSBuffer),Array:o(t.Array),Object:o(t.Object),Uint:o(t.Int)},c=typeof Buffer<"u";function h(C,B){if(typeof B>"u")C.write(n.Undefined);else if(typeof B=="string"){const F=v.$Se.fromString(B);C.write(n.String),k(C,F.byteLength),C.write(F)}else if(c&&Buffer.isBuffer(B)){const F=v.$Se.wrap(B);C.write(n.Buffer),k(C,F.byteLength),C.write(F)}else if(B instanceof v.$Se)C.write(n.VSBuffer),k(C,B.byteLength),C.write(B);else if(Array.isArray(B)){C.write(n.Array),k(C,B.length);for(const F of B)h(C,F)}else if(typeof B=="number"&&(B|0)===B)C.write(n.Uint),k(C,B);else{const F=v.$Se.fromString(JSON.stringify(B));C.write(n.Object),k(C,F.byteLength),C.write(F)}}function P(C){switch(C.read(1).readUInt8(0)){case t.Undefined:return;case t.String:return C.read(g(C)).toString();case t.Buffer:return C.read(g(C)).buffer;case t.VSBuffer:return C.read(g(C));case t.Array:{const F=g(C),z=[];for(let ie=0;ie<F;ie++)z.push(P(C));return z}case t.Object:return JSON.parse(C.read(g(C)).toString());case t.Int:return g(C)}}class w{constructor(B,F,z=null,ie=1e3){this.h=B,this.j=F,this.k=z,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:f.Initialize})}registerChannel(B,F){this.b.set(B,F),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case f.Initialize:{const F=this.o([B.type]);this.k?.logOutgoing(F,0,R.OtherSide,y(B.type));return}case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:{const F=this.o([B.type,B.id],B.data);this.k?.logOutgoing(F,B.id,R.OtherSide,y(B.type),B.data);return}}}o(B,F=void 0){const z=new a;return h(z,B),h(z,F),this.p(z.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const F=new s(B),z=P(F),ie=P(F),x=z[0];switch(x){case p.Promise:return this.k?.logIncoming(B.byteLength,z[1],R.OtherSide,`${d(x)}: ${z[2]}.${z[3]}`,ie),this.s({type:x,id:z[1],channelName:z[2],name:z[3],arg:ie});case p.EventListen:return this.k?.logIncoming(B.byteLength,z[1],R.OtherSide,`${d(x)}: ${z[2]}.${z[3]}`,ie),this.t({type:x,id:z[1],channelName:z[2],name:z[3],arg:ie});case p.PromiseCancel:return this.k?.logIncoming(B.byteLength,z[1],R.OtherSide,`${d(x)}`),this.u({type:x,id:z[1]});case p.EventDispose:return this.k?.logIncoming(B.byteLength,z[1],R.OtherSide,`${d(x)}`),this.u({type:x,id:z[1]})}}s(B){const F=this.b.get(B.channelName);if(!F){this.v(B);return}const z=new D.$Be;let ie;try{ie=F.call(this.j,B.name,B.arg,z.token)}catch(oe){ie=Promise.reject(oe)}const x=B.id;ie.then(oe=>{this.m({id:x,data:oe,type:f.PromiseSuccess})},oe=>{oe instanceof Error?this.m({id:x,data:{message:oe.message,name:oe.name,stack:oe.stack?oe.stack.split(`
`):void 0},type:f.PromiseError}):this.m({id:x,data:oe,type:f.PromiseErrorObj})}).finally(()=>{ce.dispose(),this.d.delete(B.id)});const ce=(0,l.$Xc)(()=>z.cancel());this.d.set(B.id,ce)}t(B){const F=this.b.get(B.channelName);if(!F){this.v(B);return}const z=B.id,x=F.listen(this.j,B.name,B.arg)(ce=>this.m({id:z,data:ce,type:f.EventFire}));this.d.set(B.id,x)}u(B){const F=this.d.get(B.id);F&&(F.dispose(),this.d.delete(B.id))}v(B){let F=this.g.get(B.channelName);F||(F=[],this.g.set(B.channelName,F));const z=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===p.Promise&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:f.PromiseError})},this.l);F.push({request:B,timeoutTimer:z})}w(B){const F=this.g.get(B);if(F){for(const z of F)switch(clearTimeout(z.timeoutTimer),z.request.type){case p.Promise:this.s(z.request);break;case p.EventListen:this.t(z.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Uc)(this.d.values()),this.d.clear()}}e.$mi=w;var R;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class T{constructor(B,F=null){this.l=B,this.a=!1,this.b=E.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$qe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(z=>this.s(z)),this.j=F}getChannel(B){const F=this;return{call(z,ie,x){return F.a?Promise.reject(new I.$9):F.m(B,z,ie,x)},listen(z,ie){return F.a?b.Event.None:F.o(B,z,ie)}}}m(B,F,z,ie=D.CancellationToken.None){const x=this.g++,ce=p.Promise,oe={id:x,type:ce,channelName:B,name:F,arg:z};if(ie.isCancellationRequested)return Promise.reject(new I.$9);let te;return new Promise((X,U)=>{if(ie.isCancellationRequested)return U(new I.$9);const N=()=>{const _=ae=>{switch(ae.type){case f.PromiseSuccess:this.f.delete(x),X(ae.data);break;case f.PromiseError:{this.f.delete(x);const $e=new Error(ae.data.message);$e.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,$e.name=ae.data.name,U($e);break}case f.PromiseErrorObj:this.f.delete(x),U(ae.data);break}};this.f.set(x,_),this.p(oe)};let Q=null;this.b===E.Idle?N():(Q=(0,r.$xh)(_=>this.u()),Q.then(()=>{Q=null,N()}));const K=()=>{Q?(Q.cancel(),Q=null):this.p({id:x,type:p.PromiseCancel}),U(new I.$9)},H=ie.onCancellationRequested(K);te=(0,l.$Wc)((0,l.$Xc)(K),H),this.d.add(te)}).finally(()=>{te.dispose(),this.d.delete(te)})}o(B,F,z){const ie=this.g++,x=p.EventListen,ce={id:ie,type:x,channelName:B,name:F,arg:z};let oe=null;const te=new b.$qe({onWillAddFirstListener:()=>{oe=(0,r.$xh)(X=>this.u()),oe.then(()=>{oe=null,this.d.add(te),this.p(ce)})},onDidRemoveLastListener:()=>{oe?(oe.cancel(),oe=null):(this.d.delete(te),this.p({id:ie,type:p.EventDispose}))}}),j=X=>te.fire(X.data);return this.f.set(ie,j),te.event}p(B){switch(B.type){case p.Promise:case p.EventListen:{const F=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(F,B.id,R.LocalSide,`${d(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case p.PromiseCancel:case p.EventDispose:{const F=this.q([B.type,B.id]);this.j?.logOutgoing(F,B.id,R.LocalSide,d(B.type));return}}}q(B,F=void 0){const z=new a;return h(z,B),h(z,F),this.r(z.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const F=new s(B),z=P(F),ie=P(F),x=z[0];switch(x){case f.Initialize:return this.j?.logIncoming(B.byteLength,0,R.LocalSide,y(x)),this.t({type:z[0]});case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:return this.j?.logIncoming(B.byteLength,z[1],R.LocalSide,y(x),ie),this.t({type:z[0],id:z[1],data:ie})}}t(B){if(B.type===f.Initialize){this.b=E.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Uc)(this.d.values()),this.d.clear()}}e.$ni=T,ke([O.$ci],T.prototype,"onDidInitializePromise",null);class A{get connections(){const B=[];return this.f.forEach(F=>B.push(F)),B}constructor(B,F,z){this.a=new Map,this.f=new Set,this.g=new b.$qe,this.onDidAddConnection=this.g.event,this.h=new b.$qe,this.onDidRemoveConnection=this.h.event,this.j=new l.$Yc,this.j.add(B(({protocol:ie,onDidClientDisconnect:x})=>{const ce=b.Event.once(ie.onMessage);this.j.add(ce(oe=>{const te=new s(oe),j=P(te),X=new w(ie,j,F,z),U=new T(ie,F);this.a.forEach((Q,K)=>X.registerChannel(K,Q));const N={channelServer:X,channelClient:U,ctx:j};this.f.add(N),this.g.fire(N),this.j.add(x(()=>{X.dispose(),U.dispose(),this.f.delete(N),this.h.fire(N)}))}))}))}getChannel(B,F){const z=this;return{call(ie,x,ce){let oe;if((0,$.$xg)(F)){const j=(0,i.$7b)(z.connections.filter(F));oe=j?Promise.resolve(j):b.Event.toPromise(b.Event.filter(z.onDidAddConnection,F))}else oe=F.routeCall(z,ie,x);const te=oe.then(j=>j.channelClient.getChannel(B));return M(te).call(ie,x,ce)},listen(ie,x){if((0,$.$xg)(F))return z.k(B,F,ie,x);const ce=F.routeEvent(z,ie,x).then(oe=>oe.channelClient.getChannel(B));return M(ce).listen(ie,x)}}}k(B,F,z,ie){const x=this;let ce;const oe=new b.$qe({onWillAddFirstListener:()=>{ce=new l.$Yc;const te=new b.$we,j=new Map,X=N=>{const K=N.channelClient.getChannel(B).listen(z,ie),H=te.add(K);j.set(N,H)},U=N=>{const Q=j.get(N);Q&&(Q.dispose(),j.delete(N))};x.connections.filter(F).forEach(X),b.Event.filter(x.onDidAddConnection,F)(X,void 0,ce),x.onDidRemoveConnection(U,void 0,ce),te.event(oe.fire,oe,ce),ce.add(te)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return oe.event}registerChannel(B,F){this.a.set(B,F);for(const z of this.f)z.channelServer.registerChannel(B,F)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$oi=A;class L{constructor(B,F,z=null){const ie=new a;h(ie,F),B.send(ie.buffer),this.a=new T(B,z),this.d=new w(B,F,z)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,F){this.d.registerChannel(B,F)}dispose(){this.a.dispose(),this.d.dispose()}}e.$pi=L;function M(C){return{call(B,F,z){return C.then(ie=>ie.call(B,F,z))},listen(B,F){const z=new b.$ze;return C.then(ie=>z.input=ie.listen(B,F)),z.event}}}function V(C){let B=!1;return{call(F,z,ie){return B?C.call(F,z,ie):(0,r.$Lh)(0).then(()=>B=!0).then(()=>C.call(F,z,ie))},listen(F,z){if(B)return C.listen(F,z);const ie=new b.$ze;return(0,r.$Lh)(0).then(()=>B=!0).then(()=>ie.input=C.listen(F,z)),ie.event}}}class q{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const F of B.connections)if(await Promise.resolve(this.a(F.ctx)))return Promise.resolve(F);return await b.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$si=q;var Y;(function(C){function B(x,ce,oe){const te=x,j=oe&&oe.disableMarshalling,X=new Map;for(const U in te)z(U)&&X.set(U,b.Event.buffer(te[U],!0,void 0,ce));return new class{listen(U,N,Q){const K=X.get(N);if(K)return K;const H=te[N];if(typeof H=="function"){if(ie(N))return H.call(te,Q);if(z(N))return X.set(N,b.Event.buffer(te[N],!0,void 0,ce)),X.get(N)}throw new I.$fb(`Event not found: ${N}`)}call(U,N,Q){const K=te[N];if(typeof K=="function"){if(!j&&Array.isArray(Q))for(let _=0;_<Q.length;_++)Q[_]=(0,m.$hi)(Q[_]);let H=K.apply(te,Q);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new I.$fb(`Method not found: ${N}`)}}}C.fromService=B;function F(x,ce){const oe=ce&&ce.disableMarshalling;return new Proxy({},{get(te,j){if(typeof j=="string")return ce?.properties?.has(j)?ce.properties.get(j):ie(j)?function(X){return x.listen(j,X)}:z(j)?x.listen(j):async function(...X){let U;ce&&!(0,$.$sg)(ce.context)?U=[ce.context,...X]:U=X;const N=await x.call(j,U);return oe?N:(0,m.$hi)(N)};throw new I.$fb(`Property not found: ${String(j)}`)}})}C.toService=F;function z(x){return x[0]==="o"&&x[1]==="n"&&u.$Jf(x.charCodeAt(2))}function ie(x){return/^onDynamic/.test(x)&&u.$Jf(x.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const de=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(C){if(Array.isArray(C))return C;if(C&&typeof C=="object"&&typeof C.toString=="function"){const B=C.toString();if(B!=="[object Object]")return B}return C}function ee(C){return Array.isArray(C)?C.map(re):re(C)}function W(C,B,F,z,ie,x,ce){ce=ee(ce);const oe=de[ie],te=oe[z%oe.length];let j=[`%c[${C}]%c[${String(B).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${te}`];/\($/.test(x)?(j=j.concat(ce),j.push(")")):j.push(ce),console.log.apply(console,j)}class Z{constructor(B,F){this.d=B,this.f=F,this.a=0,this.b=0}logOutgoing(B,F,z,ie,x){this.b+=B,W(this.d,this.b,B,F,z,ie,x)}logIncoming(B,F,z,ie,x){this.a+=B,W(this.f,this.a,B,F,z,ie,x)}}e.$ti=Z}),define(le[163],ue([0,1,17,4,45]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tY=e.$sY=void 0;class D{constructor(b){this.a=b,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",l=>l.data?i.$Se.wrap(l.data):i.$Se.alloc(0)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}e.$sY=D;class O extends v.$pi{constructor(b,l){const m=new D(b);super(m,l),this.b=m}dispose(){this.b.disconnect(),super.dispose()}}e.$tY=O}),define(le[121],ue([0,1,17,4,2,45]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.ProtocolConstants=e.$ui=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(n){n.enableDiagnostics=!1,n.records=[];const c=new WeakMap;let h=0;function P(R,T){if(!c.has(R)){const A=String(++h);c.set(R,A)}return c.get(R)}function w(R,T,A,L){if(!n.enableDiagnostics)return;const M=P(R,T);if(L instanceof i.$Se||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const V=i.$Se.alloc(L.byteLength);V.set(L),n.records.push({timestamp:Date.now(),id:M,label:T,type:A,buff:V})}else n.records.push({timestamp:Date.now(),id:M,label:T,type:A,data:L})}n.traceSocketEvent=w})(I||(e.SocketDiagnostics=I={}));var b;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let l=null;function m(){return l||(l=i.$Se.alloc(0)),l}class u{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return m();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const T=this.a[0];return h&&(this.a.shift(),this.b-=c),T}if(this.a[0].byteLength>c){const T=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),T}const P=i.$Se.alloc(c);let w=0,R=0;for(;c>0;){const T=this.a[R];if(T.byteLength>c){const A=T.slice(0,c);P.set(A,w),w+=c,h&&(this.a[R]=T.slice(c),this.b-=c),c-=c}else P.set(T,w),w+=T.byteLength,h?(this.a.shift(),this.b-=T.byteLength):R++,c-=T.byteLength}return P}}e.$ui=u;var $;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})($||($={}));function p(n){switch(n){case $.None:return"None";case $.Regular:return"Regular";case $.Control:return"Control";case $.Ack:return"Ack";case $.Disconnect:return"Disconnect";case $.ReplayRequest:return"ReplayRequest";case $.Pause:return"PauseWriting";case $.Resume:return"ResumeWriting";case $.KeepAlive:return"KeepAlive"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class f{constructor(c,h,P,w){this.type=c,this.id=h,this.ack=P,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends v.$Zc{constructor(c){super(),this.f=this.B(new r.$qe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:d.HeaderLength,messageType:$.None,id:0,ack:0},this.a=c,this.b=!1,this.c=new u,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent(O.ProtocolHeaderRead,{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const P=this.g.messageType,w=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=d.HeaderLength,this.g.messageType=$.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(O.ProtocolMessageRead,h),this.f.fire(new f(P,w,R,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class E{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=i.$Se.alloc(d.HeaderLength);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent(O.ProtocolHeaderWrite,{messageType:p(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent(O.ProtocolMessageWrite,c.data),this.j(h,c.data)}g(c,h){const P=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,P}h(){const c=i.$Se.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent(O.ProtocolWrite,{byteLength:c.byteLength}),this.c.write(c)}}class g extends v.$Zc{constructor(c){super(),this.f=new r.$qe,this.onMessage=this.f.event,this.g=new r.$qe,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new E(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(h=>{h.type===$.Regular&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new f($.Regular,0,0,c))}}e.$vi=g;class S extends D.$pi{static fromSocket(c,h){return new S(new g(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,P=null){super(c,h,P),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$wi=S;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$qe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$xi=k;class s{constructor(c){this.data=c,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,P=this.a;for(;P;)c[h++]=P.data,P=P.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new s(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class t{static{this.a=10}static{this.b=null}static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<t.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=t.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+t.a)*1e3;let P=0;for(let w=0;w<t.a;w++)c-this.c[w]<=h&&P++;return 1-P/t.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.d-this.f}constructor(c){this.v=new k,this.onControlMessage=this.v.event,this.w=new k,this.onMessage=this.w.event,this.x=new k,this.onDidDispose=this.x.event,this.y=new k,this.onSocketClose=this.y.event,this.z=new k,this.onSocketTimeout=this.z.event,this.t=c.loadEstimator??t.getInstance(),this.u=c.sendKeepAlive??!0,this.a=!1,this.c=new a,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new v.$Yc,this.p=c.socket,this.q=this.s.add(new E(this.p)),this.r=this.s.add(new y(this.p)),this.s.add(this.r.onMessage(h=>this.A(h))),this.s.add(this.p.onClose(h=>this.y.fire(h))),c.initialChunk&&this.r.acceptChunk(c.initialChunk),this.u?this.m=setInterval(()=>{this.E()},d.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const c=new f($.Disconnect,0,0,m());this.q.write(c),this.q.flush()}}sendPause(){const c=new f($.Pause,0,0,m());this.q.write(c)}sendResume(){const c=new f($.Resume,0,0,m());this.q.write(c)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.s.dispose(),this.s=new v.$Yc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=c,this.q=this.s.add(new E(this.p)),this.r=this.s.add(new y(this.p)),this.s.add(this.r.onMessage(P=>this.A(P))),this.s.add(this.p.onClose(P=>this.y.fire(P))),this.r.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.j=this.h;const c=new f($.Ack,0,this.j,m());this.q.write(c);const h=this.c.toArray();for(let P=0,w=h.length;P<w;P++)this.q.write(h[P]);this.C()}acceptDisconnect(){this.x.fire()}A(c){if(c.ack>this.f){this.f=c.ack;do{const h=this.c.peek();if(h&&h.id<=c.ack)this.c.pop();else break}while(!0)}switch(c.type){case $.None:break;case $.Regular:{if(c.id>this.h)if(c.id!==this.h+1){const h=Date.now();h-this.n>1e4&&(this.n=h,this.q.write(new f($.ReplayRequest,0,0,m())))}else this.h=c.id,this.k=Date.now(),this.B(),this.w.fire(c.data);break}case $.Control:{this.v.fire(c.data);break}case $.Ack:break;case $.Disconnect:{this.x.fire();break}case $.ReplayRequest:{const h=this.c.toArray();for(let P=0,w=h.length;P<w;P++)this.q.write(h[P]);this.C();break}case $.Pause:{this.q.pause();break}case $.Resume:{this.q.resume();break}case $.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(c){const h=++this.d;this.j=this.h;const P=new f($.Regular,h,this.j,c);this.c.push(P),this.a||(this.q.write(P),this.C())}sendControl(c){const h=new f($.Control,0,0,c);this.q.write(h)}B(){if(this.h<=this.j||this.l)return;const c=Date.now()-this.k;if(c>=d.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},d.AcknowledgeTime-c+5)}C(){if(this.d<=this.f||this.g||this.a)return;const c=this.c.peek(),h=Date.now()-c.writtenTime,P=Date.now()-this.r.lastReadTime,w=Date.now()-this.o;if(h>=d.TimeoutTime&&P>=d.TimeoutTime&&w>=d.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:P});return}const R=Math.max(d.TimeoutTime-h,d.TimeoutTime-P,d.TimeoutTime-w,500);this.g=setTimeout(()=>{this.g=null,this.C()},R)}D(){if(this.h<=this.j)return;this.j=this.h;const c=new f($.Ack,0,this.j,m());this.q.write(c)}E(){this.j=this.h;const c=new f($.KeepAlive,0,this.j,m());this.q.write(c)}}e.$yi=o});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[35],ue([0,1,13,15,11]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pY=void 0,i=Ge(i);class D{constructor(){this.a=new WeakMap}on(I,b){const l=(m,...u)=>{this.b(I,m)&&b(m,...u)};return this.a.set(b,l),i.default.ipcMain.on(I,l),this}once(I,b){return i.default.ipcMain.once(I,(l,...m)=>{this.b(I,l)&&b(l,...m)}),this}handle(I,b){return i.default.ipcMain.handle(I,(l,...m)=>this.b(I,l)?b(l,...m):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return i.default.ipcMain.removeHandler(I),this}removeListener(I,b){const l=this.a.get(b);return l&&(i.default.ipcMain.removeListener(I,l),this.a.delete(b)),this}b(I,b){if(!I||!I.startsWith("vscode:"))return(0,r.$4)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const l=b.senderFrame,m=l.url;if(!m||m==="about:blank")return!0;let u="unknown";try{u=new URL(m).host}catch{return(0,r.$4)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${m}'.`),!1}return u!==v.$4g?((0,r.$4)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${u}'.`),!1):l.parent!==null?((0,r.$4)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${u}' is not a main frame.`),!1):!0}}e.$pY=new D}),define(le[164],ue([0,1,13,35,155]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qY=D;function D(){r.$pY.on(v.$nY,(I,b,l,m,u)=>{const $=O(I,m,l);$.popup({x:u?u.x:void 0,y:u?u.y:void 0,positioningItem:u?u.positioningItem:void 0,callback:()=>{$&&I.sender.send(v.$oY,b)}})})}function O(I,b,l){const m=new i.Menu;return l.forEach(u=>{let $;u.type==="separator"?$=new i.MenuItem({type:u.type}):Array.isArray(u.submenu)?$=new i.MenuItem({submenu:O(I,b,u.submenu),label:u.label}):$=new i.MenuItem({label:u.label,type:u.type,accelerator:u.accelerator,checked:u.checked,enabled:u.enabled,visible:u.visible,click:(p,d,f)=>I.sender.send(b,u.id,f)}),m.append($)}),m}}),define(le[165],ue([0,1,35,17,4,2,45,156]),function(G,e,i,r,v,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wY=void 0;function b(m,u){const $=v.Event.fromNodeEventEmitter(i.$pY,u,(d,f)=>({event:d,message:f})),p=v.Event.filter($,({event:d})=>d.sender.id===m);return v.Event.map(p,({message:d})=>d&&r.$Se.wrap(d))}class l extends O.$oi{static{this.b=new Map}static d(){const u=v.Event.fromNodeEventEmitter(i.$pY,"vscode:hello",({sender:$})=>$);return v.Event.map(u,$=>{const p=$.id;l.b.get(p)?.dispose();const f=new v.$qe;l.b.set(p,(0,D.$Xc)(()=>f.fire()));const y=b(p,"vscode:message"),E=v.Event.any(v.Event.signal(b(p,"vscode:disconnect")),f.event);return{protocol:new I.$vY($,y),onDidClientDisconnect:E}})}constructor(){super(l.d())}}e.$wY=l}),define(le[122],ue([0,1,35,4,33,163]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xY=void 0,e.$yY=I;class O extends D.$tY{constructor(l,m){super({addEventListener:(u,$)=>l.addListener(u,$),removeEventListener:(u,$)=>l.removeListener(u,$),postMessage:u=>l.postMessage(u),start:()=>l.start(),close:()=>l.close()},m)}}e.$xY=O;async function I(b){if(b.isDestroyed()||b.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,v.$7g)();b.webContents.send("vscode:createMessageChannel",l);const m=r.Event.fromNodeEventEmitter(i.$pY,"vscode:createMessageChannelResult",($,p)=>({nonce:p,port:$.ports[0]})),{port:u}=await r.Event.toPromise(r.Event.once(r.Event.filter(m,$=>$.nonce===l)));return u}}),define(le[166],ue([0,1,44,8,17,22,159,15,4,2,37,96,82,45]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0,I=Ie(I);class d extends p.$mi{constructor(E){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",g=>v.$Se.wrap(Buffer.from(g,"base64")))},E),process.once("disconnect",()=>this.dispose())}}e.$pr=d;class f{constructor(E,g){this.i=E,this.j=g,this.c=new Set,this.g=new Map,this.h=new b.$qe,this.onDidProcessExit=this.h.event;const S=g&&g.timeout?g.timeout:6e4;this.b=new r.$Hh(S),this.d=null,this.f=null}getChannel(E){const g=this;return{call(S,k,s){return g.k(E,S,k,s)},listen(S,k){return g.l(E,S,k)}}}k(E,g,S,k=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(I.$0());this.b.cancel();const s=this.n(E),a=(0,r.$xh)(n=>s.call(g,S,n)),t=k.onCancellationRequested(()=>a.cancel()),o=(0,l.$Xc)(()=>a.cancel());return this.c.add(o),a.finally(()=>{t.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),a}l(E,g,S){if(!this.b)return b.Event.None;this.b.cancel();let k;const s=new b.$qe({onWillAddFirstListener:()=>{k=this.n(E).listen(g,S)(s.fire,s),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const E=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,m.$ko)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,$.$rm)(g.env),this.d=(0,i.fork)(this.i,E,g);const S=new b.$qe,s=b.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,O.$lr)(h)){(0,O.log)(h,`IPC Library: ${this.j.serverName}`);return}S.fire(v.$Se.wrap(Buffer.from(h,"base64")))}),a=this.j.useQueue?(0,u.$Em)(this.d):this.d,t=h=>this.d&&this.d.connected&&a.send(h.buffer.toString("base64")),o=S.event,n={send:t,onMessage:o};this.f=new p.$ni(n);const c=()=>this.o();process.once("exit",c),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,P)=>{process.removeListener("exit",c),s.dispose(),this.c.forEach(w=>(0,l.$Uc)(w)),this.c.clear(),h!==0&&P!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+P),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:P})})}return this.f}n(E){let g=this.g.get(E);return g||(g=this.m.getChannel(E),this.g.set(E,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$qr=f}),define(le[123],ue([0,1,8,4,2,83,12]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.StorageState=e.StorageHint=void 0,e.$jq=b;var I;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function b($){const p=$;return p?.changed instanceof Map||p?.deleted instanceof Set}var l;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(l||(e.StorageState=l={}));class m extends v.$Zc{static{this.a=100}constructor(p,d=Object.create(null)){super(),this.r=p,this.s=d,this.b=this.B(new r.$te),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new i.$Ih(m.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((d,f)=>this.w(f,d)),p.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(p,d){if(this.c===l.Closed)return;let f=!1;(0,O.$sg)(d)?f=this.f.delete(p):this.f.get(p)!==d&&(this.f.set(p,d),f=!0),f&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,d){const f=this.f.get(p);return(0,O.$sg)(f)?d:f}getBoolean(p,d){const f=this.get(p);return(0,O.$sg)(f)?d:f==="true"}getNumber(p,d){const f=this.get(p);return(0,O.$sg)(f)?d:parseInt(f,10)}getObject(p,d){const f=this.get(p);return(0,O.$sg)(f)?d:(0,D.$gi)(f)}async set(p,d,f=!1){if(this.c===l.Closed)return;if((0,O.$sg)(d))return this.delete(p,f);const y=(0,O.$lg)(d)||Array.isArray(d)?(0,D.$fi)(d):String(d);if(this.f.get(p)!==y)return this.f.set(p,y),this.j.set(p,y),this.h.delete(p),this.b.fire({key:p,external:f}),this.D()}async delete(p,d=!1){if(!(this.c===l.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:d}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(!(this.c===l.Closed||this.m))return this.D(p)}async D(p){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$kq=m;class u{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((d,f)=>this.a.set(f,d)),p.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$lq=u}),define(le[167],ue([0,1,26,8,4,31,10,23]),function(G,e,i,r,v,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UY=void 0,i=Ie(i);class b{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return v.Event.None}static{this.a=2e3}static{this.b=256}constructor(u,$=Object.create(null)){this.g=u,this.h=$,this.c=(0,O.$sc)(this.g),this.d=new l(this.h.logging),this.f=this.n(this.g)}async getItems(){const u=await this.f,$=new Map;return(await this.s(u,"SELECT * FROM ItemTable")).forEach(d=>$.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${$.size} rows`),$}async updateItems(u){const $=await this.f;return this.j($,u)}j(u,$){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${$.insert?(0,D.$Dc)($.insert):"0"}), delete(${$.delete?(0,D.$Ec)($.delete):"0"})`),this.t(u,()=>{const p=$.insert,d=$.delete;if(p&&p.size>0){const f=[];f.push([]);let y=0;p.forEach((E,g)=>{let S=f[y];S.length>b.b&&(y++,S=[],f.push(S)),S.push(g,E)}),f.forEach(E=>{this.u(u,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,g=>g.run(E),()=>{const g=[];let S=0;return p.forEach((k,s)=>{g.push(s),S+=k.length}),`Keys: ${g.join(", ")} Length: ${S}`})})}if(d&&d.size){const f=[];f.push([]);let y=0;d.forEach(E=>{let g=f[y];g.length>b.b&&(y++,g=[],f.push(g)),g.push(E)}),f.forEach(E=>{this.u(u,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,g=>g.run(E),()=>{const g=[];return d.forEach(S=>{g.push(S)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const u=await this.f;return this.q(u,"VACUUM")}async close(u){this.d.trace(`[storage ${this.c}] close()`);const $=await this.f;return this.k($,u)}k(u,$){return new Promise((p,d)=>{u.db.close(f=>(f&&this.o(u,`[storage ${this.c}] close(): ${f}`),this.g===b.IN_MEMORY_PATH?p():!u.isErroneous&&!u.isInMemory?this.l().then(p,y=>(this.d.error(`[storage ${this.c}] backup(): ${y}`),p())):typeof $=="function"?i.promises.unlink(this.g).then(()=>this.p(this.g).then(y=>{const E=()=>this.k(y,void 0);return this.j(y,{insert:$()}).then(()=>E(),g=>(E(),Promise.reject(g)))})).then(p,d):d(f||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const u=this.m(this.g);return I.Promises.copy(this.g,u,{preserveSymlinks:!1})}m(u){return`${u}.backup`}async checkIntegrity(u){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${u})`);const $=await this.f,p=await this.r($,u?"PRAGMA integrity_check":"PRAGMA quick_check"),d=u?p.integrity_check:p.quick_check;return $.isErroneous?`${d} (last error: ${$.lastError})`:$.isInMemory?`${d} (in-memory!)`:d}async n(u,$=!0){this.d.trace(`[storage ${this.c}] open(${u}, retryOnBusy: ${$})`);try{return await this.p(u)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&$)return await(0,r.$Lh)(b.a),this.n(u,!1);try{await i.promises.unlink(u);try{await I.Promises.rename(this.m(u),u,!1)}catch{}return await this.p(u)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(b.IN_MEMORY_PATH)}}}o(u,$){u.isErroneous=!0,u.lastError=$,this.d.error($)}p(u){return new Promise(($,p)=>{new Promise((d,f)=>{G(["@vscode/sqlite3"],d,f)}).then(Ie).then(d=>{const f=this.d.isTracing?d.verbose().Database:d.Database,y={db:new f(u,E=>E?y.db&&E.code!=="SQLITE_CANTOPEN"?y.db.close(()=>p(E)):p(E):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>$(y),g=>y.db.close(()=>p(g)))),isInMemory:u===b.IN_MEMORY_PATH};y.db.on("error",E=>this.o(y,`[storage ${this.c}] Error (event): ${E}`)),this.d.isTracing&&y.db.on("trace",E=>this.d.trace(`[storage ${this.c}] Trace (event): ${E}`))},p)})}q(u,$){return new Promise((p,d)=>{u.db.exec($,f=>f?(this.o(u,`[storage ${this.c}] exec(): ${f}`),d(f)):p())})}r(u,$){return new Promise((p,d)=>{u.db.get($,(f,y)=>f?(this.o(u,`[storage ${this.c}] get(): ${f}`),d(f)):p(y))})}s(u,$){return new Promise((p,d)=>{u.db.all($,(f,y)=>f?(this.o(u,`[storage ${this.c}] all(): ${f}`),d(f)):p(y))})}t(u,$){return new Promise((p,d)=>{u.db.serialize(()=>{u.db.run("BEGIN TRANSACTION"),$(),u.db.run("END TRANSACTION",f=>f?(this.o(u,`[storage ${this.c}] transaction(): ${f}`),d(f)):p())})})}u(u,$,p,d){const f=u.db.prepare($),y=E=>{this.o(u,`[storage ${this.c}] prepare(): ${E} (${$}). Details: ${d()}`)};f.on("error",y),p(f),f.finalize(E=>{E&&y(E),f.removeListener("error",y)})}}e.$UY=b;class l{static{this.a="VSCODE_TRACE_STORAGE"}constructor(u){u&&typeof u.logTrace=="function"&&process.env[l.a]&&(this.b=u.logTrace),u&&typeof u.logError=="function"&&(this.c=u.logError)}get isTracing(){return!!this.b}trace(u){this.b?.(u)}error(u){this.c?.(u)}}}),define(le[168],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qib=i,e.$Rib=r;function i(v){return v&&v.hasOwnProperty("folderUri")}function r(v){return v&&v.hasOwnProperty("workspace")}}),define(le[169],ue([0,1,7]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=r,e.$dhc=v,e.$ehc=D;function r(O){return typeof O?.backupFolder=="string"}function v(O){let I=[];try{Array.isArray(O.workspaces)&&(I=O.workspaces.map(b=>({workspace:{id:b.id,configPath:i.URI.parse(b.configURIPath)},remoteAuthority:b.remoteAuthority})))}catch{}return I}function D(O){let I=[];try{Array.isArray(O.folders)&&(I=O.folders.map(b=>({folderUri:i.URI.parse(b.folderUri),remoteAuthority:b.remoteAuthority})))}catch{}return I}}),define(le[170],ue([0,1,39,15,9]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.TokenType=void 0;var D;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(D||(e.TokenType=D={}));function O(...m){switch(m.length){case 1:return(0,v.localize)(1693,null,m[0]);case 2:return(0,v.localize)(1694,null,m[0],m[1]);case 3:return(0,v.localize)(1695,null,m[0],m[1],m[2]);default:return}}const I=(0,v.localize)(1696,null),b=(0,v.localize)(1697,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return u.isTripleEq?"===":"==";case D.NotEq:return u.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return u.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return u.lexeme;case D.QuotedStr:return u.lexeme;case D.Error:return u.lexeme;case D.EOF:return"EOF";default:throw(0,r.$_)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this.b=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this.g}reset(u){return this.c=u,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case i.CharCode.OpenParen:this.k(D.LParen);break;case i.CharCode.CloseParen:this.k(D.RParen);break;case i.CharCode.ExclamationMark:if(this.h(i.CharCode.Equals)){const $=this.h(i.CharCode.Equals);this.f.push({type:D.NotEq,offset:this.d,isTripleEq:$})}else this.k(D.Neg);break;case i.CharCode.SingleQuote:this.o();break;case i.CharCode.Slash:this.q();break;case i.CharCode.Equals:if(this.h(i.CharCode.Equals)){const $=this.h(i.CharCode.Equals);this.f.push({type:D.Eq,offset:this.d,isTripleEq:$})}else this.h(i.CharCode.Tilde)?this.k(D.RegexOp):this.l(O("==","=~"));break;case i.CharCode.LessThan:this.k(this.h(i.CharCode.Equals)?D.LtEq:D.Lt);break;case i.CharCode.GreaterThan:this.k(this.h(i.CharCode.Equals)?D.GtEq:D.Gt);break;case i.CharCode.Ampersand:this.h(i.CharCode.Ampersand)?this.k(D.And):this.l(O("&&"));break;case i.CharCode.Pipe:this.h(i.CharCode.Pipe)?this.k(D.Or):this.l(O("||"));break;case i.CharCode.Space:case i.CharCode.CarriageReturn:case i.CharCode.Tab:case i.CharCode.LineFeed:case i.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(D.EOF),Array.from(this.f)}h(u){return this.r()||this.c.charCodeAt(this.e)!==u?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?i.CharCode.Null:this.c.charCodeAt(this.e)}k(u){this.f.push({type:u,offset:this.d})}l(u){const $=this.d,p=this.c.substring(this.d,this.e),d={type:D.Error,offset:this.d,lexeme:p};this.g.push({offset:$,lexeme:p,additionalInfo:u}),this.f.push(d)}n(){this.m.lastIndex=this.d;const u=this.m.exec(this.c);if(u){this.e=this.d+u[0].length;const $=this.c.substring(this.d,this.e),p=l.b.get($);p?this.k(p):this.f.push({type:D.Str,lexeme:$,offset:this.d})}}o(){for(;this.j()!==i.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:D.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let u=this.e,$=!1,p=!1;for(;;){if(u>=this.c.length){this.e=u,this.l(b);return}const f=this.c.charCodeAt(u);if($)$=!1;else if(f===i.CharCode.Slash&&!p){u++;break}else f===i.CharCode.OpenSquareBracket?p=!0:f===i.CharCode.Backslash?$=!0:f===i.CharCode.CloseSquareBracket&&(p=!1);u++}for(;u<this.c.length&&l.a.has(this.c.charCodeAt(u));)u++;this.e=u;const d=this.c.substring(this.d,this.e);this.f.push({type:D.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fj=l}),define(le[171],ue([0,1,4,2]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=void 0;class v{constructor(){this.a=new i.$qe,this.b=new i.$qe,this.c=new i.$qe,this.d=new i.$qe}static{this.ChannelName="extensionhostdebugservice"}call(I,b,l){switch(b){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(I,b,l){switch(b){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$6o=v;class D extends r.$Zc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,b,l){this.b.call("attach",[I,b,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,b){this.b.call("terminate",[I,b])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,b){return this.b.call("openExtensionDevelopmentHostWindow",[I,b])}}e.$7o=D}),define(le[172],ue([0,1,157,54,11,10,38,18,7]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=void 0,e.$an=m,e.$bn=u,e.$$m=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,D.$rc)(v.$5g.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return b.URI.file((0,D.$oc)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.b.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,I.$lh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:v.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$lh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,i.$0m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$oc)(this.userDataPath,"logs",p)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$lh)(b.URI.file((0,D.$oc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$lh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$lh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$lh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=O.env.VSCODE_PORTABLE;return p?b.URI.file((0,D.$oc)(p,"argv.json")):(0,I.$lh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,D.$oc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,D.$pc)(p):(0,D.$mc)((0,D.$oc)(v.$5g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?b.URI.file((0,D.$pc)(p)):b.URI.file((0,D.$oc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,D.$pc)(p);const d=O.env.VSCODE_EXTENSIONS;if(d)return d;const f=O.env.VSCODE_PORTABLE;return f?(0,D.$oc)(f,"extensions"):(0,I.$lh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(d=>/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,D.$mc)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?b.URI.parse(p):b.URI.file((0,D.$mc)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.$$m.test(p))}get extensionLogLevel(){const p=[];for(const d of this.args.log||[]){const f=e.$$m.exec(d);f&&f[1]&&f[2]&&p.push([f[1],f[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,I.$lh)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=O.env.VSCODE_PORTABLE;return p?b.URI.file((0,D.$oc)(p,"policy.json")):(0,I.$lh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,d,f){this.a=p,this.b=d,this.c=f,this.editSessionId=this.args.editSessionId}}e.$_m=l,ke([r.$ci],l.prototype,"appRoot",null),ke([r.$ci],l.prototype,"userHome",null),ke([r.$ci],l.prototype,"userDataPath",null),ke([r.$ci],l.prototype,"appSettingsHome",null),ke([r.$ci],l.prototype,"tmpDir",null),ke([r.$ci],l.prototype,"cacheHome",null),ke([r.$ci],l.prototype,"stateResource",null),ke([r.$ci],l.prototype,"userRoamingDataHome",null),ke([r.$ci],l.prototype,"userDataSyncHome",null),ke([r.$ci],l.prototype,"sync",null),ke([r.$ci],l.prototype,"machineSettingsResource",null),ke([r.$ci],l.prototype,"workspaceStorageHome",null),ke([r.$ci],l.prototype,"localHistoryHome",null),ke([r.$ci],l.prototype,"keyboardLayoutResource",null),ke([r.$ci],l.prototype,"argvResource",null),ke([r.$ci],l.prototype,"isExtensionDevelopment",null),ke([r.$ci],l.prototype,"untitledWorkspacesHome",null),ke([r.$ci],l.prototype,"builtinExtensionsPath",null),ke([r.$ci],l.prototype,"extensionsPath",null),ke([r.$ci],l.prototype,"extensionDevelopmentLocationURI",null),ke([r.$ci],l.prototype,"extensionDevelopmentKind",null),ke([r.$ci],l.prototype,"extensionTestsLocationURI",null),ke([r.$ci],l.prototype,"debugExtensionHost",null),ke([r.$ci],l.prototype,"logLevel",null),ke([r.$ci],l.prototype,"extensionLogLevel",null),ke([r.$ci],l.prototype,"serviceMachineIdResource",null),ke([r.$ci],l.prototype,"disableTelemetry",null),ke([r.$ci],l.prototype,"disableWorkspaceTrust",null),ke([r.$ci],l.prototype,"useInMemorySecretStorage",null),ke([r.$ci],l.prototype,"policyFile",null);function m($,p){return u($["inspect-extensions"],$["inspect-brk-extensions"],5870,p,$.debugId,$.extensionEnvironment)}function u($,p,d,f,y,E){const S=Number(p||$)||(f?null:d),k=S?!!p:!1;let s;if(E)try{s=JSON.parse(E)}catch{}return{port:S,break:k,debugId:y,env:s}}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[124],ue([0,1,284,3,9]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=void 0,e.$Im=I,e.$Jm=l,e.$Km=p,e.$Lm=d,i=Ge(i);const D={o:(0,v.localize)(1713,null),e:(0,v.localize)(1714,null),t:(0,v.localize)(1715,null)};e.$Gm=["tunnel","serve-web"],e.$Hm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,v.localize)(1716,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,v.localize)(1717,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,v.localize)(1718,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,v.localize)(1719,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,v.localize)(1720,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,v.localize)(1721,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,v.localize)(1722,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,v.localize)(1723,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,v.localize)(1724,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,v.localize)(1725,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,v.localize)(1726,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,v.localize)(1727,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,v.localize)(1728,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,v.localize)(1729,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,v.localize)(1730,null)},"show-versions":{type:"boolean",cat:"e",description:(0,v.localize)(1731,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,v.localize)(1732,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,v.localize)(1733,null)},"pre-release":{type:"boolean",cat:"e",description:(0,v.localize)(1734,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,v.localize)(1735,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,v.localize)(1736,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,v.localize)(1737,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,v.localize)(1738,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,v.localize)(1739,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,v.localize)(1740,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,v.localize)(1741,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,v.localize)(1742,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,v.localize)(1743,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,v.localize)(1744,null)},sync:{type:"string",cat:"t",description:(0,v.localize)(1745,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,v.localize)(1746,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,v.localize)(1747,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,v.localize)(1748,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,v.localize)(1749,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,v.localize)(1750,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,v.localize)(1751,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(f,y,E=O){const g=f.find(h=>h.length>0&&h[0]!=="-"),S={},k=["_"],s=[],a={};let t;for(const h in y){const P=y[h];P.type==="subcommand"?h===g&&(t=P):(P.alias&&(S[h]=P.alias),P.type==="string"||P.type==="string[]"?(k.push(h),P.deprecates&&k.push(...P.deprecates)):P.type==="boolean"&&(s.push(h),P.deprecates&&s.push(...P.deprecates)),P.global&&(a[h]=P))}if(t&&g){const h=a;for(const T in t.options)h[T]=t.options[T];const P=f.filter(T=>T!==g),w=E.getSubcommandReporter?E.getSubcommandReporter(g):void 0,R=I(P,h,w);return{[g]:R,_:[]}}const o=(0,i.default)(f,{string:k,boolean:s,alias:S}),n={},c=o;n._=o._.map(h=>String(h)).filter(h=>h.length>0),delete c._;for(const h in y){const P=y[h];if(P.type==="subcommand")continue;P.alias&&delete c[P.alias];let w=c[h];if(P.deprecates)for(const R of P.deprecates)c.hasOwnProperty(R)&&(w||(w=c[R],w&&E.onDeprecatedOption(R,P.deprecationMessage||(0,v.localize)(1752,null,h))),delete c[R]);if(typeof w<"u"){if(P.type==="string[]"){if(Array.isArray(w)||(w=[w]),!P.allowEmptyValue){const R=w.filter(T=>T.length>0);R.length!==w.length&&(E.onEmptyValue(h),w=R.length>0?R:void 0)}}else P.type==="string"&&(Array.isArray(w)?(w=w.pop(),E.onMultipleValues(h,w)):!w&&!P.allowEmptyValue&&(E.onEmptyValue(h),w=void 0));n[h]=w,P.deprecationMessage&&E.onDeprecatedOption(h,P.deprecationMessage)}delete c[h]}for(const h in c)E.onUnknownOption(h);return n}function b(f,y){let E="";return y.args&&(Array.isArray(y.args)?E=` <${y.args.join("> <")}>`:E=` <${y.args}>`),y.alias?`-${y.alias} --${f}${E}`:`--${f}${E}`}function l(f,y){const E=[];for(const g in f){const S=f[g],k=b(g,S);E.push([k,S.description])}return m(E,y)}function m(f,y){const g=f.reduce((s,a)=>Math.max(s,a[0].length),12)+2+1;if(y-g<25)return f.reduce((s,a)=>s.concat([`  ${a[0]}`,`      ${a[1]}`]),[]);const S=y-g-1,k=[];for(const s of f){const a=s[0],t=$(s[1],S),o=u(g-a.length-2);k.push("  "+a+o+t[0]);for(let n=1;n<t.length;n++)k.push(u(g)+t[n])}return k}function u(f){return" ".repeat(f)}function $(f,y){const E=[];for(;f.length;){const g=f.length<y?f.length:f.lastIndexOf(" ",y),S=f.slice(0,g).trim();f=f.slice(g),E.push(S)}return E}function p(f,y,E,g,S){const k=process.stdout.isTTY&&process.stdout.columns||80,s=S?.noInputFiles!==!0?`[${(0,v.localize)(1753,null)}...]`:"",a=[`${f} ${E}`];a.push(""),a.push(`${(0,v.localize)(1754,null)}: ${y} [${(0,v.localize)(1755,null)}]${s}`),a.push(""),S?.noPipe!==!0&&(r.$l?a.push((0,v.localize)(1756,null,y)):a.push((0,v.localize)(1757,null,y)),a.push(""));const t={},o=[];for(const n in g){const c=g[n];if(c.type==="subcommand")c.description&&o.push({command:n,description:c.description});else if(c.description&&c.cat){let h=t[c.cat];h||(t[c.cat]=h={}),h[n]=c}}for(const n in t){const c=n,h=t[c];h&&(a.push(D[c]),a.push(...l(h,k)),a.push(""))}return o.length&&(a.push((0,v.localize)(1758,null)),a.push(...m(o.map(n=>[n.command,n.description]),k)),a.push("")),a.join(`
`)}function d(f,y){return`${f||(0,v.localize)(1759,null)}
${y||(0,v.localize)(1760,null)}
${process.arch}`}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[69],ue([0,1,285,9,124]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=I,e.$Nm=b,e.$Om=l,e.$Pm=m,i=Ge(i);function D(u,$){const p=(S,k)=>{console.warn((0,r.localize)(1761,null,S,k))},d=S=>{console.warn((0,r.localize)(1762,null,S))},f=(S,k)=>{console.warn((0,r.localize)(1763,null,S,k))},y=S=>({onUnknownOption:k=>{v.$Gm.includes(S)||console.warn((0,r.localize)(1764,null,k,S))},onMultipleValues:p,onEmptyValue:d,onDeprecatedOption:f,getSubcommandReporter:v.$Gm.includes(S)?y:void 0}),E={onUnknownOption:S=>{console.warn((0,r.localize)(1765,null,S))},onMultipleValues:p,onEmptyValue:d,onDeprecatedOption:f,getSubcommandReporter:y},g=(0,v.$Im)(u,v.$Hm,$?E:void 0);return g.goto&&g._.forEach(S=>(0,i.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(S),(0,r.localize)(1766,null))),g}function O(u){const $=u.findIndex(p=>!/^-/.test(p));if($>-1)return[...u.slice(0,$),...u.slice($+1)]}function I(u){let[,...$]=u;process.env.VSCODE_DEV&&($=O($)||[]);const p=!m(process.env);return D($,p)}function b(u){let[,,...$]=u;return process.env.VSCODE_DEV&&($=O($)||[]),D($,!0)}function l(u,...$){const p=u.indexOf("--");return p===-1?u.push(...$):u.splice(p,0,...$),u}function m(u){return u.VSCODE_CLI==="1"}}),function(){function G(e,i,r){function v(O,I){const b=D(O,I),l=[b];return e.isAbsolute(b)||l.unshift(r),e.resolve(...l)}function D(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,I);const m=O["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(u,"AppData","Roaming")}break;case"darwin":l=e.join(i.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,I)}return{getUserDataPath:v}}if(typeof define=="function")define(le[173],ue([97,27,38]),function(e,i,r){return G(e,i,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=G(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[98],ue([0,1,27,172,173]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$dn=O,e.$en=I;class D extends r.$_m{constructor(l,m){super(l,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,v.getUserDataPath)(l,m.nameShort)},m)}}e.$cn=D;function O(b,l){return(0,r.$bn)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,l,b.extensionEnvironment)}function I(b,l){return(0,r.$bn)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,l,b.extensionEnvironment)}}),define(le[174],ue([0,1,26,27,32]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=D;function D(O){const I=(0,v.$Sg)((0,r.tmpdir)());try{return(0,i.writeFileSync)(I,""),O&&console.log(`Marker file for --wait created: ${I}`),I}catch(b){O&&console.error(`Failed to create marker file for --wait: ${b}`);return}}}),define(le[175],ue([0,1,12,9]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=v;function v(O,I,b,l){try{D(O,I,b,l)}catch(m){O.error(m?.message??m)}return I}function D(O,I,b,l){const m=(u,$,p)=>{const d=u[$];if((0,i.$jg)(d)){const f=d,y=f.length;if(y>1&&f[0]==="%"&&f[y-1]==="%"){const E=f.substr(1,y-2);let g=b[E];g===void 0&&l&&(g=l[E]);const S=typeof g=="string"?g:g?.message,k=l?.[E],s=typeof k=="string"?k:k?.message;if(!S){s||O.warn(`[${I.name}]: ${(0,r.localize)(1814,null,E)}`);return}if(p&&($==="title"||$==="category")&&s&&s!==S){const a={value:S,original:s};u[$]=a}else u[$]=S}}else if((0,i.$lg)(d))for(const f in d)d.hasOwnProperty(f)&&(f==="commands"?m(d,f,!0):m(d,f,p));else if(Array.isArray(d))for(let f=0;f<d.length;f++)m(d,f,p)};for(const u in I)I.hasOwnProperty(u)&&m(I,u)}}),define(le[176],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const i={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(i)}),define(le[84],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=void 0;class i{constructor(v,D=[],O=!1){this.ctor=v,this.staticArguments=D,this.supportsDelayedInstantiation=O}}e.$Hi=i}),define(le[177],ue([0,1,84]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Zs=D,e.$1s=O;const r=[];var v;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(v||(e.InstantiationType=v={}));function D(I,b,l){b instanceof i.$Hi||(b=new i.$Hi(b,[],!!l)),r.push([I,b])}function O(){return r}}),define(le[178],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;class i{constructor(D,O){this.key=D,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$Cr=i;class r{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const O of this.a.values())O.outgoing.size===0&&D.push(O);return D}insertEdge(D,O){const I=this.lookupOrInsertNode(D),b=this.lookupOrInsertNode(O);I.outgoing.set(b.key,b),b.incoming.set(I.key,I)}removeNode(D){const O=this.b(D);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(D){const O=this.b(D);let I=this.a.get(O);return I||(I=new i(O,D),this.a.set(O,I)),I}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[O,I]of this.a)D.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,O]of this.a){const I=new Set([D]),b=this.c(O,I);if(b)return b}}c(D,O){for(const[I,b]of D.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const l=this.c(b,O);if(l)return l;O.delete(I)}}}e.$Dr=r}),define(le[6],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e._util=void 0,e.$Ki=v,e.$Li=D;var i;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(b){return b[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(i||(e._util=i={})),e.$Ji=v("instantiationService");function r(O,I,b){I[i.DI_TARGET]===I?I[i.DI_DEPENDENCIES].push({id:O,index:b}):(I[i.DI_DEPENDENCIES]=[{id:O,index:b}],I[i.DI_TARGET]=I)}function v(O){if(i.serviceIds.has(O))return i.serviceIds.get(O);const I=function(b,l,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,b,m)};return I.toString=()=>O,i.serviceIds.set(O,I),I}function D(O){return O}}),define(le[85],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0,e.$0hc=(0,i.$Ki)("auxiliaryWindowsMainService")}),define(le[70],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0,e.$fhc=(0,i.$Ki)("backupMainService")}),define(le[16],ue([0,1,12,7,6]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$ej=void 0,e.$fj=D,e.$gj=O,e.$hj=b,e.$ij=l,e.$jj=m,e.$kj=u,e.$lj=$,e.$mj=d,e.$nj=f,e.$oj=y,i=Ie(i),e.$ej=(0,v.$Ki)("configurationService");function D(E){return E&&typeof E=="object"&&(!E.overrideIdentifier||typeof E.overrideIdentifier=="string")&&(!E.resource||E.resource instanceof r.URI)}function O(E){return E&&typeof E=="object"&&(!E.overrideIdentifiers||Array.isArray(E.overrideIdentifiers))&&!E.overrideIdentifier&&(!E.resource||E.resource instanceof r.URI)}var I;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.USER=2]="USER",E[E.USER_LOCAL=3]="USER_LOCAL",E[E.USER_REMOTE=4]="USER_REMOTE",E[E.WORKSPACE=5]="WORKSPACE",E[E.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",E[E.DEFAULT=7]="DEFAULT",E[E.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function b(E){switch(E){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function l(E){return E.applicationValue!==void 0||E.userValue!==void 0||E.userLocalValue!==void 0||E.userRemoteValue!==void 0||E.workspaceValue!==void 0||E.workspaceFolderValue!==void 0}function m(E,g){const S=Object.create(null);for(const k in E)u(S,k,E[k],g);return S}function u(E,g,S,k){const s=g.split("."),a=s.pop();let t=E;for(let o=0;o<s.length;o++){const n=s[o];let c=t[n];switch(typeof c){case"undefined":c=t[n]=Object.create(null);break;case"object":if(c===null){k(`Ignoring ${g} as ${s.slice(0,o+1).join(".")} is null`);return}break;default:k(`Ignoring ${g} as ${s.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}t=c}if(typeof t=="object"&&t!==null)try{t[a]=S}catch{k(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(t)}`)}else k(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(t)}`)}function $(E,g){const S=g.split(".");p(E,S)}function p(E,g){const S=g.shift();if(g.length===0){delete E[S];return}if(Object.keys(E).indexOf(S)!==-1){const k=E[S];typeof k=="object"&&!Array.isArray(k)&&(p(k,g),Object.keys(k).length===0&&delete E[S])}}function d(E,g,S){function k(t,o){let n=t;for(const c of o){if(typeof n!="object"||n===null)return;n=n[c]}return n}const s=g.split("."),a=k(E,s);return typeof a>"u"?S:a}function f(E,g,S){Object.keys(g).forEach(k=>{k!=="__proto__"&&(k in E?i.$lg(E[k])&&i.$lg(g[k])?f(E[k],g[k],S):S&&(E[k]=g[k]):E[k]=g[k])})}function y(E){return E.replace(/[\[\]]/g,"")}}),define(le[125],ue([0,1,39,3,25,170,6,9,15]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Ij=e.$Hj=e.ContextKeyExprType=void 0,e.$Gj=m,e.$Jj=o,e.$Kj=n,e.$4j=x;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",r.$m),l.set("isLinux",r.$n),l.set("isWindows",r.$l),l.set("isWeb",r.$r),l.set("isMacNative",r.$m&&!r.$r),l.set("isEdge",r.$K),l.set("isFirefox",r.$I),l.set("isChrome",r.$H),l.set("isSafari",r.$J);function m(te,j){if(l.get(te)!==void 0)throw(0,b.$$)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(te,j)}const u=Object.prototype.hasOwnProperty;var $;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})($||(e.ContextKeyExprType=$={}));const p={regexParsingWithErrorRecovery:!0},d=(0,I.localize)(1673,null),f=(0,I.localize)(1674,null),y=(0,I.localize)(1675,null),E=(0,I.localize)(1676,null),g=(0,I.localize)(1677,null),S=(0,I.localize)(1678,null),k=(0,I.localize)(1679,null),s=(0,I.localize)(1680,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=p){this.k=j,this.d=new D.$Fj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const X=this.l();if(!this.E()){const U=this.D(),N=U.type===D.TokenType.Str?S:void 0;throw this.h.push({message:g,offset:U.offset,lexeme:D.$Fj.getLexeme(U),additionalInfo:N}),a.c}return X}catch(X){if(X!==a.c)throw X;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(D.TokenType.Or);){const X=this.o();j.push(X)}return j.length===1?j[0]:t.or(...j)}o(){const j=[this.s()];for(;this.y(D.TokenType.And);){const X=this.s();j.push(X)}return j.length===1?j[0]:t.and(...j)}s(){if(this.y(D.TokenType.Neg)){const j=this.D();switch(j.type){case D.TokenType.True:return this.z(),h.INSTANCE;case D.TokenType.False:return this.z(),P.INSTANCE;case D.TokenType.LParen:{this.z();const X=this.l();return this.A(D.TokenType.RParen,E),X?.negate()}case D.TokenType.Str:return this.z(),M.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case D.TokenType.True:return this.z(),t.true();case D.TokenType.False:return this.z(),t.false();case D.TokenType.LParen:{this.z();const X=this.l();return this.A(D.TokenType.RParen,E),X}case D.TokenType.Str:{const X=j.lexeme;if(this.z(),this.y(D.TokenType.RegexOp)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==D.TokenType.RegexStr)throw this.B("REGEX",N);const Q=N.lexeme,K=Q.lastIndexOf("/"),H=K===Q.length-1?void 0:this.w(Q.substring(K+1));let _;try{_=new RegExp(Q.substring(1,K),H)}catch{throw this.B("REGEX",N)}return ee.create(X,_)}switch(N.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const Q=[N.lexeme];this.z();let K=this.D(),H=0;for(let ye=0;ye<N.lexeme.length;ye++)N.lexeme.charCodeAt(ye)===i.CharCode.OpenParen?H++:N.lexeme.charCodeAt(ye)===i.CharCode.CloseParen&&H--;for(;!this.E()&&K.type!==D.TokenType.And&&K.type!==D.TokenType.Or;){switch(K.type){case D.TokenType.LParen:H++;break;case D.TokenType.RParen:H--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let ye=0;ye<K.lexeme.length;ye++)K.lexeme.charCodeAt(ye)===i.CharCode.OpenParen?H++:N.lexeme.charCodeAt(ye)===i.CharCode.CloseParen&&H--}if(H<0)break;Q.push(D.$Fj.getLexeme(K)),this.z(),K=this.D()}const _=Q.join(""),ae=_.lastIndexOf("/"),$e=ae===_.length-1?void 0:this.w(_.substring(ae+1));let be;try{be=new RegExp(_.substring(1,ae),$e)}catch{throw this.B("REGEX",N)}return t.regex(X,be)}case D.TokenType.QuotedStr:{const Q=N.lexeme;this.z();let K=null;if(!(0,v.$hf)(Q)){const H=Q.indexOf("/"),_=Q.lastIndexOf("/");if(H!==_&&H>=0){const ae=Q.slice(H+1,_),$e=Q[_+1]==="i"?"i":"";try{K=new RegExp(ae,$e)}catch{throw this.B("REGEX",N)}}}if(K===null)throw this.B("REGEX",N);return ee.create(X,K)}default:throw this.B("REGEX",this.D())}}if(this.y(D.TokenType.Not)){this.A(D.TokenType.In,y);const N=this.u();return t.notIn(X,N)}switch(this.D().type){case D.TokenType.Eq:{this.z();const N=this.u();if(this.x().type===D.TokenType.QuotedStr)return t.equals(X,N);switch(N){case"true":return t.has(X);case"false":return t.not(X);default:return t.equals(X,N)}}case D.TokenType.NotEq:{this.z();const N=this.u();if(this.x().type===D.TokenType.QuotedStr)return t.notEquals(X,N);switch(N){case"true":return t.not(X);case"false":return t.has(X);default:return t.notEquals(X,N)}}case D.TokenType.Lt:return this.z(),de.create(X,this.u());case D.TokenType.LtEq:return this.z(),re.create(X,this.u());case D.TokenType.Gt:return this.z(),q.create(X,this.u());case D.TokenType.GtEq:return this.z(),Y.create(X,this.u());case D.TokenType.In:return this.z(),t.in(X,this.u());default:return t.has(X)}}case D.TokenType.EOF:throw this.h.push({message:k,offset:j.offset,lexeme:"",additionalInfo:s}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this.z(),j.lexeme;case D.TokenType.True:return this.z(),"true";case D.TokenType.False:return this.z(),"false";case D.TokenType.In:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,X){if(this.C(j))return this.z();throw this.B(X,this.D())}B(j,X,U){const N=(0,I.localize)(1681,null,j,D.$Fj.getLexeme(X)),Q=X.offset,K=D.$Fj.getLexeme(X);return this.h.push({message:N,offset:Q,lexeme:K,additionalInfo:U}),a.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===D.TokenType.EOF}}e.$Hj=a;class t{static false(){return h.INSTANCE}static true(){return P.INSTANCE}static has(j){return w.create(j)}static equals(j,X){return R.create(j,X)}static notEquals(j,X){return L.create(j,X)}static regex(j,X){return ee.create(j,X)}static in(j,X){return T.create(j,X)}static notIn(j,X){return A.create(j,X)}static not(j){return M.create(j)}static and(...j){return C.create(j,null,!0)}static or(...j){return B.create(j,null,!0)}static greater(j,X){return q.create(j,X)}static greaterEquals(j,X){return Y.create(j,X)}static smaller(j,X){return de.create(j,X)}static smallerEquals(j,X){return re.create(j,X)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$Ij=t;function o(te){const j=new a({regexParsingWithErrorRecovery:!1});return te.map(X=>(j.parse(X),j.lexingErrors.length>0?j.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,I.localize)(1682,null,U.additionalInfo):(0,I.localize)(1683,null),offset:U.offset,length:U.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function n(te,j){const X=te?te.substituteConstants():void 0,U=j?j.substituteConstants():void 0;return!X&&!U?!0:!X||!U?!1:X.equals(U)}function c(te,j){return te.cmp(j)}class h{static{this.INSTANCE=new h}constructor(){this.type=$.False}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return P.INSTANCE}}e.$Lj=h;class P{static{this.INSTANCE=new P}constructor(){this.type=$.True}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return h.INSTANCE}}e.$Mj=P;class w{static create(j,X=null){const U=l.get(j);return typeof U=="boolean"?U?P.INSTANCE:h.INSTANCE:new w(j,X)}constructor(j,X){this.key=j,this.c=X,this.type=$.Defined}cmp(j){return j.type!==this.type?this.type-j.type:z(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=l.get(this.key);return typeof j=="boolean"?j?P.INSTANCE:h.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Nj=w;class R{static create(j,X,U=null){if(typeof X=="boolean")return X?w.create(j,U):M.create(j,U);const N=l.get(j);return typeof N=="boolean"?X===(N?"true":"false")?P.INSTANCE:h.INSTANCE:new R(j,X,U)}constructor(j,X,U){this.c=j,this.d=X,this.f=U,this.type=$.Equals}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=l.get(this.c);if(typeof j=="boolean"){const X=j?"true":"false";return this.d===X?P.INSTANCE:h.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Oj=R;class T{static create(j,X){return new T(j,X)}constructor(j,X){this.d=j,this.f=X,this.type=$.In,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const X=j.getValue(this.f),U=j.getValue(this.d);return Array.isArray(X)?X.includes(U):typeof U=="string"&&typeof X=="object"&&X!==null?u.call(X,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Pj=T;class A{static create(j,X){return new A(j,X)}constructor(j,X){this.d=j,this.f=X,this.type=$.NotIn,this.c=T.create(j,X)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qj=A;class L{static create(j,X,U=null){if(typeof X=="boolean")return X?M.create(j,U):w.create(j,U);const N=l.get(j);return typeof N=="boolean"?X===(N?"true":"false")?h.INSTANCE:P.INSTANCE:new L(j,X,U)}constructor(j,X,U){this.c=j,this.d=X,this.f=U,this.type=$.NotEquals}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=l.get(this.c);if(typeof j=="boolean"){const X=j?"true":"false";return this.d===X?h.INSTANCE:P.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Rj=L;class M{static create(j,X=null){const U=l.get(j);return typeof U=="boolean"?U?h.INSTANCE:P.INSTANCE:new M(j,X)}constructor(j,X){this.c=j,this.d=X,this.type=$.Not}cmp(j){return j.type!==this.type?this.type-j.type:z(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=l.get(this.c);return typeof j=="boolean"?j?h.INSTANCE:P.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Sj=M;function V(te,j){if(typeof te=="string"){const X=parseFloat(te);isNaN(X)||(te=X)}return typeof te=="string"||typeof te=="number"?j(te):h.INSTANCE}class q{static create(j,X,U=null){return V(X,N=>new q(j,N,U))}constructor(j,X,U){this.c=j,this.d=X,this.f=U,this.type=$.Greater}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Tj=q;class Y{static create(j,X,U=null){return V(X,N=>new Y(j,N,U))}constructor(j,X,U){this.c=j,this.d=X,this.f=U,this.type=$.GreaterEquals}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=de.create(this.c,this.d,this)),this.f}}e.$Uj=Y;class de{static create(j,X,U=null){return V(X,N=>new de(j,N,U))}constructor(j,X,U){this.c=j,this.d=X,this.f=U,this.type=$.Smaller}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Vj=de;class re{static create(j,X,U=null){return V(X,N=>new re(j,N,U))}constructor(j,X,U){this.c=j,this.d=X,this.f=U,this.type=$.SmallerEquals}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Wj=re;class ee{static create(j,X){return new ee(j,X)}constructor(j,X){this.d=j,this.f=X,this.type=$.Regex,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const X=this.f?this.f.source:"",U=j.f?j.f.source:"";return X<U?-1:X>U?1:0}equals(j){if(j.type===this.type){const X=this.f?this.f.source:"",U=j.f?j.f.source:"";return this.d===j.d&&X===U}return!1}substituteConstants(){return this}evaluate(j){const X=j.getValue(this.d);return this.f?this.f.test(X):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$Xj=ee;class W{static create(j){return new W(j)}constructor(j){this.c=j,this.type=$.NotRegex}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new W(this.c.map(j))}negate(){return this.c}}e.$Yj=W;function Z(te){let j=null;for(let X=0,U=te.length;X<U;X++){const N=te[X].substituteConstants();if(te[X]!==N&&j===null){j=[];for(let Q=0;Q<X;Q++)j[Q]=te[Q]}j!==null&&(j[X]=N)}return j===null?te:j}class C{static create(j,X,U){return C.d(j,X,U)}constructor(j,X){this.expr=j,this.c=X,this.type=$.And}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let X=0,U=this.expr.length;X<U;X++){const N=c(this.expr[X],j.expr[X]);if(N!==0)return N}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let X=0,U=this.expr.length;X<U;X++)if(!this.expr[X].equals(j.expr[X]))return!1;return!0}return!1}substituteConstants(){const j=Z(this.expr);return j===this.expr?this:C.create(j,this.c,!1)}evaluate(j){for(let X=0,U=this.expr.length;X<U;X++)if(!this.expr[X].evaluate(j))return!1;return!0}static d(j,X,U){const N=[];let Q=!1;for(const K of j)if(K){if(K.type===$.True){Q=!0;continue}if(K.type===$.False)return h.INSTANCE;if(K.type===$.And){N.push(...K.expr);continue}N.push(K)}if(N.length===0&&Q)return P.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(c);for(let K=1;K<N.length;K++)N[K-1].equals(N[K])&&(N.splice(K,1),K--);if(N.length===1)return N[0];for(;N.length>1;){const K=N[N.length-1];if(K.type!==$.Or)break;N.pop();const H=N.pop(),_=N.length===0,ae=B.create(K.expr.map($e=>C.create([$e,H],null,U)),null,_);ae&&(N.push(ae),N.sort(c))}if(N.length===1)return N[0];if(U){for(let K=0;K<N.length;K++)for(let H=K+1;H<N.length;H++)if(N[K].negate().equals(N[H]))return h.INSTANCE;if(N.length===1)return N[0]}return new C(N,X)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const X of this.expr)j.push(...X.keys());return j}map(j){return new C(this.expr.map(X=>X.map(j)),null)}negate(){if(!this.c){const j=[];for(const X of this.expr)j.push(X.negate());this.c=B.create(j,this,!0)}return this.c}}e.$Zj=C;class B{static create(j,X,U){return B.d(j,X,U)}constructor(j,X){this.expr=j,this.c=X,this.type=$.Or}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let X=0,U=this.expr.length;X<U;X++){const N=c(this.expr[X],j.expr[X]);if(N!==0)return N}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let X=0,U=this.expr.length;X<U;X++)if(!this.expr[X].equals(j.expr[X]))return!1;return!0}return!1}substituteConstants(){const j=Z(this.expr);return j===this.expr?this:B.create(j,this.c,!1)}evaluate(j){for(let X=0,U=this.expr.length;X<U;X++)if(this.expr[X].evaluate(j))return!0;return!1}static d(j,X,U){let N=[],Q=!1;if(j){for(let K=0,H=j.length;K<H;K++){const _=j[K];if(_){if(_.type===$.False){Q=!0;continue}if(_.type===$.True)return P.INSTANCE;if(_.type===$.Or){N=N.concat(_.expr);continue}N.push(_)}}if(N.length===0&&Q)return h.INSTANCE;N.sort(c)}if(N.length!==0){if(N.length===1)return N[0];for(let K=1;K<N.length;K++)N[K-1].equals(N[K])&&(N.splice(K,1),K--);if(N.length===1)return N[0];if(U){for(let K=0;K<N.length;K++)for(let H=K+1;H<N.length;H++)if(N[K].negate().equals(N[H]))return P.INSTANCE;if(N.length===1)return N[0]}return new B(N,X)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const X of this.expr)j.push(...X.keys());return j}map(j){return new B(this.expr.map(X=>X.map(j)),null)}negate(){if(!this.c){const j=[];for(const X of this.expr)j.push(X.negate());for(;j.length>1;){const X=j.shift(),U=j.shift(),N=[];for(const Q of oe(X))for(const K of oe(U))N.push(C.create([Q,K],null,!1));j.unshift(B.create(N,null,!1))}this.c=B.create(j,this,!0)}return this.c}}e.$1j=B;class F extends w{static{this.d=[]}static all(){return F.d.values()}constructor(j,X,U){super(j,null),this.f=X,typeof U=="object"?F.d.push({...U,key:j}):U!==!0&&F.d.push({key:j,description:U,type:X!=null?typeof X:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return R.create(this.key,j)}notEqualsTo(j){return L.create(this.key,j)}}e.$2j=F,e.$3j=(0,O.$Ki)("contextKeyService");function z(te,j){return te<j?-1:te>j?1:0}function ie(te,j,X,U){return te<X?-1:te>X?1:j<U?-1:j>U?1:0}function x(te,j){if(te.type===$.False||j.type===$.True)return!0;if(te.type===$.Or)return j.type===$.Or?ce(te.expr,j.expr):!1;if(j.type===$.Or){for(const X of j.expr)if(x(te,X))return!0;return!1}if(te.type===$.And){if(j.type===$.And)return ce(j.expr,te.expr);for(const X of te.expr)if(x(X,j))return!0;return!1}return te.equals(j)}function ce(te,j){let X=0,U=0;for(;X<te.length&&U<j.length;){const N=te[X].cmp(j[U]);if(N<0)return!1;N===0&&X++,U++}return X===te.length}function oe(te){return te.type===$.Or?te.expr:[te]}}),define(le[99],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Ym=e.ID=void 0,e.$Zm=r,e.ID="diagnosticsService",e.$Ym=(0,i.$Ki)(e.ID);function r(D){return!!D.hostName&&!!D.errorMessage}class v{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$1m=v});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[126],ue([0,1,18,81,9,6,49,3,37]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$ix=e.$hx=e.$gx=void 0,e.$jx=p,e.$kx=d,r=Ge(r),e.$gx=(0,D.$Ki)("dialogService");var l;(function(f){f[f.Confirmation=1]="Confirmation",f[f.Prompt=2]="Prompt",f[f.Input=3]="Input"})(l||(l={}));class m{a(y){return this.d(y,l.Confirmation)}b(y){return this.d(y,l.Prompt)}c(y){return this.d(y,l.Input)}d(y,E){const g=[];switch(E){case l.Confirmation:{const S=y;S.primaryButton?g.push(S.primaryButton):g.push((0,v.localize)(1698,null)),S.cancelButton?g.push(S.cancelButton):g.push((0,v.localize)(1699,null));break}case l.Prompt:{const S=y;Array.isArray(S.buttons)&&S.buttons.length>0&&g.push(...S.buttons.map(k=>k.label)),S.cancelButton&&(S.cancelButton===!0?g.push((0,v.localize)(1700,null)):typeof S.cancelButton=="string"?g.push(S.cancelButton):S.cancelButton.label?g.push(S.cancelButton.label):g.push((0,v.localize)(1701,null))),g.length===0&&g.push((0,v.localize)(1702,null));break}case l.Input:{const S=y;S.primaryButton?g.push(S.primaryButton):g.push((0,v.localize)(1703,null)),S.cancelButton?g.push(S.cancelButton):g.push((0,v.localize)(1704,null));break}}return g}e(y){if(typeof y=="string")return y;if(typeof y=="number")return y===r.default.Info?"info":y===r.default.Error?"error":y===r.default.Warning?"warning":"none"}f(y,E,g){const S=[...y.buttons??[]];y.cancelButton&&typeof y.cancelButton!="string"&&typeof y.cancelButton!="boolean"&&S.push(y.cancelButton);let k=S[E]?.run({checkboxChecked:g});return k instanceof Promise||(k=Promise.resolve(k)),{result:k,checkboxChecked:g}}}e.$hx=m,e.$ix=(0,D.$Ki)("fileDialogService");var u;(function(f){f[f.SAVE=0]="SAVE",f[f.DONT_SAVE=1]="DONT_SAVE",f[f.CANCEL=2]="CANCEL"})(u||(e.ConfirmResult=u={}));const $=10;function p(f){const y=[];return y.push(...f.slice(0,$).map(E=>typeof E=="string"?E:(0,i.$ih)(E))),f.length>$&&(f.length-$===1?y.push((0,v.localize)(1705,null)):y.push((0,v.localize)(1706,null,f.length-$))),y.push(""),y.join(`
`)}function d(f,y){const E=(0,b.$ko)(f);let g=(E.buttons??[]).map(a=>(0,O.$dx)(a)),S=(f.buttons||[]).map((a,t)=>t),k=0,s=E.cancelId??g.length-1;if(g.length>1){const a=typeof s=="number"?g[s]:void 0;if(I.$n||I.$m){if(typeof a=="string"&&g.length>1&&s!==1){g.splice(s,1),g.splice(1,0,a);const t=S[s];S.splice(s,1),S.splice(1,0,t),s=1}I.$n&&g.length>1&&(g=g.reverse(),S=S.reverse(),k=g.length-1,typeof a=="string"&&(s=k-1))}else if(I.$l&&typeof a=="string"&&g.length>1&&s!==g.length-1){g.splice(s,1),g.push(a);const t=S[s];S.splice(s,1),S.push(t),s=g.length-1}}return E.buttons=g,E.defaultId=k,E.cancelId=s,E.noLink=!0,E.title=E.title||y.nameLong,{options:E,buttonIndeces:S}}}),define(le[100],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$$Y=e.$0Y=void 0,e.$_Y=D,e.$aZ=O,e.$0Y=(0,i.$Ki)("encryptionService"),e.$$Y=(0,i.$Ki)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var v;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(v||(e.KnownStorageProvider=v={}));function D(I){return I===v.kwallet||I===v.kwallet5||I===v.kwallet6}function O(I){return I===v.gnomeAny||I===v.gnomeLibsecret||I===v.gnomeKeyring}}),define(le[36],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=void 0,e.$Ri=(0,i.$Ki)("environmentService"),e.$Si=(0,i.$Li)(e.$Ri)}),define(le[179],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=e.$Yhc=void 0,e.$Yhc=(0,i.$Ki)("extensionHostStarter"),e.$Zhc="extensionHostStarter"}),define(le[180],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b_b=e.$a_b=void 0,e.$a_b=(0,i.$Ki)("externalTerminal"),e.$b_b="Terminal.app"}),define(le[181],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0,e.$2hc=(0,i.$Ki)("externalTerminal")}),define(le[182],ue([0,1,44,54,11,10,3,82,23,96,9,180]),function(G,e,i,r,v,D,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=e.$4hc=e.$3hc=void 0,i=Ie(i),D=Ie(D),O=Ie(O),b=Ie(b),l=Ie(l),m=Ie(m);const $=m.localize(1851,null);class p{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends p{static{this.b="cmd.exe"}openTerminal(s,a){return this.spawnTerminal(i,s,l.$Dm(),a)}spawnTerminal(s,a,t,o){const n=a.windowsExec||d.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const c=D.$sc(n,".exe").toLowerCase();if(c==="cmder")return s.spawn(n,o?[o]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return n.indexOf(" ")>=0&&h.push(n),h.push(n),c==="wt"&&h.push("-d ."),new Promise((P,w)=>{const R=E(process),T=s.spawn(t,h,{cwd:o,env:R,detached:!0});T.on("error",w),T.on("exit",()=>P())})}async runInTerminal(s,a,t,o,n){const c="windowsExec"in n&&n.windowsExec?n.windowsExec:d.getDefaultTerminalWindows(),h=await d.f();return new Promise((P,w)=>{const R=`"${a} - ${$}"`,T=`"${t.join('" "')}" & pause`,A=Object.assign({},E(process),o);Object.keys(A).filter(Y=>A[Y]===null).forEach(Y=>delete A[Y]);const L={cwd:a,env:A,windowsVerbatimArguments:!0};let M,V;D.$sc(c,".exe")==="wt"?(M=c,V=["-d",".",d.b,"/c",T]):h?(M=h,V=["-d",".",c,"/c",T]):(M=d.b,V=["/c","start",R,"/wait",c,"/c",`"${T}"`]),i.spawn(M,V,L).on("error",Y=>{w(g(Y))}),P(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return d.d}static async f(){try{const s=await l.win32.findExecutable("wt");return await b.Promises.exists(s)?s:void 0}catch{return}}}e.$3hc=d,ke([r.$ci],d,"f",null);class f extends p{static{this.b="/usr/bin/osascript"}openTerminal(s,a){return this.spawnTerminal(i,s,a)}runInTerminal(s,a,t,o,n){const c=n.osxExec||u.$b_b;return new Promise((h,P)=>{if(c===u.$b_b||c==="iTerm.app"){const w=c===u.$b_b?"TerminalHelper":"iTermHelper",T=[v.$5g.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`).fsPath,"-t",s||$,"-w",a];for(const M of t)T.push("-a"),T.push(M);if(o){const M=Object.assign({},E(process),o);for(const V in M){const q=M[V];q===null?(T.push("-u"),T.push(V)):(T.push("-e"),T.push(`${V}=${q}`))}}let A="";const L=i.spawn(f.b,T);L.on("error",M=>{P(g(M))}),L.stderr.on("data",M=>{A+=M.toString()}),L.on("exit",M=>{if(M===0)h(void 0);else if(A){const V=A.split(`
`,1);P(new Error(V[0]))}else P(new Error(m.localize(1852,null,w,M)))})}else P(new Error(m.localize(1853,null,c)))})}spawnTerminal(s,a,t){const o=a.osxExec||u.$b_b;return new Promise((n,c)=>{const h=["-a",o];t&&h.push(t);const P=E(process),w=s.spawn("/usr/bin/open",h,{cwd:t,env:P});w.on("error",c),w.on("exit",()=>n())})}}e.$4hc=f;class y extends p{static{this.b=m.localize(1854,null)}openTerminal(s,a){return this.spawnTerminal(i,s,a)}runInTerminal(s,a,t,o,n){const c=n.linuxExec?Promise.resolve(n.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((h,P)=>{const w=[];c.then(R=>{R.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const T=`${S(t)}; echo; read -p "${y.b}" -n1;`;w.push(`''${T}''`);const A=Object.assign({},E(process),o);Object.keys(A).filter(q=>A[q]===null).forEach(q=>delete A[q]);const L={cwd:a,env:A};let M="";const V=i.spawn(R,w,L);V.on("error",q=>{P(g(q))}),V.stderr.on("data",q=>{M+=q.toString()}),V.on("exit",q=>{if(q===0)h(void 0);else if(M){const Y=M.split(`
`,1);P(new Error(Y[0]))}else P(new Error(m.localize(1855,null,R,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!y.d)if(!O.$n)y.d=Promise.resolve("xterm");else{const s=await b.Promises.exists("/etc/debian_version");y.d=new Promise(a=>{s?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return y.d}spawnTerminal(s,a,t){const o=a.linuxExec?Promise.resolve(a.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((n,c)=>{o.then(h=>{const P=E(process),w=s.spawn(h,[],{cwd:t,env:P});w.on("error",c),w.on("exit",()=>n())})})}}e.$5hc=y;function E(k){const s={...k.env};return(0,I.$qm)(s),s}function g(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(m.localize(1856,null,k.path)):k}function S(k){let s="";for(const a of k)a.indexOf(" ")>=0?s+='"'+a+'"':s+=a,s+=" ";return s}}),define(le[14],ue([0,1,61,10,25,12,7,9,6,3,11,67]),function(G,e,i,r,v,D,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Kl=e.FileKind=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.FileOperationResult=e.$Cl=e.$Bl=e.$Al=e.$yl=e.FileChangeType=e.$xl=e.FileOperation=e.$rl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$fl=void 0,e.$gl=$,e.$hl=y,e.$il=g,e.$jl=S,e.$kl=k,e.$ll=s,e.$ml=a,e.$nl=t,e.$ol=o,e.$pl=n,e.$ql=c,e.$sl=w,e.$tl=R,e.$ul=T,e.$vl=A,e.$wl=L,e.$zl=de,e.$Ll=B,e.$Ml=F,e.$Ol=ie,e.$fl=(0,b.$Ki)("fileService");function $(x){return x.create===!0}var p;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var d;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var f;(function(x){x[x.UPDATED=2]="UPDATED",x[x.ADDED=4]="ADDED",x[x.DELETED=8]="DELETED"})(f||(e.FileChangeFilter=f={}));function y(x){const ce=x;return!!ce&&typeof ce.onDidChange=="function"}var E;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(E||(e.FileSystemProviderCapabilities=E={}));function g(x){return!!(x.capabilities&E.FileReadWrite)}function S(x){return!!(x.capabilities&E.FileFolderCopy)}function k(x){return!!(x.capabilities&E.FileClone)}function s(x){return!!(x.capabilities&E.FileOpenReadWriteClose)}function a(x){return!!(x.capabilities&E.FileReadStream)}function t(x){return g(x)?!!(x.capabilities&E.FileAtomicRead):!1}function o(x){return g(x)?!!(x.capabilities&E.FileAtomicWrite):!1}function n(x){return!!(x.capabilities&E.FileAtomicDelete)}function c(x){return!!(x.capabilities&E.Readonly)}var h;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class P extends Error{static create(ce,oe){const te=new P(ce.toString(),oe);return T(te,oe),te}constructor(ce,oe){super(ce),this.code=oe}}e.$rl=P;function w(x,ce){return P.create(x,ce)}function R(x){return x||w((0,I.localize)(1865,null),h.Unknown)}function T(x,ce){return x.name=ce?`${ce} (FileSystemError)`:"FileSystemError",x}function A(x){if(!x)return h.Unknown;if(x instanceof P)return x.code;const ce=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!ce)return h.Unknown;switch(ce[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function L(x){if(x instanceof re)return x.fileOperationResult;switch(A(x)){case h.FileNotFound:return Z.FILE_NOT_FOUND;case h.FileIsADirectory:return Z.FILE_IS_DIRECTORY;case h.FileNotADirectory:return Z.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return Z.FILE_WRITE_LOCKED;case h.NoPermissions:return Z.FILE_PERMISSION_DENIED;case h.FileExists:return Z.FILE_MOVE_CONFLICT;case h.FileTooLarge:return Z.FILE_TOO_LARGE;default:return Z.FILE_OTHER_ERROR}}var M;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class V{constructor(ce,oe,te){this.resource=ce,this.operation=oe,this.target=te}isOperation(ce){return this.operation===ce}}e.$xl=V;var q;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(q||(e.FileChangeType=q={}));class Y{static{this.a=null}constructor(ce,oe){this.c=oe,this.b=void 0,this.d=new u.$Y(()=>{const te=i.$Qi.forUris(()=>this.c);return te.fill(this.rawAdded.map(j=>[j,!0])),te}),this.f=new u.$Y(()=>{const te=i.$Qi.forUris(()=>this.c);return te.fill(this.rawUpdated.map(j=>[j,!0])),te}),this.g=new u.$Y(()=>{const te=i.$Qi.forUris(()=>this.c);return te.fill(this.rawDeleted.map(j=>[j,!0])),te}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const te of ce){switch(te.type){case q.ADDED:this.rawAdded.push(te.resource);break;case q.UPDATED:this.rawUpdated.push(te.resource);break;case q.DELETED:this.rawDeleted.push(te.resource);break}this.b!==Y.a&&(typeof te.cId=="number"?this.b===void 0?this.b=te.cId:this.b!==te.cId&&(this.b=Y.a):this.b!==void 0&&(this.b=Y.a))}}contains(ce,...oe){return this.h(ce,{includeChildren:!1},...oe)}affects(ce,...oe){return this.h(ce,{includeChildren:!0},...oe)}h(ce,oe,...te){if(!ce)return!1;const j=te.length>0;return!!((!j||te.includes(q.ADDED))&&(this.d.value.get(ce)||oe.includeChildren&&this.d.value.findSuperstr(ce))||(!j||te.includes(q.UPDATED))&&(this.f.value.get(ce)||oe.includeChildren&&this.f.value.findSuperstr(ce))||(!j||te.includes(q.DELETED))&&(this.g.value.findSubstr(ce)||oe.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$yl=Y;function de(x,ce,oe){return!x||!ce||x===ce||ce.length>x.length?!1:(ce.charAt(ce.length-1)!==r.sep&&(ce+=r.sep),oe?(0,v.$Lf)(x,ce):x.indexOf(ce)===0)}class re extends Error{constructor(ce,oe,te){super(ce),this.fileOperationResult=oe,this.options=te}}e.$Al=re;class ee extends re{constructor(ce,oe,te,j){super(ce,oe,j),this.fileOperationResult=oe,this.size=te}}e.$Bl=ee;class W extends re{constructor(ce,oe,te){super(ce,Z.FILE_NOT_MODIFIED_SINCE,te),this.stat=oe}}e.$Cl=W;var Z;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$Dl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$El={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Fl="files.associations",e.$Gl="files.exclude",e.$Hl="files.readonlyInclude",e.$Il="files.readonlyExclude",e.$Jl="files.readonlyFromPermissions";var C;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(C||(e.FileKind=C={})),e.$Kl="";function B(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}async function F(x,ce){if(!ce.hasProvider(O.URI.from({scheme:x.scheme})))return new Promise(oe=>{const te=ce.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===x.scheme&&j.added&&(te.dispose(),oe())})})}class z{static{this.KB=1024}static{this.MB=z.KB*z.KB}static{this.GB=z.MB*z.KB}static{this.TB=z.GB*z.KB}static formatSize(ce){return(0,D.$ng)(ce)||(ce=0),ce<z.KB?(0,I.localize)(1866,null,ce.toFixed(0)):ce<z.MB?(0,I.localize)(1867,null,(ce/z.KB).toFixed(2)):ce<z.GB?(0,I.localize)(1868,null,(ce/z.MB).toFixed(2)):ce<z.TB?(0,I.localize)(1869,null,(ce/z.GB).toFixed(2)):(0,I.localize)(1870,null,(ce/z.TB).toFixed(2))}}e.$Nl=z;function ie(x){const ce=typeof x=="string"||x?.scheme===m.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===m.Schemas.file?1024*z.MB:ce?10*z.MB:l.$r?50*z.MB:1024*z.MB}}),define(le[127],ue([0,1,17,15,9,14]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=O;async function O(m,u,$,p,d,f){let y;try{await I(m,u,$,p,d,f)}catch(E){y=E}finally{y&&d.errorTransformer&&(y=d.errorTransformer(y)),typeof y<"u"&&$.error(y),$.end()}}async function I(m,u,$,p,d,f){b(f);const y=await m.open(u,{create:!1});try{b(f);let E=0,g=0,S=d&&typeof d.length=="number"?d.length:void 0,k=i.$Se.alloc(Math.min(d.bufferSize,typeof S=="number"?S:d.bufferSize)),s=d&&typeof d.position=="number"?d.position:0,a=0;do g=await m.read(y,s,k.buffer,a,k.byteLength-a),s+=g,a+=g,E+=g,typeof S=="number"&&(S-=g),a===k.byteLength&&(await $.write(p(k)),k=i.$Se.alloc(Math.min(d.bufferSize,typeof S=="number"?S:d.bufferSize)),a=0);while(g>0&&(typeof S!="number"||S>0)&&b(f)&&l(E,d));if(a>0){let t=a;typeof S=="number"&&(t=Math.min(a,S)),$.write(p(k.slice(0,t)))}}catch(E){throw(0,D.$tl)(E)}finally{await m.close(y)}}function b(m){if(m.isCancellationRequested)throw(0,r.$0)();return!0}function l(m,u){if(typeof u?.limits?.size=="number"&&m>u.limits.size)throw(0,D.$sl)((0,v.localize)(1898,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[62],ue([0,1,116,2,10,3,7,14]),function(G,e,i,r,v,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=void 0,e.$_q=b,e.$ar=l,e.$er=p,e.$fr=d,e.$gr=f,e.$hr=y,e.$ir=g,e.$jr=S;function b(k){return typeof k.correlationId=="number"}function l(k){return k.recursive===!0}class m extends r.$Zc{static{this.a=5}constructor(s,a,t,o){super(),this.h=s,this.j=a,this.m=t,this.n=o,this.c=this.B(new r.$1c),this.f=void 0,this.g=0}s(){const s=new r.$Yc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(a=>this.h(a))),s.add(this.b.onDidLogMessage(a=>this.j(a))),s.add(this.b.onDidError(a=>this.t(a.error,a.request)))}t(s,a){this.u(s,a)?this.g<m.a&&this.f?(this.y(`restarting watcher after unexpected error: ${s}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${s}`):this.y(s)}u(s,a){return!(!this.n.restartOnError||a||s.indexOf("No space left on device")!==-1||s.indexOf("EMFILE")!==-1)}w(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}y(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}z(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$br=m;class u extends m{constructor(s,a,t){super(s,a,t,{type:"node.js",restartOnError:!1})}}e.$cr=u;class $ extends m{constructor(s,a,t){super(s,a,t,{type:"universal",restartOnError:!0})}}e.$dr=$;function p(k){return k.map(s=>({type:s.type,resource:O.URI.revive(s.resource),cId:s.cId}))}function d(k){const s=new E;for(const a of k)s.processEvent(a);return s.coalesce()}function f(k,s){return typeof s=="string"&&!s.startsWith(i.$Bk)&&!(0,v.$nc)(s)?{base:k,pattern:s}:s}function y(k,s){const a=[];for(const t of s)a.push((0,i.$Fk)(f(k,t)));return a}class E{constructor(){this.a=new Set,this.b=new Map}c(s){return D.$n?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const a=this.b.get(this.c(s));let t=!1;if(a){const o=a.type,n=s.type;a.resource.fsPath!==s.resource.fsPath&&(s.type===I.FileChangeType.DELETED||s.type===I.FileChangeType.ADDED)?t=!0:o===I.FileChangeType.ADDED&&n===I.FileChangeType.DELETED?(this.b.delete(this.c(s)),this.a.delete(a)):o===I.FileChangeType.DELETED&&n===I.FileChangeType.ADDED?a.type=I.FileChangeType.UPDATED:o===I.FileChangeType.ADDED&&n===I.FileChangeType.UPDATED||(a.type=n)}else t=!0;t&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],a=[];return Array.from(this.a).filter(t=>t.type!==I.FileChangeType.DELETED?(s.push(t),!1):!0).sort((t,o)=>t.resource.fsPath.length-o.resource.fsPath.length).filter(t=>a.some(o=>(0,I.$zl)(t.resource.fsPath,o,!D.$n))?!1:(a.push(t.resource.fsPath),!0)).concat(s)}}function g(k,s){if(typeof s=="number")switch(k.type){case I.FileChangeType.ADDED:return(s&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(s&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(s&I.FileChangeFilter.UPDATED)===0}return!1}function S(k){if(typeof k=="number"){const s=[];return k&I.FileChangeFilter.ADDED&&s.push("Added"),k&I.FileChangeFilter.DELETED&&s.push("Deleted"),k&I.FileChangeFilter.UPDATED&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(le[183],ue([0,1,17,55,15,4,2,68,33,14,62]),function(G,e,i,r,v,D,O,I,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VR=e.$UR=void 0,e.$UR="localFilesystem";class u extends O.$Zc{constructor(p,d){super(),this.a=p,this.b=d,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$qe),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$qe),this.onDidWatchError=this.g.event,this.h=(0,b.$7g)(),this.j()}get capabilities(){return this.c||(this.c=l.FileSystemProviderCapabilities.FileReadWrite|l.FileSystemProviderCapabilities.FileOpenReadWriteClose|l.FileSystemProviderCapabilities.FileReadStream|l.FileSystemProviderCapabilities.FileFolderCopy|l.FileSystemProviderCapabilities.FileWriteUnlock|l.FileSystemProviderCapabilities.FileAtomicRead|l.FileSystemProviderCapabilities.FileAtomicWrite|l.FileSystemProviderCapabilities.FileAtomicDelete|l.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=l.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=l.FileSystemProviderCapabilities.Trash)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,d){const{buffer:f}=await this.a.call("readFile",[p,d]);return f}readFileStream(p,d,f){const y=(0,I.$Ge)(g=>i.$Se.concat(g.map(S=>i.$Se.wrap(S))).buffer),E=new O.$Yc;return E.add(this.a.listen("readFileStream",[p,d])(g=>{if(g instanceof i.$Se)y.write(g.buffer);else{if(g==="end")y.end();else{let S;if(g instanceof Error)S=g;else{const k=g;S=(0,l.$sl)(k.message??(0,r.$vj)(k),k.code??l.FileSystemProviderErrorCode.Unknown)}y.error(S),y.end()}E.dispose()}})),E.add(f.onCancellationRequested(()=>{y.error((0,v.$0)()),y.end(),E.dispose()})),y}writeFile(p,d,f){return this.a.call("writeFile",[p,i.$Se.wrap(d),f])}open(p,d){return this.a.call("open",[p,d])}close(p){return this.a.call("close",[p])}async read(p,d,f,y,E){const[g,S]=await this.a.call("read",[p,d,E]);return f.set(g.buffer.slice(0,S),y),S}write(p,d,f,y,E){return this.a.call("write",[p,d,i.$Se.wrap(f),y,E])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,d){return this.a.call("delete",[p,d])}rename(p,d,f){return this.a.call("rename",[p,d,f])}copy(p,d,f){return this.a.call("copy",[p,d,f])}cloneFile(p,d){return this.a.call("cloneFile",[p,d])}j(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const d=p;this.f.fire((0,m.$er)(d))}else{const d=p;this.g.fire(d)}}))}watch(p,d){const f=(0,b.$7g)();return this.a.call("watch",[this.h,f,p,d]),(0,O.$Xc)(()=>this.a.call("unwatch",[this.h,f]))}}e.$VR=u}),define(le[184],ue([0,1,26,2,62,4,14,7,8]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class l extends r.$Zc{constructor(){super(),this.a=this.B(new D.$qe),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$qe),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$qe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$9c),this.m=new Set,this.n=this.B(new b.$Ih(this.y())),this.r=5007,this.s=new b.$8h,this.R=!1,this.B(this.f(u=>this.t(u)))}t(u){this.u(u)&&this.z(u)}u(u){return(0,v.$_q)(u)}async watch(u){this.s.isSettled||this.s.complete(),this.s=new b.$8h;try{this.h.clear(),this.g.clear();for(const $ of u)this.u($)?this.h.set($.correlationId,$):this.g.add($);for(const[$]of this.j)this.h.has($)||(this.j.deleteAndDispose($),this.m.delete($));return await this.w(!1)}finally{this.s.complete()}}w(u){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter($=>!this.j.has($.correlationId))]),u?this.y():0)}y(){return 800}isSuspended(u){return typeof u.correlationId!="number"?!1:this.m.has(u.correlationId)?"polling":this.j.has(u.correlationId)}async z(u){if(this.j.has(u.correlationId))return;const $=new r.$Yc;this.j.set(u.correlationId,$),await this.s.p,!$.isDisposed&&(this.D(u,$),this.w(!0))}C(u){this.j.deleteAndDispose(u.correlationId),this.m.delete(u.correlationId),this.w(!1)}D(u,$){this.F(u,$)?(this.P(`reusing an existing recursive watcher to monitor ${u.path}`),this.m.delete(u.correlationId)):(this.G(u,$),this.m.add(u.correlationId))}F(u,$){const p=this.O?.subscribe(u.path,(d,f)=>{$.isDisposed||(d?this.D(u,$):f?.type===O.FileChangeType.ADDED&&this.H(u))});return p?($.add(p),!0):!1}G(u,$){let p=!1;const d=(f,y)=>{if($.isDisposed)return;const E=this.I(f),g=this.I(y),S=p;p=E,!E&&(g||S)&&this.H(u)};this.P(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,i.watchFile)(u.path,{persistent:!1,interval:this.r},d)}catch(f){this.Q(`fs.watchFile() failed with error ${f} on path ${u.path} (correlationId: ${u.correlationId})`)}$.add((0,r.$Xc)(()=>{this.P(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,i.unwatchFile)(u.path,d)}catch(f){this.Q(`fs.unwatchFile() failed with error ${f} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}H(u){this.P(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const $={resource:I.URI.file(u.path),type:O.FileChangeType.ADDED,cId:u.correlationId};this.a.fire([$]),this.J($,u),this.C(u)}I(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(u,$){if(this.R){const p=` >> normalized ${u.type===O.FileChangeType.ADDED?"[ADDED]":u.type===O.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.L(p,$)}}L(u,$){this.R&&this.P(`${u}${typeof $.correlationId=="number"?` <${$.correlationId}> `:""}`)}M(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,v.$jr)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.R=u}}e.$sr=l}),define(le[185],ue([0,1,26,8,22,32,2,79,10,3,18,7,117,23,14,62]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0,e.$yr=E;class y extends O.$Zc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(S,k,s,a,t,o){super(),this.s=S,this.t=k,this.u=s,this.w=a,this.y=t,this.z=o,this.c=this.B(new r.$Zh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.u(n))),this.f=this.B(new r.$Yh(n=>this.M(n),y.b)),this.g=(0,f.$hr)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,f.$hr)(this.s.path,this.s.includes):void 0,this.j=(0,f.$_q)(this.s)?this.s.filter:void 0,this.m=new v.$Be,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const S=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const k=await i.promises.stat(S);if(this.m.token.isCancellationRequested)return;this.B(await this.G(S,k.isDirectory()))}catch(S){S.code!=="ENOENT"?this.O(S):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${S})`),this.D()}}D(){this.r=!0,this.w?.()}async F(S){let k=S.path;try{k=await p.Promises.realpath(S.path),S.path===k&&(k=await(0,$.$ur)(S.path,this.m.token)??S.path),S.path!==k&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${S.path}, real: ${k})`)}catch{}return k}async G(S,k){const s=new O.$Yc;return this.H(S,k,s)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(S,k,s)),s}H(S,k,s){if(k)return!1;const a=u.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(o,n)=>{if(!s.isDisposed)if(o){const c=await this.G(S,k);s.isDisposed?c.dispose():s.add(c)}else n&&(typeof n.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:a,type:n.type,cId:this.s.correlationId},!0)});return t?(s.add(t),!0):!1}async I(S,k,s){if(l.$m&&(0,D.$Jg)(S,"/Volumes/",!0)){this.O(`Refusing to watch ${S} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new v.$Be(this.m.token);s.add((0,O.$Xc)(()=>a.dispose(!0)));const t=new O.$Yc;s.add(t);try{const o=u.URI.file(this.s.path),n=(0,b.$sc)(S),c=(0,i.watch)(S);t.add((0,O.$Xc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${S}'`);const h=new Set;if(k)try{for(const w of await p.Promises.readdir(S))h.add(w)}catch(w){this.O(w)}if(a.token.isCancellationRequested)return;const P=new Map;t.add((0,O.$Xc)(()=>{for(const[,w]of P)w.dispose();P.clear()})),c.on("error",(w,R)=>{a.token.isCancellationRequested||(this.O(`Failed to watch ${S} for changes using fs.watch() (${w}, ${R})`),this.D())}),c.on("change",(w,R)=>{if(a.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${w}"] ${R}`);let T="";if(R&&(T=R.toString(),l.$m&&(T=(0,I.$sm)(T))),!(!T||w!=="change"&&w!=="rename"))if(k)if(w==="rename"){P.get(T)?.dispose();const A=setTimeout(async()=>{if(P.delete(T),T===n&&!await p.Promises.exists(S)){this.J(o);return}if(a.token.isCancellationRequested)return;const L=await this.N((0,b.$oc)(S,T));if(a.token.isCancellationRequested)return;let M;L?h.has(T)?M=d.FileChangeType.UPDATED:(M=d.FileChangeType.ADDED,h.add(T)):(h.delete(T),M=d.FileChangeType.DELETED),this.L({resource:(0,m.$lh)(o,T),type:M,cId:this.s.correlationId})},y.a);P.set(T,(0,O.$Xc)(()=>clearTimeout(A)))}else{let A;h.has(T)?A=d.FileChangeType.UPDATED:(A=d.FileChangeType.ADDED,h.add(T)),this.L({resource:(0,m.$lh)(o,T),type:A,cId:this.s.correlationId})}else if(w==="rename"||T!==n){const A=setTimeout(async()=>{const L=await p.Promises.exists(S);a.token.isCancellationRequested||(L?(this.L({resource:o,type:d.FileChangeType.UPDATED,cId:this.s.correlationId},!0),t.add(await this.G(S,!1))):this.J(o))},y.a);t.clear(),t.add((0,O.$Xc)(()=>clearTimeout(A)))}else this.L({resource:o,type:d.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(o){a.token.isCancellationRequested||this.O(`Failed to watch ${S} for changes using fs.watch() (${o.toString()})`),this.D()}}J(S){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:S,type:d.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(S,k=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${S.type===d.FileChangeType.ADDED?"[ADDED]":S.type===d.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`),!k&&this.g.some(s=>s(S.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${S.resource.fsPath}`):!k&&this.h&&this.h.length>0&&!this.h.some(s=>s(S.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${S.resource.fsPath}`):this.f.work(S))}M(S){const k=(0,f.$fr)(S),s=[];for(const t of k){if((0,f.$ir)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}s.push(t)}if(s.length===0)return;if(this.z)for(const t of s)this.R(` >> normalized ${t.type===d.FileChangeType.ADDED?"[ADDED]":t.type===d.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(S){if(l.$n)return p.Promises.exists(S);try{const k=(0,b.$sc)(S);return(await p.Promises.readdir((0,b.$rc)(S))).some(a=>a===k)}catch(k){return this.Q(k),!1}}setVerboseLogging(S){this.z=S}O(S){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${S}`})}P(S){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${S}`})}Q(S){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${S}`})}R(S){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${S}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$xr=y;async function E(g,S,k,s,a=512){const t=await p.Promises.open(g,"r"),o=Buffer.allocUnsafe(a),n=new v.$Be(s);let c,h=!1;const P={path:g,excludes:[],recursive:!1},w=new y(P,void 0,R=>{(async()=>{for(const{type:T}of R)if(T===d.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:A}=await p.Promises.read(t,o,0,a,null);if(!A||n.token.isCancellationRequested)break;S(o.slice(0,A))}}catch(A){c=new Error(A),n.dispose(!0)}finally{h=!1}}})()});return await w.ready,k(),new Promise((R,T)=>{n.token.onCancellationRequested(async()=>{w.dispose();try{await p.Promises.close(t)}catch(A){c=new Error(A)}c?T(c):R()})})}}),define(le[186],ue([0,1,4,116,184,3,185,32]),function(G,e,i,r,v,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class b extends v.$sr{constructor(m){super(),this.O=m,this.onDidError=i.Event.None,this.watchers=new Set}async N(m){m=this.Z(m);const u=[],$=new Set(Array.from(this.watchers));for(const p of m){const d=this.W(p);d&&(0,r.$Jk)(d.request.excludes,p.excludes)&&(0,r.$Jk)(d.request.includes,p.includes)?$.delete(d):u.push(p)}u.length&&this.P(`Request to start watching: ${u.map(p=>this.M(p)).join(",")}`),$.size&&this.P(`Request to stop watching: ${Array.from($).map(p=>this.M(p.request)).join(",")}`);for(const p of $)this.Y(p);for(const p of u)this.X(p)}W(m){for(const u of this.watchers)if(typeof m.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===m.correlationId)return u}else if((0,I.$Ig)(u.request.path,m.path,!D.$n))return u}X(m){const u=new O.$xr(m,this.O,p=>this.a.fire(p),()=>this.c.fire(m),p=>this.b.fire(p),this.R),$={request:m,instance:u};this.watchers.add($)}async stop(){await super.stop();for(const m of this.watchers)this.Y(m)}Y(m){this.P("stopping file watcher",m),this.watchers.delete(m),m.instance.dispose()}Z(m){const u=new Map;for(const $ of m){const p=D.$n?$.path:$.path.toLowerCase();let d=u.get($.correlationId);d||(d=new Map,u.set($.correlationId,d)),d.has(p)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M($)}`),d.set(p,$)}return Array.from(u.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(m){super.setVerboseLogging(m);for(const u of this.watchers)u.instance.setVerboseLogging(m)}P(m,u){this.R&&this.b.fire({type:"trace",message:this.bb(m,u)})}Q(m){this.b.fire({type:"warn",message:this.bb(m)})}bb(m,u){return u?`[File Watcher (node.js)] ${m} (${this.M(u.request)})`:`[File Watcher (node.js)] ${m}`}}e.$zr=b}),define(le[187],ue([0,1,62,186]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;class v extends i.$cr{constructor(O,I,b){super(O,I,b),this.s()}r(O){return O.add(new r.$zr(void 0))}}e.$Ar=v}),define(le[188],ue([0,1,11,45,166,62]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class O extends D.$dr{constructor(b,l,m){super(b,l,m),this.s()}r(b){const l=b.add(new v.$qr(i.$5g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(l.onDidProcessExit(({code:m,signal:u})=>this.t(`terminated by itself with code ${m}, signal: ${u} (ETERM)`))),r.ProxyChannel.toService((0,r.$ri)(l.getChannel("watcher")))}}e.$rr=O}),define(le[101],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=void 0;class i{constructor(...v){this.a=new Map;for(const[D,O]of v)this.set(D,O)}set(v,D){const O=this.a.get(v);return this.a.set(v,D),O}has(v){return this.a.has(v)}get(v){return this.a.get(v)}}e.$Ii=i}),define(le[189],ue([0,1,8,15,2,84,178,6,101,111]),function(G,e,i,r,v,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;const m=!1;class u extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class ${constructor(y=new b.$Ii,E=!1,g,S=m){this.i=y,this.j=E,this.k=g,this.l=S,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Ji,this),this._globalGraph=S?g?._globalGraph??new O.$Dr(k=>k):void 0}dispose(){if(!this.f){this.f=!0,(0,v.$Uc)(this.h),this.h.clear();for(const y of this.g)(0,v.$Tc)(y)&&y.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(y,E){this.m();const g=this,S=new class extends ${dispose(){g.h.delete(S),super.dispose()}}(y,this.j,this,this.l);return this.h.add(S),E?.add(S),S}invokeFunction(y,...E){this.m();const g=d.traceInvocation(this.l,y);let S=!1;try{return y({get:s=>{if(S)throw(0,r.$_)("service accessor is only valid during the invocation of its target method");const a=this.s(s,g);if(!a)throw new Error(`[invokeFunction] unknown service '${s}'`);return a}},...E)}finally{S=!0,g.stop()}}createInstance(y,...E){this.m();let g,S;return y instanceof D.$Hi?(g=d.traceCreation(this.l,y.ctor),S=this.o(y.ctor,y.staticArguments.concat(E),g)):(g=d.traceCreation(this.l,y),S=this.o(y,E,g)),g.stop(),S}o(y,E=[],g){const S=I._util.getServiceDependencies(y).sort((a,t)=>a.index-t.index),k=[];for(const a of S){const t=this.s(a.id,g);t||this.y(`[createInstance] ${y.name} depends on UNKNOWN service ${a.id}.`,!1),k.push(t)}const s=S.length>0?S[0].index:E.length;if(E.length!==s){console.trace(`[createInstance] First service dependency of ${y.name} at position ${s+1} conflicts with ${E.length} static arguments`);const a=s-E.length;a>0?E=E.concat(new Array(a)):E=E.slice(0,s)}return Reflect.construct(y,E.concat(k))}q(y,E){if(this.i.get(y)instanceof D.$Hi)this.i.set(y,E);else if(this.k)this.k.q(y,E);else throw new Error("illegalState - setting UNKNOWN service instance")}r(y){const E=this.i.get(y);return!E&&this.k?this.k.r(y):E}s(y,E){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const g=this.r(y);return g instanceof D.$Hi?this.u(y,g,E.branch(y,!0)):(E.branch(y,!1),g)}u(y,E,g){if(this.t.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.t.add(y);try{return this.v(y,E,g)}finally{this.t.delete(y)}}v(y,E,g){const S=new O.$Dr(t=>t.id.toString());let k=0;const s=[{id:y,desc:E,_trace:g}],a=new Set;for(;s.length;){const t=s.pop();if(!a.has(String(t.id))){if(a.add(String(t.id)),S.lookupOrInsertNode(t),k++>1e3)throw new u(S);for(const o of I._util.getServiceDependencies(t.desc.ctor)){const n=this.r(o.id);if(n||this.y(`[createInstance] ${y} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof D.$Hi){const c={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};S.insertEdge(t,c),s.push(c)}}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new u(S);break}for(const{data:o}of t){if(this.r(o.id)instanceof D.$Hi){const c=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,c)}S.removeNode(o)}}return this.r(y)}w(y,E,g=[],S,k){if(this.i.get(y)instanceof D.$Hi)return this.x(y,E,g,S,k,this.g);if(this.k)return this.k.w(y,E,g,S,k);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}x(y,E,g=[],S,k,s){if(S){const a=new $(void 0,this.j,this,this.l);a.c=String(y);const t=new Map,o=new i.$4h(()=>{const n=a.o(E,g,k);for(const[c,h]of t){const P=n[c];if(typeof P=="function")for(const w of h)w.disposable=P.apply(n,w.listener)}return t.clear(),s.add(n),n});return new Proxy(Object.create(null),{get(n,c){if(!o.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let w=t.get(c);return w||(w=new l.$0c,t.set(c,w)),(T,A,L)=>{if(o.isInitialized)return o.value[c](T,A,L);{const M={listener:[T,A,L],disposable:void 0},V=w.push(M);return(0,v.$Xc)(()=>{V(),M.disposable?.dispose()})}}}if(c in n)return n[c];const h=o.value;let P=h[c];return typeof P!="function"||(P=P.bind(h),n[c]=P),P},set(n,c,h){return o.value[c]=h,!0},getPrototypeOf(n){return E.prototype}})}else{const a=this.o(E,g,k);return s.add(a),a}}y(y,E){if(E&&console.warn(y),this.j)throw new Error(y)}}e.$Er=$;var p;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(p||(p={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(p.None,null)}stop(){}branch(){return this}}}static traceInvocation(y,E){return y?new d(p.Invocation,E.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(y,E){return y?new d(p.Creation,E.name):d.c}static{this.f=0}constructor(y,E){this.type=y,this.name=E,this.g=Date.now(),this.h=[]}branch(y,E){const g=new d(p.Branch,y.toString());return this.h.push([y,E,g]),g}stop(){const y=Date.now()-this.g;d.f+=y;let E=!1;function g(k,s){const a=[],t=new Array(k+1).join("	");for(const[o,n,c]of s.h)if(n&&c){E=!0,a.push(`${t}CREATES -> ${o}`);const h=g(k+1,c);h&&a.push(h)}else a.push(`${t}uses -> ${o}`);return a.join(`
`)}const S=[`${this.type===p.Creation?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(y>2||E)&&d.all.add(S.join(`
`))}}e.$Fr=d}),define(le[190],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dvb=e.$Cvb=e.IssueSource=e.OldIssueType=void 0;var r;(function(D){D[D.Bug=0]="Bug",D[D.PerformanceIssue=1]="PerformanceIssue",D[D.FeatureRequest=2]="FeatureRequest"})(r||(e.OldIssueType=r={}));var v;(function(D){D.VSCode="vscode",D.Extension="extension",D.Marketplace="marketplace"})(v||(e.IssueSource=v={})),e.$Cvb=(0,i.$Ki)("issueService"),e.$Dvb=(0,i.$Ki)("processService")}),define(le[5],ue([0,1,9,55,4,48,2,31,3,18,12,7,125,6]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$ik=e.LogLevel=e.$gk=e.$fk=void 0,e.$hk=f,e.log=E,e.$tk=P,e.$uk=w,e.$vk=R,e.$wk=T,i=Ie(i),e.$fk=(0,p.$Ki)("logService"),e.$gk=(0,p.$Ki)("loggerService");function d(){return new Date().toISOString()}function f(A){return(0,m.$ng)(A)}var y;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$ik=y.Info;function E(A,L,M){switch(L){case y.Trace:A.trace(M);break;case y.Debug:A.debug(M);break;case y.Info:A.info(M);break;case y.Warning:A.warn(M);break;case y.Error:A.error(M);break;case y.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function g(A,L=!1){let M="";for(let V=0;V<A.length;V++){let q=A[V];if(q instanceof Error&&(q=(0,r.$vj)(q,L)),typeof q=="object")try{q=JSON.stringify(q)}catch{}M+=(V>0?" ":"")+q}return M}class S extends O.$Zc{constructor(){super(...arguments),this.b=e.$ik,this.c=this.B(new v.$qe),this.onDidChangeLogLevel=this.c.event}setLevel(L){this.b!==L&&(this.b=L,this.c.fire(this.b))}getLevel(){return this.b}f(L){return this.b!==y.Off&&this.b<=L}}e.$kk=S;class k extends S{constructor(L){super(),this.h=L}f(L){return this.h||super.f(L)}trace(L,...M){this.f(y.Trace)&&this.g(y.Trace,g([L,...M],!0))}debug(L,...M){this.f(y.Debug)&&this.g(y.Debug,g([L,...M]))}info(L,...M){this.f(y.Info)&&this.g(y.Info,g([L,...M]))}warn(L,...M){this.f(y.Warning)&&this.g(y.Warning,g([L,...M]))}error(L,...M){if(this.f(y.Error))if(L instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=L.stack,this.g(y.Error,g(V))}else this.g(y.Error,g([L,...M]))}flush(){}}e.$lk=k;class s extends S{constructor(L=e.$ik){super(),this.setLevel(L),this.g=!b.$l}trace(L,...M){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,L,...M):console.log(`[main ${d()}]`,L,...M))}debug(L,...M){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,L,...M):console.log(`[main ${d()}]`,L,...M))}info(L,...M){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,L,...M):console.log(`[main ${d()}]`,L,...M))}warn(L,...M){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,L,...M):console.warn(`[main ${d()}]`,L,...M))}error(L,...M){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,L,...M):console.error(`[main ${d()}]`,L,...M))}flush(){}}e.$mk=s;class a extends S{constructor(L=e.$ik,M=!0){super(),this.g=M,this.setLevel(L)}trace(L,...M){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",L,...M):console.log(L,...M))}debug(L,...M){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",L,...M):console.log(L,...M))}info(L,...M){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",L,...M):console.log(L,...M))}warn(L,...M){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",L,...M):console.log(L,...M))}error(L,...M){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",L,...M):console.error(L,...M))}flush(){}}e.$nk=a;class t extends S{constructor(L,M=e.$ik){super(),this.g=L,this.setLevel(M)}trace(L,...M){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(L),...M])}debug(L,...M){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(L),...M])}info(L,...M){this.f(y.Info)&&this.g.log(y.Info,[this.h(L),...M])}warn(L,...M){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(L),...M])}error(L,...M){this.f(y.Error)&&this.g.log(y.Error,[this.h(L),...M])}h(L){return typeof L=="string"?L:(0,r.$vj)(L,this.f(y.Trace))}flush(){}}e.$ok=t;class o extends S{constructor(L){super(),this.g=L,L.length&&this.setLevel(L[0].getLevel())}setLevel(L){for(const M of this.g)M.setLevel(L);super.setLevel(L)}trace(L,...M){for(const V of this.g)V.trace(L,...M)}debug(L,...M){for(const V of this.g)V.debug(L,...M)}info(L,...M){for(const V of this.g)V.info(L,...M)}warn(L,...M){for(const V of this.g)V.warn(L,...M)}error(L,...M){for(const V of this.g)V.error(L,...M)}flush(){for(const L of this.g)L.flush()}dispose(){for(const L of this.g)L.dispose();super.dispose()}}e.$pk=o;class n extends O.$Zc{constructor(L,M,V){if(super(),this.h=L,this.j=M,this.b=new I.$Fc,this.c=this.B(new v.$qe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new v.$qe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new v.$qe),this.onDidChangeVisibility=this.g.event,V)for(const q of V)this.b.set(q.resource,{logger:void 0,info:q})}m(L){return(0,m.$jg)(L)?[...this.b.values()].find(M=>M.info.id===L):this.b.get(L)}getLogger(L){return this.m(L)?.logger}createLogger(L,M){const V=this.n(L),q=(0,m.$jg)(L)?L:M?.id??(0,D.$yj)(V.toString()).toString(16);let Y=this.b.get(V)?.logger;const de=M?.logLevel==="always"?y.Trace:M?.logLevel;Y||(Y=this.s(V,de??this.getLogLevel(V)??this.h,{...M,id:q}));const re={logger:Y,info:{resource:V,id:q,logLevel:de,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(re.info),this.b.set(V,re),Y}n(L){return(0,m.$jg)(L)?(0,l.$lh)(this.j,`${L}.log`):L}setLogLevel(L,M){if(u.URI.isUri(L)){const V=L,q=M,Y=this.b.get(V);Y&&q!==Y.info.logLevel&&(Y.info.logLevel=q===this.h?void 0:q,Y.logger?.setLevel(q),this.b.set(Y.info.resource,Y),this.f.fire([V,q]))}else{this.h=L;for(const[V,q]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(L,M){const V=this.m(L);V&&M!==!V.info.hidden&&(V.info.hidden=!M,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,M]))}getLogLevel(L){let M;return L&&(M=this.b.get(L)?.info.logLevel),M??this.h}registerLogger(L){const M=this.b.get(L.resource);M?M.info.hidden!==L.hidden&&this.setVisibility(L.resource,!L.hidden):(this.b.set(L.resource,{info:L,logger:void 0}),this.c.fire({added:[L],removed:[]}))}deregisterLogger(L){const M=this.b.get(L);M&&(M.logger&&M.logger.dispose(),this.b.delete(L),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const L of this.b.values())yield L.info}getRegisteredLogger(L){return this.b.get(L)?.info}dispose(){this.b.forEach(L=>L.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qk=n;class c{constructor(){this.onDidChangeLogLevel=new v.$qe().event}setLevel(L){}getLevel(){return y.Info}trace(L,...M){}debug(L,...M){}info(L,...M){}warn(L,...M){}error(L,...M){}critical(L,...M){}dispose(){}flush(){}}e.$rk=c;class h extends c{}e.$sk=h;function P(A){if(A.verbose)return y.Trace;if(typeof A.logLevel=="string"){const L=T(A.logLevel.toLowerCase());if(L!==void 0)return L}return e.$ik}function w(A){switch(A){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}function R(A){switch(A){case y.Trace:return{original:"Trace",value:i.localize(1959,null)};case y.Debug:return{original:"Debug",value:i.localize(1960,null)};case y.Info:return{original:"Info",value:i.localize(1961,null)};case y.Warning:return{original:"Warning",value:i.localize(1962,null)};case y.Error:return{original:"Error",value:i.localize(1963,null)};case y.Off:return{original:"Off",value:i.localize(1964,null)}}}function T(A){switch(A){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$xk=new $.$2j("logLevel",w(y.Info))});var se=this&&this.__param||function(G,e){return function(i,r){e(i,r,G)}};define(le[86],ue([0,1,44,97,66,11,60,36,6,5]),function(G,e,i,r,v,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kS=e.$jS=void 0,e.$jS=(0,b.$Ki)("ICSSDevelopmentService");let m=class{constructor($,p){this.b=$,this.c=p}get isEnabled(){return!this.b.isBuilt&&v.$V}getCssModules(){return this.a??=this.d(),this.a}async d(){if(!this.isEnabled)return[];const $=await new Promise((p,d)=>{G(["@vscode/ripgrep"],p,d)}).then(Ie);return await new Promise(p=>{const d=O.$ke.create(),f=[],y=new TextDecoder,E=D.$5g.asFileUri("").fsPath,g=(0,i.spawn)($.rgPath,["-g","**/*.css","--files","--no-ignore",E],{});g.stdout.on("data",S=>{const k=y.decode(S,{stream:!0});f.push(k.split(`
`).filter(Boolean))}),g.on("error",S=>{this.c.error("[CSS_DEV] FAILED to compute CSS data",S),p([])}),g.on("close",()=>{const S=f.flat().map(k=>(0,r.relative)(E,k).replace(/\\/g,"/")).filter(Boolean).sort();p(S),this.c.info(`[CSS_DEV] DONE, ${S.length} css modules (${Math.round(d.elapsed())}ms)`)})})}};e.$kS=m,e.$kS=m=ke([se(0,I.$Ri),se(1,l.$fk)],m)}),define(le[191],ue([0,1,13,3,100,5]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;const O=i.safeStorage;let I=class{constructor(l){this.a=l,i.app.commandLine.getSwitchValue("password-store")===v.PasswordStoreCLIOption.basic&&(this.a.trace("[EncryptionMainService] setting usePlainTextEncryption to true..."),O.setUsePlainTextEncryption?.(!0),this.a.trace("[EncryptionMainService] set usePlainTextEncryption to true"))}async encrypt(l){this.a.trace("[EncryptionMainService] Encrypting value...");try{const m=JSON.stringify(O.encryptString(l));return this.a.trace("[EncryptionMainService] Encrypted value."),m}catch(m){throw this.a.error(m),m}}async decrypt(l){let m;try{if(m=JSON.parse(l),!m.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${l}`);const u=Buffer.from(m.data);this.a.trace("[EncryptionMainService] Decrypting value...");const $=O.decryptString(u);return this.a.trace("[EncryptionMainService] Decrypted value."),$}catch(u){throw this.a.error(u),u}}isEncryptionAvailable(){this.a.trace("[EncryptionMainService] Checking if encryption is available...");const l=O.isEncryptionAvailable();return this.a.trace("[EncryptionMainService] Encryption is available: ",l),Promise.resolve(l)}getKeyStorageProvider(){if(r.$l)return Promise.resolve(v.KnownStorageProvider.dplib);if(r.$m)return Promise.resolve(v.KnownStorageProvider.keychainAccess);if(O.getSelectedStorageBackend)try{this.a.trace("[EncryptionMainService] Getting selected storage backend...");const l=O.getSelectedStorageBackend();return this.a.trace("[EncryptionMainService] Selected storage backend: ",l),Promise.resolve(l)}catch(l){this.a.error(l)}return Promise.resolve(v.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$l)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$m)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");this.a.trace("[EncryptionMainService] Setting usePlainTextEncryption to true..."),O.setUsePlainTextEncryption(!0),this.a.trace("[EncryptionMainService] Set usePlainTextEncryption to true")}};e.$Xhc=I,e.$Xhc=I=ke([se(0,D.$fk)],I)}),define(le[192],ue([0,1,21,8,15,4,32,2,10,62,5]),function(G,e,i,r,v,D,O,I,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class u extends I.$Zc{constructor(p,d){super(),this.a=p,this.b=d,this.c=this.B(new D.$qe),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$qe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Ih(0)),this.w=[],this.y=this.B(new r.$Ih(0))}watch(p,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(p,d):this.z(p,d)}n(p,d){const f={path:this.J(p),excludes:d.excludes,includes:d.includes,recursive:d.recursive,filter:d.filter,correlationId:d.correlationId},y=(0,i.$Xb)(this.j,f);return this.r(),(0,I.$Xc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,v.$4)(p))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,l.$er)(d)),d=>this.G(d),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const d of this.j)(0,l.$ar)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const d of this.j)(0,l.$ar)(d)&&p.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,d){const f={path:this.J(p),excludes:d.excludes,includes:d.includes,recursive:!1,filter:d.filter,correlationId:d.correlationId},y=(0,i.$Xb)(this.w,f);return this.C(),(0,I.$Xc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,v.$4)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,l.$er)(p)),p=>this.G(p),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.H(p)}H(p){this.a[p.type](p.message)}I(p){return(0,b.$mc)(p.fsPath)}J(p){const d=this.I(p);return(0,O.$Mg)(d)}}e.$kr=u}),define(le[193],ue([0,1,21,8,17,22,4,48,78,2,61,11,71,18,68,9,14,127,5,15]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;let s=class extends l.$Zc{static{k=this}constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new O.$qe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$qe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$qe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$qe),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$qe),this.Y=this.B(new O.$qe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$qe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Th)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${t}`);const n=new l.$Yc;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),n.add(o.onDidChangeFile(c=>{const h=new y.$yl(c,!this.S(o));this.X.fire(h),h.hasCorrelation()||this.Y.fire(h)})),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(c=>this.Z.fire(new Error(c)))),n.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,l.$Xc)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,l.$Uc)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(n){o.push(n)}}),!this.h.has(t)&&await r.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return b.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,p.$ph)(t))throw new y.$Al((0,f.localize)(1871,null,this.sb(t)),y.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const n=new S.$fb;throw n.message=(0,f.localize)(1872,null,t.toString()),n}return o}async m(t){const o=await this.j(t);if((0,y.$ll)(o)||(0,y.$il)(o)||(0,y.$ml)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const o=await this.j(t);if((0,y.$ll)(o)||(0,y.$il)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.s(t,o)}catch(n){throw(0,y.$vl)(n)===y.FileSystemProviderErrorCode.FileNotFound?new y.$Al((0,f.localize)(1873,null,this.sb(t)),y.FileOperationResult.FILE_NOT_FOUND):(0,y.$tl)(n)}}async s(t,o){const n=await this.j(t),c=this.S(n),h=o?.resolveTo,P=o?.resolveSingleChildDescendants,w=o?.resolveMetadata,R=await n.stat(t);let T;return this.t(n,t,R,void 0,!!w,(A,L)=>(T||(T=m.$Qi.forUris(()=>!c),T.set(t,!0),h&&T.fill(!0,h)),T.get(A.resource)||T.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&P?L===1:!1))}async t(t,o,n,c,h,P){const{providerExtUri:w}=this.R(t),R={resource:o,name:w.basename(o),isFile:(n.type&y.FileType.File)!==0,isDirectory:(n.type&y.FileType.Directory)!==0,isSymbolicLink:(n.type&y.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&y.FilePermission.Readonly)||!!(t.capabilities&y.FileSystemProviderCapabilities.Readonly),locked:!!((n.permissions??0)&y.FilePermission.Locked),etag:(0,y.$Ll)({mtime:n.mtime,size:n.size}),children:void 0};if(R.isDirectory&&P(R,c)){try{const T=await t.readdir(o),A=await r.Promises.settled(T.map(async([L,M])=>{try{const V=w.joinPath(o,L),q=h?await t.stat(V):{type:M};return await this.t(t,V,q,T.length,h,P)}catch(V){return this.b.trace(V),null}}));R.children=(0,i.$Lb)(A)}catch(T){this.b.trace(T),R.children=[]}return R}return R}async resolveAll(t){return r.Promises.settled(t.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),n=await o.stat(t);return this.t(o,t,n,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.u(t,o)}catch(n){return n}return!0}async u(t,o){if(!o?.overwrite&&await this.exists(t))throw new y.$Al((0,f.localize)(1874,null,this.sb(t)),y.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(t,o=v.$Se.fromString(""),n){await this.u(t,n);const c=await this.writeFile(t,o);return this.r.fire(new y.$xl(t,y.FileOperation.CREATE,c)),c}async writeFile(t,o,n){const c=this.qb(await this.n(t),t),{providerExtUri:h}=this.R(c);let P=n;if((0,y.$ol)(c)&&!P?.atomic){const w=c.enforceAtomicWriteFile?.(t);w&&(P={...n,atomic:w})}try{await this.w(c,t,P)||await this.U(c,h.dirname(t));let R;if((0,y.$il)(c)&&!(o instanceof v.$Se))if((0,d.$Ee)(o)){const T=await(0,d.$Le)(o,3);T.ended?R=v.$Se.concat(T.buffer):R=T}else R=(0,d.$Ie)(o,T=>v.$Se.concat(T),3);else R=o;!(0,y.$ll)(c)||(0,y.$il)(c)&&R instanceof v.$Se||(0,y.$il)(c)&&(0,y.$ol)(c)&&P?.atomic?await this.hb(c,t,P,R):await this.db(c,t,P,R instanceof v.$Se?(0,v.$4e)(R):R),this.r.fire(new y.$xl(t,y.FileOperation.WRITE))}catch(w){throw new y.$Al((0,f.localize)(1875,null,this.sb(t),(0,y.$tl)(w).toString()),(0,y.$wl)(w),P)}return this.resolve(t,{resolveMetadata:!0})}async w(t,o,n){const c=!!n?.unlock;if(c&&!(t.capabilities&y.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,f.localize)(1876,null,this.sb(o)));if(!!n?.atomic){if(!(t.capabilities&y.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,f.localize)(1877,null,this.sb(o)));if(!(t.capabilities&y.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,f.localize)(1878,null,this.sb(o)));if(c)throw new Error((0,f.localize)(1879,null,this.sb(o)))}let P;try{P=await t.stat(o)}catch{return}if(P.type&y.FileType.Directory)throw new y.$Al((0,f.localize)(1880,null,this.sb(o)),y.FileOperationResult.FILE_IS_DIRECTORY,n);if(this.rb(o,P),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==y.$Kl&&typeof P.mtime=="number"&&typeof P.size=="number"&&n.mtime<P.mtime&&n.etag!==(0,y.$Ll)({mtime:n.mtime,size:P.size}))throw new y.$Al((0,f.localize)(1881,null),y.FileOperationResult.FILE_MODIFIED_SINCE,n);return P}async readFile(t,o,n){const c=await this.m(t);return o?.atomic?this.z(c,t,o,n):this.C(c,t,o,n)}async z(t,o,n,c){return new Promise((h,P)=>{this.cb.queueFor(o,async()=>{try{const w=await this.C(t,o,n,c);h(w)}catch(w){P(w)}},this.R(t).providerExtUri)})}async C(t,o,n,c){const h=await this.D(t,o,{...n,preferUnbuffered:!0},c);return{...h,value:await(0,v.$5e)(h.value)}}async readFileStream(t,o,n){const c=await this.m(t);return this.D(c,t,o,n)}async D(t,o,n,c){const h=new D.$Be(c);let P=n;(0,y.$nl)(t)&&t.enforceAtomicReadFile?.(o)&&(P={...n,atomic:!0});const w=this.J(o,P).then(T=>T,T=>{throw h.dispose(!0),T});let R;try{return typeof P?.etag=="string"&&P.etag!==y.$Kl&&await w,P?.atomic&&(0,y.$nl)(t)||!((0,y.$ll)(t)||(0,y.$ml)(t))||(0,y.$il)(t)&&P?.preferUnbuffered?R=this.I(t,o,P):(0,y.$ml)(t)?R=this.G(t,o,h.token,P):R=this.H(t,o,h.token,P),R.on("end",()=>h.dispose()),R.on("error",()=>h.dispose()),{...await w,value:R}}catch(T){throw R&&await(0,d.$Je)(R),this.F(T,o,P)}}F(t,o,n){const c=(0,f.localize)(1882,null,this.sb(o),(0,y.$tl)(t).toString());return t instanceof y.$Cl?new y.$Cl(c,t.stat,n):t instanceof y.$Bl?new y.$Bl(c,t.fileOperationResult,t.size,t.options):new y.$Al(c,(0,y.$wl)(t),n)}G(t,o,n,c=Object.create(null)){const h=t.readFileStream(o,c,n);return(0,d.$Pe)(h,{data:P=>P instanceof v.$Se?P:v.$Se.wrap(P),error:P=>this.F(P,o,c)},P=>v.$Se.concat(P))}H(t,o,n,c=Object.create(null)){const h=(0,v.$9e)();return(0,E.$0q)(t,o,h,P=>P,{...c,bufferSize:this.a,errorTransformer:P=>this.F(P,o,c)},n),h}I(t,o,n){const c=(0,d.$Ge)(h=>v.$Se.concat(h));return(async()=>{try{let h;n?.atomic&&(0,y.$nl)(t)?h=await t.readFile(o,{atomic:!0}):h=await t.readFile(o),typeof n?.position=="number"&&(h=h.slice(n.position)),typeof n?.length=="number"&&(h=h.slice(0,n.length)),this.L(o,h.byteLength,n),c.end(v.$Se.wrap(h))}catch(h){c.error(h),c.end()}})(),c}async J(t,o){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new y.$Al((0,f.localize)(1883,null,this.sb(t)),y.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==y.$Kl&&o.etag===n.etag)throw new y.$Cl((0,f.localize)(1884,null),n,o);return this.L(t,n.size,o),n}L(t,o,n){if(typeof n?.limits?.size=="number"&&o>n.limits.size)throw new y.$Bl((0,f.localize)(1885,null,this.sb(t)),y.FileOperationResult.FILE_TOO_LARGE,o,n)}async canMove(t,o,n){return this.M(t,o,"move",n)}async canCopy(t,o,n){return this.M(t,o,"copy",n)}async M(t,o,n,c){if(t.toString()!==o.toString())try{const h=n==="move"?this.qb(await this.n(t),t):await this.m(t),P=this.qb(await this.n(o),o);await this.Q(h,t,P,o,n,c)}catch(h){return h}return!0}async move(t,o,n){const c=this.qb(await this.n(t),t),h=this.qb(await this.n(o),o),P=await this.N(c,t,h,o,"move",!!n),w=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new y.$xl(t,P==="move"?y.FileOperation.MOVE:y.FileOperation.COPY,w)),w}async copy(t,o,n){const c=await this.m(t),h=this.qb(await this.n(o),o),P=await this.N(c,t,h,o,"copy",!!n),w=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new y.$xl(t,P==="copy"?y.FileOperation.COPY:y.FileOperation.MOVE,w)),w}async N(t,o,n,c,h,P){if(o.toString()===c.toString())return h;const{exists:w,isSameResourceWithDifferentPathCase:R}=await this.Q(t,o,n,c,h,P);if(w&&!R&&P&&await this.del(c,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(c)),h==="copy"){if(t===n&&(0,y.$jl)(t))await t.copy(o,c,{overwrite:P});else{const T=await this.resolve(o);T.isDirectory?await this.P(t,T,n,c):await this.O(t,o,n,c)}return h}else return t===n?(await t.rename(o,c,{overwrite:P}),h):(await this.N(t,o,n,c,"copy",P),await this.del(o,{recursive:!0}),"copy")}async O(t,o,n,c){if((0,y.$ll)(t)&&(0,y.$ll)(n))return this.jb(t,o,n,c);if((0,y.$ll)(t)&&(0,y.$il)(n))return this.pb(t,o,n,c);if((0,y.$il)(t)&&(0,y.$ll)(n))return this.nb(t,o,n,c);if((0,y.$il)(t)&&(0,y.$il)(n))return this.lb(t,o,n,c)}async P(t,o,n,c){await n.mkdir(c),Array.isArray(o.children)&&await r.Promises.settled(o.children.map(async h=>{const P=this.R(n).providerExtUri.joinPath(c,h.name);return h.isDirectory?this.P(t,await this.resolve(h.resource),n,P):this.O(t,h.resource,n,P)}))}async Q(t,o,n,c,h,P){let w=!1;if(t===n){const{providerExtUri:T,isPathCaseSensitive:A}=this.R(t);if(A||(w=T.isEqual(o,c)),w&&h==="copy")throw new Error((0,f.localize)(1886,null,this.sb(o),this.sb(c)));if(!w&&T.isEqualOrParent(c,o))throw new Error((0,f.localize)(1887,null,this.sb(o),this.sb(c)))}const R=await this.exists(c);if(R&&!w){if(!P)throw new y.$Al((0,f.localize)(1888,null,this.sb(o),this.sb(c)),y.FileOperationResult.FILE_MOVE_CONFLICT);if(t===n){const{providerExtUri:T}=this.R(t);if(T.isEqualOrParent(o,c))throw new Error((0,f.localize)(1889,null,this.sb(o),this.sb(c)))}}return{exists:R,isSameResourceWithDifferentPathCase:w}}R(t){const o=this.S(t);return{providerExtUri:o?p.$bh:p.$dh,isPathCaseSensitive:o}}S(t){return!!(t.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(t){const o=this.qb(await this.j(t),t);await this.U(o,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new y.$xl(t,y.FileOperation.CREATE,n)),n}async U(t,o){const n=[],{providerExtUri:c}=this.R(t);for(;!c.isEqual(o,c.dirname(o));)try{if(!((await t.stat(o)).type&y.FileType.Directory))throw new Error((0,f.localize)(1890,null,this.sb(o)));break}catch(h){if((0,y.$vl)(h)!==y.FileSystemProviderErrorCode.FileNotFound)throw h;n.push(c.basename(o)),o=c.dirname(o)}for(let h=n.length-1;h>=0;h--){o=c.joinPath(o,n[h]);try{await t.mkdir(o)}catch(P){if((0,y.$vl)(P)!==y.FileSystemProviderErrorCode.FileExists)throw P}}}async canDelete(t,o){try{await this.W(t,o)}catch(n){return n}return!0}async W(t,o){const n=this.qb(await this.j(t),t),c=!!o?.useTrash;if(c&&!(n.capabilities&y.FileSystemProviderCapabilities.Trash))throw new Error((0,f.localize)(1891,null,this.sb(t)));const h=o?.atomic;if(h&&!(n.capabilities&y.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,f.localize)(1892,null,this.sb(t)));if(c&&h)throw new Error((0,f.localize)(1893,null,this.sb(t)));let P;try{P=await n.stat(t)}catch{}if(P)this.rb(t,P);else throw new y.$Al((0,f.localize)(1894,null,this.sb(t)),y.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const R=await this.resolve(t);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,f.localize)(1895,null,this.sb(t)))}return n}async del(t,o){const n=await this.W(t,o);let c=o;if((0,y.$pl)(n)&&!c?.atomic){const R=n.enforceAtomicDelete?.(t);R&&(c={...o,atomic:R})}const h=!!c?.useTrash,P=!!c?.recursive,w=c?.atomic??!1;await n.delete(t,{recursive:P,useTrash:h,atomic:w}),this.r.fire(new y.$xl(t,y.FileOperation.DELETE))}async cloneFile(t,o){const n=await this.j(t),c=this.qb(await this.n(o),o);if(!(n===c&&this.R(n).providerExtUri.isEqual(t,o)))return n===c&&(0,y.$kl)(n)?n.cloneFile(t,o):(await this.U(c,this.R(c).providerExtUri.dirname(o)),n===c&&(0,y.$jl)(n)?this.cb.queueFor(t,()=>n.copy(t,o,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(t,()=>this.O(n,t,c,o),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(t,o){return this.watch(t,{...o,correlationId:k.ab++})}watch(t,o={recursive:!1,excludes:[]}){const n=new l.$Yc;let c=!1,h=()=>{c=!0};n.add((0,l.$Xc)(()=>h())),(async()=>{try{const w=await this.bb(t,o);c?(0,l.$Uc)(w):h=()=>(0,l.$Uc)(w)}catch(w){this.b.error(w)}})();const P=o.correlationId;if(typeof P=="number"){const w=n.add(new O.$qe);return n.add(this.X.event(T=>{T.correlates(P)&&w.fire(T)})),{onDidChange:w.event,dispose:()=>n.dispose()}}return n}async bb(t,o){const n=await this.j(t),c=(0,I.$yj)([this.R(n).providerExtUri.getComparisonKey(t),o]);let h=this.$.get(c);return h||(h={count:0,disposable:n.watch(t,o)},this.$.set(c,h)),h.count+=1,(0,l.$Xc)(()=>{h&&(h.count--,h.count===0&&((0,l.$Uc)(h.disposable),this.$.delete(c)))})}dispose(){super.dispose();for(const[,t]of this.$)(0,l.$Uc)(t.disposable);this.$.clear()}async db(t,o,n,c){return this.cb.queueFor(o,async()=>{const h=await t.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,d.$Ee)(c)||(0,d.$Fe)(c)?await this.eb(t,h,c):await this.fb(t,h,c)}catch(P){throw(0,y.$tl)(P)}finally{await t.close(h)}},this.R(t).providerExtUri)}async eb(t,o,n){let c=0,h;if((0,d.$Fe)(n)){if(n.buffer.length>0){const P=v.$Se.concat(n.buffer);await this.gb(t,o,P,P.byteLength,c,0),c+=P.byteLength}if(n.ended)return;h=n.stream}else h=n;return new Promise((P,w)=>{(0,d.$Ke)(h,{onData:async R=>{h.pause();try{await this.gb(t,o,R,R.byteLength,c,0)}catch(T){return w(T)}c+=R.byteLength,setTimeout(()=>h.resume())},onError:R=>w(R),onEnd:()=>P()})})}async fb(t,o,n){let c=0,h;for(;(h=n.read())!==null;)await this.gb(t,o,h,h.byteLength,c,0),c+=h.byteLength}async gb(t,o,n,c,h,P){let w=0;for(;w<c;){const R=await t.write(o,h+w,n.buffer,P+w,c-w);w+=R}}async hb(t,o,n,c){return this.cb.queueFor(o,()=>this.ib(t,o,n,c),this.R(t).providerExtUri)}async ib(t,o,n,c){let h;c instanceof v.$Se?h=c:(0,d.$Ee)(c)?h=await(0,v.$5e)(c):(0,d.$Fe)(c)?h=await(0,v.$6e)(c):h=(0,v.$3e)(c),await t.writeFile(o,h.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(t,o,n,c){return this.cb.queueFor(c,()=>this.kb(t,o,n,c),this.R(n).providerExtUri)}async kb(t,o,n,c){let h,P;try{h=await t.open(o,{create:!1}),P=await n.open(c,{create:!0,unlock:!1});const w=v.$Se.alloc(this.a);let R=0,T=0,A=0;do A=await t.read(h,R,w.buffer,T,w.byteLength-T),await this.gb(n,P,w,A,R,T),R+=A,T+=A,T===w.byteLength&&(T=0);while(A>0)}catch(w){throw(0,y.$tl)(w)}finally{await r.Promises.settled([typeof h=="number"?t.close(h):Promise.resolve(),typeof P=="number"?n.close(P):Promise.resolve()])}}async lb(t,o,n,c){return this.cb.queueFor(c,()=>this.mb(t,o,n,c),this.R(n).providerExtUri)}async mb(t,o,n,c){return n.writeFile(c,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(t,o,n,c){return this.cb.queueFor(c,()=>this.ob(t,o,n,c),this.R(n).providerExtUri)}async ob(t,o,n,c){const h=await n.open(c,{create:!0,unlock:!1});try{const P=await t.readFile(o);await this.gb(n,h,v.$Se.wrap(P),P.byteLength,0,0)}catch(P){throw(0,y.$tl)(P)}finally{await n.close(h)}}async pb(t,o,n,c){const h=await(0,v.$5e)(this.H(t,o,D.CancellationToken.None));await this.hb(n,c,void 0,h)}qb(t,o){if(t.capabilities&y.FileSystemProviderCapabilities.Readonly)throw new y.$Al((0,f.localize)(1896,null,this.sb(o)),y.FileOperationResult.FILE_PERMISSION_DENIED);return t}rb(t,o){if((o.permissions??0)&y.FilePermission.Readonly)throw new y.$Al((0,f.localize)(1897,null,this.sb(t)),y.FileOperationResult.FILE_PERMISSION_DENIED)}sb(t){return t.scheme===u.Schemas.file?t.fsPath:t.toString(!0)}};e.$$q=s,e.$$q=s=k=ke([se(0,g.$fk)],s)}),define(le[102],ue([0,1,26,8,31,17,4,32,2,10,3,18,68,23,9,14,127,192,188,187]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class k extends E.$kr{static{this.L=!1}constructor(a,t){super(a,t),this.onDidChangeCapabilities=O.Event.None,this.P=new v.$Fc(o=>u.$ch.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=f.FileSystemProviderCapabilities.FileReadWrite|f.FileSystemProviderCapabilities.FileOpenReadWriteClose|f.FileSystemProviderCapabilities.FileReadStream|f.FileSystemProviderCapabilities.FileFolderCopy|f.FileSystemProviderCapabilities.FileWriteUnlock|f.FileSystemProviderCapabilities.FileAtomicRead|f.FileSystemProviderCapabilities.FileAtomicWrite|f.FileSystemProviderCapabilities.FileAtomicDelete|f.FileSystemProviderCapabilities.FileClone,m.$n&&(this.M|=f.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(a){try{const{stat:t,symbolicLink:o}=await p.SymlinkSupport.stat(this.I(a));return{type:this.O(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:f.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const t=await p.Promises.readdir(this.I(a),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async n=>{try{let c;n.isSymbolicLink()?c=(await this.stat((0,u.$lh)(a,n.name))).type:c=this.O(n),o.push([n.name,c])}catch(c){this.a.trace(c)}})),o}catch(t){throw this.hb(t)}}O(a,t){let o;return t?.dangling?o=f.FileType.Unknown:a.isFile()?o=f.FileType.File:a.isDirectory()?o=f.FileType.Directory:o=f.FileType.Unknown,t&&(o|=f.FileType.SymbolicLink),o}async Q(a){const t=this.I(a);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let o;for(;o=this.P.get(a);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await o.wait();const n=new r.$Jh;return this.P.set(a,n),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,b.$Xc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(a)===n&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(a)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),n.open()})}async readFile(a,t){let o;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(a)})`),o=await this.Q(a));const n=this.I(a);return await i.promises.readFile(n)}catch(n){throw this.hb(n)}finally{o?.dispose()}}R(a){k.L&&this.a.trace(a)}readFileStream(a,t,o){const n=(0,$.$Ge)(c=>D.$Se.concat(c.map(h=>D.$Se.wrap(h))).buffer);return(0,y.$0q)(this,a,n,c=>c.buffer,{...t,bufferSize:256*1024},o),n}async writeFile(a,t,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(a)?this.U(a,(0,u.$lh)((0,u.$kh)(a),`${(0,u.$ih)(a)}${o.atomic.postfix}`),t,o):this.W(a,t,o)}async S(a){try{const t=this.I(a),{symbolicLink:o}=await p.SymlinkSupport.stat(t);if(o)return!1}catch{}return!0}async U(a,t,o,n){const c=new b.$Yc;try{c.add(await this.Q(a)),c.add(await this.Q(t)),await this.W(t,o,n,!0);try{await this.rename(t,a,{overwrite:!0})}catch(h){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw h}}finally{c.dispose()}}async W(a,t,o,n){let c;try{const h=this.I(a);if(!o.create||!o.overwrite){if(await p.Promises.exists(h)){if(!o.overwrite)throw(0,f.$sl)((0,d.localize)(1901,null),f.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,f.$sl)((0,d.localize)(1902,null),f.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(a,{create:!0,unlock:o.unlock},n),await this.write(c,0,t,0,t.byteLength)}catch(h){throw await this.ib(a,h)}finally{typeof c=="number"&&await this.close(c)}}static{this.$=!0}static configureFlushOnWrite(a){k.$=a}async open(a,t,o){const n=this.I(a);let c;(0,f.$gl)(t)&&!o&&(c=await this.Q(a));let h;try{if((0,f.$gl)(t)&&t.unlock)try{const{stat:w}=await p.SymlinkSupport.stat(n);w.mode&128||await i.promises.chmod(n,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let P;if((0,f.$gl)(t)){if(m.$l)try{await i.promises.truncate(n,0),P="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}P||(P="w")}else P="r";h=await p.Promises.open(n,P)}catch(P){throw c?.dispose(),(0,f.$gl)(t)?await this.ib(a,P):this.hb(P)}if(this.X.set(h,0),(0,f.$gl)(t)&&this.Z.set(h,a),c){const P=this.Y.get(h);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${h} (${n})`),this.Y.set(h,c),P&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${h} (${n})`),P.dispose())}return h}async close(a){const t=this.Y.get(a);try{if(this.X.delete(a),this.Z.delete(a)&&k.$)try{await p.Promises.fdatasync(a)}catch(o){k.configureFlushOnWrite(!1),this.a.error(o)}return await p.Promises.close(a)}catch(o){throw this.hb(o)}finally{t&&(this.Y.get(a)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.Y.delete(a)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),t.dispose())}}async read(a,t,o,n,c){const h=this.ab(a,t);let P=null;try{P=(await p.Promises.read(a,o,n,c,h)).bytesRead}catch(w){throw this.hb(w)}finally{this.bb(a,h,P)}return P}ab(a,t){return t===this.X.get(a)?null:t}bb(a,t,o){const n=this.X.get(a);typeof n=="number"&&(typeof t=="number"||(typeof o=="number"?this.X.set(a,n+o):this.X.delete(a)))}async write(a,t,o,n,c){return(0,r.$5h)(()=>this.cb(a,t,o,n,c),100,3)}async cb(a,t,o,n,c){const h=this.ab(a,t);let P=null;try{P=(await p.Promises.write(a,o,n,c,h)).bytesWritten}catch(w){throw await this.ib(this.Z.get(a),w)}finally{this.bb(a,h,P)}return P}async mkdir(a){try{await i.promises.mkdir(this.I(a))}catch(t){throw this.hb(t)}}async delete(a,t){try{const o=this.I(a);if(t.recursive){let n;t?.atomic!==!1&&t.atomic.postfix&&(n=(0,l.$oc)((0,l.$rc)(o),`${(0,l.$sc)(o)}${t.atomic.postfix}`)),await p.Promises.rm(o,p.RimRafMode.MOVE,n)}else try{await i.promises.unlink(o)}catch(n){if(n.code==="EPERM"||n.code==="EISDIR"){let c=!1;try{const{stat:h,symbolicLink:P}=await p.SymlinkSupport.stat(o);c=h.isDirectory()&&!P}catch{}if(c)await i.promises.rmdir(o);else throw n}else throw n}}catch(o){throw this.hb(o)}}async rename(a,t,o){const n=this.I(a),c=this.I(t);if(n!==c)try{await this.db(a,t,"move",o.overwrite),await p.Promises.rename(n,c)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,d.localize)(1903,null,(0,l.$sc)(n),(0,l.$sc)((0,l.$rc)(c)),h.toString()))),this.hb(h)}}async copy(a,t,o){const n=this.I(a),c=this.I(t);if(n!==c)try{await this.db(a,t,"copy",o.overwrite),await p.Promises.copy(n,c,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,d.localize)(1904,null,(0,l.$sc)(n),(0,l.$sc)((0,l.$rc)(c)),h.toString()))),this.hb(h)}}async db(a,t,o,n){const c=this.I(a),h=this.I(t);let P=!1;if(!!(this.capabilities&f.FileSystemProviderCapabilities.PathCaseSensitive)||(P=(0,I.$Ig)(c,h,!0)),P){if(o==="copy")throw(0,f.$sl)((0,d.localize)(1905,null),f.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const R=await this.N(a);if(!R)throw(0,f.$sl)((0,d.localize)(1906,null),f.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(t);if(T){if(!n)throw(0,f.$sl)((0,d.localize)(1907,null),f.FileSystemProviderErrorCode.FileExists);R.type&f.FileType.File&&T.type&f.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,t){return this.eb(a,t,!1)}async eb(a,t,o){const n=this.I(a),c=this.I(t),h=!!(this.capabilities&f.FileSystemProviderCapabilities.PathCaseSensitive);if((0,I.$Ig)(n,c,!h))return;const P=new b.$Yc;try{P.add(await this.Q(a)),P.add(await this.Q(t)),o&&await i.promises.mkdir((0,l.$rc)(c),{recursive:!0}),await i.promises.copyFile(n,c)}catch(w){if(w.code==="ENOENT"&&!o)return this.eb(a,t,!0);throw this.hb(w)}finally{P.dispose()}}t(a,t,o){return new g.$rr(n=>a(n),n=>t(n),o)}F(a,t,o){return new S.$Ar(n=>a(n),n=>t(n),o)}hb(a){if(a instanceof f.$rl)return a;let t=a,o;switch(a.code){case"ENOENT":o=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=f.FileSystemProviderErrorCode.Unknown;break;default:o=f.FileSystemProviderErrorCode.Unknown}return(0,f.$sl)(t,o)}async ib(a,t){let o=this.hb(t);if(a&&o.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:n}=await p.SymlinkSupport.stat(this.I(a));n.mode&128||(o=(0,f.$sl)(t,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(n){this.a.trace(n)}return o}}e.$Br=k}),define(le[194],ue([0,1,4,102,2,17,68,22]),function(G,e,i,r,v,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$_s=void 0;class b extends v.$Zc{constructor(u,$){super(),this.a=u,this.b=$,this.F=new Map,this.G=new Map}call(u,$,p){const d=this.c(u);switch($){case"stat":return this.g(d,p[0]);case"readdir":return this.h(d,p[0]);case"open":return this.r(d,p[0],p[1]);case"close":return this.s(p[0]);case"read":return this.t(p[0],p[1],p[2]);case"readFile":return this.j(d,p[0],p[1]);case"write":return this.u(p[0],p[1],p[2],p[3],p[4]);case"writeFile":return this.n(d,p[0],p[1],p[2]);case"rename":return this.z(d,p[0],p[1],p[2]);case"copy":return this.C(d,p[0],p[1],p[2]);case"cloneFile":return this.D(d,p[0],p[1]);case"mkdir":return this.w(d,p[0]);case"delete":return this.y(d,p[0],p[1]);case"watch":return this.I(d,p[0],p[1],p[2],p[3]);case"unwatch":return this.J(p[0],p[1])}throw new Error(`IPC Command ${$} not found`)}listen(u,$,p){const d=this.c(u);switch($){case"fileChange":return this.H(d,p[0]);case"readFileStream":return this.m(d,p[0],p[1])}throw new Error(`Unknown event ${$}`)}g(u,$){const p=this.f(u,$,!0);return this.a.stat(p)}h(u,$){const p=this.f(u,$);return this.a.readdir(p)}async j(u,$,p){const d=this.f(u,$,!0),f=await this.a.readFile(d,p);return D.$Se.wrap(f)}m(u,$,p){const d=this.f(u,$,!0),f=new I.$Be,y=new i.$qe({onDidRemoveLastListener:()=>{f.cancel()}}),E=this.a.readFileStream(d,p,f.token);return(0,O.$Ke)(E,{onData:g=>y.fire(D.$Se.wrap(g)),onError:g=>y.fire(g),onEnd:()=>{y.fire("end"),y.dispose(),f.dispose()}}),y.event}n(u,$,p,d){const f=this.f(u,$);return this.a.writeFile(f,p.buffer,d)}r(u,$,p){const d=this.f(u,$,!0);return this.a.open(d,p)}s(u){return this.a.close(u)}async t(u,$,p){const d=D.$Se.alloc(p),y=await this.a.read(u,$,d.buffer,0,p);return[d,y]}u(u,$,p,d,f){return this.a.write(u,$,p.buffer,d,f)}w(u,$){const p=this.f(u,$);return this.a.mkdir(p)}y(u,$,p){const d=this.f(u,$);return this.a.delete(d,p)}z(u,$,p,d){const f=this.f(u,$),y=this.f(u,p);return this.a.rename(f,y,d)}C(u,$,p,d){const f=this.f(u,$),y=this.f(u,p);return this.a.copy(f,y,d)}D(u,$,p){const d=this.f(u,$),f=this.f(u,p);return this.a.cloneFile(d,f)}H(u,$){const p=new i.$qe({onWillAddFirstListener:()=>{this.F.set($,this.L(u,p))},onDidRemoveLastListener:()=>{(0,v.$Uc)(this.F.get($)),this.F.delete($)}});return p.event}async I(u,$,p,d,f){const y=this.F.get($);if(y){const E=this.f(u,d),g=y.watch(p,E,f);this.G.set($+p,g)}}async J(u,$){const p=u+$,d=this.G.get(p);d&&((0,v.$Uc)(d),this.G.delete(p))}dispose(){super.dispose();for(const[,u]of this.G)u.dispose();this.G.clear();for(const[,u]of this.F)u.dispose();this.F.clear()}}e.$_s=b;class l extends v.$Zc{constructor(u,$,p,d){super(),this.c=u,this.f=p,this.g=d,this.a=new Map,this.b=this.B(new r.$Br(this.f,{watcher:{recursive:this.j(this.g)}})),this.h($)}h(u){const $=this.B(new i.$qe);this.B($.event(p=>{u.fire(p.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type,cId:d.cId})))})),this.B(this.b.onDidChangeFile(p=>$.fire(p))),this.B(this.b.onDidWatchError(p=>u.fire(p)))}j(u){}m(u){}watch(u,$,p){const d=this.m(this.g);return Array.isArray(d)&&(p.excludes=[...p.excludes,...d]),this.a.set(u,this.b.watch($,p)),(0,v.$Xc)(()=>{(0,v.$Uc)(this.a.get(u)),this.a.delete(u)})}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),super.dispose()}}e.$at=l}),define(le[195],ue([0,1,13,9,3,7,14,10,194,161,55]),function(G,e,i,r,v,D,O,I,b,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class u extends b.$_s{constructor(d,f,y){super(d,f),this.M=y}c(d){return l.$Tn}f(d,f){return D.URI.revive(f)}async y(d,f,y){if(!y.useTrash)return super.y(d,f,y);const E=this.f(d,f),g=(0,I.$mc)(E.fsPath);try{await i.shell.trashItem(g)}catch(S){throw(0,O.$sl)(v.$l?(0,r.localize)(1899,null,(0,I.$sc)(g),(0,m.$vj)(S)):(0,r.localize)(1900,null,(0,I.$sc)(g),(0,m.$vj)(S)),O.FileSystemProviderErrorCode.Unknown)}}L(d,f){return new $(d,f,this.b,this.M)}}e.$6hc=u;class $ extends b.$at{watch(d,f,y){if(y.recursive)throw(0,O.$sl)("Recursive file watching is not supported from main process for performance reasons.",O.FileSystemProviderErrorCode.Unavailable);return super.watch(d,f,y)}}}),define(le[196],ue([0,1,5]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;class r extends i.$lk{constructor(D=i.$ik){super(),this.m=[],this.n=void 0,this.setLevel(D),this.B(this.onDidChangeLogLevel(O=>{this.n?.setLevel(O)}))}set logger(D){this.n=D;for(const{level:O,message:I}of this.m)(0,i.log)(D,O,I);this.m=[]}g(D,O){this.n?(0,i.log)(this.n,D,O):this.getLevel()<=D&&this.m.push({level:D,message:O})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$Jec=r}),define(le[197],ue([0,1,7,4,5,2]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=e.$Cs=e.$Bs=void 0;class O extends v.$qk{constructor(u,$,p,d,f){super($,p,d),this.r=u,this.t=f,this.B(f.listen("onDidChangeLogLevel",u)(y=>{(0,v.$hk)(y)?super.setLogLevel(y):super.setLogLevel(i.URI.revive(y[0]),y[1])})),this.B(f.listen("onDidChangeVisibility",u)(([y,E])=>super.setVisibility(i.URI.revive(y),E))),this.B(f.listen("onDidChangeLoggers",u)(({added:y,removed:E})=>{for(const g of y)super.registerLogger({...g,resource:i.URI.revive(g.resource)});for(const g of E)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new v.$ok({log:(u,$)=>{this.t.call("consoleLog",[u,$])}})}registerLogger(u){super.registerLogger(u),this.t.call("registerLogger",[u,this.r])}deregisterLogger(u){super.deregisterLogger(u),this.t.call("deregisterLogger",[u,this.r])}setLogLevel(u,$){super.setLogLevel(u,$),this.t.call("setLogLevel",[u,$])}setVisibility(u,$){super.setVisibility(u,$),this.t.call("setVisibility",[this.n(u),$])}s(u,$,p){return new I(this.t,u,$,p,this.r)}static setLogLevel(u,$,p){return u.call("setLogLevel",[$,p])}}e.$Bs=O;class I extends v.$lk{constructor(u,$,p,d,f){super(d?.logLevel==="always"),this.r=u,this.s=$,this.m=!1,this.n=[],this.setLevel(p),this.r.call("createLogger",[$,d,f]).then(()=>{this.u(this.n),this.m=!0})}g(u,$){const p=[[u,$]];this.m?this.u(p):this.n.push(...p)}u(u){this.r.call("log",[this.s,u])}}class b{constructor(u,$){this.a=u,this.b=$}listen(u,$){const p=this.b(u);switch($){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(f=>this.c(f,p)),removed:[...d.removed].map(f=>this.c(f,p))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,d=>[p.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,d=>(0,v.$hk)(d)?d:[p.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${$}`)}async call(u,$,p){const d=this.b(u);switch($){case"setLogLevel":return(0,v.$hk)(p[0])?this.a.setLogLevel(p[0]):this.a.setLogLevel(i.URI.revive(d.transformIncoming(p[0][0])),p[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(f=>this.c(f,d)))}throw new Error(`Call not found: ${$}`)}c(u,$){return{...u,resource:$.transformOutgoingURI(u.resource)}}}e.$Cs=b;class l extends D.$Zc{constructor(u,$){super(),$.call("setLogLevel",[u.getLogLevel()]),this.B(u.onDidChangeLogLevel(p=>$.call("setLogLevel",[p]))),$.call("getRegisteredLoggers").then(p=>{for(const d of p)u.registerLogger({...d,resource:i.URI.revive(d.resource)})}),this.B($.listen("onDidChangeVisibility")(([p,d])=>u.setVisibility(i.URI.revive(p),d))),this.B($.listen("onDidChangeLoggers")(({added:p,removed:d})=>{for(const f of p)u.registerLogger({...f,resource:i.URI.revive(f.resource)});for(const f of d)u.deregisterLogger(f.resource)}))}}e.$Ds=l}),define(le[198],ue([0,1,2,5]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aS=void 0;class v extends i.$Zc{constructor(O,I=[]){super(),this.a=new r.$pk([O,...I]),this.B(O.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$aS=v}),define(le[199],ue([0,1,31,7,5]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;class D{constructor(I){this.b=I,this.a=new i.$Fc}listen(I,b,l){switch(b){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${b}`)}async call(I,b,l){switch(b){case"createLogger":this.c(r.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(r.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,v.$hk)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(r.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:r.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(l[0]))}throw new Error(`Call not found: ${b}`)}c(I,b,l){this.a.set(I,this.b.createLogger(I,b,l))}d(I,b){let l=console.log;switch(I){case v.LogLevel.Error:l=console.error;break;case v.LogLevel.Warning:l=console.warn;break;case v.LogLevel.Info:l=console.info;break}l.call(console,...b)}e(I,b){const l=this.a.get(I);if(!l)throw new Error("Create the logger before logging");for(const[m,u]of b)(0,v.log)(l,m,u)}}e.$4ic=D}),define(le[200],ue([0,1,14,5]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2R=void 0;var v;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(v||(v={}));async function D(l,m,u,$,p){try{const d=await new Promise((y,E)=>{G(["@vscode/spdlog"],y,E)}).then(Ie);d.setFlushOn(v.Trace);const f=await d.createAsyncRotatingLogger(l,m,u,$);return p?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(d){console.error(d)}return null}function O(l,m,u){switch(m){case r.LogLevel.Trace:l.trace(u);break;case r.LogLevel.Debug:l.debug(u);break;case r.LogLevel.Info:l.info(u);break;case r.LogLevel.Warning:l.warn(u);break;case r.LogLevel.Error:l.error(u);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function I(l,m){switch(m){case r.LogLevel.Trace:l.setLevel(v.Trace);break;case r.LogLevel.Debug:l.setLevel(v.Debug);break;case r.LogLevel.Info:l.setLevel(v.Info);break;case r.LogLevel.Warning:l.setLevel(v.Warning);break;case r.LogLevel.Error:l.setLevel(v.Error);break;case r.LogLevel.Off:l.setLevel(v.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class b extends r.$lk{constructor(m,u,$,p,d){super(),this.m=[],this.setLevel(d),this.n=this.s(m,u,$,p),this.B(this.onDidChangeLogLevel(f=>{this.r&&I(this.r,f)}))}async s(m,u,$,p){const d=$?6:1,f=30/d*i.$Nl.MB,y=await D(m,u,f,d,p);if(y){this.r=y,I(this.r,this.getLevel());for(const{level:E,message:g}of this.m)O(this.r,E,g);this.m=[]}}g(m,u){this.r?O(this.r,m,u):this.getLevel()<=m&&this.m.push({level:m,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$2R=b}),define(le[201],ue([0,1,33,5,200]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3R=void 0;class D extends r.$qk{s(I,b,l){return new v.$2R((0,i.$7g)(),I.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,b)}}e.$3R=D}),define(le[72],ue([0,1,31,4,6,5,201]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=e.$zhc=void 0,e.$zhc=(0,v.$Li)(D.$gk);class I extends O.$3R{constructor(){super(...arguments),this.u=new i.$Fc}createLogger(l,m,u){u!==void 0&&this.u.set(this.n(l),u);try{return super.createLogger(l,m)}catch($){throw this.u.delete(this.n(l)),$}}registerLogger(l,m){m!==void 0&&this.u.set(l.resource,m),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const m=[];for(const u of super.getRegisteredLoggers())l===this.u.get(u.resource)&&m.push(u);return m}getOnDidChangeLogLevelEvent(l){return r.Event.filter(this.onDidChangeLogLevel,m=>(0,D.$hk)(m)||this.w(m[0],l))}getOnDidChangeVisibilityEvent(l){return r.Event.filter(this.onDidChangeVisibility,([m])=>this.w(m,l))}getOnDidChangeLoggersEvent(l){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter($=>this.w($.resource,l)),removed:[...m.removed].filter($=>this.w($.resource,l))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(l){for(const[m,u]of this.u)u===l&&this.deregisterLogger(m)}w(l,m){const u=this.u.get(l);return u===void 0||u===m}dispose(){super.dispose(),this.u.clear()}}e.$Ahc=I}),define(le[202],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=i,e.$iic=r,e.$jic=v,e.$kic=D;function i(O){return O.submenu!==void 0}function r(O){return O.id==="vscode.menubar.separator"}function v(O){return O.uri!==void 0}function D(O){return!i(O)&&!r(O)&&!v(O)}}),define(le[40],ue([0,1,4,78,2,6]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=void 0,e.$zo=(0,D.$Ki)("policy");class O extends v.$Zc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new i.$qe),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const m=Object.keys(this.f).length;return this.f={...l,...this.f},m!==Object.keys(this.f).length&&await this.j(l),r.Iterable.reduce(this.g.entries(),(u,[$,p])=>({...u,[$]:p}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(l,[m,u])=>({...l,[m]:{definition:u,value:this.g.get(m)}}),{})}}e.$Ao=O;class I{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Bo=I}),define(le[203],ue([0,1,8,4,78,12,14,5,40]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;function l(u,$){const p=[];for(const d of new Set(v.Iterable.concat(u.keys(),$.keys())))u.get(d)!==$.get(d)&&p.push(d);return p}let m=class extends b.$Ao{constructor($,p,d){super(),this.m=$,this.n=p,this.s=d,this.c=this.B(new i.$Ih(500));const f=r.Event.filter(p.onDidFilesChange,y=>y.affects($));this.B(p.watch($)),this.B(f(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const $=new Map;try{const p=await this.n.readFile(this.m),d=JSON.parse(p.value.toString());if(!(0,D.$lg)(d))throw new Error("Policy file isn't a JSON object");for(const f of Object.keys(d))this.f[f]&&$.set(f,d[f])}catch(p){p.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",p)}return $}async w(){const $=await this.u(),p=l(this.g,$);this.g=$,p.length>0&&this.h.fire(p)}};e.$kjc=m,e.$kjc=m=ke([se(1,O.$fl),se(2,I.$fk)],m)}),define(le[204],ue([0,1,4,2,40]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=e.$Sic=void 0;class D{constructor(b){this.b=b,this.a=new r.$Yc}listen(b,l){switch(l){case"onDidChange":return i.Event.map(this.b.onDidChange,m=>m.reduce((u,$)=>({...u,[$]:this.b.getPolicyValue($)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(b,l,m){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$Sic=D;class O extends v.$Ao{constructor(b,l){super(),this.a=l;for(const m in b){const{definition:u,value:$}=b[m];this.f[m]=u,$!==void 0&&this.g.set(m,$)}this.a.listen("onDidChange")(m=>{for(const u in m){const $=m[u];$===null?this.g.delete(u):this.g.set(u,$)}this.h.fire(Object.keys(m))})}async j(b){const l=await this.a.call("updatePolicyDefinitions",b);for(const m in l)this.g.set(m,l[m])}}e.$Tic=O}),define(le[205],ue([0,1,40,8,2,5]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=void 0;let O=class extends i.$Ao{constructor(b,l){super(),this.m=b,this.n=l,this.a=new r.$Eh,this.b=this.B(new v.$1c)}async j(b){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(b).length} policy definitions`);const{createWatcher:l}=await new Promise((m,u)=>{G(["@vscode/policy-watcher"],m,u)}).then(Ie);await this.a.queue(()=>new Promise((m,u)=>{try{this.b.value=l(this.n,b,$=>{this.t($),m()})}catch($){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",$),u($)}}))}t(b){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(b)}`);for(const l in b){const m=b[l];m===void 0?this.g.delete(l):this.g.set(l,m)}this.h.fire(Object.keys(b))}};e.$jjc=O,e.$jjc=O=ke([se(0,D.$fk)],O)}),define(le[73],ue([0,1,38]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const v=globalThis.vscode;if(typeof v<"u"&&typeof v.context<"u"){const D=v.context.configuration();if(D)r=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:D.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(le[28],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=void 0,e.$yk=(0,i.$Ki)("productService"),e.$zk="vscode://schemas/vscode-product"}),define(le[206],ue([0,1,8,5]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;let v=class{constructor(O,I,b){this.a=O,this.b=I,this.c=b}async inspect(O){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,i.$Lh)(O);const b=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),b.profile}async d(){const O=this.a.webContents.debugger;O.attach(),await O.sendCommand("Profiler.enable")}async e(){const O=this.a.webContents.debugger;await O.sendCommand("Profiler.disable"),O.detach()}};e.$9hc=v,e.$9hc=v=ke([se(2,r.$fk)],v)}),define(le[74],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0,e.$ihc=(0,i.$Ki)("protocolMainService")}),define(le[46],ue([0,1,144,12]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0,i=Ie(i),r=Ie(r);class v{constructor(){this.a=new Map}add(O,I){i.ok(r.$jg(O)),i.ok(r.$lg(I)),i.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$xo=new v}),define(le[207],ue([0,1,4,146,46]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=void 0,v=Ie(v),e.$yo={JSONContribution:"base.contributions.json"};function D(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class O{constructor(){this.b=new i.$qe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,m){this.a[D(l)]=m,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(l){const m=this.a[l];return m?(0,r.$ak)(m):void 0}hasSchemaContent(l){return!!this.a[l]}}const I=new O;v.$xo.add(e.$yo.JSONContribution,I)}),define(le[56],ue([0,1,21,4,12,9,16,207,46]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ConfigurationScope=e.$Co=e.EditPresentationTypes=void 0,e.$No=f,e.$Oo=y,e.$Po=E,e.$Qo=S,e.$Ro=k,e.$So=s,e.$To=a,v=Ie(v),D=Ie(D);var l;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$Co={Configuration:"base.contributions.configuration"};var m;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho={properties:{},patternProperties:{}},e.$Io={properties:{},patternProperties:{}},e.$Jo="vscode://schemas/settings/resourceLanguage",e.$Ko="vscode://schemas/settings/configurationDefaults";const u=b.$xo.as(I.$yo.JSONContribution);class ${constructor(){this.a=[],this.i=new Set,this.j=new r.$qe,this.onDidSchemaChange=this.j.event,this.k=new r.$qe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:D.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},u.registerSchema(e.$Jo,this.h),this.z()}registerConfiguration(o,n=!0){this.registerConfigurations([o],n)}registerConfigurations(o,n=!0){const c=new Set;this.r(o,n,c),u.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:c})}deregisterConfigurations(o){const n=new Set;this.s(o,n),u.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:n})}updateConfigurations({add:o,remove:n}){const c=new Set;this.s(n,c),this.r(o,!1,c),u.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:c})}registerDefaultConfigurations(o){const n=new Set;this.l(o,n),this.j.fire(),this.k.fire({properties:n,defaultsOverrides:!0})}l(o,n){this.a.push(...o);const c=[];for(const{overrides:h,source:P}of o)for(const w in h){n.add(w);const R=this.b.get(w)??this.b.set(w,{configurationDefaultOverrides:[]}).get(w),T=h[w];if(R.configurationDefaultOverrides.push({value:T,source:P}),e.$Mo.test(w)){const A=this.o(w,T,P,R.configurationDefaultOverrideValue);if(!A)continue;R.configurationDefaultOverrideValue=A,this.n(w,A,P),c.push(...f(w))}else{const A=this.p(w,T,P,R.configurationDefaultOverrideValue);if(!A)continue;R.configurationDefaultOverrideValue=A;const L=this.e[w];L&&(this.A(w,L),this.w(w,L))}}this.q(c)}deregisterDefaultConfigurations(o){const n=new Set;this.m(o,n),this.j.fire(),this.k.fire({properties:n,defaultsOverrides:!0})}m(o,n){for(const c of o){const h=this.a.indexOf(c);h!==-1&&this.a.splice(h,1)}for(const{overrides:c,source:h}of o)for(const P in c){const w=this.b.get(P);if(!w)continue;const R=w.configurationDefaultOverrides.findIndex(T=>h?T.source?.id===h.id:T.value===c[P]);if(R!==-1){if(w.configurationDefaultOverrides.splice(R,1),w.configurationDefaultOverrides.length===0&&this.b.delete(P),e.$Mo.test(P)){let T;for(const A of w.configurationDefaultOverrides)T=this.o(P,A.value,A.source,T);T&&!v.$wg(T.value)?(w.configurationDefaultOverrideValue=T,this.n(P,T,h)):(this.b.delete(P),delete this.e[P],delete this.c.properties[P])}else{let T;for(const L of w.configurationDefaultOverrides)T=this.p(P,L.value,L.source,T);w.configurationDefaultOverrideValue=T;const A=this.e[P];A&&(this.A(P,A),this.w(P,A))}n.add(P)}}this.y()}n(o,n,c){const h={type:"object",default:n.value,description:D.localize(1663,null,(0,O.$oj)(o)),$ref:e.$Jo,defaultDefaultValue:n.value,source:c,defaultValueSource:c};this.e[o]=h,this.c.properties[o]=h}o(o,n,c,h){const P=h?.value||{},w=h?.source??new Map;if(!(w instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const R of Object.keys(n)){const T=n[R];if(v.$lg(T)&&(v.$qg(P[R])||v.$lg(P[R]))){if(P[R]={...P[R]??{},...T},c)for(const L in T)w.set(`${R}.${L}`,c)}else P[R]=T,c?w.set(R,c):w.delete(R)}return{value:P,source:w}}p(o,n,c,h){const P=this.e[o],w=h?.value??P?.defaultDefaultValue;let R=c;if(v.$lg(n)&&(P!==void 0&&P.type==="object"||P===void 0&&(v.$qg(w)||v.$lg(w)))){if(R=h?.source??new Map,!(R instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const A in n)c&&R.set(`${o}.${A}`,c);n={...v.$lg(w)?w:{},...n}}return{value:n,source:R}}deltaConfiguration(o){let n=!1;const c=new Set;o.removedDefaults&&(this.m(o.removedDefaults,c),n=!0),o.addedDefaults&&(this.l(o.addedDefaults,c),n=!0),o.removedConfigurations&&this.s(o.removedConfigurations,c),o.addedConfigurations&&this.r(o.addedConfigurations,!1,c),this.j.fire(),this.k.fire({properties:c,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...o){this.j.fire()}registerOverrideIdentifiers(o){this.q(o),this.j.fire()}q(o){for(const n of o)this.i.add(n);this.y()}r(o,n,c){o.forEach(h=>{this.u(h,n,h.extensionInfo,h.restrictedProperties,void 0,c),this.d.push(h),this.v(h)})}s(o,n){const c=h=>{if(h.properties)for(const P in h.properties){n.add(P);const w=this.e[P];w?.policy?.name&&this.f.delete(w.policy.name),delete this.e[P],this.x(P,h.properties[P])}h.allOf?.forEach(P=>c(P))};for(const h of o){c(h);const P=this.d.indexOf(h);P!==-1&&this.d.splice(P,1)}}u(o,n=!0,c,h,P=m.WINDOW,w){P=v.$sg(o.scope)?P:o.scope;const R=o.properties;if(R)for(const A in R){const L=R[A];if(n&&S(A,L)){delete R[A];continue}if(L.source=c,L.defaultDefaultValue=R[A].default,this.A(A,L),e.$Mo.test(A)?L.scope=void 0:(L.scope=v.$sg(L.scope)?P:L.scope,L.restricted=v.$sg(L.restricted)?!!h?.includes(A):L.restricted),R[A].hasOwnProperty("included")&&!R[A].included){this.g[A]=R[A],delete R[A];continue}else this.e[A]=R[A],R[A].policy?.name&&this.f.set(R[A].policy.name,A);!R[A].deprecationMessage&&R[A].markdownDeprecationMessage&&(R[A].deprecationMessage=R[A].markdownDeprecationMessage),w.add(A)}const T=o.allOf;if(T)for(const A of T)this.u(A,n,c,h,P,w)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const o=new Map;for(const[n,c]of this.b)c.configurationDefaultOverrideValue&&o.set(n,c.configurationDefaultOverrideValue);return o}v(o){const n=c=>{const h=c.properties;if(h)for(const w in h)this.w(w,h[w]);c.allOf?.forEach(n)};n(o)}w(o,n){switch(e.$Do.properties[o]=n,n.scope){case m.APPLICATION:e.$Eo.properties[o]=n;break;case m.MACHINE:e.$Fo.properties[o]=n;break;case m.MACHINE_OVERRIDABLE:e.$Go.properties[o]=n;break;case m.WINDOW:e.$Ho.properties[o]=n;break;case m.RESOURCE:e.$Io.properties[o]=n;break;case m.LANGUAGE_OVERRIDABLE:e.$Io.properties[o]=n,this.h.properties[o]=n;break}}x(o,n){switch(delete e.$Do.properties[o],n.scope){case m.APPLICATION:delete e.$Eo.properties[o];break;case m.MACHINE:delete e.$Fo.properties[o];break;case m.MACHINE_OVERRIDABLE:delete e.$Go.properties[o];break;case m.WINDOW:delete e.$Ho.properties[o];break;case m.RESOURCE:case m.LANGUAGE_OVERRIDABLE:delete e.$Io.properties[o],delete this.h.properties[o];break}}y(){for(const o of this.i.values()){const n=`[${o}]`,c={type:"object",description:D.localize(1664,null),errorMessage:D.localize(1665,null),$ref:e.$Jo};this.A(n,c),e.$Do.properties[n]=c,e.$Eo.properties[n]=c,e.$Fo.properties[n]=c,e.$Go.properties[n]=c,e.$Ho.properties[n]=c,e.$Io.properties[n]=c}}z(){const o={type:"object",description:D.localize(1666,null),errorMessage:D.localize(1667,null),$ref:e.$Jo};e.$Do.patternProperties[e.$Lo]=o,e.$Eo.patternProperties[e.$Lo]=o,e.$Fo.patternProperties[e.$Lo]=o,e.$Go.patternProperties[e.$Lo]=o,e.$Ho.patternProperties[e.$Lo]=o,e.$Io.patternProperties[e.$Lo]=o,this.j.fire()}A(o,n){const c=this.b.get(o)?.configurationDefaultOverrideValue;let h,P;c&&(!n.disallowConfigurationDefault||!c.source)&&(h=c.value,P=c.source),v.$qg(h)&&(h=n.defaultDefaultValue,P=void 0),v.$qg(h)&&(h=E(n.type)),n.default=h,n.defaultValueSource=P}}const p="\\[([^\\]]+)\\]",d=new RegExp(p,"g");e.$Lo=`^(${p})+$`,e.$Mo=new RegExp(e.$Lo);function f(t){const o=[];if(e.$Mo.test(t)){let n=d.exec(t);for(;n?.length;){const c=n[1].trim();c&&o.push(c),n=d.exec(t)}}return(0,i.$Qb)(o)}function y(t){return t.reduce((o,n)=>`${o}[${n}]`,"")}function E(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new $;b.$xo.add(e.$Co.Configuration,g);function S(t,o){return t.trim()?e.$Mo.test(t)?D.localize(1669,null,t):g.getConfigurationProperties()[t]!==void 0?D.localize(1670,null,t):o.policy?.name&&g.getPolicyConfigurations().get(o.policy?.name)!==void 0?D.localize(1671,null,t,o.policy?.name,g.getPolicyConfigurations().get(o.policy?.name)):null:D.localize(1668,null)}function k(){const t=[],o=g.getConfigurationProperties();for(const n of Object.keys(o))t.push([n,o[n].scope]);return t.push(["launch",m.RESOURCE]),t.push(["task",m.RESOURCE]),t}function s(t){const o={};for(const n of t){const c=n.properties;if(v.$lg(c))for(const h in c)o[h]=c[h];n.allOf&&Object.assign(o,s(n.allOf))}return o}function a(t){switch(t){case"application":return m.APPLICATION;case"machine":return m.MACHINE;case"resource":return m.RESOURCE;case"machine-overridable":return m.MACHINE_OVERRIDABLE;case"language-overridable":return m.LANGUAGE_OVERRIDABLE;default:return m.WINDOW}}}),define(le[128],ue([0,1,21,4,43,2,31,37,12,7,16,56,14,46]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0,e.$Yo=k,i=Ie(i),v=Ie(v),I=Ie(I),b=Ie(b);function d(o){return Object.isFrozen(o)?o:I.$lo(o)}class f{static createEmptyModel(n){return new f({},[],[],void 0,n)}constructor(n,c,h,P,w){this.b=n,this.c=c,this.d=h,this.raw=P,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(c=>{if(c instanceof f)return c;const h=new y("",this.f);return h.parseRaw(c),h.configurationModel});this.g=n.reduce((c,h)=>h===c?h:c.merge(h),n[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,m.$mj)(this.contents,n):this.contents}inspect(n,c){const h=this;return{get value(){return d(h.rawConfiguration.getValue(n))},get override(){return c?d(h.rawConfiguration.getOverrideValue(n,c)):void 0},get merged(){return d(c?h.rawConfiguration.override(c).getValue(n):h.rawConfiguration.getValue(n))},get overrides(){const P=[];for(const{contents:w,identifiers:R,keys:T}of h.rawConfiguration.overrides){const A=new f(w,T,[],void 0,h.f).getValue(n);A!==void 0&&P.push({identifiers:R,value:A})}return P.length?d(P):void 0}}}getOverrideValue(n,c){const h=this.j(c);return h?n?(0,m.$mj)(h,n):h:void 0}getKeysForOverrideIdentifier(n){const c=[];for(const h of this.overrides)h.identifiers.includes(n)&&c.push(...h.keys);return i.$Qb(c)}getAllOverrideIdentifiers(){const n=[];for(const c of this.overrides)n.push(...c.identifiers);return i.$Qb(n)}override(n){let c=this.a.get(n);return c||(c=this.h(n),this.a.set(n,c)),c}merge(...n){const c=I.$ko(this.contents),h=I.$ko(this.overrides),P=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const R of n)if(w.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(c,R.contents);for(const T of R.overrides){const[A]=h.filter(L=>i.$yb(L.identifiers,T.identifiers));A?(this.i(A.contents,T.contents),A.keys.push(...T.keys),A.keys=i.$Qb(A.keys)):h.push(I.$ko(T))}for(const T of R.keys)P.indexOf(T)===-1&&P.push(T)}return new f(c,P,h,w.every(R=>R instanceof f)?void 0:w,this.f)}h(n){const c=this.j(n);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const h={};for(const P of i.$Qb([...Object.keys(this.contents),...Object.keys(c)])){let w=this.contents[P];const R=c[P];R&&(typeof w=="object"&&typeof R=="object"?(w=I.$ko(w),this.i(w,R)):w=R),h[P]=w}return new f(h,this.keys,this.overrides,void 0,this.f)}i(n,c){for(const h of Object.keys(c)){if(h in n&&b.$lg(n[h])&&b.$lg(c[h])){this.i(n[h],c[h]);continue}n[h]=I.$ko(c[h])}}j(n){let c=null,h=null;const P=w=>{w&&(h?this.i(h,w):h=I.$ko(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===n?c=w.contents:w.identifiers.includes(n)&&P(w.contents);return P(c),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,c){this.k(n,c,!0)}setValue(n,c){this.k(n,c,!1)}removeValue(n){const c=this.keys.indexOf(n);c!==-1&&(this.keys.splice(c,1),(0,m.$lj)(this.contents,n),u.$Mo.test(n)&&this.overrides.splice(this.overrides.findIndex(h=>i.$yb(h.identifiers,(0,u.$No)(n))),1))}k(n,c,h){if((0,m.$kj)(this.contents,n,c,P=>this.f.error(P)),h=h||this.keys.indexOf(n)===-1,h&&this.keys.push(n),u.$Mo.test(n)){const P=(0,u.$No)(n),w={identifiers:P,keys:Object.keys(this.contents[n]),contents:(0,m.$jj)(this.contents[n],T=>this.f.error(T))},R=this.overrides.findIndex(T=>i.$yb(T.identifiers,P));R!==-1?this.overrides[R]=w:this.overrides.push(w)}}}e.$Uo=f;class y{constructor(n,c){this.f=n,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,c){if(!b.$sg(n)){const h=this.h(n);this.parseRaw(h,c)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,c){this.a=n;const{contents:h,keys:P,overrides:w,restricted:R,hasExcludedProperties:T}=this.i(n,c);this.b=new f(h,P,w,T?[n]:void 0,this.g),this.c=R||[]}h(n){let c={},h=null,P=[];const w=[],R=[];function T(L){Array.isArray(P)?P.push(L):h!==null&&(P[h]=L)}const A={onObjectBegin:()=>{const L={};T(L),w.push(P),P=L,h=null},onObjectProperty:L=>{h=L},onObjectEnd:()=>{P=w.pop()},onArrayBegin:()=>{const L=[];T(L),w.push(P),P=L,h=null},onArrayEnd:()=>{P=w.pop()},onLiteralValue:T,onError:(L,M,V)=>{R.push({error:L,offset:M,length:V})}};if(n)try{v.$_n(n,A),c=P[0]||{}}catch(L){this.g.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return c}i(n,c){const h=p.$xo.as(u.$Co.Configuration).getConfigurationProperties(),P=this.j(n,h,!0,c);n=P.raw;const w=(0,m.$jj)(n,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),R=Object.keys(n),T=this.l(n,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:w,keys:R,overrides:T,restricted:P.restricted,hasExcludedProperties:P.hasExcludedProperties}}j(n,c,h,P){let w=!1;if(!P?.scopes&&!P?.skipRestricted&&!P?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:w};const R={},T=[];for(const A in n)if(u.$Mo.test(A)&&h){const L=this.j(n[A],c,!1,P);R[A]=L.raw,w=w||L.hasExcludedProperties,T.push(...L.restricted)}else{const L=c[A],M=L?typeof L.scope<"u"?L.scope:u.ConfigurationScope.WINDOW:void 0;L?.restricted&&T.push(A),!P.exclude?.includes(A)&&(P.include?.includes(A)||(M===void 0||P.scopes===void 0||P.scopes.includes(M))&&!(P.skipRestricted&&L?.restricted))?R[A]=n[A]:w=!0}return{raw:R,restricted:T,hasExcludedProperties:w}}l(n,c){const h=[];for(const P of Object.keys(n))if(u.$Mo.test(P)){const w={};for(const R in n[P])w[R]=n[P][R];h.push({identifiers:(0,u.$No)(P),keys:Object.keys(w),contents:(0,m.$jj)(w,c)})}return h}}e.$Vo=y;class E extends D.$Zc{constructor(n,c,h,P,w){super(),this.c=n,this.f=c,this.g=P,this.h=w,this.b=this.B(new r.$qe),this.onDidChange=this.b.event,this.a=new y(this.c.toString(),w),this.B(this.g.watch(h.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation($.FileOperation.CREATE)||R.isOperation($.FileOperation.COPY)||R.isOperation($.FileOperation.DELETE)||R.isOperation($.FileOperation.WRITE))&&h.isEqual(R.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Wo=E;class g{constructor(n,c,h,P,w,R,T,A,L,M,V,q,Y){this.a=n,this.b=c,this.c=h,this.overrideIdentifiers=P,this.d=w,this.f=R,this.g=T,this.h=A,this.i=L,this.j=M,this.k=V,this.l=q,this.m=Y}get value(){return d(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class S{constructor(n,c,h,P,w,R,T,A,L,M){this.j=n,this.l=c,this.m=h,this.n=P,this.p=w,this.q=R,this.r=T,this.s=A,this.t=L,this.u=M,this.h=null,this.i=new O.$Fc,this.v=null}getValue(n,c,h){return this.w(n,c,h).getValue(n)}updateValue(n,c,h={}){let P;h.resource?(P=this.t.get(h.resource),P||(P=f.createEmptyModel(this.u),this.t.set(h.resource,P))):P=this.s,c===void 0?P.removeValue(n):P.setValue(n,c),h.resource||(this.h=null)}inspect(n,c,h){const P=this.w(n,c,h),w=this.A(c.resource,h),R=c.resource?this.t.get(c.resource)||this.s:this.s,T=new Set;for(const A of P.overrides)for(const L of A.identifiers)P.getOverrideValue(n,L)!==void 0&&T.add(L);return new g(n,c,P.getValue(n),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,h?this.q:void 0,w||void 0,R)}keys(n){const c=this.A(void 0,n);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(n){this.j=n,this.h=null,this.i.clear()}updatePolicyConfiguration(n){this.l=n}updateApplicationConfiguration(n){this.m=n,this.h=null,this.i.clear()}updateLocalUserConfiguration(n){this.n=n,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(n){this.p=n,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(n){this.q=n,this.h=null,this.i.clear()}updateFolderConfiguration(n,c){this.r.set(n,c),this.i.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.i.delete(n)}compareAndUpdateDefaultConfiguration(n,c){const h=[];if(!c){const{added:P,updated:w,removed:R}=a(this.j,n);c=[...P,...w,...R]}for(const P of c)for(const w of(0,u.$No)(P)){const R=this.j.getKeysForOverrideIdentifier(w),T=n.getKeysForOverrideIdentifier(w),A=[...T.filter(L=>R.indexOf(L)===-1),...R.filter(L=>T.indexOf(L)===-1),...R.filter(L=>!I.$oo(this.j.override(w).getValue(L),n.override(w).getValue(L)))];h.push([w,A])}return this.updateDefaultConfiguration(n),{keys:c,overrides:h}}compareAndUpdatePolicyConfiguration(n){const{added:c,updated:h,removed:P}=a(this.l,n),w=[...c,...h,...P];return w.length&&this.updatePolicyConfiguration(n),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.applicationConfiguration,n),R=[...c,...h,...P];return R.length&&this.updateApplicationConfiguration(n),{keys:R,overrides:w}}compareAndUpdateLocalUserConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.localUserConfiguration,n),R=[...c,...h,...P];return R.length&&this.updateLocalUserConfiguration(n),{keys:R,overrides:w}}compareAndUpdateRemoteUserConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.remoteUserConfiguration,n),R=[...c,...h,...P];return R.length&&this.updateRemoteUserConfiguration(n),{keys:R,overrides:w}}compareAndUpdateWorkspaceConfiguration(n){const{added:c,updated:h,removed:P,overrides:w}=a(this.workspaceConfiguration,n),R=[...c,...h,...P];return R.length&&this.updateWorkspaceConfiguration(n),{keys:R,overrides:w}}compareAndUpdateFolderConfiguration(n,c){const h=this.folderConfigurations.get(n),{added:P,updated:w,removed:R,overrides:T}=a(h,c),A=[...P,...w,...R];return(A.length||!h)&&this.updateFolderConfiguration(n,c),{keys:A,overrides:T}}compareAndDeleteFolderConfiguration(n){const c=this.folderConfigurations.get(n);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:h,updated:P,removed:w,overrides:R}=a(c,void 0);return{keys:[...h,...P,...w],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(n,c,h){let P=this.x(c,h);return c.overrideIdentifier&&(P=P.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(n)!==void 0&&(P=P.merge(this.l)),P}x({resource:n},c){let h=this.y();if(c&&n){const P=c.getFolder(n);P&&(h=this.z(P.uri)||h);const w=this.t.get(n);w&&(h=h.merge(w))}return h}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(n){let c=this.i.get(n);if(!c){const h=this.y(),P=this.r.get(n);P?(c=h.merge(P),this.i.set(n,c)):c=h}return c}A(n,c){if(c&&n){const h=c.getFolder(n);if(h)return this.r.get(h.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((n,c)=>{const{contents:h,overrides:P,keys:w}=this.r.get(c);return n.push([c,{contents:h,overrides:P,keys:w}]),n},[])}}allKeys(){const n=new Set;return this.j.keys.forEach(c=>n.add(c)),this.userConfiguration.keys.forEach(c=>n.add(c)),this.q.keys.forEach(c=>n.add(c)),this.r.forEach(c=>c.keys.forEach(h=>n.add(h))),[...n.values()]}B(){const n=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>n.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(h=>n.add(h))),[...n.values()]}D(n){const c=new Set;return this.j.getKeysForOverrideIdentifier(n).forEach(h=>c.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(h=>c.add(h)),this.q.getKeysForOverrideIdentifier(n).forEach(h=>c.add(h)),this.r.forEach(h=>h.getKeysForOverrideIdentifier(n).forEach(P=>c.add(P))),[...c.values()]}static parse(n,c){const h=this.E(n.defaults,c),P=this.E(n.policy,c),w=this.E(n.application,c),R=this.E(n.user,c),T=this.E(n.workspace,c),A=n.folders.reduce((L,M)=>(L.set(l.URI.revive(M[0]),this.E(M[1],c)),L),new O.$Fc);return new S(h,P,w,R,f.createEmptyModel(c),T,A,f.createEmptyModel(c),new O.$Fc,c)}static E(n,c){return new f(n.contents,n.keys,n.overrides,void 0,c)}}e.$Xo=S;function k(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,c=new Map;for(const P of o)P.keys.forEach(w=>n.add(w)),P.overrides.forEach(([w,R])=>{const T=(0,O.$Cc)(c,w,new Set);R.forEach(A=>T.add(A))});const h=[];return c.forEach((P,w)=>h.push([w,[...P.values()]])),{keys:[...n.values()],overrides:h}}class s{constructor(n,c,h,P,w){this.change=n,this.f=c,this.g=h,this.h=P,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of n.keys)this.affectedKeys.add(R);for(const[,R]of n.overrides)for(const T of R)this.affectedKeys.add(T);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=S.parse(this.f.data,this.i)),this.j}affectsConfiguration(n,c){const h=this.a+n,P=this.d.indexOf(h);if(P<0)return!1;const w=P+h.length;if(w>=this.d.length)return!1;const R=this.d.charCodeAt(w);if(R!==this.b&&R!==this.c)return!1;if(c){const T=this.previousConfiguration?this.previousConfiguration.getValue(n,c,this.f?.workspace):void 0,A=this.g.getValue(n,c,this.h);return!I.$oo(T,A)}return!0}}e.$Zo=s;function a(o,n){const{added:c,removed:h,updated:P}=t(n?.rawConfiguration,o?.rawConfiguration),w=[],R=o?.getAllOverrideIdentifiers()||[],T=n?.getAllOverrideIdentifiers()||[];if(n){const A=T.filter(L=>!R.includes(L));for(const L of A)w.push([L,n.getKeysForOverrideIdentifier(L)])}if(o){const A=R.filter(L=>!T.includes(L));for(const L of A)w.push([L,o.getKeysForOverrideIdentifier(L)])}if(n&&o){for(const A of R)if(T.includes(A)){const L=t({contents:o.getOverrideValue(void 0,A)||{},keys:o.getKeysForOverrideIdentifier(A)},{contents:n.getOverrideValue(void 0,A)||{},keys:n.getKeysForOverrideIdentifier(A)});w.push([A,[...L.added,...L.removed,...L.updated]])}}return{added:c,removed:h,updated:P,overrides:w}}function t(o,n){const c=o?n?o.keys.filter(w=>n.keys.indexOf(w)===-1):[...o.keys]:[],h=n?o?n.keys.filter(w=>o.keys.indexOf(w)===-1):[...n.keys]:[],P=[];if(o&&n){for(const w of n.keys)if(o.keys.indexOf(w)!==-1){const R=(0,m.$mj)(n.contents,w),T=(0,m.$mj)(o.contents,w);I.$oo(R,T)||P.push(w)}}return{added:c,removed:h,updated:P}}}),define(le[208],ue([0,1,21,4,2,37,12,128,56,5,40,46]),function(G,e,i,r,v,D,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=void 0;class $ extends v.$Zc{get configurationModel(){return this.b}constructor(y){super(),this.c=y,this.a=this.B(new r.$qe),this.onDidChangeConfiguration=this.a.event,this.b=I.$Uo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(u.$xo.as(b.$Co.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:E})=>this.f(Array.from(y),E))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(y,E){this.j(y,u.$xo.as(b.$Co.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:y})}g(){return{}}h(){this.b=I.$Uo.createEmptyModel(this.c);const y=u.$xo.as(b.$Co.Configuration).getConfigurationProperties();this.j(Object.keys(y),y)}j(y,E){const g=this.g();for(const S of y){const k=g[S],s=E[S];k!==void 0?this.b.setValue(S,k):s?this.b.setValue(S,s.default):this.b.removeValue(S)}}}e.$1o=$;class p{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$Uo.createEmptyModel(new l.$sk)}async initialize(){return this.configurationModel}}e.$2o=p;let d=class extends v.$Zc{get configurationModel(){return this.b}constructor(y,E,g){super(),this.c=y,this.f=E,this.g=g,this.a=this.B(new r.$qe),this.onDidChangeConfiguration=this.a.event,this.b=I.$Uo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(y=>this.j(y))),this.B(this.c.onDidChangeConfiguration(async({properties:y})=>this.m(await this.h(y),!0))),this.b}async h(y){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",y);const E={},g=[],S=u.$xo.as(b.$Co.Configuration).getConfigurationProperties();for(const k of y){const s=S[k];if(!s){g.push(k);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.g.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}g.push(k),E[s.policy.name]={type:s.type}}}return(0,O.$wg)(E)||await this.f.updatePolicyDefinitions(E),g}j(y){this.g.trace("PolicyConfiguration#onDidChangePolicies",y);const E=u.$xo.as(b.$Co.Configuration).getPolicyConfigurations(),g=(0,i.$Lb)(y.map(S=>E.get(S)));this.m(g,!0)}m(y,E){this.g.trace("PolicyConfiguration#update",y);const g=u.$xo.as(b.$Co.Configuration).getConfigurationProperties(),S=[],k=this.b.isEmpty();for(const s of y){const a=g[s]?.policy?.name;if(a){const t=this.f.getPolicyValue(a);(k?t!==void 0:!(0,D.$oo)(this.b.getValue(s),t))&&S.push([s,t])}else this.b.getValue(s)!==void 0&&S.push([s,void 0])}if(S.length){this.g.trace("PolicyConfiguration#changed",S);const s=this.b;this.b=I.$Uo.createEmptyModel(this.g);for(const a of s.keys)this.b.setValue(a,s.getValue(a));for(const[a,t]of S)t===void 0?this.b.removeValue(a):this.b.setValue(a,t);E&&this.a.fire(this.b)}}};e.$3o=d,e.$3o=d=ke([se(1,m.$zo),se(2,l.$fk)],d)}),define(le[209],ue([0,1,21,8,17,4,43,110,2,31,37,3,18,16,128,56,208,14,40]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=void 0;class S extends b.$Zc{constructor(a,t,o,n){super(),this.m=a,this.n=n,this.h=this.B(new D.$qe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new y.$1o(n)),this.c=o instanceof g.$Bo?new y.$2o:this.B(new y.$3o(this.b,o,n)),this.f=this.B(new d.$Wo(this.m,{},$.$ch,t,n)),this.a=new d.$Xo(this.b.configurationModel,this.c.configurationModel,d.$Uo.createEmptyModel(n),d.$Uo.createEmptyModel(n),d.$Uo.createEmptyModel(n),d.$Uo.createEmptyModel(n),new l.$Fc,d.$Uo.createEmptyModel(n),new l.$Fc,n),this.j=new k(a,t,this),this.g=this.B(new r.$Wh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:h})=>this.s(c,h))),this.B(this.c.onDidChangeConfiguration(c=>this.t(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,t,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new d.$Xo(a,t,d.$Uo.createEmptyModel(this.n),o,d.$Uo.createEmptyModel(this.n),d.$Uo.createEmptyModel(this.n),new l.$Fc,d.$Uo.createEmptyModel(this.n),new l.$Fc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,t){const o=typeof a=="string"?a:void 0,n=(0,p.$fj)(a)?a:(0,p.$fj)(t)?t:{};return this.a.getValue(o,n,void 0)}async updateValue(a,t,o,n,c){const h=(0,p.$gj)(o)?o:(0,p.$fj)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,P=h?n:o;if(P!==void 0&&P!==p.ConfigurationTarget.USER_LOCAL&&P!==p.ConfigurationTarget.USER)throw new Error(`Unable to write ${a} to target ${P}.`);h?.overrideIdentifiers&&(h.overrideIdentifiers=(0,i.$Qb)(h.overrideIdentifiers),h.overrideIdentifiers=h.overrideIdentifiers.length?h.overrideIdentifiers:void 0);const w=this.inspect(a,{resource:h?.resource,overrideIdentifier:h?.overrideIdentifiers?h.overrideIdentifiers[0]:void 0});if(w.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,m.$oo)(t,w.defaultValue)&&(t=void 0),h?.overrideIdentifiers?.length&&h.overrideIdentifiers.length>1){const T=h.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(L=>(0,i.$yb)([...L.identifiers].sort(),T));A&&(h.overrideIdentifiers=A.identifiers)}const R=h?.overrideIdentifiers?.length?[(0,f.$Oo)(h.overrideIdentifiers),a]:[a];await this.j.write(R,t),await this.reloadConfiguration()}inspect(a,t={}){return this.a.inspect(a,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const t=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(o,t,p.ConfigurationTarget.USER)}s(a,t){const o=this.a.toData(),n=this.a.compareAndUpdateDefaultConfiguration(a,t);this.u(n,o,p.ConfigurationTarget.DEFAULT)}t(a){const t=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(a);this.u(o,t,p.ConfigurationTarget.DEFAULT)}u(a,t,o){const n=new d.$Zo(a,{data:t},this.a,void 0,this.n);n.source=o,this.h.fire(n)}}e.$4o=S;class k{constructor(a,t,o){this.b=a,this.c=t,this.d=o,this.a=new r.$Rh}write(a,t){return this.a.queue(()=>this.e(a,t))}async e(a,t){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(h){if(h.fileOperationResult===E.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw h}const n=[];if((0,O.$5n)(o,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const c=this.f(o,a,t);o=(0,I.$jo)(o,c),await this.c.writeFile(this.b,v.$Se.fromString(o))}f(a,t,o){const{tabSize:n,insertSpaces:c,eol:h}=this.h;if(!t.length){const P=JSON.stringify(o,null,c?" ".repeat(n):"	");return[{content:P,length:P.length,offset:0}]}return(0,I.$go)(a,t,o,{tabSize:n,insertSpaces:c,eol:h})}get h(){if(!this.g){let a=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[210],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=e.$0ic=e.$9ic=void 0,e.$9ic="request",e.$0ic="remoteResourceHandler";class i{async routeCall(v,D,O){if(D!==e.$9ic)throw new Error(`Call not found: ${D}`);const I=O[0];if(I?.authority){const b=v.connections.find(l=>l.ctx===I.authority);if(b)return b}throw new Error("Caller not found")}routeEvent(v,D){throw new Error(`Event not found: ${D}`)}}e.$$ic=i}),define(le[211],ue([0,1,15,6]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.RemoteAuthorityResolverErrorCode=e.$Yl=e.$Xl=e.RemoteConnectionType=e.$Wl=void 0,e.$1l=l,e.$Wl=(0,r.$Ki)("remoteAuthorityResolverService");var v;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(v||(e.RemoteConnectionType=v={}));class D{constructor(u){this.id=u,this.type=v.Managed}toString(){return`Managed(${this.id})`}}e.$Xl=D;class O{constructor(u,$){this.host=u,this.port=$,this.type=v.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Yl=O;var I;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class b extends i.$fb{static isNotAvailable(u){return u instanceof b&&u._code===I.NotAvailable}static isTemporarilyNotAvailable(u){return u instanceof b&&u._code===I.TemporarilyNotAvailable}static isNoResolverFound(u){return u instanceof b&&u._code===I.NoResolverFound}static isInvalidAuthority(u){return u instanceof b&&u._code===I.InvalidAuthority}static isHandled(u){return u instanceof b&&u.isHandled}constructor(u,$=I.Unknown,p){super(u),this._message=u,this._code=$,this._detail=p,this.isHandled=$===I.NotAvailable&&p===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Zl=b;function l(m){const u=m.indexOf("+");return u===-1?m:m.substring(0,u)}}),define(le[212],ue([0,1,8,17,22,15,4,2,11,71,60,33,121,211]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$6l=w,e.$7l=R,e.$8l=A,l=Ie(l);const d=30*1e3;var f;(function(oe){oe[oe.Management=1]="Management",oe[oe.ExtensionHost=2]="ExtensionHost",oe[oe.Tunnel=3]="Tunnel"})(f||(e.ConnectionType=f={}));function y(oe){switch(oe){case f.Management:return"Management";case f.ExtensionHost:return"ExtensionHost";case f.Tunnel:return"Tunnel"}}function E(oe){const te=new v.$Be;return setTimeout(()=>te.cancel(),oe),te.token}function g(oe,te){if(oe.isCancellationRequested||te.isCancellationRequested)return v.CancellationToken.Cancelled;const j=new v.$Be;return oe.onCancellationRequested(()=>j.cancel()),te.onCancellationRequested(()=>j.cancel()),j.token}class S{get didTimeout(){return this.c==="timedout"}constructor(te){this.c="pending",this.d=new I.$Yc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,i.$Dh)(),te.isCancellationRequested?this.h():this.d.add(te.onCancellationRequested(()=>this.h()))}registerDisposable(te){this.c==="pending"?this.d.add(te):te.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const te=new Error("Time limit reached");return te.code="ETIMEDOUT",te.syscall="connect",te}resolve(te){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(te))}reject(te){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(te))}}function k(oe,te){const j=new S(te);return j.registerDisposable(oe.onControlMessage(X=>{const U=JSON.parse(X.toString()),N=B(U);N?j.reject(N):j.resolve(U)})),j.promise}function s(oe,te,j,X,U,N,Q,K){const H=new S(K),_=m.$ke.create(!1);return oe.info(`Creating a socket (${Q})...`),l.mark(`code/willCreateSocket/${N}`),te.connect(j,X,U,Q).then(ae=>{H.didTimeout?(l.mark(`code/didCreateSocketError/${N}`),oe.info(`Creating a socket (${Q}) finished after ${_.elapsed()} ms, but this is too late and has timed out already.`),ae?.dispose()):(l.mark(`code/didCreateSocketOK/${N}`),oe.info(`Creating a socket (${Q}) was successful after ${_.elapsed()} ms.`),H.resolve(ae))},ae=>{l.mark(`code/didCreateSocketError/${N}`),oe.info(`Creating a socket (${Q}) returned an error after ${_.elapsed()} ms.`),oe.error(ae),H.reject(ae)}),H.promise}function a(oe,te){const j=new S(te);return oe.then(X=>{j.didTimeout||j.resolve(X)},X=>{j.didTimeout||j.reject(X)}),j.promise}async function t(oe,te,j,X){const U=x(oe,te);oe.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let N;try{N=await s(oe.logService,oe.remoteSocketFactoryService,oe.connectTo,b.$Xg.getServerRootPath(),`reconnectionToken=${oe.reconnectionToken}&reconnection=${oe.reconnectionProtocol?"true":"false"}`,y(te),`renderer-${y(te)}-${oe.reconnectionToken}`,X)}catch(ae){throw oe.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),oe.logService.error(ae),ae}oe.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let Q,K;oe.reconnectionProtocol?(oe.reconnectionProtocol.beginAcceptReconnection(N,null),Q=oe.reconnectionProtocol,K=!1):(Q=new $.$yi({socket:N}),K=!0),oe.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const H=await a(oe.signService.createNewMessage((0,u.$7g)()),X),_={type:"auth",auth:oe.connectionToken||"00000000000000000000",data:H.data};Q.sendControl(r.$Se.fromString(JSON.stringify(_)));try{const ae=await k(Q,g(X,E(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Fe=new Error("Unexpected handshake message");throw Fe.code="VSCODE_CONNECTION_ERROR",Fe}if(oe.logService.trace(`${U} 4/6. received SignRequest control message.`),!await a(oe.signService.validate(H,ae.signedData),X)){const Fe=new Error("Refused to connect to unsupported server");throw Fe.code="VSCODE_CONNECTION_ERROR",Fe}const be=await a(oe.signService.sign(ae.data),X),ye={type:"connectionType",commit:oe.commit,signedData:be,desiredConnectionType:te};return j&&(ye.args=j),oe.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(r.$Se.fromString(JSON.stringify(ye))),{protocol:Q,ownsProtocol:K}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(oe.logService.error(`${U} the handshake timed out. Error:`),oe.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(oe.logService.error(`${U} received error control message when negotiating connection. Error:`),oe.logService.error(ae)),K&&C(Q),ae}}async function o(oe,te,j,X){const U=Date.now(),N=x(oe,te),{protocol:Q,ownsProtocol:K}=await t(oe,te,j,X),H=new S(X);return H.registerDisposable(Q.onControlMessage(_=>{const ae=JSON.parse(_.toString()),$e=B(ae);$e?(oe.logService.error(`${N} received error control message when negotiating connection. Error:`),oe.logService.error($e),K&&C(Q),H.reject($e)):(oe.reconnectionProtocol?.endAcceptReconnection(),oe.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${ce(U)}!`),H.resolve({protocol:Q,firstMessage:ae}))})),H.promise}async function n(oe,te){const{protocol:j}=await o(oe,f.Management,void 0,te);return{protocol:j}}async function c(oe,te,j){const{protocol:X,firstMessage:U}=await o(oe,f.ExtensionHost,te,j),N=U&&U.debugPort;return{protocol:X,debugPort:N}}async function h(oe,te,j){const X=Date.now(),U=x(oe,f.Tunnel),{protocol:N}=await t(oe,f.Tunnel,te,j);return oe.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${ce(X)}!`),N}async function P(oe,te,j){const{connectTo:X,connectionToken:U}=await oe.addressProvider.getAddress();return{commit:oe.commit,quality:oe.quality,connectTo:X,connectionToken:U,reconnectionToken:te,reconnectionProtocol:j,remoteSocketFactoryService:oe.remoteSocketFactoryService,signService:oe.signService,logService:oe.logService}}async function w(oe,te,j){return T(oe,async X=>{const{protocol:U}=await n(X,v.CancellationToken.None);return new W(oe,te,j,X.reconnectionToken,U)})}async function R(oe,te){return T(oe,async j=>{const{protocol:X,debugPort:U}=await c(j,te,v.CancellationToken.None);return new Z(oe,te,j.reconnectionToken,X,U)})}async function T(oe,te){for(let X=1;;X++)try{const U=(0,u.$7g)(),N=await P(oe,U,null);return await te(N)}catch(U){if(X<5)oe.logService.error(`[remote-connection][attempt ${X}] An error occurred in initial connection! Will retry... Error:`),oe.logService.error(U);else throw oe.logService.error(`[remote-connection][attempt ${X}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),oe.logService.error(U),ee.triggerPermanentFailure(0,0,p.$Zl.isHandled(U)),U}}async function A(oe,te,j){const X=await P(oe,(0,u.$7g)(),null);return await h(X,{host:te,port:j},v.CancellationToken.None)}function L(oe){return(0,i.$xh)(te=>new Promise((j,X)=>{const U=setTimeout(j,oe*1e3);te.onCancellationRequested(()=>{clearTimeout(U),j()})}))}var M;(function(oe){oe[oe.ConnectionLost=0]="ConnectionLost",oe[oe.ReconnectionWait=1]="ReconnectionWait",oe[oe.ReconnectionRunning=2]="ReconnectionRunning",oe[oe.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",oe[oe.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class V{constructor(te,j){this.reconnectionToken=te,this.millisSinceLastIncomingData=j,this.type=M.ConnectionLost}}e.$9l=V;class q{constructor(te,j,X,U){this.reconnectionToken=te,this.millisSinceLastIncomingData=j,this.durationSeconds=X,this.c=U,this.type=M.ReconnectionWait}skipWait(){this.c.cancel()}}e.$0l=q;class Y{constructor(te,j,X){this.reconnectionToken=te,this.millisSinceLastIncomingData=j,this.attempt=X,this.type=M.ReconnectionRunning}}e.$$l=Y;class de{constructor(te,j,X){this.reconnectionToken=te,this.millisSinceLastIncomingData=j,this.attempt=X,this.type=M.ConnectionGain}}e.$_l=de;class re{constructor(te,j,X,U){this.reconnectionToken=te,this.millisSinceLastIncomingData=j,this.attempt=X,this.handled=U,this.type=M.ReconnectionPermanentFailure}}e.$am=re;class ee extends I.$Zc{static triggerPermanentFailure(te,j,X){this._permanentFailure=!0,this.f=te,this.g=j,this.h=X,this.j.forEach(U=>U.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(te=>te.y())}static debugPauseSocketWriting(){this.j.forEach(te=>te.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ee._permanentFailure}constructor(te,j,X,U,N){super(),this.t=te,this.u=j,this.reconnectionToken=X,this.protocol=U,this.w=N,this.m=this.B(new O.$qe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new de(this.reconnectionToken,0,0)),this.B(U.onSocketClose(Q=>{const K=ie(this.t,this.reconnectionToken,!0);Q?Q.type===$.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${K} received socket close event (hadError: ${Q.hadError}).`),Q.error&&this.u.logService.error(Q.error)):(this.u.logService.info(`${K} received socket close event (wasClean: ${Q.wasClean}, code: ${Q.code}, reason: ${Q.reason}).`),Q.event&&this.u.logService.error(Q.event)):this.u.logService.info(`${K} received socket close event.`),this.y()})),this.B(U.onSocketTimeout(Q=>{const K=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${K} received socket timeout event (unacknowledgedMsgCount: ${Q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Q.timeSinceLastReceivedSomeData}).`),this.y()})),ee.j.push(this),this.B((0,I.$Xc)(()=>{const Q=ee.j.indexOf(this);Q>=0&&ee.j.splice(Q,1)})),this.n&&this.D(ee.f,ee.g,ee.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const te=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let X=-1;do{X++;const U=X<j.length?j[X]:j[j.length-1];try{if(U>0){const Q=L(U);this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,Q)),this.u.logService.info(`${te} waiting for ${U} seconds before reconnecting...`);try{await Q}catch{}}if(this.n){this.u.logService.error(`${te} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1)),this.u.logService.info(`${te} resolving connection...`);const N=await P(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${te} connecting to ${N.connectTo}...`),await this.G(N,E(d)),this.u.logService.info(`${te} reconnected!`),this.m.fire(new de(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1));break}catch(N){if(N.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${te} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(X>360){this.u.logService.error(`${te} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(p.$Zl.isTemporarilyNotAvailable(N)){this.u.logService.info(`${te} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(N);continue}if((N.code==="ETIMEDOUT"||N.code==="ENETUNREACH"||N.code==="ECONNREFUSED"||N.code==="ECONNRESET")&&N.syscall==="connect"){this.u.logService.info(`${te} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(N);continue}if((0,D.$8)(N)){this.u.logService.info(`${te} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(N);continue}if(N instanceof p.$Zl){this.u.logService.error(`${te} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,p.$Zl.isHandled(N));break}this.u.logService.error(`${te} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(N),this.C(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}}while(!this.n&&!this.s)}C(te,j,X){this.w?ee.triggerPermanentFailure(te,j,X):this.D(te,j,X)}D(te,j,X){this.m.fire(new re(this.reconnectionToken,te,j,X)),C(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$bm=ee;class W extends ee{constructor(te,j,X,U,N){super(f.Management,te,U,N,!0),this.client=this.B(new $.$wi(N,{remoteAuthority:j,clientId:X},te.ipcLogger))}async G(te,j){await n(te,j)}}e.$cm=W;class Z extends ee{constructor(te,j,X,U,N){super(f.ExtensionHost,te,X,U,!1),this.H=j,this.debugPort=N}async G(te,j){await c(te,this.H,j)}}e.$dm=Z;function C(oe){try{oe.acceptDisconnect();const te=oe.getSocket();oe.dispose(),te.dispose()}catch(te){(0,D.$4)(te)}}function B(oe){if(oe&&oe.type==="error"){const te=new Error(`Connection error: ${oe.reason}`);return te.code="VSCODE_CONNECTION_ERROR",te}return null}function F(oe,te){for(;oe.length<te;)oe+=" ";return oe}function z(oe,te){return`[remote-connection][${F(y(oe),13)}][${te.substr(0,5)}\u2026]`}function ie(oe,te,j){return`${z(oe,te)}[${j?"reconnect":"initial"}]`}function x(oe,te){return`${ie(te,oe.reconnectionToken,!!oe.reconnectionProtocol)}[${oe.connectTo}]`}function ce(oe){return`${Date.now()-oe} ms`}}),define(le[75],ue([0,1,11]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=r,e.$on=v,e.$pn=D,e.$qn=O;function r(b){return b.scheme===i.Schemas.vscodeRemote?b.authority:void 0}function v(b){if(!b)return;const l=b.indexOf("+");return l<0?b:b.substr(0,l)}function D(b){const{host:l,port:m}=I(b);if(typeof m>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:m}}function O(b,l){let{host:m,port:u}=I(b);return typeof u>"u"&&(u=l),{host:m,port:u}}function I(b){const l=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const m=b.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const u=b.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:b,port:void 0}}}),define(le[87],ue([0,1,25,6,75]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$zn=e.$yn=e.$xn=e.TargetPlatform=e.ExtensionType=e.$wn=e.$un=e.$tn=e.$sn=e.$rn=void 0,e.$vn=D,e.$An=u,e.$Bn=$,e.$Cn=p,e.$Dn=d,e.$En=f,e.$Fn=y,i=Ie(i),e.$rn="extensions.user.cache",e.$sn="extensions.builtin.cache",e.$tn="undefined_publisher",e.$un=["ui","workspace","web"];function D(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.$wn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(E){E.WIN32_X64="win32-x64",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class b{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,S){if(typeof g>"u"||g===null)return typeof S>"u"||S===null;if(typeof S>"u"||S===null)return!1;if(typeof g=="string"||typeof S=="string"){const k=typeof g=="string"?g:g.value,s=typeof S=="string"?S:S.value;return i.$Kf(k,s)}return g._lower===S._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$xn=b;class l{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const S of g)this.add(S)}add(g){this.c.add(b.toKey(g))}delete(g){return this.c.delete(b.toKey(g))}has(g){return this.c.has(b.toKey(g))}}e.$yn=l;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(b.toKey(g))}get(g){return this.c.get(b.toKey(g))}has(g){return this.c.has(b.toKey(g))}set(g,S){this.c.set(b.toKey(g),S)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$zn=m;function u(E){return $(E)}function $(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}function p(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}function d(E,g){if(g){const S=`onResolveRemoteAuthority:${(0,v.$on)(g)}`;return!!E.activationEvents?.includes(S)}return!1}function f(E){return E.map(g=>{const[S,k]=g.split("@");return{proposalName:S,version:k?parseInt(k):void 0}})}function y(E){return E.map(g=>g.split("@")[0])}e.$Gn=(0,r.$Ki)("IBuiltinExtensionsScannerService")}),define(le[129],ue([0,1,3,9,87,6]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.ExtensionManagementErrorCode=e.$sp=e.ExtensionGalleryErrorCode=e.$rp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=I,e.$mp=b,e.$np=l,e.$op=m,e.$pp=u,e.$qp=$,e.$ep="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$fp=new RegExp(e.$ep),e.$gp="__web_extension",e.$hp="skipWalkthrough",e.$ip="extensionInstallSource",e.$jp="dependecyOrPackExtensionInstall",e.$kp="clientTargetPlatform";var O;(function(s){s.COMMAND="command",s.SETTINGS_SYNC="settingsSync"})(O||(e.ExtensionInstallSource=O={}));function I(s){switch(s){case v.TargetPlatform.WIN32_X64:return"Windows 64 bit";case v.TargetPlatform.WIN32_ARM64:return"Windows ARM";case v.TargetPlatform.LINUX_X64:return"Linux 64 bit";case v.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case v.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case v.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case v.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case v.TargetPlatform.DARWIN_X64:return"Mac";case v.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case v.TargetPlatform.WEB:return"Web";case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;case v.TargetPlatform.UNKNOWN:return v.TargetPlatform.UNKNOWN;case v.TargetPlatform.UNDEFINED:return v.TargetPlatform.UNDEFINED}}function b(s){switch(s){case v.TargetPlatform.WIN32_X64:return v.TargetPlatform.WIN32_X64;case v.TargetPlatform.WIN32_ARM64:return v.TargetPlatform.WIN32_ARM64;case v.TargetPlatform.LINUX_X64:return v.TargetPlatform.LINUX_X64;case v.TargetPlatform.LINUX_ARM64:return v.TargetPlatform.LINUX_ARM64;case v.TargetPlatform.LINUX_ARMHF:return v.TargetPlatform.LINUX_ARMHF;case v.TargetPlatform.ALPINE_X64:return v.TargetPlatform.ALPINE_X64;case v.TargetPlatform.ALPINE_ARM64:return v.TargetPlatform.ALPINE_ARM64;case v.TargetPlatform.DARWIN_X64:return v.TargetPlatform.DARWIN_X64;case v.TargetPlatform.DARWIN_ARM64:return v.TargetPlatform.DARWIN_ARM64;case v.TargetPlatform.WEB:return v.TargetPlatform.WEB;case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;default:return v.TargetPlatform.UNKNOWN}}function l(s,a){switch(s){case i.Platform.Windows:return a==="x64"?v.TargetPlatform.WIN32_X64:a==="arm64"?v.TargetPlatform.WIN32_ARM64:v.TargetPlatform.UNKNOWN;case i.Platform.Linux:return a==="x64"?v.TargetPlatform.LINUX_X64:a==="arm64"?v.TargetPlatform.LINUX_ARM64:a==="arm"?v.TargetPlatform.LINUX_ARMHF:v.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?v.TargetPlatform.ALPINE_X64:a==="arm64"?v.TargetPlatform.ALPINE_ARM64:v.TargetPlatform.UNKNOWN;case i.Platform.Mac:return a==="x64"?v.TargetPlatform.DARWIN_X64:a==="arm64"?v.TargetPlatform.DARWIN_ARM64:v.TargetPlatform.UNKNOWN;case i.Platform.Web:return v.TargetPlatform.WEB}}function m(s,a){return a===v.TargetPlatform.WEB&&!s.includes(v.TargetPlatform.WEB)}function u(s,a,t){return m(a,t)?!1:s===v.TargetPlatform.UNDEFINED||s===v.TargetPlatform.UNIVERSAL?!0:s===v.TargetPlatform.UNKNOWN?!1:s===t}function $(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}var p;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var d;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var f;(function(s){s.Install="install",s.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var y;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$rp=(0,D.$Ki)("extensionGalleryService");var E;(function(s){s.Timeout="Timeout",s.Cancelled="Cancelled",s.Failed="Failed",s.DownloadFailedWriting="DownloadFailedWriting",s.Offline="Offline"})(E||(e.ExtensionGalleryErrorCode=E={}));class g extends Error{constructor(a,t){super(a),this.code=t,this.name=t}}e.$sp=g;var S;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleApi="IncompatibleApi",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.DownloadSignature="DownloadSignature",s.DownloadFailedWriting="DownloadFailedWriting",s.UpdateMetadata="UpdateMetadata",s.Extract="Extract",s.Scanning="Scanning",s.ScanningExtension="ScanningExtension",s.ReadUninstalled="ReadUninstalled",s.UnsetUninstalled="UnsetUninstalled",s.Delete="Delete",s.Rename="Rename",s.IntializeDefaultProfile="IntializeDefaultProfile",s.AddToProfile="AddToProfile",s.InstalledExtensionNotFound="InstalledExtensionNotFound",s.PostInstall="PostInstall",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.NotAllowed="NotAllowed",s.Gallery="Gallery",s.Cancelled="Cancelled",s.Unknown="Unknown",s.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));class k extends Error{constructor(a,t){super(a),this.code=t,this.name=t}}e.$tp=k,e.$up=(0,D.$Ki)("extensionManagementService"),e.$vp="extensionsIdentifiers/disabled",e.$wp="extensionsIdentifiers/enabled",e.$xp=(0,D.$Ki)("IGlobalExtensionEnablementService"),e.$yp=(0,D.$Ki)("IExtensionTipsService"),e.$zp=(0,r.localize2)(1780,"Extensions"),e.$Ap=(0,r.localize2)(1781,"Preferences")});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[213],ue([0,1,18,81,9,214,87,176]),function(G,e,i,r,v,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=m,e.$7p=u,e.$8p=$,e.$9p=p,e.$0p=d,e.$$p=f,e.$_p=y,e.$aq=E,r=Ge(r),v=Ie(v),D=Ie(D);const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function m(k){return k=k.trim(),k==="*"||b.test(k)}function u(k){if(!m(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=k.match(b);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}function $(k){if(!k)return null;const s=k.majorBase,a=k.majorMustEqual,t=k.minorBase;let o=k.minorMustEqual;const n=k.patchBase;let c=k.patchMustEqual;k.hasCaret&&(s===0||(o=!1),c=!1);let h=0;if(k.preRelease){const P=l.exec(k.preRelease);if(P){const[,w,R,T]=P;h=Date.UTC(Number(w),Number(R)-1,Number(T))}}return{majorBase:s,majorMustEqual:a,minorBase:t,minorMustEqual:o,patchBase:n,patchMustEqual:c,isMinimum:k.hasGreaterEquals,notBefore:h}}function p(k,s,a){let t;typeof k=="string"?t=$(u(k)):t=k;let o;s instanceof Date?o=s.getTime():typeof s=="string"&&(o=new Date(s).getTime());let n;if(typeof a=="string"?n=$(u(a)):n=a,!t||!n)return!1;const c=t.majorBase,h=t.minorBase,P=t.patchBase;let w=n.majorBase,R=n.minorBase,T=n.patchBase;const A=n.notBefore;let L=n.majorMustEqual,M=n.minorMustEqual,V=n.patchMustEqual;return n.isMinimum?c>w?!0:c<w?!1:h>R?!0:h<R||o&&o<A?!1:P>=T:(c===1&&w===0&&(!L||!M||!V)&&(w=1,R=0,T=0,L=!0,M=!1,V=!1),c<w?!1:c>w?!L:h<R?!1:h>R?!M:P<T?!1:P>T?!V:!(o&&o<A))}function d(k,s,a,t,o,n){const c=[];if(typeof t.publisher<"u"&&typeof t.publisher!="string")return c.push([r.default.Error,v.localize(1832,null)]),c;if(typeof t.name!="string")return c.push([r.default.Error,v.localize(1833,null,"name")]),c;if(typeof t.version!="string")return c.push([r.default.Error,v.localize(1834,null,"version")]),c;if(!t.engines)return c.push([r.default.Error,v.localize(1835,null,"engines")]),c;if(typeof t.engines.vscode!="string")return c.push([r.default.Error,v.localize(1836,null,"engines.vscode")]),c;if(typeof t.extensionDependencies<"u"&&!S(t.extensionDependencies))return c.push([r.default.Error,v.localize(1837,null,"extensionDependencies")]),c;if(typeof t.activationEvents<"u"){if(!S(t.activationEvents))return c.push([r.default.Error,v.localize(1838,null,"activationEvents")]),c;if(typeof t.main>"u"&&typeof t.browser>"u")return c.push([r.default.Error,v.localize(1839,null,"activationEvents","main","browser")]),c}if(typeof t.extensionKind<"u"&&typeof t.main>"u"&&c.push([r.default.Warning,v.localize(1840,null,"extensionKind")]),typeof t.main<"u"){if(typeof t.main!="string")return c.push([r.default.Error,v.localize(1841,null,"main")]),c;{const w=(0,i.$lh)(a,t.main);(0,i.$fh)(w,a)||c.push([r.default.Warning,v.localize(1842,null,w.path,a.path)])}}if(typeof t.browser<"u"){if(typeof t.browser!="string")return c.push([r.default.Error,v.localize(1843,null,"browser")]),c;{const w=(0,i.$lh)(a,t.browser);(0,i.$fh)(w,a)||c.push([r.default.Warning,v.localize(1844,null,w.path,a.path)])}}if(!D.valid(t.version))return c.push([r.default.Error,v.localize(1845,null)]),c;const h=[];if(!f(k,s,t,o,h))for(const w of h)c.push([r.default.Error,w]);if(n&&t.enabledApiProposals?.length){const w=[];if(!E([...t.enabledApiProposals],w))for(const R of w)c.push([r.default.Error,R])}return c}function f(k,s,a,t,o){return t||typeof a.main>"u"&&typeof a.browser>"u"?!0:g(k,s,a.engines.vscode,o)}function y(k,s,a){return k==="*"||g(s,a,k)}function E(k,s){if(k.length===0)return!0;const a=Array.isArray(s)?s:void 0,t=(a?void 0:s)??I.allApiProposals,o=[],n=(0,O.$En)(k);for(const{proposalName:c,version:h}of n){const P=t[c];P&&h&&P.version!==h&&o.push(v.localize(1846,null,c))}return a?.push(...o),o.length===0}function g(k,s,a,t=[]){const o=$(u(a));if(!o)return t.push(v.localize(1847,null,a)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return t.push(v.localize(1848,null,a)),!1}else if(!o.majorMustEqual)return t.push(v.localize(1849,null,a)),!1;return p(k,s,o)?!0:(t.push(v.localize(1850,null,k,a)),!1)}function S(k){if(!Array.isArray(k))return!1;for(let s=0,a=k.length;s<a;s++)if(typeof k[s]!="string")return!1;return!0}}),define(le[215],ue([0,1,2,6]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=void 0,e.$2l=(0,r.$Ki)("remoteSocketFactoryService");class v{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,i.$Xc)(()=>{const b=this.a[O]?.indexOf(I);typeof b=="number"&&b>=0&&this.a[O]?.splice(b,1)})}b(O){return(this.a[O.type]||[]).find(b=>b.supports(O))}connect(O,I,b,l){const m=this.b(O);if(!m)throw new Error(`No socket factory found for ${O}`);return m.connect(O,I,b,l)}}e.$3l=v}),define(le[216],ue([0,1,26,27,44,97]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=I,i=Ie(i),r=Ie(r),v=Ie(v),D=Ie(D);let O;async function I(p=!1){return(O===void 0||p)&&(O=b()),O}async function b(){const p=l();if(p===void 0)return!1;if(p>=22e3){const d=u();if(d)return new Promise(f=>{try{v.execFile(d,["--status"],y=>f(!y))}catch{f(!1)}})}else{const d=$();if(d)try{if((await i.promises.stat(d)).isFile())return!0}catch{}}return!1}function l(){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(r.release());if(p)return parseInt(p[3])}function m(p){const d=process.env.SystemRoot;if(d){const f=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return D.join(d,f?"Sysnative":"System32",p)}}function u(){return m("wsl.exe")}function $(){return m("lxss\\LxssManager.dll")}}),define(le[50],ue([0,1,17,15,2,9,56,6,5,46]),function(G,e,i,r,v,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0,e.$dq=$,e.$eq=p,e.$fq=d,e.$gq=f,e.$hq=y,e.$iq=E,e.$bq=(0,I.$Ki)("requestService");class m{constructor(s){this.b=s}toJSON(){if(!this.a){const s=Object.create(null);for(const a in this.b)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?s[a]="*****":s[a]=this.b[a];this.a=s}return this.a}}class u extends v.$Zc{constructor(s){super(),this.b=0,this.a=s.createLogger("network",{name:(0,D.localize)(2050,null),when:b.$xk.isEqualTo((0,b.$uk)(b.LogLevel.Trace)).serialize()})}async c(s,a,t){const o=`${s} #${++this.b}: ${a.url}`;this.a.trace(`${o} - begin`,a.type,new m(a.headers??{}));try{const n=await t();return this.a.trace(`${o} - end`,a.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${o} - error`,a.type,(0,r.$bb)(n)),n}}}e.$cq=u;function $(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}function p(k){return k.res.statusCode===204}async function d(k){return p(k)?null:(await(0,i.$5e)(k.stream)).toString()}async function f(k){if(!$(k))throw new Error("Server returned "+k.res.statusCode);return d(k)}async function y(k){if(!$(k))throw new Error("Server returned "+k.res.statusCode);if(p(k))return null;const a=(await(0,i.$5e)(k.stream)).toString();try{return JSON.parse(a)}catch(t){throw t.message+=`:
`+a,t}}function E(k){S(k)}let g;function S(k){const s=l.$xo.as(O.$Co.Configuration),a=g;g={id:"http",order:15,title:(0,D.localize)(2051,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,D.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(2057,null),(0,D.localize)(2058,null),(0,D.localize)(2059,null),(0,D.localize)(2060,null)],default:"override",description:(0,D.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(2063,null),restricted:!0}}},s.updateConfigurations({add:[g],remove:a?[a]:[]})}S(O.ConfigurationScope.APPLICATION)}),define(le[217],ue([0,1,17,22]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=void 0;class v{constructor(I){this.a=I}listen(I,b){throw new Error("Invalid listen")}call(I,b,l,m=r.CancellationToken.None){switch(b){case"request":return this.a.request(l[0],m).then(async({res:u,stream:$})=>{const p=await(0,i.$5e)($);return[{statusCode:u.statusCode,headers:u.headers},p]});case"resolveProxy":return this.a.resolveProxy(l[0]);case"lookupAuthorization":return this.a.lookupAuthorization(l[0]);case"lookupKerberosAuthorization":return this.a.lookupKerberosAuthorization(l[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$ks=v;class D{constructor(I){this.a=I}async request(I,b){const[l,m]=await this.a.call("request",[I],b);return{res:l,stream:(0,i.$7e)(m)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async lookupAuthorization(I){return this.a.call("lookupAuthorization",[I])}async lookupKerberosAuthorization(I){return this.a.call("lookupKerberosAuthorization",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$ls=D}),define(le[218],ue([0,1,219,12]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=D;function v(O,I){return O.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:O.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function D(O,I,b={}){const l=(0,i.parse)(O),m=b.proxyUrl||v(l,I);if(!m)return null;const u=(0,i.parse)(m);if(!/^https?:$/.test(u.protocol||""))return null;const $={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,r.$pg)(b.strictSSL)?b.strictSSL:!0};if(l.protocol==="http:"){const p=await new Promise((d,f)=>{G(["http-proxy-agent"],d,f)}).then(Ie);return new p.HttpProxyAgent(m,$)}else{const p=await new Promise((d,f)=>{G(["https-proxy-agent"],d,f)}).then(Ie);return new p.HttpsProxyAgent(m,$)}}}),define(le[220],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=e.$qic=void 0,e.$qic={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$ric={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$sic={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[103],ue([0,1,44,10,9,22,55,15,3,33,120,69,8,147]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=f;let d;async function f(E,g,S,k){return S["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.$l?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.$Pm)(k)&&!S["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.$Pm)(k)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=$.Promises.withAsyncBody(async(s,a)=>{const t=new D.$Be;let o=1e4;const n=E.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(o=(0,p.$Qm)(n,1,120)*1e3);const c=setTimeout(()=>{t.dispose(!0),a(new Error((0,v.localize)(2064,null)))},o);try{s(await y(g,t.token))}catch(h){!(0,I.$8)(h)&&!t.token.isCancellationRequested?a(new Error((0,v.localize)(2065,null,(0,O.$vj)(h)))):s({})}finally{clearTimeout(c),t.dispose()}})),d)}async function y(E,g){const S=process.env.ELECTRON_RUN_AS_NODE;E.trace("getUnixShellEnvironment#runAsNode",S);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;E.trace("getUnixShellEnvironment#noAttach",k);const s=(0,l.$7g)().replace(/-/g,"").substr(0,12),a=new RegExp(s+"({.*})"+s),t={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};E.trace("getUnixShellEnvironment#env",t);const o=await(0,m.$Fm)(b.OS,t);return E.trace("getUnixShellEnvironment#shell",o),new Promise((n,c)=>{if(g.isCancellationRequested)return c(new I.$9);const h=(0,r.$sc)(o);let P,w;const R="";/^pwsh(-preview)?$/.test(h)?(P=`& '${process.execPath}' ${R} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,w=["-Login","-Command"]):h==="nu"?(P=`^'${process.execPath}' ${R} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,w=["-i","-l","-c"]):h==="xonsh"?(P=`import os, json; print("${s}", json.dumps(dict(os.environ)), "${s}")`,w=["-i","-l","-c"]):(P=`'${process.execPath}' ${R} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,h==="tcsh"||h==="csh"?w=["-ic"]:w=["-i","-l","-c"]),E.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),P);const T=(0,i.spawn)(o,[...w,P],{detached:!0,stdio:["ignore","pipe","pipe"],env:t});g.onCancellationRequested(()=>(T.kill(),c(new I.$9))),T.on("error",M=>{E.error("getUnixShellEnvironment#errorChildProcess",(0,O.$vj)(M)),c(M)});const A=[];T.stdout.on("data",M=>A.push(M));const L=[];T.stderr.on("data",M=>L.push(M)),T.on("close",(M,V)=>{const q=Buffer.concat(A).toString("utf8");E.trace("getUnixShellEnvironment#raw",q);const Y=Buffer.concat(L).toString("utf8");if(Y.trim()&&E.trace("getUnixShellEnvironment#stderr",Y),M||V)return c(new Error((0,v.localize)(2066,null,M,V)));const de=a.exec(q),re=de?de[1]:"{}";try{const ee=JSON.parse(re);S?ee.ELECTRON_RUN_AS_NODE=S:delete ee.ELECTRON_RUN_AS_NODE,k?ee.ELECTRON_NO_ATTACH_CONSOLE=k:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.VSCODE_RESOLVING_ENVIRONMENT,delete ee.XDG_RUNTIME_DIR,E.trace("getUnixShellEnvironment#result",ee),n(ee)}catch(ee){E.error("getUnixShellEnvironment#errorCaught",(0,O.$vj)(ee)),c(ee)}})})}}),define(le[221],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;class i{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(v){try{const D=await this.c();if(D){const O=String(i.a++);return this.b.set(O,D),{id:O,data:D.createNewMessage(v)}}}catch{}return{id:"",data:v}}async validate(v,D){if(!v.id)return!0;const O=this.b.get(v.id);if(!O)return!1;this.b.delete(v.id);try{return O.validate(D)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(v){try{return await this.d(v)}catch{}return v}}e.$_dc=i}),define(le[104],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0,e.$4l="signService",e.$5l=(0,i.$Ki)(e.$4l)}),define(le[222],ue([0,1,160,221]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=void 0;class v extends r.$_dc{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(I=>new I.signer().sign(O))}async h(){return(0,i.$zq)("vsda","index.js")}}e.$ijc=v}),define(le[34],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5R=e.$4R=void 0,e.$4R=(0,i.$Ki)("stateReadService"),e.$5R=(0,i.$Ki)("stateService")}),define(le[130],ue([0,1,8,17,2,12,36,14,5]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8R=e.$7R=e.$6R=e.SaveStrategy=void 0;var l;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class m extends v.$Zc{constructor(d,f,y,E){super(),this.h=d,this.j=f,this.m=y,this.n=E,this.a=Object.create(null),this.b="",this.c=this.B(new i.$Ih(this.j===l.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(d)}}getItem(d,f){const y=this.a[d];return(0,D.$sg)(y)?f:y}setItem(d,f){this.setItems([{key:d,data:f}])}setItems(d){let f=!1;for(const{key:y,data:E}of d)this.a[y]!==E&&((0,D.$sg)(E)?(0,D.$qg)(this.a[y])||(this.a[y]=void 0,f=!0):(this.a[y]=E,f=!0));f&&this.s()}removeItem(d){(0,D.$qg)(this.a[d])||(this.a[d]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.n.writeFile(this.h,r.$Se.fromString(d),{atomic:{postfix:".vsctmp"}}),this.b=d}catch(f){this.m.error(f)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$6R=m;let u=class extends v.$Zc{constructor(d,f,y,E){super(),this.a=this.B(new m(f.stateResource,d,y,E))}async init(){await this.a.init()}getItem(d,f){return this.a.getItem(d,f)}};e.$7R=u,e.$7R=u=ke([se(1,O.$Ri),se(2,b.$fk),se(3,I.$fl)],u);class $ extends u{setItem(d,f){this.a.setItem(d,f)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.$8R=$}),define(le[131],ue([0,1,3,38,33]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=O,e.$Cp=I;function D(b){if(i.$x===i.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function O(b,l,m,u,$,p,d,f,y,E){const g=Object.create(null);g["common.machineId"]=p,g["common.sqmId"]=d,g["common.devDeviceId"]=f,g.sessionID=(0,v.$7g)()+Date.now(),g.commitHash=u,g.version=$,g["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,i.$k)(i.$x),g["common.nodePlatform"]=r.$ic,g["common.nodeArch"]=m,g["common.product"]=E||"desktop",y&&(g["common.msftInternal"]=y);let S=0;const k=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-k,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),i.$o&&(g["common.snap"]="true");const s=D(l);return s&&(g["common.platformDetail"]=s),g}function I(b){const l=r.env.USERDNSDOMAIN;if(!l)return!1;const m=l.toLowerCase();return b.some(u=>m===u)}}),define(le[24],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em=(0,i.$Ki)("telemetryService"),e.$fm=(0,i.$Ki)("customEndpointTelemetryService"),e.$gm="telemetry.currentSessionDate",e.$hm="telemetry.firstSessionDate",e.$im="telemetry.lastSessionDate",e.$jm="telemetry.machineId",e.$km="telemetry.sqmId",e.$lm="telemetry.devDeviceId",e.$mm="telemetry",e.$nm="telemetry.telemetryLevel",e.$om="telemetry.enableCrashReporter",e.$pm="telemetry.enableTelemetry";var r;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var v;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(v||(e.TelemetryConfiguration=v={}))}),define(le[223],ue([0,1,26,27,8,43,11,10,3,60,7,95,23,119,99,14,28,24]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$7s=S,e.$8s=s,e.$9s=a,i=Ie(i),r=Ie(r);const g=new Map;async function S(o,n){const c=`${o}::${n.join(":")}`,h=g.get(c);if(h)return h;const P=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i},{tag:"cursorrules",filePattern:/^\.cursorrules$/i}],w=new Map,R=new Map,T=2e4;function A(M,V,q,Y){const de=V.substring(M.length+1);return v.Promises.withAsyncBody(async re=>{let ee;Y.readdirCount++;try{ee=await $.Promises.readdir(V,{withFileTypes:!0})}catch{re();return}if(Y.count>=T){Y.count+=ee.length,Y.maxReached=!0,re();return}let W=ee.length;if(W===0){re();return}let Z=ee;Y.count+ee.length>T&&(Y.maxReached=!0,W=T-Y.count,Z=ee.slice(0,W)),Y.count+=ee.length;for(const C of Z)if(C.isDirectory()){if(q.includes(C.name)||await A(M,(0,I.$oc)(V,C.name),q,Y),--W===0){re();return}}else{const B=C.name.lastIndexOf(".");if(B>=0){const F=C.name.substring(B+1);F&&w.set(F,(w.get(F)??0)+1)}for(const F of P)F.relativePathPattern?.test(de)!==!1&&F.filePattern.test(C.name)&&R.set(F.tag,(R.get(F.tag)??0)+1);if(--W===0){re();return}}})}const L=v.Promises.withAsyncBody(async M=>{const V={count:0,maxReached:!1,readdirCount:0},q=new l.$ke(!0);await A(o,o,n,V);const Y=await a(o);M({configFiles:k(R),fileTypes:k(w),fileCount:V.count,maxFilesReached:V.maxReached,launchConfigFiles:Y,totalScanTime:q.elapsed(),totalReaddirCount:V.readdirCount})});return g.set(c,L),L}function k(o){return Array.from(o.entries(),([n,c])=>({name:n,count:c})).sort((n,c)=>c.count-n.count)}function s(){const o={os:`${r.type()} ${r.arch()} ${r.release()}`,memory:`${(r.totalmem()/f.$Nl.GB).toFixed(2)}GB (${(r.freemem()/f.$Nl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$Yn.value()*100)}%`},n=r.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}async function a(o){try{const n=new Map,c=(0,I.$oc)(o,".vscode","launch.json"),h=await i.promises.readFile(c),P=[],w=(0,D.$5n)(h.toString(),P);if(P.length)return console.log(`Unable to parse ${c}`),[];if((0,D.$ao)(w)==="object"&&w.configurations)for(const R of w.configurations){const T=R.type;T&&(n.has(T)?n.set(T,n.get(T)+1):n.set(T,1))}return k(n)}catch{return[]}}let t=class{constructor(n,c){this.c=n,this.d=c}f(n){const c=[];return c.push(`OS Version:       ${n.os}`),c.push(`CPUs:             ${n.cpus}`),c.push(`Memory (System):  ${n.memory}`),c.push(`VM:               ${n.vmHint}`),c.join(`
`)}g(n){const c=[];c.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),c.push(`OS Version:       ${r.type()} ${r.arch()} ${r.release()}`);const h=r.cpus();return h&&h.length>0&&c.push(`CPUs:             ${h[0].model} (${h.length} x ${h[0].speed})`),c.push(`Memory (System):  ${(r.totalmem()/f.$Nl.GB).toFixed(2)}GB (${(r.freemem()/f.$Nl.GB).toFixed(2)}GB free)`),b.$l||c.push(`Load (avg):       ${r.loadavg().map(P=>Math.round(P)).join(", ")}`),c.push(`VM:               ${Math.round(u.$Yn.value()*100)}%`),c.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),c.push(`Process Argv:     ${n.mainArguments.join(" ")}`),c.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),c.join(`
`)}async getPerformanceInfo(n,c){return Promise.all([(0,p.$6s)(n.mainPID),this.k(n)]).then(async h=>{let[P,w]=h,R=this.m(n,P);return c.forEach(T=>{if((0,d.$Zm)(T))R+=`
${T.errorMessage}`,w+=`
${T.errorMessage}`;else if(R+=`

Remote: ${T.hostName}`,T.processes&&(R+=`
${this.m(n,T.processes)}`),T.workspaceMetadata){w+=`
|  Remote: ${T.hostName}`;for(const A of Object.keys(T.workspaceMetadata)){const L=T.workspaceMetadata[A];let M=`${L.fileCount} files`;L.maxFilesReached&&(M=`more than ${M}`),w+=`|    Folder (${A}): ${M}`,w+=this.h(L)}}}),{processInfo:R,workspaceInfo:w}})}async getSystemInfo(n,c){const{memory:h,vmHint:P,os:w,cpus:R}=s(),T={os:w,memory:h,cpus:R,vmHint:P,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:c};return b.$l||(T.load=`${r.loadavg().map(A=>Math.round(A)).join(", ")}`),b.$n&&(T.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(T)}async getDiagnostics(n,c){const h=[];return(0,p.$6s)(n.mainPID).then(async P=>(h.push(""),h.push(this.g(n)),h.push(""),h.push(this.m(n,P)),n.windows.some(w=>w.folderURIs&&w.folderURIs.length>0&&!w.remoteAuthority)&&(h.push(""),h.push("Workspace Stats: "),h.push(await this.k(n))),c.forEach(w=>{if((0,d.$Zm)(w))h.push(`
${w.errorMessage}`);else if(h.push(`

`),h.push(`Remote:           ${w.hostName}`),h.push(this.f(w.machineInfo)),w.processes&&h.push(this.m(n,w.processes)),w.workspaceMetadata)for(const R of Object.keys(w.workspaceMetadata)){const T=w.workspaceMetadata[R];let A=`${T.fileCount} files`;T.maxFilesReached&&(A=`more than ${A}`),h.push(`Folder (${R}): ${A}`),h.push(this.h(T))}}),h.push(""),h.push(""),h.join(`
`)))}h(n){const c=[];let P=0;const w=(L,M)=>{const V=` ${L}(${M})`;P+V.length>60?(c.push(R),R="|                 ",P=R.length):P+=V.length,R+=V};let R="|      File types:";const T=10,A=n.fileTypes.length>T?T:n.fileTypes.length;for(let L=0;L<A;L++){const M=n.fileTypes[L];w(M.name,M.count)}if(c.push(R),n.configFiles.length>=0&&(R="|      Conf files:",P=0,n.configFiles.forEach(L=>{w(L.name,L.count)}),c.push(R)),n.launchConfigFiles.length>0){let L="|      Launch Configs:";n.launchConfigFiles.forEach(M=>{const V=M.count>1?` ${M.name}(${M.count})`:` ${M.name}`;L+=V}),c.push(L)}return c.join(`
`)}j(n){const c=Math.max(...Object.keys(n).map(h=>h.length));return Object.keys(n).map(h=>`${h}:  ${" ".repeat(c-h.length)}  ${n[h]}`).join(`
                  `)}k(n){const c=[],h=[];return n.windows.forEach(P=>{P.folderURIs.length===0||P.remoteAuthority||(c.push(`|  Window (${P.title})`),P.folderURIs.forEach(w=>{const R=m.URI.revive(w);if(R.scheme===O.Schemas.file){const T=R.fsPath;h.push(S(T,["node_modules",".git"]).then(A=>{let L=`${A.fileCount} files`;A.maxFilesReached&&(L=`more than ${L}`),c.push(`|    Folder (${(0,I.$sc)(T)}): ${L}`),c.push(this.h(A))}).catch(A=>{c.push(`|      Error: Unable to collect workspace stats for folder ${T} (${A.toString()})`)}))}else c.push(`|    Folder (${R.toString()}): Workspace stats not available.`)}))}),Promise.all(h).then(P=>c.join(`
`)).catch(P=>`Unable to collect workspace stats: ${P}`)}m(n,c){const h=new Map;n.windows.forEach(w=>h.set(w.pid,`window [${w.id}] (${w.title})`)),n.pidToNames.forEach(({pid:w,name:R})=>h.set(w,R));const P=[];return P.push("CPU %	Mem MB	   PID	Process"),c&&this.n(n.mainPID,h,P,c,0),P.join(`
`)}n(n,c,h,P,w){const R=w===0;let T;R?T=P.pid===n?`${this.d.applicationName} main`:"remote agent":c.has(P.pid)?T=c.get(P.pid):T=`${"  ".repeat(w)} ${P.name}`;const A=process.platform==="win32"?P.mem:r.totalmem()*(P.mem/100);h.push(`${P.load.toFixed(0).padStart(5," ")}	${(A/f.$Nl.MB).toFixed(0).padStart(6," ")}	${P.pid.toFixed(0).padStart(6," ")}	${T}`),Array.isArray(P.children)&&P.children.forEach(L=>this.n(n,c,h,L,w+1))}async getWorkspaceFileExtensions(n){const c=new Set;for(const{uri:h}of n.folders){const P=m.URI.revive(h);if(P.scheme!==O.Schemas.file)continue;const w=P.fsPath;try{(await S(w,["node_modules",".git"])).fileTypes.forEach(T=>c.add(T.name))}catch{}}return{extensions:[...c]}}async reportWorkspaceStats(n){for(const{uri:c}of n.folders){const h=m.URI.revive(c);if(h.scheme!==O.Schemas.file)continue;const P=h.fsPath;try{const w=await S(P,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),w.fileTypes.forEach(R=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:R.name,count:R.count})}),w.launchConfigFiles.forEach(R=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:R.name,count:R.count})}),w.configFiles.forEach(R=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:R.name,count:R.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:w.totalScanTime,reachedLimit:w.maxFilesReached,fileCount:w.fileCount,readdirCount:w.totalReaddirCount})}catch{}}}};e.$0s=t,e.$0s=t=ke([se(0,E.$em),se(1,y.$yk)],t)}),define(le[224],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=e.$vic=void 0;class i{constructor(D){this.b=D}listen(D,O){throw new Error(`Event not found: ${O}`)}call(D,O,{eventName:I,data:b}){return this.b.forEach(l=>l.log(I,b)),Promise.resolve(null)}}e.$vic=i;class r{constructor(D){this.b=D}log(D,O){return this.b.call("log",{eventName:D,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$wic=r}),define(le[57],ue([0,1,37,12,75,131,24]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=void 0,e.$Kp=m,e.$Lp=u,e.$Mp=$,e.$Np=p,e.$Op=f,e.$Pp=E,e.$Qp=g,e.$Rp=s;class I{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$Dp=I;class b{constructor(){this.telemetryLevel=O.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ep=b,e.$Fp=new b;class l{async publicLog(t,o,n){}async publicLogError(t,o,n){}}e.$Gp=l,e.$Hp="telemetry",e.$Ip="extensionTelemetryLog",e.$Jp={log:()=>null,flush:()=>Promise.resolve(null)};function m(a,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!a.enableTelemetry)}function u(a,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function $(a){const t=a.getValue(O.$nm),o=a.getValue(O.$om);if(a.getValue(O.$pm)===!1||o===!1)return O.TelemetryLevel.NONE;switch(t??O.TelemetryConfiguration.ON){case O.TelemetryConfiguration.ON:return O.TelemetryLevel.USAGE;case O.TelemetryConfiguration.ERROR:return O.TelemetryLevel.ERROR;case O.TelemetryConfiguration.CRASH:return O.TelemetryLevel.CRASH;case O.TelemetryConfiguration.OFF:return O.TelemetryLevel.NONE}}function p(a){const t={},o={},n={};y(a,n);for(let c in n){c=c.length>150?c.substr(c.length-149):c;const h=n[c];typeof h=="number"?o[c]=h:typeof h=="boolean"?o[c]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${h.length}`),t[c]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(t[c]=h)}return{properties:t,measurements:o}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(a){if(!a)return"none";const t=(0,v.$on)(a);return d.has(t)?t:"other"}function y(a,t,o=0,n){if(a)for(const c of Object.getOwnPropertyNames(a)){const h=a[c],P=n?n+c:c;Array.isArray(h)?t[P]=(0,i.$po)(h):h instanceof Date?t[P]=h.toISOString():(0,r.$lg)(h)?o<2?y(h,t,o+1,P+"."):t[P]=(0,i.$po)(h):t[P]=h}}function E(a,t){const o=a.msftInternalDomains||[],n=t.getValue("telemetry.internalTesting");return(0,D.$Cp)(o)||n}function g(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function S(a,t){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let o=a;const n=[];for(const w of t)for(;;){const R=w.exec(a);if(!R)break;n.push([R.index,w.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(o="";;){const w=h.exec(a);if(!w)break;const R=n.some(([T,A])=>w.index<A&&T<h.lastIndex);!c.test(w[0])&&!R&&(o+=a.substring(P,w.index)+"<REDACTED: user-file-path>",P=h.lastIndex)}return P<a.length&&(o+=a.substr(P)),o}function k(a){if(!a)return a;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of t)if(o.regex.test(a))return`<REDACTED: ${o.label}>`;return a}function s(a,t){return(0,i.$mo)(a,o=>{if(o instanceof I||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let n=o.replaceAll("%20"," ");n=S(n,t);for(const c of t)n=n.replace(c,"");return n=k(n),n}})}}),define(le[132],ue([0,1,25,129,87,3,7,15,38,57]),function(G,e,i,r,v,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$Tp=void 0,e.$Sp=m,e.$Up=d,e.$Vp=f,e.$Wp=y,e.$Xp=E,e.$Yp=g,e.$Zp=S,e.$1p=k,e.$3p=s,e.$4p=t;function m(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,i.$Ff)(o.id,n.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(n){const c=n.manifest?n.manifest.version:n.version,h=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new $(n.identifier,c,h)}static parse(n){const c=u.exec(n);return c&&c[1]&&c[2]?new $({id:c[1]},c[2],c[4]||void 0):null}constructor(n,c,h=v.TargetPlatform.UNDEFINED){this.identifier=n,this.version=c,this.targetPlatform=h,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==v.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof $?m(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$Tp=$;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(o){const n=p.exec(o);return n&&n[1]?[y(n[1]),n[2]]:[y(o),void 0]}function f(o,n){return`${o}.${n}`}function y(o){return o.toLowerCase()}function E(o,n){return y(f(o??v.$tn,n))}function g(o,n){const c=[],h=P=>{for(const w of c)if(w.some(R=>m(n(R),n(P))))return w;return null};for(const P of o){const w=h(P);w?w.push(P):c.push([P])}return c}function S(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function k(o){return{id:new l.$Dp(o.identifier.id),name:new l.$Dp(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$2p=new v.$xn("pprice.better-merge");function s(o,n){const c=[],h=n.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const P=h.shift();if(P&&c.every(w=>!m(w.identifier,{id:P}))){const w=o.filter(R=>m(R.identifier,{id:P}));w.length===1&&(c.push(w[0]),h.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function a(o,n){if(!D.$n)return!1;let c;try{c=(await o.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await o.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(P){n.debug("Error while getting the os-release file.",(0,I.$bb)(P))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function t(o,n){const c=await a(o,n),h=(0,r.$np)(c?"alpine":D.$x,b.$jc);return n.debug("ComputeTargetPlatform:",h),h}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[225],ue([0,1,2,37,3,25,9,16,56,73,28,46,24,57]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0,l=Ge(l);let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(E,g,S){this.k=g,this.l=S,this.d={},this.i=new i.$Yc,this.j=[],this.b=E.appenders,this.c=E.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=E.piiPaths||[],this.g=$.TelemetryLevel.USAGE,this.h=!!E.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,D.$mf)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$mf)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration($.$nm)||k.affectsConfiguration($.$pm)||k.affectsConfiguration($.$om))&&this.m()}))}setExperimentProperty(E,g){this.d[E]=g}m(){let E=(0,p.$Mp)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const S=g.usage?$.TelemetryLevel.USAGE:g.error?$.TelemetryLevel.ERROR:$.TelemetryLevel.NONE;E=Math.min(E,S)}this.g=E}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(E,g,S){this.g<g||(S=(0,r.$no)(S,this.d),S=(0,p.$Rp)(S,this.j),S=(0,r.$no)(S,this.c),this.b.forEach(k=>k.log(E,S)))}publicLog(E,g){this.n(E,$.TelemetryLevel.USAGE,g)}publicLog2(E,g){this.publicLog(E,g)}publicLogError(E,g){this.h&&this.n(E,$.TelemetryLevel.ERROR,g)}publicLogError2(E,g){this.publicLogError(E,g)}};e.$ps=d,e.$ps=d=ke([se(1,I.$ej),se(2,m.$yk)],d);function f(){const y=(0,O.localize)(2068,null,l.default.nameLong),E=l.default.privacyStatementUrl?(0,O.localize)(2070,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,O.localize)(2069,null,"https://aka.ms/vscode-telemetry"),g=v.$r?"":(0,O.localize)(2071,null),S=(0,O.localize)(2072,null),k=(0,O.localize)(2073,null),s=(0,O.localize)(2074,null),a=(0,O.localize)(2075,null),t=`
|       | ${S} | ${k} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,O.localize)(2076,null);return`
${y} ${E} ${g}

&nbsp;

${a}
${t}

&nbsp;

${o}
`}u.$xo.as(b.$Co.Configuration).registerConfiguration({id:$.$mm,order:1,type:"object",title:(0,O.localize)(2077,null),properties:{[$.$nm]:{type:"string",enum:[$.TelemetryConfiguration.ON,$.TelemetryConfiguration.ERROR,$.TelemetryConfiguration.CRASH,$.TelemetryConfiguration.OFF],enumDescriptions:[(0,O.localize)(2078,null),(0,O.localize)(2079,null),(0,O.localize)(2080,null),(0,O.localize)(2081,null)],markdownDescription:f(),default:$.TelemetryConfiguration.ON,restricted:!0,scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.$xo.as(b.$Co.Configuration).registerConfiguration({id:$.$mm,order:110,type:"object",title:(0,O.localize)(2082,null),properties:{[$.$pm]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,O.localize)(2084,null,l.default.nameLong,l.default.privacyStatementUrl):(0,O.localize)(2083,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(2085,null,`\`#${$.$nm}#\``),scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[226],ue([0,1,3,95,24]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=D,e.$Yic=O,e.$Zic=I;async function D(b,l){let m=b.getItem(v.$jm);return(typeof m!="string"||i.$m&&m==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(m=await(0,r.$Zn)(l.error.bind(l))),m}async function O(b,l){let m=b.getItem(v.$km);return typeof m!="string"&&(m=await(0,r.$1n)(l.error.bind(l))),m}async function I(b,l){let m=b.getItem(v.$lm);return typeof m!="string"&&(m=await(0,r.$2n)(l.error.bind(l))),m}}),define(le[227],ue([0,1,24,226]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=v,e.$2ic=D,e.$3ic=O;async function v(I,b){const l=await(0,r.$Xic)(I,b);return I.setItem(i.$jm,l),l}async function D(I,b){const l=await(0,r.$Yic)(I,b);return I.setItem(i.$km,l),l}async function O(I,b){const l=await(0,r.$Zic)(I,b);return I.setItem(i.$lm,l),l}}),define(le[133],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(le[228],ue([0,1,3,133]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;const v=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((u,$)=>{this.d(u,$);const p=u.map.entries();let d=p.next();for(;!d.done;){const f=d.value[1],y=d.value[0];let E=this.a.get(y);if(E||(E=[],this.a.set(y,E)),E.length>0&&E[0].type===r.EnvironmentVariableMutatorType.Replace){d=p.next();continue}const g={extensionIdentifier:$,value:f.value,type:f.type,scope:f.scope,variable:f.variable,options:f.options};g.scope||delete g.scope,E.unshift(g),d=p.next()}})}async applyToProcessEnvironment(m,u,$){let p;i.$l&&(p={},Object.keys(m).forEach(d=>p[d.toLowerCase()]=d));for(const[d,f]of this.getVariableMap(u)){const y=i.$l&&p[d.toLowerCase()]||d;for(const E of f){const g=$?await $(E.value):E.value;if(E.options?.applyAtProcessCreation??!0)switch(E.type){case r.EnvironmentVariableMutatorType.Append:m[y]=(m[y]||"")+g;break;case r.EnvironmentVariableMutatorType.Prepend:m[y]=g+(m[y]||"");break;case r.EnvironmentVariableMutatorType.Replace:m[y]=g;break}if(E.options?.applyAtShellIntegration??!1){const S=`VSCODE_ENV_${v.get(E.type)}`;m[S]=(m[S]?m[S]+":":"")+d+"="+this.c(g)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,u){const $=new Map,p=new Map,d=new Map;if(m.getVariableMap(u).forEach((f,y)=>{const E=this.getVariableMap(u).get(y),g=I(f,E);g&&$.set(y,g)}),this.getVariableMap(u).forEach((f,y)=>{const E=m.getVariableMap(u).get(y),g=I(f,E);g&&d.set(y,g)}),this.getVariableMap(u).forEach((f,y)=>{const E=m.getVariableMap(u).get(y),g=b(f,E);g&&p.set(y,g)}),!($.size===0&&p.size===0&&d.size===0))return{added:$,changed:p,removed:d}}getVariableMap(m){const u=new Map;for(const $ of this.a.values()){const p=$.filter(d=>O(d,m));p.length>0&&u.set(p[0].variable,p)}return u}getDescriptionMap(m){const u=new Map;for(const $ of this.b.values()){const p=$.filter(d=>O(d,m,!0));for(const d of p)u.set(d.extensionIdentifier,d.description)}return u}d(m,u){if(!m.descriptionMap)return;const $=m.descriptionMap.entries();let p=$.next();for(;!p.done;){const d=p.value[1],f=p.value[0];let y=this.b.get(f);y||(y=[],this.b.set(f,y));const E={extensionIdentifier:u,scope:d.scope,description:d.description};E.scope||delete E.scope,y.push(E),p=$.next()}}}e.$Ts=D;function O(l,m,u=!1){return l.scope?!!(l.scope.workspaceFolder&&m?.workspaceFolder&&l.scope.workspaceFolder.index===m.workspaceFolder.index):u?m===l.scope:!0}function I(l,m){if(!m)return l;const u=new Set;m.forEach(p=>u.add(p.extensionIdentifier));const $=[];return l.forEach(p=>{u.has(p.extensionIdentifier)||$.push(p)}),$.length===0?void 0:$}function b(l,m){if(!m)return;const u=new Map;m.forEach(p=>u.set(p.extensionIdentifier,p));const $=[];return l.forEach(p=>{const d=u.get(p.extensionIdentifier);d&&(p.type!==d.type||p.value!==d.value||p.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&$.push(d)}),$.length===0?void 0:$}}),define(le[229],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=i,e.$Os=r,e.$Ps=v,e.$Qs=D,e.$Rs=O,e.$Ss=I;function i(b){return[...b.entries()]}function r(b){return b?[...b.entries()]:[]}function v(b){return new Map(b)}function D(b){return new Map(b??[])}function O(b){return Array.from(b.entries()).map(l=>[l[0],i(l[1].map),r(l[1].descriptionMap)])}function I(b){return new Map(b.map(l=>[l[0],{map:v(l[1]),descriptionMap:D(l[2])}]))}}),define(le[230],ue([0,1,8,22,4,2,5]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;let I=class extends D.$Zc{constructor(l,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new v.$qe),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,D.$Xc)(()=>{for(const u of this.f.values())(0,D.$Uc)(u)}))}createRequest(l){return new Promise((m,u)=>{const $=++this.a;this.c.set($,m),this.g.fire({requestId:$,...l});const p=new r.$Be;(0,i.$Lh)(this.b,p.token).then(()=>u(`Request ${$} timed out (${this.b}ms)`)),this.f.set($,[(0,D.$Xc)(()=>p.cancel())])})}acceptReply(l,m){const u=this.c.get(l);u?(this.c.delete(l),(0,D.$Uc)(this.f.get(l)||[]),this.f.delete(l),u(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$Es=I,e.$Es=I=ke([se(1,O.$fk)],I)}),define(le[76],ue([0,1,6,125,46]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=e.$ys=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$xs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ws=void 0,e.$ws=new r.$2j("terminalTabFocusMode",!1,!0);var D;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var O;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(O||(e.TerminalSettingId=O={}));var I;(function(a){a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(I||(e.PosixShellType=I={}));var b;(function(a){a.CommandPrompt="cmd",a.Wsl="wsl",a.GitBash="gitbash"})(b||(e.WindowsShellType=b={}));var l;(function(a){a.PowerShell="pwsh",a.Python="python",a.Julia="julia",a.NuShell="nu"})(l||(e.GeneralShellType=l={}));var m;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(m||(e.TitleEventSource=m={}));var u;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(u||(e.TerminalIpcChannels=u={}));var $;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})($||(e.ProcessPropertyType=$={})),e.$xs=(0,i.$Ki)("ptyService");var p;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var d;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var f;(function(a){a.TerminalView="view",a.Editor="editor"})(f||(e.TerminalLocationString=f={}));var y;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var E;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(E||(e.FlowControlConstants=E={}));var g;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var S;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(S||(e.ShellIntegrationStatus=S={}));var k;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(k||(e.TerminalExitReason=k={})),e.$ys={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}v.$xo.add(e.$ys.Backend,new s),e.$zs=(0,i.$Ki)("localPtyService"),e.$As=(0,i.$Ki)("terminalLogService")}),define(le[231],ue([0,1,80,7,9,113]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=O,e.$Gs=l,e.$Hs=m,e.$Is=u;function O($,p){const d=[{name:null,description:(0,v.localize)(2118,null)}];return d.push(...$.map(f=>({name:f.profileName,description:I(f)}))),p&&d.push(...p.map(f=>({name:f.title,description:b(f)}))),{values:d.map(f=>f.name),markdownDescriptions:d.map(f=>f.description)}}function I($){let p=`$(${D.ThemeIcon.isThemeIcon($.icon)?$.icon.id:$.icon?$.icon:i.$0j.terminal.id}) ${$.profileName}
- path: ${$.path}`;return $.args&&(typeof $.args=="string"?p+=`
- args: "${$.args}"`:p+=`
- args: [${$.args.length===0?"":`'${$.args.join("','")}'`}]`),$.overrideName!==void 0&&(p+=`
- overrideName: ${$.overrideName}`),$.color&&(p+=`
- color: ${$.color}`),$.env&&(p+=`
- env: ${JSON.stringify($.env)}`),p}function b($){return`$(${D.ThemeIcon.isThemeIcon($.icon)?$.icon.id:$.icon?$.icon:i.$0j.terminal.id}) ${$.title}
- extensionIdentifier: ${$.extensionIdentifier}`}function l($,p){if(!$&&!p)return!0;if(typeof $=="string"&&typeof p=="string")return $===p;if(Array.isArray($)&&Array.isArray(p)){if($.length!==p.length)return!1;for(let d=0;d<$.length;d++)if($[d]!==p[d])return!1;return!0}return!1}function m($,p){if(!$&&!p)return!0;if(!$||!p)return!1;if(D.ThemeIcon.isThemeIcon($)&&D.ThemeIcon.isThemeIcon(p))return $.id===p.id&&$.color===p.color;if(typeof $=="object"&&"light"in $&&"dark"in $&&typeof p=="object"&&"light"in p&&"dark"in p){const d=$,f=p;if((r.URI.isUri(d.light)||u(d.light))&&(r.URI.isUri(d.dark)||u(d.dark))&&(r.URI.isUri(f.light)||u(f.light))&&(r.URI.isUri(f.dark)||u(f.dark)))return d.light.path===f.light.path&&d.dark.path===f.dark.path}if(r.URI.isUri($)&&r.URI.isUri(p)||u($)||u(p)){const d=$,f=p;return d.path===f.path&&d.scheme===f.scheme}return!1}function u($){return $?typeof $.path=="string"&&typeof $.scheme=="string":!1}}),define(le[232],ue([0,1,80,3,9,56,46,76,231]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=e.$Js=void 0,e.$Ls=d,e.$Ms=y,e.$Js={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Ks={type:"string",enum:Array.from((0,i.$8j)(),E=>E.id),markdownEnumDescriptions:Array.from((0,i.$8j)(),E=>`$(${E.id})`)};const l={args:{description:(0,v.localize)(2087,null),type:"array",items:{type:"string"}},overrideName:{description:(0,v.localize)(2088,null),type:"boolean"},icon:{description:(0,v.localize)(2089,null),...e.$Ks},color:{description:(0,v.localize)(2090,null),...e.$Js},env:{markdownDescription:(0,v.localize)(2091,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,v.localize)(2092,null),type:["string","array"],items:{type:"string"}},...l}},u={type:"object",required:["path"],properties:{path:{description:(0,v.localize)(2093,null),type:["string"],items:{type:"string"}},...l}};function $(E){const g=E===r.Platform.Linux?"linux":E===r.Platform.Mac?"osx":"windows";return(0,v.localize)(2094,null,(0,r.$k)(E),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,v.localize)(2095,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,v.localize)(2096,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,v.localize)(2097,null),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,v.localize)(2098,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},u],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:$(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,v.localize)(2099,null),enum:["PowerShell","Git Bash"]},...l}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,v.localize)(2100,null),type:"string"},id:{description:(0,v.localize)(2101,null),type:"string"},title:{description:(0,v.localize)(2102,null),type:"string"},...l}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:$(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,v.localize)(2103,null),type:"string"},id:{description:(0,v.localize)(2104,null),type:"string"},title:{description:(0,v.localize)(2105,null),type:"string"},...l}},{type:"null"},m]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:$(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,v.localize)(2106,null),type:"string"},id:{description:(0,v.localize)(2107,null),type:"string"},title:{description:(0,v.localize)(2108,null),type:"string"},...l}},{type:"null"},m]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,v.localize)(2109,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:D.ConfigurationScope.APPLICATION,description:(0,v.localize)(2110,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:D.ConfigurationScope.APPLICATION,markdownDescription:(0,v.localize)(2111,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:D.ConfigurationScope.APPLICATION,description:(0,v.localize)(2112,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,v.localize)(2113,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){O.$xo.as(D.$Co.Configuration).registerConfiguration(p),y()}let f;function y(E,g){const S=O.$xo.as(D.$Co.Configuration);let k;E&&(k=(0,b.$Fs)(E?.profiles,g));const s=f;f={id:"terminal",order:100,title:(0,v.localize)(2114,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,v.localize)(2115,null),type:["string","null"],default:null,enum:E?.os===r.OperatingSystem.Linux?k?.values:void 0,markdownEnumDescriptions:E?.os===r.OperatingSystem.Linux?k?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,v.localize)(2116,null),type:["string","null"],default:null,enum:E?.os===r.OperatingSystem.Macintosh?k?.values:void 0,markdownEnumDescriptions:E?.os===r.OperatingSystem.Macintosh?k?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,v.localize)(2117,null),type:["string","null"],default:null,enum:E?.os===r.OperatingSystem.Windows?k?.values:void 0,markdownEnumDescriptions:E?.os===r.OperatingSystem.Windows?k?.markdownDescriptions:void 0}}},S.updateConfigurations({add:[f],remove:s?[s]:[]})}}),define(le[233],ue([0,1,27,11,37,10,3,38,25,12,23,133,229,228]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=d,e.$Vs=f,e.$Ws=y,i=Ie(i),D=Ie(D),I=Ie(I),m=Ie(m);function d(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let P=0;return h&&h.length===4&&(P=parseInt(h[3])),P}async function f(h,P,w,R=I.env,T=m.Promises.exists){if(D.$nc(h))return await T(h)?h:void 0;if(P===void 0&&(P=I.cwd()),D.$rc(h)!=="."){const V=D.$oc(P,h);return await T(V)?V:void 0}const L=(0,v.$ro)(R,"PATH");if(w===void 0&&(0,l.$jg)(L)&&(w=L.split(D.$yc)),w===void 0||w.length===0){const V=D.$oc(P,h);return await T(V)?V:void 0}for(const V of w){let q;if(D.$nc(V)?q=D.$oc(V,h):q=D.$oc(P,V,h),await T(q))return q;if(O.$l){let Y=q+".com";if(await T(Y)||(Y=q+".exe",await T(Y)))return Y}}const M=D.$oc(P,h);return await T(M)?M:void 0}function y(h,P,w,R,T){const A=O.$l&&(!P.windowsEnableConpty||d()<18309);if(!P.shellIntegration.enabled||!h.executable||h.isFeatureTerminal&&!h.forceShellIntegration||h.ignoreShellIntegration||A)return;const L=h.args,M=I.$ic==="win32"?D.$sc(h.executable).toLowerCase():D.$sc(h.executable),V=D.$rc(r.$5g.asFileUri("").fsPath);let q;const Y={VSCODE_INJECTION:"1"};if(P.shellIntegration.nonce&&(Y.VSCODE_NONCE=P.shellIntegration.nonce),O.$l){if(M==="pwsh.exe"||M==="powershell.exe")return!L||n(L)?q=S.get(g.WindowsPwsh):o(L)&&(q=S.get(g.WindowsPwshLogin)),q?(q=[...q],q[q.length-1]=(0,b.$if)(q[q.length-1],V,""),Y.VSCODE_STABLE=T.quality==="stable"?"1":"0",P.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),{newArgs:q,envMixin:Y}):void 0;if(M==="bash.exe")return!L||L.length===0?q=S.get(g.Bash):c(L)&&(Y.VSCODE_SHELL_LOGIN="1",E(P,Y),q=S.get(g.Bash)),q?(q=[...q],q[q.length-1]=(0,b.$if)(q[q.length-1],V),Y.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:q,envMixin:Y}):void 0;R.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(M){case"bash":return!L||L.length===0?q=S.get(g.Bash):c(L)&&(Y.VSCODE_SHELL_LOGIN="1",E(P,Y),q=S.get(g.Bash)),q?(q=[...q],q[q.length-1]=(0,b.$if)(q[q.length-1],V),Y.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:q,envMixin:Y}):void 0;case"fish":{const de=w?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",re=D.$oc(V,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Y.XDG_DATA_DIRS=`${de}:${re}`,E(P,Y),{newArgs:void 0,envMixin:Y}}case"pwsh":return!L||n(L)?q=S.get(g.Pwsh):o(L)&&(q=S.get(g.PwshLogin)),q?(P.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),q=[...q],q[q.length-1]=(0,b.$if)(q[q.length-1],V,""),Y.VSCODE_STABLE=T.quality==="stable"?"1":"0",{newArgs:q,envMixin:Y}):void 0;case"zsh":{if(!L||L.length===0?q=S.get(g.Zsh):c(L)?(q=S.get(g.ZshLogin),E(P,Y)):(L===S.get(g.Zsh)||L===S.get(g.ZshLogin))&&(q=L),!q)return;q=[...q],q[q.length-1]=(0,b.$if)(q[q.length-1],V);let de;try{de=i.userInfo().username}catch{de="unknown"}const re=D.$oc(i.tmpdir(),`${de}-${T.applicationName}-zsh`);Y.ZDOTDIR=re;const ee=w?.ZDOTDIR??i.homedir()??"~";Y.USER_ZDOTDIR=ee;const W=[];return W.push({source:D.$oc(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$oc(re,".zshrc")}),W.push({source:D.$oc(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$oc(re,".zprofile")}),W.push({source:D.$oc(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$oc(re,".zshenv")}),W.push({source:D.$oc(V,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$oc(re,".zlogin")}),{newArgs:q,envMixin:Y,filesToCopy:W}}}R.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}function E(h,P){if(O.$m&&h.environmentVariableCollections){const w=(0,$.$Ss)(h.environmentVariableCollections),T=new p.$Ts(w).getVariableMap({workspaceFolder:h.workspaceFolder}).get("PATH"),A=[];if(T)for(const L of T)L.type===u.EnvironmentVariableMutatorType.Prepend&&A.push(L.value);A.length>0&&(P.VSCODE_PATH_PREFIX=A.join(""))}}var g;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})(g||(g={}));const S=new Map;S.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),S.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),S.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),S.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),S.set(g.Zsh,["-i"]),S.set(g.ZshLogin,["-il"]),S.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],s=["--login","-l"],a=["-i","--interactive"],t=["-nol","-nologo"];function o(h){return typeof h=="string"?k.includes(h.toLowerCase()):h.length===1&&k.includes(h[0].toLowerCase())||h.length===2&&(k.includes(h[0].toLowerCase())||k.includes(h[1].toLowerCase()))&&(t.includes(h[0].toLowerCase())||t.includes(h[1].toLowerCase()))}function n(h){return typeof h=="string"?t.includes(h.toLowerCase()):h.length===0||h?.length===1&&t.includes(h[0].toLowerCase())}function c(h){return typeof h!="string"&&(h=h.filter(P=>!a.includes(P.toLowerCase()))),h==="string"&&s.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&s.includes(h[0].toLowerCase())}}),define(le[234],ue([0,1,26,44,80,10,3,12,23,118,76,233,97]),function(G,e,i,r,v,D,O,I,b,l,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=y,i=Ie(i),r=Ie(r),b=Ie(b);var p;(function(w){w.UnixShellsPath="/etc/shells"})(p||(p={}));let d,f=!0;function y(w,R,T,A,L=process.env,M,V,q,Y){return M=M||{existsFile:b.SymlinkSupport.existsFile,readFile:i.promises.readFile},O.$l?E(T,M,L,V,A.getValue(m.TerminalSettingId.UseWslProfiles)!==!1,w&&typeof w=="object"?{...w}:A.getValue(m.TerminalSettingId.ProfilesWindows),typeof R=="string"?R:A.getValue(m.TerminalSettingId.DefaultProfileWindows),Y,q):c(M,V,T,w&&typeof w=="object"?{...w}:A.getValue(O.$n?m.TerminalSettingId.ProfilesLinux:m.TerminalSettingId.ProfilesMacOs),typeof R=="string"?R:A.getValue(O.$n?m.TerminalSettingId.DefaultProfileLinux:m.TerminalSettingId.DefaultProfileMacOs),Y,q,L)}async function E(w,R,T,A,L,M,V,q,Y){const de=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${de?"Sysnative":"System32"}`;let ee=!1;(0,u.$Us)()>=16299&&(ee=!0),await s(q);const W=new Map;if(w){W.set("PowerShell",{source:m.ProfileSource.Pwsh,icon:v.$0j.terminalPowershell,isAutoDetected:!0}),W.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:v.$0j.terminalPowershell,isAutoDetected:!0}),W.set("Git Bash",{source:m.ProfileSource.GitBash,isAutoDetected:!0}),W.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:v.$0j.terminalCmd,isAutoDetected:!0}),W.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),W.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:v.$0j.terminalBash,isAutoDetected:!0});const C=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;W.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",C],requiresPath:process.env.CMDER_ROOT?C:{path:C,isUnsafe:!0},isAutoDetected:!0})}h(M,W);const Z=await g(W.entries(),V,R,T,A,Y);if(w&&L)try{const C=await o(`${re}\\${ee?"wsl":"bash"}.exe`,V);for(const B of C)(!M||!(B.profileName in M))&&Z.push(B)}catch{f&&(A?.trace("WSL is not installed, so could not detect WSL profiles"),f=!1)}return Z}async function g(w,R,T,A=process.env,L,M){const V=[];for(const[q,Y]of w)V.push(S(q,Y,R,T,A,L,M));return(await Promise.all(V)).filter(q=>!!q)}async function S(w,R,T,A,L=process.env,M,V){if(R===null)return;let q,Y,de;if("source"in R&&!("path"in R)){const Z=d?.get(R.source);if(!Z)return;q=Z.paths,Y=R.args||Z.args,R.icon?de=k(R.icon):Z.icon&&(de=Z.icon)}else q=Array.isArray(R.path)?R.path:[R.path],Y=O.$l||Array.isArray(R.args)?R.args:void 0,de=k(R.icon);let re;if(V){const Z=q.map(B=>typeof B=="string"?B:B.path),C=await V(Z);re=new Array(q.length);for(let B=0;B<q.length;B++)typeof q[B]=="string"?re[B]=C[B]:re[B]={path:C[B],isUnsafe:!0}}else re=q.slice();let ee;if(R.requiresPath){let Z;if((0,I.$jg)(R.requiresPath)?Z=R.requiresPath:(Z=R.requiresPath.path,R.requiresPath.isUnsafe&&(ee=Z)),!await A.existsFile(Z))return}const W=await P(w,T,re,A,L,Y,R.env,R.overrideName,R.isAutoDetected,ee);if(!W){M?.debug("Terminal profile not validated",w,q);return}return W.isAutoDetected=R.isAutoDetected,W.icon=de,W.color=R.color,W}function k(w){return typeof w=="string"?{id:w}:w}async function s(w){if(d&&!w)return;const[R,T]=await Promise.all([a(),w||t()]);d=new Map,d.set(m.ProfileSource.GitBash,{profileName:"Git Bash",paths:R,args:["--login","-i"]}),d.set(m.ProfileSource.Pwsh,{profileName:"PowerShell",paths:T,icon:v.$0j.terminalPowershell})}async function a(){const w=new Set,R=await(0,u.$Vs)("git.exe");if(R){const L=(0,$.dirname)(R);w.add((0,$.resolve)(L,"../.."))}function T(L,M){M&&L.add(M)}T(w,process.env.ProgramW6432),T(w,process.env.ProgramFiles),T(w,process.env["ProgramFiles(X86)"]),T(w,`${process.env.LocalAppData}\\Program`);const A=[];for(const L of w)A.push(`${L}\\Git\\bin\\bash.exe`,`${L}\\Git\\usr\\bin\\bash.exe`,`${L}\\usr\\bin\\bash.exe`);return A.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),A.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),A}async function t(){const w=[];for await(const R of(0,l.$Bm)())w.push(R.exePath);return w}async function o(w,R){const T=[],A=await new Promise((V,q)=>{r.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Y,de)=>{if(Y)return q("Problem occurred when getting wsl distros");V(de)})});if(!A)return[];const L=new RegExp(/[\r?\n]/),M=A.split(L).filter(V=>V.trim().length>0&&V!=="");for(const V of M){if(V===""||V.startsWith("docker-desktop"))continue;const q=`${V} (WSL)`,Y={profileName:q,path:w,args:["-d",`${V}`],isDefault:q===R,icon:n(V),isAutoDetected:!1};T.push(Y)}return T}function n(w){return w.includes("Ubuntu")?v.$0j.terminalUbuntu:w.includes("Debian")?v.$0j.terminalDebian:v.$0j.terminalLinux}async function c(w,R,T,A,L,M,V,q){const Y=new Map;if(T&&await w.existsFile(p.UnixShellsPath)){const de=(await w.readFile(p.UnixShellsPath)).toString(),re=(M||de.split(`
`)).map(W=>{const Z=W.indexOf("#");return Z===-1?W:W.substring(0,Z)}).filter(W=>W.trim().length>0),ee=new Map;for(const W of re){let Z=(0,D.$sc)(W),C=ee.get(Z)||0;C++,C>1&&(Z=`${Z} (${C})`),ee.set(Z,C),Y.set(Z,{path:W,isAutoDetected:!0})}}return h(A,Y),await g(Y.entries(),L,w,q,R,V)}function h(w,R){if(w)for(const[T,A]of Object.entries(w))A===null||typeof A!="object"||!("path"in A)&&!("source"in A)?R.delete(T):(A.icon=A.icon||R.get(T)?.icon,R.set(T,A))}async function P(w,R,T,A,L,M,V,q,Y,de){if(T.length===0)return Promise.resolve(void 0);const re=T.shift();if(re==="")return P(w,R,T,A,L,M,V,q,Y);const ee=typeof re!="string"&&re.isUnsafe,W=typeof re=="string"?re:re.path,Z={profileName:w,path:W,args:M,env:V,overrideName:q,isAutoDetected:Y,isDefault:w===R,isUnsafePath:ee,requiresUnsafePath:de};if((0,D.$sc)(W)===W){const B=L.PATH?L.PATH.split(D.$yc):void 0,F=await(0,u.$Vs)(W,void 0,B,void 0,A.existsFile);return F?(Z.path=F,Z.isFromPath=!0,Z):P(w,R,T,A,L,M)}return await A.existsFile((0,D.$mc)(W))?Z:P(w,R,T,A,L,M,V,q,Y)}}),define(le[235],ue([0,1,4,2,3,45,16,5,197,103,230,76,232,234,120,60]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0;var y;(function(g){g[g.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let E=class extends r.$Zc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(S,k,s,a){super(),this.M=S,this.N=k,this.O=s,this.P=a,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new i.$qe),this.onPtyHostExit=this.u.event,this.w=this.B(new i.$qe),this.onPtyHostStart=this.w.event,this.y=this.B(new i.$qe),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new i.$qe),this.onPtyHostResponsive=this.z.event,this.C=this.B(new i.$qe),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new i.$qe),this.onProcessData=this.D.event,this.F=this.B(new i.$qe),this.onProcessReady=this.F.event,this.G=this.B(new i.$qe),this.onProcessReplay=this.G.event,this.H=this.B(new i.$qe),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new i.$qe),this.onDidRequestDetach=this.I.event,this.J=this.B(new i.$qe),this.onDidChangeProperty=this.J.event,this.L=this.B(new i.$qe),this.onProcessExit=this.L.event,(0,$.$Ls)(),this.B(this.M),this.B((0,r.$Xc)(()=>this.W())),this.j=this.B(new m.$Es(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(i.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(u.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(v.$l)return process.env;try{return await(0,l.$Wm)(this.N,this.O,{_:[]},process.env)}catch(S){return this.O.error("ptyHost was unable to resolve shell environment",S),{}}}U(){const S=this.M.start(),k=S.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(k.getChannel(u.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(S.onDidProcessExit(t=>{this.u.fire(t.code),!this.m&&!this.q.isDisposed&&(this.n<=y.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${t.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const a=D.ProxyChannel.toService(k.getChannel(u.TerminalIpcChannels.PtyHost));return this.B(a.onProcessData(t=>this.D.fire(t))),this.B(a.onProcessReady(t=>this.F.fire(t))),this.B(a.onProcessExit(t=>this.L.fire(t))),this.B(a.onDidChangeProperty(t=>this.J.fire(t))),this.B(a.onProcessReplay(t=>this.G.fire(t))),this.B(a.onProcessOrphanQuestion(t=>this.H.fire(t))),this.B(a.onDidRequestDetach(t=>this.I.fire(t))),this.B(new b.$Ds(this.P,k.getChannel(u.TerminalIpcChannels.Logger))),this.a=S,this.b=a,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async t=>{t.affectsConfiguration(u.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[S,a]}async createProcess(S,k,s,a,t,o,n,c,h,P,w){const R=setTimeout(()=>this.$(),u.HeartbeatConstants.CreateProcessTimeout),T=await this.f.createProcess(S,k,s,a,t,o,n,c,h,P,w);return clearTimeout(R),T}updateTitle(S,k,s){return this.f.updateTitle(S,k,s)}updateIcon(S,k,s,a){return this.f.updateIcon(S,k,s,a)}attachToProcess(S){return this.f.attachToProcess(S)}detachFromProcess(S,k){return this.f.detachFromProcess(S,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(S){return this.f.start(S)}shutdown(S,k){return this.f.shutdown(S,k)}input(S,k){return this.f.input(S,k)}processBinary(S,k){return this.f.processBinary(S,k)}resize(S,k,s){return this.f.resize(S,k,s)}clearBuffer(S){return this.f.clearBuffer(S)}acknowledgeDataEvent(S,k){return this.f.acknowledgeDataEvent(S,k)}setUnicodeVersion(S,k){return this.f.setUnicodeVersion(S,k)}getInitialCwd(S){return this.f.getInitialCwd(S)}getCwd(S){return this.f.getCwd(S)}async getLatency(){const S=new f.$ke,k=await this.f.getLatency();return S.stop(),[{label:"ptyhostservice<->ptyhost",latency:S.elapsed()},...k]}orphanQuestionReply(S){return this.f.orphanQuestionReply(S)}installAutoReply(S,k){return this.f.installAutoReply(S,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(S){return this.f.uninstallAutoReply(S)}getDefaultSystemShell(S){return this.g?.getDefaultSystemShell(S)??(0,d.$Fm)(S??v.OS,process.env)}async getProfiles(S,k,s,a=!1){const t=await this.S();return(0,p.$Xs)(k,s,a,this.N,t,void 0,this.O,this.bb.bind(this,S))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(S,k){return this.f.getWslPath(S,k)}getRevivedPtyNewId(S,k){return this.f.getRevivedPtyNewId(S,k)}setTerminalLayoutInfo(S){return this.f.setTerminalLayoutInfo(S)}async getTerminalLayoutInfo(S){return this.g?.getTerminalLayoutInfo(S)}async requestDetachInstance(S,k){return this.f.requestDetachInstance(S,k)}async acceptDetachInstanceReply(S,k){return this.f.acceptDetachInstanceReply(S,k)}async freePortKillProcess(S){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(S)}async serializeTerminalState(S){return this.f.serializeTerminalState(S)}async reviveTerminalProcesses(S,k,s){return this.f.reviveTerminalProcesses(S,k,s)}async refreshProperty(S,k){return this.f.refreshProperty(S,k)}async updateProperty(S,k,s){return this.f.updateProperty(S,k,s)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(S){this.ab(),this.s=setTimeout(()=>this.Y(),S?u.HeartbeatConstants.ConnectingBeatInterval:u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier+u.HeartbeatConstants.BeatInterval*u.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${u.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(S,k){return this.j.createRequest({workspaceId:S,originalText:k})}async acceptPtyHostResolvedVariables(S,k){this.j.acceptReply(S,k)}};e.$Ys=E,e.$Ys=E=ke([se(1,O.$ej),se(2,I.$fk),se(3,I.$gk)],E)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[77],ue([0,1,13,4,2,3,16,6,34]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=void 0,i=Ge(i);const l="#FFFFFF",m="#1E1E1E",u="#000000",$="#FFFFFF",p="theme",d="themeBackground",f="windowSplash";var y;(function(g){g.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",g.SYSTEM_COLOR_THEME="window.systemColorTheme"})(y||(y={})),e.$jhc=(0,I.$Ki)("themeMainService");let E=class extends v.$Zc{constructor(S,k){super(),this.b=S,this.c=k,this.a=this.B(new r.$qe),this.onDidChangeColorScheme=this.a.event,D.$n||this.B(this.c.onDidChangeConfiguration(s=>{(s.affectsConfiguration(y.SYSTEM_COLOR_THEME)||s.affectsConfiguration(y.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(i.default.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(D.$n||this.c.getValue(y.DETECT_COLOR_SCHEME))i.default.nativeTheme.themeSource="system";else switch(this.c.getValue(y.SYSTEM_COLOR_THEME)){case"dark":i.default.nativeTheme.themeSource="dark";break;case"light":i.default.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":i.default.nativeTheme.themeSource="light";break;case"vs-dark":i.default.nativeTheme.themeSource="dark";break;default:i.default.nativeTheme.themeSource="system"}break;default:i.default.nativeTheme.themeSource="system";break}}getColorScheme(){if(D.$l){if(i.default.nativeTheme.shouldUseHighContrastColors)return{dark:i.default.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(D.$m){if(i.default.nativeTheme.shouldUseInvertedColorScheme||i.default.nativeTheme.shouldUseHighContrastColors)return{dark:i.default.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(D.$n&&i.default.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:i.default.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const S=this.getColorScheme();if(S.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return S.dark?u:$;let k=this.b.getItem(d,null);if(!k)switch(this.g()){case"vs":k=l;break;case"hc-black":k=u;break;case"hc-light":k=$;break;default:k=m}return D.$m&&k.toUpperCase()===m&&(k="#171717"),k}g(){switch(this.b.getItem(p,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(S,k){this.b.setItems([{key:p,data:k.baseTheme},{key:d,data:k.colorInfo.background},{key:f,data:k}]),typeof S=="number"&&this.h(S,k),this.f()}h(S,k){for(const s of i.default.BrowserWindow.getAllWindows())if(s.id===S){s.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(f)}};e.$khc=E,e.$khc=E=ke([se(0,b.$5R),se(1,O.$ej)],E)}),define(le[134],ue([0,1,4,2,3,7,16,6,5]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yw=e.$Xw=e.$Uw=e.$Sw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ow=e.$Nw=void 0,e.$Pw=u,e.$Qw=p,e.$Rw=d,e.$Tw=f,e.$Vw=y,e.$Ww=E,e.$Nw=(0,I.$Ki)("tunnelService"),e.$Ow=(0,I.$Ki)("sharedTunnelsService");var l;(function(k){k.Http="http",k.Https="https"})(l||(e.TunnelProtocol=l={}));var m;(function(k){k.ConstantPrivate="constantPrivate",k.Private="private",k.Public="public"})(m||(e.TunnelPrivacyId=m={}));function u(k){return!!k.forwardPort}var $;(function(k){k[k.Notify=1]="Notify",k[k.OpenBrowser=2]="OpenBrowser",k[k.OpenPreview=3]="OpenPreview",k[k.Silent=4]="Silent",k[k.Ignore=5]="Ignore",k[k.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function p(k){if(k.scheme!=="http"&&k.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(k.authority);if(s)return{address:s[1],port:+s[2]}}function d(k){if(k.scheme!=="http"&&k.scheme!=="https"||!k.query)return;const s=k.query.split("&");for(const a of s){const t=a.split("=")[1];if(/^https?:/.exec(t)){const o=p(D.URI.parse(t));if(o)return o}}}e.$Sw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function f(k){return e.$Sw.indexOf(k)>=0}e.$Uw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(k){return e.$Uw.indexOf(k)>=0}function E(k,s,a,t){if(a===v.OperatingSystem.Windows)return!1;if(a===v.OperatingSystem.Macintosh&&y(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(o?.length===4&&parseInt(o[1])>=18)return!1}return k<1024}class g{constructor(s,a,t){this.remoteAddress=s,this.localAddress=a,this.b=t,this.a=new i.$qe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Xw=g;let S=class extends r.$Zc{constructor(s,a){super(),this.r=s,this.s=a,this.a=new i.$qe,this.onTunnelOpened=this.a.event,this.b=new i.$qe,this.onTunnelClosed=this.b.event,this.c=new i.$qe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const s=this.s.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.g=s,s?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.h=s.elevation,this.m=s.privacyOptions,this.j=s.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const s=[],a=Array.from(this.f.values());for(const t of a){const o=Array.from(t.values());for(const n of o){const c=await n.value;c&&typeof c!="string"&&s.push(c)}}return s}async dispose(){super.dispose();for(const s of this.f.values()){for(const{value:a}of s.values())await a.then(t=>typeof t!="string"?t?.dispose():void 0);s.clear()}this.f.clear()}setEnvironmentTunnel(s,a,t,o,n){this.z(s,a,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:a,localAddress:t,privacy:o,protocol:n,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,a){(y(s)||f(s))&&(s=e.$Sw[0]);const t=this.D(s,a);if(t)return++t.refcount,t.value}openTunnel(s,a,t,o,n,c=!1,h,P){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${t} on local port ${n}.`);const w=this.g??s;if(!w)return;if(a||(a="localhost"),o||(o=this.t),this.g&&this.n.has(t)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const R=this.F(w,a,t,o,n,c,h,P);return R?R.then(T=>{if(T){if(typeof T=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(a,t),T}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(a,t);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const A=this.w(T);return(T.tunnelRemoteHost!==a||T.tunnelRemotePort!==t)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&T.privacy!==h&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(A),A}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),R)}w(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const a=this.f.get(s.tunnelRemoteHost);if(a){const t=a.get(s.tunnelRemotePort);t&&(t.refcount--,await this.y(s.tunnelRemoteHost,s.tunnelRemotePort,t))}}}}async y(s,a,t){if(t.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${a}.`);const o=t.value.then(async n=>{n&&typeof n!="string"&&(await n.dispose(!0),this.b.fire({host:n.tunnelRemoteHost,port:n.tunnelRemotePort}))});return this.f.has(s)&&this.f.get(s).delete(a),o}}async closeTunnel(s,a){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${a} `);const t=this.f.get(s);if(t&&t.has(a)){const o=t.get(a);o.refcount=0,await this.y(s,a,o)}}z(s,a,t){this.f.has(s)||this.f.set(s,new Map),this.f.get(s).set(a,{refcount:1,value:t})}async C(s,a){const t=this.f.get(s);if(t){const o=t.get(a),n=o?await o.value:void 0;(!n||typeof n=="string")&&t.delete(a),t.size===0&&this.f.delete(s)}}D(s,a){const t=[s];f(s)?(t.push(...e.$Sw),t.push(...e.$Uw)):y(s)&&t.push(...e.$Uw);const o=t.map(n=>this.f.get(n));for(const n of o){const c=n?.get(a);if(c)return c}}canTunnel(s){return!!p(s)}G(s,a,t,o,n,c,h){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${t} on local port ${o}.`);const P=t;this.n.add(P);const w=o===void 0?t:o,R={elevationRequired:n?this.isPortPrivileged(w):!1},T={remoteAddress:{host:a,port:t},localAddressPort:o,privacy:c,public:c?c!==m.Private:void 0,protocol:h},A=s.forwardPort(T,R);return A?(this.z(a,t,A),A.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(P)})):this.n.delete(P),A}};e.$Yw=S,e.$Yw=S=ke([se(0,b.$fk),se(1,O.$ej)],S)}),define(le[51],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oZ=e.$nZ=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(O){O.Uninitialized="uninitialized",O.Idle="idle",O.Disabled="disabled",O.CheckingForUpdates="checking for updates",O.AvailableForDownload="available for download",O.Downloading="downloading",O.Downloaded="downloaded",O.Updating="updating",O.Ready="ready"})(r||(e.StateType=r={}));var v;(function(O){O[O.Setup=0]="Setup",O[O.Archive=1]="Archive",O[O.Snap=2]="Snap"})(v||(e.UpdateType=v={}));var D;(function(O){O[O.NotBuilt=0]="NotBuilt",O[O.DisabledByEnvironment=1]="DisabledByEnvironment",O[O.ManuallyDisabled=2]="ManuallyDisabled",O[O.MissingConfiguration=3]="MissingConfiguration",O[O.InvalidConfiguration=4]="InvalidConfiguration",O[O.RunningAsAdmin=5]="RunningAsAdmin"})(D||(e.DisablementReason=D={})),e.$nZ={Uninitialized:{type:r.Uninitialized},Disabled:O=>({type:r.Disabled,reason:O}),Idle:(O,I)=>({type:r.Idle,updateType:O,error:I}),CheckingForUpdates:O=>({type:r.CheckingForUpdates,explicit:O}),AvailableForDownload:O=>({type:r.AvailableForDownload,update:O}),Downloading:{type:r.Downloading},Downloaded:O=>({type:r.Downloaded,update:O}),Updating:O=>({type:r.Updating,update:O}),Ready:O=>({type:r.Ready,update:O})},e.$oZ=(0,i.$Ki)("updateService")}),define(le[236],ue([0,1,3,9,56,46]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.$xo.as(v.$Co.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(2431,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:v.ConfigurationScope.APPLICATION,description:(0,r.localize)(2432,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(2433,null),(0,r.localize)(2434,null),(0,r.localize)(2435,null),(0,r.localize)(2436,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:v.ConfigurationScope.APPLICATION,description:(0,r.localize)(2437,null),deprecationMessage:(0,r.localize)(2438,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:v.ConfigurationScope.APPLICATION,title:(0,r.localize)(2439,null),description:(0,r.localize)(2440,null),included:i.$l&&!i.$r},"update.showReleaseNotes":{type:"boolean",default:!0,scope:v.ConfigurationScope.APPLICATION,description:(0,r.localize)(2441,null),tags:["usesOnlineServices"]}}})}),define(le[237],ue([0,1,4,51]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=e.$xic=void 0;class v{constructor(I){this.a=I}listen(I,b){switch(b){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${b}`)}call(I,b,l){switch(b){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${b}`)}}e.$xic=v;class D{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new i.$qe,this.onStateChange=this.a.event,this.b=r.$nZ.Uninitialized,this.c.listen("onStateChange")(b=>this.state=b),this.c.call("_getInitialState").then(b=>this.state=b)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$yic=D}),define(le[41],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0,e.$Pl=(0,i.$Ki)("IUriIdentityService")}),define(le[238],ue([0,1,41,177,14,18,148,4,2]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=void 0;class l{static{this._clock=0}constructor($){this.uri=$,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let m=class{constructor($){this.g=$,this.c=new b.$Yc,this.f=2**16;const p=new Map,d=f=>{let y=p.get(f.scheme);return y===void 0&&(y=$.hasProvider(f)&&!this.g.hasCapability(f,v.FileSystemProviderCapabilities.PathCaseSensitive),p.set(f.scheme,y)),y};this.c.add(I.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(f=>{p.delete(f.scheme)})),this.extUri=new D.$ah(d),this.d=new O.$2s((f,y)=>this.extUri.compare(f,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,D.$mh)($));const p=this.d.get($);return p?p.touch().uri.with({fragment:$.fragment}):(this.d.set($,new l($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((d,f)=>d[1].time<f[1].time?1:d[1].time>f[1].time?-1:0);l._clock=0,this.d.clear();const p=this.f*.5;for(let d=0;d<p;d++)this.d.set($[d][0],$[d][1].touch())}};e.$3s=m,e.$3s=m=ke([se(0,v.$fl)],m),(0,r.$Zs)(i.$Pl,m,r.InstantiationType.Delayed)}),define(le[135],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eZ=void 0,e.$eZ=(0,i.$Ki)("urlService")}),define(le[239],ue([0,1,7]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=e.$Gic=e.$Fic=void 0;class r{constructor(I){this.a=I}listen(I,b){throw new Error(`Event not found: ${b}`)}call(I,b,l){switch(b){case"handleURL":return this.a.handleURL(i.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${b}`)}}e.$Fic=r;class v{constructor(I){this.a=I}handleURL(I,b){return this.a.call("handleURL",[I.toJSON(),b])}}e.$Gic=v;class D{constructor(I,b){this.a=I,this.b=b}async routeCall(I,b,l,m){if(b!=="handleURL")throw new Error(`Call not found: ${b}`);if(Array.isArray(l)&&l.length>0){const u=i.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",u.toString(!0)),u.query){const $=/\bwindowId=(\d+)/.exec(u.query);if($){const p=$[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${p}"`,u.toString(!0));const d=new RegExp(`window:${p}`),f=I.connections.find(y=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",y.ctx),d.test(y.ctx)));if(f)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",u.toString(!0)),f;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",u.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",u.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,b,l,m)}routeEvent(I,b){throw new Error(`Event not found: ${b}`)}}e.$Hic=D}),define(le[240],ue([0,1,8,2,7,28]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gZ=e.$fZ=void 0;class O extends r.$Zc{constructor(){super(...arguments),this.a=new Set}open(l,m){const u=[...this.a.values()];return(0,i.$Oh)(u.map($=>()=>$.handleURL(l,m)),void 0,!1).then($=>$||!1)}registerHandler(l){return this.a.add(l),(0,r.$Xc)(()=>this.a.delete(l))}}e.$fZ=O;let I=class extends O{constructor(l){super(),this.b=l}create(l){let{authority:m,path:u,query:$,fragment:p}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&u&&u.indexOf("/")!==0&&(u=`/${u}`),v.URI.from({scheme:this.b.urlProtocol,authority:m,path:u,query:$,fragment:p})}};e.$gZ=I,e.$gZ=I=ke([se(0,D.$yk)],I)}),define(le[241],ue([0,1,13,8,4,2,3,7]),function(G,e,i,r,v,D,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;class b extends D.$Zc{constructor(m,u,$,p,d,f){if(super(),this.c=u,this.f=f,this.a=[],this.b=0,m&&(f.trace("ElectronURLListener initialUrisToHandle:",m.map(g=>g.originalUrl)),this.a=m),O.$l){const g=p.isBuilt?[]:[`"${p.appRoot}"`];g.push("--open-url","--"),i.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,g)}const y=v.Event.map(v.Event.fromNodeEventEmitter(i.app,"open-url",(g,S)=>({event:g,url:S})),({event:g,url:S})=>(g.preventDefault(),S));this.B(y(g=>{const S=this.g(g);S&&this.c.open(S,{originalUrl:g})})),$.getWindows().filter(g=>g.isReady).length>0?(f.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(f.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(v.Event.once($.onDidSignalReadyWindow)(()=>this.h())))}g(m){try{return I.URI.parse(m)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const u of this.a)await this.c.open(u.uri,{originalUrl:u.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",u.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",u.originalUrl),m.push(u));m.length!==0&&(this.a=m,(0,r.$Mh)(()=>this.h(),500,this.q))}}e.$Iic=b}),define(le[242],ue([0,1,4,2,14,61,31]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;class I extends r.$Zc{constructor(l,m,u,$,p,d){super(),this.f=l,this.g=m,this.h=u,this.j=$,this.m=p,this.n=d,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new i.$qe),this.onDidChangeFile=this.a.event,this.b=D.$Qi.forUris(()=>!(this.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new O.$Gc(f=>this.m.extUri.getComparisonKey(this.t(f))),this.r(),this.B($.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(f=>this.s(f)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,m){return this.g.open(this.t(l),m)}close(l){return this.g.close(l)}read(l,m,u,$,p){return this.g.read(l,m,u,$,p)}write(l,m,u,$,p){return this.g.write(l,m,u,$,p)}watch(l,m){this.b.set(l,l);const u=this.g.watch(this.t(l),m);return(0,r.$Xc)(()=>{this.b.delete(l),u.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,m,u){return this.g.rename(this.t(l),this.t(m),u)}readFile(l,m){return this.g.readFile(this.t(l),m)}readFileStream(l,m,u){return this.g.readFileStream(this.t(l),m,u)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,m,u){return this.g.writeFile(this.t(l),m,u)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,m){return this.g.delete(this.t(l),m)}copy(l,m,u){if((0,v.$jl)(this.g))return this.g.copy(this.t(l),this.t(m),u);throw new Error("copy not supported")}cloneFile(l,m){if((0,v.$kl)(this.g))return this.g.cloneFile(this.t(l),this.t(m));throw new Error("clone not supported")}s(l){const m=[];for(const u of l){if(u.resource.scheme!==this.f)continue;const $=this.u(u.resource);this.b.findSubstr($)&&m.push({resource:$,type:u.type,cId:u.cId})}m.length&&(this.n.debug("User data changed"),this.a.fire(m))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$ljc=I}),define(le[243],ue([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0,e.$5ic="utilityProcessWorker"}),define(le[244],ue([0,1,6]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0,e.$Jic=(0,i.$Ki)("webviewManagerService")}),define(le[245],ue([0,1,13,2,11,7]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;class O extends r.$Zc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const b=this.b.bind(this);i.protocol.registerFileProtocol(v.Schemas.vscodeWebview,b)}b(b,l){try{const m=D.URI.parse(b.url),u=O.a.get(m.path);if(typeof u=="string"){const $=`vs/workbench/contrib/webview/browser/pre/${u}`,p=v.$5g.asFileUri($);return l({path:p.fsPath,headers:{...v.COI.getHeadersFromQuery(b.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$Kic=O}),define(le[47],ue([0,1,3]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$oE=void 0,e.$pE=r,e.$qE=v,e.$rE=D,e.$sE=O,e.$tE=I,e.$uE=u,e.$vE=$,e.$wE=p,e.$yE=d,e.$zE=f,e.$AE=y,e.$oE={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r(E){return typeof E.parentId=="number"}function v(E){return!!E.workspaceUri}function D(E){return!!E.folderUri}function O(E){return!!E.fileUri}function I(E){const g=$(E),S=E.getValue("window.menuBarVisibility");return S==="default"||g&&S==="compact"||i.$m&&i.$p?"classic":S}var b;(function(E){E.TITLE_BAR_STYLE="window.titleBarStyle",E.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(b||(e.TitleBarSetting=b={}));var l;(function(E){E.NATIVE="native",E.CUSTOM="custom"})(l||(e.TitlebarStyle=l={}));var m;(function(E){E.AUTO="auto",E.WINDOWED="windowed",E.NEVER="never"})(m||(e.CustomTitleBarVisibility=m={}));function u(E,g){return!0}function $(E,g){return g||(g=p(E)),g===l.NATIVE}function p(E){if(i.$r)return l.CUSTOM;const g=E.getValue("window");if(g){if(i.$m&&g.nativeTabs===!0||i.$m&&g.nativeFullScreen===!1)return l.NATIVE;const s=g.titleBarStyle;if(s===l.NATIVE||s===l.CUSTOM)return s}return i.$n?l.NATIVE:l.CUSTOM}e.$xE=35;function d(E){if(i.$m||i.$r||$(E))return!1;if(i.$n){const g=E.getValue("window.experimentalControlOverlay");if(typeof g=="boolean")return g}return!0}function f(E){const g=E.getValue("window");return!g||typeof g.nativeFullScreen!="boolean"||g.nativeTabs?!0:g.nativeFullScreen!==!1}function y(E=0){return Math.pow(1.2,E)}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[52],ue([0,1,13]),function(G,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$bhc=e.$ahc=e.UnloadReason=e.LoadReason=void 0,i=Ge(i);var r;(function(l){l[l.INITIAL=1]="INITIAL",l[l.LOAD=2]="LOAD",l[l.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var v;(function(l){l[l.CLOSE=1]="CLOSE",l[l.QUIT=2]="QUIT",l[l.RELOAD=3]="RELOAD",l[l.LOAD=4]="LOAD"})(v||(e.UnloadReason=v={}));const D=function(l=I.Normal){return{width:1024,height:768,mode:l}};e.$ahc=D;const O=function(){const u=i.default.screen.getPrimaryDisplay().workArea,$=Math.max(u.x+u.width/2-800/2,0),p=Math.max(u.y+u.height/2-600/2,0);return{x:$,y:p,width:800,height:600,mode:I.Normal}};e.$bhc=O;var I;(function(l){l[l.Maximized=0]="Maximized",l[l.Normal=1]="Normal",l[l.Minimized=2]="Minimized",l[l.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var b;(function(l){l[l.UNRESPONSIVE=1]="UNRESPONSIVE",l[l.PROCESS_GONE=2]="PROCESS_GONE",l[l.LOAD=3]="LOAD"})(b||(e.WindowError=b={}))}),define(le[246],ue([0,1,8,4,2]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;class D extends v.$Zc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:b,getActiveWindowId:l}){super(),this.a=this.B(new v.$Yc),r.Event.latch(r.Event.any(I,b))(this.f,this,this.a),this.b=(0,i.$xh)(()=>l()),(async()=>{try{const u=await this.b;this.c=typeof this.c=="number"?this.c:u}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Qic=D}),define(le[30],ue([0,1,9,10,61,18,7,6,11]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$0i=e.$9i=e.$8i=e.$7i=e.$5i=e.$4i=e.WorkbenchState=e.$Xi=e.$Wi=e.$Ti=void 0,e.$Ui=l,e.$Vi=m,e.$Yi=u,e.$Zi=$,e.$1i=p,e.$2i=f,e.$3i=y,e.$6i=S,e.$$i=k,e.$_i=s,e.$bj=a,e.$cj=t,e.$dj=o,e.$Ti=(0,I.$Ki)("contextService");function l(n){const c=n;return typeof c?.id=="string"&&O.URI.isUri(c.uri)}function m(n){return typeof n?.id=="string"&&!l(n)&&!$(n)}e.$Wi={id:"ext-dev"},e.$Xi={id:"empty-window"};function u(n,c){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,r.$sc)(n)}:c?e.$Wi:e.$Xi;const h=n;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function $(n){const c=n;return typeof c?.id=="string"&&O.URI.isUri(c.configPath)}function p(n){const c=n;if(c?.uri)return{id:c.id,uri:O.URI.revive(c.uri)};const h=n;if(h?.configPath)return{id:h.id,configPath:O.URI.revive(h.configPath)};if(n?.id)return{id:n.id}}var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function f(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function y(n){const c=n;return!!(c&&typeof c=="object"&&O.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class E{constructor(c,h,P,w,R){this.h=c,this.j=P,this.k=w,this.l=R,this.c=v.$Qi.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=v.$Qi.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$4i=E;class g{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,D.$lh)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$5i=g;function S(n){return new g({uri:n,index:0,name:(0,D.$hh)(n)},{uri:n.toString()})}e.$7i="code-workspace",e.$8i=`.${e.$7i}`,e.$9i=[{name:(0,i.localize)(2489,null),extensions:[e.$7i]}],e.$0i="workspace.json";function k(n,c){return D.$ch.isEqualOrParent(n,c.untitledWorkspacesHome)}function s(n){let c;return O.URI.isUri(n)?c=n:c=n.configuration,c?.scheme===b.Schemas.tmp}e.$aj="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(n){return n.id===e.$aj}function t(n,c){return!k(n,c)&&!s(n)}function o(n){return(typeof n=="string"?(0,r.$tc)(n):(0,D.$jh)(n))===e.$8i}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[53],ue([0,1,13,8,48,49,2,79,3,23,9,126,6,5,28,30]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=e.$ghc=void 0,i=Ge(i),e.$ghc=(0,$.$Ki)("dialogMainService");let y=class{constructor(g,S){this.d=g,this.e=S,this.a=new Map,this.b=new Map,this.c=new r.$Rh}pickFileFolder(g,S){return this.f({...g,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(1707,null)},S)}pickFolder(g,S){return this.f({...g,pickFolders:!0,title:(0,m.localize)(1708,null)},S)}pickFile(g,S){return this.f({...g,pickFiles:!0,title:(0,m.localize)(1709,null)},S)}pickWorkspace(g,S){const k=(0,m.localize)(1710,null),s=(0,D.$dx)((0,m.localize)(1711,null)),a=f.$9i;return this.f({...g,pickFiles:!0,title:k,filters:a,buttonLabel:s},S)}async f(g,S){const k={title:g.title,buttonLabel:g.buttonLabel,filters:g.filters,defaultPath:g.defaultPath};(typeof g.pickFiles=="boolean"||typeof g.pickFolders=="boolean")&&(k.properties=void 0,g.pickFiles&&g.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",g.pickFolders?"openDirectory":"openFile","createDirectory"]),b.$m&&k.properties.push("treatPackageAsDirectory");const s=await this.showOpenDialog(k,(S||i.default.BrowserWindow.getFocusedWindow())??void 0);if(s&&s.filePaths&&s.filePaths.length>0)return s.filePaths}g(g){if(g){let S=this.b.get(g.id);return S||(S=new r.$Rh,this.b.set(g.id,S)),S}else return this.c}showMessageBox(g,S){return this.g(S).queue(async()=>{const{options:k,buttonIndeces:s}=(0,u.$kx)(g,this.e);let a;return S?a=await i.default.dialog.showMessageBox(S,k):a=await i.default.dialog.showMessageBox(k),{response:s[a.response],checkboxChecked:a.checkboxChecked}})}async showSaveDialog(g,S){const k=this.j(g,S);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(S).queue(async()=>{let s;return S?s=await i.default.dialog.showSaveDialog(S,g):s=await i.default.dialog.showSaveDialog(g),s.filePath=this.h(s.filePath),s})}finally{(0,O.$Uc)(k)}}h(g){return g&&b.$m&&(g=(0,I.$sm)(g)),g}i(g){return g.map(S=>this.h(S))}async showOpenDialog(g,S){g.defaultPath&&(await l.Promises.exists(g.defaultPath)||(g.defaultPath=void 0));const k=this.j(g,S);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(S).queue(async()=>{let s;return S?s=await i.default.dialog.showOpenDialog(S,g):s=await i.default.dialog.showOpenDialog(g),s.filePaths=this.i(s.filePaths),s})}finally{(0,O.$Uc)(k)}}j(g,S){if(!S)return O.$Zc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",g);let k=this.a.get(S.id);k||(k=new Set,this.a.set(S.id,k));const s=(0,v.$yj)(g);if(!k.has(s))return this.d.trace("[DialogMainService]: new file dialog lock created",g),k.add(s),(0,O.$Xc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",g),k?.delete(s),k?.size===0&&this.a.delete(S.id)})}};e.$hhc=y,e.$hhc=y=ke([se(0,p.$fk),se(1,d.$yk)],y)}),define(le[247],ue([0,1,4,2,83,30]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0;class O extends r.$Zc{static{this.a=100}constructor(b,l){super(),this.f=b,this.g=l,this.b=this.B(new i.$qe),this.c=new Map,this.h(l.applicationStorage,this.b)}h(b,l){this.B(i.Event.debounce(b.onDidChangeStorage,(m,u)=>(m?m.push(u):m=[u],m),O.a)(m=>{m.length&&l.fire(this.j(m,b))}))}j(b,l){const m=new Map,u=new Set;return b.forEach($=>{const p=l.get($.key);typeof p=="string"?m.set($.key,p):u.add($.key)}),{changed:Array.from(m.entries()),deleted:Array.from(u.values())}}listen(b,l,m){switch(l){case"onDidChangeStorage":{const u=m.profile?(0,v.$hi)(m.profile):void 0;if(!u)return this.b.event;let $=this.c.get(u.id);return $||($=this.B(new i.$qe),this.h(this.g.profileStorage(u),$),this.c.set(u.id,$)),$.event}}throw new Error(`Event not found: ${l}`)}async call(b,l,m){const u=m.profile?(0,v.$hi)(m.profile):void 0,$=(0,D.$1i)(m.workspace),p=await this.m(u,$);switch(l){case"getItems":return Array.from(p.items.entries());case"updateItems":{const d=m;if(d.insert)for(const[f,y]of d.insert)p.set(f,y);d.delete?.forEach(f=>p.delete(f));break}case"optimize":return p.optimize();case"isUsed":{const d=m.payload;if(typeof d=="string")return this.g.isUsed(d)}default:throw new Error(`Call not found: ${l}`)}}async m(b,l){let m;l?m=this.g.workspaceStorage(l):b?m=this.g.profileStorage(b):m=this.g.applicationStorage;try{await m.init()}catch(u){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":b?"profile":"application"} storage due to ${u}`)}return m}}e.$uic=O}),define(le[42],ue([0,1,48,4,2,18,7,9,36,14,6,5,30,31,41,8,33,25,12]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Rl=e.ProfileResourceType=void 0,e.$Ql=k,e.$Sl=s,e.$Tl=a;var S;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(S||(e.ProfileResourceType=S={}));function k(n){const c=n;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&O.URI.isUri(c.location)&&O.URI.isUri(c.globalStorageHome)&&O.URI.isUri(c.settingsResource)&&O.URI.isUri(c.keybindingsResource)&&O.URI.isUri(c.tasksResource)&&O.URI.isUri(c.snippetsHome)&&O.URI.isUri(c.extensionsResource))}e.$Rl=(0,m.$Ki)("IUserDataProfilesService");function s(n,c){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:O.URI.revive(n.location).with({scheme:c}),globalStorageHome:O.URI.revive(n.globalStorageHome).with({scheme:c}),settingsResource:O.URI.revive(n.settingsResource).with({scheme:c}),keybindingsResource:O.URI.revive(n.keybindingsResource).with({scheme:c}),tasksResource:O.URI.revive(n.tasksResource).with({scheme:c}),snippetsHome:O.URI.revive(n.snippetsHome).with({scheme:c}),extensionsResource:O.URI.revive(n.extensionsResource).with({scheme:c}),cacheHome:O.URI.revive(n.cacheHome).with({scheme:c}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function a(n,c,h,P,w,R){return{id:n,name:c,location:h,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:R&&w?.useDefaultFlags?.globalState?R.globalStorageHome:(0,D.$lh)(h,"globalStorage"),settingsResource:R&&w?.useDefaultFlags?.settings?R.settingsResource:(0,D.$lh)(h,"settings.json"),keybindingsResource:R&&w?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,D.$lh)(h,"keybindings.json"),tasksResource:R&&w?.useDefaultFlags?.tasks?R.tasksResource:(0,D.$lh)(h,"tasks.json"),snippetsHome:R&&w?.useDefaultFlags?.snippets?R.snippetsHome:(0,D.$lh)(h,"snippets"),extensionsResource:R&&w?.useDefaultFlags?.extensions?R.extensionsResource:(0,D.$lh)(h,"extensions.json"),cacheHome:(0,D.$lh)(P,n),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let t=class extends v.$Zc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,P,w){super(),this.t=c,this.u=h,this.w=P,this.y=w,this.f=!0,this.h=this.B(new r.$qe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$qe),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$qe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$qe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new p.$Fc,workspaces:new p.$Fc,emptyWindows:new Map},this.profilesHome=(0,D.$lh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$lh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,g.$jg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}h.push(a((0,D.$ih)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},c))}}catch(R){this.y.error(R)}const P=new p.$Fc,w=new Map;if(h.length)try{const R=this.Q();if(R.workspaces)for(const[T,A]of Object.entries(R.workspaces)){const L=O.URI.parse(T),M=h.find(V=>V.id===A);M&&P.set(L,M)}if(R.emptyWindows)for(const[T,A]of Object.entries(R.emptyWindows)){const L=h.find(M=>M.id===A);L&&w.set(T,L)}}catch(R){this.y.error(R)}this.z={profiles:h,workspaces:P,emptyWindows:w}}return this.z}D(){const c=a("__default__profile__",(0,I.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",P=new RegExp(`${(0,E.$mf)(h)}\\s(\\d+)`);let w=0;for(const T of this.profiles){const A=P.exec(T.name),L=A?parseInt(A[1]):0;w=L>w?L:w}const R=`${h} ${w+1}`;return this.createProfile((0,i.$yj)((0,y.$7g)()).toString(16),R,{transient:!0},c)}async createNamedProfile(c,h,P){return this.createProfile((0,i.$yj)((0,y.$7g)()).toString(16),c,h,P)}async createProfile(c,h,P,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(c,h,P);return w&&await this.setProfileForWorkspace(w,R),R}async F(c,h,P){if(!(0,g.$jg)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(h);return w||(w=(async()=>{try{if(this.profiles.find(L=>L.name===h||L.id===c))throw new Error(`Profile with ${h} name already exists`);const T=a(c,h,(0,D.$lh)(this.profilesHome,c),this.g,P,this.defaultProfile);await this.u.createFolder(T.location);const A=[];return this.j.fire({profile:T,join(L){A.push(L)}}),await f.Promises.settled(A),this.I([T],[],[]),T}finally{this.r.delete(h)}})(),this.r.set(h,w)),w}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let P=this.profiles.find(w=>w.id===c.id);if(!P)throw new Error(`Profile '${c.name}' does not exist`);return P=a(P.id,h.name??P.name,P.location,this.g,{shortName:h.shortName??P.shortName,icon:h.icon===null?void 0:h.icon??P.icon,transient:h.transient??P.isTransient,useDefaultFlags:h.useDefaultFlags??P.useDefaultFlags},this.defaultProfile),this.I([],[],[P]),P}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(w=>w.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const P=[];this.m.fire({profile:h,join(w){P.push(w)}});try{await Promise.allSettled(P)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(w){(0,l.$wl)(w)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(w)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const P=this.profiles.find(w=>w.id===h.id);if(!P)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,P)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(P=>!this.w.extUri.isEqual(P.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c),P=O.URI.isUri(h)?this.C.workspaces.get(h):this.C.emptyWindows.get(h);return P||((0,$.$Ui)(c)?this.s.folders.get(c.uri):(0,$.$Zi)(c)?this.s.workspaces.get(c.configPath):this.s.emptyWindows.get(c.id))}G(c){return(0,$.$Ui)(c)?c.uri:(0,$.$Zi)(c)?c.configPath:c.id}H(c){return!!([...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.folders.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,P){const w=[...this.profiles,...c],R=[],T=this.s.profiles;this.s.profiles=[];for(let A of w){if(A.isDefault||h.some(M=>A.id===M.id))continue;A=P.find(M=>A.id===M.id)??A;const L=T.find(M=>A.id===M.id);if(A.isTransient)this.s.profiles.push(A);else{if(L){for(const[M,V]of this.s.emptyWindows.entries())if(A.id===V.id){this.L({id:M},A);break}for(const[M,V]of this.s.workspaces.entries())if(A.id===V.id){this.L({id:"",configPath:M},A);break}for(const[M,V]of this.s.folders.entries())if(A.id===V.id){this.L({id:"",uri:M},A);break}}R.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(c,h,P)}J(c,h,P){this.h.fire({added:c,removed:h,updated:P,all:this.profiles})}L(c,h,P){if(P=h?.isTransient?!0:P,P)(0,$.$Ui)(c)?(this.s.folders.delete(c.uri),h&&this.s.folders.set(c.uri,h)):(0,$.$Zi)(c)?(this.s.workspaces.delete(c.configPath),h&&this.s.workspaces.set(c.configPath,h)):(this.s.emptyWindows.delete(c.id),h&&this.s.emptyWindows.set(c.id,h));else{this.L(c,void 0,!0);const w=this.G(c);O.URI.isUri(w)?(this.C.workspaces.delete(w),h&&this.C.workspaces.set(w,h)):(this.C.emptyWindows.delete(w),h&&this.C.emptyWindows.set(w,h)),this.M()}}M(){const c={};for(const[P,w]of this.C.workspaces.entries())c[P.toString()]=w.id;const h={};for(const[P,w]of this.C.emptyWindows.entries())h[P.toString()]=w.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},P=this.D();if(c.workspaces)for(const[R,T]of Object.entries(c.workspaces)){const A=O.URI.parse(T);h[R]=this.w.extUri.isEqual(A,P.location)?P.id:this.w.extUri.basename(A)}const w={};if(c.emptyWindows)for(const[R,T]of Object.entries(c.emptyWindows)){const A=O.URI.parse(T);w[R]=this.w.extUri.isEqual(A,P.location)?P.id:this.w.extUri.basename(A)}return{workspaces:h,emptyWindows:w}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Ul=t,e.$Ul=t=ke([se(0,b.$Ri),se(1,l.$fl),se(2,d.$Pl),se(3,u.$fk)],t);class o extends t{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Vl=o}),define(le[88],ue([0,1,8,17,2,4,31,7,129,132,14,6,5,42,41,12,15,24]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=e.$Qq=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(t){t.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",t.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class S extends Error{constructor(o,n){super(o),this.code=n}}e.$Qq=S,e.$Rq=(0,u.$Ki)("IExtensionsProfileScannerService");let k=class extends v.$Zc{constructor(o,n,c,h,P,w){super(),this.j=o,this.m=n,this.n=c,this.r=h,this.s=P,this.t=w,this.b=this.B(new D.$qe),this.onAddExtensions=this.b.event,this.c=this.B(new D.$qe),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$qe),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$qe),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Fc}scanProfileExtensions(o,n){return this.u(o,void 0,n)}async addExtensionsToProfile(o,n,c){const h=[],P=[];try{return await this.u(n,w=>{const R=[];if(c)R.push(...w);else for(const T of w)o.some(([A])=>(0,l.$Sp)(A.identifier,T.identifier)&&A.manifest.version!==T.version)?h.push(T):R.push(T);for(const[T,A]of o){const L=R.findIndex(V=>(0,l.$Sp)(V.identifier,T.identifier)&&V.version===T.manifest.version),M={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:A};L===-1?(P.push(M),R.push(M)):R.splice(L,1,M)}return P.length&&this.b.fire({extensions:P,profileLocation:n}),h.length&&this.f.fire({extensions:h,profileLocation:n}),R}),P.length&&this.c.fire({extensions:P,profileLocation:n}),h.length&&this.g.fire({extensions:h,profileLocation:n}),P}catch(w){throw P.length&&this.c.fire({extensions:P,error:w,profileLocation:n}),h.length&&this.g.fire({extensions:h,error:w,profileLocation:n}),w}}async updateMetadata(o,n){const c=[];return await this.u(n,h=>{const P=[];for(const w of h){const R=o.find(([T])=>(0,l.$Sp)(T.identifier,w.identifier)&&T.manifest.version===w.version);R&&(w.metadata={...w.metadata,...R[1]},c.push(w)),P.push(w)}return P}),c}async removeExtensionFromProfile(o,n){const c=[];try{await this.u(n,h=>{const P=[];for(const w of h)(0,l.$Sp)(w.identifier,o.identifier)?c.push(w):P.push(w);return c.length&&this.f.fire({extensions:c,profileLocation:n}),P}),c.length&&this.g.fire({extensions:c,profileLocation:n})}catch(h){throw c.length&&this.g.fire({extensions:c,error:h,profileLocation:n}),h}}async u(o,n,c){return this.F(o).queue(async()=>{let h=[],P;try{const w=await this.m.readFile(o);P=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,m.$wl)(w)!==m.FileOperationResult.FILE_NOT_FOUND)throw w;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(P=await this.D()),!P&&c?.bailOutWhenFileNotFound)throw new S((0,y.$bb)(w),g.ERROR_PROFILE_NOT_FOUND)}if(P){Array.isArray(P)||this.w(o);let w=!1;for(const R of P){s(R)||this.w(o);let T;if((0,f.$jg)(R.relativeLocation)&&R.relativeLocation)T=this.z(R.relativeLocation);else if((0,f.$jg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{T=I.URI.revive(R.location);const A=this.y(T);A&&(w=!0,R.relativeLocation=A)}(0,f.$qg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(w=!0,R.metadata.hasPreReleaseVersion=!0),h.push({identifier:R.identifier,location:T,version:R.version,metadata:R.metadata})}w&&await this.m.writeFile(o,r.$Se.fromString(JSON.stringify(P)))}if(n){h=n(h);const w=h.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(o,r.$Se.fromString(JSON.stringify(w)))}return h})}w(o){const n=new S(`Invalid extensions content in ${o.toString()}`,g.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let c;try{c=(await this.m.readFile(o)).value.toString()}catch(P){if((0,m.$wl)(P)===m.FileOperationResult.FILE_NOT_FOUND)return;throw P}this.t.info("Migrating extensions from old default profile location",o.toString());let h;try{const P=JSON.parse(c);Array.isArray(P)&&P.every(w=>s(w))?h=P:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",P)}catch(P){this.t.error(P)}if(h)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Se.fromString(JSON.stringify(h)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(P){if((0,m.$wl)(P)===m.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw P}try{await this.m.del(o)}catch(P){(0,m.$wl)(P)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(P)}try{await this.m.del(n)}catch(P){(0,m.$wl)(P)!==m.FileOperationResult.FILE_NOT_FOUND&&this.t.error(P)}return h})()),this.C}F(o){let n=this.h.get(o);return n||(n=new i.$Rh,this.h.set(o,n)),n}};e.$Sq=k,e.$Sq=k=ke([se(1,m.$fl),se(2,p.$Rl),se(3,d.$Pl),se(4,E.$em),se(5,$.$fk)],k);function s(t){return(0,f.$lg)(t)&&(0,b.$qp)(t.identifier)&&(a(t.location)||(0,f.$jg)(t.location)&&t.location)&&((0,f.$qg)(t.relativeLocation)||(0,f.$jg)(t.relativeLocation))&&t.version&&(0,f.$jg)(t.version)}function a(t){return t?(0,f.$jg)(t.path)&&(0,f.$jg)(t.scheme):!1}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[136],ue([0,1,21,8,37,17,15,43,158,2,11,10,3,18,214,81,12,7,9,36,132,87,213,14,6,5,28,4,83,88,42,41,175]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k,s,a,t,o,n,c,h,P,w,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Xq=e.$Wq=e.$Vq=e.Translations=void 0,e.$Yq=de,v=Ie(v),u=Ie(u),$=Ie($),d=Ie(d),f=Ge(f);var L;(function(ee){function W(Z,C){if(Z===C)return!0;const B=Object.keys(Z),F=new Set;for(const z of Object.keys(C))F.add(z);if(B.length!==F.size)return!1;for(const z of B){if(Z[z]!==C[z])return!1;F.delete(z)}return F.size===0}ee.equals=W})(L||(e.Translations=L={})),e.$Vq=(0,o.$Ki)("IExtensionsScannerService");let M=class extends l.$Zc{constructor(W,Z,C,B,F,z,ie,x,ce,oe,te,j){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=Z,this.r=C,this.s=B,this.t=F,this.u=z,this.w=ie,this.y=x,this.z=ce,this.C=oe,this.D=te,this.F=j,this.g=this.B(new h.$qe),this.onDidChangeCache=this.g.event,this.h=(0,p.$lh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Y,this.s,this.h)),this.m=this.B(this.F.createInstance(Y,this.s,this.h)),this.n=this.B(this.F.createInstance(q,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(s.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(s.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,k.$4p)(this.w,this.y)),this.G}async scanAllExtensions(W,Z,C){const[B,F]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(Z)]),z=C?await this.scanExtensionsUnderDevelopment(W,[...B,...F]):[];return this.L(B,F,z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const Z=[];Z.push(this.M(!!W.useCache,W.language)),Z.push(this.N(W.language,!!W.checkControlFile));const[C,B]=await Promise.all(Z);return this.J([...C,...B],s.ExtensionType.System,W,!1)}async scanUserExtensions(W){const Z=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const C=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(Z,!!W.profileLocation,s.ExtensionType.User,!W.includeUninstalled,W.language,!0,C,W.productVersion??this.R()),F=W.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let z;try{z=await F.scanExtensions(B)}catch(ie){if(ie instanceof w.$Qq&&ie.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),z=await F.scanExtensions(B);else throw ie}return z=await this.J(z,s.ExtensionType.User,W,!0),this.y.trace("Scanned user extensions:",z.length),z}async scanExtensionsUnderDevelopment(W,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const C=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===m.Schemas.file).map(async B=>{const F=await this.P(B,!1,s.ExtensionType.User,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(F)).map(ie=>(ie.type=Z.find(x=>(0,k.$Sp)(x.identifier,ie.identifier))?.type??ie.type,this.n.validate(ie,F)))}))).flat();return this.J(C,"development",W,!0)}return[]}async scanExistingExtension(W,Z,C){const B=await this.P(W,!1,Z,!0,C.language,!0,void 0,C.productVersion??this.R()),F=await this.n.scanExtension(B);return!F||!C.includeInvalid&&!F.isValid?null:F}async scanOneOrMultipleExtensions(W,Z,C){const B=await this.P(W,!1,Z,!0,C.language,!0,void 0,C.productVersion??this.R()),F=await this.n.scanOneOrMultipleExtensions(B);return this.J(F,Z,C,!0)}async scanMultipleExtensions(W,Z,C){const B=[];return await Promise.all(W.map(async F=>{const z=await this.scanOneOrMultipleExtensions(F,Z,C);B.push(...z)})),this.J(B,Z,C,!0)}async scanMetadata(W){const Z=(0,p.$lh)(W,"package.json"),C=(await this.w.readFile(Z)).value.toString();return JSON.parse(C).__metadata}async updateMetadata(W,Z){const C=(0,p.$lh)(W,"package.json"),B=(await this.w.readFile(C)).value.toString(),F=JSON.parse(B);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,F.__metadata={...F.__metadata,...Z},await this.w.writeFile((0,p.$lh)(W,"package.json"),D.$Se.fromString(JSON.stringify(F,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof w.$Qq&&W.code===w.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Se.fromString(JSON.stringify([])))}catch(Z){(0,t.$wl)(Z)!==t.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$bb)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,Z,C,B){return C.includeAllVersions||(W=this.L(Z===s.ExtensionType.System?W:void 0,Z===s.ExtensionType.User?W:void 0,Z==="development"?W:void 0,await this.getTargetPlatform(),B)),C.includeInvalid||(W=W.filter(F=>F.isValid)),W.sort((F,z)=>{const ie=u.$sc(F.location.fsPath),x=u.$sc(z.location.fsPath);return ie<x?-1:ie>x?1:0})}L(W,Z,C,B,F){const z=(x,ce,oe)=>{if(x.isValid&&!ce.isValid)return!1;if(x.isValid===ce.isValid){if(F&&d.gt(x.manifest.version,ce.manifest.version))return this.y.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(d.eq(x.manifest.version,ce.manifest.version)){if(x.type===s.ExtensionType.System)return this.y.debug(`Skipping extension ${ce.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===B)return this.y.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return oe?this.y.warn(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`):this.y.debug(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`),!0},ie=new s.$zn;return W?.forEach(x=>{const ce=ie.get(x.identifier.id);(!ce||z(ce,x,!1))&&ie.set(x.identifier.id,x)}),Z?.forEach(x=>{const ce=ie.get(x.identifier.id);if(!ce&&W&&x.type===s.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!ce||z(ce,x,!1))&&ie.set(x.identifier.id,x)}),C?.forEach(x=>{const ce=ie.get(x.identifier.id);(!ce||z(ce,x,!0))&&ie.set(x.identifier.id,x),ie.set(x.identifier.id,x)}),[...ie.values()]}async M(W,Z){this.y.trace("Started scanning system extensions");const C=await this.P(this.systemExtensionsLocation,!1,s.ExtensionType.System,!0,Z,!0,void 0,this.R()),F=await(W&&!C.devMode?this.j:this.n).scanExtensions(C);return this.y.trace("Scanned system extensions:",F.length),F}async N(W,Z){const C=this.z.isBuilt?[]:this.C.builtInExtensions;if(!C?.length)return[];this.y.trace("Started scanning dev system extensions");const B=Z?await this.O():{},F=[],z=E.URI.file(u.$mc(u.$oc(m.$5g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of C){const ce=B[x.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":F.push((0,p.$lh)(z,x.name));break;default:F.push(E.URI.file(ce));break}}const ie=await Promise.all(F.map(async x=>this.n.scanExtension(await this.P(x,!1,s.ExtensionType.System,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ie.length),(0,i.$Lb)(ie)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,Z,C,B,F,z,ie,x){const ce=await this.f(F??$.$z),oe=await this.Q(W),te=Z&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,j=te?await this.Q(te):void 0;return new V(W,oe,te,j,Z,ie,C,B,z,x.version,x.date,this.C.commit,!this.z.isBuilt,F,ce)}async Q(W){try{const Z=await this.w.stat(W);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Wq=M,e.$Wq=M=ke([se(4,R.$Rl),se(5,w.$Rq),se(6,t.$fl),se(7,n.$fk),se(8,S.$Ri),se(9,c.$yk),se(10,T.$Pl),se(11,o.$Ji)],M);class V{constructor(W,Z,C,B,F,z,ie,x,ce,oe,te,j,X,U,N){this.location=W,this.mtime=Z,this.applicationExtensionslocation=C,this.applicationExtensionslocationMtime=B,this.profile=F,this.profileScanOptions=z,this.type=ie,this.excludeObsolete=x,this.validate=ce,this.productVersion=oe,this.productDate=te,this.productCommit=j,this.devMode=X,this.language=U,this.translations=N}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,Z){return(0,p.$eh)(W.location,Z.location)&&W.mtime===Z.mtime&&(0,p.$eh)(W.applicationExtensionslocation,Z.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&W.profile===Z.profile&&v.$oo(W.profileScanOptions,Z.profileScanOptions)&&W.type===Z.type&&W.excludeObsolete===Z.excludeObsolete&&W.validate===Z.validate&&W.productVersion===Z.productVersion&&W.productDate===Z.productDate&&W.productCommit===Z.productCommit&&W.devMode===Z.devMode&&W.language===Z.language&&L.equals(W.translations,Z.translations)}}e.$Xq=V;let q=class extends l.$Zc{constructor(W,Z,C,B,F,z,ie){super(),this.g=W,this.h=Z,this.j=C,this.m=B,this.n=z,this.r=ie,this.f=F.extensionsEnabledWithApiProposalVersion?.map(x=>x.toLowerCase())??[]}async scanExtensions(W){const Z=W.profile?await this.t(W):await this.s(W);let C={};if(W.excludeObsolete&&W.type===s.ExtensionType.User)try{const B=(await this.m.readFile(this.g)).value.toString();C=JSON.parse(B)}catch{}return(0,y.$wg)(C)?Z:Z.filter(B=>!C[k.$Tp.create(B).toString()])}async s(W){const Z=await this.m.resolve(W.location);if(!Z.children?.length)return[];const C=await Promise.all(Z.children.map(async B=>{if(!B.isDirectory||W.type===s.ExtensionType.User&&(0,p.$ih)(B.resource).indexOf(".")===0)return null;const F=new V(B.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(F)}));return(0,i.$Lb)(C).sort((B,F)=>B.location.path<F.location.path?-1:1)}async t(W){let Z=await this.u(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.j.extUri.isEqual(W.location,W.applicationExtensionslocation)){Z=Z.filter(B=>!B.metadata?.isApplicationScoped);const C=await this.u(W.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,W);Z.push(...C)}return Z}async u(W,Z,C){const B=await this.h.scanProfileExtensions(W,C.profileScanOptions);if(!B.length)return[];const F=await Promise.all(B.map(async z=>{if(Z(z)){const ie=new V(z.location,C.mtime,C.applicationExtensionslocation,C.applicationExtensionslocationMtime,C.profile,C.profileScanOptions,C.type,C.excludeObsolete,C.validate,C.productVersion,C.productDate,C.productCommit,C.devMode,C.language,C.translations);return this.scanExtension(ie,z.metadata)}return null}));return(0,i.$Lb)(F)}async scanOneOrMultipleExtensions(W){try{if(await this.m.exists((0,p.$lh)(W.location,"package.json"))){const Z=await this.scanExtension(W);return Z?[Z]:[]}else return await this.scanExtensions(W)}catch(Z){return this.r.error(`Error scanning extensions at ${W.location.path}:`,(0,O.$bb)(Z)),[]}}async scanExtension(W,Z){try{let C=await this.w(W.location);if(C){C.publisher||(C.publisher=s.$tn),Z=Z??C.__metadata,delete C.__metadata;const B=(0,k.$Xp)(C.publisher,C.name),F=Z?.id?{id:B,uuid:Z.id}:{id:B},z=Z?.isSystem?s.ExtensionType.System:W.type,ie=z===s.ExtensionType.System||!!Z?.isBuiltin;C=await this.y(W.location,C,V.createNlsConfiguration(W));let x={type:z,identifier:F,manifest:C,location:W.location,isBuiltin:ie,targetPlatform:Z?.targetPlatform??s.TargetPlatform.UNDEFINED,publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return W.validate&&(x=this.validate(x,W)),C.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(B.toLowerCase()))&&(C.originalEnabledApiProposals=C.enabledApiProposals,C.enabledApiProposals=(0,s.$Fn)([...C.enabledApiProposals])),x}}catch(C){W.type!==s.ExtensionType.System&&this.r.error(C)}return null}validate(W,Z){let C=!0;const B=this.n.isBuilt&&this.f.includes(W.identifier.id.toLowerCase()),F=(0,a.$0p)(Z.productVersion,Z.productDate,Z.location,W.manifest,W.isBuiltin,B);for(const[z,ie]of F)z===f.default.Error&&(C=!1,this.r.error(this.F(Z.location,ie)));return W.isValid=C,W.validations=F,W}async w(W){const Z=(0,p.$lh)(W,"package.json");let C;try{C=(await this.m.readFile(Z)).value.toString()}catch(F){return(0,t.$wl)(F)!==t.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(W,(0,g.localize)(1815,null,Z.path,F.message))),null}let B;try{B=JSON.parse(C)}catch{const z=[];(0,I.$5n)(C,z);for(const ie of z)this.r.error(this.F(W,(0,g.localize)(1816,null,Z.path,ie.offset,ie.length,(0,b.$Tq)(ie.error))));return null}return(0,I.$ao)(B)!=="object"?(this.r.error(this.F(W,(0,g.localize)(1817,null,Z.path))),null):B}async y(W,Z,C){const B=await this.z(W,Z,C);if(B)try{const F=[],z=await this.C(B.default,F);if(F.length>0)return F.forEach(x=>{this.r.error(this.F(W,(0,g.localize)(1818,null,B.default?.path,(0,b.$Tq)(x.error))))}),Z;if((0,I.$ao)(B)!=="object")return this.r.error(this.F(W,(0,g.localize)(1819,null,B.default?.path))),Z;const ie=B.values||Object.create(null);return(0,A.$Uq)(this.r,Z,ie,z)}catch{}return Z}async z(W,Z,C){const B=(0,p.$lh)(W,"package.nls.json"),F=(ce,oe)=>{oe.forEach(te=>{this.r.error(this.F(W,(0,g.localize)(1820,null,ce?.path,(0,b.$Tq)(te.error))))})},z=ce=>{this.r.error(this.F(W,(0,g.localize)(1821,null,ce?.path)))},ie=`${Z.publisher}.${Z.name}`,x=C.translations[ie];if(x)try{const ce=E.URI.file(x),oe=(await this.m.readFile(ce)).value.toString(),te=[],j=(0,I.$5n)(oe,te);return te.length>0?(F(ce,te),{values:void 0,default:B}):(0,I.$ao)(j)!=="object"?(z(ce),{values:void 0,default:B}):{values:j.contents?j.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.m.exists(B))return;let oe;try{oe=await this.D(W,C)}catch{return}if(!oe.localized)return{values:void 0,default:oe.original};try{const te=(await this.m.readFile(oe.localized)).value.toString(),j=[],X=(0,I.$5n)(te,j);return j.length>0?(F(oe.localized,j),{values:void 0,default:oe.original}):(0,I.$ao)(X)!=="object"?(z(oe.localized),{values:void 0,default:oe.original}):{values:X,default:oe.original}}catch{return{values:void 0,default:oe.original}}}}async C(W,Z){if(W)try{const C=(await this.m.readFile(W)).value.toString();return(0,I.$5n)(C,Z)}catch{}}D(W,Z){return new Promise((C,B)=>{const F=z=>{const ie=(0,p.$lh)(W,`package.nls.${z}.json`);this.m.exists(ie).then(x=>{x&&C({localized:ie,original:(0,p.$lh)(W,"package.nls.json")});const ce=z.lastIndexOf("-");ce===-1?C({localized:(0,p.$lh)(W,"package.nls.json"),original:null}):(z=z.substring(0,ce),F(z))})};if(Z.devMode||Z.pseudo||!Z.language)return C({localized:(0,p.$lh)(W,"package.nls.json"),original:null});F(Z.language)})}F(W,Z){return`[${W.path}]: ${Z}`}};q=ke([se(1,w.$Rq),se(2,T.$Pl),se(3,t.$fl),se(4,c.$yk),se(5,S.$Ri),se(6,n.$fk)],q);let Y=class extends q{constructor(W,Z,C,B,F,z,ie,x,ce){super(Z,B,F,z,ie,x,ce),this.J=W,this.L=C,this.H=this.B(new r.$Ih(3e3)),this.I=this.B(new h.$qe),this.onDidChangeCache=this.I.event}async scanExtensions(W){const Z=this.P(W),C=await this.M(Z);if(this.G=W,C&&C.input&&V.equals(C.input,this.G))return this.r.debug("Using cached extensions scan result",W.type===s.ExtensionType.System?"system":"user",W.location.toString()),this.H.trigger(()=>this.O()),C.result.map(F=>(F.location=E.URI.revive(F.location),F));const B=await super.scanExtensions(W);return await this.N(Z,{input:W,result:B}),B}async M(W){try{const Z=await this.m.readFile(W),C=JSON.parse(Z.value.toString());return{result:C.result,input:(0,P.$hi)(C.input)}}catch(Z){this.r.debug("Error while reading the extension cache file:",W.path,(0,O.$bb)(Z))}return null}async N(W,Z){try{await this.m.writeFile(W,D.$Se.fromString(JSON.stringify(Z)))}catch(C){this.r.debug("Error while writing the extension cache file:",W.path,(0,O.$bb)(C))}}async O(){if(!this.G)return;const W=this.P(this.G),Z=await this.M(W);if(!Z)return;const C=Z.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!v.$oo(B,C))try{this.r.info("Invalidating Cache",C,B),await this.m.del(W),this.I.fire()}catch(F){this.r.error(F)}}P(W){const Z=this.Q(W);return this.j.extUri.joinPath(Z.cacheHome,W.type===s.ExtensionType.System?s.$sn:s.$rn)}Q(W){return W.type===s.ExtensionType.System?this.L.defaultProfile:W.profile?this.j.extUri.isEqual(W.location,this.J.extensionsResource)?this.J:this.L.profiles.find(Z=>this.j.extUri.isEqual(W.location,Z.extensionsResource))??this.J:this.L.defaultProfile}};Y=ke([se(2,R.$Rl),se(3,w.$Rq),se(4,T.$Pl),se(5,t.$fl),se(6,c.$yk),se(7,S.$Ri),se(8,n.$fk)],Y);function de(ee,W){const Z=(0,k.$Vp)(ee.manifest.publisher,ee.manifest.name);return{id:Z,identifier:new s.$xn(Z),isBuiltin:ee.type===s.ExtensionType.System,isUserBuiltin:ee.type===s.ExtensionType.User&&ee.isBuiltin,isUnderDevelopment:W,extensionLocation:ee.location,uuid:ee.identifier.uuid,targetPlatform:ee.targetPlatform,publisherDisplayName:ee.publisherDisplayName,...ee.manifest}}class re extends M{constructor(W,Z,C,B,F,z,ie,x,ce,oe,te,j){super(W,Z,(0,p.$lh)(C,".vscode-oss-dev","extensions","control.json"),B,F,z,ie,x,ce,oe,te,j),this.S=(async()=>{if($.$C)try{const X=await this.w.readFile(E.URI.file($.$C));return JSON.parse(X.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$Zq=re}),define(le[248],ue([0,1,5,42,41,24,88,14,36,7]),function(G,e,i,r,v,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_R=void 0;let m=class extends O.$Sq{constructor($,p,d,f,y,E){super(l.URI.file($.extensionsPath),p,d,f,y,E)}};e.$_R=m,e.$_R=m=ke([se(0,b.$Si),se(1,I.$fl),se(2,r.$Rl),se(3,v.$Pl),se(4,D.$em),se(5,i.$fk)],m)}),define(le[249],ue([0,1,7,36,88,136,14,6,5,28,41,42]),function(G,e,i,r,v,D,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;let $=class extends D.$Zq{constructor(d,f,y,E,g,S,k,s){super(i.URI.file(g.builtinExtensionsPath),i.URI.file(g.extensionsPath),g.userHome,d.defaultProfile,d,f,y,E,g,S,k,s)}};e.$Uic=$,e.$Uic=$=ke([se(0,u.$Rl),se(1,v.$Rq),se(2,O.$fl),se(3,b.$fk),se(4,r.$Si),se(5,l.$yk),se(6,m.$Pl),se(7,I.$Ji)],$)}),define(le[250],ue([0,1,13,2,11,10,3,61,7,33,35,36,5,42]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=void 0;let d=class extends r.$Zc{constructor(y,E,g){super(),this.c=y,this.f=g,this.a=I.$Qi.forPaths(!O.$n),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(y.appRoot),this.addValidFileRoot(y.extensionsPath),this.addValidFileRoot(E.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath),this.addValidFileRoot(y.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:y}=i.session;y.protocol.registerFileProtocol(v.Schemas.vscodeFileResource,(E,g)=>this.j(E,g)),y.protocol.interceptFileProtocol(v.Schemas.file,(E,g)=>this.h(E,g)),this.B((0,r.$Xc)(()=>{y.protocol.unregisterProtocol(v.Schemas.vscodeFileResource),y.protocol.uninterceptProtocol(v.Schemas.file)}))}addValidFileRoot(y){const E=(0,D.$mc)(y);return this.a.get(E)?r.$Zc.None:(this.a.set(E,!0),(0,r.$Xc)(()=>this.a.delete(E)))}h(y,E){const g=b.URI.parse(y.url);return this.f.error(`Refused to load resource ${g.fsPath} from ${v.Schemas.file}: protocol (original URL: ${y.url})`),E({error:-3})}j(y,E){const g=this.m(y);let S;if(this.c.crossOriginIsolated){const k=(0,D.$sc)(g);k==="workbench.html"||k==="workbench-dev.html"||k==="workbench.esm.html"||k==="workbench-dev.esm.html"?S=v.COI.CoopAndCoep:S=v.COI.getHeadersFromQuery(y.url)}return this.a.findSubstr(g)?E({path:g,headers:S}):this.b.has((0,D.$tc)(g).toLowerCase())?E({path:g}):(this.f.error(`${v.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${v.Schemas.vscodeFileResource}: protocol (original URL: ${y.url})`),E({error:-3}))}m(y){const E=b.URI.parse(y.url),g=v.$5g.uriToFileUri(E);return(0,D.$mc)(g.fsPath)}createIPCObjectUrl(){let y;const E=b.URI.from({scheme:"vscode",path:(0,l.$7g)()}),g=E.toString(),S=async()=>y;return m.$pY.handle(g,S),this.f.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:E,update:k=>y=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${g}.`),m.$pY.removeHandler(g)}}}};e.$cjc=d,e.$cjc=d=ke([se(0,u.$Si),se(1,p.$Rl),se(2,$.$fk)],d)}),define(le[63],ue([0,1,8,4,2,71,12,123,6,42]),function(G,e,i,r,v,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$qq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$oq=e.$nq=e.$mq=void 0,e.$pq=p,e.$rq=f,e.$tq=E,e.$mq="__$__isNewStorageMarker",e.$nq="__$__targetStorageMarker",e.$oq=(0,b.$Ki)("storageService");var m;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var u;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(u||(e.StorageScope=u={}));var $;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function p(g){const S=g.get(e.$nq);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}class d extends v.$Zc{static{this.a=60*1e3}constructor(S={flushInterval:d.a}){super(),this.m=S,this.b=this.B(new r.$te),this.c=this.B(new r.$te),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$qe),this.onWillSaveState=this.f.event,this.h=this.B(new i.$Wh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new v.$1c),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(S,k,s){return r.Event.filter(this.b.event,a=>a.scope===S&&(k===void 0||a.key===k),s)}n(){this.j.value=(0,i.$1h)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,v.$Uc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(S,k){const{key:s,external:a}=k;if(s===e.$nq){switch(S){case u.APPLICATION:this.H=void 0;break;case u.PROFILE:this.F=void 0;break;case u.WORKSPACE:this.C=void 0;break}this.c.fire({scope:S})}else this.b.fire({scope:S,key:s,target:this.J(S)[s],external:a})}w(S){this.f.fire({reason:S})}get(S,k,s){return this.P(k)?.get(S,s)}getBoolean(S,k,s){return this.P(k)?.getBoolean(S,s)}getNumber(S,k,s){return this.P(k)?.getNumber(S,s)}getObject(S,k,s){return this.P(k)?.getObject(S,s)}storeAll(S,k){this.y(()=>{for(const s of S)this.store(s.key,s.value,s.scope,s.target,k)})}store(S,k,s,a,t=!1){if((0,O.$sg)(k)){this.remove(S,s,t);return}this.y(()=>{this.z(S,s,a),this.P(s)?.set(S,k,t)})}remove(S,k,s=!1){this.y(()=>{this.z(S,k,void 0),this.P(k)?.delete(S,s)})}y(S){this.b.pause(),this.c.pause();try{S()}finally{this.b.resume(),this.c.resume()}}keys(S,k){const s=[],a=this.J(S);for(const t of Object.keys(a))a[t]===k&&s.push(t);return s}z(S,k,s,a=!1){const t=this.J(k);typeof s=="number"?t[S]!==s&&(t[S]=s,this.P(k)?.set(e.$nq,JSON.stringify(t),a)):typeof t[S]=="number"&&(delete t[S],this.P(k)?.set(e.$nq,JSON.stringify(t),a))}get D(){return this.C||(this.C=this.L(u.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(u.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(u.APPLICATION)),this.H}J(S){switch(S){case u.APPLICATION:return this.I;case u.PROFILE:return this.G;default:return this.D}}L(S){const k=this.P(S);return k?p(k):Object.create(null)}isNew(S){return this.getBoolean(e.$mq,S)===!0}async flush(S=m.NONE){this.f.fire({reason:S});const k=this.P(u.APPLICATION),s=this.P(u.PROFILE),a=this.P(u.WORKSPACE);switch(S){case m.NONE:await i.Promises.settled([k?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await i.Promises.settled([k?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const S=this.P(u.APPLICATION)?.items??new Map,k=this.P(u.PROFILE)?.items??new Map,s=this.P(u.WORKSPACE)?.items??new Map;return E(S,k,s,this.Q(u.APPLICATION)??"",this.Q(u.PROFILE)??"",this.Q(u.WORKSPACE)??"")}async optimize(S){return await this.flush(),this.P(S)?.optimize()}async switch(S,k){return this.w(m.NONE),(0,l.$Ql)(S)?this.R(S,k):this.S(S,k)}M(S,k){return!(S.id===k.id||f(k)&&f(S))}N(S,k,s){this.y(()=>{const a=new Set;for(const[t,o]of S)a.add(t),k.get(t)!==o&&this.u(s,{key:t,external:!0});for(const[t]of k.items)a.has(t)||this.u(s,{key:t,external:!0})})}}e.$qq=d;function f(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class y extends d{constructor(){super(),this.U=this.B(new I.$kq(new I.$lq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$kq(new I.$lq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$kq(new I.$lq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(S=>this.u(u.WORKSPACE,S))),this.B(this.W.onDidChangeStorage(S=>this.u(u.PROFILE,S))),this.B(this.U.onDidChangeStorage(S=>this.u(u.APPLICATION,S)))}P(S){switch(S){case u.APPLICATION:return this.U;case u.PROFILE:return this.W;default:return this.X}}Q(S){switch(S){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(S){return!1}}e.$sq=y;async function E(g,S,k,s,a,t){const o=L=>{try{return JSON.parse(L)}catch{return L}},n=new Map,c=new Map;g.forEach((L,M)=>{n.set(M,L),c.set(M,o(L))});const h=new Map,P=new Map;S.forEach((L,M)=>{h.set(M,L),P.set(M,o(L))});const w=new Map,R=new Map;k.forEach((L,M)=>{w.set(M,L),R.set(M,o(L))}),console.group(s!==a?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const T=[];if(n.forEach((L,M)=>{T.push({key:M,value:L})}),console.table(T),console.groupEnd(),console.log(c),s!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const L=[];h.forEach((M,V)=>{L.push({key:V,value:M})}),console.table(L),console.groupEnd(),console.log(P)}console.group(`Storage: Workspace (path: ${t})`);const A=[];w.forEach((L,M)=>{A.push({key:M,value:L})}),console.table(A),console.groupEnd(),console.log(R)}}),define(le[251],ue([0,1,17,33,63]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=D;async function D(O,I,b){let l=b&&b.get("storage.serviceMachineId",v.StorageScope.APPLICATION)||null;if(l)return l;try{const u=(await I.readFile(O.serviceMachineIdResource)).value.toString();l=(0,r.$6g)(u)?u:null}catch{l=null}if(!l){l=(0,r.$7g)();try{await I.writeFile(O.serviceMachineIdResource,i.$Se.fromString(l))}catch{}}return b?.store("storage.serviceMachineId",l,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),l}}),define(le[252],ue([0,1,251,24,57]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=D;async function D(O,I,b,l,m,u,$){const p={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${I.nameShort})`};if((0,v.$Kp)(I,b)&&(0,v.$Mp)(l)===r.TelemetryLevel.USAGE){const d=await(0,i.$uq)(b,m,u);p["X-Market-User-Id"]=d,p["VSCode-SessionId"]=$.machineId||d}return p}}),define(le[253],ue([0,1,26,21,8,4,2,10,60,7,23,123,167,5,63,24,30,11]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=e.$Hhc=e.$Ghc=void 0,i=Ie(i);class g extends O.$Zc{static{this.a=2e3}get storage(){return this.f}constructor(n,c){super(),this.m=n,this.n=c,this.b=this.B(new D.$qe),this.onDidChangeStorage=this.b.event,this.c=this.B(new D.$qe),this.onDidCloseStorage=this.c.event,this.f=this.B(new u.$kq(new u.$lq,{hint:u.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new v.$8h,this.whenInit=this.h.p,this.j=u.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===u.StorageState.None)try{const n=this.B(await this.t());this.f.dispose(),this.f=n,this.B(n.onDidChangeStorage(h=>this.b.fire(h))),await this.s(n);const c=n.getBoolean(d.$mq);c===void 0?n.set(d.$mq,!0):c&&n.set(d.$mq,!1)}catch(n){this.m.error(`[storage main] initialize(): Unable to init storage due to ${n}`)}finally{this.j=u.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===p.LogLevel.Trace?n=>this.m.trace(n):void 0,logError:n=>this.m.error(n)}}s(n){return n.init()}get items(){return this.f.items}get(n,c){return this.f.get(n,c)}set(n,c){return this.f.set(n,c)}delete(n){return this.f.delete(n)}optimize(){return this.f.optimize()}async close(){const n=new b.$ke(!1);await this.w(),n.stop(),n.elapsed()>g.a&&await this.u(n),this.c.fire()}async u(n){if(this.path)try{const c=(0,r.top)(Array.from(this.f.items.entries()).map(([P,w])=>({key:P,length:w.length})),(P,w)=>w.length-P.length,5).map(P=>`${P.key}:${P.length}`).join(", "),h=(await this.n.stat(l.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${n.elapsed()}ms, DB size: ${h}b, Large Keys: ${c}`)}catch(c){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",c)}}async w(){this.g&&await this.g,this.j=u.StorageState.Closed,await this.f.close()}}class S extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,I.$oc)(this.z.globalStorageHome.with({scheme:E.Schemas.file}).fsPath,S.y)}constructor(n,c,h,P){super(h,P),this.z=n,this.C=c}async t(){return new u.$kq(new $.$UY(this.path??$.$UY.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:u.StorageHint.STORAGE_IN_MEMORY})}}class k extends S{constructor(n,c,h,P){super(n,c,h,P)}}e.$Ghc=k;class s extends S{constructor(n,c,h,P){super(c.defaultProfile,n,h,P)}async s(n){await super.s(n),this.G(n)}G(n){n.get(f.$hm,void 0)===void 0&&n.set(f.$hm,new Date().toUTCString());const h=n.get(f.$gm,void 0),P=new Date().toUTCString();n.set(f.$im,typeof h>"u"?null:h),n.set(f.$gm,P)}}e.$Hhc=s;class a extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,I.$oc)(this.F.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath,this.C.id,a.y)}constructor(n,c,h,P,w){super(h,w),this.C=n,this.D=c,this.F=P}async t(){const{storageFilePath:n,wasCreated:c}=await this.H();return new u.$kq(new $.$UY(n,{logging:this.r()}),{hint:this.D.useInMemoryStorage?u.StorageHint.STORAGE_IN_MEMORY:c?u.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:$.$UY.IN_MEMORY_PATH,wasCreated:!0};const n=(0,I.$oc)(this.F.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath,this.C.id),c=(0,I.$oc)(n,a.y);return await m.Promises.exists(n)?{storageFilePath:c,wasCreated:!1}:(await i.promises.mkdir(n,{recursive:!0}),this.I(n),{storageFilePath:c,wasCreated:!0})}async I(n){let c;if((0,y.$Ui)(this.C)?c={folder:this.C.uri.toString()}:(0,y.$Zi)(this.C)&&(c={workspace:this.C.configPath.toString()}),c)try{const h=(0,I.$oc)(n,a.z);await m.Promises.exists(h)||await m.Promises.writeFile(h,JSON.stringify(c,void 0,2))}catch(h){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.$Ihc=a;class t extends g{get path(){}async t(){return new u.$kq(new u.$lq,{hint:u.StorageHint.STORAGE_IN_MEMORY})}}e.$Jhc=t}),define(le[254],ue([0,1,4,2,63]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class D extends r.$Zc{constructor(I,b,l){super(),this.b=I,this.c=b,this.f=l;const m=this.B(new r.$1c);this.a=this.B(new i.$qe({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Yc;return I.add(i.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(b,l)=>(b?b.push(l.key):b=[l.key],b),100)(b=>this.h(b))),I.add(i.Event.debounce(this.b.onDidChangeProfileStorage,(b,l)=>{b||(b=new Map);let m=b.get(l.profile.id);return m||b.set(l.profile.id,m={profile:l.profile,keys:[],storage:l.storage}),m.keys.push(l.key),b},100)(b=>this.j(b))),I}h(I){const b=I.includes(v.$nq)?[this.c.defaultProfile]:[],l=[];if(I=I.filter(m=>m!==v.$nq),I.length){const m=(0,v.$pq)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:I.map(u=>({key:u,scope:v.StorageScope.PROFILE,target:m[u]}))})}this.m(b,l)}j(I){const b=[],l=new Map;for(const[m,u]of I.entries()){u.keys.includes(v.$nq)&&b.push(u.profile);const $=u.keys.filter(p=>p!==v.$nq);if($.length){const p=(0,v.$pq)(u.storage.storage);l.set(m,{profile:u.profile,changes:$.map(d=>({key:d,scope:v.StorageScope.PROFILE,target:p[d]}))})}}this.m(b,[...l.values()])}m(I,b){(I.length||b.length)&&this.a.fire({valueChanges:b,targetChanges:I})}listen(I,b,l){switch(b){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${b}`)}async call(I,b){throw new Error(`Call not found: ${b}`)}}e.$Wic=D}),define(le[255],ue([0,1,7,36,14,5,34,41,42,12,130]),function(G,e,i,r,v,D,O,I,b,l,m){"use strict";var u,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$$R=e.$0R=e.$9R=void 0;let p=class extends b.$Ul{static{u=this}static{this.a="profileAssociationsMigration"}constructor(E,g,S,k,s){super(S,k,g,s),this.U=E,this.W=S}O(){return this.U.getItem(u.b,[]).map(g=>({...g,location:(0,l.$jg)(g.location)?this.w.extUri.joinPath(this.profilesHome,g.location):i.URI.revive(g.location)}))}Q(){const E=this.U.getItem(u.c,{});return this.U.getItem(u.a,!1)?E:this.N(E)}S(){return this.w.extUri.joinPath(i.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$9R=p,e.$9R=p=u=ke([se(0,O.$4R),se(1,I.$Pl),se(2,r.$Si),se(3,v.$fl),se(4,D.$fk)],p);let d=$=class extends p{constructor(E,g,S,k,s){super(E,g,S,k,s),this.$=E}P(E){E.length?this.$.setItem($.b,E.map(g=>({...g,location:this.w.extUri.basename(g.location)}))):this.$.removeItem($.b)}O(){const E=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(E),this.$.setItem("userDataProfilesMigration",!0)),E}R(E){E.emptyWindows||E.workspaces?this.$.setItem($.c,E):this.$.removeItem($.c)}Q(){const E="workspaceAndProfileInfo",g=this.$.getItem(E,void 0);if(g){this.$.removeItem(E);const k=g.reduce((s,{workspace:a,profile:t})=>(s[i.URI.revive(a).toString()]=i.URI.revive(t).toString(),s),{});this.$.setItem($.c,{workspaces:k})}const S=super.Q();return this.$.getItem($.a,!1)||(this.R(S),this.$.setItem($.a,!0)),S}};e.$0R=d,e.$0R=d=$=ke([se(0,O.$5R),se(1,I.$Pl),se(2,r.$Si),se(3,v.$fl),se(4,D.$fk)],d);let f=class extends d{constructor(E,g,S,k){super(new m.$8R(m.SaveStrategy.IMMEDIATE,g,k,S),E,g,S,k)}async init(){return await this.$.init(),super.init()}};e.$$R=f,e.$$R=f=ke([se(0,I.$Pl),se(1,r.$Si),se(2,v.$fl),se(3,D.$fk)],f)}),define(le[58],ue([0,1,36,14,6,5,41,42,255,34]),function(G,e,i,r,v,D,O,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=e.$ohc=void 0,e.$ohc=(0,v.$Li)(I.$Rl);let m=class extends b.$0R{constructor($,p,d,f,y){super($,p,d,f,y)}getAssociatedEmptyWindows(){const $=[];for(const p of this.C.emptyWindows.keys())$.push({id:p});return $}};e.$phc=m,e.$phc=m=ke([se(0,l.$5R),se(1,O.$Pl),se(2,i.$Si),se(3,r.$fl),se(4,D.$fk)],m)}),define(le[137],ue([0,1,18,7,30]),function(G,e,i,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=D,e.$rhc=O,e.$shc=I;async function D(b,l,m){for(const $ of b){const p=$.openedWorkspace;if((0,v.$Zi)(p)){const d=await m(p);if(d){if(d.folders.some(f=>i.$ch.isEqualOrParent(l,f.uri)))return $}else if(i.$ch.isEqualOrParent(l,p.configPath))return $}}const u=b.filter($=>(0,v.$Ui)($.openedWorkspace)&&i.$ch.isEqualOrParent(l,$.openedWorkspace.uri));if(u.length)return u.sort(($,p)=>-($.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}function O(b,l){for(const m of b)if((0,v.$Zi)(m.openedWorkspace)&&i.$ch.isEqual(m.openedWorkspace.configPath,l)||(0,v.$Ui)(m.openedWorkspace)&&i.$ch.isEqual(m.openedWorkspace.uri,l))return m}function I(b,l){const m=u=>l.some($=>i.$ch.isEqual(r.URI.file($),r.URI.file(u)));for(const u of b)if(u.config?.extensionDevelopmentPath?.some($=>m($)))return u}}),define(le[105],ue([0,1,32,43,110,49,11,10,3,18,7,6,75,30]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sib=void 0,e.$Tib=d,e.$Uib=f,e.$Vib=y,e.$Wib=E,e.$Xib=k,e.$Yib=a,e.$Zib=t,e.$1ib=P,e.$2ib=w,r=Ie(r),v=Ie(v),e.$Sib=(0,u.$Ki)("workspacesService");function d(R){return R.hasOwnProperty("workspace")}function f(R){return R.hasOwnProperty("folderUri")}function y(R){return R.hasOwnProperty("fileUri")}function E(R){return g(R)||S(R)}function g(R){const T=R;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function S(R){const T=R;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function k(R,T,A,L,M){if(R.scheme!==L.scheme)return{name:A,uri:R.toString(!0)};let V=T?void 0:M.relativePath(L,R);if(V!==void 0)V.length===0?V=".":b.$l&&(V=s(V));else if(R.scheme===O.Schemas.file)V=R.fsPath,b.$l&&(V=s(V));else if(M.isEqualAuthority(R.authority,L.authority))V=R.path;else return{name:A,uri:R.toString(!0)};return{name:A,path:V}}function s(R){return R=(0,D.$0w)(R),(0,i.$Gg)(R)||(R=(0,i.$Dg)(R)),R}function a(R,T,A){const L=[],M=new Set,V=A.dirname(T);for(const q of R){let Y;if(g(q))q.path&&(Y=A.resolvePath(V,q.path));else if(S(q))try{Y=m.URI.parse(q.uri),Y.path[0]!==I.$lc.sep&&(Y=Y.with({path:I.$lc.sep+Y.path}))}catch(de){console.warn(de)}if(Y){const de=A.getComparisonKey(Y);if(!M.has(de)){M.add(de);const re=q.name||A.basenameOrAuthority(Y);L.push(new p.$5i({uri:Y,name:re,index:L.length},q))}}}return L}function t(R,T,A,L,M){const V=o(T,R),q=M.dirname(T),Y=M.dirname(L),de=[];for(const Z of V.folders){const C=g(Z)?M.resolvePath(q,Z.path):m.URI.parse(Z.uri);let B;A?B=!1:B=!g(Z)||(0,I.$nc)(Z.path),de.push(k(C,B,Z.name,Y,M))}const re={insertSpaces:!1,tabSize:4,eol:b.$n||b.$m?`
`:`\r
`},ee=v.$go(R,["folders"],de,re);let W=v.$jo(R,ee);return(0,l.$qh)(V.remoteAuthority,(0,$.$nn)(L))&&(W=v.$jo(W,v.$fo(W,["remoteAuthority"],re))),W}function o(R,T){const A=r.$5n(T);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(L=>E(L));else throw new Error(`${R} looks like an invalid workspace file.`);return A}function n(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function c(R){return typeof R.folderUri=="string"}function h(R){return typeof R.fileUri=="string"}function P(R,T){const A={workspaces:[],files:[]};if(R){const L=function(V,q){for(let Y=0;Y<V.length;Y++)try{q(V[Y],Y)}catch(de){T.warn(`Error restoring recent entry ${JSON.stringify(V[Y])}: ${de.toString()}. Skip entry.`)}},M=R;Array.isArray(M.entries)&&L(M.entries,V=>{const q=V.label,Y=V.remoteAuthority;n(V)?A.workspaces.push({label:q,remoteAuthority:Y,workspace:{id:V.workspace.id,configPath:m.URI.parse(V.workspace.configPath)}}):c(V)?A.workspaces.push({label:q,remoteAuthority:Y,folderUri:m.URI.parse(V.folderUri)}):h(V)&&A.files.push({label:q,remoteAuthority:Y,fileUri:m.URI.parse(V.fileUri)})})}return A}function w(R){const T={entries:[]};for(const A of R.workspaces)f(A)?T.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):T.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of R.files)T.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return T}}),define(le[106],ue([0,1,93,11,3,18]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0,e.$uhc=O,e.$vhc=I,e.$whc=b,e.$thc=128/4;function O(l){function m(){let u=l.scheme===r.Schemas.file?(0,D.$_g)(l):l.toString();return v.$n||(u=u.toLowerCase()),(0,i.createHash)("md5").update(u).digest("hex")}return{id:m(),configPath:l}}function I(l,m){function u(){if(l.scheme!==r.Schemas.file)return(0,i.createHash)("md5").update(l.toString()).digest("hex");if(!m)return;let p;return v.$n?p=m.ino:v.$m?p=m.birthtime.getTime():v.$l&&(typeof m.birthtimeMs=="number"?p=Math.floor(m.birthtimeMs):p=m.birthtime.getTime()),(0,i.createHash)("md5").update(l.fsPath).update(p?String(p):"").digest("hex")}const $=u();if(typeof $=="string")return{id:$,uri:l}}function b(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[107],ue([0,1,93,94,27,256,17,15,4,2,10,3,33,45,121]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Bi=e.$Ai=e.$zi=void 0,e.$Ci=n,e.$Di=c,e.$Fi=w,e.$Gi=R;const f=3e4;class y{traceSocketEvent(A,L){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,L)}constructor(A,L=""){this.f=!0,this.debugLabel=L,this.socket=A,this.traceSocketEvent(d.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=V=>{if(this.traceSocketEvent(d.SocketDiagnosticsEventType.Error,{code:V?.code,message:V?.message}),V){if(V.code==="EPIPE")return;(0,I.$4)(V)}},this.socket.on("error",this.a);let M;this.b=V=>{this.traceSocketEvent(d.SocketDiagnosticsEventType.Close,{hadError:V}),this.f=!1,M&&clearTimeout(M)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,M=setTimeout(()=>A.destroy(),f)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(A){const L=M=>{this.traceSocketEvent(d.SocketDiagnosticsEventType.Read,M),A(O.$Se.wrap(M))};return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(A){const L=M=>{A({type:d.SocketCloseEventType.NodeSocketCloseEvent,hadError:M,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(A){const L=()=>{A()};return this.socket.on("end",L),{dispose:()=>this.socket.off("end",L)}}write(A){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(d.SocketDiagnosticsEventType.Write,A),this.socket.write(A.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,I.$4)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,I.$4)(L)}}end(){this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((A,L)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeDrainEnd),A();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent(d.SocketDiagnosticsEventType.NodeDrainEnd),A()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$zi=y;var E;(function(T){T[T.MinHeaderByteSize=2]="MinHeaderByteSize",T[T.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(E||(E={}));var g;(function(T){T[T.PeekHeader=1]="PeekHeader",T[T.ReadHeader=2]="ReadHeader",T[T.ReadBody=3]="ReadBody",T[T.Fin=4]="Fin"})(g||(g={}));class S extends l.$Zc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(A,L){this.socket.traceSocketEvent(A,L)}constructor(A,L,M,V){super(),this.f=this.B(new b.$qe),this.g=this.B(new b.$qe),this.h=!1,this.j={state:g.PeekHeader,readLen:E.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=A,this.traceSocketEvent(d.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:L,inflateBytesLength:M?.byteLength||0,recordInflateBytes:V}),this.a=this.B(new k(this,L,M,V,this.f,(q,Y)=>this.m(q,Y))),this.B(this.a.onError(q=>{console.error(q),(0,I.$4)(q),this.g.fire({type:d.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:q})})),this.b=new d.$ui,this.B(this.socket.onData(q=>this.n(q))),this.B(this.socket.onClose(async q=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this.f.event(A)}onClose(A){return this.g.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){let L=0;for(;L<A.byteLength;)this.a.writeMessage(A.slice(L,Math.min(L+E.MaxWebSocketMessageLength,A.byteLength)),{compressed:!0,opcode:2}),L+=E.MaxWebSocketMessageLength}m(A,{compressed:L,opcode:M}){if(this.h)return;this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,A);let V=E.MinHeaderByteSize;A.byteLength<126?V+=0:A.byteLength<2**16?V+=2:V+=8;const q=O.$Se.alloc(V),Y=L?64:0,de=M&15;if(q.writeUInt8(128|Y|de,0),A.byteLength<126)q.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){q.writeUInt8(126,1);let re=1;q.writeUInt8(A.byteLength>>>8&255,++re),q.writeUInt8(A.byteLength>>>0&255,++re)}else{q.writeUInt8(127,1);let re=1;q.writeUInt8(0,++re),q.writeUInt8(0,++re),q.writeUInt8(0,++re),q.writeUInt8(0,++re),q.writeUInt8(A.byteLength>>>24&255,++re),q.writeUInt8(A.byteLength>>>16&255,++re),q.writeUInt8(A.byteLength>>>8&255,++re),q.writeUInt8(A.byteLength>>>0&255,++re)}this.socket.write(O.$Se.concat([q,A]))}end(){this.h=!0,this.socket.end()}n(A){if(A.byteLength!==0){for(this.b.acceptChunk(A);this.b.byteLength>=this.j.readLen;)if(this.j.state===g.PeekHeader){const L=this.b.peek(this.j.readLen),M=L.readUInt8(0),V=(M&128)>>>7,q=(M&64)>>>6,Y=M&15,de=L.readUInt8(1),re=(de&128)>>>7,ee=de&127;this.j.state=g.ReadHeader,this.j.readLen=E.MinHeaderByteSize+(re?4:0)+(ee===126?2:0)+(ee===127?8:0),this.j.fin=V,this.j.firstFrameOfMessage&&(this.j.compressed=!!q),this.j.firstFrameOfMessage=!!V,this.j.mask=0,this.j.opcode=Y,this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===g.ReadHeader){const L=this.b.read(this.j.readLen),M=L.readUInt8(1),V=(M&128)>>>7;let q=M&127,Y=1;q===126?q=L.readUInt8(++Y)*2**8+L.readUInt8(++Y):q===127&&(q=L.readUInt8(++Y)*0+L.readUInt8(++Y)*0+L.readUInt8(++Y)*0+L.readUInt8(++Y)*0+L.readUInt8(++Y)*2**24+L.readUInt8(++Y)*2**16+L.readUInt8(++Y)*2**8+L.readUInt8(++Y));let de=0;V&&(de=L.readUInt8(++Y)*2**24+L.readUInt8(++Y)*2**16+L.readUInt8(++Y)*2**8+L.readUInt8(++Y)),this.j.state=g.ReadBody,this.j.readLen=q,this.j.mask=de,this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===g.ReadBody){const L=this.b.read(this.j.readLen);this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,L),t(L,this.j.mask),this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,L),this.j.state=g.PeekHeader,this.j.readLen=E.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(L,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(L,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(d.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$Ai=S;class k extends l.$Zc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Se.alloc(0)}constructor(A,L,M,V,q,Y){super(),this.n=A,this.r=q,this.s=Y,this.a=this.B(new b.$qe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$qe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$qe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,L?(this.b=this.B(new s(this.n,V,M,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(de=>this.a.fire(de))),this.B(this.f.onError(de=>this.a.fire(de)))):(this.b=null,this.f=null)}writeMessage(A,L){this.g.push({data:A,options:L}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:A,options:L}=this.g.shift();if(this.f&&L.compressed){const M=await this.w(this.f,A);this.s(M,L)}else this.s(A,{...L,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(A,L){return new Promise((M,V)=>{A.write(L),A.flush(q=>M(q))})}acceptFrame(A,L,M){this.h.push({data:A,isCompressed:L,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const A=this.h.shift();if(this.b&&A.isCompressed){const L=await this.C(this.b,A.data,A.isLastFrameOfMessage);this.r.fire(L)}else this.r.fire(A.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(A,L,M){return new Promise((V,q)=>{A.write(L),M&&A.write(O.$Se.fromByteArray([0,0,255,255])),A.flush(Y=>V(Y))})}}class s extends l.$Zc{get recordedInflateBytes(){return this.j?O.$Se.concat(this.f):O.$Se.alloc(0)}constructor(A,L,M,V){super(),this.h=A,this.j=L,this.a=this.B(new b.$qe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(V),this.b.on("error",q=>{this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateError,{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateData,q),this.g.push(O.$Se.wrap(q))}),M&&(this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateInitialWrite,M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(A){this.j&&this.f.push(A.clone()),this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateWrite,A),this.b.write(A.buffer)}flush(A){this.b.flush(()=>{this.h.traceSocketEvent(d.SocketDiagnosticsEventType.zlibInflateFlushFired);const L=O.$Se.concat(this.g);this.g.length=0,A(L)})}}class a extends l.$Zc{constructor(A,L){super(),this.g=A,this.a=this.B(new b.$qe),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateData,M),this.f.push(O.$Se.wrap(M))})}write(A){this.g.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateWrite,A.buffer),this.b.write(A.buffer)}flush(A){this.b.flush(2,()=>{this.g.traceSocketEvent(d.SocketDiagnosticsEventType.zlibDeflateFlushFired);let L=O.$Se.concat(this.f);this.f.length=0,L=L.slice(0,L.byteLength-4),A(L)})}}function t(T,A){if(A===0)return;const L=T.byteLength>>>2;for(let re=0;re<L;re++){const ee=T.readUInt32BE(re*4);T.writeUInt32BE(ee^A,re*4)}const M=L*4,V=T.byteLength-M,q=A>>>24&255,Y=A>>>16&255,de=A>>>8&255;V>=1&&T.writeUInt8(T.readUInt8(M)^q,M),V>=2&&T.writeUInt8(T.readUInt8(M+1)^Y,M+1),V>=3&&T.writeUInt8(T.readUInt8(M+2)^de,M+2)}e.$Bi=process.env.XDG_RUNTIME_DIR;const o={[u.Platform.Linux]:107,[u.Platform.Mac]:103};function n(){const T=(0,$.$7g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${T}-sock`;const A=process.platform!=="darwin"&&e.$Bi?e.$Bi:(0,v.tmpdir)(),L=(0,m.$oc)(A,`vscode-ipc-${T}.sock`);return h(L),L}function c(T,A,L){const V=(0,i.createHash)("sha256").update(T).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${V}-${L}-${A}-sock`;const q=L.substr(0,4),Y=A.substr(0,6);let de;return process.platform!=="darwin"&&e.$Bi&&!process.env.VSCODE_PORTABLE?de=(0,m.$oc)(e.$Bi,`vscode-${V}-${q}-${Y}.sock`):de=(0,m.$oc)(T,`${q}-${Y}.sock`),h(de),de}function h(T){const A=o[u.$x];typeof A=="number"&&T.length>=A&&console.warn(`WARNING: IPC handle "${T}" is longer than ${A} chars, try a shorter --user-data-dir`)}class P extends p.$oi{static b(A){const L=b.Event.fromNodeEventEmitter(A,"connection");return b.Event.map(L,M=>({protocol:new d.$vi(new y(M,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(M,"close"))}))}constructor(A){super(P.b(A)),this.d=A}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ei=P;function w(T){return new Promise((A,L)=>{const M=(0,r.createServer)();M.on("error",L),M.listen(T,()=>{M.removeListener("error",L),A(new P(M))})})}function R(T,A){return new Promise((L,M)=>{const V=(0,r.createConnection)(T,()=>{V.removeListener("error",M),L(d.$wi.fromSocket(new y(V,`ipc-client${A}`),A))});V.once("error",M)})}}),define(le[20],ue([0,1,54,10,3,107,36,98,6]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.$$gc=void 0,e.$$gc=(0,b.$Li)(O.$Ri);class l extends I.$cn{constructor(){super(...arguments),this.d={}}get backupHome(){return(0,r.$oc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,D.$Di)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$oc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(v.$n){for(const u in process.env)if(u.endsWith("_VSCODE_SNAP_ORIG")){const $=u.slice(0,-17);if(this.d[$])continue;process.env[$]&&(this.d[$]=process.env[$]),process.env[u]?process.env[$]=process.env[u]:delete process.env[$]}}}restoreSnapExportedVariables(){if(v.$n)for(const u in this.d)process.env[u]=this.d[u],delete this.d[u]}}e.$_gc=l,ke([i.$ci],l.prototype,"backupHome",null),ke([i.$ci],l.prototype,"mainIPCHandle",null),ke([i.$ci],l.prototype,"mainLockfile",null),ke([i.$ci],l.prototype,"disableUpdates",null),ke([i.$ci],l.prototype,"crossOriginIsolated",null),ke([i.$ci],l.prototype,"codeCachePath",null),ke([i.$ci],l.prototype,"useCodeCache",null)}),define(le[257],ue([0,1,93,32,11,10,3,18,23,169,16,20,34,14,5,168,30,106]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;let S=class{static{g=this}static{this.a="backupWorkspaces"}constructor(s,a,t,o){this.j=s,this.k=a,this.l=t,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$ch,this.i={isEqual:(n,c)=>(0,r.$Ig)(n,c,!O.$n)}}async initialize(){const s=this.m.getItem(g.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(s.emptyWindows),this.d=await this.u((0,l.$dhc)(s)),this.e=await this.v((0,l.$ehc)(s)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==p.$El.OFF}q(){return this.s()===p.$El.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||p.$El.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(s,a){this.d.some(o=>s.workspace.id===o.workspace.id)||(this.d.push(s),this.C());const t=(0,D.$oc)(this.c,s.workspace.id);return a?this.t(t,a).then(()=>t):t}async t(s,a){if(await b.Promises.exists(s)&&await this.z(s),await b.Promises.exists(a))try{await b.Promises.rename(a,s,!1)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(s){return this.e.some(a=>this.h.isEqual(s.folderUri,a.folderUri))||(this.e.push(s),this.C()),(0,D.$oc)(this.c,this.D(s))}registerEmptyWindowBackup(s){return this.g.some(a=>!!a.backupFolder&&this.i.isEqual(a.backupFolder,s.backupFolder))||(this.g.push(s),this.C()),(0,D.$oc)(this.c,s.backupFolder)}async u(s){if(!Array.isArray(s))return[];const a=new Set,t=[];for(const o of s){const n=o.workspace;if(!(0,y.$Zi)(n))return[];if(!a.has(n.id)){a.add(n.id);const c=(0,D.$oc)(this.c,n.id);await this.B(c)?n.configPath.scheme!==v.Schemas.file||await b.Promises.exists(n.configPath.fsPath)?t.push(o):await this.z(c):await this.x(c)}}return t}async v(s){if(!Array.isArray(s))return[];const a=[],t=new Set;for(const o of s){const n=o.folderUri,c=this.h.getComparisonKey(n);if(!t.has(c)){t.add(c);const h=(0,D.$oc)(this.c,this.D(o));await this.B(h)?n.scheme!==v.Schemas.file||await b.Promises.exists(n.fsPath)?a.push(o):await this.z(h):await this.x(h)}}return a}async w(s){if(!Array.isArray(s))return[];const a=[],t=new Set;for(const o of s){const n=o.backupFolder;if(typeof n!="string")return[];if(!t.has(n)){t.add(n);const c=(0,D.$oc)(this.c,n);await this.B(c)?a.push(o):await this.x(c)}}return a}async x(s){try{await b.Promises.rm(s,b.RimRafMode.MOVE)}catch(a){this.l.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}y(){let s=(0,E.$whc)();for(;this.g.some(a=>!!a.backupFolder&&this.i.isEqual(a.backupFolder,s.id));)s=(0,E.$whc)();return{backupFolder:s.id}}async z(s){const a=this.y(),t=(0,D.$oc)(this.c,a.backupFolder);try{await b.Promises.rename(s,t,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(a),!0}async getDirtyWorkspaces(){const s=[];for(const a of this.d)await this.A(a)&&s.push(a);for(const a of this.e)await this.A(a)&&s.push(a);return s}A(s){let a;return(0,l.$chc)(s)?a=(0,D.$oc)(this.c,s.backupFolder):(0,f.$Qib)(s)?a=(0,D.$oc)(this.c,this.D(s)):a=(0,D.$oc)(this.c,s.workspace.id),this.B(a)}async B(s){try{const a=await b.Promises.readdir(s);for(const t of a)try{if((await b.Promises.readdir((0,D.$oc)(s,t))).length>0)return!0}catch{}}catch{}return!1}C(){const s={workspaces:this.d.map(({workspace:a,remoteAuthority:t})=>{const o={id:a.id,configURIPath:a.configPath.toString()};return t&&(o.remoteAuthority=t),o}),folders:this.e.map(({folderUri:a,remoteAuthority:t})=>{const o={folderUri:a.toString()};return t&&(o.remoteAuthority=t),o}),emptyWindows:this.g.map(({backupFolder:a,remoteAuthority:t})=>{const o={backupFolder:a};return t&&(o.remoteAuthority=t),o})};this.m.setItem(g.a,s)}D(s){const a=s.folderUri;let t;return a.scheme===v.Schemas.file?t=O.$n?a.fsPath:a.fsPath.toLowerCase():t=a.toString().toLowerCase(),(0,i.createHash)("md5").update(t).digest("hex")}};e.$Qhc=S,e.$Qhc=S=g=ke([se(0,u.$$gc),se(1,m.$ej),se(2,d.$fk),se(3,$.$5R)],S)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[19],ue([0,1,13,35,8,4,2,3,38,12,6,5,34,52,20]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.LifecycleMainPhase=e.ShutdownReason=e.$Ehc=void 0,i=Ge(i),e.$Ehc=(0,m.$Ki)("lifecycleMainService");var y;(function(S){S[S.QUIT=1]="QUIT",S[S.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var E;(function(S){S[S.Starting=1]="Starting",S[S.Ready=2]="Ready",S[S.AfterWindowOpen=3]="AfterWindowOpen",S[S.Eventually=4]="Eventually"})(E||(e.LifecycleMainPhase=E={}));let g=class extends O.$Zc{static{f=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(k,s,a){super(),this.F=k,this.G=s,this.H=a,this.c=this.B(new D.$qe),this.onBeforeShutdown=this.c.event,this.f=this.B(new D.$qe),this.onWillShutdown=this.f.event,this.g=this.B(new D.$qe),this.onWillLoadWindow=this.g.event,this.h=this.B(new D.$qe),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=E.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(E.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(f.b),this.m&&this.G.removeItem(f.b)}J(){const k=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$m&&this.t===0&&this.L(y.QUIT))};i.default.app.addListener("before-quit",k);const s=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$m)&&i.default.app.quit()};i.default.app.addListener("window-all-closed",s),i.default.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(y.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),i.default.app.removeListener("before-quit",k),i.default.app.removeListener("window-all-closed",s),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),i.default.app.quit()})})}L(k){if(this.y)return this.y;const s=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:k,join(t,o){s.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{s.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await v.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(k){if(k<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===k)return;this.S(`lifecycle (main): phase changed (value: ${k})`),this.n=k;const s=this.C.get(this.n);s&&(s.open(),this.C.delete(this.n))}async when(k){if(k<=this.n)return;let s=this.C.get(k);s||(s=new v.$Jh,this.C.set(k,s)),await s.wait()}registerWindow(k){const s=new O.$Yc;this.t++,s.add(k.onWillLoad(t=>this.g.fire({window:k,workspace:t.workspace,reason:t.reason})));const a=(0,l.$ug)(k.win);s.add(D.Event.fromNodeEventEmitter(a,"close")(t=>{const o=k.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${k.id}`),t.preventDefault(),this.unload(k,p.UnloadReason.CLOSE).then(n=>{if(n){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(k),k.close()})})),s.add(D.Event.fromNodeEventEmitter(a,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${k.id}`),this.t--,s.dispose(),this.t===0&&(!I.$m||this.j)&&this.L(y.QUIT)}))}registerAuxWindow(k){const s=(0,l.$ug)(k.win),a=new O.$Yc;a.add(D.Event.fromNodeEventEmitter(s,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${k.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(D.Event.fromNodeEventEmitter(s,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${k.id}`),a.dispose()}))}async reload(k,s){await this.unload(k,p.UnloadReason.RELOAD)||k.reload(s)}unload(k,s){const a=this.z.get(k.id);if(a)return a;const t=this.M(k,s).finally(()=>{this.z.delete(k.id)});return this.z.set(k.id,t),t}async M(k,s){if(!k.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${k.id}`);const a=this.j?p.UnloadReason.QUIT:s,t=await this.P(k,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${k.id})`),this.N(t)):(await this.Q(k,a),!1)}N(k){return k?(this.O(!0),this.j=!1,!0):!1}O(k){this.w&&(this.w(k),this.w=void 0,this.u=void 0)}P(k,s){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,n=`vscode:cancel${t}`;r.$pY.once(o,()=>{a(!1)}),r.$pY.once(n,()=>{a(!0)}),k.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:n,reason:s})})}Q(k,s){return new Promise(a=>{const o=`vscode:reply${this.s++}`;r.$pY.once(o,()=>a()),k.send("vscode:onWillUnload",{replyChannel:o,reason:s})})}quit(k){return this.R(k).then(s=>{if(!s&&k)try{if(I.$l){const a=(0,b.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return s})}R(k){return this.S(`Lifecycle#quit() - begin (willRestart: ${k})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(k&&this.G.setItem(f.b,!0),this.u=new Promise(s=>{this.w=s,this.S("Lifecycle#quit() - calling app.quit()"),i.default.app.quit()}),this.u)}S(k){this.H.args["enable-smoke-test-driver"]?this.F.info(k):this.F.trace(k)}setRelaunchHandler(k){this.D=k}async relaunch(k){this.S("Lifecycle#relaunch()");const s=process.argv.slice(1);if(k?.addArgs&&s.push(...k.addArgs),k?.removeArgs)for(const o of k.removeArgs){const n=s.indexOf(o);n>=0&&s.splice(n,1)}const a=()=>{this.D?.handleRelaunch(k)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),i.default.app.relaunch({args:s}))};i.default.app.once("quit",a),await this.quit(!0)&&i.default.app.removeListener("quit",a)}async kill(k){this.S("Lifecycle#kill()"),await this.L(y.KILL),await Promise.race([(0,v.$Lh)(1e3),(async()=>{for(const s of i.default.BrowserWindow.getAllWindows())if(s&&!s.isDestroyed()){let a;s.webContents&&!s.webContents.isDestroyed()?a=new Promise(t=>s.once("closed",t)):a=Promise.resolve(),s.destroy(),await a}})()]),i.default.app.exit(k)}};e.$Fhc=g,e.$Fhc=g=f=ke([se(0,u.$fk),se(1,$.$5R),se(2,d.$$gc)],g)}),define(le[258],ue([0,1,3,4,2,6,19]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=e.$cic=void 0,i=Ie(i),e.$cic=(0,D.$Ki)("keyboardLayoutMainService");let I=class extends v.$Zc{constructor(m){super(),this.a=this.B(new r.$qe),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(O.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((u,$)=>{G(["native-keymap"],u,$)}).then(Ie);this.c=b(m),i.$w||m.onDidChangeKeyboardLayout(()=>{this.c=b(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$dic=I,e.$dic=I=ke([se(0,O.$Ehc)],I);function b(l){const m=l.getKeyMap(),u=l.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:u}}}),define(le[259],ue([0,1,219,8,17,15,12,16,36,103,5,50,218,256]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=void 0,e.$os=y;let d=class extends u.$cq{constructor(g,S,k,s){super(s),this.m=g,this.n=S,this.r=k,this.s(),this.B(g.onDidChangeConfiguration(a=>{a.affectsConfiguration("http")&&this.s()}))}s(){const g=this.m.getValue("http");this.f=g?.proxy,this.g=!!g?.proxyStrictSSL,this.h=g?.proxyAuthorization}async request(g,S){const{f:k,g:s}=this;let a;try{a=await(0,l.$Wm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$bb)(n)))}const t={...process.env,...a},o=g.agent?g.agent:await(0,$.$ms)(g.url||"",t,{proxyUrl:k,strictSSL:s});return g.agent=o,g.strictSSL=s,this.h&&(g.headers={...g.headers||{},"Proxy-Authorization":this.h}),this.c(g.isChromiumNetwork?"electron":"node",g,()=>y(g,S))}async resolveProxy(g){}async lookupAuthorization(g){}async lookupKerberosAuthorization(g){try{const S=await new Promise((o,n)=>{G(["kerberos"],o,n)}).then(Ie),k=new URL(g),s=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${k.hostname}`:`HTTP@${k.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${k}`,`spn:${s}`),"Negotiate "+await(await S.initializeClient(s)).step("")}catch(S){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",S);return}}async loadCertificates(){return(await new Promise((S,k)=>{G(["@vscode/proxy-agent"],S,k)}).then(Ie)).loadSystemCertificates({log:this.r})}};e.$ns=d,e.$ns=d=ke([se(0,I.$ej),se(1,b.$Si),se(2,m.$fk),se(3,m.$gk)],d);async function f(E){return((0,i.parse)(E.url).protocol==="https:"?await new Promise((k,s)=>{G(["https"],k,s)}).then(Ie):await new Promise((k,s)=>{G(["http"],k,s)}).then(Ie)).request}async function y(E,g){return r.Promises.withAsyncBody(async(S,k)=>{const s=(0,i.parse)(E.url),a=E.getRawRequest?E.getRawRequest(E):await f(E),t={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,O.$pg)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(t.auth=E.user+":"+E.password);const o=a(t,n=>{const c=(0,O.$ng)(E.followRedirects)?E.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&c>0&&n.headers.location)y({...E,url:n.headers.location,followRedirects:c-1},g).then(S,k);else{let h=n;!E.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(h=n.pipe((0,p.createGunzip)())),S({res:n,stream:(0,v.$8e)(h)})}});o.on("error",k),E.timeout&&o.setTimeout(E.timeout),E.isChromiumNetwork&&o.removeHeader("Content-Length"),E.data&&typeof E.data=="string"&&o.write(E.data),o.end(),g.onCancellationRequested(()=>{o.abort(),k(new D.$9)})})}}),define(le[260],ue([0,1,13,259]),function(G,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=void 0;function v(O){return i.net.request}class D extends r.$ns{request(I,b){return super.request({...I||{},getRawRequest:v,isChromiumNetwork:!0},b)}}e.$hjc=D}),define(le[89],ue([0,1,7,4,2,36,14,6,19,5,63,253,42,58,41,11]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=e.$Mhc=e.$Lhc=e.$Khc=void 0,e.$Khc=(0,I.$Ki)("storageMainService");let y=class extends v.$Zc{constructor(S,k,s,a,t,o){super(),this.c=S,this.f=k,this.g=s,this.h=a,this.j=t,this.m=o,this.a=void 0,this.b=this.B(new r.$qe),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(b.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(S=>{S.window.profile&&this.profileStorage(S.window.profile).init(),S.workspace&&this.workspaceStorage(S.workspace).init()})),this.B(this.h.onWillShutdown(S=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=S.reason,S.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.t)S.join("profileStorage",k.close());for(const[,k]of this.w)S.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(S=>{S.join((async()=>{await this.j.exists(S.profile.globalStorageHome)||await this.j.createFolder(S.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(S=>{const k=this.t.get(S.profile.id);k&&S.join(k.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const S=new u.$Hhc(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),S}profileStorage(S){if((0,m.$rq)(S))return this.applicationStorage;let k=this.t.get(S.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${S.name})`),k=this.B(this.u(S)),this.t.set(S.id,k);const s=this.B(k.onDidChangeStorage(a=>this.b.fire({...a,storage:k,profile:S})));this.B(r.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${S.name})`),this.t.delete(S.id),s.dispose()}))}return k}u(S){return this.a===b.ShutdownReason.KILL?new u.$Jhc(this.c,this.j):new u.$Ghc(S,this.n(),this.c,this.j)}workspaceStorage(S){let k=this.w.get(S.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${S.id})`),k=this.B(this.y(S)),this.w.set(S.id,k),this.B(r.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${S.id})`),this.w.delete(S.id)}))),k}y(S){return this.a===b.ShutdownReason.KILL?new u.$Jhc(this.c,this.j):new u.$Ihc(S,this.n(),this.c,this.f,this.j)}isUsed(S){const k=i.URI.file(S);for(const s of[this.applicationStorage,...this.t.values(),...this.w.values()])if(s.path&&this.m.extUri.isEqualOrParent(i.URI.file(s.path),k))return!0;return!1}};e.$Lhc=y,e.$Lhc=y=ke([se(0,l.$fk),se(1,D.$Ri),se(2,p.$ohc),se(3,b.$Ehc),se(4,O.$fl),se(5,d.$Pl)],y),e.$Mhc=(0,I.$Ki)("applicationStorageMainService");let E=class extends m.$qq{constructor(S,k){super(),this.s=S,this.U=k,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(S){if(S===m.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(S){if(S===m.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:f.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$Nhc=E,e.$Nhc=E=ke([se(0,$.$Rl),se(1,e.$Khc)],E)}),define(le[261],ue([0,1,94,27,114,107,8,2,3,16,5,28,212,215,104,134,17]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=e.$fjc=e.$ejc=e.$djc=void 0,i=Ie(i),r=Ie(r);async function E(a,t,o,n,c){let h;for(let P=3;P&&(h?.dispose(),h=await new g(a,t,o,n,c).waitForReady(),!(c&&v.$0g[c]||!v.$0g[h.tunnelLocalPort]));P--);return h}class g extends I.$Zc{constructor(t,o,n,c,h){super(),this.m=o,this.n=h,this.privacy=f.TunnelPrivacyId.Private,this.j=new Map,this.a=t,this.b=i.createServer(),this.c=new O.$Jh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=P=>this.r(P),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const t=this.n??this.tunnelRemotePort,o=(0,f.$Vw)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,v.$$g)(t,2,1e3,o),c=null;return this.b.listen(n,this.m),await this.c.wait(),c=this.b.address(),c||(n=0,this.b.listen(n,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(t){t.pause();const o=(0,f.$Tw)(this.tunnelRemoteHost)||(0,f.$Vw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,$.$8l)(this.a,o,this.tunnelRemotePort),c=n.getSocket(),h=n.readEntireBuffer();n.dispose(),h.byteLength>0&&t.write(h.buffer),t.on("end",()=>{t.localAddress&&this.j.delete(t.localAddress),c.end()}),t.on("close",()=>c.end()),t.on("error",()=>{t.localAddress&&this.j.delete(t.localAddress),c instanceof D.$zi?c.socket.destroy():c.end()}),c instanceof D.$zi?this.t(t,c):this.s(t,c),t.localAddress&&this.j.set(t.localAddress,()=>{t.end(),c.end()})}s(t,o){o.onClose(()=>t.destroy()),o.onEnd(()=>t.end()),o.onData(n=>t.write(n.buffer)),t.on("data",n=>o.write(y.$Se.wrap(n))),t.resume()}t(t,o){const n=o.socket;n.on("end",()=>t.end()),n.on("close",()=>t.end()),n.on("error",()=>{t.destroy()}),n.pipe(t),t.pipe(n)}}e.$djc=g;let S=class extends f.$Yw{constructor(t,o,n,c,h){super(o,h),this.H=t,this.I=n,this.J=c}isPortPrivileged(t){return(0,f.$Ww)(t,this.t,b.OS,r.release())}F(t,o,n,c,h,P,w,R){const T=this.D(o,n);if(T)return++T.refcount,T.value;if((0,f.$Pw)(t))return this.G(t,o,n,h,P,w,R);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${n} on local port ${h}.`);const A={commit:this.J.commit,quality:this.J.quality,addressProvider:t,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},L=E(A,c,o,n,h);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(o,n,L),L}}};e.$ejc=S,e.$ejc=S=ke([se(0,p.$2l),se(1,m.$fk),se(2,d.$5l),se(3,u.$yk),se(4,l.$ej)],S);let k=class extends S{constructor(t,o,n,c,h){super(t,o,n,c,h)}};e.$fjc=k,e.$fjc=k=ke([se(0,p.$2l),se(1,m.$fk),se(2,d.$5l),se(3,u.$yk),se(4,l.$ej)],k);let s=class extends I.$Zc{constructor(t,o,n,c,h){super(),this.b=t,this.c=o,this.f=n,this.g=c,this.h=h,this.a=new Map}async openTunnel(t,o,n,c,h,P,w,R,T){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${c} on local port ${P}.`),!this.a.has(t)){const A=new k(this.b,this.c,this.g,this.f,this.h);this.B(A),this.a.set(t,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(t))})}return this.a.get(t).openTunnel(o,n,c,h,P,w,R,T)}};e.$gjc=s,e.$gjc=s=ke([se(0,p.$2l),se(1,m.$fk),se(2,u.$yk),se(3,d.$5l),se(4,l.$ej)],s)}),define(le[108],ue([0,1,8,22,4,16,20,19,5,28,50,51]),function(G,e,i,r,v,D,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0,e.$zic=$;function $(d,f,y){return`${y.updateUrl}/api/update/${d}/${f}/${y.commit}`}let p=class{get state(){return this.b}d(f){this.j.info("update#setState",f.type),this.b=f,this.c.fire(f)}constructor(f,y,E,g,S,k){this.f=f,this.g=y,this.h=E,this.i=g,this.j=S,this.k=k,this.b=u.$nZ.Uninitialized,this.c=new v.$qe,this.onStateChange=this.c.event,f.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(u.$nZ.Disabled(u.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(u.$nZ.Disabled(u.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(u.$nZ.Disabled(u.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const f=this.g.getValue("update.mode"),y=this.m(f);if(!y){this.d(u.$nZ.Disabled(u.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(y),!this.a){this.d(u.$nZ.Disabled(u.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const E=new URL(this.a);E.searchParams.set("prss","true"),this.a=E.toString()}if(this.d(u.$nZ.Idle(this.q())),f==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}f==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,E=>this.j.error(E))}m(f){return f==="none"?void 0:this.k.quality}n(f=60*60*1e3){return(0,i.$Lh)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(f){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.t(f)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.o(this.state)}async o(f){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(f=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(y){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(y);return}}async _applySpecificUpdate(f){}q(){return u.UpdateType.Archive}r(){}};e.$Aic=p,e.$Aic=p=ke([se(0,I.$Ehc),se(1,D.$ej),se(2,O.$$gc),se(3,m.$bq),se(4,b.$fk),se(5,l.$yk)],p)}),define(le[262],ue([0,1,13,54,4,48,2,16,20,19,5,28,50,24,51,108]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0,i=Ie(i);let y=class extends f.$Aic{get v(){return v.Event.fromNodeEventEmitter(i.autoUpdater,"error",(g,S)=>S)}get w(){return v.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get x(){return v.Event.fromNodeEventEmitter(i.autoUpdater,"update-available")}get y(){return v.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",(g,S,k,s)=>({version:k,productVersion:k,timestamp:s}))}constructor(g,S,k,s,a,t,o){super(g,S,s,a,t,o),this.z=k,this.u=new O.$Yc,g.setRelaunchHandler(this)}handleRelaunch(g){return g?.addArgs||g?.removeArgs||this.state.type!==d.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.z.publicLog2("update:error",{messageHash:String((0,D.$yj)(String(g)))}),this.j.error("UpdateService error:",g);const S=this.state.type===d.StateType.CheckingForUpdates&&this.state.explicit?g:void 0;this.d(d.$nZ.Idle(d.UpdateType.Archive,S))}s(g){let S;this.k.darwinUniversalAssetId?S=this.k.darwinUniversalAssetId:S=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,f.$zic)(S,g,this.k);try{i.autoUpdater.setFeedURL({url:k})}catch(s){this.j.error("Failed to set update feed URL",s);return}return k}t(g){this.d(d.$nZ.CheckingForUpdates(g)),i.autoUpdater.checkForUpdates()}E(){this.state.type===d.StateType.CheckingForUpdates&&this.d(d.$nZ.Downloading)}F(g){this.state.type===d.StateType.Downloading&&(this.d(d.$nZ.Downloaded(g)),this.z.publicLog2("update:downloaded",{version:g.version}),this.d(d.$nZ.Ready(g)))}G(){this.state.type===d.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.$nZ.Idle(d.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$Bic=y,ke([r.$ci],y.prototype,"v",null),ke([r.$ci],y.prototype,"w",null),ke([r.$ci],y.prototype,"x",null),ke([r.$ci],y.prototype,"y",null),e.$Bic=y=ke([se(0,l.$Ehc),se(1,I.$ej),se(2,p.$em),se(3,b.$$gc),se(4,$.$bq),se(5,m.$fk),se(6,u.$yk)],y)}),define(le[263],ue([0,1,44,26,8,4,10,20,19,5,24,51]),function(G,e,i,r,v,D,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0,O=Ie(O);let $=class{get state(){return this.a}d(f){this.g.info("update#setState",f.type),this.a=f,this.b.fire(f)}constructor(f,y,E){if(this.f=f,this.g=E,this.a=u.$nZ.Uninitialized,this.b=new D.$qe,this.onStateChange=this.b.event,y.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(u.$nZ.Idle(this.k())),this.h(30*1e3).then(void 0,g=>this.g.error(g))}h(f=60*60*1e3){return(0,v.$Lh)(f).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(f){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===u.StateType.Idle&&this.m(f)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===u.StateType.AvailableForDownload&&await this.i(this.state)}i(f){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===u.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==u.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(f=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${f}`),!f&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return u.UpdateType.Snap}l(){}async _applySpecificUpdate(f){}};$=ke([se(0,b.$Ehc),se(1,I.$$gc),se(2,l.$fk)],$);let p=class extends ${constructor(f,y,E,g,S,k){super(E,g,S),this.o=f,this.p=y,this.q=k;const s=(0,r.watch)(O.$rc(this.o)),a=D.Event.fromNodeEventEmitter(s,"change",(c,h)=>h),t=D.Event.filter(a,c=>c==="current"),n=D.Event.debounce(t,(c,h)=>h,2e3)(()=>this.checkForUpdates(!1));E.onWillShutdown(()=>{n.dispose(),s.close()})}m(){this.d(u.$nZ.CheckingForUpdates(!1)),this.u().then(f=>{f?this.d(u.$nZ.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(u.$nZ.Idle(u.UpdateType.Snap)))},f=>{this.g.error(f),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(u.$nZ.Idle(u.UpdateType.Snap,f.message||f))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+O.$sc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const f=await new Promise((E,g)=>(0,r.realpath)(`${O.$rc(this.o)}/current`,(S,k)=>S?g(S):E(k))),y=O.$sc(f);return this.p!==y}isLatestVersion(){return this.u().then(void 0,f=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Dic=p,e.$Dic=p=ke([se(2,b.$Ehc),se(3,I.$$gc),se(4,l.$fk),se(5,m.$em)],p)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[29],ue([0,1,13,143,10,3,16,20,6,28,77,47,52]),function(G,e,i,r,v,D,O,I,b,l,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$lhc=void 0,e.$mhc=d,e.$nhc=f,i=Ge(i),e.$lhc=(0,b.$Ki)("windowsMainService");var p;(function(E){E[E.CLI=0]="CLI",E[E.DOCK=1]="DOCK",E[E.MENU=2]="MENU",E[E.DIALOG=3]="DIALOG",E[E.DESKTOP=4]="DESKTOP",E[E.API=5]="API",E[E.LINK=6]="LINK"})(p||(e.OpenContext=p={}));function d(E,g,S,k){const s=E.get(m.$jhc),a=E.get(l.$yk),t=E.get(O.$ej),o=E.get(I.$$gc),n=t.getValue("window"),c={backgroundColor:s.getBackgroundColor(),minWidth:u.$oE.WIDTH,minHeight:u.$oE.HEIGHT,title:a.nameLong,show:g.mode!==$.WindowMode.Maximized&&g.mode!==$.WindowMode.Fullscreen,x:g.x,y:g.y,width:g.width,height:g.height,webPreferences:{...k,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,u.$AE)(g.zoomLevel??n?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(D.$n?c.icon=(0,v.$oc)(o.appRoot,"resources/linux/code.png"):D.$l&&!o.isBuilt&&(c.icon=(0,v.$oc)(o.appRoot,"resources/win32/code_150x150.png")),D.$m&&(c.acceptFirstMouse=!0,n?.clickThroughInactive===!1&&(c.acceptFirstMouse=!1)),S?.disableFullscreen?c.fullscreen=!1:D.$m&&!(0,u.$zE)(t)&&(c.fullscreenable=!1),D.$m&&n?.nativeTabs===!0&&(c.tabbingIdentifier=a.nameShort),!(0,u.$vE)(t,S?.forceNativeTitlebar?u.TitlebarStyle.NATIVE:void 0)&&(c.titleBarStyle="hidden",D.$m||(c.frame=!1),(0,u.$yE)(t))){const w=s.getWindowSplash()?.colorInfo.titleBarBackground??s.getBackgroundColor(),R=r.$wu.fromHex(w).isDarker()?"#FFFFFF":"#000000";c.titleBarOverlay={height:29,color:w,symbolColor:R}}return c}function f(E){let g,S=Number.MIN_VALUE;for(const k of E)k.lastFocusTime>S&&(S=k.lastFocusTime,g=k);return g}var y;(function(E){function g(k,s,a=i.default.screen.getAllDisplays()){if(k.trace(`window#validateWindowState: validating window state on ${a.length} display(s)`,s),typeof s.x!="number"||typeof s.y!="number"||typeof s.width!="number"||typeof s.height!="number"){k.trace("window#validateWindowState: unexpected type of state values");return}if(s.width<=0||s.height<=0){k.trace("window#validateWindowState: unexpected negative values");return}if(a.length===1){const n=S(a[0]);if(k.trace("window#validateWindowState: single monitor working area",n),n){let c=function(){!s||typeof s.x!="number"||typeof s.y!="number"||!n||(s.x<n.x&&(s.x=n.x),s.y<n.y&&(s.y=n.y))};c(),s.width>n.width&&(s.width=n.width),s.height>n.height&&(s.height=n.height),s.x>n.x+n.width-128&&(s.x=n.x+n.width-s.width),s.y>n.y+n.height-128&&(s.y=n.y+n.height-s.height),c()}return s}if(s.display&&s.mode===$.WindowMode.Fullscreen){const n=a.find(c=>c.id===s.display);if(n&&typeof n.bounds?.x=="number"&&typeof n.bounds?.y=="number"){k.trace("window#validateWindowState: restoring fullscreen to previous display");const c=(0,$.$ahc)($.WindowMode.Fullscreen);return c.x=n.bounds.x,c.y=n.bounds.y,c}}let t,o;try{t=i.default.screen.getDisplayMatching({x:s.x,y:s.y,width:s.width,height:s.height}),o=S(t),k.trace("window#validateWindowState: multi-monitor working area",o)}catch(n){k.error("window#validateWindowState: error finding display for window state",n)}if(t&&o&&s.x+s.width>o.x&&s.y+s.height>o.y&&s.x<o.x+o.width&&s.y<o.y+o.height)return s;k.trace("window#validateWindowState: state is outside of the multi-monitor working area")}E.validateWindowState=g;function S(k){if(k.workArea.width>0&&k.workArea.height>0)return k.workArea;if(k.bounds.width>0&&k.bounds.height>0)return k.bounds}})(y||(e.WindowStateValidator=y={}))}),define(le[264],ue([0,1,94,171,124,29]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;class O extends r.$6o{constructor(b){super(),this.f=b}call(b,l,m){return l==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(b,l,m)}async g(b,l){const m=(0,v.$Im)(b,v.$Hm);m.debugRenderer=l;const u=m.extensionDevelopmentPath;if(!u)return{success:!1};const[$]=await this.f.openExtensionDevelopmentHostWindow(u,{context:D.OpenContext.API,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!l)return{success:!0};const p=$.win;if(!p)return{success:!0};const d=p.webContents.debugger;let f=d.isAttached()?1/0:0;const y=(0,i.createServer)(E=>{f++===0&&d.attach();let g=!1;const S=a=>{g||E.write(JSON.stringify(a)+"\0")},k=(a,t,o,n)=>S({method:t,params:o,sessionId:n});p.on("close",()=>{d.removeListener("message",k),E.end(),g=!0}),d.addListener("message",k);let s=Buffer.alloc(0);E.on("data",a=>{s=Buffer.concat([s,a]);for(let t=s.indexOf(0);t!==-1;t=s.indexOf(0)){let o;try{const n=s.slice(0,t).toString("utf8");s=s.slice(t+1),o=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}d.sendCommand(o.method,o.params,o.sessionId).then(n=>S({id:o.id,sessionId:o.sessionId,result:n})).catch(n=>S({id:o.id,sessionId:o.sessionId,error:{code:0,message:n.message}}))}}),E.on("error",a=>{console.error("error on cdp pipe:",a)}),E.on("close",()=>{g=!0,--f===0&&d.detach()})});return await new Promise(E=>y.listen(0,E)),p.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.$Rhc=O}),define(le[265],ue([0,1,13,21,3,7,23,16,69,6,5,135,29]),function(G,e,i,r,v,D,O,I,b,l,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=e.$fic=e.ID=void 0,e.ID="launchMainService",e.$fic=(0,l.$Ki)(e.ID);let p=class{constructor(f,y,E,g){this.a=f,this.b=y,this.c=E,this.d=g}async start(f,y){this.a.trace("Received data from other instance: ",f,y),v.$m&&i.app.focus({steal:!0});const E=this.e(f);if(E.length){let g=Promise.resolve();if(this.b.getWindowCount()===0){const S=(0,r.$Sb)(await this.b.openEmptyWindow({context:$.OpenContext.DESKTOP}));S&&(g=S.ready())}g.then(()=>{for(const{uri:S,originalUrl:k}of E)this.c.open(S,{originalUrl:k})})}else return this.f(f,y)}e(f){return f["open-url"]&&f._urls&&f._urls.length>0?(0,r.$Lb)(f._urls.map(y=>{try{return{uri:D.URI.parse(y),originalUrl:y}}catch{return null}})):[]}async f(f,y){const E=(0,b.$Pm)(y)?$.OpenContext.CLI:$.OpenContext.DESKTOP;let g=[];const S=f.wait&&f.waitMarkerFilePath?D.URI.file(f.waitMarkerFilePath):void 0,k=f.remote||void 0,s={context:E,cli:f,userEnv:f["preserve-env"]||E===$.OpenContext.CLI?y:void 0,waitMarkerFileURI:S,remoteAuthority:k,forceProfile:f.profile,forceTempProfile:f["profile-temp"]};if(f.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(f.extensionDevelopmentPath,s);else if(!f._.length&&!f["folder-uri"]&&!f["file-uri"]){let a=!1;if(f["new-window"]||s.forceProfile||s.forceTempProfile)a=!0;else if(f["reuse-window"])a=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!v.$m}if(a)g=await this.b.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const t=this.b.getLastActiveWindow();t?(this.b.openExistingWindow(t,s),g=[t]):g=await this.b.open({...s,forceEmpty:!0})}}else g=await this.b.open({...s,forceNewWindow:f["new-window"],preferNewWindow:!f["reuse-window"]&&!f.wait,forceReuseWindow:f["reuse-window"],diffMode:f.diff,mergeMode:f.merge,addMode:f.add,noRecentEntry:!!f["skip-add-to-recently-opened"],gotoLineMode:f.goto});if(S&&g.length===1&&g[0])return Promise.race([g[0].whenClosedOrLoaded,(0,O.whenDeleted)(S.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$gic=p,e.$gic=p=ke([se(0,m.$fk),se(1,$.$lhc),se(2,u.$eZ),se(3,I.$ej)],p)}),define(le[138],ue([0,1,13,22,4,48,2,7,33,16,100,20,6,5,63,89,29]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=void 0,e.$Ohc=(0,$.$Ki)("proxyAuthService");let E=class extends O.$Zc{constructor(S,k,s,a,t,o){super(),this.h=S,this.m=k,this.n=s,this.r=a,this.s=t,this.t=o,this.a="proxy-credentials://",this.b=new Map,this.c=void 0,this.f=new Set,this.g=new Map,this.u()}u(){const S=v.Event.fromNodeEventEmitter(i.app,"login",(k,s,a,t,o)=>({event:k,authInfo:{...t,attempt:a.firstAuthAttempt?1:2},callback:o}));this.B(S(this.w,this))}async lookupAuthorization(S){return this.w({authInfo:S})}async w({event:S,authInfo:k,callback:s}){if(!k.isProxy)return;S?.preventDefault();const a=String((0,D.$yj)({scheme:k.scheme,host:k.host,port:k.port}));let t,o=this.b.get(a);if(o)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),t=await o;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),o=this.y(k,a),this.b.set(a,o);try{t=await o}finally{this.b.delete(a)}}return s?.(t?.username,t?.password),t}async y(S,k){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const s=await this.z(S,k);if(s)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),s;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async z(S,k){if(this.h.trace("auth#doResolveProxyCredentials - enter",S),this.t.extensionTestsLocationURI){const h=this.s.getValue("integration-test.http.proxyAuth");if(h){const P=h.indexOf(":");return P!==-1?{username:h.substring(0,P),password:h.substring(P+1)}:{username:h,password:""}}return}const s=(this.s.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(s?.indexOf("@")!==-1){const h=I.URI.parse(s),P=h.authority.indexOf("@");if(P!==-1){if(S.attempt>1){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - ignoring previously used config/envvar credentials");return}this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found config/envvar credentials to use");const w=h.authority.substring(0,P),R=w.indexOf(":");return R!==-1?{username:w.substring(0,R),password:w.substring(R+1)}:{username:w,password:""}}}const a=S.attempt===1&&this.g.get(k);if(a){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found session credentials to use");const{username:h,password:P}=a;return{username:h,password:P}}let t,o;try{const h=this.r.get(this.a+k,d.StorageScope.APPLICATION);if(h){const P=JSON.parse(await this.n.decrypt(h));t=P.username,o=P.password}}catch(h){this.h.error(h)}if(S.attempt===1&&typeof t=="string"&&typeof o=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.g.set(k,{username:t,password:o}),{username:t,password:o};const n=this.c,c=this.c=(async()=>{await n;const h=await this.C(S,k,t,o);return this.c===c&&(this.c=void 0),h})();return c}async C(S,k,s,a){if(this.f.has(k)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - login dialog was cancelled before, not showing again");return}const t=this.m.getFocusedWindow()||this.m.getLastActiveWindow();if(!t){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${t.id} to handle proxy login`);const o=this.g.get(k),n={authInfo:S,username:o?.username??s,password:o?.password??a,replyChannel:`vscode:proxyAuthResponse:${(0,b.$7g)()}`};t.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,n);const c=await new Promise(h=>{const P=async(w,R,T)=>{if(R===n.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${t.id}`),t.win?.webContents.off("ipc-message",P),T){const A={username:T.username,password:T.password};try{if(T.remember){const L=await this.n.encrypt(JSON.stringify(A));this.r.store(this.a+k,L,d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}else this.r.remove(this.a+k,d.StorageScope.APPLICATION)}catch(L){this.h.error(L)}h({username:A.username,password:A.password})}else this.f.add(k),h(void 0)};t.win?.webContents.on("ipc-message",P)});return this.g.set(k,c),c}};e.$Phc=E,e.$Phc=E=ke([se(0,p.$fk),se(1,y.$lhc),se(2,m.$$Y),se(3,f.$Mhc),se(4,l.$ej),se(5,u.$$gc)],E)}),define(le[266],ue([0,1,2,19,52,58,30,8,29]),function(G,e,i,r,v,D,O,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;let l=class extends i.$Zc{constructor(u,$,p){super(),this.a=$,this.b=p,this.B(u.onWillLoadWindow(d=>{d.reason===v.LoadReason.LOAD&&this.c(d.window)})),this.B(u.onBeforeCloseWindow(d=>this.c(d))),this.B(new I.$Wh(()=>this.g(),30*1e3)).schedule()}async c(u){const $=this.f(u),p=this.a.getProfileForWorkspace($);p?.isTransient&&(this.a.unsetWorkspace($,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f(u){return u.openedWorkspace??(0,O.$Yi)(u.backupPath,u.isExtensionDevelopmentHost)}g(){const u=this.a.getAssociatedEmptyWindows();if(u.length===0)return;const $=this.b.getWindows().map(p=>this.f(p));for(const p of u)$.some(d=>d.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$Vic=l,e.$Vic=l=ke([se(0,r.$Ehc),se(1,D.$ohc),se(2,b.$lhc)],l)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[64],ue([0,1,13,2,4,5,286,8,11,29,81,24,19,82,37,3,109,12]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=e.$Shc=void 0,m=Ge(m);function S(a){return typeof a.responseWindowId=="number"}let k=class extends r.$Zc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(t,o,n){super(),this.w=t,this.y=o,this.z=n,this.c=String(++g.a),this.f=this.B(new v.$qe),this.onStdout=this.f.event,this.g=this.B(new v.$qe),this.onStderr=this.g.event,this.h=this.B(new v.$qe),this.onMessage=this.h.event,this.j=this.B(new v.$qe),this.onSpawn=this.j.event,this.m=this.B(new v.$qe),this.onExit=this.m.event,this.n=this.B(new v.$qe),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(t,o){let n;switch(this.t?.correlationId?n=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:n=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case m.default.Error:this.w.error(n);break;case m.default.Warning:this.w.warn(n);break;case m.default.Info:this.w.trace(n);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(t){const o=this.F(t);return o&&t.payload&&this.postMessage(t.payload)&&this.C("payload sent via postMessage()",m.default.Info),o}F(t){if(!this.D())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,n=b.$5g.asFileUri("bootstrap-fork.js").fsPath,c=this.t.args??[],h=this.t.execArgv??[],P=this.t.allowLoadingUnsignedLibraries,w=this.t.forceAllocationsToV8Sandbox,R=this.t.respondToAuthRequestsFromMainProcess,T="pipe",A=this.G(t);return this.C("creating new...",m.default.Info),this.r=i.utilityProcess.fork(n,c,(0,E.$Bg)({serviceName:o,env:A,execArgv:h,allowLoadingUnsignedLibraries:P,forceAllocationsToV8Sandbox:w,respondToAuthRequestsFromMainProcess:R,stdio:T})),this.H(this.r,this.t,o),!0}G(t){const o=t.env?{...t.env}:{...(0,d.$ko)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,f.$l&&((0,y.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,y.getUNCHostAllowlist)().join("\\")),(0,p.$rm)(o);for(const n of Object.keys(o))o[n]=String(o[n]);return o}H(t,o,n){if(t.stdout){const c=new O.StringDecoder("utf-8");this.B(v.Event.fromNodeEventEmitter(t.stdout,"data")(h=>this.f.fire(typeof h=="string"?h:c.write(h))))}if(t.stderr){const c=new O.StringDecoder("utf-8");this.B(v.Event.fromNodeEventEmitter(t.stderr,"data")(h=>this.g.fire(typeof h=="string"?h:c.write(h))))}this.B(v.Event.fromNodeEventEmitter(t,"message")(c=>this.h.fire(c))),this.B(v.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&g.b.set(t.pid,{pid:t.pid,name:S(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.C("successfully created",m.default.Info),this.j.fire(t.pid)})),this.B(v.Event.fromNodeEventEmitter(t,"exit")(c=>{const h=this.I(c)?0:c;this.C(`received exit event with code ${h}`,m.default.Info),this.m.fire({pid:this.s,code:h,signal:"unknown"}),this.J()})),this.B(v.Event.fromNodeEventEmitter(i.app,"child-process-gone",(c,h)=>({event:c,details:h}))(({details:c})=>{c.type==="Utility"&&c.name===n&&!this.I(c.exitCode)&&(this.C(`crashed with code ${c.exitCode} and reason '${c.reason}'`,m.default.Error),this.y.publicLog2("utilityprocesscrash",{type:o.type,reason:c.reason,code:c.exitCode}),this.n.fire({pid:this.s,code:c.exitCode,reason:c.reason}),this.J())}))}once(t,o){const n=this.B(this.h.event(c=>{c===t&&(n.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:n}=new i.MessageChannelMain;return this.postMessage(t,[n]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",m.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",m.default.Info),this.r.kill()?(this.C("successfully killed the process",m.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",m.default.Warning)}I(t){return t===0?!0:this.u&&t===15}J(){typeof this.s=="number"&&g.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.C("waiting to exit...",m.default.Info),await Promise.race([v.Event.toPromise(this.onExit),(0,I.$Lh)(t)]),this.r&&(this.C(`did not exit within ${t}ms, will kill it now...`,m.default.Info),this.kill()))}};e.$Shc=k,e.$Shc=k=g=ke([se(0,D.$fk),se(1,u.$em),se(2,$.$Ehc)],k);let s=class extends k{constructor(t,o,n,c){super(t,n,c),this.L=o}start(t){const o=this.L.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.F(t))return!1;this.M(o.win,t);const c=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[c]),!0}M(t,o){o.windowLifecycleBound&&(this.B(v.Event.filter(this.z.onWillLoadWindow,n=>n.window.win===t)(()=>this.kill())),this.B(v.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$Thc=s,e.$Thc=s=ke([se(0,D.$fk),se(1,l.$lhc),se(2,u.$em),se(3,$.$Ehc)],s)}),define(le[267],ue([0,1,8,15,4,2,19,5,24,64,29]),function(G,e,i,r,v,D,O,I,b,l,m){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;let $=class extends D.$Zc{static{u=this}static{this.a=0}constructor(d,f,y,E){super(),this.f=d,this.g=f,this.h=y,this.j=E,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(d){const f=this.b.get(d);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(d){return this.m(d).onStdout}onDynamicStderr(d){return this.m(d).onStderr}onDynamicMessage(d){return this.m(d).onMessage}onDynamicExit(d){return this.m(d).onExit}async createExtensionHost(){if(this.c)throw(0,r.$0)();const d=String(++u.a),f=new l.$Thc(this.f,this.h,this.j,this.g);this.b.set(d,f);const y=f.onExit(({pid:E,code:g,signal:S})=>{y.dispose(),this.f.info(`Extension host with pid ${E} exited with code: ${g}, signal: ${S}.`),setTimeout(()=>{f.dispose(),this.b.delete(d)}),setTimeout(()=>{try{process.kill(E,0),this.f.error(`Extension host with pid ${E} still exists, forcefully killing it...`),process.kill(E)}catch{}},1e3)});return{id:d}}async start(d,f){if(this.c)throw(0,r.$0)();const y=this.m(d);return y.start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,respondToAuthRequestsFromMainProcess:!0,correlationId:d}),{pid:await v.Event.toPromise(y.onSpawn)}}async enableInspectPort(d){if(this.c)throw(0,r.$0)();const f=this.b.get(d);return f?f.enableInspectPort():!1}async kill(d){if(this.c)throw(0,r.$0)();const f=this.b.get(d);f&&f.kill()}async _killAllNow(){for(const[,d]of this.b)d.kill()}async _waitForAllExit(d){const f=[];for(const[,y]of this.b)f.push(y.waitForExit(d));return i.Promises.settled(f).then(()=>{})}};e.$1hc=$,e.$1hc=$=u=ke([se(0,I.$fk),se(1,O.$Ehc),se(2,m.$lhc),se(3,b.$em)],$)}),define(le[268],ue([0,1,35,8,2,20,19,5,42,40,72,64,57,98,12,220,4]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;let E=class extends v.$Zc{constructor(S,k,s,a,t,o,n,c,h){super(),this.g=S,this.h=k,this.j=s,this.m=a,this.n=t,this.r=o,this.s=n,this.t=c,this.u=h,this.a=new r.$Jh,this.b=void 0,this.c=void 0,this.f=this.B(new y.$qe),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){i.$pY.on(f.$ric.request,(S,k)=>this.y(S,k,f.$ric.response)),i.$pY.on(f.$sic.request,(S,k)=>this.y(S,k,f.$sic.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(S,k,s){this.s.trace(`[SharedProcess] onWindowConnection for: ${s}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(s);if(S.sender.isDestroyed())return a.close();S.sender.postMessage(s,k,[a])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(f.$qic.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const S=new r.$8h;this.b?.once(f.$qic.initDone,()=>S.complete()),await S.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const S=new r.$8h;this.b?.once(f.$qic.ipcReady,()=>S.complete()),await S.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new u.$Shc(this.s,$.$Fp,this.r)),this.c=this.b.onMessage(s=>{typeof s.warning=="string"?this.s.warn(s.warning):typeof s.error=="string"&&this.s.error(s.error)});const S=(0,p.$en)(this.m.args,this.m.isBuilt);let k;S.port&&(k=["--nolazy"],S.break?k.push(`--inspect-brk=${S.port}`):k.push(`--inspect=${S.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:k}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(S){return await this.F,(0,d.$ug)(this.b).connect(S)}};e.$tic=E,e.$tic=E=ke([se(3,D.$$gc),se(4,b.$Rl),se(5,O.$Ehc),se(6,I.$fk),se(7,m.$zhc),se(8,l.$zo)],E)}),define(le[269],ue([0,1,20,98,19,5,57,76,64,122,35,2,4,37,16,11]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;let y=class extends u.$Zc{constructor(g,S,k,s,a){super(),this.f=g,this.g=S,this.h=k,this.j=s,this.m=a,this.a=void 0,this.b=new $.$qe,this.onRequestConnection=this.b.event,this.c=new $.$qe,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),m.$pY.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,u.$Xc)(()=>{m.$pY.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new b.$Shc(this.m,O.$Fp,this.j);const g=(0,r.$dn)(this.h.args,this.h.isBuilt),S=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:S,args:["--logsPath",this.h.logsHome.with({scheme:f.Schemas.file}).fsPath],env:this.n()});const k=this.a.connect(),s=new l.$xY(k,"ptyHost"),a=new u.$Yc;return a.add(s),a.add((0,u.$Xc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:s,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,p.$ko)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},S=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);S&&typeof S=="number"&&(g.VSCODE_LATENCY=String(S));const k=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return k&&typeof k=="number"&&(g.VSCODE_STARTUP_DELAY=String(k)),this.h.restoreSnapExportedVariables(),g}r(g,S){this.b.fire();const k=this.a.connect();if(g.sender.isDestroyed()){k.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",S,[k])}};e.$8ic=y,e.$8ic=y=ke([se(1,d.$ej),se(2,i.$$gc),se(3,v.$Ehc),se(4,D.$fk)],y)}),define(le[270],ue([0,1,2,6,5,29,64,24,48,4,8,19]),function(G,e,i,r,v,D,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=e.$6ic=void 0,e.$6ic=(0,r.$Ki)("utilityProcessWorker");let $=class extends i.$Zc{constructor(f,y,E,g){super(),this.b=f,this.c=y,this.f=E,this.g=g,this.a=new Map}async createWorker(f){const y=`window: ${f.reply.windowId}, moduleId: ${f.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${y})`);const E=this.h(f);this.a.has(E)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${y})`),this.disposeWorker(f));const g=new p(this.b,this.c,this.f,this.g,f);if(!g.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(E,g);const S=new m.$8h;return l.Event.once(g.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete(E),S.complete({reason:k})}),S.p}h(f){return(0,b.$yj)({moduleId:f.process.moduleId,windowId:f.reply.windowId})}async disposeWorker(f){const y=this.h(f),E=this.a.get(y);E&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${f.reply.windowId}, moduleId: ${f.process.moduleId})`),E.kill(),E.dispose(),this.a.delete(y))}};e.$7ic=$,e.$7ic=$=ke([se(0,v.$fk),se(1,D.$lhc),se(2,I.$em),se(3,u.$Ehc)],$);let p=class extends i.$Zc{constructor(f,y,E,g,S){super(),this.c=f,this.f=y,this.g=E,this.h=g,this.j=S,this.a=this.B(new l.$qe),this.onDidTerminate=this.a.event,this.b=this.B(new O.$Thc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(f=>this.a.fire({code:f.code,signal:f.signal}))),this.B(this.b.onCrash(f=>this.a.fire({code:f.code,signal:"ECRASH"})))}spawn(){const y=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:y,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};p=ke([se(0,v.$fk),se(1,D.$lhc),se(2,I.$em),se(3,u.$Ehc)],p)}),define(le[271],ue([0,1,13,4,2,245,29]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;let I=class extends v.$Zc{constructor(l){super(),this.b=l,this.a=this.B(new r.$qe),this.onFoundInFrame=this.a.event,this.B(new D.$Kic)}async setIgnoreMenuShortcuts(l,m){let u;if(typeof l.windowId=="number"){const{windowId:$}=l,p=this.b.getWindowById($);if(!p?.win)throw new Error(`Invalid windowId: ${$}`);u=p.win.webContents}else{const{webContentsId:$}=l;if(u=i.webContents.fromId($),!u)throw new Error(`Invalid webContentsId: ${$}`)}u.isDestroyed()||u.setIgnoreMenuShortcuts(m)}async findInFrame(l,m,u,$){const d=this.c(l,m);if(typeof d.findInFrame=="function"){d.findInFrame(u,{findNext:$.findNext,forward:$.forward});const f=(y,E)=>{E.finalUpdate&&(this.a.fire(E),d.removeListener("found-in-frame",f))};d.on("found-in-frame",f)}}async stopFindInFrame(l,m,u){const p=this.c(l,m);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(u.keepSelection?"keepSelection":"clearSelection")}c(l,m){const u=this.b.getWindowById(l.windowId);if(!u?.win)throw new Error(`Invalid windowId: ${l}`);const $=u.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===m);if(!$)throw new Error(`Unknown frame: ${m}`);return $}};e.$Lic=I,e.$Lic=I=ke([se(0,O.$lhc)],I)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[272],ue([0,1,13,2,3,18,7,16,19,5,34,29,52,30]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=void 0,e.$Nic=y,e.$Oic=g,i=Ge(i);let f=class extends r.$Zc{static{d=this}static{this.a="windowsState"}get state(){return this.b}constructor(s,a,t,o,n){super(),this.g=s,this.h=a,this.j=t,this.m=o,this.n=n,this.b=y(this.h.getItem(d.a)),this.c=void 0,this.f=!1,this.r()}r(){i.default.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(s=>this.u(s))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(s=>{s.newCount-s.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(s=>this.u(s)))}s(){this.f=!0,this.t()}t(){const s=new Set,a={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!a.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(c=>!c.isExtensionDevelopmentHost)),n&&(a.lastActiveWindow=this.w(n),a.lastActiveWindow.uiState.mode===$.WindowMode.Fullscreen&&s.add(a.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);t&&(a.lastPluginDevelopmentHostWindow=this.w(t),a.lastPluginDevelopmentHostWindow.uiState.mode===$.WindowMode.Fullscreen&&(s.has(a.lastPluginDevelopmentHostWindow.uiState.display)?v.$m&&!t.win?.isSimpleFullScreen()&&(a.lastPluginDevelopmentHostWindow.uiState.mode=$.WindowMode.Normal):s.add(a.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(a.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const c=this.w(n);return c.uiState.mode===$.WindowMode.Fullscreen&&(s.has(c.uiState.display)?v.$m&&c.windowId!==a.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(c.uiState.mode=$.WindowMode.Normal):s.add(c.uiState.display)),c}));const o=g(a);this.h.setItem(d.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(s){if(this.j.quitRequested)return;const a=this.w(s);s.isExtensionDevelopmentHost&&!s.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=a:!s.isExtensionDevelopmentHost&&s.openedWorkspace&&this.b.openedWindows.forEach(t=>{const o=(0,p.$Zi)(s.openedWorkspace)&&t.workspace?.id===s.openedWorkspace.id,n=(0,p.$Ui)(s.openedWorkspace)&&t.folderUri&&D.$ch.isEqual(t.folderUri,s.openedWorkspace.uri);(o||n)&&(t.uiState=a.uiState)}),this.g.getWindowCount()===1&&(this.c=a)}w(s){return{windowId:s.id,workspace:(0,p.$Zi)(s.openedWorkspace)?s.openedWorkspace:void 0,folderUri:(0,p.$Ui)(s.openedWorkspace)?s.openedWorkspace.uri:void 0,backupPath:s.backupPath,remoteAuthority:s.remoteAuthority,uiState:s.serializeWindowState()}}getNewWindowState(s){const a=this.z(s),t=this.n.getValue("window");if(a.mode===$.WindowMode.Fullscreen){let o;a.hasDefaultState?o=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||t?.restoreFullscreen),o||(a.mode=$.WindowMode.Normal)}return a}z(s){const a=this.g.getLastActiveWindow();if(!s.extensionTestsPath){if(s.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const P=s.workspace;if((0,p.$Zi)(P)){const R=this.state.openedWindows.filter(T=>T.workspace&&T.workspace.id===P.id).map(T=>T.uiState);if(R.length)return R[0]}if((0,p.$Ui)(P)){const R=this.state.openedWindows.filter(T=>T.folderUri&&D.$ch.isEqual(T.folderUri,P.uri)).map(T=>T.uiState);if(R.length)return R[0]}else if(s.backupPath){const R=this.state.openedWindows.filter(T=>T.backupPath===s.backupPath).map(T=>T.uiState);if(R.length)return R[0]}const w=this.c||this.state.lastActiveWindow;if(!a&&w)return w.uiState}let t;const o=i.default.screen.getAllDisplays();if(o.length===1)t=o[0];else{if(v.$m){const P=i.default.screen.getCursorScreenPoint();t=i.default.screen.getDisplayNearestPoint(P)}!t&&a&&(t=i.default.screen.getDisplayMatching(a.getBounds())),t||(t=i.default.screen.getPrimaryDisplay()||o[0])}let n=(0,$.$ahc)();n.x=Math.round(t.bounds.x+t.bounds.width/2-n.width/2),n.y=Math.round(t.bounds.y+t.bounds.height/2-n.height/2);const c=this.n.getValue("window");let h=!0;if(c?.newWindowDimensions){if(c.newWindowDimensions==="maximized")n.mode=$.WindowMode.Maximized,h=!1;else if(c.newWindowDimensions==="fullscreen")n.mode=$.WindowMode.Fullscreen,h=!1;else if((c.newWindowDimensions==="inherit"||c.newWindowDimensions==="offset")&&a){const P=a.serializeWindowState();P.mode===$.WindowMode.Fullscreen?n.mode=$.WindowMode.Fullscreen:n={...P,zoomLevel:void 0},h=n.mode!==$.WindowMode.Fullscreen&&c.newWindowDimensions==="offset"}}return h&&(n=this.C(n)),n.hasDefaultState=!0,n}C(s){if(this.g.getWindows().length===0)return s;s.x=typeof s.x=="number"?s.x:0,s.y=typeof s.y=="number"?s.y:0;const a=this.g.getWindows().map(t=>t.getBounds());for(;a.some(t=>t.x===s.x||t.y===s.y);)s.x+=30,s.y+=30;return s}};e.$Mic=f,e.$Mic=f=d=ke([se(0,u.$lhc),se(1,m.$5R),se(2,b.$Ehc),se(3,l.$fk),se(4,I.$ej)],f);function y(k){const s={openedWindows:[]},a=k||{openedWindows:[]};return a.lastActiveWindow&&(s.lastActiveWindow=E(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(s.lastPluginDevelopmentHostWindow=E(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(s.openedWindows=a.openedWindows.map(t=>E(t))),s}function E(k){const s={uiState:k.uiState};return k.backupPath&&(s.backupPath=k.backupPath),k.remoteAuthority&&(s.remoteAuthority=k.remoteAuthority),k.folder&&(s.folderUri=O.URI.parse(k.folder)),k.workspaceIdentifier&&(s.workspace={id:k.workspaceIdentifier.id,configPath:O.URI.parse(k.workspaceIdentifier.configURIPath)}),s}function g(k){return{lastActiveWindow:k.lastActiveWindow&&S(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&S(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(s=>S(s))}}function S(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[59],ue([0,1,26,13,4,43,2,11,10,18,23,9,70,53,20,6,5,58,137,30,105,106]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=e.$xhc=void 0,i=Ie(i),r=Ge(r),e.$xhc=(0,f.$Ki)("workspacesManagementMainService");let a=class extends O.$Zc{constructor(o,n,c,h,P){super(),this.g=o,this.h=n,this.j=c,this.m=h,this.n=P,this.a=this.B(new v.$qe),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new v.$qe),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await m.Promises.readdir(this.c.with({scheme:I.Schemas.file}).fsPath)).map(n=>(0,l.$lh)(this.c,n,S.$0i));for(const n of o){const c=(0,s.$uhc)(n),h=await this.resolveLocalWorkspace(n);h?this.f.push({workspace:c,remoteAuthority:h.remoteAuthority}):await this.deleteUntitledWorkspace(c)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,n=>i.promises.readFile(n,"utf8"))}r(o,n){if(this.s(o)&&o.scheme===I.Schemas.file)try{const c=n(o.fsPath);return c instanceof Promise?c.then(h=>this.t(o,h),h=>{}):this.t(o,c)}catch{return}}s(o){return(0,S.$$i)(o,this.g)||(0,S.$dj)(o)}t(o,n){try{const c=this.u(o,n),h=(0,s.$uhc)(o);return{id:h.id,configPath:h.configPath,folders:(0,k.$Yib)(c.folders,h.configPath,l.$ch),remoteAuthority:c.remoteAuthority,transient:c.transient}}catch(c){this.h.warn(c.toString())}}u(o,n){const c=(0,D.$5n)(n);if(c&&Array.isArray(c.folders))c.folders=c.folders.filter(h=>(0,k.$Wib)(h));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return c}async createUntitledWorkspace(o,n){const{workspace:c,storedWorkspace:h}=this.w(o,n),P=c.configPath.fsPath;return await i.promises.mkdir((0,b.$rc)(P),{recursive:!0}),await m.Promises.writeFile(P,JSON.stringify(h,null,"	")),this.f.push({workspace:c,remoteAuthority:n}),c}w(o=[],n){const c=(Date.now()+Math.round(Math.random()*1e3)).toString(),h=(0,l.$lh)(this.c,c),P=(0,l.$lh)(h,S.$0i),w=[];for(const R of o)w.push((0,k.$Xib)(R.uri,!0,R.name,h,l.$ch));return{workspace:(0,s.$uhc)(P),storedWorkspace:{folders:w,remoteAuthority:n}}}async getWorkspaceIdentifier(o){return(0,s.$uhc)(o)}isUntitledWorkspace(o){return(0,S.$$i)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const n=(0,l.$_g)(o.configPath);try{await m.Promises.rm((0,b.$rc)(n));const c=(0,b.$oc)(this.g.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath,o.id);await m.Promises.exists(c)&&await m.Promises.writeFile((0,b.$oc)(c,"obsolete"),""),this.f=this.f.filter(h=>h.workspace.id!==o.id)}catch(c){this.h.warn(`Unable to delete untitled workspace ${n} (${c}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,n,c){if(!o||!o.win||!o.isReady||!await this.z(o,n,c))return;const P=await this.C(o,(0,s.$uhc)(c));if(P)return this.b.fire({window:o,workspace:P.workspace}),P}async z(o,n,c){return c?(0,S.$Zi)(o.openedWorkspace)&&l.$ch.isEqual(o.openedWorkspace.configPath,c)?!1:(0,g.$rhc)(n,c)?(await this.n.showMessageBox({type:"info",buttons:[(0,u.localize)(2500,null)],message:(0,u.localize)(2501,null,(0,l.$ih)(c)),detail:(0,u.localize)(2502,null)},r.default.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,n){if(!o.config)return;o.focus();let c;return o.config.extensionDevelopmentPath||(o.config.backupPath?c=await this.m.registerWorkspaceBackup({workspace:n,remoteAuthority:o.remoteAuthority},o.config.backupPath):c=this.m.registerWorkspaceBackup({workspace:n,remoteAuthority:o.remoteAuthority})),(0,S.$Zi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=n,o.config.backupPath=c,{workspace:n,backupPath:c}}};e.$yhc=a,e.$yhc=a=ke([se(0,d.$$gc),se(1,y.$fk),se(2,E.$ohc),se(3,$.$fhc),se(4,p.$ghc)],a)}),define(le[139],ue([0,1,13,35,22,6,29,30,59,12,5,64]),function(G,e,i,r,v,D,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=e.$Vhc=e.ID=void 0,e.ID="diagnosticsMainService",e.$Vhc=(0,D.$Ki)(e.ID);let $=class{constructor(d,f,y){this.a=d,this.b=f,this.c=y}async getRemoteDiagnostics(d){const f=this.a.getWindows();return(await Promise.all(f.map(async E=>{const g=E.remoteAuthority;if(!g)return;const S=`vscode:getDiagnosticInfoResponse${E.id}`,k={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?await this.f(E):void 0};return new Promise(s=>{E.sendWhenReady("vscode:getDiagnosticInfo",v.CancellationToken.None,{replyChannel:S,args:k}),r.$pY.once(S,(a,t)=>{t||s({hostName:g,errorMessage:`Unable to resolve connection to '${g}'.`}),s(t)}),setTimeout(()=>{s({hostName:g,errorMessage:`Connection to '${g}' could not be established`})},5e3)})}))).filter(E=>!!E)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const d=[];for(const y of i.BrowserWindow.getAllWindows()){const E=this.a.getWindowById(y.id);E?d.push(await this.d(E)):d.push(this.e(y))}const f=[];for(const{pid:y,name:E}of u.$Shc.getAll())f.push({pid:y,name:E});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,pidToNames:f,screenReader:!!i.app.accessibilitySupportEnabled,gpuFeatureStatus:i.app.getGPUFeatureStatus()}}async d(d){const f=await this.f(d),y=(0,l.$ug)(d.win);return this.e(y,f,d.remoteAuthority)}e(d,f=[],y){return{id:d.id,pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:f,remoteAuthority:y}}async f(d){const f=[],y=d.openedWorkspace;if((0,I.$Ui)(y))f.push(y.uri);else if((0,I.$Zi)(y)){const E=await this.b.resolveLocalWorkspace(y.configPath);E&&E.folders.forEach(S=>{f.push(S.uri)})}return f}};e.$Whc=$,e.$Whc=$=ke([se(0,O.$lhc),se(1,b.$xhc),se(2,m.$fk)],$)}),define(le[65],ue([0,1,26,44,13,27,162,54,4,2,11,10,3,7,117,95,23,114,9,53,20,6,19,5,28,77,47,29,30,59,17,216,206,85,15,16,138,50]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k,s,a,t,o,n,c,h,P,w,R,T,A,L,M,V,q,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=e.$$hc=void 0,i=Ie(i),e.$$hc=(0,s.$Ki)("nativeHostMainService");let de=class extends l.$Zc{constructor(ee,W,Z,C,B,F,z,ie,x,ce,oe,te){super(),this.a=ee,this.b=W,this.c=Z,this.f=C,this.g=B,this.h=F,this.j=z,this.m=ie,this.n=x,this.r=ce,this.s=oe,this.t=te,this.onDidOpenMainWindow=b.Event.map(this.a.onDidOpenWindow,j=>j.id),this.onDidTriggerWindowSystemContextMenu=b.Event.any(b.Event.map(this.a.onDidTriggerSystemContextMenu,({window:j,x:X,y:U})=>({windowId:j.id,x:X,y:U})),b.Event.map(this.b.onDidTriggerSystemContextMenu,({window:j,x:X,y:U})=>({windowId:j.id,x:X,y:U}))),this.onDidMaximizeWindow=b.Event.any(b.Event.map(this.a.onDidMaximizeWindow,j=>j.id),b.Event.map(this.b.onDidMaximizeWindow,j=>j.id)),this.onDidUnmaximizeWindow=b.Event.any(b.Event.map(this.a.onDidUnmaximizeWindow,j=>j.id),b.Event.map(this.b.onDidUnmaximizeWindow,j=>j.id)),this.onDidChangeWindowFullScreen=b.Event.any(b.Event.map(this.a.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen})),b.Event.map(this.b.onDidChangeFullScreen,j=>({windowId:j.window.id,fullscreen:j.fullscreen}))),this.onDidBlurMainWindow=b.Event.filter(b.Event.fromNodeEventEmitter(v.app,"browser-window-blur",(j,X)=>X.id),j=>!!this.a.getWindowById(j)),this.onDidFocusMainWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),j=>!!j),j=>j.id),b.Event.filter(b.Event.fromNodeEventEmitter(v.app,"browser-window-focus",(j,X)=>X.id),j=>!!this.a.getWindowById(j))),this.onDidBlurMainOrAuxiliaryWindow=b.Event.any(this.onDidBlurMainWindow,b.Event.map(b.Event.filter(b.Event.fromNodeEventEmitter(v.app,"browser-window-blur",(j,X)=>this.b.getWindowByWebContents(X.webContents)),j=>!!j),j=>j.id)),this.onDidFocusMainOrAuxiliaryWindow=b.Event.any(this.onDidFocusMainWindow,b.Event.map(b.Event.filter(b.Event.fromNodeEventEmitter(v.app,"browser-window-focus",(j,X)=>this.b.getWindowByWebContents(X.webContents)),j=>!!j),j=>j.id)),this.onDidResumeOS=b.Event.fromNodeEventEmitter(v.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.u=this.B(new b.$qe),this.onDidChangePassword=this.u.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(v.screen,"display-metrics-changed",(j,X,U)=>U),j=>!(Array.isArray(j)&&j.length===1&&j[0]==="workArea")),b.Event.fromNodeEventEmitter(v.screen,"display-added"),b.Event.fromNodeEventEmitter(v.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(ee,W){const Z=this.a.getWindows().map(B=>({id:B.id,workspace:B.openedWorkspace??(0,P.$Yi)(B.backupPath,B.isExtensionDevelopmentHost),title:B.win?.getTitle()??"",filename:B.getRepresentedFilename(),dirty:B.isDocumentEdited()})),C=[];return W.includeAuxiliaryWindows&&C.push(...this.b.getWindows().map(B=>({id:B.id,parentId:B.parentId,title:B.win?.getTitle()??"",filename:B.getRepresentedFilename()}))),[...Z,...C]}async getWindowCount(ee){return this.a.getWindowCount()}async getActiveWindowId(ee){const W=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(W)return W.id}async getActiveWindowPosition(){const ee=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(ee)return ee.getBounds()}openWindow(ee,W,Z){return Array.isArray(W)?this.w(ee,W,Z):this.z(ee,W)}async w(ee,W,Z=Object.create(null)){W.length>0&&await this.a.open({context:h.OpenContext.API,contextWindowId:ee,urisToOpen:W,cli:this.g.args,forceNewWindow:Z.forceNewWindow,forceReuseWindow:Z.forceReuseWindow,preferNewWindow:Z.preferNewWindow,diffMode:Z.diffMode,mergeMode:Z.mergeMode,addMode:Z.addMode,gotoLineMode:Z.gotoLineMode,noRecentEntry:Z.noRecentEntry,waitMarkerFileURI:Z.waitMarkerFileURI,remoteAuthority:Z.remoteAuthority||void 0,forceProfile:Z.forceProfile,forceTempProfile:Z.forceTempProfile})}async z(ee,W){await this.a.openEmptyWindow({context:h.OpenContext.API,contextWindowId:ee},W)}async isFullScreen(ee,W){return this.H(W?.targetWindowId,ee)?.isFullScreen??!1}async toggleFullScreen(ee,W){this.H(W?.targetWindowId,ee)?.toggleFullScreen()}async handleTitleDoubleClick(ee,W){this.H(W?.targetWindowId,ee)?.handleTitleDoubleClick()}async getCursorScreenPoint(ee){const W=v.screen.getCursorScreenPoint(),Z=v.screen.getDisplayNearestPoint(W);return{point:W,display:Z.bounds}}async isMaximized(ee,W){return this.H(W?.targetWindowId,ee)?.win?.isMaximized()??!1}async maximizeWindow(ee,W){this.H(W?.targetWindowId,ee)?.win?.maximize()}async unmaximizeWindow(ee,W){this.H(W?.targetWindowId,ee)?.win?.unmaximize()}async minimizeWindow(ee,W){this.H(W?.targetWindowId,ee)?.win?.minimize()}async moveWindowTop(ee,W){this.H(W?.targetWindowId,ee)?.win?.moveTop()}async positionWindow(ee,W,Z){const C=this.H(Z?.targetWindowId,ee);if(C?.win){if(C.win.isFullScreen()){const B=b.Event.toPromise(b.Event.once(b.Event.fromNodeEventEmitter(C.win,"leave-full-screen")));C.win.setFullScreen(!1),await B}C.win.setBounds(W)}}async updateWindowControls(ee,W){this.H(W?.targetWindowId,ee)?.updateWindowControls(W)}async focusWindow(ee,W){this.H(W?.targetWindowId,ee)?.focus({force:W?.force??!1})}async setMinimumSize(ee,W,Z){const C=this.I(ee);if(C?.win){const[B,F]=C.win.getSize(),[z,ie]=C.win.getMinimumSize(),[x,ce]=[W??z,Z??ie],[oe,te]=[Math.max(B,x),Math.max(F,ce)];(z!==x||ie!==ce)&&C.win.setMinimumSize(x,ce),(B!==oe||F!==te)&&C.win.setSize(oe,te)}}async saveWindowSplash(ee,W){this.m.saveWindowSplash(ee,W)}async installShellCommand(ee){const{source:W,target:Z}=await this.C();try{const{symbolicLink:C}=await y.SymlinkSupport.stat(W);if(C&&!C.dangling){const B=await(0,d.$vr)(W);if(Z===B)return}await i.promises.unlink(W)}catch(C){if(C.code!=="ENOENT")throw C}try{await i.promises.symlink(Z,W)}catch(C){if(C.code!=="EACCES"&&C.code!=="ENOENT")throw C;const{response:B}=await this.showMessageBox(ee,{type:"info",message:(0,g.localize)(2004,null,this.j.nameShort),buttons:[(0,g.localize)(2005,null),(0,g.localize)(2006,null)]});if(B===1)throw new M.$9;try{const F=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Z}' '${W}'\\" with administrator privileges"`;await(0,O.promisify)(r.exec)(F)}catch{throw new Error((0,g.localize)(2007,null,W))}}}async uninstallShellCommand(ee){const{source:W}=await this.C();try{await i.promises.unlink(W)}catch(Z){switch(Z.code){case"EACCES":{const{response:C}=await this.showMessageBox(ee,{type:"info",message:(0,g.localize)(2008,null,this.j.nameShort),buttons:[(0,g.localize)(2009,null),(0,g.localize)(2010,null)]});if(C===1)throw new M.$9;try{const B=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,O.promisify)(r.exec)(B)}catch{throw new Error((0,g.localize)(2011,null,W))}break}case"ENOENT":break;default:throw Z}}}async C(){const ee=(0,u.$pc)(this.g.appRoot,"bin","code"),W=`/usr/local/bin/${this.j.applicationName}`;if(!await y.Promises.exists(ee))throw new Error((0,g.localize)(2012,null,ee));return{source:W,target:ee}}async showMessageBox(ee,W){const Z=this.H(W?.targetWindowId,ee);return this.c.showMessageBox(W,Z?.win??void 0)}async showSaveDialog(ee,W){const Z=this.H(W?.targetWindowId,ee);return this.c.showSaveDialog(W,Z?.win??void 0)}async showOpenDialog(ee,W){const Z=this.H(W?.targetWindowId,ee);return this.c.showOpenDialog(W,Z?.win??void 0)}async pickFileFolderAndOpen(ee,W){const Z=await this.c.pickFileFolder(W);Z&&await this.D(await Promise.all(Z.map(async C=>await y.SymlinkSupport.existsDirectory(C)?{folderUri:p.URI.file(C)}:{fileUri:p.URI.file(C)})),W,ee)}async pickFolderAndOpen(ee,W){const Z=await this.c.pickFolder(W);Z&&await this.D(Z.map(C=>({folderUri:p.URI.file(C)})),W,ee)}async pickFileAndOpen(ee,W){const Z=await this.c.pickFile(W);Z&&await this.D(Z.map(C=>({fileUri:p.URI.file(C)})),W,ee)}async pickWorkspaceAndOpen(ee,W){const Z=await this.c.pickWorkspace(W);Z&&await this.D(Z.map(C=>({workspaceUri:p.URI.file(C)})),W,ee)}async D(ee,W,Z){await this.a.open({context:h.OpenContext.DIALOG,contextWindowId:Z,cli:this.g.args,urisToOpen:ee,forceNewWindow:W.forceNewWindow})}async showItemInFolder(ee,W){v.shell.showItemInFolder(W)}async setRepresentedFilename(ee,W,Z){this.H(Z?.targetWindowId,ee)?.setRepresentedFilename(W)}async setDocumentEdited(ee,W,Z){this.H(Z?.targetWindowId,ee)?.setDocumentEdited(W)}async openExternal(ee,W,Z){this.g.unsetSnapExportedVariables();try{(0,m.$Ug)(W,m.Schemas.http,m.Schemas.https)?this.F(W,Z):v.shell.openExternal(W)}finally{this.g.restoreSnapExportedVariables()}return!0}async F(ee,W){const Z=W??this.r.getValue("workbench.externalBrowser");if(!Z)return v.shell.openExternal(ee);if((Z.includes(u.$lc.sep)||Z.includes(u.$kc.sep))&&!await y.Promises.exists(Z))return this.h.error(`Configured external browser path does not exist: ${Z}`),v.shell.openExternal(ee);try{const{default:C}=await new Promise((F,z)=>{G(["open"],F,z)}).then(Ie);(await C(ee,{app:{name:Object.hasOwn(C.apps,Z)?C.apps[Z]:Z}})).stderr?.once("data",F=>(this.h.error(`Error openening external URL '${ee}' using browser '${Z}': ${F.toString()}`),v.shell.openExternal(ee)))}catch(C){return this.h.error(`Unable to open external URL '${ee}' using browser '${Z}' due to ${C}.`),v.shell.openExternal(ee)}}moveItemToTrash(ee,W){return v.shell.trashItem(W)}async isAdmin(){let ee;return $.$l?ee=(await new Promise((W,Z)=>{G(["native-is-elevated"],W,Z)}).then(Ie)).default():ee=process.getuid?.()===0,ee}async writeElevated(ee,W,Z,C){const B=await new Promise((F,z)=>{G(["@vscode/sudo-prompt"],F,z)}).then(Ie);return new Promise((F,z)=>{const ie=[`"${this.G}"`];C?.unlock&&ie.push("--file-chmod"),ie.push("--file-write",`"${W.fsPath}"`,`"${Z.fsPath}"`);const x={name:this.j.nameLong.replace("-",""),icns:$.$m&&this.g.isBuilt?(0,u.$oc)((0,u.$rc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};B.exec(ie.join(" "),x,(ce,oe,te)=>{oe&&this.h.trace(`[sudo-prompt] received stdout: ${oe}`),te&&this.h.trace(`[sudo-prompt] received stderr: ${te}`),ce?z(ce):F(void 0)})})}async isRunningUnderARM64Translation(){return $.$n||$.$l?!1:v.app.runningUnderARM64Translation}get G(){return $.$l?this.g.isBuilt?(0,u.$oc)((0,u.$rc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,u.$oc)(this.g.appRoot,"scripts","code-cli.bat"):$.$n?this.g.isBuilt?(0,u.$oc)((0,u.$rc)(process.execPath),"bin",`${this.j.applicationName}`):(0,u.$oc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,u.$oc)(this.g.appRoot,"bin","code"):(0,u.$oc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return f.$Yn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return $.$l&&(0,T.$8hc)()}async getProcessId(ee){return this.H(void 0,ee)?.win?.webContents.getOSProcessId()}async killProcess(ee,W,Z){process.kill(W,Z)}async readClipboardText(ee,W){return v.clipboard.readText(W)}async writeClipboardText(ee,W,Z){return v.clipboard.writeText(W,Z)}async readClipboardFindText(ee){return v.clipboard.readFindText()}async writeClipboardFindText(ee,W){return v.clipboard.writeFindText(W)}async writeClipboardBuffer(ee,W,Z,C){return v.clipboard.writeBuffer(W,Buffer.from(Z.buffer),C)}async readClipboardBuffer(ee,W){return R.$Se.wrap(v.clipboard.readBuffer(W))}async hasClipboard(ee,W,Z){return v.clipboard.has(W,Z)}async newWindowTab(){await this.a.open({context:h.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){v.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){v.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){v.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){v.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){v.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(ee,W){this.I(ee)?.updateTouchBar(W)}async notifyReady(ee){this.I(ee)?.setReady()}async relaunch(ee,W){return this.f.relaunch(W)}async reload(ee,W){const Z=this.I(ee);if(Z){if((0,P.$Zi)(Z.openedWorkspace)){const C=Z.openedWorkspace.configPath;if(C.scheme===m.Schemas.file&&(await this.n.resolveLocalWorkspace(C))?.transient)return this.openWindow(Z.id,{forceReuseWindow:!0})}return this.f.reload(Z,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(ee,W){return this.H(W?.targetWindowId,ee)?.win?.close()}async quit(ee){const W=this.a.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&W.win?W.win.close():this.f.quit()}async exit(ee,W){await this.f.kill(W)}async resolveProxy(ee,W){if(this.g.extensionTestsLocationURI){const B=this.r.getValue("integration-test.http.proxy");if(B)return B}return this.I(ee)?.win?.webContents?.session?.resolveProxy(W)}async lookupAuthorization(ee,W){return this.t.lookupAuthorization(W)}async lookupKerberosAuthorization(ee,W){return this.s.lookupKerberosAuthorization(W)}async loadCertificates(ee){return this.s.loadCertificates()}findFreePort(ee,W,Z,C,B=1){return(0,E.$9g)(W,Z,C,B)}async openDevTools(ee,W){const Z=this.H(W?.targetWindowId,ee);let C;$.$n&&(0,c.$yE)(this.r)&&(C="bottom"),Z?.win?.webContents.openDevTools(C?{mode:C}:void 0)}async toggleDevTools(ee,W){const C=this.H(W?.targetWindowId,ee)?.win?.webContents;C&&($.$n&&(0,c.$yE)(this.r)&&!C.isDevToolsOpened()?C.openDevTools({mode:"bottom"}):C.toggleDevTools())}async profileRenderer(ee,W,Z){const C=this.I(ee);if(!C||!C.win)throw new Error;return await new A.$9hc(C.win,W,this.h).inspect(Z)}async windowsGetStringRegKey(ee,W,Z,C){if(!$.$l)return;const B=await new Promise((F,z)=>{G(["@vscode/windows-registry"],F,z)}).then(Ie);try{return B.GetStringRegKey(W,Z,C)}catch{return}}H(ee,W){return this.I(ee)??this.J(ee)??this.I(W)}I(ee){if(typeof ee=="number")return this.a.getWindowById(ee)}J(ee){if(typeof ee!="number")return;const W=v.webContents.fromId(ee);if(W)return this.b.getWindowByWebContents(W)}};e.$_hc=de,ke([I.$ci],de.prototype,"G",null),e.$_hc=de=ke([se(0,h.$lhc),se(1,L.$0hc),se(2,S.$ghc),se(3,a.$Ehc),se(4,k.$$gc),se(5,t.$fk),se(6,o.$yk),se(7,n.$jhc),se(8,w.$xhc),se(9,V.$ej),se(10,Y.$bq),se(11,q.$Ohc)],de)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[273],ue([0,1,13,27,8,22,2,11,3,35,9,53,20,5,65,73,74,47,29,66,86]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0,f=Ge(f);let a=class{static{s=this}static{this.a="#1E1E1E"}constructor(o,n,c,h,P,w,R,T){this.d=o,this.e=n,this.f=c,this.g=h,this.h=P,this.i=w,this.j=R,this.k=T,this.b=null,this.c=null}async openReporter(o){if(this.b)this.b&&this.l(this.b);else if(this.c=i.BrowserWindow.getFocusedWindow(),this.c){const n=new O.$Yc,c=n.add(this.i.createIPCObjectUrl()),h=this.n(this.c,700,800);this.b=this.m(h,c,{backgroundColor:o.styles.backgroundColor,title:(0,m.localize)(1909,null),zoomLevel:o.zoomLevel,alwaysOnTop:!1},"issue-reporter"),c.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:o,disableExtensions:!!this.e.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:f.default,nls:{messages:(0,m.getNLSMessages)(),language:(0,m.getNLSLanguage)()},cssModules:this.k.isEnabled?await this.k.getCssModules():void 0}),this.b.loadURL(I.$5g.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.${S.$V?"esm.":""}html`).toString(!0)),this.b.on("close",()=>{this.b=null,n.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,n.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(o){this.f.error(o)}}async $showConfirmCloseDialog(){if(this.b){const{response:o}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(1910,null),buttons:[(0,m.localize)(1911,null),(0,m.localize)(1912,null)]},this.b);o===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:o}=await this.g.showMessageBox({type:"warning",message:(0,m.localize)(1913,null),buttons:[(0,m.localize)(1914,null),(0,m.localize)(1915,null)]},this.b);return o===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const o=this.j.getWindowById(this.c.id);if(!o)throw new Error("Window not found");return o}async $sendReporterMenu(o,n){const c=this.issueReporterWindowCheck(),h="vscode:triggerReporterMenu",P=new D.$Be;return c.sendWhenReady(h,P.token,{replyChannel:h,extensionId:o,extensionName:n}),await(0,v.$Bh)(new Promise(R=>l.$pY.once(`vscode:triggerReporterMenuResponse:${o}`,(T,A)=>R(A))),5e3,()=>{this.f.error(`Error: Extension ${o} timed out waiting for menu response`),P.cancel()})}async $closeReporter(){this.b?.close()}l(o){o.isMinimized()&&o.restore(),o.focus()}m(o,n,c,h){const P=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:o.width,height:o.height,minWidth:300,minHeight:200,x:o.x,y:o.y,title:c.title,backgroundColor:c.backgroundColor||s.a,webPreferences:{preload:I.$5g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${n.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,E.$AE)(c.zoomLevel),sandbox:!0},alwaysOnTop:c.alwaysOnTop,experimentalDarkMode:!0});return P.setMenuBarVisibility(!1),P}n(o,n,c){let h;const P=i.screen.getAllDisplays();if(P.length===1)h=P[0];else{if(b.$m){const T=i.screen.getCursorScreenPoint();h=i.screen.getDisplayNearestPoint(T)}!h&&o&&(h=i.screen.getDisplayMatching(o.getBounds())),h||(h=i.screen.getPrimaryDisplay()||P[0])}const w=h.bounds,R={width:n,height:c,x:w.x+w.width/2-n/2,y:w.y+w.height/2-c/2};return w.width>0&&w.height>0&&(R.x<w.x&&(R.x=w.x),R.y<w.y&&(R.y=w.y),R.x>w.x+w.width&&(R.x=w.x),R.y>w.y+w.height&&(R.y=w.y),R.width>w.width&&(R.width=w.width),R.height>w.height&&(R.height=w.height)),R}};e.$aic=a,e.$aic=a=s=ke([se(1,$.$$gc),se(2,p.$fk),se(3,u.$ghc),se(4,d.$$hc),se(5,y.$ihc),se(6,g.$lhc),se(7,k.$jS)],a)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[274],ue([0,1,13,32,2,11,3,119,35,9,99,139,53,20,86,5,65,73,28,74,34,64,47,66]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k,s,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0,E=Ge(E);const n="issue.processExplorerWindowState";let c=class{static{o=this}static{this.a="#1E1E1E"}constructor(w,R,T,A,L,M,V,q,Y,de,re){this.d=w,this.f=R,this.g=T,this.h=A,this.i=L,this.j=M,this.k=V,this.l=q,this.m=Y,this.n=de,this.o=re,this.b=null,this.c=null,this.p()}p(){b.$pY.on("vscode:listProcesses",async w=>{const R=[];try{R.push({name:(0,l.localize)(1916,null),rootProcess:await(0,I.$6s)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(A=>{(0,m.$Zm)(A)?R.push({name:A.hostName,rootProcess:A}):A.processes&&R.push({name:A.hostName,rootProcess:A.processes})})}catch(T){this.g.error(`Listing processes failed: ${T}`)}this.t(w,"vscode:listProcessesResponse",R)}),b.$pY.on("vscode:workbenchCommand",(w,R)=>{const{id:T,from:A,args:L}=R;let M;switch(A){case"processExplorer":M=this.c;break;default:throw new Error(`Unexpected command source: ${A}`)}M?.webContents.send("vscode:runAction",{id:T,from:A,args:L})}),b.$pY.on("vscode:closeProcessExplorer",w=>{this.b?.close()}),b.$pY.on("vscode:pidToNameRequest",async w=>{const R=await this.i.getMainDiagnostics(),T=[];for(const A of R.windows)T.push([A.pid,`window [${A.id}] (${A.title})`]);for(const{pid:A,name:L}of s.$Shc.getAll())T.push([A,L]);this.t(w,"vscode:pidToNameResponse",T)})}async openProcessExplorer(w){if(!this.b&&(this.c=i.BrowserWindow.getFocusedWindow(),this.c)){const R=new v.$Yc,T=R.add(this.l.createIPCObjectUrl()),A=this.n.getItem(n,void 0),L=h(A)?A:this.r(this.c,800,500);this.b=this.s(L,T,{backgroundColor:w.styles.backgroundColor,title:(0,l.localize)(1917,null),zoomLevel:w.zoomLevel,alwaysOnTop:!0},"process-explorer"),T.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:w,product:E.default,nls:{messages:(0,l.getNLSMessages)(),language:(0,l.getNLSLanguage)()},cssModules:this.o.isEnabled?await this.o.getCssModules():void 0}),this.b.loadURL(D.$5g.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.${t.$V?"esm.":""}html`).toString(!0)),this.b.on("close",()=>{this.b=null,R.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,R.dispose())});const M=()=>{if(!this.b)return;const V=this.b.getSize(),q=this.b.getPosition();if(!V||!q)return;const Y={width:V[0],height:V[1],x:q[0],y:q[1]};this.n.setItem(n,Y)};this.b.on("moved",M),this.b.on("resized",M)}this.b&&this.q(this.b)}q(w){w.isMinimized()&&w.restore(),w.focus()}r(w,R,T){let A;const L=i.screen.getAllDisplays();if(L.length===1)A=L[0];else{if(O.$m){const q=i.screen.getCursorScreenPoint();A=i.screen.getDisplayNearestPoint(q)}!A&&w&&(A=i.screen.getDisplayMatching(w.getBounds())),A||(A=i.screen.getPrimaryDisplay()||L[0])}const M=A.bounds,V={width:R,height:T,x:M.x+M.width/2-R/2,y:M.y+M.height/2-T/2};return M.width>0&&M.height>0&&(V.x<M.x&&(V.x=M.x),V.y<M.y&&(V.y=M.y),V.x>M.x+M.width&&(V.x=M.x),V.y>M.y+M.height&&(V.y=M.y),V.width>M.width&&(V.width=M.width),V.height>M.height&&(V.height=M.height)),V}async stopTracing(){if(!this.f.args.trace)return;const w=await i.contentTracing.stopRecording(`${(0,r.$Sg)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,l.localize)(1918,null),detail:(0,l.localize)(1919,null,w),buttons:[(0,l.localize)(1920,null)]},i.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,w)}async getSystemStatus(){const[w,R]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(w,R)}async $getSystemInfo(){const[w,R]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(w,R)}async $getPerformanceInfo(){try{const[w,R]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(w,R)}catch(w){throw this.g.warn("issueService#getPerformanceInfo ",w.message),w}}s(w,R,T,A){const L=new i.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:w.width,height:w.height,minWidth:300,minHeight:200,x:w.x,y:w.y,title:T.title,backgroundColor:T.backgroundColor||o.a,webPreferences:{preload:D.$5g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${R.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,a.$AE)(T.zoomLevel),sandbox:!0},alwaysOnTop:T.alwaysOnTop,experimentalDarkMode:!0});return L.setMenuBarVisibility(!1),L}t(w,R,...T){w.sender.isDestroyed()||w.sender.send(R,...T)}async closeProcessExplorer(){this.b?.close()}};e.$bic=c,e.$bic=c=o=ke([se(1,p.$$gc),se(2,f.$fk),se(3,m.$Ym),se(4,u.$Vhc),se(5,$.$ghc),se(6,y.$$hc),se(7,S.$ihc),se(8,g.$yk),se(9,k.$5R),se(10,d.$jS)],c);function h(P){return typeof P!="object"||P===null?!1:"x"in P&&"y"in P&&"width"in P&&"height"in P}}),define(le[275],ue([0,1,22,16,20,19,5,65,28,50,24,51,108]),function(G,e,i,r,v,D,O,I,b,l,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;let p=class extends $.$Aic{constructor(f,y,E,g,S,k,s,a){super(f,y,g,S,k,a),this.e=E,this.u=s}s(f){return(0,$.$zic)(`linux-${process.arch}`,f,this.k)}t(f){this.a&&(this.d(u.$nZ.CheckingForUpdates(f)),this.i.request({url:this.a},i.CancellationToken.None).then(l.$hq).then(y=>{!y||!y.url||!y.version||!y.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!f}),this.d(u.$nZ.Idle(u.UpdateType.Archive))):this.d(u.$nZ.AvailableForDownload(y))}).then(void 0,y=>{this.j.error(y);const E=f?y.message||y:void 0;this.d(u.$nZ.Idle(u.UpdateType.Archive,E))}))}async o(f){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):f.update.url&&this.u.openExternal(void 0,f.update.url),this.d(u.$nZ.Idle(u.UpdateType.Archive))}};e.$Cic=p,e.$Cic=p=ke([se(0,D.$Ehc),se(1,r.$ej),se(2,m.$em),se(3,v.$$gc),se(4,l.$bq),se(5,O.$fk),se(6,I.$$hc),se(7,b.$yk)],p)}),define(le[276],ue([0,1,44,26,27,8,22,54,48,10,7,153,23,16,20,14,19,5,65,28,50,24,51,108]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k,s,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0,r=Ie(r),l=Ie(l),$=Ie($);async function o(P,w=1e3){for(;!P();)await(0,D.$Lh)(w)}let n;function c(){return typeof n>"u"&&(n=r.existsSync(l.$oc(l.$rc(process.execPath),"unins000.exe"))?a.UpdateType.Setup:a.UpdateType.Archive),n}let h=class extends t.$Aic{get cachePath(){const w=l.$oc((0,v.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return r.promises.mkdir(w,{recursive:!0}).then(()=>w)}constructor(w,R,T,A,L,M,V,q,Y){super(w,R,A,L,M,Y),this.u=T,this.v=V,this.w=q,w.setRelaunchHandler(this)}handleRelaunch(w){return w?.addArgs||w?.removeArgs||this.state.type!==a.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(a.$nZ.Disabled(a.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(w){let R=`win32-${process.arch}`;return c()===a.UpdateType.Archive?R+="-archive":this.k.target==="user"&&(R+="-user"),(0,t.$zic)(R,w,this.k)}t(w){this.a&&(this.d(a.$nZ.CheckingForUpdates(w)),this.i.request({url:this.a},O.CancellationToken.None).then(k.$hq).then(R=>{const T=c();return!R||!R.url||!R.version||!R.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!w}),this.d(a.$nZ.Idle(T)),Promise.resolve(null)):T===a.UpdateType.Archive?(this.d(a.$nZ.AvailableForDownload(R)),Promise.resolve(null)):(this.d(a.$nZ.Downloading),this.C(R.version).then(()=>this.B(R.version).then(A=>$.Promises.exists(A).then(L=>{if(L)return Promise.resolve(A);const M=`${A}.tmp`;return this.i.request({url:R.url},O.CancellationToken.None).then(V=>this.v.writeFile(m.URI.file(M),V.stream)).then(R.sha256hash?()=>(0,u.$iY)(M,R.sha256hash):()=>{}).then(()=>$.Promises.rename(M,A,!1)).then(()=>A)})).then(A=>{this.e={packagePath:A},this.d(a.$nZ.Downloaded(R)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(a.$nZ.Ready(R))})))}).then(void 0,R=>{this.u.publicLog2("update:error",{messageHash:String((0,b.$yj)(String(R)))}),this.j.error(R);const T=w?R.message||R:void 0;this.d(a.$nZ.Idle(c(),T))}))}async o(w){w.update.url&&this.w.openExternal(void 0,w.update.url),this.d(a.$nZ.Idle(c()))}async B(w){const R=await this.cachePath;return l.$oc(R,`CodeSetup-${this.k.quality}-${w}.exe`)}async C(w=null){const R=w?M=>!new RegExp(`${this.k.quality}-${w}\\.exe$`).test(M):()=>!0,T=await this.cachePath,L=(await $.Promises.readdir(T)).filter(R).map(async M=>{try{await r.promises.unlink(l.$oc(T,M))}catch{}});await Promise.all(L)}async p(){if(this.state.type!==a.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const w=this.state.update;this.d(a.$nZ.Updating(w));const R=await this.cachePath;this.e.updateFilePath=l.$oc(R,`CodeSetup-${this.k.quality}-${w.version}.flag`),await $.Promises.writeFile(this.e.updateFilePath,"flag"),(0,i.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(a.$nZ.Idle(c()))});const A=`${this.k.win32MutexName}-ready`,L=await new Promise((M,V)=>{G(["@vscode/windows-mutex"],M,V)}).then(Ie);o(()=>L.isActive(A)).then(()=>this.d(a.$nZ.Ready(w)))}r(){this.state.type!==a.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,i.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return c()}async _applySpecificUpdate(w){if(this.state.type!==a.StateType.Idle)return;const R=this.g.getValue("update.enableWindowsBackgroundUpdates"),T={version:"unknown",productVersion:"unknown"};this.d(a.$nZ.Downloading),this.e={packagePath:w},this.d(a.$nZ.Downloaded(T)),R?this.k.target==="user"&&this.p():this.d(a.$nZ.Ready(T))}};e.$Eic=h,ke([I.$ci],h.prototype,"cachePath",null),e.$Eic=h=ke([se(0,y.$Ehc),se(1,p.$ej),se(2,s.$em),se(3,d.$$gc),se(4,k.$bq),se(5,E.$fk),se(6,f.$fl),se(7,g.$$hc),se(8,S.$yk)],h)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[140],ue([0,1,13,8,22,55,4,2,11,71,3,7,9,27,70,16,53,20,69,14,19,5,28,74,252,89,24,113,77,47,29,30,59,52,40,34,58,72,21,6,66]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k,s,a,t,o,n,c,h,P,w,R,T,A,L,M,V,q,Y,de,re,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=e.$Bhc=void 0,i=Ge(i);var W;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(W||(W={}));class Z extends I.$Zc{get lastFocusTime(){return this.j}get win(){return this.m}n(F,z){this.m=F,this.B(O.Event.fromNodeEventEmitter(F,"maximize")(()=>this.b.fire())),this.B(O.Event.fromNodeEventEmitter(F,"unmaximize")(()=>this.c.fire())),this.B(O.Event.fromNodeEventEmitter(F,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(O.Event.fromNodeEventEmitter(F,"focus")(()=>{this.j=Date.now()})),this.B(O.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(O.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const ie=!(0,w.$vE)(this.r,z?.titleBarStyle==="hidden"?w.TitlebarStyle.CUSTOM:void 0);if(m.$m&&ie&&F.setSheetOffset((0,m.$M)((0,p.release)())?28:22),ie&&((0,w.$yE)(this.r)||m.$m)){const x=this.s.getItem(Z.D);x?this.updateWindowControls({height:x}):this.updateWindowControls({height:w.$xE})}m.$l&&ie&&F.hookWindowMessage(278,()=>{const[ce,oe]=F.getPosition(),te=i.default.screen.getCursorScreenPoint(),j=te.x-ce,X=te.y-oe;return!(j>30&&X>=0&&X<=Math.max(F.getBounds().height*.15,35))||(F.setEnabled(!1),F.setEnabled(!0),this.f.fire({x:j,y:X})),0}),this.t.args["open-devtools"]===!0&&F.webContents.openDevTools(),m.$m&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(F,z,ie,x){super(),this.r=F,this.s=z,this.t=ie,this.u=x,this.a=this.B(new O.$qe),this.onDidClose=this.a.event,this.b=this.B(new O.$qe),this.onDidMaximize=this.b.event,this.c=this.B(new O.$qe),this.onDidUnmaximize=this.c.event,this.f=this.B(new O.$qe),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new O.$qe),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new O.$qe),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,w.$yE)(this.r),this.G=void 0,this.H=void 0}w(F,z=i.default.screen.getAllDisplays().length>0){const ie=this.r.getValue("window"),x=m.$m&&ie?.nativeTabs===!0;(m.$m||m.$l)&&z&&(!x||i.default.BrowserWindow.getAllWindows().length===1)&&[F.width,F.height,F.x,F.y].every(ce=>typeof ce=="number")&&this.m?.setBounds({width:F.width,height:F.height,x:F.x,y:F.y}),(F.mode===L.WindowMode.Maximized||F.mode===L.WindowMode.Fullscreen)&&(this.m?.maximize(),F.mode===L.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(F){m.$m?this.win?.setRepresentedFilename(F):this.z=F}getRepresentedFilename(){return m.$m?this.win?.getRepresentedFilename():this.z}setDocumentEdited(F){m.$m&&this.win?.setDocumentEdited(F),this.C=F}isDocumentEdited(){return m.$m?!!this.win?.isDocumentEdited():!!this.C}focus(F){m.$m&&F?.force&&i.default.app.focus({steal:!0});const z=this.win;z&&(z.isMinimized()&&z.restore(),z.focus())}handleTitleDoubleClick(){const F=this.win;if(F)if(m.$m)switch(i.default.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":F.minimize();break;case"None":break;case"Maximize":default:F.isMaximized()?F.unmaximize():F.maximize()}else F.isMaximized()?F.unmaximize():F.maximize()}static{this.D="windowControlHeight"}updateWindowControls(F){const z=this.win;if(z){if(F.height&&this.s.setItem(C.D,F.height),this.F)z.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if(m.$m&&F.height!==void 0){const ie=(F.height-15)/2;ie?z.setWindowButtonPosition({x:ie,y:ie}):z.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(F,z){(0,w.$zE)(this.r)?this.J(F,z):this.M(F)}get isFullScreen(){if(m.$m&&typeof this.G=="boolean")return this.G;const F=this.win,z=F?.isFullScreen(),ie=F?.isSimpleFullScreen();return!!(z||ie)}J(F,z){const ie=this.win;ie?.isSimpleFullScreen()&&ie?.setSimpleFullScreen(!1),this.L(F,z)}L(F,z){if(m.$m){this.G=F;const x=this.H=new r.$8h;(async()=>{const ce=await Promise.race([x.p,(0,r.$Lh)(1e4).then(()=>!1)]);this.H===x&&(this.G=void 0,this.H=void 0,!ce&&F&&z&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(F)}M(F){const z=this.win;z?.isFullScreen()&&this.L(!1,!1),z?.setSimpleFullScreen(F),z?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$Bhc=Z;let C=class extends Z{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const F=this.hb.profiles.find(z=>z.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.hb.getProfileForWorkspace(this.config.workspace??(0,T.$Yi)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(F,z,ie,x,ce,oe,te,j,X,U,N,Q,K,H,_,ae,$e,be,ye,Fe,xe){super(U,Fe,x,z),this.fb=ie,this.gb=ce,this.hb=oe,this.ib=te,this.jb=j,this.kb=X,this.lb=N,this.mb=Q,this.nb=K,this.ob=H,this.pb=_,this.qb=ae,this.rb=$e,this.sb=be,this.tb=ye,this.N=this.B(new O.$qe),this.onWillLoad=this.N.event,this.O=this.B(new O.$qe),this.onDidSignalReady=this.O.event,this.P=this.B(new O.$qe),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=W.NONE;{const[Ae,me]=this.Eb(F.state);this.U=Ae,this.u.trace("window#ctor: using window state",Ae);const J=xe.invokeFunction(R.$mhc,this.U,void 0,{preload:b.$5g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,l.mark)("code/willCreateCodeBrowserWindow"),this.m=new i.default.BrowserWindow(J),(0,l.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m,J),this.w(this.U,me),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=W.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.X.push(F)})}get isReady(){return this.ub===W.READY}get whenClosedOrLoaded(){return new Promise(F=>{function z(){ie.dispose(),x.dispose(),F()}const ie=this.onDidClose(()=>z()),x=this.onWillLoad(()=>z())})}vb(){this.B(O.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(L.WindowError.UNRESPONSIVE))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(z,ie)=>ie)(z=>this.yb(L.WindowError.PROCESS_GONE,{...z}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(z,ie,x)=>({exitCode:ie,reason:x}))(({exitCode:z,reason:ie})=>this.yb(L.WindowError.LOAD,{reason:ie,exitCode:z}))),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(z=>z.preventDefault())),this.B(O.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",v.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",v.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(z=>this.Bb(z))),this.B(this.mb.onDidDeleteUntitledWorkspace(z=>this.Ab(z)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(z,ie)=>{const x=await this.xb();ie({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,x)})})}xb(){return this.wb||(this.wb=(0,o.$vq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(F,z){switch(F){case L.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break;case L.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case L.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:F,reason:z?.reason,code:z?.exitCode}),F){case L.WindowError.UNRESPONSIVE:case L.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(F===L.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:ie,checkboxChecked:x}=await this.pb.showMessageBox({type:"warning",buttons:[(0,$.localize)(2463,null),(0,$.localize)(2464,null),(0,$.localize)(2465,null)],message:(0,$.localize)(2466,null),detail:(0,$.localize)(2467,null),checkboxLabel:this.S?.workspace?(0,$.localize)(2468,null):void 0},this.m);if(ie!==2){const ce=ie===0;await this.zb(ce,x)}}else if(F===L.WindowError.PROCESS_GONE){let ie;z?ie=(0,$.localize)(2470,null,z.reason,z.exitCode??"<unknown>"):ie=(0,$.localize)(2469,null);const{response:x,checkboxChecked:ce}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,$.localize)(2471,null):(0,$.localize)(2472,null),(0,$.localize)(2473,null)],message:ie,detail:this.S?.workspace?(0,$.localize)(2474,null):(0,$.localize)(2475,null),checkboxLabel:this.S?.workspace?(0,$.localize)(2476,null):void 0},this.m),oe=x===0;await this.zb(oe,ce)}break}}async zb(F,z){const ie=this.S?.workspace;if(z&&ie)try{const x=this.kb.workspaceStorage(ie);await x.init(),x.delete("memento/workbench.parts.editor"),await x.close()}catch(x){this.u.error(x)}this.P.fire();try{if(F&&this.S){let x,ce;(0,T.$Ui)(ie)?x={folderUri:ie.uri}:(0,T.$Zi)(ie)?x={workspaceUri:ie.configPath}:ce=!0,(0,de.$Sb)(await this.tb.open({context:R.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:x?[x]:void 0,forceEmpty:ce,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(F){this.S?.workspace?.id===F.id&&(this.S.workspace=void 0)}Bb(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const z=this.Gb();z!==this.W&&(this.W=z,this.Hb(z))}if(!F||F.affectsConfiguration("http.proxy")||F.affectsConfiguration("http.noProxy")){let z=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;if(z?.indexOf("@")!==-1){const x=u.URI.parse(z),ce=x.authority.indexOf("@");ce!==-1&&(z=x.with({authority:x.authority.substring(ce+1)}).toString())}z?.endsWith("/")&&(z=z.substr(0,z.length-1));const ie=(this.r.getValue("http.noProxy")||[]).map(x=>x.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.Z||ie!==this.$)){this.Z=z,this.$=ie;const x=z||"",ce=ie?`${ie},<local>`:"<local>";this.u.trace(`Setting proxy to '${x}', bypassing '${ce}'`),this.m.webContents.session.setProxy({proxyRules:x,proxyBypassRules:ce,pacScript:""}),i.default.app.setProxy({proxyRules:x,proxyBypassRules:ce,pacScript:""})}}}addTabbedWindow(F){m.$m&&F.win&&this.m.addTabbedWindow(F.win)}load(F,z=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!z.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),z.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(F,z),this.ub===W.NONE?this.S=F:this.db=F,this.ub=W.NAVIGATING,this.m.loadURL(b.$5g.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.${ee.$V?"esm.":""}html`).toString(!0));const ie=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Wh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:F.workspace,reason:z.isReload?L.LoadReason.RELOAD:ie?L.LoadReason.LOAD:L.LoadReason.INITIAL})}Cb(F,z){const ie=(this.S??this.db)?.userEnv;if(ie){const x=(0,g.$Pm)(ie)&&!(0,g.$Pm)(F.userEnv),ce=this.isExtensionDevelopmentHost;(x||ce)&&(F.userEnv={...ie,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),z.disableExtensions!==void 0&&(F["disable-extensions"]=z.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this.m.isMaximized(),F.partsSplash=this.lb.getWindowSplash(),F.zoomLevel=this.Jb(),F.isCustomZoomLevel=typeof this.ab=="number",F.isCustomZoomLevel&&F.partsSplash&&(F.partsSplash.zoomLevel=F.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),F.perfMarks=(0,l.getMarks)(),this.bb.update(F)}async reload(F){const z=Object.assign({},this.S);z.workspace=await this.Db(z),delete z.filesToOpenOrCreate,delete z.filesToDiff,delete z.filesToMerge,delete z.filesToWait,this.isExtensionDevelopmentHost&&F&&(z.verbose=F.verbose,z.debugId=F.debugId,z.extensionEnvironment=F.extensionEnvironment,z["inspect-extensions"]=F["inspect-extensions"],z["inspect-brk-extensions"]=F["inspect-brk-extensions"],z["extensions-dir"]=F["extensions-dir"]),z.accessibilitySupport=i.default.app.isAccessibilitySupportEnabled(),z.isInitialStartup=!1,z.policiesData=this.gb.serialize(),z.continueOn=this.t.continueOn,z.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},z.logLevel=this.fb.getLogLevel(),z.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(z,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async Db(F){if((0,T.$Zi)(F.workspace)){const z=F.workspace.configPath;if(z.scheme===b.Schemas.file&&!await this.ib.exists(z))return}else if((0,T.$Ui)(F.workspace)){const z=F.workspace.uri;if(z.scheme===b.Schemas.file&&!await this.ib.exists(z))return}return F.workspace}serializeWindowState(){if(!this.m)return(0,L.$ahc)();if(this.isFullScreen){let ie;try{ie=i.default.screen.getDisplayMatching(this.getBounds())}catch{}const x=(0,L.$ahc)();return{mode:L.WindowMode.Fullscreen,display:ie?ie.id:void 0,width:this.U.width||x.width,height:this.U.height||x.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const F=Object.create(null);let z;if(!m.$m&&this.m.isMaximized()?z=L.WindowMode.Maximized:z=L.WindowMode.Normal,z===L.WindowMode.Maximized?F.mode=L.WindowMode.Maximized:F.mode=L.WindowMode.Normal,z===L.WindowMode.Normal||z===L.WindowMode.Maximized){let ie;z===L.WindowMode.Normal?ie=this.getBounds():ie=this.m.getNormalBounds(),F.x=ie.x,F.y=ie.y,F.width=ie.width,F.height=ie.height}return F.zoomLevel=this.ab,F}Eb(F){(0,l.mark)("code/willRestoreCodeWindowState");let z=!1;if(F){this.ab=F.zoomLevel;try{const ie=i.default.screen.getAllDisplays();z=ie.length>1,F=R.WindowStateValidator.validateWindowState(this.u,F,ie)}catch(ie){this.u.warn(`Unexpected error validating window state: ${ie}
${ie.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[F||(0,L.$ahc)(),z]}getBounds(){const[F,z]=this.m.getPosition(),[ie,x]=this.m.getSize();return{x:F,y:z,width:ie,height:x}}I(F,z){super.I(F,z),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",v.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let F=(0,w.$tE)(this.r);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}Hb(F,z=!0){m.$m||(F==="toggle"&&z&&this.send("vscode:showInfoMessage",(0,$.localize)(2477,null)),F==="hidden"?setTimeout(()=>{this.Ib(F)}):this.Ib(F))}Ib(F){const z=this.isFullScreen;switch(F){case"classic":this.m.setMenuBarVisibility(!z),this.m.autoHideMenuBar=z;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(F){this.ab=F}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(F,z,...ie){this.isReady?this.send(F,...ie):this.ready().then(()=>{z.isCancellationRequested||this.send(F,...ie)})}send(F,...z){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this.m.webContents.send(F,...z)}catch(ie){this.u.warn(`Error sending IPC message to channel '${F}' of window ${this.Q}: ${(0,D.$vj)(ie)}`)}}}updateTouchBar(F){m.$m&&this.Y.forEach((z,ie)=>{const x=F[ie];z.segments=this.Mb(x)})}Kb(){if(m.$m){for(let F=0;F<10;F++){const z=this.Lb();this.Y.push(z)}this.m.setTouchBar(new i.default.TouchBar({items:this.Y}))}}Lb(F=[]){const z=this.Mb(F),ie=new i.default.TouchBar.TouchBarSegmentedControl({segments:z,mode:"buttons",segmentStyle:"automatic",change:x=>{this.sendWhenReady("vscode:runAction",v.CancellationToken.None,{id:ie.segments[x].id,from:"touchbar"})}});return ie}Mb(F=[]){return F.map(ie=>{let x;ie.icon&&!h.ThemeIcon.isThemeIcon(ie.icon)&&ie.icon?.dark?.scheme===b.Schemas.file&&(x=i.default.nativeImage.createFromPath(u.URI.revive(ie.icon.dark).fsPath),x.isEmpty()&&(x=void 0));let ce;return typeof ie.title=="string"?ce=ie.title:ce=ie.title.value,{id:ie.id,label:x?void 0:ce,icon:x}})}matches(F){return this.m?.webContents.id===F.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$Chc=C,e.$Chc=C=ke([se(1,s.$fk),se(2,Y.$zhc),se(3,E.$$gc),se(4,M.$zo),se(5,q.$ohc),se(6,S.$fl),se(7,n.$Mhc),se(8,n.$Khc),se(9,f.$ej),se(10,P.$jhc),se(11,A.$xhc),se(12,d.$fhc),se(13,c.$em),se(14,y.$ghc),se(15,k.$Ehc),se(16,a.$yk),se(17,t.$ihc),se(18,R.$lhc),se(19,V.$5R),se(20,re.$Ji)],C)}),define(le[277],ue([0,1,13,3,16,20,19,5,34,47,52,140]),function(G,e,i,r,v,D,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;let $=class extends u.$Bhc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(d,f,y,E,g,S){super(E,g,f,y),this.O=d,this.P=S,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(d){this.q.isDisposed||this.O.isDestroyed()||(this.Q(d),d&&!this.N&&(this.N=!0,this.w({x:d.x,y:d.y,width:d.width,height:d.height,mode:d.show===!1?m.WindowMode.Maximized:m.WindowMode.Normal})))}Q(d){if(this.m)return;const f=i.BrowserWindow.fromWebContents(this.O);f&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(f,d),f.setMenu(null),(r.$l||r.$n)&&(0,l.$vE)(this.r,d?.titleBarStyle==="hidden"?l.TitlebarStyle.CUSTOM:void 0)&&f.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(d){return this.O.id===d.id}};e.$Dhc=$,e.$Dhc=$=ke([se(1,D.$$gc),se(2,I.$fk),se(3,v.$ej),se(4,b.$5R),se(5,O.$Ehc)],$)}),define(le[278],ue([0,1,13,4,2,11,35,277,6,5,52,29]),function(G,e,i,r,v,D,O,I,b,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=void 0;let $=class extends v.$Zc{constructor(d,f){super(),this.h=d,this.j=f,this.a=this.B(new r.$qe),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$qe),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$qe),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$qe),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){i.app.on("browser-window-created",(d,f)=>{const y=this.getWindowByWebContents(f.webContents);if(y)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),y.tryClaimWindow();else{const E=new v.$Yc;E.add(r.Event.fromNodeEventEmitter(f.webContents,"did-create-window",(g,S)=>({browserWindow:g,details:S}))(({browserWindow:g,details:S})=>{const k=this.getWindowByWebContents(g.webContents);k&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),k.tryClaimWindow(S.options))})),E.add(r.Event.fromNodeEventEmitter(f,"closed")(()=>E.dispose()))}}),O.$pY.handle("vscode:registerAuxiliaryWindow",async(d,f)=>{const y=this.getWindowByWebContents(d.sender);return y&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),y.parentId=f),d.sender.id})}createWindow(d){const{state:f,overrides:y}=this.n(d);return this.h.invokeFunction(u.$mhc,f,y,{preload:D.$5g.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(d){const f={},y={},E=d.features.split(",");for(const S of E){const[k,s]=S.split("=");switch(k){case"width":f.width=parseInt(s,10);break;case"height":f.height=parseInt(s,10);break;case"left":f.x=parseInt(s,10);break;case"top":f.y=parseInt(s,10);break;case"window-maximized":f.mode=m.WindowMode.Maximized;break;case"window-fullscreen":f.mode=m.WindowMode.Fullscreen;break;case"window-disable-fullscreen":y.disableFullscreen=!0;break;case"window-native-titlebar":y.forceNativeTitlebar=!0;break}}const g=u.WindowStateValidator.validateWindowState(this.j,f)??(0,m.$bhc)();return this.j.trace("[aux window] using window state",g),{state:g,overrides:y}}registerWindow(d){const f=new v.$Yc,y=this.h.createInstance(I.$Dhc,d);this.g.set(y.id,y),f.add((0,v.$Xc)(()=>this.g.delete(y.id))),f.add(y.onDidMaximize(()=>this.a.fire(y))),f.add(y.onDidUnmaximize(()=>this.b.fire(y))),f.add(y.onDidEnterFullScreen(()=>this.c.fire({window:y,fullscreen:!0}))),f.add(y.onDidLeaveFullScreen(()=>this.c.fire({window:y,fullscreen:!1}))),f.add(y.onDidTriggerSystemContextMenu(({x:E,y:g})=>this.f.fire({window:y,x:E,y:g}))),r.Event.once(y.onDidClose)(()=>f.dispose())}getWindowByWebContents(d){const f=this.g.get(d.id);return f?.matches(d)?f:void 0}getFocusedWindow(){const d=i.BrowserWindow.getFocusedWindow();if(d)return this.getWindowByWebContents(d.webContents)}getLastActiveWindow(){return(0,u.$nhc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$_ic=$,e.$_ic=$=ke([se(0,b.$Ji),se(1,l.$fk)],$)}),define(le[90],ue([0,1,13,21,8,4,49,2,11,3,18,7,23,9,6,19,5,63,89,105,30,59,31,53]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k,s,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=e.$lic=void 0,e.$lic=(0,d.$Ki)("workspacesHistoryMainService");let n=class extends I.$Zc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(h,P,w,R,T){super(),this.f=h,this.g=P,this.h=w,this.j=R,this.m=T,this.c=this.B(new D.$qe),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new v.$Ih(800)),this.n()}n(){this.h.when(f.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(h=>this.addRecentlyOpened([{workspace:h.workspace,remoteAuthority:h.window.remoteAuthority}])))}async addRecentlyOpened(h){let P=[],w=[];for(const T of h)if((0,S.$Tib)(T))!this.g.isUntitledWorkspace(T.workspace)&&!this.w(P,T.workspace)&&P.push(T);else if((0,S.$Uib)(T))this.y(P,T.folderUri)||P.push(T);else{const A=this.z(w,T.fileUri),L=T.fileUri.scheme===b.Schemas.file&&o.G.indexOf((0,m.$ih)(T.fileUri))>=0;!A&&!L&&(w.push(T),l.$l&&T.fileUri.scheme===b.Schemas.file&&i.app.addRecentDocument(T.fileUri.fsPath))}const R=await this.r({workspaces:P,files:w});P=R.workspaces,w=R.files,P.length>o.a&&(P.length=o.a),w.length>o.a&&(w.length=o.a),await this.t({workspaces:P,files:w}),this.c.fire(),l.$m&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(h){const P=A=>{const L=this.u(A);for(const M of h)if(m.$ch.isEqual(M,L))return!1;return!0},w=await this.getRecentlyOpened(),R=w.workspaces.filter(P),T=w.files.filter(P);(R.length!==w.workspaces.length||T.length!==w.files.length)&&(await this.t({files:T,workspaces:R}),this.c.fire(),l.$m&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(h){if(h?.confirm){const{response:P}=await this.m.showMessageBox({type:"warning",buttons:[(0,p.localize)(2490,null),(0,p.localize)(2491,null)],message:(0,p.localize)(2492,null),detail:(0,p.localize)(2493,null),cancelId:1});if(P!==0)return}await this.t({workspaces:[],files:[]}),i.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(h){const P=new a.$Fc(T=>m.$ch.getComparisonKey(T));if(h?.workspaces)for(const T of h.workspaces)P.set(this.u(T),T);const w=new a.$Fc(T=>m.$ch.getComparisonKey(T));if(h?.files)for(const T of h.files)w.set(this.u(T),T);const R=await this.s();for(const T of R.workspaces){const A=P.get(this.u(T));A?A.label=A.label??T.label:P.set(this.u(T),T)}for(const T of R.files){const A=w.get(this.u(T));A?A.label=A.label??T.label:w.set(this.u(T),T)}return{workspaces:[...P.values()],files:[...w.values()]}}async s(){await this.j.whenReady;let h;const P=this.j.get(o.b,E.StorageScope.APPLICATION);if(typeof P=="string")try{h=JSON.parse(P)}catch(w){this.f.error("Unexpected error parsing opened paths list",w)}return(0,S.$1ib)(h,this.f)}async t(h){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,S.$2ib)(h)),E.StorageScope.APPLICATION,E.StorageTarget.MACHINE)}u(h){return(0,S.$Uib)(h)?h.folderUri:(0,S.$Vib)(h)?h.fileUri:h.workspace.configPath}w(h,P){return!!h.find(w=>(0,S.$Tib)(w)&&w.workspace.id===P.id)}y(h,P){return!!h.find(w=>(0,S.$Uib)(w)&&m.$ch.isEqual(w.folderUri,P))}z(h,P){return!!h.find(w=>m.$ch.isEqual(w.fileUri,P))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){l.$l&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!l.$l)return;const h=[];if(h.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(2494,null),description:(0,p.localize)(2495,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const P=[];for(const T of i.app.getJumpListSettings().removedItems){const A=T.args;if(A){const L=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);L&&P.push(u.URI.parse(L[2]))}}await this.removeRecentlyOpened(P);let w=!1;const R=(0,r.$Lb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(T=>{const A=(0,S.$Tib)(T)?T.workspace:T.folderUri,{title:L,description:M}=this.L(A,T.label);let V;return u.URI.isUri(A)?V=`--folder-uri "${A.toString()}"`:(w=!0,V=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:L.substr(0,255),description:M.substr(0,255),program:process.execPath,args:V,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&h.push({type:"custom",name:w?(0,p.localize)(2496,null):(0,p.localize)(2497,null),items:R})}h.push({type:"recent"});try{const P=i.app.setJumpList(h);P&&P!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${P}`)}catch(P){this.f.warn("updateWindowsJumpList#setJumpList",P)}}L(h,P){if(P)return{title:(0,O.$fx)(P).name,description:P};if(u.URI.isUri(h))return{title:(0,m.$ih)(h),description:this.M(h)};if(this.g.isUntitledWorkspace(h))return{title:(0,p.localize)(2498,null),description:""};let w=(0,m.$ih)(h.configPath);return w.endsWith(k.$7i)&&(w=w.substr(0,w.length-k.$7i.length-1)),{title:(0,p.localize)(2499,null,w),description:this.M(h.configPath)}}M(h){return h.scheme==="file"?(0,O.$0w)(h.fsPath):h.toString()}async N(){if(!l.$m)return;i.app.clearRecentDocuments();const h=await this.getRecentlyOpened(),P=[];let w=0;for(let T=0;T<h.workspaces.length&&w<o.C;T++){const A=this.u(h.workspaces[T]);if(A.scheme===b.Schemas.file){const L=(0,m.$_g)(A);await $.Promises.exists(L)&&(P.push(L),w++)}}const R=[];for(let T=0;T<h.files.length&&w<o.D;T++){const A=this.u(h.files[T]);if(A.scheme===b.Schemas.file){const L=(0,m.$_g)(A);if(o.G.includes((0,m.$ih)(A))||P.includes(L))continue;await $.Promises.exists(L)&&(R.push(L),w++)}}R.reverse().forEach(T=>i.app.addRecentDocument(T)),P.reverse().forEach(T=>i.app.addRecentDocument(T))}};e.$mic=n,e.$mic=n=o=ke([se(0,y.$fk),se(1,s.$xhc),se(2,f.$Ehc),se(3,g.$Mhc),se(4,t.$ghc)],n)}),define(le[279],ue([0,1,13,8,22,49,3,7,9,85,16,20,19,5,202,65,28,34,24,51,47,29,90,2]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k,s,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0,b=Ie(b);const n="menu";let c=class extends t.$Zc{static{o=this}static{this.a="lastKnownMenubarData"}constructor(w,R,T,A,L,M,V,q,Y,de,re,ee){super(),this.t=w,this.u=R,this.w=T,this.y=A,this.z=L,this.C=M,this.D=V,this.F=q,this.G=Y,this.H=de,this.I=re,this.J=ee,this.s=Object.create(null),this.h=new r.$Wh(()=>this.R(),0),this.j=new r.$Wh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(O.$m||(0,k.$vE)(R))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const w=this.D.getItem(o.a);w&&(w.menus&&(this.n=w.menus),w.keybindings&&(this.r=w.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(M,V,q)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:s.OpenContext.MENU,contextWindowId:V?.id})},this.s["workbench.action.newWindow"]=(M,V,q)=>this.w.openEmptyWindow({context:s.OpenContext.MENU,contextWindowId:V?.id}),this.s["workbench.action.files.openFileFolder"]=(M,V,q)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:n}}),this.s["workbench.action.files.openFolder"]=(M,V,q)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:n}}),this.s["workbench.action.openWorkspace"]=(M,V,q)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(q),telemetryExtraData:{from:n}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const w=this.I.youTubeUrl;w&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(w,"openYouTubeUrl"));const R=this.I.requestFeatureUrl;R&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(R,"openUserVoiceUrl"));const T=this.I.reportIssueUrl;T&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(T,"openReportIssues"));const A=this.I.licenseUrl;A&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(O.$z){const M=A.indexOf("?")>0?"&":"?";this.ob(`${A}${M}lang=${O.$z}`,"openLicenseUrl")}else this.ob(A,"openLicenseUrl")});const L=this.I.privacyStatementUrl;L&&A&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(L,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(w=>this.S(w))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const w=this.u.getValue("window.enableMenuBarMnemonics");return typeof w!="boolean"?!0:w}get P(){if(!O.$m)return!1;const w=this.u.getValue("window.nativeTabs");return typeof w!="boolean"?!1:w}updateMenu(w,R){this.n=w.menus,this.r=w.keybindings,this.D.setItem(o.a,w),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(w){O.$m&&(w.oldCount===0&&w.newCount>0||w.oldCount>0&&w.newCount===0)&&(this.f=w.newCount===0,this.Q())}U(){if(!O.$m)return;const w=i.BrowserWindow.getFocusedWindow();this.g=!w||!!this.J.getWindowByWebContents(w.webContents),this.Q()}W(){const w=i.Menu.getApplicationMenu();if(w&&this.m.push(w),Object.keys(this.n).length===0){this.X(O.$m?new i.Menu:null);return}const R=new i.Menu;let T;if(O.$m){const L=new i.Menu;T=new i.MenuItem({label:this.I.nameShort,submenu:L}),this.Y(L),R.append(T)}if(O.$m&&!this.c){this.c=!0;const L=new i.Menu;L.append(new i.MenuItem({label:this.qb(b.localize(1968,null)),click:()=>this.w.openEmptyWindow({context:s.OpenContext.DOCK})})),i.app.dock.setMenu(L)}if(this.$("File")){const L=new i.Menu,M=new i.MenuItem({label:this.qb(b.localize(1969,null)),submenu:L});this.bb(L,"File"),R.append(M)}if(this.$("Edit")){const L=new i.Menu,M=new i.MenuItem({label:this.qb(b.localize(1970,null)),submenu:L});this.bb(L,"Edit"),R.append(M)}if(this.$("Selection")){const L=new i.Menu,M=new i.MenuItem({label:this.qb(b.localize(1971,null)),submenu:L});this.bb(L,"Selection"),R.append(M)}if(this.$("View")){const L=new i.Menu,M=new i.MenuItem({label:this.qb(b.localize(1972,null)),submenu:L});this.bb(L,"View"),R.append(M)}if(this.$("Go")){const L=new i.Menu,M=new i.MenuItem({label:this.qb(b.localize(1973,null)),submenu:L});this.bb(L,"Go"),R.append(M)}if(this.$("Run")){const L=new i.Menu,M=new i.MenuItem({label:this.qb(b.localize(1974,null)),submenu:L});this.bb(L,"Run"),R.append(M)}if(this.$("Terminal")){const L=new i.Menu,M=new i.MenuItem({label:this.qb(b.localize(1975,null)),submenu:L});this.bb(L,"Terminal"),R.append(M)}let A;if(this.$("Window")){const L=new i.Menu;A=new i.MenuItem({label:this.qb(b.localize(1976,null)),submenu:L,role:"window"}),this.hb(L)}if(A&&R.append(A),this.$("Help")){const L=new i.Menu,M=new i.MenuItem({label:this.qb(b.localize(1977,null)),submenu:L,role:"help"});this.bb(L,"Help"),R.append(M)}R.items&&R.items.length>0?this.X(R):this.X(null),this.j.schedule()}X(w){if(i.Menu.setApplicationMenu(w),w)for(const R of this.J.getWindows())R.win?.setMenu(null)}Y(w){const R=this.jb(b.localize(1978,null,this.I.nameLong),"workbench.action.showAboutDialog"),T=this.ib();let A;if(this.$("Preferences")){const ee=new i.Menu;this.bb(ee,"Preferences"),A=new i.MenuItem({label:this.qb(b.localize(1979,null)),submenu:ee})}const L=new i.Menu,M=new i.MenuItem({label:b.localize(1980,null),role:"services",submenu:L}),V=new i.MenuItem({label:b.localize(1981,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),q=new i.MenuItem({label:b.localize(1982,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Y=new i.MenuItem({label:b.localize(1983,null),role:"unhide"}),de=new i.MenuItem(this.nb("workbench.action.quit",{label:b.localize(1984,null,this.I.nameLong),click:async(ee,W,Z)=>{const C=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||i.BrowserWindow.getFocusedWindow()||C?.win?.isMinimized())&&await this.Z(Z)&&this.H.quit(void 0)}})),re=[R];re.push(...T),A&&re.push(h(),A),re.push(h(),M,h(),V,q,Y,h(),de),re.forEach(ee=>w.append(ee))}async Z(w){if(this.w.getWindowCount()===0)return!0;const R=this.u.getValue("window.confirmBeforeClose");if(R==="always"||R==="keyboardOnly"&&this.fb(w)){const{response:T}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[b.localize(1985,null),b.localize(1986,null)],message:b.localize(1987,null)});return T===0}return!0}$(w){if(!O.$m&&!(0,k.$vE)(this.u))return!1;switch(w){case"File":case"Help":if(O.$m)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[w];case"Window":if(O.$m)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[w]}}ab(w,R){R.forEach(T=>{if((0,d.$iic)(T))w.append(h());else if((0,d.$hic)(T)){const A=new i.Menu,L=new i.MenuItem({label:this.qb(T.label),submenu:A});this.ab(A,T.submenu.items),w.append(L)}else(0,d.$jic)(T)?w.append(this.db(T)):(0,d.$kic)(T)&&(T.id==="workbench.action.showAboutDialog"&&this.cb(w),O.$m?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[T.id]?w.append(new i.MenuItem(this.nb(T.id,{label:this.qb(T.label),click:this.s[T.id]}))):w.append(this.jb(T.label,T.id,!1,T.checked)):w.append(this.jb(T.label,T.id,T.enabled!==!1,!!T.checked)):w.append(this.jb(T.label,T.id,T.enabled!==!1,!!T.checked)))})}bb(w,R){this.n&&this.n[R]&&this.ab(w,this.n[R].items)}cb(w){const R=this.ib();R.length&&(R.forEach(T=>w.append(T)),w.append(h()))}db(w){const R=I.URI.revive(w.uri),T=w.id,A=T==="openRecentFile"?{fileUri:R}:T==="openRecentWorkspace"?{workspaceUri:R}:{folderUri:R};return new i.MenuItem(this.nb(T,{label:w.label,click:async(L,M,V)=>{const q=this.eb(V);(await this.w.open({context:s.OpenContext.MENU,cli:this.y.args,urisToOpen:[A],forceNewWindow:q,gotoLineMode:!1,remoteAuthority:w.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([R])}},!1))}eb(w){return!!(w&&(!O.$m&&(w.ctrlKey||w.shiftKey)||O.$m&&(w.metaKey||w.altKey)))}fb(w){return!!(w.triggeredByAccelerator||w.altKey||w.ctrlKey||w.metaKey||w.shiftKey)}gb(w,R,T){const A={label:this.qb(w),role:T,enabled:!0};return new i.MenuItem(this.mb(R,A))}hb(w){const R=new i.MenuItem({label:b.localize(1988,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),T=new i.MenuItem({label:b.localize(1989,null),role:"zoom",enabled:this.w.getWindowCount()>0}),A=new i.MenuItem({label:b.localize(1990,null),role:"front",enabled:this.w.getWindowCount()>0}),L=this.jb(b.localize(1991,null),"workbench.action.switchWindow"),M=[];this.P&&(M.push(h()),M.push(this.jb(b.localize(1992,null),"workbench.action.newWindowTab")),M.push(this.gb(b.localize(1993,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.gb(b.localize(1994,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.gb(b.localize(1995,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.gb(b.localize(1996,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[R,T,h(),L,...M,h(),A].forEach(V=>w.append(V))}ib(){switch(this.t.state.type){case S.StateType.Idle:return[new i.MenuItem({label:this.qb(b.localize(1997,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case S.StateType.CheckingForUpdates:return[new i.MenuItem({label:b.localize(1998,null),enabled:!1})];case S.StateType.AvailableForDownload:return[new i.MenuItem({label:this.qb(b.localize(1999,null)),click:()=>{this.t.downloadUpdate()}})];case S.StateType.Downloading:return[new i.MenuItem({label:b.localize(2e3,null),enabled:!1})];case S.StateType.Downloaded:return O.$m?[]:[new i.MenuItem({label:this.qb(b.localize(2001,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case S.StateType.Updating:return[new i.MenuItem({label:b.localize(2002,null),enabled:!1})];case S.StateType.Ready:return[new i.MenuItem({label:this.qb(b.localize(2003,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(w,R,T,A){const L=this.qb(w),M=typeof R=="function"?R:(re,ee,W)=>{const Z=re?re.userSettingsLabel:null;let C=R;Array.isArray(R)&&(C=this.eb(W)?R[1]:R[0]),Z&&W.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:Z}):this.lb({type:"commandId",commandId:C})},V=typeof T=="boolean"?T:this.w.getWindowCount()>0,q=typeof A=="boolean"?A:!1,Y={label:L,click:M,enabled:V};q&&(Y.type="checkbox",Y.checked=q);let de;return typeof R=="string"?de=R:Array.isArray(R)&&(de=R[0]),O.$m&&(de==="editor.action.clipboardCutAction"?Y.role="cut":de==="editor.action.clipboardCopyAction"?Y.role="copy":de==="editor.action.clipboardPasteAction"&&(Y.role="paste"),de==="undo"?Y.click=this.kb(M,{inDevTools:re=>re.undo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("undo:")}):de==="redo"?Y.click=this.kb(M,{inDevTools:re=>re.redo(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("redo:")}):de==="editor.action.selectAll"&&(Y.click=this.kb(M,{inDevTools:re=>re.selectAll(),inNoWindow:()=>i.Menu.sendActionToFirstResponder("selectAll:")}))),new i.MenuItem(this.mb(de,Y))}kb(w,R){return(T,A,L)=>{const M=i.BrowserWindow.getFocusedWindow();if(!M)return R.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return R.inDevTools(M.webContents.devToolsWebContents);w(T,A||M,L)}}lb(w){let R=i.BrowserWindow.getFocusedWindow();if(R){const A=this.J.getWindowByWebContents(R.webContents);A&&(R=this.w.getWindowById(A.parentId)?.win??null)}if(!R){const A=this.w.getLastActiveWindow();A?.win?.isMinimized()&&(R=A.win)}const T=R?this.w.getWindowById(R.id):void 0;if(T){if(this.G.trace("menubar#runActionInRenderer",w),O.$m&&!this.y.isBuilt&&!T.isReady&&(w.type==="commandId"&&w.commandId==="workbench.action.toggleDevTools"||w.type!=="commandId"&&w.userSettingsLabel==="alt+cmd+i"))return!1;if(w.type==="commandId"){const A={id:w.commandId,from:"menu"};T.sendWhenReady("vscode:runAction",v.CancellationToken.None,A)}else{const A={userSettingsLabel:w.userSettingsLabel};T.sendWhenReady("vscode:runKeybinding",v.CancellationToken.None,A)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",w),!1}mb(w,R){const T=typeof w=="string"?this.r[w]:void 0;if(T?.label){if(T.isNative!==!1)R.accelerator=T.label,R.userSettingsLabel=T.userSettingsLabel;else if(typeof R.label=="string"){const A=R.label.indexOf("[");A>=0?R.label=`${R.label.substr(0,A)} [${T.label}]`:R.label=`${R.label} [${T.label}]`}}else R.accelerator=void 0;return R}nb(w,R,T=!R.accelerator){T&&(R=this.mb(w,R));const A=R.click;return R.click=(L,M,V)=>{this.pb(w),A?.(L,M,V)},R}ob(w,R){this.H.openExternal(void 0,w),this.pb(R)}pb(w){this.z.publicLog2("workbenchActionExecuted",{id:w,from:n})}qb(w){return(0,D.$cx)(w,!this.O)}};e.$nic=c,e.$nic=c=o=ke([se(0,S.$oZ),se(1,m.$ej),se(2,s.$lhc),se(3,u.$$gc),se(4,g.$em),se(5,a.$lic),se(6,E.$5R),se(7,$.$Ehc),se(8,p.$fk),se(9,f.$$hc),se(10,y.$yk),se(11,l.$0hc)],c);function h(){return new i.MenuItem({type:"separator"})}}),define(le[280],ue([0,1,6,19,5,279,2]),function(G,e,i,r,v,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=e.$oic=void 0,e.$oic=(0,i.$Ki)("menubarMainService");let I=class extends O.$Zc{constructor(l,m,u){super(),this.b=l,this.c=m,this.f=u,this.a=this.g()}async g(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(D.$nic))}async updateMenubar(l,m){this.f.trace("menubarService#updateMenubar",l),(await this.a).updateMenu(m,l)}};e.$pic=I,e.$pic=I=ke([se(0,i.$Ji),se(1,r.$Ehc),se(2,v.$fk)],I)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[281],ue([0,1,26,13,109,27,21,22,39,4,32,49,2,11,10,71,3,38,18,12,7,9,70,16,53,20,14,6,19,5,73,74,75,34,47,140,29,137,272,30,106,90,59,52,77,40,58,72,85,86]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k,s,a,t,o,n,c,h,P,w,R,T,A,L,M,V,q,Y,de,re,ee,W,Z,C,B,F,z,ie,x,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=void 0,i=Ie(i),R=Ge(R);function oe(X){return(0,re.$Zi)(X?.workspace)}function te(X){return(0,re.$Ui)(X?.workspace)}let j=class extends $.$Zc{constructor(U,N,Q,K,H,_,ae,$e,be,ye,Fe,xe,Ae,me,J,he,fe,pe,ve,je,Oe,Re){super(),this.s=U,this.t=N,this.u=Q,this.w=K,this.z=H,this.C=_,this.D=ae,this.F=$e,this.G=be,this.H=ye,this.I=Fe,this.J=xe,this.L=Ae,this.M=me,this.N=J,this.O=he,this.P=fe,this.Q=pe,this.R=ve,this.S=je,this.U=Oe,this.W=Re,this.a=this.B(new l.$qe),this.onDidOpenWindow=this.a.event,this.b=this.B(new l.$qe),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new l.$qe),this.onDidDestroyWindow=this.c.event,this.f=this.B(new l.$qe),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new l.$qe),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new l.$qe),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new l.$qe),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new l.$qe),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new de.$Mic(this,this.D,this.I,this.z,this.L)),this.X()}X(){this.B(this.N.onDidEnterWorkspace(U=>this.b.fire(U.window))),this.B(this.onDidSignalReadyWindow(U=>{if(U.config?.extensionDevelopmentPath||U.config?.extensionTestsPath){const N=new $.$Yc;if(N.add(l.Event.any(U.onDidClose,U.onDidDestroy)(()=>N.dispose())),U.config.extensionDevelopmentPath)for(const Q of U.config.extensionDevelopmentPath)N.add(this.R.addValidFileRoot(Q));U.config.extensionTestsPath&&N.add(this.R.addValidFileRoot(U.config.extensionTestsPath))}}))}openEmptyWindow(U,N){const Q=this.G.args,K=N?.remoteAuthority||void 0,H=!0,_=N?.forceReuseWindow,ae=!_;return this.open({...U,cli:Q,forceEmpty:H,forceNewWindow:ae,forceReuseWindow:_,remoteAuthority:K,forceTempProfile:N?.forceTempProfile,forceProfile:N?.forceProfile})}openExistingWindow(U,N){U.focus(),this.Y(N,[U])}async open(U){this.z.trace("windowsManager#open"),U.addMode&&(U.initialStartup||!this.getLastActiveWindow())&&(U.addMode=!1);const N=[],Q=[],K=[],H=[],_=[];let ae,$e=!1;const be=await this.eb(U);this.z.trace("windowsManager#open pathsToOpen",be);for(const me of be)te(me)?U.addMode?N.push(me):Q.push(me):oe(me)?K.push(me):me.fileUri?(ae||(ae={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:me.remoteAuthority}),ae.filesToOpenOrCreate.push(me)):me.backupPath?_.push({backupFolder:(0,d.$sc)(me.backupPath),remoteAuthority:me.remoteAuthority}):$e=!0;U.diffMode&&ae&&ae.filesToOpenOrCreate.length>=2&&(ae.filesToDiff=ae.filesToOpenOrCreate.slice(0,2),ae.filesToOpenOrCreate=[]),U.mergeMode&&ae&&ae.filesToOpenOrCreate.length===4&&(ae.filesToMerge=ae.filesToOpenOrCreate.slice(0,4),ae.filesToOpenOrCreate=[],ae.filesToDiff=[]),ae&&U.waitMarkerFileURI&&(ae.filesToWait={paths:(0,O.$Lb)([...ae.filesToDiff,ae.filesToMerge[3],...ae.filesToOpenOrCreate]),waitMarkerFileUri:U.waitMarkerFileURI}),U.initialStartup?(H.push(...this.N.getUntitledWorkspaces()),K.push(...H),_.push(...this.J.getEmptyWindowBackups())):_.length=0;const{windows:ye,filesOpenedInWindow:Fe}=await this.Z(U,K,Q,_,$e,ae,N);if(this.z.trace(`windowsManager#open used window count ${ye.length} (workspacesToOpen: ${K.length}, foldersToOpen: ${Q.length}, emptyToRestore: ${_.length}, openOneEmptyWindow: ${$e})`),ye.length>1)if(Fe)Fe.focus();else{const me=this.r.state.lastActiveWindow&&!U.forceEmpty&&!U.cli._.length&&!U.cli["file-uri"]&&!U.cli["folder-uri"]&&!(U.urisToOpen&&U.urisToOpen.length);let J=!0,he=!0;if(me){const fe=ye.filter(pe=>this.r.state.lastActiveWindow&&pe.backupPath===this.r.state.lastActiveWindow.backupPath);fe.length&&(fe[0].focus(),J=!1,he=!1)}if(J)for(let fe=ye.length-1;fe>=0;fe--){const pe=ye[fe];if(!(pe.openedWorkspace&&H.some(ve=>pe.openedWorkspace&&ve.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&_.some(ve=>pe.backupPath&&ve.backupFolder===(0,d.$sc)(pe.backupPath)))){pe.focus(),he=!1;break}}he&&ye[ye.length-1].focus()}const xe=ae&&ae.filesToDiff.length>0,Ae=ae&&ae.filesToMerge.length>0;if(!ye.some(me=>me.isExtensionDevelopmentHost)&&!xe&&!Ae&&!U.noRecentEntry){const me=[];for(const J of be)oe(J)&&!J.transient?me.push({label:J.label,workspace:J.workspace,remoteAuthority:J.remoteAuthority}):te(J)?me.push({label:J.label,folderUri:J.workspace.uri,remoteAuthority:J.remoteAuthority}):J.fileUri&&me.push({label:J.label,fileUri:J.fileUri,remoteAuthority:J.remoteAuthority});this.M.addRecentlyOpened(me)}return this.Y(U,ye),ye}Y(U,N){const Q=U.waitMarkerFileURI;U.context===q.OpenContext.CLI&&Q&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.Q.del(Q)}catch{}})()}async Z(U,N,Q,K,H,_,ae){const $e=[];let be;function ye(fe,pe){$e.push(fe),pe&&(be=fe,_=void 0)}let{openFolderInNewWindow:Fe,openFilesInNewWindow:xe}=this.qb(U);if(!U.initialStartup&&ae.length>0){const fe=ae[0].remoteAuthority,pe=this.wb(fe);pe&&ye(this.bb(pe,ae.map(ve=>ve.workspace.uri)))}const Ae=Q.length+N.length+K.length;if(_&&Ae===0){const fe=_.filesToOpenOrCreate[0]||_.filesToDiff[0]||_.filesToMerge[3],pe=this.getWindows().filter(je=>_&&(0,g.$qh)(je.remoteAuthority,_.remoteAuthority));let ve;fe?.fileUri&&!xe&&((U.context===q.OpenContext.DESKTOP||U.context===q.OpenContext.CLI||U.context===q.OpenContext.DOCK||U.context===q.OpenContext.LINK)&&(ve=await(0,Y.$qhc)(pe,fe.fileUri,async je=>je.configPath.scheme===p.Schemas.file?this.N.resolveLocalWorkspace(je.configPath):void 0)),ve||(ve=this.xb(pe))),ve?(0,re.$Zi)(ve.openedWorkspace)?N.push({workspace:ve.openedWorkspace,remoteAuthority:ve.remoteAuthority}):(0,re.$Ui)(ve.openedWorkspace)?Q.push({workspace:ve.openedWorkspace,remoteAuthority:ve.remoteAuthority}):ye(this.$(U,ve,_),!0):ye(await this.rb({userEnv:U.userEnv,cli:U.cli,initialStartup:U.initialStartup,filesToOpen:_,forceNewWindow:!0,remoteAuthority:_.remoteAuthority,forceNewTabbedWindow:U.forceNewTabbedWindow,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile}),!0)}const me=(0,O.$Qb)(N,fe=>fe.workspace.id);if(me.length>0){const fe=(0,O.$Lb)(me.map(pe=>(0,Y.$rhc)(this.getWindows(),pe.workspace.configPath)));if(fe.length>0){const pe=fe[0],ve=(0,g.$qh)(_?.remoteAuthority,pe.remoteAuthority)?_:void 0;ye(this.$(U,pe,ve),!!ve),Fe=!0}for(const pe of me){if(fe.some(Oe=>Oe.openedWorkspace&&Oe.openedWorkspace.id===pe.workspace.id))continue;const ve=pe.remoteAuthority,je=(0,g.$qh)(_?.remoteAuthority,ve)?_:void 0;ye(await this.db(U,pe,Fe,je),!!je),Fe=!0}}const J=(0,O.$Qb)(Q,fe=>g.$ch.getComparisonKey(fe.workspace.uri));if(J.length>0){const fe=(0,O.$Lb)(J.map(pe=>(0,Y.$rhc)(this.getWindows(),pe.workspace.uri)));if(fe.length>0){const pe=fe[0],ve=(0,g.$qh)(_?.remoteAuthority,pe.remoteAuthority)?_:void 0;ye(this.$(U,pe,ve),!!ve),Fe=!0}for(const pe of J){if(fe.some(Oe=>(0,re.$Ui)(Oe.openedWorkspace)&&g.$ch.isEqual(Oe.openedWorkspace.uri,pe.workspace.uri)))continue;const ve=pe.remoteAuthority,je=(0,g.$qh)(_?.remoteAuthority,ve)?_:void 0;ye(await this.db(U,pe,Fe,je),!!je),Fe=!0}}const he=(0,O.$Qb)(K,fe=>fe.backupFolder);if(he.length>0)for(const fe of he){const pe=fe.remoteAuthority,ve=(0,g.$qh)(_?.remoteAuthority,pe)?_:void 0;ye(await this.cb(U,!0,pe,ve,fe),!!ve),Fe=!0}if(_||H){const fe=_?_.remoteAuthority:U.remoteAuthority;ye(await this.cb(U,Fe,fe,_),!!_)}return{windows:(0,O.$Qb)($e),filesOpenedInWindow:be}}$(U,N,Q){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:Q}),this.ab(N);const K={filesToOpenOrCreate:Q?.filesToOpenOrCreate,filesToDiff:Q?.filesToDiff,filesToMerge:Q?.filesToMerge,filesToWait:Q?.filesToWait,termProgram:U?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",I.CancellationToken.None,K),N}ab(U){let N=U;const Q=r.BrowserWindow.getFocusedWindow();if(Q&&Q.id!==U.id){const K=this.U.getWindowByWebContents(Q.webContents);K&&K.parentId===U.id&&(N=K)}N.focus()}bb(U,N){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),U.focus();const Q={foldersToAdd:N};return U.sendWhenReady("vscode:addFolders",I.CancellationToken.None,Q),U}cb(U,N,Q,K,H){this.z.trace("windowsManager#doOpenEmpty",{restore:!!H,remoteAuthority:Q,filesToOpen:K,forceNewWindow:N});let _;return!N&&typeof U.contextWindowId=="number"&&(_=this.getWindowById(U.contextWindowId)),this.rb({userEnv:U.userEnv,cli:U.cli,initialStartup:U.initialStartup,remoteAuthority:Q,forceNewWindow:N,forceNewTabbedWindow:U.forceNewTabbedWindow,filesToOpen:K,windowToUse:_,emptyWindowBackupInfo:H,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}db(U,N,Q,K,H){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:K}),!Q&&!H&&typeof U.contextWindowId=="number"&&(H=this.getWindowById(U.contextWindowId)),this.rb({workspace:N.workspace,userEnv:U.userEnv,cli:U.cli,initialStartup:U.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:Q,forceNewTabbedWindow:U.forceNewTabbedWindow,filesToOpen:K,windowToUse:H,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}async eb(U){let N,Q=!1,K=!1;if(U.urisToOpen&&U.urisToOpen.length>0?(N=await this.fb(U),Q=!0):U.forceEmpty?N=[Object.create(null)]:U.cli._.length||U.cli["folder-uri"]||U.cli["file-uri"]?(N=await this.gb(U.cli),N.length===0&&N.push(Object.create(null)),Q=!0):(N=await this.ib(),N.length===0&&N.push(Object.create(null)),K=!0),!U.addMode&&Q){const H=N.filter(_=>te(_));if(H.length>1){const _=H[0].remoteAuthority;if(H.every(ae=>(0,g.$qh)(ae.remoteAuthority,_))){const ae=await this.N.createUntitledWorkspace(H.map($e=>({uri:$e.workspace.uri})));N.push({workspace:ae,remoteAuthority:_}),N=N.filter($e=>!te($e))}}}if(U.initialStartup&&!K&&this.L.getValue("window")?.restoreWindows==="preserve"){const H=await this.ib();N.unshift(...H.filter(_=>oe(_)||te(_)||_.backupPath))}return N}async fb(U){const N={gotoLineMode:U.gotoLineMode,remoteAuthority:U.remoteAuthority},Q=await Promise.all((0,O.$Lb)(U.urisToOpen||[]).map(async K=>{const H=await this.kb(K,N);if(H)return H.label=K.label,H;const _=this.mb(K);this.P.showMessageBox({type:"info",buttons:[(0,s.localize)(2478,null)],message:_.scheme===p.Schemas.file?(0,s.localize)(2479,null):(0,s.localize)(2480,null),detail:_.scheme===p.Schemas.file?(0,s.localize)(2481,null,(0,u.$9w)(_,{os:y.OS,tildify:this.G})):(0,s.localize)(2482,null,_.toString(!0))},r.BrowserWindow.getFocusedWindow()??void 0)}));return(0,O.$Lb)(Q)}async gb(U){const N=[],Q={ignoreFileNotFound:!0,gotoLineMode:U.goto,remoteAuthority:U.remote||void 0,forceOpenWorkspaceAsFile:U.diff&&U._.length===2||U.merge&&U._.length===4},K=U["folder-uri"];if(K){const ae=await Promise.all(K.map($e=>{const be=this.hb($e);if(be)return this.kb({folderUri:be},Q)}));N.push(...(0,O.$Lb)(ae))}const H=U["file-uri"];if(H){const ae=await Promise.all(H.map($e=>{const be=this.hb($e);if(be)return this.kb((0,re.$dj)($e)?{workspaceUri:be}:{fileUri:be},Q)}));N.push(...(0,O.$Lb)(ae))}const _=await Promise.all(U._.map(ae=>Q.remoteAuthority?this.pb(ae,Q):this.nb(ae,Q)));return N.push(...(0,O.$Lb)(_)),N}hb(U){try{const N=k.URI.parse(U);if(!N.scheme){this.z.error(`Invalid URI input string, scheme missing: ${U}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.z.error(`Invalid URI input string: ${U}, ${N.message}`)}}async ib(){const U=this.jb();switch(U){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];U!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const Q=await Promise.all(N.map(async K=>{if(K.workspace){const H=await this.kb({workspaceUri:K.workspace.configPath},{remoteAuthority:K.remoteAuthority,rejectTransientWorkspaces:!0});if(oe(H))return H}else if(K.folderUri){const H=await this.kb({folderUri:K.folderUri},{remoteAuthority:K.remoteAuthority});if(te(H))return H}else if(U!=="folders"&&K.backupPath)return{backupPath:K.backupPath,remoteAuthority:K.remoteAuthority}}));return(0,O.$Lb)(Q)}}}jb(){let U;return this.I.wasRestarted?U="all":(U=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(U)||(U="all")),U}async kb(U,N=Object.create(null)){const Q=this.mb(U);return Q.scheme===p.Schemas.file?((0,M.$sE)(U)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.nb(Q.fsPath,N)):this.lb(U,N)}lb(U,N){let Q=this.mb(U);const K=(0,A.$nn)(Q)||N.remoteAuthority;if(Q=(0,g.$sh)((0,g.$mh)(Q)),(0,M.$sE)(U)){if(N.gotoLineMode){const{path:H,line:_,column:ae}=(0,m.$Rg)(Q.path);return{fileUri:Q.with({path:H}),options:{selection:_?{startLineNumber:_,startColumn:ae||1}:void 0},remoteAuthority:K}}return{fileUri:Q,remoteAuthority:K}}else if((0,M.$qE)(U))return{workspace:(0,ee.$uhc)(Q),remoteAuthority:K};return{workspace:(0,ee.$vhc)(Q),remoteAuthority:K}}mb(U){return(0,M.$qE)(U)?U.workspaceUri:(0,M.$rE)(U)?U.folderUri:U.fileUri}async nb(U,N,Q){let K,H;N.gotoLineMode&&({path:U,line:K,column:H}=(0,m.$Rg)(U)),U=(0,m.$Lg)((0,d.$mc)(U),(0,E.cwd)());try{const _=await i.promises.stat(U);if(_.isFile()){if(!N.forceOpenWorkspaceAsFile){const ae=await this.N.resolveLocalWorkspace(k.URI.file(U));if(ae)return ae.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:ae.id,configPath:ae.configPath},type:c.FileType.File,exists:!0,remoteAuthority:ae.remoteAuthority,transient:ae.transient}}return{fileUri:k.URI.file(U),type:c.FileType.File,exists:!0,options:{selection:K?{startLineNumber:K,startColumn:H||1}:void 0}}}else{if(_.isDirectory())return{workspace:(0,ee.$vhc)(k.URI.file(U),_),type:c.FileType.Directory,exists:!0};if(!y.$l&&U==="/dev/null")return{fileUri:k.URI.file(U),type:c.FileType.File,exists:!0}}}catch(_){if(_.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!Q)return this.ob(U,N);const ae=k.URI.file(U);if(this.M.removeRecentlyOpened([ae]),N.ignoreFileNotFound)return{fileUri:ae,type:c.FileType.File,exists:!1}}}async ob(U,N){const Q=k.URI.file(U),{response:K,checkboxChecked:H}=await this.P.showMessageBox({type:"warning",buttons:[(0,s.localize)(2483,null),(0,s.localize)(2484,null),(0,s.localize)(2485,null)],message:(0,s.localize)(2486,null,Q.authority),detail:(0,s.localize)(2487,null,(0,u.$9w)(Q,{os:y.OS,tildify:this.G})),checkboxLabel:(0,s.localize)(2488,null,Q.authority),cancelId:1});if(K===0){if((0,v.addUNCHostToAllowlist)(Q.authority),H){const _={channel:"vscode:configureAllowedUNCHost",args:Q.authority};this.sendToFocused(_.channel,_.args),this.sendToOpeningWindow(_.channel,_.args)}return this.nb(U,N,!0)}if(K===2)return r.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.ob(U,N)}pb(U,N){const Q=U.charCodeAt(0),K=N.remoteAuthority;let H,_;N.gotoLineMode&&({path:U,line:H,column:_}=(0,m.$Rg)(U)),Q!==b.CharCode.Slash&&((0,m.$Kg)(Q)&&U.charCodeAt(U.charCodeAt(1))===b.CharCode.Colon&&(U=(0,m.$Dg)(U)),U=`/${U}`);const ae=k.URI.from({scheme:p.Schemas.vscodeRemote,authority:K,path:U});if(U.charCodeAt(U.length-1)!==b.CharCode.Slash){if((0,re.$dj)(U))return N.forceOpenWorkspaceAsFile?{fileUri:ae,options:{selection:H?{startLineNumber:H,startColumn:_||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,ee.$uhc)(ae),remoteAuthority:K};if(N.gotoLineMode||d.$lc.basename(U).indexOf(".")!==-1)return{fileUri:ae,options:{selection:H?{startLineNumber:H,startColumn:_||1}:void 0},remoteAuthority:K}}return{workspace:(0,ee.$vhc)(ae),remoteAuthority:K}}qb(U){const N=this.L.getValue("window"),Q=N?.openFoldersInNewWindow||"default",K=N?.openFilesInNewWindow||"off";let H=(U.preferNewWindow||U.forceNewWindow)&&!U.forceReuseWindow;!U.forceNewWindow&&!U.forceReuseWindow&&(Q==="on"||Q==="off")&&(H=Q==="on");let _=!1;return U.forceNewWindow||U.forceReuseWindow?_=!!U.forceNewWindow&&!U.forceReuseWindow:(y.$m?U.context===q.OpenContext.DOCK&&(_=!0):U.context!==q.OpenContext.DIALOG&&U.context!==q.OpenContext.MENU&&!(U.userEnv&&U.userEnv.TERM_PROGRAM==="vscode")&&(_=!0),!U.cli.extensionDevelopmentPath&&(K==="on"||K==="off")&&(_=K==="on")),{openFolderInNewWindow:!!H,openFilesInNewWindow:_}}async openExtensionDevelopmentHostWindow(U,N){const Q=(0,Y.$shc)(this.getWindows(),U);if(Q)return this.I.reload(Q,N.cli),Q.focus(),[Q];let K=N.cli["folder-uri"]||[],H=N.cli["file-uri"]||[],_=N.cli._;if(!_.length&&!K.length&&!H.length&&!N.cli.extensionTestsPath){const be=this.r.state.lastPluginDevelopmentHostWindow,ye=be?.workspace??be?.folderUri;ye&&(k.URI.isUri(ye)?ye.scheme===p.Schemas.file?_=[ye.fsPath]:K=[ye.toString()]:ye.configPath.scheme===p.Schemas.file?_=[(0,g.$_g)(ye.configPath)]:H=[ye.configPath.toString()])}let ae=N.remoteAuthority;for(const be of U)if(be.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ye=k.URI.parse(be),Fe=(0,A.$nn)(ye);Fe&&(ae?(0,g.$qh)(Fe,ae)||this.z.error("more than one extension development path authority"):ae=Fe)}_=_.filter(be=>{const ye=k.URI.file(be);return(0,Y.$rhc)(this.getWindows(),ye)?!1:(0,g.$qh)((0,A.$nn)(ye),ae)}),K=K.filter(be=>{const ye=this.hb(be);return ye&&(0,Y.$rhc)(this.getWindows(),ye)?!1:ye?(0,g.$qh)((0,A.$nn)(ye),ae):!1}),H=H.filter(be=>{const ye=this.hb(be);return ye&&(0,Y.$rhc)(this.getWindows(),ye)?!1:ye?(0,g.$qh)((0,A.$nn)(ye),ae):!1}),N.cli._=_,N.cli["folder-uri"]=K,N.cli["file-uri"]=H;const $e={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!_.length&&!K.length&&!H.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:ae,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open($e)}async rb(U){const N=this.L.getValue("window"),Q=this.getLastActiveWindow(),H=(N?.newWindowProfile?this.H.profiles.find($e=>$e.name===N.newWindowProfile):void 0)??Q?.profile??this.H.defaultProfile;let _;!U.forceNewWindow&&!U.forceNewTabbedWindow&&(_=U.windowToUse||Q,_&&_.focus());const ae={...this.G.args,...U.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:U.emptyWindowBackupInfo?(0,d.$oc)(this.G.backupHome,U.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:H},homeDir:this.G.userHome.with({scheme:p.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:p.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:U.remoteAuthority,workspace:U.workspace,userEnv:{...this.w,...U.userEnv},nls:{messages:(0,s.getNLSMessages)(),language:(0,s.getNLSLanguage)()},filesToOpenOrCreate:U.filesToOpen?.filesToOpenOrCreate,filesToDiff:U.filesToOpen?.filesToDiff,filesToMerge:U.filesToOpen?.filesToMerge,filesToWait:U.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:p.Schemas.file}).fsPath,product:R.default,isInitialStartup:U.initialStartup,perfMarks:(0,f.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)(),arch:(0,D.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:r.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn,cssModules:this.W.isEnabled?await this.W.getCssModules():void 0};if(_){const $e=_.config;!ae.extensionDevelopmentPath&&$e?.extensionDevelopmentPath&&(ae.extensionDevelopmentPath=$e.extensionDevelopmentPath,ae.extensionDevelopmentKind=$e.extensionDevelopmentKind,ae["enable-proposed-api"]=$e["enable-proposed-api"],ae.verbose=$e.verbose,ae["inspect-extensions"]=$e["inspect-extensions"],ae["inspect-brk-extensions"]=$e["inspect-brk-extensions"],ae.debugId=$e.debugId,ae.extensionEnvironment=$e.extensionEnvironment,ae["extensions-dir"]=$e["extensions-dir"],ae["disable-extensions"]=$e["disable-extensions"]),ae.loggers={global:ae.loggers.global,window:$e?.loggers.window??ae.loggers.window}}else{const $e=this.r.getNewWindowState(ae);(0,f.mark)("code/willCreateCodeWindow");const be=_=this.O.createInstance(V.$Chc,{state:$e,extensionDevelopmentPath:ae.extensionDevelopmentPath,isExtensionTestHost:!!ae.extensionTestsPath});(0,f.mark)("code/didCreateCodeWindow"),U.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(be),this.n.set(be.id,be),this.a.fire(be),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ye=new $.$Yc;ye.add(be.onDidSignalReady(()=>this.b.fire(be))),ye.add(l.Event.once(be.onDidClose)(()=>this.ub(be,ye))),ye.add(l.Event.once(be.onDidDestroy)(()=>this.vb(be))),ye.add(be.onDidMaximize(()=>this.g.fire(be))),ye.add(be.onDidUnmaximize(()=>this.h.fire(be))),ye.add(be.onDidEnterFullScreen(()=>this.j.fire({window:be,fullscreen:!0}))),ye.add(be.onDidLeaveFullScreen(()=>this.j.fire({window:be,fullscreen:!1}))),ye.add(be.onDidTriggerSystemContextMenu(({x:xe,y:Ae})=>this.m.fire({window:be,x:xe,y:Ae})));const Fe=(0,S.$ug)(be.win?.webContents);Fe.removeAllListeners("devtools-reload-page"),ye.add(l.Event.fromNodeEventEmitter(Fe,"devtools-reload-page")(()=>this.I.reload(be))),this.I.registerWindow(be)}return ae.windowId=_.id,_.isReady?this.I.unload(_,C.UnloadReason.LOAD).then(async $e=>{$e||await this.sb(_,ae,U,H)}):await this.sb(_,ae,U,H),_}async sb(U,N,Q,K){if(N.extensionDevelopmentPath||((0,re.$Zi)(N.workspace)?N.backupPath=this.J.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,re.$Ui)(N.workspace)?N.backupPath=this.J.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.J.registerEmptyWindowBackup({backupFolder:Q.emptyWindowBackupInfo?.backupFolder??(0,ee.$whc)().id,remoteAuthority:N.remoteAuthority})),this.H.isEnabled()){const H=N.workspace??(0,re.$Yi)(N.backupPath,!1),_=this.tb(Q,H,K),ae=_ instanceof Promise?await _:_;N.profiles.profile=ae,N.extensionDevelopmentPath||await this.H.setProfileForWorkspace(H,ae)}U.load(N)}tb(U,N,Q){return U.forceProfile?this.H.profiles.find(K=>K.name===U.forceProfile)??this.H.createNamedProfile(U.forceProfile):U.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(N)??Q}ub(U,N){this.n.delete(U.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}vb(U){this.n.delete(U.id),this.c.fire(U)}getFocusedWindow(){const U=r.BrowserWindow.getFocusedWindow();if(U)return this.getWindowById(U.id)}getLastActiveWindow(){return this.xb(this.getWindows())}wb(U){return this.xb(this.getWindows().filter(N=>(0,g.$qh)(N.remoteAuthority,U)))}xb(U){return(0,q.$nhc)(U)}sendToFocused(U,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(U,I.CancellationToken.None,...N)}sendToOpeningWindow(U,...N){this.B(l.Event.once(this.onDidSignalReadyWindow)(Q=>{Q.sendWhenReady(U,I.CancellationToken.None,...N)}))}sendToAll(U,N,Q){for(const K of this.getWindows())Q&&Q.indexOf(K.id)>=0||K.sendWhenReady(U,I.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(U){return this.n.get(U)}getWindowByWebContents(U){const N=r.BrowserWindow.fromWebContents(U);if(!N)return;const Q=this.getWindowById(N.id);return Q?.matches(U)?Q:void 0}};e.$Pic=j,e.$Pic=j=ke([se(4,w.$fk),se(5,ie.$zhc),se(6,L.$5R),se(7,F.$zo),se(8,n.$$gc),se(9,z.$ohc),se(10,P.$Ehc),se(11,a.$fhc),se(12,t.$ej),se(13,W.$lic),se(14,Z.$xhc),se(15,h.$Ji),se(16,o.$ghc),se(17,c.$fl),se(18,T.$ihc),se(19,B.$jhc),se(20,x.$0hc),se(21,ce.$jS)],j)}),define(le[282],ue([0,1,70,29,90,59]),function(G,e,i,r,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=void 0;let O=class{constructor(b,l,m,u){this.a=b,this.b=l,this.c=m,this.d=u,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(b,l){const m=this.b.getWindowById(b);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),l)}createUntitledWorkspace(b,l,m){return this.a.createUntitledWorkspace(l,m)}deleteUntitledWorkspace(b,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(b,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(b){return this.c.getRecentlyOpened()}addRecentlyOpened(b,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(b,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(b){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$Ric=O,e.$Ric=O=ke([se(0,D.$xhc),se(1,r.$lhc),se(2,v.$lic),se(3,i.$fhc)],O)}),define(le[283],ue([0,1,13,109,35,27,17,55,15,4,287,49,2,11,10,3,12,7,33,164,45,165,122,138,9,70,257,16,264,99,139,53,100,191,20,69,103,179,267,181,182,183,14,195,102,84,6,101,190,273,274,258,265,19,5,280,65,28,75,268,104,34,247,89,131,24,224,225,57,51,237,262,275,263,276,135,239,240,241,244,271,47,29,281,246,30,105,90,282,59,40,204,58,217,50,88,136,249,266,254,8,227,248,199,72,270,243,21,76,269,235,210,67,85,278,79,86]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k,s,a,t,o,n,c,h,P,w,R,T,A,L,M,V,q,Y,de,re,ee,W,Z,C,B,F,z,ie,x,ce,oe,te,j,X,U,N,Q,K,H,_,ae,$e,be,ye,Fe,xe,Ae,me,J,he,fe,pe,ve,je,Oe,Re,We,Ke,Qe,qe,Xe,Ye,Je,Ce,ne,ge,we,Ee,Me,Be,_e,lt,rt,at,tt,ut,ct,ft,gt,Lt,mt,$t,Tt,jt,Mt,pt,Ft,Et,dt,Nt,Ct,wt,Wt,St,Bt,kt,Pt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=void 0;let yt=class extends $.$Zc{static{bt=this}static{this.a={[p.Schemas.file]:"security.promptForLocalFileProtocolHandling",[p.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(De,Le,Te,Se,Pe,ze,Ve,Ze,Ne,He,Ue,et){super(),this.g=De,this.h=Le,this.j=Te,this.m=Se,this.n=Pe,this.s=ze,this.t=Ve,this.u=Ze,this.w=Ne,this.y=He,this.z=Ue,this.C=et,this.D(),this.F()}D(){const De=Ne=>Ne?.startsWith(`${p.Schemas.vscodeWebview}://`),Le=new Set(["clipboard-read","clipboard-sanitized-write"]);i.session.defaultSession.setPermissionRequestHandler((Ne,He,Ue,et)=>De(et.requestingUrl)?Ue(Le.has(He)):Ue(!1)),i.session.defaultSession.setPermissionCheckHandler((Ne,He,Ue,et)=>De(et.requestingUrl)?Le.has(He):!1);const Te=new Set([p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemoteResource,p.Schemas.vscodeManagedRemoteResource,"devtools"]),Se=Ne=>{for(let He=Ne;He;He=He.parent)if(He.url.startsWith(`${p.Schemas.vscodeWebview}://`))return!0;return!1},Pe=Ne=>Ne.resourceType==="xhr"||Se(Ne.frame),ze=Ne=>{const He=Ne.frame;if(!He||!this.b)return!1;const Ue=i.BrowserWindow.getAllWindows();for(const et of Ue)if(He.processId===et.webContents.mainFrame.processId)return!0;return!1},Ve=(Ne,He)=>{if(Ne.path!=="/index.html")return!0;const Ue=He.frame;if(!Ue||!this.b)return!1;for(const et of this.b.getWindows())if(et.win&&Ue.processId===et.win.webContents.mainFrame.processId)return!0;return!1};i.session.defaultSession.webRequest.onBeforeRequest((Ne,He)=>{const Ue=E.URI.parse(Ne.url);return Ue.scheme===p.Schemas.vscodeWebview&&!Ve(Ue,Ne)?(this.m.error("Blocked vscode-webview request",Ne.url),He({cancel:!0})):Ue.scheme===p.Schemas.vscodeFileResource&&!ze(Ne)?(this.m.error("Blocked vscode-file request",Ne.url),He({cancel:!0})):Ue.path.endsWith(".svg")&&!Te.has(Ue.scheme)?He({cancel:!Pe(Ne)}):He({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Ne,He)=>{const Ue=Ne.responseHeaders,et=Ue["content-type"]||Ue["Content-Type"];if(et&&Array.isArray(et)){const it=E.URI.parse(Ne.url);if(it.path.endsWith(".svg")&&Te.has(it.scheme))return Ue["Content-Type"]=["image/svg+xml"],He({cancel:!1,responseHeaders:Ue});if(!it.path.endsWith(p.Schemas.vscodeRemoteResource)&&et.some(ot=>ot.toLowerCase().includes("image/svg")))return He({cancel:!Pe(Ne)})}return He({cancel:!1})}),i.session.defaultSession.webRequest.onHeadersReceived((Ne,He)=>{if(Ne.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ue=Ne.responseHeaders??Object.create(null);if(Ue["Access-Control-Allow-Origin"]===void 0)return Ue["Access-Control-Allow-Origin"]=["*"],He({cancel:!1,responseHeaders:Ue})}return He({cancel:!1})});const Ze=i.session.defaultSession;typeof Ze.setCodeCachePath=="function"&&this.s.codeCachePath&&Ze.setCodeCachePath((0,d.$oc)(this.s.codeCachePath,"chrome")),f.$l&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,b.setUnexpectedErrorHandler)(Te=>this.G(Te)),process.on("uncaughtException",Te=>{(0,b.$3)(Te)||(0,b.$4)(Te)}),process.on("unhandledRejection",Te=>(0,b.$4)(Te)),l.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,S.$qY)(),i.app.on("accessibility-support-changed",(Te,Se)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",Se)}),i.app.on("activate",async(Te,Se)=>{this.m.trace("app#activate"),Se||await this.b?.openEmptyWindow({context:Je.OpenContext.DOCK})}),i.app.on("web-contents-created",(Te,Se)=>{Se?.opener?.url.startsWith(`${p.Schemas.vscodeFileResource}://${p.$4g}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(Se)),Se.on("will-navigate",Pe=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),Se.setWindowOpenHandler(Pe=>Pe.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Pe)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Pe.url}}`),this.f?.openExternal(void 0,Pe.url),{action:"deny"}))});let De=[],Le;i.app.on("open-file",(Te,Se)=>{Se=(0,kt.$sm)(Se),this.m.trace("app#open-file: ",Se),Te.preventDefault(),De.push((0,ge.$dj)(Se)?{workspaceUri:E.URI.file(Se)}:{fileUri:E.URI.file(Se)}),Le!==void 0&&(clearTimeout(Le),Le=void 0),Le=setTimeout(async()=>{await this.b?.open({context:Je.OpenContext.DOCK,cli:this.s.args,urisToOpen:De,gotoLineMode:!1,preferNewWindow:!0}),De=[],Le=void 0},100)}),i.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Je.OpenContext.DESKTOP})}),v.$pY.handle("vscode:fetchShellEnv",Te=>{const Se=this.b?.getWindowByWebContents(Te.sender);let Pe,ze;return Se?.config?(Pe=Se.config,ze={...process.env,...Se.config.userEnv}):(Pe=this.s.args,ze=process.env),this.W(Pe,ze,!1)}),v.$pY.on("vscode:toggleDevTools",Te=>Te.sender.toggleDevTools()),v.$pY.on("vscode:openDevTools",Te=>Te.sender.openDevTools()),v.$pY.on("vscode:reloadWindow",Te=>Te.sender.reload()),v.$pY.handle("vscode:notifyZoomLevel",async(Te,Se)=>{const Pe=this.b?.getWindowByWebContents(Te.sender);Pe&&Pe.notifyZoomLevel(Se)})}G(De){if(De){const Le={message:`[uncaught exception in main]: ${De.message}`,stack:De.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.m.error(`[uncaught exception in main]: ${De}`),De.stack&&this.m.error(De.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const De=this.z.win32AppUserModelId;f.$l&&De&&i.app.setAppUserModelId(De);try{f.$m&&this.u.getValue("window.nativeTabs")===!0&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.m.error(Ue)}const Le=new s.$wY;l.Event.once(this.t.onWillShutdown)(Ue=>{Ue.reason===X.ShutdownReason.KILL&&Le.dispose()}),this.m.trace("Resolving machine identifier...");const[Te,Se,Pe]=await Promise.all([(0,$t.$1ic)(this.w,this.m),(0,$t.$2ic)(this.w,this.m),(0,$t.$3ic)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Te}`);const{sharedProcessReady:ze,sharedProcessClient:Ve}=this.O(Te,Se,Pe),Ze=await this.P(Te,Se,Pe,ze);Ze.invokeFunction(Ue=>Ue.get(t.$Ohc)),this.B(Ze.createInstance(gt.$Vic)),Ze.invokeFunction(Ue=>this.Q(Ue,Le,Ve));const Ne=await Ze.invokeFunction(Ue=>this.H(Ue,Le));this.I(Le),this.t.phase=X.LifecycleMainPhase.Ready,await Ze.invokeFunction(Ue=>this.R(Ue,Ne)),this.t.phase=X.LifecycleMainPhase.AfterWindowOpen,this.S(),this.B(new mt.$Wh(()=>{this.B((0,mt.$1h)(()=>this.t.phase=X.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async H(De,Le){const Te=this.b=De.get(Je.$lhc),Se=De.get(Re.$eZ),Pe=this.f=De.get(Q.$$hc),ze=De.get(T.$ghc),Ve=this;Se.registerHandler({async handleURL(it,ot){return Ve.N(Te,ze,Se,it,ot)}});const Ze=this.B(new ne.$Qic({onDidOpenMainWindow:Pe.onDidOpenMainWindow,onDidFocusMainWindow:Pe.onDidFocusMainWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),Ne=new k.$si(it=>Ze.getActiveClientId().then(ot=>it===ot)),He=new We.$Hic(Ne,this.m),Ue=Le.getChannel("urlHandler",He);Se.registerHandler(new We.$Gic(Ue));const et=await this.J(Te,ze);return this.B(new Qe.$Iic(et?.urls,Se,Te,this.s,this.z,this.m)),et}I(De){const Le=()=>({statusCode:404,data:"Not found"}),Te=new Wt.$Y(()=>De.getChannel(wt.$0ic,new wt.$$ic));i.protocol.registerBufferProtocol(p.Schemas.vscodeManagedRemoteResource,(Se,Pe)=>{const ze=E.URI.parse(Se.url);if(!ze.authority.startsWith("window:"))return Pe(Le());Te.value.call(wt.$9ic,[ze]).then(Ve=>Pe({...Ve,data:Buffer.from(Ve.body,"base64")}),Ve=>{this.m.warn("error dispatching remote resource call",Ve),Pe({statusCode:500,data:String(Ve)})})})}async J(De,Le){const Te=this.s.args["open-url"]?this.s.args._urls||[]:[];Te.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Te);const Se=global.getOpenUrls()||[];if(Se.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Se),Te.length+Se.length===0)return;const Pe=[...Te,...Se].map(Ze=>{try{return{uri:E.URI.parse(Ze),originalUrl:Ze}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ze);return}}),ze=[],Ve=[];for(const Ze of Pe){if(!Ze)continue;const Ne=this.M(Ze.uri);if(Ne)if(await this.L(Ne,De,Le)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ze.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ze.uri.toString(!0),Ne),ze.push(Ne);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ze.uri.toString(!0)),Ve.push(Ze)}return{urls:Ve,openables:ze}}async L(De,Le,Te){let Se,Pe;if((0,Ye.$qE)(De)?(Se=De.workspaceUri,Pe=(0,o.localize)(145,null,Se.scheme===p.Schemas.file?(0,u.$9w)(Se,{os:f.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort)):(0,Ye.$rE)(De)?(Se=De.folderUri,Pe=(0,o.localize)(146,null,Se.scheme===p.Schemas.file?(0,u.$9w)(Se,{os:f.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort)):(Se=De.fileUri,Pe=(0,o.localize)(147,null,Se.scheme===p.Schemas.file?(0,u.$9w)(Se,{os:f.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort)),Se.scheme!==p.Schemas.file&&Se.scheme!==p.Schemas.vscodeRemote||this.u.getValue(bt.a[Se.scheme])===!1)return!1;const{response:Ve,checkboxChecked:Ze}=await Te.showMessageBox({type:"warning",buttons:[(0,o.localize)(148,null),(0,o.localize)(149,null)],message:Pe,detail:(0,o.localize)(150,null),checkboxLabel:Se.scheme===p.Schemas.file?(0,o.localize)(151,null):(0,o.localize)(152,null),cancelId:1});if(Ve!==0)return!0;if(Ze){const Ne={channel:"vscode:disablePromptForProtocolHandling",args:Se.scheme===p.Schemas.file?"local":"remote"};Le.sendToFocused(Ne.channel,Ne.args),Le.sendToOpeningWindow(Ne.channel,Ne.args)}return!1}M(De){if(De.path){if(De.authority===p.Schemas.file){const Le=E.URI.file(De.fsPath);return(0,ge.$dj)(Le)?{workspaceUri:Le}:{fileUri:Le}}else if(De.authority===p.Schemas.vscodeRemote){const Le=De.path.indexOf(d.$lc.sep,1);let Te,Se;Le!==-1?(Te=De.path.substring(1,Le),Se=De.path.substring(Le)):(Te=De.path.substring(1),Se="/");let Pe=De.query;const ze=new URLSearchParams(De.query);ze.get("windowId")==="_blank"&&(ze.delete("windowId"),Pe=ze.toString());const Ve=E.URI.from({scheme:p.Schemas.vscodeRemote,authority:Te,path:Se,query:Pe,fragment:De.fragment});return(0,ge.$dj)(Se)?{workspaceUri:Ve}:/:[\d]+$/.test(Se)?{fileUri:Ve}:{folderUri:Ve}}}}async N(De,Le,Te,Se,Pe){this.m.trace("app#handleProtocolUrl():",Se.toString(!0),Pe),Se.scheme===this.z.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:E.URI.parse(Se.query).path,query:""}));let ze=!1;const Ve=new URLSearchParams(Se.query);Ve.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Ve.delete("windowId"),Se=Se.with({query:Ve.toString()}),ze=!0):f.$m&&De.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),ze=!0);const Ze=Ve.get("continueOn");Ze!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),Ve.delete("continueOn"),Se=Se.with({query:Ve.toString()}),this.s.continueOn=Ze??void 0);const Ne=this.M(Se);return Ne?await this.L(Ne,De,Le)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ne,Se.toString(!0)),(0,Et.$Sb)(await De.open({context:Je.OpenContext.LINK,cli:{...this.s.args},urisToOpen:[Ne],forceNewWindow:ze,gotoLineMode:!0}))?.focus(),!0):ze?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0)),await(0,Et.$Sb)(await De.open({context:Je.OpenContext.LINK,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,H.$nn)(Se)}))?.ready(),Te.open(Se,Pe)):(this.m.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),Pe),!1)}O(De,Le,Te){const Se=this.B(this.j.createInstance(_.$tic,De,Le,Te));this.B(Se.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Pe=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ve=await Se.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new a.$xY(Ve,"main")})();return{sharedProcessReady:(async()=>(await Se.whenReady(),Pe))(),sharedProcessClient:Pe}}async P(De,Le,Te,Se){const Pe=new ie.$Ii;switch(process.platform){case"win32":Pe.set(he.$oZ,new F.$Hi(Oe.$Eic));break;case"linux":f.$o?Pe.set(he.$oZ,new F.$Hi(je.$Dic,[process.env.SNAP,process.env.SNAP_REVISION])):Pe.set(he.$oZ,new F.$Hi(ve.$Cic));break;case"darwin":Pe.set(he.$oZ,new F.$Hi(pe.$Bic));break}Pe.set(Je.$lhc,new F.$Hi(Ce.$Pic,[De,Le,Te,this.h],!1)),Pe.set(St.$0hc,new F.$Hi(Bt.$_ic,void 0,!1));const ze=new T.$hhc(this.m,this.z);Pe.set(T.$ghc,ze),Pe.set(j.$fic,new F.$Hi(j.$gic,void 0,!1)),Pe.set(R.$Vhc,new F.$Hi(R.$Whc,void 0,!1)),Pe.set(w.$Ym,k.ProxyChannel.toService((0,k.$qi)(Se.then(Ue=>Ue.getChannel("diagnostics"))))),Pe.set(x.$Cvb,new F.$Hi(ce.$aic,[this.h])),Pe.set(x.$Dvb,new F.$Hi(oe.$bic,[this.h])),Pe.set(A.$$Y,new F.$Hi(L.$Xhc)),Pe.set(te.$cic,new F.$Hi(te.$dic)),Pe.set(Q.$$hc,new F.$Hi(Q.$_hc,void 0,!1)),Pe.set(qe.$Jic,new F.$Hi(Xe.$Lic)),Pe.set(N.$oic,new F.$Hi(N.$pic)),Pe.set(Y.$Yhc,new F.$Hi(de.$1hc)),Pe.set(ye.$Khc,new F.$Hi(ye.$Lhc)),Pe.set(ye.$Mhc,new F.$Hi(ye.$Nhc));const Ve=new Nt.$8ic({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ze=new Ct.$Ys(Ve,this.u,this.m,this.n);Pe.set(dt.$zs,Ze),f.$l?Pe.set(re.$2hc,new F.$Hi(ee.$3hc)):f.$m?Pe.set(re.$2hc,new F.$Hi(ee.$4hc)):f.$n&&Pe.set(re.$2hc,new F.$Hi(ee.$5hc));const Ne=new c.$Qhc(this.s,this.u,this.m,this.w);Pe.set(n.$fhc,Ne);const He=new Be.$yhc(this.s,this.m,this.C,Ne,ze);if(Pe.set(Be.$xhc,He),Pe.set(we.$Sib,new F.$Hi(Me.$Ric,void 0,!1)),Pe.set(Ee.$lic,new F.$Hi(Ee.$mic,void 0,!1)),Pe.set(Re.$eZ,new F.$Hi(Ke.$gZ,void 0,!1)),(0,J.$Kp)(this.z,this.s)){const Ue=(0,J.$Pp)(this.z,this.u),et=(0,k.$qi)(Se.then(vt=>vt.getChannel("telemetryAppender"))),it=new Ae.$wic(et),ot=(0,Fe.$Bp)((0,D.release)(),(0,D.hostname)(),process.arch,this.z.commit,this.z.version,De,Le,Te,Ue),nt=(0,J.$Qp)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Pe.set(xe.$em,new F.$Hi(me.$ps,[ht],!1))}else Pe.set(xe.$em,J.$Fp);return Pe.set(ut.$Rq,new F.$Hi(Tt.$_R,void 0,!0)),Pe.set(ct.$Vq,new F.$Hi(ft.$Uic,void 0,!0)),Pe.set(pt.$6ic,new F.$Hi(pt.$7ic,void 0,!0)),Pe.set(t.$Ohc,new F.$Hi(t.$Phc)),Pe.set(Pt.$jS,new F.$Hi(Pt.$kS,void 0,!0)),await mt.Promises.settled([Ne.initialize(),He.initialize()]),this.j.createChild(Pe)}Q(De,Le,Te){const Se=this.B(new $.$Yc),Pe=k.ProxyChannel.fromService(De.get(j.$fic),Se,{disableMarshalling:!0});this.g.registerChannel("launch",Pe);const ze=k.ProxyChannel.fromService(De.get(R.$Vhc),Se,{disableMarshalling:!0});this.g.registerChannel("diagnostics",ze);const Ve=Se.add(new lt.$Sic(De.get(_e.$zo)));Le.registerChannel("policy",Ve),Te.then(st=>st.registerChannel("policy",Ve));const Ze=this.y.getProvider(p.Schemas.file);(0,y.$tg)(Ze instanceof B.$Br);const Ne=Se.add(new C.$6hc(Ze,this.m,this.s));Le.registerChannel(W.$UR,Ne),Te.then(st=>st.registerChannel(W.$UR,Ne));const He=k.ProxyChannel.fromService(De.get(rt.$ohc),Se);Le.registerChannel("userDataProfiles",He),Te.then(st=>st.registerChannel("userDataProfiles",He));const Ue=new at.$ks(De.get(tt.$bq));Te.then(st=>st.registerChannel("request",Ue));const et=new fe.$xic(De.get(he.$oZ));Le.registerChannel("update",et);const it=k.ProxyChannel.fromService(De.get(x.$Cvb),Se);Le.registerChannel("issue",it);const ot=k.ProxyChannel.fromService(De.get(x.$Dvb),Se);Le.registerChannel("process",ot);const nt=k.ProxyChannel.fromService(De.get(A.$$Y),Se);Le.registerChannel("encryption",nt);const ht=k.ProxyChannel.fromService(De.get(ae.$5l),Se);Le.registerChannel("sign",ht);const vt=k.ProxyChannel.fromService(De.get(te.$cic),Se);Le.registerChannel("keyboardLayout",vt),this.f=De.get(Q.$$hc);const It=k.ProxyChannel.fromService(this.f,Se);Le.registerChannel("nativeHost",It),Te.then(st=>st.registerChannel("nativeHost",It));const Ut=k.ProxyChannel.fromService(De.get(we.$Sib),Se);Le.registerChannel("workspaces",Ut);const qt=k.ProxyChannel.fromService(De.get(N.$oic),Se);Le.registerChannel("menubar",qt);const zt=k.ProxyChannel.fromService(De.get(Re.$eZ),Se);Le.registerChannel("url",zt);const Ht=k.ProxyChannel.fromService(De.get(qe.$Jic),Se);Le.registerChannel("webview",Ht);const Rt=Se.add(new be.$uic(this.m,De.get(ye.$Khc)));Le.registerChannel("storage",Rt),Te.then(st=>st.registerChannel("storage",Rt));const xt=Se.add(new Lt.$Wic(De.get(ye.$Khc),De.get(rt.$ohc),this.m));Te.then(st=>st.registerChannel("profileStorageListener",xt));const Vt=k.ProxyChannel.fromService(De.get(dt.$zs),Se);Le.registerChannel(dt.TerminalIpcChannels.LocalPty,Vt);const Gt=k.ProxyChannel.fromService(De.get(re.$2hc),Se);Le.registerChannel("externalTerminal",Gt);const Dt=new jt.$4ic(De.get(Mt.$zhc));Le.registerChannel("logger",Dt),Te.then(st=>st.registerChannel("logger",Dt));const Kt=new P.$Rhc(De.get(Je.$lhc));Le.registerChannel("extensionhostdebugservice",Kt);const Zt=k.ProxyChannel.fromService(De.get(Y.$Yhc),Se);Le.registerChannel(Y.$Zhc,Zt);const Yt=k.ProxyChannel.fromService(De.get(pt.$6ic),Se);Le.registerChannel(Ft.$5ic,Yt)}async R(De,Le){const Te=this.b=De.get(Je.$lhc);this.c=De.get(St.$0hc);const Se=(0,V.$Pm)(process.env)?Je.OpenContext.CLI:Je.OpenContext.DESKTOP,Pe=this.s.args;if(Le){if(Le.openables.length>0)return Te.open({context:Se,cli:Pe,urisToOpen:Le.openables,gotoLineMode:!0,initialStartup:!0});if(Le.urls.length>0)for(const nt of Le.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),Te.open({context:Se,cli:Pe,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,Ve=Pe._.length,Ze=!!Pe["folder-uri"],Ne=!!Pe["file-uri"],He=Pe["skip-add-to-recently-opened"]===!0,Ue=Pe.wait&&Pe.waitMarkerFilePath?E.URI.file(Pe.waitMarkerFilePath):void 0,et=Pe.remote||void 0,it=Pe.profile,ot=Pe["profile-temp"];if(!Ve&&!Ze&&!Ne){if(Pe["new-window"]||it||ot)return Te.open({context:Se,cli:Pe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:Ue,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot});if(ze.length)return Te.open({context:Je.OpenContext.DOCK,cli:Pe,urisToOpen:ze.map(nt=>(nt=(0,kt.$sm)(nt),(0,ge.$dj)(nt)?{workspaceUri:E.URI.file(nt)}:{fileUri:E.URI.file(nt)})),noRecentEntry:He,waitMarkerFileURI:Ue,initialStartup:!0})}return Te.open({context:Se,cli:Pe,forceNewWindow:Pe["new-window"],diffMode:Pe.diff,mergeMode:Pe.merge,noRecentEntry:He,waitMarkerFileURI:Ue,gotoLineMode:Pe.goto,initialStartup:!0,remoteAuthority:et,forceProfile:it,forceTempProfile:ot})}S(){this.U(),i.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(De,Le)=>{Le({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})}),this.W(this.s.args,process.env,!0),this.X(),f.$m&&i.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const De=this.z.win32MutexName;if(f.$l&&De)try{const Le=await new Promise((Se,Pe)=>{G(["@vscode/windows-mutex"],Se,Pe)}).then(Ie),Te=new Le.Mutex(De);l.Event.once(this.t.onWillShutdown)(()=>Te.release())}catch(Le){this.m.error(Le)}}async W(De,Le,Te){try{return await(0,q.$Wm)(this.u,this.m,De,Le)}catch(Se){const Pe=(0,I.$vj)(Se);Te?this.b?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.m.error(Pe)}return{}}async X(){try{const Le=(await this.y.readFile(this.s.argvResource)).value.toString(),Te=(0,m.parse)(Le),Pe=(0,J.$Mp)(this.u)>=xe.TelemetryLevel.CRASH;if(Te["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Pe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.$7g)()}"`,"}"],Ve=Le.substring(0,Le.length-2).concat(`,
`,ze.join(`
`));await this.y.writeFile(this.s.argvResource,O.$Se.fromString(Ve))}else{const ze=Le.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Pe},`);ze!==Le&&await this.y.writeFile(this.s.argvResource,O.$Se.fromString(ze))}}catch(De){this.m.error(De),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$ajc=yt,e.$ajc=yt=bt=ke([se(2,z.$Ji),se(3,U.$fk),se(4,U.$gk),se(5,M.$$gc),se(6,X.$Ehc),se(7,h.$ej),se(8,$e.$5R),se(9,Z.$fl),se(10,K.$yk),se(11,rt.$ohc)],yt)});var Ge=this&&this.__importDefault||function(G){return G&&G.__esModule?G:{default:G}};define(le[288],ue([0,1,13,26,7,21,8,55,15,32,4,49,11,10,71,3,38,25,23,45,107,283,9,16,209,223,20,69,174,14,193,102,84,189,101,19,196,5,73,28,74,250,134,261,50,260,104,222,34,57,77,58,40,205,203,2,41,238,72,198,126,130,242,109,236]),function(G,e,i,r,v,D,O,I,b,l,m,u,$,p,d,f,y,E,g,S,k,s,a,t,o,n,c,h,P,w,R,T,A,L,M,V,q,Y,de,re,ee,W,Z,C,B,F,z,ie,x,ce,oe,te,j,X,U,N,Q,K,H,_,ae,$e,be,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),de=Ge(de);class Fe{main(){try{this.a()}catch(me){console.error(me.message),i.app.exit(1)}}async a(){(0,b.setUnexpectedErrorHandler)(Re=>console.error(Re));const[me,J,he,fe,pe,ve,je,Oe]=this.b();try{try{await this.d(he,Oe,fe,pe,je)}catch(Re){throw this.g(he,je,Re),Re}await me.invokeFunction(async Re=>{const We=Re.get(Y.$fk),Ke=Re.get(V.$Ehc),Qe=Re.get(w.$fl),qe=Re.get(Y.$gk),Xe=await this.f(We,he,Ke,me,je,!0);return g.Promises.writeFile(he.mainLockfile,String(process.pid)).catch(Ye=>{We.warn(`app#startup(): Error writing main lockfile: ${Ye.stack}`)}),ve.logger=qe.createLogger("main",{name:(0,a.localize)(153,null)}),m.Event.once(Ke.onWillShutdown)(Ye=>{Qe.dispose(),fe.dispose(),Ye.join("instanceLockfile",r.promises.unlink(he.mainLockfile).catch(()=>{}))}),me.createInstance(s.$ajc,Xe,J).startup()})}catch(Re){me.invokeFunction(this.j,Re)}}b(){const me=new M.$Ii,J=new N.$Yc;process.once("exit",()=>J.dispose());const he={_serviceBrand:void 0,...de.default};me.set(re.$yk,he);const fe=new c.$_gc(this.k(),he),pe=this.c(fe);me.set(c.$$gc,fe);const ve=new H.$Ahc((0,Y.$tk)(fe),fe.logsHome);me.set(H.$zhc,ve);const je=new q.$Jec(ve.getLogLevel()),Oe=J.add(new _.$aS(je,[new Y.$mk(ve.getLogLevel())]));me.set(Y.$fk,Oe);const Re=new R.$$q(Oe);me.set(w.$fl,Re);const We=new T.$Br(Oe);Re.registerProvider($.Schemas.file,We);const Ke=new K.$3s(Re);me.set(Q.$Pl,Ke);const Qe=new $e.$8R($e.SaveStrategy.DELAYED,fe,Oe,Re);me.set(x.$4R,Qe),me.set(x.$5R,Qe);const qe=new te.$phc(Qe,Ke,fe,Re,Oe);me.set(te.$ohc,qe),Re.registerProvider($.Schemas.vscodeUserData,new be.$ljc($.Schemas.file,We,$.Schemas.vscodeUserData,qe,Ke,Oe));const Xe=f.$l&&he.win32RegValueName?J.add(new X.$jjc(Oe,he.win32RegValueName)):fe.policyFile?J.add(new U.$kjc(fe.policyFile,Re,Oe)):new j.$Bo;me.set(j.$zo,Xe);const Ye=new o.$4o(qe.defaultProfile.settingsResource,Re,Xe,Oe);return me.set(t.$ej,Ye),me.set(V.$Ehc,new A.$Hi(V.$Fhc,void 0,!1)),me.set(B.$bq,new A.$Hi(F.$hjc,void 0,!0)),me.set(oe.$jhc,new A.$Hi(oe.$khc)),me.set(z.$5l,new A.$Hi(ie.$ijc,void 0,!1)),me.set(Z.$Nw,new A.$Hi(C.$fjc)),me.set(ee.$ihc,new W.$cjc(fe,qe,Oe)),[new L.$Er(me,!0),pe,fe,Ye,Qe,je,he,qe]}c(me){const J={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(he=>{const fe=process.env[he];typeof fe=="string"&&(J[he]=fe)}),Object.assign(process.env,J),J}async d(me,J,he,fe,pe){await O.Promises.settled([Promise.all([this.e(me.extensionsPath),me.codeCachePath,me.logsHome.with({scheme:$.Schemas.file}).fsPath,J.defaultProfile.globalStorageHome.with({scheme:$.Schemas.file}).fsPath,me.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,me.localHistoryHome.with({scheme:$.Schemas.file}).fsPath,me.backupHome].map(ve=>ve?r.promises.mkdir(ve,{recursive:!0}):void 0)),fe.init(),he.initialize()]),J.init()}e(me){if(f.$l){const J=(0,ye.getUNCHost)(me);J&&(0,ye.addUNCHostToAllowlist)(J)}return me}async f(me,J,he,fe,pe,ve){let je;try{(0,d.mark)("code/willStartMainServer"),je=await(0,k.$Fi)(J.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),m.Event.once(he.onWillShutdown)(()=>je.dispose())}catch(Oe){if(Oe.code!=="EADDRINUSE")throw this.g(J,pe,Oe),Oe;let Re;try{Re=await(0,k.$Gi)(J.mainIPCHandle,"main")}catch(qe){if(!ve||f.$l||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.h((0,a.localize)(154,null,pe.nameShort),(0,a.localize)(155,null),pe),qe;try{(0,r.unlinkSync)(J.mainIPCHandle)}catch(Xe){throw me.warn("Could not delete obsolete instance handle",Xe),Xe}return this.f(me,J,he,fe,pe,!1)}if(J.extensionTestsLocationURI&&!J.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${pe.nameShort} is running.`;throw me.error(qe),Re.dispose(),new Error(qe)}let We;!J.args.wait&&!J.args.status&&(We=setTimeout(()=>{this.h((0,a.localize)(156,null,pe.nameShort),(0,a.localize)(157,null),pe)},1e4));const Ke=S.ProxyChannel.toService(Re.getChannel("launch"),{disableMarshalling:!0}),Qe=S.ProxyChannel.toService(Re.getChannel("diagnostics"),{disableMarshalling:!0});if(J.args.status)return fe.invokeFunction(async()=>{const qe=new n.$0s(ce.$Fp,pe),Xe=await Qe.getMainDiagnostics(),Ye=await Qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Je=await qe.getDiagnostics(Xe,Ye);throw console.log(Je),new b.$eb});throw f.$l&&await this.i(Ke,me),me.trace("Sending env to running instance..."),await Ke.start(J.args,process.env),Re.dispose(),We&&clearTimeout(We),new b.$eb("Sent env to running instance. Terminating...")}if(J.args.status)throw console.log((0,a.localize)(158,null,pe.nameShort)),new b.$eb("Terminating...");return process.env.VSCODE_PID=String(process.pid),je}g(me,J,he){if(he.code==="EACCES"||he.code==="EPERM"){const fe=(0,D.$Lb)([me.userDataPath,me.extensionsPath,k.$Bi]).map(pe=>(0,u.$9w)(v.URI.file(pe),{os:f.OS,tildify:me}));this.h((0,a.localize)(159,null),(0,a.localize)(160,null,(0,I.$vj)(he),fe.join(`
`)),J)}}h(me,J,he){i.dialog.showMessageBoxSync((0,ae.$kx)({type:"warning",buttons:[(0,a.localize)(161,null)],message:me,detail:J},he).options)}async i(me,J){if(f.$l){const he=await me.getMainProcessId();J.trace("Sending some foreground love to the running instance:",he);try{(await new Promise((fe,pe)=>{G(["windows-foreground-love"],fe,pe)}).then(Ie)).allowSetForegroundWindow(he)}catch(fe){J.error(fe)}}}j(me,J){const he=me.get(Y.$fk),fe=me.get(V.$Ehc);let pe=0;J&&(J.isExpected?J.message&&he.trace(J.message):(pe=1,J.stack?he.error(J.stack):he.error(`Startup error: ${J.toString()}`))),fe.kill(pe)}k(){const me=this.l((0,h.$Mm)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const J=(0,P.$bjc)(me.verbose);J&&((0,h.$Om)(process.argv,"--waitMarkerFilePath",J),me.waitMarkerFilePath=J)}return me}l(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const J=this.m(me._,me.goto);me._=J}return me}m(me,J){const he=(0,y.cwd)(),fe=me.map(je=>{let Oe=String(je),Re;J&&(Re=(0,l.$Rg)(Oe),Oe=Re.path),Oe&&(Oe=this.n(he,Oe));const We=(0,l.$Lg)(Oe,he),Ke=(0,p.$sc)(We);return Ke&&!(0,l.$Hg)(Ke)?null:J&&Re?(Re.path=We,this.o(Re)):We}),pe=f.$l||f.$m,ve=(0,D.$Qb)(fe,je=>je&&pe?je.toLowerCase():je||"");return(0,D.$Lb)(ve)}n(me,J){return f.$l&&(J=(0,E.$sf)(J,'"')),J=(0,E.$qf)((0,E.$qf)(J," "),"	"),f.$l&&(J=(0,p.$pc)(me,J),J=(0,E.$sf)(J,".")),J}o(me){const J=[me.path];return typeof me.line=="number"&&J.push(String(me.line)),typeof me.column=="number"&&J.push(String(me.column)),J.join(":")}}new Fe().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/336db9ece67f682159078ea1b54212de7636d88a/core/vs/code/electron-main/main.js.map
