/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/base/common/charCode","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/marshalling","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/iterator","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/ternarySearchTree","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/lazy","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/services/search/common/searchExtTypes","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/base/common/extpath","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/services/search/common/searchExtConversionTypes","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Oe=function(we){for(var e=[],v=0,D=we.length;v<D;v++)e[v]=Re[we[v]];return e};define(Re[71],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=D,e.$di=P,e.$ei=L;function v(R){return(T,m,s)=>{let I=null,w=null;if(typeof s.value=="function"?(I="value",w=s.value):typeof s.get=="function"&&(I="get",w=s.get),!w)throw new Error("not supported");s[I]=R(w,m)}}function D(R,T,m){let s=null,I=null;if(typeof m.value=="function"?(s="value",I=m.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(s="get",I=m.get),!I)throw new Error("not supported");const w=`$memoize$${T}`;m[s]=function(...u){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[w]}}function P(R,T,m){return v((s,I)=>{const w=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...k){this[u]||(this[u]=m?m():void 0),clearTimeout(this[w]),T&&(this[u]=T(this[u],...k),k=[this[u]]),this[w]=setTimeout(()=>{s.apply(this,k),this[u]=m?m():void 0},R)}})}function L(R,T,m){return v((s,I)=>{const w=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,k=`$throttle$lastRun$${I}`,$=`$throttle$pending$${I}`;return function(...r){if(this[u]||(this[u]=m?m():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),T&&(this[u]=T(this[u],...r)),this[$])return;const a=this[k]+R;a<=Date.now()?(this[k]=Date.now(),s.apply(this,[this[u]]),this[u]=m?m():void 0):(this[$]=!0,this[w]=setTimeout(()=>{this[$]=!1,this[k]=Date.now(),s.apply(this,[this[u]]),this[u]=m?m():void 0},a-Date.now()))}})}});var Hn=this&&this.__createBinding||(Object.create?function(we,e,v,D){D===void 0&&(D=v);var P=Object.getOwnPropertyDescriptor(e,v);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(we,D,P)}:function(we,e,v,D){D===void 0&&(D=v),we[D]=e[v]}),Kn=this&&this.__setModuleDefault||(Object.create?function(we,e){Object.defineProperty(we,"default",{enumerable:!0,value:e})}:function(we,e){we.default=e}),Ve=this&&this.__importStar||function(we){if(we&&we.__esModule)return we;var e={};if(we!=null)for(var v in we)v!=="default"&&Object.prototype.hasOwnProperty.call(we,v)&&Hn(e,we,v);return Kn(e,we),e};define(Re[137],Oe([1,0,17]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$c=void 0,e.$_c=P,e.$ad=L,e.$bd=R,e.$cd=T,e.$dd=m,e.$ed=s,v=Ve(v);const D=(k,$)=>k===$;e.$$c=D;function P(k=e.$$c){return($,r)=>v.$yb($,r,k)}function L(){return(k,$)=>JSON.stringify(k)===JSON.stringify($)}function R(){return(k,$)=>k.equals($)}function T(k,$,r){if(r!==void 0){const a=k;return a==null||$===void 0||$===null?$===a:r(a,$)}else{const a=k;return(h,c)=>h==null||c===void 0||c===null?c===h:a(h,c)}}function m(k,$){if(k===$)return!0;if(Array.isArray(k)&&Array.isArray($)){if(k.length!==$.length)return!1;for(let r=0;r<k.length;r++)if(!m(k[r],$[r]))return!1;return!0}if(k&&typeof k=="object"&&$&&typeof $=="object"&&Object.getPrototypeOf(k)===Object.prototype&&Object.getPrototypeOf($)===Object.prototype){const r=k,a=$,h=Object.keys(r),c=Object.keys(a),i=new Set(c);if(h.length!==c.length)return!1;for(const n of h)if(!i.has(n)||!m(r[n],a[n]))return!1;return!0}return!1}function s(k){return JSON.stringify(u(k))}let I=0;const w=new WeakMap;function u(k){if(Array.isArray(k))return k.map(u);if(k&&typeof k=="object")if(Object.getPrototypeOf(k)===Object.prototype){const $=k,r=Object.create(null);for(const a of Object.keys($).sort())r[a]=u($[a]);return r}else{let $=w.get(k);return $===void 0&&($=I++,w.set(k,$)),$+"----2b76a038c20c4bcc"}return k}}),define(Re[97],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=e.$RQ=void 0;class v{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$RQ=v,e.$SQ=new v("id#")}),define(Re[138],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$3n=R,e.$4n=w,e.$5n=u,e.$6n=k,e.$7n=$,e.$8n=r,e.$9n=a,e.$0n=h,e.$$n=c,e.$_n=i,e.$ao=n;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,o=!1){let l=0;const g=t.length;let f="",d=0,S=D.Unknown,E=v.None;function y(F){let G=0,x=0;for(;G<F;){const j=t.charCodeAt(l);if(j>=I._0&&j<=I._9)x=x*16+j-I._0;else if(j>=I.A&&j<=I.F)x=x*16+j-I.A+10;else if(j>=I.a&&j<=I.f)x=x*16+j-I.a+10;else break;l++,G++}return G<F&&(x=-1),x}function C(F){l=F,f="",d=0,S=D.Unknown,E=v.None}function O(){const F=l;if(t.charCodeAt(l)===I._0)l++;else for(l++;l<t.length&&s(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===I.dot)if(l++,l<t.length&&s(t.charCodeAt(l)))for(l++;l<t.length&&s(t.charCodeAt(l));)l++;else return E=v.UnexpectedEndOfNumber,t.substring(F,l);let G=l;if(l<t.length&&(t.charCodeAt(l)===I.E||t.charCodeAt(l)===I.e))if(l++,(l<t.length&&t.charCodeAt(l)===I.plus||t.charCodeAt(l)===I.minus)&&l++,l<t.length&&s(t.charCodeAt(l))){for(l++;l<t.length&&s(t.charCodeAt(l));)l++;G=l}else E=v.UnexpectedEndOfNumber;return t.substring(F,G)}function p(){let F="",G=l;for(;;){if(l>=g){F+=t.substring(G,l),E=v.UnexpectedEndOfString;break}const x=t.charCodeAt(l);if(x===I.doubleQuote){F+=t.substring(G,l),l++;break}if(x===I.backslash){if(F+=t.substring(G,l),l++,l>=g){E=v.UnexpectedEndOfString;break}switch(t.charCodeAt(l++)){case I.doubleQuote:F+='"';break;case I.backslash:F+="\\";break;case I.slash:F+="/";break;case I.b:F+="\b";break;case I.f:F+="\f";break;case I.n:F+=`
`;break;case I.r:F+="\r";break;case I.t:F+="	";break;case I.u:{const U=y(4);U>=0?F+=String.fromCharCode(U):E=v.InvalidUnicode;break}default:E=v.InvalidEscapeCharacter}G=l;continue}if(x>=0&&x<=31)if(m(x)){F+=t.substring(G,l),E=v.UnexpectedEndOfString;break}else E=v.InvalidCharacter;l++}return F}function b(){if(f="",E=v.None,d=l,l>=g)return d=g,S=D.EOF;let F=t.charCodeAt(l);if(T(F)){do l++,f+=String.fromCharCode(F),F=t.charCodeAt(l);while(T(F));return S=D.Trivia}if(m(F))return l++,f+=String.fromCharCode(F),F===I.carriageReturn&&t.charCodeAt(l)===I.lineFeed&&(l++,f+=`
`),S=D.LineBreakTrivia;switch(F){case I.openBrace:return l++,S=D.OpenBraceToken;case I.closeBrace:return l++,S=D.CloseBraceToken;case I.openBracket:return l++,S=D.OpenBracketToken;case I.closeBracket:return l++,S=D.CloseBracketToken;case I.colon:return l++,S=D.ColonToken;case I.comma:return l++,S=D.CommaToken;case I.doubleQuote:return l++,f=p(),S=D.StringLiteral;case I.slash:{const G=l-1;if(t.charCodeAt(l+1)===I.slash){for(l+=2;l<g&&!m(t.charCodeAt(l));)l++;return f=t.substring(G,l),S=D.LineCommentTrivia}if(t.charCodeAt(l+1)===I.asterisk){l+=2;const x=g-1;let j=!1;for(;l<x;){if(t.charCodeAt(l)===I.asterisk&&t.charCodeAt(l+1)===I.slash){l+=2,j=!0;break}l++}return j||(l++,E=v.UnexpectedEndOfComment),f=t.substring(G,l),S=D.BlockCommentTrivia}return f+=String.fromCharCode(F),l++,S=D.Unknown}case I.minus:if(f+=String.fromCharCode(F),l++,l===g||!s(t.charCodeAt(l)))return S=D.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return f+=O(),S=D.NumericLiteral;default:for(;l<g&&M(F);)l++,F=t.charCodeAt(l);if(d!==l){switch(f=t.substring(d,l),f){case"true":return S=D.TrueKeyword;case"false":return S=D.FalseKeyword;case"null":return S=D.NullKeyword}return S=D.Unknown}return f+=String.fromCharCode(F),l++,S=D.Unknown}}function M(F){if(T(F)||m(F))return!1;switch(F){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function A(){let F;do F=b();while(F>=D.LineCommentTrivia&&F<=D.Trivia);return F}return{setPosition:C,getPosition:()=>l,scan:o?A:b,getToken:()=>S,getTokenValue:()=>f,getTokenOffset:()=>d,getTokenLength:()=>l-d,getTokenError:()=>E}}function T(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function m(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function s(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function w(t,o){const l=[],g=new Object;let f;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function E(y,C,O,p){d.value=y,d.offset=C,d.length=O,d.type=p,d.colonOffset=void 0,f=d}try{i(t,{onObjectBegin:(y,C)=>{if(o<=y)throw g;f=void 0,S=o>y,l.push("")},onObjectProperty:(y,C,O)=>{if(o<C||(E(y,C,O,"property"),l[l.length-1]=y,o<=C+O))throw g},onObjectEnd:(y,C)=>{if(o<=y)throw g;f=void 0,l.pop()},onArrayBegin:(y,C)=>{if(o<=y)throw g;f=void 0,l.push(0)},onArrayEnd:(y,C)=>{if(o<=y)throw g;f=void 0,l.pop()},onLiteralValue:(y,C,O)=>{if(o<C||(E(y,C,O,n(y)),o<=C+O))throw g},onSeparator:(y,C,O)=>{if(o<=C)throw g;if(y===":"&&f&&f.type==="property")f.colonOffset=C,S=!1,f=void 0;else if(y===","){const p=l[l.length-1];typeof p=="number"?l[l.length-1]=p+1:(S=!0,l[l.length-1]=""),f=void 0}}})}catch(y){if(y!==g)throw y}return{path:l,previousNode:f,isAtPropertyKey:S,matches:y=>{let C=0;for(let O=0;C<y.length&&O<l.length;O++)if(y[C]===l[O]||y[C]==="*")C++;else if(y[C]!=="**")return!1;return C===y.length}}}function u(t,o=[],l=L.DEFAULT){let g=null,f=[];const d=[];function S(y){Array.isArray(f)?f.push(y):g!==null&&(f[g]=y)}return i(t,{onObjectBegin:()=>{const y={};S(y),d.push(f),f=y,g=null},onObjectProperty:y=>{g=y},onObjectEnd:()=>{f=d.pop()},onArrayBegin:()=>{const y=[];S(y),d.push(f),f=y,g=null},onArrayEnd:()=>{f=d.pop()},onLiteralValue:S,onError:(y,C,O)=>{o.push({error:y,offset:C,length:O})}},l),f[0]}function k(t,o=[],l=L.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(y){g.type==="property"&&(g.length=y-g.offset,g=g.parent)}function d(y){return g.children.push(y),y}i(t,{onObjectBegin:y=>{g=d({type:"object",offset:y,length:-1,parent:g,children:[]})},onObjectProperty:(y,C,O)=>{g=d({type:"property",offset:C,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:y,offset:C,length:O,parent:g})},onObjectEnd:(y,C)=>{g.length=y+C-g.offset,g=g.parent,f(y+C)},onArrayBegin:(y,C)=>{g=d({type:"array",offset:y,length:-1,parent:g,children:[]})},onArrayEnd:(y,C)=>{g.length=y+C-g.offset,g=g.parent,f(y+C)},onLiteralValue:(y,C,O)=>{d({type:n(y),offset:C,length:O,parent:g,value:y}),f(C+O)},onSeparator:(y,C,O)=>{g.type==="property"&&(y===":"?g.colonOffset=C:y===","&&f(C))},onError:(y,C,O)=>{o.push({error:y,offset:C,length:O})}},l);const E=g.children[0];return E&&delete E.parent,E}function $(t,o){if(!t)return;let l=t;for(const g of o)if(typeof g=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let f=!1;for(const d of l.children)if(Array.isArray(d.children)&&d.children[0].value===g){l=d.children[1],f=!0;break}if(!f)return}else{const f=g;if(l.type!=="array"||f<0||!Array.isArray(l.children)||f>=l.children.length)return;l=l.children[f]}return l}function r(t){if(!t.parent||!t.parent.children)return[];const o=r(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;o.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&o.push(l)}return o}function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const o=Object.create(null);for(const l of t.children){const g=l.children[1];g&&(o[l.children[0].value]=a(g))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function h(t,o,l=!1){return o>=t.offset&&o<t.offset+t.length||l&&o===t.offset+t.length}function c(t,o,l=!1){if(h(t,o,l)){const g=t.children;if(Array.isArray(g))for(let f=0;f<g.length&&g[f].offset<=o;f++){const d=c(g[f],o,l);if(d)return d}return t}}function i(t,o,l=L.DEFAULT){const g=R(t,!1);function f(ie){return ie?()=>ie(g.getTokenOffset(),g.getTokenLength()):()=>!0}function d(ie){return ie?ue=>ie(ue,g.getTokenOffset(),g.getTokenLength()):()=>!0}const S=f(o.onObjectBegin),E=d(o.onObjectProperty),y=f(o.onObjectEnd),C=f(o.onArrayBegin),O=f(o.onArrayEnd),p=d(o.onLiteralValue),b=d(o.onSeparator),M=f(o.onComment),A=d(o.onError),F=l&&l.disallowComments,G=l&&l.allowTrailingComma;function x(){for(;;){const ie=g.scan();switch(g.getTokenError()){case v.InvalidUnicode:j(P.InvalidUnicode);break;case v.InvalidEscapeCharacter:j(P.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:j(P.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:F||j(P.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:j(P.UnexpectedEndOfString);break;case v.InvalidCharacter:j(P.InvalidCharacter);break}switch(ie){case D.LineCommentTrivia:case D.BlockCommentTrivia:F?j(P.InvalidCommentToken):M();break;case D.Unknown:j(P.InvalidSymbol);break;case D.Trivia:case D.LineBreakTrivia:break;default:return ie}}}function j(ie,ue=[],_=[]){if(A(ie),ue.length+_.length>0){let $e=g.getToken();for(;$e!==D.EOF;){if(ue.indexOf($e)!==-1){x();break}else if(_.indexOf($e)!==-1)break;$e=x()}}}function U(ie){const ue=g.getTokenValue();return ie?p(ue):E(ue),x(),!0}function J(){switch(g.getToken()){case D.NumericLiteral:{let ie=0;try{ie=JSON.parse(g.getTokenValue()),typeof ie!="number"&&(j(P.InvalidNumberFormat),ie=0)}catch{j(P.InvalidNumberFormat)}p(ie);break}case D.NullKeyword:p(null);break;case D.TrueKeyword:p(!0);break;case D.FalseKeyword:p(!1);break;default:return!1}return x(),!0}function Y(){return g.getToken()!==D.StringLiteral?(j(P.PropertyNameExpected,[],[D.CloseBraceToken,D.CommaToken]),!1):(U(!1),g.getToken()===D.ColonToken?(b(":"),x(),oe()||j(P.ValueExpected,[],[D.CloseBraceToken,D.CommaToken])):j(P.ColonExpected,[],[D.CloseBraceToken,D.CommaToken]),!0)}function ae(){S(),x();let ie=!1;for(;g.getToken()!==D.CloseBraceToken&&g.getToken()!==D.EOF;){if(g.getToken()===D.CommaToken){if(ie||j(P.ValueExpected,[],[]),b(","),x(),g.getToken()===D.CloseBraceToken&&G)break}else ie&&j(P.CommaExpected,[],[]);Y()||j(P.ValueExpected,[],[D.CloseBraceToken,D.CommaToken]),ie=!0}return y(),g.getToken()!==D.CloseBraceToken?j(P.CloseBraceExpected,[D.CloseBraceToken],[]):x(),!0}function ee(){C(),x();let ie=!1;for(;g.getToken()!==D.CloseBracketToken&&g.getToken()!==D.EOF;){if(g.getToken()===D.CommaToken){if(ie||j(P.ValueExpected,[],[]),b(","),x(),g.getToken()===D.CloseBracketToken&&G)break}else ie&&j(P.CommaExpected,[],[]);oe()||j(P.ValueExpected,[],[D.CloseBracketToken,D.CommaToken]),ie=!0}return O(),g.getToken()!==D.CloseBracketToken?j(P.CloseBracketExpected,[D.CloseBracketToken],[]):x(),!0}function oe(){switch(g.getToken()){case D.OpenBracketToken:return ee();case D.OpenBraceToken:return ae();case D.StringLiteral:return U(!0);default:return J()}}return x(),g.getToken()===D.EOF?l.allowEmptyContent?!0:(j(P.ValueExpected,[],[]),!1):oe()?(g.getToken()!==D.EOF&&j(P.EndOfFileExpected,[],[]),!0):(j(P.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Re[139],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ak=v;function v(L){let R=!1;const T=new Map,m=new Map;if(P(L,r=>{if(L===r)return!0;const a=JSON.stringify(r);if(a.length<30)return!0;const h=T.get(a);if(!h){const c={schemas:[r]};return T.set(a,c),m.set(r,c),!0}return h.schemas.push(r),m.set(r,h),R=!0,!1}),T.clear(),!R)return JSON.stringify(L);let I="$defs";for(;L.hasOwnProperty(I);)I+="_";const w=[];function u(r){return JSON.stringify(r,(a,h)=>{if(h!==r){const c=m.get(h);if(c&&c.schemas.length>1)return c.id||(c.id=`_${w.length}`,w.push(c.schemas[0])),{$ref:`#/${I}/${c.id}`}}return h})}const k=u(L),$=[];for(let r=0;r<w.length;r++)$.push(`"_${r}":${u(w[r])}`);return $.length?`${k.substring(0,k.length-1)},"${I}":{${$.join(",")}}}`:k}function D(L){return typeof L=="object"&&L!==null}function P(L,R){if(!L||typeof L!="object")return;const T=(...k)=>{for(const $ of k)D($)&&w.push($)},m=(...k)=>{for(const $ of k)if(D($))for(const r in $){const a=$[r];D(a)&&w.push(a)}},s=(...k)=>{for(const $ of k)if(Array.isArray($))for(const r of $)D(r)&&w.push(r)},I=k=>{if(Array.isArray(k))for(const $ of k)D($)&&w.push($);else D(k)&&w.push(k)},w=[L];let u=w.pop();for(;u;)R(u)&&(T(u.additionalItems,u.additionalProperties,u.not,u.contains,u.propertyNames,u.if,u.then,u.else,u.unevaluatedItems,u.unevaluatedProperties),m(u.definitions,u.$defs,u.properties,u.patternProperties,u.dependencies,u.dependentSchemas),s(u.anyOf,u.allOf,u.oneOf,u.prefixItems),I(u.items)),u=w.pop()}}),function(we,e){typeof define=="function"&&define.amd?define(Re[140],Oe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(we=typeof globalThis<"u"?globalThis:we||self,e(we.marked={}))}(this,function(we){"use strict";function e(){return{async:!1,breaks:!1,extensions:null,gfm:!0,hooks:null,pedantic:!1,renderer:null,silent:!1,tokenizer:null,walkTokens:null}}we.defaults=e();function v(Ze){we.defaults=Ze}const D=/[&<>"']/,P=new RegExp(D.source,"g"),L=/[<>"']|&(?!(#\d{1,7}|#[Xx][a-fA-F0-9]{1,6}|\w+);)/,R=new RegExp(L.source,"g"),T={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=Ze=>T[Ze];function s(Ze,he){if(he){if(D.test(Ze))return Ze.replace(P,m)}else if(L.test(Ze))return Ze.replace(R,m);return Ze}const I=/(^|[^\[])\^/g;function w(Ze,he){let pe=typeof Ze=="string"?Ze:Ze.source;he=he||"";const ye={replace:(Ce,fe)=>{let ve=typeof fe=="string"?fe:fe.source;return ve=ve.replace(I,"$1"),pe=pe.replace(Ce,ve),ye},getRegex:()=>new RegExp(pe,he)};return ye}function u(Ze){try{Ze=encodeURI(Ze).replace(/%25/g,"%")}catch{return null}return Ze}const k={exec:()=>null};function $(Ze,he){const pe=Ze.replace(/\|/g,(fe,ve,Z)=>{let q=!1,de=ve;for(;--de>=0&&Z[de]==="\\";)q=!q;return q?"|":" |"}),ye=pe.split(/ \|/);let Ce=0;if(ye[0].trim()||ye.shift(),ye.length>0&&!ye[ye.length-1].trim()&&ye.pop(),he)if(ye.length>he)ye.splice(he);else for(;ye.length<he;)ye.push("");for(;Ce<ye.length;Ce++)ye[Ce]=ye[Ce].trim().replace(/\\\|/g,"|");return ye}function r(Ze,he,pe){const ye=Ze.length;if(ye===0)return"";let Ce=0;for(;Ce<ye;){const fe=Ze.charAt(ye-Ce-1);if(fe===he&&!pe)Ce++;else if(fe!==he&&pe)Ce++;else break}return Ze.slice(0,ye-Ce)}function a(Ze,he){if(Ze.indexOf(he[1])===-1)return-1;let pe=0;for(let ye=0;ye<Ze.length;ye++)if(Ze[ye]==="\\")ye++;else if(Ze[ye]===he[0])pe++;else if(Ze[ye]===he[1]&&(pe--,pe<0))return ye;return-1}function h(Ze,he,pe,ye){const Ce=he.href,fe=he.title?s(he.title):null,ve=Ze[1].replace(/\\([\[\]])/g,"$1");if(Ze[0].charAt(0)!=="!"){ye.state.inLink=!0;const Z={type:"link",raw:pe,href:Ce,title:fe,text:ve,tokens:ye.inlineTokens(ve)};return ye.state.inLink=!1,Z}return{type:"image",raw:pe,href:Ce,title:fe,text:s(ve)}}function c(Ze,he){const pe=Ze.match(/^(\s+)(?:```)/);if(pe===null)return he;const ye=pe[1];return he.split(`
`).map(Ce=>{const fe=Ce.match(/^\s+/);if(fe===null)return Ce;const[ve]=fe;return ve.length>=ye.length?Ce.slice(ye.length):Ce}).join(`
`)}class i{options;rules;lexer;constructor(he){this.options=he||we.defaults}space(he){const pe=this.rules.block.newline.exec(he);if(pe&&pe[0].length>0)return{type:"space",raw:pe[0]}}code(he){const pe=this.rules.block.code.exec(he);if(pe){const ye=pe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:pe[0],codeBlockStyle:"indented",text:this.options.pedantic?ye:r(ye,`
`)}}}fences(he){const pe=this.rules.block.fences.exec(he);if(pe){const ye=pe[0],Ce=c(ye,pe[3]||"");return{type:"code",raw:ye,lang:pe[2]?pe[2].trim().replace(this.rules.inline.anyPunctuation,"$1"):pe[2],text:Ce}}}heading(he){const pe=this.rules.block.heading.exec(he);if(pe){let ye=pe[2].trim();if(/#$/.test(ye)){const Ce=r(ye,"#");(this.options.pedantic||!Ce||/ $/.test(Ce))&&(ye=Ce.trim())}return{type:"heading",raw:pe[0],depth:pe[1].length,text:ye,tokens:this.lexer.inline(ye)}}}hr(he){const pe=this.rules.block.hr.exec(he);if(pe)return{type:"hr",raw:r(pe[0],`
`)}}blockquote(he){const pe=this.rules.block.blockquote.exec(he);if(pe){let ye=r(pe[0],`
`).split(`
`),Ce="",fe="";const ve=[];for(;ye.length>0;){let Z=!1;const q=[];let de;for(de=0;de<ye.length;de++)if(/^ {0,3}>/.test(ye[de]))q.push(ye[de]),Z=!0;else if(!Z)q.push(ye[de]);else break;ye=ye.slice(de);const je=q.join(`
`),Qe=je.replace(/\n {0,3}((?:=+|-+) *)(?=\n|$)/g,`
    $1`).replace(/^ {0,3}>[ \t]?/gm,"");Ce=Ce?`${Ce}
${je}`:je,fe=fe?`${fe}
${Qe}`:Qe;const st=this.lexer.state.top;if(this.lexer.state.top=!0,this.lexer.blockTokens(Qe,ve,!0),this.lexer.state.top=st,ye.length===0)break;const dt=ve[ve.length-1];if(dt?.type==="code")break;if(dt?.type==="blockquote"){const mt=dt,Ot=mt.raw+`
`+ye.join(`
`),Tt=this.blockquote(Ot);ve[ve.length-1]=Tt,Ce=Ce.substring(0,Ce.length-mt.raw.length)+Tt.raw,fe=fe.substring(0,fe.length-mt.text.length)+Tt.text;break}else if(dt?.type==="list"){const mt=dt,Ot=mt.raw+`
`+ye.join(`
`),Tt=this.list(Ot);ve[ve.length-1]=Tt,Ce=Ce.substring(0,Ce.length-dt.raw.length)+Tt.raw,fe=fe.substring(0,fe.length-mt.raw.length)+Tt.raw,ye=Ot.substring(ve[ve.length-1].raw.length).split(`
`);continue}}return{type:"blockquote",raw:Ce,tokens:ve,text:fe}}}list(he){let pe=this.rules.block.list.exec(he);if(pe){let ye=pe[1].trim();const Ce=ye.length>1,fe={type:"list",raw:"",ordered:Ce,start:Ce?+ye.slice(0,-1):"",loose:!1,items:[]};ye=Ce?`\\d{1,9}\\${ye.slice(-1)}`:`\\${ye}`,this.options.pedantic&&(ye=Ce?ye:"[*+-]");const ve=new RegExp(`^( {0,3}${ye})((?:[	 ][^\\n]*)?(?:\\n|$))`);let Z=!1;for(;he;){let q=!1,de="",je="";if(!(pe=ve.exec(he))||this.rules.block.hr.test(he))break;de=pe[0],he=he.substring(de.length);let Qe=pe[2].split(`
`,1)[0].replace(/^\t+/,Qt=>" ".repeat(3*Qt.length)),st=he.split(`
`,1)[0],dt=!Qe.trim(),mt=0;if(this.options.pedantic?(mt=2,je=Qe.trimStart()):dt?mt=pe[1].length+1:(mt=pe[2].search(/[^ ]/),mt=mt>4?1:mt,je=Qe.slice(mt),mt+=pe[1].length),dt&&/^ *$/.test(st)&&(de+=st+`
`,he=he.substring(st.length+1),q=!0),!q){const Qt=new RegExp(`^ {0,${Math.min(3,mt-1)}}(?:[*+-]|\\d{1,9}[.)])((?:[ 	][^\\n]*)?(?:\\n|$))`),_t=new RegExp(`^ {0,${Math.min(3,mt-1)}}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)`),Xe=new RegExp(`^ {0,${Math.min(3,mt-1)}}(?:\`\`\`|~~~)`),At=new RegExp(`^ {0,${Math.min(3,mt-1)}}#`);for(;he;){const Ut=he.split(`
`,1)[0];if(st=Ut,this.options.pedantic&&(st=st.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(st)||At.test(st)||Qt.test(st)||_t.test(he))break;if(st.search(/[^ ]/)>=mt||!st.trim())je+=`
`+st.slice(mt);else{if(dt||Qe.search(/[^ ]/)>=4||Xe.test(Qe)||At.test(Qe)||_t.test(Qe))break;je+=`
`+st}!dt&&!st.trim()&&(dt=!0),de+=Ut+`
`,he=he.substring(Ut.length+1),Qe=st.slice(mt)}}fe.loose||(Z?fe.loose=!0:/\n *\n *$/.test(de)&&(Z=!0));let Ot=null,Tt;this.options.gfm&&(Ot=/^\[[ xX]\] /.exec(je),Ot&&(Tt=Ot[0]!=="[ ] ",je=je.replace(/^\[[ xX]\] +/,""))),fe.items.push({type:"list_item",raw:de,task:!!Ot,checked:Tt,loose:!1,text:je,tokens:[]}),fe.raw+=de}fe.items[fe.items.length-1].raw=fe.items[fe.items.length-1].raw.trimEnd(),fe.items[fe.items.length-1].text=fe.items[fe.items.length-1].text.trimEnd(),fe.raw=fe.raw.trimEnd();for(let q=0;q<fe.items.length;q++)if(this.lexer.state.top=!1,fe.items[q].tokens=this.lexer.blockTokens(fe.items[q].text,[]),!fe.loose){const de=fe.items[q].tokens.filter(Qe=>Qe.type==="space"),je=de.length>0&&de.some(Qe=>/\n.*\n/.test(Qe.raw));fe.loose=je}if(fe.loose)for(let q=0;q<fe.items.length;q++)fe.items[q].loose=!0;return fe}}html(he){const pe=this.rules.block.html.exec(he);if(pe)return{type:"html",block:!0,raw:pe[0],pre:pe[1]==="pre"||pe[1]==="script"||pe[1]==="style",text:pe[0]}}def(he){const pe=this.rules.block.def.exec(he);if(pe){const ye=pe[1].toLowerCase().replace(/\s+/g," "),Ce=pe[2]?pe[2].replace(/^<(.*)>$/,"$1").replace(this.rules.inline.anyPunctuation,"$1"):"",fe=pe[3]?pe[3].substring(1,pe[3].length-1).replace(this.rules.inline.anyPunctuation,"$1"):pe[3];return{type:"def",tag:ye,raw:pe[0],href:Ce,title:fe}}}table(he){const pe=this.rules.block.table.exec(he);if(!pe||!/[:|]/.test(pe[2]))return;const ye=$(pe[1]),Ce=pe[2].replace(/^\||\| *$/g,"").split("|"),fe=pe[3]&&pe[3].trim()?pe[3].replace(/\n[ \t]*$/,"").split(`
`):[],ve={type:"table",raw:pe[0],header:[],align:[],rows:[]};if(ye.length===Ce.length){for(const Z of Ce)/^ *-+: *$/.test(Z)?ve.align.push("right"):/^ *:-+: *$/.test(Z)?ve.align.push("center"):/^ *:-+ *$/.test(Z)?ve.align.push("left"):ve.align.push(null);for(let Z=0;Z<ye.length;Z++)ve.header.push({text:ye[Z],tokens:this.lexer.inline(ye[Z]),header:!0,align:ve.align[Z]});for(const Z of fe)ve.rows.push($(Z,ve.header.length).map((q,de)=>({text:q,tokens:this.lexer.inline(q),header:!1,align:ve.align[de]})));return ve}}lheading(he){const pe=this.rules.block.lheading.exec(he);if(pe)return{type:"heading",raw:pe[0],depth:pe[2].charAt(0)==="="?1:2,text:pe[1],tokens:this.lexer.inline(pe[1])}}paragraph(he){const pe=this.rules.block.paragraph.exec(he);if(pe){const ye=pe[1].charAt(pe[1].length-1)===`
`?pe[1].slice(0,-1):pe[1];return{type:"paragraph",raw:pe[0],text:ye,tokens:this.lexer.inline(ye)}}}text(he){const pe=this.rules.block.text.exec(he);if(pe)return{type:"text",raw:pe[0],text:pe[0],tokens:this.lexer.inline(pe[0])}}escape(he){const pe=this.rules.inline.escape.exec(he);if(pe)return{type:"escape",raw:pe[0],text:s(pe[1])}}tag(he){const pe=this.rules.inline.tag.exec(he);if(pe)return!this.lexer.state.inLink&&/^<a /i.test(pe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(pe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(this.lexer.state.inRawBlock=!1),{type:"html",raw:pe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,block:!1,text:pe[0]}}link(he){const pe=this.rules.inline.link.exec(he);if(pe){const ye=pe[2].trim();if(!this.options.pedantic&&/^</.test(ye)){if(!/>$/.test(ye))return;const ve=r(ye.slice(0,-1),"\\");if((ye.length-ve.length)%2===0)return}else{const ve=a(pe[2],"()");if(ve>-1){const q=(pe[0].indexOf("!")===0?5:4)+pe[1].length+ve;pe[2]=pe[2].substring(0,ve),pe[0]=pe[0].substring(0,q).trim(),pe[3]=""}}let Ce=pe[2],fe="";if(this.options.pedantic){const ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);ve&&(Ce=ve[1],fe=ve[3])}else fe=pe[3]?pe[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(ye)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),h(pe,{href:Ce&&Ce.replace(this.rules.inline.anyPunctuation,"$1"),title:fe&&fe.replace(this.rules.inline.anyPunctuation,"$1")},pe[0],this.lexer)}}reflink(he,pe){let ye;if((ye=this.rules.inline.reflink.exec(he))||(ye=this.rules.inline.nolink.exec(he))){const Ce=(ye[2]||ye[1]).replace(/\s+/g," "),fe=pe[Ce.toLowerCase()];if(!fe){const ve=ye[0].charAt(0);return{type:"text",raw:ve,text:ve}}return h(ye,fe,ye[0],this.lexer)}}emStrong(he,pe,ye=""){let Ce=this.rules.inline.emStrongLDelim.exec(he);if(!Ce||Ce[3]&&ye.match(/[\p{L}\p{N}]/u))return;if(!(Ce[1]||Ce[2]||"")||!ye||this.rules.inline.punctuation.exec(ye)){const ve=[...Ce[0]].length-1;let Z,q,de=ve,je=0;const Qe=Ce[0][0]==="*"?this.rules.inline.emStrongRDelimAst:this.rules.inline.emStrongRDelimUnd;for(Qe.lastIndex=0,pe=pe.slice(-1*he.length+ve);(Ce=Qe.exec(pe))!=null;){if(Z=Ce[1]||Ce[2]||Ce[3]||Ce[4]||Ce[5]||Ce[6],!Z)continue;if(q=[...Z].length,Ce[3]||Ce[4]){de+=q;continue}else if((Ce[5]||Ce[6])&&ve%3&&!((ve+q)%3)){je+=q;continue}if(de-=q,de>0)continue;q=Math.min(q,q+de+je);const st=[...Ce[0]][0].length,dt=he.slice(0,ve+Ce.index+st+q);if(Math.min(ve,q)%2){const Ot=dt.slice(1,-1);return{type:"em",raw:dt,text:Ot,tokens:this.lexer.inlineTokens(Ot)}}const mt=dt.slice(2,-2);return{type:"strong",raw:dt,text:mt,tokens:this.lexer.inlineTokens(mt)}}}}codespan(he){const pe=this.rules.inline.code.exec(he);if(pe){let ye=pe[2].replace(/\n/g," ");const Ce=/[^ ]/.test(ye),fe=/^ /.test(ye)&&/ $/.test(ye);return Ce&&fe&&(ye=ye.substring(1,ye.length-1)),ye=s(ye,!0),{type:"codespan",raw:pe[0],text:ye}}}br(he){const pe=this.rules.inline.br.exec(he);if(pe)return{type:"br",raw:pe[0]}}del(he){const pe=this.rules.inline.del.exec(he);if(pe)return{type:"del",raw:pe[0],text:pe[2],tokens:this.lexer.inlineTokens(pe[2])}}autolink(he){const pe=this.rules.inline.autolink.exec(he);if(pe){let ye,Ce;return pe[2]==="@"?(ye=s(pe[1]),Ce="mailto:"+ye):(ye=s(pe[1]),Ce=ye),{type:"link",raw:pe[0],text:ye,href:Ce,tokens:[{type:"text",raw:ye,text:ye}]}}}url(he){let pe;if(pe=this.rules.inline.url.exec(he)){let ye,Ce;if(pe[2]==="@")ye=s(pe[0]),Ce="mailto:"+ye;else{let fe;do fe=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])?.[0]??"";while(fe!==pe[0]);ye=s(pe[0]),pe[1]==="www."?Ce="http://"+pe[0]:Ce=pe[0]}return{type:"link",raw:pe[0],text:ye,href:Ce,tokens:[{type:"text",raw:ye,text:ye}]}}}inlineText(he){const pe=this.rules.inline.text.exec(he);if(pe){let ye;return this.lexer.state.inRawBlock?ye=pe[0]:ye=s(pe[0]),{type:"text",raw:pe[0],text:ye}}}}const n=/^(?: *(?:\n|$))+/,t=/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,o=/^ {0,3}(`{3,}(?=[^`\n]*(?:\n|$))|~{3,})([^\n]*)(?:\n|$)(?:|([\s\S]*?)(?:\n|$))(?: {0,3}\1[~`]* *(?=\n|$)|$)/,l=/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,g=/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,f=/(?:[*+-]|\d{1,9}[.)])/,d=w(/^(?!bull |blockCode|fences|blockquote|heading|html)((?:.|\n(?!\s*?\n|bull |blockCode|fences|blockquote|heading|html))+?)\n {0,3}(=+|-+) *(?:\n+|$)/).replace(/bull/g,f).replace(/blockCode/g,/ {4}/).replace(/fences/g,/ {0,3}(?:`{3,}|~{3,})/).replace(/blockquote/g,/ {0,3}>/).replace(/heading/g,/ {0,3}#{1,6}/).replace(/html/g,/ {0,3}<[^\n>]+>\n/).getRegex(),S=/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,E=/^[^\n]+/,y=/(?!\s*\])(?:\\.|[^\[\]\\])+/,C=w(/^ {0,3}\[(label)\]: *(?:\n *)?([^<\s][^\s]*|<.*?>)(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/).replace("label",y).replace("title",/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/).getRegex(),O=w(/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/).replace(/bull/g,f).getRegex(),p="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|search|section|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",b=/<!--(?:-?>|[\s\S]*?(?:-->|$))/,M=w("^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))","i").replace("comment",b).replace("tag",p).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),A=w(S).replace("hr",l).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",p).getRegex(),G={blockquote:w(/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/).replace("paragraph",A).getRegex(),code:t,def:C,fences:o,heading:g,hr:l,html:M,lheading:d,list:O,newline:n,paragraph:A,table:k,text:E},x=w("^ *([^\\n ].*)\\n {0,3}((?:\\| *)?:?-+:? *(?:\\| *:?-+:? *)*(?:\\| *)?)(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)").replace("hr",l).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",p).getRegex(),j={...G,table:x,paragraph:w(S).replace("hr",l).replace("heading"," {0,3}#{1,6}(?:\\s|$)").replace("|lheading","").replace("table",x).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",p).getRegex()},U={...G,html:w(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",b).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:k,lheading:/^(.+?)\n {0,3}(=+|-+) *(?:\n+|$)/,paragraph:w(S).replace("hr",l).replace("heading",` *#{1,6} *[^
]`).replace("lheading",d).replace("|table","").replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").replace("|tag","").getRegex()},J=/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,Y=/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,ae=/^( {2,}|\\)\n(?!\s*$)/,ee=/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,oe="\\p{P}\\p{S}",ie=w(/^((?![*_])[\spunctuation])/,"u").replace(/punctuation/g,oe).getRegex(),ue=/\[[^[\]]*?\]\([^\(\)]*?\)|`[^`]*?`|<[^<>]*?>/g,_=w(/^(?:\*+(?:((?!\*)[punct])|[^\s*]))|^_+(?:((?!_)[punct])|([^\s_]))/,"u").replace(/punct/g,oe).getRegex(),$e=w("^[^_*]*?__[^_*]*?\\*[^_*]*?(?=__)|[^*]+(?=[^*])|(?!\\*)[punct](\\*+)(?=[\\s]|$)|[^punct\\s](\\*+)(?!\\*)(?=[punct\\s]|$)|(?!\\*)[punct\\s](\\*+)(?=[^punct\\s])|[\\s](\\*+)(?!\\*)(?=[punct])|(?!\\*)[punct](\\*+)(?!\\*)(?=[punct])|[^punct\\s](\\*+)(?=[^punct\\s])","gu").replace(/punct/g,oe).getRegex(),Ie=w("^[^_*]*?\\*\\*[^_*]*?_[^_*]*?(?=\\*\\*)|[^_]+(?=[^_])|(?!_)[punct](_+)(?=[\\s]|$)|[^punct\\s](_+)(?!_)(?=[punct\\s]|$)|(?!_)[punct\\s](_+)(?=[^punct\\s])|[\\s](_+)(?!_)(?=[punct])|(?!_)[punct](_+)(?!_)(?=[punct])","gu").replace(/punct/g,oe).getRegex(),X=w(/\\([punct])/,"gu").replace(/punct/g,oe).getRegex(),V=w(/^<(scheme:[^\s\x00-\x1f<>]*|email)>/).replace("scheme",/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/).replace("email",/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/).getRegex(),re=w(b).replace("(?:-->|$)","-->").getRegex(),be=w("^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>").replace("comment",re).replace("attribute",/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/).getRegex(),Pe=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Fe=w(/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/).replace("label",Pe).replace("href",/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/).replace("title",/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/).getRegex(),Be=w(/^!?\[(label)\]\[(ref)\]/).replace("label",Pe).replace("ref",y).getRegex(),xe=w(/^!?\[(ref)\](?:\[\])?/).replace("ref",y).getRegex(),nt=w("reflink|nolink(?!\\()","g").replace("reflink",Be).replace("nolink",xe).getRegex(),ht={_backpedal:k,anyPunctuation:X,autolink:V,blockSkip:ue,br:ae,code:Y,del:k,emStrongLDelim:_,emStrongRDelimAst:$e,emStrongRDelimUnd:Ie,escape:J,link:Fe,nolink:xe,punctuation:ie,reflink:Be,reflinkSearch:nt,tag:be,text:ee,url:k},$t={...ht,link:w(/^!?\[(label)\]\((.*?)\)/).replace("label",Pe).getRegex(),reflink:w(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Pe).getRegex()},ut={...ht,escape:w(J).replace("])","~|])").getRegex(),url:w(/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,"i").replace("email",/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/).getRegex(),_backpedal:/(?:[^?!.,:;*_'"~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_'"~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/},et={...ut,br:w(ae).replace("{2,}","*").getRegex(),text:w(ut.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()},Le={normal:G,gfm:j,pedantic:U},Ne={normal:ht,gfm:ut,breaks:et,pedantic:$t};class Me{tokens;options;state;tokenizer;inlineQueue;constructor(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||we.defaults,this.options.tokenizer=this.options.tokenizer||new i,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};const pe={block:Le.normal,inline:Ne.normal};this.options.pedantic?(pe.block=Le.pedantic,pe.inline=Ne.pedantic):this.options.gfm&&(pe.block=Le.gfm,this.options.breaks?pe.inline=Ne.breaks:pe.inline=Ne.gfm),this.tokenizer.rules=pe}static get rules(){return{block:Le,inline:Ne}}static lex(he,pe){return new Me(pe).lex(he)}static lexInline(he,pe){return new Me(pe).inlineTokens(he)}lex(he){he=he.replace(/\r\n|\r/g,`
`),this.blockTokens(he,this.tokens);for(let pe=0;pe<this.inlineQueue.length;pe++){const ye=this.inlineQueue[pe];this.inlineTokens(ye.src,ye.tokens)}return this.inlineQueue=[],this.tokens}blockTokens(he,pe=[],ye=!1){this.options.pedantic?he=he.replace(/\t/g,"    ").replace(/^ +$/gm,""):he=he.replace(/^( *)(\t+)/gm,(Z,q,de)=>q+"    ".repeat(de.length));let Ce,fe,ve;for(;he;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(Z=>(Ce=Z.call({lexer:this},he,pe))?(he=he.substring(Ce.raw.length),pe.push(Ce),!0):!1))){if(Ce=this.tokenizer.space(he)){he=he.substring(Ce.raw.length),Ce.raw.length===1&&pe.length>0?pe[pe.length-1].raw+=`
`:pe.push(Ce);continue}if(Ce=this.tokenizer.code(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce);continue}if(Ce=this.tokenizer.fences(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.heading(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.hr(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.blockquote(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.list(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.html(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.def(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[Ce.tag]||(this.tokens.links[Ce.tag]={href:Ce.href,title:Ce.title});continue}if(Ce=this.tokenizer.table(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(Ce=this.tokenizer.lheading(he)){he=he.substring(Ce.raw.length),pe.push(Ce);continue}if(ve=he,this.options.extensions&&this.options.extensions.startBlock){let Z=1/0;const q=he.slice(1);let de;this.options.extensions.startBlock.forEach(je=>{de=je.call({lexer:this},q),typeof de=="number"&&de>=0&&(Z=Math.min(Z,de))}),Z<1/0&&Z>=0&&(ve=he.substring(0,Z+1))}if(this.state.top&&(Ce=this.tokenizer.paragraph(ve))){fe=pe[pe.length-1],ye&&fe?.type==="paragraph"?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce),ye=ve.length!==he.length,he=he.substring(Ce.raw.length);continue}if(Ce=this.tokenizer.text(he)){he=he.substring(Ce.raw.length),fe=pe[pe.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+Ce.raw,fe.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):pe.push(Ce);continue}if(he){const Z="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,pe}inline(he,pe=[]){return this.inlineQueue.push({src:he,tokens:pe}),pe}inlineTokens(he,pe=[]){let ye,Ce,fe,ve=he,Z,q,de;if(this.tokens.links){const je=Object.keys(this.tokens.links);if(je.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(ve))!=null;)je.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(ve=ve.slice(0,Z.index)+"["+"a".repeat(Z[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(ve))!=null;)ve=ve.slice(0,Z.index)+"["+"a".repeat(Z[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.anyPunctuation.exec(ve))!=null;)ve=ve.slice(0,Z.index)+"++"+ve.slice(this.tokenizer.rules.inline.anyPunctuation.lastIndex);for(;he;)if(q||(de=""),q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(je=>(ye=je.call({lexer:this},he,pe))?(he=he.substring(ye.raw.length),pe.push(ye),!0):!1))){if(ye=this.tokenizer.escape(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.tag(he)){he=he.substring(ye.raw.length),Ce=pe[pe.length-1],Ce&&ye.type==="text"&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.link(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.reflink(he,this.tokens.links)){he=he.substring(ye.raw.length),Ce=pe[pe.length-1],Ce&&ye.type==="text"&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(ye=this.tokenizer.emStrong(he,ve,de)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.codespan(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.br(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.del(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(ye=this.tokenizer.autolink(he)){he=he.substring(ye.raw.length),pe.push(ye);continue}if(!this.state.inLink&&(ye=this.tokenizer.url(he))){he=he.substring(ye.raw.length),pe.push(ye);continue}if(fe=he,this.options.extensions&&this.options.extensions.startInline){let je=1/0;const Qe=he.slice(1);let st;this.options.extensions.startInline.forEach(dt=>{st=dt.call({lexer:this},Qe),typeof st=="number"&&st>=0&&(je=Math.min(je,st))}),je<1/0&&je>=0&&(fe=he.substring(0,je+1))}if(ye=this.tokenizer.inlineText(fe)){he=he.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(de=ye.raw.slice(-1)),q=!0,Ce=pe[pe.length-1],Ce&&Ce.type==="text"?(Ce.raw+=ye.raw,Ce.text+=ye.text):pe.push(ye);continue}if(he){const je="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return pe}}class W{options;parser;constructor(he){this.options=he||we.defaults}space(he){return""}code({text:he,lang:pe,escaped:ye}){const Ce=(pe||"").match(/^\S*/)?.[0],fe=he.replace(/\n$/,"")+`
`;return Ce?'<pre><code class="language-'+s(Ce)+'">'+(ye?fe:s(fe,!0))+`</code></pre>
`:"<pre><code>"+(ye?fe:s(fe,!0))+`</code></pre>
`}blockquote({tokens:he}){return`<blockquote>
${this.parser.parse(he)}</blockquote>
`}html({text:he}){return he}heading({tokens:he,depth:pe}){return`<h${pe}>${this.parser.parseInline(he)}</h${pe}>
`}hr(he){return`<hr>
`}list(he){const pe=he.ordered,ye=he.start;let Ce="";for(let Z=0;Z<he.items.length;Z++){const q=he.items[Z];Ce+=this.listitem(q)}const fe=pe?"ol":"ul",ve=pe&&ye!==1?' start="'+ye+'"':"";return"<"+fe+ve+`>
`+Ce+"</"+fe+`>
`}listitem(he){let pe="";if(he.task){const ye=this.checkbox({checked:!!he.checked});he.loose?he.tokens.length>0&&he.tokens[0].type==="paragraph"?(he.tokens[0].text=ye+" "+he.tokens[0].text,he.tokens[0].tokens&&he.tokens[0].tokens.length>0&&he.tokens[0].tokens[0].type==="text"&&(he.tokens[0].tokens[0].text=ye+" "+he.tokens[0].tokens[0].text)):he.tokens.unshift({type:"text",raw:ye+" ",text:ye+" "}):pe+=ye+" "}return pe+=this.parser.parse(he.tokens,!!he.loose),`<li>${pe}</li>
`}checkbox({checked:he}){return"<input "+(he?'checked="" ':"")+'disabled="" type="checkbox">'}paragraph({tokens:he}){return`<p>${this.parser.parseInline(he)}</p>
`}table(he){let pe="",ye="";for(let fe=0;fe<he.header.length;fe++)ye+=this.tablecell(he.header[fe]);pe+=this.tablerow({text:ye});let Ce="";for(let fe=0;fe<he.rows.length;fe++){const ve=he.rows[fe];ye="";for(let Z=0;Z<ve.length;Z++)ye+=this.tablecell(ve[Z]);Ce+=this.tablerow({text:ye})}return Ce&&(Ce=`<tbody>${Ce}</tbody>`),`<table>
<thead>
`+pe+`</thead>
`+Ce+`</table>
`}tablerow({text:he}){return`<tr>
${he}</tr>
`}tablecell(he){const pe=this.parser.parseInline(he.tokens),ye=he.header?"th":"td";return(he.align?`<${ye} align="${he.align}">`:`<${ye}>`)+pe+`</${ye}>
`}strong({tokens:he}){return`<strong>${this.parser.parseInline(he)}</strong>`}em({tokens:he}){return`<em>${this.parser.parseInline(he)}</em>`}codespan({text:he}){return`<code>${he}</code>`}br(he){return"<br>"}del({tokens:he}){return`<del>${this.parser.parseInline(he)}</del>`}link({href:he,title:pe,tokens:ye}){const Ce=this.parser.parseInline(ye),fe=u(he);if(fe===null)return Ce;he=fe;let ve='<a href="'+he+'"';return pe&&(ve+=' title="'+pe+'"'),ve+=">"+Ce+"</a>",ve}image({href:he,title:pe,text:ye}){const Ce=u(he);if(Ce===null)return ye;he=Ce;let fe=`<img src="${he}" alt="${ye}"`;return pe&&(fe+=` title="${pe}"`),fe+=">",fe}text(he){return"tokens"in he&&he.tokens?this.parser.parseInline(he.tokens):he.text}}class B{strong({text:he}){return he}em({text:he}){return he}codespan({text:he}){return he}del({text:he}){return he}html({text:he}){return he}text({text:he}){return he}link({text:he}){return""+he}image({text:he}){return""+he}br(){return""}}class Q{options;renderer;textRenderer;constructor(he){this.options=he||we.defaults,this.options.renderer=this.options.renderer||new W,this.renderer=this.options.renderer,this.renderer.options=this.options,this.renderer.parser=this,this.textRenderer=new B}static parse(he,pe){return new Q(pe).parse(he)}static parseInline(he,pe){return new Q(pe).parseInline(he)}parse(he,pe=!0){let ye="";for(let Ce=0;Ce<he.length;Ce++){const fe=he[Ce];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const Z=fe,q=this.options.extensions.renderers[Z.type].call({parser:this},Z);if(q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type)){ye+=q||"";continue}}const ve=fe;switch(ve.type){case"space":{ye+=this.renderer.space(ve);continue}case"hr":{ye+=this.renderer.hr(ve);continue}case"heading":{ye+=this.renderer.heading(ve);continue}case"code":{ye+=this.renderer.code(ve);continue}case"table":{ye+=this.renderer.table(ve);continue}case"blockquote":{ye+=this.renderer.blockquote(ve);continue}case"list":{ye+=this.renderer.list(ve);continue}case"html":{ye+=this.renderer.html(ve);continue}case"paragraph":{ye+=this.renderer.paragraph(ve);continue}case"text":{let Z=ve,q=this.renderer.text(Z);for(;Ce+1<he.length&&he[Ce+1].type==="text";)Z=he[++Ce],q+=`
`+this.renderer.text(Z);pe?ye+=this.renderer.paragraph({type:"paragraph",raw:q,text:q,tokens:[{type:"text",raw:q,text:q}]}):ye+=q;continue}default:{const Z='Token with "'+ve.type+'" type was not found.';if(this.options.silent)return console.error(Z),"";throw new Error(Z)}}}return ye}parseInline(he,pe){pe=pe||this.renderer;let ye="";for(let Ce=0;Ce<he.length;Ce++){const fe=he[Ce];if(this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]){const Z=this.options.extensions.renderers[fe.type].call({parser:this},fe);if(Z!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type)){ye+=Z||"";continue}}const ve=fe;switch(ve.type){case"escape":{ye+=pe.text(ve);break}case"html":{ye+=pe.html(ve);break}case"link":{ye+=pe.link(ve);break}case"image":{ye+=pe.image(ve);break}case"strong":{ye+=pe.strong(ve);break}case"em":{ye+=pe.em(ve);break}case"codespan":{ye+=pe.codespan(ve);break}case"br":{ye+=pe.br(ve);break}case"del":{ye+=pe.del(ve);break}case"text":{ye+=pe.text(ve);break}default:{const Z='Token with "'+ve.type+'" type was not found.';if(this.options.silent)return console.error(Z),"";throw new Error(Z)}}}return ye}}class K{options;constructor(he){this.options=he||we.defaults}static passThroughHooks=new Set(["preprocess","postprocess","processAllTokens"]);preprocess(he){return he}postprocess(he){return he}processAllTokens(he){return he}}class se{defaults=e();options=this.setOptions;parse=this.parseMarkdown(Me.lex,Q.parse);parseInline=this.parseMarkdown(Me.lexInline,Q.parseInline);Parser=Q;Renderer=W;TextRenderer=B;Lexer=Me;Tokenizer=i;Hooks=K;constructor(...he){this.use(...he)}walkTokens(he,pe){let ye=[];for(const Ce of he)switch(ye=ye.concat(pe.call(this,Ce)),Ce.type){case"table":{const fe=Ce;for(const ve of fe.header)ye=ye.concat(this.walkTokens(ve.tokens,pe));for(const ve of fe.rows)for(const Z of ve)ye=ye.concat(this.walkTokens(Z.tokens,pe));break}case"list":{const fe=Ce;ye=ye.concat(this.walkTokens(fe.items,pe));break}default:{const fe=Ce;this.defaults.extensions?.childTokens?.[fe.type]?this.defaults.extensions.childTokens[fe.type].forEach(ve=>{const Z=fe[ve].flat(1/0);ye=ye.concat(this.walkTokens(Z,pe))}):fe.tokens&&(ye=ye.concat(this.walkTokens(fe.tokens,pe)))}}return ye}use(...he){const pe=this.defaults.extensions||{renderers:{},childTokens:{}};return he.forEach(ye=>{const Ce={...ye};if(Ce.async=this.defaults.async||Ce.async||!1,ye.extensions&&(ye.extensions.forEach(fe=>{if(!fe.name)throw new Error("extension name required");if("renderer"in fe){const ve=pe.renderers[fe.name];ve?pe.renderers[fe.name]=function(...Z){let q=fe.renderer.apply(this,Z);return q===!1&&(q=ve.apply(this,Z)),q}:pe.renderers[fe.name]=fe.renderer}if("tokenizer"in fe){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");const ve=pe[fe.level];ve?ve.unshift(fe.tokenizer):pe[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?pe.startBlock?pe.startBlock.push(fe.start):pe.startBlock=[fe.start]:fe.level==="inline"&&(pe.startInline?pe.startInline.push(fe.start):pe.startInline=[fe.start]))}"childTokens"in fe&&fe.childTokens&&(pe.childTokens[fe.name]=fe.childTokens)}),Ce.extensions=pe),ye.renderer){const fe=this.defaults.renderer||new W(this.defaults);for(const ve in ye.renderer){if(!(ve in fe))throw new Error(`renderer '${ve}' does not exist`);if(["options","parser"].includes(ve))continue;const Z=ve,q=ye.renderer[Z],de=fe[Z];fe[Z]=(...je)=>{let Qe=q.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe||""}}Ce.renderer=fe}if(ye.tokenizer){const fe=this.defaults.tokenizer||new i(this.defaults);for(const ve in ye.tokenizer){if(!(ve in fe))throw new Error(`tokenizer '${ve}' does not exist`);if(["options","rules","lexer"].includes(ve))continue;const Z=ve,q=ye.tokenizer[Z],de=fe[Z];fe[Z]=(...je)=>{let Qe=q.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe}}Ce.tokenizer=fe}if(ye.hooks){const fe=this.defaults.hooks||new K;for(const ve in ye.hooks){if(!(ve in fe))throw new Error(`hook '${ve}' does not exist`);if(ve==="options")continue;const Z=ve,q=ye.hooks[Z],de=fe[Z];K.passThroughHooks.has(ve)?fe[Z]=je=>{if(this.defaults.async)return Promise.resolve(q.call(fe,je)).then(st=>de.call(fe,st));const Qe=q.call(fe,je);return de.call(fe,Qe)}:fe[Z]=(...je)=>{let Qe=q.apply(fe,je);return Qe===!1&&(Qe=de.apply(fe,je)),Qe}}Ce.hooks=fe}if(ye.walkTokens){const fe=this.defaults.walkTokens,ve=ye.walkTokens;Ce.walkTokens=function(Z){let q=[];return q.push(ve.call(this,Z)),fe&&(q=q.concat(fe.call(this,Z))),q}}this.defaults={...this.defaults,...Ce}}),this}setOptions(he){return this.defaults={...this.defaults,...he},this}lexer(he,pe){return Me.lex(he,pe??this.defaults)}parser(he,pe){return Q.parse(he,pe??this.defaults)}parseMarkdown(he,pe){return(Ce,fe)=>{const ve={...fe},Z={...this.defaults,...ve},q=this.onError(!!Z.silent,!!Z.async);if(this.defaults.async===!0&&ve.async===!1)return q(new Error("marked(): The async option was set to true by an extension. Remove async: false from the parse options object to return a Promise."));if(typeof Ce>"u"||Ce===null)return q(new Error("marked(): input parameter is undefined or null"));if(typeof Ce!="string")return q(new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected"));if(Z.hooks&&(Z.hooks.options=Z),Z.async)return Promise.resolve(Z.hooks?Z.hooks.preprocess(Ce):Ce).then(de=>he(de,Z)).then(de=>Z.hooks?Z.hooks.processAllTokens(de):de).then(de=>Z.walkTokens?Promise.all(this.walkTokens(de,Z.walkTokens)).then(()=>de):de).then(de=>pe(de,Z)).then(de=>Z.hooks?Z.hooks.postprocess(de):de).catch(q);try{Z.hooks&&(Ce=Z.hooks.preprocess(Ce));let de=he(Ce,Z);Z.hooks&&(de=Z.hooks.processAllTokens(de)),Z.walkTokens&&this.walkTokens(de,Z.walkTokens);let je=pe(de,Z);return Z.hooks&&(je=Z.hooks.postprocess(je)),je}catch(de){return q(de)}}}onError(he,pe){return ye=>{if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,he){const Ce="<p>An error occurred:</p><pre>"+s(ye.message+"",!0)+"</pre>";return pe?Promise.resolve(Ce):Ce}if(pe)return Promise.reject(ye);throw ye}}}const ge=new se;function Ee(Ze,he){return ge.parse(Ze,he)}Ee.options=Ee.setOptions=function(Ze){return ge.setOptions(Ze),Ee.defaults=ge.defaults,v(Ee.defaults),Ee},Ee.getDefaults=e,Ee.defaults=we.defaults,Ee.use=function(...Ze){return ge.use(...Ze),Ee.defaults=ge.defaults,v(Ee.defaults),Ee},Ee.walkTokens=function(Ze,he){return ge.walkTokens(Ze,he)},Ee.parseInline=ge.parseInline,Ee.Parser=Q,Ee.parser=Q.parse,Ee.Renderer=W,Ee.TextRenderer=B,Ee.Lexer=Me,Ee.lexer=Me.lex,Ee.Tokenizer=i,Ee.Hooks=K,Ee.parse=Ee;const ze=Ee.options,Je=Ee.setOptions,_e=Ee.use,tt=Ee.walkTokens,ct=Ee.parseInline,it=Ee,at=Q.parse,yt=Me.lex;we.Hooks=K,we.Lexer=Me,we.Marked=se,we.Parser=Q,we.Renderer=W,we.TextRenderer=B,we.Tokenizer=i,we.getDefaults=e,we.lexer=yt,we.marked=Ee,we.options=ze,we.parse=it,we.parseInline=ct,we.parser=at,we.setOptions=Je,we.use=_e,we.walkTokens=tt}),define(Re[141],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kk=v;function v(r){const a=L(r);if(a&&a.length>0)return new Uint32Array(a)}let D=0;const P=new Uint32Array(10);function L(r){if(D=0,R(r,w,m.InitialConsonant),D>0||(R(r,u,m.Vowel),D>0)||(R(r,k,m.FinalConsonant),D>0)||(R(r,$,m.CompatibilityJamo),D))return P.subarray(0,D);if(r>=44032&&r<=55203){const a=r-44032,h=a%588,c=Math.floor(a/588),i=Math.floor(h/28),n=h%28-1;if(c<w.length?R(c,w,0):m.InitialConsonant+c-m.CompatibilityJamo<$.length&&R(m.InitialConsonant+c,$,m.CompatibilityJamo),i<u.length?R(i,u,0):m.Vowel+i-m.CompatibilityJamo<$.length&&R(m.Vowel+i-m.CompatibilityJamo,$,m.CompatibilityJamo),n>=0&&(n<k.length?R(n,k,0):m.FinalConsonant+n-m.CompatibilityJamo<$.length&&R(m.FinalConsonant+n-m.CompatibilityJamo,$,m.CompatibilityJamo)),D>0)return P.subarray(0,D)}}function R(r,a,h){r>=h&&r<h+a.length&&T(a[r-h])}function T(r){r!==s.NUL&&(P[D++]=r&255,r>>8&&(P[D++]=r>>8&255),r>>16&&(P[D++]=r>>16&255))}var m;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var s;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(s||(s={}));var I;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(I||(I={}));const w=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),u=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l]),k=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,I.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),$=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.E,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,s.Q,I.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l])}),define(Re[142],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Qm=v,e.rot=D,e.$Vm=T;function v(m,s,I){return Math.min(Math.max(m,s),I)}function D(m,s){return(s+m%s)%s}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Sm=P;class L{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Tm=L;class R{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const I=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Um=R;function T(m,s,I,w,u,k,$,r){const a=$-I,h=r-w,c=u-I,i=k-w,n=m-I,t=s-w,o=a*a+h*h,l=a*c+h*i,g=a*n+h*t,f=c*c+i*i,d=c*n+i*t,S=1/(o*f-l*l),E=(f*g-l*d)*S,y=(o*d-l*g)*S;return E>=0&&y>=0&&E+y<1}}),define(Re[143],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fd=void 0,e.$gd=L,e.$hd=u;class v{constructor($,r,a){this.owner=$,this.debugNameSource=r,this.referenceFn=a}getDebugName($){return L($,this)}}e.$fd=v;const D=new Map,P=new WeakMap;function L(k,$){const r=P.get(k);if(r)return r;const a=R(k,$);if(a){let h=D.get(a)??0;h++,D.set(a,h);const c=h===1?a:`${a}#${h}`;return P.set(k,c),c}}function R(k,$){const r=P.get(k);if(r)return r;const a=$.owner?I($.owner)+".":"";let h;const c=$.debugNameSource;if(c!==void 0)if(typeof c=="function"){if(h=c(),h!==void 0)return a+h}else return a+c;const i=$.referenceFn;if(i!==void 0&&(h=u(i),h!==void 0))return a+h;if($.owner!==void 0){const n=T($.owner,k);if(n!==void 0)return a+n}}function T(k,$){for(const r in k)if(k[r]===$)return r}const m=new Map,s=new WeakMap;function I(k){const $=s.get(k);if($)return $;const r=w(k);let a=m.get(r)??0;a++,m.set(r,a);const h=a===1?r:`${r}#${a}`;return s.set(k,h),h}function w(k){const $=k.constructor;return $?$.name:"Object"}function u(k){const $=k.toString(),a=/\/\*\*\s*@description\s*([^*]*)\*\//.exec($);return(a?a[1]:void 0)?.trim()}}),define(Re[144],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0,e.$Pd=D,e.$Qd=P;let v;function D(r){v=r}function P(){return v}class L{constructor(){this.a=0,this.d=new WeakMap}b(a){return R([T(k("|  ",this.a)),a])}c(a){return a.hadValue?a.didChange?[T(" "),s(I(a.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),s(I(a.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),s(I(a.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(a,h){console.log(...this.b([m("observable value changed"),s(a.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(a){if(a.size!==0)return s(" (changed deps: "+[...a].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const h=a.handleChange;this.d.set(a,new Set),a.handleChange=(c,i)=>(this.d.get(a).add(c),h.apply(a,[c,i]))}handleDerivedRecomputed(a,h){const c=this.d.get(a);console.log(...this.b([m("derived recomputed"),s(a.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(c),{data:[{fn:a._debugNameData.referenceFn??a._computeFn}]}])),c.clear()}handleFromEventObservableTriggered(a,h){console.log(...this.b([m("observable from event triggered"),s(a.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const h=a.handleChange;this.d.set(a,new Set),a.handleChange=(c,i)=>(this.d.get(a).add(c),h.apply(a,[c,i]))}handleAutorunTriggered(a){const h=this.d.get(a);console.log(...this.b([m("autorun"),s(a.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:a._debugNameData.referenceFn??a._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(a){this.a--}handleBeginTransaction(a){let h=a.getDebugName();h===void 0&&(h=""),console.log(...this.b([m("transaction"),s(h,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Rd=L;function R(r){const a=new Array,h=[];let c="";function i(t){if("length"in t)for(const o of t)o&&i(o);else"text"in t?(c+=`%c${t.text}`,a.push(t.style),t.data&&h.push(...t.data)):"data"in t&&h.push(...t.data)}i(r);const n=[c,...a];return n.push(...h),n}function T(r){return s(r,{color:"black"})}function m(r){return s($(`${r}: `,10),{color:"black",bold:!0})}function s(r,a={color:"black"}){function h(i){return Object.entries(i).reduce((n,[t,o])=>`${n}${t}:${o};`,"")}const c={color:a.color};return a.strikeThrough&&(c["text-decoration"]="line-through"),a.bold&&(c["font-weight"]="bold"),{text:r,style:h(c)}}function I(r,a){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=a?`"${r}"`:`"${r.substr(0,a-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?w(r,a):u(r,a);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function w(r,a){let h="[ ",c=!0;for(const i of r){if(c||(h+=", "),h.length-5>a){h+="...";break}c=!1,h+=`${I(i,a-h.length)}`}return h+=" ]",h}function u(r,a){let h="{ ",c=!0;for(const[i,n]of Object.entries(r)){if(c||(h+=", "),h.length-5>a){h+="...";break}c=!1,h+=`${i}: ${I(n,a-h.length)}`}return h+=" }",h}function k(r,a){let h="";for(let c=1;c<=a;c++)h+=r;return h}function $(r,a){for(;r.length<a;)r+=" ";return r}}),define(Re[145],Oe([1,0,137,143,144]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$_d=e.$0d=e.$5d=e.$4d=void 0,e.$1d=R,e.$2d=m,e.$3d=I,e.$6d=k,e.$7d=r,e.$8d=a,e.$9d=h,e.$$d=i,e.$ae=t;let L;function R(l){L=l}let T;function m(l){T=l}let s;function I(l){s=l}class w{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,f){const d=f===void 0?void 0:g,S=f===void 0?g:f;return s({owner:d,debugName:()=>{const E=(0,D.$hd)(S);if(E!==void 0)return E;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(C)return`${this.debugName}.${C[2]}`;if(!d)return`${this.debugName} (mapped)`},debugReferenceFn:S},E=>S(this.read(E),E))}flatten(){return s({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},g=>this.read(g).read(g))}recomputeInitiallyAndOnChange(g,f){return g.add(L(this,f)),this}keepObserved(g){return g.add(T(this)),this}get a(){return this.get()}}e.$4d=w;class u extends w{constructor(){super(...arguments),this.b=new Set}addObserver(g){const f=this.b.size;this.b.add(g),f===0&&this.c()}removeObserver(g){this.b.delete(g)&&this.b.size===0&&this.f()}c(){}f(){}}e.$5d=u;function k(l,g){const f=new c(l,g);try{l(f)}finally{f.finish()}}let $;function r(l){if($)l($);else{const g=new c(l,void 0);$=g;try{l(g)}finally{g.finish(),$=void 0}}}async function a(l,g){const f=new c(l,g);try{await l(f)}finally{f.finish()}}function h(l,g,f){l?g(l):k(g,f)}class c{constructor(g,f){this._fn=g,this.b=f,this.a=[],(0,P.$Qd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,D.$hd)(this._fn)}updateObserver(g,f){this.a.push({observer:g,observable:f}),g.beginUpdate(f)}finish(){const g=this.a;for(let f=0;f<g.length;f++){const{observer:d,observable:S}=g[f];d.endUpdate(S)}this.a=null,(0,P.$Qd)()?.handleEndTransaction()}}e.$0d=c;function i(l,g){let f;return typeof l=="string"?f=new D.$fd(void 0,l,void 0):f=new D.$fd(l,void 0,void 0),new n(f,g,v.$$c)}class n extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(g,f,d){super(),this.e=g,this.g=d,this.d=f}get(){return this.d}set(g,f,d){if(d===void 0&&this.g(this.d,g))return;let S;f||(f=S=new c(()=>{},()=>`Setting ${this.debugName}`));try{const E=this.d;this.h(g),(0,P.$Qd)()?.handleObservableChanged(this,{oldValue:E,newValue:g,change:d,didChange:!0,hadValue:!0});for(const y of this.b)f.updateObserver(y,this),y.handleChange(this,d)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(g){this.d=g}}e.$_d=n;function t(l,g){let f;return typeof l=="string"?f=new D.$fd(void 0,l,void 0):f=new D.$fd(l,void 0,void 0),new o(f,g,v.$$c)}class o extends n{h(g){this.d!==g&&(this.d&&this.d.dispose(),this.d=g)}dispose(){this.d?.dispose()}}e.$be=o}),function(){function we(P){const L=[];typeof P=="number"&&L.push("code/timeOrigin",P);function R(m){L.push(m,Date.now())}function T(){const m=[];for(let s=0;s<L.length;s+=2)m.push({name:L[s],startTime:L[s+1]});return m}return{mark:R,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?we():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(P+R.startTime)});return L}};if(typeof process=="object"){const P=performance?.timeOrigin;return we(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),we()}function v(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=v(D))}(),define(Re[146],Oe([1,0,41]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=void 0;const D=Symbol("unset");class P{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert(m,s,I){this.d(m,w=>w._value=s,I)}mutate(m,s){this.d(m,I=>I._value=s(I._value===D?void 0:I._value))}mutatePath(m,s){this.d(m,()=>{},I=>s(I))}delete(m){const s=this.c(m);if(!s)return;let I=s.length-1;const w=s[I].node._value;if(w!==D){for(this.b--,s[I].node._value=D;I>0;I--){const{node:u,part:k}=s[I];if(u.children?.size||u._value!==D)break;s[I-1].node.children.delete(k)}return w}}*deleteRecursive(m){const s=this.c(m);if(!s)return;const I=s[s.length-1].node;for(let w=s.length-1;w>0;w--){const u=s[w-1];if(u.node.children.delete(s[w].part),u.node.children.size>0||u.node._value!==D)break}for(const w of L(I))w._value!==D&&(this.b--,yield w._value)}find(m){let s=this.a;for(const I of m){const w=s.children?.get(I);if(!w)return;s=w}return s._value===D?void 0:s._value}hasKeyOrParent(m){let s=this.a;for(const I of m){const w=s.children?.get(I);if(!w)return!1;if(w._value!==D)return!0;s=w}return!1}hasKeyOrChildren(m){let s=this.a;for(const I of m){const w=s.children?.get(I);if(!w)return!1;s=w}return!0}hasKey(m){let s=this.a;for(const I of m){const w=s.children?.get(I);if(!w)return!1;s=w}return s._value!==D}c(m){const s=[{part:"",node:this.a}];let I=0;for(const w of m){const u=s[I].node.children?.get(w);if(!u)return;s.push({part:w,node:u}),I++}return s}d(m,s,I){let w=this.a;for(const $ of m){if(w.children)if(w.children.has($))w=w.children.get($);else{const r=new R;w.children.set($,r),w=r}else{const r=new R;w.children=new Map([[$,r]]),w=r}I?.(w)}const u=w._value===D?0:1;s(w);const k=w._value===D?0:1;this.b+=k-u}*values(){for(const{_value:m}of L(this.a))m!==D&&(yield m)}}e.$qJ=P;function*L(T){const m=[T];for(;m.length>0;){const s=m.pop();if(yield s,s.children)for(const I of s.children.values())m.push(I)}}class R{constructor(){this._value=D}get value(){return this._value===D?void 0:this._value}set value(m){this._value=m===void 0?D:m}}}),function(we,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var D in v)(typeof exports=="object"?exports:we)[D]=v[D]}}(typeof self<"u"?self:this,function(){return function(we){var e={};function v(D){if(e[D])return e[D].exports;var P=e[D]={i:D,l:!1,exports:{}};return we[D].call(P.exports,P,P.exports,v),P.l=!0,P.exports}return v.m=we,v.c=e,v.d=function(D,P,L){v.o(D,P)||Object.defineProperty(D,P,{enumerable:!0,get:L})},v.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},v.t=function(D,P){if(1&P&&(D=v(D)),8&P||4&P&&typeof D=="object"&&D&&D.__esModule)return D;var L=Object.create(null);if(v.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:D}),2&P&&typeof D!="string")for(var R in D)v.d(L,R,function(T){return D[T]}.bind(null,R));return L},v.n=function(D){var P=D&&D.__esModule?function(){return D.default}:function(){return D};return v.d(P,"a",P),P},v.o=function(D,P){return Object.prototype.hasOwnProperty.call(D,P)},v.p="",v(v.s=0)}([function(we,e,v){(function(D){var P;e=we.exports=$e,P=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],m=e.src=[],s=0,I=s++;m[I]="0|[1-9]\\d*";var w=s++;m[w]="[0-9]+";var u=s++;m[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=s++;m[k]="("+m[I]+")\\.("+m[I]+")\\.("+m[I]+")";var $=s++;m[$]="("+m[w]+")\\.("+m[w]+")\\.("+m[w]+")";var r=s++;m[r]="(?:"+m[I]+"|"+m[u]+")";var a=s++;m[a]="(?:"+m[w]+"|"+m[u]+")";var h=s++;m[h]="(?:-("+m[r]+"(?:\\."+m[r]+")*))";var c=s++;m[c]="(?:-?("+m[a]+"(?:\\."+m[a]+")*))";var i=s++;m[i]="[0-9A-Za-z-]+";var n=s++;m[n]="(?:\\+("+m[i]+"(?:\\."+m[i]+")*))";var t=s++,o="v?"+m[k]+m[h]+"?"+m[n]+"?";m[t]="^"+o+"$";var l="[v=\\s]*"+m[$]+m[c]+"?"+m[n]+"?",g=s++;m[g]="^"+l+"$";var f=s++;m[f]="((?:<|>)?=?)";var d=s++;m[d]=m[w]+"|x|X|\\*";var S=s++;m[S]=m[I]+"|x|X|\\*";var E=s++;m[E]="[v=\\s]*("+m[S]+")(?:\\.("+m[S]+")(?:\\.("+m[S]+")(?:"+m[h]+")?"+m[n]+"?)?)?";var y=s++;m[y]="[v=\\s]*("+m[d]+")(?:\\.("+m[d]+")(?:\\.("+m[d]+")(?:"+m[c]+")?"+m[n]+"?)?)?";var C=s++;m[C]="^"+m[f]+"\\s*"+m[E]+"$";var O=s++;m[O]="^"+m[f]+"\\s*"+m[y]+"$";var p=s++;m[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=s++;m[b]="(?:~>?)";var M=s++;m[M]="(\\s*)"+m[b]+"\\s+",T[M]=new RegExp(m[M],"g");var A=s++;m[A]="^"+m[b]+m[E]+"$";var F=s++;m[F]="^"+m[b]+m[y]+"$";var G=s++;m[G]="(?:\\^)";var x=s++;m[x]="(\\s*)"+m[G]+"\\s+",T[x]=new RegExp(m[x],"g");var j=s++;m[j]="^"+m[G]+m[E]+"$";var U=s++;m[U]="^"+m[G]+m[y]+"$";var J=s++;m[J]="^"+m[f]+"\\s*("+l+")$|^$";var Y=s++;m[Y]="^"+m[f]+"\\s*("+o+")$|^$";var ae=s++;m[ae]="(\\s*)"+m[f]+"\\s*("+l+"|"+m[E]+")",T[ae]=new RegExp(m[ae],"g");var ee=s++;m[ee]="^\\s*("+m[E]+")\\s+-\\s+("+m[E]+")\\s*$";var oe=s++;m[oe]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var ie=s++;m[ie]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)P(ue,m[ue]),T[ue]||(T[ue]=new RegExp(m[ue]));function _(B,Q){if(B instanceof $e)return B;if(typeof B!="string"||B.length>L||!(Q?T[g]:T[t]).test(B))return null;try{return new $e(B,Q)}catch{return null}}function $e(B,Q){if(B instanceof $e){if(B.loose===Q)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof $e))return new $e(B,Q);P("SemVer",B,Q),this.loose=Q;var K=B.trim().match(Q?T[g]:T[t]);if(!K)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var ge=+se;if(ge>=0&&ge<R)return ge}return se}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=_,e.valid=function(B,Q){var K=_(B,Q);return K?K.version:null},e.clean=function(B,Q){var K=_(B.trim().replace(/^[=v]+/,""),Q);return K?K.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof $e||(B=new $e(B,this.loose)),this.compareMain(B)||this.comparePre(B)},$e.prototype.compareMain=function(B){return B instanceof $e||(B=new $e(B,this.loose)),X(this.major,B.major)||X(this.minor,B.minor)||X(this.patch,B.patch)},$e.prototype.comparePre=function(B){if(B instanceof $e||(B=new $e(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var Q=0;do{var K=this.prerelease[Q],se=B.prerelease[Q];if(P("prerelease compare",Q,K,se),K===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(K===void 0)return-1;if(K!==se)return X(K,se)}while(++Q)},$e.prototype.inc=function(B,Q){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,Q,K,se){typeof K=="string"&&(se=K,K=void 0);try{return new $e(B,K).inc(Q,se).version}catch{return null}},e.diff=function(B,Q){if(Pe(B,Q))return null;var K=_(B),se=_(Q);if(K.prerelease.length||se.prerelease.length){for(var ge in K)if((ge==="major"||ge==="minor"||ge==="patch")&&K[ge]!==se[ge])return"pre"+ge;return"prerelease"}for(var ge in K)if((ge==="major"||ge==="minor"||ge==="patch")&&K[ge]!==se[ge])return ge},e.compareIdentifiers=X;var Ie=/^[0-9]+$/;function X(B,Q){var K=Ie.test(B),se=Ie.test(Q);return K&&se&&(B=+B,Q=+Q),K&&!se?-1:se&&!K?1:B<Q?-1:B>Q?1:0}function V(B,Q,K){return new $e(B,K).compare(new $e(Q,K))}function re(B,Q,K){return V(B,Q,K)>0}function be(B,Q,K){return V(B,Q,K)<0}function Pe(B,Q,K){return V(B,Q,K)===0}function Fe(B,Q,K){return V(B,Q,K)!==0}function Be(B,Q,K){return V(B,Q,K)>=0}function xe(B,Q,K){return V(B,Q,K)<=0}function nt(B,Q,K,se){var ge;switch(Q){case"===":typeof B=="object"&&(B=B.version),typeof K=="object"&&(K=K.version),ge=B===K;break;case"!==":typeof B=="object"&&(B=B.version),typeof K=="object"&&(K=K.version),ge=B!==K;break;case"":case"=":case"==":ge=Pe(B,K,se);break;case"!=":ge=Fe(B,K,se);break;case">":ge=re(B,K,se);break;case">=":ge=Be(B,K,se);break;case"<":ge=be(B,K,se);break;case"<=":ge=xe(B,K,se);break;default:throw new TypeError("Invalid operator: "+Q)}return ge}function ht(B,Q){if(B instanceof ht){if(B.loose===Q)return B;B=B.value}if(!(this instanceof ht))return new ht(B,Q);P("comparator",B,Q),this.loose=Q,this.parse(B),this.semver===$t?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,Q){return X(Q,B)},e.major=function(B,Q){return new $e(B,Q).major},e.minor=function(B,Q){return new $e(B,Q).minor},e.patch=function(B,Q){return new $e(B,Q).patch},e.compare=V,e.compareLoose=function(B,Q){return V(B,Q,!0)},e.rcompare=function(B,Q,K){return V(Q,B,K)},e.sort=function(B,Q){return B.sort(function(K,se){return e.compare(K,se,Q)})},e.rsort=function(B,Q){return B.sort(function(K,se){return e.rcompare(K,se,Q)})},e.gt=re,e.lt=be,e.eq=Pe,e.neq=Fe,e.gte=Be,e.lte=xe,e.cmp=nt,e.Comparator=ht;var $t={};function ut(B,Q){if(B instanceof ut)return B.loose===Q?B:new ut(B.raw,Q);if(B instanceof ht)return new ut(B.value,Q);if(!(this instanceof ut))return new ut(B,Q);if(this.loose=Q,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function et(B){return!B||B.toLowerCase()==="x"||B==="*"}function Le(B,Q,K,se,ge,Ee,ze,Je,_e,tt,ct,it,at){return((Q=et(K)?"":et(se)?">="+K+".0.0":et(ge)?">="+K+"."+se+".0":">="+Q)+" "+(Je=et(_e)?"":et(tt)?"<"+(+_e+1)+".0.0":et(ct)?"<"+_e+"."+(+tt+1)+".0":it?"<="+_e+"."+tt+"."+ct+"-"+it:"<="+Je)).trim()}function Ne(B,Q){for(var K=0;K<B.length;K++)if(!B[K].test(Q))return!1;if(Q.prerelease.length){for(K=0;K<B.length;K++)if(P(B[K].semver),B[K].semver!==$t&&B[K].semver.prerelease.length>0){var se=B[K].semver;if(se.major===Q.major&&se.minor===Q.minor&&se.patch===Q.patch)return!0}return!1}return!0}function Me(B,Q,K){try{Q=new ut(Q,K)}catch{return!1}return Q.test(B)}function W(B,Q,K,se){var ge,Ee,ze,Je,_e;switch(B=new $e(B,se),Q=new ut(Q,se),K){case">":ge=re,Ee=xe,ze=be,Je=">",_e=">=";break;case"<":ge=be,Ee=Be,ze=re,Je="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(B,Q,se))return!1;for(var tt=0;tt<Q.set.length;++tt){var ct=Q.set[tt],it=null,at=null;if(ct.forEach(function(yt){yt.semver===$t&&(yt=new ht(">=0.0.0")),it=it||yt,at=at||yt,ge(yt.semver,it.semver,se)?it=yt:ze(yt.semver,at.semver,se)&&(at=yt)}),it.operator===Je||it.operator===_e||(!at.operator||at.operator===Je)&&Ee(B,at.semver)||at.operator===_e&&ze(B,at.semver))return!1}return!0}ht.prototype.parse=function(B){var Q=this.loose?T[J]:T[Y],K=B.match(Q);if(!K)throw new TypeError("Invalid comparator: "+B);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new $e(K[2],this.loose):this.semver=$t},ht.prototype.toString=function(){return this.value},ht.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===$t||(typeof B=="string"&&(B=new $e(B,this.loose)),nt(B,this.operator,this.semver,this.loose))},ht.prototype.intersects=function(B,Q){if(!(B instanceof ht))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ut(B.value,Q),Me(this.value,K,Q);if(B.operator==="")return K=new ut(this.value,Q),Me(B.semver,K,Q);var se=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Ee=this.semver.version===B.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Je=nt(this.semver,"<",B.semver,Q)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),_e=nt(this.semver,">",B.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return se||ge||Ee&&ze||Je||_e},e.Range=ut,ut.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},ut.prototype.toString=function(){return this.range},ut.prototype.parseRange=function(B){var Q=this.loose;B=B.trim(),P("range",B,Q);var K=Q?T[oe]:T[ee];B=B.replace(K,Le),P("hyphen replace",B),B=B.replace(T[ae],"$1$2$3"),P("comparator trim",B,T[ae]),B=(B=(B=B.replace(T[M],"$1~")).replace(T[x],"$1^")).split(/\s+/).join(" ");var se=Q?T[J]:T[Y],ge=B.split(" ").map(function(Ee){return function(ze,Je){return P("comp",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(ct){return function(it,at){P("caret",it,at);var yt=at?T[U]:T[j];return it.replace(yt,function(Ze,he,pe,ye,Ce){var fe;return P("caret",it,Ze,he,pe,ye,Ce),et(he)?fe="":et(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":et(ye)?fe=he==="0"?">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+".0 <"+(+he+1)+".0.0":Ce?(P("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+Ce+" <"+(+he+1)+".0.0"):(P("no pr"),fe=he==="0"?pe==="0"?">="+he+"."+pe+"."+ye+" <"+he+"."+pe+"."+(+ye+1):">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0":">="+he+"."+pe+"."+ye+" <"+(+he+1)+".0.0"),P("caret return",fe),fe})}(ct,tt)}).join(" ")}(ze,Je),P("caret",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(ct){return function(it,at){var yt=at?T[F]:T[A];return it.replace(yt,function(Ze,he,pe,ye,Ce){var fe;return P("tilde",it,Ze,he,pe,ye,Ce),et(he)?fe="":et(pe)?fe=">="+he+".0.0 <"+(+he+1)+".0.0":et(ye)?fe=">="+he+"."+pe+".0 <"+he+"."+(+pe+1)+".0":Ce?(P("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),fe=">="+he+"."+pe+"."+ye+Ce+" <"+he+"."+(+pe+1)+".0"):fe=">="+he+"."+pe+"."+ye+" <"+he+"."+(+pe+1)+".0",P("tilde return",fe),fe})}(ct,tt)}).join(" ")}(ze,Je),P("tildes",ze),ze=function(_e,tt){return P("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(ct){return function(it,at){it=it.trim();var yt=at?T[O]:T[C];return it.replace(yt,function(Ze,he,pe,ye,Ce,fe){P("xRange",it,Ze,he,pe,ye,Ce,fe);var ve=et(pe),Z=ve||et(ye),q=Z||et(Ce);return he==="="&&q&&(he=""),ve?Ze=he===">"||he==="<"?"<0.0.0":"*":he&&q?(Z&&(ye=0),q&&(Ce=0),he===">"?(he=">=",Z?(pe=+pe+1,ye=0,Ce=0):q&&(ye=+ye+1,Ce=0)):he==="<="&&(he="<",Z?pe=+pe+1:ye=+ye+1),Ze=he+pe+"."+ye+"."+Ce):Z?Ze=">="+pe+".0.0 <"+(+pe+1)+".0.0":q&&(Ze=">="+pe+"."+ye+".0 <"+pe+"."+(+ye+1)+".0"),P("xRange return",Ze),Ze})}(ct,tt)}).join(" ")}(ze,Je),P("xrange",ze),ze=function(_e,tt){return P("replaceStars",_e,tt),_e.trim().replace(T[ie],"")}(ze,Je),P("stars",ze),ze}(Ee,Q)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Ee){return!!Ee.match(se)})),ge=ge.map(function(Ee){return new ht(Ee,Q)})},ut.prototype.intersects=function(B,Q){if(!(B instanceof ut))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(se){return B.set.some(function(ge){return ge.every(function(Ee){return se.intersects(Ee,Q)})})})})},e.toComparators=function(B,Q){return new ut(B,Q).set.map(function(K){return K.map(function(se){return se.value}).join(" ").trim().split(" ")})},ut.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new $e(B,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Ne(this.set[Q],B))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(B,Q,K){var se=null,ge=null;try{var Ee=new ut(Q,K)}catch{return null}return B.forEach(function(ze){Ee.test(ze)&&(se&&ge.compare(ze)!==-1||(ge=new $e(se=ze,K)))}),se},e.minSatisfying=function(B,Q,K){var se=null,ge=null;try{var Ee=new ut(Q,K)}catch{return null}return B.forEach(function(ze){Ee.test(ze)&&(se&&ge.compare(ze)!==1||(ge=new $e(se=ze,K)))}),se},e.validRange=function(B,Q){try{return new ut(B,Q).range||"*"}catch{return null}},e.ltr=function(B,Q,K){return W(B,Q,"<",K)},e.gtr=function(B,Q,K){return W(B,Q,">",K)},e.outside=W,e.prerelease=function(B,Q){var K=_(B,Q);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(B,Q,K){return B=new ut(B,K),Q=new ut(Q,K),B.intersects(Q)},e.coerce=function(B){if(B instanceof $e)return B;if(typeof B!="string")return null;var Q=B.match(T[p]);return Q==null?null:_((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,v(1))},function(we,e){var v,D,P=we.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function T(a){if(v===setTimeout)return setTimeout(a,0);if((v===L||!v)&&setTimeout)return v=setTimeout,setTimeout(a,0);try{return v(a,0)}catch{try{return v.call(null,a,0)}catch{return v.call(this,a,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:L}catch{v=L}try{D=typeof clearTimeout=="function"?clearTimeout:R}catch{D=R}})();var m,s=[],I=!1,w=-1;function u(){I&&m&&(I=!1,m.length?s=m.concat(s):w=-1,s.length&&k())}function k(){if(!I){var a=T(u);I=!0;for(var h=s.length;h;){for(m=s,s=[];++w<h;)m&&m[w].run();w=-1,h=s.length}m=null,I=!1,function(c){if(D===clearTimeout)return clearTimeout(c);if((D===R||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(c);try{D(c)}catch{try{return D.call(null,c)}catch{return D.call(this,c)}}}(a)}}function $(a,h){this.fun=a,this.array=h}function r(){}P.nextTick=function(a){var h=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)h[c-1]=arguments[c];s.push(new $(a,h)),s.length!==1||I||T(k)},$.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(a){return[]},P.binding=function(a){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(a){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Re[147],Oe([1,0,6,4]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$nt=e.$mt=e.$lt=e.ScrollbarVisibility=void 0;var P;(function(k){k[k.Auto=1]="Auto",k[k.Hidden=2]="Hidden",k[k.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class L{constructor($,r,a,h,c,i,n){this.c=$,this._scrollStateBrand=void 0,this.c&&(r=r|0,a=a|0,h=h|0,c=c|0,i=i|0,n=n|0),this.rawScrollLeft=h,this.rawScrollTop=n,r<0&&(r=0),h+r>a&&(h=a-r),h<0&&(h=0),c<0&&(c=0),n+c>i&&(n=i-c),n<0&&(n=0),this.width=r,this.scrollWidth=a,this.scrollLeft=h,this.height=c,this.scrollHeight=i,this.scrollTop=n}equals($){return this.rawScrollLeft===$.rawScrollLeft&&this.rawScrollTop===$.rawScrollTop&&this.width===$.width&&this.scrollWidth===$.scrollWidth&&this.scrollLeft===$.scrollLeft&&this.height===$.height&&this.scrollHeight===$.scrollHeight&&this.scrollTop===$.scrollTop}withScrollDimensions($,r){return new L(this.c,typeof $.width<"u"?$.width:this.width,typeof $.scrollWidth<"u"?$.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof $.height<"u"?$.height:this.height,typeof $.scrollHeight<"u"?$.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition($){return new L(this.c,this.width,this.scrollWidth,typeof $.scrollLeft<"u"?$.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof $.scrollTop<"u"?$.scrollTop:this.rawScrollTop)}createScrollEvent($,r){const a=this.width!==$.width,h=this.scrollWidth!==$.scrollWidth,c=this.scrollLeft!==$.scrollLeft,i=this.height!==$.height,n=this.scrollHeight!==$.scrollHeight,t=this.scrollTop!==$.scrollTop;return{inSmoothScrolling:r,oldWidth:$.width,oldScrollWidth:$.scrollWidth,oldScrollLeft:$.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:$.height,oldScrollHeight:$.scrollHeight,oldScrollTop:$.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:h,scrollLeftChanged:c,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.$lt=L;class R extends D.$Zc{constructor($){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$qe),this.onScroll=this.j.event,this.c=$.smoothScrollDuration,this.f=$.scheduleAtNextAnimationFrame,this.g=new L($.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration($){this.c=$}validateScrollPosition($){return this.g.withScrollPosition($)}getScrollDimensions(){return this.g}setScrollDimensions($,r){const a=this.g.withScrollDimensions($,r);this.n(a,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow($){const r=this.g.withScrollPosition($);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth($,r){if(this.c===0)return this.setScrollPositionNow($);if(this.h){$={scrollLeft:typeof $.scrollLeft>"u"?this.h.to.scrollLeft:$.scrollLeft,scrollTop:typeof $.scrollTop>"u"?this.h.to.scrollTop:$.scrollTop};const a=this.g.withScrollPosition($);if(this.h.to.scrollLeft===a.scrollLeft&&this.h.to.scrollTop===a.scrollTop)return;let h;r?h=new I(this.h.from,a,this.h.startTime,this.h.duration):h=this.h.combine(this.g,a,this.c),this.h.dispose(),this.h=h}else{const a=this.g.withScrollPosition($);this.h=I.start(this.g,a,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const $=this.h.tick(),r=this.g.withScrollPosition($);if(this.n(r,!0),!!this.h){if($.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n($,r){const a=this.g;a.equals($)||(this.g=$,this.j.fire(this.g.createScrollEvent(a,r)))}}e.$mt=R;class T{constructor($,r,a){this.scrollLeft=$,this.scrollTop=r,this.isDone=a}}e.$nt=T;function m(k,$){const r=$-k;return function(a){return k+r*u(a)}}function s(k,$,r){return function(a){return a<r?k(a/r):$((a-r)/(1-r))}}class I{constructor($,r,a,h){this.from=$,this.to=r,this.duration=h,this.startTime=a,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f($,r,a){if(Math.abs($-r)>2.5*a){let c,i;return $<r?(c=$+.75*a,i=r-.75*a):(c=$-.75*a,i=r+.75*a),s(m($,c),m(i,r),.33)}return m($,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions($){this.to=$.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g($){const r=($-this.startTime)/this.duration;if(r<1){const a=this.c(r),h=this.d(r);return new T(a,h,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine($,r,a){return I.start($,r,a)}static start($,r,a){a=a+10;const h=Date.now()-10;return new I($,r,h,a)}}e.$ot=I;function w(k){return Math.pow(k,3)}function u(k){return 1-w(1-k)}}),define(Re[148],Oe([1,0,12,4]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=P,e.$Ee=L,e.$Fe=R,e.$Ge=T,e.$He=s,e.$Ie=I,e.$Je=w,e.$Ke=u,e.$Le=k,e.$Me=$,e.$Ne=r,e.$Oe=a,e.$Pe=h,e.$Qe=c,e.$Re=i;function P(n){const t=n;return t?typeof t.read=="function":!1}function L(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(o=>typeof o=="function"):!1}function R(n){const t=n;return t?L(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(n,t){return new m(n,t)}class m{constructor(t,o){this.e=t,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(o=>o(t))}h(t){this.c.error.length===0?(0,v.$4)(t):this.c.error.slice(0).forEach(o=>o(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,o){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(t,o){if(this.a.destroyed)return;let l;switch(t){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const g=l.indexOf(o);g>=0&&l.splice(g,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(n,t){const o=[];let l;for(;(l=n.read())!==null;)o.push(l);return t(o)}function I(n,t,o){const l=[];let g;for(;(g=n.read())!==null&&l.length<o;)l.push(g);return g===null&&l.length>0?t(l):{read:()=>{if(l.length>0)return l.shift();if(typeof g<"u"){const f=g;return g=void 0,f}return n.read()}}}function w(n,t){return new Promise((o,l)=>{const g=[];u(n,{onData:f=>{t&&g.push(f)},onError:f=>{t?l(f):o(void 0)},onEnd:()=>{o(t?t(g):void 0)}})})}function u(n,t,o){n.on("error",l=>{o?.isCancellationRequested||t.onError(l)}),n.on("end",()=>{o?.isCancellationRequested||t.onEnd()}),n.on("data",l=>{o?.isCancellationRequested||t.onData(l)})}function k(n,t){return new Promise((o,l)=>{const g=new D.$Yc,f=[],d=y=>{if(f.push(y),f.length>t)return g.dispose(),n.pause(),o({stream:n,buffer:f,ended:!1})},S=y=>(g.dispose(),l(y)),E=()=>(g.dispose(),o({stream:n,buffer:f,ended:!0}));g.add((0,D.$Xc)(()=>n.removeListener("error",S))),n.on("error",S),g.add((0,D.$Xc)(()=>n.removeListener("end",E))),n.on("end",E),g.add((0,D.$Xc)(()=>n.removeListener("data",d))),n.on("data",d)})}function $(n,t){const o=T(t);return o.end(n),o}function r(){const n=T(()=>{throw new Error("not supported")});return n.end(),n}function a(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function h(n,t,o){const l=T(o);return u(n,{onData:g=>l.write(t.data(g)),onError:g=>l.error(t.error?t.error(g):g),onEnd:()=>l.end()}),l}function c(n,t,o){let l=!1;return{read:()=>{const g=t.read();return l?g:(l=!0,g!==null?o([n,g]):n)}}}function i(n,t,o){let l=!1;const g=T(o);return u(t,{onData:f=>l?g.write(f):(l=!0,g.write(o([n,f]))),onError:f=>g.error(f),onEnd:()=>{l||(l=!0,g.write(n)),g.end()}}),g}}),define(Re[20],Oe([1,0,51,148]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=void 0,e.$Te=s,e.$Ue=I,e.$Ve=w,e.$We=u,e.$Xe=k,e.$Ye=$,e.$Ze=r,e.$1e=a,e.$2e=h,e.$3e=c,e.$4e=i,e.$5e=n,e.$6e=t,e.$7e=o,e.$8e=l,e.$9e=g,e.$0e=f,e.$$e=d,e.$_e=S,e.$af=C,D=Ve(D);const P=typeof Buffer<"u",L=new v.$Y(()=>new Uint8Array(256));let R,T;class m{static alloc(p){return P?new m(Buffer.allocUnsafe(p)):new m(new Uint8Array(p))}static wrap(p){return P&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new m(p)}static fromString(p,b){return!(b?.dontUseNodeBuffer||!1)&&P?new m(Buffer.from(p)):(R||(R=new TextEncoder),new m(R.encode(p)))}static fromByteArray(p){const b=m.alloc(p.length);for(let M=0,A=p.length;M<A;M++)b.buffer[M]=p[M];return b}static concat(p,b){if(typeof b>"u"){b=0;for(let F=0,G=p.length;F<G;F++)b+=p[F].byteLength}const M=m.alloc(b);let A=0;for(let F=0,G=p.length;F<G;F++){const x=p[F];M.set(x,A),A+=x.byteLength}return M}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=m.alloc(this.byteLength);return p.set(this),p}toString(){return P?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(p,b){return new m(this.buffer.subarray(p,b))}set(p,b){if(p instanceof m)this.buffer.set(p.buffer,b);else if(p instanceof Uint8Array)this.buffer.set(p,b);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),b);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return u(this.buffer,p)}writeUInt32BE(p,b){k(this.buffer,p,b)}readUInt32LE(p){return $(this.buffer,p)}writeUInt32LE(p,b){r(this.buffer,p,b)}readUInt8(p){return a(this.buffer,p)}writeUInt8(p,b){h(this.buffer,p,b)}indexOf(p,b=0){return s(this.buffer,p instanceof m?p.buffer:p,b)}}e.$Se=m;function s(O,p,b=0){const M=p.byteLength,A=O.byteLength;if(M===0)return 0;if(M===1)return O.indexOf(p[0]);if(M>A-b)return-1;const F=L.value;F.fill(p.length);for(let U=0;U<p.length;U++)F[p[U]]=p.length-U-1;let G=b+p.length-1,x=G,j=-1;for(;G<A;)if(O[G]===p[x]){if(x===0){j=G;break}G--,x--}else G+=Math.max(p.length-x,F[O[G]]),x=p.length-1;return j}function I(O,p){return O[p+0]<<0>>>0|O[p+1]<<8>>>0}function w(O,p,b){O[b+0]=p&255,p=p>>>8,O[b+1]=p&255}function u(O,p){return O[p]*2**24+O[p+1]*2**16+O[p+2]*2**8+O[p+3]}function k(O,p,b){O[b+3]=p,p=p>>>8,O[b+2]=p,p=p>>>8,O[b+1]=p,p=p>>>8,O[b]=p}function $(O,p){return O[p+0]<<0>>>0|O[p+1]<<8>>>0|O[p+2]<<16>>>0|O[p+3]<<24>>>0}function r(O,p,b){O[b+0]=p&255,p=p>>>8,O[b+1]=p&255,p=p>>>8,O[b+2]=p&255,p=p>>>8,O[b+3]=p&255}function a(O,p){return O[p]}function h(O,p,b){O[b]=p}function c(O){return D.$He(O,p=>m.concat(p))}function i(O){return D.$Oe(O)}function n(O){return D.$Je(O,p=>m.concat(p))}async function t(O){return O.ended?m.concat(O.buffer):m.concat([...O.buffer,await n(O.stream)])}function o(O){return D.$Me(O,p=>m.concat(p))}function l(O){return D.$Pe(O,{data:p=>typeof p=="string"?m.fromString(p):m.wrap(p)},p=>m.concat(p))}function g(O){return D.$Ge(p=>m.concat(p),O)}function f(O,p){return D.$Qe(O,p,b=>m.concat(b))}function d(O,p){return D.$Re(O,p,b=>m.concat(b))}function S(O){let p=0,b=0,M=0;const A=new Uint8Array(Math.floor(O.length/4*3)),F=x=>{switch(b){case 3:A[M++]=p|x,b=0;break;case 2:A[M++]=p|x>>>2,p=x<<6,b=3;break;case 1:A[M++]=p|x>>>4,p=x<<4,b=2;break;default:p=x<<2,b=1}};for(let x=0;x<O.length;x++){const j=O.charCodeAt(x);if(j>=65&&j<=90)F(j-65);else if(j>=97&&j<=122)F(j-97+26);else if(j>=48&&j<=57)F(j-48+52);else if(j===43||j===45)F(62);else if(j===47||j===95)F(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${O[x]}`)}}const G=M;for(;b>0;)F(0);return m.wrap(A).slice(0,G)}const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:O},p=!0,b=!1){const M=b?y:E;let A="";const F=O.byteLength%3;let G=0;for(;G<O.byteLength-F;G+=3){const x=O[G+0],j=O[G+1],U=O[G+2];A+=M[x>>>2],A+=M[(x<<4|j>>>4)&63],A+=M[(j<<2|U>>>6)&63],A+=M[U&63]}if(F===1){const x=O[G+0];A+=M[x>>>2],A+=M[x<<4&63],p&&(A+="==")}else if(F===2){const x=O[G+0],j=O[G+1];A+=M[x>>>2],A+=M[(x<<4|j>>>4)&63],A+=M[j<<2&63],p&&(A+="=")}return A}}),define(Re[36],Oe([1,0,98]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$$j=P;var D;(function(R){function T(m){return m&&typeof m=="object"&&typeof m.id=="string"}R.isThemeColor=T})(D||(e.ThemeColor=D={}));function P(R){return{id:R}}var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function m(c){const i=T.exec(c.id);if(!i)return m(v.$0j.error);const[,n,t]=i,o=["codicon","codicon-"+n];return t&&o.push("codicon-modifier-"+t.substring(1)),o}R.asClassNameArray=m;function s(c){return m(c).join(" ")}R.asClassName=s;function I(c){return"."+m(c).join(".")}R.asCSSSelector=I;function w(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||D.isThemeColor(c.color))}R.isThemeIcon=w;const u=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function k(c){const i=u.exec(c);if(!i)return;const[,n]=i;return{id:n}}R.fromString=k;function $(c){return{id:c}}R.fromId=$;function r(c,i){let n=c.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}R.modify=r;function a(c){const i=c.id.lastIndexOf("~");if(i!==-1)return c.id.substring(i+1)}R.getModifier=a;function h(c,i){return c.id===i.id&&c.color?.id===i.color?.id}R.isEqual=h})(L||(e.ThemeIcon=L={}))}),define(Re[149],Oe([1,0,30,27,141,13]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.FuzzyScore=e.$Nk=e.$Mk=void 0,e.or=R,e.$Ok=m,e.$Pk=s,e.$Qk=u,e.$Rk=E,e.$Sk=y,e.$Tk=A,e.$Uk=F,e.$Vk=G,e.$Wk=x,e.$Xk=re,e.$Zk=Be,e.$1k=ht,e.$2k=$t,L=Ve(L);function R(...Le){return function(Ne,Me){for(let W=0,B=Le.length;W<B;W++){const Q=Le[W](Ne,Me);if(Q)return Q}return null}}e.$Mk=T.bind(void 0,!1),e.$Nk=T.bind(void 0,!0);function T(Le,Ne,Me){if(!Me||Me.length<Ne.length)return null;let W;return Le?W=L.$Lf(Me,Ne):W=Me.indexOf(Ne)===0,W?Ne.length>0?[{start:0,end:Ne.length}]:[]:null}function m(Le,Ne){const Me=Ne.toLowerCase().indexOf(Le.toLowerCase());return Me===-1?null:[{start:Me,end:Me+Le.length}]}function s(Le,Ne){return I(Le.toLowerCase(),Ne.toLowerCase(),0,0)}function I(Le,Ne,Me,W){if(Me===Le.length)return[];if(W===Ne.length)return null;if(Le[Me]===Ne[W]){let B=null;return(B=I(Le,Ne,Me+1,W+1))?t({start:W,end:W+1},B):null}return I(Le,Ne,Me,W+1)}function w(Le){return v.CharCode.a<=Le&&Le<=v.CharCode.z}function u(Le){return v.CharCode.A<=Le&&Le<=v.CharCode.Z}function k(Le){return v.CharCode.Digit0<=Le&&Le<=v.CharCode.Digit9}function $(Le){return Le===v.CharCode.Space||Le===v.CharCode.Tab||Le===v.CharCode.LineFeed||Le===v.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Le=>r.add(Le.charCodeAt(0)));function a(Le){return $(Le)||r.has(Le)}function h(Le,Ne){return Le===Ne||a(Le)&&a(Ne)}const c=new Map;function i(Le){if(c.has(Le))return c.get(Le);let Ne;const Me=(0,P.$Kk)(Le);return Me&&(Ne=Me),c.set(Le,Ne),Ne}function n(Le){return w(Le)||u(Le)||k(Le)}function t(Le,Ne){return Ne.length===0?Ne=[Le]:Le.end===Ne[0].start?Ne[0].start=Le.start:Ne.unshift(Le),Ne}function o(Le,Ne){for(let Me=Ne;Me<Le.length;Me++){const W=Le.charCodeAt(Me);if(u(W)||k(W)||Me>0&&!n(Le.charCodeAt(Me-1)))return Me}return Le.length}function l(Le,Ne,Me,W){if(Me===Le.length)return[];if(W===Ne.length)return null;if(Le[Me]!==Ne[W].toLowerCase())return null;{let B=null,Q=W+1;for(B=l(Le,Ne,Me+1,W+1);!B&&(Q=o(Ne,Q))<Ne.length;)B=l(Le,Ne,Me+1,Q),Q++;return B===null?null:t({start:W,end:W+1},B)}}function g(Le){let Ne=0,Me=0,W=0,B=0,Q=0;for(let ze=0;ze<Le.length;ze++)Q=Le.charCodeAt(ze),u(Q)&&Ne++,w(Q)&&Me++,n(Q)&&W++,k(Q)&&B++;const K=Ne/Le.length,se=Me/Le.length,ge=W/Le.length,Ee=B/Le.length;return{upperPercent:K,lowerPercent:se,alphaPercent:ge,numericPercent:Ee}}function f(Le){const{upperPercent:Ne,lowerPercent:Me}=Le;return Me===0&&Ne>.6}function d(Le){const{upperPercent:Ne,lowerPercent:Me,alphaPercent:W,numericPercent:B}=Le;return Me>.2&&Ne<.8&&W>.6&&B<.2}function S(Le){let Ne=0,Me=0,W=0,B=0;for(let Q=0;Q<Le.length;Q++)W=Le.charCodeAt(Q),u(W)&&Ne++,w(W)&&Me++,$(W)&&B++;return(Ne===0||Me===0)&&B===0?Le.length<=30:Ne<=5}function E(Le,Ne){if(!Ne||(Ne=Ne.trim(),Ne.length===0)||!S(Le))return null;Ne.length>60&&(Ne=Ne.substring(0,60));const Me=g(Ne);if(!d(Me)){if(!f(Me))return null;Ne=Ne.toLowerCase()}let W=null,B=0;for(Le=Le.toLowerCase();B<Ne.length&&(W=l(Le,Ne,0,B))===null;)B=o(Ne,B+1);return W}function y(Le,Ne,Me=!1){if(!Ne||Ne.length===0)return null;let W=null,B=0;for(Le=Le.toLowerCase(),Ne=Ne.toLowerCase();B<Ne.length&&(W=C(Le,Ne,0,B,Me),W===null);)B=O(Ne,B+1);return W}function C(Le,Ne,Me,W,B){let Q=0;if(Me===Le.length)return[];if(W===Ne.length)return null;if(!h(Le.charCodeAt(Me),Ne.charCodeAt(W))){const ge=i(Le.charCodeAt(Me));if(!ge)return null;for(let Ee=0;Ee<ge.length;Ee++)if(!h(ge[Ee],Ne.charCodeAt(W+Ee)))return null;Q+=ge.length-1}let K=null,se=W+Q+1;if(K=C(Le,Ne,Me+1,se,B),!B)for(;!K&&(se=O(Ne,se))<Ne.length;)K=C(Le,Ne,Me+1,se,B),se++;if(!K)return null;if(Le.charCodeAt(Me)!==Ne.charCodeAt(W)){const ge=i(Le.charCodeAt(Me));if(!ge)return K;for(let Ee=0;Ee<ge.length;Ee++)if(ge[Ee]!==Ne.charCodeAt(W+Ee))return K}return t({start:W,end:W+Q+1},K)}function O(Le,Ne){for(let Me=Ne;Me<Le.length;Me++)if(a(Le.charCodeAt(Me))||Me>0&&a(Le.charCodeAt(Me-1)))return Me;return Le.length}const p=R(e.$Nk,E,m),b=R(e.$Nk,E,s),M=new D.$Ic(1e4);function A(Le,Ne,Me=!1){if(typeof Le!="string"||typeof Ne!="string")return null;let W=M.get(Le);W||(W=new RegExp(L.$tf(Le),"i"),M.set(Le,W));const B=W.exec(Ne);return B?[{start:B.index,end:B.index+B[0].length}]:Me?b(Le,Ne):p(Le,Ne)}function F(Le,Ne){const Me=Be(Le,Le.toLowerCase(),0,Ne,Ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?x(Me):null}function G(Le,Ne,Me,W,B,Q){const K=Math.min(13,Le.length);for(;Me<K;Me++){const se=Be(Le,Ne,Me,W,B,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,Q]}function x(Le){if(typeof Le>"u")return[];const Ne=[],Me=Le[1];for(let W=Le.length-1;W>1;W--){const B=Le[W]+Me,Q=Ne[Ne.length-1];Q&&Q.end===B?Q.end=B+1:Ne.push({start:B,end:B+1})}return Ne}const j=128;function U(){const Le=[],Ne=[];for(let Me=0;Me<=j;Me++)Ne[Me]=0;for(let Me=0;Me<=j;Me++)Le.push(Ne.slice(0));return Le}function J(Le){const Ne=[];for(let Me=0;Me<=Le;Me++)Ne[Me]=0;return Ne}const Y=J(2*j),ae=J(2*j),ee=U(),oe=U(),ie=U(),ue=!1;function _(Le,Ne,Me,W,B){function Q(se,ge,Ee=" "){for(;se.length<ge;)se=Ee+se;return se}let K=` |   |${W.split("").map(se=>Q(se,3)).join("|")}
`;for(let se=0;se<=Me;se++)se===0?K+=" |":K+=`${Ne[se-1]}|`,K+=Le[se].slice(0,B+1).map(ge=>Q(ge.toString(),3)).join("|")+`
`;return K}function $e(Le,Ne,Me,W){Le=Le.substr(Ne),Me=Me.substr(W),console.log(_(oe,Le,Le.length,Me,Me.length)),console.log(_(ie,Le,Le.length,Me,Me.length)),console.log(_(ee,Le,Le.length,Me,Me.length))}function Ie(Le,Ne){if(Ne<0||Ne>=Le.length)return!1;const Me=Le.codePointAt(Ne);switch(Me){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!L.$4f(Me)}}function X(Le,Ne){if(Ne<0||Ne>=Le.length)return!1;switch(Le.charCodeAt(Ne)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function V(Le,Ne,Me){return Ne[Le]!==Me[Le]}function re(Le,Ne,Me,W,B,Q,K=!1){for(;Ne<Me&&B<Q;)Le[Ne]===W[B]&&(K&&(Y[Ne]=B),Ne+=1),B+=1;return Ne===Me}var be;(function(Le){Le[Le.Diag=1]="Diag",Le[Le.Left=2]="Left",Le[Le.LeftLeft=3]="LeftLeft"})(be||(be={}));var Pe;(function(Le){Le.Default=[-100,0];function Ne(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}Le.isDefault=Ne})(Pe||(e.FuzzyScore=Pe={}));class Fe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ne,Me){this.firstMatchCanBeWeak=Ne,this.boostFullMatch=Me}}e.$Yk=Fe;function Be(Le,Ne,Me,W,B,Q,K=Fe.default){const se=Le.length>j?j:Le.length,ge=W.length>j?j:W.length;if(Me>=se||Q>=ge||se-Me>ge-Q||!re(Ne,Me,se,B,Q,ge,!0))return;xe(se,ge,Me,Q,Ne,B);let Ee=1,ze=1,Je=Me,_e=Q;const tt=[!1];for(Ee=1,Je=Me;Je<se;Ee++,Je++){const Ze=Y[Je],he=ae[Je],pe=Je+1<se?ae[Je+1]:ge;for(ze=Ze-Q+1,_e=Ze;_e<pe;ze++,_e++){let ye=Number.MIN_SAFE_INTEGER,Ce=!1;_e<=he&&(ye=nt(Le,Ne,Je,Me,W,B,_e,ge,Q,ee[Ee-1][ze-1]===0,tt));let fe=0;ye!==Number.MAX_SAFE_INTEGER&&(Ce=!0,fe=ye+oe[Ee-1][ze-1]);const ve=_e>Ze,Z=ve?oe[Ee][ze-1]+(ee[Ee][ze-1]>0?-5:0):0,q=_e>Ze+1&&ee[Ee][ze-1]>0,de=q?oe[Ee][ze-2]+(ee[Ee][ze-2]>0?-5:0):0;if(q&&(!ve||de>=Z)&&(!Ce||de>=fe))oe[Ee][ze]=de,ie[Ee][ze]=be.LeftLeft,ee[Ee][ze]=0;else if(ve&&(!Ce||Z>=fe))oe[Ee][ze]=Z,ie[Ee][ze]=be.Left,ee[Ee][ze]=0;else if(Ce)oe[Ee][ze]=fe,ie[Ee][ze]=be.Diag,ee[Ee][ze]=ee[Ee-1][ze-1]+1;else throw new Error("not possible")}}if(ue&&$e(Le,Me,W,Q),!tt[0]&&!K.firstMatchCanBeWeak)return;Ee--,ze--;const ct=[oe[Ee][ze],Q];let it=0,at=0;for(;Ee>=1;){let Ze=ze;do{const he=ie[Ee][Ze];if(he===be.LeftLeft)Ze=Ze-2;else if(he===be.Left)Ze=Ze-1;else break}while(Ze>=1);it>1&&Ne[Me+Ee-1]===B[Q+ze-1]&&!V(Ze+Q-1,W,B)&&it+1>ee[Ee][Ze]&&(Ze=ze),Ze===ze?it++:it=1,at||(at=Ze),Ee--,ze=Ze-1,ct.push(ze)}ge-Q===se&&K.boostFullMatch&&(ct[0]+=2);const yt=at-se;return ct[0]-=yt,ct}function xe(Le,Ne,Me,W,B,Q){let K=Le-1,se=Ne-1;for(;K>=Me&&se>=W;)B[K]===Q[se]&&(ae[K]=se,K--),se--}function nt(Le,Ne,Me,W,B,Q,K,se,ge,Ee,ze){if(Ne[Me]!==Q[K])return Number.MIN_SAFE_INTEGER;let Je=1,_e=!1;return K===Me-W?Je=Le[Me]===B[K]?7:5:V(K,B,Q)&&(K===0||!V(K-1,B,Q))?(Je=Le[Me]===B[K]?7:5,_e=!0):Ie(Q,K)&&(K===0||!Ie(Q,K-1))?Je=5:(Ie(Q,K-1)||X(Q,K-1))&&(Je=5,_e=!0),Je>1&&Me===W&&(ze[0]=!0),_e||(_e=V(K,B,Q)||Ie(Q,K-1)||X(Q,K-1)),Me===W?K>ge&&(Je-=_e?3:5):Ee?Je+=_e?2:0:Je+=_e?0:1,K+1===se&&(Je-=_e?3:5),Je}function ht(Le,Ne,Me,W,B,Q,K){return ut(Le,Ne,Me,W,B,Q,!0,K)}function $t(Le,Ne,Me,W,B,Q,K){return ut(Le,Ne,Me,W,B,Q,!1,K)}function ut(Le,Ne,Me,W,B,Q,K,se){let ge=Be(Le,Ne,Me,W,B,Q,se);if(ge&&!K)return ge;if(Le.length>=3){const Ee=Math.min(7,Le.length-1);for(let ze=Me+1;ze<Ee;ze++){const Je=et(Le,ze);if(Je){const _e=Be(Je,Je.toLowerCase(),Me,W,B,Q,se);_e&&(_e[0]-=3,(!ge||_e[0]>ge[0])&&(ge=_e))}}}return ge}function et(Le,Ne){if(Ne+1>=Le.length)return;const Me=Le[Ne],W=Le[Ne+1];if(Me!==W)return Le.slice(0,Ne)+W+Me+Le.slice(Ne+2)}}),define(Re[99],Oe([1,0,149,13,36]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=m,e.$4k=I,e.$5k=u,e.$6k=k,e.$7k=r,e.$8k=a;const L="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${R.source}`,"g");function m(h){return h.replace(T,(c,i)=>i?c:`\\${c}`)}const s=new RegExp(`\\\\${R.source}`,"g");function I(h){return h.replace(s,c=>`\\${c}`)}const w=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function u(h){return h.indexOf(L)===-1?h:h.replace(w,(c,i,n,t)=>n?c:i||t||"")}function k(h){return h?h.replace(/\$\((.*?)\)/g,(c,i)=>` ${i} `).trim():""}const $=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(h){$.lastIndex=0;let c="";const i=[];let n=0;for(;;){const t=$.lastIndex,o=$.exec(h),l=h.substring(t,o?.index);if(l.length>0){c+=l;for(let g=0;g<l.length;g++)i.push(n)}if(!o)break;n+=o[0].length}return{text:c,iconOffsets:i}}function a(h,c,i=!1){const{text:n,iconOffsets:t}=c;if(!t||t.length===0)return(0,v.$Tk)(h,n,i);const o=(0,D.$rf)(n," "),l=n.length-o.length,g=(0,v.$Tk)(h,o,i);if(g)for(const f of g){const d=t[f.start+l]+l;f.start+=d,f.end+=d}return g}}),define(Re[37],Oe([1,0,13]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=Ve(v);var D;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(D||(D={})),function(P){const L="error",R="warning",T="warn",m="info",s="ignore";function I(u){return u?v.$Kf(L,u)?P.Error:v.$Kf(R,u)||v.$Kf(T,u)?P.Warning:v.$Kf(m,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function w(u){switch(u){case P.Error:return L;case P.Warning:return R;case P.Info:return m;default:return s}}P.toString=w}(D||(D={})),e.default=D}),define(Re[48],Oe([1,0,17,30,13]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class L{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const r=$.charCodeAt(0),a=this.b.charCodeAt(this.c);return r-a}value(){return this.b[this.c]}}e.$Mi=L;class R{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===D.CharCode.Period)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,P.$Ef)($,this.b,0,$.length,this.c,this.d):(0,P.$Gf)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ni=R;class T{constructor($=!0,r=!0){this.f=$,this.g=r}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let r=$.length-1;r>=0;r--,this.c--){const a=this.b.charCodeAt(r);if(!(a===D.CharCode.Slash||this.f&&a===D.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===D.CharCode.Slash||this.f&&r===D.CharCode.Backslash)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,P.$Ef)($,this.b,0,$.length,this.d,this.e):(0,P.$Gf)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Oi=T;var m;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(m||(m={}));class s{constructor($,r){this.f=$,this.g=r,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(m.Scheme),this.c.authority&&this.d.push(m.Authority),this.c.path&&(this.b=new T(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(m.Path)),this.g($)||(this.c.query&&this.d.push(m.Query),this.c.fragment&&this.d.push(m.Fragment)),this.e=0,this}next(){return this.d[this.e]===m.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===m.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===m.Scheme)return(0,P.$Ff)($,this.c.scheme);if(this.d[this.e]===m.Authority)return(0,P.$Ff)($,this.c.authority);if(this.d[this.e]===m.Path)return this.b.cmp($);if(this.d[this.e]===m.Query)return(0,P.$Df)($,this.c.query);if(this.d[this.e]===m.Fragment)return(0,P.$Df)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===m.Scheme)return this.c.scheme;if(this.d[this.e]===m.Authority)return this.c.authority;if(this.d[this.e]===m.Path)return this.b.value();if(this.d[this.e]===m.Query)return this.c.query;if(this.d[this.e]===m.Fragment)return this.c.fragment;throw new Error}}e.$Pi=s;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(w||(w={}));class u{static forUris($=()=>!1,r=()=>!1){return new u(new s($,r))}static forPaths($=!1){return new u(new T(void 0,!$))}static forStrings(){return new u(new L)}static forConfigKeys(){return new u(new R)}constructor($){this.b=$}clear(){this.c=void 0}fill($,r){if(r){const a=r.slice(0);(0,v.$1b)(a);for(const h of a)this.set(h,$)}else{const a=$.slice(0);(0,v.$1b)(a);for(const h of a)this.set(h[0],h[1])}}set($,r){const a=this.b.reset($);let h;this.c||(this.c=new I,this.c.segment=a.value());const c=[];for(h=this.c;;){const n=a.cmp(h.segment);if(n>0)h.left||(h.left=new I,h.left.segment=a.value()),c.push([w.Left,h]),h=h.left;else if(n<0)h.right||(h.right=new I,h.right.segment=a.value()),c.push([w.Right,h]),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new I,h.mid.segment=a.value()),c.push([w.Mid,h]),h=h.mid;else break}const i=h.value;h.value=r,h.key=$;for(let n=c.length-1;n>=0;n--){const t=c[n][1];t.updateHeight();const o=t.balanceFactor();if(o<-1||o>1){const l=c[n][0],g=c[n+1][0];if(l===w.Right&&g===w.Right)c[n][1]=t.rotateLeft();else if(l===w.Left&&g===w.Left)c[n][1]=t.rotateRight();else if(l===w.Right&&g===w.Left)t.right=c[n+1][1]=c[n+1][1].rotateRight(),c[n][1]=t.rotateLeft();else if(l===w.Left&&g===w.Right)t.left=c[n+1][1]=c[n+1][1].rotateLeft(),c[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(c[n-1][0]){case w.Left:c[n-1][1].left=c[n][1];break;case w.Right:c[n-1][1].right=c[n][1];break;case w.Mid:c[n-1][1].mid=c[n][1];break}else this.c=c[0][1]}}return i}get($){return this.d($)?.value}d($){const r=this.b.reset($);let a=this.c;for(;a;){const h=r.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has($){const r=this.d($);return!(r?.value===void 0&&r?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,r){const a=this.b.reset($),h=[];let c=this.c;for(;c;){const i=a.cmp(c.segment);if(i>0)h.push([w.Left,c]),c=c.left;else if(i<0)h.push([w.Right,c]),c=c.right;else if(a.hasNext())a.next(),h.push([w.Mid,c]),c=c.mid;else break}if(c){if(r?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const i=this.f(c.right);if(i.key){const{key:n,value:t,segment:o}=i;this.e(i.key,!1),c.key=n,c.value=t,c.segment=o}}else{const i=c.left??c.right;if(h.length>0){const[n,t]=h[h.length-1];switch(n){case w.Left:t.left=i;break;case w.Mid:t.mid=i;break;case w.Right:t.right=i;break}}else this.c=i}for(let i=h.length-1;i>=0;i--){const n=h[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),h[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),h[i][1]=n.rotateRight()),i>0)switch(h[i-1][0]){case w.Left:h[i-1][1].left=h[i][1];break;case w.Right:h[i-1][1].right=h[i][1];break;case w.Mid:h[i-1][1].mid=h[i][1];break}else this.c=h[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const r=this.b.reset($);let a=this.c,h;for(;a;){const c=r.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(r.hasNext())r.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr($){return this.g($,!1)}g($,r){const a=this.b.reset($);let h=this.c;for(;h;){const c=a.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(a.hasNext())a.next(),h=h.mid;else return h.mid?this.h(h.mid):r?h.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[r,a]of this)$(a,r)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const r=[];return this.j($,r),r[Symbol.iterator]()}j($,r){$&&($.left&&this.j($.left,r),$.value&&r.push([$.key,$.value]),$.mid&&this.j($.mid,r),$.right&&this.j($.right,r))}_isBalanced(){const $=r=>{if(!r)return!0;const a=r.balanceFactor();return a<-1||a>1?!1:$(r.left)&&$(r.right)};return $(this.c)}}e.$Qi=u}),define(Re[33],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=void 0,e.$6g=D;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(P){return v.test(P)}e.$7g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(T){for(let m=0;m<T.length;m++)T[m]=Math.floor(Math.random()*256);return T};const L=new Uint8Array(16),R=[];for(let T=0;T<256;T++)R.push(T.toString(16).padStart(2,"0"));return function(){P(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let m=0,s="";return s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+="-",s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s+=R[L[m++]],s}}()}),define(Re[150],Oe([1,0,17,41,33]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bu=e.$zu=void 0,e.$xu=L,e.$yu=R,e.$Au=s;function L(w){return{asString:async()=>w,asFile:()=>{},value:typeof w=="string"?w:void 0}}function R(w,u,k){const $={id:(0,P.$7g)(),name:w,uri:u,data:k};return{asString:async()=>"",asFile:()=>$,value:void 0}}class T{constructor(){this.a=new Map}get size(){let u=0;for(const k of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const k=[...this.a.keys()];return D.Iterable.some(this,([$,r])=>r.asFile())&&k.push("files"),I(m(u),k)}get(u){return this.a.get(this.b(u))?.[0]}append(u,k){const $=this.a.get(u);$?$.push(k):this.a.set(this.b(u),[k])}replace(u,k){this.a.set(this.b(u),[k])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,k]of this.a)for(const $ of k)yield[u,$]}b(u){return m(u)}}e.$zu=T;function m(w){return w.toLowerCase()}function s(w,u){return I(m(w),u.map(m))}function I(w,u){if(w==="*/*")return u.length>0;if(u.includes(w))return!0;const k=w.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[$,r,a]=k;return a==="*"?u.some(h=>h.startsWith(r+"/")):!1}e.$Bu=Object.freeze({create:w=>(0,v.$Qb)(w.map(u=>u.toString())).join(`\r
`),split:w=>w.split(`\r
`),parse:w=>e.$Bu.split(w).filter(u=>!u.startsWith("#"))})}),define(Re[151],Oe([1,0,30]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Hu=P;var D;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function P(L){let R=0,T=0,m=0,s=D.Unknown;for(let I=0,w=L.length;I<w;I++){const u=L.charCodeAt(I);u===v.CharCode.CarriageReturn?(R===0&&(T=I),R++,I+1<w&&L.charCodeAt(I+1)===v.CharCode.LineFeed?(s|=D.CRLF,I++):s|=D.Invalid,m=I+1):u===v.CharCode.LineFeed&&(s|=D.LF,R===0&&(T=I),R++,m=I+1)}return R===0&&(T=L.length),[R,T,L.length-m,s]}}),define(Re[152],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0,e.$tt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[153],Oe([1,0,30,154]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7u=e.$6u=e.IndentAction=void 0;var P;(function(m){m[m.None=0]="None",m[m.Indent=1]="Indent",m[m.IndentOutdent=2]="IndentOutdent",m[m.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class L{constructor(s){if(this.e=null,this.f=!1,this.open=s.open,this.close=s.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(s.notIn))for(let I=0,w=s.notIn.length;I<w;I++)switch(s.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(s){switch(s){case D.StandardTokenType.Other:return!0;case D.StandardTokenType.Comment:return this.c;case D.StandardTokenType.String:return this.b;case D.StandardTokenType.RegEx:return this.d}}shouldAutoClose(s,I){if(s.getTokenCount()===0)return!0;const w=s.findTokenIndexAtOffset(I-2),u=s.getStandardTokenType(w);return this.isOK(u)}g(s,I){for(let w=s;w<=I;w++){const u=String.fromCharCode(w);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$6u=L;class R{constructor(s){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of s)T(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),T(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),T(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),T(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&T(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$7u=R;function T(m,s,I){m.has(s)?m.get(s).push(I):m.set(s,[I])}}),define(Re[155],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oD=e.NodeColor=e.$nD=void 0,e.$pD=P,e.$qD=L,e.$rD=s,e.$sD=I,e.$tD=w,e.$uD=u,e.$vD=k,e.$wD=$;class v{constructor(a,h){this.piece=a,this.color=h,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$oD)return P(this.right);let a=this;for(;a.parent!==e.$oD&&a.parent.left!==a;)a=a.parent;return a.parent===e.$oD?e.$oD:a.parent}prev(){if(this.left!==e.$oD)return L(this.left);let a=this;for(;a.parent!==e.$oD&&a.parent.right!==a;)a=a.parent;return a.parent===e.$oD?e.$oD:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$nD=v;var D;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(D||(e.NodeColor=D={})),e.$oD=new v(null,D.Black),e.$oD.parent=e.$oD,e.$oD.left=e.$oD,e.$oD.right=e.$oD,e.$oD.color=D.Black;function P(r){for(;r.left!==e.$oD;)r=r.left;return r}function L(r){for(;r.right!==e.$oD;)r=r.right;return r}function R(r){return r===e.$oD?0:r.size_left+r.piece.length+R(r.right)}function T(r){return r===e.$oD?0:r.lf_left+r.piece.lineFeedCnt+T(r.right)}function m(){e.$oD.parent=e.$oD}function s(r,a){const h=a.right;h.size_left+=a.size_left+(a.piece?a.piece.length:0),h.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=h.left,h.left!==e.$oD&&(h.left.parent=a),h.parent=a.parent,a.parent===e.$oD?r.root=h:a.parent.left===a?a.parent.left=h:a.parent.right=h,h.left=a,a.parent=h}function I(r,a){const h=a.left;a.left=h.right,h.right!==e.$oD&&(h.right.parent=a),h.parent=a.parent,a.size_left-=h.size_left+(h.piece?h.piece.length:0),a.lf_left-=h.lf_left+(h.piece?h.piece.lineFeedCnt:0),a.parent===e.$oD?r.root=h:a===a.parent.right?a.parent.right=h:a.parent.left=h,h.right=a,a.parent=h}function w(r,a){let h,c;if(a.left===e.$oD?(c=a,h=c.right):a.right===e.$oD?(c=a,h=c.left):(c=P(a.right),h=c.right),c===r.root){r.root=h,h.color=D.Black,a.detach(),m(),r.root.parent=e.$oD;return}const i=c.color===D.Red;if(c===c.parent.left?c.parent.left=h:c.parent.right=h,c===a?(h.parent=c.parent,$(r,h)):(c.parent===a?h.parent=c:h.parent=c.parent,$(r,h),c.left=a.left,c.right=a.right,c.parent=a.parent,c.color=a.color,a===r.root?r.root=c:a===a.parent.left?a.parent.left=c:a.parent.right=c,c.left!==e.$oD&&(c.left.parent=c),c.right!==e.$oD&&(c.right.parent=c),c.size_left=a.size_left,c.lf_left=a.lf_left,$(r,c)),a.detach(),h.parent.left===h){const t=R(h),o=T(h);if(t!==h.parent.size_left||o!==h.parent.lf_left){const l=t-h.parent.size_left,g=o-h.parent.lf_left;h.parent.size_left=t,h.parent.lf_left=o,k(r,h.parent,l,g)}}if($(r,h.parent),i){m();return}let n;for(;h!==r.root&&h.color===D.Black;)h===h.parent.left?(n=h.parent.right,n.color===D.Red&&(n.color=D.Black,h.parent.color=D.Red,s(r,h.parent),n=h.parent.right),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,h=h.parent):(n.right.color===D.Black&&(n.left.color=D.Black,n.color=D.Red,I(r,n),n=h.parent.right),n.color=h.parent.color,h.parent.color=D.Black,n.right.color=D.Black,s(r,h.parent),h=r.root)):(n=h.parent.left,n.color===D.Red&&(n.color=D.Black,h.parent.color=D.Red,I(r,h.parent),n=h.parent.left),n.left.color===D.Black&&n.right.color===D.Black?(n.color=D.Red,h=h.parent):(n.left.color===D.Black&&(n.right.color=D.Black,n.color=D.Red,s(r,n),n=h.parent.left),n.color=h.parent.color,h.parent.color=D.Black,n.left.color=D.Black,I(r,h.parent),h=r.root));h.color=D.Black,m()}function u(r,a){for($(r,a);a!==r.root&&a.parent.color===D.Red;)if(a.parent===a.parent.parent.left){const h=a.parent.parent.right;h.color===D.Red?(a.parent.color=D.Black,h.color=D.Black,a.parent.parent.color=D.Red,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,s(r,a)),a.parent.color=D.Black,a.parent.parent.color=D.Red,I(r,a.parent.parent))}else{const h=a.parent.parent.left;h.color===D.Red?(a.parent.color=D.Black,h.color=D.Black,a.parent.parent.color=D.Red,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,I(r,a)),a.parent.color=D.Black,a.parent.parent.color=D.Red,s(r,a.parent.parent))}r.root.color=D.Black}function k(r,a,h,c){for(;a!==r.root&&a!==e.$oD;)a.parent.left===a&&(a.parent.size_left+=h,a.parent.lf_left+=c),a=a.parent}function $(r,a){let h=0,c=0;if(a!==r.root){for(;a!==r.root&&a===a.parent.right;)a=a.parent;if(a!==r.root)for(a=a.parent,h=R(a.left)-a.size_left,c=T(a.left)-a.lf_left,a.size_left+=h,a.lf_left+=c;a!==r.root&&(h!==0||c!==0);)a.parent.left===a&&(a.parent.size_left+=h,a.parent.lf_left+=c),a=a.parent}}}),define(Re[100],Oe([1,0,30,101,32,52,155,102]),function(we,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HD=e.$GD=e.$FD=void 0,e.$DD=w,e.$ED=u;const m=65535;function s(c){let i;return c[c.length-1]<65536?i=new Uint16Array(c.length):i=new Uint32Array(c.length),i.set(c,0),i}class I{constructor(i,n,t,o,l){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=o,this.isBasicASCII=l}}function w(c,i=!0){const n=[0];let t=1;for(let o=0,l=c.length;o<l;o++){const g=c.charCodeAt(o);g===v.CharCode.CarriageReturn?o+1<l&&c.charCodeAt(o+1)===v.CharCode.LineFeed?(n[t++]=o+2,o++):n[t++]=o+1:g===v.CharCode.LineFeed&&(n[t++]=o+1)}return i?s(n):n}function u(c,i){c.length=0,c[0]=0;let n=1,t=0,o=0,l=0,g=!0;for(let d=0,S=i.length;d<S;d++){const E=i.charCodeAt(d);E===v.CharCode.CarriageReturn?d+1<S&&i.charCodeAt(d+1)===v.CharCode.LineFeed?(l++,c[n++]=d+2,d++):(t++,c[n++]=d+1):E===v.CharCode.LineFeed?(o++,c[n++]=d+1):g&&E!==v.CharCode.Tab&&(E<32||E>126)&&(g=!1)}const f=new I(s(c),t,o,l,g);return c.length=0,f}class k{constructor(i,n,t,o,l){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=o,this.length=l}}e.$FD=k;class ${constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$GD=$;class r{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==R.$oD&&i.iterate(i.root,t=>(t!==R.$oD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const t=this.b;for(let o=0;o<t.length;o++){const l=t[o];if(l.node.parent===null||l.nodeStartOffset>=i){t[o]=null,n=!0;continue}}if(n){const o=[];for(const l of t)l!==null&&o.push(l);this.b=o}}}class h{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this.a=[new $("",[0])],this.g={line:0,column:0},this.root=R.$oD,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=t;let o=null;for(let l=0,g=i.length;l<g;l++)if(i[l].buffer.length>0){i[l].lineStarts||(i[l].lineStarts=w(i[l].buffer));const f=new k(l+1,{line:0,column:0},{line:i[l].lineStarts.length-1,column:i[l].buffer.length-i[l].lineStarts[i[l].lineStarts.length-1]},i[l].lineStarts.length-1,i[l].buffer.length);this.a.push(i[l]),o=this.S(o,f)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=m,t=n-Math.floor(n/3),o=t*2;let l="",g=0;const f=[];if(this.iterate(this.root,d=>{const S=this.R(d),E=S.length;if(g<=t||g+E<o)return l+=S,g+=E,!0;const y=l.replace(/\r\n|\r|\n/g,i);return f.push(new $(y,w(y))),l=S,g=E,!0}),g>0){const d=l.replace(/\r\n|\r|\n/g,i);f.push(new $(d,w(d)))}this.create(f,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,o=>{if(o===R.$oD)return!0;const l=this.R(o),g=l.length,f=i.G(n),d=i.G(n+g),S=i.getValueInRange2(f,d);return n+=g,l===S})}getOffsetAt(i,n){let t=0,o=this.root;for(;o!==R.$oD;)if(o.left!==R.$oD&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){t+=o.size_left;const l=this.B(o,i-o.lf_left-2);return t+=l+n-1}else i-=o.lf_left+o.piece.lineFeedCnt,t+=o.size_left+o.piece.length,o=o.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const o=i;for(;n!==R.$oD;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const l=this.A(n,i-n.size_left);if(t+=n.lf_left+l.index,l.index===0){const g=this.getOffsetAt(t+1,1),f=o-g;return new D.$Vt(t+1,f+1)}return new D.$Vt(t+1,l.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===R.$oD){const l=this.getOffsetAt(t+1,1),g=o-i-l;return new D.$Vt(t+1,g+1)}else n=n.right;return new D.$Vt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),l=this.getValueInRange2(t,o);return n?n!==this.d||!this.f?l.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?l:l.replace(/\r\n|\r|\n/g,n):l}getValueInRange2(i,n){if(i.node===n.node){const f=i.node,d=this.a[f.piece.bufferIndex].buffer,S=this.u(f.piece.bufferIndex,f.piece.start);return d.substring(S+i.remainder,S+n.remainder)}let t=i.node;const o=this.a[t.piece.bufferIndex].buffer,l=this.u(t.piece.bufferIndex,t.piece.start);let g=o.substring(l+i.remainder,l+t.piece.length);for(t=t.next();t!==R.$oD;){const f=this.a[t.piece.bufferIndex].buffer,d=this.u(t.piece.bufferIndex,t.piece.start);if(t===n.node){g+=f.substring(d,d+n.remainder);break}else g+=f.substr(d,t.piece.length);t=t.next()}return g}getLinesContent(){const i=[];let n=0,t="",o=!1;return this.iterate(this.root,l=>{if(l===R.$oD)return!0;const g=l.piece;let f=g.length;if(f===0)return!0;const d=this.a[g.bufferIndex].buffer,S=this.a[g.bufferIndex].lineStarts,E=g.start.line,y=g.end.line;let C=S[E]+g.start.column;if(o&&(d.charCodeAt(C)===v.CharCode.LineFeed&&(C++,f--),i[n++]=t,t="",o=!1,f===0))return!0;if(E===y)return!this.f&&d.charCodeAt(C+f-1)===v.CharCode.CarriageReturn?(o=!0,t+=d.substr(C,f-1)):t+=d.substr(C,f),!0;t+=this.f?d.substring(C,Math.max(C,S[E+1]-this.e)):d.substring(C,S[E+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let O=E+1;O<y;O++)t=this.f?d.substring(S[O],S[O+1]-this.e):d.substring(S[O],S[O+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this.f&&d.charCodeAt(S[y]+g.end.column-1)===v.CharCode.CarriageReturn?(o=!0,g.end.column===0?n--:t=d.substr(S[y],g.end.column-1)):t=d.substr(S[y],g.end.column),!0}),o&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(o)}else{const n=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(o)}}getLineCharCode(i,n){const t=this.H(i,n+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}getNearestChunk(i){const n=this.G(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===R.$oD)return"";const o=this.a[t.piece.bufferIndex],l=this.u(t.piece.bufferIndex,t.piece.start);return o.buffer.substring(l,l+t.piece.length)}else{const t=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start),l=o+n.remainder,g=o+n.node.piece.length;return t.buffer.substring(l,g)}}findMatchesInNode(i,n,t,o,l,g,f,d,S,E,y){const C=this.a[i.piece.bufferIndex],O=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,l),b=this.u(i.piece.bufferIndex,g);let M;const A={line:0,column:0};let F,G;n._wordSeparators?(F=C.buffer.substring(p,b),G=x=>x+p,n.reset(0)):(F=C.buffer,G=x=>x,n.reset(p));do if(M=n.next(F),M){if(G(M.index)>=b)return E;this.s(i,G(M.index)-O,A);const x=this.t(i.piece.bufferIndex,l,A),j=A.line===l.line?A.column-l.column+o:A.column+1,U=j+M[0].length;if(y[E++]=(0,T.$zD)(new P.$Wt(t+x,j,t+x,U),M,d),G(M.index)+M[0].length>=b||E>=S)return E}while(M);return E}findMatchesLineByLine(i,n,t,o){const l=[];let g=0;const f=new T.$CD(n.wordSeparators,n.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const S=this.H(i.endLineNumber,i.endColumn);if(S===null)return[];let E=this.s(d.node,d.remainder);const y=this.s(S.node,S.remainder);if(d.node===S.node)return this.findMatchesInNode(d.node,f,i.startLineNumber,i.startColumn,E,y,n,t,o,g,l),l;let C=i.startLineNumber,O=d.node;for(;O!==S.node;){const b=this.t(O.piece.bufferIndex,E,O.piece.end);if(b>=1){const A=this.a[O.piece.bufferIndex].lineStarts,F=this.u(O.piece.bufferIndex,O.piece.start),G=A[E.line+b],x=C===i.startLineNumber?i.startColumn:1;if(g=this.findMatchesInNode(O,f,C,x,E,this.s(O,G-F),n,t,o,g,l),g>=o)return l;C+=b}const M=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const A=this.getLineContent(C).substring(M,i.endColumn-1);return g=this.n(n,f,A,i.endLineNumber,M,g,l,t,o),l}if(g=this.n(n,f,this.getLineContent(C).substr(M),C,M,g,l,t,o),g>=o)return l;C++,d=this.H(C,1),O=d.node,E=this.s(d.node,d.remainder)}if(C===i.endLineNumber){const b=C===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(C).substring(b,i.endColumn-1);return g=this.n(n,f,M,i.endLineNumber,b,g,l,t,o),l}const p=C===i.startLineNumber?i.startColumn:1;return g=this.findMatchesInNode(S.node,f,C,p,E,y,n,t,o,g,l),l}n(i,n,t,o,l,g,f,d,S){const E=i.wordSeparators;if(!d&&i.simpleSearch){const C=i.simpleSearch,O=C.length,p=t.length;let b=-O;for(;(b=t.indexOf(C,b+O))!==-1;)if((!E||(0,T.$BD)(E,t,p,b,O))&&(f[g++]=new L.$nw(new P.$Wt(o,b+1+l,o,b+1+O+l),null),g>=S))return g;return g}let y;n.reset(0);do if(y=n.next(t),y&&(f[g++]=(0,T.$zD)(new P.$Wt(o,y.index+1+l,o,y.index+1+y[0].length+l),y,d),g>=S))return g;while(y);return g}insert(i,n,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==R.$oD){const{node:o,remainder:l,nodeStartOffset:g}=this.G(i),f=o.piece,d=f.bufferIndex,S=this.s(o,l);if(o.piece.bufferIndex===0&&f.end.line===this.g.line&&f.end.column===this.g.column&&g+f.length===i&&n.length<m){this.F(o,n),this.y();return}if(g===i)this.o(n,o),this.h.validate(i);else if(g+o.piece.length>i){const E=[];let y=new k(f.bufferIndex,S,f.end,this.t(f.bufferIndex,S,f.end),this.u(d,f.end)-this.u(d,S));if(this.K()&&this.M(n)&&this.I(o,l)===10){const b={line:y.start.line+1,column:0};y=new k(y.bufferIndex,b,y.end,this.t(y.bufferIndex,b,y.end),y.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(o,l-1)===13){const b=this.s(o,l-1);this.C(o,b),n="\r"+n,o.piece.length===0&&E.push(o)}else this.C(o,S);else this.C(o,S);const C=this.w(n);y.length>0&&this.S(o,y);let O=o;for(let p=0;p<C.length;p++)O=this.S(O,C[p]);this.v(E)}else this.q(n,o)}else{const o=this.w(n);let l=this.T(null,o[0]);for(let g=1;g<o.length;g++)l=this.S(l,o[g])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===R.$oD)return;const t=this.G(i),o=this.G(i+n),l=t.node,g=o.node;if(l===g){const C=this.s(l,t.remainder),O=this.s(l,o.remainder);if(t.nodeStartOffset===i){if(n===l.piece.length){const p=l.next();(0,R.$tD)(this,l),this.N(p),this.y();return}this.D(l,O),this.h.validate(i),this.N(l),this.y();return}if(t.nodeStartOffset+l.piece.length===i+n){this.C(l,C),this.O(l),this.y();return}this.E(l,C,O),this.y();return}const f=[],d=this.s(l,t.remainder);this.C(l,d),this.h.validate(i),l.piece.length===0&&f.push(l);const S=this.s(g,o.remainder);this.D(g,S),g.piece.length===0&&f.push(g);const E=l.next();for(let C=E;C!==R.$oD&&C!==g;C=C.next())f.push(C);const y=l.piece.length===0?l.prev():l;this.v(f),this.O(y),this.y()}o(i,n){const t=[];if(this.K()&&this.M(i)&&this.L(n)){const g=n.piece,f={line:g.start.line+1,column:0},d=new k(g.bufferIndex,f,g.end,this.t(g.bufferIndex,f,g.end),g.length-1);n.piece=d,i+=`
`,(0,R.$vD)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const o=this.w(i);let l=this.T(n,o[o.length-1]);for(let g=o.length-2;g>=0;g--)l=this.T(l,o[g]);this.N(l),this.v(t)}q(i,n){this.Q(i,n)&&(i+=`
`);const t=this.w(i),o=this.S(n,t[0]);let l=o;for(let g=1;g<t.length;g++)l=this.S(l,t[g]);this.N(o)}s(i,n,t){const o=i.piece,l=i.piece.bufferIndex,g=this.a[l].lineStarts,d=g[o.start.line]+o.start.column+n;let S=o.start.line,E=o.end.line,y=0,C=0,O=0;for(;S<=E&&(y=S+(E-S)/2|0,O=g[y],y!==E);)if(C=g[y+1],d<O)E=y-1;else if(d>=C)S=y+1;else break;return t?(t.line=y,t.column=d-O,null):{line:y,column:d-O}}t(i,n,t){if(t.column===0)return t.line-n.line;const o=this.a[i].lineStarts;if(t.line===o.length-1)return t.line-n.line;const l=o[t.line+1],g=o[t.line]+t.column;if(l>g+1)return t.line-n.line;const f=g-1;return this.a[i].buffer.charCodeAt(f)===13?t.line-n.line+1:t.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,R.$tD)(this,i[n])}w(i){if(i.length>m){const E=[];for(;i.length>m;){const C=i.charCodeAt(m-1);let O;C===v.CharCode.CarriageReturn||C>=55296&&C<=56319?(O=i.substring(0,m-1),i=i.substring(m-1)):(O=i.substring(0,m),i=i.substring(m));const p=w(O);E.push(new k(this.a.length,{line:0,column:0},{line:p.length-1,column:O.length-p[p.length-1]},p.length-1,O.length)),this.a.push(new $(O,p))}const y=w(i);return E.push(new k(this.a.length,{line:0,column:0},{line:y.length-1,column:i.length-y[y.length-1]},y.length-1,i.length)),this.a.push(new $(i,y)),E}let n=this.a[0].buffer.length;const t=w(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let E=0;E<t.length;E++)t[E]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let E=0;E<t.length;E++)t[E]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const l=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,f=l-this.a[0].lineStarts[g],d={line:g,column:f},S=new k(0,o,d,this.t(0,o,d),l-n);return this.g=d,[S]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let t=this.root,o="";const l=this.h.get2(i);if(l){t=l.node;const g=this.B(t,i-l.nodeStartLineNumber-1),f=this.a[t.piece.bufferIndex].buffer,d=this.u(t.piece.bufferIndex,t.piece.start);if(l.nodeStartLineNumber+t.piece.lineFeedCnt===i)o=f.substring(d+g,d+t.piece.length);else{const S=this.B(t,i-l.nodeStartLineNumber);return f.substring(d+g,d+S-n)}}else{let g=0;const f=i;for(;t!==R.$oD;)if(t.left!==R.$oD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const d=this.B(t,i-t.lf_left-2),S=this.B(t,i-t.lf_left-1),E=this.a[t.piece.bufferIndex].buffer,y=this.u(t.piece.bufferIndex,t.piece.start);return g+=t.size_left,this.h.set({node:t,nodeStartOffset:g,nodeStartLineNumber:f-(i-1-t.lf_left)}),E.substring(y+d,y+S-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const d=this.B(t,i-t.lf_left-2),S=this.a[t.piece.bufferIndex].buffer,E=this.u(t.piece.bufferIndex,t.piece.start);o=S.substring(E+d,E+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==R.$oD;){const g=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const f=this.B(t,0),d=this.u(t.piece.bufferIndex,t.piece.start);return o+=g.substring(d,d+f-n),o}else{const f=this.u(t.piece.bufferIndex,t.piece.start);o+=g.substr(f,t.piece.length)}t=t.next()}return o}y(){let i=this.root,n=1,t=0;for(;i!==R.$oD;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=t,this.h.validate(this.c)}A(i,n){const t=i.piece,o=this.s(i,n),l=o.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===n){const g=this.t(i.piece.bufferIndex,t.start,o);if(g!==l)return{index:g,remainder:0}}return{index:l,remainder:o.column}}B(i,n){if(n<0)return 0;const t=i.piece,o=this.a[t.bufferIndex].lineStarts,l=t.start.line+n+1;return l>t.end.line?o[t.end.line]+t.end.column-o[t.start.line]-t.start.column:o[l]-o[t.start.line]-t.start.column}C(i,n){const t=i.piece,o=t.lineFeedCnt,l=this.u(t.bufferIndex,t.end),g=n,f=this.u(t.bufferIndex,g),d=this.t(t.bufferIndex,t.start,g),S=d-o,E=f-l,y=t.length+E;i.piece=new k(t.bufferIndex,t.start,g,d,y),(0,R.$vD)(this,i,E,S)}D(i,n){const t=i.piece,o=t.lineFeedCnt,l=this.u(t.bufferIndex,t.start),g=n,f=this.t(t.bufferIndex,g,t.end),d=this.u(t.bufferIndex,g),S=f-o,E=l-d,y=t.length+E;i.piece=new k(t.bufferIndex,g,t.end,f,y),(0,R.$vD)(this,i,E,S)}E(i,n,t){const o=i.piece,l=o.start,g=o.end,f=o.length,d=o.lineFeedCnt,S=n,E=this.t(o.bufferIndex,o.start,S),y=this.u(o.bufferIndex,n)-this.u(o.bufferIndex,l);i.piece=new k(o.bufferIndex,o.start,S,E,y),(0,R.$vD)(this,i,y-f,E-d);const C=new k(o.bufferIndex,t,g,this.t(o.bufferIndex,t,g),this.u(o.bufferIndex,g)-this.u(o.bufferIndex,t)),O=this.S(i,C);this.N(O)}F(i,n){this.Q(n,i)&&(n+=`
`);const t=this.K()&&this.L(n)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=n;const l=w(n,!1);for(let O=0;O<l.length;O++)l[O]+=o;if(t){const O=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-O}}this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1));const g=this.a[0].lineStarts.length-1,f=this.a[0].buffer.length-this.a[0].lineStarts[g],d={line:g,column:f},S=i.piece.length+n.length,E=i.piece.lineFeedCnt,y=this.t(0,i.piece.start,d),C=y-E;i.piece=new k(i.piece.bufferIndex,i.piece.start,d,y,S),this.g=d,(0,R.$vD)(this,i,n.length,C)}G(i){let n=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let o=0;for(;n!==R.$oD;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){o+=n.size_left;const l={node:n,remainder:i-n.size_left,nodeStartOffset:o};return this.h.set(l),l}else i-=n.size_left+n.piece.length,o+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let t=this.root,o=0;for(;t!==R.$oD;)if(t.left!==R.$oD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const l=this.B(t,i-t.lf_left-2),g=this.B(t,i-t.lf_left-1);return o+=t.size_left,{node:t,remainder:Math.min(l+n-1,g),nodeStartOffset:o}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const l=this.B(t,i-t.lf_left-2);if(l+n-1<=t.piece.length)return{node:t,remainder:l+n-1,nodeStartOffset:o};n-=t.piece.length-l;break}else i-=t.lf_left+t.piece.lineFeedCnt,o+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==R.$oD;){if(t.piece.lineFeedCnt>0){const l=this.B(t,0),g=this.J(t);return{node:t,remainder:Math.min(n-1,l),nodeStartOffset:g}}else if(t.piece.length>=n-1){const l=this.J(t);return{node:t,remainder:n-1,nodeStartOffset:l}}else n-=t.piece.length;t=t.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(o)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$oD||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,o=n.start.line,l=t[o]+n.start.column;return o===t.length-1||t[o+1]>l+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(l)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$oD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const t=[],o=this.a[i.piece.bufferIndex].lineStarts;let l;i.piece.end.column===0?l={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:l={line:i.piece.end.line,column:i.piece.end.column-1};const g=i.piece.length-1,f=i.piece.lineFeedCnt-1;i.piece=new k(i.piece.bufferIndex,i.piece.start,l,f,g),(0,R.$vD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const d={line:n.piece.start.line+1,column:0},S=n.piece.length-1,E=this.t(n.piece.bufferIndex,d,n.piece.end);n.piece=new k(n.piece.bufferIndex,d,n.piece.end,E,S),(0,R.$vD)(this,n,-1,-1),n.piece.length===0&&t.push(n);const y=this.w(`\r
`);this.S(i,y[0]);for(let C=0;C<t.length;C++)(0,R.$tD)(this,t[C])}Q(i,n){if(this.K()&&this.M(i)){const t=n.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,R.$tD)(this,t);else{const o=t.piece,l={line:o.start.line+1,column:0},g=o.length-1,f=this.t(o.bufferIndex,l,o.end);t.piece=new k(o.bufferIndex,l,o.end,f,g),(0,R.$vD)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===R.$oD)return n(R.$oD);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}R(i){if(i===R.$oD)return"";const n=this.a[i.piece.bufferIndex],t=i.piece,o=this.u(t.bufferIndex,t.start),l=this.u(t.bufferIndex,t.end);return n.buffer.substring(o,l)}getPieceContent(i){const n=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return n.buffer.substring(t,o)}S(i,n){const t=new R.$nD(n,R.NodeColor.Red);if(t.left=R.$oD,t.right=R.$oD,t.parent=R.$oD,t.size_left=0,t.lf_left=0,this.root===R.$oD)this.root=t,t.color=R.NodeColor.Black;else if(i.right===R.$oD)i.right=t,t.parent=i;else{const l=(0,R.$pD)(i.right);l.left=t,t.parent=l}return(0,R.$uD)(this,t),t}T(i,n){const t=new R.$nD(n,R.NodeColor.Red);if(t.left=R.$oD,t.right=R.$oD,t.parent=R.$oD,t.size_left=0,t.lf_left=0,this.root===R.$oD)this.root=t,t.color=R.NodeColor.Black;else if(i.left===R.$oD)i.left=t,t.parent=i;else{const o=(0,R.$qD)(i.left);o.right=t,t.parent=o}return(0,R.$uD)(this,t),t}U(i){let n="";return this.iterate(i,t=>(n+=this.R(t),!0)),n}}e.$HD=h}),define(Re[156],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mab=e.$lab=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$lab=v;class D{constructor(L){this.identifier=L}}e.$mab=D}),define(Re[157],Oe([1,0,6,4,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0,e.$uj=I,P=Ve(P);class L extends D.$Zc{constructor(u,k="",$="",r=!0,a){super(),this.j=this.B(new v.$qe),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=k,this.w=$,this.z=r,this.D=a}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,k){this.D&&await this.D(u)}}e.$pj=L;class R extends D.$Zc{constructor(){super(...arguments),this.f=this.B(new v.$qe),this.onWillRun=this.f.event,this.m=this.B(new v.$qe),this.onDidRun=this.m.event}async run(u,k){if(!u.enabled)return;this.f.fire({action:u});let $;try{await this.u(u,k)}catch(r){$=r}this.m.fire({action:u,error:$})}async u(u,k){await u.run(k)}}e.$qj=R;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let k=[];for(const $ of u)$.length&&(k.length?k=[...k,new T,...$]:k=$);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$rj=T;class m{get actions(){return this.a}constructor(u,k,$,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=k,this.class=r,this.a=$}async run(){}}e.$sj=m;class s extends L{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,P.localize(41,null),void 0,!1)}}e.$tj=s;function I(w){return{id:w.id,label:w.label,tooltip:w.tooltip??w.label,class:w.class,enabled:w.enabled??!0,checked:w.checked,run:async(...u)=>w.run(...u)}}}),define(Re[158],Oe([1,0,9]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=s,e.$8m=I,e.$9m=w,e.$0m=u;const D=60,P=D*60,L=P*24,R=L*7,T=L*30,m=L*365;function s(k,$,r,a){typeof k!="number"&&(k=k.getTime());const h=Math.round((new Date().getTime()-k)/1e3);if(h<-30)return(0,v.localize)(42,null,s(new Date().getTime()+h*1e3,!1));if(!a&&h<30)return(0,v.localize)(43,null);let c;return h<D?(c=h,$?c===1?r?(0,v.localize)(44,null,c):(0,v.localize)(45,null,c):r?(0,v.localize)(46,null,c):(0,v.localize)(47,null,c):c===1?r?(0,v.localize)(48,null,c):(0,v.localize)(49,null,c):r?(0,v.localize)(50,null,c):(0,v.localize)(51,null,c)):h<P?(c=Math.floor(h/D),$?c===1?r?(0,v.localize)(52,null,c):(0,v.localize)(53,null,c):r?(0,v.localize)(54,null,c):(0,v.localize)(55,null,c):c===1?r?(0,v.localize)(56,null,c):(0,v.localize)(57,null,c):r?(0,v.localize)(58,null,c):(0,v.localize)(59,null,c)):h<L?(c=Math.floor(h/P),$?c===1?r?(0,v.localize)(60,null,c):(0,v.localize)(61,null,c):r?(0,v.localize)(62,null,c):(0,v.localize)(63,null,c):c===1?r?(0,v.localize)(64,null,c):(0,v.localize)(65,null,c):r?(0,v.localize)(66,null,c):(0,v.localize)(67,null,c)):h<R?(c=Math.floor(h/L),$?c===1?(0,v.localize)(68,null,c):(0,v.localize)(69,null,c):c===1?(0,v.localize)(70,null,c):(0,v.localize)(71,null,c)):h<T?(c=Math.floor(h/R),$?c===1?r?(0,v.localize)(72,null,c):(0,v.localize)(73,null,c):r?(0,v.localize)(74,null,c):(0,v.localize)(75,null,c):c===1?r?(0,v.localize)(76,null,c):(0,v.localize)(77,null,c):r?(0,v.localize)(78,null,c):(0,v.localize)(79,null,c)):h<m?(c=Math.floor(h/T),$?c===1?r?(0,v.localize)(80,null,c):(0,v.localize)(81,null,c):r?(0,v.localize)(82,null,c):(0,v.localize)(83,null,c):c===1?r?(0,v.localize)(84,null,c):(0,v.localize)(85,null,c):r?(0,v.localize)(86,null,c):(0,v.localize)(87,null,c)):(c=Math.floor(h/m),$?c===1?r?(0,v.localize)(88,null,c):(0,v.localize)(89,null,c):r?(0,v.localize)(90,null,c):(0,v.localize)(91,null,c):c===1?r?(0,v.localize)(92,null,c):(0,v.localize)(93,null,c):r?(0,v.localize)(94,null,c):(0,v.localize)(95,null,c))}function I(k,$,r){typeof k!="number"&&(k=k.getTime());const a=new Date;a.setHours(0,0,0,0);const h=new Date(a.getTime());return h.setDate(h.getDate()-1),k>a.getTime()?(0,v.localize)(96,null):k>h.getTime()?(0,v.localize)(97,null):s(k,$,r)}function w(k,$){const r=Math.abs(k/1e3);return r<1?$?(0,v.localize)(98,null,k):(0,v.localize)(99,null,k):r<D?$?(0,v.localize)(100,null,Math.round(k)/1e3):(0,v.localize)(101,null,Math.round(k)/1e3):r<P?$?(0,v.localize)(102,null,Math.round(k/(1e3*D))):(0,v.localize)(103,null,Math.round(k/(1e3*D))):r<L?$?(0,v.localize)(104,null,Math.round(k/(1e3*P))):(0,v.localize)(105,null,Math.round(k/(1e3*P))):(0,v.localize)(106,null,Math.round(k/(1e3*L)))}function u(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[42],Oe([1,0,17,14,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=m,e.$wj=s,e.$xj=I,v=Ve(v),D=Ve(D),P=Ve(P);function L(w,u){return u&&(w.stack||w.stacktrace)?P.localize(107,null,T(w),R(w.stack)||R(w.stacktrace)):T(w)}function R(w){return Array.isArray(w)?w.join(`
`):w}function T(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?P.localize(108,null,w.message):w.message||P.localize(109,null)}function m(w=null,u=!1){if(!w)return P.localize(110,null);if(Array.isArray(w)){const k=v.$Lb(w),$=m(k[0],u);return k.length>1?P.localize(111,null,$,k.length):$}if(D.$jg(w))return w;if(w.detail){const k=w.detail;if(k.error)return L(k.error,u);if(k.exception)return L(k.exception,u)}return w.stack?L(w,u):w.message?w.message:P.localize(112,null)}function s(w){const u=w;return u instanceof Error&&Array.isArray(u.actions)}function I(w,u){let k;return typeof w=="string"?k=new Error(w):k=w,k.actions=u,k}}),define(Re[159],Oe([1,0,51,22]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=T,e.$Jr=m,e.$Kr=s,e.$Lr=I,e.$Mr=w,e.$Nr=u,e.$Or=k,e.$Pr=$,e.$Qr=r,e.$Rr=a,e.$Sr=d,e.$Tr=S,e.$Ur=E;const P=new v.$Y(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),L=new v.$Y(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new v.$Y(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(y,C,O=!1){const p=y||"",b=C||"",M=P.value.collator.compare(p,b);return P.value.collatorIsNumeric&&M===0&&p!==b?p<b?-1:1:M}function m(y,C){const O=L.value.collator;return y=y||"",C=C||"",n(O,y,C)}function s(y,C){const O=L.value.collator;return y=y||"",C=C||"",g(y,C)||n(O,y,C)}function I(y,C){const O=L.value.collator;return y=y||"",C=C||"",l(y,C)||n(O,y,C)}function w(y,C){return y=y||"",C=C||"",y===C?0:y<C?-1:1}function u(y,C){const[O,p]=c(y),[b,M]=c(C);let A=P.value.collator.compare(p,M);if(A===0){if(P.value.collatorIsNumeric&&p!==M)return p<M?-1:1;if(A=P.value.collator.compare(O,b),P.value.collatorIsNumeric&&A===0&&O!==b)return O<b?-1:1}return A}function k(y,C){y=y||"",C=C||"";const O=i(y),p=i(C),b=L.value.collator,M=R.value.collator;return n(M,O,p)||n(b,y,C)}function $(y,C){y=y||"",C=C||"";const O=i(y),p=i(C),b=L.value.collator,M=R.value.collator;return n(M,O,p)||g(y,C)||n(b,y,C)}function r(y,C){y=y||"",C=C||"";const O=i(y),p=i(C),b=L.value.collator,M=R.value.collator;return n(M,O,p)||l(y,C)||n(b,y,C)}function a(y,C){y=y||"",C=C||"";const O=i(y).toLowerCase(),p=i(C).toLowerCase();return O!==p?O<p?-1:1:y!==C?y<C?-1:1:0}const h=/^(.*?)(\.([^.]*))?$/;function c(y,C=!1){const O=y?h.exec(y):[];let p=[O&&O[1]||"",O&&O[3]||""];return C&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function i(y){const C=y?h.exec(y):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function n(y,C,O){const p=y.compare(C,O);return p!==0?p:C.length!==O.length?C.length<O.length?-1:1:0}function t(y){const C=y.charAt(0);return C.toLocaleUpperCase()!==C}function o(y){const C=y.charAt(0);return C.toLocaleLowerCase()!==C}function l(y,C){return t(y)&&o(C)?-1:o(y)&&t(C)?1:0}function g(y,C){return o(y)&&t(C)?-1:t(y)&&o(C)?1:0}function f(y,C,O=!1){return O||(y=y&&y.toLowerCase(),C=C&&C.toLowerCase()),y===C?0:y<C?-1:1}function d(y,C,O=!1){const p=y.split(D.sep),b=C.split(D.sep),M=p.length-1,A=b.length-1;let F,G;for(let x=0;;x++){if(F=M===x,G=A===x,F&&G)return T(p[x],b[x],O);if(F)return-1;if(G)return 1;const j=f(p[x],b[x],O);if(j!==0)return j}}function S(y,C,O){const p=y.toLowerCase(),b=C.toLowerCase(),M=E(y,C,O);if(M)return M;const A=p.endsWith(O),F=b.endsWith(O);if(A!==F)return A?-1:1;const G=T(p,b);return G!==0?G:p.localeCompare(b)}function E(y,C,O){const p=y.toLowerCase(),b=C.toLowerCase(),M=p.startsWith(O),A=b.startsWith(O);if(M!==A)return M?-1:1;if(M&&A){if(p.length<b.length)return-1;if(p.length>b.length)return 1}return 0}}),define(Re[72],Oe([1,0,22]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=void 0,e.$ht=L,e.$it=R,e.$jt=T,e.$kt=s,e.$gt=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const D={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(I){const w=(0,v.$tc)(I),u=D[w.toLowerCase()];return u!==void 0?u:R(I)}function R(I){const w=(0,v.$tc)(I);return P[w.toLowerCase()]}function T(I){for(const w in P)if(P[w]===I)return w}const m=/^(.+)\/(.+?)(;.+)?$/;function s(I,w){const u=m.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:w?void 0:I}}),define(Re[34],Oe([1,0,20,2,38]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=L,e.$gi=R,e.$hi=m;function L(s){return JSON.stringify(s,T)}function R(s){let I=JSON.parse(s);return I=m(I),I}function T(s,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function m(s,I=0){if(!s||I>200)return s;if(typeof s=="object"){switch(s.$mid){case P.MarshalledId.Uri:return D.URI.revive(s);case P.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case P.MarshalledId.Date:return new Date(s.source)}if(s instanceof v.$Se||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let w=0;w<s.length;++w)s[w]=m(s[w],I+1);else for(const w in s)Object.hasOwnProperty.call(s,w)&&(s[w]=m(s[w],I+1))}return s}}),define(Re[43],Oe([1,0,17,10,30,73,27,22,23,13]),function(we,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=void 0,e.$Ak=I,e.$Dk=r,e.$Ek=M,e.$Fk=A,e.$Gk=F,e.$Hk=G,e.$Ik=x,e.$Jk=Y;function I(){return Object.create(null)}e.$Bk="**",e.$Ck="/";const w="[/\\\\]",u="[^/\\\\]",k=/\//g;function $(ae,ee){switch(ae){case 0:return"";case 1:return`${u}*?`;default:return`(?:${w}|${u}+${w}${ee?`|${w}${u}+`:""})*?`}}function r(ae,ee){if(!ae)return[];const oe=[];let ie=!1,ue=!1,_="";for(const $e of ae){switch($e){case ee:if(!ie&&!ue){oe.push(_),_="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}_+=$e}return _&&oe.push(_),oe}function a(ae){if(!ae)return"";let ee="";const oe=r(ae,e.$Ck);if(oe.every(ie=>ie===e.$Bk))ee=".*";else{let ie=!1;oe.forEach((ue,_)=>{if(ue===e.$Bk){if(ie)return;ee+=$(2,_===oe.length-1)}else{let $e=!1,Ie="",X=!1,V="";for(const re of ue){if(re!=="}"&&$e){Ie+=re;continue}if(X&&(re!=="]"||!V)){let be;re==="-"?be=re:(re==="^"||re==="!")&&!V?be="^":re===e.$Ck?be="":be=(0,s.$mf)(re),V+=be;continue}switch(re){case"{":$e=!0;continue;case"[":X=!0;continue;case"}":{const Pe=`(?:${r(Ie,",").map(Fe=>a(Fe)).join("|")})`;ee+=Pe,$e=!1,Ie="";break}case"]":{ee+="["+V+"]",X=!1,V="";break}case"?":ee+=u;continue;case"*":ee+=$(1);continue;default:ee+=(0,s.$mf)(re)}}_<oe.length-1&&(oe[_+1]!==e.$Bk||_+2<oe.length)&&(ee+=w)}ie=ue===e.$Bk})}return ee}const h=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new R.$Ic(1e4),g=function(){return!1},f=function(){return null};function d(ae,ee){if(!ae)return f;let oe;typeof ae!="string"?oe=ae.pattern:oe=ae,oe=oe.trim();const ie=`${oe}_${!!ee.trimForExclusions}`;let ue=l.get(ie);if(ue)return S(ue,ae);let _;return h.test(oe)?ue=y(oe.substr(4),oe):(_=c.exec(E(oe,ee)))?ue=C(_[1],oe):(ee.trimForExclusions?n:i).test(oe)?ue=O(oe,ee):(_=t.exec(E(oe,ee)))?ue=p(_[1].substr(1),oe,!0):(_=o.exec(E(oe,ee)))?ue=p(_[1],oe,!1):ue=b(oe),l.set(ie,ue),S(ue,ae)}function S(ae,ee){if(typeof ee=="string")return ae;const oe=function(ie,ue){return(0,L.$Jg)(ie,ee.base,!m.$n)?ae((0,s.$rf)(ie.substr(ee.base.length),T.sep),ue):null};return oe.allBasenames=ae.allBasenames,oe.allPaths=ae.allPaths,oe.basenames=ae.basenames,oe.patterns=ae.patterns,oe}function E(ae,ee){return ee.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function y(ae,ee){return function(oe,ie){return typeof oe=="string"&&oe.endsWith(ae)?ee:null}}function C(ae,ee){const oe=`/${ae}`,ie=`\\${ae}`,ue=function($e,Ie){return typeof $e!="string"?null:Ie?Ie===ae?ee:null:$e===ae||$e.endsWith(oe)||$e.endsWith(ie)?ee:null},_=[ae];return ue.basenames=_,ue.patterns=[ee],ue.allBasenames=_,ue}function O(ae,ee){const oe=J(ae.slice(1,-1).split(",").map(Ie=>d(Ie,ee)).filter(Ie=>Ie!==f),ae),ie=oe.length;if(!ie)return f;if(ie===1)return oe[0];const ue=function(Ie,X){for(let V=0,re=oe.length;V<re;V++)if(oe[V](Ie,X))return ae;return null},_=oe.find(Ie=>!!Ie.allBasenames);_&&(ue.allBasenames=_.allBasenames);const $e=oe.reduce((Ie,X)=>X.allPaths?Ie.concat(X.allPaths):Ie,[]);return $e.length&&(ue.allPaths=$e),ue}function p(ae,ee,oe){const ie=T.sep===T.$lc.sep,ue=ie?ae:ae.replace(k,T.sep),_=T.sep+ue,$e=T.$lc.sep+ae;let Ie;return oe?Ie=function(X,V){return typeof X=="string"&&(X===ue||X.endsWith(_)||!ie&&(X===ae||X.endsWith($e)))?ee:null}:Ie=function(X,V){return typeof X=="string"&&(X===ue||!ie&&X===ae)?ee:null},Ie.allPaths=[(oe?"*/":"./")+ae],Ie}function b(ae){try{const ee=new RegExp(`^${a(ae)}$`);return function(oe){return ee.lastIndex=0,typeof oe=="string"&&ee.test(oe)?ae:null}}catch{return f}}function M(ae,ee,oe){return!ae||typeof ee!="string"?!1:A(ae)(ee,void 0,oe)}function A(ae,ee={}){if(!ae)return g;if(typeof ae=="string"||F(ae)){const oe=d(ae,ee);if(oe===f)return g;const ie=function(ue,_){return!!oe(ue,_)};return oe.allBasenames&&(ie.allBasenames=oe.allBasenames),oe.allPaths&&(ie.allPaths=oe.allPaths),ie}return j(ae,ee)}function F(ae){const ee=ae;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}function G(ae){return ae.allBasenames||[]}function x(ae){return ae.allPaths||[]}function j(ae,ee){const oe=J(Object.getOwnPropertyNames(ae).map(Ie=>U(Ie,ae[Ie],ee)).filter(Ie=>Ie!==f)),ie=oe.length;if(!ie)return f;if(!oe.some(Ie=>!!Ie.requiresSiblings)){if(ie===1)return oe[0];const Ie=function(re,be){let Pe;for(let Fe=0,Be=oe.length;Fe<Be;Fe++){const xe=oe[Fe](re,be);if(typeof xe=="string")return xe;(0,D.$wh)(xe)&&(Pe||(Pe=[]),Pe.push(xe))}return Pe?(async()=>{for(const Fe of Pe){const Be=await Fe;if(typeof Be=="string")return Be}return null})():null},X=oe.find(re=>!!re.allBasenames);X&&(Ie.allBasenames=X.allBasenames);const V=oe.reduce((re,be)=>be.allPaths?re.concat(be.allPaths):re,[]);return V.length&&(Ie.allPaths=V),Ie}const ue=function(Ie,X,V){let re,be;for(let Pe=0,Fe=oe.length;Pe<Fe;Pe++){const Be=oe[Pe];Be.requiresSiblings&&V&&(X||(X=(0,T.$sc)(Ie)),re||(re=X.substr(0,X.length-(0,T.$tc)(Ie).length)));const xe=Be(Ie,X,re,V);if(typeof xe=="string")return xe;(0,D.$wh)(xe)&&(be||(be=[]),be.push(xe))}return be?(async()=>{for(const Pe of be){const Fe=await Pe;if(typeof Fe=="string")return Fe}return null})():null},_=oe.find(Ie=>!!Ie.allBasenames);_&&(ue.allBasenames=_.allBasenames);const $e=oe.reduce((Ie,X)=>X.allPaths?Ie.concat(X.allPaths):Ie,[]);return $e.length&&(ue.allPaths=$e),ue}function U(ae,ee,oe){if(ee===!1)return f;const ie=d(ae,oe);if(ie===f)return f;if(typeof ee=="boolean")return ie;if(ee){const ue=ee.when;if(typeof ue=="string"){const _=($e,Ie,X,V)=>{if(!V||!ie($e,Ie))return null;const re=ue.replace("$(basename)",()=>X),be=V(re);return(0,D.$wh)(be)?be.then(Pe=>Pe?ae:null):be?ae:null};return _.requiresSiblings=!0,_}}return ie}function J(ae,ee){const oe=ae.filter(Ie=>!!Ie.basenames);if(oe.length<2)return ae;const ie=oe.reduce((Ie,X)=>{const V=X.basenames;return V?Ie.concat(V):Ie},[]);let ue;if(ee){ue=[];for(let Ie=0,X=ie.length;Ie<X;Ie++)ue.push(ee)}else ue=oe.reduce((Ie,X)=>{const V=X.patterns;return V?Ie.concat(V):Ie},[]);const _=function(Ie,X){if(typeof Ie!="string")return null;if(!X){let re;for(re=Ie.length;re>0;re--){const be=Ie.charCodeAt(re-1);if(be===P.CharCode.Slash||be===P.CharCode.Backslash)break}X=Ie.substr(re)}const V=ie.indexOf(X);return V!==-1?ue[V]:null};_.basenames=ie,_.patterns=ue,_.allBasenames=ie;const $e=ae.filter(Ie=>!Ie.basenames);return $e.push(_),$e}function Y(ae,ee){return(0,v.$yb)(ae,ee,(oe,ie)=>typeof oe=="string"&&typeof ie=="string"?oe===ie:typeof oe!="string"&&typeof ie!="string"?oe.base===ie.base&&oe.pattern===ie.pattern:!1)}}),define(Re[59],Oe([1,0,12,99,24,13,2]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.MarkdownStringTextNewlineStyle=void 0,e.$0k=s,e.$$k=I,e.$_k=w,e.$al=u,e.$bl=k,e.$cl=$,e.$dl=r,e.$el=a;var T;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class m{constructor(c="",i=!1){if(this.value=c,typeof this.value!="string")throw(0,v.$$)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(c,i=T.Paragraph){return this.value+=u(this.supportThemeIcons?(0,D.$3k)(c):c).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,i){return this.value+=`
${k(i,c)}
`,this}appendLink(c,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(c),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(c,i){const n=new RegExp((0,L.$mf)(i),"g");return c.replace(n,(t,o)=>c.charAt(o-1)!=="\\"?`\\${t}`:t)}}e.$9k=m;function s(h){return I(h)?!h.value:Array.isArray(h)?h.every(s):!0}function I(h){return h instanceof m?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function w(h,c){return h===c?!0:!h||!c?!1:h.value===c.value&&h.isTrusted===c.isTrusted&&h.supportThemeIcons===c.supportThemeIcons&&h.supportHtml===c.supportHtml&&(h.baseUri===c.baseUri||!!h.baseUri&&!!c.baseUri&&(0,P.$eh)(R.URI.from(h.baseUri),R.URI.from(c.baseUri)))}function u(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function k(h,c){const i=h.match(/^`+/gm)?.reduce((t,o)=>t.length>o.length?t:o).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${c}`,h,`${"`".repeat(n)}`].join(`
`)}function $(h){return h.replace(/"/g,"&quot;")}function r(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function a(h){const c=[],i=h.split("|").map(t=>t.trim());h=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),o=/width=(\d+)/.exec(n),l=t?t[1]:"",g=o?o[1]:"",f=isFinite(parseInt(g)),d=isFinite(parseInt(l));f&&c.push(`width="${g}"`),d&&c.push(`height="${l}"`)}return{href:h,dimensions:c}}}),define(Re[103],Oe([1,0,17,73,22,23,24,13]),function(we,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9w=m,e.$0w=I,e.$$w=u,e.$_w=k,e.$ax=h,e.$bx=i,e.$cx=n,e.$dx=t,e.$ex=o,e.$fx=l;function m(f,d){const{os:S,tildify:E,relative:y}=d;if(y){const p=s(f,y,S);if(typeof p=="string")return p}let C=f.fsPath;if(S===L.OperatingSystem.Windows&&!L.$l?C=C.replace(/\//g,"\\"):S!==L.OperatingSystem.Windows&&L.$l&&(C=C.replace(/\\/g,"/")),S!==L.OperatingSystem.Windows&&E?.userHome){const p=E.userHome.fsPath;let b;f.scheme!==E.userHome.scheme&&f.path[0]===P.$lc.sep&&f.path[1]!==P.$lc.sep?b=E.userHome.with({path:f.path}).fsPath:b=C,C=u(b,p,S)}return(S===L.OperatingSystem.Windows?P.$kc:P.$lc).normalize(I(C,S===L.OperatingSystem.Windows))}function s(f,d,S){const E=S===L.OperatingSystem.Windows?P.$kc:P.$lc,y=S===L.OperatingSystem.Linux?R.$bh:R.$dh,C=d.getWorkspace(),O=(0,v.$Sb)(C.folders);if(!O)return;f.scheme!==O.uri.scheme&&f.path[0]===P.$lc.sep&&f.path[1]!==P.$lc.sep&&(f=O.uri.with({path:f.path}));const p=d.getWorkspaceFolder(f);if(!p)return;let b;if(y.isEqual(p.uri,f)?b="":b=y.relativePath(p.uri,f)??"",b&&(b=E.normalize(b)),C.folders.length>1&&!d.noPrefix){const M=p.name?p.name:y.basenameOrAuthority(p.uri);b=b?`${M} \u2022 ${b}`:M}return b}function I(f,d=L.$l){return(0,D.$Og)(f,d)?f.charAt(0).toUpperCase()+f.slice(1):f}let w=Object.create(null);function u(f,d,S=L.OS){if(S===L.OperatingSystem.Windows||!f||!d)return f;let E=w.original===d?w.normalized:void 0;E||(E=d,L.$l&&(E=(0,D.$Dg)(E)),E=`${(0,T.$sf)(E,P.$lc.sep)}${P.$lc.sep}`,w={original:d,normalized:E});let y=f;return L.$l&&(y=(0,D.$Dg)(y)),(S===L.OperatingSystem.Linux?y.startsWith(E):(0,T.$Lf)(y,E))?`~/${y.substr(E.length)}`:f}function k(f,d){return f.replace(/^~($|\/|\\)/,`${d}$1`)}const $="\u2026",r="\\\\",a="~";function h(f,d=P.sep){const S=new Array(f.length);let E=!1;for(let y=0;y<f.length;y++){const C=f[y];if(C===""){S[y]=`.${d}`;continue}if(!C){S[y]=C;continue}E=!0;let O="",p=C;p.indexOf(r)===0?(O=p.substr(0,p.indexOf(r)+r.length),p=p.substr(p.indexOf(r)+r.length)):p.indexOf(d)===0?(O=p.substr(0,p.indexOf(d)+d.length),p=p.substr(p.indexOf(d)+d.length)):p.indexOf(a)===0&&(O=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length));const b=p.split(d);for(let M=1;E&&M<=b.length;M++)for(let A=b.length-M;E&&A>=0;A--){E=!1;let F=b.slice(A,A+M).join(d);for(let G=0;!E&&G<f.length;G++)if(G!==y&&f[G]&&f[G].indexOf(F)>-1){const x=A+M===b.length,j=A>0&&f[G].indexOf(d)>-1?d+F:F,U=f[G].endsWith(j);E=!x||U}if(!E){let G="";(b[0].endsWith(":")||O!=="")&&(A===1&&(A=0,M++,F=b[0]+d+F),A>0&&(G=b[0]+d),G=O+G),A>0&&(G=G+$+d),G=G+F,A+M<b.length&&(G=G+d+$),S[y]=G}}E&&(S[y]=C)}return S}var c;(function(f){f[f.TEXT=0]="TEXT",f[f.VARIABLE=1]="VARIABLE",f[f.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function i(f,d=Object.create(null)){const S=[];let E=!1,y="";for(const C of f)if(C==="$"||E&&C==="{")y&&S.push({value:y,type:c.TEXT}),y="",E=!0;else if(C==="}"&&E){const O=d[y];if(typeof O=="string")O.length&&S.push({value:O,type:c.VARIABLE});else if(O){const p=S[S.length-1];(!p||p.type!==c.SEPARATOR)&&S.push({value:O.label,type:c.SEPARATOR})}y="",E=!1}else y+=C;return y&&!E&&S.push({value:y,type:c.TEXT}),S.filter((C,O)=>{if(C.type===c.SEPARATOR){const p=S[O-1],b=S[O+1];return[p,b].every(M=>M&&(M.type===c.VARIABLE||M.type===c.TEXT)&&M.value.length>0)}return!0}).map(C=>C.value).join("")}function n(f,d){return L.$m||d?f.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$m?"&":"&&"):f.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function t(f,d){return L.$m||d?f.replace(/\(&&\w\)|&&/g,""):L.$l?f.replace(/&&|&/g,S=>S==="&"?"&&":"&"):f.replace(/&&/g,"_")}function o(f){return f.replace(/&/g,"&&")}function l(f){if(f.endsWith("]")){const d=f.lastIndexOf(" [",f.length-2);if(d!==-1){const S=g(f.substring(0,d)),E=f.substring(d);return{name:S.name+E,parentPath:S.parentPath}}}return g(f)}function g(f){const d=f.indexOf("/")!==-1?P.$lc:P.$kc,S=d.basename(f),E=d.dirname(f);return S.length?{name:S,parentPath:E}:{name:E,parentPath:""}}}),define(Re[160],Oe([1,0,20,38,2]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=void 0,e.$Un=m,e.$Vn=I,e.$Wn=w;function L(u){return u.toJSON()}class R{constructor(k){this.a=k}transformIncoming(k){const $=this.a.transformIncoming(k);return $===k?k:L(P.URI.from($))}transformOutgoing(k){const $=this.a.transformOutgoing(k);return $===k?k:L(P.URI.from($))}transformOutgoingURI(k){const $=this.a.transformOutgoing(k);return $===k?k:P.URI.from($)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$Sn=R,e.$Tn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function T(u,k,$){if(!u||$>200)return null;if(typeof u=="object"){if(u instanceof P.URI)return k.transformOutgoing(u);for(const r in u)if(Object.hasOwnProperty.call(u,r)){const a=T(u[r],k,$+1);a!==null&&(u[r]=a)}}return null}function m(u,k){const $=T(u,k,0);return $===null?u:$}function s(u,k,$,r){if(!u||r>200)return null;if(typeof u=="object"){if(u.$mid===D.MarshalledId.Uri)return $?P.URI.revive(k.transformIncoming(u)):k.transformIncoming(u);if(u instanceof v.$Se)return null;for(const a in u)if(Object.hasOwnProperty.call(u,a)){const h=s(u[a],k,$,r+1);h!==null&&(u[a]=h)}}return null}function I(u,k){const $=s(u,k,!1,0);return $===null?u:$}function w(u,k){const $=s(u,k,!0,0);return $===null?u:$}}),define(Re[161],Oe([1,0,10,6,4,34,14]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.StorageState=e.StorageHint=void 0,e.$jq=m;var T;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function m(u){const k=u;return k?.changed instanceof Map||k?.deleted instanceof Set}var s;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(s||(e.StorageState=s={}));class I extends P.$Zc{static{this.a=100}constructor(k,$=Object.create(null)){super(),this.r=k,this.s=$,this.b=this.B(new D.$te),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new v.$Ih(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach(($,r)=>this.w(r,$)),k.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(k,$){if(this.c===s.Closed)return;let r=!1;(0,R.$sg)($)?r=this.f.delete(k):this.f.get(k)!==$&&(this.f.set(k,$),r=!0),r&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,$){const r=this.f.get(k);return(0,R.$sg)(r)?$:r}getBoolean(k,$){const r=this.get(k);return(0,R.$sg)(r)?$:r==="true"}getNumber(k,$){const r=this.get(k);return(0,R.$sg)(r)?$:parseInt(r,10)}getObject(k,$){const r=this.get(k);return(0,R.$sg)(r)?$:(0,L.$gi)(r)}async set(k,$,r=!1){if(this.c===s.Closed)return;if((0,R.$sg)($))return this.delete(k,r);const a=(0,R.$lg)($)||Array.isArray($)?(0,L.$fi)($):String($);if(this.f.get(k)!==a)return this.f.set(k,a),this.j.set(k,a),this.h.delete(k),this.b.fire({key:k,external:r}),this.D()}async delete(k,$=!1){if(!(this.c===s.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:$}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(!(this.c===s.Closed||this.m))return this.D(k)}async D(k){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$kq=I;class w{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach(($,r)=>this.a.set(r,$)),k.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$lq=w}),define(Re[162],Oe([1,0,13,23,20]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=void 0,e.$ku=I,e.$lu=w,v=Ve(v),D=Ve(D),P=Ve(P);let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let T;function m(){return T||(T=new TextDecoder("UTF-16BE")),T}let s;function I(){return s||(s=D.$G()?R():m()),s}function w($,r,a){const h=new Uint16Array($.buffer,r,a);return a>0&&(h[0]===65279||h[0]===65534)?u($,r,a):R().decode(h)}function u($,r,a){const h=[];let c=0;for(let i=0;i<a;i++){const n=P.$Ue($,r);r+=2,h[c++]=String.fromCharCode(n)}return h.join("")}class k{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return I().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const a=this.a-this.d;a<=1&&(a===0||v.$Of(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const a=r.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=r;return}for(let h=0;h<a;h++)this.b[this.d++]=r.charCodeAt(h)}}e.$mu=k}),define(Re[163],Oe([1,0,20,162]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nu=void 0,e.$ou=R,v=Ve(v);function P(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(s,I,w,u){this.oldPosition=s,this.oldText=I,this.newPosition=w,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(s){return 4+2*s.length}static c(s,I,w){const u=I.length;v.$Xe(s,u,w),w+=4;for(let k=0;k<u;k++)v.$Ve(s,I.charCodeAt(k),w),w+=2;return w}static d(s,I){const w=v.$We(s,I);return I+=4,(0,D.$lu)(s,I,w)}writeSize(){return 8+L.a(this.oldText)+L.a(this.newText)}write(s,I){return v.$Xe(s,this.oldPosition,I),I+=4,v.$Xe(s,this.newPosition,I),I+=4,I=L.c(s,this.oldText,I),I=L.c(s,this.newText,I),I}static read(s,I,w){const u=v.$We(s,I);I+=4;const k=v.$We(s,I);I+=4;const $=L.d(s,I);I+=L.a($);const r=L.d(s,I);return I+=L.a(r),w.push(new L(u,$,k,r)),I}}e.$nu=L;function R(m,s){return m===null||m.length===0?s:new T(m,s).compress()}class T{constructor(s,I){this.a=s,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let s=0,I=0,w=this.n(s),u=this.l(I);for(;s<this.f||I<this.h;){if(w===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(w),w=this.n(++s);continue}if(u.oldEnd<=w.newPosition){this.k(u),u=this.l(++I);continue}if(w.newEnd<=u.oldPosition){this.m(w),w=this.n(++s);continue}if(u.oldPosition<w.newPosition){const[h,c]=T.r(u,w.newPosition-u.oldPosition);this.k(h),u=c;continue}if(w.newPosition<u.oldPosition){const[h,c]=T.q(w,u.oldPosition-w.newPosition);this.m(h),w=c;continue}let r,a;if(u.oldEnd===w.newEnd)r=w,a=u,w=this.n(++s),u=this.l(++I);else if(u.oldEnd<w.newEnd){const[h,c]=T.q(w,u.oldLength);r=h,a=u,w=c,u=this.l(++I)}else{const[h,c]=T.r(u,w.newLength);r=w,a=h,w=this.n(++s),u=c}this.d[this.e++]=new L(r.oldPosition,r.oldText,a.newPosition,a.newText),this.g+=r.newLength-r.oldLength,this.j+=a.newLength-a.oldLength}const k=T.s(this.d);return T.t(k)}k(s){this.d[this.e++]=T.o(this.g,s),this.j+=s.newLength-s.oldLength}l(s){return s<this.h?this.c[s]:null}m(s){this.d[this.e++]=T.p(this.j,s),this.g+=s.newLength-s.oldLength}n(s){return s<this.f?this.a[s]:null}static o(s,I){return new L(I.oldPosition-s,I.oldText,I.newPosition,I.newText)}static p(s,I){return new L(I.oldPosition,I.oldText,I.newPosition+s,I.newText)}static q(s,I){const w=s.newText.substr(0,I),u=s.newText.substr(I);return[new L(s.oldPosition,s.oldText,s.newPosition,w),new L(s.oldEnd,"",s.newPosition+I,u)]}static r(s,I){const w=s.oldText.substr(0,I),u=s.oldText.substr(I);return[new L(s.oldPosition,w,s.newPosition,s.newText),new L(s.oldPosition+I,u,s.newEnd,"")]}static s(s){if(s.length===0)return s;const I=[];let w=0,u=s[0];for(let k=1;k<s.length;k++){const $=s[k];u.oldEnd===$.oldPosition?u=new L(u.oldPosition,u.oldText+$.oldText,u.newPosition,u.newText+$.newText):(I[w++]=u,u=$)}return I[w++]=u,I}static t(s){if(s.length===0)return s;const I=[];let w=0;for(let u=0;u<s.length;u++){const k=s[u];k.oldText!==k.newText&&(I[w++]=k)}return I}}}),define(Re[164],Oe([1,0,43,22]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eu=P,e.$Fu=L;function P(R,T,m,s,I,w){if(Array.isArray(R)){let u=0;for(const k of R){const $=P(k,T,m,s,I,w);if($===10)return $;$>u&&(u=$)}return u}else{if(typeof R=="string")return s?R==="*"?5:R===m?10:0:0;if(R){const{language:u,pattern:k,scheme:$,hasAccessToAllModels:r,notebookType:a}=R;if(!s&&!r)return 0;a&&I&&(T=I);let h=0;if($)if($===T.scheme)h=10;else if($==="*")h=5;else return 0;if(u)if(u===m)h=10;else if(u==="*")h=Math.max(h,5);else return 0;if(a)if(a===w)h=10;else if(a==="*"&&w!==void 0)h=Math.max(h,5);else return 0;if(k){let c;if(typeof k=="string"?c=k:c={...k,base:(0,D.$mc)(k.base)},c===T.fsPath||(0,v.$Ek)(c,T.fsPath))h=10;else return 0}return h}else return 0}}function L(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(L):!!R.notebookType}}),define(Re[165],Oe([1,0,6,13,32,52,100,151,163,4]),function(we,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ID=void 0,D=Ve(D);class I extends s.$Zc{constructor(u,k,$,r,a,h,c){super(),this.m=this.B(new v.$qe),this.onDidChangeContent=this.m.event,this.f=k,this.j=!h,this.g=r,this.h=a,this.c=new R.$HD(u,$,c)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,k){return this.c.getOffsetAt(u,k)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,k){const $=u+k,r=this.getPositionAt(u),a=this.getPositionAt($);return new P.$Wt(r.lineNumber,r.column,a.lineNumber,a.column)}getValueInRange(u,k=L.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const $=this.n(k);return this.c.getValueInRange(u,$)}getValueLengthInRange(u,k=L.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const $=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let a=0;const h=this.n(k),c=this.getEOL();if(h.length!==c.length){const i=h.length-c.length,n=u.endLineNumber-u.startLineNumber;a=i*n}return r-$+a}getCharacterCountInRange(u,k=L.EndOfLinePreference.TextDefined){if(this.j){let $=0;const r=u.startLineNumber,a=u.endLineNumber;for(let h=r;h<=a;h++){const c=this.getLineContent(h),i=h===r?u.startColumn-1:0,n=h===a?u.endColumn-1:c.length;for(let t=i;t<n;t++)D.$Of(c.charCodeAt(t))?($=$+1,t=t+1):$=$+1}return $+=this.n(k).length*(a-r),$}return this.getValueLengthInRange(u,k)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,k){return this.c.getLineCharCode(u,k)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const k=D.$zf(this.getLineContent(u));return k===-1?0:k+1}getLineLastNonWhitespaceColumn(u){const k=D.$Bf(this.getLineContent(u));return k===-1?0:k+2}n(u){switch(u){case L.EndOfLinePreference.LF:return`
`;case L.EndOfLinePreference.CRLF:return`\r
`;case L.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,k,$){let r=this.g,a=this.h,h=this.j,c=!0,i=[];for(let d=0;d<u.length;d++){const S=u[d];c&&S._isTracked&&(c=!1);const E=S.range;if(S.text){let b=!0;h||(b=!D.$Zf(S.text),h=b),!r&&b&&(r=D.$Yf(S.text)),!a&&b&&(a=D.$2f(S.text))}let y="",C=0,O=0,p=0;if(S.text){let b;[C,O,p,b]=(0,T.$Hu)(S.text);const M=this.getEOL(),A=M===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;b===T.StringEOL.Unknown||b===A?y=S.text:y=S.text.replace(/\r\n|\r|\n/g,M)}i[d]={sortIndex:d,identifier:S.identifier||null,range:E,rangeOffset:this.getOffsetAt(E.startLineNumber,E.startColumn),rangeLength:this.getValueLengthInRange(E),text:y,eolCount:C,firstLineLength:O,lastLineLength:p,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}i.sort(I.u);let n=!1;for(let d=0,S=i.length-1;d<S;d++){const E=i[d].range.getEndPosition(),y=i[d+1].range.getStartPosition();if(y.isBeforeOrEqual(E)){if(y.isBefore(E))throw new Error("Overlapping ranges are not allowed!");n=!0}}c&&(i=this.s(i));const t=$||k?I._getInverseEditRanges(i):[],o=[];if(k)for(let d=0;d<i.length;d++){const S=i[d],E=t[d];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let y=E.startLineNumber;y<=E.endLineNumber;y++){let C="";y===E.startLineNumber&&(C=this.getLineContent(S.range.startLineNumber),D.$zf(C)!==-1)||o.push({lineNumber:y,oldContent:C})}}let l=null;if($){let d=0;l=[];for(let S=0;S<i.length;S++){const E=i[S],y=t[S],C=this.getValueInRange(E.range),O=E.rangeOffset+d;d+=E.text.length-C.length,l[S]={sortIndex:E.sortIndex,identifier:E.identifier,range:y,text:C,textChange:new m.$nu(E.rangeOffset,C,O,E.text)}}n||l.sort((S,E)=>S.sortIndex-E.sortIndex)}this.g=r,this.h=a,this.j=h;const g=this.t(i);let f=null;if(k&&o.length>0){o.sort((d,S)=>S.lineNumber-d.lineNumber),f=[];for(let d=0,S=o.length;d<S;d++){const E=o[d].lineNumber;if(d>0&&o[d-1].lineNumber===E)continue;const y=o[d].oldContent,C=this.getLineContent(E);C.length===0||C===y||D.$zf(C)!==-1||f.push(E)}}return this.m.fire(),new L.$rw(l,g,f)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let k=!1;const $=u[0].range,r=u[u.length-1].range,a=new P.$Wt($.startLineNumber,$.startColumn,r.endLineNumber,r.endColumn);let h=$.startLineNumber,c=$.startColumn;const i=[];for(let g=0,f=u.length;g<f;g++){const d=u[g],S=d.range;k=k||d.forceMoveMarkers,i.push(this.getValueInRange(new P.$Wt(h,c,S.startLineNumber,S.startColumn))),d.text.length>0&&i.push(d.text),h=S.endLineNumber,c=S.endColumn}const n=i.join(""),[t,o,l]=(0,T.$Hu)(n);return{sortIndex:0,identifier:u[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,L.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:o,lastLineLength:l,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const k=[];for(let $=0;$<u.length;$++){const r=u[$],a=r.range.startLineNumber,h=r.range.startColumn,c=r.range.endLineNumber,i=r.range.endColumn;if(a===c&&h===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const n=new P.$Wt(a,h,c,i);k.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return k}findMatchesLineByLine(u,k,$,r){return this.c.findMatchesLineByLine(u,k,$,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,k){const $=u.startLineNumber,r=u.startColumn,[a,h,c]=(0,T.$Hu)(k);let i;if(k.length>0){const n=a+1;n===1?i=new P.$Wt($,r,$,r+h):i=new P.$Wt($,r,$+n-1,c+1)}else i=new P.$Wt($,r,$,r);return i}static _getInverseEditRanges(u){const k=[];let $=0,r=0,a=null;for(let h=0,c=u.length;h<c;h++){const i=u[h];let n,t;a?a.range.endLineNumber===i.range.startLineNumber?(n=$,t=r+(i.range.startColumn-a.range.endColumn)):(n=$+(i.range.startLineNumber-a.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let o;if(i.text.length>0){const l=i.eolCount+1;l===1?o=new P.$Wt(n,t,n,t+i.firstLineLength):o=new P.$Wt(n,t,n+l-1,i.lastLineLength+1)}else o=new P.$Wt(n,t,n,t);$=o.endLineNumber,r=o.endColumn,k.push(o),a=i}return k}static u(u,k){const $=P.$Wt.compareRangesUsingEnds(u.range,k.range);return $===0?u.sortIndex-k.sortIndex:$}static w(u,k){const $=P.$Wt.compareRangesUsingEnds(u.range,k.range);return $===0?k.sortIndex-u.sortIndex:-$}}e.$ID=I}),define(Re[166],Oe([1,0,30,13,52,100,165]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JD=void 0,D=Ve(D);class T{constructor(I,w,u,k,$,r,a,h,c){this.a=I,this.b=w,this.c=u,this.d=k,this.e=$,this.f=r,this.g=a,this.h=h,this.j=c}k(I){const w=this.c+this.d+this.e,u=this.c+this.e;return w===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:u>w/2?`\r
`:`
`}create(I){const w=this.k(I),u=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let $=0,r=u.length;$<r;$++){const a=u[$].buffer.replace(/\r\n|\r|\n/g,w),h=(0,L.$DD)(a);u[$]=new L.$GD(a,h)}const k=new R.$ID(u,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class m{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&D.$0f(I)&&(this.b=D.$9f,I=I.substr(1));const w=I.charCodeAt(I.length-1);w===v.CharCode.CarriageReturn||w>=55296&&w<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=w):(this.m(I,!1),this.c=!1,this.d=w)}m(I,w){!w&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const w=(0,L.$ED)(this.e,I);this.a.push(new L.$GD(I,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=D.$Yf(I)),this.k||(this.k=D.$2f(I)))}finish(I=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const w=(0,L.$DD)(I.buffer);I.lineStarts=w,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$JD=m}),define(Re[104],Oe([1,0,20,23]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yeb=m,e.$zeb=I,D=Ve(D);var P;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(P||(P={}));function L(w){for(let u=0,k=w.length;u<k;u+=4){const $=w[u+0],r=w[u+1],a=w[u+2],h=w[u+3];w[u+0]=h,w[u+1]=a,w[u+2]=r,w[u+3]=$}}function R(w){const u=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return D.$G()||L(u),v.$Se.wrap(u)}function T(w){const u=w.buffer;if(D.$G()||L(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const k=new Uint8Array(u.byteLength);return k.set(u),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function m(w){const u=new Uint32Array(s(w));let k=0;if(u[k++]=w.id,w.type==="full")u[k++]=P.Full,u[k++]=w.data.length,u.set(w.data,k),k+=w.data.length;else{u[k++]=P.Delta,u[k++]=w.deltas.length;for(const $ of w.deltas)u[k++]=$.start,u[k++]=$.deleteCount,$.data?(u[k++]=$.data.length,u.set($.data,k),k+=$.data.length):u[k++]=0}return R(u)}function s(w){let u=0;if(u+=2,w.type==="full")u+=1+w.data.length;else{u+=1,u+=3*w.deltas.length;for(const k of w.deltas)k.data&&(u+=k.data.length)}return u}function I(w){const u=T(w);let k=0;const $=u[k++];if(u[k++]===P.Full){const c=u[k++],i=u.subarray(k,k+c);return k+=c,{id:$,type:"full",data:i}}const a=u[k++],h=[];for(let c=0;c<a;c++){const i=u[k++],n=u[k++],t=u[k++];let o;t>0&&(o=u.subarray(k,k+t),k+=t),h[c]={start:i,deleteCount:n,data:o}}return{id:$,type:"delta",deltas:h}}}),define(Re[167],Oe([1,0,30,12,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.TokenType=void 0;var L;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...I){switch(I.length){case 1:return(0,P.localize)(1693,null,I[0]);case 2:return(0,P.localize)(1694,null,I[0],I[1]);case 3:return(0,P.localize)(1695,null,I[0],I[1],I[2]);default:return}}const T=(0,P.localize)(1696,null),m=(0,P.localize)(1697,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case L.LParen:return"(";case L.RParen:return")";case L.Neg:return"!";case L.Eq:return w.isTripleEq?"===":"==";case L.NotEq:return w.isTripleEq?"!==":"!=";case L.Lt:return"<";case L.LtEq:return"<=";case L.Gt:return">=";case L.GtEq:return">=";case L.RegexOp:return"=~";case L.RegexStr:return w.lexeme;case L.True:return"true";case L.False:return"false";case L.In:return"in";case L.Not:return"not";case L.And:return"&&";case L.Or:return"||";case L.Str:return w.lexeme;case L.QuotedStr:return w.lexeme;case L.Error:return w.lexeme;case L.EOF:return"EOF";default:throw(0,D.$_)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this.b=new Map([["not",L.Not],["in",L.In],["false",L.False],["true",L.True]])}get errors(){return this.g}reset(w){return this.c=w,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(L.LParen);break;case v.CharCode.CloseParen:this.k(L.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:L.NotEq,offset:this.d,isTripleEq:u})}else this.k(L.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const u=this.h(v.CharCode.Equals);this.f.push({type:L.Eq,offset:this.d,isTripleEq:u})}else this.h(v.CharCode.Tilde)?this.k(L.RegexOp):this.l(R("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?L.LtEq:L.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?L.GtEq:L.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(L.And):this.l(R("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(L.Or):this.l(R("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(L.EOF),Array.from(this.f)}h(w){return this.r()||this.c.charCodeAt(this.e)!==w?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(w){this.f.push({type:w,offset:this.d})}l(w){const u=this.d,k=this.c.substring(this.d,this.e),$={type:L.Error,offset:this.d,lexeme:k};this.g.push({offset:u,lexeme:k,additionalInfo:w}),this.f.push($)}n(){this.m.lastIndex=this.d;const w=this.m.exec(this.c);if(w){this.e=this.d+w[0].length;const u=this.c.substring(this.d,this.e),k=s.b.get(u);k?this.k(k):this.f.push({type:L.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:L.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let w=this.e,u=!1,k=!1;for(;;){if(w>=this.c.length){this.e=w,this.l(m);return}const r=this.c.charCodeAt(w);if(u)u=!1;else if(r===v.CharCode.Slash&&!k){w++;break}else r===v.CharCode.OpenSquareBracket?k=!0:r===v.CharCode.Backslash?u=!0:r===v.CharCode.CloseSquareBracket&&(k=!1);w++}for(;w<this.c.length&&s.a.has(this.c.charCodeAt(w));)w++;this.e=w;const $=this.c.substring(this.d,this.e);this.f.push({type:L.RegexStr,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fj=s}),define(Re[105],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDebugCreateConfiguration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDebugCreateConfiguration.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlHistoryTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryTitleMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewContainerTitle:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewContainerTitle.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:6},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookReplDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookReplDocument.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Re[74],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=void 0;class v{constructor(P,L=[],R=!1){this.ctor=P,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$Hi=v}),define(Re[60],Oe([1,0,74]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Zs=L,e.$1s=R;const D=[];var P;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function L(T,m,s){m instanceof v.$Hi||(m=new v.$Hi(m,[],!!s)),D.push([T,m])}function R(){return D}}),define(Re[168],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;class v{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Cr=v;class D{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const T=this.lookupOrInsertNode(L),m=this.lookupOrInsertNode(R);T.outgoing.set(m.key,m),m.incoming.set(T.key,T)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const T of this.a.values())T.outgoing.delete(R),T.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let T=this.a.get(R);return T||(T=new v(R,L),this.a.set(R,T)),T}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,T]of this.a)L.push(`${R}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const T=new Set([L]),m=this.c(R,T);if(m)return m}}c(L,R){for(const[T,m]of L.outgoing){if(R.has(T))return[...R,T].join(" -> ");R.add(T);const s=this.c(m,R);if(s)return s;R.delete(T)}}}e.$Dr=D}),define(Re[3],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e._util=void 0,e.$Ki=P,e.$Li=L;var v;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function T(m){return m[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=T})(v||(e._util=v={})),e.$Ji=P("instantiationService");function D(R,T,m){T[v.DI_TARGET]===T?T[v.DI_DEPENDENCIES].push({id:R,index:m}):(T[v.DI_DEPENDENCIES]=[{id:R,index:m}],T[v.DI_TARGET]=T)}function P(R){if(v.serviceIds.has(R))return v.serviceIds.get(R);const T=function(m,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(T,m,I)};return T.toString=()=>R,v.serviceIds.set(R,T),T}function L(R){return R}}),define(Re[44],Oe([1,0,14,2,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$ej=void 0,e.$fj=L,e.$gj=R,e.$hj=m,e.$ij=s,e.$jj=I,e.$kj=w,e.$lj=u,e.$mj=$,e.$nj=r,e.$oj=a,v=Ve(v),e.$ej=(0,P.$Ki)("configurationService");function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof D.URI)}function R(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof D.URI)}var T;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function m(h){switch(h){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function s(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}function I(h,c){const i=Object.create(null);for(const n in h)w(i,n,h[n],c);return i}function w(h,c,i,n){const t=c.split("."),o=t.pop();let l=h;for(let g=0;g<t.length;g++){const f=t[g];let d=l[f];switch(typeof d){case"undefined":d=l[f]=Object.create(null);break;case"object":if(d===null){n(`Ignoring ${c} as ${t.slice(0,g+1).join(".")} is null`);return}break;default:n(`Ignoring ${c} as ${t.slice(0,g+1).join(".")} is ${JSON.stringify(d)}`);return}l=d}if(typeof l=="object"&&l!==null)try{l[o]=i}catch{n(`Ignoring ${c} as ${t.join(".")} is ${JSON.stringify(l)}`)}else n(`Ignoring ${c} as ${t.join(".")} is ${JSON.stringify(l)}`)}function u(h,c){const i=c.split(".");k(h,i)}function k(h,c){const i=c.shift();if(c.length===0){delete h[i];return}if(Object.keys(h).indexOf(i)!==-1){const n=h[i];typeof n=="object"&&!Array.isArray(n)&&(k(n,c),Object.keys(n).length===0&&delete h[i])}}function $(h,c,i){function n(l,g){let f=l;for(const d of g){if(typeof f!="object"||f===null)return;f=f[d]}return f}const t=c.split("."),o=n(h,t);return typeof o>"u"?i:o}function r(h,c,i){Object.keys(c).forEach(n=>{n!=="__proto__"&&(n in h?v.$lg(h[n])&&v.$lg(c[n])?r(h[n],c[n],i):i&&(h[n]=c[n]):h[n]=c[n])})}function a(h){return h.replace(/[\[\]]/g,"")}}),define(Re[31],Oe([1,0,30,23,13,167,3,9,12]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Ij=e.$Hj=e.ContextKeyExprType=void 0,e.$Gj=I,e.$Jj=g,e.$Kj=f,e.$4j=_;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",D.$m),s.set("isLinux",D.$n),s.set("isWindows",D.$l),s.set("isWeb",D.$r),s.set("isMacNative",D.$m&&!D.$r),s.set("isEdge",D.$K),s.set("isFirefox",D.$I),s.set("isChrome",D.$H),s.set("isSafari",D.$J);function I(X,V){if(s.get(X)!==void 0)throw(0,m.$$)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(X,V)}const w=Object.prototype.hasOwnProperty;var u;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const k={regexParsingWithErrorRecovery:!0},$=(0,T.localize)(1673,null),r=(0,T.localize)(1674,null),a=(0,T.localize)(1675,null),h=(0,T.localize)(1676,null),c=(0,T.localize)(1677,null),i=(0,T.localize)(1678,null),n=(0,T.localize)(1679,null),t=(0,T.localize)(1680,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=k){this.k=V,this.d=new L.$Fj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const re=this.l();if(!this.E()){const be=this.D(),Pe=be.type===L.TokenType.Str?i:void 0;throw this.h.push({message:c,offset:be.offset,lexeme:L.$Fj.getLexeme(be),additionalInfo:Pe}),o.c}return re}catch(re){if(re!==o.c)throw re;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(L.TokenType.Or);){const re=this.o();V.push(re)}return V.length===1?V[0]:l.or(...V)}o(){const V=[this.s()];for(;this.y(L.TokenType.And);){const re=this.s();V.push(re)}return V.length===1?V[0]:l.and(...V)}s(){if(this.y(L.TokenType.Neg)){const V=this.D();switch(V.type){case L.TokenType.True:return this.z(),S.INSTANCE;case L.TokenType.False:return this.z(),E.INSTANCE;case L.TokenType.LParen:{this.z();const re=this.l();return this.A(L.TokenType.RParen,h),re?.negate()}case L.TokenType.Str:return this.z(),M.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case L.TokenType.True:return this.z(),l.true();case L.TokenType.False:return this.z(),l.false();case L.TokenType.LParen:{this.z();const re=this.l();return this.A(L.TokenType.RParen,h),re}case L.TokenType.Str:{const re=V.lexeme;if(this.z(),this.y(L.TokenType.RegexOp)){const Pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Pe.type!==L.TokenType.RegexStr)throw this.B("REGEX",Pe);const Fe=Pe.lexeme,Be=Fe.lastIndexOf("/"),xe=Be===Fe.length-1?void 0:this.w(Fe.substring(Be+1));let nt;try{nt=new RegExp(Fe.substring(1,Be),xe)}catch{throw this.B("REGEX",Pe)}return U.create(re,nt)}switch(Pe.type){case L.TokenType.RegexStr:case L.TokenType.Error:{const Fe=[Pe.lexeme];this.z();let Be=this.D(),xe=0;for(let et=0;et<Pe.lexeme.length;et++)Pe.lexeme.charCodeAt(et)===v.CharCode.OpenParen?xe++:Pe.lexeme.charCodeAt(et)===v.CharCode.CloseParen&&xe--;for(;!this.E()&&Be.type!==L.TokenType.And&&Be.type!==L.TokenType.Or;){switch(Be.type){case L.TokenType.LParen:xe++;break;case L.TokenType.RParen:xe--;break;case L.TokenType.RegexStr:case L.TokenType.QuotedStr:for(let et=0;et<Be.lexeme.length;et++)Be.lexeme.charCodeAt(et)===v.CharCode.OpenParen?xe++:Pe.lexeme.charCodeAt(et)===v.CharCode.CloseParen&&xe--}if(xe<0)break;Fe.push(L.$Fj.getLexeme(Be)),this.z(),Be=this.D()}const nt=Fe.join(""),ht=nt.lastIndexOf("/"),$t=ht===nt.length-1?void 0:this.w(nt.substring(ht+1));let ut;try{ut=new RegExp(nt.substring(1,ht),$t)}catch{throw this.B("REGEX",Pe)}return l.regex(re,ut)}case L.TokenType.QuotedStr:{const Fe=Pe.lexeme;this.z();let Be=null;if(!(0,P.$hf)(Fe)){const xe=Fe.indexOf("/"),nt=Fe.lastIndexOf("/");if(xe!==nt&&xe>=0){const ht=Fe.slice(xe+1,nt),$t=Fe[nt+1]==="i"?"i":"";try{Be=new RegExp(ht,$t)}catch{throw this.B("REGEX",Pe)}}}if(Be===null)throw this.B("REGEX",Pe);return U.create(re,Be)}default:throw this.B("REGEX",this.D())}}if(this.y(L.TokenType.Not)){this.A(L.TokenType.In,a);const Pe=this.u();return l.notIn(re,Pe)}switch(this.D().type){case L.TokenType.Eq:{this.z();const Pe=this.u();if(this.x().type===L.TokenType.QuotedStr)return l.equals(re,Pe);switch(Pe){case"true":return l.has(re);case"false":return l.not(re);default:return l.equals(re,Pe)}}case L.TokenType.NotEq:{this.z();const Pe=this.u();if(this.x().type===L.TokenType.QuotedStr)return l.notEquals(re,Pe);switch(Pe){case"true":return l.not(re);case"false":return l.has(re);default:return l.notEquals(re,Pe)}}case L.TokenType.Lt:return this.z(),x.create(re,this.u());case L.TokenType.LtEq:return this.z(),j.create(re,this.u());case L.TokenType.Gt:return this.z(),F.create(re,this.u());case L.TokenType.GtEq:return this.z(),G.create(re,this.u());case L.TokenType.In:return this.z(),l.in(re,this.u());default:return l.has(re)}}case L.TokenType.EOF:throw this.h.push({message:n,offset:V.offset,lexeme:"",additionalInfo:t}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case L.TokenType.Str:case L.TokenType.QuotedStr:return this.z(),V.lexeme;case L.TokenType.True:return this.z(),"true";case L.TokenType.False:return this.z(),"false";case L.TokenType.In:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,re){if(this.C(V))return this.z();throw this.B(re,this.D())}B(V,re,be){const Pe=(0,T.localize)(1681,null,V,L.$Fj.getLexeme(re)),Fe=re.offset,Be=L.$Fj.getLexeme(re);return this.h.push({message:Pe,offset:Fe,lexeme:Be,additionalInfo:be}),o.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===L.TokenType.EOF}}e.$Hj=o;class l{static false(){return S.INSTANCE}static true(){return E.INSTANCE}static has(V){return y.create(V)}static equals(V,re){return C.create(V,re)}static notEquals(V,re){return b.create(V,re)}static regex(V,re){return U.create(V,re)}static in(V,re){return O.create(V,re)}static notIn(V,re){return p.create(V,re)}static not(V){return M.create(V)}static and(...V){return ae.create(V,null,!0)}static or(...V){return ee.create(V,null,!0)}static greater(V,re){return F.create(V,re)}static greaterEquals(V,re){return G.create(V,re)}static smaller(V,re){return x.create(V,re)}static smallerEquals(V,re){return j.create(V,re)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Ij=l;function g(X){const V=new o({regexParsingWithErrorRecovery:!1});return X.map(re=>(V.parse(re),V.lexingErrors.length>0?V.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,T.localize)(1682,null,be.additionalInfo):(0,T.localize)(1683,null),offset:be.offset,length:be.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function f(X,V){const re=X?X.substituteConstants():void 0,be=V?V.substituteConstants():void 0;return!re&&!be?!0:!re||!be?!1:re.equals(be)}function d(X,V){return X.cmp(V)}class S{static{this.INSTANCE=new S}constructor(){this.type=u.False}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return E.INSTANCE}}e.$Lj=S;class E{static{this.INSTANCE=new E}constructor(){this.type=u.True}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return S.INSTANCE}}e.$Mj=E;class y{static create(V,re=null){const be=s.get(V);return typeof be=="boolean"?be?E.INSTANCE:S.INSTANCE:new y(V,re)}constructor(V,re){this.key=V,this.c=re,this.type=u.Defined}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=s.get(this.key);return typeof V=="boolean"?V?E.INSTANCE:S.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Nj=y;class C{static create(V,re,be=null){if(typeof re=="boolean")return re?y.create(V,be):M.create(V,be);const Pe=s.get(V);return typeof Pe=="boolean"?re===(Pe?"true":"false")?E.INSTANCE:S.INSTANCE:new C(V,re,be)}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.Equals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=s.get(this.c);if(typeof V=="boolean"){const re=V?"true":"false";return this.d===re?E.INSTANCE:S.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Oj=C;class O{static create(V,re){return new O(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=u.In,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.f),be=V.getValue(this.d);return Array.isArray(re)?re.includes(be):typeof be=="string"&&typeof re=="object"&&re!==null?w.call(re,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Pj=O;class p{static create(V,re){return new p(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=u.NotIn,this.c=O.create(V,re)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qj=p;class b{static create(V,re,be=null){if(typeof re=="boolean")return re?M.create(V,be):y.create(V,be);const Pe=s.get(V);return typeof Pe=="boolean"?re===(Pe?"true":"false")?S.INSTANCE:E.INSTANCE:new b(V,re,be)}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.NotEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=s.get(this.c);if(typeof V=="boolean"){const re=V?"true":"false";return this.d===re?S.INSTANCE:E.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Rj=b;class M{static create(V,re=null){const be=s.get(V);return typeof be=="boolean"?be?S.INSTANCE:E.INSTANCE:new M(V,re)}constructor(V,re){this.c=V,this.d=re,this.type=u.Not}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=s.get(this.c);return typeof V=="boolean"?V?S.INSTANCE:E.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Sj=M;function A(X,V){if(typeof X=="string"){const re=parseFloat(X);isNaN(re)||(X=re)}return typeof X=="string"||typeof X=="number"?V(X):S.INSTANCE}class F{static create(V,re,be=null){return A(re,Pe=>new F(V,Pe,be))}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.Greater}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Tj=F;class G{static create(V,re,be=null){return A(re,Pe=>new G(V,Pe,be))}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.GreaterEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Uj=G;class x{static create(V,re,be=null){return A(re,Pe=>new x(V,Pe,be))}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.Smaller}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Vj=x;class j{static create(V,re,be=null){return A(re,Pe=>new j(V,Pe,be))}constructor(V,re,be){this.c=V,this.d=re,this.f=be,this.type=u.SmallerEquals}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Wj=j;class U{static create(V,re){return new U(V,re)}constructor(V,re){this.d=V,this.f=re,this.type=u.Regex,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const re=this.f?this.f.source:"",be=V.f?V.f.source:"";return re<be?-1:re>be?1:0}equals(V){if(V.type===this.type){const re=this.f?this.f.source:"",be=V.f?V.f.source:"";return this.d===V.d&&re===be}return!1}substituteConstants(){return this}evaluate(V){const re=V.getValue(this.d);return this.f?this.f.test(re):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=J.create(this)),this.c}}e.$Xj=U;class J{static create(V){return new J(V)}constructor(V){this.c=V,this.type=u.NotRegex}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new J(this.c.map(V))}negate(){return this.c}}e.$Yj=J;function Y(X){let V=null;for(let re=0,be=X.length;re<be;re++){const Pe=X[re].substituteConstants();if(X[re]!==Pe&&V===null){V=[];for(let Fe=0;Fe<re;Fe++)V[Fe]=X[Fe]}V!==null&&(V[re]=Pe)}return V===null?X:V}class ae{static create(V,re,be){return ae.d(V,re,be)}constructor(V,re){this.expr=V,this.c=re,this.type=u.And}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,be=this.expr.length;re<be;re++){const Pe=d(this.expr[re],V.expr[re]);if(Pe!==0)return Pe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,be=this.expr.length;re<be;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=Y(this.expr);return V===this.expr?this:ae.create(V,this.c,!1)}evaluate(V){for(let re=0,be=this.expr.length;re<be;re++)if(!this.expr[re].evaluate(V))return!1;return!0}static d(V,re,be){const Pe=[];let Fe=!1;for(const Be of V)if(Be){if(Be.type===u.True){Fe=!0;continue}if(Be.type===u.False)return S.INSTANCE;if(Be.type===u.And){Pe.push(...Be.expr);continue}Pe.push(Be)}if(Pe.length===0&&Fe)return E.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(d);for(let Be=1;Be<Pe.length;Be++)Pe[Be-1].equals(Pe[Be])&&(Pe.splice(Be,1),Be--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const Be=Pe[Pe.length-1];if(Be.type!==u.Or)break;Pe.pop();const xe=Pe.pop(),nt=Pe.length===0,ht=ee.create(Be.expr.map($t=>ae.create([$t,xe],null,be)),null,nt);ht&&(Pe.push(ht),Pe.sort(d))}if(Pe.length===1)return Pe[0];if(be){for(let Be=0;Be<Pe.length;Be++)for(let xe=Be+1;xe<Pe.length;xe++)if(Pe[Be].negate().equals(Pe[xe]))return S.INSTANCE;if(Pe.length===1)return Pe[0]}return new ae(Pe,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new ae(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.c){const V=[];for(const re of this.expr)V.push(re.negate());this.c=ee.create(V,this,!0)}return this.c}}e.$Zj=ae;class ee{static create(V,re,be){return ee.d(V,re,be)}constructor(V,re){this.expr=V,this.c=re,this.type=u.Or}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let re=0,be=this.expr.length;re<be;re++){const Pe=d(this.expr[re],V.expr[re]);if(Pe!==0)return Pe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let re=0,be=this.expr.length;re<be;re++)if(!this.expr[re].equals(V.expr[re]))return!1;return!0}return!1}substituteConstants(){const V=Y(this.expr);return V===this.expr?this:ee.create(V,this.c,!1)}evaluate(V){for(let re=0,be=this.expr.length;re<be;re++)if(this.expr[re].evaluate(V))return!0;return!1}static d(V,re,be){let Pe=[],Fe=!1;if(V){for(let Be=0,xe=V.length;Be<xe;Be++){const nt=V[Be];if(nt){if(nt.type===u.False){Fe=!0;continue}if(nt.type===u.True)return E.INSTANCE;if(nt.type===u.Or){Pe=Pe.concat(nt.expr);continue}Pe.push(nt)}}if(Pe.length===0&&Fe)return S.INSTANCE;Pe.sort(d)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let Be=1;Be<Pe.length;Be++)Pe[Be-1].equals(Pe[Be])&&(Pe.splice(Be,1),Be--);if(Pe.length===1)return Pe[0];if(be){for(let Be=0;Be<Pe.length;Be++)for(let xe=Be+1;xe<Pe.length;xe++)if(Pe[Be].negate().equals(Pe[xe]))return E.INSTANCE;if(Pe.length===1)return Pe[0]}return new ee(Pe,re)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const re of this.expr)V.push(...re.keys());return V}map(V){return new ee(this.expr.map(re=>re.map(V)),null)}negate(){if(!this.c){const V=[];for(const re of this.expr)V.push(re.negate());for(;V.length>1;){const re=V.shift(),be=V.shift(),Pe=[];for(const Fe of Ie(re))for(const Be of Ie(be))Pe.push(ae.create([Fe,Be],null,!1));V.unshift(ee.create(Pe,null,!1))}this.c=ee.create(V,this,!0)}return this.c}}e.$1j=ee;class oe extends y{static{this.d=[]}static all(){return oe.d.values()}constructor(V,re,be){super(V,null),this.f=re,typeof be=="object"?oe.d.push({...be,key:V}):be!==!0&&oe.d.push({key:V,description:be,type:re!=null?typeof re:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return C.create(this.key,V)}notEqualsTo(V){return b.create(this.key,V)}}e.$2j=oe,e.$3j=(0,R.$Ki)("contextKeyService");function ie(X,V){return X<V?-1:X>V?1:0}function ue(X,V,re,be){return X<re?-1:X>re?1:V<be?-1:V>be?1:0}function _(X,V){if(X.type===u.False||V.type===u.True)return!0;if(X.type===u.Or)return V.type===u.Or?$e(X.expr,V.expr):!1;if(V.type===u.Or){for(const re of V.expr)if(_(X,re))return!0;return!1}if(X.type===u.And){if(V.type===u.And)return $e(V.expr,X.expr);for(const re of X.expr)if(_(re,V))return!0;return!1}return X.equals(V)}function $e(X,V){let re=0,be=0;for(;re<X.length&&be<V.length;){const Pe=X[re].cmp(V[be]);if(Pe<0)return!1;Pe===0&&re++,be++}return re===X.length}function Ie(X){return X.type===u.Or?X.expr:[X]}}),define(Re[169],Oe([1,0,31,3]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.$At=e.AccessibilitySupport=e.$zt=void 0,e.$Bt=L,e.$zt=(0,D.$Ki)("accessibilityService");var P;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$At=new v.$2j("accessibilityModeEnabled",!1);function L(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.$Ct="ACCESSIBLE_VIEW_SHOWN_"}),define(Re[106],Oe([1,0,17,25,23,147,280,152,170,9,169]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=l,e.stringSet=d,e.cursorStyleToString=A,e.filterValidationDecorations=Ne,v=Ve(v),D=Ve(D),P=Ve(P),s=Ve(s);var w;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(w||(e.EditorAutoIndentStrategy=w={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(q){this.c=q}hasChanged(q){return this.c[q]}}e.ConfigurationChangedEvent=u;class k{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=k;class ${constructor(q,de,je,Qe){this.id=q,this.name=de,this.defaultValue=je,this.schema=Qe}applyUpdate(q,de){return a(q,de)}compute(q,de,je){return je}}class r{constructor(q,de){this.newValue=q,this.didChange=de}}e.ApplyUpdateResult=r;function a(Z,q){if(typeof Z!="object"||typeof q!="object"||!Z||!q)return new r(q,Z!==q);if(Array.isArray(Z)||Array.isArray(q)){const je=Array.isArray(Z)&&Array.isArray(q)&&v.$yb(Z,q);return new r(q,!je)}let de=!1;for(const je in q)if(q.hasOwnProperty(je)){const Qe=a(Z[je],q[je]);Qe.didChange&&(Z[je]=Qe.newValue,de=!0)}return new r(Z,de)}class h{constructor(q){this.schema=void 0,this.id=q,this.name="_never_",this.defaultValue=void 0}applyUpdate(q,de){return a(q,de)}validate(q){return this.defaultValue}}class c{constructor(q,de,je,Qe){this.id=q,this.name=de,this.defaultValue=je,this.schema=Qe}applyUpdate(q,de){return a(q,de)}validate(q){return typeof q>"u"?this.defaultValue:q}compute(q,de,je){return je}}function i(Z,q){return typeof Z>"u"?q:Z==="false"?!1:!!Z}class n extends c{constructor(q,de,je,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=je),super(q,de,je,Qe)}validate(q){return i(q,this.defaultValue)}}function t(Z,q,de,je){if(typeof Z>"u")return q;let Qe=parseInt(Z,10);return isNaN(Qe)?q:(Qe=Math.max(de,Qe),Qe=Math.min(je,Qe),Qe|0)}class o extends c{static clampedInt(q,de,je,Qe){return t(q,de,je,Qe)}constructor(q,de,je,Qe,st,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=je,dt.minimum=Qe,dt.maximum=st),super(q,de,je,dt),this.minimum=Qe,this.maximum=st}validate(q){return o.clampedInt(q,this.defaultValue,this.minimum,this.maximum)}}function l(Z,q,de,je){if(typeof Z>"u")return q;const Qe=g.float(Z,q);return g.clamp(Qe,de,je)}class g extends c{static clamp(q,de,je){return q<de?de:q>je?je:q}static float(q,de){if(typeof q=="number")return q;if(typeof q>"u")return de;const je=parseFloat(q);return isNaN(je)?de:je}constructor(q,de,je,Qe,st){typeof st<"u"&&(st.type="number",st.default=je),super(q,de,je,st),this.validationFn=Qe}validate(q){return this.validationFn(g.float(q,this.defaultValue))}}class f extends c{static string(q,de){return typeof q!="string"?de:q}constructor(q,de,je,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=je),super(q,de,je,Qe)}validate(q){return f.string(q,this.defaultValue)}}function d(Z,q,de,je){return typeof Z!="string"?q:je&&Z in je?je[Z]:de.indexOf(Z)===-1?q:Z}class S extends c{constructor(q,de,je,Qe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Qe,st.default=je),super(q,de,je,st),this.c=Qe}validate(q){return d(q,this.defaultValue,this.c)}}class E extends ${constructor(q,de,je,Qe,st,dt,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=st,mt.default=Qe),super(q,de,je,mt),this.c=st,this.d=dt}validate(q){return typeof q!="string"?this.defaultValue:this.c.indexOf(q)===-1?this.defaultValue:this.d(q)}}function y(Z){switch(Z){case"none":return w.None;case"keep":return w.Keep;case"brackets":return w.Brackets;case"advanced":return w.Advanced;case"full":return w.Full}}class C extends ${constructor(){super(ve.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(302,null),s.localize(303,null),s.localize(304,null)],default:"auto",tags:["accessibility"],description:s.localize(305,null)})}validate(q){switch(q){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(q,de,je){return je===I.AccessibilitySupport.Unknown?q.accessibilitySupport:je}}class O extends ${constructor(){const q={insertSpace:!0,ignoreEmptyLines:!0};super(ve.comments,"comments",q,{"editor.comments.insertSpace":{type:"boolean",default:q.insertSpace,description:s.localize(306,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:q.ignoreEmptyLines,description:s.localize(307,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{insertSpace:i(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(p||(e.TextEditorCursorBlinkingStyle=p={}));function b(Z){switch(Z){case"blink":return p.Blink;case"smooth":return p.Smooth;case"phase":return p.Phase;case"expand":return p.Expand;case"solid":return p.Solid}}var M;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function A(Z){switch(Z){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function F(Z){switch(Z){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class G extends h{constructor(){super(ve.editorClassName)}compute(q,de,je){const Qe=["monaco-editor"];return de.get(ve.extraEditorClassName)&&Qe.push(de.get(ve.extraEditorClassName)),q.extraEditorClassName&&Qe.push(q.extraEditorClassName),de.get(ve.mouseStyle)==="default"?Qe.push("mouse-default"):de.get(ve.mouseStyle)==="copy"&&Qe.push("mouse-copy"),de.get(ve.showUnused)&&Qe.push("showUnused"),de.get(ve.showDeprecated)&&Qe.push("showDeprecated"),Qe.join(" ")}}class x extends n{constructor(){super(ve.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(308,null)})}compute(q,de,je){return je&&q.emptySelectionClipboard}}class j extends ${constructor(){const q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(ve.find,"find",q,{"editor.find.cursorMoveOnType":{type:"boolean",default:q.cursorMoveOnType,description:s.localize(309,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:q.seedSearchStringFromSelection,enumDescriptions:[s.localize(310,null),s.localize(311,null),s.localize(312,null)],description:s.localize(313,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:q.autoFindInSelection,enumDescriptions:[s.localize(314,null),s.localize(315,null),s.localize(316,null)],description:s.localize(317,null)},"editor.find.globalFindClipboard":{type:"boolean",default:q.globalFindClipboard,description:s.localize(318,null),included:P.$m},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:q.addExtraSpaceOnTop,description:s.localize(319,null)},"editor.find.loop":{type:"boolean",default:q.loop,description:s.localize(320,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{cursorMoveOnType:i(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof q.seedSearchStringFromSelection=="boolean"?q.seedSearchStringFromSelection?"always":"never":d(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof q.autoFindInSelection=="boolean"?q.autoFindInSelection?"always":"never":d(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(de.loop,this.defaultValue.loop)}}}class U extends ${static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(ve.fontLigatures,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:s.localize(321,null)},{type:"string",description:s.localize(322,null)}],description:s.localize(323,null),default:!1})}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q==="false"||q.length===0?U.OFF:q==="true"?U.ON:q:q?U.ON:U.OFF}}e.EditorFontLigatures=U;class J extends ${static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(ve.fontVariations,"fontVariations",J.OFF,{anyOf:[{type:"boolean",description:s.localize(324,null)},{type:"string",description:s.localize(325,null)}],description:s.localize(326,null),default:!1})}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q==="false"?J.OFF:q==="true"?J.TRANSLATE:q:q?J.TRANSLATE:J.OFF}compute(q,de,je){return q.fontInfo.fontVariationSettings}}e.EditorFontVariations=J;class Y extends h{constructor(){super(ve.fontInfo)}compute(q,de,je){return q.fontInfo}}class ae extends c{constructor(){super(ve.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(327,null)})}validate(q){const de=g.float(q,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(de,6,100)}compute(q,de,je){return q.fontInfo.fontSize}}class ee extends ${static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(ve.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ee.d,maximum:ee.e,errorMessage:s.localize(328,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ee.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(329,null)})}validate(q){return q==="normal"||q==="bold"?q:String(o.clampedInt(q,e.EDITOR_FONT_DEFAULTS.fontWeight,ee.d,ee.e))}}class oe extends ${constructor(){const q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:q.multiple,enumDescriptions:[s.localize(330,null),s.localize(331,null),s.localize(332,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(ve.gotoLocation,"gotoLocation",q,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(333,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(334,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(335,null),...de},"editor.gotoLocation.multipleDeclarations":{description:s.localize(336,null),...de},"editor.gotoLocation.multipleImplementations":{description:s.localize(337,null),...de},"editor.gotoLocation.multipleReferences":{description:s.localize(338,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:q.alternativeDefinitionCommand,enum:je,description:s.localize(339,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:q.alternativeTypeDefinitionCommand,enum:je,description:s.localize(340,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:q.alternativeDeclarationCommand,enum:je,description:s.localize(341,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:q.alternativeImplementationCommand,enum:je,description:s.localize(342,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:q.alternativeReferenceCommand,enum:je,description:s.localize(343,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{multiple:d(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??d(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??d(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??d(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??d(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??d(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:de.multipleTests??d(de.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:f.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:f.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:f.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:f.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:f.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:f.string(de.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class ie extends ${constructor(){const q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(ve.hover,"hover",q,{"editor.hover.enabled":{type:"boolean",default:q.enabled,description:s.localize(344,null)},"editor.hover.delay":{type:"number",default:q.delay,minimum:0,maximum:1e4,description:s.localize(345,null)},"editor.hover.sticky":{type:"boolean",default:q.sticky,description:s.localize(346,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:q.hidingDelay,description:s.localize(347,null)},"editor.hover.above":{type:"boolean",default:q.above,description:s.localize(348,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),delay:o.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:i(de.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(de.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(de.above,this.defaultValue.above)}}}var ue;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(ue||(e.RenderMinimap=ue={}));class _ extends h{constructor(){super(ve.layoutInfo)}compute(q,de,je){return _.computeLayout(de,{memory:q.memory,outerWidth:q.outerWidth,outerHeight:q.outerHeight,isDominatedByLongLines:q.isDominatedByLongLines,lineHeight:q.fontInfo.lineHeight,viewLineCount:q.viewLineCount,lineNumbersDigitCount:q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:q.fontInfo.maxDigitWidth,pixelRatio:q.pixelRatio,glyphMarginDecorationLaneCount:q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(q){const de=q.height/q.lineHeight,je=Math.floor(q.paddingTop/q.lineHeight);let Qe=Math.floor(q.paddingBottom/q.lineHeight);q.scrollBeyondLastLine&&(Qe=Math.max(Qe,de-1));const st=(je+q.viewLineCount+Qe)/(q.pixelRatio*q.height),dt=Math.floor(q.viewLineCount/st);return{typicalViewportLineCount:de,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Qe,desiredRatio:st,minimapLineCount:dt}}static c(q,de){const je=q.outerWidth,Qe=q.outerHeight,st=q.pixelRatio;if(!q.minimap.enabled)return{renderMinimap:ue.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const dt=de.stableMinimapLayoutInput,mt=dt&&q.outerHeight===dt.outerHeight&&q.lineHeight===dt.lineHeight&&q.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&q.pixelRatio===dt.pixelRatio&&q.scrollBeyondLastLine===dt.scrollBeyondLastLine&&q.paddingTop===dt.paddingTop&&q.paddingBottom===dt.paddingBottom&&q.minimap.enabled===dt.minimap.enabled&&q.minimap.side===dt.minimap.side&&q.minimap.size===dt.minimap.size&&q.minimap.showSlider===dt.minimap.showSlider&&q.minimap.renderCharacters===dt.minimap.renderCharacters&&q.minimap.maxColumn===dt.minimap.maxColumn&&q.minimap.scale===dt.minimap.scale&&q.verticalScrollbarWidth===dt.verticalScrollbarWidth&&q.isViewportWrapping===dt.isViewportWrapping,Ot=q.lineHeight,Tt=q.typicalHalfwidthCharacterWidth,Qt=q.scrollBeyondLastLine,_t=q.minimap.renderCharacters;let Xe=st>=2?Math.round(q.minimap.scale*2):q.minimap.scale;const At=q.minimap.maxColumn,Ut=q.minimap.size,wt=q.minimap.side,Dt=q.verticalScrollbarWidth,ei=q.viewLineCount,ti=q.remainingWidth,Kt=q.isViewportWrapping,bt=_t?2:3;let Lt=Math.floor(st*Qe);const ci=Lt/st;let Zt=!1,Ge=!1,ii=bt*Xe,li=Xe/st,hi=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:ri,extraLinesBeforeFirstLine:Gt,extraLinesBeyondLastLine:Jt,desiredRatio:ui,minimapLineCount:Nt}=_.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Qt,paddingTop:q.paddingTop,paddingBottom:q.paddingBottom,height:Qe,lineHeight:Ot,pixelRatio:st});if(ei/Nt>1)Zt=!0,Ge=!0,Xe=1,ii=1,li=Xe/st;else{let vt=!1,Xt=Xe+1;if(Ut==="fit"){const Et=Math.ceil((Gt+ei+Jt)*ii);Kt&&mt&&ti<=de.stableFitRemainingWidth?(vt=!0,Xt=de.stableFitMaxMinimapScale):vt=Et>Lt}if(Ut==="fill"||vt){Zt=!0;const Et=Xe;ii=Math.min(Ot*st,Math.max(1,Math.floor(1/ui))),Kt&&mt&&ti<=de.stableFitRemainingWidth&&(Xt=de.stableFitMaxMinimapScale),Xe=Math.min(Xt,Math.max(1,Math.floor(ii/bt))),Xe>Et&&(hi=Math.min(2,Xe/Et)),li=Xe/st/hi,Lt=Math.ceil(Math.max(ri,Gt+ei+Jt)*ii),Kt?(de.stableMinimapLayoutInput=q,de.stableFitRemainingWidth=ti,de.stableFitMaxMinimapScale=Xe):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const kt=Math.floor(At*li),jt=Math.min(kt,Math.max(0,Math.floor((ti-Dt-2)*li/(Tt+li)))+e.MINIMAP_GUTTER_WIDTH);let Mt=Math.floor(st*jt);const Bt=Mt/st;Mt=Math.floor(Mt*hi);const ai=_t?ue.Text:ue.Blocks,ni=wt==="left"?0:je-jt-Dt;return{renderMinimap:ai,minimapLeft:ni,minimapWidth:jt,minimapHeightIsEditorHeight:Zt,minimapIsSampling:Ge,minimapScale:Xe,minimapLineHeight:ii,minimapCanvasInnerWidth:Mt,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:Bt,minimapCanvasOuterHeight:ci}}static computeLayout(q,de){const je=de.outerWidth|0,Qe=de.outerHeight|0,st=de.lineHeight|0,dt=de.lineNumbersDigitCount|0,mt=de.typicalHalfwidthCharacterWidth,Ot=de.maxDigitWidth,Tt=de.pixelRatio,Qt=de.viewLineCount,_t=q.get(ve.wordWrapOverride2),Xe=_t==="inherit"?q.get(ve.wordWrapOverride1):_t,At=Xe==="inherit"?q.get(ve.wordWrap):Xe,Ut=q.get(ve.wordWrapColumn),wt=de.isDominatedByLongLines,Dt=q.get(ve.glyphMargin),ei=q.get(ve.lineNumbers).renderType!==et.Off,ti=q.get(ve.lineNumbersMinChars),Kt=q.get(ve.scrollBeyondLastLine),bt=q.get(ve.padding),Lt=q.get(ve.minimap),ci=q.get(ve.scrollbar),Zt=ci.verticalScrollbarSize,Ge=ci.verticalHasArrows,ii=ci.arrowSize,li=ci.horizontalScrollbarSize,hi=q.get(ve.folding),kt=q.get(ve.showFoldingControls)!=="never";let jt=q.get(ve.lineDecorationsWidth);hi&&kt&&(jt+=16);let Mt=0;if(ei){const Yt=Math.max(dt,ti);Mt=Math.round(Yt*Ot)}let Bt=0;Dt&&(Bt=st*de.glyphMarginDecorationLaneCount);let ai=0,ni=ai+Bt,ri=ni+Mt,Gt=ri+jt;const Jt=je-Bt-Mt-jt;let ui=!1,Nt=!1,Ct=-1;Xe==="inherit"&&wt?(ui=!0,Nt=!0):At==="on"||At==="bounded"?Nt=!0:At==="wordWrapColumn"&&(Ct=Ut);const vt=_.c({outerWidth:je,outerHeight:Qe,lineHeight:st,typicalHalfwidthCharacterWidth:mt,pixelRatio:Tt,scrollBeyondLastLine:Kt,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:Lt,verticalScrollbarWidth:Zt,viewLineCount:Qt,remainingWidth:Jt,isViewportWrapping:Nt},de.memory||new k);vt.renderMinimap!==ue.None&&vt.minimapLeft===0&&(ai+=vt.minimapWidth,ni+=vt.minimapWidth,ri+=vt.minimapWidth,Gt+=vt.minimapWidth);const Xt=Jt-vt.minimapWidth,Et=Math.max(1,Math.floor((Xt-Zt-2)/mt)),si=Ge?ii:0;return Nt&&(Ct=Math.max(1,Et),At==="bounded"&&(Ct=Math.min(Ct,Ut))),{width:je,height:Qe,glyphMarginLeft:ai,glyphMarginWidth:Bt,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount,lineNumbersLeft:ni,lineNumbersWidth:Mt,decorationsLeft:ri,decorationsWidth:jt,contentLeft:Gt,contentWidth:Xt,minimap:vt,viewportColumn:Et,isWordWrapMinified:ui,isViewportWrapping:Nt,wrappingColumn:Ct,verticalScrollbarWidth:Zt,horizontalScrollbarHeight:li,overviewRuler:{top:si,width:Zt,height:Qe-2*si,right:0}}}}e.EditorLayoutInfoComputer=_;class $e extends ${constructor(){super(ve.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(349,null),s.localize(350,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(351,null)}})}validate(q){return d(q,"simple",["simple","advanced"])}compute(q,de,je){return de.get(ve.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":je}}var Ie;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(Ie||(e.ShowLightbulbIconMode=Ie={}));class X extends ${constructor(){const q={enabled:Ie.OnCode};super(ve.lightbulb,"lightbulb",q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ie.Off,Ie.OnCode,Ie.On],default:q.enabled,enumDescriptions:[s.localize(352,null),s.localize(353,null),s.localize(354,null)],description:s.localize(355,null)}})}validate(q){return!q||typeof q!="object"?this.defaultValue:{enabled:d(q.enabled,this.defaultValue.enabled,[Ie.Off,Ie.OnCode,Ie.On])}}}class V extends ${constructor(){const q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(ve.stickyScroll,"stickyScroll",q,{"editor.stickyScroll.enabled":{type:"boolean",default:q.enabled,description:s.localize(356,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:q.maxLineCount,minimum:1,maximum:20,description:s.localize(357,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:q.defaultModel,description:s.localize(358,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:q.scrollWithEditor,description:s.localize(359,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(de.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d(de.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(de.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends ${constructor(){const q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(ve.inlayHints,"inlayHints",q,{"editor.inlayHints.enabled":{type:"string",default:q.enabled,description:s.localize(360,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(361,null),s.localize(362,null,P.$m?"Ctrl+Option":"Ctrl+Alt"),s.localize(363,null,P.$m?"Ctrl+Option":"Ctrl+Alt"),s.localize(364,null)]},"editor.inlayHints.fontSize":{type:"number",default:q.fontSize,markdownDescription:s.localize(365,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:q.fontFamily,markdownDescription:s.localize(366,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:q.padding,description:s.localize(367,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return typeof de.enabled=="boolean"&&(de.enabled=de.enabled?"on":"off"),{enabled:d(de.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:f.string(de.fontFamily,this.defaultValue.fontFamily),padding:i(de.padding,this.defaultValue.padding)}}}class be extends ${constructor(){super(ve.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(q){return typeof q=="string"&&/^\d+(\.\d+)?ch$/.test(q)?-parseFloat(q.substring(0,q.length-2)):o.clampedInt(q,this.defaultValue,0,1e3)}compute(q,de,je){return je<0?o.clampedInt(-je*q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class Pe extends g{constructor(){super(ve.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,q=>g.clamp(q,0,150),{markdownDescription:s.localize(368,null)})}compute(q,de,je){return q.fontInfo.lineHeight}}class Fe extends ${constructor(){const q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(ve.minimap,"minimap",q,{"editor.minimap.enabled":{type:"boolean",default:q.enabled,description:s.localize(369,null)},"editor.minimap.autohide":{type:"boolean",default:q.autohide,description:s.localize(370,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(371,null),s.localize(372,null),s.localize(373,null)],default:q.size,description:s.localize(374,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:q.side,description:s.localize(375,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:q.showSlider,description:s.localize(376,null)},"editor.minimap.scale":{type:"number",default:q.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(377,null)},"editor.minimap.renderCharacters":{type:"boolean",default:q.renderCharacters,description:s.localize(378,null)},"editor.minimap.maxColumn":{type:"number",default:q.maxColumn,description:s.localize(379,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:q.showRegionSectionHeaders,description:s.localize(380,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:q.showMarkSectionHeaders,description:s.localize(381,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:q.sectionHeaderFontSize,description:s.localize(382,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:q.sectionHeaderLetterSpacing,description:s.localize(383,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),autohide:i(de.autohide,this.defaultValue.autohide),size:d(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(de.side,this.defaultValue.side,["right","left"]),showSlider:d(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(de.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(de.scale,1,1,3),maxColumn:o.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(de.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(de.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:g.clamp(de.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:g.clamp(de.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function Be(Z){return Z==="ctrlCmd"?P.$m?"metaKey":"ctrlKey":"altKey"}class xe extends ${constructor(){super(ve.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(384,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(385,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{top:o.clampedInt(de.top,0,0,1e3),bottom:o.clampedInt(de.bottom,0,0,1e3)}}}class nt extends ${constructor(){const q={enabled:!0,cycle:!0};super(ve.parameterHints,"parameterHints",q,{"editor.parameterHints.enabled":{type:"boolean",default:q.enabled,description:s.localize(386,null)},"editor.parameterHints.cycle":{type:"boolean",default:q.cycle,description:s.localize(387,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),cycle:i(de.cycle,this.defaultValue.cycle)}}}class ht extends h{constructor(){super(ve.pixelRatio)}compute(q,de,je){return q.pixelRatio}}class $t extends ${constructor(){super(ve.placeholder,"placeholder",void 0)}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q:this.defaultValue}}class ut extends ${constructor(){const q={other:"on",comments:"off",strings:"off"},de=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(388,null),s.localize(389,null),s.localize(390,null)]}];super(ve.quickSuggestions,"quickSuggestions",q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:de,default:q.strings,description:s.localize(391,null)},comments:{anyOf:de,default:q.comments,description:s.localize(392,null)},other:{anyOf:de,default:q.other,description:s.localize(393,null)}},default:q,markdownDescription:s.localize(394,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=q}validate(q){if(typeof q=="boolean"){const Tt=q?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!q||typeof q!="object")return this.defaultValue;const{other:de,comments:je,strings:Qe}=q,st=["on","inline","off"];let dt,mt,Ot;return typeof de=="boolean"?dt=de?"on":"off":dt=d(de,this.defaultValue.other,st),typeof je=="boolean"?mt=je?"on":"off":mt=d(je,this.defaultValue.comments,st),typeof Qe=="boolean"?Ot=Qe?"on":"off":Ot=d(Qe,this.defaultValue.strings,st),{other:dt,comments:mt,strings:Ot}}}var et;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(et||(e.RenderLineNumbersType=et={}));class Le extends ${constructor(){super(ve.lineNumbers,"lineNumbers",{renderType:et.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(395,null),s.localize(396,null),s.localize(397,null),s.localize(398,null)],default:"on",description:s.localize(399,null)})}validate(q){let de=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof q<"u"&&(typeof q=="function"?(de=et.Custom,je=q):q==="interval"?de=et.Interval:q==="relative"?de=et.Relative:q==="on"?de=et.On:de=et.Off),{renderType:de,renderFn:je}}}function Ne(Z){const q=Z.get(ve.renderValidationDecorations);return q==="editable"?Z.get(ve.readOnly):q!=="on"}class Me extends ${constructor(){const q=[],de={type:"number",description:s.localize(400,null)};super(ve.rulers,"rulers",q,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:s.localize(401,null),format:"color-hex"}}}]},default:q,description:s.localize(402,null)})}validate(q){if(Array.isArray(q)){const de=[];for(const je of q)if(typeof je=="number")de.push({column:o.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Qe=je;de.push({column:o.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return de.sort((je,Qe)=>je.column-Qe.column),de}return this.defaultValue}}class W extends ${constructor(){super(ve.readOnlyMessage,"readOnlyMessage",void 0)}validate(q){return!q||typeof q!="object"?this.defaultValue:q}}function B(Z,q){if(typeof Z!="string")return q;switch(Z){case"hidden":return L.ScrollbarVisibility.Hidden;case"visible":return L.ScrollbarVisibility.Visible;default:return L.ScrollbarVisibility.Auto}}class Q extends ${constructor(){const q={vertical:L.ScrollbarVisibility.Auto,horizontal:L.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(ve.scrollbar,"scrollbar",q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(403,null),s.localize(404,null),s.localize(405,null)],default:"auto",description:s.localize(406,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(407,null),s.localize(408,null),s.localize(409,null)],default:"auto",description:s.localize(410,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:q.verticalScrollbarSize,description:s.localize(411,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:q.horizontalScrollbarSize,description:s.localize(412,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:q.scrollByPage,description:s.localize(413,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:q.ignoreHorizontalScrollbarInContentHeight,description:s.localize(414,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q,je=o.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=o.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(de.vertical,this.defaultValue.vertical),horizontal:B(de.horizontal,this.defaultValue.horizontal),useShadows:i(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:o.clampedInt(de.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:o.clampedInt(de.verticalSliderSize,Qe,0,1e3),scrollByPage:i(de.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(de.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends ${constructor(){const q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(ve.unicodeHighlighting,"unicodeHighlight",q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.nonBasicASCII,description:s.localize(415,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:q.invisibleCharacters,description:s.localize(416,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:q.ambiguousCharacters,description:s.localize(417,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.includeComments,description:s.localize(418,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.includeStrings,description:s.localize(419,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:q.allowedCharacters,description:s.localize(420,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:q.allowedLocales,description:s.localize(421,null)}})}applyUpdate(q,de){let je=!1;de.allowedCharacters&&q&&(D.$oo(q.allowedCharacters,de.allowedCharacters)||(q={...q,allowedCharacters:de.allowedCharacters},je=!0)),de.allowedLocales&&q&&(D.$oo(q.allowedLocales,de.allowedLocales)||(q={...q,allowedLocales:de.allowedLocales},je=!0));const Qe=super.applyUpdate(q,de);return je?new r(Qe.newValue,!0):Qe}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{nonBasicASCII:Je(de.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(de.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(de.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Je(de.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Je(de.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(q.allowedLocales,this.defaultValue.allowedLocales)}}c(q,de){if(typeof q!="object"||!q)return de;const je={};for(const[Qe,st]of Object.entries(q))st===!0&&(je[Qe]=!0);return je}}class se extends ${constructor(){const q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(ve.inlineSuggest,"inlineSuggest",q,{"editor.inlineSuggest.enabled":{type:"boolean",default:q.enabled,description:s.localize(422,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(423,null),s.localize(424,null),s.localize(425,null)],description:s.localize(426,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:q.suppressSuggestions,description:s.localize(427,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:q.fontFamily,description:s.localize(428,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),mode:d(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(de.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:f.string(de.fontFamily,this.defaultValue.fontFamily)}}}class ge extends ${constructor(){const q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(ve.inlineEdit,"experimentalInlineEdit",q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:q.enabled,description:s.localize(429,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(430,null),s.localize(431,null),s.localize(432,null)],description:s.localize(433,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:q.fontFamily,description:s.localize(434,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),showToolbar:d(de.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:f.string(de.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(de.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ee extends ${constructor(){const q={enabled:T.$tt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$tt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(ve.bracketPairColorization,"bracketPairColorization",q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:q.enabled,markdownDescription:s.localize(435,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:q.independentColorPoolPerBracketType,description:s.localize(436,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(de.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ze extends ${constructor(){const q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(ve.guides,"guides",q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(437,null),s.localize(438,null),s.localize(439,null)],default:q.bracketPairs,description:s.localize(440,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(441,null),s.localize(442,null),s.localize(443,null)],default:q.bracketPairsHorizontal,description:s.localize(444,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:q.highlightActiveBracketPair,description:s.localize(445,null)},"editor.guides.indentation":{type:"boolean",default:q.indentation,description:s.localize(446,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(447,null),s.localize(448,null),s.localize(449,null)],default:q.highlightActiveIndentation,description:s.localize(450,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{bracketPairs:Je(de.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Je(de.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(de.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(de.indentation,this.defaultValue.indentation),highlightActiveIndentation:Je(de.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Je(Z,q,de){const je=de.indexOf(Z);return je===-1?q:de[je]}class _e extends ${constructor(){const q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(ve.suggest,"suggest",q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(451,null),s.localize(452,null)],default:q.insertMode,description:s.localize(453,null)},"editor.suggest.filterGraceful":{type:"boolean",default:q.filterGraceful,description:s.localize(454,null)},"editor.suggest.localityBonus":{type:"boolean",default:q.localityBonus,description:s.localize(455,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:q.shareSuggestSelections,markdownDescription:s.localize(456,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(457,null),s.localize(458,null),s.localize(459,null),s.localize(460,null)],default:q.selectionMode,markdownDescription:s.localize(461,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:q.snippetsPreventQuickSuggestions,description:s.localize(462,null)},"editor.suggest.showIcons":{type:"boolean",default:q.showIcons,description:s.localize(463,null)},"editor.suggest.showStatusBar":{type:"boolean",default:q.showStatusBar,description:s.localize(464,null)},"editor.suggest.preview":{type:"boolean",default:q.preview,description:s.localize(465,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:q.showInlineDetails,description:s.localize(466,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(467,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(468,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(469,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(470,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(471,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(472,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(473,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(474,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(475,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(476,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(477,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(478,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(479,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(480,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(481,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(482,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(483,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(484,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(485,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(486,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(487,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(488,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(489,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(490,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(491,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(492,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(493,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(494,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(495,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(496,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(497,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(498,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{insertMode:d(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(de.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(de.showIcons,this.defaultValue.showIcons),showStatusBar:i(de.showStatusBar,this.defaultValue.showStatusBar),preview:i(de.preview,this.defaultValue.preview),previewMode:d(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(de.showMethods,this.defaultValue.showMethods),showFunctions:i(de.showFunctions,this.defaultValue.showFunctions),showConstructors:i(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(de.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(de.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(de.showFields,this.defaultValue.showFields),showVariables:i(de.showVariables,this.defaultValue.showVariables),showClasses:i(de.showClasses,this.defaultValue.showClasses),showStructs:i(de.showStructs,this.defaultValue.showStructs),showInterfaces:i(de.showInterfaces,this.defaultValue.showInterfaces),showModules:i(de.showModules,this.defaultValue.showModules),showProperties:i(de.showProperties,this.defaultValue.showProperties),showEvents:i(de.showEvents,this.defaultValue.showEvents),showOperators:i(de.showOperators,this.defaultValue.showOperators),showUnits:i(de.showUnits,this.defaultValue.showUnits),showValues:i(de.showValues,this.defaultValue.showValues),showConstants:i(de.showConstants,this.defaultValue.showConstants),showEnums:i(de.showEnums,this.defaultValue.showEnums),showEnumMembers:i(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(de.showKeywords,this.defaultValue.showKeywords),showWords:i(de.showWords,this.defaultValue.showWords),showColors:i(de.showColors,this.defaultValue.showColors),showFiles:i(de.showFiles,this.defaultValue.showFiles),showReferences:i(de.showReferences,this.defaultValue.showReferences),showFolders:i(de.showFolders,this.defaultValue.showFolders),showTypeParameters:i(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(de.showSnippets,this.defaultValue.showSnippets),showUsers:i(de.showUsers,this.defaultValue.showUsers),showIssues:i(de.showIssues,this.defaultValue.showIssues)}}}class tt extends ${constructor(){super(ve.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(499,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(500,null),default:!0,type:"boolean"}})}validate(q){return!q||typeof q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(q.selectSubwords,this.defaultValue.selectSubwords)}}}class ct extends ${constructor(){const q=[];super(ve.wordSegmenterLocales,"wordSegmenterLocales",q,{anyOf:[{description:s.localize(501,null),type:"string"},{description:s.localize(502,null),type:"array",items:{type:"string"}}]})}validate(q){if(typeof q=="string"&&(q=[q]),Array.isArray(q)){const de=[];for(const je of q)if(typeof je=="string")try{Intl.Segmenter.supportedLocalesOf(je).length>0&&de.push(je)}catch{}return de}return this.defaultValue}}var it;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(it||(e.WrappingIndent=it={}));class at extends ${constructor(){super(ve.wrappingIndent,"wrappingIndent",it.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(503,null),s.localize(504,null),s.localize(505,null),s.localize(506,null)],description:s.localize(507,null),default:"same"}})}validate(q){switch(q){case"none":return it.None;case"same":return it.Same;case"indent":return it.Indent;case"deepIndent":return it.DeepIndent}return it.Same}compute(q,de,je){return de.get(ve.accessibilitySupport)===I.AccessibilitySupport.Enabled?it.None:je}}class yt extends h{constructor(){super(ve.wrappingInfo)}compute(q,de,je){const Qe=de.get(ve.layoutInfo);return{isDominatedByLongLines:q.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class Ze extends ${constructor(){const q={enabled:!0,showDropSelector:"afterDrop"};super(ve.dropIntoEditor,"dropIntoEditor",q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:q.enabled,markdownDescription:s.localize(508,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(509,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(510,null),s.localize(511,null)],default:"afterDrop"}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),showDropSelector:d(de.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class he extends ${constructor(){const q={enabled:!0,showPasteSelector:"afterPaste"};super(ve.pasteAs,"pasteAs",q,{"editor.pasteAs.enabled":{type:"boolean",default:q.enabled,markdownDescription:s.localize(512,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(513,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(514,null),s.localize(515,null)],default:"afterPaste"}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const de=q;return{enabled:i(de.enabled,this.defaultValue.enabled),showPasteSelector:d(de.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const pe="Consolas, 'Courier New', monospace",ye="Menlo, Monaco, 'Courier New', monospace",Ce="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$m?ye:P.$n?Ce:pe,fontWeight:"normal",fontSize:P.$m?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function fe(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var ve;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.placeholder=88]="placeholder",Z[Z.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=90]="quickSuggestions",Z[Z.quickSuggestionsDelay=91]="quickSuggestionsDelay",Z[Z.readOnly=92]="readOnly",Z[Z.readOnlyMessage=93]="readOnlyMessage",Z[Z.renameOnType=94]="renameOnType",Z[Z.renderControlCharacters=95]="renderControlCharacters",Z[Z.renderFinalNewline=96]="renderFinalNewline",Z[Z.renderLineHighlight=97]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=99]="renderValidationDecorations",Z[Z.renderWhitespace=100]="renderWhitespace",Z[Z.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Z[Z.roundedSelection=102]="roundedSelection",Z[Z.rulers=103]="rulers",Z[Z.scrollbar=104]="scrollbar",Z[Z.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=106]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=107]="scrollPredominantAxis",Z[Z.selectionClipboard=108]="selectionClipboard",Z[Z.selectionHighlight=109]="selectionHighlight",Z[Z.selectOnLineNumbers=110]="selectOnLineNumbers",Z[Z.showFoldingControls=111]="showFoldingControls",Z[Z.showUnused=112]="showUnused",Z[Z.snippetSuggestions=113]="snippetSuggestions",Z[Z.smartSelect=114]="smartSelect",Z[Z.smoothScrolling=115]="smoothScrolling",Z[Z.stickyScroll=116]="stickyScroll",Z[Z.stickyTabStops=117]="stickyTabStops",Z[Z.stopRenderingLineAfter=118]="stopRenderingLineAfter",Z[Z.suggest=119]="suggest",Z[Z.suggestFontSize=120]="suggestFontSize",Z[Z.suggestLineHeight=121]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Z[Z.suggestSelection=123]="suggestSelection",Z[Z.tabCompletion=124]="tabCompletion",Z[Z.tabIndex=125]="tabIndex",Z[Z.unicodeHighlighting=126]="unicodeHighlighting",Z[Z.unusualLineTerminators=127]="unusualLineTerminators",Z[Z.useShadowDOM=128]="useShadowDOM",Z[Z.useTabStops=129]="useTabStops",Z[Z.wordBreak=130]="wordBreak",Z[Z.wordSegmenterLocales=131]="wordSegmenterLocales",Z[Z.wordSeparators=132]="wordSeparators",Z[Z.wordWrap=133]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=136]="wordWrapColumn",Z[Z.wordWrapOverride1=137]="wordWrapOverride1",Z[Z.wordWrapOverride2=138]="wordWrapOverride2",Z[Z.wrappingIndent=139]="wrappingIndent",Z[Z.wrappingStrategy=140]="wrappingStrategy",Z[Z.showDeprecated=141]="showDeprecated",Z[Z.inlayHints=142]="inlayHints",Z[Z.editorClassName=143]="editorClassName",Z[Z.pixelRatio=144]="pixelRatio",Z[Z.tabFocusMode=145]="tabFocusMode",Z[Z.layoutInfo=146]="layoutInfo",Z[Z.wrappingInfo=147]="wrappingInfo",Z[Z.defaultColorDecorators=148]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(ve||(e.EditorOption=ve={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:fe(new n(ve.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(516,null)})),acceptSuggestionOnEnter:fe(new S(ve.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(517,null),""],markdownDescription:s.localize(518,null)})),accessibilitySupport:fe(new C),accessibilityPageSize:fe(new o(ve.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(519,null),tags:["accessibility"]})),ariaLabel:fe(new f(ve.ariaLabel,"ariaLabel",s.localize(520,null))),ariaRequired:fe(new n(ve.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:fe(new n(ve.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(521,null),tags:["accessibility"]})),autoClosingBrackets:fe(new S(ve.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(522,null),s.localize(523,null),""],description:s.localize(524,null)})),autoClosingComments:fe(new S(ve.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(525,null),s.localize(526,null),""],description:s.localize(527,null)})),autoClosingDelete:fe(new S(ve.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(528,null),""],description:s.localize(529,null)})),autoClosingOvertype:fe(new S(ve.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(530,null),""],description:s.localize(531,null)})),autoClosingQuotes:fe(new S(ve.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(532,null),s.localize(533,null),""],description:s.localize(534,null)})),autoIndent:fe(new E(ve.autoIndent,"autoIndent",w.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[s.localize(535,null),s.localize(536,null),s.localize(537,null),s.localize(538,null),s.localize(539,null)],description:s.localize(540,null)})),automaticLayout:fe(new n(ve.automaticLayout,"automaticLayout",!1)),autoSurround:fe(new S(ve.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(541,null),s.localize(542,null),s.localize(543,null),""],description:s.localize(544,null)})),bracketPairColorization:fe(new Ee),bracketPairGuides:fe(new ze),stickyTabStops:fe(new n(ve.stickyTabStops,"stickyTabStops",!1,{description:s.localize(545,null)})),codeLens:fe(new n(ve.codeLens,"codeLens",!0,{description:s.localize(546,null)})),codeLensFontFamily:fe(new f(ve.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(547,null)})),codeLensFontSize:fe(new o(ve.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(548,null)})),colorDecorators:fe(new n(ve.colorDecorators,"colorDecorators",!0,{description:s.localize(549,null)})),colorDecoratorActivatedOn:fe(new S(ve.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(550,null),s.localize(551,null),s.localize(552,null)],description:s.localize(553,null)})),colorDecoratorsLimit:fe(new o(ve.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(554,null)})),columnSelection:fe(new n(ve.columnSelection,"columnSelection",!1,{description:s.localize(555,null)})),comments:fe(new O),contextmenu:fe(new n(ve.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:fe(new n(ve.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(556,null)})),cursorBlinking:fe(new E(ve.cursorBlinking,"cursorBlinking",p.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:s.localize(557,null)})),cursorSmoothCaretAnimation:fe(new S(ve.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(558,null),s.localize(559,null),s.localize(560,null)],description:s.localize(561,null)})),cursorStyle:fe(new E(ve.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:s.localize(562,null)})),cursorSurroundingLines:fe(new o(ve.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(563,null)})),cursorSurroundingLinesStyle:fe(new S(ve.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(564,null),s.localize(565,null)],markdownDescription:s.localize(566,null)})),cursorWidth:fe(new o(ve.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(567,null)})),disableLayerHinting:fe(new n(ve.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:fe(new n(ve.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:fe(new n(ve.domReadOnly,"domReadOnly",!1)),dragAndDrop:fe(new n(ve.dragAndDrop,"dragAndDrop",!0,{description:s.localize(568,null)})),emptySelectionClipboard:fe(new x),dropIntoEditor:fe(new Ze),stickyScroll:fe(new V),experimentalWhitespaceRendering:fe(new S(ve.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(569,null),s.localize(570,null),s.localize(571,null)],description:s.localize(572,null)})),extraEditorClassName:fe(new f(ve.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:fe(new g(ve.fastScrollSensitivity,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:s.localize(573,null)})),find:fe(new j),fixedOverflowWidgets:fe(new n(ve.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:fe(new n(ve.folding,"folding",!0,{description:s.localize(574,null)})),foldingStrategy:fe(new S(ve.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(575,null),s.localize(576,null)],description:s.localize(577,null)})),foldingHighlight:fe(new n(ve.foldingHighlight,"foldingHighlight",!0,{description:s.localize(578,null)})),foldingImportsByDefault:fe(new n(ve.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(579,null)})),foldingMaximumRegions:fe(new o(ve.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(580,null)})),unfoldOnClickAfterEndOfLine:fe(new n(ve.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(581,null)})),fontFamily:fe(new f(ve.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(582,null)})),fontInfo:fe(new Y),fontLigatures2:fe(new U),fontSize:fe(new ae),fontWeight:fe(new ee),fontVariations:fe(new J),formatOnPaste:fe(new n(ve.formatOnPaste,"formatOnPaste",!1,{description:s.localize(583,null)})),formatOnType:fe(new n(ve.formatOnType,"formatOnType",!1,{description:s.localize(584,null)})),glyphMargin:fe(new n(ve.glyphMargin,"glyphMargin",!0,{description:s.localize(585,null)})),gotoLocation:fe(new oe),hideCursorInOverviewRuler:fe(new n(ve.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(586,null)})),hover:fe(new ie),inDiffEditor:fe(new n(ve.inDiffEditor,"inDiffEditor",!1)),letterSpacing:fe(new g(ve.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>g.clamp(Z,-5,20),{description:s.localize(587,null)})),lightbulb:fe(new X),lineDecorationsWidth:fe(new be),lineHeight:fe(new Pe),lineNumbers:fe(new Le),lineNumbersMinChars:fe(new o(ve.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:fe(new n(ve.linkedEditing,"linkedEditing",!1,{description:s.localize(588,null)})),links:fe(new n(ve.links,"links",!0,{description:s.localize(589,null)})),matchBrackets:fe(new S(ve.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(590,null)})),minimap:fe(new Fe),mouseStyle:fe(new S(ve.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:fe(new g(ve.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:s.localize(591,null)})),mouseWheelZoom:fe(new n(ve.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$m?s.localize(592,null):s.localize(593,null)})),multiCursorMergeOverlapping:fe(new n(ve.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(594,null)})),multiCursorModifier:fe(new E(ve.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Be,{markdownEnumDescriptions:[s.localize(595,null),s.localize(596,null)],markdownDescription:s.localize(597,null)})),multiCursorPaste:fe(new S(ve.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(598,null),s.localize(599,null)],markdownDescription:s.localize(600,null)})),multiCursorLimit:fe(new o(ve.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(601,null)})),occurrencesHighlight:fe(new S(ve.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(602,null),s.localize(603,null),s.localize(604,null)],markdownDescription:s.localize(605,null)})),overviewRulerBorder:fe(new n(ve.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(606,null)})),overviewRulerLanes:fe(new o(ve.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:fe(new xe),pasteAs:fe(new he),parameterHints:fe(new nt),peekWidgetDefaultFocus:fe(new S(ve.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(607,null),s.localize(608,null)],description:s.localize(609,null)})),placeholder:fe(new $t),definitionLinkOpensInPeek:fe(new n(ve.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(610,null)})),quickSuggestions:fe(new ut),quickSuggestionsDelay:fe(new o(ve.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(611,null)})),readOnly:fe(new n(ve.readOnly,"readOnly",!1)),readOnlyMessage:fe(new W),renameOnType:fe(new n(ve.renameOnType,"renameOnType",!1,{description:s.localize(612,null),markdownDeprecationMessage:s.localize(613,null)})),renderControlCharacters:fe(new n(ve.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(614,null),restricted:!0})),renderFinalNewline:fe(new S(ve.renderFinalNewline,"renderFinalNewline",P.$n?"dimmed":"on",["off","on","dimmed"],{description:s.localize(615,null)})),renderLineHighlight:fe(new S(ve.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(616,null)],description:s.localize(617,null)})),renderLineHighlightOnlyWhenFocus:fe(new n(ve.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(618,null)})),renderValidationDecorations:fe(new S(ve.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:fe(new S(ve.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(619,null),s.localize(620,null),s.localize(621,null),""],description:s.localize(622,null)})),revealHorizontalRightPadding:fe(new o(ve.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:fe(new n(ve.roundedSelection,"roundedSelection",!0,{description:s.localize(623,null)})),rulers:fe(new Me),scrollbar:fe(new Q),scrollBeyondLastColumn:fe(new o(ve.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(624,null)})),scrollBeyondLastLine:fe(new n(ve.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(625,null)})),scrollPredominantAxis:fe(new n(ve.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(626,null)})),selectionClipboard:fe(new n(ve.selectionClipboard,"selectionClipboard",!0,{description:s.localize(627,null),included:P.$n})),selectionHighlight:fe(new n(ve.selectionHighlight,"selectionHighlight",!0,{description:s.localize(628,null)})),selectOnLineNumbers:fe(new n(ve.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:fe(new S(ve.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(629,null),s.localize(630,null),s.localize(631,null)],description:s.localize(632,null)})),showUnused:fe(new n(ve.showUnused,"showUnused",!0,{description:s.localize(633,null)})),showDeprecated:fe(new n(ve.showDeprecated,"showDeprecated",!0,{description:s.localize(634,null)})),inlayHints:fe(new re),snippetSuggestions:fe(new S(ve.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(635,null),s.localize(636,null),s.localize(637,null),s.localize(638,null)],description:s.localize(639,null)})),smartSelect:fe(new tt),smoothScrolling:fe(new n(ve.smoothScrolling,"smoothScrolling",!1,{description:s.localize(640,null)})),stopRenderingLineAfter:fe(new o(ve.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:fe(new _e),inlineSuggest:fe(new se),inlineEdit:fe(new ge),inlineCompletionsAccessibilityVerbose:fe(new n(ve.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(641,null)})),suggestFontSize:fe(new o(ve.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(642,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:fe(new o(ve.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(643,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:fe(new n(ve.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(644,null)})),suggestSelection:fe(new S(ve.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(645,null),s.localize(646,null),s.localize(647,null)],description:s.localize(648,null)})),tabCompletion:fe(new S(ve.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(649,null),s.localize(650,null),s.localize(651,null)],description:s.localize(652,null)})),tabIndex:fe(new o(ve.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:fe(new K),unusualLineTerminators:fe(new S(ve.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(653,null),s.localize(654,null),s.localize(655,null)],description:s.localize(656,null)})),useShadowDOM:fe(new n(ve.useShadowDOM,"useShadowDOM",!0)),useTabStops:fe(new n(ve.useTabStops,"useTabStops",!0,{description:s.localize(657,null)})),wordBreak:fe(new S(ve.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(658,null),s.localize(659,null)],description:s.localize(660,null)})),wordSegmenterLocales:fe(new ct),wordSeparators:fe(new f(ve.wordSeparators,"wordSeparators",m.$ut,{description:s.localize(661,null)})),wordWrap:fe(new S(ve.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(662,null),s.localize(663,null),s.localize(664,null),s.localize(665,null)],description:s.localize(666,null)})),wordWrapBreakAfterCharacters:fe(new f(ve.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:fe(new f(ve.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:fe(new o(ve.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(667,null)})),wordWrapOverride1:fe(new S(ve.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:fe(new S(ve.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:fe(new G),defaultColorDecorators:fe(new n(ve.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(668,null)})),pixelRatio:fe(new ht),tabFocusMode:fe(new n(ve.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(669,null)})),layoutInfo:fe(new _),wrappingInfo:fe(new yt),wrappingIndent:fe(new at),wrappingStrategy:fe(new $e)}}),define(Re[107],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=void 0,e.$Ri=(0,v.$Ki)("environmentService"),e.$Si=(0,v.$Li)(e.$Ri)}),define(Re[28],Oe([1,0,48,22,13,14,2,9,3,23,15,51]),function(we,e,v,D,P,L,R,T,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Kl=e.FileKind=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.FileOperationResult=e.$Cl=e.$Bl=e.$Al=e.$yl=e.FileChangeType=e.$xl=e.FileOperation=e.$rl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$fl=void 0,e.$gl=u,e.$hl=a,e.$il=c,e.$jl=i,e.$kl=n,e.$ll=t,e.$ml=o,e.$nl=l,e.$ol=g,e.$pl=f,e.$ql=d,e.$sl=y,e.$tl=C,e.$ul=O,e.$vl=p,e.$wl=b,e.$zl=x,e.$Ll=ee,e.$Ml=oe,e.$Ol=ue,e.$fl=(0,m.$Ki)("fileService");function u(_){return _.create===!0}var k;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var $;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})($||(e.FilePermission=$={}));var r;(function(_){_[_.UPDATED=2]="UPDATED",_[_.ADDED=4]="ADDED",_[_.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function a(_){const $e=_;return!!$e&&typeof $e.onDidChange=="function"}var h;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(h||(e.FileSystemProviderCapabilities=h={}));function c(_){return!!(_.capabilities&h.FileReadWrite)}function i(_){return!!(_.capabilities&h.FileFolderCopy)}function n(_){return!!(_.capabilities&h.FileClone)}function t(_){return!!(_.capabilities&h.FileOpenReadWriteClose)}function o(_){return!!(_.capabilities&h.FileReadStream)}function l(_){return c(_)?!!(_.capabilities&h.FileAtomicRead):!1}function g(_){return c(_)?!!(_.capabilities&h.FileAtomicWrite):!1}function f(_){return!!(_.capabilities&h.FileAtomicDelete)}function d(_){return!!(_.capabilities&h.Readonly)}var S;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class E extends Error{static create($e,Ie){const X=new E($e.toString(),Ie);return O(X,Ie),X}constructor($e,Ie){super($e),this.code=Ie}}e.$rl=E;function y(_,$e){return E.create(_,$e)}function C(_){return _||y((0,T.localize)(1865,null),S.Unknown)}function O(_,$e){return _.name=$e?`${$e} (FileSystemError)`:"FileSystemError",_}function p(_){if(!_)return S.Unknown;if(_ instanceof E)return _.code;const $e=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!$e)return S.Unknown;switch($e[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function b(_){if(_ instanceof j)return _.fileOperationResult;switch(p(_)){case S.FileNotFound:return Y.FILE_NOT_FOUND;case S.FileIsADirectory:return Y.FILE_IS_DIRECTORY;case S.FileNotADirectory:return Y.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return Y.FILE_WRITE_LOCKED;case S.NoPermissions:return Y.FILE_PERMISSION_DENIED;case S.FileExists:return Y.FILE_MOVE_CONFLICT;case S.FileTooLarge:return Y.FILE_TOO_LARGE;default:return Y.FILE_OTHER_ERROR}}var M;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class A{constructor($e,Ie,X){this.resource=$e,this.operation=Ie,this.target=X}isOperation($e){return this.operation===$e}}e.$xl=A;var F;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class G{static{this.a=null}constructor($e,Ie){this.c=Ie,this.b=void 0,this.d=new w.$Y(()=>{const X=v.$Qi.forUris(()=>this.c);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.f=new w.$Y(()=>{const X=v.$Qi.forUris(()=>this.c);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.g=new w.$Y(()=>{const X=v.$Qi.forUris(()=>this.c);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of $e){switch(X.type){case F.ADDED:this.rawAdded.push(X.resource);break;case F.UPDATED:this.rawUpdated.push(X.resource);break;case F.DELETED:this.rawDeleted.push(X.resource);break}this.b!==G.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains($e,...Ie){return this.h($e,{includeChildren:!1},...Ie)}affects($e,...Ie){return this.h($e,{includeChildren:!0},...Ie)}h($e,Ie,...X){if(!$e)return!1;const V=X.length>0;return!!((!V||X.includes(F.ADDED))&&(this.d.value.get($e)||Ie.includeChildren&&this.d.value.findSuperstr($e))||(!V||X.includes(F.UPDATED))&&(this.f.value.get($e)||Ie.includeChildren&&this.f.value.findSuperstr($e))||(!V||X.includes(F.DELETED))&&(this.g.value.findSubstr($e)||Ie.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$yl=G;function x(_,$e,Ie){return!_||!$e||_===$e||$e.length>_.length?!1:($e.charAt($e.length-1)!==D.sep&&($e+=D.sep),Ie?(0,P.$Lf)(_,$e):_.indexOf($e)===0)}class j extends Error{constructor($e,Ie,X){super($e),this.fileOperationResult=Ie,this.options=X}}e.$Al=j;class U extends j{constructor($e,Ie,X,V){super($e,Ie,V),this.fileOperationResult=Ie,this.size=X}}e.$Bl=U;class J extends j{constructor($e,Ie,X){super($e,Y.FILE_NOT_MODIFIED_SINCE,X),this.stat=Ie}}e.$Cl=J;var Y;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$Dl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$El={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Fl="files.associations",e.$Gl="files.exclude",e.$Hl="files.readonlyInclude",e.$Il="files.readonlyExclude",e.$Jl="files.readonlyFromPermissions";var ae;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae||(e.FileKind=ae={})),e.$Kl="";function ee(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}async function oe(_,$e){if(!$e.hasProvider(R.URI.from({scheme:_.scheme})))return new Promise(Ie=>{const X=$e.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===_.scheme&&V.added&&(X.dispose(),Ie())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize($e){return(0,L.$ng)($e)||($e=0),$e<ie.KB?(0,T.localize)(1866,null,$e.toFixed(0)):$e<ie.MB?(0,T.localize)(1867,null,($e/ie.KB).toFixed(2)):$e<ie.GB?(0,T.localize)(1868,null,($e/ie.MB).toFixed(2)):$e<ie.TB?(0,T.localize)(1869,null,($e/ie.GB).toFixed(2)):(0,T.localize)(1870,null,($e/ie.TB).toFixed(2))}}e.$Nl=ie;function ue(_){const $e=typeof _=="string"||_?.scheme===I.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===I.Schemas.file?1024*ie.MB:$e?10*ie.MB:s.$r?50*ie.MB:1024*ie.MB}}),define(Re[75],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=void 0;class v{constructor(...P){this.a=new Map;for(const[L,R]of P)this.set(L,R)}set(P,L){const R=this.a.get(P);return this.a.set(P,L),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Ii=v}),define(Re[171],Oe([1,0,10,12,4,74,168,3,75,172]),function(we,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;const I=!1;class w extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class u{constructor(a=new m.$Ii,h=!1,c,i=I){this.i=a,this.j=h,this.k=c,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Ji,this),this._globalGraph=i?c?._globalGraph??new R.$Dr(n=>n):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Uc)(this.h),this.h.clear();for(const a of this.g)(0,P.$Tc)(a)&&a.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(a,h){this.m();const c=this,i=new class extends u{dispose(){c.h.delete(i),super.dispose()}}(a,this.j,this,this.l);return this.h.add(i),h?.add(i),i}invokeFunction(a,...h){this.m();const c=$.traceInvocation(this.l,a);let i=!1;try{return a({get:t=>{if(i)throw(0,D.$_)("service accessor is only valid during the invocation of its target method");const o=this.s(t,c);if(!o)throw new Error(`[invokeFunction] unknown service '${t}'`);return o}},...h)}finally{i=!0,c.stop()}}createInstance(a,...h){this.m();let c,i;return a instanceof L.$Hi?(c=$.traceCreation(this.l,a.ctor),i=this.o(a.ctor,a.staticArguments.concat(h),c)):(c=$.traceCreation(this.l,a),i=this.o(a,h,c)),c.stop(),i}o(a,h=[],c){const i=T._util.getServiceDependencies(a).sort((o,l)=>o.index-l.index),n=[];for(const o of i){const l=this.s(o.id,c);l||this.y(`[createInstance] ${a.name} depends on UNKNOWN service ${o.id}.`,!1),n.push(l)}const t=i.length>0?i[0].index:h.length;if(h.length!==t){console.trace(`[createInstance] First service dependency of ${a.name} at position ${t+1} conflicts with ${h.length} static arguments`);const o=t-h.length;o>0?h=h.concat(new Array(o)):h=h.slice(0,t)}return Reflect.construct(a,h.concat(n))}q(a,h){if(this.i.get(a)instanceof L.$Hi)this.i.set(a,h);else if(this.k)this.k.q(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}r(a){const h=this.i.get(a);return!h&&this.k?this.k.r(a):h}s(a,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const c=this.r(a);return c instanceof L.$Hi?this.u(a,c,h.branch(a,!0)):(h.branch(a,!1),c)}u(a,h,c){if(this.t.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.t.add(a);try{return this.v(a,h,c)}finally{this.t.delete(a)}}v(a,h,c){const i=new R.$Dr(l=>l.id.toString());let n=0;const t=[{id:a,desc:h,_trace:c}],o=new Set;for(;t.length;){const l=t.pop();if(!o.has(String(l.id))){if(o.add(String(l.id)),i.lookupOrInsertNode(l),n++>1e3)throw new w(i);for(const g of T._util.getServiceDependencies(l.desc.ctor)){const f=this.r(g.id);if(f||this.y(`[createInstance] ${a} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(g.id)),f instanceof L.$Hi){const d={id:g.id,desc:f,_trace:l._trace.branch(g.id,!0)};i.insertEdge(l,d),t.push(d)}}}}for(;;){const l=i.roots();if(l.length===0){if(!i.isEmpty())throw new w(i);break}for(const{data:g}of l){if(this.r(g.id)instanceof L.$Hi){const d=this.w(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.q(g.id,d)}i.removeNode(g)}}return this.r(a)}w(a,h,c=[],i,n){if(this.i.get(a)instanceof L.$Hi)return this.x(a,h,c,i,n,this.g);if(this.k)return this.k.w(a,h,c,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}x(a,h,c=[],i,n,t){if(i){const o=new u(void 0,this.j,this,this.l);o.c=String(a);const l=new Map,g=new v.$4h(()=>{const f=o.o(h,c,n);for(const[d,S]of l){const E=f[d];if(typeof E=="function")for(const y of S)y.disposable=E.apply(f,y.listener)}return l.clear(),t.add(f),f});return new Proxy(Object.create(null),{get(f,d){if(!g.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let y=l.get(d);return y||(y=new s.$0c,l.set(d,y)),(O,p,b)=>{if(g.isInitialized)return g.value[d](O,p,b);{const M={listener:[O,p,b],disposable:void 0},A=y.push(M);return(0,P.$Xc)(()=>{A(),M.disposable?.dispose()})}}}if(d in f)return f[d];const S=g.value;let E=S[d];return typeof E!="function"||(E=E.bind(S),f[d]=E),E},set(f,d,S){return g.value[d]=S,!0},getPrototypeOf(f){return h.prototype}})}else{const o=this.o(h,c,n);return t.add(o),o}}y(a,h){if(h&&console.warn(a),this.j)throw new Error(a)}}e.$Er=u;var k;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(k||(k={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(k.None,null)}stop(){}branch(){return this}}}static traceInvocation(a,h){return a?new $(k.Invocation,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(a,h){return a?new $(k.Creation,h.name):$.c}static{this.f=0}constructor(a,h){this.type=a,this.name=h,this.g=Date.now(),this.h=[]}branch(a,h){const c=new $(k.Branch,a.toString());return this.h.push([a,h,c]),c}stop(){const a=Date.now()-this.g;$.f+=a;let h=!1;function c(n,t){const o=[],l=new Array(n+1).join("	");for(const[g,f,d]of t.h)if(f&&d){h=!0,o.push(`${l}CREATES -> ${g}`);const S=c(n+1,d);S&&o.push(S)}else o.push(`${l}uses -> ${g}`);return o.join(`
`)}const i=[`${this.type===k.Creation?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(a>2||h)&&$.all.add(i.join(`
`))}}e.$Fr=$}),define(Re[11],Oe([1,0,9,42,6,76,4,27,23,24,14,2,31,3]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$ik=e.LogLevel=e.$gk=e.$fk=void 0,e.$hk=r,e.log=h,e.$tk=E,e.$uk=y,e.$vk=C,e.$wk=O,v=Ve(v),e.$fk=(0,k.$Ki)("logService"),e.$gk=(0,k.$Ki)("loggerService");function $(){return new Date().toISOString()}function r(p){return(0,I.$ng)(p)}var a;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(a||(e.LogLevel=a={})),e.$ik=a.Info;function h(p,b,M){switch(b){case a.Trace:p.trace(M);break;case a.Debug:p.debug(M);break;case a.Info:p.info(M);break;case a.Warning:p.warn(M);break;case a.Error:p.error(M);break;case a.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function c(p,b=!1){let M="";for(let A=0;A<p.length;A++){let F=p[A];if(F instanceof Error&&(F=(0,D.$vj)(F,b)),typeof F=="object")try{F=JSON.stringify(F)}catch{}M+=(A>0?" ":"")+F}return M}class i extends R.$Zc{constructor(){super(...arguments),this.b=e.$ik,this.c=this.B(new P.$qe),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==a.Off&&this.b<=b}}e.$kk=i;class n extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...M){this.f(a.Trace)&&this.g(a.Trace,c([b,...M],!0))}debug(b,...M){this.f(a.Debug)&&this.g(a.Debug,c([b,...M]))}info(b,...M){this.f(a.Info)&&this.g(a.Info,c([b,...M]))}warn(b,...M){this.f(a.Warning)&&this.g(a.Warning,c([b,...M]))}error(b,...M){if(this.f(a.Error))if(b instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=b.stack,this.g(a.Error,c(A))}else this.g(a.Error,c([b,...M]))}flush(){}}e.$lk=n;class t extends i{constructor(b=e.$ik){super(),this.setLevel(b),this.g=!m.$l}trace(b,...M){this.f(a.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,b,...M):console.log(`[main ${$()}]`,b,...M))}debug(b,...M){this.f(a.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,b,...M):console.log(`[main ${$()}]`,b,...M))}info(b,...M){this.f(a.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,b,...M):console.log(`[main ${$()}]`,b,...M))}warn(b,...M){this.f(a.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,b,...M):console.warn(`[main ${$()}]`,b,...M))}error(b,...M){this.f(a.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,b,...M):console.error(`[main ${$()}]`,b,...M))}flush(){}}e.$mk=t;class o extends i{constructor(b=e.$ik,M=!0){super(),this.g=M,this.setLevel(b)}trace(b,...M){this.f(a.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...M):console.log(b,...M))}debug(b,...M){this.f(a.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...M):console.log(b,...M))}info(b,...M){this.f(a.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...M):console.log(b,...M))}warn(b,...M){this.f(a.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...M):console.log(b,...M))}error(b,...M){this.f(a.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...M):console.error(b,...M))}flush(){}}e.$nk=o;class l extends i{constructor(b,M=e.$ik){super(),this.g=b,this.setLevel(M)}trace(b,...M){this.f(a.Trace)&&this.g.log(a.Trace,[this.h(b),...M])}debug(b,...M){this.f(a.Debug)&&this.g.log(a.Debug,[this.h(b),...M])}info(b,...M){this.f(a.Info)&&this.g.log(a.Info,[this.h(b),...M])}warn(b,...M){this.f(a.Warning)&&this.g.log(a.Warning,[this.h(b),...M])}error(b,...M){this.f(a.Error)&&this.g.log(a.Error,[this.h(b),...M])}h(b){return typeof b=="string"?b:(0,D.$vj)(b,this.f(a.Trace))}flush(){}}e.$ok=l;class g extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const M of this.g)M.setLevel(b);super.setLevel(b)}trace(b,...M){for(const A of this.g)A.trace(b,...M)}debug(b,...M){for(const A of this.g)A.debug(b,...M)}info(b,...M){for(const A of this.g)A.info(b,...M)}warn(b,...M){for(const A of this.g)A.warn(b,...M)}error(b,...M){for(const A of this.g)A.error(b,...M)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$pk=g;class f extends R.$Zc{constructor(b,M,A){if(super(),this.h=b,this.j=M,this.b=new T.$Fc,this.c=this.B(new P.$qe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$qe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$qe),this.onDidChangeVisibility=this.g.event,A)for(const F of A)this.b.set(F.resource,{logger:void 0,info:F})}m(b){return(0,I.$jg)(b)?[...this.b.values()].find(M=>M.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,M){const A=this.n(b),F=(0,I.$jg)(b)?b:M?.id??(0,L.$yj)(A.toString()).toString(16);let G=this.b.get(A)?.logger;const x=M?.logLevel==="always"?a.Trace:M?.logLevel;G||(G=this.s(A,x??this.getLogLevel(A)??this.h,{...M,id:F}));const j={logger:G,info:{resource:A,id:F,logLevel:x,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(j.info),this.b.set(A,j),G}n(b){return(0,I.$jg)(b)?(0,s.$lh)(this.j,`${b}.log`):b}setLogLevel(b,M){if(w.URI.isUri(b)){const A=b,F=M,G=this.b.get(A);G&&F!==G.info.logLevel&&(G.info.logLevel=F===this.h?void 0:F,G.logger?.setLevel(F),this.b.set(G.info.resource,G),this.f.fire([A,F]))}else{this.h=b;for(const[A,F]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,M){const A=this.m(b);A&&M!==!A.info.hidden&&(A.info.hidden=!M,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,M]))}getLogLevel(b){let M;return b&&(M=this.b.get(b)?.info.logLevel),M??this.h}registerLogger(b){const M=this.b.get(b.resource);M?M.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const M=this.b.get(b);M&&(M.logger&&M.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$qk=f;class d{constructor(){this.onDidChangeLogLevel=new P.$qe().event}setLevel(b){}getLevel(){return a.Info}trace(b,...M){}debug(b,...M){}info(b,...M){}warn(b,...M){}error(b,...M){}critical(b,...M){}dispose(){}flush(){}}e.$rk=d;class S extends d{}e.$sk=S;function E(p){if(p.verbose)return a.Trace;if(typeof p.logLevel=="string"){const b=O(p.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ik}function y(p){switch(p){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Off:return"off"}}function C(p){switch(p){case a.Trace:return{original:"Trace",value:v.localize(1959,null)};case a.Debug:return{original:"Debug",value:v.localize(1960,null)};case a.Info:return{original:"Info",value:v.localize(1961,null)};case a.Warning:return{original:"Warning",value:v.localize(1962,null)};case a.Error:return{original:"Error",value:v.localize(1963,null)};case a.Off:return{original:"Off",value:v.localize(1964,null)}}}function O(p){switch(p){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Error;case"off":return a.Off}}e.$xk=new u.$2j("logLevel",y(a.Info))}),define(Re[173],Oe([1,0,4,11]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aS=void 0;class P extends v.$Zc{constructor(R,T=[]){super(),this.a=new D.$pk([R,...T]),this.B(R.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...T){this.a.trace(R,...T)}debug(R,...T){this.a.debug(R,...T)}info(R,...T){this.a.info(R,...T)}warn(R,...T){this.a.warn(R,...T)}error(R,...T){this.a.error(R,...T)}flush(){this.a.flush()}}e.$aS=P});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[108],Oe([1,0,37,9,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ou=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=oi(v);var L;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(m){function s($,r){return r-$}m.compare=s;const I=Object.create(null);I[m.Error]=(0,D.localize)(1965,null),I[m.Warning]=(0,D.localize)(1966,null),I[m.Info]=(0,D.localize)(1967,null);function w($){return I[$]||""}m.toString=w;function u($){switch($){case v.default.Error:return m.Error;case v.default.Warning:return m.Warning;case v.default.Info:return m.Info;case v.default.Ignore:return m.Hint}}m.fromSeverity=u;function k($){switch($){case m.Error:return v.default.Error;case m.Warning:return v.default.Warning;case m.Info:return v.default.Info;case m.Hint:return v.default.Ignore}}m.toSeverity=k}(R||(e.MarkerSeverity=R={}));var T;(function(m){const s="";function I(u){return w(u,!0)}m.makeKey=I;function w(u,k){const $=[s];return u.source?$.push(u.source.replace("\xA6","\\\xA6")):$.push(s),u.code?typeof u.code=="string"?$.push(u.code.replace("\xA6","\\\xA6")):$.push(u.code.value.replace("\xA6","\\\xA6")):$.push(s),u.severity!==void 0&&u.severity!==null?$.push(R.toString(u.severity)):$.push(s),u.message&&k?$.push(u.message.replace("\xA6","\\\xA6")):$.push(s),u.startLineNumber!==void 0&&u.startLineNumber!==null?$.push(u.startLineNumber.toString()):$.push(s),u.startColumn!==void 0&&u.startColumn!==null?$.push(u.startColumn.toString()):$.push(s),u.endLineNumber!==void 0&&u.endLineNumber!==null?$.push(u.endLineNumber.toString()):$.push(s),u.endColumn!==void 0&&u.endColumn!==null?$.push(u.endColumn.toString()):$.push(s),$.push(s),$.join("\xA6")}m.makeKeyOptionalMessage=w})(T||(e.IMarkerData=T={})),e.$Ou=(0,P.$Ki)("markerService")});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[174],Oe([1,0,6,37,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fw=e.$Ew=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Cw=e.Severity=void 0,e.$Dw=T,D=oi(D),e.Severity=D.default,e.$Cw=(0,P.$Ki)("notificationService");var L;(function(w){w[w.DEFAULT=0]="DEFAULT",w[w.SILENT=1]="SILENT",w[w.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(w){w[w.WORKSPACE=0]="WORKSPACE",w[w.PROFILE=1]="PROFILE",w[w.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function T(w){if(w){const u=w;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var m;(function(w){w[w.OFF=0]="OFF",w[w.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class s{constructor(){this.progress=new I,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Ew=s;class I{infinite(){}done(){}total(u){}worked(u){}}e.$Fw=I}),define(Re[109],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=void 0,e.$yk=(0,v.$Ki)("productService"),e.$zk="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(we,e,v,D){var P=arguments.length,L=P<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,v):D,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(we,e,v,D);else for(var T=we.length-1;T>=0;T--)(R=we[T])&&(L=(P<3?R(L):P>3?R(e,v,L):R(e,v))||L);return P>3&&L&&Object.defineProperty(e,v,L),L},qe=this&&this.__param||function(we,e){return function(v,D){e(v,D,we)}};define(Re[77],Oe([1,0,10,19,4,3]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Kw=e.$Jw=e.$Iw=e.$Hw=e.ProgressLocation=e.$Gw=void 0,e.$Gw=(0,L.$Ki)("progressService");var R;(function(w){w[w.Explorer=1]="Explorer",w[w.Scm=3]="Scm",w[w.Extensions=5]="Extensions",w[w.Window=10]="Window",w[w.Notification=15]="Notification",w[w.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Hw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Iw=T;class m{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const k=this.d;this.d=()=>{k?.(),u()}}):Promise.resolve()}}e.$Jw=m;let s=class extends P.$Zc{constructor(u,k){super(),this.a=new v.$8h,k.withProgress(u,$=>(this.b=$,this.c&&$.report(this.c),this.a.p)),this.B((0,P.$Xc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Kw=s,e.$Kw=s=Ke([qe(1,e.$Gw)],s);class I extends P.$Zc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new P.$Yc)}start(u){this.stop();const k=++this.a,$=new D.$Be;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,P.$Xc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Xc)(()=>$.cancel())),this.b.add((0,P.$Xc)(()=>this.c?this.c.done():void 0)),{id:k,token:$.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Lw=I,e.$Mw=(0,L.$Ki)("editorProgressService")}),define(Re[29],Oe([1,0,61,14]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xo=void 0,v=Ve(v),D=Ve(D);class P{constructor(){this.a=new Map}add(R,T){v.ok(D.$jg(R)),v.ok(D.$lg(T)),v.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,T)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$xo=new P}),define(Re[78],Oe([1,0,6,139,29]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=void 0,P=Ve(P),e.$yo={JSONContribution:"base.contributions.json"};function L(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class R{constructor(){this.b=new v.$qe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(s,I){this.a[L(s)]=I,this.b.fire(s)}notifySchemaChanged(s){this.b.fire(s)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(s){const I=this.a[s];return I?(0,D.$ak)(I):void 0}hasSchemaContent(s){return!!this.a[s]}}const T=new R;P.$xo.add(e.$yo.JSONContribution,T)}),define(Re[53],Oe([1,0,17,6,14,9,44,78,29]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ConfigurationScope=e.$Co=e.EditPresentationTypes=void 0,e.$No=r,e.$Oo=a,e.$Po=h,e.$Qo=i,e.$Ro=n,e.$So=t,e.$To=o,P=Ve(P),L=Ve(L);var s;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$Co={Configuration:"base.contributions.configuration"};var I;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$Do={properties:{},patternProperties:{}},e.$Eo={properties:{},patternProperties:{}},e.$Fo={properties:{},patternProperties:{}},e.$Go={properties:{},patternProperties:{}},e.$Ho={properties:{},patternProperties:{}},e.$Io={properties:{},patternProperties:{}},e.$Jo="vscode://schemas/settings/resourceLanguage",e.$Ko="vscode://schemas/settings/configurationDefaults";const w=m.$xo.as(T.$yo.JSONContribution);class u{constructor(){this.a=[],this.i=new Set,this.j=new D.$qe,this.onDidSchemaChange=this.j.event,this.k=new D.$qe,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:L.localize(1662,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},w.registerSchema(e.$Jo,this.h),this.z()}registerConfiguration(g,f=!0){this.registerConfigurations([g],f)}registerConfigurations(g,f=!0){const d=new Set;this.r(g,f,d),w.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:d})}deregisterConfigurations(g){const f=new Set;this.s(g,f),w.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:f})}updateConfigurations({add:g,remove:f}){const d=new Set;this.s(f,d),this.r(g,!1,d),w.registerSchema(e.$Jo,this.h),this.j.fire(),this.k.fire({properties:d})}registerDefaultConfigurations(g){const f=new Set;this.l(g,f),this.j.fire(),this.k.fire({properties:f,defaultsOverrides:!0})}l(g,f){this.a.push(...g);const d=[];for(const{overrides:S,source:E}of g)for(const y in S){f.add(y);const C=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),O=S[y];if(C.configurationDefaultOverrides.push({value:O,source:E}),e.$Mo.test(y)){const p=this.o(y,O,E,C.configurationDefaultOverrideValue);if(!p)continue;C.configurationDefaultOverrideValue=p,this.n(y,p,E),d.push(...r(y))}else{const p=this.p(y,O,E,C.configurationDefaultOverrideValue);if(!p)continue;C.configurationDefaultOverrideValue=p;const b=this.e[y];b&&(this.A(y,b),this.w(y,b))}}this.q(d)}deregisterDefaultConfigurations(g){const f=new Set;this.m(g,f),this.j.fire(),this.k.fire({properties:f,defaultsOverrides:!0})}m(g,f){for(const d of g){const S=this.a.indexOf(d);S!==-1&&this.a.splice(S,1)}for(const{overrides:d,source:S}of g)for(const E in d){const y=this.b.get(E);if(!y)continue;const C=y.configurationDefaultOverrides.findIndex(O=>S?O.source?.id===S.id:O.value===d[E]);if(C!==-1){if(y.configurationDefaultOverrides.splice(C,1),y.configurationDefaultOverrides.length===0&&this.b.delete(E),e.$Mo.test(E)){let O;for(const p of y.configurationDefaultOverrides)O=this.o(E,p.value,p.source,O);O&&!P.$wg(O.value)?(y.configurationDefaultOverrideValue=O,this.n(E,O,S)):(this.b.delete(E),delete this.e[E],delete this.c.properties[E])}else{let O;for(const b of y.configurationDefaultOverrides)O=this.p(E,b.value,b.source,O);y.configurationDefaultOverrideValue=O;const p=this.e[E];p&&(this.A(E,p),this.w(E,p))}f.add(E)}}this.y()}n(g,f,d){const S={type:"object",default:f.value,description:L.localize(1663,null,(0,R.$oj)(g)),$ref:e.$Jo,defaultDefaultValue:f.value,source:d,defaultValueSource:d};this.e[g]=S,this.c.properties[g]=S}o(g,f,d,S){const E=S?.value||{},y=S?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const C of Object.keys(f)){const O=f[C];if(P.$lg(O)&&(P.$qg(E[C])||P.$lg(E[C]))){if(E[C]={...E[C]??{},...O},d)for(const b in O)y.set(`${C}.${b}`,d)}else E[C]=O,d?y.set(C,d):y.delete(C)}return{value:E,source:y}}p(g,f,d,S){const E=this.e[g],y=S?.value??E?.defaultDefaultValue;let C=d;if(P.$lg(f)&&(E!==void 0&&E.type==="object"||E===void 0&&(P.$qg(y)||P.$lg(y)))){if(C=S?.source??new Map,!(C instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const p in f)d&&C.set(`${g}.${p}`,d);f={...P.$lg(y)?y:{},...f}}return{value:f,source:C}}deltaConfiguration(g){let f=!1;const d=new Set;g.removedDefaults&&(this.m(g.removedDefaults,d),f=!0),g.addedDefaults&&(this.l(g.addedDefaults,d),f=!0),g.removedConfigurations&&this.s(g.removedConfigurations,d),g.addedConfigurations&&this.r(g.addedConfigurations,!1,d),this.j.fire(),this.k.fire({properties:d,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...g){this.j.fire()}registerOverrideIdentifiers(g){this.q(g),this.j.fire()}q(g){for(const f of g)this.i.add(f);this.y()}r(g,f,d){g.forEach(S=>{this.u(S,f,S.extensionInfo,S.restrictedProperties,void 0,d),this.d.push(S),this.v(S)})}s(g,f){const d=S=>{if(S.properties)for(const E in S.properties){f.add(E);const y=this.e[E];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[E],this.x(E,S.properties[E])}S.allOf?.forEach(E=>d(E))};for(const S of g){d(S);const E=this.d.indexOf(S);E!==-1&&this.d.splice(E,1)}}u(g,f=!0,d,S,E=I.WINDOW,y){E=P.$sg(g.scope)?E:g.scope;const C=g.properties;if(C)for(const p in C){const b=C[p];if(f&&i(p,b)){delete C[p];continue}if(b.source=d,b.defaultDefaultValue=C[p].default,this.A(p,b),e.$Mo.test(p)?b.scope=void 0:(b.scope=P.$sg(b.scope)?E:b.scope,b.restricted=P.$sg(b.restricted)?!!S?.includes(p):b.restricted),C[p].hasOwnProperty("included")&&!C[p].included){this.g[p]=C[p],delete C[p];continue}else this.e[p]=C[p],C[p].policy?.name&&this.f.set(C[p].policy.name,p);!C[p].deprecationMessage&&C[p].markdownDeprecationMessage&&(C[p].deprecationMessage=C[p].markdownDeprecationMessage),y.add(p)}const O=g.allOf;if(O)for(const p of O)this.u(p,f,d,S,E,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const g=new Map;for(const[f,d]of this.b)d.configurationDefaultOverrideValue&&g.set(f,d.configurationDefaultOverrideValue);return g}v(g){const f=d=>{const S=d.properties;if(S)for(const y in S)this.w(y,S[y]);d.allOf?.forEach(f)};f(g)}w(g,f){switch(e.$Do.properties[g]=f,f.scope){case I.APPLICATION:e.$Eo.properties[g]=f;break;case I.MACHINE:e.$Fo.properties[g]=f;break;case I.MACHINE_OVERRIDABLE:e.$Go.properties[g]=f;break;case I.WINDOW:e.$Ho.properties[g]=f;break;case I.RESOURCE:e.$Io.properties[g]=f;break;case I.LANGUAGE_OVERRIDABLE:e.$Io.properties[g]=f,this.h.properties[g]=f;break}}x(g,f){switch(delete e.$Do.properties[g],f.scope){case I.APPLICATION:delete e.$Eo.properties[g];break;case I.MACHINE:delete e.$Fo.properties[g];break;case I.MACHINE_OVERRIDABLE:delete e.$Go.properties[g];break;case I.WINDOW:delete e.$Ho.properties[g];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Io.properties[g],delete this.h.properties[g];break}}y(){for(const g of this.i.values()){const f=`[${g}]`,d={type:"object",description:L.localize(1664,null),errorMessage:L.localize(1665,null),$ref:e.$Jo};this.A(f,d),e.$Do.properties[f]=d,e.$Eo.properties[f]=d,e.$Fo.properties[f]=d,e.$Go.properties[f]=d,e.$Ho.properties[f]=d,e.$Io.properties[f]=d}}z(){const g={type:"object",description:L.localize(1666,null),errorMessage:L.localize(1667,null),$ref:e.$Jo};e.$Do.patternProperties[e.$Lo]=g,e.$Eo.patternProperties[e.$Lo]=g,e.$Fo.patternProperties[e.$Lo]=g,e.$Go.patternProperties[e.$Lo]=g,e.$Ho.patternProperties[e.$Lo]=g,e.$Io.patternProperties[e.$Lo]=g,this.j.fire()}A(g,f){const d=this.b.get(g)?.configurationDefaultOverrideValue;let S,E;d&&(!f.disallowConfigurationDefault||!d.source)&&(S=d.value,E=d.source),P.$qg(S)&&(S=f.defaultDefaultValue,E=void 0),P.$qg(S)&&(S=h(f.type)),f.default=S,f.defaultValueSource=E}}const k="\\[([^\\]]+)\\]",$=new RegExp(k,"g");e.$Lo=`^(${k})+$`,e.$Mo=new RegExp(e.$Lo);function r(l){const g=[];if(e.$Mo.test(l)){let f=$.exec(l);for(;f?.length;){const d=f[1].trim();d&&g.push(d),f=$.exec(l)}}return(0,v.$Qb)(g)}function a(l){return l.reduce((g,f)=>`${g}[${f}]`,"")}function h(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const c=new u;m.$xo.add(e.$Co.Configuration,c);function i(l,g){return l.trim()?e.$Mo.test(l)?L.localize(1669,null,l):c.getConfigurationProperties()[l]!==void 0?L.localize(1670,null,l):g.policy?.name&&c.getPolicyConfigurations().get(g.policy?.name)!==void 0?L.localize(1671,null,l,g.policy?.name,c.getPolicyConfigurations().get(g.policy?.name)):null:L.localize(1668,null)}function n(){const l=[],g=c.getConfigurationProperties();for(const f of Object.keys(g))l.push([f,g[f].scope]);return l.push(["launch",I.RESOURCE]),l.push(["task",I.RESOURCE]),l}function t(l){const g={};for(const f of l){const d=f.properties;if(P.$lg(d))for(const S in d)g[S]=d[S];f.allOf&&Object.assign(g,t(f.allOf))}return g}function o(l){switch(l){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Re[175],Oe([1,0,17,6,138,4,27,25,14,2,44,53,28,29]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0,e.$Yo=n,v=Ve(v),P=Ve(P),T=Ve(T),m=Ve(m);function $(g){return Object.isFrozen(g)?g:T.$lo(g)}class r{static createEmptyModel(f){return new r({},[],[],void 0,f)}constructor(f,d,S,E,y){this.b=f,this.c=d,this.d=S,this.raw=E,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const f=this.raw.map(d=>{if(d instanceof r)return d;const S=new a("",this.f);return S.parseRaw(d),S.configurationModel});this.g=f.reduce((d,S)=>S===d?S:d.merge(S),f[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(f){return f?(0,I.$mj)(this.contents,f):this.contents}inspect(f,d){const S=this;return{get value(){return $(S.rawConfiguration.getValue(f))},get override(){return d?$(S.rawConfiguration.getOverrideValue(f,d)):void 0},get merged(){return $(d?S.rawConfiguration.override(d).getValue(f):S.rawConfiguration.getValue(f))},get overrides(){const E=[];for(const{contents:y,identifiers:C,keys:O}of S.rawConfiguration.overrides){const p=new r(y,O,[],void 0,S.f).getValue(f);p!==void 0&&E.push({identifiers:C,value:p})}return E.length?$(E):void 0}}}getOverrideValue(f,d){const S=this.j(d);return S?f?(0,I.$mj)(S,f):S:void 0}getKeysForOverrideIdentifier(f){const d=[];for(const S of this.overrides)S.identifiers.includes(f)&&d.push(...S.keys);return v.$Qb(d)}getAllOverrideIdentifiers(){const f=[];for(const d of this.overrides)f.push(...d.identifiers);return v.$Qb(f)}override(f){let d=this.a.get(f);return d||(d=this.h(f),this.a.set(f,d)),d}merge(...f){const d=T.$ko(this.contents),S=T.$ko(this.overrides),E=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const C of f)if(y.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(d,C.contents);for(const O of C.overrides){const[p]=S.filter(b=>v.$yb(b.identifiers,O.identifiers));p?(this.i(p.contents,O.contents),p.keys.push(...O.keys),p.keys=v.$Qb(p.keys)):S.push(T.$ko(O))}for(const O of C.keys)E.indexOf(O)===-1&&E.push(O)}return new r(d,E,S,y.every(C=>C instanceof r)?void 0:y,this.f)}h(f){const d=this.j(f);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const S={};for(const E of v.$Qb([...Object.keys(this.contents),...Object.keys(d)])){let y=this.contents[E];const C=d[E];C&&(typeof y=="object"&&typeof C=="object"?(y=T.$ko(y),this.i(y,C)):y=C),S[E]=y}return new r(S,this.keys,this.overrides,void 0,this.f)}i(f,d){for(const S of Object.keys(d)){if(S in f&&m.$lg(f[S])&&m.$lg(d[S])){this.i(f[S],d[S]);continue}f[S]=T.$ko(d[S])}}j(f){let d=null,S=null;const E=y=>{y&&(S?this.i(S,y):S=T.$ko(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===f?d=y.contents:y.identifiers.includes(f)&&E(y.contents);return E(d),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(f,d){this.k(f,d,!0)}setValue(f,d){this.k(f,d,!1)}removeValue(f){const d=this.keys.indexOf(f);d!==-1&&(this.keys.splice(d,1),(0,I.$lj)(this.contents,f),w.$Mo.test(f)&&this.overrides.splice(this.overrides.findIndex(S=>v.$yb(S.identifiers,(0,w.$No)(f))),1))}k(f,d,S){if((0,I.$kj)(this.contents,f,d,E=>this.f.error(E)),S=S||this.keys.indexOf(f)===-1,S&&this.keys.push(f),w.$Mo.test(f)){const E=(0,w.$No)(f),y={identifiers:E,keys:Object.keys(this.contents[f]),contents:(0,I.$jj)(this.contents[f],O=>this.f.error(O))},C=this.overrides.findIndex(O=>v.$yb(O.identifiers,E));C!==-1?this.overrides[C]=y:this.overrides.push(y)}}}e.$Uo=r;class a{constructor(f,d){this.f=f,this.g=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(f,d){if(!m.$sg(f)){const S=this.h(f);this.parseRaw(S,d)}}reparse(f){this.a&&this.parseRaw(this.a,f)}parseRaw(f,d){this.a=f;const{contents:S,keys:E,overrides:y,restricted:C,hasExcludedProperties:O}=this.i(f,d);this.b=new r(S,E,y,O?[f]:void 0,this.g),this.c=C||[]}h(f){let d={},S=null,E=[];const y=[],C=[];function O(b){Array.isArray(E)?E.push(b):S!==null&&(E[S]=b)}const p={onObjectBegin:()=>{const b={};O(b),y.push(E),E=b,S=null},onObjectProperty:b=>{S=b},onObjectEnd:()=>{E=y.pop()},onArrayBegin:()=>{const b=[];O(b),y.push(E),E=b,S=null},onArrayEnd:()=>{E=y.pop()},onLiteralValue:O,onError:(b,M,A)=>{C.push({error:b,offset:M,length:A})}};if(f)try{P.$_n(f,p),d=E[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return d}i(f,d){const S=k.$xo.as(w.$Co.Configuration).getConfigurationProperties(),E=this.j(f,S,!0,d);f=E.raw;const y=(0,I.$jj)(f,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`)),C=Object.keys(f),O=this.l(f,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:y,keys:C,overrides:O,restricted:E.restricted,hasExcludedProperties:E.hasExcludedProperties}}j(f,d,S,E){let y=!1;if(!E?.scopes&&!E?.skipRestricted&&!E?.exclude?.length)return{raw:f,restricted:[],hasExcludedProperties:y};const C={},O=[];for(const p in f)if(w.$Mo.test(p)&&S){const b=this.j(f[p],d,!1,E);C[p]=b.raw,y=y||b.hasExcludedProperties,O.push(...b.restricted)}else{const b=d[p],M=b?typeof b.scope<"u"?b.scope:w.ConfigurationScope.WINDOW:void 0;b?.restricted&&O.push(p),!E.exclude?.includes(p)&&(E.include?.includes(p)||(M===void 0||E.scopes===void 0||E.scopes.includes(M))&&!(E.skipRestricted&&b?.restricted))?C[p]=f[p]:y=!0}return{raw:C,restricted:O,hasExcludedProperties:y}}l(f,d){const S=[];for(const E of Object.keys(f))if(w.$Mo.test(E)){const y={};for(const C in f[E])y[C]=f[E][C];S.push({identifiers:(0,w.$No)(E),keys:Object.keys(y),contents:(0,I.$jj)(y,d)})}return S}}e.$Vo=a;class h extends L.$Zc{constructor(f,d,S,E,y){super(),this.c=f,this.f=d,this.g=E,this.h=y,this.b=this.B(new D.$qe),this.onDidChange=this.b.event,this.a=new a(this.c.toString(),y),this.B(this.g.watch(S.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(u.FileOperation.CREATE)||C.isOperation(u.FileOperation.COPY)||C.isOperation(u.FileOperation.DELETE)||C.isOperation(u.FileOperation.WRITE))&&S.isEqual(C.resource,f)))(()=>this.b.fire()))}async loadConfiguration(){try{const f=await this.g.readFile(this.c);return this.a.parse(f.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(f){return f&&(this.f=f),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Wo=h;class c{constructor(f,d,S,E,y,C,O,p,b,M,A,F,G){this.a=f,this.b=d,this.c=S,this.overrideIdentifiers=E,this.d=y,this.f=C,this.g=O,this.h=p,this.i=b,this.j=M,this.k=A,this.l=F,this.m=G}get value(){return $(this.c)}n(f){return f?.value!==void 0||f?.override!==void 0||f?.overrides!==void 0?f:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(f,d,S,E,y,C,O,p,b,M){this.j=f,this.l=d,this.m=S,this.n=E,this.p=y,this.q=C,this.r=O,this.s=p,this.t=b,this.u=M,this.h=null,this.i=new R.$Fc,this.v=null}getValue(f,d,S){return this.w(f,d,S).getValue(f)}updateValue(f,d,S={}){let E;S.resource?(E=this.t.get(S.resource),E||(E=r.createEmptyModel(this.u),this.t.set(S.resource,E))):E=this.s,d===void 0?E.removeValue(f):E.setValue(f,d),S.resource||(this.h=null)}inspect(f,d,S){const E=this.w(f,d,S),y=this.A(d.resource,S),C=d.resource?this.t.get(d.resource)||this.s:this.s,O=new Set;for(const p of E.overrides)for(const b of p.identifiers)E.getOverrideValue(f,b)!==void 0&&O.add(b);return new c(f,d,E.getValue(f),O.size?[...O]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this.q:void 0,y||void 0,C)}keys(f){const d=this.A(void 0,f);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(f){this.j=f,this.h=null,this.i.clear()}updatePolicyConfiguration(f){this.l=f}updateApplicationConfiguration(f){this.m=f,this.h=null,this.i.clear()}updateLocalUserConfiguration(f){this.n=f,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(f){this.p=f,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(f){this.q=f,this.h=null,this.i.clear()}updateFolderConfiguration(f,d){this.r.set(f,d),this.i.delete(f)}deleteFolderConfiguration(f){this.folderConfigurations.delete(f),this.i.delete(f)}compareAndUpdateDefaultConfiguration(f,d){const S=[];if(!d){const{added:E,updated:y,removed:C}=o(this.j,f);d=[...E,...y,...C]}for(const E of d)for(const y of(0,w.$No)(E)){const C=this.j.getKeysForOverrideIdentifier(y),O=f.getKeysForOverrideIdentifier(y),p=[...O.filter(b=>C.indexOf(b)===-1),...C.filter(b=>O.indexOf(b)===-1),...C.filter(b=>!T.$oo(this.j.override(y).getValue(b),f.override(y).getValue(b)))];S.push([y,p])}return this.updateDefaultConfiguration(f),{keys:d,overrides:S}}compareAndUpdatePolicyConfiguration(f){const{added:d,updated:S,removed:E}=o(this.l,f),y=[...d,...S,...E];return y.length&&this.updatePolicyConfiguration(f),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(f){const{added:d,updated:S,removed:E,overrides:y}=o(this.applicationConfiguration,f),C=[...d,...S,...E];return C.length&&this.updateApplicationConfiguration(f),{keys:C,overrides:y}}compareAndUpdateLocalUserConfiguration(f){const{added:d,updated:S,removed:E,overrides:y}=o(this.localUserConfiguration,f),C=[...d,...S,...E];return C.length&&this.updateLocalUserConfiguration(f),{keys:C,overrides:y}}compareAndUpdateRemoteUserConfiguration(f){const{added:d,updated:S,removed:E,overrides:y}=o(this.remoteUserConfiguration,f),C=[...d,...S,...E];return C.length&&this.updateRemoteUserConfiguration(f),{keys:C,overrides:y}}compareAndUpdateWorkspaceConfiguration(f){const{added:d,updated:S,removed:E,overrides:y}=o(this.workspaceConfiguration,f),C=[...d,...S,...E];return C.length&&this.updateWorkspaceConfiguration(f),{keys:C,overrides:y}}compareAndUpdateFolderConfiguration(f,d){const S=this.folderConfigurations.get(f),{added:E,updated:y,removed:C,overrides:O}=o(S,d),p=[...E,...y,...C];return(p.length||!S)&&this.updateFolderConfiguration(f,d),{keys:p,overrides:O}}compareAndDeleteFolderConfiguration(f){const d=this.folderConfigurations.get(f);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(f);const{added:S,updated:E,removed:y,overrides:C}=o(d,void 0);return{keys:[...S,...E,...y],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(f,d,S){let E=this.x(d,S);return d.overrideIdentifier&&(E=E.override(d.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(f)!==void 0&&(E=E.merge(this.l)),E}x({resource:f},d){let S=this.y();if(d&&f){const E=d.getFolder(f);E&&(S=this.z(E.uri)||S);const y=this.t.get(f);y&&(S=S.merge(y))}return S}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(f){let d=this.i.get(f);if(!d){const S=this.y(),E=this.r.get(f);E?(d=S.merge(E),this.i.set(f,d)):d=S}return d}A(f,d){if(d&&f){const S=d.getFolder(f);if(S)return this.r.get(S.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((f,d)=>{const{contents:S,overrides:E,keys:y}=this.r.get(d);return f.push([d,{contents:S,overrides:E,keys:y}]),f},[])}}allKeys(){const f=new Set;return this.j.keys.forEach(d=>f.add(d)),this.userConfiguration.keys.forEach(d=>f.add(d)),this.q.keys.forEach(d=>f.add(d)),this.r.forEach(d=>d.keys.forEach(S=>f.add(S))),[...f.values()]}B(){const f=new Set;return this.j.getAllOverrideIdentifiers().forEach(d=>f.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>f.add(d)),this.q.getAllOverrideIdentifiers().forEach(d=>f.add(d)),this.r.forEach(d=>d.getAllOverrideIdentifiers().forEach(S=>f.add(S))),[...f.values()]}D(f){const d=new Set;return this.j.getKeysForOverrideIdentifier(f).forEach(S=>d.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(f).forEach(S=>d.add(S)),this.q.getKeysForOverrideIdentifier(f).forEach(S=>d.add(S)),this.r.forEach(S=>S.getKeysForOverrideIdentifier(f).forEach(E=>d.add(E))),[...d.values()]}static parse(f,d){const S=this.E(f.defaults,d),E=this.E(f.policy,d),y=this.E(f.application,d),C=this.E(f.user,d),O=this.E(f.workspace,d),p=f.folders.reduce((b,M)=>(b.set(s.URI.revive(M[0]),this.E(M[1],d)),b),new R.$Fc);return new i(S,E,y,C,r.createEmptyModel(d),O,p,r.createEmptyModel(d),new R.$Fc,d)}static E(f,d){return new r(f.contents,f.keys,f.overrides,void 0,d)}}e.$Xo=i;function n(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const f=new Set,d=new Map;for(const E of g)E.keys.forEach(y=>f.add(y)),E.overrides.forEach(([y,C])=>{const O=(0,R.$Cc)(d,y,new Set);C.forEach(p=>O.add(p))});const S=[];return d.forEach((E,y)=>S.push([y,[...E.values()]])),{keys:[...f.values()],overrides:S}}class t{constructor(f,d,S,E,y){this.change=f,this.f=d,this.g=S,this.h=E,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of f.keys)this.affectedKeys.add(C);for(const[,C]of f.overrides)for(const O of C)this.affectedKeys.add(O);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(f,d){const S=this.a+f,E=this.d.indexOf(S);if(E<0)return!1;const y=E+S.length;if(y>=this.d.length)return!1;const C=this.d.charCodeAt(y);if(C!==this.b&&C!==this.c)return!1;if(d){const O=this.previousConfiguration?this.previousConfiguration.getValue(f,d,this.f?.workspace):void 0,p=this.g.getValue(f,d,this.h);return!T.$oo(O,p)}return!0}}e.$Zo=t;function o(g,f){const{added:d,removed:S,updated:E}=l(f?.rawConfiguration,g?.rawConfiguration),y=[],C=g?.getAllOverrideIdentifiers()||[],O=f?.getAllOverrideIdentifiers()||[];if(f){const p=O.filter(b=>!C.includes(b));for(const b of p)y.push([b,f.getKeysForOverrideIdentifier(b)])}if(g){const p=C.filter(b=>!O.includes(b));for(const b of p)y.push([b,g.getKeysForOverrideIdentifier(b)])}if(f&&g){for(const p of C)if(O.includes(p)){const b=l({contents:g.getOverrideValue(void 0,p)||{},keys:g.getKeysForOverrideIdentifier(p)},{contents:f.getOverrideValue(void 0,p)||{},keys:f.getKeysForOverrideIdentifier(p)});y.push([p,[...b.added,...b.removed,...b.updated]])}}return{added:d,removed:S,updated:E,overrides:y}}function l(g,f){const d=g?f?g.keys.filter(y=>f.keys.indexOf(y)===-1):[...g.keys]:[],S=f?g?f.keys.filter(y=>g.keys.indexOf(y)===-1):[...f.keys]:[],E=[];if(g&&f){for(const y of f.keys)if(g.keys.indexOf(y)!==-1){const C=(0,I.$mj)(f.contents,y),O=(0,I.$mj)(g.contents,y);T.$oo(C,O)||E.push(y)}}return{added:d,removed:S,updated:E}}}),define(Re[110],Oe([1,0,12,3]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.RemoteAuthorityResolverErrorCode=e.$Yl=e.$Xl=e.RemoteConnectionType=e.$Wl=void 0,e.$1l=s,e.$Wl=(0,D.$Ki)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class L{constructor(w){this.id=w,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Xl=L;class R{constructor(w,u){this.host=w,this.port=u,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Yl=R;var T;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class m extends v.$fb{static isNotAvailable(w){return w instanceof m&&w._code===T.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof m&&w._code===T.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof m&&w._code===T.NoResolverFound}static isInvalidAuthority(w){return w instanceof m&&w._code===T.InvalidAuthority}static isHandled(w){return w instanceof m&&w.isHandled}constructor(w,u=T.Unknown,k){super(w),this._message=w,this._code=u,this._detail=k,this.isHandled=u===T.NotAvailable&&k===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Zl=m;function s(I){const w=I.indexOf("+");return w===-1?I:I.substring(0,w)}}),define(Re[62],Oe([1,0,15]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=D,e.$on=P,e.$pn=L,e.$qn=R;function D(m){return m.scheme===v.Schemas.vscodeRemote?m.authority:void 0}function P(m){if(!m)return;const s=m.indexOf("+");return s<0?m:m.substr(0,s)}function L(m){const{host:s,port:I}=T(m);if(typeof I>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:I}}function R(m,s){let{host:I,port:w}=T(m);return typeof w>"u"&&(w=s),{host:I,port:w}}function T(m){const s=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const I=m.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const w=m.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:m,port:void 0}}}),define(Re[18],Oe([1,0,13,3,62]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$zn=e.$yn=e.$xn=e.TargetPlatform=e.ExtensionType=e.$wn=e.$un=e.$tn=e.$sn=e.$rn=void 0,e.$vn=L,e.$An=w,e.$Bn=u,e.$Cn=k,e.$Dn=$,e.$En=r,e.$Fn=a,v=Ve(v),e.$rn="extensions.user.cache",e.$sn="extensions.builtin.cache",e.$tn="undefined_publisher",e.$un=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$wn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(R||(e.ExtensionType=R={}));var T;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class m{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,i){if(typeof c>"u"||c===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof c=="string"||typeof i=="string"){const n=typeof c=="string"?c:c.value,t=typeof i=="string"?i:i.value;return v.$Kf(n,t)}return c._lower===i._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$xn=m;class s{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const i of c)this.add(i)}add(c){this.c.add(m.toKey(c))}delete(c){return this.c.delete(m.toKey(c))}has(c){return this.c.has(m.toKey(c))}}e.$yn=s;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(m.toKey(c))}get(c){return this.c.get(m.toKey(c))}has(c){return this.c.has(m.toKey(c))}set(c,i){this.c.set(m.toKey(c),i)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$zn=I;function w(h){return u(h)}function u(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function k(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function $(h,c){if(c){const i=`onResolveRemoteAuthority:${(0,P.$on)(c)}`;return!!h.activationEvents?.includes(i)}return!1}function r(h){return h.map(c=>{const[i,n]=c.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function a(h){return h.map(c=>c.split("@")[0])}e.$Gn=(0,D.$Ki)("IBuiltinExtensionsScannerService")}),define(Re[111],Oe([1,0,23,9,18,3]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.ExtensionManagementErrorCode=e.$sp=e.ExtensionGalleryErrorCode=e.$rp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=T,e.$mp=m,e.$np=s,e.$op=I,e.$pp=w,e.$qp=u,e.$ep="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$fp=new RegExp(e.$ep),e.$gp="__web_extension",e.$hp="skipWalkthrough",e.$ip="extensionInstallSource",e.$jp="dependecyOrPackExtensionInstall",e.$kp="clientTargetPlatform";var R;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function T(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function m(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function s(t,o){switch(t){case v.Platform.Windows:return o==="x64"?P.TargetPlatform.WIN32_X64:o==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Linux:return o==="x64"?P.TargetPlatform.LINUX_X64:o==="arm64"?P.TargetPlatform.LINUX_ARM64:o==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return o==="x64"?P.TargetPlatform.ALPINE_X64:o==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Mac:return o==="x64"?P.TargetPlatform.DARWIN_X64:o==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Web:return P.TargetPlatform.WEB}}function I(t,o){return o===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function w(t,o,l){return I(o,l)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===l}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var k;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var $;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})($||(e.SortOrder=$={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var a;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(a||(e.InstallOperation=a={})),e.$rp=(0,L.$Ki)("extensionGalleryService");var h;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting",t.Offline="Offline"})(h||(e.ExtensionGalleryErrorCode=h={}));class c extends Error{constructor(o,l){super(o),this.code=l,this.name=l}}e.$sp=c;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(o,l){super(o),this.code=l,this.name=l}}e.$tp=n,e.$up=(0,L.$Ki)("extensionManagementService"),e.$vp="extensionsIdentifiers/disabled",e.$wp="extensionsIdentifiers/enabled",e.$xp=(0,L.$Ki)("IGlobalExtensionEnablementService"),e.$yp=(0,L.$Ki)("IExtensionTipsService"),e.$zp=(0,D.localize2)(1780,"Extensions"),e.$Ap=(0,D.localize2)(1781,"Preferences")}),define(Re[112],Oe([1,0,12,18]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=e.$gH=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,T){this.a.set(R,T)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const T=Object.create(null);for(const m of R){const s=this.readActivationEvents(m);s.length>0&&(T[D.$xn.toKey(m.identifier)]=s)}return T}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const T=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let m=0;m<T.length;m++)T[m]==="onUri"&&(T[m]=`onUri:${D.$xn.toKey(R.identifier)}`);if(!R.contributes)return T;for(const m in R.contributes){const s=this.a.get(m);if(!s)continue;const I=R.contributes[m],w=Array.isArray(I)?I:[I];try{s(w,T)}catch(u){(0,v.$4)(u)}}return T}}e.$gH=P,e.$hH=new P});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[176],Oe([1,0,24,37,9,281,18,105]),function(we,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=I,e.$7p=w,e.$8p=u,e.$9p=k,e.$0p=$,e.$$p=r,e.$_p=a,e.$aq=h,D=oi(D),P=Ve(P),L=Ve(L);const m=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||m.test(n)}function w(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match(m);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(n){if(!n)return null;const t=n.majorBase,o=n.majorMustEqual,l=n.minorBase;let g=n.minorMustEqual;const f=n.patchBase;let d=n.patchMustEqual;n.hasCaret&&(t===0||(g=!1),d=!1);let S=0;if(n.preRelease){const E=s.exec(n.preRelease);if(E){const[,y,C,O]=E;S=Date.UTC(Number(y),Number(C)-1,Number(O))}}return{majorBase:t,majorMustEqual:o,minorBase:l,minorMustEqual:g,patchBase:f,patchMustEqual:d,isMinimum:n.hasGreaterEquals,notBefore:S}}function k(n,t,o){let l;typeof n=="string"?l=u(w(n)):l=n;let g;t instanceof Date?g=t.getTime():typeof t=="string"&&(g=new Date(t).getTime());let f;if(typeof o=="string"?f=u(w(o)):f=o,!l||!f)return!1;const d=l.majorBase,S=l.minorBase,E=l.patchBase;let y=f.majorBase,C=f.minorBase,O=f.patchBase;const p=f.notBefore;let b=f.majorMustEqual,M=f.minorMustEqual,A=f.patchMustEqual;return f.isMinimum?d>y?!0:d<y?!1:S>C?!0:S<C||g&&g<p?!1:E>=O:(d===1&&y===0&&(!b||!M||!A)&&(y=1,C=0,O=0,b=!0,M=!1,A=!1),d<y?!1:d>y?!b:S<C?!1:S>C?!M:E<O?!1:E>O?!A:!(g&&g<p))}function $(n,t,o,l,g,f){const d=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return d.push([D.default.Error,P.localize(1832,null)]),d;if(typeof l.name!="string")return d.push([D.default.Error,P.localize(1833,null,"name")]),d;if(typeof l.version!="string")return d.push([D.default.Error,P.localize(1834,null,"version")]),d;if(!l.engines)return d.push([D.default.Error,P.localize(1835,null,"engines")]),d;if(typeof l.engines.vscode!="string")return d.push([D.default.Error,P.localize(1836,null,"engines.vscode")]),d;if(typeof l.extensionDependencies<"u"&&!i(l.extensionDependencies))return d.push([D.default.Error,P.localize(1837,null,"extensionDependencies")]),d;if(typeof l.activationEvents<"u"){if(!i(l.activationEvents))return d.push([D.default.Error,P.localize(1838,null,"activationEvents")]),d;if(typeof l.main>"u"&&typeof l.browser>"u")return d.push([D.default.Error,P.localize(1839,null,"activationEvents","main","browser")]),d}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&d.push([D.default.Warning,P.localize(1840,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return d.push([D.default.Error,P.localize(1841,null,"main")]),d;{const y=(0,v.$lh)(o,l.main);(0,v.$fh)(y,o)||d.push([D.default.Warning,P.localize(1842,null,y.path,o.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return d.push([D.default.Error,P.localize(1843,null,"browser")]),d;{const y=(0,v.$lh)(o,l.browser);(0,v.$fh)(y,o)||d.push([D.default.Warning,P.localize(1844,null,y.path,o.path)])}}if(!L.valid(l.version))return d.push([D.default.Error,P.localize(1845,null)]),d;const S=[];if(!r(n,t,l,g,S))for(const y of S)d.push([D.default.Error,y]);if(f&&l.enabledApiProposals?.length){const y=[];if(!h([...l.enabledApiProposals],y))for(const C of y)d.push([D.default.Error,C])}return d}function r(n,t,o,l,g){return l||typeof o.main>"u"&&typeof o.browser>"u"?!0:c(n,t,o.engines.vscode,g)}function a(n,t,o){return n==="*"||c(t,o,n)}function h(n,t){if(n.length===0)return!0;const o=Array.isArray(t)?t:void 0,l=(o?void 0:t)??T.allApiProposals,g=[],f=(0,R.$En)(n);for(const{proposalName:d,version:S}of f){const E=l[d];E&&S&&E.version!==S&&g.push(P.localize(1846,null,d))}return o?.push(...g),g.length===0}function c(n,t,o,l=[]){const g=u(w(o));if(!g)return l.push(P.localize(1847,null,o)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return l.push(P.localize(1848,null,o)),!1}else if(!g.majorMustEqual)return l.push(P.localize(1849,null,o)),!1;return k(n,t,g)?!0:(l.push(P.localize(1850,null,n,o)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,o=n.length;t<o;t++)if(typeof n[t]!="string")return!1;return!0}}),define(Re[177],Oe([1,0,20,12,4,9,53,3,11,29]),function(we,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0,e.$dq=u,e.$eq=k,e.$fq=$,e.$gq=r,e.$hq=a,e.$iq=h,e.$bq=(0,T.$Ki)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const o in this.b)o.toLowerCase()==="authorization"||o.toLowerCase()==="proxy-authorization"?t[o]="*****":t[o]=this.b[o];this.a=t}return this.a}}class w extends P.$Zc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,L.localize)(2050,null),when:m.$xk.isEqualTo((0,m.$uk)(m.LogLevel.Trace)).serialize()})}async c(t,o,l){const g=`${t} #${++this.b}: ${o.url}`;this.a.trace(`${g} - begin`,o.type,new I(o.headers??{}));try{const f=await l();return this.a.trace(`${g} - end`,o.type,f.res.statusCode,f.res.headers),f}catch(f){throw this.a.error(`${g} - error`,o.type,(0,D.$bb)(f)),f}}}e.$cq=w;function u(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function k(n){return n.res.statusCode===204}async function $(n){return k(n)?null:(await(0,v.$5e)(n.stream)).toString()}async function r(n){if(!u(n))throw new Error("Server returned "+n.res.statusCode);return $(n)}async function a(n){if(!u(n))throw new Error("Server returned "+n.res.statusCode);if(k(n))return null;const o=(await(0,v.$5e)(n.stream)).toString();try{return JSON.parse(o)}catch(l){throw l.message+=`:
`+o,l}}function h(n){i(n)}let c;function i(n){const t=s.$xo.as(R.$Co.Configuration),o=c;c={id:"http",order:15,title:(0,L.localize)(2051,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2052,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2053,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(2054,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,L.localize)(2055,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(2056,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(2057,null),(0,L.localize)(2058,null),(0,L.localize)(2059,null),(0,L.localize)(2060,null)],default:"override",description:(0,L.localize)(2061,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(2062,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(2063,null),restricted:!0}}},t.updateConfigurations({add:[c],remove:o?[o]:[]})}i(R.ConfigurationScope.APPLICATION)}),define(Re[178],Oe([1,0,23,79,33]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=R,e.$Cp=T;function L(m){if(v.$x===v.Platform.Linux&&/^penguin(\.|$)/i.test(m))return"chromebook"}function R(m,s,I,w,u,k,$,r,a,h){const c=Object.create(null);c["common.machineId"]=k,c["common.sqmId"]=$,c["common.devDeviceId"]=r,c.sessionID=(0,P.$7g)()+Date.now(),c.commitHash=w,c.version=u,c["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,v.$k)(v.$x),c["common.nodePlatform"]=D.$ic,c["common.nodeArch"]=I,c["common.product"]=h||"desktop",a&&(c["common.msftInternal"]=a);let i=0;const n=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$o&&(c["common.snap"]="true");const t=L(s);return t&&(c["common.platformDetail"]=t),c}function T(m){const s=D.env.USERDNSDOMAIN;if(!s)return!1;const I=s.toLowerCase();return m.some(w=>I===w)}}),define(Re[113],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=void 0,e.$em=(0,v.$Ki)("telemetryService"),e.$fm=(0,v.$Ki)("customEndpointTelemetryService"),e.$gm="telemetry.currentSessionDate",e.$hm="telemetry.firstSessionDate",e.$im="telemetry.lastSessionDate",e.$jm="telemetry.machineId",e.$km="telemetry.sqmId",e.$lm="telemetry.devDeviceId",e.$mm="telemetry",e.$nm="telemetry.telemetryLevel",e.$om="telemetry.enableCrashReporter",e.$pm="telemetry.enableTelemetry";var D;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var P;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Re[63],Oe([1,0,25,14,62,178,113]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=void 0,e.$Kp=I,e.$Lp=w,e.$Mp=u,e.$Np=k,e.$Op=r,e.$Pp=h,e.$Qp=c,e.$Rp=t;class T{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$Dp=T;class m{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ep=m,e.$Fp=new m;class s{async publicLog(l,g,f){}async publicLogError(l,g,f){}}e.$Gp=s,e.$Hp="telemetry",e.$Ip="extensionTelemetryLog",e.$Jp={log:()=>null,flush:()=>Promise.resolve(null)};function I(o,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!o.enableTelemetry)}function w(o,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}function u(o){const l=o.getValue(R.$nm),g=o.getValue(R.$om);if(o.getValue(R.$pm)===!1||g===!1)return R.TelemetryLevel.NONE;switch(l??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function k(o){const l={},g={},f={};a(o,f);for(let d in f){d=d.length>150?d.substr(d.length-149):d;const S=f[d];typeof S=="number"?g[d]=S:typeof S=="boolean"?g[d]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${S.length}`),l[d]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(l[d]=S)}return{properties:l,measurements:g}}const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(o){if(!o)return"none";const l=(0,P.$on)(o);return $.has(l)?l:"other"}function a(o,l,g=0,f){if(o)for(const d of Object.getOwnPropertyNames(o)){const S=o[d],E=f?f+d:d;Array.isArray(S)?l[E]=(0,v.$po)(S):S instanceof Date?l[E]=S.toISOString():(0,D.$lg)(S)?g<2?a(S,l,g+1,E+"."):l[E]=(0,v.$po)(S):l[E]=S}}function h(o,l){const g=o.msftInternalDomains||[],f=l.getValue("telemetry.internalTesting");return(0,L.$Cp)(g)||f}function c(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}function i(o,l){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let g=o;const f=[];for(const y of l)for(;;){const C=y.exec(o);if(!C)break;f.push([C.index,y.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(g="";;){const y=S.exec(o);if(!y)break;const C=f.some(([O,p])=>y.index<p&&O<S.lastIndex);!d.test(y[0])&&!C&&(g+=o.substring(E,y.index)+"<REDACTED: user-file-path>",E=S.lastIndex)}return E<o.length&&(g+=o.substr(E)),g}function n(o){if(!o)return o;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of l)if(g.regex.test(o))return`<REDACTED: ${g.label}>`;return o}function t(o,l){return(0,v.$mo)(o,g=>{if(g instanceof T||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let f=g.replaceAll("%20"," ");f=i(f,l);for(const d of l)f=f.replace(d,"");return f=n(f),f}})}}),define(Re[179],Oe([1,0,13,111,18,23,2,12,79,63]),function(we,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$Tp=void 0,e.$Sp=I,e.$Up=$,e.$Vp=r,e.$Wp=a,e.$Xp=h,e.$Yp=c,e.$Zp=i,e.$1p=n,e.$3p=t,e.$4p=l;function I(g,f){return g.uuid&&f.uuid?g.uuid===f.uuid:g.id===f.id?!0:(0,v.$Ff)(g.id,f.id)===0}const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(f){const d=f.manifest?f.manifest.version:f.version,S=f.manifest?f.targetPlatform:f.properties.targetPlatform;return new u(f.identifier,d,S)}static parse(f){const d=w.exec(f);return d&&d[1]&&d[2]?new u({id:d[1]},d[2],d[4]||void 0):null}constructor(f,d,S=P.TargetPlatform.UNDEFINED){this.identifier=f,this.version=d,this.targetPlatform=S,this.id=f.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(f){return f instanceof u?I(this,f)&&this.version===f.version&&this.targetPlatform===f.targetPlatform:!1}}e.$Tp=u;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(g){const f=k.exec(g);return f&&f[1]?[a(f[1]),f[2]]:[a(g),void 0]}function r(g,f){return`${g}.${f}`}function a(g){return g.toLowerCase()}function h(g,f){return a(r(g??P.$tn,f))}function c(g,f){const d=[],S=E=>{for(const y of d)if(y.some(C=>I(f(C),f(E))))return y;return null};for(const E of g){const y=S(E);y?y.push(E):d.push([E])}return d}function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}function n(g){return{id:new s.$Dp(g.identifier.id),name:new s.$Dp(g.name),version:g.version,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),isSigned:g.isSigned,...g.telemetryData}}e.$2p=new P.$xn("pprice.better-merge");function t(g,f){const d=[],S=f.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const E=S.shift();if(E&&d.every(y=>!I(y.identifier,{id:E}))){const y=g.filter(C=>I(C.identifier,{id:E}));y.length===1&&(d.push(y[0]),S.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}async function o(g,f){if(!L.$n)return!1;let d;try{d=(await g.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await g.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){f.debug("Error while getting the os-release file.",(0,T.$bb)(E))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(g,f){const d=await o(g,f),S=(0,D.$np)(d?"alpine":L.$x,m.$jc);return f.debug("ComputeTargetPlatform:",S),S}}),define(Re[180],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=v,e.$Os=D,e.$Ps=P,e.$Qs=L,e.$Rs=R,e.$Ss=T;function v(m){return[...m.entries()]}function D(m){return m?[...m.entries()]:[]}function P(m){return new Map(m)}function L(m){return new Map(m??[])}function R(m){return Array.from(m.entries()).map(s=>[s[0],v(s[1].map),D(s[1].descriptionMap)])}function T(m){return new Map(m.map(s=>[s[0],{map:P(s[1]),descriptionMap:L(s[2])}]))}}),define(Re[181],Oe([1,0,3,31,29]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=e.$ys=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$xs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.GeneralShellType=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ws=void 0,e.$ws=new D.$2j("terminalTabFocusMode",!1,!0);var L;(function(o){o.AutomationProfile="terminal.integrated.automationProfile.",o.DefaultProfile="terminal.integrated.defaultProfile.",o.Profiles="terminal.integrated.profiles."})(L||(e.TerminalSettingPrefix=L={}));var R;(function(o){o.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",o.AutomationProfileLinux="terminal.integrated.automationProfile.linux",o.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",o.AutomationProfileWindows="terminal.integrated.automationProfile.windows",o.ProfilesWindows="terminal.integrated.profiles.windows",o.ProfilesMacOs="terminal.integrated.profiles.osx",o.ProfilesLinux="terminal.integrated.profiles.linux",o.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",o.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",o.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",o.UseWslProfiles="terminal.integrated.useWslProfiles",o.TabsDefaultColor="terminal.integrated.tabs.defaultColor",o.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",o.TabsEnabled="terminal.integrated.tabs.enabled",o.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",o.TabsHideCondition="terminal.integrated.tabs.hideCondition",o.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",o.TabsShowActions="terminal.integrated.tabs.showActions",o.TabsLocation="terminal.integrated.tabs.location",o.TabsFocusMode="terminal.integrated.tabs.focusMode",o.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",o.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",o.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",o.CopyOnSelection="terminal.integrated.copyOnSelection",o.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",o.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",o.FontFamily="terminal.integrated.fontFamily",o.FontSize="terminal.integrated.fontSize",o.LetterSpacing="terminal.integrated.letterSpacing",o.LineHeight="terminal.integrated.lineHeight",o.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",o.TabStopWidth="terminal.integrated.tabStopWidth",o.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",o.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",o.BellDuration="terminal.integrated.bellDuration",o.FontWeight="terminal.integrated.fontWeight",o.FontWeightBold="terminal.integrated.fontWeightBold",o.CursorBlinking="terminal.integrated.cursorBlinking",o.CursorStyle="terminal.integrated.cursorStyle",o.CursorStyleInactive="terminal.integrated.cursorStyleInactive",o.CursorWidth="terminal.integrated.cursorWidth",o.Scrollback="terminal.integrated.scrollback",o.DetectLocale="terminal.integrated.detectLocale",o.DefaultLocation="terminal.integrated.defaultLocation",o.GpuAcceleration="terminal.integrated.gpuAcceleration",o.TerminalTitleSeparator="terminal.integrated.tabs.separator",o.TerminalTitle="terminal.integrated.tabs.title",o.TerminalDescription="terminal.integrated.tabs.description",o.RightClickBehavior="terminal.integrated.rightClickBehavior",o.MiddleClickBehavior="terminal.integrated.middleClickBehavior",o.Cwd="terminal.integrated.cwd",o.ConfirmOnExit="terminal.integrated.confirmOnExit",o.ConfirmOnKill="terminal.integrated.confirmOnKill",o.EnableBell="terminal.integrated.enableBell",o.EnableVisualBell="terminal.integrated.enableVisualBell",o.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",o.AllowChords="terminal.integrated.allowChords",o.AllowMnemonics="terminal.integrated.allowMnemonics",o.TabFocusMode="terminal.integrated.tabFocusMode",o.EnvMacOs="terminal.integrated.env.osx",o.EnvLinux="terminal.integrated.env.linux",o.EnvWindows="terminal.integrated.env.windows",o.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",o.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",o.ExperimentalWindowsUseConptyDll="terminal.integrated.experimental.windowsUseConptyDll",o.ShowExitAlert="terminal.integrated.showExitAlert",o.SplitCwd="terminal.integrated.splitCwd",o.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",o.WordSeparators="terminal.integrated.wordSeparators",o.EnableFileLinks="terminal.integrated.enableFileLinks",o.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",o.UnicodeVersion="terminal.integrated.unicodeVersion",o.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",o.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",o.HideOnStartup="terminal.integrated.hideOnStartup",o.CustomGlyphs="terminal.integrated.customGlyphs",o.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",o.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",o.InheritEnv="terminal.integrated.inheritEnv",o.ShowLinkHover="terminal.integrated.showLinkHover",o.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",o.AutoReplies="terminal.integrated.autoReplies",o.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",o.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",o.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",o.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",o.EnableImages="terminal.integrated.enableImages",o.SmoothScrolling="terminal.integrated.smoothScrolling",o.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",o.FocusAfterRun="terminal.integrated.focusAfterRun",o.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",o.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",o.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var T;(function(o){o.Bash="bash",o.Fish="fish",o.Sh="sh",o.Csh="csh",o.Ksh="ksh",o.Zsh="zsh"})(T||(e.PosixShellType=T={}));var m;(function(o){o.CommandPrompt="cmd",o.Wsl="wsl",o.GitBash="gitbash"})(m||(e.WindowsShellType=m={}));var s;(function(o){o.PowerShell="pwsh",o.Python="python",o.Julia="julia",o.NuShell="nu"})(s||(e.GeneralShellType=s={}));var I;(function(o){o[o.Api=0]="Api",o[o.Process=1]="Process",o[o.Sequence=2]="Sequence",o[o.Config=3]="Config"})(I||(e.TitleEventSource=I={}));var w;(function(o){o.LocalPty="localPty",o.PtyHost="ptyHost",o.PtyHostWindow="ptyHostWindow",o.Logger="logger",o.Heartbeat="heartbeat"})(w||(e.TerminalIpcChannels=w={}));var u;(function(o){o.Cwd="cwd",o.InitialCwd="initialCwd",o.FixedDimensions="fixedDimensions",o.Title="title",o.ShellType="shellType",o.HasChildProcesses="hasChildProcesses",o.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",o.OverrideDimensions="overrideDimensions",o.FailedShellIntegrationActivation="failedShellIntegrationActivation",o.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(u||(e.ProcessPropertyType=u={})),e.$xs=(0,v.$Ki)("ptyService");var k;(function(o){o[o.BeatInterval=5e3]="BeatInterval",o[o.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",o[o.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",o[o.SecondWaitMultiplier=1]="SecondWaitMultiplier",o[o.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var $;(function(o){o[o.Panel=1]="Panel",o[o.Editor=2]="Editor"})($||(e.TerminalLocation=$={}));var r;(function(o){o.TerminalView="view",o.Editor="editor"})(r||(e.TerminalLocationString=r={}));var a;(function(o){o[o.GraceTime=6e4]="GraceTime",o[o.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var h;(function(o){o[o.HighWatermarkChars=1e5]="HighWatermarkChars",o[o.LowWatermarkChars=5e3]="LowWatermarkChars",o[o.CharCountAckSize=5e3]="CharCountAckSize"})(h||(e.FlowControlConstants=h={}));var c;(function(o){o.GitBash="Git Bash",o.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var i;(function(o){o[o.Off=0]="Off",o[o.FinalTerm=1]="FinalTerm",o[o.VSCode=2]="VSCode"})(i||(e.ShellIntegrationStatus=i={}));var n;(function(o){o[o.Unknown=0]="Unknown",o[o.Shutdown=1]="Shutdown",o[o.Process=2]="Process",o[o.User=3]="User",o[o.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$ys={Backend:"workbench.contributions.terminal.processBackend"};class t{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(l){const g=this.b(l.remoteAuthority);if(this.a.has(g))throw new Error(`A terminal backend with remote authority '${g}' was already registered.`);this.a.set(g,l)}getTerminalBackend(l){return this.a.get(this.b(l))}b(l){return l?.toLowerCase()??""}}P.$xo.add(e.$ys.Backend,new t),e.$zs=(0,v.$Ki)("localPtyService"),e.$As=(0,v.$Ki)("terminalLogService")}),define(Re[182],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6zb=void 0;class v{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,L,R=5){const T=L(m=>{const s=typeof m=="string"?m:m.data;let I=this.a.get(P);if(I){I.data.push(s);return}const w=setTimeout(()=>this.flushBuffer(P),R);I={data:[s],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(P),T.dispose()}},this.a.set(P,I)});return T}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const L=this.a.get(P);L&&(this.a.delete(P),this.b(P,L.data.join("")))}}e.$6zb=v}),define(Re[183],Oe([1,0,10,98,282,36,6,14,2,9,78,29]),function(we,e,v,D,P,L,R,T,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rx=e.$Qx=e.$Px=e.$Ox=e.$Nx=e.$Mx=e.IconFontDefinition=e.IconContribution=e.$Jx=void 0,e.$Kx=a,e.$Lx=h,w=Ve(w),e.$Jx={IconContribution:"base.contributions.icons"};var u;(function(t){function o(l,g){let f=l.defaults;for(;L.ThemeIcon.isThemeIcon(f);){const d=r.getIcon(f.id);if(!d)return;f=d.defaults}return f}t.getDefinition=o})(u||(e.IconContribution=u={}));var k;(function(t){function o(g){return{weight:g.weight,style:g.style,src:g.src.map(f=>({format:f.format,location:f.location.toString()}))}}t.toJSONObject=o;function l(g){const f=d=>(0,T.$jg)(d)?d:void 0;if(g&&Array.isArray(g.src)&&g.src.every(d=>(0,T.$jg)(d.format)&&(0,T.$jg)(d.location)))return{weight:f(g.weight),style:f(g.style),src:g.src.map(d=>({format:d.format,location:m.URI.parse(d.location)}))}}t.fromJSONObject=l})(k||(e.IconFontDefinition=k={}));class ${constructor(){this.a=new R.$qe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,s.localize)(2364,null)},fontCharacter:{type:"string",description:(0,s.localize)(2365,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${L.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,l,g,f){const d=this.b[o];if(d){if(g&&!d.description){d.description=g,this.d.properties[o].markdownDescription=`${g} $(${o})`;const y=this.e.enum.indexOf(o);y!==-1&&(this.e.enumDescriptions[y]=g),this.a.fire()}return d}const S={id:o,description:g,defaults:l,deprecationMessage:f};this.b[o]=S;const E={$ref:"#/definitions/icons"};return f&&(E.deprecationMessage=f),g&&(E.markdownDescription=`${g}: $(${o})`),this.d.properties[o]=E,this.e.enum.push(o),this.e.enumDescriptions.push(g||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const l=this.e.enum.indexOf(o);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,l){const g=this.f[o];return g||(this.f[o]=l,this.a.fire(),l)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(d,S)=>d.id.localeCompare(S.id),l=d=>{for(;L.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.b).map(d=>this.b[d]);for(const d of f.filter(S=>!!S.description).sort(o))g.push(`|<i class="${l(d)}"></i>|${d.id}|${L.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const d of f.filter(S=>!L.ThemeIcon.isThemeIcon(S.defaults)).sort(o))g.push(`|<i class="${l(d)}"></i>|${d.id}|`);return g.join(`
`)}}const r=new $;w.$xo.add(e.$Jx.IconContribution,r);function a(t,o,l,g){return r.registerIcon(t,o,l,g)}function h(){return r}function c(){const t=(0,P.$6j)();for(const o in t){const l="\\"+t[o].toString(16);r.registerIcon(o,{fontCharacter:l})}}c(),e.$Mx="vscode://schemas/icons";const i=w.$xo.as(I.$yo.JSONContribution);i.registerSchema(e.$Mx,r.getIconSchema());const n=new v.$Wh(()=>i.notifySchemaChanged(e.$Mx),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Nx=a("widget-close",D.$0j.close,(0,s.localize)(2366,null)),e.$Ox=a("goto-previous-location",D.$0j.arrowUp,(0,s.localize)(2367,null)),e.$Px=a("goto-next-location",D.$0j.arrowDown,(0,s.localize)(2368,null)),e.$Qx=L.ThemeIcon.modify(D.$0j.sync,"spin"),e.$Rx=L.ThemeIcon.modify(D.$0j.loading,"spin")}),define(Re[184],Oe([1,0,6,4,23,2,44,3,11]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yw=e.$Xw=e.$Uw=e.$Sw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ow=e.$Nw=void 0,e.$Pw=w,e.$Qw=k,e.$Rw=$,e.$Tw=r,e.$Vw=a,e.$Ww=h,e.$Nw=(0,T.$Ki)("tunnelService"),e.$Ow=(0,T.$Ki)("sharedTunnelsService");var s;(function(n){n.Http="http",n.Https="https"})(s||(e.TunnelProtocol=s={}));var I;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(I||(e.TunnelPrivacyId=I={}));function w(n){return!!n.forwardPort}var u;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function k(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function $(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const o of t){const l=o.split("=")[1];if(/^https?:/.exec(l)){const g=k(L.URI.parse(l));if(g)return g}}}e.$Sw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.$Sw.indexOf(n)>=0}e.$Uw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(n){return e.$Uw.indexOf(n)>=0}function h(n,t,o,l){if(o===P.OperatingSystem.Windows)return!1;if(o===P.OperatingSystem.Macintosh&&a(t)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(g?.length===4&&parseInt(g[1])>=18)return!1}return n<1024}class c{constructor(t,o,l){this.remoteAddress=t,this.localAddress=o,this.b=l,this.a=new v.$qe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Xw=c;let i=class extends D.$Zc{constructor(t,o){super(),this.r=t,this.s=o,this.a=new v.$qe,this.onTunnelOpened=this.a.event,this.b=new v.$qe,this.onTunnelClosed=this.b.event,this.c=new v.$qe,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],o=Array.from(this.f.values());for(const l of o){const g=Array.from(l.values());for(const f of g){const d=await f.value;d&&typeof d!="string"&&t.push(d)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:o}of t.values())await o.then(l=>typeof l!="string"?l?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,o,l,g,f){this.z(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:l,privacy:g,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(a(t)||r(t))&&(t=e.$Sw[0]);const l=this.D(t,o);if(l)return++l.refcount,l.value}openTunnel(t,o,l,g,f,d=!1,S,E){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${l} on local port ${f}.`);const y=this.g??t;if(!y)return;if(o||(o="localhost"),g||(g=this.t),this.g&&this.n.has(l)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(y,o,l,g,f,d,S,E);return C?C.then(O=>{if(O){if(typeof O=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(o,l),O}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(o,l);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.w(O);return(O.tunnelRemoteHost!==o||O.tunnelRemotePort!==l)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),S&&O.privacy!==S&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.f.get(t.tunnelRemoteHost);if(o){const l=o.get(t.tunnelRemotePort);l&&(l.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,l))}}}}async y(t,o,l){if(l.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const g=l.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(o),g}}async closeTunnel(t,o){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const l=this.f.get(t);if(l&&l.has(o)){const g=l.get(o);g.refcount=0,await this.y(t,o,g)}}z(t,o,l){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(o,{refcount:1,value:l})}async C(t,o){const l=this.f.get(t);if(l){const g=l.get(o),f=g?await g.value:void 0;(!f||typeof f=="string")&&l.delete(o),l.size===0&&this.f.delete(t)}}D(t,o){const l=[t];r(t)?(l.push(...e.$Sw),l.push(...e.$Uw)):a(t)&&l.push(...e.$Uw);const g=l.map(f=>this.f.get(f));for(const f of g){const d=f?.get(o);if(d)return d}}canTunnel(t){return!!k(t)}G(t,o,l,g,f,d,S){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${l} on local port ${g}.`);const E=l;this.n.add(E);const y=g===void 0?l:g,C={elevationRequired:f?this.isPortPrivileged(y):!1},O={remoteAddress:{host:o,port:l},localAddressPort:g,privacy:d,public:d?d!==I.Private:void 0,protocol:S},p=t.forwardPort(O,C);return p?(this.z(o,l,p),p.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(E)})):this.n.delete(E),p}};e.$Yw=i,e.$Yw=i=Ke([qe(0,m.$fk),qe(1,R.$ej)],i)}),define(Re[114],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=void 0,e.$Pl=(0,v.$Ki)("IUriIdentityService")}),define(Re[185],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Zw=void 0,e.$Zw=(0,v.$Ki)("editSessionIdentityService");var D;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(D||(e.EditSessionIdentityMatch=D={}))}),define(Re[186],Oe([1,0,15]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=D,e.$JN=P,e.$KN=L,e.$LN=R,e.$MN=T;function D(m){return m.scheme!==v.Schemas.file&&m.scheme!==v.Schemas.vscodeRemote}function P(m){if(m.folders.length)return m.folders.every(s=>D(s.uri))?m.folders[0].uri:void 0;if(m.configuration&&D(m.configuration))return m.configuration}function L(m){return P(m)?.scheme}function R(m){return P(m)?.authority}function T(m){return P(m)!==void 0}}),define(Re[49],Oe([1,0,9,22,48,24,2,3,15]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$0i=e.$9i=e.$8i=e.$7i=e.$5i=e.$4i=e.WorkbenchState=e.$Xi=e.$Wi=e.$Ti=void 0,e.$Ui=s,e.$Vi=I,e.$Yi=w,e.$Zi=u,e.$1i=k,e.$2i=r,e.$3i=a,e.$6i=i,e.$$i=n,e.$_i=t,e.$bj=o,e.$cj=l,e.$dj=g,e.$Ti=(0,T.$Ki)("contextService");function s(f){const d=f;return typeof d?.id=="string"&&R.URI.isUri(d.uri)}function I(f){return typeof f?.id=="string"&&!s(f)&&!u(f)}e.$Wi={id:"ext-dev"},e.$Xi={id:"empty-window"};function w(f,d){if(typeof f=="string"||typeof f>"u")return typeof f=="string"?{id:(0,D.$sc)(f)}:d?e.$Wi:e.$Xi;const S=f;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function u(f){const d=f;return typeof d?.id=="string"&&R.URI.isUri(d.configPath)}function k(f){const d=f;if(d?.uri)return{id:d.id,uri:R.URI.revive(d.uri)};const S=f;if(S?.configPath)return{id:S.id,configPath:R.URI.revive(S.configPath)};if(f?.id)return{id:f.id}}var $;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function r(f){const d=f;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}function a(f){const d=f;return!!(d&&typeof d=="object"&&R.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}class h{constructor(d,S,E,y,C){this.h=d,this.j=E,this.k=y,this.l=C,this.c=P.$Qi.forUris(this.l,()=>!0),this.folders=S}update(d){this.h=d.id,this.k=d.configuration,this.j=d.transient,this.l=d.l,this.folders=d.folders}get folders(){return this.g}set folders(d){this.g=d,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(d){this.k=d}getFolder(d){return d&&this.c.findSubstr(d)||null}n(){this.c=P.$Qi.forUris(this.l,()=>!0);for(const d of this.folders)this.c.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$4i=h;class c{constructor(d,S){this.raw=S,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,L.$lh)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$5i=c;function i(f){return new c({uri:f,index:0,name:(0,L.$hh)(f)},{uri:f.toString()})}e.$7i="code-workspace",e.$8i=`.${e.$7i}`,e.$9i=[{name:(0,v.localize)(2489,null),extensions:[e.$7i]}],e.$0i="workspace.json";function n(f,d){return L.$ch.isEqualOrParent(f,d.untitledWorkspacesHome)}function t(f){let d;return R.URI.isUri(f)?d=f:d=f.configuration,d?.scheme===m.Schemas.tmp}e.$aj="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function o(f){return f.id===e.$aj}function l(f,d){return!n(f,d)&&!t(f)}function g(f){return(typeof f=="string"?(0,D.$tc)(f):(0,L.$jh)(f))===e.$8i}}),define(Re[115],Oe([1,0,76,6,4,24,2,9,107,28,3,11,49,27,114,10,33,13,14]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.$Rl=e.ProfileResourceType=void 0,e.$Ql=n,e.$Sl=t,e.$Tl=o;var i;(function(f){f.Settings="settings",f.Keybindings="keybindings",f.Snippets="snippets",f.Tasks="tasks",f.Extensions="extensions",f.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(f){const d=f;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&typeof d.isDefault=="boolean"&&typeof d.name=="string"&&R.URI.isUri(d.location)&&R.URI.isUri(d.globalStorageHome)&&R.URI.isUri(d.settingsResource)&&R.URI.isUri(d.keybindingsResource)&&R.URI.isUri(d.tasksResource)&&R.URI.isUri(d.snippetsHome)&&R.URI.isUri(d.extensionsResource))}e.$Rl=(0,I.$Ki)("IUserDataProfilesService");function t(f,d){return{id:f.id,isDefault:f.isDefault,name:f.name,shortName:f.shortName,icon:f.icon,location:R.URI.revive(f.location).with({scheme:d}),globalStorageHome:R.URI.revive(f.globalStorageHome).with({scheme:d}),settingsResource:R.URI.revive(f.settingsResource).with({scheme:d}),keybindingsResource:R.URI.revive(f.keybindingsResource).with({scheme:d}),tasksResource:R.URI.revive(f.tasksResource).with({scheme:d}),snippetsHome:R.URI.revive(f.snippetsHome).with({scheme:d}),extensionsResource:R.URI.revive(f.extensionsResource).with({scheme:d}),cacheHome:R.URI.revive(f.cacheHome).with({scheme:d}),useDefaultFlags:f.useDefaultFlags,isTransient:f.isTransient}}function o(f,d,S,E,y,C){return{id:f,name:d,location:S,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:C&&y?.useDefaultFlags?.globalState?C.globalStorageHome:(0,L.$lh)(S,"globalStorage"),settingsResource:C&&y?.useDefaultFlags?.settings?C.settingsResource:(0,L.$lh)(S,"settings.json"),keybindingsResource:C&&y?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,L.$lh)(S,"keybindings.json"),tasksResource:C&&y?.useDefaultFlags?.tasks?C.tasksResource:(0,L.$lh)(S,"tasks.json"),snippetsHome:C&&y?.useDefaultFlags?.snippets?C.snippetsHome:(0,L.$lh)(S,"snippets"),extensionsResource:C&&y?.useDefaultFlags?.extensions?C.extensionsResource:(0,L.$lh)(S,"extensions.json"),cacheHome:(0,L.$lh)(E,f),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let l=class extends P.$Zc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(d,S,E,y){super(),this.t=d,this.u=S,this.w=E,this.y=y,this.f=!0,this.h=this.B(new D.$qe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$qe),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$qe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$qe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new k.$Fc,workspaces:new k.$Fc,emptyWindows:new Map},this.profilesHome=(0,L.$lh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$lh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(d){this.f!==d&&(this.z=void 0,this.f=d)}isEnabled(){return this.f}get C(){if(!this.z){const d=this.D(),S=[d];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,c.$jg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}S.push(o((0,L.$ih)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},d))}}catch(C){this.y.error(C)}const E=new k.$Fc,y=new Map;if(S.length)try{const C=this.Q();if(C.workspaces)for(const[O,p]of Object.entries(C.workspaces)){const b=R.URI.parse(O),M=S.find(A=>A.id===p);M&&E.set(b,M)}if(C.emptyWindows)for(const[O,p]of Object.entries(C.emptyWindows)){const b=S.find(M=>M.id===p);b&&y.set(O,b)}}catch(C){this.y.error(C)}this.z={profiles:S,workspaces:E,emptyWindows:y}}return this.z}D(){const d=o("__default__profile__",(0,T.localize)(2442,null),this.t.userRoamingDataHome,this.g);return{...d,extensionsResource:this.S()??d.extensionsResource,isDefault:!0}}async createTransientProfile(d){const S="Temp",E=new RegExp(`${(0,h.$mf)(S)}\\s(\\d+)`);let y=0;for(const O of this.profiles){const p=E.exec(O.name),b=p?parseInt(p[1]):0;y=b>y?b:y}const C=`${S} ${y+1}`;return this.createProfile((0,v.$yj)((0,a.$7g)()).toString(16),C,{transient:!0},d)}async createNamedProfile(d,S,E){return this.createProfile((0,v.$yj)((0,a.$7g)()).toString(16),d,S,E)}async createProfile(d,S,E,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(d,S,E);return y&&await this.setProfileForWorkspace(y,C),C}async F(d,S,E){if(!(0,c.$jg)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(S);return y||(y=(async()=>{try{if(this.profiles.find(b=>b.name===S||b.id===d))throw new Error(`Profile with ${S} name already exists`);const O=o(d,S,(0,L.$lh)(this.profilesHome,d),this.g,E,this.defaultProfile);await this.u.createFolder(O.location);const p=[];return this.j.fire({profile:O,join(b){p.push(b)}}),await r.Promises.settled(p),this.I([O],[],[]),O}finally{this.r.delete(S)}})(),this.r.set(S,y)),y}async updateProfile(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let E=this.profiles.find(y=>y.id===d.id);if(!E)throw new Error(`Profile '${d.name}' does not exist`);return E=o(E.id,S.name??E.name,E.location,this.g,{shortName:S.shortName??E.shortName,icon:S.icon===null?void 0:S.icon??E.icon,transient:S.transient??E.isTransient,useDefaultFlags:S.useDefaultFlags??E.useDefaultFlags},this.defaultProfile),this.I([],[],[E]),E}async removeProfile(d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(d.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(y=>y.id===d.id);if(!S)throw new Error(`Profile '${d.name}' does not exist`);const E=[];this.m.fire({profile:S,join(y){E.push(y)}});try{await Promise.allSettled(E)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(y){(0,s.$wl)(y)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=this.profiles.find(y=>y.id===S.id);if(!E)throw new Error(`Profile '${S.name}' does not exist`);this.L(d,E)}unsetWorkspace(d,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(d,void 0,S)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const d=await this.u.resolve(this.profilesHome);await Promise.all((d.children||[]).filter(S=>S.isDirectory&&this.profiles.every(E=>!this.w.extUri.isEqual(E.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const d=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled(d.map(S=>this.removeProfile(S)))}getProfileForWorkspace(d){const S=this.G(d),E=R.URI.isUri(S)?this.C.workspaces.get(S):this.C.emptyWindows.get(S);return E||((0,u.$Ui)(d)?this.s.folders.get(d.uri):(0,u.$Zi)(d)?this.s.workspaces.get(d.configPath):this.s.emptyWindows.get(d.id))}G(d){return(0,u.$Ui)(d)?d.uri:(0,u.$Zi)(d)?d.configPath:d.id}H(d){return!!([...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,d.location))||[...this.s.folders.values()].some(S=>this.w.extUri.isEqual(S.location,d.location)))}I(d,S,E){const y=[...this.profiles,...d],C=[],O=this.s.profiles;this.s.profiles=[];for(let p of y){if(p.isDefault||S.some(M=>p.id===M.id))continue;p=E.find(M=>p.id===M.id)??p;const b=O.find(M=>p.id===M.id);if(p.isTransient)this.s.profiles.push(p);else{if(b){for(const[M,A]of this.s.emptyWindows.entries())if(p.id===A.id){this.L({id:M},p);break}for(const[M,A]of this.s.workspaces.entries())if(p.id===A.id){this.L({id:"",configPath:M},p);break}for(const[M,A]of this.s.folders.entries())if(p.id===A.id){this.L({id:"",uri:M},p);break}}C.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(d,S,E)}J(d,S,E){this.h.fire({added:d,removed:S,updated:E,all:this.profiles})}L(d,S,E){if(E=S?.isTransient?!0:E,E)(0,u.$Ui)(d)?(this.s.folders.delete(d.uri),S&&this.s.folders.set(d.uri,S)):(0,u.$Zi)(d)?(this.s.workspaces.delete(d.configPath),S&&this.s.workspaces.set(d.configPath,S)):(this.s.emptyWindows.delete(d.id),S&&this.s.emptyWindows.set(d.id,S));else{this.L(d,void 0,!0);const y=this.G(d);R.URI.isUri(y)?(this.C.workspaces.delete(y),S&&this.C.workspaces.set(y,S)):(this.C.emptyWindows.delete(y),S&&this.C.emptyWindows.set(y,S)),this.M()}}M(){const d={};for(const[E,y]of this.C.workspaces.entries())d[E.toString()]=y.id;const S={};for(const[E,y]of this.C.emptyWindows.entries())S[E.toString()]=y.id;this.R({workspaces:d,emptyWindows:S}),this.z=void 0}N(d){const S={},E=this.D();if(d.workspaces)for(const[C,O]of Object.entries(d.workspaces)){const p=R.URI.parse(O);S[C]=this.w.extUri.isEqual(p,E.location)?E.id:this.w.extUri.basename(p)}const y={};if(d.emptyWindows)for(const[C,O]of Object.entries(d.emptyWindows)){const p=R.URI.parse(O);y[C]=this.w.extUri.isEqual(p,E.location)?E.id:this.w.extUri.basename(p)}return{workspaces:S,emptyWindows:y}}O(){return[]}P(d){throw new Error("not implemented")}Q(){return{}}R(d){throw new Error("not implemented")}S(){}};e.$Ul=l,e.$Ul=l=Ke([qe(0,m.$Ri),qe(1,s.$fl),qe(2,$.$Pl),qe(3,w.$fk)],l);class g extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(d){this.a=d}Q(){return this.X}R(d){this.X=d}}e.$Vl=g}),define(Re[187],Oe([1,0,10,6,4,64,14,161,3,115]),function(we,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$qq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$oq=e.$nq=e.$mq=void 0,e.$pq=k,e.$rq=r,e.$tq=h,e.$mq="__$__isNewStorageMarker",e.$nq="__$__targetStorageMarker",e.$oq=(0,m.$Ki)("storageService");var I;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var w;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var u;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function k(c){const i=c.get(e.$nq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class $ extends P.$Zc{static{this.a=60*1e3}constructor(i={flushInterval:$.a}){super(),this.m=i,this.b=this.B(new D.$te),this.c=this.B(new D.$te),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$qe),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Wh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$1c),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,n,t){return D.Event.filter(this.b.event,o=>o.scope===i&&(n===void 0||o.key===n),t)}n(){this.j.value=(0,v.$1h)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Uc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,n){const{key:t,external:o}=n;if(t===e.$nq){switch(i){case w.APPLICATION:this.H=void 0;break;case w.PROFILE:this.F=void 0;break;case w.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:o})}w(i){this.f.fire({reason:i})}get(i,n,t){return this.P(n)?.get(i,t)}getBoolean(i,n,t){return this.P(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.P(n)?.getNumber(i,t)}getObject(i,n,t){return this.P(n)?.getObject(i,t)}storeAll(i,n){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,o,l=!1){if((0,R.$sg)(n)){this.remove(i,t,l);return}this.y(()=>{this.z(i,t,o),this.P(t)?.set(i,n,l)})}remove(i,n,t=!1){this.y(()=>{this.z(i,n,void 0),this.P(n)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,n){const t=[],o=this.J(i);for(const l of Object.keys(o))o[l]===n&&t.push(l);return t}z(i,n,t,o=!1){const l=this.J(n);typeof t=="number"?l[i]!==t&&(l[i]=t,this.P(n)?.set(e.$nq,JSON.stringify(l),o)):typeof l[i]=="number"&&(delete l[i],this.P(n)?.set(e.$nq,JSON.stringify(l),o))}get D(){return this.C||(this.C=this.L(w.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(w.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(w.APPLICATION)),this.H}J(i){switch(i){case w.APPLICATION:return this.I;case w.PROFILE:return this.G;default:return this.D}}L(i){const n=this.P(i);return n?k(n):Object.create(null)}isNew(i){return this.getBoolean(e.$mq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const n=this.P(w.APPLICATION),t=this.P(w.PROFILE),o=this.P(w.WORKSPACE);switch(i){case I.NONE:await v.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await v.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(w.APPLICATION)?.items??new Map,n=this.P(w.PROFILE)?.items??new Map,t=this.P(w.WORKSPACE)?.items??new Map;return h(i,n,t,this.Q(w.APPLICATION)??"",this.Q(w.PROFILE)??"",this.Q(w.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,n){return this.w(I.NONE),(0,s.$Ql)(i)?this.R(i,n):this.S(i,n)}M(i,n){return!(i.id===n.id||r(n)&&r(i))}N(i,n,t){this.y(()=>{const o=new Set;for(const[l,g]of i)o.add(l),n.get(l)!==g&&this.u(t,{key:l,external:!0});for(const[l]of n.items)o.has(l)||this.u(t,{key:l,external:!0})})}}e.$qq=$;function r(c){return c.isDefault||!!c.useDefaultFlags?.globalState}class a extends ${constructor(){super(),this.U=this.B(new T.$kq(new T.$lq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$kq(new T.$lq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$kq(new T.$lq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(w.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(w.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(w.APPLICATION,i)))}P(i){switch(i){case w.APPLICATION:return this.U;case w.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case w.APPLICATION:return"inMemory (application)";case w.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$sq=a;async function h(c,i,n,t,o,l){const g=b=>{try{return JSON.parse(b)}catch{return b}},f=new Map,d=new Map;c.forEach((b,M)=>{f.set(M,b),d.set(M,g(b))});const S=new Map,E=new Map;i.forEach((b,M)=>{S.set(M,b),E.set(M,g(b))});const y=new Map,C=new Map;n.forEach((b,M)=>{y.set(M,b),C.set(M,g(b))}),console.group(t!==o?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const O=[];if(f.forEach((b,M)=>{O.push({key:M,value:b})}),console.table(O),console.groupEnd(),console.log(d),t!==o){console.group(`Storage: Profile (path: ${o}, profile specific)`);const b=[];S.forEach((M,A)=>{b.push({key:A,value:M})}),console.table(b),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${l})`);const p=[];y.forEach((b,M)=>{p.push({key:M,value:b})}),console.table(p),console.groupEnd(),console.log(C)}}),define(Re[80],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vqc=void 0;class v{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const L=this.c++;return this.b.set(L,P),this.e(),L}get(P,L){return this.b.has(P)?this.b.get(P)[L]:void 0}delete(P){this.b.delete(P),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Vqc=v}),define(Re[50],Oe([1,0,15,24,28,3]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=e.$1qc=void 0;class R{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new D.$ah(m=>{const s=this.b.get(m.scheme);return!(s===void 0||s&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(m,s){s===null?this.b.delete(m.scheme):this.b.set(m.scheme,s)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$1qc=R,e.$2qc=(0,L.$Ki)("IExtHostFileSystemInfo")}),define(Re[26],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Q=void 0,e.$3Q=(0,v.$Ki)("IExtHostInitDataService")}),define(Re[188],Oe([1,0,9,11,173,26]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ctc=void 0;let R=class extends P.$aS{constructor(m,s,I){const w=I.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",u=I.remote.isRemote?(0,v.localize)(2706,null):m?(0,v.localize)(2707,null):(0,v.localize)(2708,null);super(s.createLogger(w,{name:u}))}};e.$ctc=R,e.$ctc=R=Ke([qe(1,D.$gk),qe(2,L.$3Q)],R)}),define(Re[189],Oe([1,0,10]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hrc=e.$Grc=void 0;class D{constructor(R,T,m){this.h=new Map,this.a=R,this.b=T,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(s=>(this.f=s,this)),this.g=this.c.onDidChangeStorage(s=>{s.shared===this.b&&s.key===this.a&&(this.f=s.value)}),this.i=new v.$Wh(()=>{const s=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of s.values())I.complete()}catch(I){for(const w of s.values())w.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,T){let m=this.f[R];return typeof m>"u"&&(m=T),m}update(R,T){this.f[R]=T;const m=this.h.get(R);if(m!==void 0)return m.p;const s=new v.$8h;return this.h.set(R,s),this.i.isScheduled()||this.i.schedule(),s.p}dispose(){this.g.dispose()}}e.$Grc=D;class P extends D{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,T){super(R.identifier.value,!0,T),this.j=R}}e.$Hrc=P}),define(Re[190],Oe([1,0,6,2]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gsc=void 0;class P{constructor(R){this.c=R,this.a=new v.$qe,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$qe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,T,m,s){const w=this.c.getNotebookDocument(D.URI.revive(R)).acceptModelChanged(T.value,m,s);this.b.fire(w)}$acceptDirtyStateChanged(R,T){this.c.getNotebookDocument(D.URI.revive(R)).acceptDirty(T)}$acceptModelSaved(R){const T=this.c.getNotebookDocument(D.URI.revive(R));this.a.fire(T.apiNotebook)}}e.$Gsc=P}),define(Re[16],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NQ=e.$MQ=void 0,e.$MQ=(0,v.$Ki)("IExtHostRpcService");class D{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$NQ=D}),define(Re[191],Oe([1,0,18,6,4]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qrc=void 0;class L{#e;constructor(T,m){this.disposables=new P.$Yc,this.a=v.$xn.toKey(T.identifier),this.#e=m,this.onDidChange=D.Event.map(D.Event.filter(this.#e.onDidChangePassword,s=>s.extensionId===this.a),s=>({key:s.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,m){return this.#e.store(this.a,T,m)}delete(T){return this.#e.delete(this.a,T)}}e.$Qrc=L}),define(Re[65],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=e.$erc=void 0,e.$erc=(0,v.$Ki)("IURITransformerService");class D{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$frc=D});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[116],Oe([1,0,9,14,2,4,3,29,28,15,42,157,37]),function(we,e,v,D,P,L,R,T,m,s,I,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$HG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$xG=e.EditorInputCapabilities=e.$wG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=void 0,e.$nG=r,e.$oG=a,e.$pG=h,e.$qG=c,e.$rG=i,e.$sG=n,e.$tG=t,e.$uG=o,e.$vG=l,e.$yG=y,e.$zG=O,e.$AG=p,e.$BG=b,e.$CG=M,e.$DG=A,e.$EG=F,e.$FG=G,e.$GG=ae,e.$IG=ie,e.$JG=_,e.$KG=$e,e.$LG=Ie,u=oi(u),e.$iG={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$jG={id:"default",displayName:(0,v.localize)(4055,null),providerDisplayName:(0,v.localize)(4056,null)},e.$kG="workbench.editor.sidebysideEditor",e.$lG="workbench.editors.textDiffEditor",e.$mG="workbench.editors.binaryResourceDiffEditor";var k;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var $;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function r(X){const V=X;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}function a(X){const V=X;return!!V&&typeof V.getScrollPosition=="function"&&typeof V.setScrollPosition=="function"&&!!V.onDidChangeScroll}function h(X,V,re){for(const be of re.visibleEditorPanes)if(be.group.id===V&&X.matches(be.input))return be.getViewState()}function c(X){if(y(X))return!1;const V=X;return P.URI.isUri(V?.resource)}function i(X){if(y(X))return!1;const V=X;return V?.original!==void 0&&V.modified!==void 0}function n(X){if(y(X))return!1;const V=X;return!V||V.resources&&!Array.isArray(V.resources)?!1:!!V.resources||!!V.multiDiffSource}function t(X){if(y(X)||i(X))return!1;const V=X;return V?.primary!==void 0&&V.secondary!==void 0}function o(X){if(y(X))return!1;const V=X;return V?V.resource===void 0||V.resource.scheme===s.Schemas.untitled||V.forceUntitled===!0:!1}function l(X){if(y(X))return!1;const V=X;return P.URI.isUri(V?.base?.resource)&&P.URI.isUri(V?.input1?.resource)&&P.URI.isUri(V?.input2?.resource)&&P.URI.isUri(V?.result?.resource)}var g;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var f;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f||(e.SaveReason=f={}));class d{constructor(){this.a=new Map}registerSource(V,re){let be=this.a.get(V);return be||(be={source:V,label:re},this.a.set(V,be)),be.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.$wG=new d;var S;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors",X[X.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class E extends L.$Zc{}e.$xG=E;function y(X){return X instanceof E}function C(X){const V=X;return P.URI.isUri(V?.preferredResource)}function O(X){const V=X;return y(V?.primary)&&y(V?.secondary)}function p(X){const V=X;return y(V?.modified)&&y(V?.original)}function b(X,V,re,be,Pe){return Ie(be,[(0,w.$uj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(4057,null),run:()=>{const Fe={...re,limits:{size:Number.MAX_VALUE}};X.openEditor(V,Fe)}}),(0,w.$uj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(4058,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function M(X){return y(X?.editor)}function A(X){const V=X;return M(X)&&V?.group!==void 0}function F(X){const V=X;return typeof V?.groupId=="number"&&y(V.editor)}function G(X){return typeof X?.groupId=="number"}var x;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(x||(e.EditorCloseContext=x={}));var j;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LABEL=2]="GROUP_LABEL",X[X.GROUP_LOCKED=3]="GROUP_LOCKED",X[X.EDITORS_SELECTION=4]="EDITORS_SELECTION",X[X.EDITOR_OPEN=5]="EDITOR_OPEN",X[X.EDITOR_CLOSE=6]="EDITOR_CLOSE",X[X.EDITOR_MOVE=7]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=9]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=11]="EDITOR_PIN",X[X.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",X[X.EDITOR_STICKY=13]="EDITOR_STICKY",X[X.EDITOR_DIRTY=14]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var U;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class J{getOriginalUri(V,re){if(!V)return;if(l(V))return e.$HG.getOriginalUri(V.result,re);if(re?.supportSideBySide){const{primary:Pe,secondary:Fe}=this.a(V);if(Pe&&Fe){if(re?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:re.filterByScheme}),secondary:this.getOriginalUri(Fe,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===U.ANY)return this.getOriginalUri(Pe,{filterByScheme:re.filterByScheme})??this.getOriginalUri(Fe,{filterByScheme:re.filterByScheme});V=re.supportSideBySide===U.PRIMARY?Pe:Fe}}if(i(V)||n(V)||t(V)||l(V))return;const be=C(V)?V.preferredResource:V.resource;return!be||!re||!re.filterByScheme?be:this.b(be,re.filterByScheme)}a(V){return O(V)||t(V)?{primary:V.primary,secondary:V.secondary}:p(V)||i(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,re){if(!V)return;if(l(V))return e.$HG.getCanonicalUri(V.result,re);if(re?.supportSideBySide){const{primary:Pe,secondary:Fe}=this.a(V);if(Pe&&Fe){if(re?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:re.filterByScheme}),secondary:this.getCanonicalUri(Fe,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===U.ANY)return this.getCanonicalUri(Pe,{filterByScheme:re.filterByScheme})??this.getCanonicalUri(Fe,{filterByScheme:re.filterByScheme});V=re.supportSideBySide===U.PRIMARY?Pe:Fe}}if(i(V)||n(V)||t(V)||l(V))return;const be=V.resource;return!be||!re||!re.filterByScheme?be:this.b(be,re.filterByScheme)}b(V,re){if(Array.isArray(re)){if(re.some(be=>V.scheme===be))return V}else if(re===V.scheme)return V}}var Y;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.KEYBOARD=1]="KEYBOARD",X[X.MOUSE=2]="MOUSE"})(Y||(e.EditorCloseMethod=Y={}));function ae(X,V,re,be){if(!X.isSticky(V))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return re===Y.MOUSE||re===Y.KEYBOARD;case"mouse":return re===Y.MOUSE;case"keyboard":return re===Y.KEYBOARD}return!1}e.$HG=new J;var ee;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(ee||(e.CloseDirection=ee={}));class oe{constructor(){this.c=new Map,this.d=new Map}start(V){const re=this.a=V.get(R.$Ji);for(const[be,Pe]of this.c)this.e(be,Pe,re);this.c.clear()}e(V,re,be){const Pe=be.createInstance(re);this.d.set(V,Pe)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,D.$ug)(this.b)}registerEditorSerializer(V,re){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,re,this.a):this.c.set(V,re),(0,L.$Xc)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}T.$xo.add(e.$iG.EditorFactory,new oe);async function ie(X,V,re){return!X||!X.length?[]:await Promise.all(X.map(async be=>{const Pe=P.URI.revive(be.fileUri);if(!Pe){re.info("Cannot resolve the path because it is not valid.",be);return}if(!await V.canHandleResource(Pe)){re.info("Cannot resolve the path because it cannot be handled",be);return}let Be=be.exists,xe=be.type;if(typeof Be!="boolean"||typeof xe!="number")try{xe=(await V.stat(Pe)).isDirectory?m.FileType.Directory:m.FileType.Unknown,Be=!0}catch(ht){re.error(ht),Be=!1}if(!Be&&be.openOnlyIfExists){re.info("Cannot resolve the path because it does not exist",be);return}if(xe===m.FileType.Directory){re.info("Cannot resolve the path because it is a directory",be);return}const nt={...be.options,pinned:!0};return Be?{resource:Pe,options:nt}:{resource:Pe,options:nt,forceUntitled:!0}}))}var ue;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function _(X){const V=X;if(!V)return!1;const re=V;if(re.modified)return _(re.modified);const be=V;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function $e(X){return(0,I.$wj)(X)}function Ie(X,V,re){const be=(0,I.$xj)(X,V);return be.forceMessage=re?.forceMessage,be.forceSeverity=re?.forceSeverity,be.allowDialog=re?.allowDialog,be}}),define(Re[192],Oe([1,0,6,9,3,4,27,29,25,98,183]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TG=e.$SG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$RG=e.ViewContentGroups=e.$PG=e.ViewContainerLocation=e.Extensions=e.$OG=e.$NG=e.$MG=void 0,e.$QG=k,e.$MG="views",e.$NG=(0,D.localize)(4218,null),e.$OG=(0,I.$Kx)("default-view-icon",s.$0j.window,(0,D.localize)(4219,null));var w;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel",o[o.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$PG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function k(o){switch(o){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class $ extends L.$Zc{constructor(){super(...arguments),this.c=this.B(new v.$qe),this.onDidRegister=this.c.event,this.f=this.B(new v.$qe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(l,g,f){const d=this.get(l.id);if(d)return d;const S=l;return S.openCommandActionDescriptor=f?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$Cc)(this.g,g,[]).push(S),f?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:g}),S}deregisterViewContainer(l){for(const g of this.g.keys()){const f=this.g.get(g),d=f?.indexOf(l);if(d!==-1){f?.splice(d,1),f.length===0&&this.g.delete(g),this.f.fire({viewContainer:l,viewContainerLocation:g});return}}}get(l){return this.all.filter(g=>g.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(f=>f?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(g=>this.getViewContainerLocation(g)===l)}}T.$xo.add(w.ViewContainersRegistry,new $);var r;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(r||(e.ViewContentGroups=r={}));function a(o,l){const g=o.group??r.More,f=l.group??r.More;return g!==f?g.localeCompare(f):(o.order??5)-(l.order??5)}class h extends L.$Zc{constructor(){super(...arguments),this.c=this.B(new v.$qe),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$qe),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$qe),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$qe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Mc}registerViews(l,g){this.registerViews2([{views:l,viewContainer:g}])}registerViews2(l){l.forEach(({views:g,viewContainer:f})=>this.r(g,f)),this.c.fire(l)}deregisterViews(l,g){const f=this.s(l,g);f.length&&this.f.fire({views:f,viewContainer:g})}moveViews(l,g){for(const f of this.m.keys())if(f!==g){const d=this.s(l,f);d.length&&(this.r(d,g),this.g.fire({views:d,from:f,to:g}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const g of this.j){const f=(this.m.get(g)||[]).filter(d=>d.id===l)[0];if(f)return f}return null}getViewContainer(l){for(const g of this.j)if((this.m.get(g)||[]).filter(d=>d.id===l)[0])return g;return null}registerViewWelcomeContent(l,g){return this.n.add(l,g),this.h.fire(l),(0,L.$Xc)(()=>{this.n.delete(l,g),this.h.fire(l)})}registerViewWelcomeContent2(l,g){const f=new Map;for(const[d,S]of g)this.n.add(l,S),f.set(d,(0,L.$Xc)(()=>{this.n.delete(l,S),this.h.fire(l)}));return this.h.fire(l),f}getViewWelcomeContent(l){const g=[];return this.n.forEach(l,f=>g.push(f)),g.sort(a)}r(l,g){let f=this.m.get(g);f||(f=[],this.m.set(g,f),this.j.push(g));for(const d of l){if(this.getView(d.id)!==null)throw new Error((0,D.localize)(4220,null,d.id));f.push(d)}}s(l,g){const f=this.m.get(g);if(!f)return[];const d=[],S=[];for(const E of f)l.includes(E)?d.push(E):S.push(E);return d.length&&(S.length?this.m.set(g,S):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),d}}T.$xo.add(w.ViewsRegistry,new h),e.$RG=(0,P.$Ki)("viewDescriptorService");var c;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var i;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(l,g){this.c=!1,this.d=!1,(0,m.$no)(this,l),this.d=!!g,this.resolve=async f=>{if(g&&!this.c){const d=await g(f);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}f.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$SG=n;class t extends Error{constructor(l){super((0,D.localize)(4221,null,l)),this.name="NoTreeViewError"}static is(l){return!!l&&l.name==="NoTreeViewError"}}e.$TG=t}),define(Re[193],Oe([1,0,9,31]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=void 0,e.$XG=new D.$2j("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(4716,null)}),e.$YG=new D.$2j("chatVoteUpEnabled",!1,{type:"boolean",description:(0,v.localize)(4717,null)}),e.$ZG=new D.$2j("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(4718,null)}),e.$1G=new D.$2j("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(4719,null)}),e.$2G=new D.$2j("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(4720,null)}),e.$3G=new D.$2j("chatSessionResponseError",!1,{type:"boolean",description:(0,v.localize)(4721,null)}),e.$4G=new D.$2j("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(4722,null)}),e.$5G=new D.$2j("chatResponse",!1,{type:"boolean",description:(0,v.localize)(4723,null)}),e.$6G=new D.$2j("chatRequest",!1,{type:"boolean",description:(0,v.localize)(4724,null)}),e.$7G=new D.$2j("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(4725,null)}),e.$8G=new D.$2j("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(4726,null)}),e.$9G=new D.$2j("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(4727,null)}),e.$0G=new D.$2j("inChatInput",!1,{type:"boolean",description:(0,v.localize)(4728,null)}),e.$$G=new D.$2j("inChat",!1,{type:"boolean",description:(0,v.localize)(4729,null)}),e.$_G=new D.$2j("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(4730,null)}),e.$aH=new D.$2j("chatPanelParticipantRegistered",!1,{type:"boolean",description:(0,v.localize)(4731,null)}),e.$bH=new D.$2j("chatExtensionInvalid",!1,{type:"boolean",description:(0,v.localize)(4732,null)}),e.$cH=new D.$2j("chatCursorAtTop",!1),e.$dH=new D.$2j("chatInputHasAgent",!1),e.$eH=new D.$2j("chatLocation",void 0),e.$fH=new D.$2j("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(4733,null)})}),define(Re[117],Oe([1,0,283,10,19,6,41,4,34,145,13,31,18,3,11,109,177,187,193]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.ChatAgentLocation=void 0,e.$oI=g,e.$pI=f;var n;(function(d){d.Panel="panel",d.Terminal="terminal",d.Notebook="notebook",d.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(d){function S(E){switch(E){case"panel":return d.Panel;case"terminal":return d.Terminal;case"notebook":return d.Notebook;case"editor":return d.Editor}return d.Panel}d.fromRaw=S}(n||(e.ChatAgentLocation=n={})),e.$jI=(0,k.$Ki)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(S){this.g=S,this.b=new Map,this.d=new L.$qe,this.onDidChangeAgents=this.d.event,this.h=new Map,this.j=new Map,this.e=c.$_G.bindTo(this.g),this.f=c.$aH.bindTo(this.g)}registerAgent(S,E){if(this.getAgent(S))throw new Error(`Agent already registered: ${JSON.stringify(S)}`);E.isDefault&&this.f.set(!0);const C=this,O=E.slashCommands;E={...E,get slashCommands(){return O.filter(b=>!b.when||C.g.contextMatchesRules(w.$Ij.deserialize(b.when)))}};const p={data:E};return this.b.set(S,p),this.d.fire(void 0),(0,T.$Xc)(()=>{this.b.delete(S),E.isDefault&&this.f.set(!1),this.d.fire(void 0)})}registerAgentImplementation(S,E){const y=this.b.get(S);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(S)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(S)}`);return y.data.isDefault&&this.e.set(!0),y.impl=E,this.d.fire(new o(y.data,E)),(0,T.$Xc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(S,E){S.isDynamic=!0;const y={data:S,impl:E};return this.b.set(S.id,y),this.d.fire(new o(S,E)),(0,T.$Xc)(()=>{this.b.delete(S.id),this.d.fire(void 0)})}registerAgentCompletionProvider(S,E){return this.h.set(S,E),{dispose:()=>{this.h.delete(S)}}}async getAgentCompletionItems(S,E,y){return await this.h.get(S)?.(E,y)??[]}updateAgent(S,E){const y=this.b.get(S);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(S)} registered`);y.data.metadata={...y.data.metadata,...E},this.d.fire(new o(y.data,y.impl))}getDefaultAgent(S){return(0,v.$jb)(this.getActivatedAgents(),E=>!!E.isDefault&&E.locations.includes(S))}getContributedDefaultAgent(S){return this.getAgents().find(E=>!!E.isDefault&&E.locations.includes(S))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),S=>!!S.data.metadata.isSecondary)?.data}getAgent(S){if(this.i(S))return this.b.get(S)?.data}i(S){const E=this.b.get(S);return!E?.data.when||this.g.contextMatchesRules(w.$Ij.deserialize(E.data.when))}getAgentByFullyQualifiedId(S){const E=R.Iterable.find(this.b.values(),y=>g(y.data)===S)?.data;if(!(E&&!this.i(E.id)))return E}getAgents(){return Array.from(this.b.values()).map(S=>S.data).filter(S=>this.i(S.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(S=>!!S.impl).filter(S=>this.i(S.data.id)).map(S=>new o(S.data,S.impl))}getAgentsByName(S){return this.getAgents().filter(E=>E.name===S)}agentHasDupeName(S){const E=this.getAgent(S);return E?this.getAgentsByName(E.name).filter(y=>y.extensionId.value!==E.extensionId.value).length>0:!1}async invokeAgent(S,E,y,C,O){const p=this.b.get(S);if(!p?.impl)throw new Error(`No activated agent with id "${S}"`);return await p.impl.invoke(E,y,C,O)}async getFollowups(S,E,y,C,O){const p=this.b.get(S);if(!p?.impl)throw new Error(`No activated agent with id "${S}"`);return p.impl?.provideFollowups?p.impl.provideFollowups(E,y,C,O):[]}async getChatTitle(S,E,y){const C=this.b.get(S);if(!C?.impl)throw new Error(`No activated agent with id "${S}"`);if(C.impl?.provideChatTitle)return C.impl.provideChatTitle(E,y)}registerChatParticipantDetectionProvider(S,E){return this.j.set(S,E),(0,T.$Xc)(()=>{this.j.delete(S)})}hasChatParticipantDetectionProviders(){return this.j.size>0}async detectAgentOrCommand(S,E,y,C){const O=R.Iterable.first(this.j.values());if(!O)return;const p=this.getAgents().reduce((F,G)=>{F.push({participant:G.id,disambiguation:G.disambiguation??[]});for(const x of G.slashCommands)F.push({participant:G.id,command:x.name,disambiguation:x.disambiguation??[]});return F},[]),b=await O.provideParticipantDetection(S,E,{...y,participants:p},C);if(!b)return;const M=this.getAgent(b.participant);if(!M)return;if(!b.command)return{agent:M};const A=M?.slashCommands.find(F=>F.name===b.command);if(A)return{agent:M,command:A}}};e.$kI=t,e.$kI=t=Ke([qe(0,w.$3j)],t);class o{constructor(S,E){this.b=S,this.d=E}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}get disambiguation(){return this.b.disambiguation}async invoke(S,E,y,C){return this.d.invoke(S,E,y,C)}async provideFollowups(S,E,y,C){return this.d.provideFollowups?this.d.provideFollowups(S,E,y,C):[]}provideWelcomeMessage(S,E){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(S,E)}provideSampleQuestions(S,E){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(S,E)}toJSON(){return this.b}}e.$lI=o,e.$mI=(0,k.$Ki)("chatAgentNameService");let l=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(S,E,y,C){if(this.g=E,this.h=y,this.i=C,this.e=(0,s.$$d)(this,Object.create(null)),this.f=!1,!S.chatParticipantRegistry)return;this.d=S.chatParticipantRegistry;const O=C.get(i.b,h.StorageScope.APPLICATION);try{this.e.set(JSON.parse(O??"{}"),void 0)}catch{C.remove(i.b,h.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(S=>this.h.warn("Failed to fetch chat participant registry",S)).then(()=>(0,D.$Lh)(5*60*1e3)).then(()=>this.j())}async k(){const S=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const E=await(0,a.$hq)(S);if(!E||E.version!==1)throw new Error("Unexpected chat participant registry response.");const y=E.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(i.b,JSON.stringify(y),h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}getAgentNameRestriction(S){const E=this.l(S.name,S).get(),y=!S.fullName||this.l(S.fullName.replace(/\s/g,""),S).get();return E&&y}l(S,E){return this.e.map(C=>C[S.toLowerCase()]).map(C=>C?C.some(O=>(0,I.$Kf)(O,O.includes(".")?E.extensionId.value:E.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$nI=l,e.$nI=l=i=Ke([qe(0,r.$yk),qe(1,a.$bq),qe(2,$.$fk),qe(3,h.$oq)],l);function g(d){return`${d.extensionId.value}.${d.id}`}function f(d){const S="name"in d?d:{...d,name:d.id};return"extensionPublisherId"in S||(S.extensionPublisherId=S.extensionPublisher??""),"extensionDisplayName"in S||(S.extensionDisplayName=""),"extensionId"in S||(S.extensionId=new u.$xn("")),(0,m.$hi)(S)}}),define(Re[194],Oe([1,0,2,32,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RH=e.$QH=e.ChatCopyKind=e.ChatAgentVoteDownReason=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$OH=L,e.$PH=R;function L(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof v.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(D.$Wt.isIRange)}function R(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(L)}var T;(function(w){w[w.Complete=1]="Complete",w[w.Partial=2]="Partial",w[w.Omitted=3]="Omitted"})(T||(e.ChatResponseReferencePartStatusKind=T={}));var m;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(m||(e.ChatAgentVoteDirection=m={}));var s;(function(w){w.IncorrectCode="incorrectCode",w.DidNotFollowInstructions="didNotFollowInstructions",w.IncompleteCode="incompleteCode",w.MissingContext="missingContext",w.PoorlyWrittenOrFormatted="poorlyWrittenOrFormatted",w.RefusedAValidRequest="refusedAValidRequest",w.OffensiveOrUnsafe="offensiveOrUnsafe",w.Other="other",w.WillReportIssue="willReportIssue"})(s||(e.ChatAgentVoteDownReason=s={}));var I;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(I||(e.ChatCopyKind=I={})),e.$QH=(0,P.$Ki)("IChatService"),e.$RH="accessibility.voice.keywordActivation"}),define(Re[195],Oe([1,0,6,10,9]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fwb=void 0;class L{constructor(){this.f=new Map,this.m=[],this.n=new v.$qe,this.o=new v.$qe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,m,s,I){const w={command:T};if(m&&Object.keys(m).length>0&&(w.arguments=m),this.u("request",w),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const k=this.f.get(w.seq);if(k){this.f.delete(w.seq);const $={type:"response",seq:0,request_seq:w.seq,success:!1,command:T,message:(0,P.localize)(5733,null,I,T)};k($)}},I)}return s&&this.f.set(w.seq,s),w.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,m){return T.type!=="event"||m.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,D.$Lh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const m=T,s=this.f.get(m.request_seq);s&&(this.f.delete(m.request_seq),s(m));break}}}}u(T,m){m.type=T,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((m,s)=>T.set(s,m)),await(0,D.$Lh)(500),T.forEach((m,s)=>{m({type:"response",seq:0,request_seq:s,success:!1,command:"canceled",message:"canceled"}),this.f.delete(s)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$fwb=L}),define(Re[81],Oe([1,0,2,9,31,3]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$aL=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$$K=e.MemoryRangeType=e.State=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=void 0,e.$0K=m,e.$_K=I,D=Ve(D),e.$XJ="workbench.view.debug",e.$YJ="workbench.debug.variablesView",e.$ZJ="workbench.debug.watchExpressionsView",e.$1J="workbench.debug.callStackView",e.$2J="workbench.debug.loadedScriptsView",e.$3J="workbench.debug.breakPointsView",e.$4J="workbench.debug.disassemblyView",e.$5J="workbench.panel.repl",e.$6J="workbench.panel.repl.view",e.$7J=new P.$2j("debugType",void 0,{type:"string",description:D.localize(5734,null)}),e.$8J=new P.$2j("debugConfigurationType",void 0,{type:"string",description:D.localize(5735,null)}),e.$9J=new P.$2j("debugState","inactive",{type:"string",description:D.localize(5736,null)}),e.$0J="debugUx",e.$$J=new P.$2j(e.$0J,"default",{type:"string",description:D.localize(5737,null)}),e.$_J=new P.$2j("hasDebugged",!1,{type:"boolean",description:D.localize(5738,null)}),e.$aK=new P.$2j("inDebugMode",!1,{type:"boolean",description:D.localize(5739,null)}),e.$bK=new P.$2j("inDebugRepl",!1,{type:"boolean",description:D.localize(5740,null)}),e.$cK=new P.$2j("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(5741,null)}),e.$dK=new P.$2j("inBreakpointWidget",!1,{type:"boolean",description:D.localize(5742,null)}),e.$eK=new P.$2j("breakpointsFocused",!0,{type:"boolean",description:D.localize(5743,null)}),e.$fK=new P.$2j("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(5744,null)}),e.$gK=new P.$2j("watchExpressionsExist",!1,{type:"boolean",description:D.localize(5745,null)}),e.$hK=new P.$2j("variablesFocused",!0,{type:"boolean",description:D.localize(5746,null)}),e.$iK=new P.$2j("expressionSelected",!1,{type:"boolean",description:D.localize(5747,null)}),e.$jK=new P.$2j("breakpointInputFocused",!1,{type:"boolean",description:D.localize(5748,null)}),e.$kK=new P.$2j("callStackItemType",void 0,{type:"string",description:D.localize(5749,null)}),e.$lK=new P.$2j("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(5750,null)}),e.$mK=new P.$2j("callStackItemStopped",!1,{type:"boolean",description:D.localize(5751,null)}),e.$nK=new P.$2j("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(5752,null)}),e.$oK=new P.$2j("watchItemType",void 0,{type:"string",description:D.localize(5753,null)}),e.$pK=new P.$2j("canViewMemory",void 0,{type:"boolean",description:D.localize(5754,null)}),e.$qK=new P.$2j("breakpointItemType",void 0,{type:"string",description:D.localize(5755,null)}),e.$rK=new P.$2j("breakpointItemBytes",void 0,{type:"boolean",description:D.localize(5756,null)}),e.$sK=new P.$2j("breakpointHasModes",!1,{type:"boolean",description:D.localize(5757,null)}),e.$tK=new P.$2j("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(5758,null)}),e.$uK=new P.$2j("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(5759,null)}),e.$vK=new P.$2j("loadedScriptsItemType",void 0,{type:"string",description:D.localize(5760,null)}),e.$wK=new P.$2j("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(5761,null)}),e.$xK=new P.$2j("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(5762,null)}),e.$yK=new P.$2j("stepBackSupported",!1,{type:"boolean",description:D.localize(5763,null)}),e.$zK=new P.$2j("restartFrameSupported",!1,{type:"boolean",description:D.localize(5764,null)}),e.$AK=new P.$2j("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(5765,null)}),e.$BK=new P.$2j("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(5766,null)}),e.$CK=new P.$2j("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(5767,null)}),e.$DK=new P.$2j("breakpointsExist",!1,{type:"boolean",description:D.localize(5768,null)}),e.$EK=new P.$2j("debuggersAvailable",!1,{type:"boolean",description:D.localize(5769,null)}),e.$FK=new P.$2j("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(5770,null)}),e.$GK=new P.$2j("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(5771,null)}),e.$HK=new P.$2j("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(5772,null)}),e.$IK=new P.$2j("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:D.localize(5773,null)}),e.$JK=new P.$2j("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(5774,null)}),e.$KK=new P.$2j("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(5775,null)}),e.$LK=new P.$2j("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(5776,null)}),e.$MK=new P.$2j("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(5777,null)}),e.$NK=new P.$2j("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(5778,null)}),e.$OK=new P.$2j("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(5779,null)}),e.$PK=new P.$2j("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(5780,null)}),e.$QK=new P.$2j("variableIsReadonly",!1,{type:"boolean",description:D.localize(5781,null)}),e.$RK=new P.$2j("variableValue",!1,{type:"string",description:D.localize(5782,null)}),e.$SK=new P.$2j("variableType",!1,{type:"string",description:D.localize(5783,null)}),e.$TK=new P.$2j("variableInterfaces",!1,{type:"array",description:D.localize(5784,null)}),e.$UK=new P.$2j("variableName",!1,{type:"string",description:D.localize(5785,null)}),e.$VK=new P.$2j("variableLanguage",!1,{type:"string",description:D.localize(5786,null)}),e.$WK=new P.$2j("variableExtensionId",!1,{type:"string",description:D.localize(5787,null)}),e.$XK=new P.$2j("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(5788,null)}),e.$YK=new P.$2j("multiSessionRepl",!1,{type:"boolean",description:D.localize(5789,null)}),e.$ZK=new P.$2j("multiSessionDebug",!1,{type:"boolean",description:D.localize(5790,null)}),e.$1K=new P.$2j("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(5791,null)}),e.$2K=new P.$2j("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(5792,null)}),e.$3K=new P.$2j("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(5793,null)}),e.$4K=new P.$2j("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(5794,null)});const R=i=>D.localize(5795,null,i);e.$5K=R,e.$6K="editor.contrib.debug",e.$7K="editor.contrib.breakpoint",e.$8K="debug",e.$9K={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(5796,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function m(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var s;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$$K="vscode-debug-memory";function I(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var w;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(w||(e.DataBreakpointSetType=w={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var k;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$aL=(0,L.$Ki)("debugService");var $;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})($||(e.BreakpointWidgetContext=$={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var a;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(a||(e.DebugTreeItemCollapsibleState=a={}));var h;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(h||(e.IDebugVisualizationTreeItem=h={}));var c;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:v.URI.revive(n.iconPath.light),dark:v.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(c||(e.IDebugVisualization=c={}))}),define(Re[196],Oe([1,0,13,2,22,25,15,32,19,17]),function(we,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=void 0,e.$sI=w,e.$tI=u,e.$uI=k,e.$vI=$,e.$wI=r,e.$xI=a,e.$yI=h,e.$zI=i,e.$AI=o,e.$BI=l,e.$CI=f,e.$DI=S;const I=/{([^}]+)}/g;function w(y,C,O){return y.replace(I,function(p,b){return C&&b.length>0&&b[0]!=="_"?p:O&&O.hasOwnProperty(b)?O[b]:p})}function u(y){const C={};for(const O of Object.keys(y))O.startsWith("!")||(C[O]=y[O]);return C}function k(y){return y.configuration.request==="attach"&&!$(y)&&(!y.parentSession||k(y.parentSession))}function $(y){let C=y.configuration.type;if(C)return C==="vslsShare"&&(C=y.configuration.adapterProxy.configuration.type),(0,v.$Kf)(C,"extensionhost")||(0,v.$Kf)(C,"pwa-extensionhost")?y:y.parentSession?$(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function a(y,C,O){let p,b=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let A=null;for(;A=M.exec(y);){const F=A.index+1,G=F+A[0].length;if(F<=C&&G>=O){p=A[0],b=F;break}}if(p){const F=/(\w|\p{L})+/gu;let G=null;for(;(G=F.exec(p))&&!(G.index+1+b+G[0].length>=O););G&&(p=p.substring(0,F.lastIndex))}return p?{start:b,end:b+p.length-1}:{start:0,end:0}}async function h(y,C,O,p){if(y.evaluatableExpressionProvider.has(C)){const b=y.evaluatableExpressionProvider.ordered(C),M=(0,s.$Lb)(await Promise.all(b.map(async A=>{try{return await A.provideEvaluatableExpression(C,O,p??m.CancellationToken.None)}catch{return}})));if(M.length>0){let A=M[0].expression;const F=M[0].range;return A||(A=C.getLineContent(O.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:A}}}else{const b=C.getLineContent(O.lineNumber),{start:M,end:A}=a(b,O.column,O.column),F=b.substring(M-1,A);return{matchingExpression:F,range:new T.$Wt(O.lineNumber,M,O.lineNumber,M+F.length)}}return null}const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(c))}function n(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return D.URI.parse(y.path);if((0,P.$nc)(y.path))return D.URI.file(y.path)}return y.path}function t(y){if(typeof y.path=="object"){const C=D.URI.revive(y.path);if(C)return C.scheme===R.Schemas.file?C.fsPath:C.toString()}return y.path}function o(y,C){const O=C?n:t,p=(0,L.$ko)(y);return g(p,(b,M)=>{b&&M&&(M.path=O(M))}),p}function l(y,C){const O=C?n:t,p=(0,L.$ko)(y);return g(p,(b,M)=>{!b&&M&&(M.path=O(M))}),p}function g(y,C){switch(y.type){case"event":{const O=y;switch(O.event){case"output":C(!1,O.body.source);break;case"loadedSource":C(!1,O.body.source);break;case"breakpoint":C(!1,O.body.breakpoint.source);break;default:break}break}case"request":{const O=y;switch(O.command){case"setBreakpoints":C(!0,O.arguments.source);break;case"breakpointLocations":C(!0,O.arguments.source);break;case"source":C(!0,O.arguments.source);break;case"gotoTargets":C(!0,O.arguments.source);break;case"launchVSCode":O.arguments.args.forEach(p=>C(!1,p));break;default:break}break}case"response":{const O=y;if(O.success&&O.body)switch(O.command){case"stackTrace":O.body.stackFrames.forEach(p=>C(!1,p.source));break;case"loadedSources":O.body.sources.forEach(p=>C(!1,p));break;case"scopes":O.body.scopes.forEach(p=>C(!1,p.source));break;case"setFunctionBreakpoints":O.body.breakpoints.forEach(p=>C(!1,p.source));break;case"setBreakpoints":O.body.breakpoints.forEach(p=>C(!1,p.source));break;case"disassemble":O.body?.instructions.forEach(b=>C(!1,b.location));break;case"locations":C(!1,O.body?.source);break;default:break}break}}}function f(y){return y.filter(C=>!C.presentation?.hidden).sort((C,O)=>C.presentation?O.presentation?C.presentation.group?O.presentation.group?C.presentation.group!==O.presentation.group?C.presentation.group.localeCompare(O.presentation.group):d(C.presentation.order,O.presentation.order):-1:O.presentation.group?1:d(C.presentation.order,O.presentation.order):-1:O.presentation?1:0)}function d(y,C){return typeof y!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:y-C}async function S(y,C){const O=y.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(O!=="none"&&(await C.saveAll(),O==="allEditorsInActiveGroup")){const p=C.activeEditorPane;p&&p.input.resource?.scheme===R.Schemas.untitled&&await C.save({editor:p.input,groupId:p.group.id})}await y.reloadConfiguration()}const E=(y,C)=>!y||!C?y===C:y.name===C.name&&y.path===C.path&&y.sourceReference===C.sourceReference;e.$EI=E}),define(Re[197],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.CellExecutionUpdateType=void 0;var D;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(D||(e.CellExecutionUpdateType=D={})),e.$iL=(0,v.$Ki)("INotebookExecutionService")}),define(Re[198],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.$lL=e.ProxyKernelState=e.$kL=void 0,e.$kL=100;var D;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(D||(e.ProxyKernelState=D={})),e.$lL=(0,v.$Ki)("INotebookKernelService"),e.$mL=(0,v.$Ki)("INotebookKernelHistoryService")}),define(Re[199],Oe([1,0,4,32,52,166,102]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S2b=void 0;class T extends v.$Zc{constructor(s,I,w){super(),this._source=s,this.b=I,this.c=w,this.a=void 0}f(s){const I=s.getLineCount();return new D.$Wt(1,1,I,this.g(s,I))}g(s,I){if(I<1||I>s.getLineCount())throw new Error("Illegal value for lineNumber");return s.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const s=new L.$JD;s.acceptChunk(this._source);const I=s.finish(!0),{textBuffer:w,disposable:u}=I.create(P.DefaultEndOfLine.LF);this.b=w,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(s=>{const I=new L.$JD;I.acceptChunk(s);const w=I.finish(!0),{textBuffer:u,disposable:k}=w.create(P.DefaultEndOfLine.LF);return this.B(k),u})),this.a}findInInputs(s){const w=new R.$xD(s,!1,!1,null).parseSearchRequest();if(!w)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,w,!0,5e3)}findInOutputs(s){const w=new R.$xD(s,!1,!1,null).parseSearchRequest();return w?this.outputTextBuffers.map(u=>{const k=u.findMatchesLineByLine(this.f(u),w,!0,5e3);if(k.length!==0)return{textBuffer:u,matches:k}}).filter(u=>!!u):[]}}e.$S2b=T}),define(Re[54],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(L){L.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var D;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(D||(e.TestPosition=D={}));class P{static fromExtHostTestItem(R,T,m=R.parent){if(R._isRoot)return new P([T]);const s=[R.id];for(let I=m;I&&I.id!==T;I=I.parent)s.push(I.id);return s.push(T),new P(s.reverse())}static isRoot(R){return!R.includes(v.Delimiter)}static root(R){const T=R.indexOf(v.Delimiter);return T===-1?R:R.slice(0,T)}static fromString(R){return new P(R.split(v.Delimiter))}static join(R,T){return new P([...R.path,T])}static joinToString(R,T){return R.toString()+v.Delimiter+T}static parentId(R){const T=R.lastIndexOf(v.Delimiter);return T===-1?void 0:R.slice(0,T)}static localId(R){const T=R.lastIndexOf(v.Delimiter);return T===-1?R:R.slice(T+v.Delimiter.length)}static isChild(R,T){return T[R.length]===v.Delimiter&&T.startsWith(R)}static compare(R,T){return R===T?D.IsSame:P.isChild(R,T)?D.IsChild:P.isChild(T,R)?D.IsParent:D.Disconnected}static getLengthOfCommonPrefix(R,T){if(R===0)return 0;let m=0;for(;m<R-1;){for(let s=1;s<R;s++){const I=T(s-1),w=T(s);if(I.path[m]!==w.path[m])return m}m++}return m}constructor(R,T=R.length){if(this.path=R,this.d=T,R.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let T=0;T<R.d&&T<this.d;T++)if(R.path[T]!==this.path[T])return D.Disconnected;return R.d>this.d?D.IsChild:R.d<this.d?D.IsParent:D.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+=v.Delimiter,this.c+=this.path[R]}return this.c}}e.$rJ=P}),define(Re[55],Oe([1,0,2,101,32,54]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$zJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$yJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$xJ=e.$wJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$vJ=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$uJ=e.$tJ=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$sJ=e.TestResultState=void 0;var R;(function(U){U[U.Unset=0]="Unset",U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$sJ={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var T;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var m;(function(U){U[U.Refresh=2]="Refresh",U[U.CodeRelatedToTest=4]="CodeRelatedToTest",U[U.TestRelatedToCode=8]="TestRelatedToCode"})(m||(e.TestControllerCapability=m={}));var s;(function(U){U[U.Run=2]="Run",U[U.Debug=4]="Debug",U[U.Coverage=8]="Coverage",U[U.HasNonDefaultProfile=16]="HasNonDefaultProfile",U[U.HasConfigurable=32]="HasConfigurable",U[U.SupportsContinuousRun=64]="SupportsContinuousRun"})(s||(e.TestRunProfileBitset=s={})),e.$tJ=[s.Run,s.Debug,s.Coverage,s.HasNonDefaultProfile,s.HasConfigurable,s.SupportsContinuousRun];const I=U=>"runId"in U;e.$uJ=I;var w;(function(U){U.serialize=J=>({range:J.range.toJSON(),uri:J.uri.toJSON()}),U.deserialize=(J,Y)=>({range:P.$Wt.lift(Y.range),uri:J.asCanonicalUri(v.URI.revive(Y.uri))})})(w||(e.IRichLocation=w={}));var u;(function(U){U[U.Error=0]="Error",U[U.Output=1]="Output"})(u||(e.TestMessageType=u={}));var k;(function(U){U.serialize=J=>({label:J.label,uri:J.uri?.toJSON(),position:J.position?.toJSON()}),U.deserialize=(J,Y)=>({label:Y.label,uri:Y.uri?J.asCanonicalUri(v.URI.revive(Y.uri)):void 0,position:Y.position?D.$Vt.lift(Y.position):void 0})})(k||(e.ITestMessageStackFrame=k={}));var $;(function(U){U.serialize=J=>({message:J.message,type:u.Error,expected:J.expected,actual:J.actual,contextValue:J.contextValue,location:J.location&&w.serialize(J.location),stackTrace:J.stackTrace?.map(k.serialize)}),U.deserialize=(J,Y)=>({message:Y.message,type:u.Error,expected:Y.expected,actual:Y.actual,contextValue:Y.contextValue,location:Y.location&&w.deserialize(J,Y.location),stackTrace:Y.stackTrace&&Y.stackTrace.map(ae=>k.deserialize(J,ae))})})($||(e.ITestErrorMessage=$={}));const r=(U,J)=>`${J?"s":"e"}${U}`;e.$vJ=r;var a;(function(U){U.serialize=J=>({message:J.message,type:u.Output,offset:J.offset,length:J.length,location:J.location&&w.serialize(J.location)}),U.deserialize=(J,Y)=>({message:Y.message,type:u.Output,offset:Y.offset,length:Y.length,location:Y.location&&w.deserialize(J,Y.location)})})(a||(e.ITestOutputMessage=a={}));var h;(function(U){U.serialize=J=>J.type===u.Error?$.serialize(J):a.serialize(J),U.deserialize=(J,Y)=>Y.type===u.Error?$.deserialize(J,Y):a.deserialize(J,Y),U.isDiffable=J=>J.type===u.Error&&J.actual!==void 0&&J.expected!==void 0})(h||(e.ITestMessage=h={}));var c;(function(U){U.serializeWithoutMessages=J=>({state:J.state,duration:J.duration,messages:[]}),U.serialize=J=>({state:J.state,duration:J.duration,messages:J.messages.map(h.serialize)}),U.deserialize=(J,Y)=>({state:Y.state,duration:Y.duration,messages:Y.messages.map(ae=>h.deserialize(J,ae))})})(c||(e.ITestTaskState=c={}));const i="\0",n=(U,J)=>U+i+J;e.$wJ=n;const t=U=>{const J=U.indexOf(i);return{ctrlId:U.slice(0,J),tagId:U.slice(J+1)}};e.$xJ=t;var o;(function(U){U.serialize=J=>({extId:J.extId,label:J.label,tags:J.tags,busy:J.busy,children:void 0,uri:J.uri?.toJSON(),range:J.range?.toJSON()||null,description:J.description,error:J.error,sortText:J.sortText}),U.deserialize=(J,Y)=>({extId:Y.extId,label:Y.label,tags:Y.tags,busy:Y.busy,children:void 0,uri:Y.uri?J.asCanonicalUri(v.URI.revive(Y.uri)):void 0,range:Y.range?P.$Wt.lift(Y.range):null,description:Y.description,error:Y.error,sortText:Y.sortText})})(o||(e.ITestItem=o={}));var l;(function(U){U[U.NotExpandable=0]="NotExpandable",U[U.Expandable=1]="Expandable",U[U.BusyExpanding=2]="BusyExpanding",U[U.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var g;(function(U){U.serialize=J=>({expand:J.expand,item:o.serialize(J.item)}),U.deserialize=(J,Y)=>({controllerId:L.$rJ.root(Y.item.extId),expand:Y.expand,item:o.deserialize(J,Y.item)})})(g||(e.InternalTestItem=g={}));var f;(function(U){U.serialize=J=>{let Y;return J.item&&(Y={},J.item.label!==void 0&&(Y.label=J.item.label),J.item.tags!==void 0&&(Y.tags=J.item.tags),J.item.busy!==void 0&&(Y.busy=J.item.busy),J.item.uri!==void 0&&(Y.uri=J.item.uri?.toJSON()),J.item.range!==void 0&&(Y.range=J.item.range?.toJSON()),J.item.description!==void 0&&(Y.description=J.item.description),J.item.error!==void 0&&(Y.error=J.item.error),J.item.sortText!==void 0&&(Y.sortText=J.item.sortText)),{extId:J.extId,expand:J.expand,item:Y}},U.deserialize=J=>{let Y;return J.item&&(Y={},J.item.label!==void 0&&(Y.label=J.item.label),J.item.tags!==void 0&&(Y.tags=J.item.tags),J.item.busy!==void 0&&(Y.busy=J.item.busy),J.item.range!==void 0&&(Y.range=J.item.range?P.$Wt.lift(J.item.range):null),J.item.description!==void 0&&(Y.description=J.item.description),J.item.error!==void 0&&(Y.error=J.item.error),J.item.sortText!==void 0&&(Y.sortText=J.item.sortText)),{extId:J.extId,expand:J.expand,item:Y}}})(f||(e.ITestItemUpdate=f={}));const d=(U,J)=>{J.expand!==void 0&&(U.expand=J.expand),J.item!==void 0&&(U.item=U.item?Object.assign(U.item,J.item):J.item)};e.$yJ=d;var S;(function(U){U.serializeWithoutMessages=J=>({...g.serialize(J),ownComputedState:J.ownComputedState,computedState:J.computedState,tasks:J.tasks.map(c.serializeWithoutMessages)}),U.serialize=J=>({...g.serialize(J),ownComputedState:J.ownComputedState,computedState:J.computedState,tasks:J.tasks.map(c.serialize)}),U.deserialize=(J,Y)=>({...g.deserialize(J,Y),ownComputedState:Y.ownComputedState,computedState:Y.computedState,tasks:Y.tasks.map(ae=>c.deserialize(J,ae)),retired:!0})})(S||(e.TestResultItem=S={}));var E;(function(U){U.empty=()=>({covered:0,total:0}),U.sum=(J,Y)=>{J.covered+=Y.covered,J.total+=Y.total}})(E||(e.ICoverageCount=E={}));var y;(function(U){U.serialize=J=>({id:J.id,statement:J.statement,branch:J.branch,declaration:J.declaration,testIds:J.testIds,uri:J.uri.toJSON()}),U.deserialize=(J,Y)=>({id:Y.id,statement:Y.statement,branch:Y.branch,declaration:Y.declaration,testIds:Y.testIds,uri:J.asCanonicalUri(v.URI.revive(Y.uri))}),U.empty=(J,Y)=>({id:J,uri:Y,statement:E.empty()})})(y||(e.IFileCoverage=y={}));function C(U){return{...U,location:U.location?.toJSON()}}function O(U){return U.location=U.location?D.$Vt.isIPosition(U.location)?D.$Vt.lift(U.location):P.$Wt.lift(U.location):void 0,U}e.$zJ=3;var p;(function(U){U[U.Declaration=0]="Declaration",U[U.Statement=1]="Statement",U[U.Branch=2]="Branch"})(p||(e.DetailType=p={}));var b;(function(U){U.serialize=J=>J.type===p.Declaration?A.serialize(J):F.serialize(J),U.deserialize=J=>J.type===p.Declaration?A.deserialize(J):F.deserialize(J)})(b||(e.CoverageDetails=b={}));var M;(function(U){U.serialize=C,U.deserialize=O})(M||(e.IBranchCoverage=M={}));var A;(function(U){U.serialize=C,U.deserialize=O})(A||(e.IDeclarationCoverage=A={}));var F;(function(U){U.serialize=J=>({...C(J),branches:J.branches?.map(M.serialize)}),U.deserialize=J=>({...O(J),branches:J.branches?.map(M.deserialize)})})(F||(e.IStatementCoverage=F={}));var G;(function(U){U[U.Add=0]="Add",U[U.Update=1]="Update",U[U.DocumentSynced=2]="DocumentSynced",U[U.Remove=3]="Remove",U[U.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",U[U.Retire=5]="Retire",U[U.AddTag=6]="AddTag",U[U.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var x;(function(U){U.deserialize=(J,Y)=>Y.op===G.Add?{op:Y.op,item:g.deserialize(J,Y.item)}:Y.op===G.Update?{op:Y.op,item:f.deserialize(Y.item)}:Y.op===G.DocumentSynced?{op:Y.op,uri:J.asCanonicalUri(v.URI.revive(Y.uri)),docv:Y.docv}:Y,U.serialize=J=>J.op===G.Add?{op:J.op,item:g.serialize(J.item)}:J.op===G.Update?{op:J.op,item:f.serialize(J.item)}:J})(x||(e.TestsDiffOp=x={}));class j{constructor(J){this.l=J,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(J){const Y=this.x();for(const ae of J)switch(ae.op){case G.Add:this.p(g.deserialize(this.l,ae.item),Y);break;case G.Update:this.q(f.deserialize(ae.item),Y);break;case G.Remove:this.v(ae.itemId,Y);break;case G.Retire:this.w(ae.itemId);break;case G.IncrementPendingExtHosts:this.updatePendingRoots(ae.amount);break;case G.AddTag:this.f.set(ae.tag.id,ae.tag);break;case G.RemoveTag:this.f.delete(ae.id);break}Y.complete?.()}p(J,Y){const ae=L.$rJ.parentId(J.item.extId)?.toString();let ee;if(!ae)ee=this.y(J),this.h.add(ee),this.g.set(J.item.extId,ee);else if(this.g.has(ae)){const oe=this.g.get(ae);oe.children.add(J.item.extId),ee=this.y(J,oe),this.g.set(J.item.extId,ee)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(J)}`);return}return Y.add?.(ee),J.expand===l.BusyExpanding&&this.j++,ee}q(J,Y){const ae=this.g.get(J.extId);if(ae)return J.expand!==void 0&&(ae.expand===l.BusyExpanding&&this.j--,J.expand===l.BusyExpanding&&this.j++),(0,e.$yJ)(ae,J),Y.update?.(ae),ae}v(J,Y){const ae=this.g.get(J);if(!ae)return;const ee=L.$rJ.parentId(ae.item.extId)?.toString();ee?this.g.get(ee).children.delete(ae.item.extId):this.h.delete(ae);const oe=[[J]];for(;oe.length;)for(const ie of oe.pop()){const ue=this.g.get(ie);ue&&(oe.push(ue.children),this.g.delete(ie),Y.remove?.(ue,ue!==ae),ue.expand===l.BusyExpanding&&this.j--)}}w(J){}updatePendingRoots(J){this.k+=J}x(){return{}}}e.$AJ=j}),define(Re[200],Oe([1,0,99,9,55]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$DHb=e.$CHb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var L;(function(w){w.ViewletId="workbench.view.extension.test",w.ExplorerViewId="workbench.view.testing",w.OutputPeekContributionId="editor.contrib.testingOutputPeek",w.DecorationsContributionId="editor.contrib.testingDecorations",w.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",w.CoverageViewId="workbench.view.testCoverage",w.ResultsPanelId="workbench.panel.testResults",w.ResultsViewId="workbench.panel.testResults.view",w.MessageLanguageId="vscodeInternalTestMessage"})(L||(e.Testing=L={}));var R;(function(w){w.List="list",w.Tree="true"})(R||(e.TestExplorerViewMode=R={}));var T;(function(w){w.ByLocation="location",w.ByStatus="status",w.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const m={[P.TestResultState.Errored]:(0,D.localize)(10841,null),[P.TestResultState.Failed]:(0,D.localize)(10842,null),[P.TestResultState.Passed]:(0,D.localize)(10843,null),[P.TestResultState.Queued]:(0,D.localize)(10844,null),[P.TestResultState.Running]:(0,D.localize)(10845,null),[P.TestResultState.Skipped]:(0,D.localize)(10846,null),[P.TestResultState.Unset]:(0,D.localize)(10847,null)},s=(w,u)=>(0,D.localize)(10848,null,(0,v.$5k)(w),m[u]);e.$CHb=s,e.$DHb={[P.TestRunProfileBitset.Debug]:(0,D.localize)(10849,null),[P.TestRunProfileBitset.Run]:(0,D.localize)(10850,null),[P.TestRunProfileBitset.Coverage]:(0,D.localize)(10851,null)};var I;(function(w){w.CancelTestRefreshAction="testing.cancelTestRefresh",w.CancelTestRunAction="testing.cancelRun",w.ClearTestResultsAction="testing.clearTestResults",w.CollapseAllAction="testing.collapseAll",w.ConfigureTestProfilesAction="testing.configureProfile",w.ContinousRunUsingForTest="testing.continuousRunUsingForTest",w.CoverageAtCursor="testing.coverageAtCursor",w.CoverageByUri="testing.coverage.uri",w.CoverageClear="testing.coverage.close",w.CoverageCurrentFile="testing.coverageCurrentFile",w.CoverageFilterToTest="testing.coverageFilterToTest",w.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",w.CoverageLastRun="testing.coverageLastRun",w.CoverageSelectedAction="testing.coverageSelected",w.CoverageToggleToolbar="testing.coverageToggleToolbar",w.CoverageViewChangeSorting="testing.coverageViewChangeSorting",w.DebugAction="testing.debug",w.DebugAllAction="testing.debugAll",w.DebugAtCursor="testing.debugAtCursor",w.DebugByUri="testing.debug.uri",w.DebugCurrentFile="testing.debugCurrentFile",w.DebugFailedTests="testing.debugFailTests",w.DebugLastRun="testing.debugLastRun",w.DebugSelectedAction="testing.debugSelected",w.FilterAction="workbench.actions.treeView.testExplorer.filter",w.GetExplorerSelection="_testing.getExplorerSelection",w.GetSelectedProfiles="testing.getSelectedProfiles",w.GoToTest="testing.editFocusedTest",w.GoToRelatedTest="testing.goToRelatedTest",w.PeekRelatedTest="testing.peekRelatedTest",w.GoToRelatedCode="testing.goToRelatedCode",w.PeekRelatedCode="testing.peekRelatedCode",w.HideTestAction="testing.hideTest",w.OpenCoverage="testing.openCoverage",w.OpenOutputPeek="testing.openOutputPeek",w.RefreshTestsAction="testing.refreshTests",w.ReRunFailedTests="testing.reRunFailTests",w.ReRunLastRun="testing.reRunLastRun",w.RunAction="testing.run",w.RunAllAction="testing.runAll",w.RunAllWithCoverageAction="testing.coverageAll",w.RunAtCursor="testing.runAtCursor",w.RunByUri="testing.run.uri",w.RunCurrentFile="testing.runCurrentFile",w.RunSelectedAction="testing.runSelected",w.RunUsingProfileAction="testing.runUsing",w.RunWithCoverageAction="testing.coverage",w.SearchForTestExtension="testing.searchForTestExtension",w.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",w.ShowMostRecentOutputAction="testing.showMostRecentOutput",w.StartContinousRun="testing.startContinuousRun",w.StopContinousRun="testing.stopContinuousRun",w.TestingSortByDurationAction="testing.sortByDuration",w.TestingSortByLocationAction="testing.sortByLocation",w.TestingSortByStatusAction="testing.sortByStatus",w.TestingViewAsListAction="testing.viewAsList",w.TestingViewAsTreeAction="testing.viewAsTree",w.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",w.ToggleInlineTestOutput="testing.toggleInlineTestOutput",w.UnhideAllTestsAction="testing.unhideAllTests",w.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Re[82],Oe([1,0,10,6,4,61,55,54]),function(we,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GQ=e.$FQ=e.$EQ=e.$DQ=e.$CQ=e.TestItemEventOp=void 0;var m;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const s=(c,i)=>c===i,w=Object.entries({range:(c,i)=>c===i?!0:!c||!i?!1:c.equalsRange(i),busy:s,label:s,description:s,error:s,sortText:s,tags:(c,i)=>!(c.length!==i.length||c.some(n=>!i.includes(n)))}),u=(c,i)=>{let n;for(const[t,o]of w)o(c[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class k extends P.$Zc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Wh(()=>this.flushDiff(),200)),this.g=this.B(new D.$qe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case R.TestDiffOpType.DocumentSynced:{for(const n of this.m)if(n.op===R.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case R.TestDiffOpType.Update:{const n=this.m[this.m.length-1];if(n){if(n.op===R.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,R.$yJ)(n.item,i.item);return}if(n.op===R.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,R.$yJ)(n.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===R.TestItemExpandState.Expandable){const o=this.M(t);return o.isOpen()?this.L(t,n-1):o.wait().then(()=>this.L(t,n-1))}else if(t.expand===R.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,n-1)):this.L(t,n-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,n){switch(n.op){case m.RemoveChild:this.O(T.$rJ.joinToString(i.fullId,n.id));break;case m.Upsert:this.z(n.item,i);break;case m.Bulk:for(const t of n.ops)this.w(i,t);break;case m.SetTags:this.C(n.new,n.old,i.fullId.toString());break;case m.UpdateCanResolveChildren:this.J(i);break;case m.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case m.DocumentSynced:this.y(i.actual.uri);break;default:(0,L.$jd)(n)}}y(i){i&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,n){const t=T.$rJ.fromExtHostTestItem(i,this.root.id,n?.actual),o=this.s.getApiFor(i);o.parent&&o.parent!==n?.actual&&this.s.getChildren(o.parent).delete(i.id);let l=this.tree.get(t.toString());if(!l){l={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,n),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,n);return}if(l.actual===i){this.H(i,l,n);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,n);const g=this.s.getChildren(l.actual),f=l.actual,d=u(this.s.toITestItem(f),this.s.toITestItem(i));this.s.getApiFor(f).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=R.TestItemExpandState.NotExpandable,d&&(d.hasOwnProperty("tags")&&(this.C(i.tags,f.tags,t.toString()),delete d.tags),this.w(l,{op:m.SetProp,update:d})),this.I(i,l,n);for(const[E,y]of g)this.s.getChildren(i).get(y.id)||this.O(T.$rJ.joinToString(t,y.id));const S=l.expandLevels;S!==void 0&&queueMicrotask(()=>{l.expand===R.TestItemExpandState.Expandable&&(l.expandLevels=void 0,this.expand(t.toString(),S))}),this.y(l.actual.uri)}C(i,n,t){const o=new Set(n.map(l=>l.id));for(const l of i)o.delete(l.id)||this.D(l);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(l=>(0,R.$wJ)(this.s.controllerId,l.id))}}}),o.forEach(this.F,this)}D(i){const n=this.j.get(i.id);n?n.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.$wJ)(this.s.controllerId,i.id)}}))}F(i){const n=this.j.get(i);n&&!--n.refCount&&(this.j.delete(i),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.$wJ)(this.s.controllerId,i)}))}G(i,n){this.s.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}H(i,n,t){this.G(i,t);const o=this.s.getApiFor(i);o.parent=t?.actual,o.listener=l=>this.w(n,l),this.J(n)}I(i,n,t){this.H(i,n,t);for(const[o,l]of this.s.getChildren(i))this.z(l,n)}J(i){let n;this.h?i.resolveBarrier?n=i.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:n=R.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===R.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,n){if(n<0)return;const t=[];for(const[o,l]of this.s.getChildren(i.actual)){const g=this.expand(T.$rJ.joinToString(i.fullId,l.id),n);(0,v.$wh)(g)&&t.push(g)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new v.$Jh;return l.open(),l}i.expand=R.TestItemExpandState.BusyExpanding,this.N(i);const n=i.resolveBarrier=new v.$Jh,t=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let o;try{o=this.h(i.actual===this.root?void 0:i.actual)}catch(l){t(l)}return(0,v.$wh)(o)?o.catch(t).then(()=>{n.open(),this.J(i)}):(n.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const o=t.pop();if(o){this.s.getApiFor(o.actual).listener=void 0;for(const l of o.actual.tags)this.F(l.id);this.tree.delete(o.fullId.toString());for(const[l,g]of this.s.getChildren(o.actual))t.push(this.tree.get(T.$rJ.joinToString(o.fullId,g.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$CQ=k;class $ extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$DQ=$;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$EQ=r;class a extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.$FQ=a;const h=(c,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(o,l){for(const g of t.values())o.call(l,g,this)},[Symbol.iterator](){return t.entries()},replace(o){const l=new Map,g=new Set(t.keys()),f={op:m.Bulk,ops:[]};for(const d of o){if(!(d instanceof n))throw new r(d.id);const S=i(d).controllerId;if(S!==c.controllerId)throw new a(d.id,S,c.controllerId);if(l.has(d.id))throw new $(d.id);l.set(d.id,d),g.delete(d.id),f.ops.push({op:m.Upsert,item:d})}for(const d of g.keys())f.ops.push({op:m.RemoveChild,id:d});c.listener?.(f),t=l},add(o){if(!(o instanceof n))throw new r(o.id);t.set(o.id,o),c.listener?.({op:m.Upsert,item:o})},delete(o){t.delete(o)&&c.listener?.({op:m.RemoveChild,id:o})},get(o){return t.get(o)},toJSON(){return Array.from(t.values())}}};e.$GQ=h}),define(Re[118],Oe([1,0,82]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=e.$HQ=void 0;const D=new WeakMap,P=(R,T)=>{const m={controllerId:T};return D.set(R,m),m};e.$HQ=P;const L=R=>{const T=D.get(R);if(!T)throw new v.$EQ(R?.id||"<unknown>");return T};e.$IQ=L}),define(Re[83],Oe([1,0,30,15,2]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uEb=e.$tEb=e.$sEb=void 0,e.$vEb=L,e.$wEb=T,e.$sEb="vscode-cdn.net",e.$tEb=`vscode-resource.${e.$sEb}`,e.$uEb=`'self' https://*.${e.$sEb}`;function L(m,s){return m.scheme===D.Schemas.http||m.scheme===D.Schemas.https?m:(s&&s.authority&&s.isRemote&&m.scheme===D.Schemas.file&&(m=P.URI.from({scheme:D.Schemas.vscodeRemote,authority:s.authority,path:m.path})),P.URI.from({scheme:D.Schemas.https,authority:`${m.scheme}+${R(m.authority)}.${e.$tEb}`,path:m.path,fragment:m.fragment,query:m.query}))}function R(m){return m.replace(/./g,s=>{const I=s.charCodeAt(0);return I>=v.CharCode.a&&I<=v.CharCode.z||I>=v.CharCode.A&&I<=v.CharCode.Z||I>=v.CharCode.Digit0&&I<=v.CharCode.Digit9?s:"-"+I.toString(16).padStart(4,"0")})}function T(m){return m.replace(/-([0-9a-f]{4})/g,(s,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Re[201],Oe([1,0,6,4,83]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crc=void 0;class L{constructor(T,m,s){this.d=T,this.e=m,this.f=s,this.a=0,this.b=new D.$Yc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const I=m.getVisibleTextEditors();for(const w of this.c.values())I.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,m,s,I,w){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){u=i;break}if(!u)throw new Error("not a visible editor");const k=this,$=this.a++,r=new v.$qe,a=new v.$qe,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$vEb)(i,k.f)}get cspSource(){return P.$uEb}set options(i){this.b=i,k.d.$setOptions($,i)}get options(){return this.b}set html(i){this.a=i,k.d.$setHtml($,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return k.d.$postMessage($,i)}},c=new class{constructor(){this.editor=T,this.line=m,this.height=s,this.webview=h,this.onDidDispose=a.event}dispose(){k.c.has($)&&(k.c.delete($),k.d.$disposeEditorInset($),a.fire(),a.dispose(),r.dispose())}};return this.d.$createEditorInset($,u.id,u.value.document.uri,m+1,s,I||{},w.identifier,w.extensionLocation),this.c.set($,{editor:T,inset:c,onDidReceiveMessage:r}),c}$onDidDispose(T){const m=this.c.get(T);m&&m.inset.dispose()}$onDidReceiveMessage(T,m){this.c.get(T)?.onDidReceiveMessage.fire(m)}}e.$crc=L}),define(Re[119],Oe([1,0,3]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=e.$cN=void 0,e.$cN="__",e.$dN=(0,v.$Ki)("IAuthenticationService"),e.$eN=(0,v.$Ki)("IAuthenticationExtensionsService")}),define(Re[202],Oe([1,0,3,12]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BR=e.VariableKind=e.$AR=void 0,e.$AR=(0,v.$Ki)("configurationResolverService");var P;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(P||(e.VariableKind=P={}));class L extends D.$fb{constructor(T,m){super(m),this.variable=T}}e.$BR=L}),define(Re[203],Oe([1,0,22,79,14,25,23,103,9,202,13]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QR=void 0,v=Ve(v),D=Ve(D),P=Ve(P),L=Ve(L);class w{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,$,r,a){this.h=new Map,this.a=k,this.b=$,this.g=r,a&&(this.c=a.then(h=>this.i(h)))}i(k){if(R.$l){const $=Object.create(null);return Object.keys(k).forEach(r=>{$[r.toLowerCase()]=k[r]}),$}return k}resolveWithEnvironment(k,$,r){return this.l({env:this.i(k),userHome:void 0},$?$.uri:void 0,r)}async resolveAsync(k,$){const r={env:await this.c,userHome:await this.g};return this.l(r,k?k.uri:void 0,$)}async j(k,$,r,a){const h=L.$ko($);R.$l&&h.windows?Object.keys(h.windows).forEach(i=>h[i]=h.windows[i]):R.$m&&h.osx?Object.keys(h.osx).forEach(i=>h[i]=h.osx[i]):R.$n&&h.linux&&Object.keys(h.linux).forEach(i=>h[i]=h.linux[i]),delete h.windows,delete h.osx,delete h.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,k?k.uri:void 0,h,r,a)}async resolveAnyAsync(k,$,r){return this.j(k,$,r)}async resolveAnyMap(k,$,r){const a=new Map;return{newConfig:await this.j(k,$,r,a),resolvedVariables:a}}resolveWithInteractionReplace(k,$,r,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,$,r,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,$){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,$)}async l(k,$,r,a,h){if(P.$jg(r))return this.m(k,$,r,a,h);if(Array.isArray(r))return Promise.all(r.map(c=>this.l(k,$,c,a,h)));if(P.$lg(r)){const c=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.m(k,$,n,a,h),await this.l(k,$,r[n],a,h)]));for(const[n,t]of i)c[n]=t;return c}return r}m(k,$,r,a,h){return(0,I.$Cf)(r,w.VARIABLE_REGEXP,async(c,i)=>{if(i.includes(w.VARIABLE_LHS))return c;let n=await this.o(k,c,i,$,a);return h?.set(i,n),n!==c&&P.$jg(n)&&n.match(w.VARIABLE_REGEXP)&&(n=await this.m(k,$,n,a,h)),n})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,$,r,a,h){let c;const i=r.split(":");i.length>1&&(r=i[0],c=i[1]);const n=l=>{const g=this.a.getFilePath();if(g)return(0,T.$0w)(g);throw new s.$BR(l,(0,m.localize)(12108,null,$))},t=l=>{const g=n(l);if(this.a.getWorkspaceFolderPathForFile){const f=this.a.getWorkspaceFolderPathForFile();if(f)return(0,T.$0w)(f)}throw new s.$BR(l,(0,m.localize)(12109,null,$,v.$sc(g)))},o=l=>{if(c){const g=this.a.getFolderUri(c);if(g)return g;throw new s.$BR(l,(0,m.localize)(12110,null,$,c))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new s.$BR(l,(0,m.localize)(12111,null,$)):new s.$BR(l,(0,m.localize)(12112,null,$))};switch(r){case"env":if(c){if(k.env){const l=k.env[R.$l?c.toLowerCase():c];if(P.$jg(l))return l}return""}throw new s.$BR(s.VariableKind.Env,(0,m.localize)(12113,null,$));case"config":if(c){const l=this.a.getConfigurationValue(a,c);if(P.$sg(l))throw new s.$BR(s.VariableKind.Config,(0,m.localize)(12114,null,$,c));if(P.$lg(l))throw new s.$BR(s.VariableKind.Config,(0,m.localize)(12115,null,$,c));return l}throw new s.$BR(s.VariableKind.Config,(0,m.localize)(12116,null,$));case"command":return this.p(s.VariableKind.Command,$,c,h,"command");case"input":return this.p(s.VariableKind.Input,$,c,h,"input");case"extensionInstallFolder":if(c){const l=await this.a.getExtension(c);if(!l)throw new s.$BR(s.VariableKind.ExtensionInstallFolder,(0,m.localize)(12117,null,$,c));return this.n(l.extensionLocation)}throw new s.$BR(s.VariableKind.ExtensionInstallFolder,(0,m.localize)(12118,null,$));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,T.$0w)(this.n(o(s.VariableKind.WorkspaceFolder)));case"cwd":return a||c?(0,T.$0w)(this.n(o(s.VariableKind.Cwd))):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$0w)(v.$sc(this.n(o(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new s.$BR(s.VariableKind.UserHome,(0,m.localize)(12119,null,$))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new s.$BR(s.VariableKind.LineNumber,(0,m.localize)(12120,null,$))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new s.$BR(s.VariableKind.SelectedText,(0,m.localize)(12121,null,$))}case"file":return n(s.VariableKind.File);case"fileWorkspaceFolder":return t(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$sc(t(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||c?v.$qc(this.n(o(s.VariableKind.RelativeFile)),n(s.VariableKind.RelativeFile)):n(s.VariableKind.RelativeFile);case"relativeFileDirname":{const l=v.$rc(n(s.VariableKind.RelativeFileDirname));if(a||c){const g=v.$qc(this.n(o(s.VariableKind.RelativeFileDirname)),l);return g.length===0?".":g}return l}case"fileDirname":return v.$rc(n(s.VariableKind.FileDirname));case"fileExtname":return v.$tc(n(s.VariableKind.FileExtname));case"fileBasename":return v.$sc(n(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=v.$sc(n(s.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-v.$tc(l).length)}case"fileDirnameBasename":return v.$sc(v.$rc(n(s.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||$}case"execInstallFolder":{const l=this.a.getAppRoot();return l||$}case"pathSeparator":case"/":return v.sep;default:try{const l=c?`${r}:${c}`:r;return this.p(s.VariableKind.Unknown,$,l,h,void 0)}catch{return $}}}}p(k,$,r,a,h){if(r&&a){const c=h===void 0?a[r]:a[h+":"+r];if(typeof c=="string")return c;throw new s.$BR(k,(0,m.localize)(12122,null,$))}return $}}e.$QR=w}),define(Re[120],Oe([1,0,3,116]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$ME=void 0,e.$NE=s,e.$OE=u,e.$PE=k,e.$ME=(0,v.$Ki)("editorGroupsService");var P;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var L;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var T;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EXPAND=1]="EXPAND",$[$.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var m;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function s($){const r=$;return(0,D.$yG)(r?.editor)&&(0,D.$yG)(r?.replacement)}var I;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var w;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(w||(e.OpenEditorContext=w={}));function u($){const r=$;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function k($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Re[204],Oe([1,0,3,120]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TE=e.$SE=e.$RE=e.$QE=void 0,e.$UE=P,e.$QE=(0,v.$Ki)("editorService"),e.$RE=-1,e.$SE=-2,e.$TE=-3;function P(L){const R=L;return typeof L=="number"||(0,D.$OE)(R)}}),define(Re[205],Oe([1,0,3,107]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=void 0,e.$wN=(0,v.$Li)(D.$Ri)}),define(Re[121],Oe([1,0,18,6,22,4,10]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.$cfc=e.$bfc=e.$afc=e.$_ec=void 0,P=Ve(P);class T{constructor(c,i){this.versionId=c,this.removedDueToLooping=i}}e.$_ec=T;class m{static isHostExtension(c,i,n){if(i.getExtensionDescription(c))return!1;const t=n.getExtensionDescription(c);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(c,i){this.j=c,this.c=new D.$qe,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new v.$zn,this.g=[],this.h=new Map;for(const c of this.e){if(this.f.has(c.identifier)){console.error("Extension `"+c.identifier.value+"` is already registered");continue}this.f.set(c.identifier,c),this.g.push(c);const i=this.j.readActivationEvents(c);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(c)}}set(c){return this.e=c,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(c,i){this.e=a(this.e,i),this.e=this.e.concat(c);const n=m.l(this.e);return this.e=a(this.e,n.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,n)}static l(c){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(g){this.d.has(g)||(this.d.add(g),this.e.push(g))}addArc(g,f){this.addNode(g),this.addNode(f),this.c.has(g)?this.c.get(g).push(f):this.c.set(g,[f])}getArcs(g){return this.c.has(g)?this.c.get(g):[]}hasOnlyGoodArcs(g,f){const d=i.getArcs(g);for(let S=0;S<d.length;S++)if(!f.has(d[S]))return!1;return!0}getNodes(){return this.e}},n=new v.$zn;for(const g of c)if(n.set(g.identifier,g),g.extensionDependencies)for(const f of g.extensionDependencies)i.addArc(v.$xn.toKey(g.identifier),v.$xn.toKey(f));const t=new Set;i.getNodes().filter(g=>i.getArcs(g).length===0).forEach(g=>t.add(g));const o=i.getNodes().filter(g=>!t.has(g));let l;do{l=!1;for(let g=0;g<o.length;g++){const f=o[g];i.hasOnlyGoodArcs(f,t)&&(o.splice(g,1),g--,t.add(f),l=!0)}}while(l);return o.map(g=>n.get(g))}containsActivationEvent(c){return this.h.has(c)}containsExtension(c){return this.f.has(c)}getExtensionDescriptionsForActivationEvent(c){const i=this.h.get(c);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new s(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(c){const i=this.f.get(c);return i||void 0}getExtensionDescriptionByUUID(c){for(const i of this.g)if(i.uuid===c)return i}getExtensionDescriptionByIdOrUUID(c,i){return this.getExtensionDescription(c)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$afc=m;class s{constructor(c,i){this.versionId=c,this.extensions=i}}e.$bfc=s;class I{constructor(c){this.d=new k,this.c=new m(c,[])}async acquireLock(c){const i=await this.d.acquire(c);return new w(this,i)}deltaExtensions(c,i,n){if(!c.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(c){return this.c.containsActivationEvent(c)}containsExtension(c){return this.c.containsExtension(c)}getExtensionDescriptionsForActivationEvent(c){return this.c.getExtensionDescriptionsForActivationEvent(c)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(c){return this.c.getExtensionDescription(c)}getExtensionDescriptionByUUID(c){return this.c.getExtensionDescriptionByUUID(c)}getExtensionDescriptionByIdOrUUID(c,i){return this.c.getExtensionDescriptionByIdOrUUID(c,i)}}e.$cfc=I;class w extends L.$Zc{constructor(c,i){super(),this.f=c,this.c=!1,this.B(i)}isAcquiredFor(c){return!this.c&&this.f===c}}e.$dfc=w;class u{constructor(c){this.name=c;const i=(0,R.$Dh)();this.promise=i.promise,this.c=i.resolve}resolve(c){this.c(c)}}class k{constructor(){this.c=[],this.d=!1}async acquire(c){const i=new u(c);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const c=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${c.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};c.resolve((0,L.$Xc)(t))}}var $;(function(h){h[h.Builtin=0]="Builtin",h[h.User=1]="User",h[h.Dev=2]="Dev"})($||($={}));function r(h,c){const i=h.isBuiltin?$.Builtin:h.isUnderDevelopment?$.Dev:$.User,n=c.isBuiltin?$.Builtin:c.isUnderDevelopment?$.Dev:$.User;if(i!==n)return i-n;const t=P.$lc.basename(h.extensionLocation.path),o=P.$lc.basename(c.extensionLocation.path);return t<o?-1:t>o?1:0}function a(h,c){const i=new v.$yn(c);return h.filter(n=>!i.has(n.identifier))}}),define(Re[84],Oe([1,0,20]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Hn=R,e.$In=T;var D;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(D||(e.UIKind=D={}));var P;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var L;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(s){const I=v.$Se.alloc(1);switch(s){case L.Initialized:I.writeUInt8(1,0);break;case L.Ready:I.writeUInt8(2,0);break;case L.Terminate:I.writeUInt8(3,0);break}return I}function T(s,I){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return I===L.Initialized;case 2:return I===L.Ready;case 3:return I===L.Terminate;default:return!1}}var m;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Re[66],Oe([1,0,3,6,113,11,26,84,62,63,25,2,4,9]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Q=e.$5Q=e.$4Q=void 0,e.$6Q=a;let $=class extends u.$Zc{constructor(c,i){super(),this.s=c,this.t=i,this.a=this.B(new D.$qe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new D.$qe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=w.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:s.$Ip,name:(0,k.localize)(2713,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,L.$hk)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(c,i,n){const t=this.getTelemetryDetails(),o=new r(i,n,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),l=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...l,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(c,i,n){this.f=c,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const i=Object.create(null);switch(i["common.extname"]=`${c.publisher}.${c.name}`,i["common.extversion"]=c.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,m.$on)((0,s.$Op)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const i=this.getTelemetryDetails();this.r.forEach((n,t)=>{const o=n.filter(l=>!l.isDisposed);o.length===0?this.r.delete(t):this.r.set(t,o)}),this.r.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,i){const t=this.r.get(c.value)?.filter(l=>!l.isDisposed);if(!t)return this.r.delete(c.value),!1;let o=!1;for(const l of t)l.ignoreUnhandledExtHostErrors||(l.logError(i),o=!0);return o}};e.$4Q=$,e.$4Q=$=Ke([qe(0,R.$3Q),qe(1,L.$gk)],$);class r{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,i,n,t,o,l,g){this.g=n,this.h=t,this.i=o,this.j=l,this.a=new D.$qe,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(c,i){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let i="properties"in c?c.properties??{}:c;return i=(0,s.$Rp)(i,[]),this.c&&(i=(0,I.$no)(i,this.c)),this.b||(i=(0,I.$no)(i,this.j)),"properties"in c?c.properties=i:c=i,c}k(c,i){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(c,i),this.h.trace(c,i))}logUsage(c,i){this.d.isUsageEnabled&&this.k(c,i)}logError(c,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,i);else{const n={name:c.name,message:c.message,stack:c.stack,cause:c.cause},t=(0,s.$Rp)(n,[]),o=new Error(t.message,{cause:t.cause});o.stack=t.stack,o.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const c=this,i={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$5Q=r;function a(h){const c=Date.now()-new Date(h).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$7Q=(0,v.$Ki)("IExtHostTelemetry")}),define(Re[21],Oe([1,0,6,2,179,112,18,3]),function(we,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GH=e.ActivationKind=e.$DH=e.$CH=e.$zH=e.ExtensionHostStartup=e.$yH=e.$xH=e.$wH=e.$vH=void 0,e.$AH=u,e.$BH=k,e.$EH=h,e.$FH=c,e.$vH=Object.freeze({identifier:new R.$xn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$wH="extensions.webWorker",e.$xH=(0,T.$Ki)("extensionService");class m{constructor(t){this.dependency=t}}e.$yH=m;var s;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,o,l){this.c=t,this.d=o.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$hH.createActivationEventsMap(this.d)}}set(t,o,l){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const g=[],f=[],d=[],S=[],E=w(this.d),y=w(o),C=(A,F)=>A.extensionLocation.toString()===F.extensionLocation.toString()||A.isBuiltin===F.isBuiltin||A.isUserBuiltin===F.isUserBuiltin||A.isUnderDevelopment===F.isUnderDevelopment;for(const A of this.d){const F=y.get(A.identifier);if(!F){g.push(A.identifier),E.delete(A.identifier);continue}if(!C(A,F)){g.push(A.identifier),E.delete(A.identifier);continue}}for(const A of o){const F=E.get(A.identifier);if(!F){f.push(A);continue}if(!C(F,A)){g.push(F.identifier),E.delete(F.identifier);continue}}const O=new R.$yn(this.e),p=new R.$yn(l);for(const A of this.e)p.has(A)||d.push(A);for(const A of l)O.has(A)||S.push(A);const b=L.$hH.createActivationEventsMap(f),M={versionId:t,toRemove:g,toAdd:f,addActivationEvents:b,myToRemove:d,myToAdd:S};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:o,toAdd:l,myToRemove:g,myToAdd:f}=t,d=new R.$yn(o),S=new R.$yn(g);for(let E=0;E<this.d.length;E++)d.has(this.d[E].identifier)&&(this.d.splice(E,1),E--);for(let E=0;E<this.e.length;E++)S.has(this.e[E])&&(this.e.splice(E,1),E--);for(const E of l)this.d.push(E);for(const E of f)this.e.push(E);return this.f=null,t}containsExtension(t){for(const o of this.e)if(R.$xn.equals(o,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const o of this.d){if(!this.containsExtension(o.identifier))continue;const l=L.$hH.readActivationEvents(o);for(const g of l)t.add(g)}return t}}e.$zH=I;function w(n){const t=new R.$zn;for(const o of n)t.set(o.identifier,o);return t}function u(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}function k(n,t){if(!u(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class ${constructor(t,o,l,g){this.codeLoadingTime=t,this.activateCallTime=o,this.activateResolvedTime=l,this.activationReason=g}}e.$CH=$;class r{constructor(t,o){this.description=t,this.value=o}}e.$DH=r;var a;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function h(n){return{type:n.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,P.$Xp)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function c(n,t){const o=(0,P.$Vp)(n.manifest.publisher,n.manifest.name);return{id:o,identifier:new R.$xn(o),isBuiltin:n.type===R.ExtensionType.System,isUserBuiltin:n.type===R.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,o){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,o){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$GH=i}),define(Re[206],Oe([1,0,12,4,121,18,21,11,10]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Drc=e.$Crc=e.$Brc=e.$Arc=e.$zrc=e.$yrc=void 0,v=Ve(v);class s{static{this.NONE=new s(!1,-1,-1,-1)}constructor(c,i,n,t){this.startup=c,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.$yrc=s;class I{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,i){return c===-1||i===-1?-1:i-c}build(){return new s(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$zrc=I;class w{constructor(c,i,n,t,o,l){this.activationFailed=c,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=o,this.disposable=l}}e.$Arc=w;class u extends w{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,D.$Zc.None)}}e.$Brc=u;class k extends w{constructor(){super(!1,null,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Zc.None)}}e.$Crc=k;class $ extends w{constructor(c){super(!0,c,s.NONE,{activate:void 0,deactivate:void 0},void 0,D.$Zc.None)}}let r=class{constructor(c,i,n,t){this.g=t,this.a=c,this.b=i,this.c=n,this.d=new L.$zn,this.f=Object.create(null)}dispose(){for(const[c,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const c=[];for(const[i,n]of this.d)c.push(n.wait());await Promise.all(c)}isActivated(c){const i=this.d.get(c);return!!(i&&i.value)}getActivatedExtension(c){const i=this.d.get(c);if(!i||!i.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return i.value}async activateByEvent(c,i){if(this.f[c])return;const n=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,i){const n=this.a.getExtensionDescription(c);if(!n)throw new Error(`Extension '${c.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(c){const i=c.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const i=this.a.getExtensionDescription(c.id);if(!i){const o=new Error(`Cannot activate unknown extension '${c.id.value}'`),l=this.k(c,null,[],new $(o));return this.c.onExtensionActivationError(c.id,o,new R.$yH(c.id.value)),l}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of t){if(this.m(o))continue;const l=this.d.get(o);if(l){n.push(l);continue}if(this.l(o)){n.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:c.reason}));continue}const g=this.a.getExtensionDescription(o);if(g){if(!g.main&&!g.browser)continue;n.push(this.j({id:g.identifier,reason:c.reason}));continue}const f=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${o}'`),S=this.k(c,i.displayName,[],new $(d));return this.c.onExtensionActivationError(i.identifier,d,new R.$yH(o)),S}return this.k(c,i.displayName,n,null)}k(c,i,n,t){const o=new a(c.id,i,c.reason,n,t,this.c,this.g);return this.d.set(c.id,o),o}l(c){return P.$afc.isHostExtension(c,this.a,this.b)}m(c){const i=this.b.getExtensionDescription(c);return i?!i.main&&!i.browser:!1}};e.$Drc=r,e.$Drc=r=Ke([qe(3,T.$fk)],r);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,i,n,t,o,l,g){this.c=c,this.d=i,this.f=n,this.g=t,this.h=o,this.j=l,this.k=g,this.a=new m.$Jh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const i=this.g[c];if(i.value&&!i.value.activationFailed){this.g.splice(c,1),c--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new $(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const i=new Error;if(c&&c.name&&(i.name=c.name),c&&c.message?i.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(i.stack=c.stack),this.h=new $(i),this.b&&v.$8(c))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};a=Ke([qe(6,T.$fk)],a)});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[122],Oe([1,0,9,12,37,111,78,29,18,109,112,105]),function(we,e,v,D,P,L,R,T,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=void 0,v=Ve(v),P=oi(P);const u=T.$xo.as(R.$yo.JSONContribution);class k{constructor(t,o,l){this.a=t,this.b=o,this.c=l}d(t,o){this.a({type:t,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$pH=k;class ${static a(t){const o=new m.$yn;for(let l=0,g=t.length;l<g;l++)o.add(t[l].description.identifier);return o}static compute(t,o){if(!t||!t.length)return new $(o,[]);if(!o||!o.length)return new $([],t);const l=this.a(t),g=this.a(o),f=o.filter(S=>!l.has(S.description.identifier)),d=t.filter(S=>!g.has(S.description.identifier));return new $(f,d)}constructor(t,o){this.added=t,this.removed=o}}e.$qH=$;class r{constructor(t,o){this.name=t,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=$.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,D.$4)(t)}}}e.$rH=r;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(12277,null),v.localize(12278,null)]},h="vscode://schemas/vscode-extensions";e.$sH={properties:{engines:{type:"object",description:v.localize(12279,null),properties:{vscode:{type:"string",description:v.localize(12280,null),default:"^1.22.0"}}},publisher:{description:v.localize(12281,null),type:"string"},displayName:{description:v.localize(12282,null),type:"string"},categories:{description:v.localize(12283,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$wn},{type:"string",const:"Languages",deprecationMessage:v.localize(12284,null)}]}},galleryBanner:{type:"object",description:v.localize(12285,null),properties:{color:{description:v.localize(12286,null),type:"string"},theme:{description:v.localize(12287,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(12288,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(12289,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(12290,null)},enabledApiProposals:{markdownDescription:v.localize(12291,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(w.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:v.localize(12292,null),type:"string",enum:["none"],enumDescriptions:[v.localize(12293,null)]},activationEvents:{description:v.localize(12294,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(12295,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(12296,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(12297,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(12298,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(12299,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(12300,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(12301,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(12302,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(12303,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(12304,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(12305,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(12306,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(12307,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(12308,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(12309,null)},{label:"onUri",body:"onUri",description:v.localize(12310,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(12311,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(12312,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(12313,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(12314,null)},{label:"onRenderer",description:v.localize(12315,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(12316,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(12317,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(12318,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(12319,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(12320,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolId}",description:v.localize(12321,null)},{label:"*",description:v.localize(12322,null),body:"*"}]}},badges:{type:"array",description:v.localize(12323,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(12324,null)},href:{type:"string",description:v.localize(12325,null)},description:{type:"string",description:v.localize(12326,null)}}}},markdown:{type:"string",description:v.localize(12327,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(12328,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(12329,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$ep}},extensionPack:{description:v.localize(12330,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$ep}},extensionKind:{description:v.localize(12331,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(12332,null)},{body:["workspace"],description:v.localize(12333,null)},{body:["ui","workspace"],description:v.localize(12334,null)},{body:["workspace","ui"],description:v.localize(12335,null)},{body:[],description:v.localize(12336,null)}]},capabilities:{description:v.localize(12337,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(12338,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(12339,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(12340,null),v.localize(12341,null),v.localize(12342,null)]},description:{type:"string",markdownDescription:v.localize(12343,null)}}},untrustedWorkspaces:{description:v.localize(12344,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(12345,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(12346,null),v.localize(12347,null),v.localize(12348,null)]},restrictedConfigurations:{description:v.localize(12349,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(12350,null)}}}}},sponsor:{description:v.localize(12351,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(12352,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(12353,null),type:"string"},"vscode:uninstall":{description:v.localize(12354,null),type:"string"}}},icon:{type:"string",description:v.localize(12355,null)},l10n:{type:"string",description:v.localize(12356,null)},pricing:{type:"string",markdownDescription:v.localize(12357,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const o=new r(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,o),t.activationEventsGenerator&&I.$hH.register(t.extensionPoint,t.activationEventsGenerator),e.$sH.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(h,e.$sH),o}getExtensionPoints(){return Array.from(this.a.values())}}e.$tH=c;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$xo.add(i.ExtensionsRegistry,new c),e.$uH=T.$xo.as(i.ExtensionsRegistry),u.registerSchema(h,e.$sH),u.registerSchema(s.$zk,{properties:{extensionEnabledApiProposals:{description:v.localize(12358,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(Re[207],Oe([1,0,6,41,4,13,9,18,3,11,21,122]),function(we,e,v,D,P,L,R,T,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JH=e.$IH=e.$HH=e.ChatMessageRole=void 0;var u;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$HH=(0,m.$Ki)("ILanguageModelsService");const k={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(4739,null)}}};e.$IH=w.$uH.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(4740,null),oneOf:[k,{type:"array",items:k}]},activationEventsGenerator:(r,a)=>{for(const h of r)a.push(`onLanguageModelChat:${h.vendor}`)}});let $=class{constructor(a,h){this.e=a,this.f=h,this.a=new P.$Yc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$qe),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$IH.setHandler(c=>{this.c.clear();for(const n of c){if(!(0,I.$AH)(n.description,"chatProvider")){n.collector.error((0,R.localize)(4741,null));continue}for(const t of D.Iterable.wrap(n.value)){if(this.c.has(t.vendor)){n.collector.error((0,R.localize)(4742,null,t.vendor));continue}if((0,L.$hf)(t.vendor)){n.collector.error((0,R.localize)(4743,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,R.localize)(4744,null));continue}this.c.add(t.vendor)}}const i=[];for(const[n,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(n),i.push(n));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(a){return this.b.get(a)?.metadata}async selectLanguageModels(a){if(a.vendor)await this.e.activateByEvent(`onLanguageModelChat:${a.vendor}}`);else{const c=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(c)}const h=[];for(const[c,i]of this.b)(a.vendor===void 0||i.metadata.vendor===a.vendor)&&(a.family===void 0||i.metadata.family===a.family)&&(a.version===void 0||i.metadata.version===a.version)&&(a.identifier===void 0||i.metadata.id===a.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>T.$xn.equals(n,a.extension)))&&h.push(c);return this.f.trace("[LM] selected language models",a,h),h}registerLanguageModelChat(a,h){if(this.f.trace("[LM] registering language model chat",a,h.metadata),!this.c.has(h.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${h.metadata.vendor}.`);if(this.b.has(a))throw new Error(`Chat response provider with identifier ${a} is already registered.`);return this.b.set(a,h),this.d.fire({added:[{identifier:a,metadata:h.metadata}]}),(0,P.$Xc)(()=>{this.b.delete(a)&&(this.d.fire({removed:[a]}),this.f.trace("[LM] UNregistered language model chat",a,h.metadata))})}async sendChatRequest(a,h,c,i,n){const t=this.b.get(a);if(!t)throw new Error(`Chat response provider with identifier ${a} is not registered.`);return t.sendChatRequest(c,h,i,n)}computeTokenLength(a,h,c){const i=this.b.get(a);if(!i)throw new Error(`Chat response provider with identifier ${a} is not registered.`);return i.provideTokenCount(h,c)}};e.$JH=$,e.$JH=$=Ke([qe(0,I.$xH),qe(1,s.$fk)],$)}),define(Re[208],Oe([1,0,9,14,25,122,31,6]),function(we,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=void 0,v=Ve(v),D=Ve(D),P=Ve(P);const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(9878,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(9879,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(9880,null),default:""}}};var s;(function(u){function k($,r,a){if(!$)return;const h=D.$jg($.type)?$.type:void 0;if(!h||h.length===0){a.error(v.localize(9881,null));return}const c=[];if(Array.isArray($.required))for(const i of $.required)D.$jg(i)&&c.push(i);return{extensionId:r.value,taskType:h,required:c,properties:$.properties?P.$ko($.properties):{},when:$.when?R.$Ij.deserialize($.when):void 0}}u.from=k})(s||(s={}));const I=L.$uH.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,k)=>{for(const $ of u)$.type&&k.push(`onTaskType:${$.type}`)},jsonSchema:{description:v.localize(9882,null),type:"array",items:m}});class w{constructor(){this.d=new T.$qe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,$)=>{I.setHandler((r,a)=>{this.c=void 0;try{for(const h of a.removed){const c=h.value;for(const i of c)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const h of a.added){const c=h.value;for(const i of c){const n=s.from(i,h.description.identifier,h.collector);n&&(this.a[n.taskType]=n)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const $ of this.all()){const r={type:"object",additionalProperties:!1};$.required.length>0&&(r.required=$.required.slice(0)),$.properties!==void 0?r.properties=P.$ko($.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[$.taskType]},k.push(r)}this.c={oneOf:k}}return this.c}}e.$fJ=new w}),define(Re[209],Oe([1,0,9,14,24,25,31,208,44]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$pJ=e.JsonSchemaVersion=e.ExecutionEngine=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$jJ=e.ShellQuoting=e.$iJ=e.$hJ=e.$gJ=void 0,v=Ve(v),D=Ve(D),P=Ve(P),L=Ve(L),e.$gJ="settings",e.$hJ=new R.$2j("taskRunning",!1,v.localize(9883,null)),e.$iJ=v.localize2(9885,"Tasks");var s;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(s||(e.ShellQuoting=s={})),e.$jJ="$customized",function(j){function U(J){if(!J)return j.Strong;switch(J.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=U}(s||(e.ShellQuoting=s={}));var I;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var w;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(w||(e.RevealKind=w={})),function(j){function U(J){switch(J.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=U}(w||(e.RevealKind=w={}));var u;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(j){function U(J){switch(J.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=U}(u||(e.RevealProblemKind=u={}));var k;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(k||(e.PanelKind=k={})),function(j){function U(J){switch(J.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=U}(k||(e.PanelKind=k={}));var $;(function(j){j.defaults={echo:!0,reveal:w.Always,revealProblems:u.Never,focus:!1,panel:k.Shared,showReuseMessage:!0,clear:!1}})($||(e.PresentationOptions=$={}));var r;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(j){function U(Y){switch(Y.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=U;function J(Y){switch(Y){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=J}(r||(e.RuntimeType=r={}));var a;(function(j){function U(J){return D.$jg(J)?J:J.value}j.value=U})(a||(e.CommandString=a={}));var h;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function U(Y){return Y===j.Clean._id||Y===j.Build._id||Y===j.Rebuild._id||Y===j.Test._id}j.is=U;function J(Y){if(Y!==void 0)return D.$jg(Y)?U(Y)?{_id:Y,isDefault:!1}:void 0:Y}j.from=J})(h||(e.TaskGroup=h={}));var c;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var i;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function U(J){switch(J){case j.User:return m.ConfigurationTarget.USER;case j.WorkspaceFile:return m.ConfigurationTarget.WORKSPACE;default:return m.ConfigurationTarget.WORKSPACE_FOLDER}}j.toConfigurationTarget=U})(i||(e.TaskSourceKind=i={}));var n;(function(j){j.parallel="parallel",j.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var o;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class l{constructor(U,J,Y,ae,ee,oe){this._label="",this._id=U,J&&(this._label=J),Y&&(this.type=Y),this.runOptions=ae,this.configurationProperties=ee,this._source=oe}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,J=!1){if(U===void 0)return!1;if(D.$jg(U))return U===this._label||U===this.configurationProperties.identifier||J&&U===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$kJ=l;class g extends l{constructor(U,J,Y,ae,ee,oe,ie,ue){super(U,Y,void 0,ie,ue,J),this.command={},this._source=J,this.hasDefinedMatchers=oe,ee&&(this.command=ee)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let J;switch(this.command?this.command.runtime:void 0){case r.Shell:J="shell";break;case r.Process:J="process";break;case r.CustomExecution:J="customExecution";break;case void 0:J="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:J,_key:this._id,id:this._id}}}static is(U){return U instanceof g}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$gJ:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let J=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(J+=this._source.kind);const Y={type:e.$jJ,folder:U,id:J};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ih(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new g(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$lJ=g;class f extends l{constructor(U,J,Y,ae,ee,oe,ie){super(U,Y,ae,oe,ie,J),this._source=J,this.configures=ee}static is(U){return U instanceof f}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ih(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$gJ:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let J=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(J+=this._source.kind);const Y={type:e.$jJ,folder:U,id:J};return JSON.stringify(Y)}}e.$mJ=f;class d extends l{constructor(U,J,Y,ae,ee,oe,ie,ue,_){super(U,Y,ae,ue,_,J),this.defines=ee,this.hasDefinedMatchers=ie,this.command=oe,this.icon=_.icon,this.hide=_.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof d}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===c.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new d(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$nJ=d;class S extends l{constructor(U,J,Y,ae,ee,oe){super(U,Y,ae,ee,oe,J),this._source=J}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new S(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$oJ=S;var E;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(E||(e.ExecutionEngine=E={})),function(j){j._default=j.Terminal}(E||(e.ExecutionEngine=E={}));var y;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class C{constructor(U){this.c=new Map;for(let J=0;J<U.length;J++)this.c.set(U[J].uri.toString(),J)}compare(U,J){const Y=U.getWorkspaceFolder(),ae=J.getWorkspaceFolder();if(Y&&ae){let ee=this.c.get(Y.uri.toString());ee=ee===void 0?0:ee+1;let oe=this.c.get(ae.uri.toString());return oe=oe===void 0?0:oe+1,ee===oe?U._label.localeCompare(J._label):ee-oe}else return!Y&&ae?-1:Y&&!ae?1:0}}e.$pJ=C;var O;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(O||(e.TaskEventKind=O={}));var p;(function(j){j.SingleRun="singleRun",j.Background="background"})(p||(e.TaskRunType=p={}));var b;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var M;(function(j){function U(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?p.Background:p.SingleRun,group:ue.configurationProperties.group,__task:ue}}function J(ue,_,$e){return{...U(ue),kind:O.Start,terminalId:_,resolvedVariables:$e}}j.start=J;function Y(ue,_,$e){return{...U(ue),kind:O.ProcessStarted,terminalId:_,processId:$e}}j.processStarted=Y;function ae(ue,_,$e){return{...U(ue),kind:O.ProcessEnded,terminalId:_,exitCode:$e}}j.processEnded=ae;function ee(ue,_,$e){return{...U(ue),kind:O.Terminated,exitReason:$e,terminalId:_}}j.terminated=ee;function oe(ue,_,$e){return{...U(_),kind:ue,terminalId:$e}}j.general=oe;function ie(){return{kind:O.Changed}}j.changed=ie})(M||(e.TaskEvent=M={}));var A;(function(j){function U(Y){const ae=Object.keys(Y).sort();let ee="";for(const oe of ae){let ie=Y[oe];ie instanceof Object?ie=U(ie):typeof ie=="string"&&(ie=ie.replace(/,/g,",,")),ee+=oe+","+ie+","}return ee}function J(Y){const ee={_key:U(Y),type:Y.taskType};return Object.assign(ee,Y),ee}j.create=J})(A||(e.KeyedTaskIdentifier=A={}));var F;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var G;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var x;(function(j){function U(J,Y){const ae=T.$fJ.get(J.type);if(ae===void 0){const ue=L.$ko(J);return delete ue._key,A.create(ue)}const ee=Object.create(null);ee.type=ae.taskType;const oe=new Set;ae.required.forEach(ue=>oe.add(ue));const ie=ae.properties;for(const ue of Object.keys(ie)){const _=J[ue];if(_!=null)ee[ue]=_;else if(oe.has(ue)){const $e=ie[ue];if($e.default!==void 0)ee[ue]=L.$ko($e.default);else switch($e.type){case"boolean":ee[ue]=!1;break;case"number":case"integer":ee[ue]=0;break;case"string":ee[ue]="";break;default:Y.error(v.localize(9884,null,JSON.stringify(J,void 0,0),ue));return}}}return A.create(ee)}j.createTaskIdentifier=U})(x||(e.TaskDefinition=x={}))}),define(Re[210],Oe([1,0,12]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=e.$efc=void 0;class D{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,T)=>{this.b=R,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,v.$4)(R))}then(R,T){return this.j().then(R,T)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$efc=D;class P extends D{constructor(){super(),this.h=!0,this.i=new v.$9}}e.$ffc=P}),define(Re[39],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7w=e.$4w=void 0,e.$5w=P,e.$6w=L;class v{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++v.count}}e.$4w=v;const D=[];function P(T){const m=new v(T);return D[m.nid]=m,m}function L(T){return D[T].sid}class R{constructor(m){this.value=m}}e.$7w=R}),define(Re[5],Oe([1,0,39]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=e.$_N=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$$N=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(D||(e.TextEditorRevealType=D={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var L;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var T;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var m;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var s;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var I;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class w{static{this.a=0}static mixin(a){return a._id=w.a++,a}}e.$$N=w;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var k;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var $;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$_N={MainThreadAuthentication:(0,v.$5w)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$5w)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$5w)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$5w)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$5w)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$5w)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$5w)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$5w)("MainThreadClipboard"),MainThreadCommands:(0,v.$5w)("MainThreadCommands"),MainThreadComments:(0,v.$5w)("MainThreadComments"),MainThreadConfiguration:(0,v.$5w)("MainThreadConfiguration"),MainThreadConsole:(0,v.$5w)("MainThreadConsole"),MainThreadDebugService:(0,v.$5w)("MainThreadDebugService"),MainThreadDecorations:(0,v.$5w)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$5w)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$5w)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$5w)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$5w)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$5w)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$5w)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$5w)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$5w)("MainThreadErrors"),MainThreadTreeViews:(0,v.$5w)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$5w)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$5w)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$5w)("MainThreadLanguages"),MainThreadLogger:(0,v.$5w)("MainThreadLogger"),MainThreadMessageService:(0,v.$5w)("MainThreadMessageService"),MainThreadOutputService:(0,v.$5w)("MainThreadOutputService"),MainThreadProgress:(0,v.$5w)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$5w)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$5w)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$5w)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$5w)("MainThreadSecretState"),MainThreadStorage:(0,v.$5w)("MainThreadStorage"),MainThreadSpeech:(0,v.$5w)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$5w)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$5w)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$5w)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$5w)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$5w)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$5w)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$5w)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$5w)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$5w)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$5w)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$5w)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$5w)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$5w)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$5w)("MainThreadExtensionService"),MainThreadSCM:(0,v.$5w)("MainThreadSCM"),MainThreadSearch:(0,v.$5w)("MainThreadSearch"),MainThreadShare:(0,v.$5w)("MainThreadShare"),MainThreadTask:(0,v.$5w)("MainThreadTask"),MainThreadWindow:(0,v.$5w)("MainThreadWindow"),MainThreadLabelService:(0,v.$5w)("MainThreadLabelService"),MainThreadNotebook:(0,v.$5w)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$5w)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$5w)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$5w)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$5w)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$5w)("MainThreadInteractive"),MainThreadTheming:(0,v.$5w)("MainThreadTheming"),MainThreadTunnelService:(0,v.$5w)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$5w)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$5w)("MainThreadTimeline"),MainThreadTesting:(0,v.$5w)("MainThreadTesting"),MainThreadLocalization:(0,v.$5w)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$5w)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$5w)("MainThreadAiEmbeddingVector")},e.$aO={ExtHostCommands:(0,v.$5w)("ExtHostCommands"),ExtHostConfiguration:(0,v.$5w)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$5w)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$5w)("ExtHostDebugService"),ExtHostDecorations:(0,v.$5w)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$5w)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$5w)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$5w)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$5w)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$5w)("ExtHostEditors"),ExtHostTreeViews:(0,v.$5w)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$5w)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$5w)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$5w)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$5w)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$5w)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$5w)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$5w)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$5w)("ExtHostStatusBar"),ExtHostShare:(0,v.$5w)("ExtHostShare"),ExtHostExtensionService:(0,v.$5w)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$5w)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$5w)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$5w)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$5w)("ExtHostSCM"),ExtHostSearch:(0,v.$5w)("ExtHostSearch"),ExtHostTask:(0,v.$5w)("ExtHostTask"),ExtHostWorkspace:(0,v.$5w)("ExtHostWorkspace"),ExtHostWindow:(0,v.$5w)("ExtHostWindow"),ExtHostWebviews:(0,v.$5w)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$5w)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$5w)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$5w)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$5w)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$5w)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$5w)("ExtHostProgress"),ExtHostComments:(0,v.$5w)("ExtHostComments"),ExtHostSecretState:(0,v.$5w)("ExtHostSecretState"),ExtHostStorage:(0,v.$5w)("ExtHostStorage"),ExtHostUrls:(0,v.$5w)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$5w)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$5w)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$5w)("ExtHostOutputService"),ExtHostLabelService:(0,v.$5w)("ExtHostLabelService"),ExtHostNotebook:(0,v.$5w)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$5w)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$5w)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$5w)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$5w)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$5w)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$5w)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$5w)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$5w)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$5w)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$5w)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$5w)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$5w)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$5w)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$5w)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$5w)("ExtHostTheming"),ExtHostTunnelService:(0,v.$5w)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$5w)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$5w)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$5w)("ExtHostTimeline"),ExtHostTesting:(0,v.$5w)("ExtHostTesting"),ExtHostTelemetry:(0,v.$5w)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$5w)("ExtHostLocalization")}}),define(Re[85],Oe([1,0,3,11,5,16]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=e.$Yqc=e.$Xqc=void 0,P=Ve(P),e.$Xqc=(0,v.$Ki)("IExtHostApiDeprecationService");let R=class{constructor(m,s){this.c=s,this.a=new Set,this.b=m.getProxy(P.$_N.MainThreadTelemetry)}report(m,s,I){const w=this.d(m,s);this.a.has(w)||(this.a.add(w),s.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:s.identifier.value,apiId:m}))}d(m,s){return`${m}-${s.identifier.value}`}};e.$Yqc=R,e.$Yqc=R=Ke([qe(0,L.$MQ),qe(1,D.$fk)],R),e.$Zqc=Object.freeze(new class{report(T,m,s){}})}),define(Re[211],Oe([1,0,5]),function(we,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=void 0;class D{constructor(L){const R=L.getProxy(v.$_N.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(T){return R.$writeText(T)}})}}e.$arc=D}),define(Re[212],Oe([1,0,25,5,26,16]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$btc=void 0;let R=class{constructor(I,w){this.a=I.getProxy(D.$_N.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,w){const u=this,k=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,w,k,arguments)}})}e(I,w,u,k){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:m(k,this.b)}),this.c&&this.f(I,u,k)}};e.$btc=R,e.$btc=R=Ke([qe(0,L.$MQ),qe(1,P.$3Q)],R);const T=1e5;function m(s,I){const w=[];if(s.length)for(let u=0;u<s.length;u++){let k=s[u];if(typeof k>"u")k="undefined";else if(k instanceof Error){const $=k;$.stack?k=$.stack:k=$.toString()}w.push(k)}if(I){const u=new Error().stack;u&&w.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,v.$po)(w);return u.length>T?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Re[213],Oe([1,0,2,5,21]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$csc=void 0;class L{constructor(T){this.a=T.getProxy(D.$_N.MainThreadDialogs)}showOpenDialog(T,m){return m?.allowUIResources&&(0,P.$BH)(T,"showLocal"),this.a.$showOpenDialog(m).then(s=>s?s.map(I=>v.URI.revive(I)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(m=>m?v.URI.revive(m):void 0)}}e.$csc=L}),define(Re[214],Oe([1,0,19,6,4,5]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsc=void 0;class R{constructor(m){this.b=new Map,this.c=new D.$qe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=m.getProxy(L.$_N.MainThreadEmbeddings)}registerEmbeddingsProvider(m,s,I){if(this.d.has(s))throw new Error("An embeddings provider for this model is already registered");const w=this.e++;return this.a.$registerEmbeddingProvider(w,s),this.b.set(w,{id:s,provider:I}),(0,P.$Xc)(()=>{this.d.delete(s),this.a.$unregisterEmbeddingProvider(w),this.b.delete(w)})}async computeEmbeddings(m,s,I){I??=v.CancellationToken.None;let w=!1;typeof s=="string"&&(s=[s],w=!0);const u=await this.a.$computeEmbeddings(m,s,I);if(u.length!==s.length)throw new Error;if(w){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(m,s,I){const w=this.b.get(m);if(!w)return[];const u=await w.provider.provideEmbeddings(s,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(m){this.d=new Set(m),this.c.fire()}}e.$fsc=R}),define(Re[215],Oe([1,0,4,5]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bsc=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(D.$_N.MainThreadLabelService)}$registerResourceLabelFormatter(R){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,R),(0,v.$Xc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$Bsc=P}),define(Re[86],Oe([1,0,23,13,2,3,11,5,26,16]),function(we,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Src=e.$Rrc=void 0;let I=class{constructor(u,k,$){this.f=$,this.d=new Map,this.a=k.getProxy(T.$_N.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===v.$j}getMessage(u,k){const{message:$,args:r,comment:a}=k;if(this.c)return(0,D.$jf)($,r??{});let h=$;a&&a.length>0&&(h+=`/${Array.isArray(a)?a.join(""):a}`);const c=this.d.get(u)?.contents[h];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,D.$jf)(c??$,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let k;const $=await this.g(u);if(!$){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents($),a=JSON.parse(r);k=u.isBuiltin?a.contents?.bundle:a}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${$}: ${r.message}`);return}k&&this.d.set(u.identifier.value,{contents:k,uri:$})}async g(u){if(u.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return P.URI.revive(k)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Rrc=I,e.$Rrc=I=Ke([qe(0,m.$3Q),qe(1,s.$MQ),qe(2,R.$fk)],I),e.$Src=(0,L.$Ki)("IExtHostLocalizationService")}),define(Re[216],Oe([1,0,11,5,26,16,2,34]),function(we,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$atc=void 0;let m=class extends v.$qk{constructor(w,u){super(u.logLevel,u.logsLocation,u.loggers.map(k=>(0,T.$hi)(k))),this.r=w.getProxy(D.$_N.MainThreadLogger)}$setLogLevel(w,u){u?this.setLogLevel(R.URI.revive(u),w):this.setLogLevel(w)}setVisibility(w,u){super.setVisibility(w,u),this.r.$setVisibility(w,u)}s(w,u,k){return new s(this.r,w,u,k)}};e.$atc=m,e.$atc=m=Ke([qe(0,L.$MQ),qe(1,P.$3Q)],m);class s extends v.$lk{constructor(w,u,k,$){super($?.logLevel==="always"),this.r=w,this.s=u,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(u,$).then(()=>{this.u(this.n),this.m=!0})}g(w,u){const k=[[w,u]];this.m?this.u(k):this.n.push(...k)}u(w){this.r.$log(this.s,w)}flush(){this.r.$flush(this.s)}}}),define(Re[87],Oe([1,0,5,3,4,16,20]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=e.$Trc=void 0,e.$Trc=(0,D.$Ki)("IExtHostManagedSockets");let T=class{constructor(w){this.b=0,this.c=null,this.d=new Map,this.a=w.getProxy(v.$_N.MainThreadManagedSockets)}setFactory(w,u){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(w,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(w){if(!this.c||this.c.socketFactoryId!==w)throw new Error(`No socket factory with id ${w}`);const u=++this.b,k=await this.c.makeConnection(),$=new P.$Yc;return this.d.set(u,new s(u,k,$)),$.add((0,P.$Xc)(()=>this.d.delete(u))),$.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),$.dispose()})),$.add(k.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),$.dispose()})),$.add(k.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,R.$Se.wrap(r)))),u}$remoteSocketWrite(w,u){this.d.get(w)?.actual.send(u.buffer)}$remoteSocketEnd(w){const u=this.d.get(w);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(w){await this.d.get(w)?.actual.drain?.()}};e.$Urc=T,e.$Urc=T=Ke([qe(0,L.$MQ)],T);class m{constructor(w,u){this.socketFactoryId=w,this.makeConnection=u}}class s extends P.$Zc{constructor(w,u,k){super(),this.socketId=w,this.actual=u,this.B(k)}}}),define(Re[217],Oe([1,0,5,11,21]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Esc=void 0;function L(T){return T&&T.title}let R=class{constructor(m,s){this.b=s,this.a=m.getProxy(v.$_N.MainThreadMessageService)}showMessage(m,s,I,w,u){const k={source:{identifier:m.identifier,label:m.displayName||m.name}};let $;typeof w=="string"||L(w)?$=[w,...u]:(k.modal=w?.modal,k.useCustom=w?.useCustom,k.detail=w?.detail,$=u),k.useCustom&&(0,P.$BH)(m,"resolvers");const r=[];let a=!1;for(let h=0;h<$.length;h++){const c=$[h];if(typeof c=="string")r.push({title:c,handle:h,isCloseAffordance:!1});else if(typeof c=="object"){const{title:i,isCloseAffordance:n}=c;r.push({title:i,isCloseAffordance:!!n,handle:h}),n&&(a?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,c):a=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,c)}return this.a.$showMessage(s,I,k,r).then(h=>{if(typeof h=="number")return $[h]})}};e.$Esc=R,e.$Esc=R=Ke([qe(1,D.$fk)],R)}),define(Re[218],Oe([1,0,4,14,2,21,5]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nsc=void 0;class T{constructor(s){this.b=new Map,this.a=s.getProxy(R.$_N.MainThreadProfileContentHandlers)}registerProfileContentHandler(s,I,w){if((0,L.$BH)(s,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,w),this.a.$registerProfileContentHandler(I,w.name,w.description,s.identifier.value),(0,v.$Xc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(s,I,w,u){const k=this.b.get(s);if(!k)throw new Error(`Unknown handler with id: ${s}`);return k.saveProfile(I,w,u)}async $readProfile(s,I,w){const u=this.b.get(s);if(!u)throw new Error(`Unknown handler with id: ${s}`);return u.readProfile((0,D.$jg)(I)?I:P.URI.revive(I),w)}}e.$Nsc=T}),define(Re[88],Oe([1,0,5,6,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Prc=e.$Orc=void 0;class L{constructor(T){this.b=new D.$qe,this.onDidChangePassword=this.b.event,this.a=T.getProxy(v.$_N.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,m){return this.a.$getPassword(T,m)}store(T,m,s){return this.a.$setPassword(T,m,s)}delete(T,m){return this.a.$deletePassword(T,m)}}e.$Orc=L,e.$Prc=(0,P.$Ki)("IExtHostSecretState")}),define(Re[219],Oe([1,0,19,4,5]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Usc=void 0;class L{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(P.$_N.MainThreadSpeech)}async $createSpeechToTextSession(T,m,s){const I=this.c.get(T);if(!I)return;const w=new D.$Yc,u=new v.$Be;this.d.set(m,u);const k=await I.provideSpeechToTextSession(u.token,s?{language:s}:void 0);k&&(w.add(k.onDidChange($=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,$)})),w.add(u.token.onCancellationRequested(()=>w.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,m,s){const I=this.c.get(T);if(!I)return;const w=new D.$Yc,u=new v.$Be;this.d.set(m,u);const k=await I.provideTextToSpeechSession(u.token,s?{language:s}:void 0);k&&(this.f.set(m,k),w.add(k.onDidChange($=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,$)})),w.add(u.token.onCancellationRequested(()=>w.dispose())))}async $synthesizeSpeech(T,m){this.f.get(T)?.synthesize(m)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,m){const s=this.c.get(T);if(!s)return;const I=new D.$Yc,w=new v.$Be;this.d.set(m,w);const u=await s.provideKeywordRecognitionSession(w.token);u&&(I.add(u.onDidChange(k=>{w.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,k)})),I.add(w.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,m,s){const I=L.a++;return this.c.set(I,s),this.b.$registerProvider(I,m,{extension:T,displayName:T.value}),(0,D.$Xc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$Usc=L}),define(Re[89],Oe([1,0,5,6,3]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Frc=e.$Erc=void 0;class L{constructor(T,m){this.c=m,this.b=new D.$qe,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(v.$_N.MainThreadStorage)}registerExtensionStorageKeysToSync(T,m){this.a.$registerExtensionStorageKeysToSync(T,m)}async initializeExtensionStorage(T,m,s){const I=await this.a.$initializeExtensionStorage(T,m);let w;return I&&(w=this.d(T,m,I)),w||s}setValue(T,m,s){return this.a.$setValue(T,m,s)}$acceptValue(T,m,s){const I=this.d(T,m,s);I&&this.b.fire({shared:T,key:m,value:I})}d(T,m,s){try{return JSON.parse(s)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${T}): ${I}`)}}}e.$Erc=L,e.$Frc=(0,P.$Ki)("IExtHostStorage")}),define(Re[220],Oe([1,0,4,15,2,5]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7sc=void 0;class R{static{this.a=new Set([D.Schemas.http,D.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(L.$_N.MainThreadUriOpeners)}registerExternalUriOpener(m,s,I,w){if(this.c.has(s))throw new Error(`Opener with id '${s}' already registered`);const u=w.schemes.find(k=>!R.a.has(k));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(s,I),this.b.$registerUriOpener(s,w.schemes,m,w.label),(0,v.$Xc)(()=>{this.c.delete(s),this.b.$unregisterUriOpener(s)})}async $canOpenUri(m,s,I){const w=this.c.get(m);if(!w)throw new Error(`Unknown opener with id: ${m}`);const u=P.URI.revive(s);return w.canOpenExternalUri(u,I)}async $openUri(m,s,I){const w=this.c.get(m);if(!w)throw new Error(`Unknown opener id: '${m}'`);return w.openExternalUri(P.URI.revive(s.resolvedUri),{sourceUri:P.URI.revive(s.sourceUri)},I)}}e.$7sc=R}),define(Re[221],Oe([1,0,5,2,4,12,18]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8sc=void 0;class T{static{this.a=0}constructor(s){this.c=new R.$yn,this.d=new Map,this.b=s.getProxy(v.$_N.MainThreadUrls)}registerUriHandler(s,I){const w=s.identifier;if(this.c.has(w))throw new Error(`Protocol handler already registered for extension ${w}`);const u=T.a++;return this.c.add(w),this.d.set(u,I),this.b.$registerUriHandler(u,w,s.displayName||s.name),(0,P.$Xc)(()=>{this.c.delete(w),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(s,I){const w=this.d.get(s);if(!w)return Promise.resolve(void 0);try{w.handleUri(D.URI.revive(I))}catch(u){(0,L.$4)(u)}return Promise.resolve(void 0)}async createAppUri(s){return D.URI.revive(await this.b.$createAppUri(s))}}e.$8sc=T}),define(Re[222],Oe([1,0,20,5]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5vb=L,e.$6vb=T,D=Ve(D);class P{constructor(){this.buffers=[]}add(s){let I=this.buffers.indexOf(s);return I<0&&(I=this.buffers.length,this.buffers.push(s)),I}}function L(m,s){if(s.serializeBuffersForPostMessage){const I=new P,u=JSON.stringify(m,($,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r)};if(ArrayBuffer.isView(r)){const a=R(r);if(a)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r.buffer),view:{type:a,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),k=I.buffers.map($=>{const r=new Uint8Array($);return v.$Se.wrap(r)});return{message:u,buffers:k}}else return{message:JSON.stringify(m),buffers:[]}}function R(m){switch(m.constructor.name){case"Int8Array":return D.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return D.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return D.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return D.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return D.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return D.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return D.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return D.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return D.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return D.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return D.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(m,s){const I=s.map(k=>{const $=new ArrayBuffer(k.byteLength);return new Uint8Array($).set(k.buffer),$}),w=s.length?(k,$)=>{if($&&typeof $=="object"&&$.$$vscode_array_buffer_reference$$){const r=$,{index:a}=r,h=I[a];if(r.view)switch(r.view.type){case D.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(h,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(h,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(h,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(h,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(h,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(h,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(h,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(h,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(h,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(h,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(h,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return $}:void 0;return{message:JSON.parse(m,w),arrayBuffers:I}}}),define(Re[67],Oe([1,0,6,4,15,25,2,176,222,83,5]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=e.$prc=void 0,e.$qrc=u,e.$src=r,e.$trc=a,L=Ve(L),I=Ve(I);class w{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(n,t,o,l,g,f,d){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new v.$qe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$qe,this._onDidDispose=this.#h.event,this.#e=n,this.#t=t,this.#o=o,this.#n=l,this.#s=g,this.#r=f,this.#u=u(f),this.#d=k(f),this.#i=d}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,s.$vEb)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===P.Schemas.https||n.scheme===P.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+s.$uEb}return s.$uEb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),L.$oo(this.#o,n)||this.#t.$setOptions(this.#e,a(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const t=(0,m.$5vb)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,o=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,g,f,d,S,E)=>{const y=R.URI.from({scheme:d||"file",path:decodeURIComponent(S)}),C=(0,s.$vEb)(y,{isRemote:t,authority:o}).toString();return`${g}${C}${E}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,g,f,d,S,E)=>{const y=R.URI.from({scheme:d||"file",path:decodeURIComponent(S)}),C=(0,s.$vEb)(y,{isRemote:t,authority:o}).toString();return`${g}${C}${E}`})}}e.$prc=w;function u(i){try{const n=(0,T.$8p)((0,T.$7p)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function k(i){try{const n=(0,T.$8p)((0,T.$7p)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class $ extends D.$Zc{constructor(n,t,o,l,g){super(),this.c=t,this.f=o,this.g=l,this.h=g,this.b=new Map,this.a=n.getProxy(I.$_N.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,t,o){const l=this.j(n);if(l){const{message:g}=(0,m.$6vb)(t,o.value);l._onMessageEmitter.fire(g)}}$onMissingCsp(n,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,o){const l=new w(n,this.a,h(t),this.c,this.f,o,this.h);this.b.set(n,l);const g=l._onDidDispose(()=>{g.dispose(),this.deleteWebview(n)});return l}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$rrc=$;function r(i){return{id:i.identifier,location:i.extensionLocation}}function a(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||c(i,n)}}function h(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>R.URI.from(n))}}function c(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Re[123],Oe([1,0,6,15,13,2,3,16,5]),function(we,e,v,D,P,L,R,T,m){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$$sc=e.$0sc=void 0;let I=class{static{s=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new v.$qe,this.onDidChangeWindowState=this.c.event,this.d=s.a,this.b=u.getProxy(m.$_N.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:$})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",$)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,k){k!==this.d[u]&&(this.d={...this.d,[u]:k},this.c.fire(this.d))}openUri(u,k){let $;if(typeof u=="string"){$=u;try{u=L.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,P.$hf)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,$,k)}async asExternalUri(u,k){if((0,P.$hf)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const $=await this.b.$asExternalUri(u,k);return L.URI.from($)}};e.$0sc=I,e.$0sc=I=s=Ke([qe(0,T.$MQ)],I),e.$$sc=(0,R.$Ki)("IExtHostWindow")}),define(Re[223],Oe([1,0,212,26,16]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nvc=void 0;let L=class extends v.$btc{constructor(T,m){super(T,m)}f(T,m,s){m.apply(console,s)}};e.$nvc=L,e.$nvc=L=Ke([qe(0,P.$MQ),qe(1,D.$3Q)],L)}),define(Re[224],Oe([1,0,10,20,19,30,12,6,4,38,160,210,39]),function(we,e,v,D,P,L,R,T,m,s,I,w,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.ResponsiveState=e.RequestInitiator=void 0,e.$gfc=c,e.$hfc=i,R=Ve(R);function $(M,A){try{return JSON.stringify(M,A)}catch{return"null"}}const r="$$ref$$",a={[r]:-1};class h{constructor(A,F){this.jsonString=A,this.referencedBuffers=F}}function c(M,A=null,F=!1){const G=[];return{jsonString:(F?$:JSON.stringify)(M,(j,U)=>{if(typeof U>"u")return a;if(typeof U=="object"){if(U instanceof D.$Se){const J=G.push(U)-1;return{[r]:J}}if(A)return A(j,U)}return U}),referencedBuffers:G}}function i(M,A,F){return JSON.parse(M,(G,x)=>{if(x){const j=x[r];if(typeof j=="number")return A[j];if(F&&x.$mid===s.MarshalledId.Uri)return F.transformIncoming(x)}return x})}function n(M,A){return JSON.stringify(M,A)}function t(M){return M?(A,F)=>F&&F.$mid===s.MarshalledId.Uri?M.transformOutgoing(F):F:null}var o;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var l;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const g=()=>{},f=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class S extends m.$Zc{static{k=f}static{this.a=3*1e3}constructor(A,F=null,G=null){super(),this[k]=!0,this.b=this.B(new T.$qe),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=F,this.g=G,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let x=0,j=u.$4w.count;x<j;x++)this.m[x]=null,this.s[x]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=l.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Wh(()=>this.H(),1e3)),this.B(this.c.onMessage(x=>this.L(x)))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const F=this.w[A];delete this.w[A],F.resolveErr(R.$0())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+S.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+S.a,this.z--,this.z===0&&this.D.cancel(),this.I(l.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(l.Unresponsive):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,I.$Vn)(A,this.g):A}getProxy(A){const{nid:F,sid:G}=A;return this.s[F]||(this.s[F]=this.J(F,G)),this.s[F]}J(A,F){const G={get:(x,j)=>(typeof j=="string"&&!x[j]&&j.charCodeAt(0)===L.CharCode.DollarSign&&(x[j]=(...U)=>this.U(A,j,U)),j===d?F:x[j])};return new Proxy(Object.create(null),G)}set(A,F){return this.m[A.nid]=F,F}assertRegistered(A){for(let F=0,G=A.length;F<G;F++){const x=A[F];if(!this.m[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}L(A){if(this.j)return;const F=A.byteLength,G=y.read(A,0),x=G.readUInt8(),j=G.readUInt32();switch(x){case p.RequestJSONArgs:case p.RequestJSONArgsWithCancellation:{let{rpcId:U,method:J,args:Y}=O.deserializeRequestJSONArgs(G);this.g&&(Y=(0,I.$Vn)(Y,this.g)),this.M(F,j,U,J,Y,x===p.RequestJSONArgsWithCancellation);break}case p.RequestMixedArgs:case p.RequestMixedArgsWithCancellation:{let{rpcId:U,method:J,args:Y}=O.deserializeRequestMixedArgs(G);this.g&&(Y=(0,I.$Vn)(Y,this.g)),this.M(F,j,U,J,Y,x===p.RequestMixedArgsWithCancellation);break}case p.Acknowledged:{this.f?.logIncoming(F,j,o.LocalSide,"ack"),this.G(j);break}case p.Cancel:{this.N(F,j);break}case p.ReplyOKEmpty:{this.O(F,j,void 0);break}case p.ReplyOKJSON:{let U=O.deserializeReplyOKJSON(G);this.g&&(U=(0,I.$Vn)(U,this.g)),this.O(F,j,U);break}case p.ReplyOKJSONWithBuffers:{const U=O.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(F,j,U);break}case p.ReplyOKVSBuffer:{const U=O.deserializeReplyOKVSBuffer(G);this.O(F,j,U);break}case p.ReplyErrError:{let U=O.deserializeReplyErrError(G);this.g&&(U=(0,I.$Vn)(U,this.g)),this.P(F,j,U);break}case p.ReplyErrEmpty:{this.P(F,j,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,F,G,x,j,U){this.f?.logIncoming(A,F,o.OtherSide,`receiveRequest ${(0,u.$6w)(G)}.${x}(`,j);const J=String(F);let Y,ae;if(U){const oe=new P.$Be;j.push(oe.token),Y=this.Q(G,x,j),ae=()=>oe.cancel()}else Y=this.Q(G,x,j),ae=g;this.u[J]=ae;const ee=O.serializeAcknowledged(F);this.f?.logOutgoing(ee.byteLength,F,o.OtherSide,"ack"),this.c.send(ee),Y.then(oe=>{delete this.u[J];const ie=O.serializeReplyOK(F,oe,this.h);this.f?.logOutgoing(ie.byteLength,F,o.OtherSide,"reply:",oe),this.c.send(ie)},oe=>{delete this.u[J];const ie=O.serializeReplyErr(F,oe);this.f?.logOutgoing(ie.byteLength,F,o.OtherSide,"replyErr:",oe),this.c.send(ie)})}N(A,F){this.f?.logIncoming(A,F,o.OtherSide,"receiveCancel");const G=String(F);this.u[G]?.()}O(A,F,G){this.f?.logIncoming(A,F,o.LocalSide,"receiveReply:",G);const x=String(F);if(!this.w.hasOwnProperty(x))return;const j=this.w[x];delete this.w[x],j.resolveOk(G)}P(A,F,G){this.f?.logIncoming(A,F,o.LocalSide,"receiveReplyErr:",G);const x=String(F);if(!this.w.hasOwnProperty(x))return;const j=this.w[x];delete this.w[x];let U;G&&(G.$isError?(U=new Error,U.name=G.name,U.message=G.message,U.stack=G.stack):U=G),j.resolveErr(U)}Q(A,F,G){try{return Promise.resolve(this.S(A,F,G))}catch(x){return Promise.reject(x)}}S(A,F,G){const x=this.m[A];if(!x)throw new Error("Unknown actor "+(0,u.$6w)(A));const j=x[F];if(typeof j!="function")throw new Error("Unknown method "+F+" on actor "+(0,u.$6w)(A));return j.apply(x,G)}U(A,F,G){if(this.j)return new w.$ffc;let x=null;if(G.length>0&&P.CancellationToken.isCancellationToken(G[G.length-1])&&(x=G.pop()),x&&x.isCancellationRequested)return Promise.reject(R.$0());const j=O.serializeRequestArguments(G,this.h),U=++this.t,J=String(U),Y=new w.$efc,ae=new m.$Yc;x&&ae.add(x.onCancellationRequested(()=>{const oe=O.serializeCancel(U);this.f?.logOutgoing(oe.byteLength,U,o.LocalSide,"cancel"),this.c.send(O.serializeCancel(U))})),this.w[J]=new E(Y,ae),this.F(U);const ee=O.serializeRequest(U,A,F,j,!!x);return this.f?.logOutgoing(ee.byteLength,U,o.LocalSide,`request: ${(0,u.$6w)(A)}.${F}(`,G),this.c.send(ee),Y}}e.$ifc=S;class E{constructor(A,F){this.a=A,this.b=F}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class y{static alloc(A,F,G){const x=new y(D.$Se.alloc(G+1+4),0);return x.writeUInt8(A),x.writeUInt32(F),x}static read(A,F){return new y(A,F)}get buffer(){return this.a}constructor(A,F){this.a=A,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+A).toString();return this.b+=A,G}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+A).toString();return this.b+=A,G}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+A);return this.b+=A,F}static sizeMixedArray(A){let F=0;F+=1;for(let G=0,x=A.length;G<x;G++){const j=A[G];switch(F+=1,j.type){case b.String:F+=this.sizeLongString(j.value);break;case b.VSBuffer:F+=this.sizeVSBuffer(j.value);break;case b.SerializedObjectWithBuffers:F+=this.sizeUInt32,F+=this.sizeLongString(j.value);for(let U=0;U<j.buffers.length;++U)F+=this.sizeVSBuffer(j.buffers[U]);break;case b.Undefined:break}}return F}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let F=0,G=A.length;F<G;F++){const x=A[F];switch(x.type){case b.String:this.writeUInt8(b.String),this.writeLongString(x.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(x.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let j=0;j<x.buffers.length;++j)this.writeBuffer(x.buffers[j]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const F=new Array(A);for(let G=0;G<A;G++)switch(this.readUInt8()){case b.String:F[G]=this.readLongString();break;case b.VSBuffer:F[G]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const j=this.readUInt32(),U=this.readLongString(),J=[];for(let Y=0;Y<j;++Y)J.push(this.readVSBuffer());F[G]=new u.$7w(i(U,J,null));break}case b.Undefined:F[G]=void 0;break}return F}}var C;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(C||(C={}));class O{static a(A){for(let F=0,G=A.length;F<G;F++)if(A[F]instanceof D.$Se||A[F]instanceof u.$7w||typeof A[F]>"u")return!0;return!1}static serializeRequestArguments(A,F){if(this.a(A)){const G=[];for(let x=0,j=A.length;x<j;x++){const U=A[x];if(U instanceof D.$Se)G[x]={type:b.VSBuffer,value:U};else if(typeof U>"u")G[x]={type:b.Undefined};else if(U instanceof u.$7w){const{jsonString:J,referencedBuffers:Y}=c(U.value,F);G[x]={type:b.SerializedObjectWithBuffers,value:D.$Se.fromString(J),buffers:Y}}else G[x]={type:b.String,value:D.$Se.fromString(n(U,F))}}return{type:C.Mixed,args:G}}return{type:C.Simple,args:n(A,F)}}static serializeRequest(A,F,G,x,j){switch(x.type){case C.Simple:return this.b(A,F,G,x.args,j);case C.Mixed:return this.c(A,F,G,x.args,j)}}static b(A,F,G,x,j){const U=D.$Se.fromString(G),J=D.$Se.fromString(x);let Y=0;Y+=y.sizeUInt8(),Y+=y.sizeShortString(U),Y+=y.sizeLongString(J);const ae=y.alloc(j?p.RequestJSONArgsWithCancellation:p.RequestJSONArgs,A,Y);return ae.writeUInt8(F),ae.writeShortString(U),ae.writeLongString(J),ae.buffer}static deserializeRequestJSONArgs(A){const F=A.readUInt8(),G=A.readShortString(),x=A.readLongString();return{rpcId:F,method:G,args:JSON.parse(x)}}static c(A,F,G,x,j){const U=D.$Se.fromString(G);let J=0;J+=y.sizeUInt8(),J+=y.sizeShortString(U),J+=y.sizeMixedArray(x);const Y=y.alloc(j?p.RequestMixedArgsWithCancellation:p.RequestMixedArgs,A,J);return Y.writeUInt8(F),Y.writeShortString(U),Y.writeMixedArray(x),Y.buffer}static deserializeRequestMixedArgs(A){const F=A.readUInt8(),G=A.readShortString(),x=A.readMixedArray(),j=new Array(x.length);for(let U=0,J=x.length;U<J;U++){const Y=x[U];typeof Y=="string"?j[U]=JSON.parse(Y):j[U]=Y}return{rpcId:F,method:G,args:j}}static serializeAcknowledged(A){return y.alloc(p.Acknowledged,A,0).buffer}static serializeCancel(A){return y.alloc(p.Cancel,A,0).buffer}static serializeReplyOK(A,F,G){if(typeof F>"u")return this.d(A);if(F instanceof D.$Se)return this.e(A,F);if(F instanceof u.$7w){const{jsonString:x,referencedBuffers:j}=c(F.value,G,!0);return this.g(A,x,j)}else return this.f(A,$(F,G))}static d(A){return y.alloc(p.ReplyOKEmpty,A,0).buffer}static e(A,F){let G=0;G+=y.sizeVSBuffer(F);const x=y.alloc(p.ReplyOKVSBuffer,A,G);return x.writeVSBuffer(F),x.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,F){const G=D.$Se.fromString(F);let x=0;x+=y.sizeLongString(G);const j=y.alloc(p.ReplyOKJSON,A,x);return j.writeLongString(G),j.buffer}static g(A,F,G){const x=D.$Se.fromString(F);let j=0;j+=y.sizeUInt32,j+=y.sizeLongString(x);for(const J of G)j+=y.sizeVSBuffer(J);const U=y.alloc(p.ReplyOKJSONWithBuffers,A,j);U.writeUInt32(G.length),U.writeLongString(x);for(const J of G)U.writeBuffer(J);return U.buffer}static deserializeReplyOKJSON(A){const F=A.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(A,F){const G=A.readUInt32(),x=A.readLongString(),j=[];for(let U=0;U<G;++U)j.push(A.readVSBuffer());return new u.$7w(i(x,j,F))}static serializeReplyErr(A,F){const G=F?$(R.$6(F),null):void 0;if(typeof G!="string")return this.h(A);const x=D.$Se.fromString(G);let j=0;j+=y.sizeLongString(x);const U=y.alloc(p.ReplyErrError,A,j);return U.writeLongString(x),U.buffer}static deserializeReplyErrError(A){const F=A.readLongString();return JSON.parse(F)}static h(A){return y.alloc(p.ReplyErrEmpty,A,0).buffer}}var p;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var b;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(b||(b={}))}),define(Re[225],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pvc=void 0;const v=function(L){const R=T=>{globalThis.removeEventListener("message",R);const m=T.data;Object.defineProperties(globalThis,{postMessage:{value(s,I){m.postMessage(s,I)}},onmessage:{get(){return m.onmessage},set(s){m.onmessage=s}}}),m.addEventListener("message",s=>{globalThis.dispatchEvent(new MessageEvent("message",{data:s.data,ports:s.ports?[...s.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",R)}.toString();class D extends EventTarget{constructor(L,R,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${v})('${R}'))`,s=new Blob([m],{type:"application/javascript"}),I=URL.createObjectURL(s),w=new MessageChannel,u=I,k={type:"_newWorker",id:u,port:w.port2,url:I,options:T};L(k,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{L({type:"_terminateWorker",id:u}),URL.revokeObjectURL(I),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set($){w.port1.onmessage=$}},onmessageerror:{get(){return w.port1.onmessageerror},set($){w.port1.onmessageerror=$}}}),w.port1.addEventListener("messageerror",$=>{const r=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(r)}),w.port1.addEventListener("message",$=>{const r=new MessageEvent("message",{data:$.data});this.dispatchEvent(r)}),w.port1.start()}}e.$pvc=D}),define(Re[226],Oe([1,0,20,27,15,60,3]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$OL=void 0,e.$PL=I,e.$QL=w,e.$RL=u,e.$SL=k,e.$OL=(0,R.$Ki)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${T.join("")}]+`),s=7;function I(r){if(r.scheme!==P.Schemas.vscodeNotebookCell)return;const a=r.fragment.indexOf("s");if(a<0)return;const h=parseInt(r.fragment.substring(0,a).replace(m,""),s),c=(0,v.$_e)(r.fragment.substring(a+1)).toString();if(!isNaN(h))return{handle:h,notebook:r.with({scheme:c,fragment:null})}}function w(r,a){const h=a.toString(s),i=`${h.length<T.length?T[h.length-1]:"z"}${h}s${(0,v.$af)(v.$Se.fromString(r.scheme),!0,!0)}`;return r.with({scheme:P.Schemas.vscodeNotebookCell,fragment:i})}function u(r){if(r.scheme!==P.Schemas.vscodeNotebookMetadata)return;const a=(0,v.$_e)(r.fragment).toString();return r.with({scheme:a,fragment:null})}function k(r){const a=`${(0,v.$af)(v.$Se.fromString(r.scheme),!0,!0)}`;return r.with({scheme:P.Schemas.vscodeNotebookMetadata,fragment:a})}class ${constructor(){this.a=new D.$Fc}getNotebook(a){if(a.scheme===P.Schemas.vscodeNotebookCell){const h=I(a);if(h){const c=this.a.get(h.notebook);if(c)return c}}return this.a.get(a)}addNotebookDocument(a){this.a.set(a.uri,a)}removeNotebookDocument(a){this.a.delete(a.uri)}}e.$TL=$,(0,L.$Zs)(e.$OL,$,L.InstantiationType.Delayed)}),define(Re[90],Oe([1,0,20,43,41,72,15,22,23,31,226]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$_L=e.CellStatusbarAlignment=e.$$L=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$8L=e.$7L=e.$5L=e.CellUri=e.NotebookUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$4L=e.$3L=e.$2L=e.$1L=e.CellKind=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=void 0,e.$6L=g,e.$9L=S,e.$0L=E,e.$aM=O,e.$bM=b,D=Ve(D),e.$UL="workbench.editor.notebook",e.$VL="workbench.editor.notebookTextDiffEditor",e.$WL="workbench.editor.notebookMultiTextDiffEditor",e.$XL="workbench.editor.interactive",e.$YL="workbench.editor.repl",e.$ZL="replNotebook.input.execute";var w;(function(Y){Y[Y.Markup=1]="Markup",Y[Y.Code=2]="Code"})(w||(e.CellKind=w={})),e.$1L=["application/json","application/javascript","text/html","image/svg+xml",L.$gt.latex,L.$gt.markdown,"image/png","image/jpeg",L.$gt.text],e.$2L=[L.$gt.latex,L.$gt.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$gt.text],e.$3L=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$4L="_notAvailable";var u;(function(Y){Y[Y.Running=1]="Running",Y[Y.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var k;(function(Y){Y[Y.Unconfirmed=1]="Unconfirmed",Y[Y.Pending=2]="Pending",Y[Y.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var $;(function(Y){Y[Y.Unconfirmed=1]="Unconfirmed",Y[Y.Pending=2]="Pending",Y[Y.Executing=3]="Executing"})($||(e.NotebookExecutionState=$={}));var r;(function(Y){Y[Y.WithHardKernelDependency=0]="WithHardKernelDependency",Y[Y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Y[Y.Pure=2]="Pure",Y[Y.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var a;(function(Y){Y.Always="always",Y.Never="never",Y.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var h;(function(Y){Y[Y.ModelChange=1]="ModelChange",Y[Y.Move=2]="Move",Y[Y.ChangeCellLanguage=5]="ChangeCellLanguage",Y[Y.Initialize=6]="Initialize",Y[Y.ChangeCellMetadata=7]="ChangeCellMetadata",Y[Y.Output=8]="Output",Y[Y.OutputItem=9]="OutputItem",Y[Y.ChangeCellContent=10]="ChangeCellContent",Y[Y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Y[Y.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Y[Y.ChangeCellMime=13]="ChangeCellMime",Y[Y.Unknown=100]="Unknown"})(h||(e.NotebookCellsChangeType=h={}));var c;(function(Y){Y[Y.Handle=0]="Handle",Y[Y.Index=1]="Index"})(c||(e.SelectionStateType=c={}));var i;(function(Y){Y[Y.Replace=1]="Replace",Y[Y.Output=2]="Output",Y[Y.Metadata=3]="Metadata",Y[Y.CellLanguage=4]="CellLanguage",Y[Y.DocumentMetadata=5]="DocumentMetadata",Y[Y.Move=6]="Move",Y[Y.OutputItems=7]="OutputItems",Y[Y.PartialMetadata=8]="PartialMetadata",Y[Y.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(Y){Y.scheme=R.Schemas.vscodeNotebookMetadata;function ae(oe){return(0,I.$SL)(oe)}Y.generate=ae;function ee(oe){return(0,I.$RL)(oe)}Y.parse=ee})(n||(e.NotebookUri=n={}));var t;(function(Y){Y.scheme=R.Schemas.vscodeNotebookCell;function ae($e,Ie){return(0,I.$QL)($e,Ie)}Y.generate=ae;function ee($e){return(0,I.$PL)($e)}Y.parse=ee;function oe($e,Ie){return $e.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${Ie??""},${$e.scheme!==R.Schemas.file?$e.scheme:""}`})}Y.generateCellOutputUri=oe;function ie($e){if($e.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const Ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!Ie)return;const X=Ie[1]&&Ie[1]!==""?Ie[1]:void 0,V=Ie[2];return{outputId:X,notebook:$e.with({scheme:V||R.Schemas.file,fragment:null})}}Y.parseCellOutputUri=ie;function ue($e,Ie,X){return Y.generate($e,Ie).with({scheme:X})}Y.generateCellPropertyUri=ue;function _($e,Ie){if($e.scheme===Ie)return Y.parse($e.with({scheme:Y.scheme}))}Y.parseCellPropertyUri=_})(t||(e.CellUri=t={}));const o=Y=>m.$l?Y.replace(/\//g,"\\"):Y;class l{constructor(ae=[],ee=e.$1L){this.e=ee,this.d=[...new Set(ae)].map(oe=>({pattern:oe,matches:D.$Fk(o(oe))}))}sort(ae){const ee=new Map(P.Iterable.map(ae,ie=>[ie,o(ie)]));let oe=[];for(const{matches:ie}of this.d)for(const[ue,_]of ee)if(ie(_)){oe.push(ue),ee.delete(ue);break}return ee.size&&(oe=oe.concat([...ee.keys()].sort((ie,ue)=>this.e.indexOf(ie)-this.e.indexOf(ue)))),oe}prioritize(ae,ee){const oe=this.f(ae);if(oe===-1){this.d.unshift({pattern:ae,matches:D.$Fk(o(ae))});return}const ie=new Set(ee.map(_=>this.f(_,oe)));ie.delete(-1);const ue=Array.from(ie).sort();this.d.splice(oe+1,0,...ue.map(_=>this.d[_]));for(let _=ue.length-1;_>=0;_--)this.d.splice(ue[_],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,ee=this.d.length){const oe=o(ae);for(let ie=0;ie<ee;ie++)if(this.d[ie].matches(oe))return ie;return-1}}e.$5L=l;function g(Y,ae,ee,oe=(ie,ue)=>ie===ue){const ie=[];function ue(Ie,X,V){if(X===0&&V.length===0)return;const re=ie[ie.length-1];re&&re.start+re.deleteCount===Ie?(re.deleteCount+=X,re.toInsert.push(...V)):ie.push({start:Ie,deleteCount:X,toInsert:V})}let _=0,$e=0;for(;;){if(_===Y.length){ue(_,0,ae.slice($e));break}if($e===ae.length){ue(_,Y.length-_,[]);break}const Ie=Y[_],X=ae[$e];if(oe(Ie,X)){_+=1,$e+=1;continue}ee(X)?(ue(_,1,[]),_+=1):(ue(_,0,[X]),$e+=1)}return ie}e.$7L=new s.$2j("notebookEditorCursorAtBoundary","none"),e.$8L=new s.$2j("notebookEditorCursorAtLineBoundary","none");var f;(function(Y){Y.default="default",Y.option="option"})(f||(e.NotebookEditorPriority=f={}));var d;(function(Y){Y.Cells="cells",Y.Text="text",Y.None="none"})(d||(e.NotebookFindScopeType=d={}));function S(Y){const ae=Y;return!!((typeof ae.include=="string"||D.$Gk(ae.include))&&(typeof ae.exclude=="string"||D.$Gk(ae.exclude)))}function E(Y,ae,ee){if(Array.isArray(Y.viewType)&&Y.viewType.indexOf(ae)>=0||Y.viewType===ae)return!0;if(Y.filenamePattern){const oe=S(Y.filenamePattern)?Y.filenamePattern.include:Y.filenamePattern,ie=S(Y.filenamePattern)?Y.filenamePattern.exclude:void 0;if(D.$Ek(oe,(0,T.$sc)(ee.fsPath).toLowerCase()))return!(ie&&D.$Ek(ie,(0,T.$sc)(ee.fsPath).toLowerCase()))}return!1}e.$$L={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var y;(function(Y){Y[Y.Left=1]="Left",Y[Y.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class C{static{this.d="notebook/"}static create(ae){return`${C.d}${ae}`}static parse(ae){if(ae.startsWith(C.d))return ae.substring(C.d.length)}}e.$_L=C;function O(Y){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Y)}const p=new TextDecoder;function b(Y){const ae=[];let ee=!1;for(const _ of Y)(ae.length===0||ee)&&(ae.push(_),ee=!0);let oe=F(ae);const ie=v.$Se.concat(ae.map(_=>v.$Se.wrap(_))),ue=J(ie);return oe=oe||ue.byteLength!==ie.byteLength,{data:ue,didCompression:oe}}e.$cM="\x1B[A";const M=e.$cM.split("").map(Y=>Y.charCodeAt(0)),A=10;function F(Y){let ae=!1;return Y.forEach((ee,oe)=>{if(oe===0||ee.length<e.$cM.length)return;const ie=Y[oe-1],ue=ee.subarray(0,e.$cM.length);if(ue[0]===M[0]&&ue[1]===M[1]&&ue[2]===M[2]){const _=ie.lastIndexOf(A);if(_===-1)return;ae=!0,Y[oe-1]=ie.subarray(0,_),Y[oe]=ee.subarray(e.$cM.length)}}),ae}function G(Y){let ae=Y;do Y=ae,ae=Y.replace(/[^\n]\x08/gm,"");while(ae.length<Y.length);return Y}function x(Y){for(Y=Y.replace(/\r+\n/gm,`
`);Y.search(/\r[^$]/g)>-1;){const ae=Y.match(/^(.*)\r+/m)[1];let ee=Y.match(/\r+(.*)$/m)[1];ee=ee+ae.slice(ee.length,ae.length),Y=Y.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return Y}const j=8,U=13;function J(Y){return!Y.buffer.includes(j)&&!Y.buffer.includes(U)?Y:v.$Se.fromString(x(G(p.decode(Y.buffer))))}}),define(Re[7],Oe([1,0,17,12,59,27,72,13,14,2,33,18,28,110,90]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$){"use strict";var r,a,h,c,i,n,t,o,l,g,f,d,S,E,y,C,O;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$BQ=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$AQ=e.$zQ=e.$yQ=e.$xQ=e.$wQ=e.$vQ=e.$uQ=e.$tQ=e.LanguageModelChatMessageRole=e.$sQ=e.$rQ=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$qQ=e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=e.$fQ=e.$eQ=e.$dQ=e.$cQ=e.$bQ=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$aQ=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$_P=e.$$P=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.$3P=e.$2P=e.$1P=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$ZP=e.$YP=e.$XP=e.$WP=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.TestRunProfileKind=e.TestResultState=e.$PP=e.$OP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$NP=e.NotebookVariablesRequestKind=e.$MP=e.$LP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$KP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.ColorThemeKind=e.$EP=e.$DP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$CP=e.QuickInputButtonLocation=e.$BP=e.DebugConsoleMode=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$vP=e.$uP=e.FileChangeType=e.$tP=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$sP=e.$rP=e.$qP=e.$pP=e.InlineCompletionTriggerKind=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$cP=e.ConfigurationTarget=e.$bP=e.$aP=e.$_O=e.$$O=e.DocumentPasteTriggerKind=e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$4O=e.ViewBadge=e.ProgressLocation=e.$3O=e.$2O=e.TaskScope=e.ShellQuoting=e.$1O=e.$ZO=e.$YO=e.TaskPanelKind=e.TaskRevealKind=e.$XO=e.TerminalLocation=e.$WO=e.$VO=e.$UO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$TO=e.$SO=e.$RO=e.$QO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$OO=e.$NO=e.$MO=e.$LO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$KO=e.$JO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.LanguageStatusSeverity=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.CodeActionTriggerKind=e.$xO=e.$wO=e.SymbolTag=e.SymbolKind=e.$vO=e.$uO=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.DiagnosticSeverity=e.DiagnosticTag=e.$oO=e.$nO=e.FileEditType=e.$mO=e.$lO=e.$kO=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$jO=e.$iO=e.$hO=e.$eO=e.$dO=e.$cO=e.$bO=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$fO=j,e.$gO=U,e.$PO=dt,e.$dP=ji,e.$VP=Cn;function p(z){return Object.assign(z,{apply:function(...ne){if(ne.length===0)return Reflect.construct(z,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(z,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(z,[]);{const[Se,...He]=ne;return Reflect.construct(z,He,Se.constructor)}}})}var b;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var M;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let A=r=class{static from(...N){let ne=N;return new r(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$bO=A,e.$bO=A=r=Ke([p],A);let F=a=class{static Min(...N){if(N.length===0)throw new TypeError;let ne=N[0];for(let Se=1;Se<N.length;Se++){const He=N[Se];He.isBefore(ne)&&(ne=He)}return ne}static Max(...N){if(N.length===0)throw new TypeError;let ne=N[0];for(let Se=1;Se<N.length;Se++){const He=N[Se];He.isAfter(ne)&&(ne=He)}return ne}static isPosition(N){if(!N)return!1;if(N instanceof a)return!0;const{line:ne,character:Se}=N;return typeof ne=="number"&&typeof Se=="number"}static of(N){if(N instanceof a)return N;if(this.isPosition(N))return new a(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ne){if(N<0)throw(0,D.$$)("line must be non-negative");if(ne<0)throw(0,D.$$)("character must be non-negative");this.c=N,this.e=ne}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ne=0){if(N===null||ne===null)throw(0,D.$$)();let Se;return typeof N>"u"?Se=0:typeof N=="number"?Se=N:(Se=typeof N.lineDelta=="number"?N.lineDelta:0,ne=typeof N.characterDelta=="number"?N.characterDelta:0),Se===0&&ne===0?this:new a(this.line+Se,this.character+ne)}with(N,ne=this.character){if(N===null||ne===null)throw(0,D.$$)();let Se;return typeof N>"u"?Se=this.line:typeof N=="number"?Se=N:(Se=typeof N.line=="number"?N.line:this.line,ne=typeof N.character=="number"?N.character:this.character),Se===this.line&&ne===this.character?this:new a(Se,ne)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$cO=F,e.$cO=F=a=Ke([p],F);let G=h=class{static isRange(N){return N instanceof h?!0:N?F.isPosition(N.start)&&F.isPosition(N.end):!1}static of(N){if(N instanceof h)return N;if(this.isRange(N))return new h(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ne,Se,He){let rt,pt;if(typeof N=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"?(rt=new F(N,ne),pt=new F(Se,He)):F.isPosition(N)&&F.isPosition(ne)&&(rt=F.of(N),pt=F.of(ne)),!rt||!pt)throw new Error("Invalid arguments");rt.isBefore(pt)?(this.c=rt,this.e=pt):(this.c=pt,this.e=rt)}contains(N){return h.isRange(N)?this.contains(N.start)&&this.contains(N.end):F.isPosition(N)?!(F.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ne=F.Max(N.start,this.c),Se=F.Min(N.end,this.e);if(!ne.isAfter(Se))return new h(ne,Se)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ne=F.Min(N.start,this.c),Se=F.Max(N.end,this.end);return new h(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ne=this.end){if(N===null||ne===null)throw(0,D.$$)();let Se;return N?F.isPosition(N)?Se=N:(Se=N.start||this.start,ne=N.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new h(Se,ne)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return j(this)}};e.$dO=G,e.$dO=G=h=Ke([p],G);let x=c=class extends G{static isSelection(N){return N instanceof c?!0:N?G.isRange(N)&&F.isPosition(N.anchor)&&F.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ne,Se,He){let rt,pt;if(typeof N=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"?(rt=new F(N,ne),pt=new F(Se,He)):F.isPosition(N)&&F.isPosition(ne)&&(rt=F.of(N),pt=F.of(ne)),!rt||!pt)throw new Error("Invalid arguments");super(rt,pt),this.f=rt,this.g=pt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return U(this)}};e.$eO=x,e.$eO=x=c=Ke([p],x);function j(z){return z.isEmpty?`[${z.start.line}:${z.start.character})`:`[${z.start.line}:${z.start.character} -> ${z.end.line}:${z.end.character})`}function U(z){let N=j(z);return z.isEmpty||(z.active.isEqual(z.start)?N=`|${N}`:N=`${N}|`),N}const J=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,D.$$)("connectionToken")};class Y{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ne,Se){if(typeof N!="string"||N.length===0)throw(0,D.$$)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,D.$$)("port");typeof Se<"u"&&J(Se),this.host=N,this.port=Math.round(ne),this.connectionToken=Se}}e.$hO=Y;class ae{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ne){this.makeConnection=N,this.connectionToken=ne,typeof ne<"u"&&J(ne)}}e.$iO=ae;class ee extends Error{static NotAvailable(N,ne){return new ee(N,k.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(N){return new ee(N,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ne=k.RemoteAuthorityResolverErrorCode.Unknown,Se){super(N),this._message=N,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,ee.prototype)}}e.$jO=ee;var oe;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(oe||(e.EndOfLine=oe={}));var ie;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(ie||(e.EnvironmentVariableMutatorType=ie={}));let ue=i=class{static isTextEdit(N){return N instanceof i?!0:N?G.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ne){return new i(N,ne)}static insert(N,ne){return i.replace(new G(N,N),ne)}static delete(N){return i.replace(N,"")}static setEndOfLine(N){const ne=new i(new G(new F(0,0),new F(0,0)),"");return ne.newEol=N,ne}get range(){return this.c}set range(N){if(N&&!G.isRange(N))throw(0,D.$$)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,D.$$)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,D.$$)("newEol");this.f=N}constructor(N,ne){this.c=N,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$kO=ue,e.$kO=ue=i=Ke([p],ue);let _=n=class{static isNotebookCellEdit(N){return N instanceof n?!0:N?ki.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ne){return new n(N,ne)}static insertCells(N,ne){return new n(new ki(N,N),ne)}static deleteCells(N){return new n(N,[])}static updateCellMetadata(N,ne){const Se=new n(new ki(N,N),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(N){const ne=new n(new ki(0,0),[]);return ne.newNotebookMetadata=N,ne}constructor(N,ne){this.range=N,this.newCells=ne}};e.$lO=_,e.$lO=_=n=Ke([p],_);class $e{static isSnippetTextEdit(N){return N instanceof $e?!0:N?G.isRange(N.range)&&V.isSnippetString(N.snippet):!1}static replace(N,ne){return new $e(N,ne)}static insert(N,ne){return $e.replace(new G(N,N),ne)}constructor(N,ne){this.range=N,this.snippet=ne}}e.$mO=$e;var Ie;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ie||(e.FileEditType=Ie={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ne,Se,He){this.c.push({_type:Ie.File,from:N,to:ne,options:Se,metadata:He})}createFile(N,ne,Se){this.c.push({_type:Ie.File,from:void 0,to:N,options:ne,metadata:Se})}deleteFile(N,ne,Se){this.c.push({_type:Ie.File,from:N,to:void 0,options:ne,metadata:Se})}e(N,ne,Se){this.c.push({_type:Ie.Cell,metadata:Se,uri:N,edit:{editType:$.CellEditType.DocumentMetadata,metadata:ne},notebookMetadata:ne})}f(N,ne,Se,He){const rt=ne.start,pt=ne.end;(rt!==pt||Se.length>0)&&this.c.push({_type:Ie.CellReplace,uri:N,index:rt,count:pt-rt,cells:Se,metadata:He})}g(N,ne,Se,He){this.c.push({_type:Ie.Cell,metadata:He,uri:N,edit:{editType:$.CellEditType.Metadata,index:ne,metadata:Se}})}replace(N,ne,Se,He){this.c.push({_type:Ie.Text,uri:N,edit:new ue(ne,Se),metadata:He})}insert(N,ne,Se,He){this.replace(N,new G(ne,ne),Se,He)}delete(N,ne,Se){this.replace(N,ne,"",Se)}has(N){return this.c.some(ne=>ne._type===Ie.Text&&ne.uri.toString()===N.toString())}set(N,ne){if(ne)for(const Se of ne){if(!Se)continue;let He,rt;Array.isArray(Se)?(He=Se[0],rt=Se[1]):He=Se,_.isNotebookCellEdit(He)?He.newCellMetadata?this.g(N,He.range.start,He.newCellMetadata,rt):He.newNotebookMetadata?this.e(N,He.newNotebookMetadata,rt):this.f(N,He.range,He.newCells,rt):$e.isSnippetTextEdit(He)?this.c.push({_type:Ie.Snippet,uri:N,range:He.range,edit:He.snippet,metadata:rt}):this.c.push({_type:Ie.Text,uri:N,edit:He,metadata:rt})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case Ie.Text:case Ie.Snippet:case Ie.Cell:case Ie.CellReplace:He.uri.toString()===N.toString()&&(this.c[Se]=void 0);break}}(0,v.$Mb)(this.c)}}get(N){const ne=[];for(const Se of this.c)Se._type===Ie.Text&&Se.uri.toString()===N.toString()&&ne.push(Se.edit);return ne}entries(){const N=new L.$Fc;for(const ne of this.c)if(ne._type===Ie.Text){let Se=N.get(ne.uri);Se||(Se=[ne.uri,[]],N.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$nO=X,e.$nO=X=Ke([p],X);let V=t=class{static isSnippetString(N){return N instanceof t?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=t.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ne=this.e++){if(typeof N=="function"){const Se=new t;Se.e=this.e,N(Se),this.e=Se.e,N=Se.value}else N=t.c(N);return this.value+="${",this.value+=ne,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ne=this.e++){const Se=N.map(He=>He.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(N,ne){if(typeof ne=="function"){const Se=new t;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$oO=V,e.$oO=V=t=Ke([p],V);var re;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(re||(e.DiagnosticTag=re={}));var be;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let Pe=o=class{static isLocation(N){return N instanceof o?!0:N?G.isRange(N.range)&&s.URI.isUri(N.uri):!1}constructor(N,ne){if(this.uri=N,ne)if(G.isRange(ne))this.range=G.of(ne);else if(F.isPosition(ne))this.range=new G(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$pO=Pe,e.$pO=Pe=o=Ke([p],Pe);let Fe=class{static is(N){return N?typeof N.message=="string"&&N.location&&G.isRange(N.location.range)&&s.URI.isUri(N.location.uri):!1}constructor(N,ne){this.location=N,this.message=ne}static isEqual(N,ne){return N===ne?!0:!N||!ne?!1:N.message===ne.message&&N.location.range.isEqual(ne.location.range)&&N.location.uri.toString()===ne.location.uri.toString()}};e.$qO=Fe,e.$qO=Fe=Ke([p],Fe);let Be=class{constructor(N,ne,Se=be.Error){if(!G.isRange(N))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=N,this.message=ne,this.severity=Se}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ne){return N===ne?!0:!N||!ne?!1:N.message===ne.message&&N.severity===ne.severity&&N.code===ne.code&&N.severity===ne.severity&&N.source===ne.source&&N.range.isEqual(ne.range)&&(0,v.$yb)(N.tags,ne.tags)&&(0,v.$yb)(N.relatedInformation,ne.relatedInformation,Fe.isEqual)}};e.$rO=Be,e.$rO=Be=Ke([p],Be);let xe=class{constructor(N,ne){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ne}};e.$sO=xe,e.$sO=xe=Ke([p],xe);let nt=class extends xe{constructor(N,ne,Se,He){super(N,ne),this.canIncreaseVerbosity=Se,this.canDecreaseVerbosity=He}};e.$tO=nt,e.$tO=nt=Ke([p],nt);var ht;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})(ht||(e.HoverVerbosityAction=ht={}));var $t;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})($t||(e.DocumentHighlightKind=$t={}));let ut=class{constructor(N,ne=$t.Text){this.range=N,this.kind=ne}toJSON(){return{range:this.range,kind:$t[this.kind]}}};e.$uO=ut,e.$uO=ut=Ke([p],ut);let et=class{constructor(N,ne){this.uri=N,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.$vO=et,e.$vO=et=Ke([p],et);var Le;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Le||(e.SymbolKind=Le={}));var Ne;(function(z){z[z.Deprecated=1]="Deprecated"})(Ne||(e.SymbolTag=Ne={}));let Me=l=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ne,Se,He,rt){this.name=N,this.kind=ne,this.containerName=rt,typeof Se=="string"&&(this.containerName=Se),He instanceof Pe?this.location=He:Se instanceof G&&(this.location=new Pe(He,Se)),l.validate(this)}toJSON(){return{name:this.name,kind:Le[this.kind],location:this.location,containerName:this.containerName}}};e.$wO=Me,e.$wO=Me=l=Ke([p],Me);let W=g=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(g.validate)}constructor(N,ne,Se,He,rt){this.name=N,this.detail=ne,this.kind=Se,this.range=He,this.selectionRange=rt,this.children=[],g.validate(this)}};e.$xO=W,e.$xO=W=g=Ke([p],W);var B;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Q=class{constructor(N,ne){this.title=N,this.kind=ne}};e.$yO=Q,e.$yO=Q=Ke([p],Q);let K=class{static{f=this}static{this.c="."}constructor(N){this.value=N}append(N){return new f(this.value?this.value+f.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+f.c)}};e.$zO=K,e.$zO=K=f=Ke([p],K),K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorMove=K.Refactor.append("move"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll"),K.Notebook=K.Empty.append("notebook");let se=class{constructor(N,ne){if(this.range=N,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$AO=se,e.$AO=se=Ke([p],se);class ge{constructor(N,ne,Se,He,rt,pt){this.kind=N,this.name=ne,this.detail=Se,this.uri=He,this.range=rt,this.selectionRange=pt}}e.$BO=ge;class Ee{constructor(N,ne){this.fromRanges=ne,this.from=N}}e.$CO=Ee;class ze{constructor(N,ne){this.fromRanges=ne,this.to=N}}e.$DO=ze;var Je;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Je||(e.LanguageStatusSeverity=Je={}));let _e=class{constructor(N,ne){this.range=N,this.command=ne}get isResolved(){return!!this.command}};e.$EO=_e,e.$EO=_e=Ke([p],_e);let tt=d=class{#e;static isMarkdownString(N){return N instanceof d?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ne=!1){this.#e=new P.$9k(N,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,ne){return this.#e.appendCodeblock(ne??"",N),this}};e.$FO=tt,e.$FO=tt=d=Ke([p],tt);let ct=class{constructor(N,ne){this.label=N,this.documentation=ne}};e.$GO=ct,e.$GO=ct=Ke([p],ct);let it=class{constructor(N,ne){this.label=N,this.documentation=ne,this.parameters=[]}};e.$HO=it,e.$HO=it=Ke([p],it);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$IO=at,e.$IO=at=Ke([p],at);var yt;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(yt||(e.SignatureHelpTriggerKind=yt={}));var Ze;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Ze||(e.InlayHintKind=Ze={}));let he=class{constructor(N){this.value=N}};e.$JO=he,e.$JO=he=Ke([p],he);let pe=class{constructor(N,ne,Se){this.position=N,this.label=ne,this.kind=Se}};e.$KO=pe,e.$KO=pe=Ke([p],pe);var ye;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye||(e.CompletionTriggerKind=ye={}));var Ce;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ce||(e.CompletionItemKind=Ce={}));var fe;(function(z){z[z.Deprecated=1]="Deprecated"})(fe||(e.CompletionItemTag=fe={}));let ve=class{constructor(N,ne){this.label=N,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$LO=ve,e.$LO=ve=Ke([p],ve);let Z=class{constructor(N=[],ne=!1){this.items=N,this.isIncomplete=ne}};e.$MO=Z,e.$MO=Z=Ke([p],Z);let q=class{constructor(N,ne,Se){this.insertText=N,this.range=ne,this.command=Se}};e.$NO=q,e.$NO=q=Ke([p],q);let de=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$OO=de,e.$OO=de=Ke([p],de);var je;(function(z){z[z.Unknown=0]="Unknown",z[z.Word=1]="Word",z[z.Line=2]="Line",z[z.Suggest=3]="Suggest"})(je||(e.PartialAcceptTriggerKind=je={}));var Qe;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Qe||(e.ViewColumn=Qe={}));var st;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function dt(z,N){return`${w.$xn.toKey(z)}.${N}`}var mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(mt||(e.TextEditorLineNumbersStyle=mt={}));var Ot;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ot||(e.TextDocumentSaveReason=Ot={}));var Tt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Tt||(e.TextEditorRevealType=Tt={}));var Qt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var _t;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Xe;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Xe||(e.DecorationRangeBehavior=Xe={})),function(z){function N(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=N}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var At;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(At||(e.SyntaxTokenType=At={})),function(z){function N(ne){switch(ne){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=N}(At||(e.SyntaxTokenType=At={}));let Ut=class{constructor(N,ne){if(ne&&!s.URI.isUri(ne))throw(0,D.$$)("target");if(!G.isRange(N)||N.isEmpty)throw(0,D.$$)("range");this.range=N,this.target=ne}};e.$QO=Ut,e.$QO=Ut=Ke([p],Ut);let wt=class{constructor(N,ne,Se,He){this.red=N,this.green=ne,this.blue=Se,this.alpha=He}};e.$RO=wt,e.$RO=wt=Ke([p],wt);let Dt=class{constructor(N,ne){if(ne&&!(ne instanceof wt))throw(0,D.$$)("color");if(!G.isRange(N)||N.isEmpty)throw(0,D.$$)("range");this.range=N,this.color=ne}};e.$SO=Dt,e.$SO=Dt=Ke([p],Dt);let ei=class{constructor(N){if(!N||typeof N!="string")throw(0,D.$$)("label");this.label=N}};e.$TO=ei,e.$TO=ei=Ke([p],ei);var ti;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var Kt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var bt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(bt||(e.TerminalExitReason=bt={}));var Lt;(function(z){z[z.Low=0]="Low",z[z.Medium=1]="Medium",z[z.High=2]="High"})(Lt||(e.TerminalShellExecutionCommandLineConfidence=Lt={}));class ci{constructor(N,ne,Se){if(this.startIndex=N,this.length=ne,this.tooltip=Se,typeof N!="number"||N<0)throw(0,D.$$)("startIndex");if(typeof ne!="number"||ne<1)throw(0,D.$$)("length");if(Se!==void 0&&typeof Se!="string")throw(0,D.$$)("tooltip")}}e.$UO=ci;class Zt{constructor(N){this.uri=N}}e.$VO=Zt;class Ge{constructor(N){this.terminalCommand=N}}e.$WO=Ge;var ii;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(ii||(e.TerminalLocation=ii={}));class li{constructor(N){if(this.options=N,typeof N!="object")throw(0,D.$$)("options")}}e.$XO=li;var hi;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(hi||(e.TaskRevealKind=hi={}));var kt;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let jt=class{static{S=this}static{this.Clean=new S("clean","Clean")}static{this.Build=new S("build","Build")}static{this.Rebuild=new S("rebuild","Rebuild")}static{this.Test=new S("test","Test")}static from(N){switch(N){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(N,ne){if(this.label=ne,typeof N!="string"||typeof ne!="string")throw(0,D.$$)("name");this.c=N}get id(){return this.c}};e.$YO=jt,e.$YO=jt=S=Ke([p],jt);function Mt(z){let N="";for(let ne=0;ne<z.length;ne++)N+=z[ne].replace(/,/g,",,")+",";return N}let Bt=class{constructor(N,ne,Se){if(typeof N!="string")throw(0,D.$$)("process");this.e=[],this.c=N,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,D.$$)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)N.push(ne);return Mt(N)}};e.$ZO=Bt,e.$ZO=Bt=Ke([p],Bt);let ai=class{constructor(N,ne,Se){if(this.f=[],Array.isArray(ne)){if(!N)throw(0,D.$$)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,D.$$)("command");this.e=N,this.f=ne,this.g=Se}else{if(typeof N!="string")throw(0,D.$$)("commandLine");this.c=N,this.g=ne}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,D.$$)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,D.$$)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)N.push(typeof ne=="string"?ne:ne.value);return Mt(N)}};e.$1O=ai,e.$1O=ai=Ke([p],ai);var ni;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var ri;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ri||(e.TaskScope=ri={}));class Gt{constructor(N){this.c=N}computeId(){return"customExecution"+(0,I.$7g)()}set callback(N){this.c=N}get callback(){return this.c}}e.$2O=Gt;let Jt=class{static{E=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,ne,Se,He,rt,pt){this.k=!1,this.l=this.definition=N;let St;typeof ne=="string"?(this.o=this.name=ne,this.w=this.source=Se,this.execution=He,St=rt,this.k=!0):ne===ri.Global||ne===ri.Workspace?(this.target=ne,this.o=this.name=Se,this.w=this.source=He,this.execution=rt,St=pt):(this.target=ne,this.o=this.name=Se,this.w=this.source=He,this.execution=rt,St=pt),typeof St=="string"?(this.r=[St],this.t=!0):Array.isArray(St)?(this.r=St,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(N){this.j=N}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:E.e,id:this.q.computeId()}:this.q instanceof ai?this.l={type:E.f,id:this.q.computeId()}:this.q instanceof Gt?this.l={type:E.c,id:this.q.computeId()}:this.l={type:E.g,id:(0,I.$7g)()}}get definition(){return this.l}set definition(N){if(N==null)throw(0,D.$$)("Kind can't be undefined or null");this.B(),this.l=N}get scope(){return this.m}set target(N){this.B(),this.m=N}get name(){return this.o}set name(N){if(typeof N!="string")throw(0,D.$$)("name");this.B(),this.o=N}get execution(){return this.q}set execution(N){N===null&&(N=void 0),this.B(),this.q=N;const ne=this.l.type;(E.g===ne||E.e===ne||E.f===ne||E.c===ne)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(N){if(Array.isArray(N))this.B(),this.r=N,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.B(),this.u=N}get source(){return this.w}set source(N){if(typeof N!="string"||N.length===0)throw(0,D.$$)("source must be a string of length > 0");this.B(),this.w=N}get group(){return this.x}set group(N){N===null&&(N=void 0),this.B(),this.x=N}get detail(){return this.A}set detail(N){N===null&&(N=void 0),this.A=N}get presentationOptions(){return this.y}set presentationOptions(N){N==null&&(N=Object.create(null)),this.B(),this.y=N}get runOptions(){return this.z}set runOptions(N){N==null&&(N=Object.create(null)),this.B(),this.z=N}};e.$3O=Jt,e.$3O=Jt=E=Ke([p],Jt);var ui;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(ui||(e.ProgressLocation=ui={}));var Nt;(function(z){function N(ne){const Se=ne;return(0,m.$ng)(Se.value)?Se.tooltip&&!(0,m.$jg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}z.isViewBadge=N})(Nt||(e.ViewBadge=Nt={}));let Ct=y=class{static isTreeItem(N,ne){const Se=N;if(Se.checkboxState!==void 0){const He=(0,m.$ng)(Se.checkboxState)?Se.checkboxState:(0,m.$lg)(Se.checkboxState)&&(0,m.$ng)(Se.checkboxState.state)?Se.checkboxState.state:void 0,rt=!(0,m.$ng)(Se.checkboxState)&&(0,m.$lg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==Xt.Checked&&He!==Xt.Unchecked||rt!==void 0&&!(0,m.$jg)(rt))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(N instanceof y)return!0;if(Se.label!==void 0&&!(0,m.$jg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,m.$jg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,m.$jg)(Se.iconPath)&&!s.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,m.$jg)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,m.$jg)(He.light)&&!s.URI.isUri(He.light)&&!(0,m.$jg)(He.dark)&&!s.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,m.$jg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!s.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,m.$jg)(Se.tooltip)&&!(Se.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<vt.None&&Se.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,m.$jg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(N,ne=vt.None){this.collapsibleState=ne,s.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$4O=Ct,e.$4O=Ct=y=Ke([p],Ct);var vt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Xt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(Xt||(e.TreeItemCheckboxState=Xt={}));let Et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$5O=Et,e.$5O=Et=Ke([p],Et);class si extends Et{}e.$6O=si;class Yt extends si{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$7O=Yt;class Ni{constructor(N,ne,Se,He){this.name=N,this.uri=ne,this._itemId=Se,this.c=He}data(){return this.c()}}e.$8O=Ni;let di=class{#e=new Map;constructor(N){for(const[ne,Se]of N??[]){const He=this.#e.get(this.#t(ne));He?He.push(Se):this.#e.set(this.#t(ne),[Se])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,ne){this.#e.set(this.#t(N),[ne])}forEach(N,ne){for(const[Se,He]of this.#e)for(const rt of He)N.call(ne,rt,Se,this)}*[Symbol.iterator](){for(const[N,ne]of this.#e)for(const Se of ne)yield[N,Se]}#t(N){return N.toLowerCase()}};e.$9O=di,e.$9O=di=Ke([p],di);let yi=class{constructor(N,ne,Se){this.insertText=N,this.title=ne,this.kind=Se}};e.$0O=yi,e.$0O=yi=Ke([p],yi);var qt;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(qt||(e.DocumentPasteTriggerKind=qt={}));class fi{static{this.c="."}constructor(N){this.value=N}append(...N){return new fi((this.value?[this.value,...N]:N).join(fi.c))}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+fi.c)}}e.$$O=fi,fi.Empty=new fi("");class Fi{constructor(N,ne,Se){this.title=ne,this.insertText=N,this.kind=Se}}e.$_O=Fi;let Rt=class{constructor(N,ne){this.id=N,this.color=ne}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$aP=Rt,e.$aP=Rt=Ke([p],Rt),Rt.File=new Rt("file"),Rt.Folder=new Rt("folder");let Si=class{constructor(N){this.id=N}};e.$bP=Si,e.$bP=Si=Ke([p],Si);var Ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ai||(e.ConfigurationTarget=Ai={}));let gi=class{get base(){return this.c}set base(N){this.c=N,this.e=s.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ne){if(typeof N!="string"&&(!N||!s.URI.isUri(N)&&!s.URI.isUri(N.uri)))throw(0,D.$$)("base");if(typeof ne!="string")throw(0,D.$$)("pattern");typeof N=="string"?this.baseUri=s.URI.file(N):s.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$cP=gi,e.$cP=gi=Ke([p],gi);const zi=new WeakMap;function ji(z,N){zi.set(z,N)}let zt=class{constructor(N,ne,Se,He,rt){this.enabled=typeof N=="boolean"?N:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=zi.get(this)??(0,I.$7g)()),this.c}};e.$eP=zt,e.$eP=zt=Ke([p],zt);let Pi=class extends zt{constructor(N,ne,Se,He,rt,pt){if(super(ne,Se,He,rt,pt),N===null)throw(0,D.$$)("location");this.location=N}};e.$fP=Pi,e.$fP=Pi=Ke([p],Pi);let Di=class extends zt{constructor(N,ne,Se,He,rt,pt){super(ne,Se,He,rt,pt),this.functionName=N}};e.$gP=Di,e.$gP=Di=Ke([p],Di);let wi=class extends zt{constructor(N,ne,Se,He,rt,pt,St,xt){if(super(He,rt,pt,St,xt),!ne)throw(0,D.$$)("dataId");this.label=N,this.dataId=ne,this.canPersist=Se}};e.$hP=wi,e.$hP=wi=Ke([p],wi);let bi=class{constructor(N,ne,Se){this.command=N,this.args=ne||[],this.options=Se}};e.$iP=bi,e.$iP=bi=Ke([p],bi);let me=class{constructor(N,ne){this.port=N,this.host=ne}};e.$jP=me,e.$jP=me=Ke([p],me);let De=class{constructor(N){this.path=N}};e.$kP=De,e.$kP=De=Ke([p],De);let ce=class{constructor(N){this.implementation=N}};e.$lP=ce,e.$lP=ce=Ke([p],ce);class H{constructor(N,ne,Se){this.session=N,this.threadId=ne,this.frameId=Se}}e.$mP=H;class ke{constructor(N,ne){this.session=N,this.threadId=ne}}e.$nP=ke;let We=class{constructor(N,ne){this.range=N,this.expression=ne}};e.$oP=We,e.$oP=We=Ke([p],We);var Ye;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Ye||(e.InlineCompletionTriggerKind=Ye={}));let Ue=class{constructor(N,ne){this.range=N,this.text=ne}};e.$pP=Ue,e.$pP=Ue=Ke([p],Ue);let ot=class{constructor(N,ne,Se=!0){this.range=N,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$qP=ot,e.$qP=ot=Ke([p],ot);let gt=class{constructor(N,ne){this.range=N,this.expression=ne}};e.$rP=gt,e.$rP=gt=Ke([p],gt);let Ht=class{constructor(N,ne){this.frameId=N,this.stoppedLocation=ne}};e.$sP=Ht,e.$sP=Ht=Ke([p],Ht);var Vt;(function(z){z[z.AIGenerated=1]="AIGenerated"})(Vt||(e.NewSymbolNameTag=Vt={}));var Wt;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Wt||(e.NewSymbolNameTriggerKind=Wt={}));class Li{constructor(N,ne){this.newSymbolName=N,this.tags=ne}}e.$tP=Li;var en;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(en||(e.FileChangeType=en={}));let Vi=C=class extends Error{static FileExists(N){return new C(N,u.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(N){return new C(N,u.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(N){return new C(N,u.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(N){return new C(N,u.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(N){return new C(N,u.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(N){return new C(N,u.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(N,ne=u.FileSystemProviderErrorCode.Unknown,Se){super(s.URI.isUri(N)?N.toString(!0):N),this.code=Se?.name??"Unknown",(0,u.$ul)(this,ne),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$uP=Vi,e.$uP=Vi=C=Ke([p],Vi);let Ei=class{constructor(N,ne,Se){this.start=N,this.end=ne,this.kind=Se}};e.$vP=Ei,e.$vP=Ei=Ke([p],Ei);var tn;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(tn||(e.FoldingRangeKind=tn={}));var nn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(nn||(e.CommentThreadCollapsibleState=nn={}));var Ui;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var rn;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(rn||(e.CommentState=rn={}));var Bi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Bi||(e.CommentThreadState=Bi={}));var Qi;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));var sn;(function(z){z[z.Reply=1]="Reply",z[z.Comment=2]="Comment"})(sn||(e.CommentThreadFocus=sn={}));class on{constructor(N,ne=[]){this.tokenTypes=N,this.tokenModifiers=ne}}e.$wP=on;function wn(z){return typeof z>"u"||(0,m.$kg)(z)}class Ci{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,N){this.m=!0;for(let ne=0,Se=N.tokenTypes.length;ne<Se;ne++)this.k.set(N.tokenTypes[ne],ne);for(let ne=0,Se=N.tokenModifiers.length;ne<Se;ne++)this.l.set(N.tokenModifiers[ne],ne)}}push(N,ne,Se,He,rt){if(typeof N=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(N,ne,Se,He,rt);if(G.isRange(N)&&typeof ne=="string"&&wn(Se))return this.o(N,ne,Se);throw(0,D.$$)()}o(N,ne,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ne))throw new Error("`tokenType` is not in the provided legend");const He=N.start.line,rt=N.start.character,pt=N.end.character-N.start.character,St=this.k.get(ne);let xt=0;if(Se)for(const $i of Se){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const vi=this.l.get($i);xt|=1<<vi>>>0}this.q(He,rt,pt,St,xt)}q(N,ne,Se,He,rt){if(this.f&&(N<this.c||N===this.c&&ne<this.e)){this.f=!1;const xt=this.g.length/5|0;let $i=0,vi=0;for(let Ii=0;Ii<xt;Ii++){let Ti=this.g[5*Ii],xi=this.g[5*Ii+1];Ti===0?(Ti=$i,xi+=vi):Ti+=$i,this.g[5*Ii]=Ti,this.g[5*Ii+1]=xi,$i=Ti,vi=xi}}let pt=N,St=ne;this.f&&this.j>0&&(pt-=this.c,pt===0&&(St-=this.e)),this.g[this.j++]=pt,this.g[this.j++]=St,this.g[this.j++]=Se,this.g[this.j++]=He,this.g[this.j++]=rt,this.c=N,this.e=ne}static r(N){const ne=[],Se=N.length/5|0;for(let St=0;St<Se;St++)ne[St]=St;ne.sort((St,xt)=>{const $i=N[5*St],vi=N[5*xt];if($i===vi){const Ii=N[5*St+1],Ti=N[5*xt+1];return Ii-Ti}return $i-vi});const He=new Uint32Array(N.length);let rt=0,pt=0;for(let St=0;St<Se;St++){const xt=5*ne[St],$i=N[xt+0],vi=N[xt+1],Ii=N[xt+2],Ti=N[xt+3],xi=N[xt+4],Qn=$i-rt,Nr=Qn===0?vi-pt:vi,_i=5*St;He[_i+0]=Qn,He[_i+1]=Nr,He[_i+2]=Ii,He[_i+3]=Ti,He[_i+4]=xi,rt=$i,pt=vi}return He}build(N){return this.f?new Hi(new Uint32Array(this.g),N):new Hi(Ci.r(this.g),N)}}e.$xP=Ci;class Hi{constructor(N,ne){this.resultId=ne,this.data=N}}e.$yP=Hi;class bn{constructor(N,ne,Se){this.start=N,this.deleteCount=ne,this.data=Se}}e.$zP=bn;class vn{constructor(N,ne){this.resultId=ne,this.edits=N}}e.$AP=vn;var Wi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Wi||(e.DebugConsoleMode=Wi={}));class an{constructor(N){this.name=N}}e.$BP=an;var Ae;(function(z){z[z.Title=1]="Title",z[z.Inline=2]="Inline"})(Ae||(e.QuickInputButtonLocation=Ae={}));let mi=class{static{this.Back={iconPath:new Rt("arrow-left")}}constructor(){}};e.$CP=mi,e.$CP=mi=Ke([p],mi);var Ki;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Ki||(e.QuickPickItemKind=Ki={}));var lt;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(lt||(e.InputBoxValidationSeverity=lt={}));var It;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(It||(e.ExtensionKind=It={}));class yn{static validate(N){if(typeof N.badge=="string"){let ne=(0,T.$Uf)(N.badge,0);if(ne<N.badge.length&&(ne+=(0,T.$Uf)(N.badge,ne)),N.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Rt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ne,Se){this.badge=N,this.tooltip=ne,this.color=Se}}e.$DP=yn;let Gi=class{constructor(N){this.kind=N}};e.$EP=Gi,e.$EP=Gi=Ke([p],Gi);var Ji;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ji||(e.ColorThemeKind=Ji={}));class ki{static isNotebookRange(N){return N instanceof ki?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ne){if(N<0)throw(0,D.$$)("start must be positive");if(ne<0)throw(0,D.$$)("end must be positive");N<=ne?(this.c=N,this.e=ne):(this.c=ne,this.e=N)}with(N){let ne=this.c,Se=this.e;return N.start!==void 0&&(ne=N.start),N.end!==void 0&&(Se=N.end),ne===this.c&&Se===this.e?this:new ki(ne,Se)}}e.$FP=ki;class Ri{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ne=>Ri.isNotebookCellData(ne))}static isNotebookCellData(N){return!0}constructor(N,ne,Se,He,rt,pt,St){this.kind=N,this.value=ne,this.languageId=Se,this.mime=He,this.outputs=rt??[],this.metadata=pt,this.executionSummary=St,Ri.validate(this)}}e.$GP=Ri;class Sn{constructor(N){this.cells=N}}e.$HP=Sn;class pi{static isNotebookCellOutputItem(N){return N instanceof pi?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ne={name:N.name,message:N.message,stack:N.stack};return pi.json(ne,"application/vnd.code.notebook.error")}static stdout(N){return pi.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return pi.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ne="application/octet-stream"){return new pi(N,ne)}static#e=new TextEncoder;static text(N,ne=R.$gt.text){const Se=pi.#e.encode(String(N));return new pi(Se,ne)}static json(N,ne="text/x-json"){const Se=JSON.stringify(N,void 0,"	");return pi.text(Se,ne)}constructor(N,ne){this.data=N,this.mime=ne;const Se=(0,R.$kt)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$IP=pi;class qi{static isNotebookCellOutput(N){return N instanceof qi?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ne=!1){const Se=new Set,He=new Set;for(let rt=0;rt<N.length;rt++){const pt=N[rt],St=(0,R.$kt)(pt.mime);if(!Se.has(St)||(0,$.$aM)(St)){Se.add(St);continue}He.add(rt),ne&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return He.size===0?N:N.filter((rt,pt)=>!He.has(pt))}constructor(N,ne,Se){this.items=qi.ensureUniqueMimeTypes(N,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,I.$7g)(),this.metadata=ne??Se)}}e.$JP=qi;var Xi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Xi||(e.NotebookCellKind=Xi={}));var cn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(cn||(e.NotebookCellExecutionState=cn={}));var ln;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ln||(e.NotebookCellStatusBarAlignment=ln={}));var un;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(un||(e.NotebookEditorRevealType=un={}));class En{constructor(N,ne){this.text=N,this.alignment=ne}}e.$KP=En;var hn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(hn||(e.NotebookControllerAffinity=hn={}));var dn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(dn||(e.NotebookControllerAffinity2=dn={}));class kn{constructor(N,ne=[]){this.uri=N,this.provides=(0,v.$6b)(ne)}}e.$LP=kn;class In{constructor(N){this.label=N}}e.$MP=In;var fn;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(fn||(e.NotebookVariablesRequestKind=fn={}));let Zi=class{constructor(N,ne){this.label=N,this.timestamp=ne}};e.$NP=Zi,e.$NP=Zi=Ke([p],Zi);var gn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(gn||(e.ExtensionMode=gn={}));var te;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(te||(e.ExtensionRuntime=te={}));var le;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(le||(e.StandardTokenType=le={}));class Te{constructor(N,ne){this.ranges=N,this.wordPattern=ne}}e.$OP=Te;class ft{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$PP=ft;var Pt;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Pt||(e.TestResultState=Pt={}));var Ft;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(Ft||(e.TestRunProfileKind=Ft={}));let Oi=class{constructor(N=void 0,ne=void 0,Se=void 0,He=!1,rt=!0){this.include=N,this.exclude=ne,this.profile=Se,this.continuous=He,this.preserveFocus=rt}};e.$QP=Oi,e.$QP=Oi=Ke([p],Oi);let Yi=O=class{static diff(N,ne,Se){const He=new O(N);return He.expectedOutput=ne,He.actualOutput=Se,He}constructor(N){this.message=N}};e.$RP=Yi,e.$RP=Yi=O=Ke([p],Yi);let Pn=class{constructor(N){this.id=N}};e.$SP=Pn,e.$SP=Pn=Ke([p],Pn);class Gn{constructor(N,ne,Se){this.label=N,this.uri=ne,this.position=Se}}e.$TP=Gn;class mn{constructor(N,ne){this.covered=N,this.total=ne,Cn(this)}}e.$UP=mn;function Cn(z){if(z){if(z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`);if(z.total<0)throw new Error(`The number of covered items (${z.total}) cannot be negative`)}}class Dn{static fromDetails(N,ne){const Se=new mn(0,0),He=new mn(0,0),rt=new mn(0,0);for(const St of ne)if("branches"in St){Se.total+=1,Se.covered+=St.executed?1:0;for(const xt of St.branches)He.total+=1,He.covered+=xt.executed?1:0}else rt.total+=1,rt.covered+=St.executed?1:0;const pt=new Dn(N,Se,He.total>0?He:void 0,rt.total>0?rt:void 0);return pt.detailedCoverage=ne,pt}constructor(N,ne,Se,He,rt=[]){this.uri=N,this.statementCoverage=ne,this.branchCoverage=Se,this.declarationCoverage=He,this.fromTests=rt}}e.$WP=Dn;class Jn{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ne,Se=[]){this.executed=N,this.location=ne,this.branches=Se}}e.$XP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ne,Se){this.executed=N,this.location=ne,this.label=Se}}e.$YP=Xn;class Zn{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ne,Se){this.name=N,this.executed=ne,this.location=Se}}e.$ZP=Zn;var Rn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Rn||(e.ExternalUriOpenerPriority=Rn={}));var On;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(On||(e.WorkspaceTrustState=On={}));var Tn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tn||(e.PortAutoForwardAction=Tn={}));class Yn{constructor(N,ne,Se,He,rt,pt){this.kind=N,this.name=ne,this.detail=Se,this.uri=He,this.range=rt,this.selectionRange=pt}}e.$1P=Yn;class xn{constructor(N){this.uri=N}}e.$2P=xn;class _n{constructor(N,ne){this.original=N,this.modified=ne}}e.$3P=_n;class er{constructor(N,ne,Se,He){this.base=N,this.input1=ne,this.input2=Se,this.result=He}}e.$4P=er;class tr{constructor(N,ne){this.uri=N,this.viewType=ne}}e.$5P=tr;class ir{constructor(N){this.viewType=N}}e.$6P=ir;class nr{constructor(N,ne){this.uri=N,this.notebookType=ne}}e.$7P=nr;class rr{constructor(N,ne,Se){this.original=N,this.modified=ne,this.notebookType=Se}}e.$8P=rr;class sr{constructor(){}}e.$9P=sr;class or{constructor(N,ne){this.uri=N,this.inputBoxUri=ne}}e.$0P=or;class ar{constructor(){}}e.$$P=ar;class cr{constructor(N){this.textDiffs=N}}e.$_P=cr;var An;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(An||(e.InteractiveSessionVoteDirection=An={}));var Ln;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Ln||(e.ChatCopyKind=Ln={}));var Mn;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(Mn||(e.ChatVariableLevel=Mn={}));class lr{constructor(N,ne,Se){this.id=N,this.label=ne,this.values=Se}}e.$aQ=lr;var Nn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(Nn||(e.InteractiveEditorResponseFeedbackKind=Nn={}));var Fn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(Fn||(e.ChatResultFeedbackKind=Fn={}));class ur{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new tt(N):N}}e.$bQ=ur;class hr{constructor(N,ne){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new tt(N):N,this.vulnerabilities=ne}}e.$cQ=hr;class dr{constructor(N,ne){this.participant=N,this.command=ne}}e.$dQ=dr;class fr{constructor(N,ne,Se,He){this.title=N,this.message=ne,this.data=Se,this.buttons=He}}e.$eQ=fr;class gr{constructor(N,ne){this.value=N,this.baseUri=ne}}e.$fQ=gr;class mr{constructor(N,ne){this.value=N,this.title=ne}}e.$gQ=mr;class pr{constructor(N){this.value=N}}e.$hQ=pr;class $r{constructor(N,ne){this.value=N,this.task=ne}}e.$iQ=$r;class wr{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new tt(N):N}}e.$jQ=wr;class br{constructor(N){this.value=N}}e.$kQ=br;class vr{constructor(N,ne,Se){this.value=N,this.iconPath=ne,this.options=Se}}e.$lQ=vr;class yr{constructor(N,ne,Se){this.value=N,this.license=ne,this.snippet=Se}}e.$mQ=yr;class Sr{constructor(N,ne){this.uri=N,this.range=ne}}e.$nQ=Sr;class Er{constructor(N,ne){this.uri=N,this.edits=Array.isArray(ne)?ne:[ne]}}e.$oQ=Er;class kr{constructor(N,ne,Se,He){this.prompt=N,this.command=ne,this.references=Se,this.participant=He}}e.$pQ=kr;class Ir{constructor(N,ne,Se,He){this.response=N,this.result=ne,this.participant=Se,this.command=He}}e.$qQ=Ir;var zn;(function(z){z[z.Panel=1]="Panel",z[z.Terminal=2]="Terminal",z[z.Notebook=3]="Notebook",z[z.Editor=4]="Editor"})(zn||(e.ChatLocation=zn={}));var Un;(function(z){z[z.Complete=1]="Complete",z[z.Partial=2]="Partial",z[z.Omitted=3]="Omitted"})(Un||(e.ChatResponseReferencePartStatusKind=Un={}));class Pr{constructor(N,ne,Se){this.document=N,this.selection=ne,this.wholeRange=Se}}e.$rQ=Pr;class Dr{constructor(N){this.cell=N}}e.$sQ=Dr;var pn;(function(z){z[z.User=1]="User",z[z.Assistant=2]="Assistant",z[z.System=3]="System"})(pn||(e.LanguageModelChatMessageRole=pn={}));class Cr{constructor(N,ne,Se){this.toolCallId=N,this.content=ne,this.isError=Se??!1}}e.$tQ=Cr;class $n{static User(N,ne){const Se=new $n(pn.User,typeof N=="string"?N:"",ne);return Se.content2=[N],Se}static Assistant(N,ne){return new $n(pn.Assistant,N,ne)}constructor(N,ne,Se){this.role=N,this.content=ne,this.content2=[ne],this.name=Se}}e.$uQ=$n;class Rr{constructor(N,ne,Se){this.name=N,this.toolCallId=ne,this.parameters=Se}}e.$vQ=Rr;class Or{constructor(N){this.value=N}}e.$wQ=Or;class Tr{constructor(N){this.content=N}}e.$xQ=Tr;class Ar{constructor(N,ne){this.content=N,this.name=ne}}e.$yQ=Ar;class Lr{constructor(N,ne){this.content=N,this.name=ne}}e.$zQ=Lr;class Mi extends Error{static NotFound(N){return new Mi(N,Mi.NotFound.name)}static NoPermissions(N){return new Mi(N,Mi.NoPermissions.name)}static Blocked(N){return new Mi(N,Mi.Blocked.name)}constructor(N,ne,Se){super(N,{cause:Se}),this.name="LanguageModelError",this.code=ne??""}}e.$AQ=Mi;var jn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(jn||(e.RelatedInformationType=jn={}));var Bn;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped",z[z.Error=5]="Error"})(Bn||(e.SpeechToTextStatus=Bn={}));var Wn;(function(z){z[z.Started=1]="Started",z[z.Stopped=2]="Stopped",z[z.Error=3]="Error"})(Wn||(e.TextToSpeechStatus=Wn={}));var qn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(qn||(e.KeywordRecognitionStatus=qn={}));class Mr{constructor(N,ne){this.text=N,this.range=ne}}e.$BQ=Mr;var Vn;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Vn||(e.InlineEditTriggerKind=Vn={}))}),define(Re[227],Oe([1,0,5,7]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wqc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$_N.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,T,m){if(this.a.size===0)throw new Error("No related information providers registered");const s=this.a.get(R);if(!s)throw new Error("related information provider not found");return await s.provideRelatedInformation(T,m)??[]}getRelatedInformation(R,T,m){return this.c.$getAiRelatedInformation(T,m)}registerRelatedInformationProvider(R,T,m){const s=this.b;return this.b++,this.a.set(s,m),this.c.$registerAiRelatedInformationProvider(s,T),new D.$bO(()=>{this.c.$unregisterAiRelatedInformationProvider(s),this.a.delete(s)})}}e.$Wqc=P}),define(Re[91],Oe([1,0,6,5,7,18,119,3,16]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9qc=e.$8qc=void 0,e.$8qc=(0,T.$Ki)("IExtHostAuthentication");let s=class{constructor(u){this.b=new Map,this.c=new v.$qe,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=u.getProxy(D.$_N.MainThreadAuthentication)}async getSession(u,k,$,r={}){const a=L.$xn.toKey(u.identifier),h=[...$].sort().join(" ");return await this.d.getOrCreate(`${a} ${k} ${h}`,async()=>{await this.a.$ensureProvider(k);const c=u.displayName||u.name;return this.a.$getSession(k,$,a,c,r)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,k){const $=this.b.get(u);return $?$.provider.removeSession(k):this.a.$removeSession(u,k)}registerAuthenticationProvider(u,k,$,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:k,provider:$,options:r??{supportsMultipleAccounts:!1}});const a=$.onDidChangeSessions(h=>this.a.$sendDidChangeSessions(u,h));return this.a.$registerAuthenticationProvider(u,k,r?.supportsMultipleAccounts??!1),new P.$bO(()=>{a.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,k,$){const r=this.b.get(u);if(r)return await r.provider.createSession(k,$);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,k){const $=this.b.get(u);if($)return await $.provider.removeSession(k);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,k,$){const r=this.b.get(u);if(r)return await r.provider.getSessions(k,$);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,k){return u.startsWith(R.$cN)||this.c.fire({provider:{id:u,label:k}}),Promise.resolve()}};e.$9qc=s,e.$9qc=s=Ke([qe(0,m.$MQ)],s);class I{constructor(){this.a=new Map}getOrCreate(u,k){const $=this.a.get(u);if($)return $;const r=k().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Re[124],Oe([1,0,2,5,7,3,16,11,17,13,22,21]),function(we,e,v,D,P,L,R,T,m,s,I,w){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$bsc=e.$asc=void 0;let k=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,a){this.h=a,this.f=new Map,this.g=r.getProxy(D.$_N.MainThreadDecorations)}registerFileDecorationProvider(r,a){const h=u.c++;this.f.set(h,{provider:r,extensionDescription:a}),this.g.$registerDecorationProvider(h,a.identifier.value);const c=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(h,null);return}const n=(0,m.$6b)(i);if(n.length<=u.d){this.g.$onDidChange(h,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,n.length);const t=n.map(g=>({uri:g,rank:(0,s.$nf)(g.path,"/")})),o=(0,m.$Db)(t,(g,f)=>g.rank-f.rank||(0,s.$Df)(g.uri.path,f.uri.path)),l=[];e:for(const g of o){let f;for(const d of g){const S=(0,I.$rc)(d.uri.path);if(f!==S&&(f=S,l.push(d.uri)>=u.d))break e}}this.g.$onDidChange(h,l)});return new P.$bO(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(h),this.f.delete(h)})}async $provideDecorations(r,a,h){if(!this.f.has(r))return Object.create(null);const c=Object.create(null),{provider:i,extensionDescription:n}=this.f.get(r);return await Promise.all(a.map(async t=>{try{const{uri:o,id:l}=t,g=await Promise.resolve(i.provideFileDecoration(v.URI.revive(o),h));if(!g)return;try{P.$DP.validate(g),g.badge&&typeof g.badge!="string"&&(0,w.$BH)(n,"codiconDecoration"),c[l]=[g.propagate,g.tooltip,g.badge,g.color]}catch(f){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${f}`)}}catch(o){this.h.error(o)}})),c}};e.$asc=k,e.$asc=k=u=Ke([qe(0,R.$MQ),qe(1,T.$fk)],k),e.$bsc=(0,L.$Ki)("IExtHostDecorations")}),define(Re[228],Oe([1,0,12,2,7,5,15,19,13]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsc=void 0;class s{static{this.a=0}constructor(w,u,k){this.d=u,this.e=k,this.b=new Map,this.c=w.getProxy(L.$_N.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,u){if(Object.keys(R.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const k=s.a++;this.b.set(k,u),this.c.$registerTextContentProvider(k,w);let $;if(typeof u.onDidChange=="function"){let r;$=u.onDidChange(async a=>{if(a.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;r&&await r;const h=this.$provideTextDocumentContent(k,a).then(async c=>{if(!c&&typeof c!="string")return;const i=this.d.getDocument(a);if(!i)return;const n=(0,m.$xf)(c);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(a,c)}).catch(v.$4).finally(()=>{r===h&&(r=void 0)});r=h})}return new P.$bO(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(w,u){const k=this.b.get(w);return k?Promise.resolve(k.provideTextDocumentContent(D.URI.revive(u),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$dsc=s}),define(Re[125],Oe([1,0,61,15,13,284,170,7,17]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QQ=e.$PQ=void 0,e.$OQ=I;const s=new Map;function I($,r){r?s.set($,r):s.delete($)}function w($){return s.get($)}class u extends L.$yw{constructor(r,a,h,c,i,n,t){super(a,h,c,i),this.o=r,this.p=n,this.q=t,this.n=!1}dispose(){(0,v.ok)(!this.n),this.n=!0,this.q=!1}equalLines(r){return(0,m.$yb)(this.b,r)}get document(){if(!this.m){const r=this;this.m={get uri(){return r.a},get fileName(){return r.a.fsPath},get isUntitled(){return r.a.scheme===D.Schemas.untitled},get languageId(){return r.p},get version(){return r.d},get isClosed(){return r.n},get isDirty(){return r.q},save(){return r.r()},getText(a){return a?r.s(a):r.getText()},get eol(){return r.c===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return r.b.length},lineAt(a){return r.t(a)},offsetAt(a){return r.u(a)},positionAt(a){return r.v(a)},validateRange(a){return r.w(a)},validatePosition(a){return r.x(a)},getWordRangeAtPosition(a,h){return r.y(a,h)},[Symbol.for("debug.description")](){return`TextDocument(${r.a.toString()})`}}}return Object.freeze(this.m)}_acceptLanguageId(r){(0,v.ok)(!this.n),this.p=r}_acceptIsDirty(r){(0,v.ok)(!this.n),this.q=r}r(){return this.n?Promise.reject(new Error("Document has been closed")):this.o.$trySaveDocument(this.a)}s(r){const a=this.w(r);if(a.isEmpty)return"";if(a.isSingleLine)return this.b[a.start.line].substring(a.start.character,a.end.character);const h=this.c,c=a.start.line,i=a.end.line,n=[];n.push(this.b[c].substring(a.start.character));for(let t=c+1;t<i;t++)n.push(this.b[t]);return n.push(this.b[i].substring(0,a.end.character)),n.join(h)}t(r){let a;if(r instanceof T.$cO?a=r.line:typeof r=="number"&&(a=r),typeof a!="number"||a<0||a>=this.b.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new k(a,this.b[a],a===this.b.length-1)}u(r){return r=this.x(r),this.h(),this.f.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.h();const a=this.f.getIndexOf(r),h=this.b[a.index].length;return new T.$cO(a.index,Math.min(a.remainder,h))}w(r){if(!(r instanceof T.$dO))throw new Error("Invalid argument");const a=this.x(r.start),h=this.x(r.end);return a===r.start&&h===r.end?r:new T.$dO(a.line,a.character,h.line,h.character)}x(r){if(!(r instanceof T.$cO))throw new Error("Invalid argument");if(this.b.length===0)return r.with(0,0);let{line:a,character:h}=r,c=!1;if(a<0)a=0,h=0,c=!0;else if(a>=this.b.length)a=this.b.length-1,h=this.b[a].length,c=!0;else{const i=this.b[a].length;h<0?(h=0,c=!0):h>i&&(h=i,c=!0)}return c?new T.$cO(a,h):r}y(r,a){const h=this.x(r);if(!a)a=w(this.p);else if((0,P.$wf)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const c=(0,R.$yt)(h.character+1,(0,R.$wt)(a),this.b[h.line],0);if(c)return new T.$dO(h.line,c.startColumn-1,h.line,c.endColumn-1)}}e.$PQ=u;class k{constructor(r,a,h){this.a=r,this.b=a,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$dO(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$dO(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$QQ=k}),define(Re[229],Oe([1,0,5,7]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gsc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(v.$_N.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,T,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const s=this.a.get(R);if(!s)throw new Error("Embedding vector provider not found");const I=await s.provideEmbeddingVector(T,m);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(R,T,m){const s=this.b;return this.b++,this.a.set(s,m),this.c.$registerAiEmbeddingVectorProvider(T,s),new D.$bO(()=>{this.c.$unregisterAiEmbeddingVectorProvider(s),this.a.delete(s)})}}e.$gsc=P}),define(Re[68],Oe([1,0,5,28,7,20,3,16,50,4,10,24,15]),function(we,e,v,D,P,L,R,T,m,s,I,w,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=e.$lrc=void 0,D=Ve(D);let $=k=class{constructor(a,h){this.b=new Map,this.c=new I.$Th,this.a=a.getProxy(v.$_N.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(i){try{let n;const t=c.b.get(i.scheme);return t?(await c.a.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await c.a.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===D.FilePermission.Readonly?1:void 0}}catch(n){k.e(n)}},async readDirectory(i){try{const n=c.b.get(i.scheme);return n?(await c.a.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await c.a.$readdir(i)}catch(n){return k.e(n)}},async createDirectory(i){try{const n=c.b.get(i.scheme);return n&&!n.isReadonly?(await c.a.$ensureActivation(i.scheme),await c.d(n.impl,n.extUri,i)):await c.a.$mkdir(i)}catch(n){return k.e(n)}},async readFile(i){try{const n=c.b.get(i.scheme);return n?(await c.a.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await c.a.$readFile(i)).buffer}catch(n){return k.e(n)}},async writeFile(i,n){try{const t=c.b.get(i.scheme);return t&&!t.isReadonly?(await c.a.$ensureActivation(i.scheme),await c.d(t.impl,t.extUri,t.extUri.dirname(i)),await c.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await c.a.$writeFile(i,L.$Se.wrap(n))}catch(t){return k.e(t)}},async delete(i,n){try{const t=c.b.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await c.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await c.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return k.e(t)}},async rename(i,n,t){try{return await c.a.$rename(i,n,{overwrite:!1,...t})}catch(o){return k.e(o)}},async copy(i,n,t){try{return await c.a.$copy(i,n,{overwrite:!1,...t})}catch(o){return k.e(o)}},isWritableFileSystem(i){const n=h.getCapabilities(i);if(typeof n=="number")return!(n&D.FileSystemProviderCapabilities.Readonly)}})}async d(a,h,c){const i=[];for(;!h.isEqual(c,h.dirname(c));)try{if(!((await a.stat(c)).type&D.FileType.Directory))throw P.$uP.FileExists(`Unable to create folder '${c.scheme===u.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(D.$vl(n)!==D.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(h.basename(c)),c=h.dirname(c)}for(let n=i.length-1;n>=0;n--){c=h.joinPath(c,i[n]);try{await a.createDirectory(c)}catch(t){if(D.$vl(t)!==D.FileSystemProviderErrorCode.FileExists)throw t}}}static e(a){if(a instanceof P.$uP)throw a;if(a instanceof D.$rl)switch(a.code){case D.FileSystemProviderErrorCode.FileExists:throw P.$uP.FileExists(a.message);case D.FileSystemProviderErrorCode.FileNotFound:throw P.$uP.FileNotFound(a.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw P.$uP.FileNotADirectory(a.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw P.$uP.FileIsADirectory(a.message);case D.FileSystemProviderErrorCode.NoPermissions:throw P.$uP.NoPermissions(a.message);case D.FileSystemProviderErrorCode.Unavailable:throw P.$uP.Unavailable(a.message);default:throw new P.$uP(a.message,a.name)}if(!(a instanceof Error))throw new P.$uP(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw P.$uP.Unavailable(a.message);switch(a.name){case D.FileSystemProviderErrorCode.FileExists:throw P.$uP.FileExists(a.message);case D.FileSystemProviderErrorCode.FileNotFound:throw P.$uP.FileNotFound(a.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw P.$uP.FileNotADirectory(a.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw P.$uP.FileIsADirectory(a.message);case D.FileSystemProviderErrorCode.NoPermissions:throw P.$uP.NoPermissions(a.message);case D.FileSystemProviderErrorCode.Unavailable:throw P.$uP.Unavailable(a.message);default:throw new P.$uP(a.message,a.name)}}addFileSystemProvider(a,h,c){return this.b.set(a,{impl:h,extUri:c?.isCaseSensitive?w.$bh:w.$dh,isReadonly:!!c?.isReadonly}),(0,s.$Xc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??w.$bh}};e.$lrc=$,e.$lrc=$=k=Ke([qe(0,T.$MQ),qe(1,m.$2qc)],$),e.$mrc=(0,R.$Ki)("IExtHostConsumerFileSystem")}),define(Re[92],Oe([1,0,3,26,11,68,2]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$orc=e.$nrc=void 0,e.$nrc=(0,v.$Ki)("IExtensionStoragePaths");let T=class{constructor(s,I,w){this.d=I,this.f=w,this.a=s.workspace??void 0,this.b=s.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(s){return R.URI.joinPath(this.b.workspaceStorageHome,s)}async h(){if(!this.a)return Promise.resolve(void 0);const s=this.a.id,I=await this.g(s);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(R.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(s){if(this.c)return R.URI.joinPath(this.c,s.identifier.value)}globalValue(s){return R.URI.joinPath(this.b.globalStorageHome,s.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$orc=T,e.$orc=T=Ke([qe(0,D.$3Q),qe(1,P.$fk),qe(2,L.$mrc)],T)}),define(Re[230],Oe([1,0,7,16,6]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3sc=void 0;let L=class{constructor(T){this.a=new v.$EP(v.ColorThemeKind.Dark),this.b=new P.$qe}get activeColorTheme(){return this.a}$onColorThemeChange(T){let m;switch(T){case"light":m=v.ColorThemeKind.Light;break;case"hcDark":m=v.ColorThemeKind.HighContrast;break;case"hcLight":m=v.ColorThemeKind.HighContrastLight;break;default:m=v.ColorThemeKind.Dark}this.a=new v.$EP(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$3sc=L,e.$3sc=L=Ke([qe(0,D.$MQ)],L)}),define(Re[93],Oe([1,0,19,6,4,9,3,11,184,5,26,16,7]),function(we,e,v,D,P,L,R,T,m,s,I,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aHb=e.$_Gb=e.TunnelDtoConverter=void 0,L=Ve(L),u=Ve(u);class k extends m.$Xw{}var $;(function(a){function h(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:i.protocol}}a.fromApiTunnel=h;function c(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==m.TunnelPrivacyId.ConstantPrivate&&i.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}a.fromServiceTunnel=c})($||(e.TunnelDtoConverter=$={})),e.$_Gb=(0,R.$Ki)("IExtHostTunnelService");let r=class extends P.$Zc{constructor(h,c,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new D.$qe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=h.getProxy(s.$_N.MainThreadTunnelService)}async openTunnel(h,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${h.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const i=await this.a.$openTunnel(c,h.displayName);if(i){const n=new k(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(h,c){h.portRange===void 0&&h.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:h,provider:c}),this.a.$registerPortsAttributesProvider(h,i),new u.$bO(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(h,c,i,n,t){const o=[];for(const g of h){const f=this.r.get(g);if(!f)return[];o.push(...await Promise.all(c.map(async d=>{let S;try{S=await f.provider.providePortAttributes({port:d,pid:i,commandLine:n},t)}catch{S=await f.provider.providePortAttributes(d,i,n,t)}return{providedAttributes:S,port:d}})))}const l=o.filter(g=>!!g.providedAttributes);return l.length>0?l.map(g=>({autoForwardAction:g.providedAttributes.autoForwardAction,port:g.port})):[]}async $registerCandidateFinder(h){}registerTunnelProvider(h,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,t)=>await h.provideTunnel(n,t,v.CancellationToken.None)??void 0;const i=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions,protocol:c.tunnelFeatures.protocol===void 0?!0:c.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Xc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(h,c){if(h){h.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(h.candidatePortSource),h.showCandidatePort&&(this.f=h.showCandidatePort,this.a.$setCandidateFilter());const i=h.tunnelFactory??(c?this.w(c):void 0);if(i){this.b=i;let n=h.tunnelFeatures?.privacyOptions??[];h.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:L.localize(2716,null),themeIcon:"lock"},{id:"public",label:L.localize(2717,null),themeIcon:"eye"}]);const t=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,public:!!h.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Xc)(()=>{this.b=void 0})}w(h){}async $closeTunnel(h,c){if(this.g.has(h.host)){const i=this.g.get(h.host);i.has(h.port)&&(c&&i.get(h.port).disposeListener.dispose(),await i.get(h.port).tunnel.dispose(),i.delete(h.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(h,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(h,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(h.remoteAddress.host)||this.g.set(h.remoteAddress.host,new Map);const t=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(h.remoteAddress.host).set(h.remoteAddress.port,{tunnel:n,disposeListener:t}),$.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(h){const c=await Promise.all(h.map(n=>this.f(n.host,n.port,n.detail??""))),i=h.filter((n,t)=>c[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${h.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.$aHb=r,e.$aHb=r=Ke([qe(0,w.$MQ),qe(1,I.$3Q),qe(2,T.$fk)],r)}),define(Re[8],Oe([1,0,17,20,150,231,59,27,140,34,72,25,146,24,36,14,2,106,32,154,94,52,108,77,118,116,117,207,81,90,54,55,204,7]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d,S,E,y,C,O,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.LanguageModelToolResult=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatLanguageModelToolReference=e.ChatPromptReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseMovePart=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$JQ=ie,e.$KQ=_,e.$LQ=$e,R=Ve(R),m=Ve(m),c=Ve(c),i=Ve(i),n=Ve(n),S=Ve(S),y=Ve(y),b=Ve(b);var M;(function(me){function De(H){const{selectionStartLineNumber:ke,selectionStartColumn:We,positionLineNumber:Ye,positionColumn:Ue}=H,ot=new b.$cO(ke-1,We-1),gt=new b.$cO(Ye-1,Ue-1);return new b.$eO(ot,gt)}me.to=De;function ce(H){const{anchor:ke,active:We}=H;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}me.from=ce})(M||(e.Selection=M={}));var A;(function(me){function De(H){if(!H)return;const{start:ke,end:We}=H;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}me.from=De;function ce(H){if(!H)return;const{startLineNumber:ke,startColumn:We,endLineNumber:Ye,endColumn:Ue}=H;return new b.$dO(ke-1,We-1,Ye-1,Ue-1)}me.to=ce})(A||(e.Range=A={}));var F;(function(me){function De(H){return{uri:H.uri,range:A.from(H.range)}}me.from=De;function ce(H){return new b.$pO(a.URI.revive(H.uri),A.to(H.range))}me.to=ce})(F||(e.Location=F={}));var G;(function(me){function De(ce){switch(ce){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}me.to=De})(G||(e.TokenType=G={}));var x;(function(me){function De(H){return new b.$cO(H.lineNumber-1,H.column-1)}me.to=De;function ce(H){return{lineNumber:H.line+1,column:H.character+1}}me.from=ce})(x||(e.Position=x={}));var j;(function(me){function De(ke,We,Ye){return(0,v.$Lb)((0,v.$6b)(ke).map(Ue=>ce(Ue,We,Ye)))}me.from=De;function ce(ke,We,Ye){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ye?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:H(ke.scheme,We),pattern:Qe.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ye?.isBuiltin}}function H(ke,We){return We&&typeof ke=="string"?We.transformOutgoingScheme(ke):ke}})(j||(e.DocumentSelector=j={}));var U;(function(me){function De(H){switch(H){case b.DiagnosticTag.Unnecessary:return o.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return o.MarkerTag.Deprecated}}me.from=De;function ce(H){switch(H){case o.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case o.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}me.to=ce})(U||(e.DiagnosticTag=U={}));var J;(function(me){function De(H){let ke;return H.code&&((0,r.$jg)(H.code)||(0,r.$ng)(H.code)?ke=String(H.code):ke={value:String(H.code.value),target:H.code.target}),{...A.from(H.range),message:H.message,source:H.source,code:ke,severity:ae.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(Y.from),tags:Array.isArray(H.tags)?(0,v.$Lb)(H.tags.map(U.from)):void 0}}me.from=De;function ce(H){const ke=new b.$rO(A.to(H),H.message,ae.to(H.severity));return ke.source=H.source,ke.code=(0,r.$jg)(H.code)?H.code:H.code?.value,ke.relatedInformation=H.relatedInformation&&H.relatedInformation.map(Y.to),ke.tags=H.tags&&(0,v.$Lb)(H.tags.map(U.to)),ke}me.to=ce})(J||(e.Diagnostic=J={}));var Y;(function(me){function De(H){return{...A.from(H.location.range),message:H.message,resource:H.location.uri}}me.from=De;function ce(H){return new b.$qO(new b.$pO(H.resource,A.to(H)),H.message)}me.to=ce})(Y||(e.DiagnosticRelatedInformation=Y={}));var ae;(function(me){function De(H){switch(H){case b.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}me.from=De;function ce(H){switch(H){case o.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}me.to=ce})(ae||(e.DiagnosticSeverity=ae={}));var ee;(function(me){function De(H){return typeof H=="number"&&H>=b.ViewColumn.One?H-1:H===b.ViewColumn.Beside?p.$SE:p.$RE}me.from=De;function ce(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=ce})(ee||(e.ViewColumn=ee={}));function oe(me){return typeof me.range<"u"}function ie(me){return me.length===0?!0:!!oe(me[0])}var ue;(function(me){function De(Ue){return Ue.map(me.from)}me.fromMany=De;function ce(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function H(Ue){let ot;if(ce(Ue)){const{language:Vt,value:Wt}=Ue;ot={value:"```"+Vt+`
`+Wt+"\n```\n"}}else b.$FO.isMarkdownString(Ue)?ot={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml,baseUri:Ue.baseUri}:typeof Ue=="string"?ot={value:Ue}:ot={value:""};const gt=Object.create(null);ot.uris=gt;const Ht=({href:Vt})=>{try{let Wt=a.URI.parse(Vt,!0);Wt=Wt.with({query:ke(Wt.query,gt)}),gt[Vt]=Wt}catch{}return""};return m.marked.walkTokens(m.marked.lexer(ot.value),Vt=>{Vt.type==="link"?Ht({href:Vt.href}):Vt.type==="image"&&typeof Vt.href=="string"&&Ht(R.$el(Vt.href))}),ot}me.from=H;function ke(Ue,ot){if(!Ue)return Ue;let gt;try{gt=(0,s.$gi)(Ue)}catch{}if(!gt)return Ue;let Ht=!1;return gt=(0,w.$mo)(gt,Vt=>{if(a.URI.isUri(Vt)){const Wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[Wt]=Vt,Ht=!0,Wt}else return}),Ht?JSON.stringify(gt):Ue}function We(Ue){const ot=new b.$FO(Ue.value,Ue.supportThemeIcons);return ot.isTrusted=Ue.isTrusted,ot.supportHtml=Ue.supportHtml,ot.baseUri=Ue.baseUri?a.URI.from(Ue.baseUri):void 0,ot}me.to=We;function Ye(Ue){if(Ue)return typeof Ue=="string"?Ue:me.from(Ue)}me.fromStrict=Ye})(ue||(e.MarkdownString=ue={}));function _(me){return ie(me)?me.map(De=>({range:A.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?ue.fromMany(De.hoverMessage):De.hoverMessage?ue.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):me.map(De=>({range:A.from(De)}))}function $e(me){return typeof me>"u"?me:typeof me=="string"?a.URI.file(me):me}var Ie;(function(me){function De(ce){return typeof ce>"u"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?$e(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}me.from=De})(Ie||(e.ThemableDecorationAttachmentRenderOptions=Ie={}));var X;(function(me){function De(ce){return typeof ce>"u"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?$e(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?Ie.from(ce.before):void 0,after:ce.after?Ie.from(ce.after):void 0}}me.from=De})(X||(e.ThemableDecorationRenderOptions=X={}));var V;(function(me){function De(ce){if(typeof ce>"u")return ce;switch(ce){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}me.from=De})(V||(e.DecorationRangeBehavior=V={}));var re;(function(me){function De(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?V.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?X.from(ce.light):void 0,dark:ce.dark?X.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?$e(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?Ie.from(ce.before):void 0,after:ce.after?Ie.from(ce.after):void 0}}me.from=De})(re||(e.DecorationRenderOptions=re={}));var be;(function(me){function De(H){return{text:H.newText,eol:H.newEol&&ve.from(H.newEol),range:A.from(H.range)}}me.from=De;function ce(H){const ke=new b.$kO(A.to(H.range),H.text);return ke.newEol=typeof H.eol>"u"?void 0:ve.to(H.eol),ke}me.to=ce})(be||(e.TextEdit=be={}));var Pe;(function(me){function De(H,ke){const We={edits:[]};if(H instanceof b.$nO){const Ye=new T.$Gc;for(const Ue of H._allEntries())Ue._type===b.FileEditType.File&&a.URI.isUri(Ue.to)&&Ue.from===void 0&&Ye.add(Ue.to);for(const Ue of H._allEntries())if(Ue._type===b.FileEditType.File){let ot;Ue.options?.contents&&(ArrayBuffer.isView(Ue.options.contents)?ot={type:"base64",value:(0,D.$af)(D.$Se.wrap(Ue.options.contents))}:ot={type:"dataTransferItem",id:Ue.options.contents._itemId}),We.edits.push({oldResource:Ue.from,newResource:Ue.to,options:{...Ue.options,contents:ot},metadata:Ue.metadata})}else Ue._type===b.FileEditType.Text?We.edits.push({resource:Ue.uri,textEdit:be.from(Ue.edit),versionId:Ye.has(Ue.uri)?void 0:ke?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===b.FileEditType.Snippet?We.edits.push({resource:Ue.uri,textEdit:{range:A.from(Ue.range),text:Ue.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ue.uri)?void 0:ke?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===b.FileEditType.Cell?We.edits.push({metadata:Ue.metadata,resource:Ue.uri,cellEdit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Ue.uri)}):Ue._type===b.FileEditType.CellReplace&&We.edits.push({metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Ue.uri),cellEdit:{editType:y.CellEditType.Replace,index:Ue.index,count:Ue.count,cells:Ue.cells.map(Xe.from)}})}return We}me.from=De;function ce(H){const ke=new b.$nO,We=new T.$Fc;for(const Ye of H.edits)if(Ye.textEdit){const Ue=Ye,ot=a.URI.revive(Ue.resource),gt=A.to(Ue.textEdit.range),Ht=Ue.textEdit.text,Vt=Ue.textEdit.insertAsSnippet;let Wt;Vt?Wt=b.$mO.replace(gt,new b.$oO(Ht)):Wt=b.$kO.replace(gt,Ht);const Li=We.get(ot);Li?Li.push(Wt):We.set(ot,[Wt])}else ke.renameFile(a.URI.revive(Ye.oldResource),a.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ue]of We)ke.set(Ye,Ue);return ke}me.to=ce})(Pe||(e.WorkspaceEdit=Pe={}));var Fe;(function(me){const De=Object.create(null);De[b.SymbolKind.File]=n.SymbolKind.File,De[b.SymbolKind.Module]=n.SymbolKind.Module,De[b.SymbolKind.Namespace]=n.SymbolKind.Namespace,De[b.SymbolKind.Package]=n.SymbolKind.Package,De[b.SymbolKind.Class]=n.SymbolKind.Class,De[b.SymbolKind.Method]=n.SymbolKind.Method,De[b.SymbolKind.Property]=n.SymbolKind.Property,De[b.SymbolKind.Field]=n.SymbolKind.Field,De[b.SymbolKind.Constructor]=n.SymbolKind.Constructor,De[b.SymbolKind.Enum]=n.SymbolKind.Enum,De[b.SymbolKind.Interface]=n.SymbolKind.Interface,De[b.SymbolKind.Function]=n.SymbolKind.Function,De[b.SymbolKind.Variable]=n.SymbolKind.Variable,De[b.SymbolKind.Constant]=n.SymbolKind.Constant,De[b.SymbolKind.String]=n.SymbolKind.String,De[b.SymbolKind.Number]=n.SymbolKind.Number,De[b.SymbolKind.Boolean]=n.SymbolKind.Boolean,De[b.SymbolKind.Array]=n.SymbolKind.Array,De[b.SymbolKind.Object]=n.SymbolKind.Object,De[b.SymbolKind.Key]=n.SymbolKind.Key,De[b.SymbolKind.Null]=n.SymbolKind.Null,De[b.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,De[b.SymbolKind.Struct]=n.SymbolKind.Struct,De[b.SymbolKind.Event]=n.SymbolKind.Event,De[b.SymbolKind.Operator]=n.SymbolKind.Operator,De[b.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function ce(ke){return typeof De[ke]=="number"?De[ke]:n.SymbolKind.Property}me.from=ce;function H(ke){for(const We in De)if(De[We]===ke)return Number(We);return b.SymbolKind.Property}me.to=H})(Fe||(e.SymbolKind=Fe={}));var Be;(function(me){function De(H){switch(H){case b.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}me.from=De;function ce(H){switch(H){case n.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}me.to=ce})(Be||(e.SymbolTag=Be={}));var xe;(function(me){function De(H){return{name:H.name,kind:Fe.from(H.kind),tags:H.tags&&H.tags.map(Be.from),containerName:H.containerName,location:et.from(H.location)}}me.from=De;function ce(H){const ke=new b.$wO(H.name,Fe.to(H.kind),H.containerName,et.to(H.location));return ke.tags=H.tags&&H.tags.map(Be.to),ke}me.to=ce})(xe||(e.WorkspaceSymbol=xe={}));var nt;(function(me){function De(H){const ke={name:H.name||"!!MISSING: name!!",detail:H.detail,range:A.from(H.range),selectionRange:A.from(H.selectionRange),kind:Fe.from(H.kind),tags:H.tags?.map(Be.from)??[]};return H.children&&(ke.children=H.children.map(De)),ke}me.from=De;function ce(H){const ke=new b.$xO(H.name,H.detail,Fe.to(H.kind),A.to(H.range),A.to(H.selectionRange));return(0,v.$Pb)(H.tags)&&(ke.tags=H.tags.map(Be.to)),H.children&&(ke.children=H.children.map(ce)),ke}me.to=ce})(nt||(e.DocumentSymbol=nt={}));var ht;(function(me){function De(H){const ke=new b.$BO(Fe.to(H.kind),H.name,H.detail||"",a.URI.revive(H.uri),A.to(H.range),A.to(H.selectionRange));return ke._sessionId=H._sessionId,ke._itemId=H._itemId,ke}me.to=De;function ce(H,ke,We){if(ke=ke??H._sessionId,We=We??H._itemId,ke===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:We,name:H.name,detail:H.detail,kind:Fe.from(H.kind),uri:H.uri,range:A.from(H.range),selectionRange:A.from(H.selectionRange),tags:H.tags?.map(Be.from)}}me.from=ce})(ht||(e.CallHierarchyItem=ht={}));var $t;(function(me){function De(ce){return new b.$CO(ht.to(ce.from),ce.fromRanges.map(H=>A.to(H)))}me.to=De})($t||(e.CallHierarchyIncomingCall=$t={}));var ut;(function(me){function De(ce){return new b.$DO(ht.to(ce.to),ce.fromRanges.map(H=>A.to(H)))}me.to=De})(ut||(e.CallHierarchyOutgoingCall=ut={}));var et;(function(me){function De(H){return{range:H.range&&A.from(H.range),uri:H.uri}}me.from=De;function ce(H){return new b.$pO(a.URI.revive(H.uri),A.to(H.range))}me.to=ce})(et||(e.location=et={}));var Le;(function(me){function De(H){const ke=H,We=H;return{originSelectionRange:ke.originSelectionRange?A.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:We.uri,range:A.from(ke.targetRange?ke.targetRange:We.range),targetSelectionRange:ke.targetSelectionRange?A.from(ke.targetSelectionRange):void 0}}me.from=De;function ce(H){return{targetUri:a.URI.revive(H.uri),targetRange:A.to(H.range),targetSelectionRange:H.targetSelectionRange?A.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?A.to(H.originSelectionRange):void 0}}me.to=ce})(Le||(e.DefinitionLink=Le={}));var Ne;(function(me){function De(H){return{range:A.from(H.range),contents:ue.fromMany(H.contents),canIncreaseVerbosity:H.canIncreaseVerbosity,canDecreaseVerbosity:H.canDecreaseVerbosity}}me.from=De;function ce(H){const ke=H.contents.map(ue.to),We=A.to(H.range),Ye=H.canIncreaseVerbosity,Ue=H.canDecreaseVerbosity;return new b.$tO(ke,We,Ye,Ue)}me.to=ce})(Ne||(e.Hover=Ne={}));var Me;(function(me){function De(H){return{range:A.from(H.range),expression:H.expression}}me.from=De;function ce(H){return new b.$oP(A.to(H.range),H.expression)}me.to=ce})(Me||(e.EvaluatableExpression=Me={}));var W;(function(me){function De(H){if(H instanceof b.$pP)return{type:"text",range:A.from(H.range),text:H.text};if(H instanceof b.$qP)return{type:"variable",range:A.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof b.$rP)return{type:"expression",range:A.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}me.from=De;function ce(H){switch(H.type){case"text":return{range:A.to(H.range),text:H.text};case"variable":return{range:A.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:A.to(H.range),expression:H.expression}}}me.to=ce})(W||(e.InlineValue=W={}));var B;(function(me){function De(H){return{frameId:H.frameId,stoppedLocation:A.from(H.stoppedLocation)}}me.from=De;function ce(H){return new b.$sP(H.frameId,A.to(H.stoppedLocation))}me.to=ce})(B||(e.InlineValueContext=B={}));var Q;(function(me){function De(H){return{range:A.from(H.range),kind:H.kind}}me.from=De;function ce(H){return new b.$uO(A.to(H.range),H.kind)}me.to=ce})(Q||(e.DocumentHighlight=Q={}));var K;(function(me){function De(H){return{uri:H.uri,highlights:H.highlights.map(Q.from)}}me.from=De;function ce(H){return new b.$vO(a.URI.revive(H.uri),H.highlights.map(Q.to))}me.to=ce})(K||(e.MultiDocumentHighlight=K={}));var se;(function(me){function De(ce){switch(ce){case n.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}me.to=De})(se||(e.CompletionTriggerKind=se={}));var ge;(function(me){function De(ce){return{triggerKind:se.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}me.to=De})(ge||(e.CompletionContext=ge={}));var Ee;(function(me){function De(H){switch(H){case b.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}me.from=De;function ce(H){switch(H){case n.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}me.to=ce})(Ee||(e.CompletionItemTag=Ee={}));var ze;(function(me){const De=new Map([[b.CompletionItemKind.Method,n.CompletionItemKind.Method],[b.CompletionItemKind.Function,n.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,n.CompletionItemKind.Field],[b.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[b.CompletionItemKind.Class,n.CompletionItemKind.Class],[b.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[b.CompletionItemKind.Module,n.CompletionItemKind.Module],[b.CompletionItemKind.Property,n.CompletionItemKind.Property],[b.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[b.CompletionItemKind.Value,n.CompletionItemKind.Value],[b.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,n.CompletionItemKind.Text],[b.CompletionItemKind.Color,n.CompletionItemKind.Color],[b.CompletionItemKind.File,n.CompletionItemKind.File],[b.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[b.CompletionItemKind.Event,n.CompletionItemKind.Event],[b.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[b.CompletionItemKind.User,n.CompletionItemKind.User]]);function ce(We){return De.get(We)??n.CompletionItemKind.Property}me.from=ce;const H=new Map([[n.CompletionItemKind.Method,b.CompletionItemKind.Method],[n.CompletionItemKind.Function,b.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,b.CompletionItemKind.Field],[n.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[n.CompletionItemKind.Class,b.CompletionItemKind.Class],[n.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[n.CompletionItemKind.Module,b.CompletionItemKind.Module],[n.CompletionItemKind.Property,b.CompletionItemKind.Property],[n.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[n.CompletionItemKind.Value,b.CompletionItemKind.Value],[n.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,b.CompletionItemKind.Text],[n.CompletionItemKind.Color,b.CompletionItemKind.Color],[n.CompletionItemKind.File,b.CompletionItemKind.File],[n.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[n.CompletionItemKind.Event,b.CompletionItemKind.Event],[n.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,b.CompletionItemKind.User],[n.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function ke(We){return H.get(We)??b.CompletionItemKind.Property}me.to=ke})(ze||(e.CompletionItemKind=ze={}));var Je;(function(me){function De(ce,H){const ke=new b.$LO(ce.label);return ke.insertText=ce.insertText,ke.kind=ze.to(ce.kind),ke.tags=ce.tags?.map(Ee.to),ke.detail=ce.detail,ke.documentation=R.$$k(ce.documentation)?ue.to(ce.documentation):ce.documentation,ke.sortText=ce.sortText,ke.filterText=ce.filterText,ke.preselect=ce.preselect,ke.commitCharacters=ce.commitCharacters,c.$Wt.isIRange(ce.range)?ke.range=A.to(ce.range):typeof ce.range=="object"&&(ke.range={inserting:A.to(ce.range.insert),replacing:A.to(ce.range.replace)}),ke.keepWhitespace=typeof ce.insertTextRules>"u"?!1:!!(ce.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof ce.insertTextRules<"u"&&ce.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?ke.insertText=new b.$oO(ce.insertText):(ke.insertText=ce.insertText,ke.textEdit=ke.range instanceof b.$dO?new b.$kO(ke.range,ke.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(ke.additionalTextEdits=ce.additionalTextEdits.map(We=>be.to(We))),ke.command=H&&ce.command?H.fromInternal(ce.command):void 0,ke}me.to=De})(Je||(e.CompletionItem=Je={}));var _e;(function(me){function De(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:ue.fromStrict(H.documentation)}}me.from=De;function ce(H){return{label:H.label,documentation:R.$$k(H.documentation)?ue.to(H.documentation):H.documentation}}me.to=ce})(_e||(e.ParameterInformation=_e={}));var tt;(function(me){function De(H){return{label:H.label,documentation:ue.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(_e.from):[],activeParameter:H.activeParameter}}me.from=De;function ce(H){return{label:H.label,documentation:R.$$k(H.documentation)?ue.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(_e.to):[],activeParameter:H.activeParameter}}me.to=ce})(tt||(e.SignatureInformation=tt={}));var ct;(function(me){function De(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(tt.from):[]}}me.from=De;function ce(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(tt.to):[]}}me.to=ce})(ct||(e.SignatureHelp=ct={}));var it;(function(me){function De(ce,H){const ke=new b.$KO(x.to(H.position),typeof H.label=="string"?H.label:H.label.map(at.to.bind(void 0,ce)),H.kind&&yt.to(H.kind));return ke.textEdits=H.textEdits&&H.textEdits.map(be.to),ke.tooltip=R.$$k(H.tooltip)?ue.to(H.tooltip):H.tooltip,ke.paddingLeft=H.paddingLeft,ke.paddingRight=H.paddingRight,ke}me.to=De})(it||(e.InlayHint=it={}));var at;(function(me){function De(ce,H){const ke=new b.$JO(H.label);return ke.tooltip=R.$$k(H.tooltip)?ue.to(H.tooltip):H.tooltip,n.Command.is(H.command)&&(ke.command=ce.fromInternal(H.command)),H.location&&(ke.location=et.to(H.location)),ke}me.to=De})(at||(e.InlayHintLabelPart=at={}));var yt;(function(me){function De(H){return H}me.from=De;function ce(H){return H}me.to=ce})(yt||(e.InlayHintKind=yt={}));var Ze;(function(me){function De(H){return{range:A.from(H.range),url:H.target,tooltip:H.tooltip}}me.from=De;function ce(H){let ke;if(H.url)try{ke=typeof H.url=="string"?a.URI.parse(H.url,!0):a.URI.revive(H.url)}catch{}const We=new b.$QO(A.to(H.range),ke);return We.tooltip=H.tooltip,We}me.to=ce})(Ze||(e.DocumentLink=Ze={}));var he;(function(me){function De(H){const ke=new b.$TO(H.label);return H.textEdit&&(ke.textEdit=be.to(H.textEdit)),H.additionalTextEdits&&(ke.additionalTextEdits=H.additionalTextEdits.map(We=>be.to(We))),ke}me.to=De;function ce(H){return{label:H.label,textEdit:H.textEdit?be.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(ke=>be.from(ke)):void 0}}me.from=ce})(he||(e.ColorPresentation=he={}));var pe;(function(me){function De(H){return new b.$RO(H[0],H[1],H[2],H[3])}me.to=De;function ce(H){return[H.red,H.green,H.blue,H.alpha]}me.from=ce})(pe||(e.Color=pe={}));var ye;(function(me){function De(H){return{range:A.from(H.range)}}me.from=De;function ce(H){return new b.$AO(A.to(H.range))}me.to=ce})(ye||(e.SelectionRange=ye={}));var Ce;(function(me){function De(ce){switch(ce){case f.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case f.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case f.SaveReason.FOCUS_CHANGE:case f.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}me.to=De})(Ce||(e.TextDocumentSaveReason=Ce={}));var fe;(function(me){function De(H){switch(H){case b.TextEditorLineNumbersStyle.Off:return h.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return h.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return h.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return h.RenderLineNumbersType.On}}me.from=De;function ce(H){switch(H){case h.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case h.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case h.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case h.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}me.to=ce})(fe||(e.TextEditorLineNumbersStyle=fe={}));var ve;(function(me){function De(H){if(H===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(H===b.EndOfLine.LF)return t.EndOfLineSequence.LF}me.from=De;function ce(H){if(H===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(H===t.EndOfLineSequence.LF)return b.EndOfLine.LF}me.to=ce})(ve||(e.EndOfLine=ve={}));var Z;(function(me){function De(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case b.ProgressLocation.SourceControl:return l.ProgressLocation.Scm;case b.ProgressLocation.Window:return l.ProgressLocation.Window;case b.ProgressLocation.Notification:return l.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}me.from=De})(Z||(e.ProgressLocation=Z={}));var q;(function(me){function De(H){const ke={start:H.start+1,end:H.end+1};return H.kind&&(ke.kind=de.from(H.kind)),ke}me.from=De;function ce(H){const ke={start:H.start-1,end:H.end-1};return H.kind&&(ke.kind=de.to(H.kind)),ke}me.to=ce})(q||(e.FoldingRange=q={}));var de;(function(me){function De(H){if(H)switch(H){case b.FoldingRangeKind.Comment:return n.$Xu.Comment;case b.FoldingRangeKind.Imports:return n.$Xu.Imports;case b.FoldingRangeKind.Region:return n.$Xu.Region}}me.from=De;function ce(H){if(H)switch(H.value){case n.$Xu.Comment.value:return b.FoldingRangeKind.Comment;case n.$Xu.Imports.value:return b.FoldingRangeKind.Imports;case n.$Xu.Region.value:return b.FoldingRangeKind.Region}}me.to=ce})(de||(e.FoldingRangeKind=de={}));var je;(function(me){function De(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?A.from(ce.selection):void 0,override:typeof ce.override=="boolean"?f.$jG.id:void 0}}me.from=De})(je||(e.TextEditorOpenOptions=je={}));var Qe;(function(me){function De(We){return We instanceof b.$cP?We.toJSON():typeof We=="string"?We:ce(We)||H(We)?new b.$cP(We.baseUri??We.base,We.pattern).toJSON():We}me.from=De;function ce(We){const Ye=We;return Ye?a.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function H(We){const Ye=We;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function ke(We){return typeof We=="string"?We:new b.$cP(a.URI.revive(We.baseUri),We.pattern)}me.to=ke})(Qe||(e.GlobPattern=Qe={}));var st;(function(me){function De(ce){if(ce){if(Array.isArray(ce))return ce.map(De);if(typeof ce=="string")return ce;{const H=ce;return{language:H.language,scheme:H.scheme,pattern:Qe.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}me.from=De})(st||(e.LanguageSelector=st={}));var dt;(function(me){function De(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(ke=>Array.isArray(ke)&&ke.every(We=>We&&typeof We=="object"&&"uri"in We&&a.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ye=>Ye instanceof b.$dO)))}me.is=De;function ce(H){return{documents:H.documents.map(ke=>ke.map(We=>({uri:a.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ye=>A.from(Ye))})))}}me.from=ce})(dt||(e.MappedEditsContext=dt={}));var mt;(function(me){function De(H){return{start:H.start,end:H.end}}me.from=De;function ce(H){return new b.$FP(H.start,H.end)}me.to=ce})(mt||(e.NotebookRange=mt={}));var Ot;(function(me){function De(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}me.to=De;function ce(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}me.from=ce})(Ot||(e.NotebookCellExecutionSummary=Ot={}));var Tt;(function(me){function De(ce){if(ce===y.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(ce===y.NotebookCellExecutionState.Pending)return;if(ce===y.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ce}`)}me.to=De})(Tt||(e.NotebookCellExecutionState=Tt={}));var Qt;(function(me){function De(H){switch(H){case b.NotebookCellKind.Markup:return y.CellKind.Markup;case b.NotebookCellKind.Code:default:return y.CellKind.Code}}me.from=De;function ce(H){switch(H){case y.CellKind.Markup:return b.NotebookCellKind.Markup;case y.CellKind.Code:default:return b.NotebookCellKind.Code}}me.to=ce})(Qt||(e.NotebookCellKind=Qt={}));var _t;(function(me){function De(H){const ke={metadata:H.metadata??Object.create(null),cells:[]};for(const We of H.cells)b.$GP.validate(We),ke.cells.push(Xe.from(We));return ke}me.from=De;function ce(H){const ke=new b.$HP(H.cells.map(Xe.to));return(0,r.$wg)(H.metadata)||(ke.metadata=H.metadata),ke}me.to=ce})(_t||(e.NotebookData=_t={}));var Xe;(function(me){function De(H){return{cellKind:Qt.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Ot.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Ut.from):[]}}me.from=De;function ce(H){return new b.$GP(Qt.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Ut.to):void 0,H.metadata,H.internalMetadata?Ot.to(H.internalMetadata):void 0)}me.to=ce})(Xe||(e.NotebookCellData=Xe={}));var At;(function(me){function De(H){return{mime:H.mime,valueBytes:D.$Se.wrap(H.data)}}me.from=De;function ce(H){return new b.$IP(H.valueBytes.buffer,H.mime)}me.to=ce})(At||(e.NotebookCellOutputItem=At={}));var Ut;(function(me){function De(H){return{outputId:H.id,items:H.items.map(At.from),metadata:H.metadata}}me.from=De;function ce(H){const ke=H.items.map(At.to);return new b.$JP(ke,H.outputId,H.metadata)}me.to=ce})(Ut||(e.NotebookCellOutput=Ut={}));var wt;(function(me){function De(ke){return H(ke)?{include:Qe.from(ke.include)??void 0,exclude:Qe.from(ke.exclude)??void 0}:Qe.from(ke)??void 0}me.from=De;function ce(ke){return H(ke)?{include:Qe.to(ke.include),exclude:Qe.to(ke.exclude)}:Qe.to(ke)}me.to=ce;function H(ke){const We=ke;return We?!(0,r.$sg)(We.include)&&!(0,r.$sg)(We.exclude):!1}})(wt||(e.NotebookExclusiveDocumentPattern=wt={}));var Dt;(function(me){function De(ce,H,ke){const We=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===b.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:H.toInternal(We,ke),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}me.from=De})(Dt||(e.NotebookStatusBarItem=Dt={}));var ei;(function(me){function De(ce,H,ke){const We=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{command:H.toInternal(We,ke),label:ce.label,description:ce.description,detail:ce.detail,documentation:ce.documentation}}me.from=De})(ei||(e.NotebookKernelSourceAction=ei={}));var ti;(function(me){function De(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{},cellContentMetadata:ce?.cellContentMetadata??{}}}me.from=De})(ti||(e.NotebookDocumentContentOptions=ti={}));var Kt;(function(me){function De(H){return{uri:H.uri,provides:H.provides}}me.from=De;function ce(H){return new b.$LP(a.URI.revive(H.uri),H.provides)}me.to=ce})(Kt||(e.NotebookRendererScript=Kt={}));var bt;(function(me){function De(H){return{message:ue.fromStrict(H.message)||"",type:O.TestMessageType.Error,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:A.from(H.location.range),uri:H.location.uri},stackTrace:H.stackTrace?.map(ke=>({label:ke.label,position:ke.position&&x.from(ke.position),uri:ke.uri&&a.URI.revive(ke.uri).toJSON()}))}}me.from=De;function ce(H){const ke=new b.$RP(typeof H.message=="string"?H.message:ue.to(H.message));return ke.actualOutput=H.actual,ke.expectedOutput=H.expected,ke.contextValue=H.contextValue,ke.location=H.location?et.to(H.location):void 0,ke}me.to=ce})(bt||(e.TestMessage=bt={}));var Lt;(function(me){me.namespace=O.$wJ,me.denamespace=O.$xJ})(Lt||(e.TestTag=Lt={}));var ci;(function(me){function De(H){const ke=(0,g.$IQ)(H).controllerId;return{extId:C.$rJ.fromExtHostTestItem(H,ke).toString(),label:H.label,uri:a.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(We=>Lt.namespace(ke,We.id)),range:c.$Wt.lift(A.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&ue.fromStrict(H.error)||null}}me.from=De;function ce(H){return{parent:void 0,error:void 0,id:C.$rJ.fromString(H.extId).localId,label:H.label,uri:a.URI.revive(H.uri),tags:(H.tags||[]).map(ke=>{const{tagId:We}=Lt.denamespace(ke);return new b.$SP(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:A.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}me.toPlain=ce})(ci||(e.TestItem=ci={})),function(me){function De(H){return{id:H.id}}me.from=De;function ce(H){return new b.$SP(H.id)}me.to=ce}(Lt||(e.TestTag=Lt={}));var Zt;(function(me){const De=(H,ke)=>{const We=H.value;if(!We)return;const Ye={...ci.toPlain(We.item),parent:ke,taskStates:We.tasks.map(Ue=>({state:Ue.state,duration:Ue.duration,messages:Ue.messages.filter(ot=>ot.type===O.TestMessageType.Error).map(bt.to)})),children:[]};if(H.children)for(const Ue of H.children.values()){const ot=De(Ue,Ye);ot&&Ye.children.push(ot)}return Ye};function ce(H){const ke=new u.$qJ;for(const Ue of H.items)ke.insert(C.$rJ.fromString(Ue.item.extId).path,Ue);const We=[ke.nodes],Ye=[];for(;We.length;)for(const Ue of We.pop())Ue.value?Ye.push(Ue):Ue.children&&We.push(Ue.children.values());return{completedAt:H.completedAt,results:Ye.map(Ue=>De(Ue)).filter(r.$rg)}}me.to=ce})(Zt||(e.TestResults=Zt={}));var Ge;(function(me){function De(Ue){return{covered:Ue.covered,total:Ue.total}}function ce(Ue){return"line"in Ue?x.from(Ue):A.from(Ue)}function H(Ue){if(Ue)return"endLineNumber"in Ue?A.to(Ue):x.to(Ue)}function ke(Ue){if(Ue.type===O.DetailType.Statement){const ot=[];if(Ue.branches)for(const gt of Ue.branches)ot.push({executed:gt.count,location:H(gt.location),label:gt.label});return new b.$XP(Ue.count,H(Ue.location),Ue.branches?.map(gt=>new b.$YP(gt.count,H(gt.location),gt.label)))}else return new b.$ZP(Ue.name,Ue.count,H(Ue.location))}me.to=ke;function We(Ue){if(typeof Ue.executed=="number"&&Ue.executed<0)throw new Error(`Invalid coverage count ${Ue.executed}`);return"branches"in Ue?{count:Ue.executed,location:ce(Ue.location),type:O.DetailType.Statement,branches:Ue.branches.length?Ue.branches.map(ot=>({count:ot.executed,location:ot.location&&ce(ot.location),label:ot.label})):void 0}:{type:O.DetailType.Declaration,name:Ue.name,count:Ue.executed,location:ce(Ue.location)}}me.fromDetails=We;function Ye(Ue,ot,gt){return b.$VP(gt.statementCoverage),b.$VP(gt.branchCoverage),b.$VP(gt.declarationCoverage),{id:ot,uri:gt.uri,statement:De(gt.statementCoverage),branch:gt.branchCoverage&&De(gt.branchCoverage),declaration:gt.declarationCoverage&&De(gt.declarationCoverage),testIds:gt instanceof b.$WP&&gt.fromTests.length?gt.fromTests.map(Ht=>C.$rJ.fromExtHostTestItem(Ht,Ue).toString()):void 0}}me.fromFile=Ye})(Ge||(e.TestCoverage=Ge={}));var ii;(function(me){function De(ce){switch(ce){case n.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}me.to=De})(ii||(e.CodeActionTriggerKind=ii={}));var li;(function(me){function De(H){const ke=new b.$1P(Fe.to(H.kind),H.name,H.detail||"",a.URI.revive(H.uri),A.to(H.range),A.to(H.selectionRange));return ke._sessionId=H._sessionId,ke._itemId=H._itemId,ke}me.to=De;function ce(H,ke,We){if(ke=ke??H._sessionId,We=We??H._itemId,ke===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:We,kind:Fe.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:A.from(H.range),selectionRange:A.from(H.selectionRange),tags:H.tags?.map(Be.from)}}me.from=ce})(li||(e.TypeHierarchyItem=li={}));var hi;(function(me){function De(ce){if(ce)return{value:ce.value,tooltip:ce.tooltip}}me.from=De})(hi||(e.ViewBadge=hi={}));var kt;(function(me){function De(We,Ye,Ue){const ot=Ye.fileData;return ot?new b.$7O(new b.$8O(ot.name,a.URI.revive(ot.uri),ot.id,(0,L.$hb)(()=>Ue(ot.id)))):We===I.$gt.uriList&&Ye.uriListData?new b.$6O(ke(Ye.uriListData)):new b.$6O(Ye.asString)}me.to=De;async function ce(We,Ye){const Ue=await Ye.asString();if(We===I.$gt.uriList)return{asString:Ue,fileData:void 0,uriListData:H(Ue)};const ot=Ye.asFile();return{asString:Ue,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}me.from=ce;function H(We){return P.$Bu.split(We).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return a.URI.parse(Ye)}catch{}return Ye})}function ke(We){return P.$Bu.create(We.map(Ye=>typeof Ye=="string"?Ye:a.URI.revive(Ye)))}})(kt||(e.DataTransferItem=kt={}));var jt;(function(me){function De(H,ke){const We=H.items.map(([Ye,Ue])=>[Ye,kt.to(Ye,Ue,ke)]);return new b.$9O(We)}me.toDataTransfer=De;async function ce(H){const ke={items:[]},We=[];for(const[Ye,Ue]of H)We.push((async()=>{ke.items.push([Ye,await kt.from(Ye,Ue)])})());return await Promise.all(We),ke}me.from=ce})(jt||(e.DataTransfer=jt={}));var Mt;(function(me){function De(H,ke){return{kind:"reply",agentId:H.participant??ke?.agentId??"",subCommand:H.command??ke?.command,message:H.prompt,title:H.label}}me.from=De;function ce(H){return{prompt:H.message,label:H.title,participant:H.agentId,command:H.subCommand}}me.to=ce})(Mt||(e.ChatFollowup=Mt={}));var Bt;(function(me){function De(H){switch(H){case S.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case S.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case S.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}me.to=De;function ce(H){switch(H){case b.LanguageModelChatMessageRole.System:return S.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return S.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return S.ChatMessageRole.Assistant}return S.ChatMessageRole.User}me.from=ce})(Bt||(e.LanguageModelChatMessageRole=Bt={}));var ai;(function(me){function De(H){const ke=H.content.map(ot=>ot.type==="text"?ot.value:ot.type==="tool_result"?new b.$tQ(ot.toolCallId,ot.value,ot.isError):new b.$vQ(ot.name,ot.toolCallId,ot.parameters)),We=ke.find(ot=>typeof ot=="string")??"",Ye=Bt.to(H.role),Ue=new b.$uQ(Ye,We,H.name);return Ue.content2=ke,Ue}me.to=De;function ce(H){const ke=Bt.from(H.role),We=H.name,Ye=H.content2.map(Ue=>{if(Ue instanceof b.$tQ)return{type:"tool_result",toolCallId:Ue.toolCallId,value:Ue.content,isError:Ue.isError};if(Ue instanceof b.$vQ)return{type:"tool_use",toolCallId:Ue.toolCallId,name:Ue.name,parameters:Ue.parameters};if(typeof Ue!="string")throw new Error("Unexpected chat message content type");return{type:"text",value:Ue}});return{role:ke,name:We,content:Ye}}me.from=ce})(ai||(e.LanguageModelChatMessage=ai={}));var ni;(function(me){function De(H){return{kind:"markdownContent",content:ue.from(H.value)}}me.from=De;function ce(H){return new b.$bQ(ue.to(H.content))}me.to=ce})(ni||(e.ChatResponseMarkdownPart=ni={}));var ri;(function(me){function De(H){return{kind:"markdownVuln",content:ue.from(H.value),vulnerabilities:H.vulnerabilities}}me.from=De;function ce(H){return new b.$cQ(ue.to(H.content),H.vulnerabilities)}me.to=ce})(ri||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ri={}));var Gt;(function(me){function De(H){return{kind:"agentDetection",agentId:H.participant,command:H.command}}me.from=De;function ce(H){return new b.$dQ(H.agentId,H.command)}me.to=ce})(Gt||(e.ChatResponseDetectedParticipantPart=Gt={}));var Jt;(function(me){function De(ce){return{kind:"confirmation",title:ce.title,message:ce.message,data:ce.data,buttons:ce.buttons}}me.from=De})(Jt||(e.ChatResponseConfirmationPart=Jt={}));var ui;(function(me){function De(H){const{value:ke,baseUri:We}=H;function Ye(Ue,ot){return Ue.map(gt=>{const Ht=a.URI.joinPath(ot,gt.name);return{label:gt.name,uri:Ht,children:gt.children&&Ye(gt.children,Ht)}})}return{kind:"treeData",treeData:{label:(0,k.$ih)(We),uri:We,children:Ye(ke,We)}}}me.from=De;function ce(H){const ke=(0,s.$hi)(H.treeData);function We(ot){return ot.map(gt=>({name:gt.label,children:gt.children&&We(gt.children)}))}const Ye=ke.uri,Ue=ke.children?We(ke.children):[];return new b.$fQ(Ue,Ye)}me.to=ce})(ui||(e.ChatResponseFilesPart=ui={}));var Nt;(function(me){function De(H){const ke=We=>a.URI.isUri(We);return{kind:"inlineReference",name:H.title,inlineReference:ke(H.value)?H.value:F.from(H.value)}}me.from=De;function ce(H){const ke=(0,s.$hi)(H);return new b.$gQ(a.URI.isUri(ke.inlineReference)?ke.inlineReference:F.to(ke.inlineReference),H.name)}me.to=ce})(Nt||(e.ChatResponseAnchorPart=Nt={}));var Ct;(function(me){function De(H){return{kind:"progressMessage",content:ue.from(H.value)}}me.from=De;function ce(H){return new b.$hQ(H.content.value)}me.to=ce})(Ct||(e.ChatResponseProgressPart=Ct={}));var vt;(function(me){function De(H){return{kind:"warning",content:ue.from(H.value)}}me.from=De;function ce(H){return new b.$jQ(H.content.value)}me.to=ce})(vt||(e.ChatResponseWarningPart=vt={}));var Xt;(function(me){function De(H){return{kind:"move",uri:H.uri,range:A.from(H.range)}}me.from=De;function ce(H){return new b.$nQ(a.URI.revive(H.uri),A.to(H.range))}me.to=ce})(Xt||(e.ChatResponseMovePart=Xt={}));var Et;(function(me){function De(ce){return{kind:"progressTask",content:ue.from(ce.value)}}me.from=De})(Et||(e.ChatTask=Et={}));var si;(function(me){function De(ce){return{kind:"progressTaskResult",content:typeof ce=="string"?ue.from(ce):void 0}}me.from=De})(si||(e.ChatTaskResult=si={}));var Yt;(function(me){function De(H,ke,We){return{kind:"command",command:ke.toInternal(H.value,We)??{command:H.value.command,title:H.value.title}}}me.from=De;function ce(H,ke){return new b.$kQ(ke.fromInternal(H.command)??{command:H.command.id,title:H.command.title})}me.to=ce})(Yt||(e.ChatResponseCommandButtonPart=Yt={}));var Ni;(function(me){function De(H){return{kind:"textEdit",uri:H.uri,edits:H.edits.map(ke=>be.from(ke))}}me.from=De;function ce(H){return new b.$oQ(a.URI.revive(H.uri),H.edits.map(ke=>be.to(ke)))}me.to=ce})(Ni||(e.ChatResponseTextEditPart=Ni={}));var di;(function(me){function De(H){const ke=$.ThemeIcon.isThemeIcon(H.iconPath)?H.iconPath:a.URI.isUri(H.iconPath)?{light:a.URI.revive(H.iconPath)}:H.iconPath&&"light"in H.iconPath&&"dark"in H.iconPath&&a.URI.isUri(H.iconPath.light)&&a.URI.isUri(H.iconPath.dark)?{light:a.URI.revive(H.iconPath.light),dark:a.URI.revive(H.iconPath.dark)}:void 0;return typeof H.value=="object"&&"variableName"in H.value?{kind:"reference",reference:{variableName:H.value.variableName,value:a.URI.isUri(H.value.value)||!H.value.value?H.value.value:F.from(H.value.value)},iconPath:ke,options:H.options}:{kind:"reference",reference:a.URI.isUri(H.value)||typeof H.value=="string"?H.value:F.from(H.value),iconPath:ke,options:H.options}}me.from=De;function ce(H){const ke=(0,s.$hi)(H),We=Ye=>a.URI.isUri(Ye)?Ye:F.to(Ye);return new b.$lQ(typeof ke.reference=="string"?ke.reference:"variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&We(ke.reference.value)}:We(ke.reference))}me.to=ce})(di||(e.ChatResponseReferencePart=di={}));var yi;(function(me){function De(ce){return{kind:"codeCitation",value:ce.value,license:ce.license,snippet:ce.snippet}}me.from=De})(yi||(e.ChatResponseCodeCitationPart=yi={}));var qt;(function(me){function De(ke,We,Ye){return ke instanceof b.$bQ?ni.from(ke):ke instanceof b.$gQ?Nt.from(ke):ke instanceof b.$lQ?di.from(ke):ke instanceof b.$hQ?Ct.from(ke):ke instanceof b.$fQ?ui.from(ke):ke instanceof b.$kQ?Yt.from(ke,We,Ye):ke instanceof b.$oQ?Ni.from(ke):ke instanceof b.$cQ?ri.from(ke):ke instanceof b.$dQ?Gt.from(ke):ke instanceof b.$jQ?vt.from(ke):ke instanceof b.$eQ?Jt.from(ke):ke instanceof b.$mQ?yi.from(ke):ke instanceof b.$nQ?Xt.from(ke):{kind:"markdownContent",content:ue.from("")}}me.from=De;function ce(ke,We){switch(ke.kind){case"reference":return di.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return H(ke,We)}}me.to=ce;function H(ke,We){switch(ke.kind){case"markdownContent":return ni.to(ke);case"inlineReference":return Nt.to(ke);case"progressMessage":return;case"treeData":return ui.to(ke);case"command":return Yt.to(ke,We)}}me.toContent=H})(qt||(e.ChatResponsePart=qt={}));var fi;(function(me){function De(ce,H){const ke=ce.variables.variables.filter(Ye=>Ye.isTool),We=ce.variables.variables.filter(Ye=>!Ye.isTool);return{prompt:ce.message,command:ce.command,attempt:ce.attempt??0,enableCommandDetection:ce.enableCommandDetection??!0,isParticipantDetected:ce.isParticipantDetected??!1,references:We.map(Rt.to),toolReferences:ke.map(Si.to),location:Fi.to(ce.location),acceptedConfirmationData:ce.acceptedConfirmationData,rejectedConfirmationData:ce.rejectedConfirmationData,location2:H}}me.to=De})(fi||(e.ChatAgentRequest=fi={}));var Fi;(function(me){function De(H){switch(H){case d.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case d.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case d.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case d.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}me.to=De;function ce(H){switch(H){case b.ChatLocation.Notebook:return d.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return d.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return d.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return d.ChatAgentLocation.Editor}}me.from=ce})(Fi||(e.ChatLocation=Fi={}));var Rt;(function(me){function De(ce){const H=ce.value;if(!H)throw new Error("Invalid value reference");return{id:ce.id,name:ce.name,range:ce.range&&[ce.range.start,ce.range.endExclusive],value:(0,a.$Ac)(H)?a.URI.revive(H):H&&typeof H=="object"&&"uri"in H&&"range"in H&&(0,a.$Ac)(H.uri)?F.to((0,s.$hi)(H)):H,modelDescription:ce.modelDescription}}me.to=De})(Rt||(e.ChatPromptReference=Rt={}));var Si;(function(me){function De(ce){if(ce.value)throw new Error("Invalid tool reference");return{id:ce.id,range:ce.range&&[ce.range.start,ce.range.endExclusive]}}me.to=De})(Si||(e.ChatLanguageModelToolReference=Si={}));var Ai;(function(me){function De(ce,H,ke){return{id:ce.id,label:ce.label,fullName:ce.fullName,icon:ce.icon?.id,value:ce.values[0].value,insertText:ce.insertText,detail:ce.detail,documentation:ce.documentation,command:H.toInternal(ce.command,ke)}}me.from=De})(Ai||(e.ChatAgentCompletionItem=Ai={}));var gi;(function(me){function De(ce){return{errorDetails:ce.errorDetails,metadata:ce.metadata,nextQuestion:ce.nextQuestion}}me.to=De})(gi||(e.ChatAgentResult=gi={}));var zi;(function(me){function De(ce,H,ke){if(H.action.kind==="vote")return;const We=gi.to(ce);if(H.action.kind==="command"){const Ye=H.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:We}}else return H.action.kind==="followUp"?{action:{kind:"followUp",followup:Mt.to(H.action.followup)},result:We}:H.action.kind==="inlineChat"?{action:{kind:"editor",accepted:H.action.action==="accepted"},result:We}:{action:H.action,result:We}}me.to=De})(zi||(e.ChatAgentUserActionEvent=zi={}));var ji;(function(me){function De(H){return{...H,string:H.toString()}}me.from=De;function ce(H){const ke={...H,toString:()=>H.string};return delete ke.string,ke}me.to=ce})(ji||(e.LanguageModelToolResult=ji={}));var zt;(function(me){function De(ce,H,ke){return"terminalCommand"in ce?{terminalCommand:ce.terminalCommand,shouldExecute:ce.shouldExecute}:"uri"in ce?{uri:ce.uri}:H.toInternal(ce,ke)}me.from=De})(zt||(e.TerminalQuickFix=zt={}));var Pi;(function(me){function De(ce){return{kind:Di.to(ce.kind)}}me.to=De})(Pi||(e.PartialAcceptInfo=Pi={}));var Di;(function(me){function De(ce){switch(ce){case n.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}me.to=De})(Di||(e.PartialAcceptTriggerKind=Di={}));var wi;(function(me){function De(ce,H){return{id:H,label:ce.label,description:ce.description,canEdit:ce.canEdit,collapsibleState:ce.collapsibleState||E.DebugTreeItemCollapsibleState.None,contextValue:ce.contextValue}}me.from=De})(wi||(e.DebugTreeItem=wi={}));var bi;(function(me){function De(ce){return{id:ce.id,modelDescription:ce.modelDescription,parametersSchema:ce.parametersSchema,displayName:ce.displayName}}me.to=De})(bi||(e.LanguageModelToolDescription=bi={}))}),define(Re[232],Oe([1,0,5,16,8,39]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=void 0;let R=class{constructor(m,s){this.a=m.getProxy(v.$_N.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>s.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,s,I){const w=new L.$7w(P.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(w,void 0,I?.isRefactoring??!1)}};e.$0qc=R,e.$0qc=R=Ke([qe(0,D.$MQ)],R)}),define(Re[233],Oe([1,0,17,10,42,6,41,4,34,69,14,2,18,5,8,7,117,194,21]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0,$=Ve($),r=Ve(r);class i{constructor(l,g,f,d,S){this.j=l,this.k=g,this.l=f,this.m=d,this.n=S,this.b=s.$ke.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let g=function(d){if(l.c){const S=new Error("Response stream has been closed");throw Error.captureStackTrace(S,d),S}};const l=this;this.b.reset();const f=(d,S)=>{if(typeof this.d>"u"&&(d.kind==="markdownContent"||d.kind==="markdownVuln")&&(this.d=this.b.elapsed()),S){const E=this.l.$handleProgressChunk(this.k.requestId,d),y={report:C=>{E?.then(O=>{O&&(r.$FO.isMarkdownString(C.value)?this.l.$handleProgressChunk(this.k.requestId,$.ChatResponseWarningPart.from(C),O):this.l.$handleProgressChunk(this.k.requestId,$.ChatResponseReferencePart.from(C),O))})}};Promise.all([E,S?.(y)]).then(([C,O])=>{C!==void 0&&this.l.$handleProgressChunk(this.k.requestId,$.ChatTaskResult.from(O),C)})}else this.l.$handleProgressChunk(this.k.requestId,d)};this.g={markdown(d){g(this.markdown);const S=new r.$bQ(d),E=$.ChatResponseMarkdownPart.from(S);return f(E),this},markdownWithVulnerabilities(d,S){g(this.markdown),S&&(0,c.$BH)(l.j,"chatParticipantAdditions");const E=new r.$cQ(d,S),y=$.ChatResponseMarkdownWithVulnerabilitiesPart.from(E);return f(y),this},filetree(d,S){g(this.filetree);const E=new r.$fQ(d,S),y=$.ChatResponseFilesPart.from(E);return f(y),this},anchor(d,S){g(this.anchor);const E=new r.$gQ(d,S),y=$.ChatResponseAnchorPart.from(E);return f(y),this},button(d){g(this.anchor);const S=new r.$kQ(d),E=$.ChatResponseCommandButtonPart.from(S,l.m,l.n);return f(E),this},progress(d,S){g(this.progress);const E=new r.$iQ(d,S),y=S?$.ChatTask.from(E):$.ChatResponseProgressPart.from(E);return f(y,S),this},warning(d){g(this.progress),(0,c.$BH)(l.j,"chatParticipantAdditions");const S=new r.$jQ(d),E=$.ChatResponseWarningPart.from(S);return f(E),this},reference(d,S){return this.reference2(d,S)},reference2(d,S,E){if(g(this.reference),typeof d=="object"&&"variableName"in d&&(0,c.$BH)(l.j,"chatParticipantAdditions"),typeof d=="object"&&"variableName"in d&&!d.value){const y=l.k.variables.variables.find(C=>C.name===d.variableName);if(y){let C;if(y.references?.length)C=y.references.map(O=>({kind:"reference",reference:{variableName:d.variableName,value:O.reference}}));else{const O=new r.$lQ(d,S,E);C=[$.ChatResponseReferencePart.from(O)]}return C.forEach(O=>f(O)),this}}else{const y=new r.$lQ(d,S,E),C=$.ChatResponseReferencePart.from(y);f(C)}return this},codeCitation(d,S,E){g(this.codeCitation),(0,c.$BH)(l.j,"chatParticipantAdditions");const y=new r.$mQ(d,S,E),C=$.ChatResponseCodeCitationPart.from(y);f(C)},textEdit(d,S){g(this.textEdit),(0,c.$BH)(l.j,"chatParticipantAdditions");const E=new r.$oQ(d,S),y=$.ChatResponseTextEditPart.from(E);return f(y),this},detectedParticipant(d,S){g(this.detectedParticipant),(0,c.$BH)(l.j,"chatParticipantAdditions");const E=new r.$dQ(d,S),y=$.ChatResponseDetectedParticipantPart.from(E);return f(y),this},confirmation(d,S,E,y){g(this.confirmation),(0,c.$BH)(l.j,"chatParticipantAdditions");const C=new r.$eQ(d,S,E,y),O=$.ChatResponseConfirmationPart.from(C);return f(O),this},push(d){if(g(this.push),(d instanceof r.$oQ||d instanceof r.$cQ||d instanceof r.$dQ||d instanceof r.$jQ||d instanceof r.$eQ||d instanceof r.$mQ||d instanceof r.$nQ)&&(0,c.$BH)(l.j,"chatParticipantAdditions"),d instanceof r.$lQ)this.reference2(d.value,d.iconPath,d.options);else{const S=$.ChatResponsePart.from(d,l.m,l.n);f(S)}return this}}}return this.g}}class n extends T.$Zc{static{this.b=0}static{this.j=0}constructor(l,g,f,d){super(),this.t=g,this.u=f,this.w=d,this.c=new Map,this.m=new Map,this.n=this.B(new T.$9c),this.s=this.B(new T.$9c),this.g=l.getProxy(k.$_N.MainThreadChatAgents2)}transferActiveChat(l){this.g.$transferActiveChatSession(l)}createChatAgent(l,g,f){const d=n.b++,S=new t(l,g,this.g,d,f);return this.c.set(d,S),this.g.$registerAgent(d,l.identifier,g,{},void 0),S.apiAgent}createDynamicChatAgent(l,g,f,d){const S=n.b++,E=new t(l,g,this.g,S,d);return this.c.set(S,E),this.g.$registerAgent(S,l.identifier,g,{isSticky:!0},f),E.apiAgent}registerChatParticipantDetectionProvider(l){const g=n.j++;return this.m.set(g,l),this.g.$registerChatParticipantDetectionProvider(g),(0,T.$Xc)(()=>{this.m.delete(g),this.g.$unregisterChatParticipantDetectionProvider(g)})}async $detectChatParticipant(l,g,f,d,S){const{request:E,location:y,history:C}=await this.y(g,f),O=this.m.get(l);if(O)return O.provideParticipantDetection($.ChatAgentRequest.to(E,y),{history:C},{participants:d.participants,location:$.ChatLocation.to(d.location)},S)}async y(l,g){const f=(0,m.$hi)(l),d=await this.z(f.agentId,g);let S;if(f.locationData?.type===a.ChatAgentLocation.Editor){const E=this.w.getDocument(f.locationData.document);S=new r.$rQ(E,$.Selection.to(f.locationData.selection),$.Range.to(f.locationData.wholeRange))}else if(f.locationData?.type===a.ChatAgentLocation.Notebook){const E=this.w.getDocument(f.locationData.sessionInputUri);S=new r.$sQ(E)}else f.locationData?.type,a.ChatAgentLocation.Terminal;return{request:f,location:S,history:d}}async $invokeAgent(l,g,f,d){const S=this.c.get(l);if(!S)throw new Error(`[CHAT](${l}) CANNOT invoke agent because the agent is not registered`);let E;try{const{request:y,location:C,history:O}=await this.y(g,f);let p=this.n.get(y.sessionId);p||(p=new T.$Yc,this.n.set(y.sessionId,p)),E=new i(S.extension,y,this.g,this.u.converter,p);const b=S.invoke($.ChatAgentRequest.to(y,C),{history:O},E.apiObject,d);return await(0,D.$yh)(Promise.resolve(b).then(M=>{if(M?.metadata)try{JSON.stringify(M.metadata)}catch(F){const G=`result.metadata MUST be JSON.stringify-able. Got error: ${F.message}`;return this.t.error(`[${S.extension.identifier.value}] [@${S.id}] ${G}`,S.extension),{errorDetails:{message:G},timings:E?.timings,nextQuestion:M.nextQuestion}}let A;return M?.errorDetails&&(A={...M.errorDetails,responseIsIncomplete:!0}),A?.responseIsRedacted&&(0,c.$BH)(S.extension,"chatParticipantPrivate"),{errorDetails:A,timings:E?.timings,metadata:M?.metadata,nextQuestion:M?.nextQuestion}}),d)}catch(y){return this.t.error(y,S.extension),y instanceof r.$AQ&&y.cause&&(y=y.cause),{errorDetails:{message:(0,P.$vj)(y),responseIsIncomplete:!0}}}finally{E?.close()}}async z(l,g){const f=[];for(const d of g.history){const S=$.ChatAgentResult.to(d.result),E=l===d.request.agentId?S:{...S,metadata:void 0},y=d.request.variables.variables.filter(b=>!b.isTool).map($.ChatPromptReference.to),C=d.request.variables.variables.filter(b=>b.isTool).map($.ChatLanguageModelToolReference.to),O=new r.$pQ(d.request.message,d.request.command,y,d.request.agentId);O.toolReferences=C,f.push(O);const p=(0,v.$Lb)(d.response.map(b=>$.ChatResponsePart.toContent(b,this.u.converter)));f.push(new r.$qQ(p,E,d.request.agentId,d.request.command))}return f}$releaseSession(l){this.n.deleteAndDispose(l)}async $provideFollowups(l,g,f,d,S){const E=this.c.get(g);if(!E)return Promise.resolve([]);const y=(0,m.$hi)(l),C=await this.z(E.id,d),O=$.ChatAgentResult.to(f);return(await E.provideFollowups(O,{history:C},S)).filter(p=>{const b=!p.participant||R.Iterable.some(this.c.values(),M=>M.id===p.participant&&u.$xn.equals(M.extension.identifier,E.extension.identifier));return b||this.t.warn(`[@${E.id}] ChatFollowup refers to an unknown participant: ${p.participant}`),b}).map(p=>$.ChatFollowup.from(p,y))}$acceptFeedback(l,g,f){const d=this.c.get(l);if(!d)return;const S=$.ChatAgentResult.to(g);let E;switch(f.direction){case h.ChatAgentVoteDirection.Down:E=r.ChatResultFeedbackKind.Unhelpful;break;case h.ChatAgentVoteDirection.Up:E=r.ChatResultFeedbackKind.Helpful;break}const y={result:S,kind:E,unhelpfulReason:(0,c.$AH)(d.extension,"chatParticipantAdditions")?f.reason:void 0};d.acceptFeedback(Object.freeze(y))}$acceptAction(l,g,f){const d=this.c.get(l);if(!d||f.action.kind==="vote")return;const S=$.ChatAgentUserActionEvent.to(g,f,this.u.converter);S&&d.acceptAction(Object.freeze(S))}async $invokeCompletionProvider(l,g,f){const d=this.c.get(l);if(!d)return[];let S=this.s.get(l);return S?S.clear():(S=new T.$Yc,this.s.set(l,S)),(await d.invokeCompletionProvider(g,f)).map(y=>$.ChatAgentCompletionItem.from(y,this.u.converter,S))}async $provideWelcomeMessage(l,g,f){const d=this.c.get(l);if(d)return await d.provideWelcomeMessage($.ChatLocation.to(g),f)}async $provideChatTitle(l,g,f){const d=this.c.get(l);if(!d)return;const S=await this.z(d.id,{history:g});return await d.provideTitle({history:S},f)}async $provideSampleQuestions(l,g,f){const d=this.c.get(l);if(d)return(await d.provideSampleQuestions($.ChatLocation.to(g),f)).map(S=>$.ChatFollowup.from(S,void 0))}}e.$$qc=n;class t{constructor(l,g,f,d,S){this.extension=l,this.id=g,this.w=f,this.x=d,this.y=S,this.l=new L.$qe,this.m=new L.$qe}acceptFeedback(l){this.l.fire(l)}acceptAction(l){this.m.fire(l)}async invokeCompletionProvider(l,g){return this.o?await this.o.provider.provideCompletionItems(l,g)??[]:[]}async provideFollowups(l,g,f){if(!this.b)return[];const d=await this.b.provideFollowups(l,g,f);return d?d.filter(S=>!(S&&"commandId"in S)).filter(S=>!(S&&"message"in S)):[]}async provideWelcomeMessage(l,g){if(!this.q)return[];const f=await this.q.provideWelcomeMessage(l,g);return f?f.map(d=>typeof d=="string"?d:$.MarkdownString.from(d)):[]}async provideTitle(l,g){if(this.s)return await this.s.provideChatTitle(l,g)??void 0}async provideSampleQuestions(l,g){if(!this.q||!this.q.provideSampleQuestions)return[];const f=await this.q.provideSampleQuestions(l,g);return f||[]}get apiAgent(){let l=!1,g=!1;const f=()=>{l||g||(g=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof w.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof r.$aP?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.k,helpTextPrefix:!this.d||typeof this.d=="string"?this.d:$.MarkdownString.from(this.d),helpTextVariablesPrefix:!this.g||typeof this.g=="string"?this.g:$.MarkdownString.from(this.g),helpTextPostfix:!this.j||typeof this.j=="string"?this.j:$.MarkdownString.from(this.j),supportIssueReporting:this.n,requester:this.t,supportsSlowVariables:this.u}),g=!1}))},d=this;return{get id(){return d.id},get iconPath(){return d.c},set iconPath(S){d.c=S,f()},get requestHandler(){return d.y},set requestHandler(S){(0,I.$tg)(typeof S=="function","Invalid request handler"),d.y=S},get followupProvider(){return d.b},set followupProvider(S){d.b=S,f()},get helpTextPrefix(){return(0,c.$BH)(d.extension,"defaultChatParticipant"),d.d},set helpTextPrefix(S){(0,c.$BH)(d.extension,"defaultChatParticipant"),d.d=S,f()},get helpTextVariablesPrefix(){return(0,c.$BH)(d.extension,"defaultChatParticipant"),d.g},set helpTextVariablesPrefix(S){(0,c.$BH)(d.extension,"defaultChatParticipant"),d.g=S,f()},get helpTextPostfix(){return(0,c.$BH)(d.extension,"defaultChatParticipant"),d.j},set helpTextPostfix(S){(0,c.$BH)(d.extension,"defaultChatParticipant"),d.j=S,f()},get isSecondary(){return(0,c.$BH)(d.extension,"defaultChatParticipant"),d.k},set isSecondary(S){(0,c.$BH)(d.extension,"defaultChatParticipant"),d.k=S,f()},get supportIssueReporting(){return(0,c.$BH)(d.extension,"chatParticipantPrivate"),d.n},set supportIssueReporting(S){(0,c.$BH)(d.extension,"chatParticipantPrivate"),d.n=S,f()},get onDidReceiveFeedback(){return d.l.event},set participantVariableProvider(S){if((0,c.$BH)(d.extension,"chatParticipantAdditions"),d.o=S,S){if(!S.triggerCharacters.length)throw new Error("triggerCharacters are required");d.w.$registerAgentCompletionsProvider(d.x,d.id,S.triggerCharacters)}else d.w.$unregisterAgentCompletionsProvider(d.x,d.id)},get participantVariableProvider(){return(0,c.$BH)(d.extension,"chatParticipantAdditions"),d.o},set welcomeMessageProvider(S){(0,c.$BH)(d.extension,"defaultChatParticipant"),d.q=S,f()},get welcomeMessageProvider(){return(0,c.$BH)(d.extension,"defaultChatParticipant"),d.q},set titleProvider(S){(0,c.$BH)(d.extension,"defaultChatParticipant"),d.s=S,f()},get titleProvider(){return(0,c.$BH)(d.extension,"defaultChatParticipant"),d.s},onDidPerformAction:(0,c.$AH)(this.extension,"chatParticipantAdditions")?this.m.event:void 0,set requester(S){d.t=S,f()},get requester(){return d.t},set supportsSlowReferences(S){(0,c.$BH)(d.extension,"chatParticipantPrivate"),d.u=S,f()},get supportsSlowReferences(){return(0,c.$BH)(d.extension,"chatParticipantPrivate"),d.u},dispose(){l=!0,d.b=void 0,d.l.dispose(),d.w.$unregisterAgent(d.x)}}}invoke(l,g,f,d){return this.y(l,g,f,d)}}}),define(Re[234],Oe([1,0,12,4,36,5,8,7,21]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_qc=void 0,R=Ve(R),T=Ve(T);class s{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(L.$_N.MainThreadChatVariables)}async $resolveVariable(u,k,$,r){const a=this.b.get(u);if(a)try{if(a.resolver.resolve2){(0,m.$BH)(a.extension,"chatParticipantAdditions");const h=new I(k,this.c),c=await a.resolver.resolve2(a.data.name,{prompt:$},h.apiObject,r);if(c&&c[0])return c[0].value}else{const h=await a.resolver.resolve(a.data.name,{prompt:$},r);if(h&&h[0])return h[0].value}}catch(h){(0,v.$5)(h)}}registerVariableResolver(u,k,$,r,a,h,c,i,n){const t=s.a++,o=n?P.ThemeIcon.fromId(n):void 0;return this.b.set(t,{extension:u,data:{id:k,name:$,description:r,modelDescription:a,icon:o},resolver:c}),this.c.$registerVariable(t,{id:k,name:$,description:r,modelDescription:a,isSlow:h,fullName:i,icon:o}),(0,D.$Xc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$_qc=s;class I{constructor(u,k){this.c=u,this.d=k,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let k=function(r){if(u.a){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,r),a}};const u=this,$=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){k(this.progress);const a=new T.$hQ(r),h=R.ChatResponseProgressPart.from(a);return $(h),this},reference(r){k(this.reference);const a=new T.$lQ(r),h=R.ChatResponseReferencePart.from(a);return $(h),this},push(r){return k(this.push),r instanceof T.$lQ?$(R.ChatResponseReferencePart.from(r)):r instanceof T.$hQ&&$(R.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Re[235],Oe([1,0,10,71,6,4,38,2,94,18,8,7,5,21]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=$,m=Ve(m),I=Ve(I),w=Ve(w);function $(r,a,h){const c=r.getProxy(u.$_N.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new s.$zn,a.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===R.MarshalledId.CommentController){const C=this.b.get(y.handle);return C?C.value:y}else if(y&&y.$mid===R.MarshalledId.CommentThread){const C=y,O=this.b.get(C.commentControlHandle);if(!O)return C;const p=O.getCommentThread(C.commentThreadHandle);return p?p.value:C}else if(y&&(y.$mid===R.MarshalledId.CommentThreadReply||y.$mid===R.MarshalledId.CommentThreadInstance)){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const O=C.getCommentThread(y.thread.commentThreadHandle);return O?y.$mid===R.MarshalledId.CommentThreadInstance?O.value:{thread:O.value,text:y.text}:y}else if(y&&y.$mid===R.MarshalledId.CommentNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const O=C.getCommentThread(y.thread.commentThreadHandle);if(!O)return y;const p=y.commentUniqueId,b=O.getCommentByUniqueId(p);return b||y}else if(y&&y.$mid===R.MarshalledId.CommentThreadNode){const C=this.b.get(y.thread.commentControlHandle);if(!C)return y;const O=C.getCommentThread(y.thread.commentThreadHandle);if(!O)return y;const p=y.text,b=y.commentUniqueId,M=O.getCommentByUniqueId(b);return M?(typeof M.body=="string"?M.body=p:M.body=new w.$FO(p),M):y}return y}})}createCommentController(y,C,O){const p=i.a++,b=new t(y,p,C,O);this.b.set(b.handle,b);const M=this.c.get(y.identifier)||[];return M.push(b),this.c.set(y.identifier,M),b.value}async $createCommentThreadTemplate(y,C,O,p){const b=this.b.get(y);b&&b.$createCommentThreadTemplate(C,O,p)}async $setActiveComment(y,C){const O=this.b.get(y);O&&O.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(y,C,O){const p=this.b.get(y);p&&p.$updateCommentThreadTemplate(C,O)}$deleteCommentThread(y,C){this.b.get(y)?.$deleteCommentThread(C)}async $provideCommentingRanges(y,C,O){const p=this.b.get(y);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const b=await h.ensureDocumentData(T.URI.revive(C));return(0,v.$Ch)(async()=>{const M=await p.commentingRangeProvider.provideCommentingRanges(b.document,O);let A;return Array.isArray(M)?A={ranges:M,fileComments:!1}:M?A={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:A=M??void 0,A}).then(M=>{let A;return M&&(A={ranges:M.ranges.map(F=>I.Range.from(F)),fileComments:M.fileComments}),A})}$toggleReaction(y,C,O,p,b){const M=this.b.get(y);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,v.$Ch)(()=>{const A=M.getCommentThread(C);if(A){const F=A.getCommentByUniqueId(p.uniqueIdInThread);if(M!==void 0&&F&&M.reactionHandler)return M.reactionHandler(F,g(b))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,k.$BH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,C,O,p,b,M,A,F,G){this.m=C,this.n=O,this.o=p,this.p=b,this.q=M,this.extensionDescription=A,this.r=F,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$qe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$1c,this.l.value=new L.$Yc,this.n===void 0&&(this.n=`${y}.${this.handle}`),c.$createCommentThread(C,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(j=>o(this,j,this.k,this.extensionDescription)),A.identifier,this.r,G),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{c.$deleteCommentThread(C,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(j){x.range=j},get comments(){return x.comments},set comments(j){x.comments=j},get collapsibleState(){return x.collapsibleState},set collapsibleState(j){x.collapsibleState=j},get canReply(){return x.canReply},set canReply(j){x.canReply=j},get contextValue(){return x.contextValue},set contextValue(j){x.contextValue=j},get label(){return x.label},set label(j){x.label=j},get state(){return x.state},set state(j){x.state=j},reveal:(j,U)=>x.reveal(j,U),hide:()=>x.hide(),dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Yc);const y=O=>Object.prototype.hasOwnProperty.call(this.b,O),C={};y("range")&&(C.range=I.Range.from(this.p)),y("label")&&(C.label=this.label),y("contextValue")&&(C.contextValue=this.contextValue??null),y("comments")&&(C.comments=this.q.map(O=>o(this,O,this.k,this.extensionDescription))),y("collapsibleState")&&(C.collapseState=f(this.g)),y("canReply")&&(C.canReply=this.canReply),y("state")&&(C.state=d(this.h)),y("applicability")&&(C.applicability=S(this.h)),y("isTemplate")&&(C.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(y){for(const C of this.k){const O=C[0],p=C[1];if(y===p)return O}}async reveal(y,C){(0,k.$BH)(this.extensionDescription,"commentReveal");let O;y&&y.body!==void 0?O=y:C=C??y;let p=O?this.k.get(O):void 0;p??=this.k.get(this.q[0]);let b=!0,M=!1;return C?.focus===w.CommentThreadFocus.Reply?(M=!0,b=!1):C?.focus===w.CommentThreadFocus.Comment&&(b=!1),c.$revealCommentThread(this.m,this.handle,p,{preserveFocus:b,focusReply:M})}async hide(){return c.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Ke([(0,D.$di)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,k.$BH)(this.h,"commentingRangeHint"),c.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,k.$BH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,k.$BH)(this.h,"activeComment"),this.f?.value}constructor(y,C,O,p){this.h=y,this.i=C,this.j=O,this.k=p,this.a=new Map,c.$registerCommentController(this.handle,O,p,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(M){b.options=M},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(M){b.commentingRangeProvider=M},get reactionHandler(){return b.reactionHandler},set reactionHandler(M){b.reactionHandler=M},get activeCommentThread(){return b.activeCommentThread},createCommentThread(M,A,F){return b.createCommentThread(M,A,F).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(y,C,O){C===void 0&&(0,k.$BH)(this.h,"fileComments");const p=new n(this.id,this.handle,void 0,y,C,O,this.h,!1);return this.a.set(p.handle,p),p}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const C=this.a.get(y.commentThreadHandle);C&&(this.e=y.uniqueIdInThread?C.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(y,C,O){const p=new n(this.id,this.handle,void 0,T.URI.revive(y),I.Range.to(C),[],this.h,!0,O);return p.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(y,C){const O=this.a.get(y);O&&(O.range=I.Range.to(C))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function o(E,y,C,O){let p=C.get(y);return p||(p=++E.commentHandle,C.set(y,p)),y.state!==void 0&&(0,k.$BH)(O,"commentsDraftState"),y.reactions?.some(b=>b.reactors!==void 0)&&(0,k.$BH)(O,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:p,body:typeof y.body=="string"?y.body:I.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(b=>l(b)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function l(E){return{label:E.label,iconPath:E.iconPath?I.$LQ(E.iconPath):void 0,count:E.count,hasReacted:E.authorHasReacted,reactors:E.reactors&&E.reactors.length>0&&typeof E.reactors[0]!="string"?E.reactors.map(y=>y.name):E.reactors}}function g(E){return{label:E.label||"",count:E.count||0,iconPath:E.iconPath?T.URI.revive(E.iconPath):"",authorHasReacted:E.hasReacted||!1,reactors:E.reactors?.map(y=>({name:y}))}}function f(E){if(E!==void 0)switch(E){case w.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case w.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function d(E){let y;if(typeof E=="object"?y=E.resolved:y=E,y!==void 0)switch(y){case w.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case w.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function S(E){let y;if(typeof E=="object"&&(y=E.applicability),y!==void 0)switch(y){case w.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case w.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new i}}),define(Re[236],Oe([1,0,19,76,4,15,24,2,8,67,80,5,7]),function(we,e,v,D,P,L,R,T,m,s,I,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=void 0,m=Ve(m),w=Ve(w),u=Ve(u);class k{constructor(l,g){this.document=l,this.b=g,this.a=1,this.c=new I.$Vqc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,g){await this.f(l).undo(),g||this.disposeBackup()}async redo(l,g){await this.f(l).redo(),g||this.disposeBackup()}disposeEdits(l){for(const g of l)this.c.delete(g)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=t(this.document.uri)+this.a++;return(0,R.$lh)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const g=this.c.get(l,0);if(!g)throw new Error("No edit found");return g}}class ${constructor(){this.a=new Map}get(l,g){return this.a.get(this.b(l,g))}add(l,g,f){const d=this.b(l,g.uri);if(this.a.has(d))throw new Error(`Document already exists for viewType:${l} resource:${g.uri}`);const S=new k(g,f);return this.a.set(d,S),S}delete(l,g){const f=this.b(l,g.uri);this.a.delete(f)}b(l,g){return`${l}@@@${g}`}}var r;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(r||(r={}));class a{constructor(){this.a=new Map}addTextProvider(l,g,f){return this.b(l,{type:r.Text,extension:g,provider:f})}addCustomProvider(l,g,f){return this.b(l,{type:r.Custom,extension:g,provider:f})}get(l){return this.a.get(l)}b(l,g){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,g),new u.$bO(()=>this.a.delete(l))}}class h{constructor(l,g,f,d,S){this.d=g,this.f=f,this.g=d,this.h=S,this.b=new a,this.c=new $,this.a=l.getProxy(w.$_N.MainThreadCustomEditors)}registerCustomEditorProvider(l,g,f,d){const S=new P.$Yc;return i(f)?(S.add(this.b.addTextProvider(g,l,f)),this.a.$registerTextEditorProvider((0,s.$src)(l),g,d.webviewOptions||{},{supportsMove:!!f.moveCustomTextEditor},(0,s.$qrc)(l))):(S.add(this.b.addCustomProvider(g,l,f)),c(f)&&S.add(f.onDidChangeCustomDocument(E=>{const y=this.i(g,E.document.uri);if(n(E)){const C=y.addEdit(E);this.a.$onDidEdit(E.document.uri,g,C,E.label)}else this.a.$onContentChange(E.document.uri,g)})),this.a.$registerCustomEditorProvider((0,s.$src)(l),g,d.webviewOptions||{},!!d.supportsMultipleEditorsPerDocument,(0,s.$qrc)(l))),u.$bO.from(S,new u.$bO(()=>{this.a.$unregisterEditorProvider(g)}))}async $createCustomDocument(l,g,f,d,S){const E=this.b.get(g);if(!E)throw new Error(`No provider found for '${g}'`);if(E.type!==r.Custom)throw new Error(`Invalid provide type for '${g}'`);const y=T.URI.revive(l),C=await E.provider.openCustomDocument(y,{backupId:f,untitledDocumentData:d?.buffer},S);let O;return c(E.provider)&&this.f&&(O=this.f.workspaceValue(E.extension)??this.f.globalValue(E.extension)),this.c.add(g,C,O),{editable:c(E.provider)}}async $disposeCustomDocument(l,g){const f=this.b.get(g);if(!f)throw new Error(`No provider found for '${g}'`);if(f.type!==r.Custom)throw new Error(`Invalid provider type for '${g}'`);const d=T.URI.revive(l),{document:S}=this.i(g,d);this.c.delete(g,S),S.dispose()}async $resolveCustomEditor(l,g,f,d,S,E){const y=this.b.get(f);if(!y)throw new Error(`No provider found for '${f}'`);const C=m.ViewColumn.to(S),O=this.g.createNewWebview(g,d.contentOptions,y.extension),p=this.h.createNewWebviewPanel(g,f,d.title,C,d.options,O,d.active),b=T.URI.revive(l);switch(y.type){case r.Custom:{const{document:M}=this.i(f,b);return y.provider.resolveCustomEditor(M,p,E)}case r.Text:{const M=this.d.getDocument(b);return y.provider.resolveCustomTextEditor(M,p,E)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,g,f){this.i(g,l).disposeEdits(f)}async $onMoveCustomEditor(l,g,f){const d=this.b.get(f);if(!d)throw new Error(`No provider found for '${f}'`);if(!d.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${f}'`);const S=this.h.getWebviewPanel(l);if(!S)throw new Error("No webview found");const E=T.URI.revive(g),y=this.d.getDocument(E);await d.provider.moveCustomTextEditor(y,S,v.CancellationToken.None)}async $undo(l,g,f,d){return this.i(g,l).undo(f,d)}async $redo(l,g,f,d){return this.i(g,l).redo(f,d)}async $revert(l,g,f){const d=this.i(g,l);await this.j(g).revertCustomDocument(d.document,f),d.disposeBackup()}async $onSave(l,g,f){const d=this.i(g,l);await this.j(g).saveCustomDocument(d.document,f),d.disposeBackup()}async $onSaveAs(l,g,f,d){const S=this.i(g,l);return this.j(g).saveCustomDocumentAs(S.document,T.URI.revive(f),d)}async $backup(l,g,f){const d=this.i(g,l),E=await this.j(g).backupCustomDocument(d.document,{destination:d.getNewBackupUri()},f);return d.updateBackup(E),E.id}i(l,g){const f=this.c.get(l,T.URI.revive(g));if(!f)throw new Error("No custom document found");return f}j(l){const f=this.b.get(l)?.provider;if(!f||!c(f))throw new Error("Custom document is not editable");return f}}e.$vrc=h;function c(o){return!!o.onDidChangeCustomDocument}function i(o){return typeof o.resolveCustomTextEditor=="function"}function n(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function t(o){const l=o.scheme===L.Schemas.file||o.scheme===L.Schemas.untitled?o.fsPath:o.toString();return(0,D.$yj)(l)+""}}),define(Re[237],Oe([1,0,9,108,2,5,7,8,6,11,27,50]),function(we,e,v,D,P,L,R,T,m,s,I,w){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=e.$3qc=void 0,T=Ve(T);class k{#e;#t;#i;constructor(a,h,c,i,n,t,o,l){this.d=a,this.e=h,this.f=c,this.g=i,this.h=n,this.c=!1,this.f=Math.max(i,c),this.#i=new I.$Fc(g=>t.getComparisonKey(g)),this.#e=o,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,h){if(!a){this.clear();return}this.j();let c=[];if(P.URI.isUri(a)){if(!h){this.delete(a);return}this.#i.set(a,h.slice()),c=[a]}else if(Array.isArray(a)){c=[];let t;a=[...a].sort(k.k);for(const o of a){const[l,g]=o;if((!t||l.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=l,c.push(l),this.#i.set(l,[])),g)this.#i.get(l)?.push(...g);else{const f=this.#i.get(l);f&&(f.length=0)}}}if(this.#t.fire(c),!this.#e)return;const i=[];let n=0;for(const t of c){let o=[];const l=this.#i.get(t);if(l)if(l.length>this.g){o=[];const g=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const d of l)if(d.severity===g[f]&&o.push({...T.Diagnostic.from(d),modelVersionId:this.h(t)})===this.g)break e;o.push({severity:D.MarkerSeverity.Info,message:(0,v.localize)(2700,null,l.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=l.map(g=>({...T.Diagnostic.from(g),modelVersionId:this.h(t)}));if(i.push([t,o]),n+=o.length,n>this.f)break}this.#e.$changeMany(this.e,i)}delete(a){this.j(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(a,h){this.j();for(const[c,i]of this)a.call(h,c,i,this)}*[Symbol.iterator](){this.j();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this.j();const h=this.#i.get(a);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(a){return this.j(),Array.isArray(this.#i.get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,h){return a[0].toString()<h[0].toString()?-1:a[0].toString()>h[0].toString()?1:0}}e.$3qc=k;let $=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(a){const h=new I.$Fc;for(const c of a)h.set(c,c);return{uris:Object.freeze(Array.from(h.values()))}}constructor(a,h,c,i){this.j=h,this.k=c,this.l=i,this.g=new Map,this.h=new m.$ue({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,u._mapper),this.f=a.getProxy(L.$_N.MainThreadDiagnostics)}createDiagnosticCollection(a,h){const{g:c,f:i,h:n,j:t,k:o,l}=this,g=new class{$changeMany(S,E){i.$changeMany(S,E),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,S,E.length===0?"CLEARING":E)}$clear(S){i.$clear(S),t.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,S)}dispose(){i.dispose()}};let f;if(!h)h="_generated_diagnostic_collection_name_#"+u.c++,f=h;else if(!c.has(h))f=h;else{this.j.warn(`DiagnosticCollection with name '${h}' does already exist.`);do f=h+u.c++;while(c.has(f))}return new class extends k{constructor(){super(h,f,u.e,u.d,S=>l.getDocument(S)?.version,o.extUri,g,n),c.set(f,this)}dispose(){super.dispose(),c.delete(f)}}}getDiagnostics(a){if(a)return this.m(a);{const h=new Map,c=[];for(const i of this.g.values())i.forEach((n,t)=>{let o=h.get(n.toString());typeof o>"u"&&(o=c.length,h.set(n.toString(),o),c.push([n,[]])),c[o][1]=c[o][1].concat(...t)});return c}}m(a){let h=[];for(const c of this.g.values())c.has(a)&&(h=h.concat(c.get(a)));return h}$acceptMarkersChange(a){if(!this.n){const h="_generated_mirror",c=new k(h,h,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(h,c),this.n=c}for(const[h,c]of a)this.n.set(P.URI.revive(h),c.map(T.Diagnostic.to))}};e.$4qc=$,e.$4qc=$=u=Ke([qe(1,s.$fk),qe(2,w.$2qc)],$)}),define(Re[238],Oe([1,0,2,12,7,8,172,39]),function(we,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$esc=void 0;class m{constructor(I,w,u,k={timeout:1500,errors:3}){this.c=I,this.d=w,this.f=u,this.g=k,this.a=new R.$0c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(w,u,k)=>{const r={dispose:this.a.push([w,u,I])};return Array.isArray(k)&&k.push(r),r}}async $participateInSave(I,w){const u=v.URI.revive(I);let k=!1;const $=setTimeout(()=>k=!0,this.g.timeout),r=[];try{for(const a of[...this.a]){if(k)break;const h=this.d.getDocument(u),c=await this.h(a,{document:h,reason:L.TextDocumentSaveReason.to(w)});r.push(c)}}finally{clearTimeout($)}return r}h([I,w,u],k){const $=this.b.get(I);return typeof $=="number"&&$>this.g.errors?Promise.resolve(!1):this.i(u,I,w,k).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const a=this.b.get(I);this.b.set(I,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,w,u,k){const $=[],r=Date.now(),{document:a,reason:h}=k,{version:c}=a,i=Object.freeze({document:a,reason:h,waitUntil(n){if(Object.isFrozen($))throw(0,D.$_)("waitUntil can not be called async");$.push(Promise.resolve(n))}});try{w.apply(u,[i])}catch(n){return Promise.reject(n)}return Object.freeze($),new Promise((n,t)=>{const o=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all($).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(o),n(l)}).catch(l=>{clearTimeout(o),t(l)})}).then(n=>{const t={edits:[]};for(const o of n)if(Array.isArray(o)&&o.every(l=>l instanceof P.$kO))for(const{newText:l,newEol:g,range:f}of o)t.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:f&&L.Range.from(f),text:l,eol:g&&L.EndOfLine.from(g)}});if(t.edits.length!==0)return c===a.version?this.f.$tryApplyWorkspaceEdit(new T.$7w(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$esc=m}),define(Re[239],Oe([1,0,6,4,2,5,125,8,14,25,7]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0,T=Ve(T);class w{constructor(k,$){this.a=new v.$qe,this.b=new v.$qe,this.c=new v.$qe,this.d=new v.$qe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new D.$Yc,this.h=new Map,this.f=k.getProxy(L.$_N.MainThreadDocuments),this.g=$,this.g.onDidRemoveDocuments(r=>{for(const a of r)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const a of r)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const $=this.g.getDocument(k);if($)return $}getDocument(k){const $=this.getDocumentData(k);if(!$?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return $.document}ensureDocumentData(k){const $=this.g.getDocument(k);if($)return Promise.resolve($);let r=this.h.get(k.toString());return r||(r=this.f.$tryOpenDocument(k).then(a=>{this.h.delete(k.toString());const h=P.URI.revive(a);return(0,m.$ug)(this.g.getDocument(h))},a=>(this.h.delete(k.toString()),Promise.reject(a))),this.h.set(k.toString(),r)),r}createDocumentData(k){return this.f.$tryCreateDocument(k).then($=>P.URI.revive($))}$acceptModelLanguageChanged(k,$){const r=P.URI.revive(k),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId($),this.a.fire(a.document)}$acceptModelSaved(k){const $=P.URI.revive(k),r=this.g.getDocument($);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(k,$){const r=P.URI.revive(k),a=this.g.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty($),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,$,r){const a=P.URI.revive(k),h=this.g.getDocument(a);if(!h)throw new Error("unknown document");h._acceptIsDirty(r),h.onEvents($);let c;$.isUndoing?c=I.TextDocumentChangeReason.Undo:$.isRedoing&&(c=I.TextDocumentChangeReason.Redo),this.c.fire((0,s.$lo)({document:h.document,contentChanges:$.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:c}))}setWordDefinitionFor(k,$){(0,R.$OQ)(k,$)}}e.$5qc=w}),define(Re[70],Oe([1,0,240,6,14,2,3,5,16,8,7]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xrc=e.$wrc=void 0,s=Ve(s),e.$wrc=(0,R.$Ki)("IExtHostEditorTabs");class w{constructor(a,h,c){this.e=c,this.d=h,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,h={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new I.$2P(L.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new I.$3P(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new I.$4P(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new I.$5P(L.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new I.$6P(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new I.$7P(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new I.$8P(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new I.$9P;case T.TabInputKind.InteractiveEditorInput:return new I.$0P(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new I.$$P;case T.TabInputKind.MultiDiffEditorInput:return new I.$_P(this.b.input.diffEditors.map(a=>new I.$3P(L.URI.revive(a.original),L.URI.revive(a.modified))));default:return}}}class u{constructor(a,h){this.c=[],this.d="",this.b=a,this.e=h;for(const c of a.tabs)c.isActive&&(this.d=c.id),this.c.push(new w(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,h={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return s.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(c=>c.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(c=>c.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===T.TabModelOperationKind.TAB_OPEN){const c=new w(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,c),a.tabDto.isActive&&(this.d=c.tabId),c}else if(a.kind===T.TabModelOperationKind.TAB_CLOSE){const c=this.c.splice(a.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(a.kind===T.TabModelOperationKind.TAB_MOVE){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(a.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,c),c}const h=this.c.find(c=>c.tabId===a.tabDto.id);if(!h)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(a.tabDto),h}activeTabId(){return this.d}}let k=class{constructor(a){this.b=new D.$qe,this.c=new D.$qe,this.e=[],this.a=a.getProxy(T.$_N.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,h={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(c=>c.apiObject))},get activeTabGroup(){const c=a.d;return(0,P.$ug)(a.e.find(n=>n.groupId===c)?.apiObject)},close:async(c,i)=>{const n=Array.isArray(c)?c:[c];return n.length?$(n[0])?this.j(n,i):this.i(n,i):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(a){const h=new Set(this.e.map(g=>g.groupId)),c=new Set(a.map(g=>g.groupId)),i=(0,v.$f)(h,c),n=this.e.filter(g=>i.removed.includes(g.groupId)).map(g=>g.apiObject),t=[],o=[];this.e=a.map(g=>{const f=new u(g,()=>this.d);return i.added.includes(f.groupId)?t.push(f.apiObject):o.push(f.apiObject),f});const l=(0,P.$ug)(a.find(g=>g.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:t,closed:n,changed:o}))}$acceptTabGroupUpdate(a){const h=this.e.find(c=>c.groupId===a.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const h=this.e.find(i=>i.groupId===a.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const c=h.acceptTabOperation(a);switch(a.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(a){for(const h of this.e)for(const c of h.tabs)if(c.apiObject===a)return c}h(a){return this.e.find(h=>h.apiObject===a)}async i(a,h){const c=[];for(const i of a){const n=this.g(i);if(!n)throw new Error("Tab close: Invalid tab not found!");c.push(n.tabId)}return this.a.$closeTab(c,h)}async j(a,h){const c=[];for(const i of a){const n=this.h(i);if(!n)throw new Error("Group close: Invalid group not found!");c.push(n.groupId)}return this.a.$closeGroup(c,h)}};e.$xrc=k,e.$xrc=k=Ke([qe(0,m.$MQ)],k);function $(r){return r.tabs!==void 0}}),define(Re[241],Oe([1,0,2,5,28,4,7,8,285,13,30,20,21,59]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hsc=void 0,P=Ve(P),T=Ve(T);class ${constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const c=this.a.indexOf(h);c>=0&&(this.a.splice(c,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),c=[];let i,n,t=m.State.LastKnownState,o=m.State.LastKnownState;for(const l of h){let g=i?(0,s.$Mf)(i,l):0;for(g===0?n=m.State.Start:n=o;g<l.length;g++)g+1===l.length?(t=o,o=m.State.BeforeColon):o+=1,c.push([n,l.toUpperCase().charCodeAt(g),o]),c.push([n,l.toLowerCase().charCodeAt(g),o]),n=o;i=l,o=t}c.push([m.State.BeforeColon,I.CharCode.Colon,m.State.AfterColon]),c.push([m.State.AfterColon,I.CharCode.Slash,m.State.End]),this.b=new m.$_4(c)}}provideDocumentLinks(h){this.c();const c=[],i=m.$a5.computeLinks({getLineContent(n){return h.lineAt(n-1).text},getLineCount(){return h.lineCount}},this.b);for(const n of i){const t=T.DocumentLink.to(n);t.target&&c.push(t)}return c}}class r{constructor(h,c){this.i=c,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(D.$_N.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,c,i,n={}){if(r.j(i),this.d.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const t=this.h++;this.b.add(c),this.d.add(c),this.c.set(t,i);let o=P.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(o+=P.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(o+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(o+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$BH)(h,"fsChunks"),o+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let l;n.isReadonly&&(0,k.$$k)(n.isReadonly)&&n.isReadonly.value!==""&&(l={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,c,o,l).catch(f=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${c}`),console.error(f)});const g=i.onDidChangeFile(f=>{const d=[];for(const S of f){const{uri:E,type:y}=S;if(E.scheme!==c)continue;let C;switch(y){case R.FileChangeType.Changed:C=P.FileChangeType.UPDATED;break;case R.FileChangeType.Created:C=P.FileChangeType.ADDED;break;case R.FileChangeType.Deleted:C=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:E,type:C})}this.a.$onFileSystemChange(t,d)});return(0,L.$Xc)(()=>{g.dispose(),this.b.delete(c),this.d.delete(c),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:c,ctime:i,mtime:n,size:t,permissions:o}=h;return{type:c,ctime:i,mtime:n,size:t,permissions:o}}$stat(h,c){return Promise.resolve(this.l(h).stat(v.URI.revive(c))).then(i=>r.k(i))}$readdir(h,c){return Promise.resolve(this.l(h).readDirectory(v.URI.revive(c)))}$readFile(h,c){return Promise.resolve(this.l(h).readFile(v.URI.revive(c))).then(i=>w.$Se.wrap(i))}$writeFile(h,c,i,n){return Promise.resolve(this.l(h).writeFile(v.URI.revive(c),i.buffer,n))}$delete(h,c,i){return Promise.resolve(this.l(h).delete(v.URI.revive(c),i))}$rename(h,c,i,n){return Promise.resolve(this.l(h).rename(v.URI.revive(c),v.URI.revive(i),n))}$copy(h,c,i,n){const t=this.l(h);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(c),v.URI.revive(i),n))}$mkdir(h,c){return Promise.resolve(this.l(h).createDirectory(v.URI.revive(c)))}$watch(h,c,i,n){const t=this.l(h).watch(v.URI.revive(i),n);this.f.set(c,t)}$unwatch(h,c){const i=this.f.get(c);i&&(i.dispose(),this.f.delete(c))}$open(h,c,i){const n=this.l(h);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(v.URI.revive(c),i))}$close(h,c){const i=this.l(h);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(c))}$read(h,c,i,n){const t=this.l(h);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const o=w.$Se.alloc(n);return Promise.resolve(t.read(c,i,o.buffer,0,n)).then(l=>o.slice(0,l))}$write(h,c,i,n){const t=this.l(h);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(c,i,n.buffer,0,n.byteLength))}l(h){const c=this.c.get(h);if(!c){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return c}}e.$hsc=r}),define(Re[242],Oe([1,0,6,43,2,5,8,7,28,51]),function(we,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$isc=void 0,R=Ve(R);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor($,r,a,h,c,i){this.a=Math.random(),this.b=new v.$qe,this.c=new v.$qe,this.d=new v.$qe,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,D.$Fk)(c),t=typeof c=="string",o=i?.correlate,l=h(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(o&&typeof g.session>"u")){if(!i?.ignoreCreateEvents)for(const f of g.created){const d=P.URI.revive(f);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const f of g.changed){const d=P.URI.revive(f);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const f of g.deleted){const d=P.URI.revive(f);n(d.fsPath)&&(!t||r.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=T.$bO.from(this.i($,a,c,i,i?.correlate),this.b,this.c,this.d,l)}i($,r,a,h,c){const i=T.$bO.from();if(typeof a=="string"||h?.ignoreChangeEvents&&h?.ignoreCreateEvents&&h?.ignoreDeleteEvents)return i;const n=$.getProxy(L.$_N.MainThreadFileSystemEventService);let t=!1;(a.pattern.includes(D.$Bk)||a.pattern.includes(D.$Ck))&&(t=!0);let o;return c&&(h?.ignoreChangeEvents||h?.ignoreCreateEvents||h?.ignoreDeleteEvents)&&(o=m.FileChangeFilter.UPDATED|m.FileChangeFilter.ADDED|m.FileChangeFilter.DELETED,h?.ignoreChangeEvents&&(o&=~m.FileChangeFilter.UPDATED),h?.ignoreCreateEvents&&(o&=~m.FileChangeFilter.ADDED),h?.ignoreDeleteEvents&&(o&=~m.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.a,a.baseUri,{recursive:t,excludes:h?.excludes??[],filter:o},!!c),T.$bO.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class w{constructor($){this.a=$,this.session=this.a.session,this.b=new s.$Y(()=>this.a.created.map(P.URI.revive)),this.c=new s.$Y(()=>this.a.changed.map(P.URI.revive)),this.d=new s.$Y(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor($,r,a){this.j=$,this.k=r,this.l=a,this.a=new v.$qe,this.b=new v.$qe,this.c=new v.$qe,this.d=new v.$qe,this.g=new v.$se,this.h=new v.$se,this.i=new v.$se,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher($,r,a,h){return new I(this.j,$,r,this.a.event,R.GlobPattern.from(a),h)}$onFileEvent($){this.a.fire(new w($))}$onDidRunFileOperation($,r){switch($){case m.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(a=>({oldUri:P.URI.revive(a.source),newUri:P.URI.revive(a.target)}))}));break;case m.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(a=>P.URI.revive(a.target))}));break;case m.FileOperation.CREATE:case m.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(a=>P.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent($){return this.m($,this.g)}getOnWillCreateFileEvent($){return this.m($,this.h)}getOnWillDeleteFileEvent($){return this.m($,this.i)}m($,r){return(a,h,c)=>{const i=function(t){a.call(h,t)};return i.extension=$,r.event(i,void 0,c)}}async $onWillRunFileOperation($,r,a,h){switch($){case m.FileOperation.MOVE:return await this.n(this.g,{files:r.map(c=>({oldUri:P.URI.revive(c.source),newUri:P.URI.revive(c.target)}))},a,h);case m.FileOperation.DELETE:return await this.n(this.i,{files:r.map(c=>P.URI.revive(c.target))},a,h);case m.FileOperation.CREATE:case m.FileOperation.COPY:return await this.n(this.h,{files:r.map(c=>P.URI.revive(c.target))},a,h)}}async n($,r,a,h){const c=new Set,i=[];if(await $.fireAsync(r,h,async(t,o)=>{const l=Date.now(),g=await Promise.resolve(t);g instanceof T.$nO&&(i.push([o.extension,g]),c.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-l>a&&this.k.warn("SLOW file-participant",o.extension.identifier)}),h.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:o}=R.WorkspaceEdit.from(t,{getTextDocumentVersion:l=>this.l.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(o)}return{edit:n,extensionNames:Array.from(c)}}}e.$isc=u}),define(Re[243],Oe([1,0,17,10,19,12,97,4,25,69,13,14,2,32,286,94,104,9,18,8,7,21,80,5]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0,r=Ve(r),i=Ve(i),l=Ve(l);class g{constructor(W,B){this.d=W,this.e=B}async provideDocumentSymbols(W,B){const Q=this.d.getDocument(W),K=await this.e.provideDocumentSymbols(Q,B);if(!(0,v.$Ob)(K))return K[0]instanceof n.$xO?K.map(i.DocumentSymbol.from):g.f(K)}static f(W){W=W.slice(0).sort((K,se)=>{let ge=K.location.range.start.compareTo(se.location.range.start);return ge===0&&(ge=se.location.range.end.compareTo(K.location.range.end)),ge});const B=[],Q=[];for(const K of W){const se={name:K.name||"!!MISSING: name!!",kind:i.SymbolKind.from(K.kind),tags:K.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:i.Range.from(K.location.range),selectionRange:i.Range.from(K.location.range),children:[]};for(;;){if(Q.length===0){Q.push(se),B.push(se);break}const ge=Q[Q.length-1];if(k.$Wt.containsRange(ge.range,se.range)&&!k.$Wt.equalsRange(ge.range,se.range)){ge.children?.push(se),Q.push(se);break}Q.pop()}}return B}}class f{constructor(W,B,Q,K,se,ge){this.f=W,this.g=B,this.h=Q,this.j=K,this.k=se,this.l=ge,this.d=new o.$Vqc("CodeLens"),this.e=new Map}async provideCodeLenses(W,B){const Q=this.f.getDocument(W),K=await this.h.provideCodeLenses(Q,B);if(!K||B.isCancellationRequested)return;const se=this.d.add(K),ge=new T.$Yc;this.e.set(se,ge);const Ee={cacheId:se,lenses:[]};for(let ze=0;ze<K.length;ze++)Ee.lenses.push({cacheId:[se,ze],range:i.Range.from(K[ze].range),command:this.g.toInternal(K[ze].command,ge)});return Ee}async resolveCodeLens(W,B){const Q=W.cacheId&&this.d.get(...W.cacheId);if(!Q)return;let K;if(typeof this.h.resolveCodeLens!="function"||Q.isResolved?K=Q:K=await this.h.resolveCodeLens(Q,B),K||(K=Q),B.isCancellationRequested)return;const se=W.cacheId&&this.e.get(W.cacheId[0]);if(se){if(!K.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ge),this.l.error(ge);return}return W.command=this.g.toInternal(K.command,se),W}}releaseCodeLenses(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}}function d(Me){return Array.isArray(Me)?Me.map(i.DefinitionLink.from):Me?[i.DefinitionLink.from(Me)]:[]}class S{constructor(W,B){this.d=W,this.e=B}async provideDefinition(W,B,Q){const K=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideDefinition(K,se,Q);return d(ge)}}class E{constructor(W,B){this.d=W,this.e=B}async provideDeclaration(W,B,Q){const K=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideDeclaration(K,se,Q);return d(ge)}}class y{constructor(W,B){this.d=W,this.e=B}async provideImplementation(W,B,Q){const K=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideImplementation(K,se,Q);return d(ge)}}class C{constructor(W,B){this.d=W,this.e=B}async provideTypeDefinition(W,B,Q){const K=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideTypeDefinition(K,se,Q);return d(ge)}}class O{static{this.f=10}constructor(W,B){this.g=W,this.h=B,this.d=0,this.e=new Map}async provideHover(W,B,Q,K){const se=this.g.getDocument(W),ge=i.Position.to(B);let Ee;if(Q&&Q.verbosityRequest){const tt=Q.verbosityRequest.previousHover.id,ct=this.e.get(tt);if(!ct)throw new Error(`Hover with id ${tt} not found`);const it={verbosityDelta:Q.verbosityRequest.verbosityDelta,previousHover:ct};Ee=await this.h.provideHover(se,ge,K,it)}else Ee=await this.h.provideHover(se,ge,K);if(!Ee||(0,v.$Ob)(Ee.contents))return;Ee.range||(Ee.range=se.getWordRangeAtPosition(ge)),Ee.range||(Ee.range=new n.$dO(ge,ge));const ze=i.Hover.from(Ee),Je=this.d;if(this.e.size===O.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Je,Ee),this.d+=1,{...ze,id:Je}}releaseHover(W){this.e.delete(W)}}class p{constructor(W,B){this.d=W,this.e=B}async provideEvaluatableExpression(W,B,Q){const K=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideEvaluatableExpression(K,se,Q);if(ge)return i.EvaluatableExpression.from(ge)}}class b{constructor(W,B){this.d=W,this.e=B}async provideInlineValues(W,B,Q,K){const se=this.d.getDocument(W),ge=await this.e.provideInlineValues(se,i.Range.to(B),i.InlineValueContext.to(Q),K);if(Array.isArray(ge))return ge.map(Ee=>i.InlineValue.from(Ee))}}class M{constructor(W,B){this.d=W,this.e=B}async provideDocumentHighlights(W,B,Q){const K=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideDocumentHighlights(K,se,Q);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class A{constructor(W,B){this.d=W,this.e=B}async provideMultiDocumentHighlights(W,B,Q,K){const se=this.d.getDocument(W),ge=Q.map(Je=>this.d.getDocument(Je)),Ee=i.Position.to(B),ze=await this.e.provideMultiDocumentHighlights(se,Ee,ge,K);if(Array.isArray(ze))return ze.map(i.MultiDocumentHighlight.from)}}class F{constructor(W,B){this.d=W,this.e=B}async provideLinkedEditingRanges(W,B,Q){const K=this.d.getDocument(W),se=i.Position.to(B),ge=await this.e.provideLinkedEditingRanges(K,se,Q);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,v.$Lb)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class G{constructor(W,B){this.d=W,this.e=B}async provideReferences(W,B,Q,K){const se=this.d.getDocument(W),ge=i.Position.to(B),Ee=await this.e.provideReferences(se,ge,Q,K);if(Array.isArray(Ee))return Ee.map(i.location.from)}}class x{static{this.d=1e3}constructor(W,B,Q,K,se,ge,Ee){this.g=W,this.h=B,this.j=Q,this.k=K,this.l=se,this.m=ge,this.n=Ee,this.e=new o.$Vqc("CodeAction"),this.f=new Map}async provideCodeActions(W,B,Q,K){const se=this.g.getDocument(W),ge=$.$Yt.isISelection(B)?i.Selection.to(B):i.Range.to(B),Ee=[];for(const it of this.j.getDiagnostics(W))if(ge.intersection(it.range)&&Ee.push(it)>x.d)break;const ze={diagnostics:Ee,only:Q.only?new n.$zO(Q.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Q.trigger)},Je=await this.k.provideCodeActions(se,ge,ze,K);if(!(0,v.$Pb)(Je)||K.isCancellationRequested)return;const _e=this.e.add(Je),tt=new T.$Yc;this.f.set(_e,tt);const ct=[];for(let it=0;it<Je.length;it++){const at=Je[it];if(at)if(x.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ct.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,tt)});else{ze.only&&(at.kind?ze.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const yt=at.ranges??[];ct.push({cacheId:[_e,it],title:at.title,command:at.command&&this.h.toInternal(at.command,tt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.$AH)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,t.$AH)(this.m,"codeActionRanges")?(0,v.$Lb)(yt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:_e,actions:ct}}async resolveCodeAction(W,B){const[Q,K]=W,se=this.e.get(Q,K);if(!se||x.o(se))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(se,B)??se;let Ee;ge.edit&&(Ee=i.WorkspaceEdit.from(ge.edit,void 0));let ze;if(ge.command){const Je=this.f.get(Q);Je&&(ze=this.h.toInternal(ge.command,Je))}return{edit:Ee,command:ze}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}class j{constructor(W,B,Q,K,se){this.e=W,this.f=B,this.g=Q,this.h=K,this.j=se,this.d=new o.$Vqc("DocumentPasteEdit")}async prepareDocumentPaste(W,B,Q,K){if(!this.g.prepareDocumentPaste)return;const se=this.f.getDocument(W),ge=B.map(Je=>i.Range.to(Je)),Ee=i.DataTransfer.toDataTransfer(Q,()=>{throw new L.$cb});if(await this.g.prepareDocumentPaste(se,ge,Ee,K),K.isCancellationRequested)return;const ze=Array.from(Ee).filter(([,Je])=>!(Je instanceof n.$6O));return i.DataTransfer.from(ze)}async providePasteEdits(W,B,Q,K,se,ge){if(!this.g.provideDocumentPasteEdits)return[];const Ee=this.f.getDocument(B),ze=Q.map(ct=>i.Range.to(ct)),Je=i.DataTransfer.toDataTransfer(K,async ct=>(await this.e.$resolvePasteFileData(this.h,W,ct)).buffer),_e=await this.g.provideDocumentPasteEdits(Ee,ze,Je,{only:se.only?new n.$$O(se.only):void 0,triggerKind:se.triggerKind},ge);if(!_e||ge.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((ct,it)=>({_cacheId:[tt,it],title:ct.title??(0,h.localize)(2703,null,this.j.displayName||this.j.name),kind:ct.kind,yieldTo:ct.yieldTo?.map(at=>at.value),insertText:typeof ct.insertText=="string"?ct.insertText:{snippet:ct.insertText.value},additionalEdit:ct.additionalEdit?i.WorkspaceEdit.from(ct.additionalEdit,void 0):void 0}))}async resolvePasteEdit(W,B){const[Q,K]=W,se=this.d.get(Q,K);if(!se||!this.g.resolveDocumentPasteEdit)return{};const ge=await this.g.resolveDocumentPasteEdit(se,B)??se;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(W){this.d.delete(W)}}class U{constructor(W,B){this.d=W,this.e=B}async provideDocumentFormattingEdits(W,B,Q){const K=this.d.getDocument(W),se=await this.e.provideDocumentFormattingEdits(K,B,Q);if(Array.isArray(se))return se.map(i.TextEdit.from)}}class J{constructor(W,B){this.d=W,this.e=B}async provideDocumentRangeFormattingEdits(W,B,Q,K){const se=this.d.getDocument(W),ge=i.Range.to(B),Ee=await this.e.provideDocumentRangeFormattingEdits(se,ge,Q,K);if(Array.isArray(Ee))return Ee.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,B,Q,K){(0,w.$tg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const se=this.d.getDocument(W),ge=B.map(i.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(se,ge,Q,K);if(Array.isArray(Ee))return Ee.map(i.TextEdit.from)}}class Y{constructor(W,B){this.d=W,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,B,Q,K,se){const ge=this.d.getDocument(W),Ee=i.Position.to(B),ze=await this.e.provideOnTypeFormattingEdits(ge,Ee,Q,K,se);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class ae{constructor(W,B){this.e=W,this.f=B,this.d=new o.$Vqc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,B){const Q=await this.e.provideWorkspaceSymbols(W,B);if(!(0,v.$Pb)(Q))return{symbols:[]};const K=this.d.add(Q),se={cacheId:K,symbols:[]};for(let ge=0;ge<Q.length;ge++){const Ee=Q[ge];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}se.symbols.push({...i.WorkspaceSymbol.from(Ee),cacheId:[K,ge]})}return se}async resolveWorkspaceSymbol(W,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const Q=this.d.get(...W.cacheId);if(Q){const K=await this.e.resolveWorkspaceSymbol(Q,B);return K&&(0,m.$no)(W,i.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class ee{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,B,Q){this.d=W,this.e=B,this.f=Q}async provideRenameEdits(W,B,Q,K){const se=this.d.getDocument(W),ge=i.Position.to(B);try{const Ee=await this.e.provideRenameEdits(se,ge,Q,K);return Ee?i.WorkspaceEdit.from(Ee):void 0}catch(Ee){const ze=ee.g(Ee);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(W,B,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(W),se=i.Position.to(B);try{const ge=await this.e.prepareRename(K,se,Q);let Ee,ze;if(n.$dO.isRange(ge)?(Ee=ge,ze=K.getText(ge)):(0,w.$lg)(ge)&&(Ee=ge.range,ze=ge.placeholder),!Ee||!ze)return;if(Ee.start.line>se.line||Ee.end.line<se.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ee),text:ze}}catch(ge){const Ee=ee.g(ge);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(ge)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class oe{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(W,B,Q){this.e=W,this.f=B,this.g=Q}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(W,B,Q,K){const se=this.e.getDocument(W),ge=i.Range.to(B);try{const Ee=oe.d[Q],ze=await this.f.provideNewSymbolNames(se,ge,Ee,K);return ze?ze.map(Je=>typeof Je=="string"?{newSymbolName:Je}:{newSymbolName:Je.newSymbolName,tags:Je.tags}):void 0}catch(Ee){this.g.error(oe.h(Ee)??JSON.stringify(Ee,null,"	"));return}}static h(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class ie{constructor(W,B){this.resultId=W,this.tokens=B}}class ue{constructor(W,B){this.f=W,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,B,Q){const K=this.f.getDocument(W),se=B!==0?this.d.get(B):null;let ge=typeof se?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,se.resultId,Q):await this.g.provideDocumentSemanticTokens(K,Q);return se&&this.d.delete(B),ge?(ge=ue.h(ge),this.o(ue.n(se,ge),ge)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return ue.j(W)?ue.k(W)?W:new n.$yP(new Uint32Array(W.data),W.resultId):ue.l(W)?ue.m(W)?W:new n.$AP(W.edits.map(B=>new n.$zP(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const B of W.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(W,B){if(!ue.j(B)||!W||!W.tokens)return B;const Q=W.tokens,K=Q.length,se=B.data,ge=se.length;let Ee=0;const ze=Math.min(K,ge);for(;Ee<ze&&Q[Ee]===se[Ee];)Ee++;if(Ee===K&&Ee===ge)return new n.$AP([],B.resultId);let Je=0;const _e=ze-Ee;for(;Je<_e&&Q[K-Je-1]===se[ge-Je-1];)Je++;return new n.$AP([{start:Ee,deleteCount:K-Ee-Je,data:se.subarray(Ee,ge-Je)}],B.resultId)}o(W,B){if(ue.j(W)){const Q=this.e++;return this.d.set(Q,new ie(W.resultId,W.data)),(0,a.$yeb)({id:Q,type:"full",data:W.data})}if(ue.l(W)){const Q=this.e++;return ue.j(B)?this.d.set(Q,new ie(B.resultId,B.data)):this.d.set(Q,new ie(W.resultId)),(0,a.$yeb)({id:Q,type:"delta",deltas:(W.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class _{constructor(W,B){this.d=W,this.e=B}async provideDocumentRangeSemanticTokens(W,B,Q){const K=this.d.getDocument(W),se=await this.e.provideDocumentRangeSemanticTokens(K,i.Range.to(B),Q);return se?this.f(se):null}f(W){return(0,a.$yeb)({id:0,type:"full",data:W.data})}}class $e{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,B,Q,K,se){this.f=W,this.g=B,this.h=Q,this.j=K,this.k=se,this.d=new o.$Vqc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,B,Q,K){const se=this.f.getDocument(W),ge=i.Position.to(B),Ee=se.getWordRangeAtPosition(ge)||new n.$dO(ge,ge),ze=Ee.with({end:ge}),Je=new s.$ke,_e=await this.h.provideCompletionItems(se,ge,K,i.CompletionContext.to(Q));if(!_e||K.isCancellationRequested)return;const tt=Array.isArray(_e)?new n.$MO(_e):_e,ct=$e.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),it=new T.$Yc;this.e.set(ct,it);const at=[],yt={x:ct,[l.ISuggestResultDtoField.completions]:at,[l.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ee),insert:i.Range.from(ze)},[l.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[l.ISuggestResultDtoField.duration]:Je.elapsed()};for(let Ze=0;Ze<tt.items.length;Ze++){const he=tt.items[Ze],pe=this.l(he,[ct,Ze],ze,Ee);at.push(pe)}return yt}async resolveCompletionItem(W,B){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...W);if(!Q)return;const K=this.l(Q,W),se=await this.h.resolveCompletionItem(Q,B);if(!se)return;const ge=this.l(se,W);return(K[l.ISuggestDataDtoField.insertText]!==ge[l.ISuggestDataDtoField.insertText]||K[l.ISuggestDataDtoField.insertTextRules]!==ge[l.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K[l.ISuggestDataDtoField.commandIdent]!==ge[l.ISuggestDataDtoField.commandIdent]||K[l.ISuggestDataDtoField.commandId]!==ge[l.ISuggestDataDtoField.commandId]||!(0,m.$oo)(K[l.ISuggestDataDtoField.commandArguments],ge[l.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,[l.ISuggestDataDtoField.documentation]:ge[l.ISuggestDataDtoField.documentation],[l.ISuggestDataDtoField.detail]:ge[l.ISuggestDataDtoField.detail],[l.ISuggestDataDtoField.additionalTextEdits]:ge[l.ISuggestDataDtoField.additionalTextEdits],[l.ISuggestDataDtoField.insertText]:ge[l.ISuggestDataDtoField.insertText],[l.ISuggestDataDtoField.insertTextRules]:ge[l.ISuggestDataDtoField.insertTextRules],[l.ISuggestDataDtoField.commandIdent]:ge[l.ISuggestDataDtoField.commandIdent],[l.ISuggestDataDtoField.commandId]:ge[l.ISuggestDataDtoField.commandId],[l.ISuggestDataDtoField.commandArguments]:ge[l.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,B,Q,K){const se=this.e.get(B[0]);if(!se)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(W.command,se),Ee={x:B,[l.ISuggestDataDtoField.label]:W.label,[l.ISuggestDataDtoField.kind]:W.kind!==void 0?i.CompletionItemKind.from(W.kind):void 0,[l.ISuggestDataDtoField.kindModifier]:W.tags&&W.tags.map(i.CompletionItemTag.from),[l.ISuggestDataDtoField.detail]:W.detail,[l.ISuggestDataDtoField.documentation]:typeof W.documentation>"u"?void 0:i.MarkdownString.fromStrict(W.documentation),[l.ISuggestDataDtoField.sortText]:W.sortText!==W.label?W.sortText:void 0,[l.ISuggestDataDtoField.filterText]:W.filterText!==W.label?W.filterText:void 0,[l.ISuggestDataDtoField.preselect]:W.preselect||void 0,[l.ISuggestDataDtoField.insertTextRules]:W.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[l.ISuggestDataDtoField.commitCharacters]:W.commitCharacters?.join(""),[l.ISuggestDataDtoField.additionalTextEdits]:W.additionalTextEdits&&W.additionalTextEdits.map(i.TextEdit.from),[l.ISuggestDataDtoField.commandIdent]:ge?.$ident,[l.ISuggestDataDtoField.commandId]:ge?.id,[l.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee[l.ISuggestDataDtoField.insertText]=W.textEdit.newText):typeof W.insertText=="string"?Ee[l.ISuggestDataDtoField.insertText]=W.insertText:W.insertText instanceof n.$oO&&(Ee[l.ISuggestDataDtoField.insertText]=W.insertText.value,Ee[l.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let ze;return W.textEdit?ze=W.textEdit.range:W.range&&(ze=W.range),n.$dO.isRange(ze)?Ee[l.ISuggestDataDtoField.range]=i.Range.from(ze):ze&&(!Q?.isEqual(ze.inserting)||!K?.isEqual(ze.replacing))&&(Ee[l.ISuggestDataDtoField.range]={insert:i.Range.from(ze.inserting),replace:i.Range.from(ze.replacing)}),Ee}}class Ie{async provideInlineCompletions(W,B,Q,K){}async provideInlineEdits(W,B,Q,K){}disposeCompletions(W){}handleDidShowCompletionItem(W,B,Q){}handlePartialAccept(W,B,Q,K){}}class X extends Ie{constructor(W,B,Q,K){super(),this.f=W,this.g=B,this.h=Q,this.j=K,this.d=new re,this.e=(0,t.$AH)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$AH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,B,Q,K){const se=this.g.getDocument(W),ge=i.Position.to(B),Ee=await this.h.provideInlineCompletionItems(se,ge,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},K);if(!Ee||K.isCancellationRequested)return;const ze=Array.isArray(Ee)?Ee:Ee.items,Je=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((it,at)=>{let yt;it.command&&(tt||(tt=new T.$Yc),yt=this.j.toInternal(it.command,tt));const Ze=it.insertText;return{insertText:typeof Ze=="string"?Ze:{snippet:Ze.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:yt,idx:at,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(tt||(tt=new T.$Yc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(W,B,Q,K){if(!this.h.provideInlineEdits)return;(0,t.$BH)(this.f,"inlineCompletionsAdditions");const se=this.g.getDocument(W),ge=i.Range.to(B),Ee=await this.h.provideInlineEdits(se,ge,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind],userPrompt:Q.userPrompt},K);if(!Ee||K.isCancellationRequested)return;const ze=Array.isArray(Ee)?Ee:Ee.items,Je=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((it,at)=>{let yt;it.command&&(tt||(tt=new T.$Yc),yt=this.j.toInternal(it.command,tt));const Ze=it.insertText;return{insertText:typeof Ze=="string"?Ze:{snippet:Ze.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:yt,idx:at,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Je.map(it=>(tt||(tt=new T.$Yc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,B,Q){const K=this.d.get(W)?.items[B];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K,Q)}handlePartialAccept(W,B,Q,K){const se=this.d.get(W)?.items[B];se&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(se,Q),this.h.handleDidPartiallyAcceptCompletionItem(se,i.PartialAcceptInfo.to(K)))}}class V{async provideInlineEdits(W,B,Q){const K=this.f.getDocument(W),se=await this.g.provideInlineEdit(K,{triggerKind:this.e[B.triggerKind]},Q);if(!se||Q.isCancellationRequested)return;let ge;const Ee=this.d.createReferenceId({dispose(){ge?.dispose()},item:se});let ze;se.accepted&&(ge||(ge=new T.$Yc),ze=this.h.toInternal(se.accepted,ge));let Je;return se.rejected&&(ge||(ge=new T.$Yc),Je=this.h.toInternal(se.rejected,ge)),{pid:Ee,text:se.text,range:i.Range.from(se.range),accepted:ze,rejected:Je}}disposeEdit(W){this.d.disposeReferenceId(W)?.dispose()}constructor(W,B,Q,K){this.f=B,this.g=Q,this.h=K,this.d=new re,this.e={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class re{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const B=this.e++;return this.d.set(B,W),B}disposeReferenceId(W){const B=this.d.get(W);return this.d.delete(W),B}get(W){return this.d.get(W)}}class be{constructor(W,B){this.e=W,this.f=B,this.d=new o.$Vqc("SignatureHelp")}async provideSignatureHelp(W,B,Q,K){const se=this.e.getDocument(W),ge=i.Position.to(B),Ee=this.g(Q),ze=await this.f.provideSignatureHelp(se,ge,K,Ee);if(ze){const Je=this.d.add([ze]);return{...i.SignatureHelp.from(ze),id:Je}}}g(W){let B;if(W.activeSignatureHelp){const Q=i.SignatureHelp.to(W.activeSignatureHelp),K=this.d.get(W.activeSignatureHelp.id,0);K?(B=K,B.activeSignature=Q.activeSignature,B.activeParameter=Q.activeParameter):B=Q}return{...W,activeSignatureHelp:B}}releaseSignatureHelp(W){this.d.delete(W)}}class Pe{constructor(W,B,Q,K,se){this.f=W,this.g=B,this.h=Q,this.j=K,this.k=se,this.d=new o.$Vqc("InlayHints"),this.e=new Map}async provideInlayHints(W,B,Q){const K=this.f.getDocument(W),se=i.Range.to(B),ge=await this.h.provideInlayHints(K,se,Q);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`);return}if(Q.isCancellationRequested)return;const Ee=this.d.add(ge);this.e.set(Ee,new T.$Yc);const ze={hints:[],cacheId:Ee};for(let Je=0;Je<ge.length;Je++)this.l(ge[Je],se)&&ze.hints.push(this.m(ge[Je],[Ee,Je]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`),ze}async resolveInlayHint(W,B){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...W);if(!Q)return;const K=await this.h.resolveInlayHint(Q,B);if(K&&this.l(K))return this.m(K,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,B){return W.label.length===0||Array.isArray(W.label)&&W.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(B&&!B.contains(W.position))}m(W,B){const Q=this.e.get(B[0]);if(!Q)throw Error("DisposableStore is missing...");const K={label:"",cacheId:B,tooltip:i.MarkdownString.fromStrict(W.tooltip),position:i.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(i.TextEdit.from),kind:W.kind&&i.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};if(typeof W.label=="string")K.label=W.label;else{const se=[];K.label=se;for(const ge of W.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.$pO.isLocation(ge.location)&&(Ee.location=i.location.from(ge.location)),ge.command&&(Ee.command=this.g.toInternal(ge.command,Q)),se.push(Ee)}}return K}}class Fe{constructor(W,B){this.e=W,this.f=B,this.d=new o.$Vqc("DocumentLink")}async provideLinks(W,B){const Q=this.e.getDocument(W),K=await this.f.provideDocumentLinks(Q,B);if(!(!Array.isArray(K)||K.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(Fe.g).map(i.DocumentLink.from)};{const se=this.d.add(K),ge={links:[],cacheId:se};for(let Ee=0;Ee<K.length;Ee++){if(!Fe.g(K[Ee]))continue;const ze=i.DocumentLink.from(K[Ee]);ze.cacheId=[se,Ee],ge.links.push(ze)}return ge}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,B){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...W);if(!Q)return;const K=await this.f.resolveDocumentLink(Q,B);if(!(!K||!Fe.g(K)))return i.DocumentLink.from(K)}releaseLinks(W){this.d.delete(W)}}class Be{constructor(W,B){this.d=W,this.e=B}async provideColors(W,B){const Q=this.d.getDocument(W),K=await this.e.provideDocumentColors(Q,B);return Array.isArray(K)?K.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(W,B,Q){const K=this.d.getDocument(W),se=i.Range.to(B.range),ge=i.Color.to(B.color),Ee=await this.e.provideColorPresentations(ge,{document:K,range:se},Q);if(Array.isArray(Ee))return Ee.map(i.ColorPresentation.from)}}class xe{constructor(W,B){this.d=W,this.e=B}async provideFoldingRanges(W,B,Q){const K=this.d.getDocument(W),se=await this.e.provideFoldingRanges(K,B,Q);if(Array.isArray(se))return se.map(i.FoldingRange.from)}}class nt{constructor(W,B,Q){this.d=W,this.e=B,this.f=Q}async provideSelectionRanges(W,B,Q){const K=this.d.getDocument(W),se=B.map(i.Position.to),ge=await this.e.provideSelectionRanges(K,se,Q);if(!(0,v.$Pb)(ge))return[];if(ge.length!==se.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let ze=0;ze<se.length;ze++){const Je=[];Ee.push(Je);let _e=se[ze],tt=ge[ze];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Je.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ee}}class ht{constructor(W,B){this.f=W,this.g=B,this.d=new R.$RQ(""),this.e=new Map}async prepareSession(W,B,Q){const K=this.f.getDocument(W),se=i.Position.to(B),ge=await this.g.prepareCallHierarchy(K,se,Q);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ee,ze)):[this.h(Ee,ge)]}async provideCallsTo(W,B,Q){const K=this.j(W,B);if(!K)throw new Error("missing call hierarchy item");const se=await this.g.provideCallHierarchyIncomingCalls(K,Q);if(se)return se.map(ge=>({from:this.h(W,ge.from),fromRanges:ge.fromRanges.map(Ee=>i.Range.from(Ee))}))}async provideCallsFrom(W,B,Q){const K=this.j(W,B);if(!K)throw new Error("missing call hierarchy item");const se=await this.g.provideCallHierarchyOutgoingCalls(K,Q);if(se)return se.map(ge=>({to:this.h(W,ge.to),fromRanges:ge.fromRanges.map(Ee=>i.Range.from(Ee))}))}releaseSession(W){this.e.delete(W)}h(W,B){const Q=this.e.get(W),K=i.CallHierarchyItem.from(B,W,Q.size.toString(36));return Q.set(K._itemId,B),K}j(W,B){return this.e.get(W)?.get(B)}}class $t{constructor(W,B){this.f=W,this.g=B,this.d=new R.$RQ(""),this.e=new Map}async prepareSession(W,B,Q){const K=this.f.getDocument(W),se=i.Position.to(B),ge=await this.g.prepareTypeHierarchy(K,se,Q);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ee,ze)):[this.h(Ee,ge)]}async provideSupertypes(W,B,Q){const K=this.j(W,B);if(!K)throw new Error("missing type hierarchy item");const se=await this.g.provideTypeHierarchySupertypes(K,Q);if(se)return se.map(ge=>this.h(W,ge))}async provideSubtypes(W,B,Q){const K=this.j(W,B);if(!K)throw new Error("missing type hierarchy item");const se=await this.g.provideTypeHierarchySubtypes(K,Q);if(se)return se.map(ge=>this.h(W,ge))}releaseSession(W){this.e.delete(W)}h(W,B){const Q=this.e.get(W),K=i.TypeHierarchyItem.from(B,W,Q.size.toString(36));return Q.set(K._itemId,B),K}j(W,B){return this.e.get(W)?.get(B)}}class ut{constructor(W,B,Q,K,se){this.e=W,this.f=B,this.g=Q,this.h=K,this.j=se,this.d=new o.$Vqc("DocumentDropEdit")}async provideDocumentOnDropEdits(W,B,Q,K,se){const ge=this.f.getDocument(B),Ee=i.Position.to(Q),ze=i.DataTransfer.toDataTransfer(K,async ct=>(await this.e.$resolveDocumentOnDropFileData(this.h,W,ct)).buffer),Je=await this.g.provideDocumentDropEdits(ge,Ee,ze,se);if(!Je)return;const _e=(0,v.$6b)(Je),tt=this.d.add(_e);return _e.map((ct,it)=>({_cacheId:[tt,it],title:ct.title??(0,h.localize)(2704,null,this.j.displayName||this.j.name),kind:ct.kind?.value,yieldTo:ct.yieldTo?.map(at=>at.value),insertText:typeof ct.insertText=="string"?ct.insertText:{snippet:ct.insertText.value},additionalEdit:ct.additionalEdit?i.WorkspaceEdit.from(ct.additionalEdit,void 0):void 0}))}async resolveDropEdit(W,B){const[Q,K]=W,se=this.d.get(Q,K);if(!se||!this.g.resolveDocumentDropEdit)return{};const ge=await this.g.resolveDocumentDropEdit(se,B)??se;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(W){this.d.delete(W)}}class et{constructor(W,B){this.d=W,this.e=B}async provideMappedEdits(W,B,Q,K){const se=u.URI.revive(W),ge=this.d.getDocument(se),Ee=Q.documents.map(_e=>_e.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(ct=>i.Range.to(ct))}))),ze={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},Je=await this.e.provideMappedEdits(ge,B,ze,K);return Je?i.WorkspaceEdit.from(Je):null}}class Le{constructor(W,B){this.adapter=W,this.extension=B}}class Ne{static{this.d=0}constructor(W,B,Q,K,se,ge,Ee,ze){this.g=B,this.h=Q,this.j=K,this.k=se,this.l=ge,this.m=Ee,this.n=ze,this.f=new Map,this.e=W.getProxy(l.$_N.MainThreadLanguageFeatures)}o(W,B){return i.DocumentSelector.from(W,this.g,B)}p(W){return new n.$bO(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return Ne.d++}async s(W,B,Q,K,se,ge=!1){const Ee=this.f.get(W);if(!Ee||!(Ee.adapter instanceof B))return K;const ze=Date.now();ge||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const Je=Q(Ee.adapter,Ee.extension);return Promise.resolve(Je).catch(_e=>{(0,L.$8)(_e)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ee.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),P.CancellationToken.isCancellationToken(se)?(0,D.$zh)(Je,se):Je}t(W,B){const Q=this.q();return this.f.set(Q,new Le(W,B)),Q}static u(W){return W.displayName||W.name}static w(W){return W.identifier.value}registerDocumentSymbolProvider(W,B,Q,K){const se=this.t(new g(this.h,Q),W),ge=K&&K.label||Ne.u(W);return this.e.$registerDocumentSymbolProvider(se,this.o(B,W),ge),this.p(se)}$provideDocumentSymbols(W,B,Q){return this.s(W,g,K=>K.provideDocumentSymbols(u.URI.revive(B),Q),void 0,Q)}registerCodeLensProvider(W,B,Q){const K=this.q(),se=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new Le(new f(this.h,this.j.converter,Q,W,this.n,this.l),W)),this.e.$registerCodeLensSupport(K,this.o(B,W),se);let ge=this.p(K);if(se!==void 0){const Ee=Q.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(se));ge=n.$bO.from(ge,Ee)}return ge}$provideCodeLenses(W,B,Q){return this.s(W,f,K=>K.provideCodeLenses(u.URI.revive(B),Q),void 0,Q,B.scheme==="output")}$resolveCodeLens(W,B,Q){return this.s(W,f,K=>K.resolveCodeLens(B,Q),void 0,void 0,!0)}$releaseCodeLenses(W,B){this.s(W,f,Q=>Promise.resolve(Q.releaseCodeLenses(B)),void 0,void 0,!0)}registerDefinitionProvider(W,B,Q){const K=this.t(new S(this.h,Q),W);return this.e.$registerDefinitionSupport(K,this.o(B,W)),this.p(K)}$provideDefinition(W,B,Q,K){return this.s(W,S,se=>se.provideDefinition(u.URI.revive(B),Q,K),[],K)}registerDeclarationProvider(W,B,Q){const K=this.t(new E(this.h,Q),W);return this.e.$registerDeclarationSupport(K,this.o(B,W)),this.p(K)}$provideDeclaration(W,B,Q,K){return this.s(W,E,se=>se.provideDeclaration(u.URI.revive(B),Q,K),[],K)}registerImplementationProvider(W,B,Q){const K=this.t(new y(this.h,Q),W);return this.e.$registerImplementationSupport(K,this.o(B,W)),this.p(K)}$provideImplementation(W,B,Q,K){return this.s(W,y,se=>se.provideImplementation(u.URI.revive(B),Q,K),[],K)}registerTypeDefinitionProvider(W,B,Q){const K=this.t(new C(this.h,Q),W);return this.e.$registerTypeDefinitionSupport(K,this.o(B,W)),this.p(K)}$provideTypeDefinition(W,B,Q,K){return this.s(W,C,se=>se.provideTypeDefinition(u.URI.revive(B),Q,K),[],K)}registerHoverProvider(W,B,Q,K){const se=this.t(new O(this.h,Q),W);return this.e.$registerHoverProvider(se,this.o(B,W)),this.p(se)}$provideHover(W,B,Q,K,se){return this.s(W,O,ge=>ge.provideHover(u.URI.revive(B),Q,K,se),void 0,se)}$releaseHover(W,B){this.s(W,O,Q=>Promise.resolve(Q.releaseHover(B)),void 0,void 0)}registerEvaluatableExpressionProvider(W,B,Q,K){const se=this.t(new p(this.h,Q),W);return this.e.$registerEvaluatableExpressionProvider(se,this.o(B,W)),this.p(se)}$provideEvaluatableExpression(W,B,Q,K){return this.s(W,p,se=>se.provideEvaluatableExpression(u.URI.revive(B),Q,K),void 0,K)}registerInlineValuesProvider(W,B,Q,K){const se=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new b(this.h,Q),W);this.e.$registerInlineValuesProvider(ge,this.o(B,W),se);let Ee=this.p(ge);if(se!==void 0){const ze=Q.onDidChangeInlineValues(Je=>this.e.$emitInlineValuesEvent(se));Ee=n.$bO.from(Ee,ze)}return Ee}$provideInlineValues(W,B,Q,K,se){return this.s(W,b,ge=>ge.provideInlineValues(u.URI.revive(B),Q,K,se),void 0,se)}registerDocumentHighlightProvider(W,B,Q){const K=this.t(new M(this.h,Q),W);return this.e.$registerDocumentHighlightProvider(K,this.o(B,W)),this.p(K)}registerMultiDocumentHighlightProvider(W,B,Q){const K=this.t(new A(this.h,Q),W);return this.e.$registerMultiDocumentHighlightProvider(K,this.o(B,W)),this.p(K)}$provideDocumentHighlights(W,B,Q,K){return this.s(W,M,se=>se.provideDocumentHighlights(u.URI.revive(B),Q,K),void 0,K)}$provideMultiDocumentHighlights(W,B,Q,K,se){return this.s(W,A,ge=>ge.provideMultiDocumentHighlights(u.URI.revive(B),Q,K.map(Ee=>u.URI.revive(Ee)),se),void 0,se)}registerLinkedEditingRangeProvider(W,B,Q){const K=this.t(new F(this.h,Q),W);return this.e.$registerLinkedEditingRangeProvider(K,this.o(B,W)),this.p(K)}$provideLinkedEditingRanges(W,B,Q,K){return this.s(W,F,async se=>{const ge=await se.provideLinkedEditingRanges(u.URI.revive(B),Q,K);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Ne.y(ge.wordPattern):void 0}},void 0,K)}registerReferenceProvider(W,B,Q){const K=this.t(new G(this.h,Q),W);return this.e.$registerReferenceSupport(K,this.o(B,W)),this.p(K)}$provideReferences(W,B,Q,K,se){return this.s(W,G,ge=>ge.provideReferences(u.URI.revive(B),Q,K,se),void 0,se)}registerCodeActionProvider(W,B,Q,K){const se=new T.$Yc,ge=this.t(new x(this.h,this.j.converter,this.k,Q,this.l,W,this.m),W);return this.e.$registerCodeActionSupport(ge,this.o(B,W),{providedKinds:K?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:K?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,se)}))},Ne.u(W),Ne.w(W),!!Q.resolveCodeAction),se.add(this.p(ge)),se}$provideCodeActions(W,B,Q,K,se){return this.s(W,x,ge=>ge.provideCodeActions(u.URI.revive(B),Q,K,se),void 0,se)}$resolveCodeAction(W,B,Q){return this.s(W,x,K=>K.resolveCodeAction(B,Q),{},void 0)}$releaseCodeActions(W,B){this.s(W,x,Q=>Promise.resolve(Q.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(W,B,Q){const K=this.t(new U(this.h,Q),W);return this.e.$registerDocumentFormattingSupport(K,this.o(B,W),W.identifier,W.displayName||W.name),this.p(K)}$provideDocumentFormattingEdits(W,B,Q,K){return this.s(W,U,se=>se.provideDocumentFormattingEdits(u.URI.revive(B),Q,K),void 0,K)}registerDocumentRangeFormattingEditProvider(W,B,Q){const K=typeof Q.provideDocumentRangesFormattingEdits=="function",se=this.t(new J(this.h,Q),W);return this.e.$registerRangeFormattingSupport(se,this.o(B,W),W.identifier,W.displayName||W.name,K),this.p(se)}$provideDocumentRangeFormattingEdits(W,B,Q,K,se){return this.s(W,J,ge=>ge.provideDocumentRangeFormattingEdits(u.URI.revive(B),Q,K,se),void 0,se)}$provideDocumentRangesFormattingEdits(W,B,Q,K,se){return this.s(W,J,ge=>ge.provideDocumentRangesFormattingEdits(u.URI.revive(B),Q,K,se),void 0,se)}registerOnTypeFormattingEditProvider(W,B,Q,K){const se=this.t(new Y(this.h,Q),W);return this.e.$registerOnTypeFormattingSupport(se,this.o(B,W),K,W.identifier),this.p(se)}$provideOnTypeFormattingEdits(W,B,Q,K,se,ge){return this.s(W,Y,Ee=>Ee.provideOnTypeFormattingEdits(u.URI.revive(B),Q,K,se,ge),void 0,ge)}registerWorkspaceSymbolProvider(W,B){const Q=this.t(new ae(B,this.l),W);return this.e.$registerNavigateTypeSupport(Q,typeof B.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(W,B,Q){return this.s(W,ae,K=>K.provideWorkspaceSymbols(B,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(W,B,Q){return this.s(W,ae,K=>K.resolveWorkspaceSymbol(B,Q),void 0,void 0)}$releaseWorkspaceSymbols(W,B){this.s(W,ae,Q=>Q.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(W,B,Q){const K=this.t(new ee(this.h,Q,this.l),W);return this.e.$registerRenameSupport(K,this.o(B,W),ee.supportsResolving(Q)),this.p(K)}$provideRenameEdits(W,B,Q,K,se){return this.s(W,ee,ge=>ge.provideRenameEdits(u.URI.revive(B),Q,K,se),void 0,se)}$resolveRenameLocation(W,B,Q,K){return this.s(W,ee,se=>se.resolveRenameLocation(u.URI.revive(B),Q,K),void 0,K)}registerNewSymbolNamesProvider(W,B,Q){const K=this.t(new oe(this.h,Q,this.l),W);return this.e.$registerNewSymbolNamesProvider(K,this.o(B,W)),this.p(K)}$supportsAutomaticNewSymbolNamesTriggerKind(W){return this.s(W,oe,B=>B.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(W,B,Q,K,se){return this.s(W,oe,ge=>ge.provideNewSymbolNames(u.URI.revive(B),Q,K,se),void 0,se)}registerDocumentSemanticTokensProvider(W,B,Q,K){const se=this.t(new ue(this.h,Q),W),ge=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(se,this.o(B,W),K,ge);let Ee=this.p(se);if(ge){const ze=Q.onDidChangeSemanticTokens(Je=>this.e.$emitDocumentSemanticTokensEvent(ge));Ee=n.$bO.from(Ee,ze)}return Ee}$provideDocumentSemanticTokens(W,B,Q,K){return this.s(W,ue,se=>se.provideDocumentSemanticTokens(u.URI.revive(B),Q,K),null,K)}$releaseDocumentSemanticTokens(W,B){this.s(W,ue,Q=>Q.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,B,Q,K){const se=this.t(new _(this.h,Q),W);return this.e.$registerDocumentRangeSemanticTokensProvider(se,this.o(B,W),K),this.p(se)}$provideDocumentRangeSemanticTokens(W,B,Q,K){return this.s(W,_,se=>se.provideDocumentRangeSemanticTokens(u.URI.revive(B),Q,K),null,K)}registerCompletionItemProvider(W,B,Q,K){const se=this.t(new $e(this.h,this.j.converter,Q,this.m,W),W);return this.e.$registerCompletionsProvider(se,this.o(B,W),K,$e.supportsResolving(Q),W.identifier),this.p(se)}$provideCompletionItems(W,B,Q,K,se){return this.s(W,$e,ge=>ge.provideCompletionItems(u.URI.revive(B),Q,K,se),void 0,se)}$resolveCompletionItem(W,B,Q){return this.s(W,$e,K=>K.resolveCompletionItem(B,Q),void 0,Q)}$releaseCompletionItems(W,B){this.s(W,$e,Q=>Q.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(W,B,Q,K){const se=new X(W,this.h,Q,this.j.converter),ge=this.t(se,W);return this.e.$registerInlineCompletionsSupport(ge,this.o(B,W),se.supportsHandleEvents,c.$xn.toKey(W.identifier.value),K?.yieldTo?.map(Ee=>c.$xn.toKey(Ee))||[]),this.p(ge)}$provideInlineCompletions(W,B,Q,K,se){return this.s(W,Ie,ge=>ge.provideInlineCompletions(u.URI.revive(B),Q,K,se),void 0,se)}$provideInlineEdits(W,B,Q,K,se){return this.s(W,Ie,ge=>ge.provideInlineEdits(u.URI.revive(B),Q,K,se),void 0,se)}$handleInlineCompletionDidShow(W,B,Q,K){this.s(W,Ie,async se=>{se.handleDidShowCompletionItem(B,Q,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,B,Q,K,se){this.s(W,Ie,async ge=>{ge.handlePartialAccept(B,Q,K,se)},void 0,void 0)}$freeInlineCompletionsList(W,B){this.s(W,Ie,async Q=>{Q.disposeCompletions(B)},void 0,void 0)}registerInlineEditProvider(W,B,Q){const K=new V(W,this.h,Q,this.j.converter),se=this.t(K,W);return this.e.$registerInlineEditProvider(se,this.o(B,W),W.identifier),this.p(se)}$provideInlineEdit(W,B,Q,K){return this.s(W,V,se=>se.provideInlineEdits(u.URI.revive(B),Q,K),void 0,K)}$freeInlineEdit(W,B){this.s(W,V,async Q=>{Q.disposeEdit(B)},void 0,void 0)}registerSignatureHelpProvider(W,B,Q,K){const se=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,ge=this.t(new be(this.h,Q),W);return this.e.$registerSignatureHelpProvider(ge,this.o(B,W),se),this.p(ge)}$provideSignatureHelp(W,B,Q,K,se){return this.s(W,be,ge=>ge.provideSignatureHelp(u.URI.revive(B),Q,K,se),void 0,se)}$releaseSignatureHelp(W,B){this.s(W,be,Q=>Q.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(W,B,Q){const K=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,se=this.t(new Pe(this.h,this.j.converter,Q,this.l,W),W);this.e.$registerInlayHintsProvider(se,this.o(B,W),typeof Q.resolveInlayHint=="function",K,Ne.u(W));let ge=this.p(se);if(K!==void 0){const Ee=Q.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(K));ge=n.$bO.from(ge,Ee)}return ge}$provideInlayHints(W,B,Q,K){return this.s(W,Pe,se=>se.provideInlayHints(u.URI.revive(B),Q,K),void 0,K)}$resolveInlayHint(W,B,Q){return this.s(W,Pe,K=>K.resolveInlayHint(B,Q),void 0,Q)}$releaseInlayHints(W,B){this.s(W,Pe,Q=>Q.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(W,B,Q){const K=this.t(new Fe(this.h,Q),W);return this.e.$registerDocumentLinkProvider(K,this.o(B,W),typeof Q.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(W,B,Q){return this.s(W,Fe,K=>K.provideLinks(u.URI.revive(B),Q),void 0,Q,B.scheme==="output")}$resolveDocumentLink(W,B,Q){return this.s(W,Fe,K=>K.resolveLink(B,Q),void 0,void 0,!0)}$releaseDocumentLinks(W,B){this.s(W,Fe,Q=>Q.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(W,B,Q){const K=this.t(new Be(this.h,Q),W);return this.e.$registerDocumentColorProvider(K,this.o(B,W)),this.p(K)}$provideDocumentColors(W,B,Q){return this.s(W,Be,K=>K.provideColors(u.URI.revive(B),Q),[],Q)}$provideColorPresentations(W,B,Q,K){return this.s(W,Be,se=>se.provideColorPresentations(u.URI.revive(B),Q,K),void 0,K)}registerFoldingRangeProvider(W,B,Q){const K=this.q(),se=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new Le(new xe(this.h,Q),W)),this.e.$registerFoldingRangeProvider(K,this.o(B,W),W.identifier,se);let ge=this.p(K);if(se!==void 0){const Ee=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(se));ge=n.$bO.from(ge,Ee)}return ge}$provideFoldingRanges(W,B,Q,K){return this.s(W,xe,se=>se.provideFoldingRanges(u.URI.revive(B),Q,K),void 0,K)}registerSelectionRangeProvider(W,B,Q){const K=this.t(new nt(this.h,Q,this.l),W);return this.e.$registerSelectionRangeProvider(K,this.o(B,W)),this.p(K)}$provideSelectionRanges(W,B,Q,K){return this.s(W,nt,se=>se.provideSelectionRanges(u.URI.revive(B),Q,K),[],K)}registerCallHierarchyProvider(W,B,Q){const K=this.t(new ht(this.h,Q),W);return this.e.$registerCallHierarchyProvider(K,this.o(B,W)),this.p(K)}$prepareCallHierarchy(W,B,Q,K){return this.s(W,ht,se=>Promise.resolve(se.prepareSession(u.URI.revive(B),Q,K)),void 0,K)}$provideCallHierarchyIncomingCalls(W,B,Q,K){return this.s(W,ht,se=>se.provideCallsTo(B,Q,K),void 0,K)}$provideCallHierarchyOutgoingCalls(W,B,Q,K){return this.s(W,ht,se=>se.provideCallsFrom(B,Q,K),void 0,K)}$releaseCallHierarchy(W,B){this.s(W,ht,Q=>Promise.resolve(Q.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(W,B,Q){const K=this.t(new $t(this.h,Q),W);return this.e.$registerTypeHierarchyProvider(K,this.o(B,W)),this.p(K)}$prepareTypeHierarchy(W,B,Q,K){return this.s(W,$t,se=>Promise.resolve(se.prepareSession(u.URI.revive(B),Q,K)),void 0,K)}$provideTypeHierarchySupertypes(W,B,Q,K){return this.s(W,$t,se=>se.provideSupertypes(B,Q,K),void 0,K)}$provideTypeHierarchySubtypes(W,B,Q,K){return this.s(W,$t,se=>se.provideSubtypes(B,Q,K),void 0,K)}$releaseTypeHierarchy(W,B){this.s(W,$t,Q=>Promise.resolve(Q.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(W,B,Q,K){const se=this.q();return this.f.set(se,new Le(new ut(this.e,this.h,Q,se,W),W)),this.e.$registerDocumentOnDropEditProvider(se,this.o(B,W),(0,t.$AH)(W,"documentPaste")&&K?{supportsResolve:!!Q.resolveDocumentDropEdit,dropMimeTypes:K.dropMimeTypes}:void 0),this.p(se)}$provideDocumentOnDropEdits(W,B,Q,K,se,ge){return this.s(W,ut,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(B,u.URI.revive(Q),K,se,ge)),void 0,void 0)}$resolveDropEdit(W,B,Q){return this.s(W,ut,K=>K.resolveDropEdit(B,Q),{},void 0)}$releaseDocumentOnDropEdits(W,B){this.s(W,ut,Q=>Promise.resolve(Q.releaseDropEdits(B)),void 0,void 0)}registerMappedEditsProvider(W,B,Q){const K=this.t(new et(this.h,Q),W);return this.e.$registerMappedEditsProvider(K,this.o(B,W),W.displayName??W.name),this.p(K)}$provideMappedEdits(W,B,Q,K,se){return this.s(W,et,ge=>Promise.resolve(ge.provideMappedEdits(B,Q,K,se)),null,se)}registerDocumentPasteEditProvider(W,B,Q,K){const se=this.q();return this.f.set(se,new Le(new j(this.e,this.h,Q,se,W),W)),this.e.$registerPasteEditProvider(se,this.o(B,W),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,supportsResolve:!!Q.resolveDocumentPasteEdit,providedPasteEditKinds:K.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this.p(se)}$prepareDocumentPaste(W,B,Q,K,se){return this.s(W,j,ge=>ge.prepareDocumentPaste(u.URI.revive(B),Q,K,se),void 0,se)}$providePasteEdits(W,B,Q,K,se,ge,Ee){return this.s(W,j,ze=>ze.providePasteEdits(B,u.URI.revive(Q),K,se,ge,Ee),void 0,Ee)}$resolvePasteEdit(W,B,Q){return this.s(W,j,K=>K.resolvePasteEdit(B,Q),{},void 0)}$releasePasteEdits(W,B){this.s(W,j,Q=>Promise.resolve(Q.releasePasteEdits(B)),void 0,void 0)}static y(W){return{pattern:W.source,flags:W.flags}}static z(W){return{decreaseIndentPattern:Ne.y(W.decreaseIndentPattern),increaseIndentPattern:Ne.y(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Ne.y(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Ne.y(W.unIndentedLinePattern):void 0}}static B(W){return{beforeText:Ne.y(W.beforeText),afterText:W.afterText?Ne.y(W.afterText):void 0,previousLineText:W.previousLineText?Ne.y(W.previousLineText):void 0,action:W.action}}static C(W){return W.map(Ne.B)}static D(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(B=>n.SyntaxTokenType.toString(B)):void 0}}static E(W){return W.map(Ne.D)}setLanguageConfiguration(W,B,Q){const{wordPattern:K}=Q;if(K&&(0,I.$wf)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(B,K):this.h.setWordDefinitionFor(B,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const se=this.q(),ge={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Ne.y(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Ne.z(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Ne.C(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Ne.E(Q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(se,B,ge),this.p(se)}$setWordDefinitions(W){for(const B of W)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.$6qc=Ne}),define(Re[244],Oe([1,0,10,19,12,4,34,33,5,8]),function(we,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Csc=void 0,s=Ve(s);class I{constructor(u){this.a=new Map,this.c=new Map,this.d=new Map,this.b=u.getProxy(m.$_N.MainThreadLanguageModelTools),this.b.$getTools().then(k=>{for(const $ of k)this.d.set($.id,(0,R.$hi)($))})}async $countTokensForInvocation(u,k,$){const r=this.c.get(u);if(!r)throw new Error(`Tool invocation call ${u} not found`);return await r(k,$)}async invokeTool(u,k,$){const r=(0,T.$7g)();k.tokenOptions&&this.c.set(r,k.tokenOptions.countTokens);try{const a=await this.b.$invokeTool({toolId:u,callId:r,parameters:k.parameters,tokenBudget:k.tokenOptions?.tokenBudget},$);return s.LanguageModelToolResult.to(a)}finally{this.c.delete(r)}}$onDidChangeTools(u){this.d.clear();for(const k of u)this.d.set(k.id,k)}get tools(){return Array.from(this.d.values()).map(u=>s.LanguageModelToolDescription.to(u))}async $invokeTool(u,k){const $=this.a.get(u.toolId);if(!$)throw new Error(`Unknown tool ${u.toolId}`);const r={parameters:u.parameters};u.tokenBudget!==void 0&&(r.tokenOptions={tokenBudget:u.tokenBudget,countTokens:this.c.get(u.callId)||((h,c=D.CancellationToken.None)=>this.b.$countTokensForInvocation(u.callId,h,c))});const a=await(0,v.$yh)(Promise.resolve($.tool.invoke(r,k)),k);if(!a)throw new P.$9;for(const h of Object.keys(a))if(a[h]instanceof Promise)throw new Error(`Tool result for '${h}' cannot be a Promise`);return s.LanguageModelToolResult.from(a)}registerTool(u,k,$){return this.a.set(k,{extension:u,tool:$}),this.b.$registerTool(k),(0,L.$Xc)(()=>{this.a.delete(k),this.b.$unregisterTool(k)})}}e.$Csc=I}),define(Re[95],Oe([1,0,10,19,42,12,6,41,4,9,18,3,11,77,5,91,16,8,7,119,21]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nrc=e.$Mrc=void 0,h=Ve(h),c=Ve(c),e.$Mrc=(0,w.$Ki)("IExtHostLanguageModels");class o{constructor(d,S){this.option=d,this.stream=new v.$bi,this.stream=S??new v.$bi}}class l{constructor(){this.a=new Map,this.b=new v.$bi,this.c=!1;const d=this;this.apiObject={get stream(){return d.b.asyncIterable},get text(){return v.$$h.map(d.b.asyncIterable,S=>{if(S instanceof c.$wQ)return S.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;let S=this.a.get(d.index);S||(this.a.size===0?S=new o(d.index,this.b):S=new o(d.index),this.a.set(d.index,S));let E;d.part.type==="text"?E=new c.$wQ(d.part.value):E=new c.$vQ(d.part.name,d.part.toolCallId,d.part.parameters),S.stream.emitOne(E)}reject(d){this.c=!0;for(const S of this.d())S.reject(d)}resolve(){this.c=!0;for(const d of this.d())d.resolve()}}let g=class{static{t=this}static{this.a=1}constructor(d,S,E){this.j=S,this.k=E,this.c=new R.$qe,this.d=new R.$qe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$zn,this.i=new Map,this.s=new Set,this.b=d.getProxy($.$_N.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,S,E,y){const C=t.a++;this.f.set(C,{extension:d.identifier,provider:E,languageModelId:S});let O;y.auth&&(O={providerLabel:d.displayName||d.name,accountLabel:typeof y.auth=="object"?y.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,`${I.$xn.toKey(d.identifier)}/${C}/${S}`,{extension:d.identifier,id:S,vendor:y.vendor??I.$xn.toKey(d.identifier),name:y.name??"",family:y.family??"",version:y.version,maxInputTokens:y.maxInputTokens,maxOutputTokens:y.maxOutputTokens,auth:O,targetExtensions:y.extensions});const p=E.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:M,tokenCount:A})=>{this.b.$whenLanguageModelChatRequestMade(S,new I.$xn(b),M,A)});return(0,m.$Xc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C),p?.dispose()})}async $startChatRequest(d,S,E,y,C,O){const p=this.f.get(d);if(!p)throw new Error("Provider not found");const b=new k.$Iw(async A=>{if(O.isCancellationRequested){this.j.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let F;if(A.part instanceof c.$vQ?F={type:"tool_use",name:A.part.name,parameters:A.part.parameters,toolCallId:A.part.toolCallId}:A.part instanceof c.$wQ&&(F={type:"text",value:A.part.value}),!F){this.j.warn(`[CHAT](${p.extension.value}) UNKNOWN part ${JSON.stringify(A)}`);return}this.b.$reportResponsePart(S,{index:A.index,part:F})});let M;if(p.provider.provideLanguageModelResponse2)M=Promise.resolve(p.provider.provideLanguageModelResponse2(y.map(h.LanguageModelChatMessage.to),C,I.$xn.toKey(E),b,O));else{const A=new k.$Iw(async F=>{b.report({index:F.index,part:new c.$wQ(F.part)})});M=Promise.resolve(p.provider.provideLanguageModelResponse(y.map(h.LanguageModelChatMessage.to),C?.modelOptions??{},I.$xn.toKey(E),A,O))}M.then(()=>{this.b.$reportResponseDone(S,void 0)},A=>{this.b.$reportResponseDone(S,(0,L.$6)(A))})}$provideTokenLength(d,S,E){const y=this.f.get(d);return y?Promise.resolve(y.provider.provideTokenCount(S,E)):Promise.resolve(0)}$acceptChatModelMetadata(d){if(d.added)for(const{identifier:S,metadata:E}of d.added)this.g.set(S,{metadata:E,apiObjects:new I.$zn});if(d.removed)for(const S of d.removed){this.g.delete(S);for(const[E,y]of this.i)y.languageModelId===S&&(y.res.reject(new L.$9),this.i.delete(E))}d.added?.forEach(S=>this.q(S.metadata)),this.d.fire(void 0)}async selectLanguageModels(d,S){const E=await this.b.$selectChatModels({...S,extension:d.identifier}),y=[],C=this;for(const O of E){const p=this.g.get(O);if(!p)continue;this.o(d.identifier,p.metadata)&&await this.q(p.metadata);let b=p.apiObjects.get(d.identifier);b||(b={id:O,vendor:p.metadata.vendor,family:p.metadata.family,version:p.metadata.version,name:p.metadata.name,maxInputTokens:p.metadata.maxInputTokens,countTokens(M,A){if(!C.g.has(O))throw c.$AQ.NotFound(O);return C.r(O,M,A??D.CancellationToken.None)},sendRequest(M,A,F){if(!C.g.has(O))throw c.$AQ.NotFound(O);return C.l(d,O,M,A??{},F??D.CancellationToken.None)}},Object.freeze(b),p.apiObjects.set(d.identifier,b)),y.push(b)}return y}async l(d,S,E,y,C){const O=this.m(d,E),p=d.identifier,b=this.g.get(S)?.metadata;if(!b||!this.g.has(S))throw c.$AQ.NotFound(`Language model '${S}' is unknown.`);if(this.o(p,b)&&(!await this.n(d,{identifier:b.extension,displayName:b.auth.providerLabel},y.justification,!1)||!this.h.get(p)?.has(b.extension)))throw c.$AQ.NoPermissions(`Language model '${S}' cannot be used by '${p.value}'.`);try{const M=Math.random()*1e6|0,A=new l;this.i.set(M,{languageModelId:S,res:A});try{await this.b.$tryStartChatRequest(p,S,M,O,y,C)}catch(F){throw this.i.delete(M),F}return A.apiObject}catch(M){throw M.name===c.$AQ.name?M:new c.$AQ(`Language model '${S}' errored: ${(0,P.$vj)(M)}`,"Unknown",M)}}m(d,S){const E=[];for(const y of S)y.role===c.LanguageModelChatMessageRole.System&&(0,n.$BH)(d,"languageModelSystem"),y.content2.some(C=>C instanceof c.$tQ)&&(0,n.$BH)(d,"lmTools"),E.push(h.LanguageModelChatMessage.from(y));return E}async $acceptResponsePart(d,S){const E=this.i.get(d);E&&E.res.handleFragment(S)}async $acceptResponseDone(d,S){const E=this.i.get(d);E&&(this.i.delete(d),S?E.res.reject((0,L.$7)(S)):E.res.resolve())}async n(d,S,E,y){const C=i.$cN+S.identifier.value;if(await this.k.getSession(d,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:S.identifier,enabled:!0}]),!0;if(y)return!1;try{const p=E?(0,s.localize)(2705,null,S.displayName,E):void 0;return await this.k.getSession(d,C,[],{forceNewSession:{detail:p}}),this.$updateModelAccesslist([{from:d.identifier,to:S.identifier,enabled:!0}]),!0}catch{return!1}}o(d,S){return!!S.auth&&!I.$xn.equals(S.extension,d)}async q(d){if(d.auth)for(const S of this.s)try{await this.n(S,{identifier:d.extension,displayName:""},void 0,!0)}catch(E){this.j.error("Fake Auth request failed"),this.j.error(E)}}async r(d,S,E){if(!this.g.get(d))throw c.$AQ.NotFound(`Language model '${d}' is unknown.`);const C=T.Iterable.find(this.f.values(),O=>O.languageModelId===d);return C?C.provider.provideTokenCount(S,E):this.b.$countTokens(d,typeof S=="string"?S:h.LanguageModelChatMessage.from(S),E)}$updateModelAccesslist(d){const S=new Array;for(const{from:E,to:y,enabled:C}of d){const O=this.h.get(E)??new I.$yn;if(O.has(y)!==C){C?O.add(y):O.delete(y),this.h.set(E,O);const b={from:E,to:y};S.push(b),this.c.fire(b)}}}createLanguageModelAccessInformation(d){this.s.add(d);const S=this,E=R.Event.signal(R.Event.filter(this.c.event,C=>I.$xn.equals(C.from,d.identifier))),y=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(E,y)},canSendRequest(C){let O;e:for(const[b,M]of S.g)for(const A of M.apiObjects.values())if(A===C){O=M.metadata;break e}if(!O)return;if(!S.o(d.identifier,O))return!0;const p=S.h.get(d.identifier);if(p)return p.has(O.extension)}}}};e.$Nrc=g,e.$Nrc=g=t=Ke([qe(0,a.$MQ),qe(1,u.$fk),qe(2,r.$8qc)],g)});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[245],Oe([1,0,5,8,7,37,10,4,21]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dsc=void 0,D=Ve(D),L=oi(L);class s{constructor(w,u,k,$){this.c=u,this.d=k,this.e=$,this.b=[],this.f=0,this.g=new Set,this.a=w.getProxy(v.$_N.MainThreadLanguages)}$acceptLanguageIds(w){this.b=w}async getLanguages(){return this.b.slice(0)}async changeLanguage(w,u){await this.a.$changeLanguage(w,u);const k=this.c.getDocumentData(w);if(!k)throw new Error(`document '${w.toString()}' NOT found`);return k.document}async tokenAtPosition(w,u){const k=w.version,$=D.Position.from(u),r=await this.a.$tokensAtPosition(w.uri,$),a={type:P.StandardTokenType.Other,range:w.getWordRangeAtPosition(u)??new P.$dO(u.line,u.character,u.line,u.character)};if(!r)return a;const h={range:D.Range.to(r.range),type:D.TokenType.to(r.type)};return!h.range.contains(u)||k!==w.version?a:h}createLanguageStatusItem(w,u,k){const $=this.f++,r=this.a,a=this.g,h=`${w.identifier.value}/${u}`;if(a.has(h))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);a.add(h);const c={selector:k,id:u,name:w.displayName??w.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new T.$Yc,t=()=>{if(i?.dispose(),!a.has(h)){console.warn(`LanguageStatusItem (${u}) from ${w.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$Mh)(()=>{n.clear(),this.a.$setLanguageStatus($,{id:h,name:c.name??w.displayName??w.name,source:w.displayName??w.name,selector:D.DocumentSelector.from(c.selector,this.e),label:c.text,detail:c.detail??"",severity:c.severity===P.LanguageStatusSeverity.Error?L.default.Error:c.severity===P.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:c.command&&this.d.toInternal(c.command,n),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},o={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus($),a.delete(h)},get id(){return c.id},get name(){return c.name},set name(l){c.name=l,t()},get selector(){return c.selector},set selector(l){c.selector=l,t()},get text(){return c.text},set text(l){c.text=l,t()},set text2(l){(0,m.$BH)(w,"languageStatusText"),c.text=l,t()},get text2(){return(0,m.$BH)(w,"languageStatusText"),c.text},get detail(){return c.detail},set detail(l){c.detail=l,t()},get severity(){return c.severity},set severity(l){c.severity=l,t()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(l){c.accessibilityInformation=l,t()},get command(){return c.command},set command(l){c.command=l,t()},get busy(){return c.busy},set busy(l){c.busy=l,t()}};return t(),o}}e.$Dsc=s}),define(Re[246],Oe([1,0,15,2,8,7,90]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ksc=e.$jsc=void 0,P=Ve(P),R=Ve(R);class T{constructor(w,u,k,$){this.start=w,this.deletedCount=u,this.deletedItems=k,this.items=$}asApiEvent(){return{range:new L.$FP(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1}}constructor(w,u,k){this.notebook=w,this.h=u,this.j=k,this.handle=k.handle,this.uri=D.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(P.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return w.g},set mime($){w.g=$},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(k)}return this.f}setOutputs(w){this.a=w.map(P.NotebookCellOutput.to)}setOutputItems(w,u,k){const $=k.map(P.NotebookCellOutputItem.to),r=this.a.find(a=>a.id===w);if(r&&(u||(r.items.length=0),r.items.push(...$),r.items.length>1&&r.items.every(a=>R.$aM(a.mime)))){const a=new Map,h=[];r.items.forEach(c=>{let i;a.has(c.mime)?i=a.get(c.mime):(i=[],a.set(c.mime,i),h.push(c.mime)),i.push(c.data)}),r.items.length=0,h.forEach(c=>{const i=R.$bM(a.get(c));r.items.push({mime:c,data:i.data.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.$jsc=m;class s{static{this.a=0}constructor(w,u,k,$,r){this.k=w,this.l=u,this.m=k,this.uri=$,this.handle=s.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const w=this,u={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===v.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(k){return k=w.n(k),w.b[k].apiCell},getCells(k){return(k?w.p(k):w.b).map(r=>r.apiCell)},save(){return w.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,u,k){this.g=w.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:k});const $={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},r=[];for(const h of w.rawEvents)h.kind===R.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,$.contentChanges):h.kind===R.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,$.contentChanges):h.kind===R.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),r.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===R.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),r.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),r.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),r.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),r.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const a=new Map;for(let h=0;h<r.length;h++){const c=r[h],i=a.get(c.cell);if(i===void 0){const n=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});a.set(c.cell,n-1)}else $.cellChanges[i]={...$.cellChanges[i],...c}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let u=w.start|0,k=w.end|0;return u<0&&(u=0),k>this.b.length&&(k=this.b.length),w.with({start:u,end:k})}p(w){w=this.o(w);const u=[];for(let k=w.start;k<w.end;k++)u.push(this.b[k]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,u,k){if(this.j)return;const $=[],r=[],a=[];if(w.reverse().forEach(h=>{const i=h[2].map(o=>{const l=new m(this,this.l,o);return u||r.push(m.asModelAddData(o)),l}),n=new T(h[0],h[1],[],i),t=this.b.splice(h[0],h[1],...i);for(const o of t)a.push(o.uri),n.deletedItems.push(o.apiCell);$.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:a}),k)for(const h of $)k.push(h.asApiEvent())}s(w,u,k,$){const r=this.b.splice(w,u);this.b.splice(k,0,...r);const a=[new T(w,u,r.map(h=>h.apiCell),[]),new T(k,0,[],r)];for(const h of a)$.push(h.asApiEvent())}t(w,u){this.b[w].setOutputs(u)}u(w,u,k,$){this.b[w].setOutputItems(u,k,$)}v(w,u){const k=this.b[w];k.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(k.uri,u)}w(w,u){const k=this.b[w];k.apiCell.mime=u}x(w,u){this.b[w].setMetadata(u)}y(w,u){this.b[w].setInternalMetadata(u)}getCellFromApiCell(w){return this.b.find(u=>u.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(u=>u.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}e.$ksc=s}),define(Re[247],Oe([1,0,6,2,8,7,39]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsc=void 0;class T{constructor(s,I,w,u={timeout:1500,errors:3}){this.b=s,this.c=I,this.d=w,this.f=u,this.a=new v.$se}dispose(){}getOnWillSaveNotebookDocumentEvent(s){return(I,w,u)=>{const k=function(r){I.call(w,r)};return k.extension=s,this.a.event(k,void 0,u)}}async $participateInSave(s,I,w){const u=D.URI.revive(s),k=this.c.getNotebookDocument(u);if(!k)throw new Error("Unable to resolve notebook document");const $=[];if(await this.a.fireAsync({notebook:k.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},w,async(a,h)=>{const c=Date.now(),i=await await Promise.resolve(a);Date.now()-c>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier),!w.isCancellationRequested&&i&&(i instanceof L.$nO?$.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier,"ignored due to invalid data"))}),w.isCancellationRequested)return!1;if($.length===0)return!0;const r={edits:[]};for(const a of $){const{edits:h}=P.WorkspaceEdit.from(a);r.edits=r.edits.concat(h)}return this.d.$tryApplyWorkspaceEdit(new R.$7w(r))}}e.$Fsc=T}),define(Re[126],Oe([1,0,12,8,7]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lsc=void 0,D=Ve(D),P=Ve(P);class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,m,s,I,w,u){this.id=T,this.f=m,this.notebookData=s,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=I,this.c=u}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(m){this.selections=[m]},get selections(){return T.a},set selections(m){if(!Array.isArray(m)||!m.every(P.$FP.isNotebookRange))throw(0,v.$$)("selections");T.a=m,T.g(m)},get visibleRanges(){return T.b},revealRange(m,s){T.f.$tryRevealRange(T.id,D.NotebookRange.from(m),s??P.NotebookEditorRevealType.Default)},get viewColumn(){return T.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(D.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$lsc=L}),define(Re[248],Oe([1,0,6,11,8]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hsc=void 0,P=Ve(P);let L=class{constructor(T,m){this.c=T,this.d=m,this.a=new v.$qe,this.b=new v.$qe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,m);const s=this.d.getEditorById(T);m.visibleRanges&&s._acceptVisibleRanges(m.visibleRanges.ranges.map(P.NotebookRange.to)),m.selections&&s._acceptSelections(m.selections.selections.map(P.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:s.apiEditor,visibleRanges:s.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:s.apiEditor,selections:s.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const m in T)this.d.getEditorById(m)._acceptViewColumn(P.ViewColumn.to(T[m]))}};e.$Hsc=L,e.$Hsc=L=Ke([qe(0,D.$fk)],L)}),define(Re[249],Oe([1,0,6,5,126]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ksc=void 0;class L{constructor(T,m){this.c=m,this.a=new Map,this.b=T.getProxy(D.$_N.MainThreadNotebookRenderers)}$postRendererMessage(T,m,s){const I=this.c.getEditorById(T);this.a.get(m)?.fire({editor:I.apiEditor,message:s})}createRendererMessaging(T,m){if(!T.contributes?.notebookRenderer?.some(I=>I.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(I,w,u)=>this.d(m).event(I,w,u),postMessage:(I,w)=>{P.$lsc.apiEditorsToExtHost.has(I)&&([I,w]=[w,I]);const u=w&&P.$lsc.apiEditorsToExtHost.get(w);return this.b.$postMessage(u?.id,m,I)}}}d(T){let m=this.a.get(T);return m||(m=new v.$qe({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(T)}}),this.a.set(T,m),m)}}e.$Ksc=L}),define(Re[250],Oe([1,0,8,77,19,71,12]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Osc=void 0;class T{constructor(w){this.b=0,this.c=new Map,this.a=w}async withProgress(w,u,k){const $=this.b++,{title:r,location:a,cancellable:h}=u,c={label:w.displayName||w.name,id:w.identifier.value};return this.a.$startProgress($,{location:v.ProgressLocation.from(a),title:r,source:c,cancellable:h},w.isUnderDevelopment?void 0:w.identifier.value).catch(R.$5),this.d($,k,!!h)}d(w,u,k){let $;k&&($=new P.$Be,this.c.set(w,$));const r=h=>{this.a.$progressEnd(h),this.c.delete(h),$?.dispose()};let a;try{a=u(new s(this.a,w),k&&$?$.token:P.CancellationToken.None)}catch(h){throw r(w),h}return a.then(h=>r(w),h=>r(w)),a}$acceptProgressCanceled(w){const u=this.c.get(w);u&&(u.cancel(),this.c.delete(w))}}e.$Osc=T;function m(I,w){return I.message=w.message,typeof w.increment=="number"&&(typeof I.increment=="number"?I.increment+=w.increment:I.increment=w.increment),I}class s extends D.$Iw{constructor(w,u){super(k=>this.throttledReport(k)),this.c=w,this.d=u}throttledReport(w){this.c.$progressReport(this.d,w)}}Ke([(0,L.$ei)(100,(I,w)=>m(I,w),()=>Object.create(null))],s.prototype,"throttledReport",null)}),define(Re[251],Oe([1,0,2,5,10,8]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Psc=void 0;class R{static{this.a=0}constructor(m,s){this.d=s,this.c=new Map,this.b=m.getProxy(D.$_N.MainThreadQuickDiff)}$provideOriginalResource(m,s,I){const w=v.URI.revive(s),u=this.c.get(m);return u?(0,P.$Ch)(()=>u.provideOriginalResource(w,I)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(m,s,I,w){const u=R.a++;return this.c.set(u,s),this.b.$registerQuickDiffProvider(u,L.DocumentSelector.from(m,this.d),I,w),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Psc=R});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[252],Oe([1,0,19,6,4,5,2,7,12,17,37,36,21,8]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qsc=$,I=oi(I);function $(r,a,h){const c=r.getProxy(L.$_N.MainThreadQuickOpen);class i{constructor(E,y){this.e=new Map,this.f=0,this.a=E,this.b=y}showQuickPick(E,y,C,O=v.CancellationToken.None){this.c=void 0;const p=Promise.resolve(y),b=++this.f,M=c.$show(b,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},O),A={},F=M.then(()=>A);return Promise.race([F,p]).then(G=>{if(G===A)return;const x=(0,u.$AH)(E,"quickPickItemTooltip");return p.then(j=>{const U=[];for(let J=0;J<j.length;J++){const Y=j[J];if(typeof Y=="string")U.push({label:Y,handle:J});else if(Y.kind===T.QuickPickItemKind.Separator)U.push({type:"separator",label:Y.label});else{Y.tooltip&&!x&&console.warn(`Extension '${E.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`);const ae=Y.iconPath?g(Y.iconPath):void 0;U.push({label:Y.label,iconPath:ae?.iconPath,iconClass:ae?.iconClass,description:Y.description,detail:Y.detail,picked:Y.picked,alwaysShow:Y.alwaysShow,tooltip:x?k.MarkdownString.fromStrict(Y.tooltip):void 0,handle:J})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=J=>{C.onDidSelectItem(j[J])}),c.$setItems(b,U),M.then(J=>{if(typeof J=="number")return j[J];if(Array.isArray(J))return J.map(Y=>j[Y])})})}).then(void 0,G=>{if(!(0,m.$8)(G))return c.$setError(b,G),Promise.reject(G)})}$onItemSelected(E){this.c?.(E)}showInput(E,y=v.CancellationToken.None){return this.d=E?.validateInput,c.$input(E,typeof this.d=="function",y).then(void 0,C=>{if(!(0,m.$8)(C))return Promise.reject(C)})}async $validateInput(E){if(!this.d)return;const y=await this.d(E);if(!y||typeof y=="string")return y;let C;switch(y.severity){case T.InputBoxValidationSeverity.Info:C=I.default.Info;break;case T.InputBoxValidationSeverity.Warning:C=I.default.Warning;break;case T.InputBoxValidationSeverity.Error:C=I.default.Error;break;default:C=y.message?I.default.Error:I.default.Ignore;break}return{content:y.message,severity:C}}async showWorkspaceFolderPick(E,y=v.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[E]);if(!C)return;const O=await this.a.getWorkspaceFolders2();if(O)return O.find(p=>p.uri.toString()===C.uri.toString())}createQuickPick(E){const y=new f(E,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(E){const y=new d(E,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(E,y){this.e.get(E)?._fireDidChangeValue(y)}$onDidAccept(E){this.e.get(E)?._fireDidAccept()}$onDidChangeActive(E,y){const C=this.e.get(E);C instanceof f&&C._fireDidChangeActive(y)}$onDidChangeSelection(E,y){const C=this.e.get(E);C instanceof f&&C._fireDidChangeSelection(y)}$onDidTriggerButton(E,y){this.e.get(E)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(E,y,C){const O=this.e.get(E);O instanceof f&&O._fireDidTriggerItemButton(y,C)}$onDidHide(E){this.e.get(E)?._fireDidHide()}}class n{static{this.a=1}constructor(E,y){this.x=E,this.y=y,this._id=f.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new D.$qe,this.q=new D.$qe,this.r=new D.$qe,this.s=new D.$qe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(E){this.b=E,this.z({title:E})}get step(){return this.c}set step(E){this.c=E,this.z({step:E})}get totalSteps(){return this.d}set totalSteps(E){this.d=E,this.z({totalSteps:E})}get enabled(){return this.g}set enabled(E){this.g=E,this.z({enabled:E})}get busy(){return this.j}set busy(E){this.j=E,this.z({busy:E})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(E){this.k=E,this.z({ignoreFocusOut:E})}get value(){return this.l}set value(E){this.l=E,this.z({value:E})}get placeholder(){return this.m}set placeholder(E){this.m=E,this.z({placeholder:E})}get buttons(){return this.n}set buttons(E){const y=(0,u.$AH)(this.x,"quickInputButtonLocation");!y&&E.some(C=>C.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=E.slice(),this.o.clear(),E.forEach((C,O)=>{const p=C===T.$CP.Back?-1:O;this.o.set(p,C)}),this.z({buttons:E.map((C,O)=>({...g(C.iconPath),tooltip:C.tooltip,handle:C===T.$CP.Back?-1:O,location:y?C.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(E){this.l=E,this.q.fire(E)}_fireDidTriggerButton(E){const y=this.o.get(E);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Uc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(E){if(!this.v){for(const y of Object.keys(E)){const C=E[y];this.u[y]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function t(S){if(S instanceof T.$aP)return{id:S.id};const E=l(S),y=o(S);return{dark:typeof E=="string"?R.URI.file(E):E,light:typeof y=="string"?R.URI.file(y):y}}function o(S){return typeof S=="object"&&"light"in S?S.light:S}function l(S){return typeof S=="object"&&"dark"in S?S.dark:S}function g(S){const E=t(S);let y,C;return"id"in E?C=w.ThemeIcon.asClassName(E):y=E,{iconPath:y,iconClass:C}}class f extends n{constructor(E,y){super(E,y),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new D.$qe,this.L=[],this.M=new D.$qe,this.N=new D.$qe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(E){this.B=E.slice(),this.C.clear(),this.D.clear(),E.forEach((O,p)=>{this.C.set(p,O),this.D.set(O,p)});const y=(0,u.$AH)(this.x,"quickPickItemTooltip"),C=[];for(let O=0;O<E.length;O++){const p=E[O];if(p.kind===T.QuickPickItemKind.Separator)C.push({type:"separator",label:p.label});else{p.tooltip&&!y&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const b=p.iconPath?g(p.iconPath):void 0;C.push({handle:O,label:p.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:y?k.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((M,A)=>({...g(M.iconPath),tooltip:M.tooltip,handle:A}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(E){this.E=E,this.z({canSelectMany:E})}get matchOnDescription(){return this.F}set matchOnDescription(E){this.F=E,this.z({matchOnDescription:E})}get matchOnDetail(){return this.G}set matchOnDetail(E){this.G=E,this.z({matchOnDetail:E})}get sortByLabel(){return this.H}set sortByLabel(E){this.H=E,this.z({sortByLabel:E})}get keepScrollPosition(){return this.I}set keepScrollPosition(E){this.I=E,this.z({keepScrollPosition:E})}get activeItems(){return this.J}set activeItems(E){this.J=E.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(E){this.L=E.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(E){const y=(0,s.$Lb)(E.map(C=>this.C.get(C)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(E){const y=(0,s.$Lb)(E.map(C=>this.C.get(C)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(E,y){const C=this.C.get(E);if(!C||!C.buttons||!C.buttons.length)return;const O=C.buttons[y];O&&this.N.fire({button:O,item:C})}}class d extends n{constructor(E,y){super(E,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(E){this.B=E,this.z({password:E})}get prompt(){return this.C}set prompt(E){this.C=E,this.z({prompt:E})}get valueSelection(){return this.D}set valueSelection(E){this.D=E,this.z({valueSelection:E})}get validationMessage(){return this.E}set validationMessage(E){this.E=E,E?typeof E=="string"?this.z({validationMessage:E,severity:I.default.Error}):this.z({validationMessage:E.message,severity:E.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(a,h)}}),define(Re[253],Oe([1,0,2,6,71,4,10,5,17,159,11,18,38,36,8,21,15,23]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ssc=e.$Rsc=void 0;function i(A){return A instanceof v.URI}function n(A,F){return A.scheme===a.Schemas.file&&F.scheme===a.Schemas.file&&h.$n?A.toString()===F.toString():A.toString().toLowerCase()===F.toString().toLowerCase()}function t(A){if(A)return typeof A.iconPath=="string"?v.URI.file(A.iconPath):v.URI.isUri(A.iconPath)||k.ThemeIcon.isThemeIcon(A.iconPath)?A.iconPath:void 0}function o(A){if(A){if(v.URI.isUri(A))return A;if(k.ThemeIcon.isThemeIcon(A))return A;{const F=A;return{light:F.light,dark:F.dark}}}else return}function l(A){const F=o(A.icon),G=A.labels?.map(x=>({title:x.title,icon:o(x.icon)}));return{...A,icon:F,labels:G}}function g(A,F){if(!A.iconPath&&!F.iconPath)return 0;if(A.iconPath){if(!F.iconPath)return 1}else return-1;const G=typeof A.iconPath=="string"?A.iconPath:v.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id,x=typeof F.iconPath=="string"?F.iconPath:v.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,s.$Sr)(G,x)}function f(A,F){let G=0;if(A.strikeThrough!==F.strikeThrough)return A.strikeThrough?1:-1;if(A.faded!==F.faded)return A.faded?1:-1;if(A.tooltip!==F.tooltip)return(A.tooltip||"").localeCompare(F.tooltip||"");if(G=g(A,F),G!==0)return G;if(A.light&&F.light)G=g(A.light,F.light);else{if(A.light)return 1;if(F.light)return-1}if(G!==0)return G;if(A.dark&&F.dark)G=g(A.dark,F.dark);else{if(A.dark)return 1;if(F.dark)return-1}return G}function d(A,F){if(A.command!==F.command)return A.command<F.command?-1:1;if(A.title!==F.title)return A.title<F.title?-1:1;if(A.tooltip!==F.tooltip){if(A.tooltip!==void 0&&F.tooltip!==void 0)return A.tooltip<F.tooltip?-1:1;if(A.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(A.arguments===F.arguments)return 0;if(A.arguments)if(F.arguments){if(A.arguments.length!==F.arguments.length)return A.arguments.length-F.arguments.length}else return 1;else return-1;for(let G=0;G<A.arguments.length;G++){const x=A.arguments[G],j=F.arguments[G];if(x!==j&&!(i(x)&&i(j)&&n(x,j)))return x<j?-1:1}return 0}function S(A,F){let G=(0,s.$Sr)(A.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(G!==0)return G;if(A.command&&F.command)G=d(A.command,F.command);else{if(A.command)return 1;if(F.command)return-1}if(G!==0)return G;if(A.decorations&&F.decorations)G=f(A.decorations,F.decorations);else{if(A.decorations)return 1;if(F.decorations)return-1}if(A.multiFileDiffEditorModifiedUri&&F.multiFileDiffEditorModifiedUri)G=(0,s.$Sr)(A.multiFileDiffEditorModifiedUri.fsPath,F.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(A.multiFileDiffEditorModifiedUri)return 1;if(F.multiFileDiffEditorModifiedUri)return-1}if(A.multiDiffEditorOriginalUri&&F.multiDiffEditorOriginalUri)G=(0,s.$Sr)(A.multiDiffEditorOriginalUri.fsPath,F.multiDiffEditorOriginalUri.fsPath,!0);else{if(A.multiDiffEditorOriginalUri)return 1;if(F.multiDiffEditorOriginalUri)return-1}return G}function E(A,F){for(let G=0;G<A.length;G++)if(A[G]!==F[G])return!1;return!0}function y(A,F){return A.command===F.command&&A.title===F.title&&A.tooltip===F.tooltip&&(A.arguments&&F.arguments?E(A.arguments,F.arguments):A.arguments===F.arguments)}function C(A,F){return(0,m.$yb)(A,F,y)}class O{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.m,F),this.o(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.m,F),this.f=F}get validateInput(){return(0,r.$BH)(this.k,"scmValidation"),this.g}set validateInput(F){if((0,r.$BH)(this.k,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.m,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.m,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.m,F))}get document(){return(0,r.$BH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(F,G,x,j,U){this.k=F,this.m=j,this.n=U,this.d="",this.e=new D.$qe,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=x}showValidationMessage(F,G){(0,r.$BH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,F,G)}$onInputBoxValueChange(F){this.o(F)}o(F){this.d=F,this.e.fire(F)}}e.$Rsc=O;class p{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(F){this.w=F,this.s.$updateGroupLabel(this.u,this.handle,F)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(F){this.q=F,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,G,x,j,U,J,Y){this.s=F,this.t=G,this.u=x,this.v=j,this.w=U,this.multiDiffEditorEnableViewChanges=J,this.x=Y,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new D.$qe,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new D.$qe,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=p.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,G){const x=this.h.get(F);return x?(0,R.$Ch)(()=>this.t.executeCommand(x.command,...x.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(S),x=(0,m.$Hb)(this.p,F,S).map(J=>{const Y=J.toInsert.map(ae=>{const ee=this.e++;this.g.set(ee,ae);const oe=ae.resourceUri;let ie;if(ae.command)if(ae.command.command==="vscode.open"||ae.command.command==="vscode.diff"||ae.command.command==="vscode.changes"){const nt=new L.$Yc;ie=this.t.converter.toInternal(ae.command,nt),this.j.set(ee,nt)}else this.h.set(ee,ae.command);const ue=(0,r.$AH)(this.x,"scmMultiDiffEditor"),_=ue?ae.multiDiffEditorOriginalUri:void 0,$e=ue?ae.multiFileDiffEditorModifiedUri:void 0,Ie=t(ae.decorations),X=ae.decorations&&t(ae.decorations.light)||Ie,V=ae.decorations&&t(ae.decorations.dark)||Ie,re=[X,V],be=ae.decorations&&ae.decorations.tooltip||"",Pe=ae.decorations&&!!ae.decorations.strikeThrough,Fe=ae.decorations&&!!ae.decorations.faded,Be=ae.contextValue||"";return{rawResource:[ee,oe,re,be,Pe,Fe,Be,ie,_,$e],handle:ee}});return{start:J.start,deleteCount:J.deleteCount,toInsert:Y}}),j=x.map(({start:J,deleteCount:Y,toInsert:ae})=>[J,Y,ae.map(ee=>ee.rawResource)]),U=x.reverse();for(const{start:J,deleteCount:Y,toInsert:ae}of U){const ee=ae.map(ie=>ie.handle),oe=this.o.splice(J,Y,...ee);for(const ie of oe)this.g.delete(ie),this.h.delete(ie),this.j.get(ie)?.dispose(),this.j.delete(ie)}return this.p=F,j}dispose(){this.m=!0,this.n.fire()}}class b{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.x,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let G;(0,r.$AH)(this.y,"quickDiffProvider")&&(G=F?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!F,quickDiffLabel:G})}get historyProvider(){return(0,r.$BH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(F){(0,r.$BH)(this.y,"scmHistoryProvider"),this.j=F,this.k.value=new L.$Yc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!F}),F&&this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.m=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(F){F!==this.n&&(this.n=F,this.#e.$updateSourceControl(this.x,{commitTemplate:F}))}get acceptInputCommand(){return this.p}set acceptInputCommand(F){this.o.value=new L.$Yc,this.p=F;const G=this.z.converter.toInternal(F,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:G})}get actionButton(){return(0,r.$BH)(this.y,"scmActionButton"),this.s}set actionButton(F){(0,r.$BH)(this.y,"scmActionButton"),this.q.value=new L.$Yc,this.s=F;const G=F!==void 0?{command:this.z.converter.toInternal(F.command,this.q.value),secondaryCommands:F.secondaryCommands?.map(x=>x.map(j=>this.z.converter.toInternal(j,this.q.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:G??null})}get statusBarCommands(){return this.u}set statusBarCommands(F){if(this.u&&F&&C(this.u,F))return;this.t.value=new L.$Yc,this.u=F;const G=(F||[]).map(x=>this.z.converter.toInternal(x,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:G})}get selected(){return this.v}constructor(F,G,x,j,U,J,Y){this.y=F,this.z=j,this.A=U,this.B=J,this.C=Y,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$1c,this.n=void 0,this.o=new L.$1c,this.p=void 0,this.q=new L.$1c,this.t=new L.$1c,this.u=void 0,this.v=!1,this.w=new D.$qe,this.onDidChangeSelection=this.w.event,this.x=b.d++,this.D=new Map,this.E=new Set,this.#e=x;const ae=v.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:Y?`rootUri=${encodeURIComponent(Y.toString())}`:void 0});this.f=new O(F,G,this.#e,this.x,ae),this.#e.$registerSourceControl(this.x,U,J,Y,ae)}createResourceGroup(F,G,x){const j=(0,r.$AH)(this.y,"scmMultiDiffEditor")&&x?.multiDiffEditorEnableViewChanges===!0,U=new p(this.#e,this.z,this.x,F,G,j,this.y),J=D.Event.once(U.onDidDispose)(()=>this.D.delete(U));return this.D.set(U,J),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const F=[],G=[];for(const[x,j]of this.D){j.dispose();const U=x.onDidUpdateResourceStates(()=>{this.E.add(x),this.eventuallyUpdateResourceStates()});D.Event.once(x.onDidDispose)(()=>{this.E.delete(x),U.dispose(),this.e.delete(x.handle),this.#e.$unregisterGroup(this.x,x.handle)}),F.push([x.handle,x.id,x.label,x.features,x.multiDiffEditorEnableViewChanges]);const J=x._takeResourceStateSnapshot();J.length>0&&G.push([x.handle,J]),this.e.set(x.handle,x)}this.#e.$registerGroups(this.x,F,G),this.D.clear()}eventuallyUpdateResourceStates(){const F=[];this.E.forEach(G=>{const x=G._takeResourceStateSnapshot();x.length!==0&&F.push([G.handle,x])}),F.length>0&&this.#e.$spliceResourceStates(this.x,F),this.E.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.v=F,this.w.fire(F)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,P.$di)(100)],b.prototype,"eventuallyAddResourceGroups",null),Ke([(0,P.$di)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{c=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(F,G,x,j){this.m=G,this.n=x,this.o=j,this.g=new Map,this.h=new w.$zn,this.j=new D.$qe,this.e=F.getProxy(T.$_N.MainThreadSCM),this.f=F.getProxy(T.$_N.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===u.MarshalledId.ScmResource){const J=this.g.get(U.sourceControlHandle);if(!J)return U;const Y=J.getResourceGroup(U.groupHandle);return Y?Y.getResourceState(U.handle):U}else if(U&&U.$mid===u.MarshalledId.ScmResourceGroup){const J=this.g.get(U.sourceControlHandle);return J?J.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===u.MarshalledId.ScmProvider){const J=this.g.get(U.handle);return J||U}return U}})}createSourceControl(F,G,x,j){this.o.trace("ExtHostSCM#createSourceControl",F.identifier.value,G,x,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const U=c.d++,J=new b(F,this.n,this.e,this.m,G,x,j);this.g.set(U,J);const Y=this.h.get(F.identifier)||[];return Y.push(J),this.h.set(F.identifier,Y),J}getLastInputBox(F){this.o.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const G=this.h.get(F.identifier),x=G&&G[G.length-1];return x&&x.inputBox}$provideOriginalResource(F,G,x){const j=v.URI.revive(G);this.o.trace("ExtHostSCM#$provideOriginalResource",F,j.toString());const U=this.g.get(F);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ch)(()=>U.quickDiffProvider.provideOriginalResource(j,x)).then(J=>J||null)}$onInputBoxValueChange(F,G){this.o.trace("ExtHostSCM#$onInputBoxValueChange",F);const x=this.g.get(F);return x&&x.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(F,G,x,j){this.o.trace("ExtHostSCM#$executeResourceCommand",F,G,x);const U=this.g.get(F);if(!U)return Promise.resolve(void 0);const J=U.getResourceGroup(G);return J?J.$executeResourceCommand(x,j):Promise.resolve(void 0)}$validateInput(F,G,x){this.o.trace("ExtHostSCM#$validateInput",F);const j=this.g.get(F);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ch)(()=>j.inputBox.validateInput(G,x)).then(U=>{if(!U)return Promise.resolve(void 0);const J=$.MarkdownString.fromStrict(U.message);return J?Promise.resolve([J,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.g.get(F)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(F,G,x,j){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,x,j)??void 0}async $resolveHistoryItemGroupCommonAncestor2(F,G,x){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(G,x)??void 0}async $provideHistoryItems(F,G,x,j){return(await this.g.get(F)?.historyProvider?.provideHistoryItems(G,x,j))?.map(Y=>l(Y))??void 0}async $provideHistoryItems2(F,G,x){return(await this.g.get(F)?.historyProvider?.provideHistoryItems2(G,x))?.map(J=>l(J))??void 0}async $provideHistoryItemSummary(F,G,x,j){const U=this.g.get(F)?.historyProvider;if(typeof U?.provideHistoryItemSummary!="function")return;const J=await U.provideHistoryItemSummary(G,x,j);return J?l(J):void 0}async $provideHistoryItemChanges(F,G,x,j){return await this.g.get(F)?.historyProvider?.provideHistoryItemChanges(G,x,j)??void 0}};e.$Ssc=M,e.$Ssc=M=c=Ke([qe(3,I.$fk)],M)}),define(Re[254],Oe([1,0,5,8,2]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tsc=void 0;class L{static{this.a=0}constructor(T,m){this.d=m,this.c=new Map,this.b=T.getProxy(v.$_N.MainThreadShare)}async $provideShare(T,m,s){return await this.c.get(T)?.provideShare({selection:D.Range.to(m.selection),resourceUri:P.URI.revive(m.resourceUri)},s)??void 0}registerShareProvider(T,m){const s=L.a++;return this.c.set(s,m),this.b.$registerShareProvider(s,D.DocumentSelector.from(T,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(s),this.c.delete(s)}}}}e.$Tsc=L}),define(Re[255],Oe([1,0,7,5,9,4,8,14]),function(we,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wsc=e.$Vsc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$bP("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$bP("statusBarItem.warningForeground")]])}#e;#t;constructor(u,k,$,r,a,h=v.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new L.$Yc,this.#e=u,this.#t=k,a&&r){this.c=(0,v.$PO)(r.identifier,a);const i=$.get(this.c);i&&(h=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,c=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(m.a++);this.e=r,this.f=a,this.g=h,this.h=this.u(c)}u(u){if((0,T.$ng)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!m.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new L.$Yc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let k;this.m?k=this.m:k=(0,P.localize)(2711,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=m.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,k,this.k,r,this.r?.internal,$,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Vsc=m;class s{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(2712,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const k={message:u};return this.b.unshift(k),this.c(),new v.$bO(()=>{const $=this.b.indexOf(k);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,k){this.e=new Map,this.a=u.getProxy(D.$_N.MainThreadStatusBar),this.b=k,this.c=new s(this)}$acceptStaticEntries(u){for(const k of u)this.e.set(k.entryId,k)}createStatusBarEntry(u,k,$,r){return new m(this.a,this.b,this.e,u,k,$,r)}setStatusBarMessage(u,k){const $=this.c.setMessage(u);let r;return typeof k=="number"?r=setTimeout(()=>$.dispose(),k):typeof k<"u"&&k.then(()=>$.dispose(),()=>$.dispose()),new v.$bO(()=>{$.dispose(),clearTimeout(r)})}}e.$Wsc=I}),define(Re[127],Oe([1,0,32,118,54,82,55,8,2]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Q=e.$1Q=e.$ZQ=e.$YQ=void 0,v=Ve(v),T=Ve(T);const s=(i,n,t,o)=>{let l=n;return{enumerable:!0,configurable:!1,get(){return l},set(g){if(!t(l,g)){const f=l;l=g,i.listener?.(o(g,f))}}}},I=(i,n)=>i===n,w={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(o=>t.id===o.id)))},u=i=>n=>({op:L.TestItemEventOp.SetProp,update:i(n)}),k=(i,n)=>({range:(()=>{let t;const o=u(l=>({range:v.$Wt.lift(T.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return t},set(l){i.listener?.({op:L.TestItemEventOp.DocumentSynced}),w.range(t,l)||(t=l,i.listener?.(o(l)))}}})(),label:s(i,n,w.label,u(t=>({label:t}))),description:s(i,void 0,w.description,u(t=>({description:t}))),sortText:s(i,void 0,w.sortText,u(t=>({sortText:t}))),canResolveChildren:s(i,!1,w.canResolveChildren,t=>({op:L.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:s(i,!1,w.busy,u(t=>({busy:t}))),error:s(i,void 0,w.error,u(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:s(i,[],w.tags,(t,o)=>({op:L.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:o.map(T.TestTag.from)}))}),$=i=>{const n=P.$rJ.fromString(i.extId),t=new a(n.controllerId,n.localId,i.label,m.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(o=>T.TestTag.to({id:(0,R.$xJ)(o).tagId})),t},r=i=>{let n;for(const t of i.tests){const o=$(t.item);(0,D.$IQ)(o).parent=n,n=o}return n};e.$YQ=r;class a{constructor(n,t,o,l){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const g=(0,D.$HQ)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof h?void 0:g.parent}},children:{value:(0,L.$GQ)(g,D.$IQ,a),enumerable:!0,writable:!1},...k(g,o)})}}e.$ZQ=a;class h extends a{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.$1Q=h;class c extends L.$CQ{constructor(n,t,o){super({controllerId:n,getDocumentVersion:l=>l&&o.getDocument(l)?.version,getApiFor:D.$IQ,getChildren:l=>l.children,root:new h(n,t),toITestItem:T.TestItem.from})}}e.$2Q=c}),define(Re[35],Oe([1,0,14,7,8,25,5,17,11,34,32,101,2,4,3,16,127,20,39,42,69,63,66,33]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aR=e.$_Q=e.$$Q=e.$0Q=e.$9Q=e.$8Q=void 0,D=Ve(D),P=Ve(P);let g=class{#e;#t;#i;constructor(C,O,p){this.b=new Map,this.c=new Map,this.#e=C.getProxy(R.$_N.MainThreadCommands),this.d=O,this.#i=p,this.#t=C.getProxy(R.$_N.MainThreadTelemetry),this.converter=new f(this,b=>{const M=this.c.get(b);return M?.result===S.Void?M:void 0},O),this.f=[{processArgument(b){return(0,s.$hi)(b)}},{processArgument(b){return(0,L.$mo)(b,function(M){if(I.$Wt.isIRange(M))return P.Range.to(M);if(w.$Vt.isIPosition(M))return P.Position.to(M);if(I.$Wt.isIRange(M.range)&&u.URI.isUri(M.uri))return P.location.to(M);if(M instanceof h.$Se)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const O=this.registerCommand(!1,C.id,async(...p)=>{const b=C.args.map((A,F)=>{if(!A.validate(p[F]))throw new Error(`Invalid argument '${A.name}' when running '${C.id}', received: ${typeof p[F]=="object"?JSON.stringify(p[F],null,"	"):p[F]} `);return A.convert(p[F])}),M=await this.executeCommand(C.internalId,...b);return C.result.convert(M,p,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new D.$bO(()=>{O.dispose(),this.c.delete(C.id)})}registerCommand(C,O,p,b,M,A){if(this.d.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this.b.has(O))throw new Error(`command '${O}' already exists`);return this.b.set(O,{callback:p,thisArg:b,metadata:M,extension:A}),C&&this.#e.$registerCommand(O),new D.$bO(()=>{this.b.delete(O)&&C&&this.#e.$unregisterCommand(O)})}executeCommand(C,...O){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,O,!0)}async g(C,O,p){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,O,!1);{let b=!1;const M=(0,L.$mo)(O,function(A){if(A instanceof D.$cO)return P.Position.from(A);if(A instanceof D.$dO)return P.Range.from(A);if(A instanceof D.$pO)return P.location.from(A);if(D.$FP.isNotebookRange(A))return P.NotebookRange.from(A);if(A instanceof ArrayBuffer)return b=!0,h.$Se.wrap(new Uint8Array(A));if(A instanceof Uint8Array)return b=!0,h.$Se.wrap(A);if(A instanceof h.$Se)return b=!0,A;if(!Array.isArray(A))return A});try{const A=await this.#e.$executeCommand(C,b?new c.$7w(M):M,p);return(0,s.$hi)(A)}catch(A){if(A instanceof Error&&A.message==="$executeCommand:retry")return this.g(C,O,!1);throw A}}}async h(C,O,p){const b=this.b.get(C);if(!b)throw new Error("Unknown command");const{callback:M,thisArg:A,metadata:F}=b;if(F?.args)for(let x=0;x<F.args.length;x++)try{(0,v.$Ag)(O[x],F.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${F.args[x].name}' - ${F.args[x].description}`)}const G=n.$ke.create();try{return await M.apply(A,O)}catch(x){if(C===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...O);j&&(C=j.command)}if(this.d.error(x,C,b.extension?.identifier),!p)throw x;if(b.extension?.identifier){const j=this.#i.onExtensionError(b.extension.identifier,x);this.d.trace("forwarded error to extension?",j,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$vj)(x)),this.id=C,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,C,G.elapsed())}}j(C,O,p){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$Dp(O),duration:p})}$executeContributedCommand(C,...O){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const p=this.b.get(C);return p?(O=O.map(b=>this.f.reduce((M,A)=>A.processArgument(M,p.extension?.identifier),b)),this.h(C,O,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(O=>(C&&(O=O.filter(p=>p[0]!=="_")),O))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[O,p]of this.b){const{metadata:b}=p;b&&(C[O]=b)}return Promise.resolve(C)}};e.$8Q=g,e.$8Q=g=Ke([qe(0,r.$MQ),qe(1,m.$fk),qe(2,o.$7Q)],g),e.$9Q=(0,$.$Ki)("IExtHostCommands");class f{constructor(C,O,p){this.d=C,this.f=O,this.g=p,this.delegatingCommandId=`__vsc${(0,l.$7g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,O){if(!C)return;const p={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return p;const b=this.f(C.command);if(b)p.id=b.internalId,p.arguments=b.args.map((M,A)=>M.convert(C.arguments&&C.arguments[A]));else if((0,T.$Pb)(C.arguments)){const M=`${C.command} /${++this.c}`;this.b.set(M,C),O.add((0,k.$Xc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),p.$ident=M,p.id=this.delegatingCommandId,p.arguments=[M],this.g.trace("CommandsConverter#CREATE",C.command,M)}return p}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const O=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],O?O.command:"MISSING"),O?this.d.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$0Q=f;class d{static{this.Uri=new d("uri","Uri of a text document",C=>u.URI.isUri(C),C=>C)}static{this.Position=new d("position","A position in a text document",C=>D.$cO.isPosition(C),P.Position.from)}static{this.Range=new d("range","A range in a text document",C=>D.$dO.isRange(C),P.Range.from)}static{this.Selection=new d("selection","A selection in a text document",C=>D.$eO.isSelection(C),P.Selection.from)}static{this.Number=new d("number","",C=>typeof C=="number",C=>C)}static{this.String=new d("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=d.Arr(d.String)}static Arr(C){return new d(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,O=>Array.isArray(O)&&O.every(p=>C.validate(p)),O=>O.map(p=>C.convert(p)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",C=>C instanceof D.$BO,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",C=>C instanceof D.$1P,P.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VS Code TestItem",C=>C instanceof a.$ZQ,P.TestItem.from)}constructor(C,O,p,b){this.name=C,this.description=O,this.validate=p,this.convert=b}optional(){return new d(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,O){return new d(C??this.name,O??this.description,this.validate,this.convert)}}e.$$Q=d;class S{static{this.Void=new S("no result",C=>C)}constructor(C,O){this.description=C,this.convert=O}}e.$_Q=S;class E{constructor(C,O,p,b,M){this.id=C,this.internalId=O,this.description=p,this.args=b,this.result=M}}e.$aR=E}),define(Re[256],Oe([1,0,17,15,2,94,104,31,35,8,7]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=void 0,L=Ve(L),s=Ve(s),I=Ve(I);const w=[new m.$aR("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of DocumentHighlight-instances.",k(s.DocumentHighlight.to))),new m.$aR("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$$Q.Uri],new m.$_Q("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if((0,v.$Ob)(r))return;class h extends I.$wO{static to(i){const n=new h(i.name,s.SymbolKind.to(i.kind),i.containerName||"",new I.$pO(a[0],s.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=s.Range.to(i.selectionRange),n.children=i.children?i.children.map(h.to):[],n}}return r.map(h.to)})),new m.$aR("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$$Q.Uri,new m.$$Q("options","Formatting options",r=>!0,r=>r)],new m.$_Q("A promise that resolves to an array of TextEdits.",k(s.TextEdit.to))),new m.$aR("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$$Q.Uri,m.$$Q.Range,new m.$$Q("options","Formatting options",r=>!0,r=>r)],new m.$_Q("A promise that resolves to an array of TextEdits.",k(s.TextEdit.to))),new m.$aR("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$$Q.Uri,m.$$Q.Position,new m.$$Q("ch","Trigger character",r=>typeof r=="string",r=>r),new m.$$Q("options","Formatting options",r=>!0,r=>r)],new m.$_Q("A promise that resolves to an array of TextEdits.",k(s.TextEdit.to))),new m.$aR("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$aR("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$aR("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$aR("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$aR("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$aR("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$aR("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$aR("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Location or LocationLink instances.",$)),new m.$aR("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Location-instances.",k(s.location.to))),new m.$aR("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Location-instances.",k(s.location.to))),new m.$aR("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Hover-instances.",k(s.Hover.to))),new m.$aR("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of Hover-instances.",k(s.Hover.to))),new m.$aR("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$$Q.Uri,new m.$$Q("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>I.$cO.isPosition(a)),r=>r.map(s.Position.from))],new m.$_Q("A promise that resolves to an array of ranges.",r=>r.map(a=>{let h;for(const c of a.reverse())h=new I.$AO(s.Range.to(c),h);return h}))),new m.$aR("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$$Q.String.with("query","Search string")],new m.$_Q("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(s.WorkspaceSymbol.to))),new m.$aR("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(s.CallHierarchyItem.to))),new m.$aR("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$$Q.CallHierarchyItem],new m.$_Q("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(s.CallHierarchyIncomingCall.to))),new m.$aR("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$$Q.CallHierarchyItem],new m.$_Q("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(s.CallHierarchyOutgoingCall.to))),new m.$aR("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:s.Range.to(r.range),placeholder:r.text}})),new m.$aR("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$$Q.Uri,m.$$Q.Position,m.$$Q.String.with("newName","The new symbol name")],new m.$_Q("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return s.WorkspaceEdit.to(r)}})),new m.$aR("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$$Q.Uri,m.$$Q.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$_Q("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(s.DocumentLink.to))),new m.$aR("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$$Q.Uri],new m.$_Q("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$wP(r.tokenTypes,r.tokenModifiers)})),new m.$aR("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$$Q.Uri],new m.$_Q("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,R.$zeb)(r);if(a.type==="full")return new I.$yP(a.data,void 0)})),new m.$aR("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$$Q.Uri,m.$$Q.Range.optional()],new m.$_Q("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$wP(r.tokenTypes,r.tokenModifiers)})),new m.$aR("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$$Q.Uri,m.$$Q.Range],new m.$_Q("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const a=(0,R.$zeb)(r);if(a.type==="full")return new I.$yP(a.data,void 0)})),new m.$aR("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$$Q.Uri,m.$$Q.Position,m.$$Q.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$$Q.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$_Q("A promise that resolves to a CompletionList-instance.",(r,a,h)=>{if(!r)return new I.$MO([]);const c=r.suggestions.map(i=>s.CompletionItem.to(i,h));return new I.$MO(c,r.incomplete)})),new m.$aR("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$$Q.Uri,m.$$Q.Position,m.$$Q.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$_Q("A promise that resolves to SignatureHelp.",r=>{if(r)return s.SignatureHelp.to(r)})),new m.$aR("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$$Q.Uri,m.$$Q.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$_Q("A promise that resolves to an array of CodeLens-instances.",(r,a,h)=>k(c=>new I.$EO(s.Range.to(c.range),c.command&&h.fromInternal(c.command)))(r))),new m.$aR("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$$Q.Uri,new m.$$Q("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$dO.isRange(r),r=>I.$eO.isSelection(r)?s.Selection.from(r):s.Range.from(r)),m.$$Q.String.with("kind","Code action kind to return code actions for").optional(),m.$$Q.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$_Q("A promise that resolves to an array of Command-instances.",(r,a,h)=>k(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(c.command)}else{const i=new I.$yO(c.title,c.kind?new I.$zO(c.kind):void 0);return c.edit&&(i.edit=s.WorkspaceEdit.to(c.edit)),c.command&&(i.command=h.fromInternal(c.command)),i.isPreferred=c.isPreferred,i}})(r))),new m.$aR("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$$Q.Uri],new m.$_Q("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new I.$SO(s.Range.to(a.range),s.Color.to(a.color))):[])),new m.$aR("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$$Q("color","The color to show and insert",r=>r instanceof I.$RO,s.Color.from),new m.$$Q("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:s.Range.from(r.range)}))],new m.$_Q("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(s.ColorPresentation.to):[])),new m.$aR("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$$Q.Uri,m.$$Q.Range],new m.$_Q("A promise that resolves to an array of Inlay objects",(r,a,h)=>r.map(s.InlayHint.to.bind(void 0,h)))),new m.$aR("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$$Q.Uri],new m.$_Q("A promise that resolves to an array of FoldingRange objects",(r,a)=>{if(r)return r.map(s.FoldingRange.to)})),new m.$aR("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$_Q("A promise that resolves to an array of NotebookContentProvider static info objects.",k(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>s.NotebookExclusiveDocumentPattern.to(a))})))),new m.$aR("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$$Q.Uri,m.$$Q.Range,new m.$$Q("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.$dO,r=>s.InlineValueContext.from(r))],new m.$_Q("A promise that resolves to an array of InlineValue objects",r=>r.map(s.InlineValue.to))),new m.$aR("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$$Q("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,D.$Ug)(r,D.Schemas.http,D.Schemas.https),r=>r),new m.$$Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional(),m.$$Q.String.with("label","").optional()],m.$_Q.Void),new m.$aR("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$$Q.Uri.with("resource","Resource to open"),m.$$Q.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$$Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[s.ViewColumn.from(r),void 0]:[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)])).optional()],m.$_Q.Void),new m.$aR("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$$Q.Uri.with("left","Left-hand side resource of the diff editor"),m.$$Q.Uri.with("right","Right-hand side resource of the diff editor"),m.$$Q.String.with("title","Human readable title for the diff editor").optional(),new m.$$Q("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[s.ViewColumn.from(r.viewColumn),s.TextEditorOpenOptions.from(r)]).optional()],m.$_Q.Void),new m.$aR("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$$Q.String.with("title","Human readable title for the changes editor"),new m.$$Q("resourceList","List of resources to compare",r=>{for(const a of r){if(a.length!==3)return!1;const[h,c,i]=a;if(!P.URI.isUri(h)||!P.URI.isUri(c)&&c!==void 0&&c!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],m.$_Q.Void),new m.$aR("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$$Q.Uri,m.$$Q.Position],new m.$_Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.$aR("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$$Q.TypeHierarchyItem],new m.$_Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.$aR("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$$Q.TypeHierarchyItem],new m.$_Q("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(s.TypeHierarchyItem.to))),new m.$aR("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$$Q.TestItem],m.$_Q.Void),new m.$aR("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$$Q.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$_Q.Void),new m.$aR("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$$Q.String.with("name","The context key name"),new m.$$Q("value","The context key value",()=>!0,r=>r)],m.$_Q.Void),new m.$aR("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$$Q.Uri,m.$$Q.StringArray,new m.$$Q("MappedEditsContext","Mapped Edits Context",r=>s.MappedEditsContext.is(r),r=>s.MappedEditsContext.from(r))],new m.$_Q("A promise that resolves to a workspace edit or null",r=>r?s.WorkspaceEdit.to(r):null)),new m.$aR("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$$Q("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?s.Range.from(r.initialRange):void 0,initialSelection:I.$eO.isSelection(r.initialSelection)?s.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?s.Position.from(r.position):void 0}})],m.$_Q.Void)];class u{static register(a){w.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",T.$Jj)}}e.$7qc=u;function k(r){return a=>{if(Array.isArray(a))return a.map(r)}}function $(r){if(!Array.isArray(r))return;const a=[];for(const h of r)L.$Tu(h)?a.push(s.DefinitionLink.to(h)):a.push(s.location.to(h));return a}}),define(Re[257],Oe([1,0,2,35]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Asc=void 0;class P{constructor(R,T,m,s,I){this.a=T,this.b=m,this.c=s;const w=new D.$aR("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new D.$$Q("showOptions","Show Options",u=>!0,u=>u),new D.$$Q("resource","Interactive resource Uri",u=>!0,u=>u),new D.$$Q("controllerId","Notebook controller Id",u=>!0,u=>u),new D.$$Q("title","Interactive editor title",u=>!0,u=>u)],new D.$_Q("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const k=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri),notebookEditor:k.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:v.URI.revive(u.notebookUri),inputUri:v.URI.revive(u.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(R,T,m,s){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:m,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Asc=P}),define(Re[258],Oe([1,0,17,10,19,6,4,27,2,18,11,5,35,8,7,83,197,21,39,198]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Isc=void 0,e.$Jsc=d,k=Ve(k);let n=class{constructor(E,y,C,O,p){this.m=y,this.n=C,this.o=O,this.q=p,this.b=new T.$Fc,this.c=new T.$Fc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$qe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=E.getProxy(w.$_N.MainThreadNotebookKernels);const b=new u.$aR("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$$Q("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const F=this.n.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:F}}else if(A&&"notebookEditor"in A){const F=this.n.getIdByEditor(A.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return A})],u.$_Q.Void),M=new u.$aR("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$$Q.Uri],new u.$_Q("A promise that resolves to an array of variables",(A,F)=>A.map(G=>({variable:{name:G.name,value:G.value,expression:G.expression,type:G.type,language:G.language},hasNamedChildren:G.hasNamedChildren,indexedChildrenCount:G.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(M)}createNotebookController(E,y,C,O,p,b){for(const _ of this.j.values())if(_.controller.id===y&&s.$xn.equals(E.identifier,_.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const M=this.k++,A=this;this.q.trace(`NotebookController[${M}], CREATED by ${E.identifier.value}, ${y}`);const F=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${E.identifier}'`);let G=!1;const x=new L.$qe,j=new L.$qe,U={id:d(E.identifier,y),notebookType:C,extensionId:E.identifier,extensionLocation:E.extensionLocation,label:O||E.identifier.value,preloads:b?b.map(k.NotebookRendererScript.from):[]};let J=p??F,Y,ae;this.a.$addKernel(M,U).catch(_=>{console.log(_),G=!0});let ee=0;const oe=()=>{if(G)return;const _=++ee;Promise.resolve().then(()=>{_===ee&&this.a.$updateKernel(M,U)})},ie=new T.$Fc,ue={get id(){return y},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return U.label},set label(_){U.label=_??E.displayName??E.name,oe()},get detail(){return U.detail??""},set detail(_){U.detail=_,oe()},get description(){return U.description??""},set description(_){U.description=_,oe()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(_){U.supportedLanguages=_,oe()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(_){U.supportsExecutionOrder=_,oe()},get rendererScripts(){return U.preloads?U.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler(_){J=_??F},get interruptHandler(){return Y},set interruptHandler(_){Y=_,U.supportsInterrupt=!!_,oe()},set variableProvider(_){(0,h.$BH)(E,"notebookVariableProvider"),ae=_,U.hasVariableProvider=!!_,_?.onDidChangeVariables($e=>A.a.$variablesUpdated($e.uri)),oe()},get variableProvider(){return ae},createNotebookCellExecution(_){if(G)throw new Error("notebook controller is DISPOSED");if(!ie.has(_.notebook.uri))throw A.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.notebook.uri.toString()}`);return A._createNotebookCellExecution(_,d(E.identifier,this.id))},createNotebookExecution(_){if((0,h.$BH)(E,"notebookExecution"),G)throw new Error("notebook controller is DISPOSED");if(!ie.has(_.uri))throw A.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${_.uri.toString()}`);return A._createNotebookExecution(_,d(E.identifier,this.id))},dispose:()=>{G||(this.q.trace(`NotebookController[${M}], DISPOSED`),G=!0,this.j.delete(M),x.dispose(),j.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(_,$e){$e===$.NotebookControllerAffinity2.Hidden&&(0,h.$BH)(E,"notebookControllerAffinityHidden"),A.a.$updateNotebookPriority(M,_.uri,$e)},onDidReceiveMessage:j.event,postMessage(_,$e){return(0,h.$BH)(E,"notebookMessaging"),A.a.$postMessage(M,$e&&A.n.getIdByEditor($e),_)},asWebviewUri(_){return(0,h.$BH)(E,"notebookMessaging"),(0,r.$vEb)(_,A.m.remote)}};return this.j.set(M,{extensionId:E.identifier,controller:ue,onDidReceiveMessage:j,onDidChangeSelection:x,associatedNotebooks:ie}),ue}getIdByController(E){for(const[y,C]of this.j)if(C.controller===E)return d(C.extensionId,E.id);return null}createNotebookControllerDetectionTask(E,y){const C=this.g++,O=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${E.identifier.value}`),this.a.$addKernelDetectionTask(C,y);const p={dispose:()=>{this.f.delete(C),O.a.$removeKernelDetectionTask(C)}};return this.f.set(C,p),p}registerKernelSourceActionProvider(E,y,C){const O=this.i++,p=typeof C.onDidChangeNotebookKernelSourceActions=="function"?O:void 0,b=this;this.h.set(O,C),this.q.trace(`NotebookKernelSourceActionProvider[${O}], CREATED by ${E.identifier.value}`),this.a.$addKernelSourceActionProvider(O,O,y);let M;return p!==void 0&&(M=C.onDidChangeNotebookKernelSourceActions(A=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(O),b.a.$removeKernelSourceActionProvider(O,O),M?.dispose()}}}async $provideKernelSourceActions(E,y){const C=this.h.get(E);if(C){const O=new R.$Yc;return(await C.provideNotebookKernelSourceActions(y)??[]).map(b=>k.NotebookKernelSourceAction.from(b,this.o.converter,O))}return[]}$acceptNotebookAssociation(E,y,C){const O=this.j.get(E);if(O){const p=this.n.getNotebookDocument(m.URI.revive(y));C?O.associatedNotebooks.set(p.uri,!0):O.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${E}] ASSOCIATE notebook`,p.uri.toString(),C),O.onDidChangeSelection.fire({selected:C,notebook:p.apiNotebook})}}async $executeCells(E,y,C){const O=this.j.get(E);if(!O)return;const p=this.n.getNotebookDocument(m.URI.revive(y)),b=[];for(const M of C){const A=p.getCell(M);A&&b.push(A.apiCell)}try{this.q.trace(`NotebookController[${E}] EXECUTE cells`,p.uri.toString(),b.length),await O.controller.executeHandler.call(O.controller,b,p.apiNotebook,O.controller)}catch(M){this.q.error(`NotebookController[${E}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(E,y,C){const O=this.j.get(E);if(!O)return;const p=this.n.getNotebookDocument(m.URI.revive(y));if(O.controller.interruptHandler)await O.controller.interruptHandler.call(O.controller,p.apiNotebook);else for(const b of C){const M=p.getCell(b);M&&this.b.get(M.uri)?.cancel()}if(O.controller.interruptHandler){const b=this.c.get(p.uri);this.c.delete(p.uri),C.length&&Array.isArray(b)&&b.length&&b.forEach(M=>M.dispose())}}async $provideVariables(E,y,C,O,p,b,M){const A=this.j.get(E);if(!A)return;const F=this.n.getNotebookDocument(m.URI.revive(C)),G=A.controller.variableProvider;if(!G)return;let x;if(O!==void 0){if(x=this.s[O],!x)return}else this.s={};const j=p==="named"?$.NotebookVariablesRequestKind.Named:$.NotebookVariablesRequestKind.Indexed,U=G.provideVariables(F.apiNotebook,x,j,b,M);let J=0;for await(const Y of U){if(M.isCancellationRequested)return;const ae={id:this.r++,name:Y.variable.name,value:Y.variable.value,type:Y.variable.type,interfaces:Y.variable.interfaces,language:Y.variable.language,expression:Y.variable.expression,hasNamedChildren:Y.hasNamedChildren,indexedChildrenCount:Y.indexedChildrenCount,extensionId:A.extensionId.value};if(this.s[ae.id]=Y.variable,this.a.$receiveVariable(y,ae),J++>=i.$kL)return}}$acceptKernelMessageFromRenderer(E,y,C){const O=this.j.get(E);if(!O)return;const p=this.n.getEditorById(y);O.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:C}))}$cellExecutionChanged(E,y,C){const p=this.n.getNotebookDocument(m.URI.revive(E)).getCell(y);if(p){const b=C?k.NotebookCellExecutionState.to(C):$.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:p.apiCell,state:b})}}_createNotebookCellExecution(E,y){if(E.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const O=this.n.getNotebookDocument(E.notebook.uri).getCellFromApiCell(E);if(!O)throw new Error("invalid cell");if(this.b.has(O.uri))throw new Error(`duplicate execution for ${O.uri}`);const p=new o(y,O,this.a);this.b.set(O.uri,p);const b=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),b.dispose(),this.b.delete(O.uri))});return p.asApiObject()}_createNotebookExecution(E,y){const C=this.n.getNotebookDocument(E.uri),O=E.getCells().find(M=>{const A=C.getCellFromApiCell(M);return A&&this.b.has(A.uri)});if(O)throw new Error(`duplicate cell execution for ${O.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const p=new g(y,C,this.a),b=p.onDidChangeState(()=>{p.state===l.Resolved&&(p.dispose(),b.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[p,b]),p.asApiObject()}};e.$Isc=n,e.$Isc=n=Ke([qe(4,I.$fk)],n);var t;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(t||(t={}));class o extends R.$Zc{static{this.a=0}get state(){return this.f}constructor(E,y,C){super(),this.m=y,this.n=C,this.b=o.a++,this.c=new L.$qe,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$Be),this.h=new f(10,O=>this.s(O)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,E,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(E){await this.h.addItem(E)}async s(E){const y=Array.isArray(E)?E:[E];return this.n.$updateExecution(this.b,new c.$7w(y))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(E){let y=this.m;if(E&&(y=this.m.notebook.getCellFromApiCell(E)),!y)throw new Error("INVALID cell");return y.handle}y(E){return E.map(y=>{const C=$.$JP.ensureUniqueMimeTypes(y.items,!0);return C===y.items?k.NotebookCellOutput.from(y):k.NotebookCellOutput.from({items:C,id:y.id,metadata:y.metadata})})}async z(E,y,C){const O=this.w(y),p=this.y((0,v.$6b)(E));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:O,append:C,outputs:p})}async C(E,y,C){return E=$.$JP.ensureUniqueMimeTypes((0,v.$6b)(E),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:E.map(k.NotebookCellOutputItem.from),outputId:y.id,append:C})}asApiObject(){const E=this;return Object.freeze({get token(){return E.g.token},get cell(){return E.m.apiCell},get executionOrder(){return E.j},set executionOrder(C){E.j=C,E.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:E.j}])},start(C){if(E.f===t.Resolved||E.f===t.Started)throw new Error("Cannot call start again");E.f=t.Started,E.c.fire(),E.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,O,p){if(E.f===t.Resolved)throw new Error("Cannot call resolve twice");E.f=t.Resolved,E.c.fire(),E.h.flush();const b=p?{message:p.message,stack:p.stack,location:p?.location?{startLineNumber:p.location.start.line,startColumn:p.location.start.character,endLineNumber:p.location.end.line,endColumn:p.location.end.character}:void 0,uri:p.uri}:void 0;E.n.$completeExecution(E.b,new c.$7w({runEndTime:O,lastRunSuccess:C,error:b}))},clearOutput(C){return E.t(),E.z([],C,!1)},appendOutput(C,O){return E.t(),E.z(C,O,!0)},replaceOutput(C,O){return E.t(),E.z(C,O,!1)},appendOutputItems(C,O){return E.t(),E.C(C,O,!0)},replaceOutputItems(C,O){return E.t(),E.C(C,O,!1)}})}}var l;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(l||(l={}));class g extends R.$Zc{static{this.a=0}get state(){return this.f}constructor(E,y,C){super(),this.h=y,this.j=C,this.b=g.a++,this.c=new L.$qe,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new P.$Be),this.j.$createNotebookExecution(this.b,E,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class f{constructor(E,y){this.f=E,this.g=y,this.a=[],this.b=Date.now()}addItem(E){return this.a.push(E),this.c||(this.c=new D.$8h,this.b=Date.now(),(0,D.$Lh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const E=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>E.complete())}}function d(S,E){return`${S.value}/${E}`}}),define(Re[56],Oe([1,0,6,5,3,2,16,4,7,9,12,180,19,33,181,182,36,10,8,35,38]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lrc=e.$Krc=e.$Jrc=e.$Irc=void 0,e.$Irc=(0,P.$Ki)("IExtHostTerminalService");class t extends T.$Zc{constructor(p,b,M,A){super(),this.u=p,this._id=b,this.w=M,this.y=A,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$qe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(G=>this.g=G);const F=this;this.value={get name(){return F.y||""},get processId(){return F.b},get creationOptions(){return F.w},get exitStatus(){return F.j},get state(){return F.m},get selection(){return F.n},get shellIntegration(){return F.shellIntegration},sendText(G,x=!0){F.C(),F.u.$sendText(F._id,G,x)},show(G){F.C(),F.u.$show(F._id,G)},hide(){F.C(),F.u.$hide(F._id)},dispose(){F.a||(F.a=!0,F.u.$dispose(F._id))},get dimensions(){if(!(F.f===void 0||F.h===void 0))return{columns:F.f,rows:F.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??b?.cwd??void 0,env:p.env??void 0,icon:E(p.iconPath)??void 0,color:a.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(p.location,b?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,b,M,A,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:A,color:a.ThemeColor.isThemeColor(F)?F.id:void 0,location:b?.location||this.z(p,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,b){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in p?{viewColumn:c.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,b){this.j=Object.freeze({code:p,reason:b})}setDimensions(p,b){return p===this.f&&b===this.h||p===0||b===0?!1:(this.f=p,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(b=>{b!==p&&(this.b=Promise.resolve(p))})}}e.$Jrc=t;class o{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new v.$qe,this.onProcessData=this.a.event,this.b=new v.$qe,this.d=new v.$qe,this.onDidChangeProperty=this.d.event,this.f=new v.$qe,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,b){this.g.setDimensions?.({columns:p,rows:b})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:$.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:$.ProcessPropertyType.Title,value:b})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,g=class extends T.$Zc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,b,M){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$1c),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$qe,this.onDidCloseTerminal=this.H.event,this.I=new v.$qe,this.onDidOpenTerminal=this.I.event,this.J=new v.$qe,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$qe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$qe,this.onDidChangeTerminalState=this.M.event,this.N=new v.$qe,this.onDidChangeShell=this.N.event,this.O=new v.$qe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$qe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(D.$_N.MainThreadTerminalService),this.y=new r.$6zb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:A=>{const F=G=>{const x=G;return this.getTerminalById(x.instanceId)?.value};switch(A?.$mid){case n.MarshalledId.TerminalContext:return F(A);default:{if(Array.isArray(A))for(let G=0;G<A.length&&A[G].$mid===n.MarshalledId.TerminalContext;G++)A[G]=F(A[G]);return A}}}}),this.B({dispose:()=>{for(const[A,F]of this.g)F.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,b){const M=new t(this.a,(0,k.$7g)(),p,p.name),A=new o(p.pty);return M.createExtensionTerminal(p.location,b,this.R(p,b).resolvedExtHostIdentifier,E(p.iconPath),y(p.color)).then(F=>{const G=this.S(F,A);this.h[F]=G}),this.f.push(M),M.value}R(p,b){if(b=b||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const M=p.location.parentTerminal;if(M){const A=this.f.find(F=>F.value===M);A&&(b.resolvedExtHostIdentifier=A._id)}}else p.location&&typeof p.location!="object"?b.location=p.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(p,b){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const A=new o(b),F=this.S(p,A);this.h[p]=F}async $acceptActiveTerminalChanged(p){const b=this.b;if(p===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById(p);M&&(this.b=M,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,b){const M=this.getTerminalById(p);M&&this.O.fire({terminal:M.value,data:b})}async $acceptTerminalDimensions(p,b,M){const A=this.getTerminalById(p);A&&A.setDimensions(b,M)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(p,b){const M=this.getTerminalById(p);M&&this.P.fire({terminal:M.value,...b})}async $acceptTerminalMaximumDimensions(p,b,M){this.g.get(p)?.resize(b,M)}async $acceptTerminalTitleChange(p,b){const M=this.getTerminalById(p);M&&(M.name=b)}async $acceptTerminalClosed(p,b,M){const A=this.X(this.f,p);if(A!==null){const F=this.f.splice(A,1)[0];F.setExitStatus(b,M),this.H.fire(F.value)}}$acceptTerminalOpened(p,b,M,A){if(b){const x=this.X(this.f,b);if(x!==null){this.f[x]._id=p,this.I.fire(this.terminals[x]),this.f[x].isOpen=!0;return}}const F={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:L.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},G=new t(this.a,p,F,M);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(p,b){this.getTerminalById(p)?._setProcessId(b)}async $startExtensionTerminal(p,b){const M=this.getTerminalById(p);if(!M)return{message:(0,s.localize)(2714,null,p)};M.isOpen||await new Promise(F=>{const G=this.onDidOpenTerminal(async x=>{x===M.value&&(G.dispose(),F())})});const A=this.g.get(p);A?A.startSendingEvents(b):this.j[p]={initialDimensions:b}}S(p,b){const M=new T.$Yc;M.add(b.onProcessReady(F=>this.a.$sendProcessReady(p,F.pid,F.cwd,F.windowsPty))),M.add(b.onDidChangeProperty(F=>this.a.$sendProcessProperty(p,F))),this.y.startBuffering(p,b.onProcessData),M.add(b.onProcessExit(F=>this.U(p,F))),this.g.set(p,b);const A=this.j[p];return A&&b instanceof o&&(b.startSendingEvents(A.initialDimensions),delete this.j[p]),M}$acceptProcessAckDataEvent(p,b){this.g.get(p)?.acknowledgeDataEvent(b)}$acceptProcessInput(p,b){this.g.get(p)?.input(b)}$acceptTerminalInteraction(p){const b=this.getTerminalById(p);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(p,b){this.getTerminalById(p)?.setSelection(b)}$acceptProcessResize(p,b,M){try{this.g.get(p)?.resize(b,M)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(p,b){this.g.get(p)?.shutdown(b)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(p,{type:$.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(b=>this.a.$sendProcessProperty(p,{type:$.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new m.$bO(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,b,M){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,M),this.a.$registerProfileProvider(b,p.identifier.value),new m.$bO(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(p,b,M){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,M),this.a.$registerQuickFixProvider(p,b),new m.$bO(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,b){const M=new u.$Be().token;if(M.isCancellationRequested)return;const A=this.D.get(p);if(!A)return;const F=await A.provideTerminalQuickFixes(b,M);if(F===null||Array.isArray(F)&&F.length===0)return;const G=new T.$Yc;if(this.w.value=G,!Array.isArray(F))return F?c.TerminalQuickFix.from(F,this.Q.converter,G):void 0;const x=[];for(const j of F){const U=c.TerminalQuickFix.from(j,this.Q.converter,G);U&&x.push(U)}return x}async $createContributedProfileTerminal(p,b){const M=new u.$Be().token;let A=await this.C.get(p)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,b);return}this.createTerminalFromOptions(A.options,b)}}async $provideLinks(p,b){const M=this.getTerminalById(p);if(!M)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const F=new u.$Be;this.G.set(p,F);const G=[],x={terminal:M.value,line:b},j=[];for(const Y of this.z)j.push(h.Promises.withAsyncBody(async ae=>{F.token.onCancellationRequested(()=>ae({provider:Y,links:[]}));const ee=await Y.provideTerminalLinks(x,F.token)||[];F.token.isCancellationRequested||ae({provider:Y,links:ee})}));const U=await Promise.all(j);if(F.token.isCancellationRequested)return[];const J=new Map;for(const Y of U)Y&&Y.links.length>0&&G.push(...Y.links.map(ae=>{const ee={id:l++,startIndex:ae.startIndex,length:ae.length,label:ae.tooltip};return J.set(ee.id,{provider:Y.provider,link:ae}),ee}));return this.F.set(p,J),G}$activateLink(p,b){const M=this.F.get(p)?.get(b);M&&M.provider.handleTerminalLink(M.link)}U(p,b){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const M=this.h[p];M&&(M.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,b)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const b=this.f.findIndex(M=>M.value===p);return b>=0?b:null}W(p,b){const M=this.X(p,b);return M!==null?p[M]:null}X(p,b){const M=p.findIndex(A=>A._id===b);return M>=0?M:null}getEnvironmentVariableCollection(p){let b=this.n.get(p.identifier.value);return b||(b=this.B(new f),this.Z(p.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(p,b){const M=(0,w.$Ns)(b.map),A=(0,w.$Os)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(p,b.persistent,M.length===0?void 0:M,A)}$initEnvironmentVariableCollections(p){p.forEach(b=>{const M=b[0],A=this.B(new f(b[1]));this.Z(M,A)})}$acceptDefaultProfile(p,b){const M=this.s;this.s=p,this.u=b,M?.path!==p.path&&this.N.fire(p.path)}Z(p,b){this.n.set(p,b),this.B(b.onDidChangeCollection(()=>{this.Y(p,b)}))}};e.$Krc=g,e.$Krc=g=Ke([qe(1,i.$9Q),qe(2,R.$MQ)],g);class f extends T.$Zc{get persistent(){return this.b}set persistent(p){this.b=p,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(p){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$qe,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const b=this.j(p);let M=this.a.get(b);return M||(M=new d(this,p),this.a.set(b,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace(p,b,M,A){this.g(p,{value:b,type:m.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:A})}append(p,b,M,A){this.g(p,{value:b,type:m.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:A})}prepend(p,b,M,A){this.g(p,{value:b,type:m.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:A})}g(p,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(p,b.scope),A=this.map.get(M),F=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==b.value||A.type!==b.type||A.options?.applyAtProcessCreation!==F.applyAtProcessCreation||A.options?.applyAtShellIntegration!==F.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const G=this.h(p,b.scope),x={variable:p,...b,options:F};this.map.set(G,x),this.f.fire()}}get(p,b){const M=this.h(p,b),A=this.map.get(M);return A?C(A):void 0}h(p,b){const M=this.j(b);return M.length?`${p}:::${M}`:p}j(p){return this.m(p?.workspaceFolder)??""}m(p){return p?p.uri.toString():void 0}getVariableMap(p){const b=new Map;for(const[M,A]of this.map)this.j(A.scope)===this.j(p)&&b.set(A.variable,C(A));return b}delete(p,b){const M=this.h(p,b);this.map.delete(M),this.f.fire()}clear(p){if(p?.workspaceFolder){for(const[b,M]of this.map)M.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(b);this.n(p)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(p,b){const M=this.j(b),A=this.descriptionMap.get(M);if(!A||A.description!==p){let F;typeof p=="string"?F=p:F=p?.value.split(`

`)[0];const G={description:F,scope:b};this.descriptionMap.set(M,G),this.f.fire()}}getDescription(p){const b=this.j(p);return this.descriptionMap.get(b)?.description}n(p){const b=this.j(p);this.descriptionMap.delete(b)}}class d{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,b){this.b=p,this.d=b,this.a=new v.$qe}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,b,M){this.b.replace(p,b,M,this.d)}append(p,b,M){this.b.append(p,b,M,this.d)}prepend(p,b,M){this.b.prepend(p,b,M,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,b){this.b.getVariableMap(this.d).forEach((M,A)=>p.call(b,A,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let S=class extends g{constructor(p,b){super(!1,p,b)}createTerminal(p,b,M){throw new I.$db}createTerminalFromOptions(p,b){throw new I.$db}};e.$Lrc=S,e.$Lrc=S=Ke([qe(0,i.$9Q),qe(1,R.$MQ)],S);function E(O){if(!(!O||typeof O=="string"))return"id"in O?{id:O.id,color:O.color}:O}function y(O){return a.ThemeColor.isThemeColor(O)?O:void 0}function C(O){const p={...O};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(Re[128],Oe([1,0,7,4,3,5,16,56,6,2,10]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2sc=e.$1sc=void 0,e.$1sc=(0,P.$Ki)("IExtHostTerminalShellIntegration");let w=class extends D.$Zc{constructor(a,h){super(),this.h=h,this.b=new Map,this.c=new m.$qe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$qe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$qe,this.onDidEndTerminalShellExecution=this.g.event,this.a=a.getProxy(L.$_N.MainThreadTerminalShellIntegration),this.B((0,D.$Xc)(()=>{for(const[c,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(a){const h=this.h.getTerminalById(a);if(!h)return;const c=h.value;let i=this.b.get(a);i||(i=new u(h.value,this.f),this.b.set(a,i),i.store.add(h.onWillDispose(()=>this.b.get(a)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(a,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),h.shellIntegration=i.value),this.c.fire({terminal:c,shellIntegration:i.value})}$shellExecutionStart(a,h,c,i,n){this.b.has(a)||this.$shellIntegrationChange(a);const t={value:h,confidence:c,isTrusted:i};this.b.get(a)?.startShellExecution(t,s.URI.revive(n))}$shellExecutionEnd(a,h,c,i,n){const t={value:h,confidence:c,isTrusted:i};this.b.get(a)?.endShellExecution(t,n)}$shellExecutionData(a,h){this.b.get(a)?.emitData(h)}$cwdChange(a,h){this.b.get(a)?.setCwd(s.URI.revive(h))}$closeTerminal(a){this.b.get(a)?.dispose(),this.b.delete(a)}};e.$2sc=w,e.$2sc=w=Ke([qe(0,R.$MQ),qe(1,T.$Irc)],w);class u extends D.$Zc{get currentExecution(){return this.a}constructor(a,h){super(),this.j=a,this.m=h,this.b=!1,this.store=this.B(new D.$Yc),this.f=this.B(new m.$qe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$qe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$qe),this.onDidRequestEndExecution=this.h.event;const c=this;this.value={get cwd(){return c.c},executeCommand(i,n){let t=i;n&&(t+=` "${n.map(g=>`${g.replaceAll('"','\\"')}`).join('" "')}"`),c.g.fire(t);const o={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=c.startShellExecution(o,c.c,!0).value;return c.b=!0,l}}}startShellExecution(a,h,c){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new k(a,h??this.c);c?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(a){this.currentExecution?.emitData(a)}endShellExecution(a,h){this.a&&(this.a.endExecution(a),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:h}),this.a=void 0)}setCwd(a){let h=!1;s.URI.isUri(this.c)?h=!s.URI.isUri(a)||this.c.toString()!==a.toString():this.c!==a&&(h=!0),h&&(this.c=a,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class k{constructor(a,h){this.c=a,this.cwd=h,this.b=!1;const c=this;this.value={get commandLine(){return c.c},get cwd(){return c.cwd},read(){return c.d()}}}d(){if(!this.a){if(this.b)return I.$$h.EMPTY;this.a=new $}return this.a.createIterable()}emitData(a){this.a?.emitData(a)}endExecution(a){a&&(this.c=a),this.a?.endExecution(),this.a=void 0,this.b=!0}}class $ extends D.$Zc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Jh);const a=this.a;return new I.$$h(async c=>{this.b.push(c),await a.wait()})}emitData(a){for(const h of this.b)h.emitOne(a)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Re[129],Oe([1,0,61,12,97,8,7]),function(we,e,v,D,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VQ=e.$UQ=e.$TQ=void 0,L=Ve(L);class T{static{this.c=new P.$RQ("TextEditorDecorationType")}constructor(u,k,$){const r=T.c.nextId();u.$registerTextEditorDecorationType(k.identifier,r,L.DecorationRenderOptions.from($)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$TQ=T;class m{constructor(u,k){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,k){this.k();let $=null;if(u instanceof R.$cO)$=new R.$dO(u,u);else if(u instanceof R.$dO)$=u;else throw new Error("Unrecognized location");this.l($,k,!1)}insert(u,k){this.k(),this.l(new R.$dO(u,u),k,!0)}delete(u){this.k();let k=null;if(u instanceof R.$dO)k=u;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(u,k,$){const r=this.c.validateRange(u);this.g.push({range:r,text:k,forceMoveMarkers:$})}setEndOfLine(u){if(this.k(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,D.$$)("endOfLine");this.h=u}}class s{constructor(u,k,$,r){this.c=u,this.d=k,this._accept($),this.e=r;const a=this;this.value={get tabSize(){return a.f},set tabSize(h){a.n(h)},get indentSize(){return a.g},set indentSize(h){a.p(h)},get insertSpaces(){return a.j},set insertSpaces(h){a.s(h)},get cursorStyle(){return a.k},set cursorStyle(h){a.t(h)},get lineNumbers(){return a.l},set lineNumbers(h){a.u(h)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=L.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}n(u){const k=this.m(u);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}p(u){const k=this.o(u);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const k=this.q(u);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(u)})))}assign(u){const k={};let $=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?($=!0,k.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,$=!0,k.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?($=!0,k.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,$=!0,k.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?($=!0,k.insertSpaces=r):this.j!==r&&(this.j=r,$=!0,k.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,$=!0,k.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,$=!0,k.lineNumbers=L.TextEditorLineNumbersStyle.from(u.lineNumbers)),$&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v(u,k){k.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn($)})}}e.$UQ=s;class I{constructor(u,k,$,r,a,h,c,i){this.id=u,this.j=k,this.k=$,this.g=!1,this.h=new Set,this.c=a,this.d=new s(this.j,this.id,h,$),this.e=c,this.f=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new D.$ab("document")},get selection(){return n.c&&n.c[0]},set selection(t){if(!(t instanceof R.$eO))throw(0,D.$$)("selection");n.c=[t],n.l()},get selections(){return n.c},set selections(t){if(!Array.isArray(t)||t.some(o=>!(o instanceof R.$eO)))throw(0,D.$$)("selections");n.c=t,n.l()},get visibleRanges(){return n.e},set visibleRanges(t){throw new D.$ab("visibleRanges")},get options(){return n.d.value},set options(t){n.g||n.d.assign(t)},get viewColumn(){return n.f},set viewColumn(t){throw new D.$ab("viewColumn")},edit(t,o={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new m(r.value,o);return t(l),n.m(l)},insertSnippet(t,o,l={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let g;if(!o||Array.isArray(o)&&o.length===0)g=n.c.map(f=>L.Range.from(f));else if(o instanceof R.$cO){const{lineNumber:f,column:d}=L.Position.from(o);g=[{startLineNumber:f,startColumn:d,endLineNumber:f,endColumn:d}]}else if(o instanceof R.$dO)g=[L.Range.from(o)];else{g=[];for(const f of o)if(f instanceof R.$dO)g.push(L.Range.from(f));else{const{lineNumber:d,column:S}=L.Position.from(f);g.push({startLineNumber:d,startColumn:S,endLineNumber:d,endColumn:S})}}return k.$tryInsertSnippet(u,r.value.version,t.value,g,l)},setDecorations(t,o){const l=o.length===0;l&&!n.h.has(t.key)||(l?n.h.delete(t.key):n.h.add(t.key),n.n(()=>{if(L.$JQ(o))return k.$trySetDecorations(u,t.key,L.$KQ(o));{const g=new Array(4*o.length);for(let f=0,d=o.length;f<d;f++){const S=o[f];g[4*f]=S.start.line+1,g[4*f+1]=S.start.character+1,g[4*f+2]=S.end.line+1,g[4*f+3]=S.end.character+1}return k.$trySetDecorationsFast(u,t.key,g)}}))},revealRange(t,o){n.n(()=>k.$tryRevealRange(u,L.Range.from(t),o||R.TextEditorRevealType.Default))},show(t){k.$tryShowEditor(u,L.ViewColumn.from(t))},hide(){k.$tryHideEditor(u)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,v.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,v.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,v.ok)(!this.g),this.f=u}_acceptSelections(u){(0,v.ok)(!this.g),this.c=u}async l(){const u=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const k=u.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const $=k.edits.map(a=>a.range);$.sort((a,h)=>a.end.line===h.end.line?a.end.character===h.end.character?a.start.line===h.start.line?a.start.character-h.start.character:a.start.line-h.start.line:a.end.character-h.end.character:a.end.line-h.end.line);for(let a=0,h=$.length-1;a<h;a++){const c=$[a].end;if($[a+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=k.edits.map(a=>({range:L.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,r,{setEndOfLine:typeof k.setEndOfLine=="number"?L.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$VQ=I}),define(Re[57],Oe([1,0,61,6,4,2,3,5,125,16,129,8,11,27,15,41,51]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XQ=e.$WQ=void 0,v=Ve(v),w=Ve(w);class h{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(n,t){this.h=n,this.i=t,this.a=null,this.b=new Map,this.c=new k.$Fc,this.d=new D.$qe,this.e=new D.$qe,this.f=new D.$qe,this.g=new D.$qe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],o=[],l=[];if(n.removedDocuments)for(const g of n.removedDocuments){const f=L.URI.revive(g),d=this.c.get(f);d?.unref()&&(this.c.delete(f),t.push(d.value))}if(n.addedDocuments)for(const g of n.addedDocuments){const f=L.URI.revive(g.uri);let d=this.c.get(f);if(d&&f.scheme!==$.Schemas.vscodeNotebookCell&&f.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${f} already exists!'`);d||(d=new h(new m.$PQ(this.h.getProxy(T.$_N.MainThreadDocuments),f,g.lines,g.EOL,g.versionId,g.languageId,g.isDirty)),this.c.set(f,d),o.push(d.value)),d.ref()}if(n.removedEditors)for(const g of n.removedEditors){const f=this.b.get(g);this.b.delete(g),f&&l.push(f)}if(n.addedEditors)for(const g of n.addedEditors){const f=L.URI.revive(g.documentUri);v.ok(this.c.has(f),`document '${f}' does not exist`),v.ok(!this.b.has(g.id),`editor '${g.id}' already exists!`);const d=this.c.get(f).value,S=new I.$VQ(g.id,this.h.getProxy(T.$_N.MainThreadTextEditors),this.i,new a.$Y(()=>d.document),g.selections.map(w.Selection.to),g.options,g.visibleRanges.map(E=>w.Range.to(E)),typeof g.editorPosition=="number"?w.ViewColumn.to(g.editorPosition):void 0);this.b.set(g.id,S)}n.newActiveEditor!==void 0&&(v.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,P.$Uc)(t),(0,P.$Uc)(l),n.removedDocuments&&this.e.fire(t),n.addedDocuments&&this.d.fire(o),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(g=>g.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return r.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const t=this.b.get(this.a);return n?t:t?.value}allEditors(){return[...this.b.values()]}};e.$WQ=c,e.$WQ=c=Ke([qe(0,s.$MQ),qe(1,u.$fk)],c),e.$XQ=(0,R.$Ki)("IExtHostDocumentsAndEditors")}),define(Re[96],Oe([1,0,10,20,19,6,231,76,4,38,14,2,33,3,11,5,35,57,16,127,8,7,200,54,82,55,21]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7rc=e.$6rc=e.$5rc=e.$4rc=e.$3rc=void 0,n=Ve(n);let S=0;const E=new WeakMap;e.$3rc=(0,k.$Ki)("IExtHostTesting");let y=class extends m.$Zc{constructor(ee,oe,ie,ue){super(),this.C=oe,this.D=ie,this.F=ue,this.f=this.B(new L.$qe),this.g=new Map,this.w=this.B(new L.$qe),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=ee.getProxy(r.$_N.MainThreadTesting),this.m=new x(this.h),this.j=new b(this.h,oe),ie.registerArgumentProcessor({processArgument:_=>{switch(_?.$mid){case s.MarshalledId.TestItemContext:{const $e=_,Ie=$e.tests[$e.tests.length-1].item.extId;return this.g.get(l.$rJ.root(Ie))?.collection.tree.get(Ie)?.actual??(0,i.$YQ)(_)}case s.MarshalledId.TestMessageMenuArgs:{const{test:$e,message:Ie}=_,X=$e.item.extId;return{test:this.g.get(l.$rJ.root(X))?.collection.tree.get(X)?.actual??(0,i.$YQ)({$mid:s.MarshalledId.TestItemContext,tests:[$e]}),message:n.TestMessage.to(Ie)}}default:return _}}}),ie.registerCommand(!1,"testing.getExplorerSelection",async()=>{const _=await ie.executeCommand(o.TestCommandId.GetExplorerSelection),$e=Ie=>{const X=this.g.get(l.$rJ.root(Ie));if(X)return l.$rJ.isRoot(Ie)?X.controller:X.collection.tree.get(Ie)?.actual};return{include:_?.include.map($e).filter(I.$rg)||[],exclude:_?.exclude.map($e).filter(I.$rg)||[]}})}createTestController(ee,oe,ie,ue){if(this.g.has(oe))throw new Error(`Attempt to insert a duplicate controller with ID "${oe}"`);const _=new m.$Yc,$e=_.add(new i.$2Q(oe,ie,this.F));$e.root.label=ie;const Ie=new Map,X=new Set,V=this.h,re=()=>{let Fe=0;ue&&(Fe|=f.TestControllerCapability.Refresh);const Be=Pe.relatedCodeProvider;return Be&&(Be?.provideRelatedTests&&(Fe|=f.TestControllerCapability.TestRelatedToCode),Be?.provideRelatedCode&&(Fe|=f.TestControllerCapability.CodeRelatedToTest)),Fe},be={items:$e.root.children,get label(){return ie},set label(Fe){ie=Fe,$e.root.label=Fe,V.$updateController(oe,{label:ie})},get refreshHandler(){return ue},set refreshHandler(Fe){ue=Fe,V.$updateController(oe,{capabilities:re()})},get id(){return oe},get relatedCodeProvider(){return Pe.relatedCodeProvider},set relatedCodeProvider(Fe){(0,d.$BH)(ee,"testRelatedCode"),Pe.relatedCodeProvider=Fe,V.$updateController(oe,{capabilities:re()})},createRunProfile:(Fe,Be,xe,nt,ht,$t)=>{let ut=(0,T.$yj)(Fe);for(;Ie.has(ut);)ut++;return new U(this.h,Ie,X,this.w.event,oe,ut,Fe,Be,xe,nt,ht,$t)},createTestItem(Fe,Be,xe){return new i.$ZQ(oe,Fe,Be,xe)},createTestRun:(Fe,Be,xe=!0)=>this.j.createTestRun(ee,oe,$e,Fe,Be,xe),invalidateTestResults:Fe=>{if(Fe===void 0)this.h.$markTestRetired(void 0);else{const Be=Fe instanceof Array?Fe:[Fe];this.h.$markTestRetired(Be.map(xe=>l.$rJ.fromExtHostTestItem(xe,oe).toString()))}},set resolveHandler(Fe){$e.resolveHandler=Fe},get resolveHandler(){return $e.resolveHandler},dispose:()=>{_.dispose()}},Pe={controller:be,collection:$e,profiles:Ie,extension:ee,activeProfiles:X};return V.$registerTestController(oe,ie,re()),_.add((0,m.$Xc)(()=>V.$unregisterTestController(oe))),this.g.set(oe,Pe),_.add((0,m.$Xc)(()=>this.g.delete(oe))),_.add($e.onDidGenerateDiff(Fe=>V.$publishDiff(oe,Fe.map(f.TestsDiffOp.serialize)))),be}createTestObserver(){return this.m.checkout()}async runTests(ee,oe=P.CancellationToken.None){const ie=M(ee);if(!ie)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ue=this.g.get(ie.controllerId);if(!ue)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:ee.preserveFocus??!0,group:J[ie.kind],targets:[{testIds:ee.include?.map(_=>l.$rJ.fromExtHostTestItem(_,ue.collection.root.id).toString())??[ue.collection.root.id],profileId:ie.profileId,controllerId:ie.controllerId}],exclude:ee.exclude?.map(_=>_.id)},oe)}registerTestFollowupProvider(ee){return this.y.add(ee),{dispose:()=>{this.y.delete(ee)}}}async $getTestsRelatedToCode(ee,oe,ie){const ue=this.F.getDocument(w.URI.revive(ee));if(!ue)return[];const _=n.Position.to(oe),$e=[];return await Promise.all([...this.g.values()].map(async Ie=>{let X;try{X=await Ie.relatedCodeProvider?.provideRelatedTests?.(ue.document,_,ie)}catch(V){ie.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${Ie.controller.label}`,V)}if(X){for(const V of X)$e.push(l.$rJ.fromExtHostTestItem(V,Ie.controller.id).toString());Ie.collection.flushDiff()}})),$e}async $getCodeRelatedToTest(ee,oe){const ie=this.g.get(l.$rJ.root(ee));if(!ie)return[];const ue=ie.collection.tree.get(ee);return ue?(await ie.relatedCodeProvider?.provideRelatedCode?.(ue.actual,oe))?.map(n.location.from)??[]:[]}$syncTests(){for(const{collection:ee}of this.g.values())ee.flushDiff();return Promise.resolve()}async $getCoverageDetails(ee,oe,ie){return(await this.j.getCoverageDetails(ee,oe,ie))?.map(n.TestCoverage.fromDetails)}async $disposeRun(ee){this.j.disposeTestRun(ee)}$configureRunProfile(ee,oe){this.g.get(ee)?.profiles.get(oe)?.configureHandler?.()}$setDefaultRunProfiles(ee){const oe=new Map;for(const[ie,ue]of Object.entries(ee)){const _=this.g.get(ie);if(!_)continue;const $e=new Map,Ie=ue.filter(V=>!_.activeProfiles.has(V)),X=[..._.activeProfiles].filter(V=>!ue.includes(V));for(const V of Ie)$e.set(V,!0),_.activeProfiles.add(V);for(const V of X)$e.set(V,!1),_.activeProfiles.delete(V);$e.size&&oe.set(ie,$e)}this.w.fire(oe)}async $refreshTests(ee,oe){await this.g.get(ee)?.controller.refreshHandler?.(oe)}$publishTestResults(ee){this.results=Object.freeze(ee.map(oe=>{const ie=n.TestResults.to(oe),ue=oe.tasks.findIndex(_=>_.hasCoverage);return ue!==-1&&(ie.getDetailedCoverage=(_,$e=P.CancellationToken.None)=>this.h.$getCoverageDetails(oe.id,ue,_,$e).then(Ie=>Ie.map(n.TestCoverage.to))),E.set(ie,oe.id),ie}).concat(this.results).sort((oe,ie)=>ie.completedAt-oe.completedAt).slice(0,32)),this.f.fire()}async $expandTest(ee,oe){const ie=this.g.get(l.$rJ.fromString(ee).controllerId)?.collection;ie&&(await ie.expand(ee,oe<0?1/0:oe),ie.flushDiff())}$acceptDiff(ee){this.m.applyDiff(ee.map(oe=>f.TestsDiffOp.deserialize({asCanonicalUri:ie=>ie},oe)))}async $runControllerTests(ee,oe){return Promise.all(ee.map(ie=>this.G(ie,!1,oe)))}async $startContinuousRun(ee,oe){const ie=new P.$Be(oe),ue=await Promise.all(ee.map(_=>this.G(_,!0,ie.token)));return!oe.isCancellationRequested&&!ue.some(_=>_.error)&&await new Promise(_=>oe.onCancellationRequested(_)),ie.dispose(!0),ue}async $provideTestFollowups(ee,oe){const ie=this.results.find($e=>E.get($e)===ee.resultId),ue=ie&&Y(l.$rJ.fromString(ee.extId),ie?.results);if(!ue)return[];let _=[];return await Promise.all([...this.y].map(async $e=>{try{const Ie=await $e.provideFollowup(ie,ue,ee.taskIndex,ee.messageIndex,oe);Ie&&(_=_.concat(Ie))}catch(Ie){this.C.error("Error thrown while providing followup for test message",Ie)}})),oe.isCancellationRequested?[]:_.map($e=>{const Ie=S++;return this.z.set(Ie,$e),{title:$e.title,id:Ie}})}$disposeTestFollowups(ee){for(const oe of ee)this.z.delete(oe)}$executeTestFollowup(ee){const oe=this.z.get(ee);return oe?this.D.executeCommand(oe.command,...oe.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(ee,oe){ee===void 0?this.j.cancelAllRuns():this.j.cancelRunById(ee,oe)}getMetadataForRun(ee){for(const oe of this.j.trackers){const ie=oe.getTaskIdForRun(ee);if(ie)return{taskId:ie,runId:oe.id}}}async G(ee,oe,ie){const ue=this.g.get(ee.controllerId);if(!ue)return{};const{collection:_,profiles:$e,extension:Ie}=ue,X=$e.get(ee.profileId);if(!X)return{};const V=ee.testIds.map(Fe=>_.tree.get(Fe)).filter(I.$rg),re=ee.excludeExtIds.map(Fe=>ue.collection.tree.get(Fe)).filter(I.$rg).filter(Fe=>V.some(Be=>Be.fullId.compare(Fe.fullId)===l.TestPosition.IsChild));if(!V.length)return{};const be=new t.$QP(V.some(Fe=>Fe.actual instanceof i.$1Q)?void 0:V.map(Fe=>Fe.actual),re.map(Fe=>Fe.actual),X,oe),Pe=(0,f.$uJ)(ee)&&this.j.prepareForMainThreadTestRun(Ie,be,A.fromInternal(ee,ue.collection),X,ie);try{return await X.runHandler(be,ie),{}}catch(Fe){return{error:String(Fe)}}finally{Pe&&Pe.hasRunningTasks&&!ie.isCancellationRequested&&await L.Event.toPromise(Pe.onEnd)}}};e.$4rc=y,e.$4rc=y=Ke([qe(0,c.$MQ),qe(1,$.$fk),qe(2,a.$9Q),qe(3,h.$XQ)],y);const C=1e4;var O;(function(ae){ae[ae.Running=0]="Running",ae[ae.Cancelling=1]="Cancelling",ae[ae.Ended=2]="Ended"})(O||(O={}));class p extends m.$Zc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(ee,oe,ie,ue,_,$e){super(),this.C=ee,this.D=oe,this.F=ie,this.G=ue,this.H=_,this.f=O.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new L.$qe),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new P.$Be($e));const Ie=this.B(new v.$Wh(()=>this.I(),C));this.B(this.m.token.onCancellationRequested(()=>Ie.schedule()));const X=new L.$qe;this.y=X.event,this.B((0,m.$Xc)(()=>{X.fire(),X.dispose()}))}getTaskIdForRun(ee){for(const[oe,{run:ie}]of this.h)if(ie===ee)return oe}cancel(ee){ee?this.h.get(ee)?.cts.cancel():this.f===O.Running?(this.m.cancel(),this.f=O.Cancelling):this.f===O.Cancelling&&this.I()}async getCoverageDetails(ee,oe,ie){const[,ue]=l.$rJ.fromString(ee).path,_=this.z.get(ee);if(!_)return[];const{report:$e,extIds:Ie}=_,X=this.h.get(ue);if(!X)throw new Error("unreachable: run task was not found");let V;if(oe&&$e instanceof t.$WP){const be=Ie.indexOf(oe);if(be===-1)return[];V=$e.fromTests[be]}return await(V?this.G?.loadDetailedCoverageForTest?.(X.run,$e,V,ie):this.G?.loadDetailedCoverage?.(X.run,$e,ie))??[]}createRun(ee){const oe=this.C.id,ie=this.C.controllerId,ue=(0,u.$7g)(),_=re=>(be,...Pe)=>{if(Ie){this.F.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}this.L(be),re(be,...Pe)},$e=(re,be)=>{const Pe=be instanceof Array?be.map(n.TestMessage.from):[n.TestMessage.from(be)];if(re.uri&&re.range){const Fe={range:n.Range.from(re.range),uri:re.uri};for(const Be of Pe)Be.location=Be.location||Fe}this.D.$appendTestMessagesInRun(oe,ue,l.$rJ.fromExtHostTestItem(re,ie).toString(),Pe)};let Ie=!1;const X=this.B(new P.$Be(this.m.token)),V={isPersisted:this.C.isPersisted,token:X.token,name:ee,onDidDispose:this.y,addCoverage:re=>{if(Ie)return;const be=re instanceof t.$WP?re.fromTests:[];if(be.length){(0,d.$BH)(this.H,"attributableCoverage");for(const Be of be)this.L(Be)}const Pe=re.uri.toString(),Fe=new l.$rJ([oe,ue,Pe]).toString();this.z.set(Fe,{report:re,extIds:be.map(Be=>l.$rJ.fromExtHostTestItem(Be,ie).toString())}),this.D.$appendCoverage(oe,ue,n.TestCoverage.fromFile(ie,Fe,re))},enqueued:_(re=>{this.D.$updateTestStateInRun(oe,ue,l.$rJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Queued)}),skipped:_(re=>{this.D.$updateTestStateInRun(oe,ue,l.$rJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Skipped)}),started:_(re=>{this.D.$updateTestStateInRun(oe,ue,l.$rJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Running)}),errored:_((re,be,Pe)=>{$e(re,be),this.D.$updateTestStateInRun(oe,ue,l.$rJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Errored,Pe)}),failed:_((re,be,Pe)=>{$e(re,be),this.D.$updateTestStateInRun(oe,ue,l.$rJ.fromExtHostTestItem(re,ie).toString(),f.TestResultState.Failed,Pe)}),passed:_((re,be)=>{this.D.$updateTestStateInRun(oe,ue,l.$rJ.fromExtHostTestItem(re,this.C.controllerId).toString(),f.TestResultState.Passed,be)}),appendOutput:(re,be,Pe)=>{Ie||(Pe&&this.L(Pe),this.D.$appendOutputToRun(oe,ue,D.$Se.fromString(re),be&&n.location.from(be),Pe&&l.$rJ.fromExtHostTestItem(Pe,ie).toString()))},end:()=>{Ie||(Ie=!0,this.D.$finishedTestRunTask(oe,ue),--this.g||this.J())}};return this.g++,this.h.set(ue,{run:V,cts:X}),this.D.$startedTestRunTask(oe,{id:ue,ctrlId:this.C.controllerId,name:ee||this.H.displayName||this.H.identifier.value,running:!0}),V}I(){for(const{run:ee}of this.h.values())ee.end()}J(){this.f!==O.Ended&&(this.f=O.Ended,this.w.fire())}L(ee){if(!(ee instanceof i.$ZQ))throw new g.$EQ(ee.id);if(this.j.has(l.$rJ.fromExtHostTestItem(ee,this.C.controllerId).toString()))return;const oe=[],ie=this.C.colllection.root;for(;;){const ue=n.TestItem.from(ee);if(oe.unshift(ue),this.j.has(ue.extId)||(this.j.add(ue.extId),ee===ie))break;ee=ee.parent||ie}this.D.$addTestsToRun(this.C.controllerId,this.C.id,oe)}dispose(){this.J(),super.dispose()}}class b{get trackers(){return this.f.values()}constructor(ee,oe){this.h=ee,this.j=oe,this.f=new Map,this.g=new Map}getCoverageDetails(ee,oe,ie){const ue=l.$rJ.root(ee);return this.g.get(ue)?.getCoverageDetails(ee,oe,ie)||[]}disposeTestRun(ee){this.g.get(ee)?.dispose(),this.g.delete(ee);for(const[oe,{id:ie}]of this.f)ie===ee&&this.f.delete(oe)}prepareForMainThreadTestRun(ee,oe,ie,ue,_){return this.k(oe,ie,ue,ee,_)}cancelRunById(ee,oe){this.g.get(ee)?.cancel(oe)}cancelAllRuns(){for(const ee of this.f.values())ee.cancel()}createTestRun(ee,oe,ie,ue,_,$e){const Ie=this.f.get(ue);if(Ie)return Ie.createRun(_);const X=A.fromPublic(oe,ie,ue,$e),V=M(ue);this.h.$startedExtensionTestRun({controllerId:oe,continuous:!!ue.continuous,profile:V&&{group:J[V.kind],id:V.profileId},exclude:ue.exclude?.map(be=>l.$rJ.fromExtHostTestItem(be,ie.root.id).toString())??[],id:X.id,include:ue.include?.map(be=>l.$rJ.fromExtHostTestItem(be,ie.root.id).toString())??[ie.root.id],preserveFocus:ue.preserveFocus??!0,persist:$e});const re=this.k(ue,X,ue.profile,ee);return L.Event.once(re.onEnd)(()=>{this.h.$finishedExtensionTestRun(X.id)}),re.createRun(_)}k(ee,oe,ie,ue,_){const $e=new p(oe,this.h,this.j,ie,ue,_);return this.f.set(ee,$e),this.g.set($e.id,$e),$e}}e.$5rc=b;const M=ae=>{if(ae.profile){if(!(ae.profile instanceof U))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ae.profile}};class A{static fromPublic(ee,oe,ie,ue){return new A(ee,(0,u.$7g)(),ue,oe)}static fromInternal(ee,oe){return new A(ee.controllerId,ee.runId,!0,oe)}constructor(ee,oe,ie,ue){this.controllerId=ee,this.id=oe,this.isPersisted=ie,this.colllection=ue}}e.$6rc=A;class F{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(ee){this.k=ee,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(ee){this.f.add(ee)}update(ee){Object.assign(ee.revived,n.TestItem.toPlain(ee.item)),this.f.has(ee)||this.g.add(ee)}remove(ee){if(this.f.has(ee)){this.f.delete(ee);return}this.g.delete(ee);const oe=l.$rJ.parentId(ee.item.extId);if(oe&&this.j.has(oe.toString())){this.j.add(ee.item.extId);return}this.h.add(ee)}getChangeEvent(){const{f:ee,g:oe,h:ie}=this;return{get added(){return[...ee].map(ue=>ue.revived)},get updated(){return[...oe].map(ue=>ue.revived)},get removed(){return[...ie].map(ue=>ue.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class G extends f.$AJ{constructor(){super(...arguments),this.z=new L.$qe,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(ee){return this.g.get(ee)}getMirroredTestDataByReference(ee){return this.g.get(ee.id)}y(ee,oe){return{...ee,revived:n.TestItem.toPlain(ee.item),depth:oe?oe.depth+1:0,children:new Set}}x(){return new F(this.z)}}class x{constructor(ee){this.g=ee}checkout(){this.f||(this.f=this.h());const ee=this.f;return ee.observers++,{onDidChangeTest:ee.tests.onDidChangeTests,get tests(){return[...ee.tests.rootTests].map(oe=>oe.revived)},dispose:(0,R.$hb)(()=>{--ee.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(ee){return this.f?.tests.getMirroredTestDataByReference(ee)}applyDiff(ee){this.f?.tests.apply(ee)}h(){const ee=new G({asCanonicalUri:oe=>oe});return this.g.$subscribeToDiffs(),{observers:0,tests:ee}}}const j=(ae,ee,oe,ie)=>{oe?Object.assign(oe,ie):ee.$updateTestRunConfig(ae.controllerId,ae.profileId,ie)};class U{#e;#t;#i;#n;#s;get label(){return this.g}set label(ee){ee!==this.g&&(this.g=ee,j(this,this.#e,this.#n,{label:ee}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(ee){ee!==this.h&&(this.h=ee,j(this,this.#e,this.#n,{supportsContinuousRun:ee}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(ee){ee!==this.isDefault&&(ee?this.#t.add(this.profileId):this.#t.delete(this.profileId),j(this,this.#e,this.#n,{isDefault:ee}))}get tag(){return this._tag}set tag(ee){ee?.id!==this._tag?.id&&(this._tag=ee,j(this,this.#e,this.#n,{tag:ee?n.TestTag.namespace(this.controllerId,ee.id):null}))}get configureHandler(){return this.f}set configureHandler(ee){ee!==this.f&&(this.f=ee,j(this,this.#e,this.#n,{hasConfigurationHandler:!!ee}))}get onDidChangeDefault(){return L.Event.chain(this.#i,ee=>ee.map(oe=>oe.get(this.controllerId)?.get(this.profileId)).filter(I.$rg))}constructor(ee,oe,ie,ue,_,$e,Ie,X,V,re=!1,be=void 0,Pe=!1){this.controllerId=_,this.profileId=$e,this.g=Ie,this.kind=X,this.runHandler=V,this._tag=be,this.h=Pe,this.#e=ee,this.#s=oe,this.#t=ie,this.#i=ue,oe.set($e,this);const Fe=J[X];if(typeof Fe!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);re&&ie.add($e),this.#n={profileId:$e,controllerId:_,tag:be?n.TestTag.namespace(this.controllerId,be.id):null,label:Ie,group:Fe,isDefault:re,hasConfigurationHandler:!1,supportsContinuousRun:Pe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$7rc=U;const J={[t.TestRunProfileKind.Coverage]:f.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:f.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:f.TestRunProfileBitset.Run};function Y(ae,ee){for(let oe=0;oe<ae.path.length;oe++){const ie=ee.find(ue=>ue.id===ae.path[oe]);if(!ie)return;if(oe===ae.path.length-1)return ie;ee=ie.children}}}),define(Re[259],Oe([1,0,17,6,4,5,129,8,7]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$brc=void 0,v=Ve(v),T=Ve(T);class s extends P.$Zc{constructor(w,u){super(),this.m=u,this.a=new D.$qe,this.b=new D.$qe,this.c=new D.$qe,this.f=new D.$qe,this.g=new D.$qe,this.h=new D.$qe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=w.getProxy(L.$_N.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(k=>this.h.fire(k))),this.B(this.m.onDidChangeActiveTextEditor(k=>this.g.fire(k)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(w){const u=this.m.allEditors();return w?u:u.map(k=>k.value)}async showTextDocument(w,u,k){let $;typeof u=="number"?$={position:T.ViewColumn.from(u),preserveFocus:k}:typeof u=="object"?$={position:T.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?T.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:$={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(w.uri,$),a=r&&this.m.getEditor(r);if(a)return a.value;throw r?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}createTextEditorDecorationType(w,u){return new R.$TQ(this.j,w,u).value}$acceptEditorPropertiesChanged(w,u){const k=this.m.getEditor(w);if(!k)throw new Error("unknown text editor");if(u.options&&k._acceptOptions(u.options),u.selections){const $=u.selections.selections.map(T.Selection.to);k._acceptSelections($)}if(u.visibleRanges){const $=v.$Lb(u.visibleRanges.map(T.Range.to));k._acceptVisibleRanges($)}if(u.options&&this.b.fire({textEditor:k.value,options:{...u.options,lineNumbers:T.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const $=m.TextEditorSelectionChangeKind.fromValue(u.selections.source),r=u.selections.selections.map(T.Selection.to);this.a.fire({textEditor:k.value,selections:r,kind:$})}if(u.visibleRanges){const $=v.$Lb(u.visibleRanges.map(T.Range.to));this.c.fire({textEditor:k.value,visibleRanges:$})}}$acceptEditorPositionData(w){for(const u in w){const k=this.m.getEditor(u);if(!k)throw new Error("Unknown text editor");const $=T.ViewColumn.to(w[u]);k.value.viewColumn!==$&&(k._acceptViewColumn($),this.f.fire({textEditor:k.value,viewColumn:$}))}}getDiffInformation(w){return Promise.resolve(this.j.$getDiffInformation(w))}}e.$brc=s}),define(Re[260],Oe([1,0,2,3,5,4,7,8,18,38,14]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5sc=e.$4sc=void 0,e.$4sc=(0,D.$Ki)("IExtHostTimeline");class w{constructor($,r){this.b=new Map,this.c=new Map,this.a=$.getProxy(P.$_N.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(a,h)=>{if(a&&a.$mid===s.MarshalledId.TimelineActionContext)if(this.b.get(a.source)&&m.$xn.equals(h,this.b.get(a.source)?.extension)){const c=a.uri===void 0?void 0:v.URI.revive(a.uri);return this.c.get(a.source)?.get(u(c))?.get(a.handle)}else return;return a}})}async $getTimeline($,r,a,h){return this.b.get($)?.provider.provideTimeline(v.URI.revive(r),a,h)}registerTimelineProvider($,r,a,h){const c=new L.$Yc,i=this.d(r.id,h,c).bind(this);let n;r.onDidChange&&(n=r.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:r.id}),this));const t=this.c;return this.f({...r,scheme:$,onDidChange:void 0,async provideTimeline(o,l,g){l?.resetCache&&(c.clear(),t.get(r.id)?.clear());const f=await r.provideTimeline(o,l,g);if(f==null)return;const d=i(o,l);return{...f,source:r.id,items:f.items.map(d)}},dispose(){for(const o of t.values())o.get(r.id)?.clear();n?.dispose(),c.dispose()}},a)}d($,r,a){return(h,c)=>{let i;if(c?.cacheResults){let n=this.c.get($);n===void 0&&(n=new Map,this.c.set($,n));const t=u(h);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...o}=n,l=`${$}|${n.id??n.timestamp}`;i?.set(l,n);let g,f,d;n.iconPath&&(t instanceof R.$aP?d={id:t.id,color:t.color}:v.URI.isUri(t)?(g=t,f=t):{light:g,dark:f}=t);let S;return R.$FO.isMarkdownString(o.tooltip)?S=T.MarkdownString.from(o.tooltip):(0,I.$jg)(o.tooltip)?S=o.tooltip:R.$FO.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=T.MarkdownString.from(o.detail)):(0,I.$jg)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=o.detail),{...o,id:o.id??void 0,handle:l,source:$,command:n.command?r.toInternal(n.command,a):void 0,icon:g,iconDark:f,themeIcon:d,tooltip:S,accessibilityInformation:n.accessibilityInformation}}}}f($,r){if(this.b.get($.id))throw new Error(`Timeline Provider ${$.id} already exists.`);return this.a.$registerTimelineProvider({id:$.id,label:$.label,scheme:$.scheme}),this.b.set($.id,{provider:$,extension:r}),(0,L.$Xc)(()=>{for(const h of this.c.values())h.get($.id)?.clear();this.b.delete($.id),this.a.$unregisterTimelineProvider($.id),$.dispose()})}}e.$5sc=w;function u(k){return k?.toString()}}),define(Re[261],Oe([1,0,9,24,2,6,4,192,10,7,14,17,8,59,19,156,21]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6sc=void 0,s=Ve(s);function h(n,t){if((0,I.$jg)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let o;return Array.isArray(n.highlights)&&(o=n.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),o=o.length?o:void 0),{label:n.label,highlights:o}}}class c extends R.$Zc{constructor(t,o,l){super(),this.f=t,this.g=o,this.h=l,this.a=new Map,this.b=new r.$lab;function g(f){return f&&f.$treeViewId&&(f.$treeItemHandle||f.$selectedTreeItems||f.$focusedTreeItem)}o.registerArgumentProcessor({processArgument:f=>g(f)?this.r(f):Array.isArray(f)&&f.length>0?f.map(d=>g(d)?this.r(d):d):f})}registerTreeDataProvider(t,o,l){const g=this.createTreeView(t,{treeDataProvider:o},l);return{dispose:()=>g.dispose()}}createTreeView(t,o,l){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=o.dragAndDropController?.dropMimeTypes??[],f=o.dragAndDropController?.dragMimeTypes??[],d=!!o.dragAndDropController?.handleDrag,S=!!o.dragAndDropController?.handleDrop,E=this.m(t,o,l),y={showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dropMimeTypes:g,dragMimeTypes:f,hasHandleDrag:d,hasHandleDrop:S,manuallyManageCheckboxes:!!o.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,y),O={get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get activeItem(){return(0,a.$BH)(l,"treeViewActiveItem"),E.focusedElement},get onDidChangeActiveItem(){return(0,a.$BH)(l,"treeViewActiveItem"),E.onDidChangeActiveItem},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get onDidChangeCheckboxState(){return E.onDidChangeCheckboxState},get message(){return E.message},set message(p){(0,k.$$k)(p)&&(0,a.$BH)(l,"treeViewMarkdownMessage"),E.message=p},get title(){return E.title},set title(p){E.title=p},get description(){return E.description},set description(p){E.description=p},get badge(){return E.badge},set badge(p){p!==void 0&&s.ViewBadge.isViewBadge(p)?E.badge={value:Math.floor(Math.abs(p.value)),tooltip:p.tooltip}:p===void 0&&(E.badge=void 0)},reveal:(p,b)=>E.reveal(p,b),dispose:async()=>{await C,this.a.delete(t),E.dispose()}};return this.B(O),O}$getChildren(t,o){const l=this.a.get(t);return l?l.getChildren(o):Promise.reject(new T.$TG(t))}async $handleDrop(t,o,l,g,f,d,S,E){const y=this.a.get(t);if(!y)return Promise.reject(new T.$TG(t));const C=u.DataTransfer.toDataTransfer(l,async O=>(await this.f.$resolveDropFileData(t,o,O)).buffer);return S===t&&E&&await this.j(C,y,E,f,d),y.onDrop(C,g,f)}async j(t,o,l,g,f){const d=this.b.removeDragOperationTransfer(f);if(d)(await d)?.forEach((S,E)=>{S&&t.set(E,S)});else if(f&&o.handleDrag){const S=o.handleDrag(l,t,g);this.b.addDragOperationTransfer(f,S),await S}return t}async $handleDrag(t,o,l,g){const f=this.a.get(t);if(!f)return Promise.reject(new T.$TG(t));const d=await this.j(new s.$9O,f,o,g,l);if(!(!d||g.isCancellationRequested))return u.DataTransfer.from(d)}async $hasResolve(t){const o=this.a.get(t);if(!o)throw new T.$TG(t);return o.hasResolve}$resolve(t,o,l){const g=this.a.get(t);if(!g)throw new T.$TG(t);return g.resolveTreeItem(o,l)}$setExpanded(t,o,l){const g=this.a.get(t);if(!g)throw new T.$TG(t);g.setExpanded(o,l)}$setSelectionAndFocus(t,o,l){const g=this.a.get(t);if(!g)throw new T.$TG(t);g.setSelectionAndFocus(o,l)}$setVisible(t,o){const l=this.a.get(t);if(!l){if(!o)return;throw new T.$TG(t)}l.setVisible(o)}$changeCheckboxState(t,o){const l=this.a.get(t);if(!l)throw new T.$TG(t);l.setCheckboxState(o)}m(t,o,l){const g=this.B(new i(t,o,this.f,this.g.converter,this.h,l));return this.a.set(t,g),g}r(t){const o=this.a.get(t.$treeViewId);return o&&"$treeItemHandle"in t?o.getExtensionElement(t.$treeItemHandle):o&&"$focusedTreeItem"in t&&t.$focusedTreeItem?o.focusedElement:null}}e.$6sc=c;class i extends R.$Zc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$sg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,o,l,g,f,d){if(super(),this.I=t,this.J=l,this.L=g,this.M=f,this.N=d,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$qe),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$qe),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$qe),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$qe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$qe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$qe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$qe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$Be,d.contributes&&d.contributes.views)for(const C in d.contributes.views)for(const O of d.contributes.views[C])O.id===t&&(this.P=O.name);this.f=o.treeDataProvider,this.g=o.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let S,E;const y=L.Event.debounce(this.F.event,(C,O)=>(C||(C={message:!1,elements:[]}),O.element!==!1&&(S||(S=new Promise(p=>E=p),this.G=this.G.then(()=>S)),Array.isArray(O.element)?C.elements.push(...O.element):C.elements.push(O.element)),O.message&&(C.message=!0),C),200,!0);this.B(y(({message:C,elements:O})=>{O.length&&(this.H=this.H.then(()=>{const p=E;return S=null,this.$(O).then(()=>p())})),C&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const o=t?this.getExtensionElement(t):void 0;if(t&&!o)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let l=this.X(t);return l||(l=await this.Y(o)),l?l.map(g=>g.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,o){o=o||{select:!0,focus:!1};const l=(0,I.$sg)(o.select)?!0:o.select,g=(0,I.$sg)(o.focus)?!1:o.focus,f=(0,I.$sg)(o.expand)?!1:o.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(d=>this.W(t,d[d.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:d.map(E=>E.item)},{select:l,focus:g,expand:f})),d=>this.M.error(d)):this.J.$reveal(this.I,void 0,{select:l,focus:g,expand:f})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,o){const l=this.getExtensionElement(t);l&&(o?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(t,o){const l=!(0,w.$yb)(this.s,t);this.s=t;const g=this.t!==o;this.t=o,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),g&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const o=(await Promise.all(t.map(async l=>{const g=this.getExtensionElement(l.treeItemHandle);return g?{extensionItem:g,treeItem:await this.f.getTreeItem(g),newState:l.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);o.forEach(l=>{l.treeItem.checkboxState=l.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}),this.D.fire({items:o.map(l=>[l.extensionItem,l.newState])})}async handleDrag(t,o,l){const g=[];for(const f of t){const d=this.getExtensionElement(f);d&&g.push(d)}if(!(!this.g?.handleDrag||g.length===0))return await this.g.handleDrag(g,o,l),o}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,o,l){const g=o?this.getExtensionElement(o):void 0;if(!(!g&&o||!this.g?.handleDrop))return(0,m.$Ch)(()=>this.g?.handleDrop?this.g.handleDrop(g,t,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,o){if(!this.f.resolveTreeItem)return;const l=this.j.get(t);if(l){const g=this.m.get(l);if(g){const f=await this.f.resolveTreeItem(g.extensionItem,l,o)??g.extensionItem;return this.hb(f),g.item.tooltip=this.eb(f.tooltip),g.item.command=this.fb(g.disposableStore,f.command),g.item}}}S(t){return this.U(t).then(o=>o?this.S(o).then(l=>this.W(o,l[l.length-1]).then(g=>(l.push(g),l))):Promise.resolve([]))}U(t){const o=this.m.get(t);return o?Promise.resolve(o.parent?this.j.get(o.parent.item.handle):void 0):(0,m.$Ch)(()=>this.f.getParent(t))}W(t,o){const l=this.m.get(t);return l?Promise.resolve(l):(0,m.$Ch)(()=>this.f.getTreeItem(t)).then(g=>this.kb(t,g,o,!0)).then(g=>this.getChildren(o?o.item.handle:void 0).then(()=>{const f=this.getExtensionElement(g);if(f){const d=this.m.get(f);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${g} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let o;if(typeof t=="string"){const l=this.getExtensionElement(t);o=l?this.m.get(l):void 0}else o=t;return o&&o.children||void 0}return this.h}async Y(t){this.rb(t);const o=new $.$Be(this.Z.token);try{const l=t?this.m.get(t):void 0,g=await this.f.getChildren(t);if(o.token.isCancellationRequested)return;const f=(0,w.$Lb)(g||[]),d=await Promise.all((0,w.$Lb)(f).map(E=>this.f.getTreeItem(E)));if(o.token.isCancellationRequested)return;const S=d.map((E,y)=>E?this.db(f[y],E,l):null);return(0,w.$Lb)(S)}finally{o.dispose()}}$(t){if(t.some(l=>!l))return this.Z.dispose(!0),this.Z=new $.$Be,this.tb(),this.J.$refresh(this.I);{const l=this.ab(t);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(t){const o=new Set,l=t.map(f=>this.m.get(f));for(const f of l)if(f&&!o.has(f.item.handle)){let d=f;for(;d&&d.parent&&l.findIndex(S=>d&&d.parent&&S&&S.item.handle===d.parent.item.handle)===-1;){const S=this.j.get(d.parent.item.handle);d=S?this.m.get(S):void 0}d&&!d.parent&&o.add(f.item.handle)}const g=[];return o.forEach(f=>{const d=this.j.get(f);if(d){const S=this.m.get(d);S&&(!S.parent||!o.has(S.parent.item.handle))&&g.push(f)}}),g}bb(t){const o={};return Promise.all(t.map(l=>this.cb(l).then(g=>{g&&(o[l]=g.item)}))).then(()=>Object.keys(o).length?this.J.$refresh(this.I,o):void 0)}cb(t){const o=this.getExtensionElement(t);if(o){const l=this.m.get(o);if(l)return this.rb(o),(0,m.$Ch)(()=>this.f.getTreeItem(o)).then(g=>{if(g){const f=this.ib(o,g,l.parent);return this.pb(o,f,l,l.parent),l.dispose(),f}return null})}return Promise.resolve(null)}db(t,o,l){const g=this.ib(t,o,l);if(o.id&&this.j.has(g.item.handle))throw new Error((0,v.localize)(2715,null,o.id));return this.ob(t,g),this.qb(g,l),g}eb(t){return s.$FO.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,o){return o?{...this.L.toInternal(o,t),originalId:o.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let o,l,g;return typeof t.checkboxState=="number"?o=t.checkboxState:(o=t.checkboxState.state,l=t.checkboxState.tooltip,g=t.checkboxState.accessibilityInformation),{isChecked:o===s.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:g}}hb(t){if(!s.$4O.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,o,l){this.hb(o);const g=this.B(new R.$Yc),f=this.kb(t,o,l),d=this.lb(o);return{item:{handle:f,parentHandle:l?l.item.handle:void 0,label:h(o.label,this.N),description:o.description,resourceUri:o.resourceUri,tooltip:this.eb(o.tooltip),command:this.fb(g,o.command),contextValue:o.contextValue,icon:d,iconDark:this.mb(o)||d,themeIcon:this.jb(o),collapsibleState:(0,I.$sg)(o.collapsibleState)?s.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation,checkbox:this.gb(o)},extensionItem:o,parent:l,children:void 0,disposableStore:g,dispose(){g.dispose()}}}jb(t){return t.iconPath instanceof s.$aP?t.iconPath:void 0}kb(t,{id:o,label:l,resourceUri:g},f,d){if(o)return`${i.b}/${o}`;const S=h(l,this.N),E=f?f.item.handle:i.a;let y=S?S.label:g?(0,D.$ih)(g):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,O=this.X(f)||[];let p,b=0;do{if(p=`${E}/${b}:${y}`,d||!this.j.has(p)||C===p)break;b++}while(b<=O.length);return p}lb(t){if(t.iconPath&&!(t.iconPath instanceof s.$aP))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof s.$aP)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,o){this.j.set(o.item.handle,t),this.m.set(t,o)}pb(t,o,l,g){this.j.delete(o.item.handle),this.m.delete(t),o.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(t,o);const f=this.X(g)||[],d=f.filter(S=>S.item.handle===l.item.handle)[0];d&&f.splice(f.indexOf(d),1,o)}qb(t,o){o?(o.children||(o.children=[]),o.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const o=this.m.get(t);if(o){if(o.children)for(const l of o.children){const g=this.j.get(l.item.handle);g&&this.sb(g)}o.children=void 0}}else this.tb()}sb(t){const o=this.m.get(t);if(o){if(o.children)for(const l of o.children){const g=this.j.get(l.item.handle);g&&this.sb(g)}this.m.delete(t),this.j.delete(o.item.handle),o.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[262],Oe([1,0,6,4,2,33,8,67,5,7]),function(we,e,v,D,P,L,R,T,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=void 0,R=Ve(R),m=Ve(m),s=Ve(s);class I extends D.$Zc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor($,r,a,h){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new v.$qe),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$qe),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=r,this.#n=a,this.#i=h.viewType,this.#s=h.panelOptions,this.#o=h.viewColumn,this.#r=h.title,this.#l=h.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title($){this.c(),this.#r!==$&&(this.#r=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#a}set iconPath($){this.c(),this.#a!==$&&(this.#a=$,this.#t.$setIconPath(this.#e,P.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState($){this.#u||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#l=$.active,this.#c=$.visible,this.#o=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:R.ViewColumn.from($),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class w extends D.$Zc{static c(){return(0,L.$7g)()}constructor($,r,a){super(),this.j=r,this.m=a,this.g=new Map,this.h=new Map,this.f=$.getProxy(m.$_N.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,r,a,h,c={}){const i=typeof h=="object"?h.viewColumn:h,n={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof h=="object"&&!!h.preserveFocus},t=(0,T.$qrc)($),o=w.c();this.f.$createWebviewPanel((0,T.$src)($),o,r,{title:a,panelOptions:u(c),webviewOptions:(0,T.$trc)($,this.m,c),serializeBuffersForPostMessage:t},n);const l=this.j.createNewWebview(o,c,$);return this.createNewWebviewPanel(o,r,a,i,c,l,!0)}$onDidChangeWebviewPanelViewStates($){const r=Object.keys($);r.sort((a,h)=>{const c=$[a],i=$[h];return c.active?1:i.active?-1:+c.visible-+i.visible});for(const a of r){const h=this.getWebviewPanel(a);if(!h)continue;const c=$[a];h._updateViewState({active:c.active,visible:c.visible,viewColumn:R.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,r,a){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:a,extension:$}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,T.$qrc)($)}),new s.$bO(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel($,r,a,h){const c=this.h.get(r);if(!c)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=c,t=this.j.createNewWebview($,a.webviewOptions,n),o=this.createNewWebviewPanel($,r,a.title,h,a.panelOptions,t,a.active);await i.deserializeWebviewPanel(o,a.state)}createNewWebviewPanel($,r,a,h,c,i,n){const t=new I($,this.f,i,{viewType:r,title:a,viewColumn:h,panelOptions:c,active:n});return this.g.set($,t),t}getWebviewPanel($){return this.g.get($)}}e.$urc=w;function u(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(Re[263],Oe([1,0,6,4,67,8,5,7]),function(we,e,v,D,P,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9sc=void 0,R=Ve(R),T=Ve(T);class m extends D.$Zc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(w,u,k,$,r,a){super(),this.#s=!1,this.#l=this.B(new v.$qe),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new v.$qe),this.onDidDispose=this.#u.event,this.#i=k,this.#a=$,this.#e=w,this.#t=u,this.#n=r,this.#r=a}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(w){this.a(),this.#a!==w&&(this.#a=w,this.#t.$setWebviewViewTitle(this.#e,w))}get description(){return this.a(),this.#o}set description(w){this.a(),this.#o!==w&&(this.#o=w,this.#t.$setWebviewViewDescription(this.#e,w))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(w){w===this.#r||this.#s||(this.#r=w,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(w){this.a(),!(w?.value===this.#c?.value&&w?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(w),this.#t.$setWebviewViewBadge(this.#e,w))}show(w){this.a(),this.#t.$show(this.#e,!!w)}a(){if(this.#s)throw new Error("Webview is disposed")}}class s{constructor(w,u){this.d=u,this.b=new Map,this.c=new Map,this.a=w.getProxy(R.$_N.MainThreadWebviewViews)}registerWebviewViewProvider(w,u,k,$){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:k,extension:w}),this.a.$registerWebviewViewProvider((0,P.$src)(w),u,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$qrc)(w)}),new T.$bO(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(w,u,k,$,r){const a=this.b.get(u);if(!a)throw new Error(`No view provider found for '${u}'`);const{provider:h,extension:c}=a,i=this.d.createNewWebview(w,{},c),n=new m(w,this.a,u,k,i,!0);this.c.set(w,n),await h.resolveWebviewView(n,{state:$},r)}async $onDidChangeWebviewViewVisibility(w,u){this.e(w)._setVisible(u)}async $disposeWebviewView(w){const u=this.e(w);this.c.delete(w),u.dispose(),this.d.deleteWebview(w)}e(w){const u=this.c.get(w);if(!u)throw new Error("No webview found");return u}}e.$9sc=s}),define(Re[264],Oe([1,0,6,29,31,3]),function(we,e,v,D,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.OutputChannelUpdateMode=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=void 0,e.$iN="text/x-code-output",e.$jN="Log",e.$kN="text/x-code-log-output",e.$lN="log",e.$mN="workbench.panel.output",e.$nN=new P.$2j("inOutput",!1),e.$oN=new P.$2j("activeLogOutput",!1),e.$pN=new P.$2j("activeLogOutput.levelSettable",!1),e.$qN=new P.$2j("activeLogOutput.level",""),e.$rN=new P.$2j("activeLogOutput.levelIsDefault",!1),e.$sN=new P.$2j("outputView.scrollLock",!1),e.$tN=(0,L.$Ki)("outputService");var R;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$uN={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new v.$qe,this.onDidRegisterChannel=this.b.event,this.c=new v.$qe,this.onDidRemoveChannel=this.c.event}registerChannel(s){this.a.has(s.id)||(this.a.set(s.id,s),this.b.fire(s.id))}getChannels(){const s=[];return this.a.forEach(I=>s.push(I)),s}getChannel(s){return this.a.get(s)}removeChannel(s){this.a.delete(s),this.c.fire(s)}}D.$xo.add(e.$uN.OutputChannels,new T),e.$vN=new P.$2j("activeOutputChannel","")}),define(Re[130],Oe([1,0,5,3,16,18,11,264,68,26,50,158,20,14,28,6,4]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Msc=e.$Lsc=void 0;class h extends R.$lk{get disposed(){return this.n}constructor(t,o,l,g,f){super(),this.id=t,this.name=o,this.r=l,this.s=g,this.extension=f,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const o=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,o),this.visible&&this.r.flush()}show(t,o){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:o))}hide(){this.s.$close(this.id)}g(t,o){this.m+=u.$Se.fromString(o).byteLength,(0,R.log)(this.r,t,o),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends h{appendLine(t){this.append(t)}}let i=class{constructor(t,o,l,g,f,d){this.i=o,this.j=l,this.k=g,this.l=f,this.m=d,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$_N.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,w.$0m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[o,l]of this.g)l.visible=o===this.h}createOutputChannel(t,o,l){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const g=typeof o=="object"&&o.log,f=(0,k.$jg)(o)?o:void 0;if((0,k.$jg)(f)&&!f.trim())throw new Error("illegal argument `languageId`. must not be empty");let d;const S=this.i.environment.extensionLogLevel?.find(([y])=>L.$xn.equals(l.identifier,y))?.[1];S&&(d=(0,R.$wk)(S));const E=g?this.o(t,d,l):this.n(t,f,l);return E.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),g?this.r(t,d??this.m.getLevel(),E):this.q(t,E)}async n(t,o,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const g=await this.c,f=this.k.extUri.joinPath(g,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.l.createLogger(f,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(t,f,o,l.identifier.value);return new h(S,t,d,this.a,l)}async o(t,o,l){const g=await this.p(l),f=t.replace(/[\\/:\*\?"<>\|]/g,""),d=this.k.extUri.joinPath(g,`${f}.log`),S=`${l.identifier.value}.${f}`,E=this.l.createLogger(d,{id:S,name:t,logLevel:o,extensionId:l.identifier.value});return new c(S,t,E,this.a,l)}p(t){let o=this.d.get(t.identifier.value);if(!o){const l=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(l)}catch(g){if((0,$.$vl)(g)!==$.FileSystemProviderErrorCode.FileExists)throw g}return l})())}return o}q(t,o){let l=!1;const g=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return t},append(f){g(),o.then(d=>d.append(f))},appendLine(f){g(),o.then(d=>d.appendLine(f))},clear(){g(),o.then(f=>f.clear())},replace(f){g(),o.then(d=>d.replace(f))},show(f,d){g(),o.then(S=>S.show(f,d))},hide(){g(),o.then(f=>f.hide())},dispose(){l=!0,o.then(f=>f.dispose())}}}r(t,o,l){const g=new a.$Yc,f=()=>{if(g.isDisposed)throw new Error("Channel has been closed")},d=g.add(new r.$qe);function S(E){o=E,d.fire(E)}return l.then(E=>{g.add(E),E.logLevel!==o&&S(E.logLevel),g.add(E.onDidChangeLogLevel(y=>S(y)))}),{...this.q(t,l),get logLevel(){return o},onDidChangeLogLevel:d.event,trace(E,...y){f(),l.then(C=>C.trace(E,...y))},debug(E,...y){f(),l.then(C=>C.debug(E,...y))},info(E,...y){f(),l.then(C=>C.info(E,...y))},warn(E,...y){f(),l.then(C=>C.warn(E,...y))},error(E,...y){f(),l.then(C=>C.error(E,...y))},dispose(){g.dispose()}}}};e.$Lsc=i,e.$Lsc=i=Ke([qe(0,P.$MQ),qe(1,s.$3Q),qe(2,m.$mrc),qe(3,I.$2qc),qe(4,R.$gk),qe(5,R.$fk)],i),e.$Msc=(0,D.$Ki)("IExtHostOutputService")}),define(Re[131],Oe([1,0,3,10]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$2m=(0,v.$Ki)("remoteAgentService"),e.$3m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let L=1/0;for(let T=0;T<this.maxSampleCount;T++){const m=await P.getRoundTripTime();if(m===void 0)return;L=Math.min(L,m/2),await(0,D.$Lh)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((T,m)=>T+m,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((T,m)=>T+m,0)/this.average.length,high:typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[265],Oe([1,0,9,53,29,49,44,4,6,131,23,25,10,115]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=void 0,e.$AL=Object.freeze({id:"application",order:100,title:(0,v.localize)(3975,null),type:"object"}),e.$BL=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(3976,null),type:"object"}),e.$CL=Object.freeze({id:"security",scope:D.ConfigurationScope.APPLICATION,title:(0,v.localize)(3977,null),type:"object",order:7}),e.$DL=Object.freeze({id:"problems",title:(0,v.localize)(3978,null),type:"object",order:101}),e.$EL=Object.freeze({id:"window",order:8,title:(0,v.localize)(3979,null),type:"object"}),e.$FL={ConfigurationMigration:"base.contributions.configuration.migration"};class ${constructor(){this.migrations=[],this.a=new m.$qe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new $;P.$xo.add(e.$FL.ConfigurationMigration,r);let a=class extends T.$Zc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const l of o.added)await this.f(l,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(o=>this.g(o,n?.uri))])}async g(n,t){const o=this.a.inspect(n.key,{resource:t}),l=this.b.getWorkbenchState()===L.WorkbenchState.WORKSPACE?[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE],["workspaceFolder",R.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE]];for(const[g,f]of l){const d=o[g];if(!d)continue;const S=[];if(d.value!==void 0){const E=await this.h(n,g,d.value,t,void 0);for(const y of E??[])S.push([y,[]])}for(const{identifiers:E,value:y}of d.overrides??[])if(y!==void 0){const C=await this.h(n,g,y,t,E);for(const O of C??[])S.push([O,E])}S.length&&await Promise.allSettled(S.map(async([[E,y],C])=>this.a.updateValue(E,y.value,{resource:t,overrideIdentifiers:C},f)))}}async h(n,t,o,l,g){const f=S=>{const y=this.a.inspect(S,{resource:l})[t];if(y)return g?y.overrides?.find(({identifiers:C})=>(0,w.$oo)(C,g))?.value:y.value},d=await n.migrateFn(o,f);return Array.isArray(d)?d:[[n.key,d]]}};e.$GL=a,e.$GL=a=Ke([qe(0,R.$ej),qe(1,L.$Ti)],a);let h=class extends T.$Zc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$8h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$l&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.$xo.as(D.$Co.Configuration).registerConfiguration({...e.$CL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(3980,null)},default:[],markdownDescription:(0,v.localize)(3981,null),scope:D.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(3982,null),scope:D.ConfigurationScope.MACHINE}}})}};e.$HL=h,e.$HL=h=Ke([qe(0,s.$2m)],h),e.$IL="window.newWindowProfile";let c=class extends T.$Zc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.c=n,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(o=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(o=>{o.source!==R.ConfigurationTarget.DEFAULT&&o.affectsConfiguration(e.$IL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=P.$xo.as(D.$Co.Configuration),t={...e.$EL,properties:{[e.$IL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(o=>o.name),null],enumItemLabels:[...this.c.profiles.map(o=>""),(0,v.localize)(3983,null)],description:(0,v.localize)(3984,null),scope:D.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[t],remove:[this.a]}):n.registerConfiguration(t),this.a=t}h(){const n=this.f.getValue(e.$IL);this.b=n?this.c.profiles.find(t=>t.name===n):void 0}j(){const n=this.f.getValue(e.$IL);if(!n)return;const t=this.b?this.c.profiles.find(o=>o.id===this.b.id):void 0;n!==t?.name&&this.f.updateValue(e.$IL,t?.name)}};e.$JL=c,e.$JL=c=Ke([qe(0,k.$Rl),qe(1,R.$ej)],c)}),define(Re[266],Oe([1,0,43,15,22,24,9,265,53,3,29]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$LL=e.$KL=void 0,e.$ML=r,e.$NL=a,v=Ve(v),e.$KL=(0,s.$Ki)("editorResolverService"),e.$LL="workbench.editorAssociations";const w=I.$xo.as(m.$Co.Configuration),u={...T.$BL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(12175,null),additionalProperties:{type:"string"}}}};w.registerConfiguration(u);var k;(function(h){h.builtin="builtin",h.option="option",h.exclusive="exclusive",h.default="default"})(k||(e.RegisteredEditorPriority=k={}));var $;(function(h){h[h.ABORT=1]="ABORT",h[h.NONE=2]="NONE"})($||(e.ResolvedStatus=$={}));function r(h){switch(h){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}function a(h,c){if(new Set([D.Schemas.extension,D.Schemas.webviewPanel,D.Schemas.vscodeWorkspaceTrust,D.Schemas.vscodeSettings]).has(c.scheme))return!1;const t=typeof h=="string"&&h.indexOf(P.$lc.sep)>=0?`${c.scheme}:${c.path}`:(0,L.$ih)(c);return v.$Ek(typeof h=="string"?h.toLowerCase():h,t.toLowerCase())}}),define(Re[267],Oe([1,0,73,15,22,23,24,2,3,186,49,205,131]),function(we,e,v,D,P,L,R,T,m,s,I,w,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=e.$NN=void 0,e.$NN=(0,m.$Ki)("pathService");let $=k=class{constructor(a,h,c,i){this.d=a,this.e=h,this.f=c,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??a})()}hasValidBasename(a,h,c){return typeof h=="string"||typeof h>"u"?this.a.then(i=>this.h(a,i,h)):this.h(a,h,c)}h(a,h,c){return a.scheme===D.Schemas.file||a.scheme===D.Schemas.vscodeRemote?(0,v.$Hg)(c??(0,R.$ih)(a),h===L.OperatingSystem.Windows):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,h){if(a.remoteAuthority)return D.Schemas.vscodeRemote;const c=(0,s.$KN)(h.getWorkspace());if(c)return c;const i=h.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=h.getWorkspace().configuration;return n?n.scheme:D.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===L.OperatingSystem.Windows?P.$kc:P.$lc)}async fileURI(a){let h="";if(await this.a===L.OperatingSystem.Windows&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const i=a.indexOf("/",2);i===-1?(h=a.substring(2),a="/"):(h=a.substring(2,i),a=a.substring(i)||"/")}return T.URI.from({scheme:D.Schemas.file,authority:h,path:a,query:"",fragment:""})}};e.$ON=$,e.$ON=$=k=Ke([qe(1,u.$2m),qe(2,w.$wN),qe(3,I.$Ti)],$)}),define(Re[58],Oe([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.ExcludeSettingOptions=e.$oM=e.$nM=e.$mM=e.$lM=void 0;class v{constructor(s,I){this.line=s,this.character=I}isBefore(s){return!1}isBeforeOrEqual(s){return!1}isAfter(s){return!1}isAfterOrEqual(s){return!1}isEqual(s){return!1}compareTo(s){return 0}translate(s,I){return new v(0,0)}with(s){return new v(0,0)}}e.$lM=v;class D{constructor(s,I,w,u){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(s,I),this.end=new v(w,u)}contains(s){return!1}isEqual(s){return!1}intersection(s){}union(s){return new D(0,0,0,0)}with(s){return new D(0,0,0,0)}}e.$mM=D;class P{constructor(s,I,w){this.uri=s,this.ranges=I,this.previewText=w}}e.$nM=P;class L{constructor(s,I,w){this.uri=s,this.text=I,this.lineNumber=w}}e.$oM=L;var R;(function(m){m[m.None=1]="None",m[m.FilesExclude=2]="FilesExclude",m[m.SearchAndFilesExclude=3]="SearchAndFilesExclude"})(R||(e.ExcludeSettingOptions=R={}));var T;(function(m){m[m.Information=1]="Information",m[m.Warning=2]="Warning"})(T||(e.TextSearchCompleteMessageType=T={}))}),define(Re[40],Oe([1,0,17,43,25,73,13,3,22,12,58,10]),function(we,e,v,D,P,L,R,T,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$OM=e.$MM=e.$FM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$CM=e.$BM=e.$AM=e.$zM=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.TextSearchCompleteMessageType=void 0,e.$wM=h,e.$xM=c,e.$yM=i,e.$DM=E,e.$EM=y,e.$GM=p,e.$HM=b,e.$IM=M,e.$JM=A,e.$KM=F,e.$LM=G,e.$NM=j,e.$PM=Y,e.$QM=ae,e.$RM=oe,D=Ve(D),P=Ve(P),L=Ve(L),m=Ve(m),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$pM="workbench.view.search",e.$qM="workbench.panel.search",e.$rM="workbench.view.search",e.$sM="search-result",e.$tM="search.exclude",e.$uM=2e4;const u="\u27EA ",k=" characters skipped \u27EB",$=(u.length+k.length+5)*2;e.$vM=(0,T.$Ki)("searchService");var r;(function(ie){ie[ie.file=0]="file",ie[ie.text=1]="text",ie[ie.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var a;(function(ie){ie[ie.File=1]="File",ie[ie.Text=2]="Text",ie[ie.aiText=3]="aiText"})(a||(e.QueryType=a={}));function h(ie){return!!ie.rangeLocations&&!!ie.previewText}function c(ie){return!!ie.resource}function i(ie){return!!ie.message}var n;(function(ie){ie[ie.Normal=0]="Normal",ie[ie.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(ue){this.resource=ue,this.results=[]}}e.$zM=t;class o{constructor(ue,_,$e,Ie){this.rangeLocations=[],this.webviewIndex=Ie;const X=Array.isArray(_)?_:[_];if($e&&$e.matchLines===1&&l(X)){ue=(0,R.$cg)(ue,$e.matchLines);let V="",re=0,be=0;const Pe=Math.floor($e.charsPerLine/5);for(const Fe of X){const Be=Math.max(Fe.startColumn-Pe,0),xe=Fe.startColumn+$e.charsPerLine;if(Be>be+Pe+$){const nt=u+(Be-be)+k;V+=nt+ue.slice(Be,xe),re+=Be-(be+nt.length)}else V+=ue.slice(be,xe);be=xe,this.rangeLocations.push({source:Fe,preview:new f(0,Fe.startColumn-re,Fe.endColumn-re)})}this.previewText=V}else{const V=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber,re=(0,v.$5b)(_,be=>({preview:new g(be.startLineNumber-V,be.startColumn,be.endLineNumber-V,be.endColumn),source:be}));this.rangeLocations=Array.isArray(re)?re:[re],this.previewText=ue}}}e.$AM=o;function l(ie){const ue=ie[0].startLineNumber;for(const _ of ie)if(_.startLineNumber!==ue||_.endLineNumber!==ue)return!1;return!0}class g{constructor(ue,_,$e,Ie){this.startLineNumber=ue,this.startColumn=_,this.endLineNumber=$e,this.endColumn=Ie}}e.$BM=g;class f extends g{constructor(ue,_,$e){super(ue,_,ue,$e)}}e.$CM=f;var d;(function(ie){ie.List="list",ie.Tree="tree"})(d||(e.ViewMode=d={}));var S;(function(ie){ie.Default="default",ie.FileNames="fileNames",ie.Type="type",ie.Modified="modified",ie.CountDescending="countDescending",ie.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function E(ie,ue=!0){const _=ie&&ie.files&&ie.files.exclude,$e=ue&&ie&&ie.search&&ie.search.exclude;if(!_&&!$e)return;if(!_||!$e)return _||$e||void 0;let Ie=Object.create(null);return Ie=P.$no(Ie,P.$ko(_)),Ie=P.$no(Ie,P.$ko($e),!0),Ie}function y(ie,ue){return ie.excludePattern&&D.$Ek(ie.excludePattern,ue)?!1:ie.includePattern||ie.usingSearchPaths?ie.includePattern&&D.$Ek(ie.includePattern,ue)?!0:ie.usingSearchPaths?!!ie.folderQueries&&ie.folderQueries.some(_=>{const $e=_.folder.fsPath;if(L.$Jg(ue,$e)){const Ie=m.$qc($e,ue);return!_.includePattern||!!D.$Ek(_.includePattern,Ie)}else return!1}):!1:!0}var C;(function(ie){ie[ie.unknownEncoding=1]="unknownEncoding",ie[ie.regexParseError=2]="regexParseError",ie[ie.globParseError=3]="globParseError",ie[ie.invalidLiteral=4]="invalidLiteral",ie[ie.rgProcessError=5]="rgProcessError",ie[ie.other=6]="other",ie[ie.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class O extends Error{constructor(ue,_){super(ue),this.code=_}}e.$FM=O;function p(ie){const ue=ie.message;if((0,s.$8)(ie))return new O(ue,C.canceled);try{const _=JSON.parse(ue);return new O(_.message,_.code)}catch{return new O(ue,C.other)}}function b(ie){const ue={message:ie.message,code:ie.code};return new Error(JSON.stringify(ue))}function M(ie){return ie.type==="error"?!0:ie.type==="success"}function A(ie){return ie.type==="success"}function F(ie){return!!ie.path}function G(ie,ue,_=!0){const $e=ie.searchPath?ie.searchPath:ie.relativePath;return _?(0,R.$_f)($e,ue):D.$Ek(ue,$e)}class x{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$MM=x;function j(ie,ue){const _={...ie||{},...ue||{}};return Object.keys(_).filter($e=>{const Ie=_[$e];return typeof Ie=="boolean"&&Ie})}class U{constructor(ue,_){this.c=null,this.a=_.excludePattern?.map(Ie=>({...ue.excludePattern||{},...Ie.pattern||{}}))??[],this.a.length===0&&(this.a=[ue.excludePattern||{}]),this.b=this.a.map(Ie=>D.$Fk(Ie));let $e=ue.includePattern;_.includePattern&&($e?$e={...$e,..._.includePattern}:$e=_.includePattern),$e&&(this.c=D.$Fk($e))}d(ue,_,$e){let Ie=null;for(const X of this.b){const V=X(ue,_,$e);if(typeof V=="string"){Ie=V;break}}return Ie}matchesExcludesSync(ue,_,$e){return!!(this.b&&this.d(ue,_,$e))}includedInQuerySync(ue,_,$e){return!(this.b&&this.d(ue,_,$e)||this.c&&!this.c(ue,_,$e))}includedInQuery(ue,_,$e){const Ie=()=>this.c?!!this.c(ue,_,$e):!0;return Promise.all(this.b.map(X=>{const V=X(ue,_,$e);return(0,w.$wh)(V)?V.then(re=>re?!1:Ie()):Ie()})).then(X=>X.some(V=>!!V))}hasSiblingExcludeClauses(){return this.a.reduce((ue,_)=>J(_)||ue,!1)}}e.$OM=U;function J(ie){for(const ue in ie)if(typeof ie[ue]!="boolean")return!0;return!1}function Y(ie){if(!ie)return;let ue;return _=>(ue||(ue=(ie()||Promise.resolve([])).then($e=>$e?ee($e):{})),ue.then($e=>!!$e[_]))}function ae(ie){if(!ie)return;let ue;return _=>{if(!ue){const $e=ie();ue=$e?ee($e):{}}return!!ue[_]}}function ee(ie){const ue={};for(const _ of ie)ue[_]=!0;return ue}function oe(ie){return ie.flatMap(ue=>ue.patterns.map(_=>ue.baseUri?{baseUri:ue.baseUri,pattern:_}:_))}e.$SM={matchLines:100,charsPerLine:1e4}}),define(Re[45],Oe([1,0,17,10,19,6,4,48,15,142,24,13,2,9,28,3,11,174,49,50,26,16,8,7,65,40,5,34,58]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=e.$grc=void 0;function y(x,j,U){return new I.$ah(J=>b(J,U)).isEqual(x,j)}function C(x,j,U){return y(x.uri,j.uri,U)?0:(0,w.$Df)(x.uri.toString(),j.uri.toString())}function O(x,j,U){return x.index!==j.index?x.index<j.index?-1:1:y(x.uri,j.uri,U)?(0,w.$Df)(x.name,j.name):(0,w.$Df)(x.uri.toString(),j.uri.toString())}function p(x,j,U,J){const Y=x.slice(0).sort((ee,oe)=>U(ee,oe,J)),ae=j.slice(0).sort((ee,oe)=>U(ee,oe,J));return(0,v.$Ib)(Y,ae,(ee,oe)=>U(ee,oe,J))}function b(x,j){const U=j.getCapabilities(x.scheme);return!(U&&U&$.FileSystemProviderCapabilities.PathCaseSensitive)}class M extends c.$4i{static toExtHostWorkspace(j,U,J,Y){if(!j)return{workspace:null,added:[],removed:[]};const{id:ae,name:ee,folders:oe,configuration:ie,transient:ue,isUntitled:_}=j,$e=[],Ie=U;U?oe.forEach((be,Pe)=>{const Fe=u.URI.revive(be.uri),Be=M.o(J||U,Fe,Y);Be?(Be.name=be.name,Be.index=be.index,$e.push(Be)):$e.push({uri:Fe,name:be.name,index:Pe})}):$e.push(...oe.map(({uri:be,name:Pe,index:Fe})=>({uri:u.URI.revive(be),name:Pe,index:Fe}))),$e.sort((be,Pe)=>be.index<Pe.index?-1:1);const X=new M(ae,ee,$e,!!ue,ie?u.URI.revive(ie):null,!!_,be=>b(be,Y)),{added:V,removed:re}=p(Ie?Ie.workspaceFolders:[],X.workspaceFolders,C,Y);return{workspace:X,added:V,removed:re}}static o(j,U,J){for(let Y=0;Y<j.folders.length;Y++){const ae=j.workspaceFolders[Y];if(y(ae.uri,U,J))return ae}}constructor(j,U,J,Y,ae,ee,oe){super(j,J.map(ie=>new c.$5i(ie)),Y,ae,oe),this.t=U,this.u=ee,this.q=[],this.s=T.$Qi.forUris(oe,()=>!0),J.forEach(ie=>{this.q.push(ie),this.s.set(ie.uri,ie)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,U){return U&&this.s.get(j)&&(j=(0,I.$kh)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let A=class{constructor(j,U,J,Y,ae){this.c=new L.$qe,this.onDidChangeWorkspace=this.c.event,this.g=new L.$qe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.B=0,this.C=new L.$se,this.D=new Map,this.h=Y,this.s=J,this.t=ae,this.j=new s.$Sm,this.k=new D.$Jh,this.o=j.getProxy(d.$_N.MainThreadWorkspace),this.q=j.getProxy(d.$_N.MainThreadMessageService);const ee=U.workspace;this.l=ee?new M(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,oe=>b(oe,J)):void 0}$initializeWorkspace(j,U){this.v=U,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:m.Schemas.untitled,path:(0,I.$ih)((0,I.$kh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,U,J,...Y){const ae=[];if(Array.isArray(Y)&&Y.forEach(_=>{u.URI.isUri(_.uri)&&!ae.some($e=>y($e.uri,_.uri,this.s))&&ae.push({uri:_.uri,name:_.name||(0,I.$hh)(_.uri)})}),this.n||[U,J].some(_=>typeof _!="number"||_<0)||J===0&&ae.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(U+J>ee.length)return!1;const oe=ee.slice(0);oe.splice(U,J,...ae.map(_=>({uri:_.uri,name:_.name||(0,I.$hh)(_.uri),index:void 0})));for(let _=0;_<oe.length;_++){const $e=oe[_];if(oe.some((Ie,X)=>X!==_&&y($e.uri,Ie.uri,this.s)))return!1}oe.forEach((_,$e)=>_.index=$e);const{added:ie,removed:ue}=p(ee,oe,O,this.s);if(ie.length===0&&ue.length===0)return!1;if(this.o){const _=j.displayName||j.name;this.o.$updateWorkspaceFolders(_,U,J,ae).then(void 0,$e=>{this.n=void 0;const Ie={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(h.Severity.Error,(0,k.localize)(2718,null,_,$e.toString()),Ie,[])})}return this.y(oe),!0}getWorkspaceFolder(j,U){if(this.x)return this.x.getWorkspaceFolder(j,U)}async getWorkspaceFolder2(j,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,U)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,U){let J,Y="";if(typeof j=="string"?(J=u.URI.file(j),Y=j):typeof j<"u"&&(J=j,Y=j.fsPath),!J)return Y;const ae=this.getWorkspaceFolder(J,!0);if(!ae)return Y;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ee=(0,I.$nh)(ae.uri,J);return U&&ae.name&&(ee=`${ae.name}/${ee}`),ee}y(j){this.x&&(this.n=M.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:U,added:J,removed:Y}=M.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:J,removed:Y}))}findFiles(j,U,J,Y,ae=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Y.value}, entryPoint: findFiles`);let ee="",oe=!0;return U===null?oe=!1:U!==void 0&&(typeof U=="string"?ee=U:ee=U.pattern),this.z(j,void 0,{exclude:[ee],maxResults:J,useExcludeSettings:oe?E.ExcludeSettingOptions.FilesExclude:E.ExcludeSettingOptions.None,useIgnoreFiles:{local:!1}},ae)}findFiles2(j,U={},J,Y=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${J.value}, entryPoint: findFiles2`);const ae=U.useDefaultExcludes??!0,ee=U.useDefaultSearchExcludes??!0,oe=ae?ee?E.ExcludeSettingOptions.SearchAndFilesExclude:E.ExcludeSettingOptions.FilesExclude:E.ExcludeSettingOptions.None,ie={exclude:U.exclude?[U.exclude]:void 0,useIgnoreFiles:{local:U.useIgnoreFiles,global:U.useGlobalIgnoreFiles,parent:U.useParentIgnoreFiles},useExcludeSettings:oe,followSymlinks:U.followSymlinks,maxResults:U.maxResults};return this.z(void 0,j!==void 0?[j]:[],ie,Y)}findFiles2New(j,U={},J,Y=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2New: fileSearch, extension: ${J.value}, entryPoint: findFiles2New`),this.z(void 0,j,U,Y)}async z(j,U,J,Y=P.CancellationToken.None){if(Y&&Y.isCancellationRequested)return Promise.resolve([]);const ee=(j!==void 0?[j]:U)?.map(oe=>{const ie=G(J.exclude),ue={ignoreSymlinks:typeof J.followSymlinks=="boolean"?!J.followSymlinks:void 0,disregardIgnoreFiles:typeof J.useIgnoreFiles?.local=="boolean"?!J.useIgnoreFiles.local:void 0,disregardGlobalIgnoreFiles:typeof J.useIgnoreFiles?.global=="boolean"?!J.useIgnoreFiles.global:void 0,disregardParentIgnoreFiles:typeof J.useIgnoreFiles?.parent=="boolean"?!J.useIgnoreFiles.parent:void 0,disregardExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings===E.ExcludeSettingOptions.None,disregardSearchExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings!==E.ExcludeSettingOptions.SearchAndFilesExclude,maxResults:J.maxResults,excludePattern:ie.length>0?ie:void 0,_reason:"startFileSearch",shouldGlobSearch:j?void 0:!0},_=F(o.GlobPattern.from(oe)),$e=_?.folder;return j?ue.includePattern=_?.pattern:ue.filePattern=_?.pattern,{folder:$e,options:ue}})??[];return this.A(ee,Y)}async A(j,U){return(await Promise.all(j?.map(Y=>this.o.$startFileSearch(Y.folder??null,Y.options,U).then(ae=>Array.isArray(ae)?ae.map(ee=>u.URI.revive(ee)):[]))??[])).flat()}findTextInFilesNew(j,U,J,Y){this.h.trace(`extHostWorkspace#findTextInFilesNew: textSearch, extension: ${U.value}, entryPoint: findTextInFilesNew`);const ae=_=>{if(!J)return{folder:void 0,options:{}};const $e=_?F(o.GlobPattern.from(_)):void 0,Ie=G(J.exclude);return{options:{ignoreSymlinks:typeof J.followSymlinks=="boolean"?!J.followSymlinks:void 0,disregardIgnoreFiles:typeof J.useIgnoreFiles=="boolean"?!J.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof J.useIgnoreFiles?.global=="boolean"?!J.useIgnoreFiles?.global:void 0,disregardParentIgnoreFiles:typeof J.useIgnoreFiles?.parent=="boolean"?!J.useIgnoreFiles?.parent:void 0,disregardExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings===E.ExcludeSettingOptions.None,disregardSearchExcludeSettings:J.useExcludeSettings!==void 0&&J.useExcludeSettings!==E.ExcludeSettingOptions.SearchAndFilesExclude,fileEncoding:J.encoding,maxResults:J.maxResults,previewOptions:J.previewOptions?{matchLines:J.previewOptions?.numMatchLines??100,charsPerLine:J.previewOptions?.charsPerLine??1e4}:void 0,surroundingContext:J.surroundingContext,includePattern:$e?.pattern,excludePattern:Ie},folder:$e?.folder}},oe=(J?.include?.map(_=>ae(_))??[ae(void 0)]).filter(_=>!!_),ie=Promise.resolve(void 0);return{results:new D.$$h(async _=>{const $e=(Ie,X)=>((0,f.$wM)(Ie)?_.emitOne(new E.$nM(X,Ie.rangeLocations.map(V=>({previewRange:new l.$dO(V.preview.startLineNumber,V.preview.startColumn,V.preview.endLineNumber,V.preview.endColumn),sourceRange:new l.$dO(V.source.startLineNumber,V.source.startColumn,V.source.endLineNumber,V.source.endColumn)})),Ie.previewText)):_.emitOne(new E.$oM(X,Ie.text,Ie.lineNumber)),Ie);await ie.then(Ie=>this.findTextInFilesBase(j,oe,$e,Y))}),complete:ie.then(_=>({limitHit:_?.limitHit??!1}))}}async findTextInFilesBase(j,U,J,Y=P.CancellationToken.None){const ae=this.j.getNext();let ee=!1;if(Y.onCancellationRequested(oe=>{ee=!0}),this.u[ae]=oe=>{if(ee)return;const ie=u.URI.revive(oe.resource);oe.results.forEach(ue=>{const _=(0,S.$hi)(ue);J(_,ie)})},Y.isCancellationRequested)return{};try{const oe=await Promise.all(U?.map(ie=>this.o.$startTextSearch(j,ie.folder??null,ie.options,ae,Y)||{})??[]);return delete this.u[ae],oe.reduce((ie,ue)=>({limitHit:ie?.limitHit||(ue?.limitHit??!1),message:[ie?.message??[],ue?.message??[]].flat()}),{})??{limitHit:!1}}catch(oe){throw delete this.u[ae],oe}}async findTextInFiles(j,U,J,Y,ae=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Y.value}, entryPoint: findTextInFiles`);const ee=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,oe=F(o.GlobPattern.from(U.include)),ie=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ue={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof U.useSearchExclude=="boolean"?!U.useSearchExclude:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ee,surroundingContext:U.afterContext,includePattern:oe?.pattern,excludePattern:ie?[{pattern:ie}]:void 0},_=($e,Ie)=>{(0,f.$wM)($e)?J({uri:Ie,preview:{text:$e.previewText,matches:(0,v.$5b)($e.rangeLocations,X=>new l.$dO(X.preview.startLineNumber,X.preview.startColumn,X.preview.endLineNumber,X.preview.endColumn))},ranges:(0,v.$5b)($e.rangeLocations,X=>new l.$dO(X.source.startLineNumber,X.source.startColumn,X.source.endLineNumber,X.source.endColumn))}):J({uri:Ie,text:$e.text,lineNumber:$e.lineNumber})};return this.findTextInFilesBase(j,[{options:ue,folder:oe?.folder}],_,ae)}$handleTextSearchResult(j,U){this.u[U]?.(j)}async save(j){const U=await this.o.$save(j,{saveAs:!1});return u.URI.revive(U)}async saveAs(j){const U=await this.o.$save(j,{saveAs:!0});return u.URI.revive(U)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}lookupAuthorization(j){return this.o.$lookupAuthorization(j)}lookupKerberosAuthorization(j){return this.o.$lookupKerberosAuthorization(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,U){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,U);const J=this.t.transformOutgoingScheme(j),Y=this.B++;return this.o.$registerEditSessionIdentityProvider(Y,J),(0,R.$Xc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(Y)})}async $getEditSessionIdentifier(j,U){this.h.info("Getting edit session identifier for workspaceFolder",j);const J=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!J){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",J);const Y=this.w.get(J.uri.scheme);if(this.h.info(`Provider for scheme ${J.uri.scheme} is defined: `,!!Y),!Y)return;const ae=await Y.provideEditSessionIdentity(J,U);if(this.h.info("Provider returned edit session identifier: ",ae),!!ae)return ae}async $provideEditSessionIdentityMatch(j,U,J,Y){this.h.info("Getting edit session identifier for workspaceFolder",j);const ae=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!ae){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ae);const ee=this.w.get(ae.uri.scheme);if(this.h.info(`Provider for scheme ${ae.uri.scheme} is defined: `,!!ee),!ee)return;const oe=await ee.provideEditSessionIdentityMatch?.(U,J,Y);if(this.h.info("Provider returned edit session identifier match result: ",oe),!!oe)return oe}getOnWillCreateEditSessionIdentityEvent(j){return(U,J,Y)=>{const ae=function(oe){U.call(J,oe)};return ae.extension=j,this.C.event(ae,void 0,Y)}}async $onWillCreateEditSessionIdentity(j,U,J){const Y=await this.resolveWorkspaceFolder(u.URI.revive(j));if(Y===void 0)throw new Error("Unable to resolve workspace folder");await this.C.fireAsync({workspaceFolder:Y},U,async(ae,ee)=>{const oe=Date.now();await Promise.resolve(ae),Date.now()-oe>J&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(j,U){if(this.D.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.D.set(j,U);const J=this.t.transformOutgoingScheme(j),Y=this.B++;return this.o.$registerCanonicalUriProvider(Y,J),(0,R.$Xc)(()=>{this.D.delete(j),this.o.$unregisterCanonicalUriProvider(Y)})}async provideCanonicalUri(j,U,J){const Y=this.D.get(j.scheme);if(!Y)return;const ae=await Y.provideCanonicalUri?.(u.URI.revive(j),U,J);if(ae)return ae}async $provideCanonicalUri(j,U,J){return this.provideCanonicalUri(u.URI.revive(j),{targetScheme:U},J)}};e.$grc=A,e.$grc=A=Ke([qe(0,t.$MQ),qe(1,n.$3Q),qe(2,i.$2qc),qe(3,a.$fk),qe(4,g.$erc)],A),e.$hrc=(0,r.$Ki)("IExtHostWorkspace");function F(x){let j,U;if(x)return typeof x=="string"?j=x:(j=x.pattern,U=u.URI.revive(x.baseUri)),{pattern:j,folder:U}}function G(x){return(x?.map(j=>{if(typeof j=="string")return j===""?void 0:{pattern:j,uri:void 0};{const U=F(j);return U?{pattern:U.pattern,uri:U.folder}:void 0}})??[]).filter(j=>!!j)}}),define(Re[46],Oe([1,0,25,6,45,5,7,44,175,53,14,10,3,16,11,2]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=e.$jrc=e.$irc=void 0;function a(g,f){if(f){const d=f.split(".");let S=g;for(let E=0;S&&E<d.length;E++)S=S[d[E]];return S}}function h(g){return g instanceof r.URI}function c(g){return g&&g.uri instanceof r.URI&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&g.uri instanceof r.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function t(g){if(h(g))return{resource:g};if(c(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(i(g))return{overrideIdentifier:g.languageId};if(n(g))return{resource:g.uri};if(g===null)return{resource:null}}let o=class{constructor(f,d,S){this.a=f.getProxy(L.$_N.MainThreadConfiguration),this.c=d,this.b=S,this.d=new w.$Jh,this.e=null}getConfigProvider(){return this.d.wait().then(f=>this.e)}$initializeConfiguration(f){this.e=new l(this.a,this.c,f,this.b),this.d.open()}$acceptConfigurationChanged(f,d){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(f,d))}};e.$irc=o,e.$irc=o=Ke([qe(0,k.$MQ),qe(1,P.$hrc),qe(2,$.$fk)],o);class l{constructor(f,d,S,E){this.a=new D.$qe,this.b=f,this.f=E,this.c=d,this.e=m.$Xo.parse(S,E),this.d=this.k(S.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(f,d){const S={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$Xo.parse(f,this.f),this.d=this.k(f.configurationScopes),this.a.fire(this.j(d,S))}getConfiguration(f,d,S){const E=t(d)||{},y=this.g(f?a(this.e.getValue(void 0,E,this.c.workspace),f):this.e.getValue(void 0,E,this.c.workspace));f&&this.h(f,E,S?.identifier);function C(p){if(p==null)return null;if(typeof p=="boolean")return p?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(p){case R.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case R.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case R.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const O={has(p){return typeof a(y,p)<"u"},get:(p,b)=>{this.h(f?`${f}.${p}`:p,E,S?.identifier);let M=a(y,p);if(typeof M>"u")M=b;else{let A;const F=(G,x)=>{if((0,I.$lg)(G)){let j;const U=()=>{A=A||(0,v.$ko)(y),j=j||a(A,x)};return new Proxy(G,{get:(J,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return U(),()=>j;if(A)return j=j||a(A,x),j[Y];const ae=J[Y];return typeof Y=="string"?F(ae,`${x}.${Y}`):ae},set:(J,Y,ae)=>(U(),j&&(j[Y]=ae),!0),deleteProperty:(J,Y)=>(U(),j&&delete j[Y],!0),defineProperty:(J,Y,ae)=>(U(),j&&Object.defineProperty(j,Y,ae),!0)})}return Array.isArray(G)?(0,v.$ko)(G):G};M=F(M,p)}return M},update:(p,b,M,A)=>{p=f?`${f}.${p}`:p;const F=C(M);return b!==void 0?this.b.$updateConfigurationOption(F,p,b,E,A):this.b.$removeConfigurationOption(F,p,E,A)},inspect:p=>{p=f?`${f}.${p}`:p;const b=this.e.inspect(p,E,this.c.workspace);if(b)return{key:p,defaultValue:(0,v.$ko)(b.policy?.value??b.default?.value),globalValue:(0,v.$ko)(b.user?.value??b.application?.value),workspaceValue:(0,v.$ko)(b.workspace?.value),workspaceFolderValue:(0,v.$ko)(b.workspaceFolder?.value),defaultLanguageValue:(0,v.$ko)(b.default?.override),globalLanguageValue:(0,v.$ko)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,v.$ko)(b.workspace?.override),workspaceFolderLanguageValue:(0,v.$ko)(b.workspaceFolder?.override),languageIds:(0,v.$ko)(b.overrideIdentifiers)}}};return typeof y=="object"&&(0,v.$no)(O,y,!1),Object.freeze(O)}g(f){const d=S=>(0,I.$lg)(S)?new Proxy(S,{get:(E,y)=>d(E[y]),set:(E,y,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(E,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(E,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:E=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return d(f)}h(f,d,S){const E=s.$Mo.test(f)?s.ConfigurationScope.RESOURCE:this.d.get(f),y=S?`[${S.value}] `:"";if(s.ConfigurationScope.RESOURCE===E){typeof d?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${f}', provide the URI of a resource or 'null' for any resource.`);return}if(s.ConfigurationScope.WINDOW===E){d?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${f}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(f,d){const S=new m.$Zo(f,d,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(E,y)=>S.affectsConfiguration(E,t(y))})}k(f){return f.reduce((d,S)=>(d.set(S[0],S[1]),d),new Map)}}e.$jrc=l,e.$krc=(0,u.$Ki)("IExtHostConfiguration")}),define(Re[132],Oe([1,0,2,10,6,5,7,45,57,46,19,56,16,26,3,15,23,11,85,209,12,17]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zsc=e.$Ysc=e.$Xsc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,R=Ve(R),a=Ve(a);var o;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(o||(o={}));var l;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(l||(l={}));var g;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(g||(g={}));var f;(function(F){function G(U){if(U){const J=U;return J&&!!J.process}else return!1}F.is=G;function x(U){if(U==null)return;const J={process:U.process,args:U.args};return U.options&&(J.options=g.from(U.options)),J}F.from=x;function j(U){if(U!=null)return new R.$ZO(U.process,U.args,U.options)}F.to=j})(f||(f={}));var d;(function(F){function G(j){if(j!=null)return j}F.from=G;function x(j){if(j!=null)return j}F.to=x})(d||(d={}));var S;(function(F){function G(U){if(U){const J=U;return J&&(!!J.commandLine||!!J.command)}else return!1}F.is=G;function x(U){if(U==null)return;const J={};return U.commandLine!==void 0?J.commandLine=U.commandLine:(J.command=U.command,J.args=U.args),U.options&&(J.options=d.from(U.options)),J}F.from=x;function j(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new R.$1O(U.commandLine,U.options):new R.$1O(U.command,U.args?U.args:[],U.options)}F.to=j})(S||(S={}));var E;(function(F){function G(U){if(U){const J=U;return J&&J.customExecution==="customExecution"}else return!1}F.is=G;function x(U){return{customExecution:"customExecution"}}F.from=x;function j(U,J){return J.get(U)}F.to=j})(E||(e.CustomExecutionDTO=E={}));var y;(function(F){function G(x,j){let U;return x.scope!==void 0&&typeof x.scope!="number"?U=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===R.TaskScope.Workspace&&j&&j.workspaceFile?U=j.workspaceFile:U=i.$gJ),{id:x._id,workspaceFolder:U}}F.from=G})(y||(e.TaskHandleDTO=y={}));var C;(function(F){function G(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}F.from=G})(C||(C={}));var O;(function(F){function G(U,J){if(U==null)return[];const Y=[];for(const ae of U){const ee=x(ae,J);ee&&Y.push(ee)}return Y}F.fromMany=G;function x(U,J){if(U==null)return;let Y;U.execution instanceof R.$ZO?Y=f.from(U.execution):U.execution instanceof R.$1O?Y=S.from(U.execution):U.execution&&U.execution instanceof R.$2O&&(Y=E.from(U.execution));const ae=o.from(U.definition);let ee;return U.scope?typeof U.scope=="number"?ee=U.scope:ee=U.scope.uri:ee=R.TaskScope.Workspace,!ae||!ee?void 0:{_id:U._id,definition:ae,name:U.name,source:{extensionId:J.identifier.value,label:U.source,scope:ee},execution:Y,isBackground:U.isBackground,group:C.from(U.group),presentationOptions:l.from(U.presentationOptions),problemMatchers:(0,t.$6b)(U.problemMatchers),hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}F.from=x;async function j(U,J,Y){if(U==null)return;let ae;f.is(U.execution)?ae=f.to(U.execution):S.is(U.execution)?ae=S.to(U.execution):E.is(U.execution)&&(ae=E.to(U._id,Y));const ee=o.to(U.definition);let oe;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?oe=U.source.scope:oe=await J.resolveWorkspaceFolder(v.URI.revive(U.source.scope)):oe=R.TaskScope.Workspace),!ee||!oe)return;const ie=new R.$3O(ee,oe,U.name,U.source.label,ae,U.problemMatchers);return U.isBackground!==void 0&&(ie.isBackground=U.isBackground),U.group!==void 0&&(ie.group=R.$YO.from(U.group._id),ie.group&&U.group.isDefault&&(ie.group=new R.$YO(ie.group.id,ie.group.label),U.group.isDefault===!0&&(ie.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ie.presentationOptions=l.to(U.presentationOptions)),U._id&&(ie._id=U._id),U.detail&&(ie.detail=U.detail),ie}F.to=j})(O||(e.TaskDTO=O={}));var p;(function(F){function G(j){return j}F.from=G;function x(j){if(j)return Object.assign(Object.create(null),j)}F.to=x})(p||(p={}));class b{#e;constructor(G,x,j){this._id=x,this.a=j,this.#e=G}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}let M=class{constructor(G,x,j,U,J,Y,ae,ee){this.q=new P.$qe,this.r=new P.$qe,this.s=new P.$qe,this.u=new P.$qe,this.a=G.getProxy(L.$_N.MainThreadTask),this.b=j,this.c=U,this.d=J,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ae,this.g=ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(G,x,j){if(!j)return new R.$bO(()=>{});const U=this.x();return this.j.set(U,{type:x,provider:j,extension:G}),this.a.$registerTaskProvider(U,x),new R.$bO(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(G,x){this.a.$registerTaskSystem(G,x)}fetchTasks(G){return this.a.$fetchTasks(p.from(G)).then(async x=>{const j=[];for(const U of x){const J=await O.to(U,this.b,this.m);J&&j.push(J)}return j})}get taskExecutions(){const G=[];return this.k.forEach(x=>G.push(x)),G}terminateTask(G){if(!(G instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(G._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(G,x,j){const U=this.m.get(G.id);U&&(this.o.set(G.id,U),this.e.attachPtyToTerminal(x,await U.callback(j))),this.p=G.id,this.q.fire({execution:await this.z(G)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(G){if(!this.l.has(G.id))return;const x=await this.z(G);this.l.delete(G.id),this.k.delete(G.id),this.B(G),this.r.fire({execution:x})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(G){const x=await this.z(G.id);this.s.fire({execution:x,processId:G.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(G){const x=await this.z(G.id);this.u.fire({execution:x,exitCode:G.exitCode})}$provideTasks(G,x){const j=this.j.get(G);if(!j)return Promise.reject(new Error("no handler found"));const U=[],J=(0,D.$Ch)(()=>j.provider.provideTasks(I.CancellationToken.None)).then(Y=>this.v(x,U,j,Y));return new Promise(Y=>{J.then(ae=>{Promise.all(U).then(()=>{Y(ae)})})})}async $resolveTask(G,x){const j=this.j.get(G);if(!j)return Promise.reject(new Error("no handler found"));if(x.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${j.type}].`);const U=await O.to(x,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const J=await j.provider.resolveTask(U,I.CancellationToken.None);if(!J)return;this.A(J,j);const Y=O.from(J,j.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(J.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(Y.execution)&&await this.y(Y,J,!0),await this.w(Y)}x(){return this.h++}async y(G,x,j){const U=await this.a.$createTaskId(G);!j&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,x.execution)),this.m.set(U,x.execution)}async z(G,x){if(typeof G=="string"){const J=this.l.get(G);if(!J)throw new n.$fb("Unexpected: The specified task is missing an execution");return J}const j=this.l.get(G.id);if(j)return j;let U;return x?U=Promise.resolve(new b(this,G.id,x)):U=O.to(G.task,this.b,this.m).then(J=>{if(!J)throw new n.$fb("Unexpected: Task does not exist.");return new b(this,G.id,J)}),this.l.set(G.id,U),U.then(J=>(this.k.set(G.id,J),J))}A(G,x){G._deprecated&&this.g.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}B(G){this.o.get(G.id)&&this.o.delete(G.id),this.n.has(G.id)&&this.p!==G.id&&(this.m.delete(G.id),this.n.delete(G.id));const j=this.n.values();let U=j.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=j.next()}};e.$Xsc=M,e.$Xsc=M=Ke([qe(0,u.$MQ),qe(1,k.$3Q),qe(2,T.$hrc),qe(3,m.$XQ),qe(4,s.$krc),qe(5,w.$Irc),qe(6,h.$fk),qe(7,c.$Xqc)],M);let A=class extends M{constructor(G,x,j,U,J,Y,ae,ee){super(G,x,j,U,J,Y,ae,ee),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:a.$k(a.Platform.Web)})}async executeTask(G,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const j=O.from(x,G);if(j===void 0)throw new Error("Task is not valid");if(E.is(j.execution))await this.y(j,x,!1);else throw new n.$db;const U=await this.z(await this.a.$getTaskExecution(j),x);return this.a.$executeTask(j).catch(J=>{throw new Error(J)}),U}v(G,x,j,U){const J=[];if(U)for(const Y of U){if(this.A(Y,j),!Y.definition||!G[Y.definition.type]){const ee=Y.source?Y.source:"No task source";this.f.warn(`The task [${ee}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=O.from(Y,j.extension);ae&&E.is(ae.execution)?(J.push(ae),x.push(this.y(ae,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:J,extension:j.extension}}async w(G){if(E.is(G.execution))return G;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(G,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,x,j){}};e.$Ysc=A,e.$Ysc=A=Ke([qe(0,u.$MQ),qe(1,k.$3Q),qe(2,T.$hrc),qe(3,m.$XQ),qe(4,s.$krc),qe(5,w.$Irc),qe(6,h.$fk),qe(7,c.$Xqc)],A),e.$Zsc=(0,$.$Ki)("IExtHostTask")}),define(Re[268],Oe([1,0,40,32]),function(we,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=void 0,e.$YM=P,e.$1M=L;function P(R){return"cellResults"in R}e.$ZM="rawCell#";function L(R,T){let m=-1;const s=[];let I=[];return R.forEach(u=>{u.range.startLineNumber!==m&&I.length>0&&(s.push([...I]),I=[]),I.push(u),m=u.range.endLineNumber}),I.length>0&&s.push([...I]),s.map(u=>{const k=[],$=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let a=$;a<=r;a++)k.push(T.getLineContent(a));return new v.$AM(k.join(`
`)+`
`,u.map(a=>new D.$Wt(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}}),define(Re[269],Oe([1,0,9,20,6,4,27,38,13,14,2,28,80,5,35,8,7,39,246,126,25,15,40,199,268,266]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t,o,l,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zsc=void 0,w=Ve(w),r=Ve(r),a=Ve(a);class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,y,C,O,p,b,M){this.q=C,this.r=O,this.s=p,this.t=b,this.u=M,this.f=new Map,this.g=new R.$Fc,this.h=new Map,this.j=new P.$qe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$qe,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$qe,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$qe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$Vqc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=E.getProxy(k.$_N.MainThreadNotebook),this.c=E.getProxy(k.$_N.MainThreadNotebookDocuments),this.d=E.getProxy(k.$_N.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===T.MarshalledId.NotebookCellActionContext){const F=A.notebookEditor?.notebookUri,G=A.cell.handle,j=this.g.get(F)?.getCell(G);if(j)return j.apiCell}if(A&&A.$mid===T.MarshalledId.NotebookActionContext){const F=A.uri,G=this.g.get(F);if(G)return G.apiNotebook}return A}}),d.C(y)}getEditorById(E){const y=this.h.get(E);if(!y)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(E){for(const[y,C]of this.h)if(C.apiEditor===E)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,y){const C=this.g.get(E);if(!C&&!y)throw new Error(`NO notebook document for '${E}'`);return C}static w(E,y){if(!y)return;const C=y.filenamePattern.map(O=>r.NotebookExclusiveDocumentPattern.from(O)).filter(O=>O!==void 0);if(y.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:y.displayName,filenamePattern:C,priority:y.exclusive?f.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(E,y,C){const O=d.a++,p=typeof C.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(O,C),this.b.$registerNotebookCellStatusBarItemProvider(O,p,y);let b;return p!==void 0&&(b=C.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(p))),new a.$bO(()=>{this.f.delete(O),this.b.$unregisterNotebookCellStatusBarItemProvider(O,p),b?.dispose()})}async createNotebookDocument(E){const y=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&r.NotebookData.from(E.content)});return I.URI.revive(y)}async openNotebookDocument(E){const y=this.g.get(E);if(y)return y.apiNotebook;const C=await this.c.$tryOpenNotebook(E),O=this.g.get(I.URI.revive(C));return(0,s.$ug)(O?.apiNotebook)}async showNotebookDocument(E,y){let C;typeof y=="object"?C={position:r.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(r.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0,label:y?.label}:C={preserveFocus:!1,pinned:!0};const O=y?.asRepl?"repl":E.notebookType,p=await this.d.$tryShowNotebookDocument(E.uri,O,C),b=p&&this.h.get(p)?.apiEditor;if(b)return b;throw p?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,y,C,O){const p=this.f.get(E),b=I.URI.revive(y),M=this.g.get(b);if(!M||!p)return;const A=M.getCellFromIndex(C);if(!A)return;const F=await p.provideCellStatusBarItems(A.apiCell,O);if(!F)return;const G=new L.$Yc,x=this.p.add([G]),U=(Array.isArray(F)?F:[F]).map(J=>r.NotebookStatusBarItem.from(J,this.i,G));return{cacheId:x,items:U}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,y,C,O,p){if((0,m.$hf)(y))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:y,serializer:C,options:O}),this.b.$registerNotebookSerializer(b,{id:E.identifier,location:E.extensionLocation},y,r.NotebookDocumentContentOptions.from(O),d.w(E,p)),(0,L.$Xc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(E,y,C){const O=this.y.get(E);if(!O)throw new Error("NO serializer found");const p=await O.serializer.deserializeNotebook(y.buffer,C);return new h.$7w(r.NotebookData.from(p))}async $notebookToData(E,y,C){const O=this.y.get(E);if(!O)throw new Error("NO serializer found");const p=await O.serializer.serializeNotebook(r.NotebookData.to(y.value),C);return D.$Se.wrap(p)}async $saveNotebook(E,y,C,O,p){const b=I.URI.revive(y),M=this.y.get(E);if(this.D(`enter saveNotebook(versionId: ${C}, ${b.toString()})`),!M)throw new Error("NO serializer found");const A=this.g.get(b);if(!A)throw new Error("Document NOT found");if(A.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new w.$Al((0,v.localize)(2709,null,this.A(b)),w.FileOperationResult.FILE_PERMISSION_DENIED);const F={metadata:(0,n.$so)(A.apiNotebook.metadata,J=>!(M.options?.transientDocumentMetadata??{})[J]),cells:[]};for(const J of A.apiNotebook.getCells()){const Y=new a.$GP(J.kind,J.document.getText(),J.document.languageId,J.mime,M.options?.transientOutputs?[]:[...J.outputs],J.metadata,J.executionSummary);Y.metadata=(0,n.$so)(J.metadata,ae=>!(M.options?.transientCellMetadata??{})[ae]),F.cells.push(Y)}if(await this.z(b,O),p.isCancellationRequested)throw new Error("canceled");const G=await M.serializer.serializeNotebook(F,p);if(p.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${b.toString()}`),await this.s.value.writeFile(b,G),this.D(`Finished write versionId: ${C} ${b.toString()}`);const x=this.s.getFileSystemProviderExtUri(b.scheme),j=await this.s.value.stat(b),U={name:x.basename(b),isFile:(j.type&w.FileType.File)!==0,isDirectory:(j.type&w.FileType.Directory)!==0,isSymbolicLink:(j.type&w.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&w.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((j.permissions??0)&w.FilePermission.Locked),etag:w.$Ll({mtime:j.mtime,size:j.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${b.toString()})`),U}async $searchInNotebooks(E,y,C,O,p){const b=this.y.get(E)?.serializer;if(!b)return{limitHit:!1,results:[]};const M=new R.$Gc;await(async(j,U,J)=>{await Promise.all(j.map(async Y=>await Promise.all(Y.filenamePatterns.map(ae=>{const ee={_reason:J._reason,folderQueries:J.folderQueries,includePattern:J.includePattern,excludePattern:J.excludePattern,maxResults:J.maxResults,type:o.QueryType.File,filePattern:ae};return this.t.doInternalFileSearchWithCustomCallback(ee,U,oe=>{oe.forEach(ie=>{M.has(ie)||O.some(_=>Y.isFromSettings&&!_.isFromSettings?!1:_.filenamePatterns.some($e=>(0,f.$NL)($e,ie)))||M.add(ie)})}).catch(oe=>{if(oe.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw oe})}))))})(C,p,y);const F=new R.$Fc;let G=!1;const x=Array.from(M).map(async j=>{const U=[];try{if(p.isCancellationRequested)return;if(y.maxResults&&[...F.values()].reduce((ee,oe)=>ee+oe.cellResults.length,0)>y.maxResults){G=!0;return}const J=[],Y=this.g.get(j);if(Y)Y.apiNotebook.getCells().forEach(oe=>J.push({input:oe.document.getText(),outputs:oe.outputs.flatMap(ie=>ie.items.map(ue=>ue.data.toString()))}));else{const ee=await this.s.value.readFile(j),oe=D.$Se.fromString(ee.toString()),ie=await b.deserializeNotebook(oe.buffer,p);if(p.isCancellationRequested)return;r.NotebookData.from(ie).cells.forEach(_=>J.push({input:_.source,outputs:_.outputs.flatMap($e=>$e.items.map(Ie=>Ie.valueBytes.toString()))}))}if(p.isCancellationRequested)return;J.forEach((ee,oe)=>{const ie=y.contentPattern.pattern,ue=new l.$S2b(ee.input,void 0,ee.outputs),_=ue.findInInputs(ie),$e=ue.findInOutputs(ie),Ie=$e.flatMap(X=>(0,g.$1M)(X.matches,X.textBuffer)).map((X,V)=>(X.webviewIndex=V,X));if(_.length>0||$e.length>0){const X={index:oe,contentResults:(0,g.$1M)(_,ue.inputTextBuffer),webviewResults:Ie};U.push(X)}});const ae={resource:j,cellResults:U};F.set(j,ae);return}catch{return}});return await Promise.all(x),{limitHit:G,results:[...F.values()]}}async z(E,y){const C=await this.s.value.stat(E);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==w.$Kl&&typeof C.mtime=="number"&&typeof C.size=="number"&&y.mtime<C.mtime&&y.etag!==w.$Ll({mtime:y.mtime,size:C.size}))throw new w.$Al((0,v.localize)(2710,null),w.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(E){return E.scheme===t.Schemas.file?E.fsPath:E.toString()}B(E,y,C){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const O=new i.$lsc(y,this.d,E,C.visibleRanges.map(r.NotebookRange.to),C.selections.map(r.NotebookRange.to),typeof C.viewColumn=="number"?r.ViewColumn.to(C.viewColumn):void 0);this.h.set(y,O)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const C of E.value.removedDocuments){const O=I.URI.revive(C),p=this.g.get(O);p&&(p.dispose(),this.g.delete(O),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(p.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===O.toString()&&this.h.delete(b.id)}if(E.value.addedDocuments){const C=[];for(const O of E.value.addedDocuments){const p=I.URI.revive(O.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const b=new c.$ksc(this.c,this.q,this.r,p,O);C.push(...O.cells.map(M=>c.$jsc.asModelAddData(M))),this.g.get(p)?.dispose(),this.g.set(p,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(b.apiNotebook)}}if(E.value.addedEditors)for(const C of E.value.addedEditors){if(this.h.has(C.id))return;const O=I.URI.revive(C.documentUri),p=this.g.get(O);p&&this.B(p,C.id,C)}const y=[];if(E.value.removedEditors)for(const C of E.value.removedEditors){const O=this.h.get(C);O&&(this.h.delete(C),this.k?.id===O.id&&(this.k=void 0),y.push(O))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(O=>this.h.get(O)).filter(O=>!!O);const C=new Set;this.l.forEach(O=>C.add(O.id));for(const O of this.h.values()){const p=C.has(O.id);O._acceptVisibility(p)}this.l=[...this.h.values()].map(O=>O).filter(O=>O.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.h.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(E){const y=$.$$Q.String.with("notebookType","A notebook type"),C=new $.$aR("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new $.$$Q("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>D.$Se.wrap(p))],new $.$_Q("Notebook Data",p=>r.NotebookData.to(p.value))),O=new $.$aR("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new $.$$Q("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new h.$7w(r.NotebookData.from(p)))],new $.$_Q("Bytes",p=>p.buffer));E.registerApiCommand(C),E.registerApiCommand(O)}D(E){this.u.trace(`[Extension Host Notebook] ${E}`)}}e.$zsc=d}),define(Re[270],Oe([1,0,17,240,43,103,27,15,22,24,13,14,2,102,9,44,11,114,49,120,267,40]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=void 0,e.$PN=o,e.$QN=l,e.$SN=p,v=Ve(v),D=Ve(D),P=Ve(P),m=Ve(m),I=Ve(I),$=Ve($);function o(b){return typeof b=="object"&&"uri"in b&&"pattern"in b}function l(b){return typeof b=="string"?{pattern:b}:{pattern:b.pattern,uri:b.baseUri}}let g=class{constructor(M,A,F,G,x,j){this.a=M,this.b=A,this.c=F,this.d=G,this.f=x,this.g=j}text(M,A,F={}){M=this.h(M,F);const G=this.a.getValue(),x=A&&A.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.j(A?.map(c.$6i),F),type:t.QueryType.Text,contentPattern:M,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:G.search.usePCRE2||x||!1,surroundingContext:F.surroundingContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}h(M,A){const F=this.a.getValue();M.isRegExp&&(M.pattern=M.pattern.replace(/\r?\n/g,"\\n"));const G={...M,wordSeparators:F.editor.wordSeparators};return this.l(M,A)&&(G.isCaseSensitive=!0),this.m(M)&&(G.isMultiline=!0),A.notebookSearchConfig?.includeMarkupInput&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookMarkdownInput=A.notebookSearchConfig.includeMarkupInput),A.notebookSearchConfig?.includeMarkupPreview&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookMarkdownPreview=A.notebookSearchConfig.includeMarkupPreview),A.notebookSearchConfig?.includeCodeInput&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookCellInput=A.notebookSearchConfig.includeCodeInput),A.notebookSearchConfig?.includeOutput&&(G.notebookInfo||(G.notebookInfo={}),G.notebookInfo.isInNotebookCellOutput=A.notebookSearchConfig.includeOutput),G}file(M,A={}){return{...this.j(M,A),type:t.QueryType.File,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey,shouldGlobMatchFilePattern:A.shouldGlobSearch}}i(M,A){if(!M)return{};if(Array.isArray(M)){if(M=M.filter(F=>F.length>0).map(y),!M.length)return{}}else M=y(M);return A?this.parseSearchPaths(M):{pattern:d(...Array.isArray(M)?M:[M])}}j(M=[],A={}){let F=Array.isArray(A.excludePattern)?A.excludePattern.map(ae=>ae.pattern).flat():A.excludePattern;F=F?.length===1?F[0]:F;const G=this.i(A.includePattern,A.expandPatterns),x=this.i(F,A.expandPatterns),j=M.length>1,U=(G.searchPaths&&G.searchPaths.length?G.searchPaths.map(ae=>this.t(ae,A,x)):M.map(ae=>this.u(ae,A,x,j))).filter(ae=>!!ae),J={_reason:A._reason,folderQueries:U,usingSearchPaths:!!(G.searchPaths&&G.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:x.pattern,includePattern:G.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults,onlyFileScheme:A.onlyFileScheme};if(A.onlyOpenEditors){const ae=v.$Lb(this.c.groups.flatMap(ie=>ie.editors.map(ue=>ue.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(ae));const ee=ae.filter(ie=>(0,t.$EM)(J,ie.fsPath)),oe=this.k(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(oe)),{...J,...oe}}const Y=A.extraFileResources&&A.extraFileResources.filter(ae=>(0,t.$EM)(J,ae.fsPath));return J.extraFileResources=Y&&Y.length?Y:void 0,J}k(M){const A=[],F=new R.$Fc,G={};let x=!1;return M.forEach(j=>{if(j.scheme===T.Schemas.walkThrough)return;if((0,s.$ph)(j)){const J=this.b.getWorkspaceFolder(j)?.uri??this.g.extUri.dirname(j);let Y=F.get(J);Y||(x=!0,Y={folder:J,includePattern:{}},A.push(Y),F.set(J,Y));const ae=m.$qc(J.fsPath,j.fsPath);(0,w.$ug)(Y.includePattern)[ae.replace(/\\/g,"/")]=!0}else j.fsPath&&(x=!0,G[j.fsPath]=!0)}),{folderQueries:A,includePattern:G,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}l(M,A){if(A.isSmartCase){if(M.isRegExp){if(I.$ag(M.pattern,!0))return!0}else if(I.$ag(M.pattern))return!0}return!!M.isCaseSensitive}m(M){return M.isMultiline||M.isRegExp&&(0,k.$yD)(M.pattern)||M.pattern.indexOf(`
`)>=0?!0:!!M.isMultiline}parseSearchPaths(M){const A=ee=>m.$nc(ee)||/^\.\.?([\/\\]|$)/.test(ee),G=(Array.isArray(M)?M:S(M)).map(ee=>{const oe=this.f.resolvedUserHome;return oe?(0,L.$_w)(ee,oe.scheme===T.Schemas.file?oe.fsPath:oe.path):ee}),x=D.$e(G,ee=>A(ee)?"searchPaths":"exprSegments"),j=(x.exprSegments||[]).map(ee=>I.$sf(ee,"/")).map(ee=>I.$sf(ee,"\\")).map(ee=>(ee[0]==="."&&(ee="*"+ee),E(ee))),U={},J=this.o(x.searchPaths||[]);J&&J.length&&(U.searchPaths=J);const Y=j.flat(),ae=d(...Y);return ae&&(U.pattern=ae),U}n(M,A){return A.disregardExcludeSettings?void 0:(0,t.$DM)(M,!A.disregardSearchExcludeSettings)}o(M){if(!M||!M.length)return[];const A=M.flatMap(G=>{let{pathPortion:x,globPortion:j}=f(G);return j&&(j=C(j)),this.q(x).flatMap(J=>this.r(J,j))}),F=new Map;return A.forEach(G=>{const x=G.searchPath.toString(),j=F.get(x);j?G.pattern&&(j.pattern=j.pattern||{},j.pattern[G.pattern]=!0):F.set(x,{searchPath:G.searchPath,pattern:G.pattern?d(G.pattern):void 0})}),Array.from(F.values())}q(M){if(m.$nc(M)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==T.Schemas.file?[{searchPath:A[0].uri.with({path:M})}]:[{searchPath:u.URI.file(m.$mc(M))}]}if(this.b.getWorkbenchState()===c.WorkbenchState.FOLDER){const A=this.b.getWorkspace().folders[0].uri;if(M=y(M),M.startsWith("../")||M===".."){const G=m.$lc.resolve(A.path,M);return[{searchPath:A.with({path:G})}]}const F=C(M);return[{searchPath:A,pattern:F}]}else{if(M==="./"||M===".\\")return[];{const A=M.replace(/^\.[\/\\]/,""),G=this.b.getWorkspace().folders.map(x=>{const j=A.match(new RegExp(`^${I.$mf(x.name)}(?:/(.*)|$)`));return j?{match:j,folder:x}:null}).filter(w.$rg);if(G.length)return G.map(x=>{const j=x.match[1];return{searchPath:x.folder.uri,pattern:j&&C(j)}});{const x=M.match(/\.[\/\\](.+)[\/\\]?/),j=x?x[1]:M,U=$.localize(12568,null,j);throw new Error(U)}}}}r(M,A){const F=M.pattern&&A?`${M.pattern}/${A}`:M.pattern||A,G=[{searchPath:M.searchPath,pattern:F}];return F&&!F.endsWith("**")&&G.push({searchPath:M.searchPath,pattern:F+"/**"}),G}t(M,A,F){const G=this.u((0,c.$6i)(M.searchPath),A,F,!1);return G?{...G,includePattern:M.pattern}:null}u(M,A,F,G){let x;const j=u.URI.isUri(M)?M:M.uri;let U=A.excludePattern?.map(ie=>{const ue=A.excludePattern&&o(ie)?ie.uri:void 0;return!ue||!(u.URI.isUri(M)&&this.g.extUri.isEqual(M,ue))?ue:void 0});if(U?.length||(U=[void 0]),F.searchPaths){const ie=F.searchPaths.filter(ue=>(0,s.$eh)(ue.searchPath,j))[0];if(ie&&!ie.pattern)return null;ie&&(x=ie.pattern)}const J=this.a.getValue({resource:j}),ae={...this.n(J,A)||{},...x||{}},ee=u.URI.isUri(M)?(0,s.$ih)(M):M.name,oe=U.map(ie=>Object.keys(ae).length>0?{folder:ie,pattern:ae}:void 0).filter(ie=>ie);return{folder:j,folderName:G?ee:void 0,excludePattern:oe,fileEncoding:J.files&&J.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!J.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!J.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!J.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!J.search.followSymlinks}}};e.$RN=g,e.$RN=g=Ke([qe(0,r.$ej),qe(1,c.$Ti),qe(2,i.$ME),qe(3,a.$fk),qe(4,n.$NN),qe(5,h.$Pl)],g);function f(b){const M=b.match(/[\*\{\}\(\)\[\]\?]/);if(M){const A=M.index,F=b.substr(0,A).match(/[/|\\][^/\\]*$/);if(F){let G=b.substr(0,F.index);return G.match(/[/\\]/)||(G+="/"),{pathPortion:G,globPortion:b.substr((F.index||0)+1)}}}return{pathPortion:b}}function d(...b){return b.length?b.reduce((M,A)=>(M[A]=!0,M),Object.create(null)):void 0}function S(b){return P.$Dk(b,",").map(M=>M.trim()).filter(M=>!!M.length)}function E(b){return[`**/${b}/**`,`**/${b}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function y(b){return b.replace(/\\/g,"/")}function C(b){return y(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function O(b){return b.replace(/([?*[\]])/g,"[$1]")}function p(b,M){b=v.$Qb(b,G=>G.toString());const A=[],F=M.getWorkspace();return b&&b.forEach(G=>{let x;if(M.getWorkbenchState()===c.WorkbenchState.FOLDER)x=(0,s.$nh)(F.folders[0].uri,G),x&&x!=="."&&(x="./"+x);else{const j=M.getWorkspaceFolder(G);if(j){const U=j.name;if(F.folders.filter(Y=>Y.name===U).length===1){const Y=(0,s.$nh)(j.uri,G);Y===""?x=`./${j.name}`:x=`./${j.name}/${Y}`}else x=G.fsPath}}x&&A.push(O(x))}),A}}),define(Re[271],Oe([1,0,24,2,19,12,3,270,40,49,10]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LAb=u,e.$MAb=r,v=Ve(v),L=Ve(L);const w=7e3;function u(a,h){const c=h.activationEvents;if(!c)return Promise.resolve(void 0);const i=[],n=[];for(const d of c)if(/^workspaceContains:/.test(d)){const S=d.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||a.forceUsingSearch?n.push(S):i.push(S)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:o}=(0,I.$Dh)(),l=d=>o({activationEvent:d}),g=Promise.all(i.map(d=>k(a,d,l))).then(()=>{}),f=$(a,h.identifier,n,l);return Promise.all([g,f]).then(()=>{o(void 0)}),t}async function k(a,h,c){for(const i of a.folders)if(await a.exists(v.$lh(D.URI.revive(i),h))){c(`workspaceContains:${h}`);return}}async function $(a,h,c,i){if(c.length===0)return Promise.resolve(void 0);const n=new P.$Be,t=a.checkExists(a.folders,c,n.token),o=setTimeout(async()=>{n.cancel(),a.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},w);let l=!1;try{l=await t}catch(g){L.$8(g)||L.$4(g)}n.dispose(),clearTimeout(o),l&&i(`workspaceContains:${c.join(",")}`)}function r(a,h,c,i){const n=a.get(R.$Ji),t=a.get(m.$vM),l=n.createInstance(T.$RN).file(h.map(g=>(0,s.$6i)(D.URI.revive(g))),{_reason:"checkExists",includePattern:c,exists:!0});return t.fileSearch(l,i).then(g=>!!g.limitHit,g=>L.$8(g)?!1:Promise.reject(g))}}),define(Re[47],Oe([1,0,9,22,64,24,10,4,48,2,11,5,46,206,89,45,21,121,12,18,20,189,7,110,3,26,92,16,75,93,56,95,6,271,88,191,15,86,69,23,87]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d,S,E,y,C,O,p,b,M,A,F,G,x,j,U){"use strict";var J;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zrc=e.$Yrc=e.$Xrc=e.$Wrc=e.$Vrc=void 0,v=Ve(v),D=Ve(D),P=Ve(P),c=Ve(c),e.$Vrc=(0,g.$Ki)("IHostUtils");let Y=J=class extends T.$Zc{constructor(X,V,re,be,Pe,Fe,Be,xe,nt,ht,$t,ut,et){super(),this.Y=ut,this.Z=et,this.a=this.B(new p.$qe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=V,this.g=re,this.f=Be,this.j=be,this.m=Pe,this.s=Fe,this.t=nt,this.u=ht,this.w=$t,this.y=this.g.getProxy(w.$_N.MainThreadWorkspace),this.z=this.g.getProxy(w.$_N.MainThreadTelemetry),this.C=this.g.getProxy(w.$_N.MainThreadExtensionService),this.D=new R.$Jh,this.F=new R.$Jh,this.G=new R.$Jh,this.H=new R.$Jh,this.I=new $e(this.f.extensions.activationEvents),this.L=new h.$afc(this.I,this.f.extensions.allExtensions);const Le=new i.$yn(this.f.extensions.myExtensions);this.J=new h.$afc(this.I,ue(this.L,Le)),j.$w&&(this.s.info(`Creating extension host with the following global extensions: ${oe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${oe(this.J)}`)),this.M=new $.$Erc(this.g,this.s),this.N=new M.$Orc(this.g),this.O=xe,this.h=this.q.add(X.createChild(new E.$Ii([$.$Frc,this.M],[M.$Prc,this.N]))),this.P=this.B(new k.$Drc(this.J,this.L,{onExtensionActivationError:(Ne,Me,W)=>{this.C.$onExtensionActivationError(Ne,c.$6(Me),W)},actualActivateExtension:async(Ne,Me)=>{if(h.$afc.isHostExtension(Ne,this.J,this.L))return await this.C.$activateExtension(Ne,Me),new k.$Crc;const W=this.J.getExtensionDescription(Ne);return this.fb(W,Me)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(X){c.$4(X)}}async $(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(Pe=>Pe.identifier).filter(Pe=>this.isActivated(Pe)).map(Pe=>this.eb(Pe))}catch{}await Promise.all(X)}terminate(X,V=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const re=this.$();Promise.race([(0,R.$Lh)(5e3),re]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const V=await this.C.$getExtension(X);return V&&{...V,identifier:new i.$xn(V.identifier.value),extensionLocation:s.URI.revive(V.extensionLocation)}}ab(X,V){return this.P.activateByEvent(X,V)}bb(X,V){return this.P.activateById(X,V)}activateByIdWithErrors(X,V){return this.bb(X,V).then(()=>{const re=this.P.getActivatedExtension(X);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async cb(X){if(X.scheme===F.Schemas.file&&this.c.fsRealpath){const V=X.fsPath;this.R.has(V)||this.R.set(V,this.c.fsRealpath(V));const re=await this.R.get(V);return s.URI.file(re)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(X=>new _(X))),this.Q}async db(X){const V=m.$Qi.forUris(re=>L.$ch.ignorePathCasing(re));return await Promise.all(X.map(async re=>{if(this.wb(re)){const be=await this.cb(re.extensionLocation);V.set(be,re)}})),V}eb(X){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return V;const re=this.P.getActivatedExtension(X);if(!re)return V;try{typeof re.module.deactivate=="function"&&(V=Promise.resolve(re.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(be)}try{re.disposable.dispose()}catch(be){this.s.error(`An error occurred when disposing the subscriptions for extension '${X.value}':`),this.s.error(be)}return V}async fb(X,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.hb(X,V).then(re=>{const be=re.activationTimes;return this.C.$onDidActivateExtension(X.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,V),this.gb(X,V,"success",be),re},re=>{throw this.gb(X,V,"failure"),re})}gb(X,V,re,be){const Pe=ee(X,V);this.z.$publicLog2("extensionActivationTimes",{...Pe,...be||{},outcome:re})}hb(X,V){const re=ee(X,V);this.z.$publicLog2("activatePlugin",re);const be=this.wb(X);if(!be)return Promise.resolve(new k.$Brc(k.$yrc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Pe=new T.$Yc,Fe=new k.$zrc(V.startup);return Promise.all([this.xb(X,(0,L.$lh)(X.extensionLocation,be),Fe),this.ib(X,Pe)]).then(Be=>(P.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),J.jb(this.s,X.identifier,Be[0],Be[1],Pe,Fe))).then(Be=>(P.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),Be))}ib(X,V){const re=this.Z.createLanguageModelAccessInformation(X),be=V.add(new t.$Hrc(X,this.M)),Pe=V.add(new t.$Grc(X.identifier.value,!1,this.M)),Fe=V.add(new A.$Qrc(X,this.N)),Be=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,xe=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([be.whenReady,Pe.whenReady,this.O.whenReady]).then(()=>{const nt=this;let ht,$t;const ut=(0,a.$AH)(X,"ipc")?this.f.messagePorts?.get(i.$xn.toKey(X.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Pe,secrets:Fe,subscriptions:[],get languageModelAccessInformation(){return re},get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(et){return D.$oc(X.extensionLocation.fsPath,et)},get storagePath(){return nt.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return nt.O.globalValue(X).fsPath},get logPath(){return D.$oc(nt.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return s.URI.joinPath(nt.f.logsLocation,X.identifier.value)},get storageUri(){return nt.O.workspaceValue(X)},get globalStorageUri(){return nt.O.globalValue(X)},get extensionMode(){return Be},get extension(){return ht===void 0&&(ht=new ie(nt,X.identifier,X,xe,!1)),ht},get extensionRuntime(){return(0,a.$BH)(X,"extensionRuntime"),nt.extensionRuntime},get environmentVariableCollection(){return nt.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!$t){if(!ut)return;const et=p.Event.buffer(p.Event.fromDOMEventEmitter(ut,"message",Le=>Le.data));ut.start(),$t={onDidReceiveMessage:et,postMessage:ut.postMessage.bind(ut)}}return $t}})})}static jb(X,V,re,be,Pe,Fe){return re=re||{activate:void 0,deactivate:void 0},this.kb(X,V,re,be,Fe).then(Be=>new k.$Arc(!1,null,Fe.build(),re,Be,(0,T.$Xc)(()=>{Pe.dispose(),(0,T.$Uc)(be.subscriptions)})))}static kb(X,V,re,be,Pe){if(typeof re.activate=="function")try{Pe.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Fe=typeof global=="object"?global:self,Be=re.activate.apply(Fe,[be]);return Pe.activateCallStop(),Pe.activateResolveStart(),Promise.resolve(Be).then(xe=>(Pe.activateResolveStop(),xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(re)}lb(X,V){this.bb(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,re=>{this.s.error(re)})}mb(X,V=0){const be=Date.now();(0,j.$E)(()=>{for(let Pe=V;Pe<X.length;Pe+=1){const Fe=X[Pe];for(const Be of Fe.activationEvents??[])if(Be==="onStartupFinished")if(Date.now()-be>50){this.mb(X,Pe);break}else this.lb(Fe,Be)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.J.getAllExtensionDescriptions();if(V)this.mb(re);else for(const be of re)if(be.activationEvents)for(const Pe of be.activationEvents)Pe==="onStartupFinished"&&this.lb(be,Pe)})}ob(){const X=this.ab("*",!0).then(void 0,Fe=>{this.s.error(Fe)});this.B(this.j.onDidChangeWorkspace(Fe=>this.pb(Fe.added)));const V=this.j.workspace?this.j.workspace.folders:[],re=this.pb(V),be=this.rb(),Pe=Promise.all([be,X,re]).then(()=>{});return Promise.race([Pe,(0,R.$Lh)(1e4)]).then(()=>{this.nb()}),Pe}pb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.qb(X,V))).then(()=>{})}async qb(X,V){if(this.isActivated(V.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:X.map(Fe=>Fe.uri),forceUsingSearch:re||!this.c.fsExists,exists:Fe=>this.c.fsExists(Fe.fsPath),checkExists:(Fe,Be,xe)=>this.y.$checkExists(Fe,Be,xe)},Pe=await(0,b.$LAb)(be,V);if(Pe)return this.bb(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Pe.activationEvent}).then(void 0,Fe=>this.s.error(Fe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(X){throw console.error(X),X}}async sb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this.f.environment;if(!X||!V)throw new Error(v.localize(2701,null));const re=await this.xb(null,V,new k.$zrc(!1));if(!re||typeof re.run!="function")throw new Error(v.localize(2702,null,V.toString()));return new Promise((be,Pe)=>{const Fe=(nt,ht)=>{nt?(j.$w&&this.s.error("Test runner called back with error",nt),Pe(nt)):(j.$w&&(ht?this.s.info(`Test runner called back with ${ht} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof ht=="number"&&ht>0?1:0))},Be=(0,L.$_g)(V),xe=re.run(Be,Fe);xe&&xe.then&&xe.then(()=>{j.$w&&this.s.info("Test runner finished successfully."),be(0)}).catch(nt=>{j.$w&&this.s.error("Test runner finished with error",nt),Pe(nt instanceof Error&&nt.stack?nt.stack:String(nt))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Lh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this.S[X]=V,(0,T.$Xc)(()=>{delete this.S[X]})}async getRemoteExecServer(X){const{resolver:V}=await this.ub(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async ub(X){const V=X.indexOf("+");if(V===-1)throw new o.$jO("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=X.substr(0,V);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.S[re]}}async $resolveAuthority(X,V){const re=x.$ke.create(!1),be=()=>`[resolveAuthority(${(0,l.$1l)(X)},${V})][${re.elapsed()}ms] `,Pe=B=>this.s.info(`${be()}${B}`),Fe=B=>this.s.warn(`${be()}${B}`),Be=(B,Q=void 0)=>this.s.error(`${be()}${B}`,Q),xe=B=>{if(B instanceof o.$jO)return{type:"error",error:{code:B._code,message:B._message,detail:B._detail}};throw B},nt=async B=>{Pe(`activating resolver for ${B}...`);const{resolver:Q,authorityPrefix:K}=await this.ub(B);if(!Q)throw Be(`no resolver for ${K}`),new o.$jO(`No remote extension installed to resolve ${K}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:K,remoteAuthority:B}},ht=X.split(/@|%40/g).reverse();Pe(`activating remote resolvers ${ht.join(" -> ")}`);let $t;try{$t=await Promise.all(ht.map(nt)).catch(async B=>{if(!(B instanceof o.$jO)||B._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw B;return Fe(`resolving nested authorities failed: ${B.message}`),[await nt(X)]})}catch(B){return xe(B)}const ut=new R.$Vh;ut.cancelAndSet(()=>Pe("waiting..."),1e3);let et,Le;for(const[B,{authorityPrefix:Q,resolver:K,remoteAuthority:se}]of $t.entries())try{if(B===$t.length-1)Pe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${Q}`),et=await K.resolve(se,{resolveAttempt:V,execServer:Le}),P.mark(`code/extHost/didResolveAuthorityOK/${Q}`),Pe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(K,o.$iO.isManagedResolvedAuthority(et)?et:void 0));else{if(Pe(`invoking resolveExecServer() for ${se}`),P.mark(`code/extHost/willResolveExecServer/${Q}`),Le=await K.resolveExecServer?.(se,{resolveAttempt:V,execServer:Le}),!Le)throw new o.$jO(`Exec server was not available for ${se}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(ge){return P.mark(`code/extHost/didResolveAuthorityError/${Q}`),Be("returned an error",ge),ut.dispose(),xe(ge)}ut.dispose();const Ne={environmentTunnels:et.environmentTunnels,features:et.tunnelFeatures?{elevation:et.tunnelFeatures.elevation,privacyOptions:et.tunnelFeatures.privacyOptions,protocol:et.tunnelFeatures.protocol===void 0?!0:et.tunnelFeatures.protocol}:void 0},Me={extensionHostEnv:et.extensionHostEnv,isTrusted:et.isTrusted,authenticationSession:et.authenticationSessionForInitializingExtensions?{id:et.authenticationSessionForInitializingExtensions.id,providerId:et.authenticationSessionForInitializingExtensions.providerId}:void 0};Pe(`returned ${o.$iO.isManagedResolvedAuthority(et)?"managed authority":`${et.host}:${et.port}`}`);let W;if(o.$iO.isManagedResolvedAuthority(et)){const B=V;this.Y.setFactory(B,et.makeConnection),W={authority:X,connectTo:new l.$Xl(B),connectionToken:et.connectionToken}}else W={authority:X,connectTo:new l.$Yl(et.host,et.port),connectionToken:et.connectionToken};return{type:"ok",value:{authority:W,options:Me,tunnelInformation:Ne}}}async $getCanonicalURI(X,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$1l)(X)})`);const{resolver:re}=await this.ub(X);if(!re)return null;const be=s.URI.revive(V);if(typeof re.getCanonicalURI>"u")return be;const Pe=await(0,R.$Ch)(()=>re.getCanonicalURI(be));return Pe||be}async $startExtensionHost(X){X.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:V,myExtensions:re}=ae(this.I,this.L,this.J,X),be=await this.db(re);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(V.getAllExtensionDescriptions()),this.J.set(re),j.$w&&(this.s.info(`$startExtensionHost: global extensions: ${oe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${oe(this.J)}`)),this.tb()}$activateByEvent(X,V){return V===a.ActivationKind.Immediate?this.D.wait().then(re=>this.ab(X,!1)):this.G.wait().then(re=>this.ab(X,!1))}async $activate(X,V){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.bb(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Fe=>Fe.extensionLocation=s.URI.revive(Fe.extensionLocation));const{globalRegistry:V,myExtensions:re}=ae(this.I,this.L,this.J,X),be=await this.db(re);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(V.getAllExtensionDescriptions()),this.J.set(re),j.$w&&(this.s.info(`$deltaExtensions: global extensions: ${oe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${oe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=n.$Se.alloc(X),re=Math.random()%256;for(let be=0;be<X;be++)V.writeUInt8(re,be);return V}async $updateRemoteConnectionData(X){this.X=X,this.a.fire()}};e.$Wrc=Y,e.$Wrc=Y=J=Ke([qe(0,g.$Ji),qe(1,e.$Vrc),qe(2,S.$MQ),qe(3,r.$hrc),qe(4,u.$krc),qe(5,I.$fk),qe(6,f.$3Q),qe(7,d.$nrc),qe(8,y.$_Gb),qe(9,C.$Irc),qe(10,G.$Src),qe(11,U.$Trc),qe(12,O.$Mrc)],Y);function ae(Ie,X,V,re){Ie.addActivationEvents(re.addActivationEvents);const be=new h.$afc(Ie,X.getAllExtensionDescriptions());be.deltaExtensions(re.toAdd,re.toRemove);const Pe=new i.$yn(V.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of re.myToRemove)Pe.delete(Be);for(const Be of re.myToAdd)Pe.add(Be);const Fe=ue(be,Pe);return{globalRegistry:be,myExtensions:Fe}}function ee(Ie,X){return{id:Ie.identifier.value,name:Ie.name,extensionVersion:Ie.version,publisherDisplayName:Ie.publisher,activationEvents:Ie.activationEvents?Ie.activationEvents.join(","):null,isBuiltin:Ie.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function oe(Ie){return Ie.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$Xrc=(0,g.$Ki)("IExtHostExtensionService");class ie{#e;#t;#i;constructor(X,V,re,be,Pe){this.#e=X,this.#t=V,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=D.$mc((0,L.$_g)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=be,this.isFromDifferentExtensionHost=Pe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Yrc=ie;function ue(Ie,X){return Ie.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class _{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$Zrc=_;class $e{constructor(X){this.a=new i.$zn,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this.a.set(V,X[V])}}}),define(Re[272],Oe([1,0,64,2,5,46,21,18,16,26,3,47,11,13]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$dtc=void 0,v=Ve(v);let r=class{constructor(n,t,o,l,g,f,d){this.c=n,this.d=t,this.e=o,this.f=l,this.g=g,this.h=f,this.i=d,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new h(this.c,t,this.d,n,this.i)),this.register(this.e.createInstance(a)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,t,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this.a.set(t,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(t=>n.alternativeModuleName(t))}};e.$dtc=r,e.$dtc=r=Ke([qe(2,I.$Ji),qe(3,L.$krc),qe(4,w.$Xrc),qe(5,s.$3Q),qe(6,u.$fk)],r);let a=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&$.a.size){const t=(0,k.$mf)(this.c(n.environment.appRoot.fsPath)),o="[a-z0-9_.-]",l=`@${o}+\\/${o}+|${o}+`,g="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${g}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const t=this.b.exec(this.c(n));if(!t)return;const[,o,l,g]=t,f=$.a.get(l);if(f!==void 0)return console.warn(`${l} as been renamed to ${f}, please update your imports`),o+f+g}c(n){return n.replace(/\\/g,"/")}};a=$=Ke([qe(0,s.$3Q)],a);class h{constructor(n,t,o,l,g){this.c=n,this.d=t,this.e=o,this.f=l,this.g=g,this.nodeModuleName="vscode",this.a=new T.$zn}load(n,t){const o=this.d.findSubstr(t);if(o){let l=this.a.get(o.identifier);return l||(l=this.c(o,this.e,this.f),this.a.set(o.identifier,l)),l}if(!this.b){let l="";this.d.forEach((g,f)=>l+=`	${f} -> ${g.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${l}`),this.b=this.c(R.$vH,this.e,this.f)}return this.b}}let c=class{constructor(n,t,o){this.e=n,this.f=t,this.nodeModuleName=["open","opn"],this.d=o.getProxy(P.$_N.MainThreadTelemetry);const l=o.getProxy(P.$_N.MainThreadWindow);this.c=(g,f)=>{const d=D.URI.parse(g);return f?this.g(g,f):d.scheme==="http"||d.scheme==="https"?l.$openUri(d,g,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this.f?l.$openUri(d,g,{}):this.g(g,f)}}load(n,t,o){const l=this.e.findSubstr(t);return l&&(this.a=l.identifier.value,this.h()),this.b=o(n),this.c}g(n,t){return this.i(),this.b(n,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=Ke([qe(2,m.$MQ)],c)}),define(Re[133],Oe([1,0,51,4,22,79,3,57,70,47,7,45,203,46]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2rc=e.$1rc=void 0,P=Ve(P),L=Ve(L),e.$1rc=(0,R.$Ki)("IExtHostVariableResolverProvider");class $ extends u.$QR{constructor(h,c,i,n,t,o,l){function g(){if(i){const f=i.activeEditor();if(f)return f.document.uri;const d=n.tabGroups.all.find(S=>S.isActive)?.activeTab;if(d!==void 0){if(d.input instanceof I.$3P||d.input instanceof I.$8P)return d.input.modified;if(d.input instanceof I.$2P||d.input instanceof I.$7P||d.input instanceof I.$5P)return d.input.uri}}}super({getFolderUri:f=>{const d=o.folders.filter(S=>S.name===f);if(d&&d.length>0)return d[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(f,d)=>t.getConfiguration(void 0,f).get(d),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const f=g();if(f)return P.$mc(f.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const f=g();if(f){const d=c.getWorkspaceFolder(f);if(d)return P.$mc(d.uri.fsPath)}}},getSelectedText:()=>{if(i){const f=i.activeEditor();if(f&&!f.selection.isEmpty)return f.document.getText(f.selection)}},getLineNumber:()=>{if(i){const f=i.activeEditor();if(f)return String(f.selection.end.line+1)}},getExtension:f=>h.getExtension(f)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(L.env))}}let r=class extends D.$Zc{constructor(h,c,i,n,t){super(),this.b=h,this.c=c,this.g=i,this.h=n,this.j=t,this.a=new v.$Y(async()=>{const o=await this.h.getConfigProvider(),g={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async f=>{g.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,o,g,this.m())})}getResolver(){return this.a.value}m(){}};e.$2rc=r,e.$2rc=r=Ke([qe(0,s.$Xrc),qe(1,w.$hrc),qe(2,T.$XQ),qe(3,k.$krc),qe(4,m.$wrc)],r)}),define(Re[134],Oe([1,0,10,6,2,4,18,3,5,70,47,16,7,45,195,81,196,46,133,36,35,8,17,96]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_rc=e.$$rc=e.$0rc=e.$9rc=e.$8rc=void 0,t=Ve(t),e.$8rc=(0,T.$Ki)("IExtHostDebugService");let g=class extends L.$Zc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(O,p,b,M,A,F,G,x){super(),this.Y=p,this.Z=b,this.$=M,this.ab=A,this.bb=F,this.cb=G,this.db=x,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new D.$qe),this.z=this.B(new D.$qe),this.C=this.B(new D.$qe),this.F=this.B(new D.$qe),this.u=O.getProxy(m.$_N.MainThreadDebugService),this.I=this.B(new D.$qe),this.L=this.B(new D.$qe),this.G=new d(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(j=>{this.B(j.onDidChange(U=>{this.fb(j)})),this.fb(j)})}async $getVisualizerTreeItem(O,p){const b=this.gb(p);if(!b)return;const M=await this.Q.get(O)?.getTreeItem?.(b);return M?this.eb(O,M):void 0}registerDebugVisualizationTree(O,p,b){const M=R.$xn.toKey(O.identifier),A=this.ub(M,p);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.Q.set(A,b),this.u.$registerDebugVisualizerTree(A,!!b.editItem),(0,L.$Xc)(()=>{this.u.$unregisterDebugVisualizerTree(A),this.Q.delete(p)})}async $getVisualizerTreeItemChildren(O,p){const b=this.S.get(p)?.item;return b?(await this.Q.get(O)?.getChildren?.(b))?.map(A=>this.eb(O,A))||[]:[]}async $editVisualizerTreeItem(O,p){const b=this.S.get(O);if(!b)return;const M=await this.Q.get(b.provider)?.editItem?.(b.item,p);return this.eb(b.provider,M||b.item)}$disposeVisualizedTree(O){const p=this.S.get(O);if(!p)return;const b=[p.children];for(const M of b)if(M)for(const A of M)b.push(this.S.get(A)?.children),this.S.delete(A)}eb(O,p){let b=this.R.get(p);return b||(b=this.O++,this.R.set(p,b),this.S.set(b,{provider:O,item:p})),t.DebugTreeItem.from(p,b)}asDebugSourceUri(O,p){const b=O;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let M=`debug:${encodeURIComponent(b.path||"")}`,A="?";return p&&(M+=`${A}session=${encodeURIComponent(p.id)}`,A="&"),M+=`${A}ref=${b.sourceReference}`,P.URI.parse(M)}else{if(b.path)return P.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(O){const p=[];for(const b of O.getAllExtensionDescriptions())if(b.contributes){const M=b.contributes.debuggers;if(M&&M.length>0)for(const A of M)(0,a.$wI)(A)&&p.push(A.type)}this.u.$registerDebugTypes(p)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const O=[];return this.H.forEach(p=>O.push(p)),O}async $resolveDebugVisualizer(O,p){const b=this.W.get(O);if(!b)throw new Error(`No debug visualizer found with id '${O}'`);let{v:M,provider:A,extensionId:F}=b;if(M.visualization||(M=await A.resolveDebugVisualization?.(M,p)||M,b.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${A}'`);return this.vb(F,M.visualization)}async $executeDebugVisualizerCommand(O){const p=this.W.get(O);if(!p)throw new Error(`No debug visualizer found with id '${O}'`);const b=p.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(O){const p=this.w.get(O.sessionId);return p&&{session:p.api,variable:O.variable,containerId:O.containerId,frameId:O.frameId,threadId:O.threadId}}async $provideDebugVisualizers(O,p,b,M){const A=this.gb(b),F=this.ub(O,p),G=this.P.get(F);if(!A||!G)return[];const x=await G.provideDebugVisualization(A,M);return x?x.map(j=>{const U=++this.X;this.W.set(U,{v:j,provider:G,extensionId:O});const J=j.iconPath?this.wb(j.iconPath):void 0;return{id:U,name:j.name,iconClass:J?.iconClass,iconPath:J?.iconPath,visualization:this.vb(O,j.visualization)}}):[]}$disposeDebugVisualizers(O){for(const p of O)this.W.delete(p)}registerDebugVisualizationProvider(O,p,b){if(!O.contributes?.debugVisualizers?.some(F=>F.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const M=R.$xn.toKey(O.identifier),A=this.ub(M,p);if(this.P.has(A))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.P.set(A,b),this.u.$registerDebugVisualizer(M,p),(0,L.$Xc)(()=>{this.u.$unregisterDebugVisualizer(M,p),this.P.delete(p)})}addBreakpoints(O){const p=O.filter(A=>{const F=A.id;return this.H.has(F)?!1:(this.H.set(F,A),!0)});this.rb(p,[],[]);const b=[],M=new Map;for(const A of p)if(A instanceof u.$fP){let F=M.get(A.location.uri.toString());F||(F={type:"sourceMulti",uri:A.location.uri,lines:[]},M.set(A.location.uri.toString(),F),b.push(F)),F.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character,mode:A.mode})}else A instanceof u.$gP&&b.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName,mode:A.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(O){const p=O.filter(F=>this.H.delete(F.id));this.rb([],p,[]);const b=p.filter(F=>F instanceof u.$fP).map(F=>F.id),M=p.filter(F=>F instanceof u.$gP).map(F=>F.id),A=p.filter(F=>F instanceof u.$hP).map(F=>F.id);return this.u.$unregisterBreakpoints(b,M,A)}startDebugging(O,p,b){const M=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(O?O.uri:void 0,p,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(O){return this.u.$stopDebugging(O?O.id:void 0)}registerDebugConfigurationProvider(O,p,b){if(!p)return new u.$bO(()=>{});const M=this.f++;return this.g.push({type:O,handle:M,provider:p}),this.u.$registerDebugConfigurationProvider(O,b,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,M),new u.$bO(()=>{this.g=this.g.filter(A=>A.provider!==p),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(O,p,b){if(!b)return new u.$bO(()=>{});if(!this.nb(O,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.kb(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:p,handle:M,factory:b}),this.u.$registerDebugAdapterDescriptorFactory(p,M),new u.$bO(()=>{this.j=this.j.filter(A=>A.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(O,p){if(!p)return new u.$bO(()=>{});const b=this.m++;return this.n.push({type:O,handle:b,factory:p}),new u.$bO(()=>{this.n=this.n.filter(M=>M.factory!==p)})}async $runInTerminal(O,p){return Promise.resolve(void 0)}async $substituteVariables(O,p){let b;const M=await this.tb(O);return M&&(b={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,p)}hb(O,p){if(O.type==="implementation")return new E(O.implementation)}ib(){}async $startDASession(O,p){const b=this,M=await this.sb(p);return this.pb(this.kb(M.type),M).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const F=this.jb(A),G=this.hb(F,M);if(!G)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const x=G;return this.M.set(O,x),this.ob(M).then(j=>(j&&this.N.set(O,j),x.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const J=U,Y={type:"response",seq:0,command:J.command,request_seq:J.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const ae=await this.U.sign(J.arguments.value);Y.body={signature:ae},x.sendResponse(Y)}else throw new Error("no signer")}catch(ae){Y.success=!1,Y.message=ae.message,x.sendResponse(Y)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(U),U=(0,a.$BI)(U,!0),b.u.$acceptDAMessage(O,U)}),x.onError(U=>{j&&j.onError&&j.onError(U),this.u.$acceptDAError(O,U.name,U.message,U.stack)}),x.onExit(U=>{j&&j.onExit&&j.onExit(U??void 0,void 0),this.u.$acceptDAExit(O,U??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),x.startSession()))})}$sendDAMessage(O,p){p=(0,a.$AI)(p,!1);const b=this.N.get(O);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(p),this.M.get(O)?.sendMessage(p)}$stopDASession(O){const p=this.N.get(O);this.N.delete(O),p&&p.onWillStopSession&&p.onWillStopSession();const b=this.M.get(O);return this.M.delete(O),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(O){const p=[],b=[],M=[];if(O.added)for(const A of O.added){const F=A.id;if(F&&!this.H.has(F)){let G;if(A.type==="function")G=new u.$gP(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode);else if(A.type==="data")G=new u.$hP(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage,A.mode);else{const x=P.URI.revive(A.uri);G=new u.$fP(new u.$pO(x,new u.$cO(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage,A.mode)}(0,u.$dP)(G,F),this.H.set(F,G),p.push(G)}}if(O.removed)for(const A of O.removed){const F=this.H.get(A);F&&(this.H.delete(A),b.push(F))}if(O.changed){for(const A of O.changed)if(A.id){const F=this.H.get(A.id);if(F){if(F instanceof u.$gP&&A.type==="function"){const G=F;G.enabled=A.enabled,G.condition=A.condition,G.hitCondition=A.hitCondition,G.logMessage=A.logMessage,G.functionName=A.functionName}else if(F instanceof u.$fP&&A.type==="source"){const G=F;G.enabled=A.enabled,G.condition=A.condition,G.hitCondition=A.hitCondition,G.logMessage=A.logMessage,G.location=new u.$pO(P.URI.revive(A.uri),new u.$cO(A.line,A.character))}M.push(F)}}}this.rb(p,b,M)}async $acceptStackFrameFocus(O){let p;if(O){const b=await this.sb(O.sessionId);O.kind==="thread"?p=new u.$nP(b.api,O.threadId):p=new u.$mP(b.api,O.threadId,O.frameId)}this.J=p,this.L.fire(this.J)}$provideDebugConfigurations(O,p,b){return(0,v.$Ch)(async()=>{const M=this.mb(O);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.tb(p);return M.provideDebugConfigurations(A,b)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(O,p,b,M){return(0,v.$Ch)(async()=>{const A=this.mb(O);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.tb(p);return A.resolveDebugConfiguration(F,b,M)})}$resolveDebugConfigurationWithSubstitutedVariables(O,p,b,M){return(0,v.$Ch)(async()=>{const A=this.mb(O);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.tb(p);return A.resolveDebugConfigurationWithSubstitutedVariables(F,b,M)})}async $provideDebugAdapter(O,p){const b=this.lb(O);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb(p);return this.pb(b,M).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(A)})}async $acceptDebugSessionStarted(O){const p=await this.sb(O);this.y.fire(p.api)}async $acceptDebugSessionTerminated(O){const p=await this.sb(O);p&&(this.z.fire(p.api),this.w.delete(p.id))}async $acceptDebugSessionActiveChanged(O){this.D=O?await this.sb(O):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(O,p){(await this.sb(O))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(O,p){const M={session:(await this.sb(O)).api,event:p.event,body:p.body};this.F.fire(M)}jb(O){if(O instanceof u.$iP)return{type:"executable",command:O.command,args:O.args,options:O.options};if(O instanceof u.$jP)return{type:"server",port:O.port,host:O.host};if(O instanceof u.$kP)return{type:"pipeServer",path:O.path};if(O instanceof u.$lP)return{type:"implementation",implementation:O.implementation};throw new Error("convertToDto unexpected type")}kb(O){const p=this.j.filter(b=>b.type===O);if(p.length>0)return p[0].factory}lb(O){const p=this.j.filter(b=>b.handle===O);if(p.length>0)return p[0].factory}mb(O){const p=this.g.filter(b=>b.handle===O);if(p.length>0)return p[0].provider}nb(O,p){if(O.contributes){const b=O.contributes.debuggers;if(b&&b.length>0){for(const M of b)if(M.label&&M.type&&M.type===p)return!0}}return!1}ob(O){const b=O.configuration.type,M=this.n.filter(A=>A.type===b||A.type==="*").map(A=>(0,v.$Ch)(()=>A.factory.createDebugAdapterTracker(O.api)).then(F=>F,F=>null));return Promise.race([Promise.all(M).then(A=>{const F=(0,o.$Lb)(A);if(F.length>0)return new S(F)}),new Promise(A=>setTimeout(()=>A(void 0),1e3))]).catch(A=>{})}async pb(O,p){const b=p.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new u.$jP(b));if(O){const A=await this.Z.getExtensionRegistry();return(0,v.$Ch)(()=>O.createDebugAdapterDescriptor(p.api,this.qb(p,A))).then(F=>{if(F)return F})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(p,M))}qb(O,p){}rb(O,p,b){(O.length>0||p.length>0||b.length>0)&&this.I.fire(Object.freeze({added:O,removed:p,changed:b}))}async sb(O){if(O)if(typeof O=="string"){const p=this.w.get(O);if(p)return p}else{let p=this.w.get(O.id);if(!p){const b=await this.tb(O.folderUri),M=O.parent?this.w.get(O.parent):void 0;p=new f(this.u,O.id,O.type,O.name,b,O.configuration,M?.api),this.w.set(p.id,p),this.u.$sessionCached(p.id)}return p}throw new Error("cannot find session")}tb(O){if(O){const p=P.URI.revive(O);return this.Y.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}ub(O,p){return`${O}\0${p}`}vb(O,p){if(p){if("title"in p&&"command"in p)return{type:r.DebugVisualizationType.Command};if("treeId"in p)return{type:r.DebugVisualizationType.Tree,id:`${O}\0${p.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(O){const p=this.xb(O);let b,M;return"id"in p?M=i.ThemeIcon.asClassName(p):b=p,{iconPath:b,iconClass:M}}xb(O){if(O instanceof u.$aP)return{id:O.id};const p=typeof O=="object"&&"dark"in O?O.dark:O,b=typeof O=="object"&&"light"in O?O.light:O;return{dark:typeof p=="string"?P.URI.file(p):p,light:typeof b=="string"?P.URI.file(b):b}}};e.$9rc=g,e.$9rc=g=Ke([qe(0,w.$MQ),qe(1,k.$hrc),qe(2,I.$Xrc),qe(3,h.$krc),qe(4,s.$wrc),qe(5,c.$1rc),qe(6,n.$9Q),qe(7,l.$3rc)],g);class f{constructor(O,p,b,M,A,F,G){this.f=O,this.g=p,this.h=b,this.j=M,this.k=A,this.l=F,this.m=G}get api(){const O=this;return this.d??=Object.freeze({id:O.g,type:O.h,get name(){return O.j},set name(p){O.j=p,O.f.$setDebugSessionName(O.g,p)},parentSession:O.m,workspaceFolder:O.k,configuration:O.l,customRequest(p,b){return O.f.$customDebugAdapterRequest(O.g,p,b)},getDebugProtocolBreakpoint(p){return O.f.$getDebugProtocolBreakpoint(O.g,p.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(O){this.j=O}get configuration(){return this.l}}e.$0rc=f;class d{constructor(O){this.value=Object.freeze({append(p){O.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$$rc=d;class S{constructor(O){this.d=O}onWillStartSession(){this.d.forEach(O=>O.onWillStartSession?O.onWillStartSession():void 0)}onWillReceiveMessage(O){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(O):void 0)}onDidSendMessage(O){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(O):void 0)}onWillStopSession(){this.d.forEach(O=>O.onWillStopSession?O.onWillStopSession():void 0)}onError(O){this.d.forEach(p=>p.onError?p.onError(O):void 0)}onExit(O,p){this.d.forEach(b=>b.onExit?b.onExit(O,p):void 0)}}class E extends $.$fwb{constructor(O){super(),this.h=O,O.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(O){this.h.handleMessage(O)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends g{constructor(O,p,b,M,A,F,G,x){super(O,p,b,M,A,F,G,x)}};e.$_rc=y,e.$_rc=y=Ke([qe(0,w.$MQ),qe(1,k.$hrc),qe(2,I.$Xrc),qe(3,h.$krc),qe(4,s.$wrc),qe(5,c.$1rc),qe(6,n.$9Q),qe(7,l.$3rc)],y)}),define(Re[273],Oe([1,0,12,64,2,5,224,11,60,75,26,171,16,65,47,66]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ftc=e.$etc=void 0,v=Ve(v),D=Ve(D);class a{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(T.$fk),o=i.get(u.$MQ).getProxy(L.$_N.MainThreadErrors);v.setUnexpectedErrorHandler(l=>{n.error(l);const g=v.$6(l);o.$onUnexpectedError(g)})}static async installFullHandler(i){const n=i.get(T.$fk),t=i.get(u.$MQ),o=i.get($.$Xrc),l=i.get(r.$7Q),g=t.getProxy(L.$_N.MainThreadExtensionService),f=t.getProxy(L.$_N.MainThreadErrors),d=await o.getExtensionPathIndex(),S=new WeakMap;function E(O,p){if(S.has(O))return S.get(O).stack;let b="",M,A;for(const G of p)b+=`
	at ${G.toString()}`,A=G.getFileName(),!M&&A&&(M=d.findSubstr(P.URI.file(A)));const F=`${O.name||"Error"}: ${O.message||""}${b}`;return S.set(O,{extensionIdentifier:M?.identifier,stack:F}),F}const y=Symbol("prepareStackTrace wrapped");let C=E;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(O){if(O===E||!O||O[y]){C=O||E;return}C=function(p,b){return E(p,b),O.call(Error,p,b)},Object.assign(C,{[y]:!0})}}),v.setUnexpectedErrorHandler(O=>{n.error(O);const p=v.$6(O),b=S.get(O);if(!b?.extensionIdentifier){f.$onUnexpectedError(p);return}g.$onExtensionRuntimeError(b.extensionIdentifier,p);const M=l.onExtensionError(b.extensionIdentifier,O);n.trace("forwarded error to extension?",M,b)})}}e.$etc=a;class h{constructor(i,n,t,o,l){this.a=t,this.b=new R.$ifc(i,null,o),n=h.e(n,this.b);const g=new s.$Ii(...(0,m.$1s)());g.set(I.$3Q,{_serviceBrand:void 0,...n,messagePorts:l}),g.set(u.$MQ,new u.$NQ(this.b)),g.set(k.$erc,new k.$frc(o)),g.set($.$Vrc,t);const f=new w.$Er(g,!0);f.invokeFunction(a.installEarlyHandler),this.d=f.invokeFunction(d=>d.get(T.$fk)),D.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=f.invokeFunction(d=>d.get($.$Xrc)),this.c.initialize(),f.invokeFunction(a.installFullHandler)}async asBrowserUri(i){const n=this.b.getProxy(L.$_N.MainThreadExtensionService);return P.URI.revive(await n.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,n){i.extensions.allExtensions.forEach(o=>{o.extensionLocation=P.URI.revive(n.transformIncomingURIs(o.extensionLocation))}),i.environment.appRoot=P.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(o=>P.URI.revive(n.transformIncomingURIs(o)))),i.environment.extensionTestsLocationURI=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.$ftc=h}),define(Re[135],Oe([1,0,17,40,58]),function(we,e,v,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qsc=e.$psc=e.$msc=void 0,e.$nsc=s,e.$osc=I,e.$rsc=$;function L(r){return"uri"in r&&"ranges"in r&&"preview"in r}function R(r){return r.folderOptions.map(a=>({folder:a.folder,excludes:a.excludes.map(h=>typeof h=="string"?h:h.pattern),includes:a.includes,useGlobalIgnoreFiles:a.useIgnoreFiles.global,useIgnoreFiles:a.useIgnoreFiles.local,useParentIgnoreFiles:a.useIgnoreFiles.parent,followSymlinks:a.followSymlinks,maxResults:r.maxResults,session:r.session}))}class T{constructor(a){this.a=a}provideFileSearchResults(a,h,c){return(async()=>{const n=R(h);return Promise.all(n.map(t=>this.a.provideFileSearchResults({pattern:a},t,c)))})().then(n=>(0,v.$Lb)(n).flat())}}e.$msc=T;function m(r){return r.folderOptions.map(a=>({folder:a.folder,excludes:a.excludes.map(h=>typeof h=="string"?h:h.pattern),includes:a.includes,useGlobalIgnoreFiles:a.useIgnoreFiles.global,useIgnoreFiles:a.useIgnoreFiles.local,useParentIgnoreFiles:a.useIgnoreFiles.parent,followSymlinks:a.followSymlinks,maxResults:r.maxResults,previewOptions:s(r.previewOptions),maxFileSize:r.maxFileSize,encoding:a.encoding,afterContext:r.surroundingContext,beforeContext:r.surroundingContext}))}function s(r){return{matchLines:r?.matchLines??D.$SM.matchLines,charsPerLine:r?.charsPerLine??D.$SM.charsPerLine}}function I(r){if(L(r)){const a=(0,v.$6b)(r.ranges).map((h,c)=>{const n=(0,v.$6b)(r.preview.matches)[c];return{sourceRange:h,previewRange:n}});return new P.$nM(r.uri,a,r.preview.text)}else return new P.$oM(r.uri,r.text,r.lineNumber)}class w{constructor(a){this.a=a}provideTextSearchResults(a,h,c,i){const n=l=>{k(l)&&c.report(I(l))};return(async()=>(0,v.$Lb)(await Promise.all(m(h).map(l=>this.a.provideTextSearchResults(a,l,{report:g=>n(g)},i)))).reduce((l,g)=>({limitHit:l.limitHit||g.limitHit}),{limitHit:!1}))().then(l=>({limitHit:l.limitHit,message:(0,v.$Lb)((0,v.$6b)(l.message))}))}}e.$psc=w;class u{constructor(a){this.a=a}provideAITextSearchResults(a,h,c,i){const n=l=>{k(l)&&c.report(I(l))};return(async()=>(0,v.$Lb)(await Promise.all(m(h).map(l=>this.a.provideAITextSearchResults(a,l,{report:g=>n(g)},i)))).reduce((l,g)=>({limitHit:l.limitHit||g.limitHit}),{limitHit:!1}))().then(l=>({limitHit:l.limitHit,message:(0,v.$Lb)((0,v.$6b)(l.message))}))}}e.$qsc=u;function k(r){if($(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}function $(r){return!!r.preview}}),define(Re[274],Oe([1,0,22,19,42,43,24,69,40,48,4,135]),function(we,e,v,D,P,L,R,T,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ssc=void 0,v=Ve(v),L=Ve(L),R=Ve(R);class u{constructor(a,h,c){this.l=a,this.o=h,this.p=c,this.f=!1,this.g=0,this.h=!1,this.a=a.filePattern,this.b=a.includePattern&&L.$Fk(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.j=new Set,this.k=a.excludePattern&&L.$Fk(a.excludePattern)}cancel(){this.h=!0,this.j.forEach(a=>a.cancel()),this.j=new Set}search(a){const h=this.l.folderQueries||[];return new Promise((c,i)=>{const n=t=>{this.g++,a(t)};if(this.h)return c({limitHit:this.f});this.l.extraFileResources&&this.l.extraFileResources.forEach(t=>{const o=t.toString(),l=v.$sc(o);this.k&&this.k(o,l)||this.w(n,{base:t,basename:l})}),this.q(h,n).then(t=>{c({limitHit:this.f,stats:t||void 0})},t=>{i(new Error((0,P.$vj)(t)))})})}async q(a,h){const c=new D.$Be,i=a.map(g=>this.r(g)),n=this.o instanceof w.$msc?this.p?.tokenSource.token:this.p?.obj,t={folderOptions:i,maxResults:this.l.maxResults??m.$uM,session:n},o=s.$Qi.forUris();a.forEach(g=>{const f=new m.$OM(this.l,g),d=!f.hasSiblingExcludeClauses();o.set(g.folder,{queryTester:f,noSiblingsClauses:d,folder:g.folder,tree:this.s()})});let l;try{this.j.add(c),l=T.$ke.create();const g=await this.o.provideFileSearchResults(this.l.filePattern||"",t,c.token),f=l.elapsed(),d=T.$ke.create();return this.h&&!this.f||(g&&g.forEach(S=>{const E=o.findSubstr(S),y=v.$lc.relative(E.folder.path,S.path);if(E.noSiblingsClauses){const C=v.$sc(S.path);this.w(h,{base:E.folder,relativePath:y,basename:C});return}this.u(E.tree,E.folder,y,h)}),this.h&&!this.f)?null:(o.forEach(S=>{this.v(S.tree,S.queryTester,h)}),{providerTime:f,postProcessTime:d.elapsed()})}finally{c.dispose(),this.j.delete(c)}}r(a){const h=(0,m.$NM)(this.l.includePattern,a.includePattern);let c=a.excludePattern?.map(n=>({folder:n.folder,patterns:(0,m.$NM)(this.l.excludePattern,n.pattern)}));c?.length||(c=[{folder:void 0,patterns:(0,m.$NM)(this.l.excludePattern,void 0)}]);const i=(0,m.$RM)(c);return{folder:a.folder,excludes:i,includes:h,useIgnoreFiles:{local:!a.disregardIgnoreFiles,parent:!a.disregardParentIgnoreFiles,global:!a.disregardGlobalIgnoreFiles},followSymlinks:!a.ignoreSymlinks}}s(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}u({pathToEntries:a},h,c,i){if(c===this.a){const t=v.$sc(this.a);this.w(i,{base:h,relativePath:this.a,basename:t})}function n(t){const o=v.$sc(t),l=v.$rc(t);let g=a[l];g||(g=a[l]=[],n(l)),g.push({base:h,relativePath:t,basename:o})}n(c)}v({rootEntries:a,pathToEntries:h},c,i){const n=this,t=this.a;function o(l){const g=(0,m.$QM)(()=>l.map(f=>f.basename));for(let f=0,d=l.length;f<d;f++){const S=l[f],{relativePath:E,basename:y}=S;if(c.matchesExcludesSync(E,y,t!==y?g:void 0))continue;const C=h[E];if(C)o(C);else{if(E===t)continue;n.w(i,S)}if(n.f)break}}o(a)}w(a,h){(!this.b||h.relativePath&&this.b(h.relativePath,h.basename))&&((this.d||this.c&&this.g>=this.c)&&(this.f=!0,this.cancel()),this.f||a(h))}}class k extends I.$Zc{constructor(){super(),this.obj=new Object,this.tokenSource=new D.$Be}dispose(){this.tokenSource.cancel(),super.dispose()}}class ${constructor(){this.b=new Map}static{this.a=512}fileSearch(a,h,c,i){const n=this.c(a.cacheKey),t=new u(a,h,n);let o=0;const l=g=>{o+=g.length,c(g.map(f=>this.d(f)))};return this.f(t,$.a,l,i).then(g=>({limitHit:g.limitHit,stats:g.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:o,detailStats:g.stats}:void 0,messages:[]}))}clearCache(a){this.b.get(a)?.dispose(),this.b.delete(a)}c(a){if(a)return this.b.has(a)||this.b.set(a,new k),this.b.get(a)}d(a){return a.relativePath?{resource:R.$lh(a.base,a.relativePath)}:{resource:a.base}}f(a,h,c,i){const n=i.onCancellationRequested(()=>{a.cancel()}),t=l=>{l&&(o.push(l),h>0&&o.length>=h&&(c(o),o=[]))};let o=[];return a.search(t).then(l=>(o.length&&c(o),n.dispose(),l),l=>(o.length&&c(o),n.dispose(),Promise.reject(l)))}}e.$ssc=$}),define(Re[275],Oe([1,0,10,19,42,15,22,24,48,2,40,58]),function(we,e,v,D,P,L,R,T,m,s,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vsc=e.$usc=e.$tsc=void 0,R=Ve(R),T=Ve(T);class u{constructor(c,i,n){this.f=c,this.g=i,this.h=n,this.b=null,this.c=!1,this.d=0}get j(){return this.f.query}search(c,i){const n=this.j.folderQueries||[],t=new D.$Be(i);return new Promise((o,l)=>{this.b=new $(c);let g=!1;const f=(d,S)=>{if(!g&&!this.c){const E=this.l(d);d instanceof w.$nM&&typeof this.j.maxResults=="number"&&this.d+E>this.j.maxResults&&(this.c=!0,g=!0,t.cancel(),d=this.m(d,this.j.maxResults-this.d));const y=this.l(d);this.d+=y;const C=d instanceof w.$nM;(y>0||!C)&&this.b.add(d,S)}};this.n(n,f,t.token).then(d=>{t.dispose(),this.b.flush(),o({limitHit:this.c||d?.limitHit,messages:this.k(d),stats:{type:this.h}})},d=>{t.dispose();const S=(0,P.$vj)(d);l(new Error(S))})})}k(c){return c?.message?Array.isArray(c.message)?c.message:[c.message]:[]}l(c){return c instanceof w.$nM?Array.isArray(c.ranges)?c.ranges.length:1:0}m(c,i){return new w.$nM(c.uri,c.ranges.slice(0,i),c.previewText)}async n(c,i,n){const t=m.$Qi.forUris();c.forEach((S,E)=>{const y=new I.$OM(this.j,S);t.set(S.folder,{queryTester:y,folder:S.folder,folderIdx:E})});const o=[],l={report:S=>{if(S.uri===void 0)throw Error("Text search result URI is undefined. Please check provider implementation.");const E=t.findSubstr(S.uri),y=E.folder.scheme===L.Schemas.file?(0,I.$PM)(()=>this.g.readdir(T.$kh(S.uri))):void 0,C=T.$nh(E.folder,S.uri);if(C){const O=E.queryTester.includedInQuery(C,R.$sc(C),y);(0,v.$wh)(O)?o.push(O.then(p=>{p&&i(S,E.folderIdx)})):O&&i(S,E.folderIdx)}}},f={folderOptions:c.map(S=>this.o(S)),maxFileSize:this.j.maxFileSize,maxResults:this.j.maxResults??I.$uM,previewOptions:this.j.previewOptions??I.$SM,surroundingContext:this.j.surroundingContext??0};"usePCRE2"in this.j&&(f.usePCRE2=this.j.usePCRE2);let d;return this.f.query.type===I.QueryType.aiText?d=await this.f.provider.provideAITextSearchResults(this.f.query.contentPattern,f,l,n):d=await this.f.provider.provideTextSearchResults(k(this.f.query.contentPattern),f,l,n),o.length&&await Promise.all(o),d}o(c){const i=(0,I.$NM)(this.j.includePattern,c.includePattern);let n=c.excludePattern?.map(l=>({folder:l.folder,patterns:(0,I.$NM)(this.j.excludePattern,l.pattern)}));(!n||n.length===0)&&(n=[{folder:void 0,patterns:(0,I.$NM)(this.j.excludePattern,void 0)}]);const t=(0,I.$RM)(n);return{folder:s.URI.from(c.folder),excludes:t,includes:i,useIgnoreFiles:{local:!c.disregardIgnoreFiles,parent:!c.disregardParentIgnoreFiles,global:!c.disregardGlobalIgnoreFiles},followSymlinks:!c.ignoreSymlinks,encoding:(c.fileEncoding&&this.g.toCanonicalName(c.fileEncoding))??""}}}e.$tsc=u;function k(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class ${constructor(c){this.g=c,this.c=-1,this.f=null,this.b=new a(512,i=>this.j(i))}add(c,i){this.f&&(this.c!==i||!T.$eh(this.d,c.uri))&&(this.h(),this.f=null),this.f||(this.c=i,this.f={resource:c.uri,results:[]}),this.f.results.push(r(c))}h(){const c=this.f&&this.f.results?this.f.results.length:0;this.b.addItem(this.f,c)}flush(){this.h(),this.b.flush()}j(c){this.g(c)}}e.$usc=$;function r(h){return h instanceof w.$nM?{previewText:h.previewText,rangeLocations:h.ranges.map(c=>({preview:{startLineNumber:c.previewRange.start.line,startColumn:c.previewRange.start.character,endLineNumber:c.previewRange.end.line,endColumn:c.previewRange.end.character},source:{startLineNumber:c.sourceRange.start.line,startColumn:c.sourceRange.start.character,endLineNumber:c.sourceRange.end.line,endColumn:c.sourceRange.end.character}}))}:{text:h.text,lineNumber:h.lineNumber}}class a{static{this.b=4e3}static{this.c=50}constructor(c,i){this.j=c,this.k=i,this.d=0,this.f=[],this.g=0}addItem(c,i){c&&this.l(c,i)}addItems(c,i){c&&this.m(c,i)}l(c,i){this.f.push(c),this.g+=i,this.n()}m(c,i){this.f=this.f.concat(c),this.g+=i,this.n()}n(){this.d<a.c?this.flush():this.g>=this.j?this.flush():this.h||(this.h=setTimeout(()=>{this.flush()},a.b))}flush(){this.g&&(this.d+=this.g,this.k(this.f),this.f=[],this.g=0,this.h&&(clearTimeout(this.h),this.h=0))}}e.$vsc=a}),define(Re[136],Oe([1,0,4,5,3,274,16,65,11,2,275,34,135]),function(we,e,v,D,P,L,R,T,m,s,I,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xsc=e.$wsc=void 0,e.$ysc=$,e.$wsc=(0,P.$Ki)("IExtHostSearch");let k=class{constructor(h,c,i){this.n=h,this.o=c,this.q=i,this.c=this.n.getProxy(D.$_N.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new L.$ssc}s(h){return this.o.transformOutgoingScheme(h)}registerTextSearchProviderOld(h,c){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const i=this.d++;return this.e.set(i,new u.$psc(c)),this.c.$registerTextSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.g.delete(h),this.e.delete(i),this.c.$unregisterProvider(i)})}registerTextSearchProvider(h,c){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const i=this.d++;return this.e.set(i,c),this.c.$registerTextSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.g.delete(h),this.e.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProviderOld(h,c){if(this.i.has(h))throw new Error(`an AI text search provider for the scheme '${h}'is already registered`);this.i.add(h);const i=this.d++;return this.h.set(i,new u.$qsc(c)),this.c.$registerAITextSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.i.delete(h),this.h.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProvider(h,c){if(this.i.has(h))throw new Error(`an AI text search provider for the scheme '${h}'is already registered`);this.i.add(h);const i=this.d++;return this.h.set(i,c),this.c.$registerAITextSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.i.delete(h),this.h.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProviderOld(h,c){if(this.k.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.k.add(h);const i=this.d++;return this.j.set(i,new u.$msc(c)),this.c.$registerFileSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.k.delete(h),this.j.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(h,c){if(this.k.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.k.add(h);const i=this.d++;return this.j.set(i,c),this.c.$registerFileSearchProvider(i,this.s(h)),(0,v.$Xc)(()=>{this.k.delete(h),this.j.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(h,c,i,n){const t=$(i),o=this.j.get(h);if(o)return this.l.fileSearch(t,o,l=>{this.c.$handleFileMatch(h,c,l.map(g=>g.resource))},n);throw new Error("unknown provider: "+h)}async doInternalFileSearchWithCustomCallback(h,c,i){return{messages:[]}}$clearCache(h){return this.l.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,c,i,n){const t=this.e.get(h);if(!t||!t.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${h}`);const o=$(i);return this.t(o,t).search(g=>this.c.$handleTextMatch(h,c,g),n)}$provideAITextSearchResults(h,c,i,n){const t=this.h.get(h);if(!t||!t.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${h}`);const o=$(i);return this.v(o,t).search(g=>this.c.$handleTextMatch(h,c,g),n)}$enableExtensionHostSearch(){}t(h,c){return new I.$tsc({query:h,provider:c},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}v(h,c){return new I.$tsc({query:h,provider:c},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"aiTextSearchProvider")}};e.$xsc=k,e.$xsc=k=Ke([qe(0,R.$MQ),qe(1,T.$erc),qe(2,m.$fk)],k);function $(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(r),extraFileResources:a.extraFileResources&&a.extraFileResources.map(h=>s.URI.revive(h))}}function r(a){return(0,w.$hi)(a)}});var oi=this&&this.__importDefault||function(we){return we&&we.__esModule?we:{default:we}};define(Re[276],Oe([1,0,19,12,6,4,15,37,2,106,164,153,52,18,28,11,62,63,185,5,227,256,85,91,232,233,234,211,201,35,235,46,236,134,124,237,213,228,238,239,57,70,214,229,47,241,68,242,50,26,257,215,243,244,95,245,86,87,217,269,247,190,248,258,249,130,218,250,251,252,16,253,136,88,254,219,255,89,92,132,66,56,128,96,259,230,260,261,93,8,7,220,65,221,67,262,263,123,45,81,84,21,58]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d,S,E,y,C,O,p,b,M,A,F,G,x,j,U,J,Y,ae,ee,oe,ie,ue,_,$e,Ie,X,V,re,be,Pe,Fe,Be,xe,nt,ht,$t,ut,et,Le,Ne,Me,W,B,Q,K,se,ge,Ee,ze,Je,_e,tt,ct,it,at,yt,Ze,he,pe,ye,Ce,fe,ve,Z,q,de,je,Qe,st,dt,mt,Ot,Tt,Qt,_t,Xe,At){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_sc=Ut,D=Ve(D),T=oi(T),w=Ve(w),$=Ve($),Z=Ve(Z),q=Ve(q);function Ut(wt){const Dt=wt.get($e.$3Q),ei=wt.get(_.$2qc),ti=wt.get(ie.$mrc),Kt=wt.get(ee.$Xrc),bt=wt.get(Tt.$hrc),Lt=wt.get(at.$7Q),ci=wt.get(O.$krc),Zt=wt.get(je.$erc),Ge=wt.get(K.$MQ),ii=wt.get(tt.$Frc),li=wt.get(ct.$nrc),hi=wt.get(r.$gk),kt=wt.get(r.$fk),jt=wt.get(ve.$_Gb),Mt=wt.get(o.$Xqc),Bt=wt.get(Ot.$$sc),ai=wt.get(Ee.$Prc),ni=wt.get(J.$wrc),ri=wt.get(Be.$Trc),Gt=wt.get(l.$8qc),Jt=wt.get(be.$Mrc);Ge.set(i.$aO.ExtHostFileSystemInfo,ei),Ge.set(i.$aO.ExtHostLogLevelServiceShape,hi),Ge.set(i.$aO.ExtHostWorkspace,bt),Ge.set(i.$aO.ExtHostConfiguration,ci),Ge.set(i.$aO.ExtHostExtensionService,Kt),Ge.set(i.$aO.ExtHostStorage,ii),Ge.set(i.$aO.ExtHostTunnelService,jt),Ge.set(i.$aO.ExtHostWindow,Bt),Ge.set(i.$aO.ExtHostSecretState,ai),Ge.set(i.$aO.ExtHostTelemetry,Lt),Ge.set(i.$aO.ExtHostEditorTabs,ni),Ge.set(i.$aO.ExtHostManagedSockets,ri),Ge.set(i.$aO.ExtHostAuthentication,Gt),Ge.set(i.$aO.ExtHostChatProvider,Jt);const ui=Ge.set(i.$aO.ExtHostDecorations,wt.get(M.$bsc)),Nt=Ge.set(i.$aO.ExtHostDocumentsAndEditors,wt.get(U.$XQ)),Ct=Ge.set(i.$aO.ExtHostCommands,wt.get(y.$9Q)),vt=Ge.set(i.$aO.ExtHostTerminalService,wt.get(yt.$Irc)),Xt=Ge.set(i.$aO.ExtHostTerminalShellIntegration,wt.get(Ze.$1sc)),Et=Ge.set(i.$aO.ExtHostDebugService,wt.get(b.$8rc)),si=Ge.set(i.$aO.ExtHostSearch,wt.get(ge.$wsc)),Yt=Ge.set(i.$aO.ExtHostTask,wt.get(it.$Zsc)),Ni=Ge.set(i.$aO.ExtHostOutputService,wt.get(Ne.$Msc)),di=Ge.set(i.$aO.ExtHostLocalization,wt.get(Fe.$Src)),yi=Ge.set(i.$aO.ExtHostUrls,new Qe.$8sc(Ge)),qt=Ge.set(i.$aO.ExtHostDocuments,new j.$5qc(Ge,Nt)),fi=Ge.set(i.$aO.ExtHostDocumentContentProviders,new G.$dsc(Ge,Nt,kt)),Fi=Ge.set(i.$aO.ExtHostDocumentSaveParticipant,new x.$esc(kt,qt,Ge.getProxy(i.$_N.MainThreadBulkEdits))),Rt=Ge.set(i.$aO.ExtHostNotebook,new nt.$zsc(Ge,Ct,Nt,qt,ti,si,kt)),Si=Ge.set(i.$aO.ExtHostNotebookDocuments,new $t.$Gsc(Rt)),Ai=Ge.set(i.$aO.ExtHostNotebookEditors,new ut.$Hsc(kt,Rt)),gi=Ge.set(i.$aO.ExtHostNotebookKernels,new et.$Isc(Ge,Dt,Rt,Ct,kt)),zi=Ge.set(i.$aO.ExtHostNotebookRenderers,new Le.$Ksc(Ge,Rt)),ji=Ge.set(i.$aO.ExtHostNotebookDocumentSaveParticipant,new ht.$Fsc(kt,Rt,Ge.getProxy(i.$_N.MainThreadBulkEdits))),zt=Ge.set(i.$aO.ExtHostEditors,new pe.$brc(Ge,Nt)),Pi=Ge.set(i.$aO.ExtHostTreeViews,new fe.$6sc(Ge.getProxy(i.$_N.MainThreadTreeViews),Ct,kt)),Di=Ge.set(i.$aO.ExtHostEditorInsets,new E.$crc(Ge.getProxy(i.$_N.MainThreadEditorInsets),zt,Dt.remote)),wi=Ge.set(i.$aO.ExtHostDiagnostics,new A.$4qc(Ge,kt,ei,Nt)),bi=Ge.set(i.$aO.ExtHostLanguages,new Pe.$Dsc(Ge,qt,Ct.converter,Zt)),me=Ge.set(i.$aO.ExtHostLanguageFeatures,new V.$6qc(Ge,Zt,qt,Ct,wi,kt,Mt,Lt)),De=Ge.set(i.$aO.ExtHostFileSystem,new oe.$hsc(Ge,me)),ce=Ge.set(i.$aO.ExtHostFileSystemEventService,new ue.$isc(Ge,kt,Nt)),H=Ge.set(i.$aO.ExtHostQuickOpen,(0,Q.$Qsc)(Ge,bt,Ct)),ke=Ge.set(i.$aO.ExtHostSCM,new se.$Ssc(Ge,Ct,qt,kt)),We=Ge.set(i.$aO.ExtHostQuickDiff,new B.$Psc(Ge,Zt)),Ye=Ge.set(i.$aO.ExtHostShare,new ze.$Tsc(Ge,Zt)),Ue=Ge.set(i.$aO.ExtHostComments,(0,C.$drc)(Ge,Ct,qt)),ot=Ge.set(i.$aO.ExtHostProgress,new W.$Osc(Ge.getProxy(i.$_N.MainThreadProgress))),gt=Ge.set(i.$aO.ExtHostLabelService,new X.$Bsc(Ge)),Ht=Ge.set(i.$aO.ExtHostTheming,new ye.$3sc(Ge)),Vt=Ge.set(i.$aO.ExtHostTimeline,new Ce.$5sc(Ge,Ct)),Wt=Ge.set(i.$aO.ExtHostWebviews,new st.$rrc(Ge,Dt.remote,bt,kt,Mt)),Li=Ge.set(i.$aO.ExtHostWebviewPanels,new dt.$urc(Ge,Wt,bt)),en=Ge.set(i.$aO.ExtHostCustomEditors,new p.$vrc(Ge,qt,li,Wt,Li)),Vi=Ge.set(i.$aO.ExtHostWebviewViews,new mt.$9sc(Ge,Wt)),Ei=Ge.set(i.$aO.ExtHostTesting,wt.get(he.$3rc)),tn=Ge.set(i.$aO.ExtHostUriOpeners,new de.$7sc(Ge)),nn=Ge.set(i.$aO.ExtHostProfileContentHandlers,new Me.$Nsc(Ge));Ge.set(i.$aO.ExtHostInteractive,new Ie.$Asc(Ge,Rt,Nt,Ct,kt));const Ui=Ge.set(i.$aO.ExtHostChatAgents2,new f.$$qc(Ge,kt,Ct,qt)),rn=Ge.set(i.$aO.ExtHostChatVariables,new d.$_qc(Ge)),Bi=Ge.set(i.$aO.ExtHostLanguageModelTools,new re.$Csc(Ge)),Qi=Ge.set(i.$aO.ExtHostAiRelatedInformation,new n.$Wqc(Ge)),sn=Ge.set(i.$aO.ExtHostAiEmbeddingVector,new ae.$gsc(Ge)),on=Ge.set(i.$aO.ExtHostStatusBar,new _e.$Wsc(Ge,Ct.converter)),wn=Ge.set(i.$aO.ExtHostSpeech,new Je.$Usc(Ge)),Ci=Ge.set(i.$aO.ExtHostEmbeddings,new Y.$fsc(Ge)),Hi=Object.values(i.$aO);Ge.assertRegistered(Hi);const bn=new g.$0qc(Ge,Nt),vn=new S.$arc(Ge),Wi=new xe.$Esc(Ge,kt),an=new F.$csc(Ge);return t.$7qc.register(Ct),function(Ae,mi,Ki){function lt(te){return(le,Te,ft)=>{const Pt=te(Ft=>{try{le.call(Te,Ft)}catch(Oi){D.$5(new Error(`[ExtensionListenerError] Extension '${Ae.identifier.value}' FAILED to handle event: ${Oi.toString()}`,{cause:Oi})),Lt.onExtensionError(Ae.identifier,Oi)}});return ft?.push(Pt),Pt}}const It=function(){let te=!Ae.isUnderDevelopment;function le(){te||(kt.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(ft){if(Array.isArray(ft))ft.forEach(Te);else if(typeof ft=="string")le();else{const Pt=ft;typeof Pt.scheme>"u"&&le(),typeof Pt.exclusive=="boolean"&&(0,Xe.$BH)(Ae,"documentFiltersExclusive")}return ft}}(),yn={getSession(te,le,Te){return typeof Te?.forceNewSession=="object"&&Te.forceNewSession.learnMore&&(0,Xe.$BH)(Ae,"authLearnMore"),Gt.getSession(Ae,te,le,Te)},getAccounts(te){return Gt.getAccounts(te)},async hasSession(te,le){return(0,Xe.$BH)(Ae,"authSession"),!!await Gt.getSession(Ae,te,le,{silent:!0})},get onDidChangeSessions(){return lt(Gt.onDidChangeSessions)},registerAuthenticationProvider(te,le,Te,ft){return Gt.registerAuthenticationProvider(te,le,Te,ft)}},Gi={registerCommand(te,le,Te){return Ct.registerCommand(!0,te,le,Te,void 0,Ae)},registerTextEditorCommand(te,le,Te){return Ct.registerCommand(!0,te,(...ft)=>{const Pt=zt.getActiveTextEditor();if(!Pt){kt.warn("Cannot execute "+te+" because there is no active text editor.");return}return Pt.edit(Ft=>{le.apply(Te,[Pt,Ft,...ft])}).then(Ft=>{Ft||kt.warn("Edits from command "+te+" were not applied.")},Ft=>{kt.warn("An error occurred while running command "+te,Ft)})},void 0,void 0,Ae)},registerDiffInformationCommand:(te,le,Te)=>((0,Xe.$BH)(Ae,"diffCommand"),Ct.registerCommand(!0,te,async(...ft)=>{const Pt=Nt.activeEditor(!0);if(!Pt){kt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ft=await zt.getDiffInformation(Pt.id);le.apply(Te,[Ft,...ft])},void 0,void 0,Ae)),executeCommand(te,...le){return Ct.executeCommand(te,...le)},getCommands(te=!1){return Ct.getCommands(te)}},Ji={get machineId(){return Dt.telemetryInfo.machineId},get sessionId(){return Dt.telemetryInfo.sessionId},get language(){return Dt.environment.appLanguage},get appName(){return Dt.environment.appName},get appRoot(){return Dt.environment.appRoot?.fsPath??""},get appHost(){return Dt.environment.appHost},get uriScheme(){return Dt.environment.appUriScheme},get clipboard(){return vn.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return lt(vt.onDidChangeShell)},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return lt(Lt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$BH)(Ae,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$BH)(Ae,"telemetry"),lt(Lt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.$6Q)(Dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,le){return at.$5Q.validateSender(te),Lt.instantiateLogger(Ae,te,le)},openExternal(te,le){return Bt.openUri(te,{allowTunneling:!!Dt.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Dt.environment.appUriScheme)return yi.createAppUri(te);try{return await Bt.asExternalUri(te,{allowTunneling:!!Dt.remote.authority})}catch(le){if((0,R.$Tg)(te,R.Schemas.http)||(0,R.$Tg)(te,R.Schemas.https))return te;throw le}},get remoteName(){return(0,a.$on)(Dt.remote.authority)},get remoteAuthority(){return(0,Xe.$BH)(Ae,"resolvers"),Dt.remote.authority},get uiKind(){return Dt.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return lt(kt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$BH)(Ae,"resolvers"),Dt.quality},get appCommit(){return(0,Xe.$BH)(Ae,"resolvers"),Dt.commit}};Dt.environment.extensionTestsLocationURI||Object.freeze(Ji);const ki={createTestController(te,le,Te){return Ei.createTestController(Ae,te,le,Te)},createTestObserver(){return(0,Xe.$BH)(Ae,"testObserver"),Ei.createTestObserver()},runTests(te){return(0,Xe.$BH)(Ae,"testObserver"),Ei.runTests(te)},registerTestFollowupProvider(te){return(0,Xe.$BH)(Ae,"testObserver"),Ei.registerTestFollowupProvider(te)},get onDidChangeTestResults(){return(0,Xe.$BH)(Ae,"testObserver"),lt(Ei.onResultsChanged)},get testResults(){return(0,Xe.$BH)(Ae,"testObserver"),Ei.results}},Ri=Dt.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,Sn={getExtension(te,le){(0,Xe.$AH)(Ae,"extensionsAny")||(le=!1);const Te=mi.mine.getExtensionDescription(te);if(Te)return new ee.$Yrc(Kt,Ae.identifier,Te,Ri,!1);if(le){const ft=mi.all.getExtensionDescription(te);if(ft)return new ee.$Yrc(Kt,Ae.identifier,ft,Ri,!0)}},get all(){const te=[];for(const le of mi.mine.getAllExtensionDescriptions())te.push(new ee.$Yrc(Kt,Ae.identifier,le,Ri,!1));return te},get allAcrossExtensionHosts(){(0,Xe.$BH)(Ae,"extensionsAny");const te=new k.$yn(mi.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),le=[];for(const Te of mi.all.getAllExtensionDescriptions()){const ft=!te.has(Te.identifier);le.push(new ee.$Yrc(Kt,Ae.identifier,Te,Ri,ft))}return le},get onDidChange(){return(0,Xe.$AH)(Ae,"extensionsAny")?lt(P.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):lt(mi.mine.onDidChange)}},pi={createDiagnosticCollection(te){return wi.createDiagnosticCollection(Ae.identifier,te)},get onDidChangeDiagnostics(){return lt(wi.onDidChangeDiagnostics)},getDiagnostics:te=>wi.getDiagnostics(te),getLanguages(){return bi.getLanguages()},setTextDocumentLanguage(te,le){return bi.changeLanguage(te.uri,le)},match(te,le){const Te=Z.LanguageSelector.from(te);let ft;return(0,I.$Fu)(Te)&&(ft=Rt.notebookDocuments.find(Pt=>Pt.apiNotebook.getCells().find(Ft=>Ft.document===le))?.apiNotebook),(0,I.$Eu)(Te,le.uri,le.languageId,!0,ft?.uri,ft?.notebookType)},registerCodeActionsProvider(te,le,Te){return me.registerCodeActionProvider(Ae,It(te),le,Te)},registerDocumentPasteEditProvider(te,le,Te){return(0,Xe.$BH)(Ae,"documentPaste"),me.registerDocumentPasteEditProvider(Ae,It(te),le,Te)},registerCodeLensProvider(te,le){return me.registerCodeLensProvider(Ae,It(te),le)},registerDefinitionProvider(te,le){return me.registerDefinitionProvider(Ae,It(te),le)},registerDeclarationProvider(te,le){return me.registerDeclarationProvider(Ae,It(te),le)},registerImplementationProvider(te,le){return me.registerImplementationProvider(Ae,It(te),le)},registerTypeDefinitionProvider(te,le){return me.registerTypeDefinitionProvider(Ae,It(te),le)},registerHoverProvider(te,le){return me.registerHoverProvider(Ae,It(te),le,Ae.identifier)},registerEvaluatableExpressionProvider(te,le){return me.registerEvaluatableExpressionProvider(Ae,It(te),le,Ae.identifier)},registerInlineValuesProvider(te,le){return me.registerInlineValuesProvider(Ae,It(te),le,Ae.identifier)},registerDocumentHighlightProvider(te,le){return me.registerDocumentHighlightProvider(Ae,It(te),le)},registerMultiDocumentHighlightProvider(te,le){return me.registerMultiDocumentHighlightProvider(Ae,It(te),le)},registerLinkedEditingRangeProvider(te,le){return me.registerLinkedEditingRangeProvider(Ae,It(te),le)},registerReferenceProvider(te,le){return me.registerReferenceProvider(Ae,It(te),le)},registerRenameProvider(te,le){return me.registerRenameProvider(Ae,It(te),le)},registerNewSymbolNamesProvider(te,le){return(0,Xe.$BH)(Ae,"newSymbolNamesProvider"),me.registerNewSymbolNamesProvider(Ae,It(te),le)},registerDocumentSymbolProvider(te,le,Te){return me.registerDocumentSymbolProvider(Ae,It(te),le,Te)},registerWorkspaceSymbolProvider(te){return me.registerWorkspaceSymbolProvider(Ae,te)},registerDocumentFormattingEditProvider(te,le){return me.registerDocumentFormattingEditProvider(Ae,It(te),le)},registerDocumentRangeFormattingEditProvider(te,le){return me.registerDocumentRangeFormattingEditProvider(Ae,It(te),le)},registerOnTypeFormattingEditProvider(te,le,Te,...ft){return me.registerOnTypeFormattingEditProvider(Ae,It(te),le,[Te].concat(ft))},registerDocumentSemanticTokensProvider(te,le,Te){return me.registerDocumentSemanticTokensProvider(Ae,It(te),le,Te)},registerDocumentRangeSemanticTokensProvider(te,le,Te){return me.registerDocumentRangeSemanticTokensProvider(Ae,It(te),le,Te)},registerSignatureHelpProvider(te,le,Te,...ft){return typeof Te=="object"?me.registerSignatureHelpProvider(Ae,It(te),le,Te):me.registerSignatureHelpProvider(Ae,It(te),le,typeof Te>"u"?[]:[Te,...ft])},registerCompletionItemProvider(te,le,...Te){return me.registerCompletionItemProvider(Ae,It(te),le,Te)},registerInlineCompletionItemProvider(te,le,Te){return le.handleDidShowCompletionItem&&(0,Xe.$BH)(Ae,"inlineCompletionsAdditions"),le.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$BH)(Ae,"inlineCompletionsAdditions"),Te&&(0,Xe.$BH)(Ae,"inlineCompletionsAdditions"),me.registerInlineCompletionsProvider(Ae,It(te),le,Te)},registerInlineEditProvider(te,le){return(0,Xe.$BH)(Ae,"inlineEdit"),me.registerInlineEditProvider(Ae,It(te),le)},registerDocumentLinkProvider(te,le){return me.registerDocumentLinkProvider(Ae,It(te),le)},registerColorProvider(te,le){return me.registerColorProvider(Ae,It(te),le)},registerFoldingRangeProvider(te,le){return me.registerFoldingRangeProvider(Ae,It(te),le)},registerSelectionRangeProvider(te,le){return me.registerSelectionRangeProvider(Ae,te,le)},registerCallHierarchyProvider(te,le){return me.registerCallHierarchyProvider(Ae,te,le)},registerTypeHierarchyProvider(te,le){return me.registerTypeHierarchyProvider(Ae,te,le)},setLanguageConfiguration:(te,le)=>me.setLanguageConfiguration(Ae,te,le),getTokenInformationAtPosition(te,le){return(0,Xe.$BH)(Ae,"tokenInformation"),bi.tokenAtPosition(te,le)},registerInlayHintsProvider(te,le){return me.registerInlayHintsProvider(Ae,te,le)},createLanguageStatusItem(te,le){return bi.createLanguageStatusItem(Ae,te,le)},registerDocumentDropEditProvider(te,le,Te){return me.registerDocumentOnDropEditProvider(Ae,te,le,(0,Xe.$AH)(Ae,"documentPaste")?Te:void 0)}},qi={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(te,le,Te){m.URI.isUri(te)&&te.scheme===R.Schemas.vscodeRemote&&!te.authority&&Mt.report("workspace.showTextDocument",Ae,"A URI of 'vscode-remote' scheme requires an authority.");const ft=await(m.URI.isUri(te)?Promise.resolve(Xi.openTextDocument(te)):Promise.resolve(te));return zt.showTextDocument(ft,le,Te)},createTextEditorDecorationType(te){return zt.createTextEditorDecorationType(Ae,te)},onDidChangeActiveTextEditor(te,le,Te){return lt(zt.onDidChangeActiveTextEditor)(te,le,Te)},onDidChangeVisibleTextEditors(te,le,Te){return lt(zt.onDidChangeVisibleTextEditors)(te,le,Te)},onDidChangeTextEditorSelection(te,le,Te){return lt(zt.onDidChangeTextEditorSelection)(te,le,Te)},onDidChangeTextEditorOptions(te,le,Te){return lt(zt.onDidChangeTextEditorOptions)(te,le,Te)},onDidChangeTextEditorVisibleRanges(te,le,Te){return lt(zt.onDidChangeTextEditorVisibleRanges)(te,le,Te)},onDidChangeTextEditorViewColumn(te,le,Te){return lt(zt.onDidChangeTextEditorViewColumn)(te,le,Te)},onDidCloseTerminal(te,le,Te){return lt(vt.onDidCloseTerminal)(te,le,Te)},onDidOpenTerminal(te,le,Te){return lt(vt.onDidOpenTerminal)(te,le,Te)},onDidChangeActiveTerminal(te,le,Te){return lt(vt.onDidChangeActiveTerminal)(te,le,Te)},onDidChangeTerminalDimensions(te,le,Te){return(0,Xe.$BH)(Ae,"terminalDimensions"),lt(vt.onDidChangeTerminalDimensions)(te,le,Te)},onDidChangeTerminalState(te,le,Te){return lt(vt.onDidChangeTerminalState)(te,le,Te)},onDidWriteTerminalData(te,le,Te){return(0,Xe.$BH)(Ae,"terminalDataWriteEvent"),lt(vt.onDidWriteTerminalData)(te,le,Te)},onDidExecuteTerminalCommand(te,le,Te){return(0,Xe.$BH)(Ae,"terminalExecuteCommandEvent"),lt(vt.onDidExecuteTerminalCommand)(te,le,Te)},onDidChangeTerminalShellIntegration(te,le,Te){return lt(Xt.onDidChangeTerminalShellIntegration)(te,le,Te)},onDidStartTerminalShellExecution(te,le,Te){return lt(Xt.onDidStartTerminalShellExecution)(te,le,Te)},onDidEndTerminalShellExecution(te,le,Te){return lt(Xt.onDidEndTerminalShellExecution)(te,le,Te)},get state(){return Bt.getState()},onDidChangeWindowState(te,le,Te){return lt(Bt.onDidChangeWindowState)(te,le,Te)},showInformationMessage(te,...le){return Wi.showMessage(Ae,T.default.Info,te,le[0],le.slice(1))},showWarningMessage(te,...le){return Wi.showMessage(Ae,T.default.Warning,te,le[0],le.slice(1))},showErrorMessage(te,...le){return Wi.showMessage(Ae,T.default.Error,te,le[0],le.slice(1))},showQuickPick(te,le,Te){return H.showQuickPick(Ae,te,le,Te)},showWorkspaceFolderPick(te){return H.showWorkspaceFolderPick(te)},showInputBox(te,le){return H.showInput(te,le)},showOpenDialog(te){return an.showOpenDialog(Ae,te)},showSaveDialog(te){return an.showSaveDialog(te)},createStatusBarItem(te,le,Te){let ft,Pt,Ft;return typeof te=="string"?(ft=te,Pt=le,Ft=Te):(Pt=te,Ft=le),on.createStatusBarEntry(Ae,ft,Pt,Ft)},setStatusBarMessage(te,le){return on.setStatusBarMessage(te,le)},withScmProgress(te){return Mt.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),ot.withProgress(Ae,{location:q.ProgressLocation.SourceControl},(le,Te)=>te({report(ft){}}))},withProgress(te,le){return ot.withProgress(Ae,te,le)},createOutputChannel(te,le){return Ni.createOutputChannel(te,le,Ae)},createWebviewPanel(te,le,Te,ft){return Li.createWebviewPanel(Ae,te,le,Te,ft)},createWebviewTextEditorInset(te,le,Te,ft){return(0,Xe.$BH)(Ae,"editorInsets"),Di.createWebviewEditorInset(te,le,Te,ft,Ae)},createTerminal(te,le,Te){return typeof te=="object"?"pty"in te?vt.createExtensionTerminal(te):vt.createTerminalFromOptions(te):vt.createTerminal(te,le,Te)},registerTerminalLinkProvider(te){return vt.registerLinkProvider(te)},registerTerminalProfileProvider(te,le){return vt.registerProfileProvider(Ae,te,le)},registerTerminalQuickFixProvider(te,le){return(0,Xe.$BH)(Ae,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(te,Ae.identifier.value,le)},registerTreeDataProvider(te,le){return Pi.registerTreeDataProvider(te,le,Ae)},createTreeView(te,le){return Pi.createTreeView(te,le,Ae)},registerWebviewPanelSerializer:(te,le)=>Li.registerWebviewPanelSerializer(Ae,te,le),registerCustomEditorProvider:(te,le,Te={})=>en.registerCustomEditorProvider(Ae,te,le,Te),registerFileDecorationProvider(te){return ui.registerFileDecorationProvider(te,Ae)},registerUriHandler(te){return yi.registerUriHandler(Ae,te)},createQuickPick(){return H.createQuickPick(Ae)},createInputBox(){return H.createInputBox(Ae)},get activeColorTheme(){return Ht.activeColorTheme},onDidChangeActiveColorTheme(te,le,Te){return lt(Ht.onDidChangeActiveColorTheme)(te,le,Te)},registerWebviewViewProvider(te,le,Te){return Vi.registerWebviewViewProvider(Ae,te,le,Te?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,le,Te){return lt(Rt.onDidChangeActiveNotebookEditor)(te,le,Te)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return lt(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,le,Te){return lt(Ai.onDidChangeNotebookEditorSelection)(te,le,Te)},onDidChangeNotebookEditorVisibleRanges(te,le,Te){return lt(Ai.onDidChangeNotebookEditorVisibleRanges)(te,le,Te)},showNotebookDocument(te,le){return Rt.showNotebookDocument(te,le)},registerExternalUriOpener(te,le,Te){return(0,Xe.$BH)(Ae,"externalUriOpener"),tn.registerExternalUriOpener(Ae.identifier,te,le,Te)},registerProfileContentHandler(te,le){return(0,Xe.$BH)(Ae,"profileContentHandlers"),nn.registerProfileContentHandler(Ae,te,le)},registerQuickDiffProvider(te,le,Te,ft){return(0,Xe.$BH)(Ae,"quickDiffProvider"),We.registerQuickDiffProvider(It(te),le,Te,ft)},get tabGroups(){return ni.tabGroups},registerShareProvider(te,le){return(0,Xe.$BH)(Ae,"shareProvider"),Ye.registerShareProvider(It(te),le)}},Xi={get rootPath(){return Mt.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),bt.getPath()},set rootPath(te){throw new D.$ab("rootPath")},getWorkspaceFolder(te){return bt.getWorkspaceFolder(te)},get workspaceFolders(){return bt.getWorkspaceFolders()},get name(){return bt.name},set name(te){throw new D.$ab("name")},get workspaceFile(){return bt.workspaceFile},set workspaceFile(te){throw new D.$ab("workspaceFile")},updateWorkspaceFolders:(te,le,...Te)=>bt.updateWorkspaceFolders(Ae,te,le||0,...Te),onDidChangeWorkspaceFolders:function(te,le,Te){return lt(bt.onDidChangeWorkspace)(te,le,Te)},asRelativePath:(te,le)=>bt.getRelativePath(te,le),findFiles:(te,le,Te,ft)=>bt.findFiles(te,le,Te,Ae.identifier,ft),findFiles2:(te,le,Te)=>((0,Xe.$BH)(Ae,"findFiles2"),bt.findFiles2(te,le,Ae.identifier,Te)),findFiles2New:(te,le,Te)=>((0,Xe.$BH)(Ae,"findFiles2New"),bt.findFiles2New(te,le,Ae.identifier,Te)),findTextInFiles:(te,le,Te,ft)=>{(0,Xe.$BH)(Ae,"findTextInFiles");let Pt,Ft;return typeof le=="object"?(Pt=le,Ft=Te):(Pt={},Ft=le,ft=Te),bt.findTextInFiles(te,Pt||{},Ft,Ae.identifier,ft)},findTextInFilesNew:(te,le,Te)=>((0,Xe.$BH)(Ae,"findTextInFilesNew"),(0,Xe.$BH)(Ae,"textSearchProviderNew"),bt.findTextInFilesNew(te,Ae.identifier,le||{},Te)),save:te=>bt.save(te),saveAs:te=>bt.saveAs(te),saveAll:te=>bt.saveAll(te),applyEdit(te,le){return bn.applyWorkspaceEdit(te,Ae,le)},createFileSystemWatcher:(te,le,Te,ft)=>{let Pt;return typeof le=="boolean"?Pt={ignoreCreateEvents:!!le,ignoreChangeEvents:!!Te,ignoreDeleteEvents:!!ft,correlate:!1}:le&&((0,Xe.$BH)(Ae,"createFileSystemWatcher"),Pt={...le,correlate:!0}),ce.createFileSystemWatcher(bt,Ae,te,Pt)},get textDocuments(){return qt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new D.$ab("textDocuments")},openTextDocument(te){let le;const Te=te;if(typeof te=="string")le=Promise.resolve(m.URI.file(te));else if(m.URI.isUri(te))le=Promise.resolve(te);else if(!Te||typeof Te=="object")le=qt.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ft=>(kt.trace(`openTextDocument from ${Ae.identifier}`),ft.scheme===R.Schemas.vscodeRemote&&!ft.authority&&Mt.report("workspace.openTextDocument",Ae,"A URI of 'vscode-remote' scheme requires an authority."),qt.ensureDocumentData(ft).then(Pt=>Pt.document)))},onDidOpenTextDocument:(te,le,Te)=>lt(qt.onDidAddDocument)(te,le,Te),onDidCloseTextDocument:(te,le,Te)=>lt(qt.onDidRemoveDocument)(te,le,Te),onDidChangeTextDocument:(te,le,Te)=>lt(qt.onDidChangeDocument)(te,le,Te),onDidSaveTextDocument:(te,le,Te)=>lt(qt.onDidSaveDocument)(te,le,Te),onWillSaveTextDocument:(te,le,Te)=>lt(Fi.getOnWillSaveTextDocumentEvent(Ae))(te,le,Te),get notebookDocuments(){return Rt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,le){let Te;if(m.URI.isUri(te))Te=te,await Rt.openNotebookDocument(te);else if(typeof te=="string")Te=m.URI.revive(await Rt.createNotebookDocument({viewType:te,content:le}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,le,Te){return lt(Si.onDidSaveNotebookDocument)(te,le,Te)},onDidChangeNotebookDocument(te,le,Te){return lt(Si.onDidChangeNotebookDocument)(te,le,Te)},onWillSaveNotebookDocument(te,le,Te){return lt(ji.getOnWillSaveNotebookDocumentEvent(Ae))(te,le,Te)},get onDidOpenNotebookDocument(){return lt(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return lt(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(te,le,Te,ft){return Rt.registerNotebookSerializer(Ae,te,le,Te,(0,Xe.$AH)(Ae,"notebookLiveShare")?ft:void 0)},onDidChangeConfiguration:(te,le,Te)=>lt(Ki.onDidChangeConfiguration)(te,le,Te),getConfiguration(te,le){return le=arguments.length===1?void 0:le,Ki.getConfiguration(te,le,Ae)},registerTextDocumentContentProvider(te,le){return fi.registerTextDocumentContentProvider(te,le)},registerTaskProvider:(te,le)=>(Mt.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),Yt.registerTaskProvider(Ae,te,le)),registerFileSystemProvider(te,le,Te){return(0,L.$Wc)(De.registerFileSystemProvider(Ae,te,le,Te),ti.addFileSystemProvider(te,le,Te))},get fs(){return ti.value},registerFileSearchProvider:(te,le)=>((0,Xe.$BH)(Ae,"fileSearchProvider"),si.registerFileSearchProviderOld(te,le)),registerTextSearchProvider:(te,le)=>((0,Xe.$BH)(Ae,"textSearchProvider"),si.registerTextSearchProviderOld(te,le)),registerAITextSearchProvider:(te,le)=>((0,Xe.$BH)(Ae,"aiTextSearchProvider"),(0,Xe.$BH)(Ae,"textSearchProvider"),si.registerAITextSearchProviderOld(te,le)),registerFileSearchProviderNew:(te,le)=>((0,Xe.$BH)(Ae,"fileSearchProviderNew"),si.registerFileSearchProvider(te,le)),registerTextSearchProviderNew:(te,le)=>((0,Xe.$BH)(Ae,"textSearchProviderNew"),si.registerTextSearchProvider(te,le)),registerAITextSearchProviderNew:(te,le)=>((0,Xe.$BH)(Ae,"aiTextSearchProviderNew"),(0,Xe.$BH)(Ae,"textSearchProviderNew"),si.registerAITextSearchProvider(te,le)),registerRemoteAuthorityResolver:(te,le)=>((0,Xe.$BH)(Ae,"resolvers"),Kt.registerRemoteAuthorityResolver(te,le)),registerResourceLabelFormatter:te=>((0,Xe.$BH)(Ae,"resolvers"),gt.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Xe.$BH)(Ae,"resolvers"),Kt.getRemoteExecServer(te)),onDidCreateFiles:(te,le,Te)=>lt(ce.onDidCreateFile)(te,le,Te),onDidDeleteFiles:(te,le,Te)=>lt(ce.onDidDeleteFile)(te,le,Te),onDidRenameFiles:(te,le,Te)=>lt(ce.onDidRenameFile)(te,le,Te),onWillCreateFiles:(te,le,Te)=>lt(ce.getOnWillCreateFileEvent(Ae))(te,le,Te),onWillDeleteFiles:(te,le,Te)=>lt(ce.getOnWillDeleteFileEvent(Ae))(te,le,Te),onWillRenameFiles:(te,le,Te)=>lt(ce.getOnWillRenameFileEvent(Ae))(te,le,Te),openTunnel:te=>((0,Xe.$BH)(Ae,"tunnels"),jt.openTunnel(Ae,te).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,Xe.$BH)(Ae,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(te,le,Te)=>((0,Xe.$BH)(Ae,"tunnels"),lt(jt.onDidChangeTunnels)(te,le,Te)),registerPortAttributesProvider:(te,le)=>((0,Xe.$BH)(Ae,"portsAttributes"),jt.registerPortsAttributesProvider(te,le)),registerTunnelProvider:(te,le)=>((0,Xe.$BH)(Ae,"tunnelFactory"),jt.registerTunnelProvider(te,le)),registerTimelineProvider:(te,le)=>((0,Xe.$BH)(Ae,"timeline"),Vt.registerTimelineProvider(te,le,Ae.identifier,Ct.converter)),get isTrusted(){return bt.trusted},requestWorkspaceTrust:te=>((0,Xe.$BH)(Ae,"workspaceTrust"),bt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,le,Te)=>lt(bt.onDidGrantWorkspaceTrust)(te,le,Te),registerEditSessionIdentityProvider:(te,le)=>((0,Xe.$BH)(Ae,"editSessionIdentityProvider"),bt.registerEditSessionIdentityProvider(te,le)),onWillCreateEditSessionIdentity:(te,le,Te)=>((0,Xe.$BH)(Ae,"editSessionIdentityProvider"),lt(bt.getOnWillCreateEditSessionIdentityEvent(Ae))(te,le,Te)),registerCanonicalUriProvider:(te,le)=>((0,Xe.$BH)(Ae,"canonicalUriProvider"),bt.registerCanonicalUriProvider(te,le)),getCanonicalUri:(te,le,Te)=>((0,Xe.$BH)(Ae,"canonicalUriProvider"),bt.provideCanonicalUri(te,le,Te))},cn={get inputBox(){return Mt.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),ke.getLastInputBox(Ae)},createSourceControl(te,le,Te){return ke.createSourceControl(Ae,te,le,Te)}},ln={createCommentController(te,le){return Ue.createCommentController(Ae,te,le)}},un={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){return Et.activeStackItem},registerDebugVisualizationProvider(te,le){return(0,Xe.$BH)(Ae,"debugVisualization"),Et.registerDebugVisualizationProvider(Ae,te,le)},registerDebugVisualizationTreeProvider(te,le){return(0,Xe.$BH)(Ae,"debugVisualization"),Et.registerDebugVisualizationTree(Ae,te,le)},onDidStartDebugSession(te,le,Te){return lt(Et.onDidStartDebugSession)(te,le,Te)},onDidTerminateDebugSession(te,le,Te){return lt(Et.onDidTerminateDebugSession)(te,le,Te)},onDidChangeActiveDebugSession(te,le,Te){return lt(Et.onDidChangeActiveDebugSession)(te,le,Te)},onDidReceiveDebugSessionCustomEvent(te,le,Te){return lt(Et.onDidReceiveDebugSessionCustomEvent)(te,le,Te)},onDidChangeBreakpoints(te,le,Te){return lt(Et.onDidChangeBreakpoints)(te,le,Te)},onDidChangeActiveStackItem(te,le,Te){return lt(Et.onDidChangeActiveStackItem)(te,le,Te)},registerDebugConfigurationProvider(te,le,Te){return Et.registerDebugConfigurationProvider(te,le,Te||Qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,le){return Et.registerDebugAdapterDescriptorFactory(Ae,te,le)},registerDebugAdapterTrackerFactory(te,le){return Et.registerDebugAdapterTrackerFactory(te,le)},startDebugging(te,le,Te){return!Te||typeof Te=="object"&&"configuration"in Te?Et.startDebugging(te,le,{parentSession:Te}):Et.startDebugging(te,le,Te||{})},stopDebugging(te){return Et.stopDebugging(te)},addBreakpoints(te){return Et.addBreakpoints(te)},removeBreakpoints(te){return Et.removeBreakpoints(te)},asDebugSourceUri(te,le){return Et.asDebugSourceUri(te,le)}},En={registerTaskProvider:(te,le)=>Yt.registerTaskProvider(Ae,te,le),fetchTasks:te=>Yt.fetchTasks(te),executeTask:te=>Yt.executeTask(Ae,te),get taskExecutions(){return Yt.taskExecutions},onDidStartTask:(te,le,Te)=>lt(Yt.onDidStartTask)(te,le,Te),onDidEndTask:(te,le,Te)=>lt(Yt.onDidEndTask)(te,le,Te),onDidStartTaskProcess:(te,le,Te)=>lt(Yt.onDidStartTaskProcess)(te,le,Te),onDidEndTaskProcess:(te,le,Te)=>lt(Yt.onDidEndTaskProcess)(te,le,Te)},hn={createNotebookController(te,le,Te,ft,Pt){return gi.createNotebookController(Ae,te,le,Te,ft,(0,Xe.$AH)(Ae,"notebookMessaging")?Pt:void 0)},registerNotebookCellStatusBarItemProvider:(te,le)=>Rt.registerNotebookCellStatusBarItemProvider(Ae,te,le),createRendererMessaging(te){return zi.createRendererMessaging(Ae,te)},createNotebookControllerDetectionTask(te){return(0,Xe.$BH)(Ae,"notebookKernelSource"),gi.createNotebookControllerDetectionTask(Ae,te)},registerKernelSourceActionProvider(te,le){return(0,Xe.$BH)(Ae,"notebookKernelSource"),gi.registerKernelSourceActionProvider(Ae,te,le)},onDidChangeNotebookCellExecutionState(te,le,Te){return(0,Xe.$BH)(Ae,"notebookCellExecutionState"),lt(gi.onDidChangeNotebookCellExecutionState)(te,le,Te)}},dn={t(...te){if(typeof te[0]=="string"){const le=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return di.getMessage(Ae.identifier.value,{message:le,args:Te})}return di.getMessage(Ae.identifier.value,te[0])},get bundle(){return di.getBundle(Ae.identifier.value)},get uri(){return di.getBundleUri(Ae.identifier.value)}},kn={transferActiveChat(te){return(0,Xe.$BH)(Ae,"interactive"),Ui.transferActiveChat(te)}},In={getRelatedInformation(te,le){return(0,Xe.$BH)(Ae,"aiRelatedInformation"),Qi.getRelatedInformation(Ae,te,le)},registerRelatedInformationProvider(te,le){return(0,Xe.$BH)(Ae,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Ae,te,le)},registerEmbeddingVectorProvider(te,le){return(0,Xe.$BH)(Ae,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Ae,te,le)}},fn={registerChatResponseProvider(te,le,Te){return(0,Xe.$BH)(Ae,"chatProvider"),Jt.registerLanguageModel(Ae,te,le,Te)},registerChatVariableResolver(te,le,Te,ft,Pt,Ft,Oi,Yi){return(0,Xe.$BH)(Ae,"chatVariableResolver"),rn.registerVariableResolver(Ae,te,le,Te,ft,Pt,Ft,Oi,Yi?.id)},registerMappedEditsProvider(te,le){return(0,Xe.$BH)(Ae,"mappedEditsProvider"),me.registerMappedEditsProvider(Ae,te,le)},createChatParticipant(te,le){return Ui.createChatAgent(Ae,te,le)},createDynamicChatParticipant(te,le,Te){return(0,Xe.$BH)(Ae,"chatParticipantPrivate"),Ui.createDynamicChatAgent(Ae,te,le,Te)},registerChatParticipantDetectionProvider(te){return(0,Xe.$BH)(Ae,"chatParticipantAdditions"),Ui.registerChatParticipantDetectionProvider(te)}},Zi={selectChatModels:te=>Jt.selectLanguageModels(Ae,te??{}),onDidChangeChatModels:(te,le,Te)=>Jt.onDidChangeProviders(te,le,Te),registerChatModelProvider:(te,le,Te)=>((0,Xe.$BH)(Ae,"chatProvider"),Jt.registerLanguageModel(Ae,te,le,Te)),get embeddingModels(){return(0,Xe.$BH)(Ae,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(te,le,Te)=>((0,Xe.$BH)(Ae,"embeddings"),Ci.onDidChange(te,le,Te)),registerEmbeddingsProvider(te,le){return(0,Xe.$BH)(Ae,"embeddings"),Ci.registerEmbeddingsProvider(Ae,te,le)},async computeEmbeddings(te,le,Te){return(0,Xe.$BH)(Ae,"embeddings"),Ci.computeEmbeddings(te,le,Te)},registerTool(te,le){return(0,Xe.$BH)(Ae,"lmTools"),Bi.registerTool(Ae,te,le)},invokeTool(te,le,Te){return(0,Xe.$BH)(Ae,"lmTools"),Bi.invokeTool(te,le,Te)},get tools(){return(0,Xe.$BH)(Ae,"lmTools"),Bi.tools}},gn={registerSpeechProvider(te,le){return(0,Xe.$BH)(Ae,"speech"),wn.registerProvider(Ae.identifier,te,le)}};return{version:Dt.version,ai:In,authentication:yn,commands:Gi,comments:ln,chat:fn,debug:un,env:Ji,extensions:Sn,interactive:kn,l10n:dn,languages:pi,lm:Zi,notebooks:hn,scm:cn,speech:gn,tasks:En,tests:ki,window:qi,workspace:Xi,Breakpoint:q.$eP,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatResultFeedbackKind:q.ChatResultFeedbackKind,ChatVariableLevel:q.ChatVariableLevel,ChatCompletionItem:q.$aQ,CallHierarchyIncomingCall:q.$CO,CallHierarchyItem:q.$BO,CallHierarchyOutgoingCall:q.$DO,CancellationError:D.$9,CancellationTokenSource:v.$Be,CandidatePortSource:i.CandidatePortSource,CodeAction:q.$yO,CodeActionKind:q.$zO,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.$EO,Color:q.$RO,ColorInformation:q.$SO,ColorPresentation:q.$TO,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CommentThreadApplicability:q.CommentThreadApplicability,CommentThreadFocus:q.CommentThreadFocus,CompletionItem:q.$LO,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.$MO,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.$2O,DebugAdapterExecutable:q.$iP,DebugAdapterInlineImplementation:q.$lP,DebugAdapterNamedPipeServer:q.$kP,DebugAdapterServer:q.$jP,DebugConfigurationProviderTriggerKind:Qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DebugVisualization:q.$BP,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.$rO,DiagnosticRelatedInformation:q.$qO,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.$bO,DocumentHighlight:q.$uO,DocumentHighlightKind:q.DocumentHighlightKind,MultiDocumentHighlight:q.$vO,DocumentLink:q.$QO,DocumentSymbol:q.$xO,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.$oP,InlineValueText:q.$pP,InlineValueVariableLookup:q.$qP,InlineValueEvaluatableExpression:q.$rP,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:P.$qe,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.$DP,FileDecoration2:q.$DP,FileSystemError:q.$uP,FileType:$.FileType,FilePermission:$.FilePermission,FoldingRange:q.$vP,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.$gP,InlineCompletionItem:q.$NO,InlineCompletionList:q.$OO,Hover:q.$sO,VerboseHover:q.$tO,HoverVerbosityAction:q.HoverVerbosityAction,IndentAction:w.IndentAction,Location:q.$pO,MarkdownString:q.$FO,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:q.$GO,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.$cO,ProcessExecution:q.$ZO,ProgressLocation:q.ProgressLocation,QuickInputButtonLocation:q.QuickInputButtonLocation,QuickInputButtons:q.$CP,Range:q.$dO,RelativePattern:q.$cP,Selection:q.$eO,SelectionRange:q.$AO,SemanticTokens:q.$yP,SemanticTokensBuilder:q.$xP,SemanticTokensEdit:q.$zP,SemanticTokensEdits:q.$AP,SemanticTokensLegend:q.$wP,ShellExecution:q.$1O,ShellQuoting:q.ShellQuoting,SignatureHelp:q.$IO,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.$HO,SnippetString:q.$oO,SourceBreakpoint:q.$fP,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.$wO,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.$3O,TaskGroup:q.$YO,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.$UO,TerminalQuickFixTerminalCommand:q.$WO,TerminalQuickFixOpener:q.$VO,TerminalLocation:q.TerminalLocation,TerminalProfile:q.$XO,TerminalExitReason:q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.$kO,SnippetTextEdit:q.$mO,TextEditorCursorStyle:s.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,SyntaxTokenType:q.SyntaxTokenType,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.$bP,ThemeIcon:q.$aP,TreeItem:q.$4O,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.$1P,UIKind:_t.UIKind,Uri:m.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.$nO,DocumentPasteTriggerKind:q.DocumentPasteTriggerKind,DocumentDropEdit:q.$0O,DocumentDropOrPasteEditKind:q.$$O,DocumentPasteEdit:q.$_O,InlayHint:q.$KO,InlayHintLabelPart:q.$JO,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.$jO,ResolvedAuthority:q.$hO,ManagedResolvedAuthority:q.$iO,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.$NP,NotebookRange:q.$FP,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.$GP,NotebookData:q.$HP,NotebookRendererScript:q.$LP,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.$JP,NotebookCellOutputItem:q.$IP,NotebookCellStatusBarItem:q.$KP,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.$lO,NotebookKernelSourceAction:q.$MP,NotebookVariablesRequestKind:q.NotebookVariablesRequestKind,PortAttributes:q.$PP,LinkedEditingRanges:q.$OP,TestResultState:q.TestResultState,TestRunRequest:q.$QP,TestMessage:q.$RP,TestMessageStackFrame:q.$TP,TestTag:q.$SP,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:At.TextSearchCompleteMessageType,DataTransfer:q.$9O,DataTransferItem:q.$5O,TestCoverageCount:q.$UP,FileCoverage:q.$WP,FileCoverage2:q.$WP,StatementCoverage:q.$XP,BranchCoverage:q.$YP,DeclarationCoverage:q.$ZP,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.$2P,TabInputTextDiff:q.$3P,TabInputTextMerge:q.$4P,TabInputCustom:q.$5P,TabInputNotebook:q.$7P,TabInputNotebookDiff:q.$8P,TabInputWebview:q.$6P,TabInputTerminal:q.$9P,TabInputInteractiveWindow:q.$0P,TabInputChat:q.$$P,TabInputTextMultiDiff:q.$_P,TelemetryTrustedValue:h.$Dp,LogLevel:r.LogLevel,EditSessionIdentityMatch:c.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,ChatCopyKind:q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:q.$mP,DebugThread:q.$nP,RelatedInformationType:q.RelatedInformationType,SpeechToTextStatus:q.SpeechToTextStatus,TextToSpeechStatus:q.TextToSpeechStatus,PartialAcceptTriggerKind:q.PartialAcceptTriggerKind,KeywordRecognitionStatus:q.KeywordRecognitionStatus,ChatResponseMarkdownPart:q.$bQ,ChatResponseFileTreePart:q.$fQ,ChatResponseAnchorPart:q.$gQ,ChatResponseProgressPart:q.$hQ,ChatResponseProgressPart2:q.$iQ,ChatResponseReferencePart:q.$lQ,ChatResponseReferencePart2:q.$lQ,ChatResponseCodeCitationPart:q.$mQ,ChatResponseWarningPart:q.$jQ,ChatResponseTextEditPart:q.$oQ,ChatResponseMarkdownWithVulnerabilitiesPart:q.$cQ,ChatResponseCommandButtonPart:q.$kQ,ChatResponseDetectedParticipantPart:q.$dQ,ChatResponseConfirmationPart:q.$eQ,ChatResponseMovePart:q.$nQ,ChatResponseReferencePartStatusKind:q.ChatResponseReferencePartStatusKind,ChatRequestTurn:q.$pQ,ChatResponseTurn:q.$qQ,ChatLocation:q.ChatLocation,ChatRequestEditorData:q.$rQ,ChatRequestNotebookData:q.$sQ,LanguageModelChatMessageRole:q.LanguageModelChatMessageRole,LanguageModelChatMessage:q.$uQ,LanguageModelChatMessageToolResultPart:q.$tQ,LanguageModelChatResponseTextPart:q.$wQ,LanguageModelChatResponseToolCallPart:q.$vQ,LanguageModelError:q.$AQ,NewSymbolName:q.$tP,NewSymbolNameTag:q.NewSymbolNameTag,NewSymbolNameTriggerKind:q.NewSymbolNameTriggerKind,InlineEdit:q.$BQ,InlineEditTriggerKind:q.InlineEditTriggerKind,ExcludeSettingOptions:At.ExcludeSettingOptions,TextSearchContextNew:At.$oM,TextSearchMatchNew:At.$nM,TextSearchCompleteMessageTypeNew:At.TextSearchCompleteMessageType}}}}),define(Re[277],Oe([1,0,60,130,45,124,46,35,57,56,132,134,136,89,93,85,123,68,50,88,66,70,216,11,133,86,87,91,95,128,96]),function(we,e,v,D,P,L,R,T,m,s,I,w,u,k,$,r,a,h,c,i,n,t,o,l,g,f,d,S,E,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Zs)(f.$Src,f.$Rrc,v.InstantiationType.Delayed),(0,v.$Zs)(l.$gk,o.$atc,v.InstantiationType.Delayed),(0,v.$Zs)(r.$Xqc,r.$Yqc,v.InstantiationType.Delayed),(0,v.$Zs)(T.$9Q,T.$8Q,v.InstantiationType.Eager),(0,v.$Zs)(S.$8qc,S.$9qc,v.InstantiationType.Eager),(0,v.$Zs)(E.$Mrc,E.$Nrc,v.InstantiationType.Eager),(0,v.$Zs)(R.$krc,R.$irc,v.InstantiationType.Eager),(0,v.$Zs)(h.$mrc,h.$lrc,v.InstantiationType.Eager),(0,v.$Zs)(C.$3rc,C.$4rc,v.InstantiationType.Eager),(0,v.$Zs)(w.$8rc,w.$_rc,v.InstantiationType.Eager),(0,v.$Zs)(L.$bsc,L.$asc,v.InstantiationType.Eager),(0,v.$Zs)(m.$XQ,m.$WQ,v.InstantiationType.Eager),(0,v.$Zs)(d.$Trc,d.$Urc,v.InstantiationType.Eager),(0,v.$Zs)(c.$2qc,c.$1qc,v.InstantiationType.Eager),(0,v.$Zs)(D.$Msc,D.$Lsc,v.InstantiationType.Delayed),(0,v.$Zs)(u.$wsc,u.$xsc,v.InstantiationType.Eager),(0,v.$Zs)(k.$Frc,k.$Erc,v.InstantiationType.Eager),(0,v.$Zs)(I.$Zsc,I.$Ysc,v.InstantiationType.Eager),(0,v.$Zs)(s.$Irc,s.$Lrc,v.InstantiationType.Eager),(0,v.$Zs)(y.$1sc,y.$2sc,v.InstantiationType.Eager),(0,v.$Zs)($.$_Gb,$.$aHb,v.InstantiationType.Eager),(0,v.$Zs)(a.$$sc,a.$0sc,v.InstantiationType.Eager),(0,v.$Zs)(P.$hrc,P.$grc,v.InstantiationType.Eager),(0,v.$Zs)(i.$Prc,i.$Orc,v.InstantiationType.Eager),(0,v.$Zs)(n.$7Q,n.$4Q,v.InstantiationType.Eager),(0,v.$Zs)(t.$wrc,t.$xrc,v.InstantiationType.Eager),(0,v.$Zs)(g.$1rc,g.$2rc,v.InstantiationType.Eager)}),define(Re[278],Oe([1,0,276,47,2,272,7,10,223]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ovc=void 0;class s extends L.$dtc{j(){}getModule(k,$){for(const r of this.b){const a=r(k);if(a){k=a;break}}if(this.a.has(k))return this.a.get(k).load(k,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends D.$Wrc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(m.$nvc);const k=this.h.invokeFunction(v.$_sc);this.r=this.h.createInstance(s,k,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(k){return k.browser}async xb(k,$,r){$=$.with({path:w($.path,".js")});const a=k?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const h=P.URI.revive(await this.C.$asBrowserUri($)),c=await fetch(h.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),c.status!==200)throw new Error(c.statusText);const i=await c.text(),n=`${$.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let o;try{o=new Function("module","exports","require",t)}catch(d){throw console.error(a?`Loading code for extension ${a} failed: ${d.message}`:`Loading code failed: ${d.message}`),console.error(`${$.toString(!0)}${typeof d.line=="number"?` line ${d.line}`:""}${typeof d.column=="number"?` column ${d.column}`:""}`),console.error(d),d}k&&await this.w.initializeLocalizedMessages(k);const l={},g={exports:l},f=d=>{const S=this.r.getModule(d,$);if(S===void 0)throw new Error(`Cannot load module '${d}'`);return S};try{return r.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),o(g,l,f),g.exports!==l?g.exports:l}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),r.codeLoadingStop()}}async $setRemoteEnvironment(k){}async Bb(k=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+k;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Lh)(10)}}e.$ovc=I;function w(u,k){return u.endsWith(k)?u:u+k}}),define(Re[279],Oe([1,0,74,60,11,47,188,92,278]),function(we,e,v,D,P,L,R,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Zs)(P.$fk,new v.$Hi(R.$ctc,[!0],!0)),(0,D.$Zs)(L.$Xrc,m.$ovc,D.InstantiationType.Eager),(0,D.$Zs)(T.$nrc,T.$orc,D.InstantiationType.Eager)}),define(Re[287],Oe([1,0,20,6,84,273,225,22,64,15,2,277,279]),function(we,e,v,D,P,L,R,T,m,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=Ve(T),m=Ve(m);const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function k(o){return/^(file|vscode-remote):/i.test(o)}const $=fetch.bind(self);function r(o){self.fetch=async function(l,g){return l instanceof Request||k(String(l))&&(l=(await o(I.URI.parse(String(l)))).toString(!0)),$(l,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,g,f,d,S){(async()=>(k(g.toString())&&(g=(await o(I.URI.parse(g.toString()))).toString(!0)),super.open(l,g,f??!0,d,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.Worker;Worker=function(l,g){if(/^file:/i.test(l.toString()))l=s.$5g.uriToBrowserUri(I.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const d=`(${function(C){function O(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const p=fetch.bind(self);self.fetch=function(M,A){return M instanceof Request?p(M,A):p(O(M),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,A,F,G,x){return super.open(M,O(A),F??!0,G,x)}};const b=importScripts.bind(self);self.importScripts=(...M)=>{b(...M.map(O))},b(C)}.toString()}('${l}'))`;g=g||{},g.name=`${name} -> ${g.name||T.$sc(l.toString())}`;const S=new Blob([d],{type:"application/javascript"}),E=URL.createObjectURL(S);return new o(E,g)}}else self.Worker=class extends R.$pvc{constructor(o,l){super(u,o,{name:T.$sc(o.toString()),...l})}};const a=new class{constructor(){this.pid=void 0}exit(o){w()}};class h{constructor(){const l=new MessageChannel,g=new D.$qe;let f=!1;u(l.port2,[l.port2]),l.port1.onmessage=d=>{const{data:S}=d;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const E=v.$Se.wrap(new Uint8Array(S,0,S.byteLength));if((0,P.$In)(E,P.MessageType.Terminate)){f=!0,i("received terminate message from renderer");return}g.fire(E)},this.protocol={onMessage:g.event,send:d=>{if(!f){const S=d.buffer.buffer.slice(d.buffer.byteOffset,d.buffer.byteOffset+d.buffer.byteLength);l.port1.postMessage(S,[S])}}}}}function c(o){return new Promise(l=>{const g=o.onMessage(f=>{g.dispose();const d=JSON.parse(f.toString());o.send((0,P.$Hn)(P.MessageType.Initialized)),l({protocol:o,initData:d})});o.send((0,P.$Hn)(P.MessageType.Ready))})}let i=o=>w();function n(o){return!!o&&typeof o=="object"&&o.type==="vscode.init"&&o.data instanceof Map}function t(){m.mark("code/extHost/willConnectToRenderer");const o=new h;return{onmessage(l){n(l)&&c(o.protocol).then(g=>{m.mark("code/extHost/didWaitForInitData");const f=new L.$ftc(g.protocol,g.initData,a,null,l.data);r(d=>f.asBrowserUri(d)),i=d=>f.terminate(d)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/336db9ece67f682159078ea1b54212de7636d88a/core/vs/workbench/api/worker/extensionHostWorker.js.map
